import xtrack as xt
import numpy as np

env = xt.Environment()
env._xdeps_vref._owner.default_factory = lambda: 0
env.vars["twopi"] = np.pi * 2
env.new("vkicker", "Multipole")
env.new("hkicker", "Multipole")
env.new("tkicker", "Multipole")
env.new("collimator", "Drift")
env.new("instrument", "Drift")
env.new("monitor", "Drift")
env.new("placeholder", "Drift")
env.new("sbend", "Bend")
env.new("rbend", "Bend")
env.new("quadrupole", "Quadrupole")
env.new("sextupole", "Sextupole")
env.new("octupole", "Octupole")
env.new("marker", "Drift")
env.new("rfcavity", "Cavity")
env.new("multipole", "Multipole", knl=[0, 0, 0, 0, 0, 0])
env.new("solenoid", "Solenoid")

# /**********************************************************************************
# *
# * LHC ring (draft) version YETS 2021-2022 in MAD X sequence format
# * Generated the 17-JUN-2022 18:42:11 from LAYOUT
# *
# ***********************************************************************************/


# /************************************************************************************/
# /*                       GEOMETRY                                                   */
# /************************************************************************************/

# if (version>=50401){option,-rbarc;};

env["lhclength"] = 26658.8832
env["sep_arc"] = 0.194
env["sep_ir3"] = 0.224
env["sep_ir4"] = 0.42
env["sep_ir7"] = 0.224
env["ip1ofs.b1"] = 0.0
env["ip1ofs.b2"] = 0.0
env["ip2ofs.b1"] = 154.0
env["ip2ofs.b2"] = -154.0
env["ip3ofs.b1"] = 0.0
env["ip3ofs.b2"] = 0.0
env["ip4ofs.b1"] = -154.0
env["ip4ofs.b2"] = 154.0
env["ip5ofs.b1"] = -308.0
env["ip5ofs.b2"] = 308.0
env["ip6ofs.b1"] = -154.0
env["ip6ofs.b2"] = 154.0
env["ip7ofs.b1"] = 0.0
env["ip7ofs.b2"] = 0.0
env["ip8ofs.b1"] = 154.0
env["ip8ofs.b2"] = -154.0
env["dsep1"] = 85.913
env["dsep2"] = 63.295
env["dsep3"] = 26.493
env["dsep4"] = 71.901
env["dsep5"] = 85.913
env["dsep7"] = 39.7395
env["dsep8"] = 63.295
env["aip1"] = "atan(sep_arc/2/dsep1)"
env["aip2"] = "atan(sep_arc/2/dsep2)"
env["aip3"] = "atan((sep_ir3-sep_arc)/2/dsep3)"
env["aip4"] = "atan((sep_ir4-sep_arc)/2/dsep4)"
env["aip5"] = "atan(sep_arc/2/dsep5)"
env["aip7"] = "atan((sep_ir7-sep_arc)/2/dsep7)"
env["aip8"] = "atan((sep_arc)/2/dsep8)"
env["pip1"] = 0.0
env["pip1.l1"] = 26658.8832
env["pip2"] = 3332.3604
env["pip3"] = 6664.7208
env["pip4"] = 9997.0812
env["pip5"] = 13329.4416
env["pip6"] = 16661.802
env["pip7"] = 19994.1624
env["pip8"] = 23315.3028
env["hrf200"] = 17820.0
env["hrf400"] = 35640.0

env["a.mb"] = "twopi/8/(23*6+2*2*4)"
env["ab.a12"] = "a.mb"
env["ab.a23"] = "a.mb"
env["ab.a34"] = "a.mb"
env["ab.a45"] = "a.mb"
env["ab.a56"] = "a.mb"
env["ab.a67"] = "a.mb"
env["ab.a78"] = "a.mb"
env["ab.a81"] = "a.mb"

env["l.acsca"] = 0.0
env["l.acsph001"] = 0.5125
env["l.acsph002"] = 0.5825
env["l.adtkh"] = 0.0
env["l.adtkv"] = 0.0
env["l.apwl"] = 0.0
env["l.bbcwb"] = 0.0
env["l.bbcwe"] = 0.0
env["l.bbcwi"] = 0.0
env["l.bbcwt"] = 0.0
env["l.bctdc"] = 0.0
env["l.bctfr"] = 0.0
env["l.bgcab"] = 0.0
env["l.bgvca001"] = 0.0
env["l.bgvca003"] = 0.0
env["l.bgvca004"] = 0.0
env["l.bplh"] = 0.0
env["l.bplv"] = 0.0
env["l.bplx"] = 0.0
env["l.bpm"] = 0.0
env["l.bpmcs"] = 0.0
env["l.bpmr"] = 0.0
env["l.bpmra"] = 0.0
env["l.bpmsa"] = 0.0
env["l.bpmse"] = 0.0
env["l.bpmsi002"] = 0.0
env["l.bpmsw002"] = 0.0
env["l.bpmsx002"] = 0.0
env["l.bpmsx003"] = 0.0
env["l.bpmsx004"] = 0.0
env["l.bpmsy002"] = 0.0
env["l.bpms_003"] = 0.0
env["l.bpmwa"] = 0.0
env["l.bpmwb"] = 0.0
env["l.bpmwc"] = 0.0
env["l.bpmwe003"] = 0.0
env["l.bpmwe007"] = 0.0
env["l.bpmwe008"] = 0.0
env["l.bpmwe009"] = 0.0
env["l.bpmwf"] = 0.0
env["l.bpmwg"] = 0.0
env["l.bpmwi"] = 0.0
env["l.bpmwj"] = 0.0
env["l.bpmwt"] = 0.0
env["l.bpmw_010"] = 0.0
env["l.bpmw_013"] = 0.0
env["l.bpmw_014"] = 0.0
env["l.bpmw_015"] = 0.0
env["l.bpmya"] = 0.0
env["l.bpmyb"] = 0.0
env["l.bpm_a"] = 0.0
env["l.bptdh"] = 0.0
env["l.bptdj"] = 0.0
env["l.bptdv"] = 0.0
env["l.bptuh"] = 0.0
env["l.bptuj"] = 0.0
env["l.bptut"] = 0.0
env["l.bptuv"] = 0.0
env["l.bptx"] = 0.0
env["l.bqkh"] = 0.0
env["l.bqkv"] = 0.0
env["l.bqsh"] = 0.0
env["l.bqsv"] = 0.0
env["l.brana"] = 0.0
env["l.branc"] = 0.0
env["l.brand"] = 0.0
env["l.bsrtm"] = 0.0
env["l.bsrtmb"] = 0.0
env["l.bsrto001"] = 0.0
env["l.bsrto002"] = 0.0
env["l.bsrtr"] = 0.0
env["l.btvm"] = 0.0
env["l.btvse"] = 0.0
env["l.btvsi084"] = 0.0
env["l.btvsi088"] = 0.5
env["l.btvss074"] = 0.0
env["l.btvss075"] = 0.75
env["l.btvst064"] = 0.0
env["l.btvst065"] = 0.0
env["l.bws"] = 0.0
env["l.dfbaa"] = 2.175
env["l.dfbab"] = 2.675
env["l.dfbac"] = 2.175
env["l.dfbad"] = 2.675
env["l.dfbae"] = 2.175
env["l.dfbaf"] = 2.675
env["l.dfbag"] = 2.175
env["l.dfbah"] = 2.675
env["l.dfbai"] = 2.175
env["l.dfbaj"] = 2.675
env["l.dfbak"] = 2.175
env["l.dfbal"] = 2.675
env["l.dfbam"] = 2.175
env["l.dfban"] = 2.675
env["l.dfbao"] = 2.175
env["l.dfbap"] = 2.675
env["l.dfbxa"] = 3.09
env["l.dfbxb"] = 3.09
env["l.dfbxc"] = 2.853
env["l.dfbxd"] = 2.853
env["l.dfbxe"] = 3.09
env["l.dfbxf"] = 3.09
env["l.dfbxg"] = 2.853
env["l.dfbxh"] = 2.853
env["l.leal"] = 12.7747
env["l.lear"] = 12.7747
env["l.lebl"] = 12.7747
env["l.lebr"] = 12.7747
env["l.lecl"] = 12.7747
env["l.ledr"] = 13.7167
env["l.leel"] = 13.7167
env["l.lefl"] = 13.7167
env["l.legr"] = 13.7167
env["l.lehr"] = 13.7167
env["l.leir"] = 13.7167
env["l.lejl"] = 10.12
env["l.lenla"] = 2.156
env["l.lenra"] = 2.156
env["l.lepla"] = 5.30935
env["l.leplb"] = 5.30935
env["l.lepra"] = 5.30935
env["l.leprb"] = 5.30935
env["l.mb"] = 14.3
env["l.mbas2"] = 3.0
env["l.mbaw"] = 4.5406
env["l.mbcs2"] = 6.5
env["l.mbls2"] = 6.05
env["l.mblw"] = 5.0
env["l.mbrb"] = 9.45
env["l.mbrc"] = 9.45
env["l.mbrs"] = 9.45
env["l.mbw"] = 3.4
env["l.mbwmd"] = 2.62
env["l.mbx"] = 9.45
env["l.mbxw"] = 3.4
env["l.mbxwh"] = 3.4
env["l.mbxws"] = 0.78
env["l.mbxwt"] = 1.53
env["l.mcbch"] = 0.904
env["l.mcbcv"] = 0.904
env["l.mcbh"] = 0.647
env["l.mcbh_unplugged"] = 0.647
env["l.mcbv"] = 0.647
env["l.mcbv_unplugged"] = 0.647
env["l.mcbwh"] = 1.7
env["l.mcbwv"] = 1.7
env["l.mcbxh"] = 0.45
env["l.mcbxh_unplugged"] = 0.45
env["l.mcbxv"] = 0.48
env["l.mcbyh"] = 0.899
env["l.mcbyv"] = 0.899
env["l.mcd"] = 0.066
env["l.mcd_unplugged"] = 0.066
env["l.mco"] = 0.066
env["l.mcosx"] = 0.138
env["l.mcosx_unplugged"] = 0.138
env["l.mcox"] = 0.137
env["l.mcox_unplugged"] = 0.137
env["l.mco_unplugged"] = 0.066
env["l.mcs"] = 0.11
env["l.mcssx"] = 0.132
env["l.mcssx_unplugged"] = 0.132
env["l.mcsx"] = 0.576
env["l.mcs_unplugged"] = 0.11
env["l.mctx"] = 0.615
env["l.mgmwh"] = 0.5263
env["l.mgmwh003"] = 0.5263
env["l.mgmwv"] = 0.5263
env["l.mgmwv003"] = 0.5263
env["l.mkd"] = 1.348
env["l.mkima192"] = 0.0
env["l.mkima193"] = 0.0
env["l.mkqa"] = 1.583
env["l.mo"] = 0.32
env["l.mo_unplugged"] = 0.32
env["l.mq"] = 3.1
env["l.mqm"] = 3.4
env["l.mqmc"] = 2.4
env["l.mqml"] = 4.8
env["l.mqs"] = 0.32
env["l.mqsx"] = 0.223
env["l.mqt"] = 0.32
env["l.mqtlh"] = 1.3
env["l.mqtli"] = 1.3
env["l.mqt_unplugged"] = 0.32
env["l.mqwa"] = 3.108
env["l.mqwb"] = 3.108
env["l.mqxa"] = 6.37
env["l.mqxb"] = 5.5
env["l.mqy"] = 3.4
env["l.ms"] = 0.369
env["l.msda"] = 4.088
env["l.msdb"] = 4.088
env["l.msdb2"] = 2.044
env["l.msdc"] = 4.088
env["l.msia"] = 4.0
env["l.msib"] = 4.0
env["l.mss"] = 0.369
env["l.mss_unplugged"] = 0.369
env["l.mu"] = 0.14
env["l.omk"] = 0.0
env["l.tanal"] = 3.492
env["l.tanar"] = 3.492
env["l.tanb"] = 0.605
env["l.tanc"] = 3.492
env["l.tas"] = 1.8
env["l.tasb"] = 1.2
env["l.tcapa019"] = 1.0
env["l.tcapa020"] = 1.0
env["l.tcapb"] = 0.2
env["l.tcapc"] = 0.6
env["l.tcapd"] = 1.0
env["l.tcdd"] = 1.0
env["l.tcddm"] = 1.0
env["l.tcdqa"] = 0.0
env["l.tcdqm"] = 1.05
env["l.tcdsa"] = 3.012
env["l.tcdsb"] = 3.012
env["l.tcl"] = 1.0
env["l.tcla"] = 1.0
env["l.tcld"] = 0.6
env["l.tclia"] = 1.0
env["l.tclib"] = 1.0
env["l.tclim"] = 0.5
env["l.tcp"] = 0.6
env["l.tcpch"] = 0.0
env["l.tcpcv"] = 0.0
env["l.tcppm"] = 0.6
env["l.tcsg"] = 1.0
env["l.tcsp"] = 1.0
env["l.tcspm"] = 1.0
env["l.tctph"] = 1.0
env["l.tctpv"] = 1.0
env["l.tctwh"] = 1.0
env["l.tctwv"] = 1.0
env["l.tdisa"] = 1.565
env["l.tdisb"] = 1.565
env["l.tdisc"] = 1.565
env["l.x1zdc001"] = 0.6
env["l.x1zdc002"] = 0.3
env["l.x2zdc001"] = 1.5
env["l.x2zdc002"] = 1.5
env["l.x5fca"] = 0.0
env["l.x5fcb"] = 0.0
env["l.x5zdc001"] = 0.775
env["l.x5zdc002"] = 0.125
env["l.xrph"] = 0.0
env["l.xrpv"] = 0.0

env["r0"] = 0.0
env["ds"] = "0.097*twopi/8/(23*6+2*2*4)*(1-r0)"

env["ad1.l2"] = "aip2*(1-r0)"
env["ad1.l8"] = "aip8*(1-r0)"
env["ad1.lr1"] = "aip1/6*(1-r0)"
env["ad1.lr5"] = "aip5/6*(1-r0)"
env["ad1.r2"] = "aip2*(1-r0)"
env["ad1.r8"] = "aip8*(1-r0)"
env["ad2.l1"] = "aip1*(1-r0)"
env["ad2.l2"] = "aip2*(1-r0)"
env["ad2.l5"] = "aip5*(1-r0)"
env["ad2.l8"] = "aip8*(1-r0)"
env["ad2.r1"] = "aip1*(1-r0)"
env["ad2.r2"] = "aip2*(1-r0)"
env["ad2.r5"] = "aip5*(1-r0)"
env["ad2.r8"] = "aip8*(1-r0)"
env["ad3.l4"] = "aip4*(1-r0)"
env["ad3.lr3"] = "(aip3/3)*(1-r0)"
env["ad3.lr7"] = "(aip7/2)*(1-r0)"
env["ad3.r4"] = "aip4*(1-r0)"
env["ad4.l4"] = "aip4*(1-r0)"
env["ad4.lr3"] = "(aip3/3)*(1-r0)"
env["ad4.lr7"] = "(aip7/2)*(1-r0)"
env["ad4.r4"] = "aip4*(1-r0)"
env["ad34.lr3"] = "(aip3/3)*(1-r0)"
env["ad34.lr7"] = "(aip7/2)*(1-r0)"

# /************************************************************************************/
# /*                       Kmax STRENGTH                                              */
# /************************************************************************************/

env["kmax_mb"] = 8.3274
env["kmax_mbaw"] = 0.6792
env["kmax_mblw"] = 1.1
env["kmax_mbrb_4.5k"] = 3.88
env["kmax_mbrc_4.5k"] = 3.8
env["kmax_mbrs_4.5k"] = 3.88
env["kmax_mbw"] = 1.42
env["kmax_mbwmd"] = 1.345
env["kmax_mbx"] = 3.8
env["kmax_mbxw"] = 1.282
env["kmax_mbxwh"] = 1.24
env["kmax_mbxws"] = 1.1
env["kmax_mbxwt"] = 1.68
env["kmax_mcbch"] = 3.11
env["kmax_mcbch_4.5k"] = 2.33
env["kmax_mcbcv"] = 3.11
env["kmax_mcbcv_4.5k"] = 2.33
env["kmax_mcbh"] = 2.93
env["kmax_mcbv"] = 2.93
env["kmax_mcbwh"] = 1.1
env["kmax_mcbwv"] = 1.1
env["kmax_mcbxh"] = 3.35
env["kmax_mcbxv"] = 3.26
env["kmax_mcbyh_4.5k"] = 2.5
env["kmax_mcbyv_4.5k"] = 2.5
env["kmax_mcd"] = 28800000.0
env["kmax_mco"] = 48900.0
env["kmax_mcosx"] = 58080.0
env["kmax_mcox"] = 55380.0
env["kmax_mcs"] = 3260.0
env["kmax_mcssx"] = 754.0
env["kmax_mcsx"] = 208.0
env["kmax_mctx"] = 847200000.0
env["kmax_mo"] = 378600.0
env["kmax_mq"] = 223.0
env["kmax_mqm"] = 200.0
env["kmax_mqm_4.5k"] = 160.0
env["kmax_mqmc"] = 200.0
env["kmax_mqml"] = 200.0
env["kmax_mqml_4.5k"] = 160.0
env["kmax_mqs"] = 123.0
env["kmax_mqsx"] = 80.0
env["kmax_mqt"] = 123.0
env["kmax_mqtlh_4.5k"] = 90.0
env["kmax_mqtli"] = 125.0
env["kmax_mqwa"] = 35.0
env["kmax_mqwb"] = 30.0
env["kmax_mqxa"] = 205.0
env["kmax_mqxb"] = 205.0
env["kmax_mqy_4.5k"] = 160.0
env["kmax_ms"] = 8860.0
env["kmax_msda"] = 0.8
env["kmax_msdb"] = 0.99
env["kmax_msdb2"] = 0.99
env["kmax_msdc"] = 1.17
env["kmax_msia"] = 0.76
env["kmax_msib"] = 1.13
env["kmax_mss"] = 8860.0

# /************************************************************************************/
# /*                       Kmin STRENGTH                                              */
# /************************************************************************************/

env["kmin_mb"] = 0.246
env["kmin_mbaw"] = -0.6792
env["kmin_mblw"] = -1.1
env["kmin_mbrb_4.5k"] = 0.126
env["kmin_mbrc_4.5k"] = 0.104
env["kmin_mbrs_4.5k"] = 0.132
env["kmin_mbw"] = 0.036
env["kmin_mbwmd"] = 0.037
env["kmin_mbx"] = 0.131
env["kmin_mbxw"] = 0.031
env["kmin_mbxwh"] = -1.24
env["kmin_mbxws"] = -1.1
env["kmin_mbxwt"] = 0.042
env["kmin_mcbch"] = -3.11
env["kmin_mcbch_4.5k"] = -2.33
env["kmin_mcbcv"] = -3.11
env["kmin_mcbcv_4.5k"] = -2.33
env["kmin_mcbh"] = -2.93
env["kmin_mcbv"] = -2.93
env["kmin_mcbwh"] = -1.1
env["kmin_mcbwv"] = -1.1
env["kmin_mcbxh"] = -3.35
env["kmin_mcbxv"] = -3.26
env["kmin_mcbyh_4.5k"] = -2.5
env["kmin_mcbyv_4.5k"] = -2.5
env["kmin_mcd"] = -28800000.0
env["kmin_mco"] = -48900.0
env["kmin_mcosx"] = -58080.0
env["kmin_mcox"] = -55380.0
env["kmin_mcs"] = -3260.0
env["kmin_mcssx"] = -754.0
env["kmin_mcsx"] = -208.0
env["kmin_mctx"] = -847200000.0
env["kmin_mo"] = -378600.0
env["kmin_mq"] = 6.575
env["kmin_mqm"] = 4.453
env["kmin_mqm_4.5k"] = 4.455
env["kmin_mqmc"] = 4.453
env["kmin_mqml"] = 4.453
env["kmin_mqml_4.5k"] = 4.455
env["kmin_mqs"] = -123.0
env["kmin_mqsx"] = -80.0
env["kmin_mqt"] = -123.0
env["kmin_mqtlh_4.5k"] = -90.0
env["kmin_mqtli"] = -125.0
env["kmin_mqwa"] = 1.873
env["kmin_mqwb"] = -30.0
env["kmin_mqxa"] = 5.71
env["kmin_mqxb"] = 5.999
env["kmin_mqy_4.5k"] = 3.546
env["kmin_ms"] = -8860.0
env["kmin_msda"] = 0.021
env["kmin_msdb"] = 0.026
env["kmin_msdb2"] = 0.026
env["kmin_msdc"] = 0.031
env["kmin_msia"] = 0.04
env["kmin_msib"] = 0.059
env["kmin_mss"] = -8860.0

# /************************************************************************************/
# /*                       Imax                                                       */
# /************************************************************************************/

env["imax_mb"] = 11850.0
env["imax_mbaw"] = 6000.0
env["imax_mblw"] = 5850.0
env["imax_mbrb_4.5k"] = 6150.0
env["imax_mbrc_4.5k"] = 4400.0
env["imax_mbrs_4.5k"] = 5860.0
env["imax_mbw"] = 720.0
env["imax_mbwmd"] = 550.0
env["imax_mbx"] = 5800.0
env["imax_mbxw"] = 750.0
env["imax_mbxwh"] = 750.0
env["imax_mbxws"] = 780.0
env["imax_mbxwt"] = 600.0
env["imax_mcbch"] = 100.0
env["imax_mcbch_4.5k"] = 80.0
env["imax_mcbcv"] = 100.0
env["imax_mcbcv_4.5k"] = 80.0
env["imax_mcbh"] = 55.0
env["imax_mcbv"] = 55.0
env["imax_mcbwh"] = 500.0
env["imax_mcbwv"] = 500.0
env["imax_mcbxh"] = 550.0
env["imax_mcbxv"] = 550.0
env["imax_mcbyh_4.5k"] = 72.0
env["imax_mcbyv_4.5k"] = 72.0
env["imax_mcd"] = 550.0
env["imax_mco"] = 100.0
env["imax_mcosx"] = 100.0
env["imax_mcox"] = 100.0
env["imax_mcs"] = 550.0
env["imax_mcssx"] = 100.0
env["imax_mcsx"] = 100.0
env["imax_mctx"] = 80.0
env["imax_mo"] = 550.0
env["imax_mq"] = 11870.0
env["imax_mqm"] = 5390.0
env["imax_mqm_4.5k"] = 4310.0
env["imax_mqmc"] = 5390.0
env["imax_mqml"] = 5390.0
env["imax_mqml_4.5k"] = 4310.0
env["imax_mqs"] = 550.0
env["imax_mqsx"] = 550.0
env["imax_mqt"] = 550.0
env["imax_mqtlh_4.5k"] = 400.0
env["imax_mqtli"] = 550.0
env["imax_mqwa"] = 710.0
env["imax_mqwb"] = 600.0
env["imax_mqxa"] = 7180.0
env["imax_mqxb"] = 11960.0
env["imax_mqy_4.5k"] = 3610.0
env["imax_ms"] = 550.0
env["imax_msda"] = 880.0
env["imax_msdb"] = 880.0
env["imax_msdb2"] = 880.0
env["imax_msdc"] = 880.0
env["imax_msia"] = 950.0
env["imax_msib"] = 950.0
env["imax_mss"] = 550.0

# /************************************************************************************/
# /*                       CLASSES DEFINITION                                         */
# /************************************************************************************/

env.new(
    "hcorrector",
    "hkicker",
)
env.new(
    "vcorrector",
    "vkicker",
)

# //---------------------- COLLIMATOR     ---------------------------------------------
env.new("tanb", "collimator", length="l.tanb")
env.new("tas", "collimator", length="l.tas")
env.new("tasb", "collimator", length="l.tasb")
env.new("tcapa019", "collimator", length="l.tcapa019")
env.new("tcapa020", "collimator", length="l.tcapa020")
env.new("tcapb", "collimator", length="l.tcapb")
env.new("tcapc", "collimator", length="l.tcapc")
env.new("tcapd", "collimator", length="l.tcapd")
env.new("tcdd", "collimator", length="l.tcdd")
env.new("tcddm", "collimator", length="l.tcddm")
env.new("tcdqa", "collimator", length="l.tcdqa")
env.new("tcdqm", "collimator", length="l.tcdqm")
env.new("tcdsa", "collimator", length="l.tcdsa")
env.new("tcdsb", "collimator", length="l.tcdsb")
env.new("tcl", "collimator", length="l.tcl")
env.new("tcla", "collimator", length="l.tcla")
env.new("tcld", "collimator", length="l.tcld")
env.new("tclia", "collimator", length="l.tclia")
env.new("tclib", "collimator", length="l.tclib")
env.new("tclim", "collimator", length="l.tclim")
env.new("tcp", "collimator", length="l.tcp")
env.new("tcpch", "collimator", length="l.tcpch")
env.new("tcpcv", "collimator", length="l.tcpcv")
env.new("tcppm", "collimator", length="l.tcppm")
env.new("tcsg", "collimator", length="l.tcsg")
env.new("tcsp", "collimator", length="l.tcsp")
env.new("tcspm", "collimator", length="l.tcspm")
env.new("tctph", "collimator", length="l.tctph")
env.new("tctpv", "collimator", length="l.tctpv")
env.new("tctwh", "collimator", length="l.tctwh")
env.new("tctwv", "collimator", length="l.tctwv")
env.new("tdisa", "collimator", length="l.tdisa")
env.new("tdisb", "collimator", length="l.tdisb")
env.new("tdisc", "collimator", length="l.tdisc")
env.new("xrph", "collimator", length="l.xrph")
env.new("xrpv", "collimator", length="l.xrpv")
# //---------------------- HCORRECTOR     ---------------------------------------------
env.new("mcbch", "hcorrector", length="l.mcbch", extra=dict(kmax="kmax_mcbch", kmin="kmin_mcbch", calib="kmax_mcbch/imax_mcbch"))
env.new("mcbh", "hcorrector", length="l.mcbh", extra=dict(kmax="kmax_mcbh", kmin="kmin_mcbh", calib="kmax_mcbh/imax_mcbh"))
env.new("mcbwh", "hcorrector", length="l.mcbwh", extra=dict(kmax="kmax_mcbwh", kmin="kmin_mcbwh", calib="kmax_mcbwh/imax_mcbwh"))
env.new("mcbxh", "hcorrector", length="l.mcbxh", extra=dict(kmax="kmax_mcbxh", kmin="kmin_mcbxh", calib="kmax_mcbxh/imax_mcbxh"))
env.new("mcbyh", "hcorrector", length="l.mcbyh", extra=dict(calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
# //---------------------- HKICKER        ---------------------------------------------
env.new("mblw", "hkicker", length="l.mblw", extra=dict(kmax="kmax_mblw", kmin="kmin_mblw", calib="kmax_mblw/imax_mblw"))
env.new("mbxwh", "hkicker", length="l.mbxwh", extra=dict(kmax="kmax_mbxwh", kmin="kmin_mbxwh", calib="kmax_mbxwh/imax_mbxwh"))
env.new("mbxws", "hkicker", length="l.mbxws", extra=dict(kmax="kmax_mbxws", kmin="kmin_mbxws", calib="kmax_mbxws/imax_mbxws"))
# //---------------------- INSTRUMENT     ---------------------------------------------
env.new("apwl", "instrument", length="l.apwl")
env.new("bctdc", "instrument", length="l.bctdc")
env.new("bctfr", "instrument", length="l.bctfr")
env.new("bgcab", "instrument", length="l.bgcab")
env.new("bgvca001", "instrument", length="l.bgvca001")
env.new("bplh", "instrument", length="l.bplh")
env.new("bplv", "instrument", length="l.bplv")
env.new("bplx", "instrument", length="l.bplx")
env.new("bptx", "instrument", length="l.bptx")
env.new("bqsh", "instrument", length="l.bqsh")
env.new("bqsv", "instrument", length="l.bqsv")
env.new("brana", "instrument", length="l.brana")
env.new("branc", "instrument", length="l.branc")
env.new("brand", "instrument", length="l.brand")
env.new("bsrtm", "instrument", length="l.bsrtm")
env.new("bsrtmb", "instrument", length="l.bsrtmb")
env.new("bsrto001", "instrument", length="l.bsrto001")
env.new("bsrto002", "instrument", length="l.bsrto002")
env.new("bsrtr", "instrument", length="l.bsrtr")
env.new("btvm", "instrument", length="l.btvm")
env.new("btvse", "instrument", length="l.btvse")
env.new("btvsi084", "instrument", length="l.btvsi084")
env.new("btvsi088", "instrument", length="l.btvsi088")
env.new("btvss074", "instrument", length="l.btvss074")
env.new("btvss075", "instrument", length="l.btvss075")
env.new("btvst064", "instrument", length="l.btvst064")
env.new("btvst065", "instrument", length="l.btvst065")
env.new("bws", "instrument", length="l.bws")
env.new(
    "tanal",
    "instrument",
)
env.new(
    "tanar",
    "instrument",
)
env.new(
    "tanc",
    "instrument",
)
env.new(
    "x1zdc001",
    "instrument",
)
env.new(
    "x1zdc002",
    "instrument",
)
env.new(
    "x2zdc001",
    "instrument",
)
env.new(
    "x2zdc002",
    "instrument",
)
env.new("x5fca", "instrument", length="l.x5fca")
env.new("x5fcb", "instrument", length="l.x5fcb")
env.new(
    "x5zdc001",
    "instrument",
)
env.new(
    "x5zdc002",
    "instrument",
)
# //---------------------- MARKER         ---------------------------------------------
env.new(
    "omk",
    "marker",
)
# //---------------------- MONITOR        ---------------------------------------------
env.new("bbcwb", "monitor", length="l.bbcwb")
env.new("bbcwe", "monitor", length="l.bbcwe")
env.new("bbcwi", "monitor", length="l.bbcwi")
env.new("bbcwt", "monitor", length="l.bbcwt")
env.new("bpm", "monitor", length="l.bpm")
env.new("bpmcs", "monitor", length="l.bpmcs")
env.new("bpmr", "monitor", length="l.bpmr")
env.new("bpmra", "monitor", length="l.bpmra")
env.new("bpmsa", "monitor", length="l.bpmsa")
env.new("bpmse", "monitor", length="l.bpmse")
env.new("bpmsi002", "monitor", length="l.bpmsi002")
env.new("bpmsw002", "monitor", length="l.bpmsw002")
env.new("bpmsx002", "monitor", length="l.bpmsx002")
env.new("bpmsx003", "monitor", length="l.bpmsx003")
env.new("bpmsx004", "monitor", length="l.bpmsx004")
env.new("bpmsy002", "monitor", length="l.bpmsy002")
env.new("bpms_003", "monitor", length="l.bpms_003")
env.new("bpmwa", "monitor", length="l.bpmwa")
env.new("bpmwb", "monitor", length="l.bpmwb")
env.new("bpmwc", "monitor", length="l.bpmwc")
env.new("bpmwe003", "monitor", length="l.bpmwe003")
env.new("bpmwe007", "monitor", length="l.bpmwe007")
env.new("bpmwe008", "monitor", length="l.bpmwe008")
env.new("bpmwe009", "monitor", length="l.bpmwe009")
env.new("bpmwf", "monitor", length="l.bpmwf")
env.new("bpmwg", "monitor", length="l.bpmwg")
env.new("bpmwi", "monitor", length="l.bpmwi")
env.new("bpmwj", "monitor", length="l.bpmwj")
env.new("bpmwt", "monitor", length="l.bpmwt")
env.new("bpmw_010", "monitor", length="l.bpmw_010")
env.new("bpmw_013", "monitor", length="l.bpmw_013")
env.new("bpmw_014", "monitor", length="l.bpmw_014")
env.new("bpmw_015", "monitor", length="l.bpmw_015")
env.new("bpmya", "monitor", length="l.bpmya")
env.new("bpmyb", "monitor", length="l.bpmyb")
env.new("bpm_a", "monitor", length="l.bpm_a")
env.new("bptdh", "monitor", length="l.bptdh")
env.new("bptdj", "monitor", length="l.bptdj")
env.new("bptdv", "monitor", length="l.bptdv")
env.new("bptuh", "monitor", length="l.bptuh")
env.new("bptuj", "monitor", length="l.bptuj")
env.new("bptut", "monitor", length="l.bptut")
env.new("bptuv", "monitor", length="l.bptuv")
# //---------------------- MULTIPOLE      ---------------------------------------------
env.new("mcd", "multipole", length="l.mcd", extra=dict(kmax="kmax_mcd", kmin="kmin_mcd", calib="kmax_mcd/imax_mcd"))
env.new("mco", "multipole", length="l.mco", extra=dict(kmax="kmax_mco", kmin="kmin_mco", calib="kmax_mco/imax_mco"))
env.new("mcosx", "multipole", length="l.mcosx", extra=dict(kmax="kmax_mcosx", kmin="kmin_mcosx", calib="kmax_mcosx/imax_mcosx"))
env.new("mcox", "multipole", length="l.mcox", extra=dict(kmax="kmax_mcox", kmin="kmin_mcox", calib="kmax_mcox/imax_mcox"))
env.new("mcssx", "multipole", length="l.mcssx", extra=dict(kmax="kmax_mcssx", kmin="kmin_mcssx", calib="kmax_mcssx/imax_mcssx"))
env.new("mcsx", "multipole", length="l.mcsx", extra=dict(kmax="kmax_mcsx", kmin="kmin_mcsx", calib="kmax_mcsx/imax_mcsx"))
env.new("mctx", "multipole", length="l.mctx", extra=dict(kmax="kmax_mctx", kmin="kmin_mctx", calib="kmax_mctx/imax_mctx"))
# //---------------------- OCTUPOLE       ---------------------------------------------
env.new("mo", "octupole", length="l.mo", extra=dict(kmax="kmax_mo", kmin="kmin_mo", calib="kmax_mo/imax_mo"))
# //---------------------- PLACEHOLDER    ---------------------------------------------
env.new("acsph001", "placeholder", length="l.acsph001")
env.new("acsph002", "placeholder", length="l.acsph002")
env.new("bgvca003", "placeholder", length="l.bgvca003")
env.new("bgvca004", "placeholder", length="l.bgvca004")
env.new("dfbaa", "placeholder", length="l.dfbaa")
env.new("dfbab", "placeholder", length="l.dfbab")
env.new("dfbac", "placeholder", length="l.dfbac")
env.new("dfbad", "placeholder", length="l.dfbad")
env.new("dfbae", "placeholder", length="l.dfbae")
env.new("dfbaf", "placeholder", length="l.dfbaf")
env.new("dfbag", "placeholder", length="l.dfbag")
env.new("dfbah", "placeholder", length="l.dfbah")
env.new("dfbai", "placeholder", length="l.dfbai")
env.new("dfbaj", "placeholder", length="l.dfbaj")
env.new("dfbak", "placeholder", length="l.dfbak")
env.new("dfbal", "placeholder", length="l.dfbal")
env.new("dfbam", "placeholder", length="l.dfbam")
env.new("dfban", "placeholder", length="l.dfban")
env.new("dfbao", "placeholder", length="l.dfbao")
env.new("dfbap", "placeholder", length="l.dfbap")
env.new("dfbxa", "placeholder", length="l.dfbxa")
env.new("dfbxb", "placeholder", length="l.dfbxb")
env.new("dfbxc", "placeholder", length="l.dfbxc")
env.new("dfbxd", "placeholder", length="l.dfbxd")
env.new("dfbxe", "placeholder", length="l.dfbxe")
env.new("dfbxf", "placeholder", length="l.dfbxf")
env.new("dfbxg", "placeholder", length="l.dfbxg")
env.new("dfbxh", "placeholder", length="l.dfbxh")
env.new("leal", "placeholder", length="l.leal")
env.new("lear", "placeholder", length="l.lear")
env.new("lebl", "placeholder", length="l.lebl")
env.new("lebr", "placeholder", length="l.lebr")
env.new("lecl", "placeholder", length="l.lecl")
env.new("ledr", "placeholder", length="l.ledr")
env.new("leel", "placeholder", length="l.leel")
env.new("lefl", "placeholder", length="l.lefl")
env.new("legr", "placeholder", length="l.legr")
env.new("lehr", "placeholder", length="l.lehr")
env.new("leir", "placeholder", length="l.leir")
env.new("lejl", "placeholder", length="l.lejl")
env.new("lenla", "placeholder", length="l.lenla")
env.new("lenra", "placeholder", length="l.lenra")
env.new("lepla", "placeholder", length="l.lepla")
env.new("leplb", "placeholder", length="l.leplb")
env.new("lepra", "placeholder", length="l.lepra")
env.new("leprb", "placeholder", length="l.leprb")
env.new("mcbh_unplugged", "placeholder", length="l.mcbh_unplugged")
env.new("mcbv_unplugged", "placeholder", length="l.mcbv_unplugged")
env.new(
    "mcbxh_unplugged",
    "placeholder",
)
env.new(
    "mcd_unplugged",
    "placeholder",
)
env.new(
    "mcosx_unplugged",
    "placeholder",
)
env.new(
    "mcox_unplugged",
    "placeholder",
)
env.new(
    "mco_unplugged",
    "placeholder",
)
env.new(
    "mcssx_unplugged",
    "placeholder",
)
env.new("mcs_unplugged", "placeholder", length="l.mcs_unplugged")
env.new("mo_unplugged", "placeholder", length="l.mo_unplugged")
env.new("mqt_unplugged", "placeholder", length="l.mqt_unplugged")
env.new("mss_unplugged", "placeholder", length="l.mss_unplugged")
# //---------------------- QUADRUPOLE     ---------------------------------------------
env.new("mq", "quadrupole", length="l.mq", extra=dict(kmax="kmax_mq", kmin="kmin_mq", calib="kmax_mq/imax_mq"))
env.new("mqm", "quadrupole", length="l.mqm", extra=dict(kmax="kmax_mqm", kmin="kmin_mqm", calib="kmax_mqm/imax_mqm"))
env.new("mqmc", "quadrupole", length="l.mqmc", extra=dict(kmax="kmax_mqmc", kmin="kmin_mqmc", calib="kmax_mqmc/imax_mqmc"))
env.new("mqml", "quadrupole", length="l.mqml", extra=dict(kmax="kmax_mqml", kmin="kmin_mqml", calib="kmax_mqml/imax_mqml"))
env.new("mqs", "quadrupole", length="l.mqs", extra=dict(kmax="kmax_mqs", kmin="kmin_mqs", calib="kmax_mqs/imax_mqs"))
env.new("mqsx", "quadrupole", length="l.mqsx", extra=dict(kmax="kmax_mqsx", kmin="kmin_mqsx", calib="kmax_mqsx/imax_mqsx"))
env.new("mqt", "quadrupole", length="l.mqt", extra=dict(kmax="kmax_mqt", kmin="kmin_mqt", calib="kmax_mqt/imax_mqt"))
env.new("mqtlh", "quadrupole", length="l.mqtlh", extra=dict(calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.new("mqtli", "quadrupole", length="l.mqtli", extra=dict(kmax="kmax_mqtli", kmin="kmin_mqtli", calib="kmax_mqtli/imax_mqtli"))
env.new("mqwa", "quadrupole", length="l.mqwa", extra=dict(kmax="kmax_mqwa", kmin="kmin_mqwa", calib="kmax_mqwa/imax_mqwa"))
env.new("mqwb", "quadrupole", length="l.mqwb", extra=dict(kmax="kmax_mqwb", kmin="kmin_mqwb", calib="kmax_mqwb/imax_mqwb"))
env.new("mqxa", "quadrupole", length="l.mqxa", extra=dict(kmax="kmax_mqxa", kmin="kmin_mqxa", calib="kmax_mqxa/imax_mqxa"))
env.new("mqxb", "quadrupole", length="l.mqxb", extra=dict(kmax="kmax_mqxb", kmin="kmin_mqxb", calib="kmax_mqxb/imax_mqxb"))
env.new("mqy", "quadrupole", length="l.mqy", extra=dict(calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
# //---------------------- RBEND          ---------------------------------------------
env.new("mbrb", "rbend", length="l.mbrb", extra=dict(calib="kmax_mbrb_4.5k/imax_mbrb_4.5k"))
env.new("mbrc", "rbend", length="l.mbrc", extra=dict(calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.new("mbrs", "rbend", length="l.mbrs", extra=dict(calib="kmax_mbrs_4.5k/imax_mbrs_4.5k"))
env.new("mbw", "rbend", length="l.mbw", extra=dict(kmax="kmax_mbw", kmin="kmin_mbw", calib="kmax_mbw/imax_mbw"))
env.new("mbx", "rbend", length="l.mbx", extra=dict(kmax="kmax_mbx", kmin="kmin_mbx", calib="kmax_mbx/imax_mbx"))
env.new("mbxw", "rbend", length="l.mbxw", extra=dict(kmax="kmax_mbxw", kmin="kmin_mbxw", calib="kmax_mbxw/imax_mbxw"))
# //---------------------- RFCAVITY       ---------------------------------------------
env.new(
    "acsca",
    "rfcavity",
)
# //---------------------- SBEND          ---------------------------------------------
env.new("mb", "sbend", length="l.mb", extra=dict(kmax="kmax_mb", kmin="kmin_mb", calib="kmax_mb/imax_mb"))
# //---------------------- SEXTUPOLE      ---------------------------------------------
env.new("mcs", "sextupole", length="l.mcs", extra=dict(kmax="kmax_mcs", kmin="kmin_mcs", calib="kmax_mcs/imax_mcs"))
env.new("ms", "sextupole", length="l.ms", extra=dict(kmax="kmax_ms", kmin="kmin_ms", calib="kmax_ms/imax_ms"))
env.new("mss", "sextupole", length="l.mss", extra=dict(kmax="kmax_mss", kmin="kmin_mss", calib="kmax_mss/imax_mss"))
# //---------------------- SOLENOID       ---------------------------------------------
env.new("mbas2", "solenoid", length="l.mbas2")
env.new("mbcs2", "solenoid", length="l.mbcs2")
env.new("mbls2", "solenoid", length="l.mbls2")
# //---------------------- TKICKER        ---------------------------------------------
env.new("adtkh", "tkicker", length="l.adtkh")
env.new("adtkv", "tkicker", length="l.adtkv")
env.new("bqkh", "tkicker", length="l.bqkh")
env.new("bqkv", "tkicker", length="l.bqkv")
env.new("mgmwh", "tkicker", length="l.mgmwh")
env.new("mgmwh003", "tkicker", length="l.mgmwh003")
env.new("mgmwv", "tkicker", length="l.mgmwv")
env.new("mgmwv003", "tkicker", length="l.mgmwv003")
env.new("mkd", "tkicker", length="l.mkd")
env.new("mkima192", "tkicker", length="l.mkima192")
env.new("mkima193", "tkicker", length="l.mkima193")
env.new("mkqa", "tkicker", length="l.mkqa")
env.new("msda", "tkicker", length="l.msda", extra=dict(kmax="kmax_msda", kmin="kmin_msda", calib="kmax_msda/imax_msda"))
env.new("msdb", "tkicker", length="l.msdb", extra=dict(kmax="kmax_msdb", kmin="kmin_msdb", calib="kmax_msdb/imax_msdb"))
env.new("msdb2", "tkicker", length="l.msdb2", extra=dict(kmax="kmax_msdb2", kmin="kmin_msdb2", calib="kmax_msdb2/imax_msdb2"))
env.new("msdc", "tkicker", length="l.msdc", extra=dict(kmax="kmax_msdc", kmin="kmin_msdc", calib="kmax_msdc/imax_msdc"))
env.new("msia", "tkicker", length="l.msia", extra=dict(kmax="kmax_msia", kmin="kmin_msia", calib="kmax_msia/imax_msia"))
env.new("msib", "tkicker", length="l.msib", extra=dict(kmax="kmax_msib", kmin="kmin_msib", calib="kmax_msib/imax_msib"))
env.new("mu", "tkicker", length="l.mu")
# //---------------------- VCORRECTOR     ---------------------------------------------
env.new("mcbcv", "vcorrector", length="l.mcbcv", extra=dict(kmax="kmax_mcbcv", kmin="kmin_mcbcv", calib="kmax_mcbcv/imax_mcbcv"))
env.new("mcbv", "vcorrector", length="l.mcbv", extra=dict(kmax="kmax_mcbv", kmin="kmin_mcbv", calib="kmax_mcbv/imax_mcbv"))
env.new("mcbwv", "vcorrector", length="l.mcbwv", extra=dict(kmax="kmax_mcbwv", kmin="kmin_mcbwv", calib="kmax_mcbwv/imax_mcbwv"))
env.new("mcbxv", "vcorrector", length="l.mcbxv", extra=dict(kmax="kmax_mcbxv", kmin="kmin_mcbxv", calib="kmax_mcbxv/imax_mcbxv"))
env.new("mcbyv", "vcorrector", length="l.mcbyv", extra=dict(calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
# //---------------------- VKICKER        ---------------------------------------------
env.new("mbaw", "vkicker", length="l.mbaw", extra=dict(kmax="kmax_mbaw", kmin="kmin_mbaw", calib="kmax_mbaw/imax_mbaw"))
env.new("mbwmd", "vkicker", length="l.mbwmd", extra=dict(kmax="kmax_mbwmd", kmin="kmin_mbwmd", calib="kmax_mbwmd/imax_mbwmd"))
env.new("mbxwt", "vkicker", length="l.mbxwt", extra=dict(kmax="kmax_mbxwt", kmin="kmin_mbxwt", calib="kmax_mbxwt/imax_mbxwt"))

# /************************************************************************************/
# /*                       LHC SEQUENCE                                               */
# /************************************************************************************/

lhcb1 = env.new_builder(name="lhcb1")
lhcb1.new("ip1", "omk", at="pip1+ip1ofs.b1*ds")
lhcb1.new("mbas2.1r1", "mbas2", at="1.5+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=51937884.0))
lhcb1.new("tas.1r1", "tas", at="19.95+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=102103.0))
lhcb1.new("bpmsw.1r1.b1", "bpmsw002", at="21.564+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=6080259.0, assembly_id=6080224.0))
lhcb1.new("bpmsw.1r1.b1_doros", "bpmsw002", at="21.564+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=10429420.0, assembly_id=6080224.0))
lhcb1.new("bpmwf.a1r1.b1", "bpmwf", at="21.697+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=6080267.0, assembly_id=6080224.0))
lhcb1.new("mqxa.1r1", "mqxa", at="26.15+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282126.0, assembly_id=102104.0))
lhcb1.new("mcbxh.1r1", "mcbxh", at="29.842+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282213.0, assembly_id=102104.0))
lhcb1.new("mcbxv.1r1", "mcbxv", at="29.842+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282212.0, assembly_id=102104.0))
lhcb1.new("bpms.2r1.b1", "bpms_003", at="31.529+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=47564239.0, assembly_id=102105.0))
lhcb1.new("mqxb.a2r1", "mqxb", at="34.8+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=241890.0, assembly_id=102105.0))
lhcb1.new("mcbxh.2r1", "mcbxh", at="38.019+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249450.0, assembly_id=102105.0))
lhcb1.new("mcbxv.2r1", "mcbxv", at="38.019+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249451.0, assembly_id=102105.0))
lhcb1.new("mqxb.b2r1", "mqxb", at="41.3+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=241892.0, assembly_id=102105.0))
lhcb1.new("tasb.3r1", "tasb", at="45.342+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=241893.0, assembly_id=102106.0))
lhcb1.new("mqsx.3r1", "mqsx", at="46.608+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282127.0, assembly_id=102106.0))
lhcb1.new("mqxa.3r1", "mqxa", at="50.15+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=241895.0, assembly_id=102106.0))
lhcb1.new("mcbxh.3r1", "mcbxh", at="53.814+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249456.0, assembly_id=102106.0))
lhcb1.new("mcbxv.3r1", "mcbxv", at="53.814+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249457.0, assembly_id=102106.0))
lhcb1.new("mcsx.3r1", "mcsx", at="53.814+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249458.0, assembly_id=102106.0))
lhcb1.new("mctx.3r1", "mctx", at="53.814+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249459.0, assembly_id=102106.0))
lhcb1.new("mcosx.3r1", "mcosx", at="54.297+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282237.0, assembly_id=102106.0))
lhcb1.new("mcox.3r1", "mcox", at="54.297+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282236.0, assembly_id=102106.0))
lhcb1.new("mcssx.3r1", "mcssx", at="54.297+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282235.0, assembly_id=102106.0))
lhcb1.new("dfbxb.3r1", "dfbxb", at="56.427+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=104672.0))
lhcb1.new("bpmsy.4r1.b1", "bpmsy002", at="58.2545+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=47562514.0, assembly_id=104595.0))
lhcb1.new("mbxw.a4r1", "mbxw", at="61.322+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134500.0))
lhcb1.new("mbxw.b4r1", "mbxw", at="65.588+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134501.0))
lhcb1.new("mbxw.c4r1", "mbxw", at="69.854+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134502.0))
lhcb1.new("mbxw.d4r1", "mbxw", at="74.12+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134503.0))
lhcb1.new("mbxw.e4r1", "mbxw", at="78.386+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134504.0))
lhcb1.new("mbxw.f4r1", "mbxw", at="82.652+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134505.0))
lhcb1.new("x1zdc.b4r1", "x1zdc002", at="141.16+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=2019588.0, assembly_id=102108.0))
lhcb1.new("brand.4r1", "brand", at="141.476+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=55374060.0, assembly_id=102108.0))
lhcb1.new("x1zdc.a4r1", "x1zdc001", at="141.71+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=2019586.0, assembly_id=102108.0))
lhcb1.new("tanar.4r1", "tanar", at="142.754+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.0, slot_id=102108.0))
lhcb1.new("tcl.4r1.b1", "tcl", at="150.03+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.1757, slot_id=6755437.0))
lhcb1.new("bpmwb.4r1.b1", "bpmwb", at="151.0945+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.178, slot_id=181634.0))
lhcb1.new("mbrc.4r1.b1", "mbrc", at="157.9+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.188, slot_id=52819614.0, assembly_id=102110.0))
lhcb1.new("mcbyv.a4r1.b1", "mcbyv", at="164.439+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249460.0, assembly_id=102111.0))
lhcb1.new("mcbyh.4r1.b1", "mcbyh", at="165.735+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249462.0, assembly_id=102111.0))
lhcb1.new("mcbyv.b4r1.b1", "mcbyv", at="167.031+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249464.0, assembly_id=102111.0))
lhcb1.new("mqy.4r1.b1", "mqy", at="169.553+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2302956.0, assembly_id=102111.0))
lhcb1.new("bpmya.4r1.b1", "bpmya", at="172.227+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241908.0, assembly_id=102111.0))
lhcb1.new("tcl.5r1.b1", "tcl", at="184.357+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=102112.0))
lhcb1.new("mcbch.5r1.b1", "mcbch", at="193.448+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249466.0, assembly_id=102113.0))
lhcb1.new("mqml.5r1.b1", "mqml", at="196.49+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2302964.0, assembly_id=102113.0))
lhcb1.new("bpm.5r1.b1", "bpm", at="199.635+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=377901.0, assembly_id=102113.0))
lhcb1.new("xrph.a6r1.b1", "xrph", at="205.217+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=34158027.0, assembly_id=34154641.0))
lhcb1.new("xrph.b6r1.b1", "xrph", at="217.302+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=34158029.0, assembly_id=34154642.0))
lhcb1.new("bpmsa.a6r1.b1", "bpmsa", at="217.6105+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=34154643.0))
lhcb1.new("tcl.6r1.b1", "tcl", at="219.013+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=12962634.0))
lhcb1.new("mcbcv.6r1.b1", "mcbcv", at="225.348+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249468.0, assembly_id=102114.0))
lhcb1.new("mqml.6r1.b1", "mqml", at="228.39+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2303152.0, assembly_id=102114.0))
lhcb1.new("bpmr.6r1.b1", "bpmr", at="231.535+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=377903.0, assembly_id=102114.0))
lhcb1.new("xrpv.a7r1.b1", "xrpv", at="237.398+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=389137.0, assembly_id=825699.0))
lhcb1.new("bpmsx.7r1.b1", "bpmsx004", at="237.7505+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=826796.0))
lhcb1.new("xrpv.b7r1.b1", "xrpv", at="245.656+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=389138.0, assembly_id=825700.0))
lhcb1.new("dfbab.7r1.b1", "dfbab", at="257.4465+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52996563.0, assembly_id=104673.0))
lhcb1.new("bpm_a.7r1.b1", "bpm_a", at="259.259+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=377907.0, assembly_id=102115.0))
lhcb1.new("mqm.a7r1.b1", "mqm", at="261.704+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307759.0, assembly_id=102115.0))
lhcb1.new("mqm.b7r1.b1", "mqm", at="265.471+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307774.0, assembly_id=102115.0))
lhcb1.new("mcbch.7r1.b1", "mcbch", at="267.812+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=378077.0, assembly_id=102115.0))
lhcb1.new("s.ds.r1.b1", "omk", at="268.904+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(slot_id=100932.0))
lhcb1.new("mco.8r1.b1", "mco_unplugged", at="269.248+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249472.0, assembly_id=102116.0))
lhcb1.new("mcd.8r1.b1", "mcd", at="269.2495+(0-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249473.0, assembly_id=102116.0))
lhcb1.new("mb.a8r1.b1", "mb", at="276.734+(.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820278.0, assembly_id=102116.0))
lhcb1.new("mcs.a8r1.b1", "mcs", at="284.158+(1-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241927.0, assembly_id=102116.0))
lhcb1.new("mb.b8r1.b1", "mb", at="292.394+(1.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820302.0, assembly_id=102117.0))
lhcb1.new("mcs.b8r1.b1", "mcs", at="299.818+(2-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241930.0, assembly_id=102117.0))
lhcb1.new("bpm.8r1.b1", "bpm", at="300.697+(2-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=377910.0, assembly_id=102118.0))
lhcb1.new("mqml.8r1.b1", "mqml", at="303.842+(2-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307610.0, assembly_id=102118.0))
lhcb1.new("mcbcv.8r1.b1", "mcbcv", at="306.884+(2-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=378080.0, assembly_id=102118.0))
lhcb1.new("mco.9r1.b1", "mco_unplugged", at="308.313+(2-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249478.0, assembly_id=102119.0))
lhcb1.new("mcd.9r1.b1", "mcd", at="308.3145+(2-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249479.0, assembly_id=102119.0))
lhcb1.new("mb.a9r1.b1", "mb", at="315.799+(2.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820326.0, assembly_id=102119.0))
lhcb1.new("mcs.a9r1.b1", "mcs", at="323.223+(3-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241939.0, assembly_id=102119.0))
lhcb1.new("mb.b9r1.b1", "mb", at="331.459+(3.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820350.0, assembly_id=102120.0))
lhcb1.new("mcs.b9r1.b1", "mcs", at="338.883+(4-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241942.0, assembly_id=102120.0))
lhcb1.new("bpm.9r1.b1", "bpm", at="339.763+(4-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=377916.0, assembly_id=102121.0))
lhcb1.new("mqmc.9r1.b1", "mqmc", at="341.739+(4-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307793.0, assembly_id=102121.0))
lhcb1.new("mqm.9r1.b1", "mqm", at="345.005+(4-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307740.0, assembly_id=102121.0))
lhcb1.new("mcbch.9r1.b1", "mcbch", at="347.346+(4-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=378087.0, assembly_id=102121.0))
lhcb1.new("mco.10r1.b1", "mco_unplugged", at="348.778+(4-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249484.0, assembly_id=102122.0))
lhcb1.new("mcd.10r1.b1", "mcd", at="348.7795+(4-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249485.0, assembly_id=102122.0))
lhcb1.new("mb.a10r1.b1", "mb", at="356.264+(4.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820374.0, assembly_id=102122.0))
lhcb1.new("mcs.a10r1.b1", "mcs", at="363.688+(5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241952.0, assembly_id=102122.0))
lhcb1.new("mb.b10r1.b1", "mb", at="371.924+(5.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820398.0, assembly_id=102123.0))
lhcb1.new("mcs.b10r1.b1", "mcs", at="379.348+(6-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241955.0, assembly_id=102123.0))
lhcb1.new("bpm.10r1.b1", "bpm", at="380.227+(6-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=377919.0, assembly_id=102124.0))
lhcb1.new("mqml.10r1.b1", "mqml", at="383.372+(6-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307816.0, assembly_id=102124.0))
lhcb1.new("mcbcv.10r1.b1", "mcbcv", at="386.414+(6-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=378090.0, assembly_id=102124.0))
lhcb1.new("mco.11r1.b1", "mco_unplugged", at="387.843+(6-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249490.0, assembly_id=102125.0))
lhcb1.new("mcd.11r1.b1", "mcd", at="387.8445+(6-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249491.0, assembly_id=102125.0))
lhcb1.new("mb.a11r1.b1", "mb", at="395.329+(6.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820422.0, assembly_id=102125.0))
lhcb1.new("mcs.a11r1.b1", "mcs", at="402.753+(7-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241964.0, assembly_id=102125.0))
lhcb1.new("mb.b11r1.b1", "mb", at="410.989+(7.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52849390.0, assembly_id=102126.0))
lhcb1.new("mcs.b11r1.b1", "mcs", at="418.413+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=357281.0, assembly_id=102126.0))
lhcb1.new("lehr.11r1.b1", "lehr", at="425.67735+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52997922.0, assembly_id=102127.0))
lhcb1.new("bpm.11r1.b1", "bpm", at="433.0087+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241969.0, assembly_id=102128.0))
lhcb1.new("mq.11r1.b1", "mq", at="435.5557+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308664.0, assembly_id=102128.0))
lhcb1.new("mqtli.11r1.b1", "mqtli", at="437.9247+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307353.0, assembly_id=102128.0))
lhcb1.new("ms.11r1.b1", "ms", at="438.9367+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249494.0, assembly_id=102128.0))
lhcb1.new("mcbh.11r1.b1", "mcbh_unplugged", at="439.5297+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249496.0, assembly_id=102128.0))
lhcb1.new("s.arc.12.b1", "omk", at="440.2807+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a12r1.b1", "mco_unplugged", at="440.6247+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249498.0, assembly_id=102129.0))
lhcb1.new("mcd.a12r1.b1", "mcd", at="440.6262+(8-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249499.0, assembly_id=102129.0))
lhcb1.new("mb.a12r1.b1", "mb", at="448.1107+(8.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820446.0, assembly_id=102129.0))
lhcb1.new("mcs.a12r1.b1", "mcs", at="455.5347+(9-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241977.0, assembly_id=102129.0))
lhcb1.new("mb.b12r1.b1", "mb", at="463.7707+(9.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820470.0, assembly_id=102130.0))
lhcb1.new("mcs.b12r1.b1", "mcs", at="471.1947+(10-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241980.0, assembly_id=102130.0))
lhcb1.new("mco.b12r1.b1", "mco_unplugged", at="471.9447+(10-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249502.0, assembly_id=102131.0))
lhcb1.new("mcd.b12r1.b1", "mcd", at="471.9462+(10-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249503.0, assembly_id=102131.0))
lhcb1.new("mb.c12r1.b1", "mb", at="479.4307+(10.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820494.0, assembly_id=102131.0))
lhcb1.new("mcs.c12r1.b1", "mcs", at="486.8547+(11-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241985.0, assembly_id=102131.0))
lhcb1.new("bpm.12r1.b1", "bpm", at="487.7337+(11-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241987.0, assembly_id=102132.0))
lhcb1.new("mqt.12r1.b1", "mqt", at="488.4877+(11-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307699.0, assembly_id=102132.0))
lhcb1.new("mq.12r1.b1", "mq", at="490.4957+(11-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308458.0, assembly_id=102132.0))
lhcb1.new("ms.12r1.b1", "ms", at="492.3907+(11-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249506.0, assembly_id=102132.0))
lhcb1.new("mcbv.12r1.b1", "mcbv", at="492.9837+(11-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249508.0, assembly_id=102132.0))
lhcb1.new("mb.a13r1.b1", "mb", at="501.5607+(11.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820518.0, assembly_id=102133.0))
lhcb1.new("mcs.a13r1.b1", "mcs", at="508.9847+(12-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241993.0, assembly_id=102133.0))
lhcb1.new("mco.13r1.b1", "mco_unplugged", at="509.7347+(12-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249510.0, assembly_id=102134.0))
lhcb1.new("mcd.13r1.b1", "mcd", at="509.7362+(12-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249511.0, assembly_id=102134.0))
lhcb1.new("mb.b13r1.b1", "mb", at="517.2207+(12.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820542.0, assembly_id=102134.0))
lhcb1.new("mcs.b13r1.b1", "mcs", at="524.6447+(13-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=241998.0, assembly_id=102134.0))
lhcb1.new("mb.c13r1.b1", "mb", at="532.8807+(13.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820566.0, assembly_id=102135.0))
lhcb1.new("mcs.c13r1.b1", "mcs", at="540.3047+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242001.0, assembly_id=102135.0))
lhcb1.new("bpm.13r1.b1", "bpm", at="541.1837+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242003.0, assembly_id=102136.0))
lhcb1.new("mqt.13r1.b1", "mqt", at="541.9377+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307492.0, assembly_id=102136.0))
lhcb1.new("mq.13r1.b1", "mq", at="543.9457+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308487.0, assembly_id=102136.0))
lhcb1.new("ms.13r1.b1", "ms", at="545.8407+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249514.0, assembly_id=102136.0))
lhcb1.new("mcbh.13r1.b1", "mcbh", at="546.4337+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249516.0, assembly_id=102136.0))
lhcb1.new("e.ds.r1.b1", "omk", at="547.1807+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a14r1.b1", "mco_unplugged", at="547.5247+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249518.0, assembly_id=102137.0))
lhcb1.new("mcd.a14r1.b1", "mcd", at="547.5262+(14-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249519.0, assembly_id=102137.0))
lhcb1.new("mb.a14r1.b1", "mb", at="555.0107+(14.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820590.0, assembly_id=102137.0))
lhcb1.new("mcs.a14r1.b1", "mcs", at="562.4347+(15-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242011.0, assembly_id=102137.0))
lhcb1.new("mb.b14r1.b1", "mb", at="570.6707+(15.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820614.0, assembly_id=102138.0))
lhcb1.new("mcs.b14r1.b1", "mcs", at="578.0947+(16-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242014.0, assembly_id=102138.0))
lhcb1.new("mco.b14r1.b1", "mco_unplugged", at="578.8447+(16-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249522.0, assembly_id=102139.0))
lhcb1.new("mcd.b14r1.b1", "mcd", at="578.8462+(16-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249523.0, assembly_id=102139.0))
lhcb1.new("mb.c14r1.b1", "mb", at="586.3307+(16.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820638.0, assembly_id=102139.0))
lhcb1.new("mcs.c14r1.b1", "mcs", at="593.7547+(17-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242019.0, assembly_id=102139.0))
lhcb1.new("bpm.14r1.b1", "bpm", at="594.6337+(17-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242021.0, assembly_id=102140.0))
lhcb1.new("mqt.14r1.b1", "mqt", at="595.3877+(17-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307523.0, assembly_id=102140.0))
lhcb1.new("mq.14r1.b1", "mq", at="597.3957+(17-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308517.0, assembly_id=102140.0))
lhcb1.new("ms.14r1.b1", "ms", at="599.2907+(17-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249526.0, assembly_id=102140.0))
lhcb1.new("mcbv.14r1.b1", "mcbv", at="599.8837+(17-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249528.0, assembly_id=102140.0))
lhcb1.new("mb.a15r1.b1", "mb", at="608.4607+(17.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820662.0, assembly_id=102141.0))
lhcb1.new("mcs.a15r1.b1", "mcs", at="615.8847+(18-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242027.0, assembly_id=102141.0))
lhcb1.new("mco.15r1.b1", "mco_unplugged", at="616.6347+(18-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249530.0, assembly_id=102142.0))
lhcb1.new("mcd.15r1.b1", "mcd", at="616.6362+(18-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249531.0, assembly_id=102142.0))
lhcb1.new("mb.b15r1.b1", "mb", at="624.1207+(18.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820686.0, assembly_id=102142.0))
lhcb1.new("mcs.b15r1.b1", "mcs", at="631.5447+(19-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242032.0, assembly_id=102142.0))
lhcb1.new("mb.c15r1.b1", "mb", at="639.7807+(19.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820710.0, assembly_id=102143.0))
lhcb1.new("mcs.c15r1.b1", "mcs", at="647.2047+(20-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242035.0, assembly_id=102143.0))
lhcb1.new("bpm.15r1.b1", "bpm", at="648.0837+(20-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242037.0, assembly_id=102144.0))
lhcb1.new("mqt.15r1.b1", "mqt", at="648.8377+(20-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307555.0, assembly_id=102144.0))
lhcb1.new("mq.15r1.b1", "mq", at="650.8457+(20-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308547.0, assembly_id=102144.0))
lhcb1.new("ms.15r1.b1", "ms", at="652.7407+(20-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249534.0, assembly_id=102144.0))
lhcb1.new("mcbh.15r1.b1", "mcbh", at="653.3337+(20-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249536.0, assembly_id=102144.0))
lhcb1.new("mco.a16r1.b1", "mco_unplugged", at="654.4247+(20-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249538.0, assembly_id=102145.0))
lhcb1.new("mcd.a16r1.b1", "mcd", at="654.4262+(20-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249539.0, assembly_id=102145.0))
lhcb1.new("mb.a16r1.b1", "mb", at="661.9107+(20.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820734.0, assembly_id=102145.0))
lhcb1.new("mcs.a16r1.b1", "mcs", at="669.3347+(21-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242045.0, assembly_id=102145.0))
lhcb1.new("mb.b16r1.b1", "mb", at="677.5707+(21.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820758.0, assembly_id=102146.0))
lhcb1.new("mcs.b16r1.b1", "mcs", at="684.9947+(22-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242048.0, assembly_id=102146.0))
lhcb1.new("mco.b16r1.b1", "mco_unplugged", at="685.7447+(22-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249542.0, assembly_id=102147.0))
lhcb1.new("mcd.b16r1.b1", "mcd", at="685.7462+(22-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249543.0, assembly_id=102147.0))
lhcb1.new("mb.c16r1.b1", "mb", at="693.2307+(22.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820782.0, assembly_id=102147.0))
lhcb1.new("mcs.c16r1.b1", "mcs", at="700.6547+(23-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242053.0, assembly_id=102147.0))
lhcb1.new("bpm.16r1.b1", "bpm", at="701.5337+(23-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242055.0, assembly_id=102148.0))
lhcb1.new("mqt.16r1.b1", "mqt", at="702.2877+(23-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307585.0, assembly_id=102148.0))
lhcb1.new("mq.16r1.b1", "mq", at="704.2957+(23-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308340.0, assembly_id=102148.0))
lhcb1.new("ms.16r1.b1", "ms", at="706.1907+(23-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249546.0, assembly_id=102148.0))
lhcb1.new("mcbv.16r1.b1", "mcbv", at="706.7837+(23-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249548.0, assembly_id=102148.0))
lhcb1.new("mb.a17r1.b1", "mb", at="715.3607+(23.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820806.0, assembly_id=102149.0))
lhcb1.new("mcs.a17r1.b1", "mcs", at="722.7847+(24-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242061.0, assembly_id=102149.0))
lhcb1.new("mco.17r1.b1", "mco_unplugged", at="723.5347+(24-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249550.0, assembly_id=102150.0))
lhcb1.new("mcd.17r1.b1", "mcd", at="723.5362+(24-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249551.0, assembly_id=102150.0))
lhcb1.new("mb.b17r1.b1", "mb", at="731.0207+(24.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820830.0, assembly_id=102150.0))
lhcb1.new("mcs.b17r1.b1", "mcs", at="738.4447+(25-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242066.0, assembly_id=102150.0))
lhcb1.new("mb.c17r1.b1", "mb", at="746.6807+(25.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820854.0, assembly_id=102151.0))
lhcb1.new("mcs.c17r1.b1", "mcs", at="754.1047+(26-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242069.0, assembly_id=102151.0))
lhcb1.new("bpm.17r1.b1", "bpm", at="754.9837+(26-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242071.0, assembly_id=102152.0))
lhcb1.new("mqt.17r1.b1", "mqt", at="755.7377+(26-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307379.0, assembly_id=102152.0))
lhcb1.new("mq.17r1.b1", "mq", at="757.7457+(26-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308370.0, assembly_id=102152.0))
lhcb1.new("ms.17r1.b1", "ms", at="759.6407+(26-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249554.0, assembly_id=102152.0))
lhcb1.new("mcbh.17r1.b1", "mcbh", at="760.2337+(26-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249556.0, assembly_id=102152.0))
lhcb1.new("mco.a18r1.b1", "mco_unplugged", at="761.3247+(26-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249558.0, assembly_id=102153.0))
lhcb1.new("mcd.a18r1.b1", "mcd", at="761.3262+(26-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249559.0, assembly_id=102153.0))
lhcb1.new("mb.a18r1.b1", "mb", at="768.8107+(26.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820878.0, assembly_id=102153.0))
lhcb1.new("mcs.a18r1.b1", "mcs", at="776.2347+(27-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242079.0, assembly_id=102153.0))
lhcb1.new("mb.b18r1.b1", "mb", at="784.4707+(27.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820902.0, assembly_id=102154.0))
lhcb1.new("mcs.b18r1.b1", "mcs", at="791.8947+(28-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242082.0, assembly_id=102154.0))
lhcb1.new("mco.b18r1.b1", "mco_unplugged", at="792.6447+(28-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249562.0, assembly_id=102155.0))
lhcb1.new("mcd.b18r1.b1", "mcd", at="792.6462+(28-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249563.0, assembly_id=102155.0))
lhcb1.new("mb.c18r1.b1", "mb", at="800.1307+(28.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820926.0, assembly_id=102155.0))
lhcb1.new("mcs.c18r1.b1", "mcs", at="807.5547+(29-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242087.0, assembly_id=102155.0))
lhcb1.new("bpm.18r1.b1", "bpm", at="808.4337+(29-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242089.0, assembly_id=102156.0))
lhcb1.new("mqt.18r1.b1", "mqt", at="809.1877+(29-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307411.0, assembly_id=102156.0))
lhcb1.new("mq.18r1.b1", "mq", at="811.1957+(29-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308400.0, assembly_id=102156.0))
lhcb1.new("ms.18r1.b1", "ms", at="813.0907+(29-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249566.0, assembly_id=102156.0))
lhcb1.new("mcbv.18r1.b1", "mcbv", at="813.6837+(29-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249568.0, assembly_id=102156.0))
lhcb1.new("mb.a19r1.b1", "mb", at="822.2607+(29.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820950.0, assembly_id=102157.0))
lhcb1.new("mcs.a19r1.b1", "mcs", at="829.6847+(30-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242095.0, assembly_id=102157.0))
lhcb1.new("mco.19r1.b1", "mco_unplugged", at="830.4347+(30-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249570.0, assembly_id=102158.0))
lhcb1.new("mcd.19r1.b1", "mcd", at="830.4362+(30-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249571.0, assembly_id=102158.0))
lhcb1.new("mb.b19r1.b1", "mb", at="837.9207+(30.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820974.0, assembly_id=102158.0))
lhcb1.new("mcs.b19r1.b1", "mcs", at="845.3447+(31-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242100.0, assembly_id=102158.0))
lhcb1.new("mb.c19r1.b1", "mb", at="853.5807+(31.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52820998.0, assembly_id=102159.0))
lhcb1.new("mcs.c19r1.b1", "mcs", at="861.0047+(32-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242103.0, assembly_id=102159.0))
lhcb1.new("bpm.19r1.b1", "bpm", at="861.8837+(32-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242105.0, assembly_id=102160.0))
lhcb1.new("mqt.19r1.b1", "mqt", at="862.6377+(32-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307442.0, assembly_id=102160.0))
lhcb1.new("mq.19r1.b1", "mq", at="864.6457+(32-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308432.0, assembly_id=102160.0))
lhcb1.new("ms.19r1.b1", "ms", at="866.5407+(32-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249574.0, assembly_id=102160.0))
lhcb1.new("mcbh.19r1.b1", "mcbh", at="867.1337+(32-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249576.0, assembly_id=102160.0))
lhcb1.new("mco.a20r1.b1", "mco_unplugged", at="868.2247+(32-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249578.0, assembly_id=102161.0))
lhcb1.new("mcd.a20r1.b1", "mcd", at="868.2262+(32-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249579.0, assembly_id=102161.0))
lhcb1.new("mb.a20r1.b1", "mb", at="875.7107+(32.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821022.0, assembly_id=102161.0))
lhcb1.new("mcs.a20r1.b1", "mcs", at="883.1347+(33-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242113.0, assembly_id=102161.0))
lhcb1.new("mb.b20r1.b1", "mb", at="891.3707+(33.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821046.0, assembly_id=102162.0))
lhcb1.new("mcs.b20r1.b1", "mcs", at="898.7947+(34-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242116.0, assembly_id=102162.0))
lhcb1.new("mco.b20r1.b1", "mco_unplugged", at="899.5447+(34-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249582.0, assembly_id=102163.0))
lhcb1.new("mcd.b20r1.b1", "mcd", at="899.5462+(34-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249583.0, assembly_id=102163.0))
lhcb1.new("mb.c20r1.b1", "mb", at="907.0307+(34.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821070.0, assembly_id=102163.0))
lhcb1.new("mcs.c20r1.b1", "mcs", at="914.4547+(35-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242121.0, assembly_id=102163.0))
lhcb1.new("bpm.20r1.b1", "bpm", at="915.3337+(35-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242123.0, assembly_id=102164.0))
lhcb1.new("mqt.20r1.b1", "mqt", at="916.0877+(35-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307472.0, assembly_id=102164.0))
lhcb1.new("mq.20r1.b1", "mq", at="918.0957+(35-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308223.0, assembly_id=102164.0))
lhcb1.new("ms.20r1.b1", "ms", at="919.9907+(35-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249586.0, assembly_id=102164.0))
lhcb1.new("mcbv.20r1.b1", "mcbv", at="920.5837+(35-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249588.0, assembly_id=102164.0))
lhcb1.new("mb.a21r1.b1", "mb", at="929.1607+(35.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821094.0, assembly_id=102165.0))
lhcb1.new("mcs.a21r1.b1", "mcs", at="936.5847+(36-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242129.0, assembly_id=102165.0))
lhcb1.new("mco.21r1.b1", "mco_unplugged", at="937.3347+(36-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249590.0, assembly_id=102166.0))
lhcb1.new("mcd.21r1.b1", "mcd", at="937.3362+(36-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249591.0, assembly_id=102166.0))
lhcb1.new("mb.b21r1.b1", "mb", at="944.8207+(36.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821118.0, assembly_id=102166.0))
lhcb1.new("mcs.b21r1.b1", "mcs", at="952.2447+(37-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242134.0, assembly_id=102166.0))
lhcb1.new("mb.c21r1.b1", "mb", at="960.4807+(37.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821142.0, assembly_id=102167.0))
lhcb1.new("mcs.c21r1.b1", "mcs", at="967.9047+(38-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242137.0, assembly_id=102167.0))
lhcb1.new("bpm.21r1.b1", "bpm", at="968.7837+(38-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242139.0, assembly_id=102168.0))
lhcb1.new("mqt.21r1.b1", "mqt", at="969.5377+(38-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307269.0, assembly_id=102168.0))
lhcb1.new("mq.21r1.b1", "mq", at="971.5457+(38-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308253.0, assembly_id=102168.0))
lhcb1.new("ms.21r1.b1", "ms", at="973.4407+(38-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249594.0, assembly_id=102168.0))
lhcb1.new("mcbh.21r1.b1", "mcbh", at="974.0337+(38-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249596.0, assembly_id=102168.0))
lhcb1.new("mco.a22r1.b1", "mco_unplugged", at="975.1247+(38-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249598.0, assembly_id=102169.0))
lhcb1.new("mcd.a22r1.b1", "mcd", at="975.1262+(38-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249599.0, assembly_id=102169.0))
lhcb1.new("mb.a22r1.b1", "mb", at="982.6107+(38.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821166.0, assembly_id=102169.0))
lhcb1.new("mcs.a22r1.b1", "mcs", at="990.0347+(39-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242147.0, assembly_id=102169.0))
lhcb1.new("mb.b22r1.b1", "mb", at="998.2707+(39.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821190.0, assembly_id=102170.0))
lhcb1.new("mcs.b22r1.b1", "mcs", at="1005.6947+(40-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242150.0, assembly_id=102170.0))
lhcb1.new("mco.b22r1.b1", "mco_unplugged", at="1006.4447+(40-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249602.0, assembly_id=102171.0))
lhcb1.new("mcd.b22r1.b1", "mcd", at="1006.4462+(40-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249603.0, assembly_id=102171.0))
lhcb1.new("mb.c22r1.b1", "mb", at="1013.9307+(40.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821214.0, assembly_id=102171.0))
lhcb1.new("mcs.c22r1.b1", "mcs", at="1021.3547+(41-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242155.0, assembly_id=102171.0))
lhcb1.new("bpm.22r1.b1", "bpm", at="1022.2337+(41-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242157.0, assembly_id=102172.0))
lhcb1.new("mo.22r1.b1", "mo", at="1022.9847+(41-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308813.0, assembly_id=102172.0))
lhcb1.new("mq.22r1.b1", "mq", at="1024.9957+(41-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308285.0, assembly_id=102172.0))
lhcb1.new("ms.22r1.b1", "ms", at="1026.8907+(41-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249606.0, assembly_id=102172.0))
lhcb1.new("mcbv.22r1.b1", "mcbv", at="1027.4837+(41-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249608.0, assembly_id=102172.0))
lhcb1.new("mb.a23r1.b1", "mb", at="1036.0607+(41.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821238.0, assembly_id=102173.0))
lhcb1.new("mcs.a23r1.b1", "mcs", at="1043.4847+(42-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242163.0, assembly_id=102173.0))
lhcb1.new("mco.23r1.b1", "mco_unplugged", at="1044.2347+(42-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249610.0, assembly_id=102174.0))
lhcb1.new("mcd.23r1.b1", "mcd", at="1044.2362+(42-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249611.0, assembly_id=102174.0))
lhcb1.new("mb.b23r1.b1", "mb", at="1051.7207+(42.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821262.0, assembly_id=102174.0))
lhcb1.new("mcs.b23r1.b1", "mcs", at="1059.1447+(43-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242168.0, assembly_id=102174.0))
lhcb1.new("mb.c23r1.b1", "mb", at="1067.3807+(43.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821286.0, assembly_id=102175.0))
lhcb1.new("mcs.c23r1.b1", "mcs", at="1074.8047+(44-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242171.0, assembly_id=102175.0))
lhcb1.new("bpm.23r1.b1", "bpm", at="1075.6837+(44-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242173.0, assembly_id=102176.0))
lhcb1.new("mqs.23r1.b1", "mqs", at="1076.4377+(44-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307636.0, assembly_id=102176.0))
lhcb1.new("mq.23r1.b1", "mq", at="1078.4457+(44-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308316.0, assembly_id=102176.0))
lhcb1.new("ms.23r1.b1", "ms", at="1080.3407+(44-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249614.0, assembly_id=102176.0))
lhcb1.new("mcbh.23r1.b1", "mcbh", at="1080.9337+(44-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249616.0, assembly_id=102176.0))
lhcb1.new("mco.a24r1.b1", "mco_unplugged", at="1082.0247+(44-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249618.0, assembly_id=102177.0))
lhcb1.new("mcd.a24r1.b1", "mcd", at="1082.0262+(44-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249619.0, assembly_id=102177.0))
lhcb1.new("mb.a24r1.b1", "mb", at="1089.5107+(44.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821310.0, assembly_id=102177.0))
lhcb1.new("mcs.a24r1.b1", "mcs", at="1096.9347+(45-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242181.0, assembly_id=102177.0))
lhcb1.new("mb.b24r1.b1", "mb", at="1105.1707+(45.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821334.0, assembly_id=102178.0))
lhcb1.new("mcs.b24r1.b1", "mcs", at="1112.5947+(46-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242184.0, assembly_id=102178.0))
lhcb1.new("mco.b24r1.b1", "mco_unplugged", at="1113.3447+(46-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249622.0, assembly_id=102179.0))
lhcb1.new("mcd.b24r1.b1", "mcd", at="1113.3462+(46-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249623.0, assembly_id=102179.0))
lhcb1.new("mb.c24r1.b1", "mb", at="1120.8307+(46.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821358.0, assembly_id=102179.0))
lhcb1.new("mcs.c24r1.b1", "mcs", at="1128.2547+(47-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242189.0, assembly_id=102179.0))
lhcb1.new("bpm.24r1.b1", "bpm", at="1129.1337+(47-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242191.0, assembly_id=102180.0))
lhcb1.new("mo.24r1.b1", "mo", at="1129.8847+(47-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308843.0, assembly_id=102180.0))
lhcb1.new("mq.24r1.b1", "mq", at="1131.8957+(47-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308106.0, assembly_id=102180.0))
lhcb1.new("ms.24r1.b1", "ms", at="1133.7907+(47-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249626.0, assembly_id=102180.0))
lhcb1.new("mcbv.24r1.b1", "mcbv", at="1134.3837+(47-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249628.0, assembly_id=102180.0))
lhcb1.new("mb.a25r1.b1", "mb", at="1142.9607+(47.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821382.0, assembly_id=102181.0))
lhcb1.new("mcs.a25r1.b1", "mcs", at="1150.3847+(48-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242197.0, assembly_id=102181.0))
lhcb1.new("mco.25r1.b1", "mco_unplugged", at="1151.1347+(48-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249630.0, assembly_id=102182.0))
lhcb1.new("mcd.25r1.b1", "mcd", at="1151.1362+(48-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249631.0, assembly_id=102182.0))
lhcb1.new("mb.b25r1.b1", "mb", at="1158.6207+(48.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821406.0, assembly_id=102182.0))
lhcb1.new("mcs.b25r1.b1", "mcs", at="1166.0447+(49-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242202.0, assembly_id=102182.0))
lhcb1.new("mb.c25r1.b1", "mb", at="1174.2807+(49.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821430.0, assembly_id=102183.0))
lhcb1.new("mcs.c25r1.b1", "mcs", at="1181.7047+(50-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242205.0, assembly_id=102183.0))
lhcb1.new("bpm.25r1.b1", "bpm", at="1182.5837+(50-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242207.0, assembly_id=102184.0))
lhcb1.new("mo.25r1.b1", "mo", at="1183.3347+(50-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308875.0, assembly_id=102184.0))
lhcb1.new("mq.25r1.b1", "mq", at="1185.3457+(50-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308138.0, assembly_id=102184.0))
lhcb1.new("ms.25r1.b1", "ms", at="1187.2407+(50-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249634.0, assembly_id=102184.0))
lhcb1.new("mcbh.25r1.b1", "mcbh", at="1187.8337+(50-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249636.0, assembly_id=102184.0))
lhcb1.new("mco.a26r1.b1", "mco_unplugged", at="1188.9247+(50-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249638.0, assembly_id=102185.0))
lhcb1.new("mcd.a26r1.b1", "mcd", at="1188.9262+(50-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249639.0, assembly_id=102185.0))
lhcb1.new("mb.a26r1.b1", "mb", at="1196.4107+(50.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821454.0, assembly_id=102185.0))
lhcb1.new("mcs.a26r1.b1", "mcs", at="1203.8347+(51-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242215.0, assembly_id=102185.0))
lhcb1.new("mb.b26r1.b1", "mb", at="1212.0707+(51.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821478.0, assembly_id=102186.0))
lhcb1.new("mcs.b26r1.b1", "mcs", at="1219.4947+(52-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242218.0, assembly_id=102186.0))
lhcb1.new("mco.b26r1.b1", "mco_unplugged", at="1220.2447+(52-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249642.0, assembly_id=102187.0))
lhcb1.new("mcd.b26r1.b1", "mcd", at="1220.2462+(52-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249643.0, assembly_id=102187.0))
lhcb1.new("mb.c26r1.b1", "mb", at="1227.7307+(52.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821502.0, assembly_id=102187.0))
lhcb1.new("mcs.c26r1.b1", "mcs", at="1235.1547+(53-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242223.0, assembly_id=102187.0))
lhcb1.new("bpm.26r1.b1", "bpm", at="1236.0337+(53-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242225.0, assembly_id=102188.0))
lhcb1.new("mo.26r1.b1", "mo", at="1236.7847+(53-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308907.0, assembly_id=102188.0))
lhcb1.new("mq.26r1.b1", "mq", at="1238.7957+(53-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308169.0, assembly_id=102188.0))
lhcb1.new("ms.26r1.b1", "ms", at="1240.6907+(53-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249646.0, assembly_id=102188.0))
lhcb1.new("mcbv.26r1.b1", "mcbv", at="1241.2837+(53-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249648.0, assembly_id=102188.0))
lhcb1.new("mb.a27r1.b1", "mb", at="1249.8607+(53.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821526.0, assembly_id=102189.0))
lhcb1.new("mcs.a27r1.b1", "mcs", at="1257.2847+(54-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242231.0, assembly_id=102189.0))
lhcb1.new("mco.27r1.b1", "mco_unplugged", at="1258.0347+(54-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249650.0, assembly_id=102190.0))
lhcb1.new("mcd.27r1.b1", "mcd", at="1258.0362+(54-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249651.0, assembly_id=102190.0))
lhcb1.new("mb.b27r1.b1", "mb", at="1265.5207+(54.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821550.0, assembly_id=102190.0))
lhcb1.new("mcs.b27r1.b1", "mcs", at="1272.9447+(55-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242236.0, assembly_id=102190.0))
lhcb1.new("mb.c27r1.b1", "mb", at="1281.1807+(55.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821574.0, assembly_id=102191.0))
lhcb1.new("mcs.c27r1.b1", "mcs", at="1288.6047+(56-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242239.0, assembly_id=102191.0))
lhcb1.new("bpm.27r1.b1", "bpm", at="1289.4837+(56-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242241.0, assembly_id=102192.0))
lhcb1.new("mqs.27r1.b1", "mqs", at="1290.2377+(56-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307667.0, assembly_id=102192.0))
lhcb1.new("mq.27r1.b1", "mq", at="1292.2457+(56-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308199.0, assembly_id=102192.0))
lhcb1.new("ms.27r1.b1", "ms", at="1294.1407+(56-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249654.0, assembly_id=102192.0))
lhcb1.new("mcbh.27r1.b1", "mcbh", at="1294.7337+(56-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249656.0, assembly_id=102192.0))
lhcb1.new("mco.a28r1.b1", "mco_unplugged", at="1295.8247+(56-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249658.0, assembly_id=102193.0))
lhcb1.new("mcd.a28r1.b1", "mcd", at="1295.8262+(56-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249659.0, assembly_id=102193.0))
lhcb1.new("mb.a28r1.b1", "mb", at="1303.3107+(56.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821598.0, assembly_id=102193.0))
lhcb1.new("mcs.a28r1.b1", "mcs", at="1310.7347+(57-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242249.0, assembly_id=102193.0))
lhcb1.new("mb.b28r1.b1", "mb", at="1318.9707+(57.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821622.0, assembly_id=102194.0))
lhcb1.new("mcs.b28r1.b1", "mcs", at="1326.3947+(58-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242252.0, assembly_id=102194.0))
lhcb1.new("mco.b28r1.b1", "mco_unplugged", at="1327.1447+(58-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249662.0, assembly_id=102195.0))
lhcb1.new("mcd.b28r1.b1", "mcd", at="1327.1462+(58-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249663.0, assembly_id=102195.0))
lhcb1.new("mb.c28r1.b1", "mb", at="1334.6307+(58.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821646.0, assembly_id=102195.0))
lhcb1.new("mcs.c28r1.b1", "mcs", at="1342.0547+(59-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242257.0, assembly_id=102195.0))
lhcb1.new("bpm.28r1.b1", "bpm", at="1342.9337+(59-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242259.0, assembly_id=102196.0))
lhcb1.new("mo.28r1.b1", "mo", at="1343.6847+(59-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308696.0, assembly_id=102196.0))
lhcb1.new("mq.28r1.b1", "mq", at="1345.6957+(59-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307990.0, assembly_id=102196.0))
lhcb1.new("ms.28r1.b1", "ms", at="1347.5907+(59-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249666.0, assembly_id=102196.0))
lhcb1.new("mcbv.28r1.b1", "mcbv", at="1348.1837+(59-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249668.0, assembly_id=102196.0))
lhcb1.new("mb.a29r1.b1", "mb", at="1356.7607+(59.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821670.0, assembly_id=102197.0))
lhcb1.new("mcs.a29r1.b1", "mcs", at="1364.1847+(60-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242265.0, assembly_id=102197.0))
lhcb1.new("mco.29r1.b1", "mco_unplugged", at="1364.9347+(60-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249670.0, assembly_id=102198.0))
lhcb1.new("mcd.29r1.b1", "mcd", at="1364.9362+(60-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249671.0, assembly_id=102198.0))
lhcb1.new("mb.b29r1.b1", "mb", at="1372.4207+(60.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821694.0, assembly_id=102198.0))
lhcb1.new("mcs.b29r1.b1", "mcs", at="1379.8447+(61-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242270.0, assembly_id=102198.0))
lhcb1.new("mb.c29r1.b1", "mb", at="1388.0807+(61.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821718.0, assembly_id=102199.0))
lhcb1.new("mcs.c29r1.b1", "mcs", at="1395.5047+(62-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242273.0, assembly_id=102199.0))
lhcb1.new("bpm.29r1.b1", "bpm", at="1396.3837+(62-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242275.0, assembly_id=102200.0))
lhcb1.new("mo.29r1.b1", "mo", at="1397.1347+(62-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308728.0, assembly_id=102200.0))
lhcb1.new("mq.29r1.b1", "mq", at="1399.1457+(62-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308021.0, assembly_id=102200.0))
lhcb1.new("mss.29r1.b1", "mss", at="1401.0407+(62-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249674.0, assembly_id=102200.0))
lhcb1.new("mcbh.29r1.b1", "mcbh", at="1401.6337+(62-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249676.0, assembly_id=102200.0))
lhcb1.new("mco.a30r1.b1", "mco_unplugged", at="1402.7247+(62-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249678.0, assembly_id=102201.0))
lhcb1.new("mcd.a30r1.b1", "mcd", at="1402.7262+(62-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249679.0, assembly_id=102201.0))
lhcb1.new("mb.a30r1.b1", "mb", at="1410.2107+(62.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821742.0, assembly_id=102201.0))
lhcb1.new("mcs.a30r1.b1", "mcs", at="1417.6347+(63-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242283.0, assembly_id=102201.0))
lhcb1.new("mb.b30r1.b1", "mb", at="1425.8707+(63.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821766.0, assembly_id=102202.0))
lhcb1.new("mcs.b30r1.b1", "mcs", at="1433.2947+(64-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242286.0, assembly_id=102202.0))
lhcb1.new("mco.b30r1.b1", "mco_unplugged", at="1434.0447+(64-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249682.0, assembly_id=102203.0))
lhcb1.new("mcd.b30r1.b1", "mcd", at="1434.0462+(64-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249683.0, assembly_id=102203.0))
lhcb1.new("mb.c30r1.b1", "mb", at="1441.5307+(64.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821790.0, assembly_id=102203.0))
lhcb1.new("mcs.c30r1.b1", "mcs", at="1448.9547+(65-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242291.0, assembly_id=102203.0))
lhcb1.new("bpm.30r1.b1", "bpm", at="1449.8337+(65-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242293.0, assembly_id=102204.0))
lhcb1.new("mo.30r1.b1", "mo", at="1450.5847+(65-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308759.0, assembly_id=102204.0))
lhcb1.new("mq.30r1.b1", "mq", at="1452.5957+(65-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308051.0, assembly_id=102204.0))
lhcb1.new("ms.30r1.b1", "ms", at="1454.4907+(65-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249686.0, assembly_id=102204.0))
lhcb1.new("mcbv.30r1.b1", "mcbv", at="1455.0837+(65-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249688.0, assembly_id=102204.0))
lhcb1.new("mb.a31r1.b1", "mb", at="1463.6607+(65.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821814.0, assembly_id=102205.0))
lhcb1.new("mcs.a31r1.b1", "mcs", at="1471.0847+(66-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242299.0, assembly_id=102205.0))
lhcb1.new("mco.31r1.b1", "mco_unplugged", at="1471.8347+(66-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249690.0, assembly_id=102206.0))
lhcb1.new("mcd.31r1.b1", "mcd", at="1471.8362+(66-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249691.0, assembly_id=102206.0))
lhcb1.new("mb.b31r1.b1", "mb", at="1479.3207+(66.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821838.0, assembly_id=102206.0))
lhcb1.new("mcs.b31r1.b1", "mcs", at="1486.7447+(67-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242304.0, assembly_id=102206.0))
lhcb1.new("mb.c31r1.b1", "mb", at="1494.9807+(67.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821862.0, assembly_id=102207.0))
lhcb1.new("mcs.c31r1.b1", "mcs", at="1502.4047+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242307.0, assembly_id=102207.0))
lhcb1.new("bpm.31r1.b1", "bpm", at="1503.2837+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242309.0, assembly_id=102208.0))
lhcb1.new("mo.31r1.b1", "mo", at="1504.0347+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308789.0, assembly_id=102208.0))
lhcb1.new("mq.31r1.b1", "mq", at="1506.0457+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308081.0, assembly_id=102208.0))
lhcb1.new("ms.31r1.b1", "ms", at="1507.9407+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249694.0, assembly_id=102208.0))
lhcb1.new("mcbh.31r1.b1", "mcbh", at="1508.5337+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249696.0, assembly_id=102208.0))
lhcb1.new("s.cell.12.b1", "omk", at="1509.2807+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a32r1.b1", "mco_unplugged", at="1509.6247+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249698.0, assembly_id=102209.0))
lhcb1.new("mcd.a32r1.b1", "mcd", at="1509.6262+(68-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249699.0, assembly_id=102209.0))
lhcb1.new("mb.a32r1.b1", "mb", at="1517.1107+(68.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821886.0, assembly_id=102209.0))
lhcb1.new("mcs.a32r1.b1", "mcs", at="1524.5347+(69-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242317.0, assembly_id=102209.0))
lhcb1.new("mb.b32r1.b1", "mb", at="1532.7707+(69.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821910.0, assembly_id=102210.0))
lhcb1.new("mcs.b32r1.b1", "mcs", at="1540.1947+(70-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242320.0, assembly_id=102210.0))
lhcb1.new("mco.b32r1.b1", "mco_unplugged", at="1540.9447+(70-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249702.0, assembly_id=102211.0))
lhcb1.new("mcd.b32r1.b1", "mcd", at="1540.9462+(70-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249703.0, assembly_id=102211.0))
lhcb1.new("mb.c32r1.b1", "mb", at="1548.4307+(70.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821934.0, assembly_id=102211.0))
lhcb1.new("mcs.c32r1.b1", "mcs", at="1555.8547+(71-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242325.0, assembly_id=102211.0))
lhcb1.new("bpm.32r1.b1", "bpm", at="1556.7337+(71-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242327.0, assembly_id=102212.0))
lhcb1.new("mo.32r1.b1", "mo", at="1557.4847+(71-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308581.0, assembly_id=102212.0))
lhcb1.new("mq.32r1.b1", "mq", at="1559.4957+(71-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307873.0, assembly_id=102212.0))
lhcb1.new("ms.32r1.b1", "ms", at="1561.3907+(71-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249706.0, assembly_id=102212.0))
lhcb1.new("mcbv.32r1.b1", "mcbv", at="1561.9837+(71-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249708.0, assembly_id=102212.0))
lhcb1.new("mb.a33r1.b1", "mb", at="1570.5607+(71.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821958.0, assembly_id=102213.0))
lhcb1.new("mcs.a33r1.b1", "mcs", at="1577.9847+(72-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242333.0, assembly_id=102213.0))
lhcb1.new("mco.33r1.b1", "mco_unplugged", at="1578.7347+(72-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249710.0, assembly_id=102214.0))
lhcb1.new("mcd.33r1.b1", "mcd", at="1578.7362+(72-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249711.0, assembly_id=102214.0))
lhcb1.new("mb.b33r1.b1", "mb", at="1586.2207+(72.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52821982.0, assembly_id=102214.0))
lhcb1.new("mcs.b33r1.b1", "mcs", at="1593.6447+(73-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242338.0, assembly_id=102214.0))
lhcb1.new("mb.c33r1.b1", "mb", at="1601.8807+(73.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52822006.0, assembly_id=102215.0))
lhcb1.new("mcs.c33r1.b1", "mcs", at="1609.3047+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242341.0, assembly_id=102215.0))
lhcb1.new("bpm.33r1.b1", "bpm", at="1610.1837+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242343.0, assembly_id=102216.0))
lhcb1.new("mo.33r1.b1", "mo", at="1610.9347+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308612.0, assembly_id=102216.0))
lhcb1.new("mq.33r1.b1", "mq", at="1612.9457+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307902.0, assembly_id=102216.0))
lhcb1.new("mss.33r1.b1", "mss", at="1614.8407+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249714.0, assembly_id=102216.0))
lhcb1.new("mcbh.33r1.b1", "mcbh", at="1615.4337+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249716.0, assembly_id=102216.0))
lhcb1.new("e.cell.12.b1", "omk", at="1616.1807+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a34r1.b1", "mco_unplugged", at="1616.5247+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249718.0, assembly_id=102217.0))
lhcb1.new("mcd.a34r1.b1", "mcd", at="1616.5262+(74-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249719.0, assembly_id=102217.0))
lhcb1.new("mb.a34r1.b1", "mb", at="1624.0107+(74.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52822030.0, assembly_id=102217.0))
lhcb1.new("mcs.a34r1.b1", "mcs", at="1631.4347+(75-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242351.0, assembly_id=102217.0))
lhcb1.new("mb.b34r1.b1", "mb", at="1639.6707+(75.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52822054.0, assembly_id=102218.0))
lhcb1.new("mcs.b34r1.b1", "mcs", at="1647.0947+(76-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242354.0, assembly_id=102218.0))
lhcb1.new("mco.b34r1.b1", "mco_unplugged", at="1647.8447+(76-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249722.0, assembly_id=102219.0))
lhcb1.new("mcd.b34r1.b1", "mcd", at="1647.8462+(76-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=249723.0, assembly_id=102219.0))
lhcb1.new("mb.c34r1.b1", "mb", at="1655.3307+(76.5-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=52822078.0, assembly_id=102219.0))
lhcb1.new("mcs.c34r1.b1", "mcs", at="1662.7547+(77-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242359.0, assembly_id=102219.0))
lhcb1.new("bpm.34r1.b1", "bpm", at="1663.6337+(77-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=242361.0, assembly_id=102220.0))
lhcb1.new("mo.34r1.b1", "mo", at="1664.3847+(77-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2308627.0, assembly_id=102220.0))
lhcb1.new("mq.34r1.b1", "mq", at="1666.3957+(77-ip1ofs.b1)*ds", from_="ip1", extra=dict(mech_sep=0.194, slot_id=2307917.0, assembly_id=102220.0))
lhcb1.new("ms.34l2.b1", "ms", at="-1664.0697+(77-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249726.0, assembly_id=102220.0))
lhcb1.new("mcbv.34l2.b1", "mcbv", at="-1663.4767+(77-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249728.0, assembly_id=102220.0))
lhcb1.new("mb.c34l2.b1", "mb", at="-1654.8997+(77.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822102.0, assembly_id=102221.0))
lhcb1.new("mcs.c34l2.b1", "mcs", at="-1647.4757+(78-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242367.0, assembly_id=102221.0))
lhcb1.new("mco.34l2.b1", "mco_unplugged", at="-1646.7257+(78-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249730.0, assembly_id=102222.0))
lhcb1.new("mcd.34l2.b1", "mcd_unplugged", at="-1646.7242+(78-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249731.0, assembly_id=102222.0))
lhcb1.new("mb.b34l2.b1", "mb", at="-1639.2397+(78.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822126.0, assembly_id=102222.0))
lhcb1.new("mcs.b34l2.b1", "mcs", at="-1631.8157+(79-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242372.0, assembly_id=102222.0))
lhcb1.new("mb.a34l2.b1", "mb", at="-1623.5797+(79.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822150.0, assembly_id=102223.0))
lhcb1.new("mcs.a34l2.b1", "mcs", at="-1616.1557+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242375.0, assembly_id=102223.0))
lhcb1.new("bpm.33l2.b1", "bpm", at="-1615.2767+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242377.0, assembly_id=102224.0))
lhcb1.new("mo.33l2.b1", "mo", at="-1614.5257+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308599.0, assembly_id=102224.0))
lhcb1.new("mq.33l2.b1", "mq", at="-1612.5147+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307889.0, assembly_id=102224.0))
lhcb1.new("mss.33l2.b1", "mss", at="-1610.6197+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249734.0, assembly_id=102224.0))
lhcb1.new("mcbh.33l2.b1", "mcbh", at="-1610.0267+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249736.0, assembly_id=102224.0))
lhcb1.new("mco.b33l2.b1", "mco_unplugged", at="-1608.9357+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249738.0, assembly_id=102225.0))
lhcb1.new("mcd.b33l2.b1", "mcd", at="-1608.9342+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249739.0, assembly_id=102225.0))
lhcb1.new("mb.c33l2.b1", "mb", at="-1601.4497+(80.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822174.0, assembly_id=102225.0))
lhcb1.new("mcs.c33l2.b1", "mcs", at="-1594.0257+(81-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242385.0, assembly_id=102225.0))
lhcb1.new("mb.b33l2.b1", "mb", at="-1585.7897+(81.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822198.0, assembly_id=102226.0))
lhcb1.new("mcs.b33l2.b1", "mcs", at="-1578.3657+(82-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242388.0, assembly_id=102226.0))
lhcb1.new("mco.a33l2.b1", "mco_unplugged", at="-1577.6157+(82-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249742.0, assembly_id=102227.0))
lhcb1.new("mcd.a33l2.b1", "mcd", at="-1577.6142+(82-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249743.0, assembly_id=102227.0))
lhcb1.new("mb.a33l2.b1", "mb", at="-1570.1297+(82.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822222.0, assembly_id=102227.0))
lhcb1.new("mcs.a33l2.b1", "mcs", at="-1562.7057+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242393.0, assembly_id=102227.0))
lhcb1.new("bpm.32l2.b1", "bpm", at="-1561.8267+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242395.0, assembly_id=102228.0))
lhcb1.new("mo.32l2.b1", "mo", at="-1561.0757+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308567.0, assembly_id=102228.0))
lhcb1.new("mq.32l2.b1", "mq", at="-1559.0647+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307860.0, assembly_id=102228.0))
lhcb1.new("ms.32l2.b1", "ms", at="-1557.1697+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249746.0, assembly_id=102228.0))
lhcb1.new("mcbv.32l2.b1", "mcbv", at="-1556.5767+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249748.0, assembly_id=102228.0))
lhcb1.new("mb.c32l2.b1", "mb", at="-1547.9997+(83.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822246.0, assembly_id=102229.0))
lhcb1.new("mcs.c32l2.b1", "mcs", at="-1540.5757+(84-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242401.0, assembly_id=102229.0))
lhcb1.new("mco.32l2.b1", "mco_unplugged", at="-1539.8257+(84-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249750.0, assembly_id=102230.0))
lhcb1.new("mcd.32l2.b1", "mcd", at="-1539.8242+(84-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249751.0, assembly_id=102230.0))
lhcb1.new("mb.b32l2.b1", "mb", at="-1532.3397+(84.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822270.0, assembly_id=102230.0))
lhcb1.new("mcs.b32l2.b1", "mcs", at="-1524.9157+(85-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242406.0, assembly_id=102230.0))
lhcb1.new("mb.a32l2.b1", "mb", at="-1516.6797+(85.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822294.0, assembly_id=102231.0))
lhcb1.new("mcs.a32l2.b1", "mcs", at="-1509.2557+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242409.0, assembly_id=102231.0))
lhcb1.new("bpm.31l2.b1", "bpm", at="-1508.3767+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242411.0, assembly_id=102232.0))
lhcb1.new("mo.31l2.b1", "mo", at="-1507.6257+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308776.0, assembly_id=102232.0))
lhcb1.new("mq.31l2.b1", "mq", at="-1505.6147+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308068.0, assembly_id=102232.0))
lhcb1.new("ms.31l2.b1", "ms", at="-1503.7197+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249754.0, assembly_id=102232.0))
lhcb1.new("mcbh.31l2.b1", "mcbh", at="-1503.1267+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249756.0, assembly_id=102232.0))
lhcb1.new("mco.b31l2.b1", "mco_unplugged", at="-1502.0357+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249758.0, assembly_id=102233.0))
lhcb1.new("mcd.b31l2.b1", "mcd", at="-1502.0342+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249759.0, assembly_id=102233.0))
lhcb1.new("mb.c31l2.b1", "mb", at="-1494.5497+(86.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822318.0, assembly_id=102233.0))
lhcb1.new("mcs.c31l2.b1", "mcs", at="-1487.1257+(87-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242419.0, assembly_id=102233.0))
lhcb1.new("mb.b31l2.b1", "mb", at="-1478.8897+(87.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822342.0, assembly_id=102234.0))
lhcb1.new("mcs.b31l2.b1", "mcs", at="-1471.4657+(88-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242422.0, assembly_id=102234.0))
lhcb1.new("mco.a31l2.b1", "mco_unplugged", at="-1470.7157+(88-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249762.0, assembly_id=102235.0))
lhcb1.new("mcd.a31l2.b1", "mcd", at="-1470.7142+(88-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249763.0, assembly_id=102235.0))
lhcb1.new("mb.a31l2.b1", "mb", at="-1463.2297+(88.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822366.0, assembly_id=102235.0))
lhcb1.new("mcs.a31l2.b1", "mcs", at="-1455.8057+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242427.0, assembly_id=102235.0))
lhcb1.new("bpm.30l2.b1", "bpm", at="-1454.9267+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242429.0, assembly_id=102236.0))
lhcb1.new("mo.30l2.b1", "mo", at="-1454.1757+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308746.0, assembly_id=102236.0))
lhcb1.new("mq.30l2.b1", "mq", at="-1452.1647+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308038.0, assembly_id=102236.0))
lhcb1.new("ms.30l2.b1", "ms", at="-1450.2697+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249766.0, assembly_id=102236.0))
lhcb1.new("mcbv.30l2.b1", "mcbv", at="-1449.6767+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249768.0, assembly_id=102236.0))
lhcb1.new("mb.c30l2.b1", "mb", at="-1441.0997+(89.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822390.0, assembly_id=102237.0))
lhcb1.new("mcs.c30l2.b1", "mcs", at="-1433.6757+(90-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242435.0, assembly_id=102237.0))
lhcb1.new("mco.30l2.b1", "mco_unplugged", at="-1432.9257+(90-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249770.0, assembly_id=102238.0))
lhcb1.new("mcd.30l2.b1", "mcd", at="-1432.9242+(90-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249771.0, assembly_id=102238.0))
lhcb1.new("mb.b30l2.b1", "mb", at="-1425.4397+(90.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822414.0, assembly_id=102238.0))
lhcb1.new("mcs.b30l2.b1", "mcs", at="-1418.0157+(91-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242440.0, assembly_id=102238.0))
lhcb1.new("mb.a30l2.b1", "mb", at="-1409.7797+(91.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822438.0, assembly_id=102239.0))
lhcb1.new("mcs.a30l2.b1", "mcs", at="-1402.3557+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242443.0, assembly_id=102239.0))
lhcb1.new("bpm.29l2.b1", "bpm", at="-1401.4767+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242445.0, assembly_id=102240.0))
lhcb1.new("mo.29l2.b1", "mo", at="-1400.7257+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308714.0, assembly_id=102240.0))
lhcb1.new("mq.29l2.b1", "mq", at="-1398.7147+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308008.0, assembly_id=102240.0))
lhcb1.new("mss.29l2.b1", "mss", at="-1396.8197+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249774.0, assembly_id=102240.0))
lhcb1.new("mcbh.29l2.b1", "mcbh", at="-1396.2267+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249776.0, assembly_id=102240.0))
lhcb1.new("mco.b29l2.b1", "mco_unplugged", at="-1395.1357+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249778.0, assembly_id=102241.0))
lhcb1.new("mcd.b29l2.b1", "mcd", at="-1395.1342+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249779.0, assembly_id=102241.0))
lhcb1.new("mb.c29l2.b1", "mb", at="-1387.6497+(92.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822462.0, assembly_id=102241.0))
lhcb1.new("mcs.c29l2.b1", "mcs", at="-1380.2257+(93-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242453.0, assembly_id=102241.0))
lhcb1.new("mb.b29l2.b1", "mb", at="-1371.9897+(93.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822486.0, assembly_id=102242.0))
lhcb1.new("mcs.b29l2.b1", "mcs", at="-1364.5657+(94-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242456.0, assembly_id=102242.0))
lhcb1.new("mco.a29l2.b1", "mco_unplugged", at="-1363.8157+(94-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249782.0, assembly_id=102243.0))
lhcb1.new("mcd.a29l2.b1", "mcd", at="-1363.8142+(94-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249783.0, assembly_id=102243.0))
lhcb1.new("mb.a29l2.b1", "mb", at="-1356.3297+(94.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822510.0, assembly_id=102243.0))
lhcb1.new("mcs.a29l2.b1", "mcs", at="-1348.9057+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242461.0, assembly_id=102243.0))
lhcb1.new("bpm.28l2.b1", "bpm", at="-1348.0267+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242463.0, assembly_id=102244.0))
lhcb1.new("mo.28l2.b1", "mo", at="-1347.2757+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308924.0, assembly_id=102244.0))
lhcb1.new("mq.28l2.b1", "mq", at="-1345.2647+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307976.0, assembly_id=102244.0))
lhcb1.new("ms.28l2.b1", "ms", at="-1343.3697+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249786.0, assembly_id=102244.0))
lhcb1.new("mcbv.28l2.b1", "mcbv", at="-1342.7767+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249788.0, assembly_id=102244.0))
lhcb1.new("mb.c28l2.b1", "mb", at="-1334.1997+(95.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822534.0, assembly_id=102245.0))
lhcb1.new("mcs.c28l2.b1", "mcs", at="-1326.7757+(96-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242469.0, assembly_id=102245.0))
lhcb1.new("mco.28l2.b1", "mco_unplugged", at="-1326.0257+(96-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249790.0, assembly_id=102246.0))
lhcb1.new("mcd.28l2.b1", "mcd", at="-1326.0242+(96-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249791.0, assembly_id=102246.0))
lhcb1.new("mb.b28l2.b1", "mb", at="-1318.5397+(96.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822558.0, assembly_id=102246.0))
lhcb1.new("mcs.b28l2.b1", "mcs", at="-1311.1157+(97-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242474.0, assembly_id=102246.0))
lhcb1.new("mb.a28l2.b1", "mb", at="-1302.8797+(97.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822582.0, assembly_id=102247.0))
lhcb1.new("mcs.a28l2.b1", "mcs", at="-1295.4557+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242477.0, assembly_id=102247.0))
lhcb1.new("bpm.27l2.b1", "bpm", at="-1294.5767+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242479.0, assembly_id=102248.0))
lhcb1.new("mqs.27l2.b1", "mqs", at="-1293.8227+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307653.0, assembly_id=102248.0))
lhcb1.new("mq.27l2.b1", "mq", at="-1291.8147+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308186.0, assembly_id=102248.0))
lhcb1.new("ms.27l2.b1", "ms", at="-1289.9197+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249794.0, assembly_id=102248.0))
lhcb1.new("mcbh.27l2.b1", "mcbh", at="-1289.3267+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249796.0, assembly_id=102248.0))
lhcb1.new("mco.b27l2.b1", "mco_unplugged", at="-1288.2357+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249798.0, assembly_id=102249.0))
lhcb1.new("mcd.b27l2.b1", "mcd", at="-1288.2342+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249799.0, assembly_id=102249.0))
lhcb1.new("mb.c27l2.b1", "mb", at="-1280.7497+(98.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822606.0, assembly_id=102249.0))
lhcb1.new("mcs.c27l2.b1", "mcs", at="-1273.3257+(99-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242487.0, assembly_id=102249.0))
lhcb1.new("mb.b27l2.b1", "mb", at="-1265.0897+(99.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822630.0, assembly_id=102250.0))
lhcb1.new("mcs.b27l2.b1", "mcs", at="-1257.6657+(100-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242490.0, assembly_id=102250.0))
lhcb1.new("mco.a27l2.b1", "mco_unplugged", at="-1256.9157+(100-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249802.0, assembly_id=102251.0))
lhcb1.new("mcd.a27l2.b1", "mcd", at="-1256.9142+(100-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249803.0, assembly_id=102251.0))
lhcb1.new("mb.a27l2.b1", "mb", at="-1249.4297+(100.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822654.0, assembly_id=102251.0))
lhcb1.new("mcs.a27l2.b1", "mcs", at="-1242.0057+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242495.0, assembly_id=102251.0))
lhcb1.new("bpm.26l2.b1", "bpm", at="-1241.1267+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242497.0, assembly_id=102252.0))
lhcb1.new("mo.26l2.b1", "mo", at="-1240.3757+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308893.0, assembly_id=102252.0))
lhcb1.new("mq.26l2.b1", "mq", at="-1238.3647+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308156.0, assembly_id=102252.0))
lhcb1.new("ms.26l2.b1", "ms", at="-1236.4697+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249806.0, assembly_id=102252.0))
lhcb1.new("mcbv.26l2.b1", "mcbv", at="-1235.8767+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249808.0, assembly_id=102252.0))
lhcb1.new("mb.c26l2.b1", "mb", at="-1227.2997+(101.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822678.0, assembly_id=102253.0))
lhcb1.new("mcs.c26l2.b1", "mcs", at="-1219.8757+(102-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242503.0, assembly_id=102253.0))
lhcb1.new("mco.26l2.b1", "mco_unplugged", at="-1219.1257+(102-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249810.0, assembly_id=102254.0))
lhcb1.new("mcd.26l2.b1", "mcd", at="-1219.1242+(102-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249811.0, assembly_id=102254.0))
lhcb1.new("mb.b26l2.b1", "mb", at="-1211.6397+(102.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822702.0, assembly_id=102254.0))
lhcb1.new("mcs.b26l2.b1", "mcs", at="-1204.2157+(103-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242508.0, assembly_id=102254.0))
lhcb1.new("mb.a26l2.b1", "mb", at="-1195.9797+(103.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822726.0, assembly_id=102255.0))
lhcb1.new("mcs.a26l2.b1", "mcs", at="-1188.5557+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242511.0, assembly_id=102255.0))
lhcb1.new("bpm.25l2.b1", "bpm", at="-1187.6767+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242513.0, assembly_id=102256.0))
lhcb1.new("mo.25l2.b1", "mo", at="-1186.9257+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308861.0, assembly_id=102256.0))
lhcb1.new("mq.25l2.b1", "mq", at="-1184.9147+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308124.0, assembly_id=102256.0))
lhcb1.new("ms.25l2.b1", "ms", at="-1183.0197+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249814.0, assembly_id=102256.0))
lhcb1.new("mcbh.25l2.b1", "mcbh", at="-1182.4267+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249816.0, assembly_id=102256.0))
lhcb1.new("mco.b25l2.b1", "mco_unplugged", at="-1181.3357+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249818.0, assembly_id=102257.0))
lhcb1.new("mcd.b25l2.b1", "mcd", at="-1181.3342+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249819.0, assembly_id=102257.0))
lhcb1.new("mb.c25l2.b1", "mb", at="-1173.8497+(104.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822750.0, assembly_id=102257.0))
lhcb1.new("mcs.c25l2.b1", "mcs", at="-1166.4257+(105-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242521.0, assembly_id=102257.0))
lhcb1.new("mb.b25l2.b1", "mb", at="-1158.1897+(105.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822774.0, assembly_id=102258.0))
lhcb1.new("mcs.b25l2.b1", "mcs", at="-1150.7657+(106-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242524.0, assembly_id=102258.0))
lhcb1.new("mco.a25l2.b1", "mco_unplugged", at="-1150.0157+(106-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249822.0, assembly_id=102259.0))
lhcb1.new("mcd.a25l2.b1", "mcd", at="-1150.0142+(106-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249823.0, assembly_id=102259.0))
lhcb1.new("mb.a25l2.b1", "mb", at="-1142.5297+(106.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822798.0, assembly_id=102259.0))
lhcb1.new("mcs.a25l2.b1", "mcs", at="-1135.1057+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242529.0, assembly_id=102259.0))
lhcb1.new("bpm.24l2.b1", "bpm", at="-1134.2267+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242531.0, assembly_id=102260.0))
lhcb1.new("mo.24l2.b1", "mo", at="-1133.4757+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308830.0, assembly_id=102260.0))
lhcb1.new("mq.24l2.b1", "mq", at="-1131.4647+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308092.0, assembly_id=102260.0))
lhcb1.new("ms.24l2.b1", "ms", at="-1129.5697+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249826.0, assembly_id=102260.0))
lhcb1.new("mcbv.24l2.b1", "mcbv", at="-1128.9767+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249828.0, assembly_id=102260.0))
lhcb1.new("mb.c24l2.b1", "mb", at="-1120.3997+(107.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822822.0, assembly_id=102261.0))
lhcb1.new("mcs.c24l2.b1", "mcs", at="-1112.9757+(108-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242537.0, assembly_id=102261.0))
lhcb1.new("mco.24l2.b1", "mco_unplugged", at="-1112.2257+(108-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249830.0, assembly_id=102262.0))
lhcb1.new("mcd.24l2.b1", "mcd", at="-1112.2242+(108-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249831.0, assembly_id=102262.0))
lhcb1.new("mb.b24l2.b1", "mb", at="-1104.7397+(108.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822846.0, assembly_id=102262.0))
lhcb1.new("mcs.b24l2.b1", "mcs", at="-1097.3157+(109-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242542.0, assembly_id=102262.0))
lhcb1.new("mb.a24l2.b1", "mb", at="-1089.0797+(109.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822870.0, assembly_id=102263.0))
lhcb1.new("mcs.a24l2.b1", "mcs", at="-1081.6557+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242545.0, assembly_id=102263.0))
lhcb1.new("bpm.23l2.b1", "bpm", at="-1080.7767+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242547.0, assembly_id=102264.0))
lhcb1.new("mqs.23l2.b1", "mqs", at="-1080.0227+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307623.0, assembly_id=102264.0))
lhcb1.new("mq.23l2.b1", "mq", at="-1078.0147+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308303.0, assembly_id=102264.0))
lhcb1.new("ms.23l2.b1", "ms", at="-1076.1197+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249834.0, assembly_id=102264.0))
lhcb1.new("mcbh.23l2.b1", "mcbh", at="-1075.5267+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249836.0, assembly_id=102264.0))
lhcb1.new("mco.b23l2.b1", "mco_unplugged", at="-1074.4357+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249838.0, assembly_id=102265.0))
lhcb1.new("mcd.b23l2.b1", "mcd", at="-1074.4342+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249839.0, assembly_id=102265.0))
lhcb1.new("mb.c23l2.b1", "mb", at="-1066.9497+(110.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822894.0, assembly_id=102265.0))
lhcb1.new("mcs.c23l2.b1", "mcs", at="-1059.5257+(111-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242555.0, assembly_id=102265.0))
lhcb1.new("mb.b23l2.b1", "mb", at="-1051.2897+(111.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822918.0, assembly_id=102266.0))
lhcb1.new("mcs.b23l2.b1", "mcs", at="-1043.8657+(112-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242558.0, assembly_id=102266.0))
lhcb1.new("mco.a23l2.b1", "mco_unplugged", at="-1043.1157+(112-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249842.0, assembly_id=102267.0))
lhcb1.new("mcd.a23l2.b1", "mcd", at="-1043.1142+(112-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249843.0, assembly_id=102267.0))
lhcb1.new("mb.a23l2.b1", "mb", at="-1035.6297+(112.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822942.0, assembly_id=102267.0))
lhcb1.new("mcs.a23l2.b1", "mcs", at="-1028.2057+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242563.0, assembly_id=102267.0))
lhcb1.new("bpm.22l2.b1", "bpm", at="-1027.3267+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242565.0, assembly_id=102268.0))
lhcb1.new("mo.22l2.b1", "mo", at="-1026.5757+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2309037.0, assembly_id=102268.0))
lhcb1.new("mq.22l2.b1", "mq", at="-1024.5647+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308271.0, assembly_id=102268.0))
lhcb1.new("ms.22l2.b1", "ms", at="-1022.6697+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249846.0, assembly_id=102268.0))
lhcb1.new("mcbv.22l2.b1", "mcbv", at="-1022.0767+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249848.0, assembly_id=102268.0))
lhcb1.new("mb.c22l2.b1", "mb", at="-1013.4997+(113.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822966.0, assembly_id=102269.0))
lhcb1.new("mcs.c22l2.b1", "mcs", at="-1006.0757+(114-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242571.0, assembly_id=102269.0))
lhcb1.new("mco.22l2.b1", "mco_unplugged", at="-1005.3257+(114-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249850.0, assembly_id=102270.0))
lhcb1.new("mcd.22l2.b1", "mcd", at="-1005.3242+(114-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249851.0, assembly_id=102270.0))
lhcb1.new("mb.b22l2.b1", "mb", at="-997.8397+(114.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52822990.0, assembly_id=102270.0))
lhcb1.new("mcs.b22l2.b1", "mcs", at="-990.4157+(115-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242576.0, assembly_id=102270.0))
lhcb1.new("mb.a22l2.b1", "mb", at="-982.1797+(115.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823014.0, assembly_id=102271.0))
lhcb1.new("mcs.a22l2.b1", "mcs", at="-974.7557+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242579.0, assembly_id=102271.0))
lhcb1.new("bpm.21l2.b1", "bpm", at="-973.8767+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242581.0, assembly_id=102272.0))
lhcb1.new("mqt.21l2.b1", "mqt", at="-973.1227+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307488.0, assembly_id=102272.0))
lhcb1.new("mq.21l2.b1", "mq", at="-971.1147+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308240.0, assembly_id=102272.0))
lhcb1.new("ms.21l2.b1", "ms", at="-969.2197+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249854.0, assembly_id=102272.0))
lhcb1.new("mcbh.21l2.b1", "mcbh", at="-968.6267+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249856.0, assembly_id=102272.0))
lhcb1.new("mco.b21l2.b1", "mco_unplugged", at="-967.5357+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249858.0, assembly_id=102273.0))
lhcb1.new("mcd.b21l2.b1", "mcd", at="-967.5342+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249859.0, assembly_id=102273.0))
lhcb1.new("mb.c21l2.b1", "mb", at="-960.0497+(116.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823038.0, assembly_id=102273.0))
lhcb1.new("mcs.c21l2.b1", "mcs", at="-952.6257+(117-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242589.0, assembly_id=102273.0))
lhcb1.new("mb.b21l2.b1", "mb", at="-944.3897+(117.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823062.0, assembly_id=102274.0))
lhcb1.new("mcs.b21l2.b1", "mcs", at="-936.9657+(118-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242592.0, assembly_id=102274.0))
lhcb1.new("mco.a21l2.b1", "mco_unplugged", at="-936.2157+(118-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249862.0, assembly_id=102275.0))
lhcb1.new("mcd.a21l2.b1", "mcd", at="-936.2142+(118-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249863.0, assembly_id=102275.0))
lhcb1.new("mb.a21l2.b1", "mb", at="-928.7297+(118.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823086.0, assembly_id=102275.0))
lhcb1.new("mcs.a21l2.b1", "mcs", at="-921.3057+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242597.0, assembly_id=102275.0))
lhcb1.new("bpm.20l2.b1", "bpm", at="-920.4267+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242599.0, assembly_id=102276.0))
lhcb1.new("mqt.20l2.b1", "mqt", at="-919.6727+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2348441.0, assembly_id=102276.0))
lhcb1.new("mq.20l2.b1", "mq", at="-917.6647+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308210.0, assembly_id=102276.0))
lhcb1.new("ms.20l2.b1", "ms", at="-915.7697+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249866.0, assembly_id=102276.0))
lhcb1.new("mcbv.20l2.b1", "mcbv", at="-915.1767+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249868.0, assembly_id=102276.0))
lhcb1.new("mb.c20l2.b1", "mb", at="-906.5997+(119.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823110.0, assembly_id=102277.0))
lhcb1.new("mcs.c20l2.b1", "mcs", at="-899.1757+(120-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242605.0, assembly_id=102277.0))
lhcb1.new("mco.20l2.b1", "mco_unplugged", at="-898.4257+(120-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249870.0, assembly_id=102278.0))
lhcb1.new("mcd.20l2.b1", "mcd", at="-898.4242+(120-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249871.0, assembly_id=102278.0))
lhcb1.new("mb.b20l2.b1", "mb", at="-890.9397+(120.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823134.0, assembly_id=102278.0))
lhcb1.new("mcs.b20l2.b1", "mcs", at="-883.5157+(121-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242610.0, assembly_id=102278.0))
lhcb1.new("mb.a20l2.b1", "mb", at="-875.2797+(121.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823158.0, assembly_id=102279.0))
lhcb1.new("mcs.a20l2.b1", "mcs", at="-867.8557+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242613.0, assembly_id=102279.0))
lhcb1.new("bpm.19l2.b1", "bpm", at="-866.9767+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242615.0, assembly_id=102280.0))
lhcb1.new("mqt.19l2.b1", "mqt", at="-866.2227+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307429.0, assembly_id=102280.0))
lhcb1.new("mq.19l2.b1", "mq", at="-864.2147+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308418.0, assembly_id=102280.0))
lhcb1.new("ms.19l2.b1", "ms", at="-862.3197+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249874.0, assembly_id=102280.0))
lhcb1.new("mcbh.19l2.b1", "mcbh", at="-861.7267+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249876.0, assembly_id=102280.0))
lhcb1.new("mco.b19l2.b1", "mco_unplugged", at="-860.6357+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249878.0, assembly_id=102281.0))
lhcb1.new("mcd.b19l2.b1", "mcd", at="-860.6342+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249879.0, assembly_id=102281.0))
lhcb1.new("mb.c19l2.b1", "mb", at="-853.1497+(122.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823182.0, assembly_id=102281.0))
lhcb1.new("mcs.c19l2.b1", "mcs", at="-845.7257+(123-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242623.0, assembly_id=102281.0))
lhcb1.new("mb.b19l2.b1", "mb", at="-837.4897+(123.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823206.0, assembly_id=102282.0))
lhcb1.new("mcs.b19l2.b1", "mcs", at="-830.0657+(124-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242626.0, assembly_id=102282.0))
lhcb1.new("mco.a19l2.b1", "mco_unplugged", at="-829.3157+(124-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249882.0, assembly_id=102283.0))
lhcb1.new("mcd.a19l2.b1", "mcd", at="-829.3142+(124-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249883.0, assembly_id=102283.0))
lhcb1.new("mb.a19l2.b1", "mb", at="-821.8297+(124.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823230.0, assembly_id=102283.0))
lhcb1.new("mcs.a19l2.b1", "mcs", at="-814.4057+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242631.0, assembly_id=102283.0))
lhcb1.new("bpm.18l2.b1", "bpm", at="-813.5267+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242633.0, assembly_id=102284.0))
lhcb1.new("mqt.18l2.b1", "mqt", at="-812.7727+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307397.0, assembly_id=102284.0))
lhcb1.new("mq.18l2.b1", "mq", at="-810.7647+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308387.0, assembly_id=102284.0))
lhcb1.new("ms.18l2.b1", "ms", at="-808.8697+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249886.0, assembly_id=102284.0))
lhcb1.new("mcbv.18l2.b1", "mcbv", at="-808.2767+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249888.0, assembly_id=102284.0))
lhcb1.new("mb.c18l2.b1", "mb", at="-799.6997+(125.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823254.0, assembly_id=102285.0))
lhcb1.new("mcs.c18l2.b1", "mcs", at="-792.2757+(126-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242639.0, assembly_id=102285.0))
lhcb1.new("mco.18l2.b1", "mco_unplugged", at="-791.5257+(126-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249890.0, assembly_id=102286.0))
lhcb1.new("mcd.18l2.b1", "mcd", at="-791.5242+(126-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249891.0, assembly_id=102286.0))
lhcb1.new("mb.b18l2.b1", "mb", at="-784.0397+(126.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823278.0, assembly_id=102286.0))
lhcb1.new("mcs.b18l2.b1", "mcs", at="-776.6157+(127-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242644.0, assembly_id=102286.0))
lhcb1.new("mb.a18l2.b1", "mb", at="-768.3797+(127.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823302.0, assembly_id=102287.0))
lhcb1.new("mcs.a18l2.b1", "mcs", at="-760.9557+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242647.0, assembly_id=102287.0))
lhcb1.new("bpm.17l2.b1", "bpm", at="-760.0767+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242649.0, assembly_id=102288.0))
lhcb1.new("mqt.17l2.b1", "mqt", at="-759.3227+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307602.0, assembly_id=102288.0))
lhcb1.new("mq.17l2.b1", "mq", at="-757.3147+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308357.0, assembly_id=102288.0))
lhcb1.new("ms.17l2.b1", "ms", at="-755.4197+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249894.0, assembly_id=102288.0))
lhcb1.new("mcbh.17l2.b1", "mcbh", at="-754.8267+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249896.0, assembly_id=102288.0))
lhcb1.new("mco.b17l2.b1", "mco_unplugged", at="-753.7357+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249898.0, assembly_id=102289.0))
lhcb1.new("mcd.b17l2.b1", "mcd", at="-753.7342+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249899.0, assembly_id=102289.0))
lhcb1.new("mb.c17l2.b1", "mb", at="-746.2497+(128.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823326.0, assembly_id=102289.0))
lhcb1.new("mcs.c17l2.b1", "mcs", at="-738.8257+(129-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242657.0, assembly_id=102289.0))
lhcb1.new("mb.b17l2.b1", "mb", at="-730.5897+(129.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823350.0, assembly_id=102290.0))
lhcb1.new("mcs.b17l2.b1", "mcs", at="-723.1657+(130-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242660.0, assembly_id=102290.0))
lhcb1.new("mco.a17l2.b1", "mco_unplugged", at="-722.4157+(130-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249902.0, assembly_id=102291.0))
lhcb1.new("mcd.a17l2.b1", "mcd", at="-722.4142+(130-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249903.0, assembly_id=102291.0))
lhcb1.new("mb.a17l2.b1", "mb", at="-714.9297+(130.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823374.0, assembly_id=102291.0))
lhcb1.new("mcs.a17l2.b1", "mcs", at="-707.5057+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242665.0, assembly_id=102291.0))
lhcb1.new("bpm.16l2.b1", "bpm", at="-706.6267+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242667.0, assembly_id=102292.0))
lhcb1.new("mqt.16l2.b1", "mqt", at="-705.8727+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307572.0, assembly_id=102292.0))
lhcb1.new("mq.16l2.b1", "mq", at="-703.8647+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308327.0, assembly_id=102292.0))
lhcb1.new("ms.16l2.b1", "ms", at="-701.9697+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249906.0, assembly_id=102292.0))
lhcb1.new("mcbv.16l2.b1", "mcbv", at="-701.3767+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249908.0, assembly_id=102292.0))
lhcb1.new("mb.c16l2.b1", "mb", at="-692.7997+(131.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823398.0, assembly_id=102293.0))
lhcb1.new("mcs.c16l2.b1", "mcs", at="-685.3757+(132-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242673.0, assembly_id=102293.0))
lhcb1.new("mco.16l2.b1", "mco_unplugged", at="-684.6257+(132-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249910.0, assembly_id=102294.0))
lhcb1.new("mcd.16l2.b1", "mcd", at="-684.6242+(132-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249911.0, assembly_id=102294.0))
lhcb1.new("mb.b16l2.b1", "mb", at="-677.1397+(132.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823422.0, assembly_id=102294.0))
lhcb1.new("mcs.b16l2.b1", "mcs", at="-669.7157+(133-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242678.0, assembly_id=102294.0))
lhcb1.new("mb.a16l2.b1", "mb", at="-661.4797+(133.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823446.0, assembly_id=102295.0))
lhcb1.new("mcs.a16l2.b1", "mcs", at="-654.0557+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242681.0, assembly_id=102295.0))
lhcb1.new("bpm.15l2.b1", "bpm", at="-653.1767+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242683.0, assembly_id=102296.0))
lhcb1.new("mqt.15l2.b1", "mqt", at="-652.4227+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307541.0, assembly_id=102296.0))
lhcb1.new("mq.15l2.b1", "mq", at="-650.4147+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308534.0, assembly_id=102296.0))
lhcb1.new("ms.15l2.b1", "ms", at="-648.5197+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249914.0, assembly_id=102296.0))
lhcb1.new("mcbh.15l2.b1", "mcbh", at="-647.9267+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249916.0, assembly_id=102296.0))
lhcb1.new("mco.b15l2.b1", "mco_unplugged", at="-646.8357+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249918.0, assembly_id=102297.0))
lhcb1.new("mcd.b15l2.b1", "mcd", at="-646.8342+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249919.0, assembly_id=102297.0))
lhcb1.new("mb.c15l2.b1", "mb", at="-639.3497+(134.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823470.0, assembly_id=102297.0))
lhcb1.new("mcs.c15l2.b1", "mcs", at="-631.9257+(135-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242691.0, assembly_id=102297.0))
lhcb1.new("mb.b15l2.b1", "mb", at="-623.6897+(135.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823494.0, assembly_id=102298.0))
lhcb1.new("mcs.b15l2.b1", "mcs", at="-616.2657+(136-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242694.0, assembly_id=102298.0))
lhcb1.new("mco.a15l2.b1", "mco_unplugged", at="-615.5157+(136-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249922.0, assembly_id=102299.0))
lhcb1.new("mcd.a15l2.b1", "mcd", at="-615.5142+(136-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249923.0, assembly_id=102299.0))
lhcb1.new("mb.a15l2.b1", "mb", at="-608.0297+(136.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823518.0, assembly_id=102299.0))
lhcb1.new("mcs.a15l2.b1", "mcs", at="-600.6057+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242699.0, assembly_id=102299.0))
lhcb1.new("bpm.14l2.b1", "bpm", at="-599.7267+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242701.0, assembly_id=102300.0))
lhcb1.new("mqt.14l2.b1", "mqt", at="-598.9727+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307509.0, assembly_id=102300.0))
lhcb1.new("mq.14l2.b1", "mq", at="-596.9647+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308504.0, assembly_id=102300.0))
lhcb1.new("ms.14l2.b1", "ms", at="-595.0697+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249926.0, assembly_id=102300.0))
lhcb1.new("mcbv.14l2.b1", "mcbv", at="-594.4767+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249928.0, assembly_id=102300.0))
lhcb1.new("mb.c14l2.b1", "mb", at="-585.8997+(137.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823542.0, assembly_id=102301.0))
lhcb1.new("mcs.c14l2.b1", "mcs", at="-578.4757+(138-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242707.0, assembly_id=102301.0))
lhcb1.new("mco.14l2.b1", "mco_unplugged", at="-577.7257+(138-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249930.0, assembly_id=102302.0))
lhcb1.new("mcd.14l2.b1", "mcd", at="-577.7242+(138-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249931.0, assembly_id=102302.0))
lhcb1.new("mb.b14l2.b1", "mb", at="-570.2397+(138.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823566.0, assembly_id=102302.0))
lhcb1.new("mcs.b14l2.b1", "mcs", at="-562.8157+(139-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242712.0, assembly_id=102302.0))
lhcb1.new("mb.a14l2.b1", "mb", at="-554.5797+(139.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823590.0, assembly_id=102303.0))
lhcb1.new("mcs.a14l2.b1", "mcs", at="-547.1557+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242715.0, assembly_id=102303.0))
lhcb1.new("s.ds.l2.b1", "omk", at="-546.7497+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.13l2.b1", "bpm", at="-546.2767+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242717.0, assembly_id=102304.0))
lhcb1.new("mqt.13l2.b1", "mqt", at="-545.5227+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307717.0, assembly_id=102304.0))
lhcb1.new("mq.13l2.b1", "mq", at="-543.5147+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308474.0, assembly_id=102304.0))
lhcb1.new("ms.13l2.b1", "ms", at="-541.6197+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249934.0, assembly_id=102304.0))
lhcb1.new("mcbh.13l2.b1", "mcbh", at="-541.0267+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249936.0, assembly_id=102304.0))
lhcb1.new("mco.b13l2.b1", "mco_unplugged", at="-539.9357+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249938.0, assembly_id=102305.0))
lhcb1.new("mcd.b13l2.b1", "mcd", at="-539.9342+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249939.0, assembly_id=102305.0))
lhcb1.new("mb.c13l2.b1", "mb", at="-532.4497+(140.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823614.0, assembly_id=102305.0))
lhcb1.new("mcs.c13l2.b1", "mcs", at="-525.0257+(141-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242725.0, assembly_id=102305.0))
lhcb1.new("mb.b13l2.b1", "mb", at="-516.7897+(141.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823638.0, assembly_id=102306.0))
lhcb1.new("mcs.b13l2.b1", "mcs", at="-509.3657+(142-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242728.0, assembly_id=102306.0))
lhcb1.new("mco.a13l2.b1", "mco_unplugged", at="-508.6157+(142-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249942.0, assembly_id=102307.0))
lhcb1.new("mcd.a13l2.b1", "mcd", at="-508.6142+(142-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249943.0, assembly_id=102307.0))
lhcb1.new("mb.a13l2.b1", "mb", at="-501.1297+(142.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823662.0, assembly_id=102307.0))
lhcb1.new("mcs.a13l2.b1", "mcs", at="-493.7057+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242733.0, assembly_id=102307.0))
lhcb1.new("bpm.12l2.b1", "bpm", at="-492.8267+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242735.0, assembly_id=102308.0))
lhcb1.new("mqt.12l2.b1", "mqt", at="-492.0727+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307685.0, assembly_id=102308.0))
lhcb1.new("mq.12l2.b1", "mq", at="-490.0647+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308681.0, assembly_id=102308.0))
lhcb1.new("ms.12l2.b1", "ms", at="-488.1697+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249946.0, assembly_id=102308.0))
lhcb1.new("mcbv.12l2.b1", "mcbv", at="-487.5767+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249948.0, assembly_id=102308.0))
lhcb1.new("mb.c12l2.b1", "mb", at="-478.9997+(143.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823686.0, assembly_id=102309.0))
lhcb1.new("mcs.c12l2.b1", "mcs", at="-471.5757+(144-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242741.0, assembly_id=102309.0))
lhcb1.new("mco.12l2.b1", "mco_unplugged", at="-470.8257+(144-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249950.0, assembly_id=102310.0))
lhcb1.new("mcd.12l2.b1", "mcd", at="-470.8242+(144-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249951.0, assembly_id=102310.0))
lhcb1.new("mb.b12l2.b1", "mb", at="-463.3397+(144.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823710.0, assembly_id=102310.0))
lhcb1.new("mcs.b12l2.b1", "mcs", at="-455.9157+(145-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242746.0, assembly_id=102310.0))
lhcb1.new("mb.a12l2.b1", "mb", at="-447.6797+(145.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823734.0, assembly_id=102311.0))
lhcb1.new("mcs.a12l2.b1", "mcs", at="-440.2557+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242749.0, assembly_id=102311.0))
lhcb1.new("e.arc.12.b1", "omk", at="-439.8497+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.11l2.b1", "bpm", at="-439.3767+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242751.0, assembly_id=102312.0))
lhcb1.new("mq.11l2.b1", "mq", at="-436.8297+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308651.0, assembly_id=102312.0))
lhcb1.new("mqtli.11l2.b1", "mqtli", at="-434.4607+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2348437.0, assembly_id=102312.0))
lhcb1.new("ms.11l2.b1", "ms", at="-433.4487+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249954.0, assembly_id=102312.0))
lhcb1.new("mcbh.11l2.b1", "mcbh", at="-432.8557+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249956.0, assembly_id=102312.0))
lhcb1.new("leprb.11l2.b1", "leprb", at="-429.450025+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52998162.0, assembly_id=43344242.0))
lhcb1.new("lenra.11l2.b1", "lenra", at="-425.71735+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52998018.0, assembly_id=43347335.0))
lhcb1.new("lepra.11l2.b1", "lepra", at="-421.984675+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52998138.0, assembly_id=43347323.0))
lhcb1.new("mco.11l2.b1", "mco_unplugged", at="-418.986+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249958.0, assembly_id=102314.0))
lhcb1.new("mcd.11l2.b1", "mcd", at="-418.9845+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249959.0, assembly_id=102314.0))
lhcb1.new("mb.b11l2.b1", "mb", at="-411.5+(146.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823758.0, assembly_id=102314.0))
lhcb1.new("mcs.b11l2.b1", "mcs", at="-404.076+(147-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242759.0, assembly_id=102314.0))
lhcb1.new("mb.a11l2.b1", "mb", at="-395.84+(147.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52849414.0, assembly_id=102315.0))
lhcb1.new("mcs.a11l2.b1", "mcs", at="-388.416+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=357284.0, assembly_id=102315.0))
lhcb1.new("bpm.10l2.b1", "bpm", at="-387.537+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=377924.0, assembly_id=102316.0))
lhcb1.new("mqml.10l2.b1", "mqml", at="-384.392+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307806.0, assembly_id=102316.0))
lhcb1.new("mcbcv.10l2.b1", "mcbcv", at="-381.35+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=378094.0, assembly_id=102316.0))
lhcb1.new("mco.10l2.b1", "mco_unplugged", at="-379.921+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249964.0, assembly_id=102317.0))
lhcb1.new("mcd.10l2.b1", "mcd", at="-379.9195+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249965.0, assembly_id=102317.0))
lhcb1.new("mb.b10l2.b1", "mb", at="-372.435+(148.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823782.0, assembly_id=102317.0))
lhcb1.new("mcs.b10l2.b1", "mcs", at="-365.011+(149-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242771.0, assembly_id=102317.0))
lhcb1.new("mb.a10l2.b1", "mb", at="-356.775+(149.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823806.0, assembly_id=102318.0))
lhcb1.new("mcs.a10l2.b1", "mcs", at="-349.351+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242774.0, assembly_id=102318.0))
lhcb1.new("bpm.9l2.b1", "bpm", at="-348.471+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=377928.0, assembly_id=102319.0))
lhcb1.new("mqmc.9l2.b1", "mqmc", at="-346.495+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307783.0, assembly_id=102319.0))
lhcb1.new("mqm.9l2.b1", "mqm", at="-343.229+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307731.0, assembly_id=102319.0))
lhcb1.new("mcbch.9l2.b1", "mcbch", at="-340.888+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=378101.0, assembly_id=102319.0))
lhcb1.new("mco.9l2.b1", "mco_unplugged", at="-339.456+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249970.0, assembly_id=102320.0))
lhcb1.new("mcd.9l2.b1", "mcd", at="-339.4545+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249971.0, assembly_id=102320.0))
lhcb1.new("mb.b9l2.b1", "mb", at="-331.97+(150.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823830.0, assembly_id=102320.0))
lhcb1.new("mcs.b9l2.b1", "mcs", at="-324.546+(151-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242784.0, assembly_id=102320.0))
lhcb1.new("mb.a9l2.b1", "mb", at="-316.31+(151.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823854.0, assembly_id=102321.0))
lhcb1.new("mcs.a9l2.b1", "mcs", at="-308.886+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242787.0, assembly_id=102321.0))
lhcb1.new("bpm.8l2.b1", "bpm", at="-308.007+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=377934.0, assembly_id=102322.0))
lhcb1.new("mqml.8l2.b1", "mqml", at="-304.862+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307838.0, assembly_id=102322.0))
lhcb1.new("mcbcv.8l2.b1", "mcbcv", at="-301.82+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=378104.0, assembly_id=102322.0))
lhcb1.new("mco.8l2.b1", "mco_unplugged", at="-300.391+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249976.0, assembly_id=102323.0))
lhcb1.new("mcd.8l2.b1", "mcd", at="-300.3895+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249977.0, assembly_id=102323.0))
lhcb1.new("mb.b8l2.b1", "mb", at="-292.905+(152.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823878.0, assembly_id=102323.0))
lhcb1.new("mcs.b8l2.b1", "mcs", at="-285.481+(153-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242796.0, assembly_id=102323.0))
lhcb1.new("mb.a8l2.b1", "mb", at="-277.245+(153.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52849438.0, assembly_id=102324.0))
lhcb1.new("mcs.a8l2.b1", "mcs", at="-269.821+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=357287.0, assembly_id=102324.0))
lhcb1.new("e.ds.l2.b1", "omk", at="-269.415+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.7l2.b1", "bpm", at="-268.94+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242801.0, assembly_id=102325.0))
lhcb1.new("mqm.b7l2.b1", "mqm", at="-266.495+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307768.0, assembly_id=102325.0))
lhcb1.new("mqm.a7l2.b1", "mqm", at="-262.728+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307753.0, assembly_id=102325.0))
lhcb1.new("mcbch.7l2.b1", "mcbch", at="-260.387+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249981.0, assembly_id=102325.0))
lhcb1.new("dfbac.7l2.b1", "dfbac", at="-258.2075+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52996587.0, assembly_id=104674.0))
lhcb1.new("mcbcv.6l2.b1", "mcbcv", at="-246.79+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249982.0, assembly_id=102326.0))
lhcb1.new("mqml.6l2.b1", "mqml", at="-243.748+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307828.0, assembly_id=102326.0))
lhcb1.new("mqm.6l2.b1", "mqm", at="-239.281+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307955.0, assembly_id=102326.0))
lhcb1.new("bpmr.6l2.b1", "bpmr", at="-236.834+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242809.0, assembly_id=102326.0))
lhcb1.new("msib.c6l2.b1", "msib", at="-212.723+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52849950.0, assembly_id=134506.0))
lhcb1.new("msib.b6l2.b1", "msib", at="-208.273+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52849976.0, assembly_id=134507.0))
lhcb1.new("msib.a6l2.b1", "msib", at="-203.823+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52850002.0, assembly_id=134508.0))
lhcb1.new("msia.b6l2.b1", "msia", at="-199.373+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52849846.0, assembly_id=134509.0))
lhcb1.new("msia.a6l2.b1", "msia", at="-194.923+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52849872.0, assembly_id=134510.0))
lhcb1.new("msia.exit.b1", "omk", at="-192.923+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("btvss.6l2.b1", "btvss075", at="-192.173+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=181614.0))
lhcb1.new("mcbyh.b5l2.b1", "mcbyh", at="-175.75+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249984.0, assembly_id=102328.0))
lhcb1.new("mcbyv.5l2.b1", "mcbyv", at="-174.604+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249986.0, assembly_id=102328.0))
lhcb1.new("mcbyh.a5l2.b1", "mcbyh", at="-173.457+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249988.0, assembly_id=102328.0))
lhcb1.new("mqy.b5l2.b1", "mqy", at="-171.11+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2302969.0, assembly_id=102328.0))
lhcb1.new("mqy.a5l2.b1", "mqy", at="-167.329+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2302968.0, assembly_id=102328.0))
lhcb1.new("bpmyb.5l2.b1", "bpmyb", at="-164.635+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242816.0, assembly_id=102328.0))
lhcb1.new("btvsi.c5l2.b1", "btvsi088", at="-163.269+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=181615.0))
lhcb1.new("mki.d5l2.b1", "mkima192", at="-160.296+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=378207.0))
lhcb1.new("mki.c5l2.b1", "mkima192", at="-156.332+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=378208.0))
lhcb1.new("mki.b5l2.b1", "mkima192", at="-152.368+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=378209.0))
lhcb1.new("mki.a5l2.b1", "mkima192", at="-148.404+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=378210.0))
lhcb1.new("bptx.5l2.b1", "bptx", at="-146.1615+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=104665.0))
lhcb1.new("btvsi.a5l2.b1", "btvsi088", at="-145.431+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=181616.0))
lhcb1.new("bpmyb.4l2.b1", "bpmyb", at="-144.065+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242818.0, assembly_id=102330.0))
lhcb1.new("lhcinj.b1", "omk", at="-143.071+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("mqy.b4l2.b1", "mqy", at="-141.371+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2302979.0, assembly_id=102330.0))
lhcb1.new("mqy.a4l2.b1", "mqy", at="-137.59+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2302978.0, assembly_id=102330.0))
lhcb1.new("mcbyv.b4l2.b1", "mcbyv", at="-135.243+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249991.0, assembly_id=102330.0))
lhcb1.new("mcbyh.4l2.b1", "mcbyh", at="-134.096+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249993.0, assembly_id=102330.0))
lhcb1.new("mcbyv.a4l2.b1", "mcbyv", at="-132.95+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.194, slot_id=249995.0, assembly_id=102330.0))
lhcb1.new("mbrc.4l2.b1", "mbrc", at="-126.403+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.188, slot_id=52819636.0, assembly_id=102331.0))
lhcb1.new("bpmwi.4l2.b1", "bpmwi", at="-119.5975+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.174, slot_id=104597.0))
lhcb1.new("bptuh.a4l2.b1", "bptuh", at="-119.128+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.172, slot_id=10402842.0, assembly_id=377594.0))
lhcb1.new("tctph.4l2.b1", "tctph", at="-118.533+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.1699, slot_id=377594.0))
lhcb1.new("bptdh.a4l2.b1", "bptdh", at="-117.938+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.172, slot_id=10429552.0, assembly_id=377594.0))
lhcb1.new("bptuv.a4l2.b1", "bptuv", at="-117.128+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.166, slot_id=10402670.0, assembly_id=5619143.0))
lhcb1.new("tctpv.4l2.b1", "tctpv", at="-116.533+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.1637, slot_id=5619143.0))
lhcb1.new("bptdv.a4l2.b1", "bptdv", at="-115.938+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.166, slot_id=10402672.0, assembly_id=5619143.0))
lhcb1.new("x2zdc.4l2", "x2zdc001", at="-113.3245+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=102332.0))
lhcb1.new("branc.4l2", "branc", at="-111.5104+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=55373880.0))
lhcb1.new("btvst.a4l2", "btvst065", at="-85.433+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.08, slot_id=181617.0))
lhcb1.new("tdisa.a4l2.b1", "tdisa", at="-82.743+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.074, slot_id=47535641.0, assembly_id=47535223.0))
lhcb1.new("tdisb.a4l2.b1", "tdisb", at="-81.163+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.074, slot_id=47535649.0, assembly_id=47535223.0))
lhcb1.new("tdisc.a4l2.b1", "tdisc", at="-79.583+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.074, slot_id=47535653.0, assembly_id=47535223.0))
lhcb1.new("tcdd.4l2", "tcdd", at="-71.228+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=102334.0))
lhcb1.new("bpmsx.4l2.b1", "bpmsx003", at="-69.5005+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0194, slot_id=43068873.0, assembly_id=104598.0))
lhcb1.new("mbx.4l2", "mbx", at="-63.108+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242833.0, assembly_id=102335.0))
lhcb1.new("dfbxc.3l2", "dfbxc", at="-56.3085+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=104675.0))
lhcb1.new("mcosx.3l2", "mcosx_unplugged", at="-54.297+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282240.0, assembly_id=102336.0))
lhcb1.new("mcox.3l2", "mcox_unplugged", at="-54.297+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282239.0, assembly_id=102336.0))
lhcb1.new("mcssx.3l2", "mcssx_unplugged", at="-54.297+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282238.0, assembly_id=102336.0))
lhcb1.new("mcbxh.3l2", "mcbxh", at="-53.814+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=249996.0, assembly_id=102336.0))
lhcb1.new("mcbxv.3l2", "mcbxv", at="-53.814+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=249997.0, assembly_id=102336.0))
lhcb1.new("mcsx.3l2", "mcsx", at="-53.814+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=249998.0, assembly_id=102336.0))
lhcb1.new("mctx.3l2", "mctx", at="-53.814+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=249999.0, assembly_id=102336.0))
lhcb1.new("mqxa.3l2", "mqxa", at="-50.15+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242835.0, assembly_id=102336.0))
lhcb1.new("mqsx.3l2", "mqsx", at="-46.608+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282128.0, assembly_id=102336.0))
lhcb1.new("mqxb.b2l2", "mqxb", at="-41.3+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242837.0, assembly_id=102337.0))
lhcb1.new("mcbxh.2l2", "mcbxh", at="-38.019+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250004.0, assembly_id=102337.0))
lhcb1.new("mcbxv.2l2", "mcbxv", at="-38.019+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250005.0, assembly_id=102337.0))
lhcb1.new("mqxb.a2l2", "mqxb", at="-34.8+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242839.0, assembly_id=102337.0))
lhcb1.new("bpms.2l2.b1", "bpms_003", at="-31.529+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=43068881.0, assembly_id=102337.0))
lhcb1.new("mcbxh.1l2", "mcbxh_unplugged", at="-29.842+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250006.0, assembly_id=102338.0))
lhcb1.new("mcbxv.1l2", "mcbxv", at="-29.842+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250007.0, assembly_id=102338.0))
lhcb1.new("mqxa.1l2", "mqxa", at="-26.15+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242842.0, assembly_id=102338.0))
lhcb1.new("bpmsw.1l2.b1", "bpmsw002", at="-21.595+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=10428876.0, assembly_id=104599.0))
lhcb1.new("bpmsw.1l2.b1_doros", "bpmsw002", at="-21.595+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=12907563.0, assembly_id=104599.0))
lhcb1.new("mbxwt.1l2", "mbxwt", at="-20.49+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=103994.0))
lhcb1.new("mbwmd.1l2", "mbwmd", at="-10.75+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242845.0))
lhcb1.new("mbls2.1l2", "mbls2", at="-3.025+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=52895785.0, assembly_id=2212849.0))
lhcb1.new("ip2", "omk", at="pip2+ip2ofs.b1*ds")
lhcb1.new("mbls2.1r2", "mbls2", at="3.025+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=52895804.0, assembly_id=2212849.0))
lhcb1.new("mbaw.1r2", "mbaw", at="9.75+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=104000.0))
lhcb1.new("mbxwt.1r2", "mbxwt", at="20.49+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=103996.0))
lhcb1.new("bpmsw.1r2.b1", "bpmsw002", at="21.595+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=10428862.0, assembly_id=104600.0))
lhcb1.new("bpmsw.1r2.b1_doros", "bpmsw002", at="21.595+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=12907555.0, assembly_id=104600.0))
lhcb1.new("mqxa.1r2", "mqxa", at="26.15+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242848.0, assembly_id=102339.0))
lhcb1.new("mcbxh.1r2", "mcbxh", at="29.842+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250008.0, assembly_id=102339.0))
lhcb1.new("mcbxv.1r2", "mcbxv", at="29.842+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250009.0, assembly_id=102339.0))
lhcb1.new("bpms.2r2.b1", "bpms_003", at="31.529+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=43068877.0, assembly_id=102340.0))
lhcb1.new("mqxb.a2r2", "mqxb", at="34.8+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242851.0, assembly_id=102340.0))
lhcb1.new("mcbxh.2r2", "mcbxh", at="38.019+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250010.0, assembly_id=102340.0))
lhcb1.new("mcbxv.2r2", "mcbxv", at="38.019+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250011.0, assembly_id=102340.0))
lhcb1.new("mqxb.b2r2", "mqxb", at="41.3+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242853.0, assembly_id=102340.0))
lhcb1.new("mqsx.3r2", "mqsx", at="46.608+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282129.0, assembly_id=102341.0))
lhcb1.new("mqxa.3r2", "mqxa", at="50.15+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242855.0, assembly_id=102341.0))
lhcb1.new("mcbxh.3r2", "mcbxh", at="53.814+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250016.0, assembly_id=102341.0))
lhcb1.new("mcbxv.3r2", "mcbxv", at="53.814+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250017.0, assembly_id=102341.0))
lhcb1.new("mcsx.3r2", "mcsx", at="53.814+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250018.0, assembly_id=102341.0))
lhcb1.new("mctx.3r2", "mctx", at="53.814+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250019.0, assembly_id=102341.0))
lhcb1.new("mcosx.3r2", "mcosx", at="54.297+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282243.0, assembly_id=102341.0))
lhcb1.new("mcox.3r2", "mcox", at="54.297+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282242.0, assembly_id=102341.0))
lhcb1.new("mcssx.3r2", "mcssx", at="54.297+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282241.0, assembly_id=102341.0))
lhcb1.new("dfbxd.3r2", "dfbxd", at="56.3085+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=104676.0))
lhcb1.new("mbx.4r2", "mbx", at="63.108+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242857.0, assembly_id=102342.0))
lhcb1.new("bpmsx.4r2.b1", "bpmsx003", at="69.3805+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.0194, slot_id=43068875.0, assembly_id=104601.0))
lhcb1.new("tclia.4r2", "tclia", at="71.548+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=357146.0))
lhcb1.new("branc.4r2", "branc", at="111.609+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=55373933.0))
lhcb1.new("x2zdc.4r2", "x2zdc002", at="113.3245+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=0.0, slot_id=102343.0))
lhcb1.new("bpmwb.4r2.b1", "bpmwb", at="119.6735+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.174, slot_id=104602.0))
lhcb1.new("mbrc.4r2.b1", "mbrc", at="126.403+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.188, slot_id=52819660.0, assembly_id=102344.0))
lhcb1.new("mcbyh.a4r2.b1", "mcbyh", at="132.95+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250021.0, assembly_id=102345.0))
lhcb1.new("mcbyv.4r2.b1", "mcbyv", at="134.096+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250023.0, assembly_id=102345.0))
lhcb1.new("mcbyh.b4r2.b1", "mcbyh", at="135.243+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250025.0, assembly_id=102345.0))
lhcb1.new("mqy.a4r2.b1", "mqy", at="137.59+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2303165.0, assembly_id=102345.0))
lhcb1.new("mqy.b4r2.b1", "mqy", at="141.371+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2303164.0, assembly_id=102345.0))
lhcb1.new("bpmyb.4r2.b1", "bpmyb", at="144.065+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242870.0, assembly_id=102345.0))
lhcb1.new("mcbcv.a5r2.b1", "mcbcv", at="162.689+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=298305.0, assembly_id=102346.0))
lhcb1.new("mcbch.5r2.b1", "mcbch", at="163.836+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=298308.0, assembly_id=102346.0))
lhcb1.new("mcbcv.b5r2.b1", "mcbcv", at="164.982+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=298309.0, assembly_id=102346.0))
lhcb1.new("mqm.a5r2.b1", "mqm", at="167.329+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2303033.0, assembly_id=102346.0))
lhcb1.new("mqm.b5r2.b1", "mqm", at="171.11+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2303032.0, assembly_id=102346.0))
lhcb1.new("bpmr.5r2.b1", "bpmr", at="173.599+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242877.0, assembly_id=102346.0))
lhcb1.new("tclib.6r2.b1", "tclib", at="227.654+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=102347.0))
lhcb1.new("tclim.6r2.b1", "tclim", at="234.399+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52998848.0, assembly_id=357147.0))
lhcb1.new("mcbch.6r2.b1", "mcbch", at="236.939+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250033.0, assembly_id=102348.0))
lhcb1.new("mqml.6r2.b1", "mqml", at="239.981+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307832.0, assembly_id=102348.0))
lhcb1.new("mqm.6r2.b1", "mqm", at="244.448+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307959.0, assembly_id=102348.0))
lhcb1.new("bpm.6r2.b1", "bpm", at="246.895+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=298152.0, assembly_id=102348.0))
lhcb1.new("dfbad.7r2.b1", "dfbad", at="257.9575+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52996611.0, assembly_id=104677.0))
lhcb1.new("bpm_a.7r2.b1", "bpm_a", at="259.77+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=377941.0, assembly_id=102350.0))
lhcb1.new("mqm.a7r2.b1", "mqm", at="262.215+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307761.0, assembly_id=102350.0))
lhcb1.new("mqm.b7r2.b1", "mqm", at="265.982+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307776.0, assembly_id=102350.0))
lhcb1.new("mcbcv.7r2.b1", "mcbcv", at="268.323+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250034.0, assembly_id=102350.0))
lhcb1.new("s.ds.r2.b1", "omk", at="269.415+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("mco.8r2.b1", "mco", at="269.759+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250038.0, assembly_id=102351.0))
lhcb1.new("mcd.8r2.b1", "mcd", at="269.7605+(154-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250039.0, assembly_id=102351.0))
lhcb1.new("mb.a8r2.b1", "mb", at="277.245+(153.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823902.0, assembly_id=102351.0))
lhcb1.new("mcs.a8r2.b1", "mcs", at="284.669+(153-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242894.0, assembly_id=102351.0))
lhcb1.new("mb.b8r2.b1", "mb", at="292.905+(152.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823926.0, assembly_id=102352.0))
lhcb1.new("mcs.b8r2.b1", "mcs", at="300.329+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242897.0, assembly_id=102352.0))
lhcb1.new("bpm.8r2.b1", "bpm", at="301.208+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242899.0, assembly_id=102353.0))
lhcb1.new("mqml.8r2.b1", "mqml", at="304.353+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2348448.0, assembly_id=102353.0))
lhcb1.new("mcbch.8r2.b1", "mcbch", at="307.395+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250040.0, assembly_id=102353.0))
lhcb1.new("mco.9r2.b1", "mco", at="308.824+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250044.0, assembly_id=102354.0))
lhcb1.new("mcd.9r2.b1", "mcd", at="308.8255+(152-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250045.0, assembly_id=102354.0))
lhcb1.new("mb.a9r2.b1", "mb", at="316.31+(151.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823950.0, assembly_id=102354.0))
lhcb1.new("mcs.a9r2.b1", "mcs", at="323.734+(151-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242906.0, assembly_id=102354.0))
lhcb1.new("mb.b9r2.b1", "mb", at="331.97+(150.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823974.0, assembly_id=102355.0))
lhcb1.new("mcs.b9r2.b1", "mcs", at="339.394+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242909.0, assembly_id=102355.0))
lhcb1.new("bpm.9r2.b1", "bpm", at="340.274+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242911.0, assembly_id=102356.0))
lhcb1.new("mqmc.9r2.b1", "mqmc", at="342.25+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307794.0, assembly_id=102356.0))
lhcb1.new("mqm.9r2.b1", "mqm", at="345.516+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307742.0, assembly_id=102356.0))
lhcb1.new("mcbcv.9r2.b1", "mcbcv", at="347.857+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250046.0, assembly_id=102356.0))
lhcb1.new("mco.10r2.b1", "mco", at="349.289+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250050.0, assembly_id=102357.0))
lhcb1.new("mcd.10r2.b1", "mcd", at="349.2905+(150-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250051.0, assembly_id=102357.0))
lhcb1.new("mb.a10r2.b1", "mb", at="356.775+(149.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823998.0, assembly_id=102357.0))
lhcb1.new("mcs.a10r2.b1", "mcs", at="364.199+(149-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242919.0, assembly_id=102357.0))
lhcb1.new("mb.b10r2.b1", "mb", at="372.435+(148.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824022.0, assembly_id=102358.0))
lhcb1.new("mcs.b10r2.b1", "mcs", at="379.859+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242922.0, assembly_id=102358.0))
lhcb1.new("bpm.10r2.b1", "bpm", at="380.738+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242924.0, assembly_id=102359.0))
lhcb1.new("mqml.10r2.b1", "mqml", at="383.883+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307818.0, assembly_id=102359.0))
lhcb1.new("mcbch.10r2.b1", "mcbch", at="386.925+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250052.0, assembly_id=102359.0))
lhcb1.new("mco.11r2.b1", "mco", at="388.354+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250056.0, assembly_id=102360.0))
lhcb1.new("mcd.11r2.b1", "mcd", at="388.3555+(148-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250057.0, assembly_id=102360.0))
lhcb1.new("mb.a11r2.b1", "mb", at="395.84+(147.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824046.0, assembly_id=102360.0))
lhcb1.new("mcs.a11r2.b1", "mcs", at="403.264+(147-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242931.0, assembly_id=102360.0))
lhcb1.new("mb.b11r2.b1", "mb", at="411.5+(146.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52849462.0, assembly_id=102361.0))
lhcb1.new("mcs.b11r2.b1", "mcs", at="418.924+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=357296.0, assembly_id=102361.0))
lhcb1.new("lepla.11r2.b1", "lepla", at="421.984675+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52998090.0, assembly_id=52433772.0))
lhcb1.new("bptuh.a11r2.b1", "bptuh", at="425.36435+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52697708.0, assembly_id=52433988.0))
lhcb1.new("tcld.a11r2.b1", "tcld", at="425.71735+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52506153.0, assembly_id=52433988.0))
lhcb1.new("bptdh.a11r2.b1", "bptdh", at="426.07035+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52697718.0, assembly_id=52433988.0))
lhcb1.new("leplb.11r2.b1", "leplb", at="429.450025+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52998114.0, assembly_id=52433791.0))
lhcb1.new("bpm.11r2.b1", "bpm", at="432.5777+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242936.0, assembly_id=102363.0))
lhcb1.new("mq.11r2.b1", "mq", at="435.1247+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308666.0, assembly_id=102363.0))
lhcb1.new("mqtli.11r2.b1", "mqtli", at="437.4937+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307354.0, assembly_id=102363.0))
lhcb1.new("ms.11r2.b1", "ms", at="438.5057+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250059.0, assembly_id=102363.0))
lhcb1.new("mcbv.11r2.b1", "mcbv", at="439.0987+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250061.0, assembly_id=102363.0))
lhcb1.new("s.arc.23.b1", "omk", at="439.8497+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a12r2.b1", "mco", at="440.1937+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250064.0, assembly_id=102364.0))
lhcb1.new("mcd.a12r2.b1", "mcd", at="440.1952+(146-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250065.0, assembly_id=102364.0))
lhcb1.new("mb.a12r2.b1", "mb", at="447.6797+(145.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824070.0, assembly_id=102364.0))
lhcb1.new("mcs.a12r2.b1", "mcs", at="455.1037+(145-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242944.0, assembly_id=102364.0))
lhcb1.new("mb.b12r2.b1", "mb", at="463.3397+(144.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824094.0, assembly_id=102365.0))
lhcb1.new("mcs.b12r2.b1", "mcs", at="470.7637+(144-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242947.0, assembly_id=102365.0))
lhcb1.new("mco.b12r2.b1", "mco", at="471.5137+(144-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250068.0, assembly_id=102366.0))
lhcb1.new("mcd.b12r2.b1", "mcd", at="471.5152+(144-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250069.0, assembly_id=102366.0))
lhcb1.new("mb.c12r2.b1", "mb", at="478.9997+(143.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824118.0, assembly_id=102366.0))
lhcb1.new("mcs.c12r2.b1", "mcs", at="486.4237+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242952.0, assembly_id=102366.0))
lhcb1.new("bpm.12r2.b1", "bpm", at="487.3027+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242954.0, assembly_id=102367.0))
lhcb1.new("mqt.12r2.b1", "mqt", at="488.0567+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307701.0, assembly_id=102367.0))
lhcb1.new("mq.12r2.b1", "mq", at="490.0647+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308460.0, assembly_id=102367.0))
lhcb1.new("ms.12r2.b1", "ms", at="491.9597+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250071.0, assembly_id=102367.0))
lhcb1.new("mcbh.12r2.b1", "mcbh", at="492.5527+(143-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250073.0, assembly_id=102367.0))
lhcb1.new("mb.a13r2.b1", "mb", at="501.1297+(142.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824142.0, assembly_id=102368.0))
lhcb1.new("mcs.a13r2.b1", "mcs", at="508.5537+(142-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242960.0, assembly_id=102368.0))
lhcb1.new("mco.13r2.b1", "mco", at="509.3037+(142-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250076.0, assembly_id=102369.0))
lhcb1.new("mcd.13r2.b1", "mcd", at="509.3052+(142-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250077.0, assembly_id=102369.0))
lhcb1.new("mb.b13r2.b1", "mb", at="516.7897+(141.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824166.0, assembly_id=102369.0))
lhcb1.new("mcs.b13r2.b1", "mcs", at="524.2137+(141-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242965.0, assembly_id=102369.0))
lhcb1.new("mb.c13r2.b1", "mb", at="532.4497+(140.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824190.0, assembly_id=102370.0))
lhcb1.new("mcs.c13r2.b1", "mcs", at="539.8737+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242968.0, assembly_id=102370.0))
lhcb1.new("bpm.13r2.b1", "bpm", at="540.7527+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242970.0, assembly_id=102371.0))
lhcb1.new("mqt.13r2.b1", "mqt", at="541.5067+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307494.0, assembly_id=102371.0))
lhcb1.new("mq.13r2.b1", "mq", at="543.5147+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308489.0, assembly_id=102371.0))
lhcb1.new("ms.13r2.b1", "ms", at="545.4097+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250079.0, assembly_id=102371.0))
lhcb1.new("mcbv.13r2.b1", "mcbv", at="546.0027+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250081.0, assembly_id=102371.0))
lhcb1.new("e.ds.r2.b1", "omk", at="546.7497+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a14r2.b1", "mco", at="547.0937+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250084.0, assembly_id=102372.0))
lhcb1.new("mcd.a14r2.b1", "mcd", at="547.0952+(140-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250085.0, assembly_id=102372.0))
lhcb1.new("mb.a14r2.b1", "mb", at="554.5797+(139.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824214.0, assembly_id=102372.0))
lhcb1.new("mcs.a14r2.b1", "mcs", at="562.0037+(139-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242978.0, assembly_id=102372.0))
lhcb1.new("mb.b14r2.b1", "mb", at="570.2397+(138.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824238.0, assembly_id=102373.0))
lhcb1.new("mcs.b14r2.b1", "mcs", at="577.6637+(138-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242981.0, assembly_id=102373.0))
lhcb1.new("mco.b14r2.b1", "mco", at="578.4137+(138-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250088.0, assembly_id=102374.0))
lhcb1.new("mcd.b14r2.b1", "mcd", at="578.4152+(138-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250089.0, assembly_id=102374.0))
lhcb1.new("mb.c14r2.b1", "mb", at="585.8997+(137.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824262.0, assembly_id=102374.0))
lhcb1.new("mcs.c14r2.b1", "mcs", at="593.3237+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242986.0, assembly_id=102374.0))
lhcb1.new("bpm.14r2.b1", "bpm", at="594.2027+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242988.0, assembly_id=102375.0))
lhcb1.new("mqt.14r2.b1", "mqt", at="594.9567+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307525.0, assembly_id=102375.0))
lhcb1.new("mq.14r2.b1", "mq", at="596.9647+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308519.0, assembly_id=102375.0))
lhcb1.new("ms.14r2.b1", "ms", at="598.8597+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250091.0, assembly_id=102375.0))
lhcb1.new("mcbh.14r2.b1", "mcbh", at="599.4527+(137-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250093.0, assembly_id=102375.0))
lhcb1.new("mb.a15r2.b1", "mb", at="608.0297+(136.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824286.0, assembly_id=102376.0))
lhcb1.new("mcs.a15r2.b1", "mcs", at="615.4537+(136-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242994.0, assembly_id=102376.0))
lhcb1.new("mco.15r2.b1", "mco", at="616.2037+(136-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250096.0, assembly_id=102377.0))
lhcb1.new("mcd.15r2.b1", "mcd", at="616.2052+(136-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250097.0, assembly_id=102377.0))
lhcb1.new("mb.b15r2.b1", "mb", at="623.6897+(135.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824310.0, assembly_id=102377.0))
lhcb1.new("mcs.b15r2.b1", "mcs", at="631.1137+(135-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242999.0, assembly_id=102377.0))
lhcb1.new("mb.c15r2.b1", "mb", at="639.3497+(134.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824334.0, assembly_id=102378.0))
lhcb1.new("mcs.c15r2.b1", "mcs", at="646.7737+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243002.0, assembly_id=102378.0))
lhcb1.new("bpm.15r2.b1", "bpm", at="647.6527+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243004.0, assembly_id=102379.0))
lhcb1.new("mqt.15r2.b1", "mqt", at="648.4067+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307557.0, assembly_id=102379.0))
lhcb1.new("mq.15r2.b1", "mq", at="650.4147+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308549.0, assembly_id=102379.0))
lhcb1.new("ms.15r2.b1", "ms", at="652.3097+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250099.0, assembly_id=102379.0))
lhcb1.new("mcbv.15r2.b1", "mcbv", at="652.9027+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250101.0, assembly_id=102379.0))
lhcb1.new("mco.a16r2.b1", "mco", at="653.9937+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250104.0, assembly_id=102380.0))
lhcb1.new("mcd.a16r2.b1", "mcd", at="653.9952+(134-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250105.0, assembly_id=102380.0))
lhcb1.new("mb.a16r2.b1", "mb", at="661.4797+(133.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824358.0, assembly_id=102380.0))
lhcb1.new("mcs.a16r2.b1", "mcs", at="668.9037+(133-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243012.0, assembly_id=102380.0))
lhcb1.new("mb.b16r2.b1", "mb", at="677.1397+(132.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824382.0, assembly_id=102381.0))
lhcb1.new("mcs.b16r2.b1", "mcs", at="684.5637+(132-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243015.0, assembly_id=102381.0))
lhcb1.new("mco.b16r2.b1", "mco", at="685.3137+(132-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250108.0, assembly_id=102382.0))
lhcb1.new("mcd.b16r2.b1", "mcd", at="685.3152+(132-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250109.0, assembly_id=102382.0))
lhcb1.new("mb.c16r2.b1", "mb", at="692.7997+(131.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824406.0, assembly_id=102382.0))
lhcb1.new("mcs.c16r2.b1", "mcs", at="700.2237+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243020.0, assembly_id=102382.0))
lhcb1.new("bpm.16r2.b1", "bpm", at="701.1027+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243022.0, assembly_id=102383.0))
lhcb1.new("mqt.16r2.b1", "mqt", at="701.8567+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307587.0, assembly_id=102383.0))
lhcb1.new("mq.16r2.b1", "mq", at="703.8647+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308342.0, assembly_id=102383.0))
lhcb1.new("ms.16r2.b1", "ms", at="705.7597+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250111.0, assembly_id=102383.0))
lhcb1.new("mcbh.16r2.b1", "mcbh", at="706.3527+(131-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250113.0, assembly_id=102383.0))
lhcb1.new("mb.a17r2.b1", "mb", at="714.9297+(130.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824430.0, assembly_id=102384.0))
lhcb1.new("mcs.a17r2.b1", "mcs", at="722.3537+(130-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243028.0, assembly_id=102384.0))
lhcb1.new("mco.17r2.b1", "mco", at="723.1037+(130-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250116.0, assembly_id=102385.0))
lhcb1.new("mcd.17r2.b1", "mcd", at="723.1052+(130-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250117.0, assembly_id=102385.0))
lhcb1.new("mb.b17r2.b1", "mb", at="730.5897+(129.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824454.0, assembly_id=102385.0))
lhcb1.new("mcs.b17r2.b1", "mcs", at="738.0137+(129-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243033.0, assembly_id=102385.0))
lhcb1.new("mb.c17r2.b1", "mb", at="746.2497+(128.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824478.0, assembly_id=102386.0))
lhcb1.new("mcs.c17r2.b1", "mcs", at="753.6737+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243036.0, assembly_id=102386.0))
lhcb1.new("bpm.17r2.b1", "bpm", at="754.5527+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243038.0, assembly_id=102387.0))
lhcb1.new("mqt.17r2.b1", "mqt", at="755.3067+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307381.0, assembly_id=102387.0))
lhcb1.new("mq.17r2.b1", "mq", at="757.3147+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308372.0, assembly_id=102387.0))
lhcb1.new("ms.17r2.b1", "ms", at="759.2097+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250119.0, assembly_id=102387.0))
lhcb1.new("mcbv.17r2.b1", "mcbv", at="759.8027+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250121.0, assembly_id=102387.0))
lhcb1.new("mco.a18r2.b1", "mco", at="760.8937+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250124.0, assembly_id=102388.0))
lhcb1.new("mcd.a18r2.b1", "mcd", at="760.8952+(128-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250125.0, assembly_id=102388.0))
lhcb1.new("mb.a18r2.b1", "mb", at="768.3797+(127.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824502.0, assembly_id=102388.0))
lhcb1.new("mcs.a18r2.b1", "mcs", at="775.8037+(127-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243046.0, assembly_id=102388.0))
lhcb1.new("mb.b18r2.b1", "mb", at="784.0397+(126.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824526.0, assembly_id=102389.0))
lhcb1.new("mcs.b18r2.b1", "mcs", at="791.4637+(126-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243049.0, assembly_id=102389.0))
lhcb1.new("mco.b18r2.b1", "mco", at="792.2137+(126-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250128.0, assembly_id=102390.0))
lhcb1.new("mcd.b18r2.b1", "mcd", at="792.2152+(126-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250129.0, assembly_id=102390.0))
lhcb1.new("mb.c18r2.b1", "mb", at="799.6997+(125.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824550.0, assembly_id=102390.0))
lhcb1.new("mcs.c18r2.b1", "mcs", at="807.1237+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243054.0, assembly_id=102390.0))
lhcb1.new("bpm.18r2.b1", "bpm", at="808.0027+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243056.0, assembly_id=102391.0))
lhcb1.new("mqt.18r2.b1", "mqt", at="808.7567+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307413.0, assembly_id=102391.0))
lhcb1.new("mq.18r2.b1", "mq", at="810.7647+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308402.0, assembly_id=102391.0))
lhcb1.new("ms.18r2.b1", "ms", at="812.6597+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250131.0, assembly_id=102391.0))
lhcb1.new("mcbh.18r2.b1", "mcbh", at="813.2527+(125-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250133.0, assembly_id=102391.0))
lhcb1.new("mb.a19r2.b1", "mb", at="821.8297+(124.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824574.0, assembly_id=102392.0))
lhcb1.new("mcs.a19r2.b1", "mcs", at="829.2537+(124-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243062.0, assembly_id=102392.0))
lhcb1.new("mco.19r2.b1", "mco", at="830.0037+(124-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250136.0, assembly_id=102393.0))
lhcb1.new("mcd.19r2.b1", "mcd", at="830.0052+(124-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250137.0, assembly_id=102393.0))
lhcb1.new("mb.b19r2.b1", "mb", at="837.4897+(123.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824598.0, assembly_id=102393.0))
lhcb1.new("mcs.b19r2.b1", "mcs", at="844.9137+(123-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243067.0, assembly_id=102393.0))
lhcb1.new("mb.c19r2.b1", "mb", at="853.1497+(122.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824622.0, assembly_id=102394.0))
lhcb1.new("mcs.c19r2.b1", "mcs", at="860.5737+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243070.0, assembly_id=102394.0))
lhcb1.new("bpm.19r2.b1", "bpm", at="861.4527+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243072.0, assembly_id=102395.0))
lhcb1.new("mqt.19r2.b1", "mqt", at="862.2067+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307444.0, assembly_id=102395.0))
lhcb1.new("mq.19r2.b1", "mq", at="864.2147+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308434.0, assembly_id=102395.0))
lhcb1.new("ms.19r2.b1", "ms", at="866.1097+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250139.0, assembly_id=102395.0))
lhcb1.new("mcbv.19r2.b1", "mcbv", at="866.7027+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250141.0, assembly_id=102395.0))
lhcb1.new("mco.a20r2.b1", "mco", at="867.7937+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250144.0, assembly_id=102396.0))
lhcb1.new("mcd.a20r2.b1", "mcd", at="867.7952+(122-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250145.0, assembly_id=102396.0))
lhcb1.new("mb.a20r2.b1", "mb", at="875.2797+(121.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824646.0, assembly_id=102396.0))
lhcb1.new("mcs.a20r2.b1", "mcs", at="882.7037+(121-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243080.0, assembly_id=102396.0))
lhcb1.new("mb.b20r2.b1", "mb", at="890.9397+(120.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824670.0, assembly_id=102397.0))
lhcb1.new("mcs.b20r2.b1", "mcs", at="898.3637+(120-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243083.0, assembly_id=102397.0))
lhcb1.new("mco.b20r2.b1", "mco", at="899.1137+(120-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250148.0, assembly_id=102398.0))
lhcb1.new("mcd.b20r2.b1", "mcd", at="899.1152+(120-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250149.0, assembly_id=102398.0))
lhcb1.new("mb.c20r2.b1", "mb", at="906.5997+(119.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824694.0, assembly_id=102398.0))
lhcb1.new("mcs.c20r2.b1", "mcs", at="914.0237+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243088.0, assembly_id=102398.0))
lhcb1.new("bpm.20r2.b1", "bpm", at="914.9027+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243090.0, assembly_id=102399.0))
lhcb1.new("mqt.20r2.b1", "mqt", at="915.6567+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307473.0, assembly_id=102399.0))
lhcb1.new("mq.20r2.b1", "mq", at="917.6647+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308225.0, assembly_id=102399.0))
lhcb1.new("ms.20r2.b1", "ms", at="919.5597+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250151.0, assembly_id=102399.0))
lhcb1.new("mcbh.20r2.b1", "mcbh", at="920.1527+(119-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250153.0, assembly_id=102399.0))
lhcb1.new("mb.a21r2.b1", "mb", at="928.7297+(118.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824718.0, assembly_id=102400.0))
lhcb1.new("mcs.a21r2.b1", "mcs", at="936.1537+(118-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243096.0, assembly_id=102400.0))
lhcb1.new("mco.21r2.b1", "mco", at="936.9037+(118-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250156.0, assembly_id=102401.0))
lhcb1.new("mcd.21r2.b1", "mcd", at="936.9052+(118-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250157.0, assembly_id=102401.0))
lhcb1.new("mb.b21r2.b1", "mb", at="944.3897+(117.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824742.0, assembly_id=102401.0))
lhcb1.new("mcs.b21r2.b1", "mcs", at="951.8137+(117-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243101.0, assembly_id=102401.0))
lhcb1.new("mb.c21r2.b1", "mb", at="960.0497+(116.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824766.0, assembly_id=102402.0))
lhcb1.new("mcs.c21r2.b1", "mcs", at="967.4737+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243104.0, assembly_id=102402.0))
lhcb1.new("bpm.21r2.b1", "bpm", at="968.3527+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243106.0, assembly_id=102403.0))
lhcb1.new("mqt.21r2.b1", "mqt", at="969.1067+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307271.0, assembly_id=102403.0))
lhcb1.new("mq.21r2.b1", "mq", at="971.1147+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308255.0, assembly_id=102403.0))
lhcb1.new("ms.21r2.b1", "ms", at="973.0097+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250159.0, assembly_id=102403.0))
lhcb1.new("mcbv.21r2.b1", "mcbv", at="973.6027+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250161.0, assembly_id=102403.0))
lhcb1.new("mco.a22r2.b1", "mco", at="974.6937+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250164.0, assembly_id=102404.0))
lhcb1.new("mcd.a22r2.b1", "mcd", at="974.6952+(116-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250165.0, assembly_id=102404.0))
lhcb1.new("mb.a22r2.b1", "mb", at="982.1797+(115.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824790.0, assembly_id=102404.0))
lhcb1.new("mcs.a22r2.b1", "mcs", at="989.6037+(115-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243114.0, assembly_id=102404.0))
lhcb1.new("mb.b22r2.b1", "mb", at="997.8397+(114.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824814.0, assembly_id=102405.0))
lhcb1.new("mcs.b22r2.b1", "mcs", at="1005.2637+(114-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243117.0, assembly_id=102405.0))
lhcb1.new("mco.b22r2.b1", "mco", at="1006.0137+(114-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250168.0, assembly_id=102406.0))
lhcb1.new("mcd.b22r2.b1", "mcd", at="1006.0152+(114-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250169.0, assembly_id=102406.0))
lhcb1.new("mb.c22r2.b1", "mb", at="1013.4997+(113.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824838.0, assembly_id=102406.0))
lhcb1.new("mcs.c22r2.b1", "mcs", at="1020.9237+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243122.0, assembly_id=102406.0))
lhcb1.new("bpm.22r2.b1", "bpm", at="1021.8027+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243124.0, assembly_id=102407.0))
lhcb1.new("mo.22r2.b1", "mo", at="1022.5537+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308815.0, assembly_id=102407.0))
lhcb1.new("mq.22r2.b1", "mq", at="1024.5647+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308287.0, assembly_id=102407.0))
lhcb1.new("ms.22r2.b1", "ms", at="1026.4597+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250171.0, assembly_id=102407.0))
lhcb1.new("mcbh.22r2.b1", "mcbh", at="1027.0527+(113-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250173.0, assembly_id=102407.0))
lhcb1.new("mb.a23r2.b1", "mb", at="1035.6297+(112.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824862.0, assembly_id=102408.0))
lhcb1.new("mcs.a23r2.b1", "mcs", at="1043.0537+(112-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243130.0, assembly_id=102408.0))
lhcb1.new("mco.23r2.b1", "mco", at="1043.8037+(112-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250176.0, assembly_id=102409.0))
lhcb1.new("mcd.23r2.b1", "mcd", at="1043.8052+(112-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250177.0, assembly_id=102409.0))
lhcb1.new("mb.b23r2.b1", "mb", at="1051.2897+(111.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824886.0, assembly_id=102409.0))
lhcb1.new("mcs.b23r2.b1", "mcs", at="1058.7137+(111-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243135.0, assembly_id=102409.0))
lhcb1.new("mb.c23r2.b1", "mb", at="1066.9497+(110.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824910.0, assembly_id=102410.0))
lhcb1.new("mcs.c23r2.b1", "mcs", at="1074.3737+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243138.0, assembly_id=102410.0))
lhcb1.new("bpm.23r2.b1", "bpm", at="1075.2527+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=266501.0, assembly_id=102411.0))
lhcb1.new("mqs.23r2.b1", "mqs", at="1076.0067+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307638.0, assembly_id=102411.0))
lhcb1.new("mq.23r2.b1", "mq", at="1078.0147+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308318.0, assembly_id=102411.0))
lhcb1.new("ms.23r2.b1", "ms", at="1079.9097+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250179.0, assembly_id=102411.0))
lhcb1.new("mcbv.23r2.b1", "mcbv", at="1080.5027+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250181.0, assembly_id=102411.0))
lhcb1.new("mco.a24r2.b1", "mco", at="1081.5937+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250184.0, assembly_id=102412.0))
lhcb1.new("mcd.a24r2.b1", "mcd", at="1081.5952+(110-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250185.0, assembly_id=102412.0))
lhcb1.new("mb.a24r2.b1", "mb", at="1089.0797+(109.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824934.0, assembly_id=102412.0))
lhcb1.new("mcs.a24r2.b1", "mcs", at="1096.5037+(109-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243146.0, assembly_id=102412.0))
lhcb1.new("mb.b24r2.b1", "mb", at="1104.7397+(108.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824958.0, assembly_id=102413.0))
lhcb1.new("mcs.b24r2.b1", "mcs", at="1112.1637+(108-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243149.0, assembly_id=102413.0))
lhcb1.new("mco.b24r2.b1", "mco", at="1112.9137+(108-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250188.0, assembly_id=102414.0))
lhcb1.new("mcd.b24r2.b1", "mcd", at="1112.9152+(108-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250189.0, assembly_id=102414.0))
lhcb1.new("mb.c24r2.b1", "mb", at="1120.3997+(107.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52824982.0, assembly_id=102414.0))
lhcb1.new("mcs.c24r2.b1", "mcs", at="1127.8237+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243154.0, assembly_id=102414.0))
lhcb1.new("bpm.24r2.b1", "bpm", at="1128.7027+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243156.0, assembly_id=102415.0))
lhcb1.new("mo.24r2.b1", "mo", at="1129.4537+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308845.0, assembly_id=102415.0))
lhcb1.new("mq.24r2.b1", "mq", at="1131.4647+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308108.0, assembly_id=102415.0))
lhcb1.new("ms.24r2.b1", "ms", at="1133.3597+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250191.0, assembly_id=102415.0))
lhcb1.new("mcbh.24r2.b1", "mcbh", at="1133.9527+(107-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250193.0, assembly_id=102415.0))
lhcb1.new("mb.a25r2.b1", "mb", at="1142.5297+(106.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825006.0, assembly_id=102416.0))
lhcb1.new("mcs.a25r2.b1", "mcs", at="1149.9537+(106-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243162.0, assembly_id=102416.0))
lhcb1.new("mco.25r2.b1", "mco", at="1150.7037+(106-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250196.0, assembly_id=102417.0))
lhcb1.new("mcd.25r2.b1", "mcd", at="1150.7052+(106-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250197.0, assembly_id=102417.0))
lhcb1.new("mb.b25r2.b1", "mb", at="1158.1897+(105.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825030.0, assembly_id=102417.0))
lhcb1.new("mcs.b25r2.b1", "mcs", at="1165.6137+(105-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243167.0, assembly_id=102417.0))
lhcb1.new("mb.c25r2.b1", "mb", at="1173.8497+(104.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825054.0, assembly_id=102418.0))
lhcb1.new("mcs.c25r2.b1", "mcs", at="1181.2737+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243170.0, assembly_id=102418.0))
lhcb1.new("bpm.25r2.b1", "bpm", at="1182.1527+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243172.0, assembly_id=102419.0))
lhcb1.new("mo.25r2.b1", "mo", at="1182.9037+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308877.0, assembly_id=102419.0))
lhcb1.new("mq.25r2.b1", "mq", at="1184.9147+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308140.0, assembly_id=102419.0))
lhcb1.new("ms.25r2.b1", "ms", at="1186.8097+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250199.0, assembly_id=102419.0))
lhcb1.new("mcbv.25r2.b1", "mcbv", at="1187.4027+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250201.0, assembly_id=102419.0))
lhcb1.new("mco.a26r2.b1", "mco", at="1188.4937+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250204.0, assembly_id=102420.0))
lhcb1.new("mcd.a26r2.b1", "mcd", at="1188.4952+(104-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250205.0, assembly_id=102420.0))
lhcb1.new("mb.a26r2.b1", "mb", at="1195.9797+(103.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825078.0, assembly_id=102420.0))
lhcb1.new("mcs.a26r2.b1", "mcs", at="1203.4037+(103-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243180.0, assembly_id=102420.0))
lhcb1.new("mb.b26r2.b1", "mb", at="1211.6397+(102.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825102.0, assembly_id=102421.0))
lhcb1.new("mcs.b26r2.b1", "mcs", at="1219.0637+(102-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243183.0, assembly_id=102421.0))
lhcb1.new("mco.b26r2.b1", "mco", at="1219.8137+(102-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250208.0, assembly_id=102422.0))
lhcb1.new("mcd.b26r2.b1", "mcd", at="1219.8152+(102-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250209.0, assembly_id=102422.0))
lhcb1.new("mb.c26r2.b1", "mb", at="1227.2997+(101.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825126.0, assembly_id=102422.0))
lhcb1.new("mcs.c26r2.b1", "mcs", at="1234.7237+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243188.0, assembly_id=102422.0))
lhcb1.new("bpm.26r2.b1", "bpm", at="1235.6027+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243190.0, assembly_id=102423.0))
lhcb1.new("mo.26r2.b1", "mo", at="1236.3537+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308909.0, assembly_id=102423.0))
lhcb1.new("mq.26r2.b1", "mq", at="1238.3647+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308171.0, assembly_id=102423.0))
lhcb1.new("ms.26r2.b1", "ms", at="1240.2597+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250211.0, assembly_id=102423.0))
lhcb1.new("mcbh.26r2.b1", "mcbh", at="1240.8527+(101-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250213.0, assembly_id=102423.0))
lhcb1.new("mb.a27r2.b1", "mb", at="1249.4297+(100.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825150.0, assembly_id=102424.0))
lhcb1.new("mcs.a27r2.b1", "mcs", at="1256.8537+(100-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243196.0, assembly_id=102424.0))
lhcb1.new("mco.27r2.b1", "mco", at="1257.6037+(100-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250216.0, assembly_id=102425.0))
lhcb1.new("mcd.27r2.b1", "mcd", at="1257.6052+(100-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250217.0, assembly_id=102425.0))
lhcb1.new("mb.b27r2.b1", "mb", at="1265.0897+(99.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825174.0, assembly_id=102425.0))
lhcb1.new("mcs.b27r2.b1", "mcs", at="1272.5137+(99-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243201.0, assembly_id=102425.0))
lhcb1.new("mb.c27r2.b1", "mb", at="1280.7497+(98.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825198.0, assembly_id=102426.0))
lhcb1.new("mcs.c27r2.b1", "mcs", at="1288.1737+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243204.0, assembly_id=102426.0))
lhcb1.new("bpm.27r2.b1", "bpm", at="1289.0527+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=266503.0, assembly_id=102427.0))
lhcb1.new("mqs.27r2.b1", "mqs", at="1289.8067+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307669.0, assembly_id=102427.0))
lhcb1.new("mq.27r2.b1", "mq", at="1291.8147+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308201.0, assembly_id=102427.0))
lhcb1.new("ms.27r2.b1", "ms", at="1293.7097+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250219.0, assembly_id=102427.0))
lhcb1.new("mcbv.27r2.b1", "mcbv", at="1294.3027+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250221.0, assembly_id=102427.0))
lhcb1.new("mco.a28r2.b1", "mco", at="1295.3937+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250224.0, assembly_id=102428.0))
lhcb1.new("mcd.a28r2.b1", "mcd", at="1295.3952+(98-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250225.0, assembly_id=102428.0))
lhcb1.new("mb.a28r2.b1", "mb", at="1302.8797+(97.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825222.0, assembly_id=102428.0))
lhcb1.new("mcs.a28r2.b1", "mcs", at="1310.3037+(97-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243212.0, assembly_id=102428.0))
lhcb1.new("mb.b28r2.b1", "mb", at="1318.5397+(96.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825246.0, assembly_id=102429.0))
lhcb1.new("mcs.b28r2.b1", "mcs", at="1325.9637+(96-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243215.0, assembly_id=102429.0))
lhcb1.new("mco.b28r2.b1", "mco", at="1326.7137+(96-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250228.0, assembly_id=102430.0))
lhcb1.new("mcd.b28r2.b1", "mcd", at="1326.7152+(96-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250229.0, assembly_id=102430.0))
lhcb1.new("mb.c28r2.b1", "mb", at="1334.1997+(95.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825270.0, assembly_id=102430.0))
lhcb1.new("mcs.c28r2.b1", "mcs", at="1341.6237+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243220.0, assembly_id=102430.0))
lhcb1.new("bpm.28r2.b1", "bpm", at="1342.5027+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243222.0, assembly_id=102431.0))
lhcb1.new("mo.28r2.b1", "mo", at="1343.2537+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308698.0, assembly_id=102431.0))
lhcb1.new("mq.28r2.b1", "mq", at="1345.2647+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307992.0, assembly_id=102431.0))
lhcb1.new("ms.28r2.b1", "ms", at="1347.1597+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250231.0, assembly_id=102431.0))
lhcb1.new("mcbh.28r2.b1", "mcbh", at="1347.7527+(95-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250233.0, assembly_id=102431.0))
lhcb1.new("mb.a29r2.b1", "mb", at="1356.3297+(94.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825294.0, assembly_id=102432.0))
lhcb1.new("mcs.a29r2.b1", "mcs", at="1363.7537+(94-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243228.0, assembly_id=102432.0))
lhcb1.new("mco.29r2.b1", "mco", at="1364.5037+(94-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250236.0, assembly_id=102433.0))
lhcb1.new("mcd.29r2.b1", "mcd", at="1364.5052+(94-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250237.0, assembly_id=102433.0))
lhcb1.new("mb.b29r2.b1", "mb", at="1371.9897+(93.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825318.0, assembly_id=102433.0))
lhcb1.new("mcs.b29r2.b1", "mcs", at="1379.4137+(93-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243233.0, assembly_id=102433.0))
lhcb1.new("mb.c29r2.b1", "mb", at="1387.6497+(92.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825342.0, assembly_id=102434.0))
lhcb1.new("mcs.c29r2.b1", "mcs", at="1395.0737+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243236.0, assembly_id=102434.0))
lhcb1.new("bpm.29r2.b1", "bpm", at="1395.9527+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243238.0, assembly_id=102435.0))
lhcb1.new("mo.29r2.b1", "mo", at="1396.7037+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308730.0, assembly_id=102435.0))
lhcb1.new("mq.29r2.b1", "mq", at="1398.7147+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308023.0, assembly_id=102435.0))
lhcb1.new("ms.29r2.b1", "ms", at="1400.6097+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250239.0, assembly_id=102435.0))
lhcb1.new("mcbv.29r2.b1", "mcbv", at="1401.2027+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250241.0, assembly_id=102435.0))
lhcb1.new("mco.a30r2.b1", "mco", at="1402.2937+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250244.0, assembly_id=102436.0))
lhcb1.new("mcd.a30r2.b1", "mcd", at="1402.2952+(92-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250245.0, assembly_id=102436.0))
lhcb1.new("mb.a30r2.b1", "mb", at="1409.7797+(91.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825366.0, assembly_id=102436.0))
lhcb1.new("mcs.a30r2.b1", "mcs", at="1417.2037+(91-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243246.0, assembly_id=102436.0))
lhcb1.new("mb.b30r2.b1", "mb", at="1425.4397+(90.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825390.0, assembly_id=102437.0))
lhcb1.new("mcs.b30r2.b1", "mcs", at="1432.8637+(90-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243249.0, assembly_id=102437.0))
lhcb1.new("mco.b30r2.b1", "mco", at="1433.6137+(90-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250248.0, assembly_id=102438.0))
lhcb1.new("mcd.b30r2.b1", "mcd", at="1433.6152+(90-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250249.0, assembly_id=102438.0))
lhcb1.new("mb.c30r2.b1", "mb", at="1441.0997+(89.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825414.0, assembly_id=102438.0))
lhcb1.new("mcs.c30r2.b1", "mcs", at="1448.5237+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243254.0, assembly_id=102438.0))
lhcb1.new("bpm.30r2.b1", "bpm", at="1449.4027+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243256.0, assembly_id=102439.0))
lhcb1.new("mo.30r2.b1", "mo", at="1450.1537+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308761.0, assembly_id=102439.0))
lhcb1.new("mq.30r2.b1", "mq", at="1452.1647+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308053.0, assembly_id=102439.0))
lhcb1.new("mss.30r2.b1", "mss", at="1454.0597+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250251.0, assembly_id=102439.0))
lhcb1.new("mcbh.30r2.b1", "mcbh", at="1454.6527+(89-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250253.0, assembly_id=102439.0))
lhcb1.new("mb.a31r2.b1", "mb", at="1463.2297+(88.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825438.0, assembly_id=102440.0))
lhcb1.new("mcs.a31r2.b1", "mcs", at="1470.6537+(88-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243262.0, assembly_id=102440.0))
lhcb1.new("mco.31r2.b1", "mco", at="1471.4037+(88-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250256.0, assembly_id=102441.0))
lhcb1.new("mcd.31r2.b1", "mcd", at="1471.4052+(88-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250257.0, assembly_id=102441.0))
lhcb1.new("mb.b31r2.b1", "mb", at="1478.8897+(87.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825462.0, assembly_id=102441.0))
lhcb1.new("mcs.b31r2.b1", "mcs", at="1486.3137+(87-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243267.0, assembly_id=102441.0))
lhcb1.new("mb.c31r2.b1", "mb", at="1494.5497+(86.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825486.0, assembly_id=102442.0))
lhcb1.new("mcs.c31r2.b1", "mcs", at="1501.9737+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243270.0, assembly_id=102442.0))
lhcb1.new("bpm.31r2.b1", "bpm", at="1502.8527+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243272.0, assembly_id=102443.0))
lhcb1.new("mo.31r2.b1", "mo", at="1503.6037+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308791.0, assembly_id=102443.0))
lhcb1.new("mq.31r2.b1", "mq", at="1505.6147+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308083.0, assembly_id=102443.0))
lhcb1.new("ms.31r2.b1", "ms", at="1507.5097+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250259.0, assembly_id=102443.0))
lhcb1.new("mcbv.31r2.b1", "mcbv", at="1508.1027+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250261.0, assembly_id=102443.0))
lhcb1.new("s.cell.23.b1", "omk", at="1508.8497+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a32r2.b1", "mco", at="1509.1937+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250264.0, assembly_id=102444.0))
lhcb1.new("mcd.a32r2.b1", "mcd", at="1509.1952+(86-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250265.0, assembly_id=102444.0))
lhcb1.new("mb.a32r2.b1", "mb", at="1516.6797+(85.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825510.0, assembly_id=102444.0))
lhcb1.new("mcs.a32r2.b1", "mcs", at="1524.1037+(85-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243280.0, assembly_id=102444.0))
lhcb1.new("mb.b32r2.b1", "mb", at="1532.3397+(84.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825534.0, assembly_id=102445.0))
lhcb1.new("mcs.b32r2.b1", "mcs", at="1539.7637+(84-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243283.0, assembly_id=102445.0))
lhcb1.new("mco.b32r2.b1", "mco", at="1540.5137+(84-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250268.0, assembly_id=102446.0))
lhcb1.new("mcd.b32r2.b1", "mcd", at="1540.5152+(84-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250269.0, assembly_id=102446.0))
lhcb1.new("mb.c32r2.b1", "mb", at="1547.9997+(83.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825558.0, assembly_id=102446.0))
lhcb1.new("mcs.c32r2.b1", "mcs", at="1555.4237+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243288.0, assembly_id=102446.0))
lhcb1.new("bpm.32r2.b1", "bpm", at="1556.3027+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243290.0, assembly_id=102447.0))
lhcb1.new("mo.32r2.b1", "mo", at="1557.0537+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308583.0, assembly_id=102447.0))
lhcb1.new("mq.32r2.b1", "mq", at="1559.0647+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2348458.0, assembly_id=102447.0))
lhcb1.new("ms.32r2.b1", "ms", at="1560.9597+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250271.0, assembly_id=102447.0))
lhcb1.new("mcbh.32r2.b1", "mcbh", at="1561.5527+(83-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250273.0, assembly_id=102447.0))
lhcb1.new("mb.a33r2.b1", "mb", at="1570.1297+(82.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825582.0, assembly_id=102448.0))
lhcb1.new("mcs.a33r2.b1", "mcs", at="1577.5537+(82-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243296.0, assembly_id=102448.0))
lhcb1.new("mco.33r2.b1", "mco", at="1578.3037+(82-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250276.0, assembly_id=102449.0))
lhcb1.new("mcd.33r2.b1", "mcd", at="1578.3052+(82-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250277.0, assembly_id=102449.0))
lhcb1.new("mb.b33r2.b1", "mb", at="1585.7897+(81.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825606.0, assembly_id=102449.0))
lhcb1.new("mcs.b33r2.b1", "mcs", at="1593.2137+(81-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243301.0, assembly_id=102449.0))
lhcb1.new("mb.c33r2.b1", "mb", at="1601.4497+(80.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825630.0, assembly_id=102450.0))
lhcb1.new("mcs.c33r2.b1", "mcs", at="1608.8737+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243304.0, assembly_id=102450.0))
lhcb1.new("bpm.33r2.b1", "bpm", at="1609.7527+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243306.0, assembly_id=102451.0))
lhcb1.new("mo.33r2.b1", "mo", at="1610.5037+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308614.0, assembly_id=102451.0))
lhcb1.new("mq.33r2.b1", "mq", at="1612.5147+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307904.0, assembly_id=102451.0))
lhcb1.new("ms.33r2.b1", "ms", at="1614.4097+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250279.0, assembly_id=102451.0))
lhcb1.new("mcbv.33r2.b1", "mcbv", at="1615.0027+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250281.0, assembly_id=102451.0))
lhcb1.new("e.cell.23.b1", "omk", at="1615.7497+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a34r2.b1", "mco", at="1616.0937+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250284.0, assembly_id=102452.0))
lhcb1.new("mcd.a34r2.b1", "mcd", at="1616.0952+(80-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250285.0, assembly_id=102452.0))
lhcb1.new("mb.a34r2.b1", "mb", at="1623.5797+(79.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825654.0, assembly_id=102452.0))
lhcb1.new("mcs.a34r2.b1", "mcs", at="1631.0037+(79-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243314.0, assembly_id=102452.0))
lhcb1.new("mb.b34r2.b1", "mb", at="1639.2397+(78.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825678.0, assembly_id=102453.0))
lhcb1.new("mcs.b34r2.b1", "mcs", at="1646.6637+(78-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243317.0, assembly_id=102453.0))
lhcb1.new("mco.b34r2.b1", "mco", at="1647.4137+(78-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250288.0, assembly_id=102454.0))
lhcb1.new("mcd.b34r2.b1", "mcd", at="1647.4152+(78-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=250289.0, assembly_id=102454.0))
lhcb1.new("mb.c34r2.b1", "mb", at="1654.8997+(77.5-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52825702.0, assembly_id=102454.0))
lhcb1.new("mcs.c34r2.b1", "mcs", at="1662.3237+(77-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243322.0, assembly_id=102454.0))
lhcb1.new("bpm.34r2.b1", "bpm", at="1663.2027+(77-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=243324.0, assembly_id=102455.0))
lhcb1.new("mo.34r2.b1", "mo", at="1663.9537+(77-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308629.0, assembly_id=102455.0))
lhcb1.new("mq.34r2.b1", "mq", at="1665.9647+(77-ip2ofs.b1)*ds", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307919.0, assembly_id=102455.0))
lhcb1.new("mss.34l3.b1", "mss", at="-1664.5007+(77-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250291.0, assembly_id=102455.0))
lhcb1.new("mcbh.34l3.b1", "mcbh", at="-1663.9077+(77-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250293.0, assembly_id=102455.0))
lhcb1.new("mb.c34l3.b1", "mb", at="-1655.3307+(76.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825726.0, assembly_id=102456.0))
lhcb1.new("mcs.c34l3.b1", "mcs", at="-1647.9067+(76-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243330.0, assembly_id=102456.0))
lhcb1.new("mco.34l3.b1", "mco", at="-1647.1567+(76-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250296.0, assembly_id=102457.0))
lhcb1.new("mcd.34l3.b1", "mcd", at="-1647.1552+(76-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250297.0, assembly_id=102457.0))
lhcb1.new("mb.b34l3.b1", "mb", at="-1639.6707+(75.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825750.0, assembly_id=102457.0))
lhcb1.new("mcs.b34l3.b1", "mcs", at="-1632.2467+(75-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243335.0, assembly_id=102457.0))
lhcb1.new("mb.a34l3.b1", "mb", at="-1624.0107+(74.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825774.0, assembly_id=102458.0))
lhcb1.new("mcs.a34l3.b1", "mcs", at="-1616.5867+(74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243338.0, assembly_id=102458.0))
lhcb1.new("bpm.33l3.b1", "bpm", at="-1615.7077+(74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243340.0, assembly_id=102459.0))
lhcb1.new("mo.33l3.b1", "mo", at="-1614.9567+(74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308601.0, assembly_id=102459.0))
lhcb1.new("mq.33l3.b1", "mq", at="-1612.9457+(74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307891.0, assembly_id=102459.0))
lhcb1.new("ms.33l3.b1", "ms", at="-1611.0507+(74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250299.0, assembly_id=102459.0))
lhcb1.new("mcbv.33l3.b1", "mcbv", at="-1610.4577+(74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250301.0, assembly_id=102459.0))
lhcb1.new("mco.b33l3.b1", "mco", at="-1609.3667+(74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250304.0, assembly_id=102460.0))
lhcb1.new("mcd.b33l3.b1", "mcd", at="-1609.3652+(74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250305.0, assembly_id=102460.0))
lhcb1.new("mb.c33l3.b1", "mb", at="-1601.8807+(73.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825798.0, assembly_id=102460.0))
lhcb1.new("mcs.c33l3.b1", "mcs", at="-1594.4567+(73-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243348.0, assembly_id=102460.0))
lhcb1.new("mb.b33l3.b1", "mb", at="-1586.2207+(72.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825822.0, assembly_id=102461.0))
lhcb1.new("mcs.b33l3.b1", "mcs", at="-1578.7967+(72-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243351.0, assembly_id=102461.0))
lhcb1.new("mco.a33l3.b1", "mco", at="-1578.0467+(72-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250308.0, assembly_id=102462.0))
lhcb1.new("mcd.a33l3.b1", "mcd", at="-1578.0452+(72-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250309.0, assembly_id=102462.0))
lhcb1.new("mb.a33l3.b1", "mb", at="-1570.5607+(71.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825846.0, assembly_id=102462.0))
lhcb1.new("mcs.a33l3.b1", "mcs", at="-1563.1367+(71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243356.0, assembly_id=102462.0))
lhcb1.new("bpm.32l3.b1", "bpm", at="-1562.2577+(71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243358.0, assembly_id=102463.0))
lhcb1.new("mo.32l3.b1", "mo", at="-1561.5067+(71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308569.0, assembly_id=102463.0))
lhcb1.new("mq.32l3.b1", "mq", at="-1559.4957+(71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2348457.0, assembly_id=102463.0))
lhcb1.new("mss.32l3.b1", "mss", at="-1557.6007+(71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250311.0, assembly_id=102463.0))
lhcb1.new("mcbh.32l3.b1", "mcbh", at="-1557.0077+(71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250313.0, assembly_id=102463.0))
lhcb1.new("mb.c32l3.b1", "mb", at="-1548.4307+(70.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825870.0, assembly_id=102464.0))
lhcb1.new("mcs.c32l3.b1", "mcs", at="-1541.0067+(70-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243364.0, assembly_id=102464.0))
lhcb1.new("mco.32l3.b1", "mco", at="-1540.2567+(70-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250316.0, assembly_id=102465.0))
lhcb1.new("mcd.32l3.b1", "mcd", at="-1540.2552+(70-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250317.0, assembly_id=102465.0))
lhcb1.new("mb.b32l3.b1", "mb", at="-1532.7707+(69.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825894.0, assembly_id=102465.0))
lhcb1.new("mcs.b32l3.b1", "mcs", at="-1525.3467+(69-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243369.0, assembly_id=102465.0))
lhcb1.new("mb.a32l3.b1", "mb", at="-1517.1107+(68.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825918.0, assembly_id=102466.0))
lhcb1.new("mcs.a32l3.b1", "mcs", at="-1509.6867+(68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243372.0, assembly_id=102466.0))
lhcb1.new("bpm.31l3.b1", "bpm", at="-1508.8077+(68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243374.0, assembly_id=102467.0))
lhcb1.new("mo.31l3.b1", "mo", at="-1508.0567+(68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308778.0, assembly_id=102467.0))
lhcb1.new("mq.31l3.b1", "mq", at="-1506.0457+(68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308070.0, assembly_id=102467.0))
lhcb1.new("ms.31l3.b1", "ms", at="-1504.1507+(68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250319.0, assembly_id=102467.0))
lhcb1.new("mcbv.31l3.b1", "mcbv", at="-1503.5577+(68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250321.0, assembly_id=102467.0))
lhcb1.new("mco.b31l3.b1", "mco", at="-1502.4667+(68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250324.0, assembly_id=102468.0))
lhcb1.new("mcd.b31l3.b1", "mcd", at="-1502.4652+(68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250325.0, assembly_id=102468.0))
lhcb1.new("mb.c31l3.b1", "mb", at="-1494.9807+(67.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825942.0, assembly_id=102468.0))
lhcb1.new("mcs.c31l3.b1", "mcs", at="-1487.5567+(67-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243382.0, assembly_id=102468.0))
lhcb1.new("mb.b31l3.b1", "mb", at="-1479.3207+(66.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825966.0, assembly_id=102469.0))
lhcb1.new("mcs.b31l3.b1", "mcs", at="-1471.8967+(66-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243385.0, assembly_id=102469.0))
lhcb1.new("mco.a31l3.b1", "mco", at="-1471.1467+(66-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250328.0, assembly_id=102470.0))
lhcb1.new("mcd.a31l3.b1", "mcd", at="-1471.1452+(66-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250329.0, assembly_id=102470.0))
lhcb1.new("mb.a31l3.b1", "mb", at="-1463.6607+(65.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52825990.0, assembly_id=102470.0))
lhcb1.new("mcs.a31l3.b1", "mcs", at="-1456.2367+(65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243390.0, assembly_id=102470.0))
lhcb1.new("bpm.30l3.b1", "bpm", at="-1455.3577+(65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243392.0, assembly_id=102471.0))
lhcb1.new("mo.30l3.b1", "mo", at="-1454.6067+(65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308748.0, assembly_id=102471.0))
lhcb1.new("mq.30l3.b1", "mq", at="-1452.5957+(65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308040.0, assembly_id=102471.0))
lhcb1.new("ms.30l3.b1", "ms", at="-1450.7007+(65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250331.0, assembly_id=102471.0))
lhcb1.new("mcbh.30l3.b1", "mcbh", at="-1450.1077+(65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250333.0, assembly_id=102471.0))
lhcb1.new("mb.c30l3.b1", "mb", at="-1441.5307+(64.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826014.0, assembly_id=102472.0))
lhcb1.new("mcs.c30l3.b1", "mcs", at="-1434.1067+(64-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243398.0, assembly_id=102472.0))
lhcb1.new("mco.30l3.b1", "mco", at="-1433.3567+(64-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250336.0, assembly_id=102473.0))
lhcb1.new("mcd.30l3.b1", "mcd", at="-1433.3552+(64-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250337.0, assembly_id=102473.0))
lhcb1.new("mb.b30l3.b1", "mb", at="-1425.8707+(63.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826038.0, assembly_id=102473.0))
lhcb1.new("mcs.b30l3.b1", "mcs", at="-1418.4467+(63-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243403.0, assembly_id=102473.0))
lhcb1.new("mb.a30l3.b1", "mb", at="-1410.2107+(62.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826062.0, assembly_id=102474.0))
lhcb1.new("mcs.a30l3.b1", "mcs", at="-1402.7867+(62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243406.0, assembly_id=102474.0))
lhcb1.new("bpm.29l3.b1", "bpm", at="-1401.9077+(62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243408.0, assembly_id=102475.0))
lhcb1.new("mo.29l3.b1", "mo", at="-1401.1567+(62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308716.0, assembly_id=102475.0))
lhcb1.new("mq.29l3.b1", "mq", at="-1399.1457+(62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308010.0, assembly_id=102475.0))
lhcb1.new("ms.29l3.b1", "ms", at="-1397.2507+(62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250339.0, assembly_id=102475.0))
lhcb1.new("mcbv.29l3.b1", "mcbv", at="-1396.6577+(62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250341.0, assembly_id=102475.0))
lhcb1.new("mco.b29l3.b1", "mco", at="-1395.5667+(62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250344.0, assembly_id=102476.0))
lhcb1.new("mcd.b29l3.b1", "mcd", at="-1395.5652+(62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250345.0, assembly_id=102476.0))
lhcb1.new("mb.c29l3.b1", "mb", at="-1388.0807+(61.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826086.0, assembly_id=102476.0))
lhcb1.new("mcs.c29l3.b1", "mcs", at="-1380.6567+(61-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243416.0, assembly_id=102476.0))
lhcb1.new("mb.b29l3.b1", "mb", at="-1372.4207+(60.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826110.0, assembly_id=102477.0))
lhcb1.new("mcs.b29l3.b1", "mcs", at="-1364.9967+(60-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243419.0, assembly_id=102477.0))
lhcb1.new("mco.a29l3.b1", "mco", at="-1364.2467+(60-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250348.0, assembly_id=102478.0))
lhcb1.new("mcd.a29l3.b1", "mcd", at="-1364.2452+(60-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250349.0, assembly_id=102478.0))
lhcb1.new("mb.a29l3.b1", "mb", at="-1356.7607+(59.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826134.0, assembly_id=102478.0))
lhcb1.new("mcs.a29l3.b1", "mcs", at="-1349.3367+(59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243424.0, assembly_id=102478.0))
lhcb1.new("bpm.28l3.b1", "bpm", at="-1348.4577+(59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243426.0, assembly_id=102479.0))
lhcb1.new("mo.28l3.b1", "mo", at="-1347.7067+(59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308685.0, assembly_id=102479.0))
lhcb1.new("mq.28l3.b1", "mq", at="-1345.6957+(59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307978.0, assembly_id=102479.0))
lhcb1.new("mss.28l3.b1", "mss", at="-1343.8007+(59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250351.0, assembly_id=102479.0))
lhcb1.new("mcbh.28l3.b1", "mcbh", at="-1343.2077+(59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250353.0, assembly_id=102479.0))
lhcb1.new("mb.c28l3.b1", "mb", at="-1334.6307+(58.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826158.0, assembly_id=102480.0))
lhcb1.new("mcs.c28l3.b1", "mcs", at="-1327.2067+(58-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243432.0, assembly_id=102480.0))
lhcb1.new("mco.28l3.b1", "mco", at="-1326.4567+(58-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250356.0, assembly_id=102481.0))
lhcb1.new("mcd.28l3.b1", "mcd", at="-1326.4552+(58-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250357.0, assembly_id=102481.0))
lhcb1.new("mb.b28l3.b1", "mb", at="-1318.9707+(57.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826182.0, assembly_id=102481.0))
lhcb1.new("mcs.b28l3.b1", "mcs", at="-1311.5467+(57-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243437.0, assembly_id=102481.0))
lhcb1.new("mb.a28l3.b1", "mb", at="-1303.3107+(56.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826206.0, assembly_id=102482.0))
lhcb1.new("mcs.a28l3.b1", "mcs", at="-1295.8867+(56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243440.0, assembly_id=102482.0))
lhcb1.new("bpm.27l3.b1", "bpm", at="-1295.0077+(56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=266505.0, assembly_id=102483.0))
lhcb1.new("mqs.27l3.b1", "mqs", at="-1294.2537+(56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307655.0, assembly_id=102483.0))
lhcb1.new("mq.27l3.b1", "mq", at="-1292.2457+(56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308188.0, assembly_id=102483.0))
lhcb1.new("ms.27l3.b1", "ms", at="-1290.3507+(56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250359.0, assembly_id=102483.0))
lhcb1.new("mcbv.27l3.b1", "mcbv", at="-1289.7577+(56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250361.0, assembly_id=102483.0))
lhcb1.new("mco.b27l3.b1", "mco", at="-1288.6667+(56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250364.0, assembly_id=102484.0))
lhcb1.new("mcd.b27l3.b1", "mcd", at="-1288.6652+(56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250365.0, assembly_id=102484.0))
lhcb1.new("mb.c27l3.b1", "mb", at="-1281.1807+(55.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826230.0, assembly_id=102484.0))
lhcb1.new("mcs.c27l3.b1", "mcs", at="-1273.7567+(55-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243448.0, assembly_id=102484.0))
lhcb1.new("mb.b27l3.b1", "mb", at="-1265.5207+(54.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826254.0, assembly_id=102485.0))
lhcb1.new("mcs.b27l3.b1", "mcs", at="-1258.0967+(54-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243451.0, assembly_id=102485.0))
lhcb1.new("mco.a27l3.b1", "mco", at="-1257.3467+(54-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250368.0, assembly_id=102486.0))
lhcb1.new("mcd.a27l3.b1", "mcd", at="-1257.3452+(54-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250369.0, assembly_id=102486.0))
lhcb1.new("mb.a27l3.b1", "mb", at="-1249.8607+(53.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826278.0, assembly_id=102486.0))
lhcb1.new("mcs.a27l3.b1", "mcs", at="-1242.4367+(53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243456.0, assembly_id=102486.0))
lhcb1.new("bpm.26l3.b1", "bpm", at="-1241.5577+(53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243458.0, assembly_id=102487.0))
lhcb1.new("mo.26l3.b1", "mo", at="-1240.8067+(53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308895.0, assembly_id=102487.0))
lhcb1.new("mq.26l3.b1", "mq", at="-1238.7957+(53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308158.0, assembly_id=102487.0))
lhcb1.new("ms.26l3.b1", "ms", at="-1236.9007+(53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250371.0, assembly_id=102487.0))
lhcb1.new("mcbh.26l3.b1", "mcbh", at="-1236.3077+(53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250373.0, assembly_id=102487.0))
lhcb1.new("mb.c26l3.b1", "mb", at="-1227.7307+(52.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826302.0, assembly_id=102488.0))
lhcb1.new("mcs.c26l3.b1", "mcs", at="-1220.3067+(52-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243464.0, assembly_id=102488.0))
lhcb1.new("mco.26l3.b1", "mco", at="-1219.5567+(52-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250376.0, assembly_id=102489.0))
lhcb1.new("mcd.26l3.b1", "mcd", at="-1219.5552+(52-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250377.0, assembly_id=102489.0))
lhcb1.new("mb.b26l3.b1", "mb", at="-1212.0707+(51.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826326.0, assembly_id=102489.0))
lhcb1.new("mcs.b26l3.b1", "mcs", at="-1204.6467+(51-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243469.0, assembly_id=102489.0))
lhcb1.new("mb.a26l3.b1", "mb", at="-1196.4107+(50.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826350.0, assembly_id=102490.0))
lhcb1.new("mcs.a26l3.b1", "mcs", at="-1188.9867+(50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243472.0, assembly_id=102490.0))
lhcb1.new("bpm.25l3.b1", "bpm", at="-1188.1077+(50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243474.0, assembly_id=102491.0))
lhcb1.new("mo.25l3.b1", "mo", at="-1187.3567+(50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308863.0, assembly_id=102491.0))
lhcb1.new("mq.25l3.b1", "mq", at="-1185.3457+(50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308126.0, assembly_id=102491.0))
lhcb1.new("ms.25l3.b1", "ms", at="-1183.4507+(50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250379.0, assembly_id=102491.0))
lhcb1.new("mcbv.25l3.b1", "mcbv", at="-1182.8577+(50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250381.0, assembly_id=102491.0))
lhcb1.new("mco.b25l3.b1", "mco", at="-1181.7667+(50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250384.0, assembly_id=102492.0))
lhcb1.new("mcd.b25l3.b1", "mcd", at="-1181.7652+(50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250385.0, assembly_id=102492.0))
lhcb1.new("mb.c25l3.b1", "mb", at="-1174.2807+(49.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826374.0, assembly_id=102492.0))
lhcb1.new("mcs.c25l3.b1", "mcs", at="-1166.8567+(49-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243482.0, assembly_id=102492.0))
lhcb1.new("mb.b25l3.b1", "mb", at="-1158.6207+(48.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826398.0, assembly_id=102493.0))
lhcb1.new("mcs.b25l3.b1", "mcs", at="-1151.1967+(48-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243485.0, assembly_id=102493.0))
lhcb1.new("mco.a25l3.b1", "mco", at="-1150.4467+(48-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250388.0, assembly_id=102494.0))
lhcb1.new("mcd.a25l3.b1", "mcd", at="-1150.4452+(48-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250389.0, assembly_id=102494.0))
lhcb1.new("mb.a25l3.b1", "mb", at="-1142.9607+(47.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826422.0, assembly_id=102494.0))
lhcb1.new("mcs.a25l3.b1", "mcs", at="-1135.5367+(47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243490.0, assembly_id=102494.0))
lhcb1.new("bpm.24l3.b1", "bpm", at="-1134.6577+(47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243492.0, assembly_id=102495.0))
lhcb1.new("mo.24l3.b1", "mo", at="-1133.9067+(47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308832.0, assembly_id=102495.0))
lhcb1.new("mq.24l3.b1", "mq", at="-1131.8957+(47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308094.0, assembly_id=102495.0))
lhcb1.new("ms.24l3.b1", "ms", at="-1130.0007+(47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250391.0, assembly_id=102495.0))
lhcb1.new("mcbh.24l3.b1", "mcbh", at="-1129.4077+(47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250393.0, assembly_id=102495.0))
lhcb1.new("mb.c24l3.b1", "mb", at="-1120.8307+(46.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826446.0, assembly_id=102496.0))
lhcb1.new("mcs.c24l3.b1", "mcs", at="-1113.4067+(46-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243498.0, assembly_id=102496.0))
lhcb1.new("mco.24l3.b1", "mco", at="-1112.6567+(46-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250396.0, assembly_id=102497.0))
lhcb1.new("mcd.24l3.b1", "mcd", at="-1112.6552+(46-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250397.0, assembly_id=102497.0))
lhcb1.new("mb.b24l3.b1", "mb", at="-1105.1707+(45.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826470.0, assembly_id=102497.0))
lhcb1.new("mcs.b24l3.b1", "mcs", at="-1097.7467+(45-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243503.0, assembly_id=102497.0))
lhcb1.new("mb.a24l3.b1", "mb", at="-1089.5107+(44.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826494.0, assembly_id=102498.0))
lhcb1.new("mcs.a24l3.b1", "mcs", at="-1082.0867+(44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243506.0, assembly_id=102498.0))
lhcb1.new("bpm.23l3.b1", "bpm", at="-1081.2077+(44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=266507.0, assembly_id=102499.0))
lhcb1.new("mqs.23l3.b1", "mqs", at="-1080.4537+(44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2348449.0, assembly_id=102499.0))
lhcb1.new("mq.23l3.b1", "mq", at="-1078.4457+(44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308305.0, assembly_id=102499.0))
lhcb1.new("ms.23l3.b1", "ms", at="-1076.5507+(44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250399.0, assembly_id=102499.0))
lhcb1.new("mcbv.23l3.b1", "mcbv", at="-1075.9577+(44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250401.0, assembly_id=102499.0))
lhcb1.new("mco.b23l3.b1", "mco", at="-1074.8667+(44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250404.0, assembly_id=102500.0))
lhcb1.new("mcd.b23l3.b1", "mcd", at="-1074.8652+(44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250405.0, assembly_id=102500.0))
lhcb1.new("mb.c23l3.b1", "mb", at="-1067.3807+(43.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826518.0, assembly_id=102500.0))
lhcb1.new("mcs.c23l3.b1", "mcs", at="-1059.9567+(43-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243514.0, assembly_id=102500.0))
lhcb1.new("mb.b23l3.b1", "mb", at="-1051.7207+(42.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826542.0, assembly_id=102501.0))
lhcb1.new("mcs.b23l3.b1", "mcs", at="-1044.2967+(42-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243517.0, assembly_id=102501.0))
lhcb1.new("mco.a23l3.b1", "mco", at="-1043.5467+(42-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250408.0, assembly_id=102502.0))
lhcb1.new("mcd.a23l3.b1", "mcd", at="-1043.5452+(42-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250409.0, assembly_id=102502.0))
lhcb1.new("mb.a23l3.b1", "mb", at="-1036.0607+(41.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826566.0, assembly_id=102502.0))
lhcb1.new("mcs.a23l3.b1", "mcs", at="-1028.6367+(41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243522.0, assembly_id=102502.0))
lhcb1.new("bpm.22l3.b1", "bpm", at="-1027.7577+(41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243524.0, assembly_id=102503.0))
lhcb1.new("mo.22l3.b1", "mo", at="-1027.0067+(41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2309039.0, assembly_id=102503.0))
lhcb1.new("mq.22l3.b1", "mq", at="-1024.9957+(41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308273.0, assembly_id=102503.0))
lhcb1.new("ms.22l3.b1", "ms", at="-1023.1007+(41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250411.0, assembly_id=102503.0))
lhcb1.new("mcbh.22l3.b1", "mcbh", at="-1022.5077+(41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250413.0, assembly_id=102503.0))
lhcb1.new("mb.c22l3.b1", "mb", at="-1013.9307+(40.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826590.0, assembly_id=102504.0))
lhcb1.new("mcs.c22l3.b1", "mcs", at="-1006.5067+(40-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243530.0, assembly_id=102504.0))
lhcb1.new("mco.22l3.b1", "mco", at="-1005.7567+(40-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250416.0, assembly_id=102505.0))
lhcb1.new("mcd.22l3.b1", "mcd", at="-1005.7552+(40-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250417.0, assembly_id=102505.0))
lhcb1.new("mb.b22l3.b1", "mb", at="-998.2707+(39.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826614.0, assembly_id=102505.0))
lhcb1.new("mcs.b22l3.b1", "mcs", at="-990.8467+(39-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243535.0, assembly_id=102505.0))
lhcb1.new("mb.a22l3.b1", "mb", at="-982.6107+(38.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826638.0, assembly_id=102506.0))
lhcb1.new("mcs.a22l3.b1", "mcs", at="-975.1867+(38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243538.0, assembly_id=102506.0))
lhcb1.new("bpm.21l3.b1", "bpm", at="-974.3077+(38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243540.0, assembly_id=102507.0))
lhcb1.new("mqt.21l3.b1", "mqt", at="-973.5537+(38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307490.0, assembly_id=102507.0))
lhcb1.new("mq.21l3.b1", "mq", at="-971.5457+(38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308242.0, assembly_id=102507.0))
lhcb1.new("ms.21l3.b1", "ms", at="-969.6507+(38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250419.0, assembly_id=102507.0))
lhcb1.new("mcbv.21l3.b1", "mcbv", at="-969.0577+(38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250421.0, assembly_id=102507.0))
lhcb1.new("mco.b21l3.b1", "mco", at="-967.9667+(38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250424.0, assembly_id=102508.0))
lhcb1.new("mcd.b21l3.b1", "mcd", at="-967.9652+(38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250425.0, assembly_id=102508.0))
lhcb1.new("mb.c21l3.b1", "mb", at="-960.4807+(37.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826662.0, assembly_id=102508.0))
lhcb1.new("mcs.c21l3.b1", "mcs", at="-953.0567+(37-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243548.0, assembly_id=102508.0))
lhcb1.new("mb.b21l3.b1", "mb", at="-944.8207+(36.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826686.0, assembly_id=102509.0))
lhcb1.new("mcs.b21l3.b1", "mcs", at="-937.3967+(36-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243551.0, assembly_id=102509.0))
lhcb1.new("mco.a21l3.b1", "mco", at="-936.6467+(36-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250428.0, assembly_id=102510.0))
lhcb1.new("mcd.a21l3.b1", "mcd", at="-936.6452+(36-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250429.0, assembly_id=102510.0))
lhcb1.new("mb.a21l3.b1", "mb", at="-929.1607+(35.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826710.0, assembly_id=102510.0))
lhcb1.new("mcs.a21l3.b1", "mcs", at="-921.7367+(35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243556.0, assembly_id=102510.0))
lhcb1.new("bpm.20l3.b1", "bpm", at="-920.8577+(35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243558.0, assembly_id=102511.0))
lhcb1.new("mqt.20l3.b1", "mqt", at="-920.1037+(35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307460.0, assembly_id=102511.0))
lhcb1.new("mq.20l3.b1", "mq", at="-918.0957+(35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308212.0, assembly_id=102511.0))
lhcb1.new("ms.20l3.b1", "ms", at="-916.2007+(35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250431.0, assembly_id=102511.0))
lhcb1.new("mcbh.20l3.b1", "mcbh", at="-915.6077+(35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250433.0, assembly_id=102511.0))
lhcb1.new("mb.c20l3.b1", "mb", at="-907.0307+(34.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826734.0, assembly_id=102512.0))
lhcb1.new("mcs.c20l3.b1", "mcs", at="-899.6067+(34-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243564.0, assembly_id=102512.0))
lhcb1.new("mco.20l3.b1", "mco", at="-898.8567+(34-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250436.0, assembly_id=102513.0))
lhcb1.new("mcd.20l3.b1", "mcd", at="-898.8552+(34-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250437.0, assembly_id=102513.0))
lhcb1.new("mb.b20l3.b1", "mb", at="-891.3707+(33.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826758.0, assembly_id=102513.0))
lhcb1.new("mcs.b20l3.b1", "mcs", at="-883.9467+(33-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243569.0, assembly_id=102513.0))
lhcb1.new("mb.a20l3.b1", "mb", at="-875.7107+(32.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826782.0, assembly_id=102514.0))
lhcb1.new("mcs.a20l3.b1", "mcs", at="-868.2867+(32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243572.0, assembly_id=102514.0))
lhcb1.new("bpm.19l3.b1", "bpm", at="-867.4077+(32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243574.0, assembly_id=102515.0))
lhcb1.new("mqt.19l3.b1", "mqt", at="-866.6537+(32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307431.0, assembly_id=102515.0))
lhcb1.new("mq.19l3.b1", "mq", at="-864.6457+(32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308420.0, assembly_id=102515.0))
lhcb1.new("ms.19l3.b1", "ms", at="-862.7507+(32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250439.0, assembly_id=102515.0))
lhcb1.new("mcbv.19l3.b1", "mcbv", at="-862.1577+(32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250441.0, assembly_id=102515.0))
lhcb1.new("mco.b19l3.b1", "mco", at="-861.0667+(32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250444.0, assembly_id=102516.0))
lhcb1.new("mcd.b19l3.b1", "mcd", at="-861.0652+(32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250445.0, assembly_id=102516.0))
lhcb1.new("mb.c19l3.b1", "mb", at="-853.5807+(31.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826806.0, assembly_id=102516.0))
lhcb1.new("mcs.c19l3.b1", "mcs", at="-846.1567+(31-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243582.0, assembly_id=102516.0))
lhcb1.new("mb.b19l3.b1", "mb", at="-837.9207+(30.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826830.0, assembly_id=102517.0))
lhcb1.new("mcs.b19l3.b1", "mcs", at="-830.4967+(30-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243585.0, assembly_id=102517.0))
lhcb1.new("mco.a19l3.b1", "mco", at="-829.7467+(30-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250448.0, assembly_id=102518.0))
lhcb1.new("mcd.a19l3.b1", "mcd", at="-829.7452+(30-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250449.0, assembly_id=102518.0))
lhcb1.new("mb.a19l3.b1", "mb", at="-822.2607+(29.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826854.0, assembly_id=102518.0))
lhcb1.new("mcs.a19l3.b1", "mcs", at="-814.8367+(29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243590.0, assembly_id=102518.0))
lhcb1.new("bpm.18l3.b1", "bpm", at="-813.9577+(29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243592.0, assembly_id=102519.0))
lhcb1.new("mqt.18l3.b1", "mqt", at="-813.2037+(29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307399.0, assembly_id=102519.0))
lhcb1.new("mq.18l3.b1", "mq", at="-811.1957+(29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308389.0, assembly_id=102519.0))
lhcb1.new("ms.18l3.b1", "ms", at="-809.3007+(29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250451.0, assembly_id=102519.0))
lhcb1.new("mcbh.18l3.b1", "mcbh", at="-808.7077+(29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250453.0, assembly_id=102519.0))
lhcb1.new("mb.c18l3.b1", "mb", at="-800.1307+(28.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826878.0, assembly_id=102520.0))
lhcb1.new("mcs.c18l3.b1", "mcs", at="-792.7067+(28-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243598.0, assembly_id=102520.0))
lhcb1.new("mco.18l3.b1", "mco", at="-791.9567+(28-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250456.0, assembly_id=102521.0))
lhcb1.new("mcd.18l3.b1", "mcd", at="-791.9552+(28-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250457.0, assembly_id=102521.0))
lhcb1.new("mb.b18l3.b1", "mb", at="-784.4707+(27.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826902.0, assembly_id=102521.0))
lhcb1.new("mcs.b18l3.b1", "mcs", at="-777.0467+(27-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243603.0, assembly_id=102521.0))
lhcb1.new("mb.a18l3.b1", "mb", at="-768.8107+(26.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826926.0, assembly_id=102522.0))
lhcb1.new("mcs.a18l3.b1", "mcs", at="-761.3867+(26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243606.0, assembly_id=102522.0))
lhcb1.new("bpm.17l3.b1", "bpm", at="-760.5077+(26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243608.0, assembly_id=102523.0))
lhcb1.new("mqt.17l3.b1", "mqt", at="-759.7537+(26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307604.0, assembly_id=102523.0))
lhcb1.new("mq.17l3.b1", "mq", at="-757.7457+(26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308359.0, assembly_id=102523.0))
lhcb1.new("ms.17l3.b1", "ms", at="-755.8507+(26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250459.0, assembly_id=102523.0))
lhcb1.new("mcbv.17l3.b1", "mcbv", at="-755.2577+(26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250461.0, assembly_id=102523.0))
lhcb1.new("mco.b17l3.b1", "mco", at="-754.1667+(26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250464.0, assembly_id=102524.0))
lhcb1.new("mcd.b17l3.b1", "mcd", at="-754.1652+(26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250465.0, assembly_id=102524.0))
lhcb1.new("mb.c17l3.b1", "mb", at="-746.6807+(25.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826950.0, assembly_id=102524.0))
lhcb1.new("mcs.c17l3.b1", "mcs", at="-739.2567+(25-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243616.0, assembly_id=102524.0))
lhcb1.new("mb.b17l3.b1", "mb", at="-731.0207+(24.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826974.0, assembly_id=102525.0))
lhcb1.new("mcs.b17l3.b1", "mcs", at="-723.5967+(24-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243619.0, assembly_id=102525.0))
lhcb1.new("mco.a17l3.b1", "mco", at="-722.8467+(24-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250468.0, assembly_id=102526.0))
lhcb1.new("mcd.a17l3.b1", "mcd", at="-722.8452+(24-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250469.0, assembly_id=102526.0))
lhcb1.new("mb.a17l3.b1", "mb", at="-715.3607+(23.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52826998.0, assembly_id=102526.0))
lhcb1.new("mcs.a17l3.b1", "mcs", at="-707.9367+(23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243624.0, assembly_id=102526.0))
lhcb1.new("bpm.16l3.b1", "bpm", at="-707.0577+(23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243626.0, assembly_id=102527.0))
lhcb1.new("mqt.16l3.b1", "mqt", at="-706.3037+(23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307574.0, assembly_id=102527.0))
lhcb1.new("mq.16l3.b1", "mq", at="-704.2957+(23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308329.0, assembly_id=102527.0))
lhcb1.new("ms.16l3.b1", "ms", at="-702.4007+(23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250471.0, assembly_id=102527.0))
lhcb1.new("mcbh.16l3.b1", "mcbh", at="-701.8077+(23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250473.0, assembly_id=102527.0))
lhcb1.new("mb.c16l3.b1", "mb", at="-693.2307+(22.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827022.0, assembly_id=102528.0))
lhcb1.new("mcs.c16l3.b1", "mcs", at="-685.8067+(22-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243632.0, assembly_id=102528.0))
lhcb1.new("mco.16l3.b1", "mco", at="-685.0567+(22-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250476.0, assembly_id=102529.0))
lhcb1.new("mcd.16l3.b1", "mcd", at="-685.0552+(22-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250477.0, assembly_id=102529.0))
lhcb1.new("mb.b16l3.b1", "mb", at="-677.5707+(21.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827046.0, assembly_id=102529.0))
lhcb1.new("mcs.b16l3.b1", "mcs", at="-670.1467+(21-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243637.0, assembly_id=102529.0))
lhcb1.new("mb.a16l3.b1", "mb", at="-661.9107+(20.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827070.0, assembly_id=102530.0))
lhcb1.new("mcs.a16l3.b1", "mcs", at="-654.4867+(20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243640.0, assembly_id=102530.0))
lhcb1.new("bpm.15l3.b1", "bpm", at="-653.6077+(20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243642.0, assembly_id=102531.0))
lhcb1.new("mqt.15l3.b1", "mqt", at="-652.8537+(20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307543.0, assembly_id=102531.0))
lhcb1.new("mq.15l3.b1", "mq", at="-650.8457+(20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308536.0, assembly_id=102531.0))
lhcb1.new("ms.15l3.b1", "ms", at="-648.9507+(20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250479.0, assembly_id=102531.0))
lhcb1.new("mcbv.15l3.b1", "mcbv", at="-648.3577+(20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250481.0, assembly_id=102531.0))
lhcb1.new("mco.b15l3.b1", "mco", at="-647.2667+(20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250484.0, assembly_id=102532.0))
lhcb1.new("mcd.b15l3.b1", "mcd", at="-647.2652+(20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250485.0, assembly_id=102532.0))
lhcb1.new("mb.c15l3.b1", "mb", at="-639.7807+(19.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827094.0, assembly_id=102532.0))
lhcb1.new("mcs.c15l3.b1", "mcs", at="-632.3567+(19-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243650.0, assembly_id=102532.0))
lhcb1.new("mb.b15l3.b1", "mb", at="-624.1207+(18.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827118.0, assembly_id=102533.0))
lhcb1.new("mcs.b15l3.b1", "mcs", at="-616.6967+(18-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243653.0, assembly_id=102533.0))
lhcb1.new("mco.a15l3.b1", "mco", at="-615.9467+(18-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250488.0, assembly_id=102534.0))
lhcb1.new("mcd.a15l3.b1", "mcd", at="-615.9452+(18-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250489.0, assembly_id=102534.0))
lhcb1.new("mb.a15l3.b1", "mb", at="-608.4607+(17.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827142.0, assembly_id=102534.0))
lhcb1.new("mcs.a15l3.b1", "mcs", at="-601.0367+(17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243658.0, assembly_id=102534.0))
lhcb1.new("bpm.14l3.b1", "bpm", at="-600.1577+(17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243660.0, assembly_id=102535.0))
lhcb1.new("mqt.14l3.b1", "mqt", at="-599.4037+(17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307511.0, assembly_id=102535.0))
lhcb1.new("mq.14l3.b1", "mq", at="-597.3957+(17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308506.0, assembly_id=102535.0))
lhcb1.new("ms.14l3.b1", "ms", at="-595.5007+(17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250491.0, assembly_id=102535.0))
lhcb1.new("mcbh.14l3.b1", "mcbh", at="-594.9077+(17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250493.0, assembly_id=102535.0))
lhcb1.new("mb.c14l3.b1", "mb", at="-586.3307+(16.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827166.0, assembly_id=102536.0))
lhcb1.new("mcs.c14l3.b1", "mcs", at="-578.9067+(16-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243666.0, assembly_id=102536.0))
lhcb1.new("mco.14l3.b1", "mco", at="-578.1567+(16-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250496.0, assembly_id=102537.0))
lhcb1.new("mcd.14l3.b1", "mcd", at="-578.1552+(16-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250497.0, assembly_id=102537.0))
lhcb1.new("mb.b14l3.b1", "mb", at="-570.6707+(15.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827190.0, assembly_id=102537.0))
lhcb1.new("mcs.b14l3.b1", "mcs", at="-563.2467+(15-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243671.0, assembly_id=102537.0))
lhcb1.new("mb.a14l3.b1", "mb", at="-555.0107+(14.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827214.0, assembly_id=102538.0))
lhcb1.new("mcs.a14l3.b1", "mcs", at="-547.5867+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243674.0, assembly_id=102538.0))
lhcb1.new("s.ds.l3.b1", "omk", at="-547.1807+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.13l3.b1", "bpm", at="-546.7077+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243676.0, assembly_id=102539.0))
lhcb1.new("mqt.13l3.b1", "mqt", at="-545.9537+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307719.0, assembly_id=102539.0))
lhcb1.new("mq.13l3.b1", "mq", at="-543.9457+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308476.0, assembly_id=102539.0))
lhcb1.new("ms.13l3.b1", "ms", at="-542.0507+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250499.0, assembly_id=102539.0))
lhcb1.new("mcbv.13l3.b1", "mcbv", at="-541.4577+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250501.0, assembly_id=102539.0))
lhcb1.new("mco.b13l3.b1", "mco", at="-540.3667+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250504.0, assembly_id=102540.0))
lhcb1.new("mcd.b13l3.b1", "mcd", at="-540.3652+(14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250505.0, assembly_id=102540.0))
lhcb1.new("mb.c13l3.b1", "mb", at="-532.8807+(13.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827238.0, assembly_id=102540.0))
lhcb1.new("mcs.c13l3.b1", "mcs", at="-525.4567+(13-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243684.0, assembly_id=102540.0))
lhcb1.new("mb.b13l3.b1", "mb", at="-517.2207+(12.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827262.0, assembly_id=102541.0))
lhcb1.new("mcs.b13l3.b1", "mcs", at="-509.7967+(12-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243687.0, assembly_id=102541.0))
lhcb1.new("mco.a13l3.b1", "mco", at="-509.0467+(12-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250508.0, assembly_id=102542.0))
lhcb1.new("mcd.a13l3.b1", "mcd", at="-509.0452+(12-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250509.0, assembly_id=102542.0))
lhcb1.new("mb.a13l3.b1", "mb", at="-501.5607+(11.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827286.0, assembly_id=102542.0))
lhcb1.new("mcs.a13l3.b1", "mcs", at="-494.1367+(11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243692.0, assembly_id=102542.0))
lhcb1.new("bpm.12l3.b1", "bpm", at="-493.2577+(11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243694.0, assembly_id=102543.0))
lhcb1.new("mqt.12l3.b1", "mqt", at="-492.5037+(11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307687.0, assembly_id=102543.0))
lhcb1.new("mq.12l3.b1", "mq", at="-490.4957+(11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308683.0, assembly_id=102543.0))
lhcb1.new("ms.12l3.b1", "ms", at="-488.6007+(11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250511.0, assembly_id=102543.0))
lhcb1.new("mcbh.12l3.b1", "mcbh", at="-488.0077+(11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250513.0, assembly_id=102543.0))
lhcb1.new("mb.c12l3.b1", "mb", at="-479.4307+(10.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827310.0, assembly_id=102544.0))
lhcb1.new("mcs.c12l3.b1", "mcs", at="-472.0067+(10-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243700.0, assembly_id=102544.0))
lhcb1.new("mco.12l3.b1", "mco", at="-471.2567+(10-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250516.0, assembly_id=102545.0))
lhcb1.new("mcd.12l3.b1", "mcd", at="-471.2552+(10-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250517.0, assembly_id=102545.0))
lhcb1.new("mb.b12l3.b1", "mb", at="-463.7707+(9.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827334.0, assembly_id=102545.0))
lhcb1.new("mcs.b12l3.b1", "mcs", at="-456.3467+(9-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243705.0, assembly_id=102545.0))
lhcb1.new("mb.a12l3.b1", "mb", at="-448.1107+(8.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827358.0, assembly_id=102546.0))
lhcb1.new("mcs.a12l3.b1", "mcs", at="-440.6867+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243708.0, assembly_id=102546.0))
lhcb1.new("e.arc.23.b1", "omk", at="-440.2807+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.11l3.b1", "bpm", at="-439.8077+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243710.0, assembly_id=102547.0))
lhcb1.new("mq.11l3.b1", "mq", at="-437.2607+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308653.0, assembly_id=102547.0))
lhcb1.new("mqtli.11l3.b1", "mqtli", at="-434.8917+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307341.0, assembly_id=102547.0))
lhcb1.new("ms.11l3.b1", "ms", at="-433.8797+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250519.0, assembly_id=102547.0))
lhcb1.new("mcbv.11l3.b1", "mcbv", at="-433.2867+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250521.0, assembly_id=102547.0))
lhcb1.new("lefl.11l3.b1", "lefl", at="-425.67735+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52997826.0, assembly_id=102548.0))
lhcb1.new("mco.11l3.b1", "mco", at="-418.475+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250524.0, assembly_id=102549.0))
lhcb1.new("mcd.11l3.b1", "mcd", at="-418.4735+(8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250525.0, assembly_id=102549.0))
lhcb1.new("mb.b11l3.b1", "mb", at="-410.989+(7.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827382.0, assembly_id=102549.0))
lhcb1.new("mcs.b11l3.b1", "mcs", at="-403.565+(7-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243718.0, assembly_id=102549.0))
lhcb1.new("mb.a11l3.b1", "mb", at="-395.329+(6.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827406.0, assembly_id=102550.0))
lhcb1.new("mcs.a11l3.b1", "mcs", at="-387.905+(6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243721.0, assembly_id=102550.0))
lhcb1.new("bpm.10l3.b1", "bpm", at="-387.026+(6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243723.0, assembly_id=102551.0))
lhcb1.new("mq.10l3.b1", "mq", at="-384.479+(6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308642.0, assembly_id=102551.0))
lhcb1.new("mqtli.10l3.b1", "mqtli", at="-382.11+(6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307330.0, assembly_id=102551.0))
lhcb1.new("mcbch.10l3.b1", "mcbch", at="-380.82+(6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250527.0, assembly_id=102551.0))
lhcb1.new("mco.10l3.b1", "mco", at="-379.41+(6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250530.0, assembly_id=102552.0))
lhcb1.new("mcd.10l3.b1", "mcd", at="-379.4085+(6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250531.0, assembly_id=102552.0))
lhcb1.new("mb.b10l3.b1", "mb", at="-371.924+(5.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827430.0, assembly_id=102552.0))
lhcb1.new("mcs.b10l3.b1", "mcs", at="-364.5+(5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243731.0, assembly_id=102552.0))
lhcb1.new("mb.a10l3.b1", "mb", at="-356.264+(4.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827454.0, assembly_id=102553.0))
lhcb1.new("mcs.a10l3.b1", "mcs", at="-348.84+(4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243734.0, assembly_id=102553.0))
lhcb1.new("bpm.9l3.b1", "bpm", at="-347.96+(4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243736.0, assembly_id=102554.0))
lhcb1.new("mq.9l3.b1", "mq", at="-345.413+(4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307947.0, assembly_id=102554.0))
lhcb1.new("mqtli.b9l3.b1", "mqtli", at="-343.044+(4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307157.0, assembly_id=102554.0))
lhcb1.new("mqtli.a9l3.b1", "mqtli", at="-341.589+(4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307150.0, assembly_id=102554.0))
lhcb1.new("mcbcv.9l3.b1", "mcbcv", at="-340.299+(4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250533.0, assembly_id=102554.0))
lhcb1.new("mco.9l3.b1", "mco", at="-338.945+(4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250536.0, assembly_id=102555.0))
lhcb1.new("mcd.9l3.b1", "mcd", at="-338.9435+(4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250537.0, assembly_id=102555.0))
lhcb1.new("mb.b9l3.b1", "mb", at="-331.459+(3.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827478.0, assembly_id=102555.0))
lhcb1.new("mcs.b9l3.b1", "mcs", at="-324.035+(3-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243745.0, assembly_id=102555.0))
lhcb1.new("mb.a9l3.b1", "mb", at="-315.799+(2.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827502.0, assembly_id=102556.0))
lhcb1.new("mcs.a9l3.b1", "mcs", at="-308.375+(2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243748.0, assembly_id=102556.0))
lhcb1.new("bpm.8l3.b1", "bpm", at="-307.496+(2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243750.0, assembly_id=102557.0))
lhcb1.new("mq.8l3.b1", "mq", at="-304.949+(2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307940.0, assembly_id=102557.0))
lhcb1.new("mqtli.8l3.b1", "mqtli", at="-302.58+(2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307142.0, assembly_id=102557.0))
lhcb1.new("mcbch.8l3.b1", "mcbch", at="-301.29+(2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250539.0, assembly_id=102557.0))
lhcb1.new("mco.8l3.b1", "mco", at="-299.88+(2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250542.0, assembly_id=102558.0))
lhcb1.new("mcd.8l3.b1", "mcd", at="-299.8785+(2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250543.0, assembly_id=102558.0))
lhcb1.new("mb.b8l3.b1", "mb", at="-292.394+(1.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827526.0, assembly_id=102558.0))
lhcb1.new("mcs.b8l3.b1", "mcs", at="-284.97+(1-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243758.0, assembly_id=102558.0))
lhcb1.new("mb.a8l3.b1", "mb", at="-276.734+(.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52849486.0, assembly_id=102559.0))
lhcb1.new("mcs.a8l3.b1", "mcs", at="-269.31+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=357299.0, assembly_id=102559.0))
lhcb1.new("e.ds.l3.b1", "omk", at="-268.904+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.7l3.b1", "bpm", at="-268.431+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243763.0, assembly_id=102560.0))
lhcb1.new("mq.7l3.b1", "mq", at="-265.884+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307932.0, assembly_id=102560.0))
lhcb1.new("mqtli.7l3.b1", "mqtli", at="-263.515+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307368.0, assembly_id=102560.0))
lhcb1.new("mcbcv.7l3.b1", "mcbcv", at="-262.225+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250545.0, assembly_id=102560.0))
lhcb1.new("dfbae.7l3.b1", "dfbae", at="-260.0715+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52996635.0, assembly_id=104678.0))
lhcb1.new("btvm.7l3.b1", "btvm", at="-220.116+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=181618.0))
lhcb1.new("mcbch.6l3.b1", "mcbch", at="-205.73+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250547.0, assembly_id=102561.0))
lhcb1.new("mqtlh.f6l3.b1", "mqtlh", at="-204.439+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307323.0, assembly_id=102561.0))
lhcb1.new("mqtlh.e6l3.b1", "mqtlh", at="-202.983+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307315.0, assembly_id=102561.0))
lhcb1.new("mqtlh.d6l3.b1", "mqtlh", at="-201.527+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307308.0, assembly_id=102561.0))
lhcb1.new("mqtlh.c6l3.b1", "mqtlh", at="-200.072+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307300.0, assembly_id=102561.0))
lhcb1.new("mqtlh.b6l3.b1", "mqtlh", at="-198.617+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307293.0, assembly_id=102561.0))
lhcb1.new("mqtlh.a6l3.b1", "mqtlh", at="-197.162+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307285.0, assembly_id=102561.0))
lhcb1.new("bpm.6l3.b1", "bpm", at="-195.792+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=377943.0, assembly_id=102561.0))
lhcb1.new("mbw.f6l3.b1", "mbw", at="-191.466+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52819798.0))
lhcb1.new("mbw.e6l3.b1", "mbw", at="-187.231+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52819822.0))
lhcb1.new("mbw.d6l3.b1", "mbw", at="-182.996+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52819846.0))
lhcb1.new("tcp.6l3.b1", "tcp", at="-177.0495+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.2056, slot_id=102563.0))
lhcb1.new("tcapa.6l3.b1", "tcapa020", at="-168.173+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.2156, slot_id=691018.0))
lhcb1.new("mbw.c6l3.b1", "mbw", at="-164.973+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=52819870.0))
lhcb1.new("mbw.b6l3.b1", "mbw", at="-160.738+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=52819894.0))
lhcb1.new("mbw.a6l3.b1", "mbw", at="-156.503+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=52819918.0))
lhcb1.new("bpmwg.a5l3.b1", "bpmwg", at="-154.0875+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=6703842.0))
lhcb1.new("tcapd.5l3.b1", "tcapd", at="-153.058+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=6703861.0))
lhcb1.new("mqwa.e5l3.b1", "mqwa", at="-150.548+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241745.0))
lhcb1.new("mqwa.d5l3.b1", "mqwa", at="-146.748+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241746.0))
lhcb1.new("tcsg.5l3.b1", "tcsg", at="-143.728+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=297854.0))
lhcb1.new("mqwa.c5l3.b1", "mqwa", at="-138.708+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241747.0))
lhcb1.new("mqwb.5l3.b1", "mqwb", at="-134.908+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241744.0))
lhcb1.new("mqwa.b5l3.b1", "mqwa", at="-131.108+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241748.0))
lhcb1.new("mqwa.a5l3.b1", "mqwa", at="-127.308+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241749.0))
lhcb1.new("bpmw.5l3.b1", "bpmw_015", at="-125.1175+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=297848.0))
lhcb1.new("mcbwv.5l3.b1", "mcbwv", at="-121.323+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=297846.0))
lhcb1.new("bpmwe.4l3.b1", "bpmwe003", at="-49.9895+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=297872.0))
lhcb1.new("mqwa.e4l3.b1", "mqwa", at="-47.875+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241751.0))
lhcb1.new("mqwa.d4l3.b1", "mqwa", at="-39.835+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241752.0))
lhcb1.new("mqwa.c4l3.b1", "mqwa", at="-36.035+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241753.0))
lhcb1.new("mqwb.4l3.b1", "mqwb", at="-32.235+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241750.0))
lhcb1.new("mqwa.b4l3.b1", "mqwa", at="-28.435+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241754.0))
lhcb1.new("mqwa.a4l3.b1", "mqwa", at="-24.635+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241755.0))
lhcb1.new("bpmw.4l3.b1", "bpmw_010", at="-22.4445+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=297862.0))
lhcb1.new("mcbwh.4l3.b1", "mcbwh", at="-18.7+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=297859.0))
lhcb1.new("ip3", "omk", at="pip3+ip3ofs.b1*ds")
lhcb1.new("mcbwv.4r3.b1", "mcbwv", at="21.03+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=134540.0))
lhcb1.new("bpmw.4r3.b1", "bpmw_014", at="22.5205+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=134740.0))
lhcb1.new("mqwa.a4r3.b1", "mqwa", at="24.635+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241757.0))
lhcb1.new("mqwa.b4r3.b1", "mqwa", at="28.435+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241758.0))
lhcb1.new("mqwb.4r3.b1", "mqwb", at="32.235+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241756.0))
lhcb1.new("mqwa.c4r3.b1", "mqwa", at="36.035+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241759.0))
lhcb1.new("mqwa.d4r3.b1", "mqwa", at="39.835+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241760.0))
lhcb1.new("tcsg.4r3.b1", "tcsg", at="42.855+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=114804.0))
lhcb1.new("mqwa.e4r3.b1", "mqwa", at="47.875+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241761.0))
lhcb1.new("bpmwe.4r3.b1", "bpmwe007", at="50.0655+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=134741.0))
lhcb1.new("tcsg.a5r3.b1", "tcsg", at="54.2+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=102571.0))
lhcb1.new("tcsg.b5r3.b1", "tcsg", at="60.02+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=102573.0))
lhcb1.new("tcla.a5r3.b1", "tcla", at="90.5+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=479337.0))
lhcb1.new("tcla.b5r3.b1", "tcla", at="92.5+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=479338.0))
lhcb1.new("mcbwh.5r3.b1", "mcbwh", at="123.653+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=134548.0))
lhcb1.new("bpmw.5r3.b1", "bpmw_013", at="125.1935+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=134743.0))
lhcb1.new("mqwa.a5r3.b1", "mqwa", at="127.308+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241763.0))
lhcb1.new("mqwa.b5r3.b1", "mqwa", at="131.108+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241764.0))
lhcb1.new("mqwb.5r3.b1", "mqwb", at="134.908+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241762.0))
lhcb1.new("mqwa.c5r3.b1", "mqwa", at="138.708+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241765.0))
lhcb1.new("mqwa.d5r3.b1", "mqwa", at="146.748+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241766.0))
lhcb1.new("mqwa.e5r3.b1", "mqwa", at="150.548+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=241767.0))
lhcb1.new("bpmwj.a5r3.b1", "bpmwj", at="153.9115+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=6703880.0))
lhcb1.new("mbw.a6r3.b1", "mbw", at="156.351+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=52819942.0))
lhcb1.new("mbw.b6r3.b1", "mbw", at="160.586+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=52819966.0))
lhcb1.new("mbw.c6r3.b1", "mbw", at="164.821+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.224, slot_id=52819990.0))
lhcb1.new("tcla.6r3.b1", "tcla", at="179.0495+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.2028, slot_id=479340.0))
lhcb1.new("mbw.d6r3.b1", "mbw", at="182.844+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.1986, slot_id=52820014.0))
lhcb1.new("mbw.e6r3.b1", "mbw", at="187.079+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52820038.0))
lhcb1.new("mbw.f6r3.b1", "mbw", at="191.314+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52820062.0))
lhcb1.new("bpmwc.6r3.b1", "bpmwc", at="193.7295+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=104603.0))
lhcb1.new("mcbcv.6r3.b1", "mcbcv", at="195.87+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250549.0, assembly_id=102578.0))
lhcb1.new("mqtlh.a6r3.b1", "mqtlh", at="197.161+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307289.0, assembly_id=102578.0))
lhcb1.new("mqtlh.b6r3.b1", "mqtlh", at="198.617+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307297.0, assembly_id=102578.0))
lhcb1.new("mqtlh.c6r3.b1", "mqtlh", at="200.073+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307304.0, assembly_id=102578.0))
lhcb1.new("mqtlh.d6r3.b1", "mqtlh", at="201.528+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2348435.0, assembly_id=102578.0))
lhcb1.new("mqtlh.e6r3.b1", "mqtlh", at="202.983+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307319.0, assembly_id=102578.0))
lhcb1.new("mqtlh.f6r3.b1", "mqtlh", at="204.438+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307326.0, assembly_id=102578.0))
lhcb1.new("bpmr.6r3.b1", "bpmr", at="205.808+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=377945.0, assembly_id=102578.0))
lhcb1.new("tcla.7r3.b1", "tcla", at="250.455+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=479341.0))
lhcb1.new("dfbaf.7r3.b1", "dfbaf", at="259.8215+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52996659.0, assembly_id=104679.0))
lhcb1.new("bpm_a.7r3.b1", "bpm_a", at="261.632+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=377948.0, assembly_id=102579.0))
lhcb1.new("mq.7r3.b1", "mq", at="264.179+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307936.0, assembly_id=102579.0))
lhcb1.new("mqtli.7r3.b1", "mqtli", at="266.548+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307372.0, assembly_id=102579.0))
lhcb1.new("mcbch.7r3.b1", "mcbch", at="267.838+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250551.0, assembly_id=102579.0))
lhcb1.new("s.ds.r3.b1", "omk", at="268.904+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(slot_id=100932.0))
lhcb1.new("mco.8r3.b1", "mco", at="269.248+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250554.0, assembly_id=102580.0))
lhcb1.new("mcd.8r3.b1", "mcd", at="269.2495+(0-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250555.0, assembly_id=102580.0))
lhcb1.new("mb.a8r3.b1", "mb", at="276.734+(-.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827550.0, assembly_id=102580.0))
lhcb1.new("mcs.a8r3.b1", "mcs", at="284.158+(-1-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243824.0, assembly_id=102580.0))
lhcb1.new("mb.b8r3.b1", "mb", at="292.394+(-1.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827574.0, assembly_id=102581.0))
lhcb1.new("mcs.b8r3.b1", "mcs", at="299.818+(-2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243827.0, assembly_id=102581.0))
lhcb1.new("bpm.8r3.b1", "bpm", at="300.697+(-2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243829.0, assembly_id=102582.0))
lhcb1.new("mq.8r3.b1", "mq", at="303.244+(-2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307943.0, assembly_id=102582.0))
lhcb1.new("mqtli.8r3.b1", "mqtli", at="305.613+(-2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307146.0, assembly_id=102582.0))
lhcb1.new("mcbcv.8r3.b1", "mcbcv", at="306.903+(-2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250557.0, assembly_id=102582.0))
lhcb1.new("mco.9r3.b1", "mco", at="308.313+(-2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250560.0, assembly_id=102583.0))
lhcb1.new("mcd.9r3.b1", "mcd", at="308.3145+(-2-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250561.0, assembly_id=102583.0))
lhcb1.new("mb.a9r3.b1", "mb", at="315.799+(-2.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827598.0, assembly_id=102583.0))
lhcb1.new("mcs.a9r3.b1", "mcs", at="323.223+(-3-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243837.0, assembly_id=102583.0))
lhcb1.new("mb.b9r3.b1", "mb", at="331.459+(-3.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827622.0, assembly_id=102584.0))
lhcb1.new("mcs.b9r3.b1", "mcs", at="338.883+(-4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243840.0, assembly_id=102584.0))
lhcb1.new("bpm.9r3.b1", "bpm", at="339.763+(-4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243842.0, assembly_id=102585.0))
lhcb1.new("mq.9r3.b1", "mq", at="342.31+(-4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307951.0, assembly_id=102585.0))
lhcb1.new("mqtli.a9r3.b1", "mqtli", at="344.679+(-4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307154.0, assembly_id=102585.0))
lhcb1.new("mqtli.b9r3.b1", "mqtli", at="346.134+(-4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307161.0, assembly_id=102585.0))
lhcb1.new("mcbch.9r3.b1", "mcbch", at="347.424+(-4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250563.0, assembly_id=102585.0))
lhcb1.new("mco.10r3.b1", "mco", at="348.778+(-4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250566.0, assembly_id=102586.0))
lhcb1.new("mcd.10r3.b1", "mcd", at="348.7795+(-4-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250567.0, assembly_id=102586.0))
lhcb1.new("mb.a10r3.b1", "mb", at="356.264+(-4.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827646.0, assembly_id=102586.0))
lhcb1.new("mcs.a10r3.b1", "mcs", at="363.688+(-5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243851.0, assembly_id=102586.0))
lhcb1.new("mb.b10r3.b1", "mb", at="371.924+(-5.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827670.0, assembly_id=102587.0))
lhcb1.new("mcs.b10r3.b1", "mcs", at="379.348+(-6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243854.0, assembly_id=102587.0))
lhcb1.new("bpm.10r3.b1", "bpm", at="380.227+(-6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243856.0, assembly_id=102588.0))
lhcb1.new("mq.10r3.b1", "mq", at="382.774+(-6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308646.0, assembly_id=102588.0))
lhcb1.new("mqtli.10r3.b1", "mqtli", at="385.143+(-6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307334.0, assembly_id=102588.0))
lhcb1.new("mcbcv.10r3.b1", "mcbcv", at="386.433+(-6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250569.0, assembly_id=102588.0))
lhcb1.new("mco.11r3.b1", "mco", at="387.843+(-6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250572.0, assembly_id=102589.0))
lhcb1.new("mcd.11r3.b1", "mcd", at="387.8445+(-6-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250573.0, assembly_id=102589.0))
lhcb1.new("mb.a11r3.b1", "mb", at="395.329+(-6.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827694.0, assembly_id=102589.0))
lhcb1.new("mcs.a11r3.b1", "mcs", at="402.753+(-7-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243864.0, assembly_id=102589.0))
lhcb1.new("mb.b11r3.b1", "mb", at="410.989+(-7.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52849510.0, assembly_id=102590.0))
lhcb1.new("mcs.b11r3.b1", "mcs", at="418.413+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=357303.0, assembly_id=102590.0))
lhcb1.new("leel.11r3.b1", "leel", at="425.67735+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52997802.0, assembly_id=102591.0))
lhcb1.new("bpm.11r3.b1", "bpm", at="433.0087+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243869.0, assembly_id=102592.0))
lhcb1.new("mq.11r3.b1", "mq", at="435.5557+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308668.0, assembly_id=102592.0))
lhcb1.new("mqtli.11r3.b1", "mqtli", at="437.9247+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307356.0, assembly_id=102592.0))
lhcb1.new("ms.11r3.b1", "ms", at="438.9367+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250575.0, assembly_id=102592.0))
lhcb1.new("mcbh.11r3.b1", "mcbh", at="439.5297+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250577.0, assembly_id=102592.0))
lhcb1.new("s.arc.34.b1", "omk", at="440.2807+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a12r3.b1", "mco", at="440.6247+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250580.0, assembly_id=102593.0))
lhcb1.new("mcd.a12r3.b1", "mcd", at="440.6262+(-8-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250581.0, assembly_id=102593.0))
lhcb1.new("mb.a12r3.b1", "mb", at="448.1107+(-8.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827718.0, assembly_id=102593.0))
lhcb1.new("mcs.a12r3.b1", "mcs", at="455.5347+(-9-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243877.0, assembly_id=102593.0))
lhcb1.new("mb.b12r3.b1", "mb", at="463.7707+(-9.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827742.0, assembly_id=102594.0))
lhcb1.new("mcs.b12r3.b1", "mcs", at="471.1947+(-10-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243880.0, assembly_id=102594.0))
lhcb1.new("mco.b12r3.b1", "mco", at="471.9447+(-10-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250584.0, assembly_id=102595.0))
lhcb1.new("mcd.b12r3.b1", "mcd", at="471.9462+(-10-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250585.0, assembly_id=102595.0))
lhcb1.new("mb.c12r3.b1", "mb", at="479.4307+(-10.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827766.0, assembly_id=102595.0))
lhcb1.new("mcs.c12r3.b1", "mcs", at="486.8547+(-11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243885.0, assembly_id=102595.0))
lhcb1.new("bpm.12r3.b1", "bpm", at="487.7337+(-11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243887.0, assembly_id=102596.0))
lhcb1.new("mqt.12r3.b1", "mqt", at="488.4877+(-11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307703.0, assembly_id=102596.0))
lhcb1.new("mq.12r3.b1", "mq", at="490.4957+(-11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308461.0, assembly_id=102596.0))
lhcb1.new("ms.12r3.b1", "ms", at="492.3907+(-11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250587.0, assembly_id=102596.0))
lhcb1.new("mcbv.12r3.b1", "mcbv", at="492.9837+(-11-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250589.0, assembly_id=102596.0))
lhcb1.new("mb.a13r3.b1", "mb", at="501.5607+(-11.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827790.0, assembly_id=102597.0))
lhcb1.new("mcs.a13r3.b1", "mcs", at="508.9847+(-12-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243893.0, assembly_id=102597.0))
lhcb1.new("mco.13r3.b1", "mco", at="509.7347+(-12-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250592.0, assembly_id=102598.0))
lhcb1.new("mcd.13r3.b1", "mcd", at="509.7362+(-12-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250593.0, assembly_id=102598.0))
lhcb1.new("mb.b13r3.b1", "mb", at="517.2207+(-12.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827814.0, assembly_id=102598.0))
lhcb1.new("mcs.b13r3.b1", "mcs", at="524.6447+(-13-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243898.0, assembly_id=102598.0))
lhcb1.new("mb.c13r3.b1", "mb", at="532.8807+(-13.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827838.0, assembly_id=102599.0))
lhcb1.new("mcs.c13r3.b1", "mcs", at="540.3047+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243901.0, assembly_id=102599.0))
lhcb1.new("bpm.13r3.b1", "bpm", at="541.1837+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243903.0, assembly_id=102600.0))
lhcb1.new("mqt.13r3.b1", "mqt", at="541.9377+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307496.0, assembly_id=102600.0))
lhcb1.new("mq.13r3.b1", "mq", at="543.9457+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308491.0, assembly_id=102600.0))
lhcb1.new("ms.13r3.b1", "ms", at="545.8407+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250595.0, assembly_id=102600.0))
lhcb1.new("mcbh.13r3.b1", "mcbh", at="546.4337+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250597.0, assembly_id=102600.0))
lhcb1.new("e.ds.r3.b1", "omk", at="547.1807+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a14r3.b1", "mco", at="547.5247+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250600.0, assembly_id=102601.0))
lhcb1.new("mcd.a14r3.b1", "mcd", at="547.5262+(-14-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250601.0, assembly_id=102601.0))
lhcb1.new("mb.a14r3.b1", "mb", at="555.0107+(-14.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827862.0, assembly_id=102601.0))
lhcb1.new("mcs.a14r3.b1", "mcs", at="562.4347+(-15-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243911.0, assembly_id=102601.0))
lhcb1.new("mb.b14r3.b1", "mb", at="570.6707+(-15.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827886.0, assembly_id=102602.0))
lhcb1.new("mcs.b14r3.b1", "mcs", at="578.0947+(-16-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243914.0, assembly_id=102602.0))
lhcb1.new("mco.b14r3.b1", "mco", at="578.8447+(-16-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250604.0, assembly_id=102603.0))
lhcb1.new("mcd.b14r3.b1", "mcd", at="578.8462+(-16-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250605.0, assembly_id=102603.0))
lhcb1.new("mb.c14r3.b1", "mb", at="586.3307+(-16.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827910.0, assembly_id=102603.0))
lhcb1.new("mcs.c14r3.b1", "mcs", at="593.7547+(-17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243919.0, assembly_id=102603.0))
lhcb1.new("bpm.14r3.b1", "bpm", at="594.6337+(-17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243921.0, assembly_id=102604.0))
lhcb1.new("mqt.14r3.b1", "mqt", at="595.3877+(-17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307527.0, assembly_id=102604.0))
lhcb1.new("mq.14r3.b1", "mq", at="597.3957+(-17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308521.0, assembly_id=102604.0))
lhcb1.new("ms.14r3.b1", "ms", at="599.2907+(-17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250607.0, assembly_id=102604.0))
lhcb1.new("mcbv.14r3.b1", "mcbv", at="599.8837+(-17-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250609.0, assembly_id=102604.0))
lhcb1.new("mb.a15r3.b1", "mb", at="608.4607+(-17.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827934.0, assembly_id=102605.0))
lhcb1.new("mcs.a15r3.b1", "mcs", at="615.8847+(-18-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243927.0, assembly_id=102605.0))
lhcb1.new("mco.15r3.b1", "mco", at="616.6347+(-18-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250612.0, assembly_id=102606.0))
lhcb1.new("mcd.15r3.b1", "mcd", at="616.6362+(-18-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250613.0, assembly_id=102606.0))
lhcb1.new("mb.b15r3.b1", "mb", at="624.1207+(-18.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827958.0, assembly_id=102606.0))
lhcb1.new("mcs.b15r3.b1", "mcs", at="631.5447+(-19-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243932.0, assembly_id=102606.0))
lhcb1.new("mb.c15r3.b1", "mb", at="639.7807+(-19.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52827982.0, assembly_id=102607.0))
lhcb1.new("mcs.c15r3.b1", "mcs", at="647.2047+(-20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243935.0, assembly_id=102607.0))
lhcb1.new("bpm.15r3.b1", "bpm", at="648.0837+(-20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243937.0, assembly_id=102608.0))
lhcb1.new("mqt.15r3.b1", "mqt", at="648.8377+(-20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307559.0, assembly_id=102608.0))
lhcb1.new("mq.15r3.b1", "mq", at="650.8457+(-20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308551.0, assembly_id=102608.0))
lhcb1.new("ms.15r3.b1", "ms", at="652.7407+(-20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250615.0, assembly_id=102608.0))
lhcb1.new("mcbh.15r3.b1", "mcbh", at="653.3337+(-20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250617.0, assembly_id=102608.0))
lhcb1.new("mco.a16r3.b1", "mco", at="654.4247+(-20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250620.0, assembly_id=102609.0))
lhcb1.new("mcd.a16r3.b1", "mcd", at="654.4262+(-20-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250621.0, assembly_id=102609.0))
lhcb1.new("mb.a16r3.b1", "mb", at="661.9107+(-20.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828006.0, assembly_id=102609.0))
lhcb1.new("mcs.a16r3.b1", "mcs", at="669.3347+(-21-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243945.0, assembly_id=102609.0))
lhcb1.new("mb.b16r3.b1", "mb", at="677.5707+(-21.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828030.0, assembly_id=102610.0))
lhcb1.new("mcs.b16r3.b1", "mcs", at="684.9947+(-22-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243948.0, assembly_id=102610.0))
lhcb1.new("mco.b16r3.b1", "mco", at="685.7447+(-22-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250624.0, assembly_id=102611.0))
lhcb1.new("mcd.b16r3.b1", "mcd", at="685.7462+(-22-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250625.0, assembly_id=102611.0))
lhcb1.new("mb.c16r3.b1", "mb", at="693.2307+(-22.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828054.0, assembly_id=102611.0))
lhcb1.new("mcs.c16r3.b1", "mcs", at="700.6547+(-23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243953.0, assembly_id=102611.0))
lhcb1.new("bpm.16r3.b1", "bpm", at="701.5337+(-23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243955.0, assembly_id=102612.0))
lhcb1.new("mqt.16r3.b1", "mqt", at="702.2877+(-23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307589.0, assembly_id=102612.0))
lhcb1.new("mq.16r3.b1", "mq", at="704.2957+(-23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308344.0, assembly_id=102612.0))
lhcb1.new("ms.16r3.b1", "ms", at="706.1907+(-23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250627.0, assembly_id=102612.0))
lhcb1.new("mcbv.16r3.b1", "mcbv", at="706.7837+(-23-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250629.0, assembly_id=102612.0))
lhcb1.new("mb.a17r3.b1", "mb", at="715.3607+(-23.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828078.0, assembly_id=102613.0))
lhcb1.new("mcs.a17r3.b1", "mcs", at="722.7847+(-24-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243961.0, assembly_id=102613.0))
lhcb1.new("mco.17r3.b1", "mco", at="723.5347+(-24-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250632.0, assembly_id=102614.0))
lhcb1.new("mcd.17r3.b1", "mcd", at="723.5362+(-24-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250633.0, assembly_id=102614.0))
lhcb1.new("mb.b17r3.b1", "mb", at="731.0207+(-24.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828102.0, assembly_id=102614.0))
lhcb1.new("mcs.b17r3.b1", "mcs", at="738.4447+(-25-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243966.0, assembly_id=102614.0))
lhcb1.new("mb.c17r3.b1", "mb", at="746.6807+(-25.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828126.0, assembly_id=102615.0))
lhcb1.new("mcs.c17r3.b1", "mcs", at="754.1047+(-26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243969.0, assembly_id=102615.0))
lhcb1.new("bpm.17r3.b1", "bpm", at="754.9837+(-26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243971.0, assembly_id=102616.0))
lhcb1.new("mqt.17r3.b1", "mqt", at="755.7377+(-26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307383.0, assembly_id=102616.0))
lhcb1.new("mq.17r3.b1", "mq", at="757.7457+(-26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308374.0, assembly_id=102616.0))
lhcb1.new("ms.17r3.b1", "ms", at="759.6407+(-26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250635.0, assembly_id=102616.0))
lhcb1.new("mcbh.17r3.b1", "mcbh", at="760.2337+(-26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250637.0, assembly_id=102616.0))
lhcb1.new("mco.a18r3.b1", "mco", at="761.3247+(-26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250640.0, assembly_id=102617.0))
lhcb1.new("mcd.a18r3.b1", "mcd", at="761.3262+(-26-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250641.0, assembly_id=102617.0))
lhcb1.new("mb.a18r3.b1", "mb", at="768.8107+(-26.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828150.0, assembly_id=102617.0))
lhcb1.new("mcs.a18r3.b1", "mcs", at="776.2347+(-27-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243979.0, assembly_id=102617.0))
lhcb1.new("mb.b18r3.b1", "mb", at="784.4707+(-27.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828174.0, assembly_id=102618.0))
lhcb1.new("mcs.b18r3.b1", "mcs", at="791.8947+(-28-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243982.0, assembly_id=102618.0))
lhcb1.new("mco.b18r3.b1", "mco", at="792.6447+(-28-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250644.0, assembly_id=102619.0))
lhcb1.new("mcd.b18r3.b1", "mcd", at="792.6462+(-28-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250645.0, assembly_id=102619.0))
lhcb1.new("mb.c18r3.b1", "mb", at="800.1307+(-28.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828198.0, assembly_id=102619.0))
lhcb1.new("mcs.c18r3.b1", "mcs", at="807.5547+(-29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243987.0, assembly_id=102619.0))
lhcb1.new("bpm.18r3.b1", "bpm", at="808.4337+(-29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243989.0, assembly_id=102620.0))
lhcb1.new("mqt.18r3.b1", "mqt", at="809.1877+(-29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307415.0, assembly_id=102620.0))
lhcb1.new("mq.18r3.b1", "mq", at="811.1957+(-29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308404.0, assembly_id=102620.0))
lhcb1.new("ms.18r3.b1", "ms", at="813.0907+(-29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250647.0, assembly_id=102620.0))
lhcb1.new("mcbv.18r3.b1", "mcbv", at="813.6837+(-29-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250649.0, assembly_id=102620.0))
lhcb1.new("mb.a19r3.b1", "mb", at="822.2607+(-29.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828222.0, assembly_id=102621.0))
lhcb1.new("mcs.a19r3.b1", "mcs", at="829.6847+(-30-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=243995.0, assembly_id=102621.0))
lhcb1.new("mco.19r3.b1", "mco", at="830.4347+(-30-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250652.0, assembly_id=102622.0))
lhcb1.new("mcd.19r3.b1", "mcd", at="830.4362+(-30-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250653.0, assembly_id=102622.0))
lhcb1.new("mb.b19r3.b1", "mb", at="837.9207+(-30.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828246.0, assembly_id=102622.0))
lhcb1.new("mcs.b19r3.b1", "mcs", at="845.3447+(-31-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244000.0, assembly_id=102622.0))
lhcb1.new("mb.c19r3.b1", "mb", at="853.5807+(-31.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828270.0, assembly_id=102623.0))
lhcb1.new("mcs.c19r3.b1", "mcs", at="861.0047+(-32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244003.0, assembly_id=102623.0))
lhcb1.new("bpm.19r3.b1", "bpm", at="861.8837+(-32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244005.0, assembly_id=102624.0))
lhcb1.new("mqt.19r3.b1", "mqt", at="862.6377+(-32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2348440.0, assembly_id=102624.0))
lhcb1.new("mq.19r3.b1", "mq", at="864.6457+(-32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308436.0, assembly_id=102624.0))
lhcb1.new("ms.19r3.b1", "ms", at="866.5407+(-32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250655.0, assembly_id=102624.0))
lhcb1.new("mcbh.19r3.b1", "mcbh", at="867.1337+(-32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250657.0, assembly_id=102624.0))
lhcb1.new("mco.a20r3.b1", "mco", at="868.2247+(-32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250660.0, assembly_id=102625.0))
lhcb1.new("mcd.a20r3.b1", "mcd", at="868.2262+(-32-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250661.0, assembly_id=102625.0))
lhcb1.new("mb.a20r3.b1", "mb", at="875.7107+(-32.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828294.0, assembly_id=102625.0))
lhcb1.new("mcs.a20r3.b1", "mcs", at="883.1347+(-33-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244013.0, assembly_id=102625.0))
lhcb1.new("mb.b20r3.b1", "mb", at="891.3707+(-33.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828318.0, assembly_id=102626.0))
lhcb1.new("mcs.b20r3.b1", "mcs", at="898.7947+(-34-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244016.0, assembly_id=102626.0))
lhcb1.new("mco.b20r3.b1", "mco", at="899.5447+(-34-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250664.0, assembly_id=102627.0))
lhcb1.new("mcd.b20r3.b1", "mcd", at="899.5462+(-34-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250665.0, assembly_id=102627.0))
lhcb1.new("mb.c20r3.b1", "mb", at="907.0307+(-34.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828342.0, assembly_id=102627.0))
lhcb1.new("mcs.c20r3.b1", "mcs", at="914.4547+(-35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244021.0, assembly_id=102627.0))
lhcb1.new("bpm.20r3.b1", "bpm", at="915.3337+(-35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244023.0, assembly_id=102628.0))
lhcb1.new("mqt.20r3.b1", "mqt", at="916.0877+(-35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307475.0, assembly_id=102628.0))
lhcb1.new("mq.20r3.b1", "mq", at="918.0957+(-35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308227.0, assembly_id=102628.0))
lhcb1.new("ms.20r3.b1", "ms", at="919.9907+(-35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250667.0, assembly_id=102628.0))
lhcb1.new("mcbv.20r3.b1", "mcbv", at="920.5837+(-35-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250669.0, assembly_id=102628.0))
lhcb1.new("mb.a21r3.b1", "mb", at="929.1607+(-35.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828366.0, assembly_id=102629.0))
lhcb1.new("mcs.a21r3.b1", "mcs", at="936.5847+(-36-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244029.0, assembly_id=102629.0))
lhcb1.new("mco.21r3.b1", "mco", at="937.3347+(-36-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250672.0, assembly_id=102630.0))
lhcb1.new("mcd.21r3.b1", "mcd", at="937.3362+(-36-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250673.0, assembly_id=102630.0))
lhcb1.new("mb.b21r3.b1", "mb", at="944.8207+(-36.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828390.0, assembly_id=102630.0))
lhcb1.new("mcs.b21r3.b1", "mcs", at="952.2447+(-37-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244034.0, assembly_id=102630.0))
lhcb1.new("mb.c21r3.b1", "mb", at="960.4807+(-37.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828414.0, assembly_id=102631.0))
lhcb1.new("mcs.c21r3.b1", "mcs", at="967.9047+(-38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244037.0, assembly_id=102631.0))
lhcb1.new("bpm.21r3.b1", "bpm", at="968.7837+(-38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244039.0, assembly_id=102632.0))
lhcb1.new("mqt.21r3.b1", "mqt", at="969.5377+(-38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307273.0, assembly_id=102632.0))
lhcb1.new("mq.21r3.b1", "mq", at="971.5457+(-38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308257.0, assembly_id=102632.0))
lhcb1.new("ms.21r3.b1", "ms", at="973.4407+(-38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250675.0, assembly_id=102632.0))
lhcb1.new("mcbh.21r3.b1", "mcbh", at="974.0337+(-38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250677.0, assembly_id=102632.0))
lhcb1.new("mco.a22r3.b1", "mco", at="975.1247+(-38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250680.0, assembly_id=102633.0))
lhcb1.new("mcd.a22r3.b1", "mcd", at="975.1262+(-38-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250681.0, assembly_id=102633.0))
lhcb1.new("mb.a22r3.b1", "mb", at="982.6107+(-38.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828438.0, assembly_id=102633.0))
lhcb1.new("mcs.a22r3.b1", "mcs", at="990.0347+(-39-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244047.0, assembly_id=102633.0))
lhcb1.new("mb.b22r3.b1", "mb", at="998.2707+(-39.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828462.0, assembly_id=102634.0))
lhcb1.new("mcs.b22r3.b1", "mcs", at="1005.6947+(-40-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244050.0, assembly_id=102634.0))
lhcb1.new("mco.b22r3.b1", "mco", at="1006.4447+(-40-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250684.0, assembly_id=102635.0))
lhcb1.new("mcd.b22r3.b1", "mcd", at="1006.4462+(-40-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250685.0, assembly_id=102635.0))
lhcb1.new("mb.c22r3.b1", "mb", at="1013.9307+(-40.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828486.0, assembly_id=102635.0))
lhcb1.new("mcs.c22r3.b1", "mcs", at="1021.3547+(-41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244055.0, assembly_id=102635.0))
lhcb1.new("bpm.22r3.b1", "bpm", at="1022.2337+(-41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244057.0, assembly_id=102636.0))
lhcb1.new("mo.22r3.b1", "mo", at="1022.9847+(-41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308817.0, assembly_id=102636.0))
lhcb1.new("mq.22r3.b1", "mq", at="1024.9957+(-41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308289.0, assembly_id=102636.0))
lhcb1.new("ms.22r3.b1", "ms", at="1026.8907+(-41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250687.0, assembly_id=102636.0))
lhcb1.new("mcbv.22r3.b1", "mcbv", at="1027.4837+(-41-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250689.0, assembly_id=102636.0))
lhcb1.new("mb.a23r3.b1", "mb", at="1036.0607+(-41.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828510.0, assembly_id=102637.0))
lhcb1.new("mcs.a23r3.b1", "mcs", at="1043.4847+(-42-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244063.0, assembly_id=102637.0))
lhcb1.new("mco.23r3.b1", "mco", at="1044.2347+(-42-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250692.0, assembly_id=102638.0))
lhcb1.new("mcd.23r3.b1", "mcd", at="1044.2362+(-42-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250693.0, assembly_id=102638.0))
lhcb1.new("mb.b23r3.b1", "mb", at="1051.7207+(-42.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828534.0, assembly_id=102638.0))
lhcb1.new("mcs.b23r3.b1", "mcs", at="1059.1447+(-43-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244068.0, assembly_id=102638.0))
lhcb1.new("mb.c23r3.b1", "mb", at="1067.3807+(-43.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828558.0, assembly_id=102639.0))
lhcb1.new("mcs.c23r3.b1", "mcs", at="1074.8047+(-44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244071.0, assembly_id=102639.0))
lhcb1.new("bpm.23r3.b1", "bpm", at="1075.6837+(-44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244073.0, assembly_id=102640.0))
lhcb1.new("mqs.23r3.b1", "mqs", at="1076.4377+(-44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307639.0, assembly_id=102640.0))
lhcb1.new("mq.23r3.b1", "mq", at="1078.4457+(-44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308320.0, assembly_id=102640.0))
lhcb1.new("ms.23r3.b1", "ms", at="1080.3407+(-44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250695.0, assembly_id=102640.0))
lhcb1.new("mcbh.23r3.b1", "mcbh", at="1080.9337+(-44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250697.0, assembly_id=102640.0))
lhcb1.new("mco.a24r3.b1", "mco", at="1082.0247+(-44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250700.0, assembly_id=102641.0))
lhcb1.new("mcd.a24r3.b1", "mcd", at="1082.0262+(-44-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250701.0, assembly_id=102641.0))
lhcb1.new("mb.a24r3.b1", "mb", at="1089.5107+(-44.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828582.0, assembly_id=102641.0))
lhcb1.new("mcs.a24r3.b1", "mcs", at="1096.9347+(-45-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244081.0, assembly_id=102641.0))
lhcb1.new("mb.b24r3.b1", "mb", at="1105.1707+(-45.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828606.0, assembly_id=102642.0))
lhcb1.new("mcs.b24r3.b1", "mcs", at="1112.5947+(-46-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244084.0, assembly_id=102642.0))
lhcb1.new("mco.b24r3.b1", "mco", at="1113.3447+(-46-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250704.0, assembly_id=102643.0))
lhcb1.new("mcd.b24r3.b1", "mcd", at="1113.3462+(-46-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250705.0, assembly_id=102643.0))
lhcb1.new("mb.c24r3.b1", "mb", at="1120.8307+(-46.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828630.0, assembly_id=102643.0))
lhcb1.new("mcs.c24r3.b1", "mcs", at="1128.2547+(-47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244089.0, assembly_id=102643.0))
lhcb1.new("bpm.24r3.b1", "bpm", at="1129.1337+(-47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244091.0, assembly_id=102644.0))
lhcb1.new("mo.24r3.b1", "mo", at="1129.8847+(-47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308847.0, assembly_id=102644.0))
lhcb1.new("mq.24r3.b1", "mq", at="1131.8957+(-47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308110.0, assembly_id=102644.0))
lhcb1.new("ms.24r3.b1", "ms", at="1133.7907+(-47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250707.0, assembly_id=102644.0))
lhcb1.new("mcbv.24r3.b1", "mcbv", at="1134.3837+(-47-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250709.0, assembly_id=102644.0))
lhcb1.new("mb.a25r3.b1", "mb", at="1142.9607+(-47.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828654.0, assembly_id=102645.0))
lhcb1.new("mcs.a25r3.b1", "mcs", at="1150.3847+(-48-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244097.0, assembly_id=102645.0))
lhcb1.new("mco.25r3.b1", "mco", at="1151.1347+(-48-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250712.0, assembly_id=102646.0))
lhcb1.new("mcd.25r3.b1", "mcd", at="1151.1362+(-48-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250713.0, assembly_id=102646.0))
lhcb1.new("mb.b25r3.b1", "mb", at="1158.6207+(-48.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828678.0, assembly_id=102646.0))
lhcb1.new("mcs.b25r3.b1", "mcs", at="1166.0447+(-49-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244102.0, assembly_id=102646.0))
lhcb1.new("mb.c25r3.b1", "mb", at="1174.2807+(-49.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828702.0, assembly_id=102647.0))
lhcb1.new("mcs.c25r3.b1", "mcs", at="1181.7047+(-50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244105.0, assembly_id=102647.0))
lhcb1.new("bpm.25r3.b1", "bpm", at="1182.5837+(-50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244107.0, assembly_id=102648.0))
lhcb1.new("mo.25r3.b1", "mo", at="1183.3347+(-50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308879.0, assembly_id=102648.0))
lhcb1.new("mq.25r3.b1", "mq", at="1185.3457+(-50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308142.0, assembly_id=102648.0))
lhcb1.new("ms.25r3.b1", "ms", at="1187.2407+(-50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250715.0, assembly_id=102648.0))
lhcb1.new("mcbh.25r3.b1", "mcbh", at="1187.8337+(-50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250717.0, assembly_id=102648.0))
lhcb1.new("mco.a26r3.b1", "mco", at="1188.9247+(-50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250720.0, assembly_id=102649.0))
lhcb1.new("mcd.a26r3.b1", "mcd", at="1188.9262+(-50-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250721.0, assembly_id=102649.0))
lhcb1.new("mb.a26r3.b1", "mb", at="1196.4107+(-50.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828726.0, assembly_id=102649.0))
lhcb1.new("mcs.a26r3.b1", "mcs", at="1203.8347+(-51-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244115.0, assembly_id=102649.0))
lhcb1.new("mb.b26r3.b1", "mb", at="1212.0707+(-51.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828750.0, assembly_id=102650.0))
lhcb1.new("mcs.b26r3.b1", "mcs", at="1219.4947+(-52-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244118.0, assembly_id=102650.0))
lhcb1.new("mco.b26r3.b1", "mco", at="1220.2447+(-52-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250724.0, assembly_id=102651.0))
lhcb1.new("mcd.b26r3.b1", "mcd", at="1220.2462+(-52-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250725.0, assembly_id=102651.0))
lhcb1.new("mb.c26r3.b1", "mb", at="1227.7307+(-52.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828774.0, assembly_id=102651.0))
lhcb1.new("mcs.c26r3.b1", "mcs", at="1235.1547+(-53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244123.0, assembly_id=102651.0))
lhcb1.new("bpm.26r3.b1", "bpm", at="1236.0337+(-53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244125.0, assembly_id=102652.0))
lhcb1.new("mo.26r3.b1", "mo", at="1236.7847+(-53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308911.0, assembly_id=102652.0))
lhcb1.new("mq.26r3.b1", "mq", at="1238.7957+(-53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308173.0, assembly_id=102652.0))
lhcb1.new("ms.26r3.b1", "ms", at="1240.6907+(-53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250727.0, assembly_id=102652.0))
lhcb1.new("mcbv.26r3.b1", "mcbv", at="1241.2837+(-53-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250729.0, assembly_id=102652.0))
lhcb1.new("mb.a27r3.b1", "mb", at="1249.8607+(-53.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828798.0, assembly_id=102653.0))
lhcb1.new("mcs.a27r3.b1", "mcs", at="1257.2847+(-54-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244131.0, assembly_id=102653.0))
lhcb1.new("mco.27r3.b1", "mco", at="1258.0347+(-54-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250732.0, assembly_id=102654.0))
lhcb1.new("mcd.27r3.b1", "mcd", at="1258.0362+(-54-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250733.0, assembly_id=102654.0))
lhcb1.new("mb.b27r3.b1", "mb", at="1265.5207+(-54.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828822.0, assembly_id=102654.0))
lhcb1.new("mcs.b27r3.b1", "mcs", at="1272.9447+(-55-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244136.0, assembly_id=102654.0))
lhcb1.new("mb.c27r3.b1", "mb", at="1281.1807+(-55.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828846.0, assembly_id=102655.0))
lhcb1.new("mcs.c27r3.b1", "mcs", at="1288.6047+(-56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244139.0, assembly_id=102655.0))
lhcb1.new("bpm.27r3.b1", "bpm", at="1289.4837+(-56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244141.0, assembly_id=102656.0))
lhcb1.new("mqs.27r3.b1", "mqs", at="1290.2377+(-56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307671.0, assembly_id=102656.0))
lhcb1.new("mq.27r3.b1", "mq", at="1292.2457+(-56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308203.0, assembly_id=102656.0))
lhcb1.new("ms.27r3.b1", "ms", at="1294.1407+(-56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250735.0, assembly_id=102656.0))
lhcb1.new("mcbh.27r3.b1", "mcbh", at="1294.7337+(-56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250737.0, assembly_id=102656.0))
lhcb1.new("mco.a28r3.b1", "mco", at="1295.8247+(-56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250740.0, assembly_id=102657.0))
lhcb1.new("mcd.a28r3.b1", "mcd", at="1295.8262+(-56-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250741.0, assembly_id=102657.0))
lhcb1.new("mb.a28r3.b1", "mb", at="1303.3107+(-56.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828870.0, assembly_id=102657.0))
lhcb1.new("mcs.a28r3.b1", "mcs", at="1310.7347+(-57-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244149.0, assembly_id=102657.0))
lhcb1.new("mb.b28r3.b1", "mb", at="1318.9707+(-57.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828894.0, assembly_id=102658.0))
lhcb1.new("mcs.b28r3.b1", "mcs", at="1326.3947+(-58-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244152.0, assembly_id=102658.0))
lhcb1.new("mco.b28r3.b1", "mco", at="1327.1447+(-58-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250744.0, assembly_id=102659.0))
lhcb1.new("mcd.b28r3.b1", "mcd", at="1327.1462+(-58-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250745.0, assembly_id=102659.0))
lhcb1.new("mb.c28r3.b1", "mb", at="1334.6307+(-58.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828918.0, assembly_id=102659.0))
lhcb1.new("mcs.c28r3.b1", "mcs", at="1342.0547+(-59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244157.0, assembly_id=102659.0))
lhcb1.new("bpm.28r3.b1", "bpm", at="1342.9337+(-59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51849017.0, assembly_id=51848980.0))
lhcb1.new("mo.28r3.b1", "mo", at="1343.6877+(-59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51849067.0, assembly_id=51848980.0))
lhcb1.new("mq.28r3.b1", "mq", at="1345.6957+(-59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51849069.0, assembly_id=51848980.0))
lhcb1.new("ms.28r3.b1", "ms", at="1347.5907+(-59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51849022.0, assembly_id=51848980.0))
lhcb1.new("mcbv.28r3.b1", "mcbv", at="1348.1837+(-59-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51849024.0, assembly_id=51848980.0))
lhcb1.new("mb.a29r3.b1", "mb", at="1356.7607+(-59.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828942.0, assembly_id=102661.0))
lhcb1.new("mcs.a29r3.b1", "mcs", at="1364.1847+(-60-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244165.0, assembly_id=102661.0))
lhcb1.new("mco.29r3.b1", "mco", at="1364.9347+(-60-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250752.0, assembly_id=102662.0))
lhcb1.new("mcd.29r3.b1", "mcd", at="1364.9362+(-60-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250753.0, assembly_id=102662.0))
lhcb1.new("mb.b29r3.b1", "mb", at="1372.4207+(-60.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828966.0, assembly_id=102662.0))
lhcb1.new("mcs.b29r3.b1", "mcs", at="1379.8447+(-61-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244170.0, assembly_id=102662.0))
lhcb1.new("mb.c29r3.b1", "mb", at="1388.0807+(-61.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52828990.0, assembly_id=102663.0))
lhcb1.new("mcs.c29r3.b1", "mcs", at="1395.5047+(-62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244173.0, assembly_id=102663.0))
lhcb1.new("bpm.29r3.b1", "bpm", at="1396.3837+(-62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244175.0, assembly_id=102664.0))
lhcb1.new("mo.29r3.b1", "mo", at="1397.1347+(-62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308732.0, assembly_id=102664.0))
lhcb1.new("mq.29r3.b1", "mq", at="1399.1457+(-62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308025.0, assembly_id=102664.0))
lhcb1.new("mss.29r3.b1", "mss_unplugged", at="1401.0407+(-62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250755.0, assembly_id=102664.0))
lhcb1.new("mcbh.29r3.b1", "mcbh", at="1401.6337+(-62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250757.0, assembly_id=102664.0))
lhcb1.new("mco.a30r3.b1", "mco", at="1402.7247+(-62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250760.0, assembly_id=102665.0))
lhcb1.new("mcd.a30r3.b1", "mcd", at="1402.7262+(-62-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250761.0, assembly_id=102665.0))
lhcb1.new("mb.a30r3.b1", "mb", at="1410.2107+(-62.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829014.0, assembly_id=102665.0))
lhcb1.new("mcs.a30r3.b1", "mcs", at="1417.6347+(-63-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244183.0, assembly_id=102665.0))
lhcb1.new("mb.b30r3.b1", "mb", at="1425.8707+(-63.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829038.0, assembly_id=102666.0))
lhcb1.new("mcs.b30r3.b1", "mcs", at="1433.2947+(-64-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244186.0, assembly_id=102666.0))
lhcb1.new("mco.b30r3.b1", "mco", at="1434.0447+(-64-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250764.0, assembly_id=102667.0))
lhcb1.new("mcd.b30r3.b1", "mcd", at="1434.0462+(-64-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250765.0, assembly_id=102667.0))
lhcb1.new("mb.c30r3.b1", "mb", at="1441.5307+(-64.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829062.0, assembly_id=102667.0))
lhcb1.new("mcs.c30r3.b1", "mcs", at="1448.9547+(-65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244191.0, assembly_id=102667.0))
lhcb1.new("bpm.30r3.b1", "bpm", at="1449.8337+(-65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244193.0, assembly_id=102668.0))
lhcb1.new("mo.30r3.b1", "mo", at="1450.5847+(-65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308763.0, assembly_id=102668.0))
lhcb1.new("mq.30r3.b1", "mq", at="1452.5957+(-65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308055.0, assembly_id=102668.0))
lhcb1.new("ms.30r3.b1", "ms", at="1454.4907+(-65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250767.0, assembly_id=102668.0))
lhcb1.new("mcbv.30r3.b1", "mcbv", at="1455.0837+(-65-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250769.0, assembly_id=102668.0))
lhcb1.new("mb.a31r3.b1", "mb", at="1463.6607+(-65.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829086.0, assembly_id=102669.0))
lhcb1.new("mcs.a31r3.b1", "mcs", at="1471.0847+(-66-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244199.0, assembly_id=102669.0))
lhcb1.new("mco.31r3.b1", "mco", at="1471.8347+(-66-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250772.0, assembly_id=102670.0))
lhcb1.new("mcd.31r3.b1", "mcd", at="1471.8362+(-66-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250773.0, assembly_id=102670.0))
lhcb1.new("mb.b31r3.b1", "mb", at="1479.3207+(-66.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829110.0, assembly_id=102670.0))
lhcb1.new("mcs.b31r3.b1", "mcs", at="1486.7447+(-67-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244204.0, assembly_id=102670.0))
lhcb1.new("mb.c31r3.b1", "mb", at="1494.9807+(-67.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829134.0, assembly_id=102671.0))
lhcb1.new("mcs.c31r3.b1", "mcs", at="1502.4047+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244207.0, assembly_id=102671.0))
lhcb1.new("bpm.31r3.b1", "bpm", at="1503.2837+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244209.0, assembly_id=102672.0))
lhcb1.new("mo.31r3.b1", "mo", at="1504.0347+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308793.0, assembly_id=102672.0))
lhcb1.new("mq.31r3.b1", "mq", at="1506.0457+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308084.0, assembly_id=102672.0))
lhcb1.new("ms.31r3.b1", "ms", at="1507.9407+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250775.0, assembly_id=102672.0))
lhcb1.new("mcbh.31r3.b1", "mcbh", at="1508.5337+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250777.0, assembly_id=102672.0))
lhcb1.new("s.cell.34.b1", "omk", at="1509.2807+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a32r3.b1", "mco", at="1509.6247+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250780.0, assembly_id=102673.0))
lhcb1.new("mcd.a32r3.b1", "mcd", at="1509.6262+(-68-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250781.0, assembly_id=102673.0))
lhcb1.new("mb.a32r3.b1", "mb", at="1517.1107+(-68.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829158.0, assembly_id=102673.0))
lhcb1.new("mcs.a32r3.b1", "mcs", at="1524.5347+(-69-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244217.0, assembly_id=102673.0))
lhcb1.new("mb.b32r3.b1", "mb", at="1532.7707+(-69.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829182.0, assembly_id=102674.0))
lhcb1.new("mcs.b32r3.b1", "mcs", at="1540.1947+(-70-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244220.0, assembly_id=102674.0))
lhcb1.new("mco.b32r3.b1", "mco", at="1540.9447+(-70-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250784.0, assembly_id=102675.0))
lhcb1.new("mcd.b32r3.b1", "mcd", at="1540.9462+(-70-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250785.0, assembly_id=102675.0))
lhcb1.new("mb.c32r3.b1", "mb", at="1548.4307+(-70.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829206.0, assembly_id=102675.0))
lhcb1.new("mcs.c32r3.b1", "mcs", at="1555.8547+(-71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244225.0, assembly_id=102675.0))
lhcb1.new("bpm.32r3.b1", "bpm", at="1556.7337+(-71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51851050.0, assembly_id=51851014.0))
lhcb1.new("mo.32r3.b1", "mo", at="1557.4877+(-71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51851082.0, assembly_id=51851014.0))
lhcb1.new("mq.32r3.b1", "mq", at="1559.4957+(-71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51851084.0, assembly_id=51851014.0))
lhcb1.new("ms.32r3.b1", "ms", at="1561.3907+(-71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51851055.0, assembly_id=51851014.0))
lhcb1.new("mcbv.32r3.b1", "mcbv", at="1561.9837+(-71-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=51851057.0, assembly_id=51851014.0))
lhcb1.new("mb.a33r3.b1", "mb", at="1570.5607+(-71.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829230.0, assembly_id=102677.0))
lhcb1.new("mcs.a33r3.b1", "mcs", at="1577.9847+(-72-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244233.0, assembly_id=102677.0))
lhcb1.new("mco.33r3.b1", "mco", at="1578.7347+(-72-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250792.0, assembly_id=102678.0))
lhcb1.new("mcd.33r3.b1", "mcd", at="1578.7362+(-72-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250793.0, assembly_id=102678.0))
lhcb1.new("mb.b33r3.b1", "mb", at="1586.2207+(-72.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829254.0, assembly_id=102678.0))
lhcb1.new("mcs.b33r3.b1", "mcs", at="1593.6447+(-73-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244238.0, assembly_id=102678.0))
lhcb1.new("mb.c33r3.b1", "mb", at="1601.8807+(-73.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829278.0, assembly_id=102679.0))
lhcb1.new("mcs.c33r3.b1", "mcs", at="1609.3047+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244241.0, assembly_id=102679.0))
lhcb1.new("bpm.33r3.b1", "bpm", at="1610.1837+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244243.0, assembly_id=102680.0))
lhcb1.new("mo.33r3.b1", "mo", at="1610.9347+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308616.0, assembly_id=102680.0))
lhcb1.new("mq.33r3.b1", "mq", at="1612.9457+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307906.0, assembly_id=102680.0))
lhcb1.new("mss.33r3.b1", "mss_unplugged", at="1614.8407+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250795.0, assembly_id=102680.0))
lhcb1.new("mcbh.33r3.b1", "mcbh", at="1615.4337+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250797.0, assembly_id=102680.0))
lhcb1.new("e.cell.34.b1", "omk", at="1616.1807+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a34r3.b1", "mco", at="1616.5247+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250800.0, assembly_id=102681.0))
lhcb1.new("mcd.a34r3.b1", "mcd", at="1616.5262+(-74-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250801.0, assembly_id=102681.0))
lhcb1.new("mb.a34r3.b1", "mb", at="1624.0107+(-74.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829302.0, assembly_id=102681.0))
lhcb1.new("mcs.a34r3.b1", "mcs", at="1631.4347+(-75-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244251.0, assembly_id=102681.0))
lhcb1.new("mb.b34r3.b1", "mb", at="1639.6707+(-75.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829326.0, assembly_id=102682.0))
lhcb1.new("mcs.b34r3.b1", "mcs", at="1647.0947+(-76-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244254.0, assembly_id=102682.0))
lhcb1.new("mco.b34r3.b1", "mco", at="1647.8447+(-76-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250804.0, assembly_id=102683.0))
lhcb1.new("mcd.b34r3.b1", "mcd", at="1647.8462+(-76-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=250805.0, assembly_id=102683.0))
lhcb1.new("mb.c34r3.b1", "mb", at="1655.3307+(-76.5-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=52829350.0, assembly_id=102683.0))
lhcb1.new("mcs.c34r3.b1", "mcs", at="1662.7547+(-77-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244259.0, assembly_id=102683.0))
lhcb1.new("bpm.34r3.b1", "bpm", at="1663.6337+(-77-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=244261.0, assembly_id=102684.0))
lhcb1.new("mo.34r3.b1", "mo", at="1664.3847+(-77-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2308631.0, assembly_id=102684.0))
lhcb1.new("mq.34r3.b1", "mq", at="1666.3957+(-77-ip3ofs.b1)*ds", from_="ip3", extra=dict(mech_sep=-0.194, slot_id=2307921.0, assembly_id=102684.0))
lhcb1.new("ms.34l4.b1", "ms", at="-1664.0697+(-77-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250807.0, assembly_id=102684.0))
lhcb1.new("mcbv.34l4.b1", "mcbv", at="-1663.4767+(-77-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250809.0, assembly_id=102684.0))
lhcb1.new("mb.c34l4.b1", "mb", at="-1654.8997+(-77.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829374.0, assembly_id=102685.0))
lhcb1.new("mcs.c34l4.b1", "mcs", at="-1647.4757+(-78-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244267.0, assembly_id=102685.0))
lhcb1.new("mco.34l4.b1", "mco", at="-1646.7257+(-78-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250812.0, assembly_id=102686.0))
lhcb1.new("mcd.34l4.b1", "mcd", at="-1646.7242+(-78-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250813.0, assembly_id=102686.0))
lhcb1.new("mb.b34l4.b1", "mb", at="-1639.2397+(-78.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829398.0, assembly_id=102686.0))
lhcb1.new("mcs.b34l4.b1", "mcs", at="-1631.8157+(-79-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244272.0, assembly_id=102686.0))
lhcb1.new("mb.a34l4.b1", "mb", at="-1623.5797+(-79.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829422.0, assembly_id=102687.0))
lhcb1.new("mcs.a34l4.b1", "mcs", at="-1616.1557+(-80-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244275.0, assembly_id=102687.0))
lhcb1.new("bpm.33l4.b1", "bpm", at="-1615.2767+(-80-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244277.0, assembly_id=102688.0))
lhcb1.new("mo.33l4.b1", "mo", at="-1614.5257+(-80-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308603.0, assembly_id=102688.0))
lhcb1.new("mq.33l4.b1", "mq", at="-1612.5147+(-80-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307893.0, assembly_id=102688.0))
lhcb1.new("mss.33l4.b1", "mss_unplugged", at="-1610.6197+(-80-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250815.0, assembly_id=102688.0))
lhcb1.new("mcbh.33l4.b1", "mcbh", at="-1610.0267+(-80-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250817.0, assembly_id=102688.0))
lhcb1.new("mco.b33l4.b1", "mco", at="-1608.9357+(-80-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250820.0, assembly_id=102689.0))
lhcb1.new("mcd.b33l4.b1", "mcd", at="-1608.9342+(-80-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250821.0, assembly_id=102689.0))
lhcb1.new("mb.c33l4.b1", "mb", at="-1601.4497+(-80.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829446.0, assembly_id=102689.0))
lhcb1.new("mcs.c33l4.b1", "mcs", at="-1594.0257+(-81-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244285.0, assembly_id=102689.0))
lhcb1.new("mb.b33l4.b1", "mb", at="-1585.7897+(-81.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829470.0, assembly_id=102690.0))
lhcb1.new("mcs.b33l4.b1", "mcs", at="-1578.3657+(-82-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244288.0, assembly_id=102690.0))
lhcb1.new("mco.a33l4.b1", "mco", at="-1577.6157+(-82-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250824.0, assembly_id=102691.0))
lhcb1.new("mcd.a33l4.b1", "mcd", at="-1577.6142+(-82-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250825.0, assembly_id=102691.0))
lhcb1.new("mb.a33l4.b1", "mb", at="-1570.1297+(-82.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829494.0, assembly_id=102691.0))
lhcb1.new("mcs.a33l4.b1", "mcs", at="-1562.7057+(-83-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244293.0, assembly_id=102691.0))
lhcb1.new("bpm.32l4.b1", "bpm", at="-1561.8267+(-83-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244295.0, assembly_id=102692.0))
lhcb1.new("mo.32l4.b1", "mo", at="-1561.0757+(-83-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308571.0, assembly_id=102692.0))
lhcb1.new("mq.32l4.b1", "mq", at="-1559.0647+(-83-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307863.0, assembly_id=102692.0))
lhcb1.new("ms.32l4.b1", "ms", at="-1557.1697+(-83-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250827.0, assembly_id=102692.0))
lhcb1.new("mcbv.32l4.b1", "mcbv", at="-1556.5767+(-83-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250829.0, assembly_id=102692.0))
lhcb1.new("mb.c32l4.b1", "mb", at="-1547.9997+(-83.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829518.0, assembly_id=102693.0))
lhcb1.new("mcs.c32l4.b1", "mcs", at="-1540.5757+(-84-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244301.0, assembly_id=102693.0))
lhcb1.new("mco.32l4.b1", "mco", at="-1539.8257+(-84-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250832.0, assembly_id=102694.0))
lhcb1.new("mcd.32l4.b1", "mcd", at="-1539.8242+(-84-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250833.0, assembly_id=102694.0))
lhcb1.new("mb.b32l4.b1", "mb", at="-1532.3397+(-84.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829542.0, assembly_id=102694.0))
lhcb1.new("mcs.b32l4.b1", "mcs", at="-1524.9157+(-85-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244306.0, assembly_id=102694.0))
lhcb1.new("mb.a32l4.b1", "mb", at="-1516.6797+(-85.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829566.0, assembly_id=102695.0))
lhcb1.new("mcs.a32l4.b1", "mcs", at="-1509.2557+(-86-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244309.0, assembly_id=102695.0))
lhcb1.new("bpm.31l4.b1", "bpm", at="-1508.3767+(-86-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244311.0, assembly_id=102696.0))
lhcb1.new("mo.31l4.b1", "mo", at="-1507.6257+(-86-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308780.0, assembly_id=102696.0))
lhcb1.new("mq.31l4.b1", "mq", at="-1505.6147+(-86-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308071.0, assembly_id=102696.0))
lhcb1.new("ms.31l4.b1", "ms", at="-1503.7197+(-86-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250835.0, assembly_id=102696.0))
lhcb1.new("mcbh.31l4.b1", "mcbh", at="-1503.1267+(-86-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250837.0, assembly_id=102696.0))
lhcb1.new("mco.b31l4.b1", "mco", at="-1502.0357+(-86-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250840.0, assembly_id=102697.0))
lhcb1.new("mcd.b31l4.b1", "mcd", at="-1502.0342+(-86-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250841.0, assembly_id=102697.0))
lhcb1.new("mb.c31l4.b1", "mb", at="-1494.5497+(-86.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829590.0, assembly_id=102697.0))
lhcb1.new("mcs.c31l4.b1", "mcs", at="-1487.1257+(-87-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244319.0, assembly_id=102697.0))
lhcb1.new("mb.b31l4.b1", "mb", at="-1478.8897+(-87.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829614.0, assembly_id=102698.0))
lhcb1.new("mcs.b31l4.b1", "mcs", at="-1471.4657+(-88-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244322.0, assembly_id=102698.0))
lhcb1.new("mco.a31l4.b1", "mco", at="-1470.7157+(-88-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250844.0, assembly_id=102699.0))
lhcb1.new("mcd.a31l4.b1", "mcd", at="-1470.7142+(-88-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250845.0, assembly_id=102699.0))
lhcb1.new("mb.a31l4.b1", "mb", at="-1463.2297+(-88.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829638.0, assembly_id=102699.0))
lhcb1.new("mcs.a31l4.b1", "mcs", at="-1455.8057+(-89-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244327.0, assembly_id=102699.0))
lhcb1.new("bpm.30l4.b1", "bpm", at="-1454.9267+(-89-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244329.0, assembly_id=102700.0))
lhcb1.new("mo.30l4.b1", "mo", at="-1454.1757+(-89-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308750.0, assembly_id=102700.0))
lhcb1.new("mq.30l4.b1", "mq", at="-1452.1647+(-89-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308042.0, assembly_id=102700.0))
lhcb1.new("ms.30l4.b1", "ms", at="-1450.2697+(-89-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250847.0, assembly_id=102700.0))
lhcb1.new("mcbv.30l4.b1", "mcbv", at="-1449.6767+(-89-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250849.0, assembly_id=102700.0))
lhcb1.new("mb.c30l4.b1", "mb", at="-1441.0997+(-89.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829662.0, assembly_id=102701.0))
lhcb1.new("mcs.c30l4.b1", "mcs", at="-1433.6757+(-90-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244335.0, assembly_id=102701.0))
lhcb1.new("mco.30l4.b1", "mco", at="-1432.9257+(-90-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250852.0, assembly_id=102702.0))
lhcb1.new("mcd.30l4.b1", "mcd", at="-1432.9242+(-90-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250853.0, assembly_id=102702.0))
lhcb1.new("mb.b30l4.b1", "mb", at="-1425.4397+(-90.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829686.0, assembly_id=102702.0))
lhcb1.new("mcs.b30l4.b1", "mcs", at="-1418.0157+(-91-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244340.0, assembly_id=102702.0))
lhcb1.new("mb.a30l4.b1", "mb", at="-1409.7797+(-91.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829710.0, assembly_id=102703.0))
lhcb1.new("mcs.a30l4.b1", "mcs", at="-1402.3557+(-92-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244343.0, assembly_id=102703.0))
lhcb1.new("bpm.29l4.b1", "bpm", at="-1401.4767+(-92-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244345.0, assembly_id=102704.0))
lhcb1.new("mo.29l4.b1", "mo", at="-1400.7257+(-92-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308718.0, assembly_id=102704.0))
lhcb1.new("mq.29l4.b1", "mq", at="-1398.7147+(-92-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308012.0, assembly_id=102704.0))
lhcb1.new("mss.29l4.b1", "mss_unplugged", at="-1396.8197+(-92-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250855.0, assembly_id=102704.0))
lhcb1.new("mcbh.29l4.b1", "mcbh", at="-1396.2267+(-92-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250857.0, assembly_id=102704.0))
lhcb1.new("mco.b29l4.b1", "mco", at="-1395.1357+(-92-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250860.0, assembly_id=102705.0))
lhcb1.new("mcd.b29l4.b1", "mcd", at="-1395.1342+(-92-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250861.0, assembly_id=102705.0))
lhcb1.new("mb.c29l4.b1", "mb", at="-1387.6497+(-92.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829734.0, assembly_id=102705.0))
lhcb1.new("mcs.c29l4.b1", "mcs", at="-1380.2257+(-93-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244353.0, assembly_id=102705.0))
lhcb1.new("mb.b29l4.b1", "mb", at="-1371.9897+(-93.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829758.0, assembly_id=102706.0))
lhcb1.new("mcs.b29l4.b1", "mcs", at="-1364.5657+(-94-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244356.0, assembly_id=102706.0))
lhcb1.new("mco.a29l4.b1", "mco", at="-1363.8157+(-94-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250864.0, assembly_id=102707.0))
lhcb1.new("mcd.a29l4.b1", "mcd", at="-1363.8142+(-94-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250865.0, assembly_id=102707.0))
lhcb1.new("mb.a29l4.b1", "mb", at="-1356.3297+(-94.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829782.0, assembly_id=102707.0))
lhcb1.new("mcs.a29l4.b1", "mcs", at="-1348.9057+(-95-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244361.0, assembly_id=102707.0))
lhcb1.new("bpm.28l4.b1", "bpm", at="-1348.0267+(-95-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244363.0, assembly_id=102708.0))
lhcb1.new("mo.28l4.b1", "mo", at="-1347.2757+(-95-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308687.0, assembly_id=102708.0))
lhcb1.new("mq.28l4.b1", "mq", at="-1345.2647+(-95-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307980.0, assembly_id=102708.0))
lhcb1.new("ms.28l4.b1", "ms", at="-1343.3697+(-95-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250867.0, assembly_id=102708.0))
lhcb1.new("mcbv.28l4.b1", "mcbv", at="-1342.7767+(-95-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250869.0, assembly_id=102708.0))
lhcb1.new("mb.c28l4.b1", "mb", at="-1334.1997+(-95.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829806.0, assembly_id=102709.0))
lhcb1.new("mcs.c28l4.b1", "mcs", at="-1326.7757+(-96-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244369.0, assembly_id=102709.0))
lhcb1.new("mco.28l4.b1", "mco", at="-1326.0257+(-96-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250872.0, assembly_id=102710.0))
lhcb1.new("mcd.28l4.b1", "mcd", at="-1326.0242+(-96-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250873.0, assembly_id=102710.0))
lhcb1.new("mb.b28l4.b1", "mb", at="-1318.5397+(-96.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829830.0, assembly_id=102710.0))
lhcb1.new("mcs.b28l4.b1", "mcs", at="-1311.1157+(-97-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244374.0, assembly_id=102710.0))
lhcb1.new("mb.a28l4.b1", "mb", at="-1302.8797+(-97.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829854.0, assembly_id=102711.0))
lhcb1.new("mcs.a28l4.b1", "mcs", at="-1295.4557+(-98-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244377.0, assembly_id=102711.0))
lhcb1.new("bpm.27l4.b1", "bpm", at="-1294.5767+(-98-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244379.0, assembly_id=102712.0))
lhcb1.new("mqs.27l4.b1", "mqs", at="-1293.8227+(-98-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307657.0, assembly_id=102712.0))
lhcb1.new("mq.27l4.b1", "mq", at="-1291.8147+(-98-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308190.0, assembly_id=102712.0))
lhcb1.new("ms.27l4.b1", "ms", at="-1289.9197+(-98-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250875.0, assembly_id=102712.0))
lhcb1.new("mcbh.27l4.b1", "mcbh", at="-1289.3267+(-98-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250877.0, assembly_id=102712.0))
lhcb1.new("mco.b27l4.b1", "mco", at="-1288.2357+(-98-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250880.0, assembly_id=102713.0))
lhcb1.new("mcd.b27l4.b1", "mcd", at="-1288.2342+(-98-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250881.0, assembly_id=102713.0))
lhcb1.new("mb.c27l4.b1", "mb", at="-1280.7497+(-98.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829878.0, assembly_id=102713.0))
lhcb1.new("mcs.c27l4.b1", "mcs", at="-1273.3257+(-99-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244387.0, assembly_id=102713.0))
lhcb1.new("mb.b27l4.b1", "mb", at="-1265.0897+(-99.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829902.0, assembly_id=102714.0))
lhcb1.new("mcs.b27l4.b1", "mcs", at="-1257.6657+(-100-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244390.0, assembly_id=102714.0))
lhcb1.new("mco.a27l4.b1", "mco", at="-1256.9157+(-100-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250884.0, assembly_id=102715.0))
lhcb1.new("mcd.a27l4.b1", "mcd", at="-1256.9142+(-100-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250885.0, assembly_id=102715.0))
lhcb1.new("mb.a27l4.b1", "mb", at="-1249.4297+(-100.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829926.0, assembly_id=102715.0))
lhcb1.new("mcs.a27l4.b1", "mcs", at="-1242.0057+(-101-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244395.0, assembly_id=102715.0))
lhcb1.new("bpm.26l4.b1", "bpm", at="-1241.1267+(-101-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244397.0, assembly_id=102716.0))
lhcb1.new("mo.26l4.b1", "mo", at="-1240.3757+(-101-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308897.0, assembly_id=102716.0))
lhcb1.new("mq.26l4.b1", "mq", at="-1238.3647+(-101-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308160.0, assembly_id=102716.0))
lhcb1.new("ms.26l4.b1", "ms", at="-1236.4697+(-101-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250887.0, assembly_id=102716.0))
lhcb1.new("mcbv.26l4.b1", "mcbv", at="-1235.8767+(-101-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250889.0, assembly_id=102716.0))
lhcb1.new("mb.c26l4.b1", "mb", at="-1227.2997+(-101.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829950.0, assembly_id=102717.0))
lhcb1.new("mcs.c26l4.b1", "mcs", at="-1219.8757+(-102-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244403.0, assembly_id=102717.0))
lhcb1.new("mco.26l4.b1", "mco", at="-1219.1257+(-102-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250892.0, assembly_id=102718.0))
lhcb1.new("mcd.26l4.b1", "mcd", at="-1219.1242+(-102-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250893.0, assembly_id=102718.0))
lhcb1.new("mb.b26l4.b1", "mb", at="-1211.6397+(-102.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829974.0, assembly_id=102718.0))
lhcb1.new("mcs.b26l4.b1", "mcs", at="-1204.2157+(-103-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244408.0, assembly_id=102718.0))
lhcb1.new("mb.a26l4.b1", "mb", at="-1195.9797+(-103.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52829998.0, assembly_id=102719.0))
lhcb1.new("mcs.a26l4.b1", "mcs", at="-1188.5557+(-104-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244411.0, assembly_id=102719.0))
lhcb1.new("bpm.25l4.b1", "bpm", at="-1187.6767+(-104-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244413.0, assembly_id=102720.0))
lhcb1.new("mo.25l4.b1", "mo", at="-1186.9257+(-104-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308865.0, assembly_id=102720.0))
lhcb1.new("mq.25l4.b1", "mq", at="-1184.9147+(-104-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308128.0, assembly_id=102720.0))
lhcb1.new("ms.25l4.b1", "ms", at="-1183.0197+(-104-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250895.0, assembly_id=102720.0))
lhcb1.new("mcbh.25l4.b1", "mcbh", at="-1182.4267+(-104-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250897.0, assembly_id=102720.0))
lhcb1.new("mco.b25l4.b1", "mco", at="-1181.3357+(-104-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250900.0, assembly_id=102721.0))
lhcb1.new("mcd.b25l4.b1", "mcd", at="-1181.3342+(-104-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250901.0, assembly_id=102721.0))
lhcb1.new("mb.c25l4.b1", "mb", at="-1173.8497+(-104.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830022.0, assembly_id=102721.0))
lhcb1.new("mcs.c25l4.b1", "mcs", at="-1166.4257+(-105-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244421.0, assembly_id=102721.0))
lhcb1.new("mb.b25l4.b1", "mb", at="-1158.1897+(-105.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830046.0, assembly_id=102722.0))
lhcb1.new("mcs.b25l4.b1", "mcs", at="-1150.7657+(-106-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244424.0, assembly_id=102722.0))
lhcb1.new("mco.a25l4.b1", "mco", at="-1150.0157+(-106-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250904.0, assembly_id=102723.0))
lhcb1.new("mcd.a25l4.b1", "mcd", at="-1150.0142+(-106-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250905.0, assembly_id=102723.0))
lhcb1.new("mb.a25l4.b1", "mb", at="-1142.5297+(-106.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830070.0, assembly_id=102723.0))
lhcb1.new("mcs.a25l4.b1", "mcs", at="-1135.1057+(-107-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244429.0, assembly_id=102723.0))
lhcb1.new("bpm.24l4.b1", "bpm", at="-1134.2267+(-107-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244431.0, assembly_id=102724.0))
lhcb1.new("mo.24l4.b1", "mo", at="-1133.4757+(-107-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308834.0, assembly_id=102724.0))
lhcb1.new("mq.24l4.b1", "mq", at="-1131.4647+(-107-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308096.0, assembly_id=102724.0))
lhcb1.new("ms.24l4.b1", "ms", at="-1129.5697+(-107-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250907.0, assembly_id=102724.0))
lhcb1.new("mcbv.24l4.b1", "mcbv", at="-1128.9767+(-107-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250909.0, assembly_id=102724.0))
lhcb1.new("mb.c24l4.b1", "mb", at="-1120.3997+(-107.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830094.0, assembly_id=102725.0))
lhcb1.new("mcs.c24l4.b1", "mcs", at="-1112.9757+(-108-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244437.0, assembly_id=102725.0))
lhcb1.new("mco.24l4.b1", "mco", at="-1112.2257+(-108-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250912.0, assembly_id=102726.0))
lhcb1.new("mcd.24l4.b1", "mcd", at="-1112.2242+(-108-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250913.0, assembly_id=102726.0))
lhcb1.new("mb.b24l4.b1", "mb", at="-1104.7397+(-108.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830118.0, assembly_id=102726.0))
lhcb1.new("mcs.b24l4.b1", "mcs", at="-1097.3157+(-109-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244442.0, assembly_id=102726.0))
lhcb1.new("mb.a24l4.b1", "mb", at="-1089.0797+(-109.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830142.0, assembly_id=102727.0))
lhcb1.new("mcs.a24l4.b1", "mcs", at="-1081.6557+(-110-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244445.0, assembly_id=102727.0))
lhcb1.new("bpm.23l4.b1", "bpm", at="-1080.7767+(-110-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=266529.0, assembly_id=102728.0))
lhcb1.new("mqs.23l4.b1", "mqs", at="-1080.0227+(-110-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307626.0, assembly_id=102728.0))
lhcb1.new("mq.23l4.b1", "mq", at="-1078.0147+(-110-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308307.0, assembly_id=102728.0))
lhcb1.new("ms.23l4.b1", "ms", at="-1076.1197+(-110-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250915.0, assembly_id=102728.0))
lhcb1.new("mcbh.23l4.b1", "mcbh", at="-1075.5267+(-110-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250917.0, assembly_id=102728.0))
lhcb1.new("mco.b23l4.b1", "mco", at="-1074.4357+(-110-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250920.0, assembly_id=102729.0))
lhcb1.new("mcd.b23l4.b1", "mcd", at="-1074.4342+(-110-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250921.0, assembly_id=102729.0))
lhcb1.new("mb.c23l4.b1", "mb", at="-1066.9497+(-110.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830166.0, assembly_id=102729.0))
lhcb1.new("mcs.c23l4.b1", "mcs", at="-1059.5257+(-111-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244453.0, assembly_id=102729.0))
lhcb1.new("mb.b23l4.b1", "mb", at="-1051.2897+(-111.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830190.0, assembly_id=102730.0))
lhcb1.new("mcs.b23l4.b1", "mcs", at="-1043.8657+(-112-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244456.0, assembly_id=102730.0))
lhcb1.new("mco.a23l4.b1", "mco", at="-1043.1157+(-112-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250924.0, assembly_id=102731.0))
lhcb1.new("mcd.a23l4.b1", "mcd", at="-1043.1142+(-112-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250925.0, assembly_id=102731.0))
lhcb1.new("mb.a23l4.b1", "mb", at="-1035.6297+(-112.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830214.0, assembly_id=102731.0))
lhcb1.new("mcs.a23l4.b1", "mcs", at="-1028.2057+(-113-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244461.0, assembly_id=102731.0))
lhcb1.new("bpm.22l4.b1", "bpm", at="-1027.3267+(-113-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244463.0, assembly_id=102732.0))
lhcb1.new("mo.22l4.b1", "mo", at="-1026.5757+(-113-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308804.0, assembly_id=102732.0))
lhcb1.new("mq.22l4.b1", "mq", at="-1024.5647+(-113-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308275.0, assembly_id=102732.0))
lhcb1.new("ms.22l4.b1", "ms", at="-1022.6697+(-113-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250927.0, assembly_id=102732.0))
lhcb1.new("mcbv.22l4.b1", "mcbv", at="-1022.0767+(-113-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250929.0, assembly_id=102732.0))
lhcb1.new("mb.c22l4.b1", "mb", at="-1013.4997+(-113.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830238.0, assembly_id=102733.0))
lhcb1.new("mcs.c22l4.b1", "mcs", at="-1006.0757+(-114-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244469.0, assembly_id=102733.0))
lhcb1.new("mco.22l4.b1", "mco", at="-1005.3257+(-114-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250932.0, assembly_id=102734.0))
lhcb1.new("mcd.22l4.b1", "mcd", at="-1005.3242+(-114-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250933.0, assembly_id=102734.0))
lhcb1.new("mb.b22l4.b1", "mb", at="-997.8397+(-114.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830262.0, assembly_id=102734.0))
lhcb1.new("mcs.b22l4.b1", "mcs", at="-990.4157+(-115-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244474.0, assembly_id=102734.0))
lhcb1.new("mb.a22l4.b1", "mb", at="-982.1797+(-115.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830286.0, assembly_id=102735.0))
lhcb1.new("mcs.a22l4.b1", "mcs", at="-974.7557+(-116-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244477.0, assembly_id=102735.0))
lhcb1.new("bpm.21l4.b1", "bpm", at="-973.8767+(-116-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244479.0, assembly_id=102736.0))
lhcb1.new("mqt.21l4.b1", "mqt", at="-973.1227+(-116-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307259.0, assembly_id=102736.0))
lhcb1.new("mq.21l4.b1", "mq", at="-971.1147+(-116-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2348476.0, assembly_id=102736.0))
lhcb1.new("ms.21l4.b1", "ms", at="-969.2197+(-116-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250935.0, assembly_id=102736.0))
lhcb1.new("mcbh.21l4.b1", "mcbh", at="-968.6267+(-116-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250937.0, assembly_id=102736.0))
lhcb1.new("mco.b21l4.b1", "mco", at="-967.5357+(-116-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250940.0, assembly_id=102737.0))
lhcb1.new("mcd.b21l4.b1", "mcd", at="-967.5342+(-116-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250941.0, assembly_id=102737.0))
lhcb1.new("mb.c21l4.b1", "mb", at="-960.0497+(-116.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830310.0, assembly_id=102737.0))
lhcb1.new("mcs.c21l4.b1", "mcs", at="-952.6257+(-117-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244487.0, assembly_id=102737.0))
lhcb1.new("mb.b21l4.b1", "mb", at="-944.3897+(-117.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830334.0, assembly_id=102738.0))
lhcb1.new("mcs.b21l4.b1", "mcs", at="-936.9657+(-118-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244490.0, assembly_id=102738.0))
lhcb1.new("mco.a21l4.b1", "mco", at="-936.2157+(-118-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250944.0, assembly_id=102739.0))
lhcb1.new("mcd.a21l4.b1", "mcd", at="-936.2142+(-118-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250945.0, assembly_id=102739.0))
lhcb1.new("mb.a21l4.b1", "mb", at="-928.7297+(-118.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830358.0, assembly_id=102739.0))
lhcb1.new("mcs.a21l4.b1", "mcs", at="-921.3057+(-119-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244495.0, assembly_id=102739.0))
lhcb1.new("bpm.20l4.b1", "bpm", at="-920.4267+(-119-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244497.0, assembly_id=102740.0))
lhcb1.new("mqt.20l4.b1", "mqt", at="-919.6727+(-119-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307462.0, assembly_id=102740.0))
lhcb1.new("mq.20l4.b1", "mq", at="-917.6647+(-119-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308214.0, assembly_id=102740.0))
lhcb1.new("ms.20l4.b1", "ms", at="-915.7697+(-119-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250947.0, assembly_id=102740.0))
lhcb1.new("mcbv.20l4.b1", "mcbv", at="-915.1767+(-119-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250949.0, assembly_id=102740.0))
lhcb1.new("mb.c20l4.b1", "mb", at="-906.5997+(-119.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830382.0, assembly_id=102741.0))
lhcb1.new("mcs.c20l4.b1", "mcs", at="-899.1757+(-120-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244503.0, assembly_id=102741.0))
lhcb1.new("mco.20l4.b1", "mco", at="-898.4257+(-120-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250952.0, assembly_id=102742.0))
lhcb1.new("mcd.20l4.b1", "mcd", at="-898.4242+(-120-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250953.0, assembly_id=102742.0))
lhcb1.new("mb.b20l4.b1", "mb", at="-890.9397+(-120.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830406.0, assembly_id=102742.0))
lhcb1.new("mcs.b20l4.b1", "mcs", at="-883.5157+(-121-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244508.0, assembly_id=102742.0))
lhcb1.new("mb.a20l4.b1", "mb", at="-875.2797+(-121.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830430.0, assembly_id=102743.0))
lhcb1.new("mcs.a20l4.b1", "mcs", at="-867.8557+(-122-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244511.0, assembly_id=102743.0))
lhcb1.new("bpm.19l4.b1", "bpm", at="-866.9767+(-122-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244513.0, assembly_id=102744.0))
lhcb1.new("mqt.19l4.b1", "mqt", at="-866.2227+(-122-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2348439.0, assembly_id=102744.0))
lhcb1.new("mq.19l4.b1", "mq", at="-864.2147+(-122-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308422.0, assembly_id=102744.0))
lhcb1.new("ms.19l4.b1", "ms", at="-862.3197+(-122-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250955.0, assembly_id=102744.0))
lhcb1.new("mcbh.19l4.b1", "mcbh", at="-861.7267+(-122-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250957.0, assembly_id=102744.0))
lhcb1.new("mco.b19l4.b1", "mco", at="-860.6357+(-122-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250960.0, assembly_id=102745.0))
lhcb1.new("mcd.b19l4.b1", "mcd", at="-860.6342+(-122-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250961.0, assembly_id=102745.0))
lhcb1.new("mb.c19l4.b1", "mb", at="-853.1497+(-122.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830454.0, assembly_id=102745.0))
lhcb1.new("mcs.c19l4.b1", "mcs", at="-845.7257+(-123-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244521.0, assembly_id=102745.0))
lhcb1.new("mb.b19l4.b1", "mb", at="-837.4897+(-123.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830478.0, assembly_id=102746.0))
lhcb1.new("mcs.b19l4.b1", "mcs", at="-830.0657+(-124-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244524.0, assembly_id=102746.0))
lhcb1.new("mco.a19l4.b1", "mco", at="-829.3157+(-124-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250964.0, assembly_id=102747.0))
lhcb1.new("mcd.a19l4.b1", "mcd", at="-829.3142+(-124-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250965.0, assembly_id=102747.0))
lhcb1.new("mb.a19l4.b1", "mb", at="-821.8297+(-124.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830502.0, assembly_id=102747.0))
lhcb1.new("mcs.a19l4.b1", "mcs", at="-814.4057+(-125-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244529.0, assembly_id=102747.0))
lhcb1.new("bpm.18l4.b1", "bpm", at="-813.5267+(-125-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244531.0, assembly_id=102748.0))
lhcb1.new("mqt.18l4.b1", "mqt", at="-812.7727+(-125-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307401.0, assembly_id=102748.0))
lhcb1.new("mq.18l4.b1", "mq", at="-810.7647+(-125-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308391.0, assembly_id=102748.0))
lhcb1.new("ms.18l4.b1", "ms", at="-808.8697+(-125-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250967.0, assembly_id=102748.0))
lhcb1.new("mcbv.18l4.b1", "mcbv", at="-808.2767+(-125-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250969.0, assembly_id=102748.0))
lhcb1.new("mb.c18l4.b1", "mb", at="-799.6997+(-125.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830526.0, assembly_id=102749.0))
lhcb1.new("mcs.c18l4.b1", "mcs", at="-792.2757+(-126-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244537.0, assembly_id=102749.0))
lhcb1.new("mco.18l4.b1", "mco", at="-791.5257+(-126-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250972.0, assembly_id=102750.0))
lhcb1.new("mcd.18l4.b1", "mcd", at="-791.5242+(-126-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250973.0, assembly_id=102750.0))
lhcb1.new("mb.b18l4.b1", "mb", at="-784.0397+(-126.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830550.0, assembly_id=102750.0))
lhcb1.new("mcs.b18l4.b1", "mcs", at="-776.6157+(-127-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244542.0, assembly_id=102750.0))
lhcb1.new("mb.a18l4.b1", "mb", at="-768.3797+(-127.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830574.0, assembly_id=102751.0))
lhcb1.new("mcs.a18l4.b1", "mcs", at="-760.9557+(-128-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244545.0, assembly_id=102751.0))
lhcb1.new("bpm.17l4.b1", "bpm", at="-760.0767+(-128-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244547.0, assembly_id=102752.0))
lhcb1.new("mqt.17l4.b1", "mqt", at="-759.3227+(-128-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307606.0, assembly_id=102752.0))
lhcb1.new("mq.17l4.b1", "mq", at="-757.3147+(-128-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308361.0, assembly_id=102752.0))
lhcb1.new("ms.17l4.b1", "ms", at="-755.4197+(-128-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250975.0, assembly_id=102752.0))
lhcb1.new("mcbh.17l4.b1", "mcbh", at="-754.8267+(-128-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250977.0, assembly_id=102752.0))
lhcb1.new("mco.b17l4.b1", "mco", at="-753.7357+(-128-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250980.0, assembly_id=102753.0))
lhcb1.new("mcd.b17l4.b1", "mcd", at="-753.7342+(-128-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250981.0, assembly_id=102753.0))
lhcb1.new("mb.c17l4.b1", "mb", at="-746.2497+(-128.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830598.0, assembly_id=102753.0))
lhcb1.new("mcs.c17l4.b1", "mcs", at="-738.8257+(-129-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244555.0, assembly_id=102753.0))
lhcb1.new("mb.b17l4.b1", "mb", at="-730.5897+(-129.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830622.0, assembly_id=102754.0))
lhcb1.new("mcs.b17l4.b1", "mcs", at="-723.1657+(-130-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244558.0, assembly_id=102754.0))
lhcb1.new("mco.a17l4.b1", "mco", at="-722.4157+(-130-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250984.0, assembly_id=102755.0))
lhcb1.new("mcd.a17l4.b1", "mcd", at="-722.4142+(-130-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250985.0, assembly_id=102755.0))
lhcb1.new("mb.a17l4.b1", "mb", at="-714.9297+(-130.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830646.0, assembly_id=102755.0))
lhcb1.new("mcs.a17l4.b1", "mcs", at="-707.5057+(-131-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244563.0, assembly_id=102755.0))
lhcb1.new("bpm.16l4.b1", "bpm", at="-706.6267+(-131-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244565.0, assembly_id=102756.0))
lhcb1.new("mqt.16l4.b1", "mqt", at="-705.8727+(-131-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307576.0, assembly_id=102756.0))
lhcb1.new("mq.16l4.b1", "mq", at="-703.8647+(-131-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308331.0, assembly_id=102756.0))
lhcb1.new("ms.16l4.b1", "ms", at="-701.9697+(-131-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250987.0, assembly_id=102756.0))
lhcb1.new("mcbv.16l4.b1", "mcbv", at="-701.3767+(-131-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250989.0, assembly_id=102756.0))
lhcb1.new("mb.c16l4.b1", "mb", at="-692.7997+(-131.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830670.0, assembly_id=102757.0))
lhcb1.new("mcs.c16l4.b1", "mcs", at="-685.3757+(-132-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244571.0, assembly_id=102757.0))
lhcb1.new("mco.16l4.b1", "mco", at="-684.6257+(-132-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250992.0, assembly_id=102758.0))
lhcb1.new("mcd.16l4.b1", "mcd", at="-684.6242+(-132-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250993.0, assembly_id=102758.0))
lhcb1.new("mb.b16l4.b1", "mb", at="-677.1397+(-132.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830694.0, assembly_id=102758.0))
lhcb1.new("mcs.b16l4.b1", "mcs", at="-669.7157+(-133-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244576.0, assembly_id=102758.0))
lhcb1.new("mb.a16l4.b1", "mb", at="-661.4797+(-133.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830718.0, assembly_id=102759.0))
lhcb1.new("mcs.a16l4.b1", "mcs", at="-654.0557+(-134-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244579.0, assembly_id=102759.0))
lhcb1.new("bpm.15l4.b1", "bpm", at="-653.1767+(-134-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244581.0, assembly_id=102760.0))
lhcb1.new("mqt.15l4.b1", "mqt", at="-652.4227+(-134-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307545.0, assembly_id=102760.0))
lhcb1.new("mq.15l4.b1", "mq", at="-650.4147+(-134-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308538.0, assembly_id=102760.0))
lhcb1.new("ms.15l4.b1", "ms", at="-648.5197+(-134-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250995.0, assembly_id=102760.0))
lhcb1.new("mcbh.15l4.b1", "mcbh", at="-647.9267+(-134-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=250997.0, assembly_id=102760.0))
lhcb1.new("mco.b15l4.b1", "mco", at="-646.8357+(-134-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251000.0, assembly_id=102761.0))
lhcb1.new("mcd.b15l4.b1", "mcd", at="-646.8342+(-134-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251001.0, assembly_id=102761.0))
lhcb1.new("mb.c15l4.b1", "mb", at="-639.3497+(-134.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830742.0, assembly_id=102761.0))
lhcb1.new("mcs.c15l4.b1", "mcs", at="-631.9257+(-135-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244589.0, assembly_id=102761.0))
lhcb1.new("mb.b15l4.b1", "mb", at="-623.6897+(-135.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830766.0, assembly_id=102762.0))
lhcb1.new("mcs.b15l4.b1", "mcs", at="-616.2657+(-136-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244592.0, assembly_id=102762.0))
lhcb1.new("mco.a15l4.b1", "mco", at="-615.5157+(-136-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251004.0, assembly_id=102763.0))
lhcb1.new("mcd.a15l4.b1", "mcd", at="-615.5142+(-136-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251005.0, assembly_id=102763.0))
lhcb1.new("mb.a15l4.b1", "mb", at="-608.0297+(-136.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830790.0, assembly_id=102763.0))
lhcb1.new("mcs.a15l4.b1", "mcs", at="-600.6057+(-137-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244597.0, assembly_id=102763.0))
lhcb1.new("bpm.14l4.b1", "bpm", at="-599.7267+(-137-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244599.0, assembly_id=102764.0))
lhcb1.new("mqt.14l4.b1", "mqt", at="-598.9727+(-137-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307513.0, assembly_id=102764.0))
lhcb1.new("mq.14l4.b1", "mq", at="-596.9647+(-137-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308508.0, assembly_id=102764.0))
lhcb1.new("ms.14l4.b1", "ms", at="-595.0697+(-137-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251007.0, assembly_id=102764.0))
lhcb1.new("mcbv.14l4.b1", "mcbv", at="-594.4767+(-137-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251009.0, assembly_id=102764.0))
lhcb1.new("mb.c14l4.b1", "mb", at="-585.8997+(-137.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830814.0, assembly_id=102765.0))
lhcb1.new("mcs.c14l4.b1", "mcs", at="-578.4757+(-138-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244605.0, assembly_id=102765.0))
lhcb1.new("mco.14l4.b1", "mco", at="-577.7257+(-138-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251012.0, assembly_id=102766.0))
lhcb1.new("mcd.14l4.b1", "mcd", at="-577.7242+(-138-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251013.0, assembly_id=102766.0))
lhcb1.new("mb.b14l4.b1", "mb", at="-570.2397+(-138.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830838.0, assembly_id=102766.0))
lhcb1.new("mcs.b14l4.b1", "mcs", at="-562.8157+(-139-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244610.0, assembly_id=102766.0))
lhcb1.new("mb.a14l4.b1", "mb", at="-554.5797+(-139.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830862.0, assembly_id=102767.0))
lhcb1.new("mcs.a14l4.b1", "mcs", at="-547.1557+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244613.0, assembly_id=102767.0))
lhcb1.new("s.ds.l4.b1", "omk", at="-546.7497+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.13l4.b1", "bpm", at="-546.2767+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244615.0, assembly_id=102768.0))
lhcb1.new("mqt.13l4.b1", "mqt", at="-545.5227+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307721.0, assembly_id=102768.0))
lhcb1.new("mq.13l4.b1", "mq", at="-543.5147+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308478.0, assembly_id=102768.0))
lhcb1.new("ms.13l4.b1", "ms", at="-541.6197+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251015.0, assembly_id=102768.0))
lhcb1.new("mcbh.13l4.b1", "mcbh", at="-541.0267+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251017.0, assembly_id=102768.0))
lhcb1.new("mco.b13l4.b1", "mco", at="-539.9357+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251020.0, assembly_id=102769.0))
lhcb1.new("mcd.b13l4.b1", "mcd", at="-539.9342+(-140-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251021.0, assembly_id=102769.0))
lhcb1.new("mb.c13l4.b1", "mb", at="-532.4497+(-140.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830886.0, assembly_id=102769.0))
lhcb1.new("mcs.c13l4.b1", "mcs", at="-525.0257+(-141-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244623.0, assembly_id=102769.0))
lhcb1.new("mb.b13l4.b1", "mb", at="-516.7897+(-141.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830910.0, assembly_id=102770.0))
lhcb1.new("mcs.b13l4.b1", "mcs", at="-509.3657+(-142-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244626.0, assembly_id=102770.0))
lhcb1.new("mco.a13l4.b1", "mco", at="-508.6157+(-142-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251024.0, assembly_id=102771.0))
lhcb1.new("mcd.a13l4.b1", "mcd", at="-508.6142+(-142-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251025.0, assembly_id=102771.0))
lhcb1.new("mb.a13l4.b1", "mb", at="-501.1297+(-142.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830934.0, assembly_id=102771.0))
lhcb1.new("mcs.a13l4.b1", "mcs", at="-493.7057+(-143-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244631.0, assembly_id=102771.0))
lhcb1.new("bpm.12l4.b1", "bpm", at="-492.8267+(-143-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244633.0, assembly_id=102772.0))
lhcb1.new("mqt.12l4.b1", "mqt", at="-492.0727+(-143-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307689.0, assembly_id=102772.0))
lhcb1.new("mq.12l4.b1", "mq", at="-490.0647+(-143-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308448.0, assembly_id=102772.0))
lhcb1.new("ms.12l4.b1", "ms", at="-488.1697+(-143-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251027.0, assembly_id=102772.0))
lhcb1.new("mcbv.12l4.b1", "mcbv", at="-487.5767+(-143-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251029.0, assembly_id=102772.0))
lhcb1.new("mb.c12l4.b1", "mb", at="-478.9997+(-143.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830958.0, assembly_id=102773.0))
lhcb1.new("mcs.c12l4.b1", "mcs", at="-471.5757+(-144-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244639.0, assembly_id=102773.0))
lhcb1.new("mco.12l4.b1", "mco", at="-470.8257+(-144-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251032.0, assembly_id=102774.0))
lhcb1.new("mcd.12l4.b1", "mcd", at="-470.8242+(-144-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251033.0, assembly_id=102774.0))
lhcb1.new("mb.b12l4.b1", "mb", at="-463.3397+(-144.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52830982.0, assembly_id=102774.0))
lhcb1.new("mcs.b12l4.b1", "mcs", at="-455.9157+(-145-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244644.0, assembly_id=102774.0))
lhcb1.new("mb.a12l4.b1", "mb", at="-447.6797+(-145.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831006.0, assembly_id=102775.0))
lhcb1.new("mcs.a12l4.b1", "mcs", at="-440.2557+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244647.0, assembly_id=102775.0))
lhcb1.new("e.arc.34.b1", "omk", at="-439.8497+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.11l4.b1", "bpm", at="-439.3767+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244649.0, assembly_id=102776.0))
lhcb1.new("mq.11l4.b1", "mq", at="-436.8297+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308655.0, assembly_id=102776.0))
lhcb1.new("mqtli.11l4.b1", "mqtli", at="-434.4607+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307343.0, assembly_id=102776.0))
lhcb1.new("ms.11l4.b1", "ms", at="-433.4487+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251035.0, assembly_id=102776.0))
lhcb1.new("mcbh.11l4.b1", "mcbh", at="-432.8557+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251037.0, assembly_id=102776.0))
lhcb1.new("lebl.11l4.b1", "lebl", at="-425.71735+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52997634.0, assembly_id=102777.0))
lhcb1.new("mco.11l4.b1", "mco", at="-418.986+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251040.0, assembly_id=102778.0))
lhcb1.new("mcd.11l4.b1", "mcd", at="-418.9845+(-146-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251041.0, assembly_id=102778.0))
lhcb1.new("mb.b11l4.b1", "mb", at="-411.5+(-146.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831030.0, assembly_id=102778.0))
lhcb1.new("mcs.b11l4.b1", "mcs", at="-404.076+(-147-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244657.0, assembly_id=102778.0))
lhcb1.new("mb.a11l4.b1", "mb", at="-395.84+(-147.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52849534.0, assembly_id=102779.0))
lhcb1.new("mcs.a11l4.b1", "mcs", at="-388.416+(-148-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=357305.0, assembly_id=102779.0))
lhcb1.new("bpmcs.10l4.b1", "bpmcs", at="-387.729+(-148-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773693.0, assembly_id=102780.0))
lhcb1.new("bpm.10l4.b1", "bpm", at="-387.537+(-148-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773657.0, assembly_id=102780.0))
lhcb1.new("mqml.10l4.b1", "mqml", at="-384.392+(-148-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307808.0, assembly_id=102780.0))
lhcb1.new("mcbcv.10l4.b1", "mcbcv", at="-381.35+(-148-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251042.0, assembly_id=102780.0))
lhcb1.new("mco.10l4.b1", "mco", at="-379.921+(-148-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251046.0, assembly_id=102781.0))
lhcb1.new("mcd.10l4.b1", "mcd", at="-379.9195+(-148-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251047.0, assembly_id=102781.0))
lhcb1.new("mb.b10l4.b1", "mb", at="-372.435+(-148.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831054.0, assembly_id=102781.0))
lhcb1.new("mcs.b10l4.b1", "mcs", at="-365.011+(-149-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244669.0, assembly_id=102781.0))
lhcb1.new("mb.a10l4.b1", "mb", at="-356.775+(-149.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831078.0, assembly_id=102782.0))
lhcb1.new("mcs.a10l4.b1", "mcs", at="-349.351+(-150-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244672.0, assembly_id=102782.0))
lhcb1.new("bpmcs.9l4.b1", "bpmcs", at="-348.663+(-150-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773701.0, assembly_id=102783.0))
lhcb1.new("bpm.9l4.b1", "bpm", at="-348.471+(-150-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773665.0, assembly_id=102783.0))
lhcb1.new("mqmc.9l4.b1", "mqmc", at="-346.495+(-150-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307785.0, assembly_id=102783.0))
lhcb1.new("mqm.9l4.b1", "mqm", at="-343.229+(-150-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307733.0, assembly_id=102783.0))
lhcb1.new("mcbch.9l4.b1", "mcbch", at="-340.888+(-150-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251048.0, assembly_id=102783.0))
lhcb1.new("mco.9l4.b1", "mco", at="-339.456+(-150-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251052.0, assembly_id=102784.0))
lhcb1.new("mcd.9l4.b1", "mcd", at="-339.4545+(-150-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251053.0, assembly_id=102784.0))
lhcb1.new("mb.b9l4.b1", "mb", at="-331.97+(-150.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831102.0, assembly_id=102784.0))
lhcb1.new("mcs.b9l4.b1", "mcs", at="-324.546+(-151-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244682.0, assembly_id=102784.0))
lhcb1.new("mb.a9l4.b1", "mb", at="-316.31+(-151.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831126.0, assembly_id=102785.0))
lhcb1.new("mcs.a9l4.b1", "mcs", at="-308.886+(-152-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244685.0, assembly_id=102785.0))
lhcb1.new("bpmcs.8l4.b1", "bpmcs", at="-308.199+(-152-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773705.0, assembly_id=102786.0))
lhcb1.new("bpm.8l4.b1", "bpm", at="-308.007+(-152-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773669.0, assembly_id=102786.0))
lhcb1.new("mqml.8l4.b1", "mqml", at="-304.862+(-152-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307840.0, assembly_id=102786.0))
lhcb1.new("mcbcv.8l4.b1", "mcbcv", at="-301.82+(-152-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251054.0, assembly_id=102786.0))
lhcb1.new("mco.8l4.b1", "mco", at="-300.391+(-152-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251058.0, assembly_id=102787.0))
lhcb1.new("mcd.8l4.b1", "mcd", at="-300.3895+(-152-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251059.0, assembly_id=102787.0))
lhcb1.new("mb.b8l4.b1", "mb", at="-292.905+(-152.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831150.0, assembly_id=102787.0))
lhcb1.new("mcs.b8l4.b1", "mcs", at="-285.481+(-153-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244694.0, assembly_id=102787.0))
lhcb1.new("mb.a8l4.b1", "mb", at="-277.245+(-153.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52849558.0, assembly_id=102788.0))
lhcb1.new("mcs.a8l4.b1", "mcs", at="-269.821+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=357309.0, assembly_id=102788.0))
lhcb1.new("e.ds.l4.b1", "omk", at="-269.415+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(slot_id=100932.0))
lhcb1.new("bpmcs.7l4.b1", "bpmcs", at="-269.134+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773709.0, assembly_id=102789.0))
lhcb1.new("bpm.7l4.b1", "bpm", at="-268.942+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773673.0, assembly_id=102789.0))
lhcb1.new("mqm.7l4.b1", "mqm", at="-266.367+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307963.0, assembly_id=102789.0))
lhcb1.new("mcbch.7l4.b1", "mcbch", at="-264.026+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251060.0, assembly_id=102789.0))
lhcb1.new("dfbag.7l4.b1", "dfbag", at="-261.8575+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52996683.0, assembly_id=104680.0))
lhcb1.new("bpmyb.6l4.b1", "bpmyb", at="-172.338+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=298213.0, assembly_id=102790.0))
lhcb1.new("mqy.6l4.b1", "mqy", at="-169.62+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2303131.0, assembly_id=102790.0))
lhcb1.new("mcbyv.6l4.b1", "mcbyv", at="-167.273+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251062.0, assembly_id=102790.0))
lhcb1.new("bqkv.6l4.b1", "bqkv", at="-164.388+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635730.0))
lhcb1.new("mkqa.6l4.b1", "mkqa", at="-150.9285+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=377747.0))
lhcb1.new("btvm.6l4.b1", "btvm", at="-148.87+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635731.0))
lhcb1.new("apwl.b6l4.b1", "apwl", at="-143.8883+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=694130.0))
lhcb1.new("bqkh.b6l4.b1", "bqkh", at="-137.252+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635729.0))
lhcb1.new("bpmya.5l4.b1", "bpmya", at="-135.338+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244707.0, assembly_id=102791.0))
lhcb1.new("mqy.5l4.b1", "mqy", at="-132.62+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2302991.0, assembly_id=102791.0))
lhcb1.new("mcbyh.5l4.b1", "mcbyh", at="-130.273+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251064.0, assembly_id=102791.0))
lhcb1.new("mbrb.5l4.b1", "mbrb", at="-123.684+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52819566.0, assembly_id=102792.0))
lhcb1.new("bsrtmb.5l4.b1", "bsrtmb", at="-98.9285+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.2718, slot_id=56282630.0))
lhcb1.new("mgmwh.a5l4.b1", "mgmwh", at="-65.4459+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.3771, slot_id=642434.0))
lhcb1.new("mgmwh.c5l4.b1", "mgmwh003", at="-64.01925+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.379, slot_id=2057442.0))
lhcb1.new("mgmwv.c5l4.b1", "mgmwv003", at="-62.22905+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.3846, slot_id=2057445.0))
lhcb1.new("mgmwv.a5l4.b1", "mgmwv", at="-60.7959+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.3917, slot_id=642436.0))
lhcb1.new("bpmwi.a5l4.b1", "bpmwi", at="-58.7355+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.398, slot_id=6729055.0))
lhcb1.new("mbrs.5l4.b1", "mbrs", at="-51.783+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244712.0, assembly_id=102793.0))
lhcb1.new("bgcab.a5l4.b1", "bgcab", at="-42.104+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=51625890.0))
lhcb1.new("bpmwa.b5l4.b1", "bpmwa", at="-32.8715+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=104604.0))
lhcb1.new("adtkh.d5l4.b1", "adtkh", at="-30.967+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=627222.0, assembly_id=102799.0))
lhcb1.new("adtkh.c5l4.b1", "adtkh", at="-29.367+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=627226.0, assembly_id=102799.0))
lhcb1.new("adtkh.b5l4.b1", "adtkh", at="-26.767+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=627224.0, assembly_id=102801.0))
lhcb1.new("adtkh.a5l4.b1", "adtkh", at="-25.167+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=627228.0, assembly_id=102801.0))
lhcb1.new("bpmwa.a5l4.b1", "bpmwa", at="-23.9865+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=104605.0))
lhcb1.new("acsph.a5l4.b1", "acsph001", at="-14.79925+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538017.0, assembly_id=102804.0))
lhcb1.new("acsca.d5l4.b1", "acsca", at="-14.543+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244721.0, assembly_id=102804.0))
lhcb1.new("acsph.e5l4.b1", "acsph002", at="-14.25175+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538025.0, assembly_id=102804.0))
lhcb1.new("acsph.b5l4.b1", "acsph001", at="-13.30325+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538019.0, assembly_id=102804.0))
lhcb1.new("acsca.c5l4.b1", "acsca", at="-13.047+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244722.0, assembly_id=102804.0))
lhcb1.new("acsph.f5l4.b1", "acsph002", at="-12.75575+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538027.0, assembly_id=102804.0))
lhcb1.new("acsph.c5l4.b1", "acsph001", at="-11.80725+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538021.0, assembly_id=102804.0))
lhcb1.new("acsca.b5l4.b1", "acsca", at="-11.551+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244723.0, assembly_id=102804.0))
lhcb1.new("acsph.g5l4.b1", "acsph002", at="-11.25975+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538029.0, assembly_id=102804.0))
lhcb1.new("acsph.d5l4.b1", "acsph001", at="-10.31125+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538023.0, assembly_id=102804.0))
lhcb1.new("acsca.a5l4.b1", "acsca", at="-10.055+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244724.0, assembly_id=102804.0))
lhcb1.new("acsph.h5l4.b1", "acsph002", at="-9.76375+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538031.0, assembly_id=102804.0))
lhcb1.new("ip4", "omk", at="pip4+ip4ofs.b1*ds")
lhcb1.new("acsph.a5r4.b1", "acsph001", at="9.29875+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538405.0, assembly_id=102807.0))
lhcb1.new("acsca.a5r4.b1", "acsca", at="9.555+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244733.0, assembly_id=102807.0))
lhcb1.new("acsph.e5r4.b1", "acsph002", at="9.84625+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538417.0, assembly_id=102807.0))
lhcb1.new("acsph.b5r4.b1", "acsph001", at="10.79475+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538407.0, assembly_id=102807.0))
lhcb1.new("acsca.b5r4.b1", "acsca", at="11.051+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244734.0, assembly_id=102807.0))
lhcb1.new("acsph.f5r4.b1", "acsph002", at="11.34225+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538419.0, assembly_id=102807.0))
lhcb1.new("acsph.c5r4.b1", "acsph001", at="12.29075+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538409.0, assembly_id=102807.0))
lhcb1.new("acsca.c5r4.b1", "acsca", at="12.547+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244735.0, assembly_id=102807.0))
lhcb1.new("acsph.g5r4.b1", "acsph002", at="12.83825+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538421.0, assembly_id=102807.0))
lhcb1.new("acsph.d5r4.b1", "acsph001", at="13.78675+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538411.0, assembly_id=102807.0))
lhcb1.new("acsca.d5r4.b1", "acsca", at="14.043+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244736.0, assembly_id=102807.0))
lhcb1.new("acsph.h5r4.b1", "acsph002", at="14.33425+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=40538423.0, assembly_id=102807.0))
lhcb1.new("apwl.5r4.b1", "apwl", at="17.25+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=479345.0))
lhcb1.new("apwl.b5r4.b1", "apwl", at="18.15+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=479346.0))
lhcb1.new("bpmwa.a5r4.b1", "bpmwa", at="24.0625+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=104606.0))
lhcb1.new("adtkv.a5r4.b1", "adtkv", at="25.967+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=628037.0, assembly_id=102809.0))
lhcb1.new("adtkv.b5r4.b1", "adtkv", at="27.567+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=628041.0, assembly_id=102809.0))
lhcb1.new("adtkv.c5r4.b1", "adtkv", at="30.167+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=628039.0, assembly_id=102810.0))
lhcb1.new("adtkv.d5r4.b1", "adtkv", at="31.767+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=628043.0, assembly_id=102810.0))
lhcb1.new("bpmwa.b5r4.b1", "bpmwa", at="32.9475+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=104607.0))
lhcb1.new("mu.a5r4.b1", "mu", at="45.631+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=266549.0, assembly_id=102817.0))
lhcb1.new("mu.b5r4.b1", "mu", at="45.771+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=266548.0, assembly_id=102817.0))
lhcb1.new("mu.c5r4.b1", "mu", at="45.911+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=266547.0, assembly_id=102817.0))
lhcb1.new("mu.d5r4.b1", "mu", at="46.051+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=266546.0, assembly_id=102817.0))
lhcb1.new("mbrs.5r4.b1", "mbrs", at="51.783+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.42, slot_id=244746.0, assembly_id=102818.0))
lhcb1.new("bsrtr.5r4.b1", "bsrtr", at="58.781+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.404, slot_id=635738.0))
lhcb1.new("bsrto.a5r4.b1", "bsrto001", at="70.981+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.376, slot_id=42551670.0, assembly_id=635739.0))
lhcb1.new("bsrtm.5r4.b1", "bsrtm", at="73.081+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.376, slot_id=635739.0))
lhcb1.new("bws.5r4.b1", "bws", at="84.876+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.3176, slot_id=642430.0))
lhcb1.new("bqsv.5r4.b1", "bqsv", at="116.109+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.216, slot_id=635695.0))
lhcb1.new("mbrb.5r4.b1", "mbrb", at="123.684+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52819590.0, assembly_id=102819.0))
lhcb1.new("mcbyv.5r4.b1", "mcbyv", at="130.273+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251067.0, assembly_id=102820.0))
lhcb1.new("mqy.5r4.b1", "mqy", at="132.62+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2348363.0, assembly_id=102820.0))
lhcb1.new("bpmyb.5r4.b1", "bpmyb", at="135.338+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=298215.0, assembly_id=102820.0))
lhcb1.new("bplv.a6r4.b1", "bplv", at="137.752+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635709.0))
lhcb1.new("bplv.b6r4.b1", "bplv", at="138.552+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635710.0))
lhcb1.new("bplv.c6r4.b1", "bplv", at="139.352+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635711.0))
lhcb1.new("bplx.h6r4.b1", "bplx", at="149.662+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=6731967.0))
lhcb1.new("bplx.d6r4.b1", "bplx", at="150.452+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635713.0))
lhcb1.new("bctdc.a6r4.b1", "bctdc", at="153.078+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635717.0))
lhcb1.new("bctdc.b6r4.b1", "bctdc", at="153.998+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635718.0))
lhcb1.new("bctfr.a6r4.b1", "bctfr", at="158.838+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635723.0))
lhcb1.new("bctfr.b6r4.b1", "bctfr", at="159.758+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635724.0))
lhcb1.new("bplh.a6r4.b1", "bplh", at="163.088+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635706.0))
lhcb1.new("bplh.b6r4.b1", "bplh", at="163.888+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635707.0))
lhcb1.new("bpmya.6r4.b1", "bpmya", at="166.902+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244753.0, assembly_id=102821.0))
lhcb1.new("mqy.6r4.b1", "mqy", at="169.62+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2303099.0, assembly_id=102821.0))
lhcb1.new("mcbyh.6r4.b1", "mcbyh", at="171.967+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251068.0, assembly_id=102821.0))
lhcb1.new("bqsh.7r4.b1", "bqsh", at="174.902+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635694.0))
lhcb1.new("bplh.7r4.b1", "bplh", at="177.952+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=635708.0))
lhcb1.new("dfbah.7r4.b1", "dfbah", at="261.6075+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52996707.0, assembly_id=104681.0))
lhcb1.new("bpmcs.7r4.b1", "bpmcs", at="263.226+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773714.0, assembly_id=102822.0))
lhcb1.new("bpm.7r4.b1", "bpm", at="263.418+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773678.0, assembly_id=102822.0))
lhcb1.new("mqm.7r4.b1", "mqm", at="265.993+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307965.0, assembly_id=102822.0))
lhcb1.new("mcbcv.7r4.b1", "mcbcv", at="268.334+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251070.0, assembly_id=102822.0))
lhcb1.new("s.ds.r4.b1", "omk", at="269.415+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(slot_id=100932.0))
lhcb1.new("mco.8r4.b1", "mco_unplugged", at="269.759+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251074.0, assembly_id=102823.0))
lhcb1.new("mcd.8r4.b1", "mcd", at="269.7605+(-154-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251075.0, assembly_id=102823.0))
lhcb1.new("mb.a8r4.b1", "mb", at="277.245+(-154.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831174.0, assembly_id=102823.0))
lhcb1.new("mcs.a8r4.b1", "mcs", at="284.669+(-155-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244764.0, assembly_id=102823.0))
lhcb1.new("mb.b8r4.b1", "mb", at="292.905+(-155.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831198.0, assembly_id=102824.0))
lhcb1.new("mcs.b8r4.b1", "mcs", at="300.329+(-156-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244767.0, assembly_id=102824.0))
lhcb1.new("bpmcs.8r4.b1", "bpmcs", at="301.016+(-156-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773717.0, assembly_id=102825.0))
lhcb1.new("bpm.8r4.b1", "bpm", at="301.208+(-156-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773681.0, assembly_id=102825.0))
lhcb1.new("mqml.8r4.b1", "mqml", at="304.353+(-156-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307613.0, assembly_id=102825.0))
lhcb1.new("mcbch.8r4.b1", "mcbch", at="307.395+(-156-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251076.0, assembly_id=102825.0))
lhcb1.new("mco.9r4.b1", "mco_unplugged", at="308.824+(-156-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251080.0, assembly_id=102826.0))
lhcb1.new("mcd.9r4.b1", "mcd", at="308.8255+(-156-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251081.0, assembly_id=102826.0))
lhcb1.new("mb.a9r4.b1", "mb", at="316.31+(-156.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831222.0, assembly_id=102826.0))
lhcb1.new("mcs.a9r4.b1", "mcs", at="323.734+(-157-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244776.0, assembly_id=102826.0))
lhcb1.new("mb.b9r4.b1", "mb", at="331.97+(-157.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831246.0, assembly_id=102827.0))
lhcb1.new("mcs.b9r4.b1", "mcs", at="339.394+(-158-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244779.0, assembly_id=102827.0))
lhcb1.new("bpmcs.9r4.b1", "bpmcs", at="340.082+(-158-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773721.0, assembly_id=102828.0))
lhcb1.new("bpm.9r4.b1", "bpm", at="340.274+(-158-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773685.0, assembly_id=102828.0))
lhcb1.new("mqmc.9r4.b1", "mqmc", at="342.25+(-158-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307796.0, assembly_id=102828.0))
lhcb1.new("mqm.9r4.b1", "mqm", at="345.516+(-158-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307744.0, assembly_id=102828.0))
lhcb1.new("mcbcv.9r4.b1", "mcbcv", at="347.857+(-158-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251082.0, assembly_id=102828.0))
lhcb1.new("mco.10r4.b1", "mco_unplugged", at="349.289+(-158-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251086.0, assembly_id=102829.0))
lhcb1.new("mcd.10r4.b1", "mcd", at="349.2905+(-158-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251087.0, assembly_id=102829.0))
lhcb1.new("mb.a10r4.b1", "mb", at="356.775+(-158.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831270.0, assembly_id=102829.0))
lhcb1.new("mcs.a10r4.b1", "mcs", at="364.199+(-159-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244789.0, assembly_id=102829.0))
lhcb1.new("mb.b10r4.b1", "mb", at="372.435+(-159.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831294.0, assembly_id=102830.0))
lhcb1.new("mcs.b10r4.b1", "mcs", at="379.859+(-160-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244792.0, assembly_id=102830.0))
lhcb1.new("bpmcs.10r4.b1", "bpmcs", at="380.546+(-160-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773725.0, assembly_id=102831.0))
lhcb1.new("bpm.10r4.b1", "bpm", at="380.738+(-160-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=4773689.0, assembly_id=102831.0))
lhcb1.new("mqml.10r4.b1", "mqml", at="383.883+(-160-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307820.0, assembly_id=102831.0))
lhcb1.new("mcbch.10r4.b1", "mcbch", at="386.925+(-160-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251088.0, assembly_id=102831.0))
lhcb1.new("mco.11r4.b1", "mco_unplugged", at="388.354+(-160-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251092.0, assembly_id=102832.0))
lhcb1.new("mcd.11r4.b1", "mcd", at="388.3555+(-160-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251093.0, assembly_id=102832.0))
lhcb1.new("mb.a11r4.b1", "mb", at="395.84+(-160.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831318.0, assembly_id=102832.0))
lhcb1.new("mcs.a11r4.b1", "mcs", at="403.264+(-161-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244801.0, assembly_id=102832.0))
lhcb1.new("mb.b11r4.b1", "mb", at="411.5+(-161.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831342.0, assembly_id=102833.0))
lhcb1.new("mcs.b11r4.b1", "mcs", at="418.924+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244804.0, assembly_id=102833.0))
lhcb1.new("leal.11r4.b1", "leal", at="425.71735+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52997586.0, assembly_id=102834.0))
lhcb1.new("bpm.11r4.b1", "bpm", at="432.5777+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244806.0, assembly_id=102835.0))
lhcb1.new("mq.11r4.b1", "mq", at="435.1247+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308670.0, assembly_id=102835.0))
lhcb1.new("mqtli.11r4.b1", "mqtli", at="437.4937+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307358.0, assembly_id=102835.0))
lhcb1.new("ms.11r4.b1", "ms", at="438.5057+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251095.0, assembly_id=102835.0))
lhcb1.new("mcbv.11r4.b1", "mcbv", at="439.0987+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251097.0, assembly_id=102835.0))
lhcb1.new("s.arc.45.b1", "omk", at="439.8497+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a12r4.b1", "mco_unplugged", at="440.1937+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251100.0, assembly_id=102836.0))
lhcb1.new("mcd.a12r4.b1", "mcd", at="440.1952+(-162-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251101.0, assembly_id=102836.0))
lhcb1.new("mb.a12r4.b1", "mb", at="447.6797+(-162.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831366.0, assembly_id=102836.0))
lhcb1.new("mcs.a12r4.b1", "mcs", at="455.1037+(-163-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244814.0, assembly_id=102836.0))
lhcb1.new("mb.b12r4.b1", "mb", at="463.3397+(-163.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831390.0, assembly_id=102837.0))
lhcb1.new("mcs.b12r4.b1", "mcs", at="470.7637+(-164-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244817.0, assembly_id=102837.0))
lhcb1.new("mco.b12r4.b1", "mco_unplugged", at="471.5137+(-164-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251104.0, assembly_id=102838.0))
lhcb1.new("mcd.b12r4.b1", "mcd", at="471.5152+(-164-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251105.0, assembly_id=102838.0))
lhcb1.new("mb.c12r4.b1", "mb", at="478.9997+(-164.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831414.0, assembly_id=102838.0))
lhcb1.new("mcs.c12r4.b1", "mcs", at="486.4237+(-165-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244822.0, assembly_id=102838.0))
lhcb1.new("bpm.12r4.b1", "bpm", at="487.3027+(-165-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244824.0, assembly_id=102839.0))
lhcb1.new("mqt.12r4.b1", "mqt", at="488.0567+(-165-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307705.0, assembly_id=102839.0))
lhcb1.new("mq.12r4.b1", "mq", at="490.0647+(-165-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308463.0, assembly_id=102839.0))
lhcb1.new("ms.12r4.b1", "ms", at="491.9597+(-165-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251107.0, assembly_id=102839.0))
lhcb1.new("mcbh.12r4.b1", "mcbh", at="492.5527+(-165-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251109.0, assembly_id=102839.0))
lhcb1.new("mb.a13r4.b1", "mb", at="501.1297+(-165.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831438.0, assembly_id=102840.0))
lhcb1.new("mcs.a13r4.b1", "mcs", at="508.5537+(-166-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244830.0, assembly_id=102840.0))
lhcb1.new("mco.13r4.b1", "mco_unplugged", at="509.3037+(-166-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251112.0, assembly_id=102841.0))
lhcb1.new("mcd.13r4.b1", "mcd", at="509.3052+(-166-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251113.0, assembly_id=102841.0))
lhcb1.new("mb.b13r4.b1", "mb", at="516.7897+(-166.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831462.0, assembly_id=102841.0))
lhcb1.new("mcs.b13r4.b1", "mcs", at="524.2137+(-167-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244835.0, assembly_id=102841.0))
lhcb1.new("mb.c13r4.b1", "mb", at="532.4497+(-167.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831486.0, assembly_id=102842.0))
lhcb1.new("mcs.c13r4.b1", "mcs", at="539.8737+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244838.0, assembly_id=102842.0))
lhcb1.new("bpm.13r4.b1", "bpm", at="540.7527+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244840.0, assembly_id=102843.0))
lhcb1.new("mqt.13r4.b1", "mqt", at="541.5067+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307498.0, assembly_id=102843.0))
lhcb1.new("mq.13r4.b1", "mq", at="543.5147+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308493.0, assembly_id=102843.0))
lhcb1.new("ms.13r4.b1", "ms", at="545.4097+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251115.0, assembly_id=102843.0))
lhcb1.new("mcbv.13r4.b1", "mcbv", at="546.0027+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251117.0, assembly_id=102843.0))
lhcb1.new("e.ds.r4.b1", "omk", at="546.7497+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a14r4.b1", "mco_unplugged", at="547.0937+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251120.0, assembly_id=102844.0))
lhcb1.new("mcd.a14r4.b1", "mcd", at="547.0952+(-168-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251121.0, assembly_id=102844.0))
lhcb1.new("mb.a14r4.b1", "mb", at="554.5797+(-168.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831510.0, assembly_id=102844.0))
lhcb1.new("mcs.a14r4.b1", "mcs", at="562.0037+(-169-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244848.0, assembly_id=102844.0))
lhcb1.new("mb.b14r4.b1", "mb", at="570.2397+(-169.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831534.0, assembly_id=102845.0))
lhcb1.new("mcs.b14r4.b1", "mcs", at="577.6637+(-170-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244851.0, assembly_id=102845.0))
lhcb1.new("mco.b14r4.b1", "mco_unplugged", at="578.4137+(-170-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251124.0, assembly_id=102846.0))
lhcb1.new("mcd.b14r4.b1", "mcd", at="578.4152+(-170-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251125.0, assembly_id=102846.0))
lhcb1.new("mb.c14r4.b1", "mb", at="585.8997+(-170.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831558.0, assembly_id=102846.0))
lhcb1.new("mcs.c14r4.b1", "mcs", at="593.3237+(-171-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244856.0, assembly_id=102846.0))
lhcb1.new("bpm.14r4.b1", "bpm", at="594.2027+(-171-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244858.0, assembly_id=102847.0))
lhcb1.new("mqt.14r4.b1", "mqt", at="594.9567+(-171-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307529.0, assembly_id=102847.0))
lhcb1.new("mq.14r4.b1", "mq", at="596.9647+(-171-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308523.0, assembly_id=102847.0))
lhcb1.new("ms.14r4.b1", "ms", at="598.8597+(-171-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251127.0, assembly_id=102847.0))
lhcb1.new("mcbh.14r4.b1", "mcbh", at="599.4527+(-171-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251129.0, assembly_id=102847.0))
lhcb1.new("mb.a15r4.b1", "mb", at="608.0297+(-171.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831582.0, assembly_id=102848.0))
lhcb1.new("mcs.a15r4.b1", "mcs", at="615.4537+(-172-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244864.0, assembly_id=102848.0))
lhcb1.new("mco.15r4.b1", "mco_unplugged", at="616.2037+(-172-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251132.0, assembly_id=102849.0))
lhcb1.new("mcd.15r4.b1", "mcd", at="616.2052+(-172-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251133.0, assembly_id=102849.0))
lhcb1.new("mb.b15r4.b1", "mb", at="623.6897+(-172.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831606.0, assembly_id=102849.0))
lhcb1.new("mcs.b15r4.b1", "mcs", at="631.1137+(-173-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244869.0, assembly_id=102849.0))
lhcb1.new("mb.c15r4.b1", "mb", at="639.3497+(-173.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831630.0, assembly_id=102850.0))
lhcb1.new("mcs.c15r4.b1", "mcs", at="646.7737+(-174-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244872.0, assembly_id=102850.0))
lhcb1.new("bpm.15r4.b1", "bpm", at="647.6527+(-174-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244874.0, assembly_id=102851.0))
lhcb1.new("mqt.15r4.b1", "mqt", at="648.4067+(-174-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307561.0, assembly_id=102851.0))
lhcb1.new("mq.15r4.b1", "mq", at="650.4147+(-174-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308553.0, assembly_id=102851.0))
lhcb1.new("ms.15r4.b1", "ms", at="652.3097+(-174-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251135.0, assembly_id=102851.0))
lhcb1.new("mcbv.15r4.b1", "mcbv", at="652.9027+(-174-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251137.0, assembly_id=102851.0))
lhcb1.new("mco.a16r4.b1", "mco_unplugged", at="653.9937+(-174-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251140.0, assembly_id=102852.0))
lhcb1.new("mcd.a16r4.b1", "mcd", at="653.9952+(-174-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251141.0, assembly_id=102852.0))
lhcb1.new("mb.a16r4.b1", "mb", at="661.4797+(-174.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831654.0, assembly_id=102852.0))
lhcb1.new("mcs.a16r4.b1", "mcs", at="668.9037+(-175-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244882.0, assembly_id=102852.0))
lhcb1.new("mb.b16r4.b1", "mb", at="677.1397+(-175.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831678.0, assembly_id=102853.0))
lhcb1.new("mcs.b16r4.b1", "mcs", at="684.5637+(-176-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244885.0, assembly_id=102853.0))
lhcb1.new("mco.b16r4.b1", "mco_unplugged", at="685.3137+(-176-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251144.0, assembly_id=102854.0))
lhcb1.new("mcd.b16r4.b1", "mcd", at="685.3152+(-176-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251145.0, assembly_id=102854.0))
lhcb1.new("mb.c16r4.b1", "mb", at="692.7997+(-176.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831702.0, assembly_id=102854.0))
lhcb1.new("mcs.c16r4.b1", "mcs", at="700.2237+(-177-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244890.0, assembly_id=102854.0))
lhcb1.new("bpm.16r4.b1", "bpm", at="701.1027+(-177-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244892.0, assembly_id=102855.0))
lhcb1.new("mqt.16r4.b1", "mqt", at="701.8567+(-177-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307591.0, assembly_id=102855.0))
lhcb1.new("mq.16r4.b1", "mq", at="703.8647+(-177-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308346.0, assembly_id=102855.0))
lhcb1.new("ms.16r4.b1", "ms", at="705.7597+(-177-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251147.0, assembly_id=102855.0))
lhcb1.new("mcbh.16r4.b1", "mcbh", at="706.3527+(-177-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251149.0, assembly_id=102855.0))
lhcb1.new("mb.a17r4.b1", "mb", at="714.9297+(-177.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831726.0, assembly_id=102856.0))
lhcb1.new("mcs.a17r4.b1", "mcs", at="722.3537+(-178-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244898.0, assembly_id=102856.0))
lhcb1.new("mco.17r4.b1", "mco_unplugged", at="723.1037+(-178-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251152.0, assembly_id=102857.0))
lhcb1.new("mcd.17r4.b1", "mcd", at="723.1052+(-178-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251153.0, assembly_id=102857.0))
lhcb1.new("mb.b17r4.b1", "mb", at="730.5897+(-178.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831750.0, assembly_id=102857.0))
lhcb1.new("mcs.b17r4.b1", "mcs", at="738.0137+(-179-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244903.0, assembly_id=102857.0))
lhcb1.new("mb.c17r4.b1", "mb", at="746.2497+(-179.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831774.0, assembly_id=102858.0))
lhcb1.new("mcs.c17r4.b1", "mcs", at="753.6737+(-180-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244906.0, assembly_id=102858.0))
lhcb1.new("bpm.17r4.b1", "bpm", at="754.5527+(-180-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244908.0, assembly_id=102859.0))
lhcb1.new("mqt.17r4.b1", "mqt", at="755.3067+(-180-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307385.0, assembly_id=102859.0))
lhcb1.new("mq.17r4.b1", "mq", at="757.3147+(-180-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308376.0, assembly_id=102859.0))
lhcb1.new("ms.17r4.b1", "ms", at="759.2097+(-180-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251155.0, assembly_id=102859.0))
lhcb1.new("mcbv.17r4.b1", "mcbv", at="759.8027+(-180-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251157.0, assembly_id=102859.0))
lhcb1.new("mco.a18r4.b1", "mco_unplugged", at="760.8937+(-180-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251160.0, assembly_id=102860.0))
lhcb1.new("mcd.a18r4.b1", "mcd", at="760.8952+(-180-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251161.0, assembly_id=102860.0))
lhcb1.new("mb.a18r4.b1", "mb", at="768.3797+(-180.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831798.0, assembly_id=102860.0))
lhcb1.new("mcs.a18r4.b1", "mcs", at="775.8037+(-181-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244916.0, assembly_id=102860.0))
lhcb1.new("mb.b18r4.b1", "mb", at="784.0397+(-181.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831822.0, assembly_id=102861.0))
lhcb1.new("mcs.b18r4.b1", "mcs", at="791.4637+(-182-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244919.0, assembly_id=102861.0))
lhcb1.new("mco.b18r4.b1", "mco_unplugged", at="792.2137+(-182-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251164.0, assembly_id=102862.0))
lhcb1.new("mcd.b18r4.b1", "mcd", at="792.2152+(-182-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251165.0, assembly_id=102862.0))
lhcb1.new("mb.c18r4.b1", "mb", at="799.6997+(-182.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831846.0, assembly_id=102862.0))
lhcb1.new("mcs.c18r4.b1", "mcs", at="807.1237+(-183-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244924.0, assembly_id=102862.0))
lhcb1.new("bpm.18r4.b1", "bpm", at="808.0027+(-183-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244926.0, assembly_id=102863.0))
lhcb1.new("mqt.18r4.b1", "mqt", at="808.7567+(-183-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307417.0, assembly_id=102863.0))
lhcb1.new("mq.18r4.b1", "mq", at="810.7647+(-183-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308406.0, assembly_id=102863.0))
lhcb1.new("ms.18r4.b1", "ms", at="812.6597+(-183-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251167.0, assembly_id=102863.0))
lhcb1.new("mcbh.18r4.b1", "mcbh", at="813.2527+(-183-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251169.0, assembly_id=102863.0))
lhcb1.new("mb.a19r4.b1", "mb", at="821.8297+(-183.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831870.0, assembly_id=102864.0))
lhcb1.new("mcs.a19r4.b1", "mcs", at="829.2537+(-184-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244932.0, assembly_id=102864.0))
lhcb1.new("mco.19r4.b1", "mco_unplugged", at="830.0037+(-184-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251172.0, assembly_id=102865.0))
lhcb1.new("mcd.19r4.b1", "mcd", at="830.0052+(-184-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251173.0, assembly_id=102865.0))
lhcb1.new("mb.b19r4.b1", "mb", at="837.4897+(-184.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831894.0, assembly_id=102865.0))
lhcb1.new("mcs.b19r4.b1", "mcs", at="844.9137+(-185-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244937.0, assembly_id=102865.0))
lhcb1.new("mb.c19r4.b1", "mb", at="853.1497+(-185.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831918.0, assembly_id=102866.0))
lhcb1.new("mcs.c19r4.b1", "mcs", at="860.5737+(-186-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244940.0, assembly_id=102866.0))
lhcb1.new("bpm.19r4.b1", "bpm", at="861.4527+(-186-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244942.0, assembly_id=102867.0))
lhcb1.new("mqt.19r4.b1", "mqt", at="862.2067+(-186-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307447.0, assembly_id=102867.0))
lhcb1.new("mq.19r4.b1", "mq", at="864.2147+(-186-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308438.0, assembly_id=102867.0))
lhcb1.new("ms.19r4.b1", "ms", at="866.1097+(-186-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251175.0, assembly_id=102867.0))
lhcb1.new("mcbv.19r4.b1", "mcbv", at="866.7027+(-186-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251177.0, assembly_id=102867.0))
lhcb1.new("mco.a20r4.b1", "mco_unplugged", at="867.7937+(-186-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251180.0, assembly_id=102868.0))
lhcb1.new("mcd.a20r4.b1", "mcd", at="867.7952+(-186-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251181.0, assembly_id=102868.0))
lhcb1.new("mb.a20r4.b1", "mb", at="875.2797+(-186.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831942.0, assembly_id=102868.0))
lhcb1.new("mcs.a20r4.b1", "mcs", at="882.7037+(-187-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244950.0, assembly_id=102868.0))
lhcb1.new("mb.b20r4.b1", "mb", at="890.9397+(-187.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831966.0, assembly_id=102869.0))
lhcb1.new("mcs.b20r4.b1", "mcs", at="898.3637+(-188-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244953.0, assembly_id=102869.0))
lhcb1.new("mco.b20r4.b1", "mco_unplugged", at="899.1137+(-188-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251184.0, assembly_id=102870.0))
lhcb1.new("mcd.b20r4.b1", "mcd", at="899.1152+(-188-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251185.0, assembly_id=102870.0))
lhcb1.new("mb.c20r4.b1", "mb", at="906.5997+(-188.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52831990.0, assembly_id=102870.0))
lhcb1.new("mcs.c20r4.b1", "mcs", at="914.0237+(-189-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244958.0, assembly_id=102870.0))
lhcb1.new("bpm.20r4.b1", "bpm", at="914.9027+(-189-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244960.0, assembly_id=102871.0))
lhcb1.new("mqt.20r4.b1", "mqt", at="915.6567+(-189-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307477.0, assembly_id=102871.0))
lhcb1.new("mq.20r4.b1", "mq", at="917.6647+(-189-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308229.0, assembly_id=102871.0))
lhcb1.new("ms.20r4.b1", "ms", at="919.5597+(-189-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251187.0, assembly_id=102871.0))
lhcb1.new("mcbh.20r4.b1", "mcbh", at="920.1527+(-189-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251189.0, assembly_id=102871.0))
lhcb1.new("mb.a21r4.b1", "mb", at="928.7297+(-189.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832014.0, assembly_id=102872.0))
lhcb1.new("mcs.a21r4.b1", "mcs", at="936.1537+(-190-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244966.0, assembly_id=102872.0))
lhcb1.new("mco.21r4.b1", "mco_unplugged", at="936.9037+(-190-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251192.0, assembly_id=102873.0))
lhcb1.new("mcd.21r4.b1", "mcd", at="936.9052+(-190-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251193.0, assembly_id=102873.0))
lhcb1.new("mb.b21r4.b1", "mb", at="944.3897+(-190.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832038.0, assembly_id=102873.0))
lhcb1.new("mcs.b21r4.b1", "mcs", at="951.8137+(-191-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244971.0, assembly_id=102873.0))
lhcb1.new("mb.c21r4.b1", "mb", at="960.0497+(-191.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832062.0, assembly_id=102874.0))
lhcb1.new("mcs.c21r4.b1", "mcs", at="967.4737+(-192-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244974.0, assembly_id=102874.0))
lhcb1.new("bpm.21r4.b1", "bpm", at="968.3527+(-192-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244976.0, assembly_id=102875.0))
lhcb1.new("mqt.21r4.b1", "mqt", at="969.1067+(-192-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307275.0, assembly_id=102875.0))
lhcb1.new("mq.21r4.b1", "mq", at="971.1147+(-192-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308259.0, assembly_id=102875.0))
lhcb1.new("ms.21r4.b1", "ms", at="973.0097+(-192-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251195.0, assembly_id=102875.0))
lhcb1.new("mcbv.21r4.b1", "mcbv", at="973.6027+(-192-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251197.0, assembly_id=102875.0))
lhcb1.new("mco.a22r4.b1", "mco_unplugged", at="974.6937+(-192-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251200.0, assembly_id=102876.0))
lhcb1.new("mcd.a22r4.b1", "mcd", at="974.6952+(-192-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251201.0, assembly_id=102876.0))
lhcb1.new("mb.a22r4.b1", "mb", at="982.1797+(-192.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832086.0, assembly_id=102876.0))
lhcb1.new("mcs.a22r4.b1", "mcs", at="989.6037+(-193-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244984.0, assembly_id=102876.0))
lhcb1.new("mb.b22r4.b1", "mb", at="997.8397+(-193.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832110.0, assembly_id=102877.0))
lhcb1.new("mcs.b22r4.b1", "mcs", at="1005.2637+(-194-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244987.0, assembly_id=102877.0))
lhcb1.new("mco.b22r4.b1", "mco_unplugged", at="1006.0137+(-194-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251204.0, assembly_id=102878.0))
lhcb1.new("mcd.b22r4.b1", "mcd", at="1006.0152+(-194-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251205.0, assembly_id=102878.0))
lhcb1.new("mb.c22r4.b1", "mb", at="1013.4997+(-194.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832134.0, assembly_id=102878.0))
lhcb1.new("mcs.c22r4.b1", "mcs", at="1020.9237+(-195-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244992.0, assembly_id=102878.0))
lhcb1.new("bpm.22r4.b1", "bpm", at="1021.8027+(-195-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=244994.0, assembly_id=102879.0))
lhcb1.new("mo.22r4.b1", "mo", at="1022.5537+(-195-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308819.0, assembly_id=102879.0))
lhcb1.new("mq.22r4.b1", "mq", at="1024.5647+(-195-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308291.0, assembly_id=102879.0))
lhcb1.new("ms.22r4.b1", "ms", at="1026.4597+(-195-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251207.0, assembly_id=102879.0))
lhcb1.new("mcbh.22r4.b1", "mcbh", at="1027.0527+(-195-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251209.0, assembly_id=102879.0))
lhcb1.new("mb.a23r4.b1", "mb", at="1035.6297+(-195.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832158.0, assembly_id=102880.0))
lhcb1.new("mcs.a23r4.b1", "mcs", at="1043.0537+(-196-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245000.0, assembly_id=102880.0))
lhcb1.new("mco.23r4.b1", "mco_unplugged", at="1043.8037+(-196-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251212.0, assembly_id=102881.0))
lhcb1.new("mcd.23r4.b1", "mcd", at="1043.8052+(-196-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251213.0, assembly_id=102881.0))
lhcb1.new("mb.b23r4.b1", "mb", at="1051.2897+(-196.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832182.0, assembly_id=102881.0))
lhcb1.new("mcs.b23r4.b1", "mcs", at="1058.7137+(-197-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245005.0, assembly_id=102881.0))
lhcb1.new("mb.c23r4.b1", "mb", at="1066.9497+(-197.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832206.0, assembly_id=102882.0))
lhcb1.new("mcs.c23r4.b1", "mcs", at="1074.3737+(-198-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245008.0, assembly_id=102882.0))
lhcb1.new("bpm.23r4.b1", "bpm", at="1075.2527+(-198-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245010.0, assembly_id=102883.0))
lhcb1.new("mqs.23r4.b1", "mqs", at="1076.0067+(-198-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307641.0, assembly_id=102883.0))
lhcb1.new("mq.23r4.b1", "mq", at="1078.0147+(-198-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308322.0, assembly_id=102883.0))
lhcb1.new("ms.23r4.b1", "ms", at="1079.9097+(-198-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251215.0, assembly_id=102883.0))
lhcb1.new("mcbv.23r4.b1", "mcbv", at="1080.5027+(-198-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251217.0, assembly_id=102883.0))
lhcb1.new("mco.a24r4.b1", "mco_unplugged", at="1081.5937+(-198-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251220.0, assembly_id=102884.0))
lhcb1.new("mcd.a24r4.b1", "mcd", at="1081.5952+(-198-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251221.0, assembly_id=102884.0))
lhcb1.new("mb.a24r4.b1", "mb", at="1089.0797+(-198.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832230.0, assembly_id=102884.0))
lhcb1.new("mcs.a24r4.b1", "mcs", at="1096.5037+(-199-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245018.0, assembly_id=102884.0))
lhcb1.new("mb.b24r4.b1", "mb", at="1104.7397+(-199.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832254.0, assembly_id=102885.0))
lhcb1.new("mcs.b24r4.b1", "mcs", at="1112.1637+(-200-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245021.0, assembly_id=102885.0))
lhcb1.new("mco.b24r4.b1", "mco_unplugged", at="1112.9137+(-200-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251224.0, assembly_id=102886.0))
lhcb1.new("mcd.b24r4.b1", "mcd", at="1112.9152+(-200-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251225.0, assembly_id=102886.0))
lhcb1.new("mb.c24r4.b1", "mb", at="1120.3997+(-200.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832278.0, assembly_id=102886.0))
lhcb1.new("mcs.c24r4.b1", "mcs", at="1127.8237+(-201-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245026.0, assembly_id=102886.0))
lhcb1.new("bpm.24r4.b1", "bpm", at="1128.7027+(-201-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245028.0, assembly_id=102887.0))
lhcb1.new("mo.24r4.b1", "mo", at="1129.4537+(-201-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308849.0, assembly_id=102887.0))
lhcb1.new("mq.24r4.b1", "mq", at="1131.4647+(-201-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308112.0, assembly_id=102887.0))
lhcb1.new("ms.24r4.b1", "ms", at="1133.3597+(-201-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251227.0, assembly_id=102887.0))
lhcb1.new("mcbh.24r4.b1", "mcbh", at="1133.9527+(-201-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251229.0, assembly_id=102887.0))
lhcb1.new("mb.a25r4.b1", "mb", at="1142.5297+(-201.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832302.0, assembly_id=102888.0))
lhcb1.new("mcs.a25r4.b1", "mcs", at="1149.9537+(-202-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245034.0, assembly_id=102888.0))
lhcb1.new("mco.25r4.b1", "mco_unplugged", at="1150.7037+(-202-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251232.0, assembly_id=102889.0))
lhcb1.new("mcd.25r4.b1", "mcd", at="1150.7052+(-202-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251233.0, assembly_id=102889.0))
lhcb1.new("mb.b25r4.b1", "mb", at="1158.1897+(-202.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832326.0, assembly_id=102889.0))
lhcb1.new("mcs.b25r4.b1", "mcs", at="1165.6137+(-203-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245039.0, assembly_id=102889.0))
lhcb1.new("mb.c25r4.b1", "mb", at="1173.8497+(-203.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832350.0, assembly_id=102890.0))
lhcb1.new("mcs.c25r4.b1", "mcs", at="1181.2737+(-204-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245042.0, assembly_id=102890.0))
lhcb1.new("bpm.25r4.b1", "bpm", at="1182.1527+(-204-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245044.0, assembly_id=102891.0))
lhcb1.new("mo.25r4.b1", "mo", at="1182.9037+(-204-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308881.0, assembly_id=102891.0))
lhcb1.new("mq.25r4.b1", "mq", at="1184.9147+(-204-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308144.0, assembly_id=102891.0))
lhcb1.new("ms.25r4.b1", "ms", at="1186.8097+(-204-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251235.0, assembly_id=102891.0))
lhcb1.new("mcbv.25r4.b1", "mcbv", at="1187.4027+(-204-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251237.0, assembly_id=102891.0))
lhcb1.new("mco.a26r4.b1", "mco_unplugged", at="1188.4937+(-204-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251240.0, assembly_id=102892.0))
lhcb1.new("mcd.a26r4.b1", "mcd", at="1188.4952+(-204-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251241.0, assembly_id=102892.0))
lhcb1.new("mb.a26r4.b1", "mb", at="1195.9797+(-204.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832374.0, assembly_id=102892.0))
lhcb1.new("mcs.a26r4.b1", "mcs", at="1203.4037+(-205-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245052.0, assembly_id=102892.0))
lhcb1.new("mb.b26r4.b1", "mb", at="1211.6397+(-205.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832398.0, assembly_id=102893.0))
lhcb1.new("mcs.b26r4.b1", "mcs", at="1219.0637+(-206-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245055.0, assembly_id=102893.0))
lhcb1.new("mco.b26r4.b1", "mco_unplugged", at="1219.8137+(-206-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251244.0, assembly_id=102894.0))
lhcb1.new("mcd.b26r4.b1", "mcd", at="1219.8152+(-206-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251245.0, assembly_id=102894.0))
lhcb1.new("mb.c26r4.b1", "mb", at="1227.2997+(-206.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832422.0, assembly_id=102894.0))
lhcb1.new("mcs.c26r4.b1", "mcs", at="1234.7237+(-207-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245060.0, assembly_id=102894.0))
lhcb1.new("bpm.26r4.b1", "bpm", at="1235.6027+(-207-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245062.0, assembly_id=102895.0))
lhcb1.new("mo.26r4.b1", "mo", at="1236.3537+(-207-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2348505.0, assembly_id=102895.0))
lhcb1.new("mq.26r4.b1", "mq", at="1238.3647+(-207-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308175.0, assembly_id=102895.0))
lhcb1.new("ms.26r4.b1", "ms", at="1240.2597+(-207-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251247.0, assembly_id=102895.0))
lhcb1.new("mcbh.26r4.b1", "mcbh", at="1240.8527+(-207-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251249.0, assembly_id=102895.0))
lhcb1.new("mb.a27r4.b1", "mb", at="1249.4297+(-207.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832446.0, assembly_id=102896.0))
lhcb1.new("mcs.a27r4.b1", "mcs", at="1256.8537+(-208-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245068.0, assembly_id=102896.0))
lhcb1.new("mco.27r4.b1", "mco_unplugged", at="1257.6037+(-208-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251252.0, assembly_id=102897.0))
lhcb1.new("mcd.27r4.b1", "mcd", at="1257.6052+(-208-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251253.0, assembly_id=102897.0))
lhcb1.new("mb.b27r4.b1", "mb", at="1265.0897+(-208.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832470.0, assembly_id=102897.0))
lhcb1.new("mcs.b27r4.b1", "mcs", at="1272.5137+(-209-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245073.0, assembly_id=102897.0))
lhcb1.new("mb.c27r4.b1", "mb", at="1280.7497+(-209.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832494.0, assembly_id=102898.0))
lhcb1.new("mcs.c27r4.b1", "mcs", at="1288.1737+(-210-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245076.0, assembly_id=102898.0))
lhcb1.new("bpm.27r4.b1", "bpm", at="1289.0527+(-210-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245078.0, assembly_id=102899.0))
lhcb1.new("mqs.27r4.b1", "mqs", at="1289.8067+(-210-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307673.0, assembly_id=102899.0))
lhcb1.new("mq.27r4.b1", "mq", at="1291.8147+(-210-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308204.0, assembly_id=102899.0))
lhcb1.new("ms.27r4.b1", "ms", at="1293.7097+(-210-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251255.0, assembly_id=102899.0))
lhcb1.new("mcbv.27r4.b1", "mcbv", at="1294.3027+(-210-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251257.0, assembly_id=102899.0))
lhcb1.new("mco.a28r4.b1", "mco_unplugged", at="1295.3937+(-210-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251260.0, assembly_id=102900.0))
lhcb1.new("mcd.a28r4.b1", "mcd", at="1295.3952+(-210-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251261.0, assembly_id=102900.0))
lhcb1.new("mb.a28r4.b1", "mb", at="1302.8797+(-210.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832518.0, assembly_id=102900.0))
lhcb1.new("mcs.a28r4.b1", "mcs", at="1310.3037+(-211-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245086.0, assembly_id=102900.0))
lhcb1.new("mb.b28r4.b1", "mb", at="1318.5397+(-211.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832542.0, assembly_id=102901.0))
lhcb1.new("mcs.b28r4.b1", "mcs", at="1325.9637+(-212-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245089.0, assembly_id=102901.0))
lhcb1.new("mco.b28r4.b1", "mco_unplugged", at="1326.7137+(-212-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251264.0, assembly_id=102902.0))
lhcb1.new("mcd.b28r4.b1", "mcd", at="1326.7152+(-212-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251265.0, assembly_id=102902.0))
lhcb1.new("mb.c28r4.b1", "mb", at="1334.1997+(-212.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832566.0, assembly_id=102902.0))
lhcb1.new("mcs.c28r4.b1", "mcs", at="1341.6237+(-213-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245094.0, assembly_id=102902.0))
lhcb1.new("bpm.28r4.b1", "bpm", at="1342.5027+(-213-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245096.0, assembly_id=102903.0))
lhcb1.new("mo.28r4.b1", "mo", at="1343.2537+(-213-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308702.0, assembly_id=102903.0))
lhcb1.new("mq.28r4.b1", "mq", at="1345.2647+(-213-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307996.0, assembly_id=102903.0))
lhcb1.new("ms.28r4.b1", "ms", at="1347.1597+(-213-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251267.0, assembly_id=102903.0))
lhcb1.new("mcbh.28r4.b1", "mcbh", at="1347.7527+(-213-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251269.0, assembly_id=102903.0))
lhcb1.new("mb.a29r4.b1", "mb", at="1356.3297+(-213.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832590.0, assembly_id=102904.0))
lhcb1.new("mcs.a29r4.b1", "mcs", at="1363.7537+(-214-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245102.0, assembly_id=102904.0))
lhcb1.new("mco.29r4.b1", "mco_unplugged", at="1364.5037+(-214-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251272.0, assembly_id=102905.0))
lhcb1.new("mcd.29r4.b1", "mcd", at="1364.5052+(-214-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251273.0, assembly_id=102905.0))
lhcb1.new("mb.b29r4.b1", "mb", at="1371.9897+(-214.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832614.0, assembly_id=102905.0))
lhcb1.new("mcs.b29r4.b1", "mcs", at="1379.4137+(-215-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245107.0, assembly_id=102905.0))
lhcb1.new("mb.c29r4.b1", "mb", at="1387.6497+(-215.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832638.0, assembly_id=102906.0))
lhcb1.new("mcs.c29r4.b1", "mcs", at="1395.0737+(-216-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245110.0, assembly_id=102906.0))
lhcb1.new("bpm.29r4.b1", "bpm", at="1395.9527+(-216-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245112.0, assembly_id=102907.0))
lhcb1.new("mo.29r4.b1", "mo", at="1396.7037+(-216-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308734.0, assembly_id=102907.0))
lhcb1.new("mq.29r4.b1", "mq", at="1398.7147+(-216-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308027.0, assembly_id=102907.0))
lhcb1.new("ms.29r4.b1", "ms", at="1400.6097+(-216-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251275.0, assembly_id=102907.0))
lhcb1.new("mcbv.29r4.b1", "mcbv", at="1401.2027+(-216-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251277.0, assembly_id=102907.0))
lhcb1.new("mco.a30r4.b1", "mco_unplugged", at="1402.2937+(-216-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251280.0, assembly_id=102908.0))
lhcb1.new("mcd.a30r4.b1", "mcd", at="1402.2952+(-216-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251281.0, assembly_id=102908.0))
lhcb1.new("mb.a30r4.b1", "mb", at="1409.7797+(-216.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832662.0, assembly_id=102908.0))
lhcb1.new("mcs.a30r4.b1", "mcs", at="1417.2037+(-217-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245120.0, assembly_id=102908.0))
lhcb1.new("mb.b30r4.b1", "mb", at="1425.4397+(-217.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832686.0, assembly_id=102909.0))
lhcb1.new("mcs.b30r4.b1", "mcs", at="1432.8637+(-218-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245123.0, assembly_id=102909.0))
lhcb1.new("mco.b30r4.b1", "mco_unplugged", at="1433.6137+(-218-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251284.0, assembly_id=102910.0))
lhcb1.new("mcd.b30r4.b1", "mcd", at="1433.6152+(-218-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251285.0, assembly_id=102910.0))
lhcb1.new("mb.c30r4.b1", "mb", at="1441.0997+(-218.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832710.0, assembly_id=102910.0))
lhcb1.new("mcs.c30r4.b1", "mcs", at="1448.5237+(-219-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245128.0, assembly_id=102910.0))
lhcb1.new("bpm.30r4.b1", "bpm", at="1449.4027+(-219-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245130.0, assembly_id=102911.0))
lhcb1.new("mo.30r4.b1", "mo", at="1450.1537+(-219-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308765.0, assembly_id=102911.0))
lhcb1.new("mq.30r4.b1", "mq", at="1452.1647+(-219-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308057.0, assembly_id=102911.0))
lhcb1.new("mss.30r4.b1", "mss", at="1454.0597+(-219-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251287.0, assembly_id=102911.0))
lhcb1.new("mcbh.30r4.b1", "mcbh", at="1454.6527+(-219-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251289.0, assembly_id=102911.0))
lhcb1.new("mb.a31r4.b1", "mb", at="1463.2297+(-219.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832734.0, assembly_id=102912.0))
lhcb1.new("mcs.a31r4.b1", "mcs", at="1470.6537+(-220-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245136.0, assembly_id=102912.0))
lhcb1.new("mco.31r4.b1", "mco_unplugged", at="1471.4037+(-220-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251292.0, assembly_id=102913.0))
lhcb1.new("mcd.31r4.b1", "mcd", at="1471.4052+(-220-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251293.0, assembly_id=102913.0))
lhcb1.new("mb.b31r4.b1", "mb", at="1478.8897+(-220.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832758.0, assembly_id=102913.0))
lhcb1.new("mcs.b31r4.b1", "mcs", at="1486.3137+(-221-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245141.0, assembly_id=102913.0))
lhcb1.new("mb.c31r4.b1", "mb", at="1494.5497+(-221.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832782.0, assembly_id=102914.0))
lhcb1.new("mcs.c31r4.b1", "mcs", at="1501.9737+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245144.0, assembly_id=102914.0))
lhcb1.new("bpm.31r4.b1", "bpm", at="1502.8527+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245146.0, assembly_id=102915.0))
lhcb1.new("mo.31r4.b1", "mo", at="1503.6037+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308795.0, assembly_id=102915.0))
lhcb1.new("mq.31r4.b1", "mq", at="1505.6147+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307848.0, assembly_id=102915.0))
lhcb1.new("ms.31r4.b1", "ms", at="1507.5097+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251295.0, assembly_id=102915.0))
lhcb1.new("mcbv.31r4.b1", "mcbv", at="1508.1027+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251297.0, assembly_id=102915.0))
lhcb1.new("s.cell.45.b1", "omk", at="1508.8497+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a32r4.b1", "mco_unplugged", at="1509.1937+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251300.0, assembly_id=102916.0))
lhcb1.new("mcd.a32r4.b1", "mcd", at="1509.1952+(-222-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251301.0, assembly_id=102916.0))
lhcb1.new("mb.a32r4.b1", "mb", at="1516.6797+(-222.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832806.0, assembly_id=102916.0))
lhcb1.new("mcs.a32r4.b1", "mcs", at="1524.1037+(-223-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245154.0, assembly_id=102916.0))
lhcb1.new("mb.b32r4.b1", "mb", at="1532.3397+(-223.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832830.0, assembly_id=102917.0))
lhcb1.new("mcs.b32r4.b1", "mcs", at="1539.7637+(-224-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245157.0, assembly_id=102917.0))
lhcb1.new("mco.b32r4.b1", "mco_unplugged", at="1540.5137+(-224-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251304.0, assembly_id=102918.0))
lhcb1.new("mcd.b32r4.b1", "mcd", at="1540.5152+(-224-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251305.0, assembly_id=102918.0))
lhcb1.new("mb.c32r4.b1", "mb", at="1547.9997+(-224.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832854.0, assembly_id=102918.0))
lhcb1.new("mcs.c32r4.b1", "mcs", at="1555.4237+(-225-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245162.0, assembly_id=102918.0))
lhcb1.new("bpm.32r4.b1", "bpm", at="1556.3027+(-225-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245164.0, assembly_id=102919.0))
lhcb1.new("mo.32r4.b1", "mo", at="1557.0537+(-225-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308587.0, assembly_id=102919.0))
lhcb1.new("mq.32r4.b1", "mq", at="1559.0647+(-225-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307878.0, assembly_id=102919.0))
lhcb1.new("ms.32r4.b1", "ms", at="1560.9597+(-225-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251307.0, assembly_id=102919.0))
lhcb1.new("mcbh.32r4.b1", "mcbh", at="1561.5527+(-225-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251309.0, assembly_id=102919.0))
lhcb1.new("mb.a33r4.b1", "mb", at="1570.1297+(-225.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832878.0, assembly_id=102920.0))
lhcb1.new("mcs.a33r4.b1", "mcs", at="1577.5537+(-226-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245170.0, assembly_id=102920.0))
lhcb1.new("mco.33r4.b1", "mco_unplugged", at="1578.3037+(-226-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251312.0, assembly_id=102921.0))
lhcb1.new("mcd.33r4.b1", "mcd", at="1578.3052+(-226-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251313.0, assembly_id=102921.0))
lhcb1.new("mb.b33r4.b1", "mb", at="1585.7897+(-226.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832902.0, assembly_id=102921.0))
lhcb1.new("mcs.b33r4.b1", "mcs", at="1593.2137+(-227-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245175.0, assembly_id=102921.0))
lhcb1.new("mb.c33r4.b1", "mb", at="1601.4497+(-227.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832926.0, assembly_id=102922.0))
lhcb1.new("mcs.c33r4.b1", "mcs", at="1608.8737+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245178.0, assembly_id=102922.0))
lhcb1.new("bpm.33r4.b1", "bpm", at="1609.7527+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245180.0, assembly_id=102923.0))
lhcb1.new("mo.33r4.b1", "mo", at="1610.5037+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308618.0, assembly_id=102923.0))
lhcb1.new("mq.33r4.b1", "mq", at="1612.5147+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307908.0, assembly_id=102923.0))
lhcb1.new("ms.33r4.b1", "ms", at="1614.4097+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251315.0, assembly_id=102923.0))
lhcb1.new("mcbv.33r4.b1", "mcbv", at="1615.0027+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251317.0, assembly_id=102923.0))
lhcb1.new("e.cell.45.b1", "omk", at="1615.7497+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a34r4.b1", "mco_unplugged", at="1616.0937+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251320.0, assembly_id=102924.0))
lhcb1.new("mcd.a34r4.b1", "mcd", at="1616.0952+(-228-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251321.0, assembly_id=102924.0))
lhcb1.new("mb.a34r4.b1", "mb", at="1623.5797+(-228.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832950.0, assembly_id=102924.0))
lhcb1.new("mcs.a34r4.b1", "mcs", at="1631.0037+(-229-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245188.0, assembly_id=102924.0))
lhcb1.new("mb.b34r4.b1", "mb", at="1639.2397+(-229.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832974.0, assembly_id=102925.0))
lhcb1.new("mcs.b34r4.b1", "mcs", at="1646.6637+(-230-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245191.0, assembly_id=102925.0))
lhcb1.new("mco.b34r4.b1", "mco_unplugged", at="1647.4137+(-230-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251324.0, assembly_id=102926.0))
lhcb1.new("mcd.b34r4.b1", "mcd", at="1647.4152+(-230-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=251325.0, assembly_id=102926.0))
lhcb1.new("mb.c34r4.b1", "mb", at="1654.8997+(-230.5-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=52832998.0, assembly_id=102926.0))
lhcb1.new("mcs.c34r4.b1", "mcs", at="1662.3237+(-231-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245196.0, assembly_id=102926.0))
lhcb1.new("bpm.34r4.b1", "bpm", at="1663.2027+(-231-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=245198.0, assembly_id=102927.0))
lhcb1.new("mo.34r4.b1", "mo", at="1663.9537+(-231-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2308633.0, assembly_id=102927.0))
lhcb1.new("mq.34r4.b1", "mq", at="1665.9647+(-231-ip4ofs.b1)*ds", from_="ip4", extra=dict(mech_sep=-0.194, slot_id=2307923.0, assembly_id=102927.0))
lhcb1.new("mss.34l5.b1", "mss", at="-1664.5007+(-231-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251327.0, assembly_id=102927.0))
lhcb1.new("mcbh.34l5.b1", "mcbh", at="-1663.9077+(-231-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251329.0, assembly_id=102927.0))
lhcb1.new("mb.c34l5.b1", "mb", at="-1655.3307+(-231.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833022.0, assembly_id=102928.0))
lhcb1.new("mcs.c34l5.b1", "mcs", at="-1647.9067+(-232-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245204.0, assembly_id=102928.0))
lhcb1.new("mco.34l5.b1", "mco_unplugged", at="-1647.1567+(-232-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251332.0, assembly_id=102929.0))
lhcb1.new("mcd.34l5.b1", "mcd", at="-1647.1552+(-232-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251333.0, assembly_id=102929.0))
lhcb1.new("mb.b34l5.b1", "mb", at="-1639.6707+(-232.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833046.0, assembly_id=102929.0))
lhcb1.new("mcs.b34l5.b1", "mcs", at="-1632.2467+(-233-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245209.0, assembly_id=102929.0))
lhcb1.new("mb.a34l5.b1", "mb", at="-1624.0107+(-233.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833070.0, assembly_id=102930.0))
lhcb1.new("mcs.a34l5.b1", "mcs", at="-1616.5867+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245212.0, assembly_id=102930.0))
lhcb1.new("bpm.33l5.b1", "bpm", at="-1615.7077+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245214.0, assembly_id=102931.0))
lhcb1.new("mo.33l5.b1", "mo", at="-1614.9567+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308605.0, assembly_id=102931.0))
lhcb1.new("mq.33l5.b1", "mq", at="-1612.9457+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307895.0, assembly_id=102931.0))
lhcb1.new("ms.33l5.b1", "ms", at="-1611.0507+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251335.0, assembly_id=102931.0))
lhcb1.new("mcbv.33l5.b1", "mcbv", at="-1610.4577+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251337.0, assembly_id=102931.0))
lhcb1.new("mco.b33l5.b1", "mco_unplugged", at="-1609.3667+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251340.0, assembly_id=102932.0))
lhcb1.new("mcd.b33l5.b1", "mcd", at="-1609.3652+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251341.0, assembly_id=102932.0))
lhcb1.new("mb.c33l5.b1", "mb", at="-1601.8807+(-234.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833094.0, assembly_id=102932.0))
lhcb1.new("mcs.c33l5.b1", "mcs", at="-1594.4567+(-235-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245222.0, assembly_id=102932.0))
lhcb1.new("mb.b33l5.b1", "mb", at="-1586.2207+(-235.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833118.0, assembly_id=102933.0))
lhcb1.new("mcs.b33l5.b1", "mcs", at="-1578.7967+(-236-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245225.0, assembly_id=102933.0))
lhcb1.new("mco.a33l5.b1", "mco_unplugged", at="-1578.0467+(-236-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251344.0, assembly_id=102934.0))
lhcb1.new("mcd.a33l5.b1", "mcd", at="-1578.0452+(-236-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251345.0, assembly_id=102934.0))
lhcb1.new("mb.a33l5.b1", "mb", at="-1570.5607+(-236.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833142.0, assembly_id=102934.0))
lhcb1.new("mcs.a33l5.b1", "mcs", at="-1563.1367+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245230.0, assembly_id=102934.0))
lhcb1.new("bpm.32l5.b1", "bpm", at="-1562.2577+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245232.0, assembly_id=102935.0))
lhcb1.new("mo.32l5.b1", "mo", at="-1561.5067+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308573.0, assembly_id=102935.0))
lhcb1.new("mq.32l5.b1", "mq", at="-1559.4957+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307865.0, assembly_id=102935.0))
lhcb1.new("mss.32l5.b1", "mss", at="-1557.6007+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251347.0, assembly_id=102935.0))
lhcb1.new("mcbh.32l5.b1", "mcbh", at="-1557.0077+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251349.0, assembly_id=102935.0))
lhcb1.new("mb.c32l5.b1", "mb", at="-1548.4307+(-237.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833166.0, assembly_id=102936.0))
lhcb1.new("mcs.c32l5.b1", "mcs", at="-1541.0067+(-238-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245238.0, assembly_id=102936.0))
lhcb1.new("mco.32l5.b1", "mco_unplugged", at="-1540.2567+(-238-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251352.0, assembly_id=102937.0))
lhcb1.new("mcd.32l5.b1", "mcd", at="-1540.2552+(-238-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251353.0, assembly_id=102937.0))
lhcb1.new("mb.b32l5.b1", "mb", at="-1532.7707+(-238.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833190.0, assembly_id=102937.0))
lhcb1.new("mcs.b32l5.b1", "mcs", at="-1525.3467+(-239-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245243.0, assembly_id=102937.0))
lhcb1.new("mb.a32l5.b1", "mb", at="-1517.1107+(-239.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833214.0, assembly_id=102938.0))
lhcb1.new("mcs.a32l5.b1", "mcs", at="-1509.6867+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245246.0, assembly_id=102938.0))
lhcb1.new("bpm.31l5.b1", "bpm", at="-1508.8077+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245248.0, assembly_id=102939.0))
lhcb1.new("mo.31l5.b1", "mo", at="-1508.0567+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308782.0, assembly_id=102939.0))
lhcb1.new("mq.31l5.b1", "mq", at="-1506.0457+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308073.0, assembly_id=102939.0))
lhcb1.new("ms.31l5.b1", "ms", at="-1504.1507+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251355.0, assembly_id=102939.0))
lhcb1.new("mcbv.31l5.b1", "mcbv", at="-1503.5577+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251357.0, assembly_id=102939.0))
lhcb1.new("mco.b31l5.b1", "mco_unplugged", at="-1502.4667+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251360.0, assembly_id=102940.0))
lhcb1.new("mcd.b31l5.b1", "mcd", at="-1502.4652+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251361.0, assembly_id=102940.0))
lhcb1.new("mb.c31l5.b1", "mb", at="-1494.9807+(-240.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833238.0, assembly_id=102940.0))
lhcb1.new("mcs.c31l5.b1", "mcs", at="-1487.5567+(-241-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245256.0, assembly_id=102940.0))
lhcb1.new("mb.b31l5.b1", "mb", at="-1479.3207+(-241.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833262.0, assembly_id=102941.0))
lhcb1.new("mcs.b31l5.b1", "mcs", at="-1471.8967+(-242-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245259.0, assembly_id=102941.0))
lhcb1.new("mco.a31l5.b1", "mco_unplugged", at="-1471.1467+(-242-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251364.0, assembly_id=102942.0))
lhcb1.new("mcd.a31l5.b1", "mcd", at="-1471.1452+(-242-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251365.0, assembly_id=102942.0))
lhcb1.new("mb.a31l5.b1", "mb", at="-1463.6607+(-242.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833286.0, assembly_id=102942.0))
lhcb1.new("mcs.a31l5.b1", "mcs", at="-1456.2367+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245264.0, assembly_id=102942.0))
lhcb1.new("bpm.30l5.b1", "bpm", at="-1455.3577+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245266.0, assembly_id=102943.0))
lhcb1.new("mo.30l5.b1", "mo", at="-1454.6067+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308752.0, assembly_id=102943.0))
lhcb1.new("mq.30l5.b1", "mq", at="-1452.5957+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2348466.0, assembly_id=102943.0))
lhcb1.new("ms.30l5.b1", "ms", at="-1450.7007+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251367.0, assembly_id=102943.0))
lhcb1.new("mcbh.30l5.b1", "mcbh", at="-1450.1077+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251369.0, assembly_id=102943.0))
lhcb1.new("mb.c30l5.b1", "mb", at="-1441.5307+(-243.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833310.0, assembly_id=102944.0))
lhcb1.new("mcs.c30l5.b1", "mcs", at="-1434.1067+(-244-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245272.0, assembly_id=102944.0))
lhcb1.new("mco.30l5.b1", "mco_unplugged", at="-1433.3567+(-244-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251372.0, assembly_id=102945.0))
lhcb1.new("mcd.30l5.b1", "mcd", at="-1433.3552+(-244-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251373.0, assembly_id=102945.0))
lhcb1.new("mb.b30l5.b1", "mb", at="-1425.8707+(-244.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833334.0, assembly_id=102945.0))
lhcb1.new("mcs.b30l5.b1", "mcs", at="-1418.4467+(-245-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245277.0, assembly_id=102945.0))
lhcb1.new("mb.a30l5.b1", "mb", at="-1410.2107+(-245.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833358.0, assembly_id=102946.0))
lhcb1.new("mcs.a30l5.b1", "mcs", at="-1402.7867+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245280.0, assembly_id=102946.0))
lhcb1.new("bpm.29l5.b1", "bpm", at="-1401.9077+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245282.0, assembly_id=102947.0))
lhcb1.new("mo.29l5.b1", "mo", at="-1401.1567+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308720.0, assembly_id=102947.0))
lhcb1.new("mq.29l5.b1", "mq", at="-1399.1457+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308014.0, assembly_id=102947.0))
lhcb1.new("ms.29l5.b1", "ms", at="-1397.2507+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251375.0, assembly_id=102947.0))
lhcb1.new("mcbv.29l5.b1", "mcbv", at="-1396.6577+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251377.0, assembly_id=102947.0))
lhcb1.new("mco.b29l5.b1", "mco_unplugged", at="-1395.5667+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251380.0, assembly_id=102948.0))
lhcb1.new("mcd.b29l5.b1", "mcd", at="-1395.5652+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251381.0, assembly_id=102948.0))
lhcb1.new("mb.c29l5.b1", "mb", at="-1388.0807+(-246.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833382.0, assembly_id=102948.0))
lhcb1.new("mcs.c29l5.b1", "mcs", at="-1380.6567+(-247-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245290.0, assembly_id=102948.0))
lhcb1.new("mb.b29l5.b1", "mb", at="-1372.4207+(-247.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833406.0, assembly_id=102949.0))
lhcb1.new("mcs.b29l5.b1", "mcs", at="-1364.9967+(-248-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245293.0, assembly_id=102949.0))
lhcb1.new("mco.a29l5.b1", "mco_unplugged", at="-1364.2467+(-248-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251384.0, assembly_id=102950.0))
lhcb1.new("mcd.a29l5.b1", "mcd", at="-1364.2452+(-248-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251385.0, assembly_id=102950.0))
lhcb1.new("mb.a29l5.b1", "mb", at="-1356.7607+(-248.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833430.0, assembly_id=102950.0))
lhcb1.new("mcs.a29l5.b1", "mcs", at="-1349.3367+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245298.0, assembly_id=102950.0))
lhcb1.new("bpm.28l5.b1", "bpm", at="-1348.4577+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245300.0, assembly_id=102951.0))
lhcb1.new("mo.28l5.b1", "mo", at="-1347.7067+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308689.0, assembly_id=102951.0))
lhcb1.new("mq.28l5.b1", "mq", at="-1345.6957+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307982.0, assembly_id=102951.0))
lhcb1.new("mss.28l5.b1", "mss", at="-1343.8007+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251387.0, assembly_id=102951.0))
lhcb1.new("mcbh.28l5.b1", "mcbh", at="-1343.2077+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251389.0, assembly_id=102951.0))
lhcb1.new("mb.c28l5.b1", "mb", at="-1334.6307+(-249.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833454.0, assembly_id=102952.0))
lhcb1.new("mcs.c28l5.b1", "mcs", at="-1327.2067+(-250-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245306.0, assembly_id=102952.0))
lhcb1.new("mco.28l5.b1", "mco_unplugged", at="-1326.4567+(-250-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251392.0, assembly_id=102953.0))
lhcb1.new("mcd.28l5.b1", "mcd", at="-1326.4552+(-250-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251393.0, assembly_id=102953.0))
lhcb1.new("mb.b28l5.b1", "mb", at="-1318.9707+(-250.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833478.0, assembly_id=102953.0))
lhcb1.new("mcs.b28l5.b1", "mcs", at="-1311.5467+(-251-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245311.0, assembly_id=102953.0))
lhcb1.new("mb.a28l5.b1", "mb", at="-1303.3107+(-251.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833502.0, assembly_id=102954.0))
lhcb1.new("mcs.a28l5.b1", "mcs", at="-1295.8867+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245314.0, assembly_id=102954.0))
lhcb1.new("bpm.27l5.b1", "bpm", at="-1295.0077+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245316.0, assembly_id=102955.0))
lhcb1.new("mqs.27l5.b1", "mqs", at="-1294.2537+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307659.0, assembly_id=102955.0))
lhcb1.new("mq.27l5.b1", "mq", at="-1292.2457+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308191.0, assembly_id=102955.0))
lhcb1.new("ms.27l5.b1", "ms", at="-1290.3507+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251395.0, assembly_id=102955.0))
lhcb1.new("mcbv.27l5.b1", "mcbv", at="-1289.7577+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251397.0, assembly_id=102955.0))
lhcb1.new("mco.b27l5.b1", "mco_unplugged", at="-1288.6667+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251400.0, assembly_id=102956.0))
lhcb1.new("mcd.b27l5.b1", "mcd", at="-1288.6652+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251401.0, assembly_id=102956.0))
lhcb1.new("mb.c27l5.b1", "mb", at="-1281.1807+(-252.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833526.0, assembly_id=102956.0))
lhcb1.new("mcs.c27l5.b1", "mcs", at="-1273.7567+(-253-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245324.0, assembly_id=102956.0))
lhcb1.new("mb.b27l5.b1", "mb", at="-1265.5207+(-253.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833550.0, assembly_id=102957.0))
lhcb1.new("mcs.b27l5.b1", "mcs", at="-1258.0967+(-254-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245327.0, assembly_id=102957.0))
lhcb1.new("mco.a27l5.b1", "mco_unplugged", at="-1257.3467+(-254-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251404.0, assembly_id=102958.0))
lhcb1.new("mcd.a27l5.b1", "mcd", at="-1257.3452+(-254-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251405.0, assembly_id=102958.0))
lhcb1.new("mb.a27l5.b1", "mb", at="-1249.8607+(-254.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833574.0, assembly_id=102958.0))
lhcb1.new("mcs.a27l5.b1", "mcs", at="-1242.4367+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245332.0, assembly_id=102958.0))
lhcb1.new("bpm.26l5.b1", "bpm", at="-1241.5577+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245334.0, assembly_id=102959.0))
lhcb1.new("mo.26l5.b1", "mo", at="-1240.8067+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308899.0, assembly_id=102959.0))
lhcb1.new("mq.26l5.b1", "mq", at="-1238.7957+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308162.0, assembly_id=102959.0))
lhcb1.new("ms.26l5.b1", "ms", at="-1236.9007+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251407.0, assembly_id=102959.0))
lhcb1.new("mcbh.26l5.b1", "mcbh", at="-1236.3077+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251409.0, assembly_id=102959.0))
lhcb1.new("mb.c26l5.b1", "mb", at="-1227.7307+(-255.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833598.0, assembly_id=102960.0))
lhcb1.new("mcs.c26l5.b1", "mcs", at="-1220.3067+(-256-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245340.0, assembly_id=102960.0))
lhcb1.new("mco.26l5.b1", "mco_unplugged", at="-1219.5567+(-256-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251412.0, assembly_id=102961.0))
lhcb1.new("mcd.26l5.b1", "mcd", at="-1219.5552+(-256-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251413.0, assembly_id=102961.0))
lhcb1.new("mb.b26l5.b1", "mb", at="-1212.0707+(-256.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833622.0, assembly_id=102961.0))
lhcb1.new("mcs.b26l5.b1", "mcs", at="-1204.6467+(-257-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245345.0, assembly_id=102961.0))
lhcb1.new("mb.a26l5.b1", "mb", at="-1196.4107+(-257.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833646.0, assembly_id=102962.0))
lhcb1.new("mcs.a26l5.b1", "mcs", at="-1188.9867+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245348.0, assembly_id=102962.0))
lhcb1.new("bpm.25l5.b1", "bpm", at="-1188.1077+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245350.0, assembly_id=102963.0))
lhcb1.new("mo.25l5.b1", "mo", at="-1187.3567+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308867.0, assembly_id=102963.0))
lhcb1.new("mq.25l5.b1", "mq", at="-1185.3457+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308130.0, assembly_id=102963.0))
lhcb1.new("ms.25l5.b1", "ms", at="-1183.4507+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251415.0, assembly_id=102963.0))
lhcb1.new("mcbv.25l5.b1", "mcbv", at="-1182.8577+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251417.0, assembly_id=102963.0))
lhcb1.new("mco.b25l5.b1", "mco_unplugged", at="-1181.7667+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251420.0, assembly_id=102964.0))
lhcb1.new("mcd.b25l5.b1", "mcd", at="-1181.7652+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251421.0, assembly_id=102964.0))
lhcb1.new("mb.c25l5.b1", "mb", at="-1174.2807+(-258.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833670.0, assembly_id=102964.0))
lhcb1.new("mcs.c25l5.b1", "mcs", at="-1166.8567+(-259-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245358.0, assembly_id=102964.0))
lhcb1.new("mb.b25l5.b1", "mb", at="-1158.6207+(-259.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833694.0, assembly_id=102965.0))
lhcb1.new("mcs.b25l5.b1", "mcs", at="-1151.1967+(-260-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245361.0, assembly_id=102965.0))
lhcb1.new("mco.a25l5.b1", "mco_unplugged", at="-1150.4467+(-260-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251424.0, assembly_id=102966.0))
lhcb1.new("mcd.a25l5.b1", "mcd", at="-1150.4452+(-260-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251425.0, assembly_id=102966.0))
lhcb1.new("mb.a25l5.b1", "mb", at="-1142.9607+(-260.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833718.0, assembly_id=102966.0))
lhcb1.new("mcs.a25l5.b1", "mcs", at="-1135.5367+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245366.0, assembly_id=102966.0))
lhcb1.new("bpm.24l5.b1", "bpm", at="-1134.6577+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245368.0, assembly_id=102967.0))
lhcb1.new("mo.24l5.b1", "mo", at="-1133.9067+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308836.0, assembly_id=102967.0))
lhcb1.new("mq.24l5.b1", "mq", at="-1131.8957+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308098.0, assembly_id=102967.0))
lhcb1.new("ms.24l5.b1", "ms", at="-1130.0007+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251427.0, assembly_id=102967.0))
lhcb1.new("mcbh.24l5.b1", "mcbh", at="-1129.4077+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251429.0, assembly_id=102967.0))
lhcb1.new("mb.c24l5.b1", "mb", at="-1120.8307+(-261.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833742.0, assembly_id=102968.0))
lhcb1.new("mcs.c24l5.b1", "mcs", at="-1113.4067+(-262-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245374.0, assembly_id=102968.0))
lhcb1.new("mco.24l5.b1", "mco_unplugged", at="-1112.6567+(-262-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251432.0, assembly_id=102969.0))
lhcb1.new("mcd.24l5.b1", "mcd", at="-1112.6552+(-262-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251433.0, assembly_id=102969.0))
lhcb1.new("mb.b24l5.b1", "mb", at="-1105.1707+(-262.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833766.0, assembly_id=102969.0))
lhcb1.new("mcs.b24l5.b1", "mcs", at="-1097.7467+(-263-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245379.0, assembly_id=102969.0))
lhcb1.new("mb.a24l5.b1", "mb", at="-1089.5107+(-263.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833790.0, assembly_id=102970.0))
lhcb1.new("mcs.a24l5.b1", "mcs", at="-1082.0867+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245382.0, assembly_id=102970.0))
lhcb1.new("bpm.23l5.b1", "bpm", at="-1081.2077+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245384.0, assembly_id=102971.0))
lhcb1.new("mqs.23l5.b1", "mqs", at="-1080.4537+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307628.0, assembly_id=102971.0))
lhcb1.new("mq.23l5.b1", "mq", at="-1078.4457+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308309.0, assembly_id=102971.0))
lhcb1.new("ms.23l5.b1", "ms", at="-1076.5507+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251435.0, assembly_id=102971.0))
lhcb1.new("mcbv.23l5.b1", "mcbv", at="-1075.9577+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251437.0, assembly_id=102971.0))
lhcb1.new("mco.b23l5.b1", "mco_unplugged", at="-1074.8667+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251440.0, assembly_id=102972.0))
lhcb1.new("mcd.b23l5.b1", "mcd", at="-1074.8652+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251441.0, assembly_id=102972.0))
lhcb1.new("mb.c23l5.b1", "mb", at="-1067.3807+(-264.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833814.0, assembly_id=102972.0))
lhcb1.new("mcs.c23l5.b1", "mcs", at="-1059.9567+(-265-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245392.0, assembly_id=102972.0))
lhcb1.new("mb.b23l5.b1", "mb", at="-1051.7207+(-265.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833838.0, assembly_id=102973.0))
lhcb1.new("mcs.b23l5.b1", "mcs", at="-1044.2967+(-266-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245395.0, assembly_id=102973.0))
lhcb1.new("mco.a23l5.b1", "mco_unplugged", at="-1043.5467+(-266-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251444.0, assembly_id=102974.0))
lhcb1.new("mcd.a23l5.b1", "mcd", at="-1043.5452+(-266-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251445.0, assembly_id=102974.0))
lhcb1.new("mb.a23l5.b1", "mb", at="-1036.0607+(-266.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833862.0, assembly_id=102974.0))
lhcb1.new("mcs.a23l5.b1", "mcs", at="-1028.6367+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245400.0, assembly_id=102974.0))
lhcb1.new("bpm.22l5.b1", "bpm", at="-1027.7577+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245402.0, assembly_id=102975.0))
lhcb1.new("mo.22l5.b1", "mo", at="-1027.0067+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308806.0, assembly_id=102975.0))
lhcb1.new("mq.22l5.b1", "mq", at="-1024.9957+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308277.0, assembly_id=102975.0))
lhcb1.new("ms.22l5.b1", "ms", at="-1023.1007+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251447.0, assembly_id=102975.0))
lhcb1.new("mcbh.22l5.b1", "mcbh", at="-1022.5077+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251449.0, assembly_id=102975.0))
lhcb1.new("mb.c22l5.b1", "mb", at="-1013.9307+(-267.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833886.0, assembly_id=102976.0))
lhcb1.new("mcs.c22l5.b1", "mcs", at="-1006.5067+(-268-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245408.0, assembly_id=102976.0))
lhcb1.new("mco.22l5.b1", "mco_unplugged", at="-1005.7567+(-268-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251452.0, assembly_id=102977.0))
lhcb1.new("mcd.22l5.b1", "mcd", at="-1005.7552+(-268-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251453.0, assembly_id=102977.0))
lhcb1.new("mb.b22l5.b1", "mb", at="-998.2707+(-268.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833910.0, assembly_id=102977.0))
lhcb1.new("mcs.b22l5.b1", "mcs", at="-990.8467+(-269-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245413.0, assembly_id=102977.0))
lhcb1.new("mb.a22l5.b1", "mb", at="-982.6107+(-269.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833934.0, assembly_id=102978.0))
lhcb1.new("mcs.a22l5.b1", "mcs", at="-975.1867+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245416.0, assembly_id=102978.0))
lhcb1.new("bpm.21l5.b1", "bpm", at="-974.3077+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245418.0, assembly_id=102979.0))
lhcb1.new("mqt.21l5.b1", "mqt", at="-973.5537+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307261.0, assembly_id=102979.0))
lhcb1.new("mq.21l5.b1", "mq", at="-971.5457+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308245.0, assembly_id=102979.0))
lhcb1.new("ms.21l5.b1", "ms", at="-969.6507+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251455.0, assembly_id=102979.0))
lhcb1.new("mcbv.21l5.b1", "mcbv", at="-969.0577+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251457.0, assembly_id=102979.0))
lhcb1.new("mco.b21l5.b1", "mco_unplugged", at="-967.9667+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251460.0, assembly_id=102980.0))
lhcb1.new("mcd.b21l5.b1", "mcd", at="-967.9652+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251461.0, assembly_id=102980.0))
lhcb1.new("mb.c21l5.b1", "mb", at="-960.4807+(-270.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833958.0, assembly_id=102980.0))
lhcb1.new("mcs.c21l5.b1", "mcs", at="-953.0567+(-271-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245426.0, assembly_id=102980.0))
lhcb1.new("mb.b21l5.b1", "mb", at="-944.8207+(-271.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52833982.0, assembly_id=102981.0))
lhcb1.new("mcs.b21l5.b1", "mcs", at="-937.3967+(-272-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245429.0, assembly_id=102981.0))
lhcb1.new("mco.a21l5.b1", "mco_unplugged", at="-936.6467+(-272-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251464.0, assembly_id=102982.0))
lhcb1.new("mcd.a21l5.b1", "mcd", at="-936.6452+(-272-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251465.0, assembly_id=102982.0))
lhcb1.new("mb.a21l5.b1", "mb", at="-929.1607+(-272.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834006.0, assembly_id=102982.0))
lhcb1.new("mcs.a21l5.b1", "mcs", at="-921.7367+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245434.0, assembly_id=102982.0))
lhcb1.new("bpm.20l5.b1", "bpm", at="-920.8577+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245436.0, assembly_id=102983.0))
lhcb1.new("mqt.20l5.b1", "mqt", at="-920.1037+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307464.0, assembly_id=102983.0))
lhcb1.new("mq.20l5.b1", "mq", at="-918.0957+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308216.0, assembly_id=102983.0))
lhcb1.new("ms.20l5.b1", "ms", at="-916.2007+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251467.0, assembly_id=102983.0))
lhcb1.new("mcbh.20l5.b1", "mcbh", at="-915.6077+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251469.0, assembly_id=102983.0))
lhcb1.new("mb.c20l5.b1", "mb", at="-907.0307+(-273.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834030.0, assembly_id=102984.0))
lhcb1.new("mcs.c20l5.b1", "mcs", at="-899.6067+(-274-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245442.0, assembly_id=102984.0))
lhcb1.new("mco.20l5.b1", "mco_unplugged", at="-898.8567+(-274-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251472.0, assembly_id=102985.0))
lhcb1.new("mcd.20l5.b1", "mcd", at="-898.8552+(-274-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251473.0, assembly_id=102985.0))
lhcb1.new("mb.b20l5.b1", "mb", at="-891.3707+(-274.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834054.0, assembly_id=102985.0))
lhcb1.new("mcs.b20l5.b1", "mcs", at="-883.9467+(-275-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245447.0, assembly_id=102985.0))
lhcb1.new("mb.a20l5.b1", "mb", at="-875.7107+(-275.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834078.0, assembly_id=102986.0))
lhcb1.new("mcs.a20l5.b1", "mcs", at="-868.2867+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245450.0, assembly_id=102986.0))
lhcb1.new("bpm.19l5.b1", "bpm", at="-867.4077+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245452.0, assembly_id=102987.0))
lhcb1.new("mqt.19l5.b1", "mqt", at="-866.6537+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307434.0, assembly_id=102987.0))
lhcb1.new("mq.19l5.b1", "mq", at="-864.6457+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308424.0, assembly_id=102987.0))
lhcb1.new("ms.19l5.b1", "ms", at="-862.7507+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251475.0, assembly_id=102987.0))
lhcb1.new("mcbv.19l5.b1", "mcbv", at="-862.1577+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251477.0, assembly_id=102987.0))
lhcb1.new("mco.b19l5.b1", "mco_unplugged", at="-861.0667+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251480.0, assembly_id=102988.0))
lhcb1.new("mcd.b19l5.b1", "mcd", at="-861.0652+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251481.0, assembly_id=102988.0))
lhcb1.new("mb.c19l5.b1", "mb", at="-853.5807+(-276.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834102.0, assembly_id=102988.0))
lhcb1.new("mcs.c19l5.b1", "mcs", at="-846.1567+(-277-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245460.0, assembly_id=102988.0))
lhcb1.new("mb.b19l5.b1", "mb", at="-837.9207+(-277.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834126.0, assembly_id=102989.0))
lhcb1.new("mcs.b19l5.b1", "mcs", at="-830.4967+(-278-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245463.0, assembly_id=102989.0))
lhcb1.new("mco.a19l5.b1", "mco_unplugged", at="-829.7467+(-278-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251484.0, assembly_id=102990.0))
lhcb1.new("mcd.a19l5.b1", "mcd", at="-829.7452+(-278-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251485.0, assembly_id=102990.0))
lhcb1.new("mb.a19l5.b1", "mb", at="-822.2607+(-278.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834150.0, assembly_id=102990.0))
lhcb1.new("mcs.a19l5.b1", "mcs", at="-814.8367+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245468.0, assembly_id=102990.0))
lhcb1.new("bpm.18l5.b1", "bpm", at="-813.9577+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245470.0, assembly_id=102991.0))
lhcb1.new("mqt.18l5.b1", "mqt", at="-813.2037+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307403.0, assembly_id=102991.0))
lhcb1.new("mq.18l5.b1", "mq", at="-811.1957+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2348483.0, assembly_id=102991.0))
lhcb1.new("ms.18l5.b1", "ms", at="-809.3007+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251487.0, assembly_id=102991.0))
lhcb1.new("mcbh.18l5.b1", "mcbh", at="-808.7077+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251489.0, assembly_id=102991.0))
lhcb1.new("mb.c18l5.b1", "mb", at="-800.1307+(-279.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834174.0, assembly_id=102992.0))
lhcb1.new("mcs.c18l5.b1", "mcs", at="-792.7067+(-280-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245476.0, assembly_id=102992.0))
lhcb1.new("mco.18l5.b1", "mco_unplugged", at="-791.9567+(-280-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251492.0, assembly_id=102993.0))
lhcb1.new("mcd.18l5.b1", "mcd", at="-791.9552+(-280-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251493.0, assembly_id=102993.0))
lhcb1.new("mb.b18l5.b1", "mb", at="-784.4707+(-280.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834198.0, assembly_id=102993.0))
lhcb1.new("mcs.b18l5.b1", "mcs", at="-777.0467+(-281-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245481.0, assembly_id=102993.0))
lhcb1.new("mb.a18l5.b1", "mb", at="-768.8107+(-281.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834222.0, assembly_id=102994.0))
lhcb1.new("mcs.a18l5.b1", "mcs", at="-761.3867+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245484.0, assembly_id=102994.0))
lhcb1.new("bpm.17l5.b1", "bpm", at="-760.5077+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245486.0, assembly_id=102995.0))
lhcb1.new("mqt.17l5.b1", "mqt", at="-759.7537+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307608.0, assembly_id=102995.0))
lhcb1.new("mq.17l5.b1", "mq", at="-757.7457+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308363.0, assembly_id=102995.0))
lhcb1.new("ms.17l5.b1", "ms", at="-755.8507+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251495.0, assembly_id=102995.0))
lhcb1.new("mcbv.17l5.b1", "mcbv", at="-755.2577+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251497.0, assembly_id=102995.0))
lhcb1.new("mco.b17l5.b1", "mco_unplugged", at="-754.1667+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251500.0, assembly_id=102996.0))
lhcb1.new("mcd.b17l5.b1", "mcd", at="-754.1652+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251501.0, assembly_id=102996.0))
lhcb1.new("mb.c17l5.b1", "mb", at="-746.6807+(-282.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834246.0, assembly_id=102996.0))
lhcb1.new("mcs.c17l5.b1", "mcs", at="-739.2567+(-283-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245494.0, assembly_id=102996.0))
lhcb1.new("mb.b17l5.b1", "mb", at="-731.0207+(-283.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834270.0, assembly_id=102997.0))
lhcb1.new("mcs.b17l5.b1", "mcs", at="-723.5967+(-284-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245497.0, assembly_id=102997.0))
lhcb1.new("mco.a17l5.b1", "mco_unplugged", at="-722.8467+(-284-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251504.0, assembly_id=102998.0))
lhcb1.new("mcd.a17l5.b1", "mcd", at="-722.8452+(-284-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251505.0, assembly_id=102998.0))
lhcb1.new("mb.a17l5.b1", "mb", at="-715.3607+(-284.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834294.0, assembly_id=102998.0))
lhcb1.new("mcs.a17l5.b1", "mcs", at="-707.9367+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245502.0, assembly_id=102998.0))
lhcb1.new("bpm.16l5.b1", "bpm", at="-707.0577+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245504.0, assembly_id=102999.0))
lhcb1.new("mqt.16l5.b1", "mqt", at="-706.3037+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307578.0, assembly_id=102999.0))
lhcb1.new("mq.16l5.b1", "mq", at="-704.2957+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308333.0, assembly_id=102999.0))
lhcb1.new("ms.16l5.b1", "ms", at="-702.4007+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251507.0, assembly_id=102999.0))
lhcb1.new("mcbh.16l5.b1", "mcbh", at="-701.8077+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251509.0, assembly_id=102999.0))
lhcb1.new("mb.c16l5.b1", "mb", at="-693.2307+(-285.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834318.0, assembly_id=103000.0))
lhcb1.new("mcs.c16l5.b1", "mcs", at="-685.8067+(-286-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245510.0, assembly_id=103000.0))
lhcb1.new("mco.16l5.b1", "mco_unplugged", at="-685.0567+(-286-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251512.0, assembly_id=103001.0))
lhcb1.new("mcd.16l5.b1", "mcd", at="-685.0552+(-286-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251513.0, assembly_id=103001.0))
lhcb1.new("mb.b16l5.b1", "mb", at="-677.5707+(-286.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834342.0, assembly_id=103001.0))
lhcb1.new("mcs.b16l5.b1", "mcs", at="-670.1467+(-287-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245515.0, assembly_id=103001.0))
lhcb1.new("mb.a16l5.b1", "mb", at="-661.9107+(-287.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834366.0, assembly_id=103002.0))
lhcb1.new("mcs.a16l5.b1", "mcs", at="-654.4867+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245518.0, assembly_id=103002.0))
lhcb1.new("bpm.15l5.b1", "bpm", at="-653.6077+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245520.0, assembly_id=103003.0))
lhcb1.new("mqt.15l5.b1", "mqt", at="-652.8537+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307547.0, assembly_id=103003.0))
lhcb1.new("mq.15l5.b1", "mq", at="-650.8457+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308540.0, assembly_id=103003.0))
lhcb1.new("ms.15l5.b1", "ms", at="-648.9507+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251515.0, assembly_id=103003.0))
lhcb1.new("mcbv.15l5.b1", "mcbv", at="-648.3577+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251517.0, assembly_id=103003.0))
lhcb1.new("mco.b15l5.b1", "mco_unplugged", at="-647.2667+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251520.0, assembly_id=103004.0))
lhcb1.new("mcd.b15l5.b1", "mcd", at="-647.2652+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251521.0, assembly_id=103004.0))
lhcb1.new("mb.c15l5.b1", "mb", at="-639.7807+(-288.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834390.0, assembly_id=103004.0))
lhcb1.new("mcs.c15l5.b1", "mcs", at="-632.3567+(-289-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245528.0, assembly_id=103004.0))
lhcb1.new("mb.b15l5.b1", "mb", at="-624.1207+(-289.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834414.0, assembly_id=103005.0))
lhcb1.new("mcs.b15l5.b1", "mcs", at="-616.6967+(-290-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245531.0, assembly_id=103005.0))
lhcb1.new("mco.a15l5.b1", "mco_unplugged", at="-615.9467+(-290-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251524.0, assembly_id=103006.0))
lhcb1.new("mcd.a15l5.b1", "mcd", at="-615.9452+(-290-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251525.0, assembly_id=103006.0))
lhcb1.new("mb.a15l5.b1", "mb", at="-608.4607+(-290.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834438.0, assembly_id=103006.0))
lhcb1.new("mcs.a15l5.b1", "mcs", at="-601.0367+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245536.0, assembly_id=103006.0))
lhcb1.new("bpm.14l5.b1", "bpm", at="-600.1577+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245538.0, assembly_id=103007.0))
lhcb1.new("mqt.14l5.b1", "mqt", at="-599.4037+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307515.0, assembly_id=103007.0))
lhcb1.new("mq.14l5.b1", "mq", at="-597.3957+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308510.0, assembly_id=103007.0))
lhcb1.new("ms.14l5.b1", "ms", at="-595.5007+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251527.0, assembly_id=103007.0))
lhcb1.new("mcbh.14l5.b1", "mcbh", at="-594.9077+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251529.0, assembly_id=103007.0))
lhcb1.new("mb.c14l5.b1", "mb", at="-586.3307+(-291.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834462.0, assembly_id=103008.0))
lhcb1.new("mcs.c14l5.b1", "mcs", at="-578.9067+(-292-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245544.0, assembly_id=103008.0))
lhcb1.new("mco.14l5.b1", "mco_unplugged", at="-578.1567+(-292-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251532.0, assembly_id=103009.0))
lhcb1.new("mcd.14l5.b1", "mcd", at="-578.1552+(-292-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251533.0, assembly_id=103009.0))
lhcb1.new("mb.b14l5.b1", "mb", at="-570.6707+(-292.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834486.0, assembly_id=103009.0))
lhcb1.new("mcs.b14l5.b1", "mcs", at="-563.2467+(-293-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245549.0, assembly_id=103009.0))
lhcb1.new("mb.a14l5.b1", "mb", at="-555.0107+(-293.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834510.0, assembly_id=103010.0))
lhcb1.new("mcs.a14l5.b1", "mcs", at="-547.5867+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245552.0, assembly_id=103010.0))
lhcb1.new("s.ds.l5.b1", "omk", at="-547.1807+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.13l5.b1", "bpm", at="-546.7077+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245554.0, assembly_id=103011.0))
lhcb1.new("mqt.13l5.b1", "mqt", at="-545.9537+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307723.0, assembly_id=103011.0))
lhcb1.new("mq.13l5.b1", "mq", at="-543.9457+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308480.0, assembly_id=103011.0))
lhcb1.new("ms.13l5.b1", "ms", at="-542.0507+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251535.0, assembly_id=103011.0))
lhcb1.new("mcbv.13l5.b1", "mcbv", at="-541.4577+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251537.0, assembly_id=103011.0))
lhcb1.new("mco.b13l5.b1", "mco_unplugged", at="-540.3667+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251540.0, assembly_id=103012.0))
lhcb1.new("mcd.b13l5.b1", "mcd", at="-540.3652+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251541.0, assembly_id=103012.0))
lhcb1.new("mb.c13l5.b1", "mb", at="-532.8807+(-294.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834534.0, assembly_id=103012.0))
lhcb1.new("mcs.c13l5.b1", "mcs", at="-525.4567+(-295-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245562.0, assembly_id=103012.0))
lhcb1.new("mb.b13l5.b1", "mb", at="-517.2207+(-295.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834558.0, assembly_id=103013.0))
lhcb1.new("mcs.b13l5.b1", "mcs", at="-509.7967+(-296-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245565.0, assembly_id=103013.0))
lhcb1.new("mco.a13l5.b1", "mco_unplugged", at="-509.0467+(-296-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251544.0, assembly_id=103014.0))
lhcb1.new("mcd.a13l5.b1", "mcd", at="-509.0452+(-296-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251545.0, assembly_id=103014.0))
lhcb1.new("mb.a13l5.b1", "mb", at="-501.5607+(-296.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834582.0, assembly_id=103014.0))
lhcb1.new("mcs.a13l5.b1", "mcs", at="-494.1367+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245570.0, assembly_id=103014.0))
lhcb1.new("bpm.12l5.b1", "bpm", at="-493.2577+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245572.0, assembly_id=103015.0))
lhcb1.new("mqt.12l5.b1", "mqt", at="-492.5037+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307691.0, assembly_id=103015.0))
lhcb1.new("mq.12l5.b1", "mq", at="-490.4957+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308450.0, assembly_id=103015.0))
lhcb1.new("ms.12l5.b1", "ms", at="-488.6007+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251547.0, assembly_id=103015.0))
lhcb1.new("mcbh.12l5.b1", "mcbh", at="-488.0077+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251549.0, assembly_id=103015.0))
lhcb1.new("mb.c12l5.b1", "mb", at="-479.4307+(-297.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834606.0, assembly_id=103016.0))
lhcb1.new("mcs.c12l5.b1", "mcs", at="-472.0067+(-298-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245578.0, assembly_id=103016.0))
lhcb1.new("mco.12l5.b1", "mco_unplugged", at="-471.2567+(-298-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251552.0, assembly_id=103017.0))
lhcb1.new("mcd.12l5.b1", "mcd", at="-471.2552+(-298-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251553.0, assembly_id=103017.0))
lhcb1.new("mb.b12l5.b1", "mb", at="-463.7707+(-298.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834630.0, assembly_id=103017.0))
lhcb1.new("mcs.b12l5.b1", "mcs", at="-456.3467+(-299-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245583.0, assembly_id=103017.0))
lhcb1.new("mb.a12l5.b1", "mb", at="-448.1107+(-299.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834654.0, assembly_id=103018.0))
lhcb1.new("mcs.a12l5.b1", "mcs", at="-440.6867+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245586.0, assembly_id=103018.0))
lhcb1.new("e.arc.45.b1", "omk", at="-440.2807+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.11l5.b1", "bpm", at="-439.8077+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245588.0, assembly_id=103019.0))
lhcb1.new("mq.11l5.b1", "mq", at="-437.2607+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308657.0, assembly_id=103019.0))
lhcb1.new("mqtli.11l5.b1", "mqtli", at="-434.8917+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307345.0, assembly_id=103019.0))
lhcb1.new("ms.11l5.b1", "ms", at="-433.8797+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251555.0, assembly_id=103019.0))
lhcb1.new("mcbv.11l5.b1", "mcbv", at="-433.2867+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251557.0, assembly_id=103019.0))
lhcb1.new("lefl.11l5.b1", "lefl", at="-425.67735+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52997850.0, assembly_id=103020.0))
lhcb1.new("mco.11l5.b1", "mco_unplugged", at="-418.475+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251560.0, assembly_id=103021.0))
lhcb1.new("mcd.11l5.b1", "mcd", at="-418.4735+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251561.0, assembly_id=103021.0))
lhcb1.new("mb.b11l5.b1", "mb", at="-410.989+(-300.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834678.0, assembly_id=103021.0))
lhcb1.new("mcs.b11l5.b1", "mcs", at="-403.565+(-301-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245596.0, assembly_id=103021.0))
lhcb1.new("mb.a11l5.b1", "mb", at="-395.329+(-301.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52849582.0, assembly_id=103022.0))
lhcb1.new("mcs.a11l5.b1", "mcs", at="-387.905+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=357311.0, assembly_id=103022.0))
lhcb1.new("bpm.10l5.b1", "bpm", at="-387.026+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245601.0, assembly_id=103023.0))
lhcb1.new("mqml.10l5.b1", "mqml", at="-383.881+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307810.0, assembly_id=103023.0))
lhcb1.new("mcbch.10l5.b1", "mcbch", at="-380.839+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251562.0, assembly_id=103023.0))
lhcb1.new("mco.10l5.b1", "mco_unplugged", at="-379.41+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251566.0, assembly_id=103024.0))
lhcb1.new("mcd.10l5.b1", "mcd", at="-379.4085+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251567.0, assembly_id=103024.0))
lhcb1.new("mb.b10l5.b1", "mb", at="-371.924+(-302.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834702.0, assembly_id=103024.0))
lhcb1.new("mcs.b10l5.b1", "mcs", at="-364.5+(-303-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245608.0, assembly_id=103024.0))
lhcb1.new("mb.a10l5.b1", "mb", at="-356.264+(-303.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52849606.0, assembly_id=103025.0))
lhcb1.new("mcs.a10l5.b1", "mcs", at="-348.84+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=357314.0, assembly_id=103025.0))
lhcb1.new("bpm.9l5.b1", "bpm", at="-347.96+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245613.0, assembly_id=103026.0))
lhcb1.new("mqmc.9l5.b1", "mqmc", at="-345.984+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307787.0, assembly_id=103026.0))
lhcb1.new("mqm.9l5.b1", "mqm", at="-342.718+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307735.0, assembly_id=103026.0))
lhcb1.new("mcbcv.9l5.b1", "mcbcv", at="-340.377+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251568.0, assembly_id=103026.0))
lhcb1.new("mco.9l5.b1", "mco_unplugged", at="-338.945+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251572.0, assembly_id=103027.0))
lhcb1.new("mcd.9l5.b1", "mcd", at="-338.9435+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251573.0, assembly_id=103027.0))
lhcb1.new("mb.b9l5.b1", "mb", at="-331.459+(-304.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834726.0, assembly_id=103027.0))
lhcb1.new("mcs.b9l5.b1", "mcs", at="-324.035+(-305-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245621.0, assembly_id=103027.0))
lhcb1.new("mb.a9l5.b1", "mb", at="-315.799+(-305.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52849630.0, assembly_id=103028.0))
lhcb1.new("mcs.a9l5.b1", "mcs", at="-308.375+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=357317.0, assembly_id=103028.0))
lhcb1.new("bpm.8l5.b1", "bpm", at="-307.496+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245626.0, assembly_id=103029.0))
lhcb1.new("mqml.8l5.b1", "mqml", at="-304.351+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307842.0, assembly_id=103029.0))
lhcb1.new("mcbch.8l5.b1", "mcbch", at="-301.309+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251574.0, assembly_id=103029.0))
lhcb1.new("mco.8l5.b1", "mco_unplugged", at="-299.88+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251578.0, assembly_id=103030.0))
lhcb1.new("mcd.8l5.b1", "mcd", at="-299.8785+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251579.0, assembly_id=103030.0))
lhcb1.new("mb.b8l5.b1", "mb", at="-292.394+(-306.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834750.0, assembly_id=103030.0))
lhcb1.new("mcs.b8l5.b1", "mcs", at="-284.97+(-307-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245633.0, assembly_id=103030.0))
lhcb1.new("mb.a8l5.b1", "mb", at="-276.734+(-307.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52849654.0, assembly_id=103031.0))
lhcb1.new("mcs.a8l5.b1", "mcs", at="-269.31+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=357320.0, assembly_id=103031.0))
lhcb1.new("e.ds.l5.b1", "omk", at="-268.904+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(slot_id=100932.0))
lhcb1.new("bpmr.7l5.b1", "bpmr", at="-268.429+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=377975.0, assembly_id=103032.0))
lhcb1.new("mqm.b7l5.b1", "mqm", at="-265.984+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307770.0, assembly_id=103032.0))
lhcb1.new("mqm.a7l5.b1", "mqm", at="-262.217+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307755.0, assembly_id=103032.0))
lhcb1.new("mcbcv.7l5.b1", "mcbcv", at="-259.876+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251580.0, assembly_id=103032.0))
lhcb1.new("dfbai.7l5.b1", "dfbai", at="-257.6965+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52996731.0, assembly_id=104682.0))
lhcb1.new("bpm.6l5.b1", "bpm", at="-231.535+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=377977.0, assembly_id=103033.0))
lhcb1.new("mqml.6l5.b1", "mqml", at="-228.39+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2303102.0, assembly_id=103033.0))
lhcb1.new("mcbch.6l5.b1", "mcbch", at="-225.348+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251582.0, assembly_id=103033.0))
lhcb1.new("bpmr.5l5.b1", "bpmr", at="-199.635+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=377979.0, assembly_id=103035.0))
lhcb1.new("mqml.5l5.b1", "mqml", at="-196.49+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2303134.0, assembly_id=103035.0))
lhcb1.new("mcbcv.5l5.b1", "mcbcv", at="-193.448+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251584.0, assembly_id=103035.0))
lhcb1.new("bptx.5l5.b1", "bptx", at="-174.6425+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=104667.0))
lhcb1.new("bpmya.4l5.b1", "bpmya", at="-172.229+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245652.0, assembly_id=103038.0))
lhcb1.new("mqy.4l5.b1", "mqy", at="-169.553+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2303106.0, assembly_id=103038.0))
lhcb1.new("mcbyh.b4l5.b1", "mcbyh", at="-167.031+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251586.0, assembly_id=103038.0))
lhcb1.new("mcbyv.4l5.b1", "mcbyv", at="-165.735+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251588.0, assembly_id=103038.0))
lhcb1.new("mcbyh.a4l5.b1", "mcbyh", at="-164.439+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251590.0, assembly_id=103038.0))
lhcb1.new("mbrc.4l5.b1", "mbrc", at="-157.9+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.188, slot_id=52819682.0, assembly_id=103039.0))
lhcb1.new("bpmwb.4l5.b1", "bpmwb", at="-151.0945+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.178, slot_id=104608.0))
lhcb1.new("bbcwe.4l5.u.b1", "bbcwe", at="-148.54+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.172, slot_id=52659225.0, assembly_id=52658403.0))
lhcb1.new("bbcwi.4l5.u.b1", "bbcwi", at="-148.54+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.172, slot_id=52659243.0, assembly_id=52658403.0))
lhcb1.new("bptuh.a4l5.b1", "bptuh", at="-148.49+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.1728, slot_id=52661751.0, assembly_id=52658403.0))
lhcb1.new("tctph.4l5.b1", "tctwh", at="-147.945+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.1715, slot_id=52658403.0))
lhcb1.new("bptdh.a4l5.b1", "bptdh", at="-147.4+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.1703, slot_id=52661742.0, assembly_id=52658403.0))
lhcb1.new("bbcwe.4l5.d.b1", "bbcwe", at="-147.35+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.17, slot_id=52659216.0, assembly_id=52658403.0))
lhcb1.new("bbcwi.4l5.d.b1", "bbcwi", at="-147.35+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.17, slot_id=52659234.0, assembly_id=52658403.0))
lhcb1.new("bptuv.a4l5.b1", "bptuv", at="-146.49+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.1683, slot_id=10402736.0, assembly_id=377607.0))
lhcb1.new("tctpv.4l5.b1", "tctpv", at="-145.945+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.1671, slot_id=377607.0))
lhcb1.new("bptdv.a4l5.b1", "bptdv", at="-145.4+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=-0.1658, slot_id=10402740.0, assembly_id=377607.0))
lhcb1.new("tanc.4l5", "tanc", at="-142.754+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=103042.0))
lhcb1.new("x5zdc.b4l5", "x5zdc001", at="-141.6225+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=2019606.0, assembly_id=103042.0))
lhcb1.new("brand.4l5", "brand", at="-141.185+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=55374093.0, assembly_id=103042.0))
lhcb1.new("x5zdc.a4l5", "x5zdc002", at="-141.0725+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=2019602.0, assembly_id=103042.0))
lhcb1.new("x5fcb.a4l5", "x5fcb", at="-114.13+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593911.0))
lhcb1.new("x5fca.b4l5", "x5fca", at="-85.08+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593908.0))
lhcb1.new("mbxw.f4l5", "mbxw", at="-82.652+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134562.0))
lhcb1.new("mbxw.e4l5", "mbxw", at="-78.386+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134563.0))
lhcb1.new("mbxw.d4l5", "mbxw", at="-74.12+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134564.0))
lhcb1.new("mbxw.c4l5", "mbxw", at="-69.854+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134565.0))
lhcb1.new("mbxw.b4l5", "mbxw", at="-65.588+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134566.0))
lhcb1.new("mbxw.a4l5", "mbxw", at="-61.322+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134567.0))
lhcb1.new("x5fca.a4l5", "x5fca", at="-59.24+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593907.0))
lhcb1.new("bpmsy.4l5.b1", "bpmsy002", at="-58.3745+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=47562516.0, assembly_id=104609.0))
lhcb1.new("dfbxe.3l5", "dfbxe", at="-56.427+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=104683.0))
lhcb1.new("mcosx.3l5", "mcosx", at="-54.297+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282246.0, assembly_id=103044.0))
lhcb1.new("mcox.3l5", "mcox", at="-54.297+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282245.0, assembly_id=103044.0))
lhcb1.new("mcssx.3l5", "mcssx", at="-54.297+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282244.0, assembly_id=103044.0))
lhcb1.new("mcbxh.3l5", "mcbxh", at="-53.814+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251592.0, assembly_id=103044.0))
lhcb1.new("mcbxv.3l5", "mcbxv", at="-53.814+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251593.0, assembly_id=103044.0))
lhcb1.new("mcsx.3l5", "mcsx", at="-53.814+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251594.0, assembly_id=103044.0))
lhcb1.new("mctx.3l5", "mctx", at="-53.814+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251595.0, assembly_id=103044.0))
lhcb1.new("mqxa.3l5", "mqxa", at="-50.15+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245665.0, assembly_id=103044.0))
lhcb1.new("mqsx.3l5", "mqsx", at="-46.608+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282142.0, assembly_id=103044.0))
lhcb1.new("tasb.3l5", "tasb", at="-45.342+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245667.0, assembly_id=103044.0))
lhcb1.new("mqxb.b2l5", "mqxb", at="-41.3+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245668.0, assembly_id=103045.0))
lhcb1.new("mcbxh.2l5", "mcbxh", at="-38.019+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251600.0, assembly_id=103045.0))
lhcb1.new("mcbxv.2l5", "mcbxv", at="-38.019+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251601.0, assembly_id=103045.0))
lhcb1.new("mqxb.a2l5", "mqxb", at="-34.8+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245670.0, assembly_id=103045.0))
lhcb1.new("bpms.2l5.b1", "bpms_003", at="-31.529+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=47564251.0, assembly_id=103045.0))
lhcb1.new("mcbxh.1l5", "mcbxh", at="-29.842+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282215.0, assembly_id=103046.0))
lhcb1.new("mcbxv.1l5", "mcbxv", at="-29.842+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282214.0, assembly_id=103046.0))
lhcb1.new("mqxa.1l5", "mqxa", at="-26.15+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282143.0, assembly_id=103046.0))
lhcb1.new("bpmwf.a1l5.b1", "bpmwf", at="-21.751+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=6080247.0, assembly_id=6080226.0))
lhcb1.new("bpmsw.1l5.b1", "bpmsw002", at="-21.564+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=6080243.0, assembly_id=6080226.0))
lhcb1.new("bpmsw.1l5.b1_doros", "bpmsw002", at="-21.564+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=10429427.0, assembly_id=6080226.0))
lhcb1.new("tas.1l5", "tas", at="-19.95+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=103047.0))
lhcb1.new("mbcs2.1l5", "mbcs2", at="-3.25+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=52895730.0, assembly_id=2209455.0))
lhcb1.new("ip5", "omk", at="pip5+ip5ofs.b1*ds")
lhcb1.new("mbcs2.1r5", "mbcs2", at="3.25+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=52895762.0, assembly_id=2209455.0))
lhcb1.new("tas.1r5", "tas", at="19.95+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=103048.0))
lhcb1.new("bpmsw.1r5.b1", "bpmsw002", at="21.564+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=6080261.0, assembly_id=6080227.0))
lhcb1.new("bpmsw.1r5.b1_doros", "bpmsw002", at="21.564+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=10429434.0, assembly_id=6080227.0))
lhcb1.new("bpmwf.a1r5.b1", "bpmwf", at="21.697+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=6080269.0, assembly_id=6080227.0))
lhcb1.new("mqxa.1r5", "mqxa", at="26.15+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282146.0, assembly_id=103049.0))
lhcb1.new("mcbxh.1r5", "mcbxh", at="29.842+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282217.0, assembly_id=103049.0))
lhcb1.new("mcbxv.1r5", "mcbxv", at="29.842+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282216.0, assembly_id=103049.0))
lhcb1.new("bpms.2r5.b1", "bpms_003", at="31.529+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=47564241.0, assembly_id=103050.0))
lhcb1.new("mqxb.a2r5", "mqxb", at="34.8+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245683.0, assembly_id=103050.0))
lhcb1.new("mcbxh.2r5", "mcbxh", at="38.019+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251606.0, assembly_id=103050.0))
lhcb1.new("mcbxv.2r5", "mcbxv", at="38.019+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251607.0, assembly_id=103050.0))
lhcb1.new("mqxb.b2r5", "mqxb", at="41.3+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245685.0, assembly_id=103050.0))
lhcb1.new("tasb.3r5", "tasb", at="45.342+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245686.0, assembly_id=103051.0))
lhcb1.new("mqsx.3r5", "mqsx", at="46.608+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282147.0, assembly_id=103051.0))
lhcb1.new("mqxa.3r5", "mqxa", at="50.15+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245688.0, assembly_id=103051.0))
lhcb1.new("mcbxh.3r5", "mcbxh", at="53.814+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251612.0, assembly_id=103051.0))
lhcb1.new("mcbxv.3r5", "mcbxv", at="53.814+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251613.0, assembly_id=103051.0))
lhcb1.new("mcsx.3r5", "mcsx", at="53.814+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251614.0, assembly_id=103051.0))
lhcb1.new("mctx.3r5", "mctx", at="53.814+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251615.0, assembly_id=103051.0))
lhcb1.new("mcosx.3r5", "mcosx", at="54.297+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282249.0, assembly_id=103051.0))
lhcb1.new("mcox.3r5", "mcox", at="54.297+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282248.0, assembly_id=103051.0))
lhcb1.new("mcssx.3r5", "mcssx", at="54.297+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282247.0, assembly_id=103051.0))
lhcb1.new("dfbxf.3r5", "dfbxf", at="56.427+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=104684.0))
lhcb1.new("bpmsy.4r5.b1", "bpmsy002", at="58.2545+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=47562518.0, assembly_id=104612.0))
lhcb1.new("x5fca.b4r5", "x5fca", at="59.24+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593910.0))
lhcb1.new("mbxw.a4r5", "mbxw", at="61.322+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134568.0))
lhcb1.new("mbxw.b4r5", "mbxw", at="65.588+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134569.0))
lhcb1.new("mbxw.c4r5", "mbxw", at="69.854+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134570.0))
lhcb1.new("mbxw.d4r5", "mbxw", at="74.12+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134571.0))
lhcb1.new("mbxw.e4r5", "mbxw", at="78.386+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134572.0))
lhcb1.new("mbxw.f4r5", "mbxw", at="82.652+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134573.0))
lhcb1.new("x5fca.a4r5", "x5fca", at="84.94+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593909.0))
lhcb1.new("x5fcb.a4r5", "x5fcb", at="114.15+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593912.0))
lhcb1.new("x5zdc.b4r5", "x5zdc002", at="141.0725+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=2019608.0, assembly_id=103053.0))
lhcb1.new("brana.4r5", "brana", at="141.185+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=883604.0, assembly_id=103053.0))
lhcb1.new("x5zdc.a4r5", "x5zdc001", at="141.6225+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=2019604.0, assembly_id=103053.0))
lhcb1.new("tanc.4r5", "tanc", at="142.754+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.0, slot_id=103053.0))
lhcb1.new("tcl.4r5.b1", "tcl", at="150.03+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.1757, slot_id=103055.0))
lhcb1.new("bpmwb.4r5.b1", "bpmwb", at="151.0945+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.178, slot_id=181643.0))
lhcb1.new("mbrc.4r5.b1", "mbrc", at="157.9+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.188, slot_id=52819706.0, assembly_id=103056.0))
lhcb1.new("mcbyv.a4r5.b1", "mcbyv", at="164.439+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251616.0, assembly_id=103057.0))
lhcb1.new("mcbyh.4r5.b1", "mcbyh", at="165.735+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251618.0, assembly_id=103057.0))
lhcb1.new("mcbyv.b4r5.b1", "mcbyv", at="167.031+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251620.0, assembly_id=103057.0))
lhcb1.new("mqy.4r5.b1", "mqy", at="169.553+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2303120.0, assembly_id=103057.0))
lhcb1.new("bpmya.4r5.b1", "bpmya", at="172.227+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245701.0, assembly_id=103057.0))
lhcb1.new("tcl.5r5.b1", "tcl", at="184.264+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=103059.0))
lhcb1.new("bpm.5r5.b1", "bpm", at="193.345+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=377988.0, assembly_id=103060.0))
lhcb1.new("mqml.5r5.b1", "mqml", at="196.49+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2303124.0, assembly_id=103060.0))
lhcb1.new("mcbch.5r5.b1", "mcbch", at="199.532+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251623.0, assembly_id=103060.0))
lhcb1.new("bpmwt.c6r5.b1", "bpmwt", at="203.152+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738966.0, assembly_id=6738963.0))
lhcb1.new("xrpv.c6r5.b1", "xrpv", at="203.377+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738970.0, assembly_id=6738963.0))
lhcb1.new("xrph.d6r5.b1", "xrph", at="212.551+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738974.0, assembly_id=6738964.0))
lhcb1.new("xrpv.d6r5.b1", "xrpv", at="213+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738976.0, assembly_id=6738964.0))
lhcb1.new("bpmwt.d6r5.b1", "bpmwt", at="213.225+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738972.0, assembly_id=6738964.0))
lhcb1.new("bpmwt.a6r5.b1", "bpmwt", at="214.403+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826593.0, assembly_id=825718.0))
lhcb1.new("xrpv.a6r5.b1", "xrpv", at="214.628+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826617.0, assembly_id=825718.0))
lhcb1.new("xrph.a6r5.b1", "xrph", at="215.077+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826605.0, assembly_id=825718.0))
lhcb1.new("xrph.e6r5.b1", "xrph", at="215.71+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=12978120.0, assembly_id=12978114.0))
lhcb1.new("xrph.b6r5.b1", "xrph", at="219.551+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826641.0, assembly_id=825719.0))
lhcb1.new("xrpv.b6r5.b1", "xrpv", at="220+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826653.0, assembly_id=825719.0))
lhcb1.new("bpmwt.b6r5.b1", "bpmwt", at="220.225+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826629.0, assembly_id=825719.0))
lhcb1.new("tcl.6r5.b1", "tcl", at="221.574+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=12962654.0))
lhcb1.new("bpmr.6r5.b1", "bpmr", at="225.245+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=377990.0, assembly_id=103062.0))
lhcb1.new("mqml.6r5.b1", "mqml", at="228.39+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2303128.0, assembly_id=103062.0))
lhcb1.new("mcbcv.6r5.b1", "mcbcv", at="231.432+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251625.0, assembly_id=103062.0))
lhcb1.new("dfbaj.7r5.b1", "dfbaj", at="257.4465+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52996755.0, assembly_id=104685.0))
lhcb1.new("bpm_a.7r5.b1", "bpm_a", at="259.259+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=377993.0, assembly_id=103063.0))
lhcb1.new("mqm.a7r5.b1", "mqm", at="261.704+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307763.0, assembly_id=103063.0))
lhcb1.new("mqm.b7r5.b1", "mqm", at="265.471+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307778.0, assembly_id=103063.0))
lhcb1.new("mcbch.7r5.b1", "mcbch", at="267.812+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251627.0, assembly_id=103063.0))
lhcb1.new("s.ds.r5.b1", "omk", at="268.904+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(slot_id=100932.0))
lhcb1.new("mco.8r5.b1", "mco", at="269.248+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251628.0, assembly_id=103064.0))
lhcb1.new("mcd.8r5.b1", "mcd", at="269.2495+(-308-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251629.0, assembly_id=103064.0))
lhcb1.new("mb.a8r5.b1", "mb", at="276.734+(-307.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834774.0, assembly_id=103064.0))
lhcb1.new("mcs.a8r5.b1", "mcs", at="284.158+(-307-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245720.0, assembly_id=103064.0))
lhcb1.new("mb.b8r5.b1", "mb", at="292.394+(-306.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834798.0, assembly_id=103065.0))
lhcb1.new("mcs.b8r5.b1", "mcs", at="299.818+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245723.0, assembly_id=103065.0))
lhcb1.new("bpm.8r5.b1", "bpm", at="300.697+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=377996.0, assembly_id=103066.0))
lhcb1.new("mqml.8r5.b1", "mqml", at="303.842+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307615.0, assembly_id=103066.0))
lhcb1.new("mcbcv.8r5.b1", "mcbcv", at="306.884+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=378108.0, assembly_id=103066.0))
lhcb1.new("mco.9r5.b1", "mco", at="308.313+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251634.0, assembly_id=103067.0))
lhcb1.new("mcd.9r5.b1", "mcd", at="308.3145+(-306-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251635.0, assembly_id=103067.0))
lhcb1.new("mb.a9r5.b1", "mb", at="315.799+(-305.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834822.0, assembly_id=103067.0))
lhcb1.new("mcs.a9r5.b1", "mcs", at="323.223+(-305-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245732.0, assembly_id=103067.0))
lhcb1.new("mb.b9r5.b1", "mb", at="331.459+(-304.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834846.0, assembly_id=103068.0))
lhcb1.new("mcs.b9r5.b1", "mcs", at="338.883+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245735.0, assembly_id=103068.0))
lhcb1.new("bpm.9r5.b1", "bpm", at="339.763+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=383967.0, assembly_id=103069.0))
lhcb1.new("mqmc.9r5.b1", "mqmc", at="341.739+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307798.0, assembly_id=103069.0))
lhcb1.new("mqm.9r5.b1", "mqm", at="345.005+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307746.0, assembly_id=103069.0))
lhcb1.new("mcbch.9r5.b1", "mcbch", at="347.346+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=383973.0, assembly_id=103069.0))
lhcb1.new("mco.10r5.b1", "mco", at="348.778+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251640.0, assembly_id=103070.0))
lhcb1.new("mcd.10r5.b1", "mcd", at="348.7795+(-304-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251641.0, assembly_id=103070.0))
lhcb1.new("mb.a10r5.b1", "mb", at="356.264+(-303.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834870.0, assembly_id=103070.0))
lhcb1.new("mcs.a10r5.b1", "mcs", at="363.688+(-303-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245745.0, assembly_id=103070.0))
lhcb1.new("mb.b10r5.b1", "mb", at="371.924+(-302.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834894.0, assembly_id=103071.0))
lhcb1.new("mcs.b10r5.b1", "mcs", at="379.348+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245748.0, assembly_id=103071.0))
lhcb1.new("bpm.10r5.b1", "bpm", at="380.227+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=378000.0, assembly_id=103072.0))
lhcb1.new("mqml.10r5.b1", "mqml", at="383.372+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307822.0, assembly_id=103072.0))
lhcb1.new("mcbcv.10r5.b1", "mcbcv", at="386.414+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=378112.0, assembly_id=103072.0))
lhcb1.new("mco.11r5.b1", "mco", at="387.843+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251646.0, assembly_id=103073.0))
lhcb1.new("mcd.11r5.b1", "mcd", at="387.8445+(-302-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251647.0, assembly_id=103073.0))
lhcb1.new("mb.a11r5.b1", "mb", at="395.329+(-301.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834918.0, assembly_id=103073.0))
lhcb1.new("mcs.a11r5.b1", "mcs", at="402.753+(-301-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245757.0, assembly_id=103073.0))
lhcb1.new("mb.b11r5.b1", "mb", at="410.989+(-300.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834942.0, assembly_id=103074.0))
lhcb1.new("mcs.b11r5.b1", "mcs", at="418.413+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245760.0, assembly_id=103074.0))
lhcb1.new("legr.11r5.b1", "legr", at="425.67735+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52997898.0, assembly_id=103075.0))
lhcb1.new("bpm.11r5.b1", "bpm", at="433.0087+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245762.0, assembly_id=103076.0))
lhcb1.new("mq.11r5.b1", "mq", at="435.5557+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308672.0, assembly_id=103076.0))
lhcb1.new("mqtli.11r5.b1", "mqtli", at="437.9247+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307360.0, assembly_id=103076.0))
lhcb1.new("ms.11r5.b1", "ms", at="438.9367+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251650.0, assembly_id=103076.0))
lhcb1.new("mcbh.11r5.b1", "mcbh", at="439.5297+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251652.0, assembly_id=103076.0))
lhcb1.new("s.arc.56.b1", "omk", at="440.2807+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a12r5.b1", "mco", at="440.6247+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251654.0, assembly_id=103077.0))
lhcb1.new("mcd.a12r5.b1", "mcd", at="440.6262+(-300-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251655.0, assembly_id=103077.0))
lhcb1.new("mb.a12r5.b1", "mb", at="448.1107+(-299.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834966.0, assembly_id=103077.0))
lhcb1.new("mcs.a12r5.b1", "mcs", at="455.5347+(-299-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245770.0, assembly_id=103077.0))
lhcb1.new("mb.b12r5.b1", "mb", at="463.7707+(-298.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834990.0, assembly_id=103078.0))
lhcb1.new("mcs.b12r5.b1", "mcs", at="471.1947+(-298-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245773.0, assembly_id=103078.0))
lhcb1.new("mco.b12r5.b1", "mco", at="471.9447+(-298-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251658.0, assembly_id=103079.0))
lhcb1.new("mcd.b12r5.b1", "mcd", at="471.9462+(-298-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251659.0, assembly_id=103079.0))
lhcb1.new("mb.c12r5.b1", "mb", at="479.4307+(-297.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835014.0, assembly_id=103079.0))
lhcb1.new("mcs.c12r5.b1", "mcs", at="486.8547+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245778.0, assembly_id=103079.0))
lhcb1.new("bpm.12r5.b1", "bpm", at="487.7337+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245780.0, assembly_id=103080.0))
lhcb1.new("mqt.12r5.b1", "mqt", at="488.4877+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307707.0, assembly_id=103080.0))
lhcb1.new("mq.12r5.b1", "mq", at="490.4957+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308465.0, assembly_id=103080.0))
lhcb1.new("ms.12r5.b1", "ms", at="492.3907+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251662.0, assembly_id=103080.0))
lhcb1.new("mcbv.12r5.b1", "mcbv", at="492.9837+(-297-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251664.0, assembly_id=103080.0))
lhcb1.new("mb.a13r5.b1", "mb", at="501.5607+(-296.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835038.0, assembly_id=103081.0))
lhcb1.new("mcs.a13r5.b1", "mcs", at="508.9847+(-296-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245786.0, assembly_id=103081.0))
lhcb1.new("mco.13r5.b1", "mco", at="509.7347+(-296-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251666.0, assembly_id=103082.0))
lhcb1.new("mcd.13r5.b1", "mcd", at="509.7362+(-296-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251667.0, assembly_id=103082.0))
lhcb1.new("mb.b13r5.b1", "mb", at="517.2207+(-295.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835062.0, assembly_id=103082.0))
lhcb1.new("mcs.b13r5.b1", "mcs", at="524.6447+(-295-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245791.0, assembly_id=103082.0))
lhcb1.new("mb.c13r5.b1", "mb", at="532.8807+(-294.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835086.0, assembly_id=103083.0))
lhcb1.new("mcs.c13r5.b1", "mcs", at="540.3047+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245794.0, assembly_id=103083.0))
lhcb1.new("bpm.13r5.b1", "bpm", at="541.1837+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245796.0, assembly_id=103084.0))
lhcb1.new("mqt.13r5.b1", "mqt", at="541.9377+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2348444.0, assembly_id=103084.0))
lhcb1.new("mq.13r5.b1", "mq", at="543.9457+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308495.0, assembly_id=103084.0))
lhcb1.new("ms.13r5.b1", "ms", at="545.8407+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251670.0, assembly_id=103084.0))
lhcb1.new("mcbh.13r5.b1", "mcbh", at="546.4337+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251672.0, assembly_id=103084.0))
lhcb1.new("e.ds.r5.b1", "omk", at="547.1807+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a14r5.b1", "mco", at="547.5247+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251674.0, assembly_id=103085.0))
lhcb1.new("mcd.a14r5.b1", "mcd", at="547.5262+(-294-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251675.0, assembly_id=103085.0))
lhcb1.new("mb.a14r5.b1", "mb", at="555.0107+(-293.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835110.0, assembly_id=103085.0))
lhcb1.new("mcs.a14r5.b1", "mcs", at="562.4347+(-293-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245804.0, assembly_id=103085.0))
lhcb1.new("mb.b14r5.b1", "mb", at="570.6707+(-292.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835134.0, assembly_id=103086.0))
lhcb1.new("mcs.b14r5.b1", "mcs", at="578.0947+(-292-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245807.0, assembly_id=103086.0))
lhcb1.new("mco.b14r5.b1", "mco", at="578.8447+(-292-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251678.0, assembly_id=103087.0))
lhcb1.new("mcd.b14r5.b1", "mcd", at="578.8462+(-292-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251679.0, assembly_id=103087.0))
lhcb1.new("mb.c14r5.b1", "mb", at="586.3307+(-291.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835158.0, assembly_id=103087.0))
lhcb1.new("mcs.c14r5.b1", "mcs", at="593.7547+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245812.0, assembly_id=103087.0))
lhcb1.new("bpm.14r5.b1", "bpm", at="594.6337+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245814.0, assembly_id=103088.0))
lhcb1.new("mqt.14r5.b1", "mqt", at="595.3877+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307531.0, assembly_id=103088.0))
lhcb1.new("mq.14r5.b1", "mq", at="597.3957+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308525.0, assembly_id=103088.0))
lhcb1.new("ms.14r5.b1", "ms", at="599.2907+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251682.0, assembly_id=103088.0))
lhcb1.new("mcbv.14r5.b1", "mcbv", at="599.8837+(-291-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251684.0, assembly_id=103088.0))
lhcb1.new("mb.a15r5.b1", "mb", at="608.4607+(-290.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835182.0, assembly_id=103089.0))
lhcb1.new("mcs.a15r5.b1", "mcs", at="615.8847+(-290-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245820.0, assembly_id=103089.0))
lhcb1.new("mco.15r5.b1", "mco", at="616.6347+(-290-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251686.0, assembly_id=103090.0))
lhcb1.new("mcd.15r5.b1", "mcd", at="616.6362+(-290-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251687.0, assembly_id=103090.0))
lhcb1.new("mb.b15r5.b1", "mb", at="624.1207+(-289.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835206.0, assembly_id=103090.0))
lhcb1.new("mcs.b15r5.b1", "mcs", at="631.5447+(-289-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245825.0, assembly_id=103090.0))
lhcb1.new("mb.c15r5.b1", "mb", at="639.7807+(-288.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835230.0, assembly_id=103091.0))
lhcb1.new("mcs.c15r5.b1", "mcs", at="647.2047+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245828.0, assembly_id=103091.0))
lhcb1.new("bpm.15r5.b1", "bpm", at="648.0837+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245830.0, assembly_id=103092.0))
lhcb1.new("mqt.15r5.b1", "mqt", at="648.8377+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307563.0, assembly_id=103092.0))
lhcb1.new("mq.15r5.b1", "mq", at="650.8457+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308555.0, assembly_id=103092.0))
lhcb1.new("ms.15r5.b1", "ms", at="652.7407+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251690.0, assembly_id=103092.0))
lhcb1.new("mcbh.15r5.b1", "mcbh", at="653.3337+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251692.0, assembly_id=103092.0))
lhcb1.new("mco.a16r5.b1", "mco", at="654.4247+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251694.0, assembly_id=103093.0))
lhcb1.new("mcd.a16r5.b1", "mcd", at="654.4262+(-288-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251695.0, assembly_id=103093.0))
lhcb1.new("mb.a16r5.b1", "mb", at="661.9107+(-287.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835254.0, assembly_id=103093.0))
lhcb1.new("mcs.a16r5.b1", "mcs", at="669.3347+(-287-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245838.0, assembly_id=103093.0))
lhcb1.new("mb.b16r5.b1", "mb", at="677.5707+(-286.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835278.0, assembly_id=103094.0))
lhcb1.new("mcs.b16r5.b1", "mcs", at="684.9947+(-286-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245841.0, assembly_id=103094.0))
lhcb1.new("mco.b16r5.b1", "mco", at="685.7447+(-286-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251698.0, assembly_id=103095.0))
lhcb1.new("mcd.b16r5.b1", "mcd", at="685.7462+(-286-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251699.0, assembly_id=103095.0))
lhcb1.new("mb.c16r5.b1", "mb", at="693.2307+(-285.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835302.0, assembly_id=103095.0))
lhcb1.new("mcs.c16r5.b1", "mcs", at="700.6547+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245846.0, assembly_id=103095.0))
lhcb1.new("bpm.16r5.b1", "bpm", at="701.5337+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245848.0, assembly_id=103096.0))
lhcb1.new("mqt.16r5.b1", "mqt", at="702.2877+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307593.0, assembly_id=103096.0))
lhcb1.new("mq.16r5.b1", "mq", at="704.2957+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308348.0, assembly_id=103096.0))
lhcb1.new("ms.16r5.b1", "ms", at="706.1907+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251702.0, assembly_id=103096.0))
lhcb1.new("mcbv.16r5.b1", "mcbv", at="706.7837+(-285-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251704.0, assembly_id=103096.0))
lhcb1.new("mb.a17r5.b1", "mb", at="715.3607+(-284.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835326.0, assembly_id=103097.0))
lhcb1.new("mcs.a17r5.b1", "mcs", at="722.7847+(-284-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245854.0, assembly_id=103097.0))
lhcb1.new("mco.17r5.b1", "mco", at="723.5347+(-284-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251706.0, assembly_id=103098.0))
lhcb1.new("mcd.17r5.b1", "mcd", at="723.5362+(-284-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251707.0, assembly_id=103098.0))
lhcb1.new("mb.b17r5.b1", "mb", at="731.0207+(-283.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835350.0, assembly_id=103098.0))
lhcb1.new("mcs.b17r5.b1", "mcs", at="738.4447+(-283-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245859.0, assembly_id=103098.0))
lhcb1.new("mb.c17r5.b1", "mb", at="746.6807+(-282.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835374.0, assembly_id=103099.0))
lhcb1.new("mcs.c17r5.b1", "mcs", at="754.1047+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245862.0, assembly_id=103099.0))
lhcb1.new("bpm.17r5.b1", "bpm", at="754.9837+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245864.0, assembly_id=103100.0))
lhcb1.new("mqt.17r5.b1", "mqt", at="755.7377+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307387.0, assembly_id=103100.0))
lhcb1.new("mq.17r5.b1", "mq", at="757.7457+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308378.0, assembly_id=103100.0))
lhcb1.new("ms.17r5.b1", "ms", at="759.6407+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251710.0, assembly_id=103100.0))
lhcb1.new("mcbh.17r5.b1", "mcbh", at="760.2337+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251712.0, assembly_id=103100.0))
lhcb1.new("mco.a18r5.b1", "mco", at="761.3247+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251714.0, assembly_id=103101.0))
lhcb1.new("mcd.a18r5.b1", "mcd", at="761.3262+(-282-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251715.0, assembly_id=103101.0))
lhcb1.new("mb.a18r5.b1", "mb", at="768.8107+(-281.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835398.0, assembly_id=103101.0))
lhcb1.new("mcs.a18r5.b1", "mcs", at="776.2347+(-281-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245872.0, assembly_id=103101.0))
lhcb1.new("mb.b18r5.b1", "mb", at="784.4707+(-280.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835422.0, assembly_id=103102.0))
lhcb1.new("mcs.b18r5.b1", "mcs", at="791.8947+(-280-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245875.0, assembly_id=103102.0))
lhcb1.new("mco.b18r5.b1", "mco", at="792.6447+(-280-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251718.0, assembly_id=103103.0))
lhcb1.new("mcd.b18r5.b1", "mcd", at="792.6462+(-280-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251719.0, assembly_id=103103.0))
lhcb1.new("mb.c18r5.b1", "mb", at="800.1307+(-279.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835446.0, assembly_id=103103.0))
lhcb1.new("mcs.c18r5.b1", "mcs", at="807.5547+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245880.0, assembly_id=103103.0))
lhcb1.new("bpm.18r5.b1", "bpm", at="808.4337+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245882.0, assembly_id=103104.0))
lhcb1.new("mqt.18r5.b1", "mqt", at="809.1877+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307419.0, assembly_id=103104.0))
lhcb1.new("mq.18r5.b1", "mq", at="811.1957+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308408.0, assembly_id=103104.0))
lhcb1.new("ms.18r5.b1", "ms", at="813.0907+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251722.0, assembly_id=103104.0))
lhcb1.new("mcbv.18r5.b1", "mcbv", at="813.6837+(-279-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251724.0, assembly_id=103104.0))
lhcb1.new("mb.a19r5.b1", "mb", at="822.2607+(-278.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835470.0, assembly_id=103105.0))
lhcb1.new("mcs.a19r5.b1", "mcs", at="829.6847+(-278-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245888.0, assembly_id=103105.0))
lhcb1.new("mco.19r5.b1", "mco", at="830.4347+(-278-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251726.0, assembly_id=103106.0))
lhcb1.new("mcd.19r5.b1", "mcd", at="830.4362+(-278-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251727.0, assembly_id=103106.0))
lhcb1.new("mb.b19r5.b1", "mb", at="837.9207+(-277.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835494.0, assembly_id=103106.0))
lhcb1.new("mcs.b19r5.b1", "mcs", at="845.3447+(-277-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245893.0, assembly_id=103106.0))
lhcb1.new("mb.c19r5.b1", "mb", at="853.5807+(-276.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835518.0, assembly_id=103107.0))
lhcb1.new("mcs.c19r5.b1", "mcs", at="861.0047+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245896.0, assembly_id=103107.0))
lhcb1.new("bpm.19r5.b1", "bpm", at="861.8837+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245898.0, assembly_id=103108.0))
lhcb1.new("mqt.19r5.b1", "mqt", at="862.6377+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307449.0, assembly_id=103108.0))
lhcb1.new("mq.19r5.b1", "mq", at="864.6457+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308440.0, assembly_id=103108.0))
lhcb1.new("ms.19r5.b1", "ms", at="866.5407+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251730.0, assembly_id=103108.0))
lhcb1.new("mcbh.19r5.b1", "mcbh", at="867.1337+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251732.0, assembly_id=103108.0))
lhcb1.new("mco.a20r5.b1", "mco", at="868.2247+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251734.0, assembly_id=103109.0))
lhcb1.new("mcd.a20r5.b1", "mcd", at="868.2262+(-276-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251735.0, assembly_id=103109.0))
lhcb1.new("mb.a20r5.b1", "mb", at="875.7107+(-275.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835542.0, assembly_id=103109.0))
lhcb1.new("mcs.a20r5.b1", "mcs", at="883.1347+(-275-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245906.0, assembly_id=103109.0))
lhcb1.new("mb.b20r5.b1", "mb", at="891.3707+(-274.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835566.0, assembly_id=103110.0))
lhcb1.new("mcs.b20r5.b1", "mcs", at="898.7947+(-274-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245909.0, assembly_id=103110.0))
lhcb1.new("mco.b20r5.b1", "mco", at="899.5447+(-274-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251738.0, assembly_id=103111.0))
lhcb1.new("mcd.b20r5.b1", "mcd", at="899.5462+(-274-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251739.0, assembly_id=103111.0))
lhcb1.new("mb.c20r5.b1", "mb", at="907.0307+(-273.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835590.0, assembly_id=103111.0))
lhcb1.new("mcs.c20r5.b1", "mcs", at="914.4547+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245914.0, assembly_id=103111.0))
lhcb1.new("bpm.20r5.b1", "bpm", at="915.3337+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245916.0, assembly_id=103112.0))
lhcb1.new("mqt.20r5.b1", "mqt", at="916.0877+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307479.0, assembly_id=103112.0))
lhcb1.new("mq.20r5.b1", "mq", at="918.0957+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2348475.0, assembly_id=103112.0))
lhcb1.new("ms.20r5.b1", "ms", at="919.9907+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251742.0, assembly_id=103112.0))
lhcb1.new("mcbv.20r5.b1", "mcbv", at="920.5837+(-273-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251744.0, assembly_id=103112.0))
lhcb1.new("mb.a21r5.b1", "mb", at="929.1607+(-272.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835614.0, assembly_id=103113.0))
lhcb1.new("mcs.a21r5.b1", "mcs", at="936.5847+(-272-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245922.0, assembly_id=103113.0))
lhcb1.new("mco.21r5.b1", "mco", at="937.3347+(-272-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251746.0, assembly_id=103114.0))
lhcb1.new("mcd.21r5.b1", "mcd", at="937.3362+(-272-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251747.0, assembly_id=103114.0))
lhcb1.new("mb.b21r5.b1", "mb", at="944.8207+(-271.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835638.0, assembly_id=103114.0))
lhcb1.new("mcs.b21r5.b1", "mcs", at="952.2447+(-271-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245927.0, assembly_id=103114.0))
lhcb1.new("mb.c21r5.b1", "mb", at="960.4807+(-270.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835662.0, assembly_id=103115.0))
lhcb1.new("mcs.c21r5.b1", "mcs", at="967.9047+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245930.0, assembly_id=103115.0))
lhcb1.new("bpm.21r5.b1", "bpm", at="968.7837+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245932.0, assembly_id=103116.0))
lhcb1.new("mqt.21r5.b1", "mqt", at="969.5377+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307277.0, assembly_id=103116.0))
lhcb1.new("mq.21r5.b1", "mq", at="971.5457+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308261.0, assembly_id=103116.0))
lhcb1.new("ms.21r5.b1", "ms", at="973.4407+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251750.0, assembly_id=103116.0))
lhcb1.new("mcbh.21r5.b1", "mcbh", at="974.0337+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251752.0, assembly_id=103116.0))
lhcb1.new("mco.a22r5.b1", "mco", at="975.1247+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251754.0, assembly_id=103117.0))
lhcb1.new("mcd.a22r5.b1", "mcd", at="975.1262+(-270-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251755.0, assembly_id=103117.0))
lhcb1.new("mb.a22r5.b1", "mb", at="982.6107+(-269.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835686.0, assembly_id=103117.0))
lhcb1.new("mcs.a22r5.b1", "mcs", at="990.0347+(-269-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245940.0, assembly_id=103117.0))
lhcb1.new("mb.b22r5.b1", "mb", at="998.2707+(-268.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835710.0, assembly_id=103118.0))
lhcb1.new("mcs.b22r5.b1", "mcs", at="1005.6947+(-268-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245943.0, assembly_id=103118.0))
lhcb1.new("mco.b22r5.b1", "mco", at="1006.4447+(-268-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251758.0, assembly_id=103119.0))
lhcb1.new("mcd.b22r5.b1", "mcd", at="1006.4462+(-268-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251759.0, assembly_id=103119.0))
lhcb1.new("mb.c22r5.b1", "mb", at="1013.9307+(-267.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835734.0, assembly_id=103119.0))
lhcb1.new("mcs.c22r5.b1", "mcs", at="1021.3547+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245948.0, assembly_id=103119.0))
lhcb1.new("bpm.22r5.b1", "bpm", at="1022.2337+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245950.0, assembly_id=103120.0))
lhcb1.new("mo.22r5.b1", "mo_unplugged", at="1022.9847+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308821.0, assembly_id=103120.0))
lhcb1.new("mq.22r5.b1", "mq", at="1024.9957+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308293.0, assembly_id=103120.0))
lhcb1.new("ms.22r5.b1", "ms", at="1026.8907+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251762.0, assembly_id=103120.0))
lhcb1.new("mcbv.22r5.b1", "mcbv", at="1027.4837+(-267-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251764.0, assembly_id=103120.0))
lhcb1.new("mb.a23r5.b1", "mb", at="1036.0607+(-266.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835758.0, assembly_id=103121.0))
lhcb1.new("mcs.a23r5.b1", "mcs", at="1043.4847+(-266-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245956.0, assembly_id=103121.0))
lhcb1.new("mco.23r5.b1", "mco", at="1044.2347+(-266-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251766.0, assembly_id=103122.0))
lhcb1.new("mcd.23r5.b1", "mcd", at="1044.2362+(-266-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251767.0, assembly_id=103122.0))
lhcb1.new("mb.b23r5.b1", "mb", at="1051.7207+(-265.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835782.0, assembly_id=103122.0))
lhcb1.new("mcs.b23r5.b1", "mcs", at="1059.1447+(-265-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245961.0, assembly_id=103122.0))
lhcb1.new("mb.c23r5.b1", "mb", at="1067.3807+(-264.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835806.0, assembly_id=103123.0))
lhcb1.new("mcs.c23r5.b1", "mcs", at="1074.8047+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245964.0, assembly_id=103123.0))
lhcb1.new("bpm.23r5.b1", "bpm", at="1075.6837+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245966.0, assembly_id=103124.0))
lhcb1.new("mqs.23r5.b1", "mqs", at="1076.4377+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307643.0, assembly_id=103124.0))
lhcb1.new("mq.23r5.b1", "mq", at="1078.4457+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308324.0, assembly_id=103124.0))
lhcb1.new("ms.23r5.b1", "ms", at="1080.3407+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251770.0, assembly_id=103124.0))
lhcb1.new("mcbh.23r5.b1", "mcbh", at="1080.9337+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251772.0, assembly_id=103124.0))
lhcb1.new("mco.a24r5.b1", "mco", at="1082.0247+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251774.0, assembly_id=103125.0))
lhcb1.new("mcd.a24r5.b1", "mcd", at="1082.0262+(-264-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251775.0, assembly_id=103125.0))
lhcb1.new("mb.a24r5.b1", "mb", at="1089.5107+(-263.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835830.0, assembly_id=103125.0))
lhcb1.new("mcs.a24r5.b1", "mcs", at="1096.9347+(-263-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245974.0, assembly_id=103125.0))
lhcb1.new("mb.b24r5.b1", "mb", at="1105.1707+(-262.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835854.0, assembly_id=103126.0))
lhcb1.new("mcs.b24r5.b1", "mcs", at="1112.5947+(-262-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245977.0, assembly_id=103126.0))
lhcb1.new("mco.b24r5.b1", "mco", at="1113.3447+(-262-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251778.0, assembly_id=103127.0))
lhcb1.new("mcd.b24r5.b1", "mcd", at="1113.3462+(-262-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251779.0, assembly_id=103127.0))
lhcb1.new("mb.c24r5.b1", "mb", at="1120.8307+(-261.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835878.0, assembly_id=103127.0))
lhcb1.new("mcs.c24r5.b1", "mcs", at="1128.2547+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245982.0, assembly_id=103127.0))
lhcb1.new("bpm.24r5.b1", "bpm", at="1129.1337+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245984.0, assembly_id=103128.0))
lhcb1.new("mo.24r5.b1", "mo_unplugged", at="1129.8847+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308851.0, assembly_id=103128.0))
lhcb1.new("mq.24r5.b1", "mq", at="1131.8957+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308114.0, assembly_id=103128.0))
lhcb1.new("ms.24r5.b1", "ms", at="1133.7907+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251782.0, assembly_id=103128.0))
lhcb1.new("mcbv.24r5.b1", "mcbv", at="1134.3837+(-261-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251784.0, assembly_id=103128.0))
lhcb1.new("mb.a25r5.b1", "mb", at="1142.9607+(-260.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835902.0, assembly_id=103129.0))
lhcb1.new("mcs.a25r5.b1", "mcs", at="1150.3847+(-260-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245990.0, assembly_id=103129.0))
lhcb1.new("mco.25r5.b1", "mco", at="1151.1347+(-260-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251786.0, assembly_id=103130.0))
lhcb1.new("mcd.25r5.b1", "mcd", at="1151.1362+(-260-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251787.0, assembly_id=103130.0))
lhcb1.new("mb.b25r5.b1", "mb", at="1158.6207+(-259.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835926.0, assembly_id=103130.0))
lhcb1.new("mcs.b25r5.b1", "mcs", at="1166.0447+(-259-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245995.0, assembly_id=103130.0))
lhcb1.new("mb.c25r5.b1", "mb", at="1174.2807+(-258.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835950.0, assembly_id=103131.0))
lhcb1.new("mcs.c25r5.b1", "mcs", at="1181.7047+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245998.0, assembly_id=103131.0))
lhcb1.new("bpm.25r5.b1", "bpm", at="1182.5837+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246000.0, assembly_id=103132.0))
lhcb1.new("mo.25r5.b1", "mo", at="1183.3347+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308883.0, assembly_id=103132.0))
lhcb1.new("mq.25r5.b1", "mq", at="1185.3457+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308146.0, assembly_id=103132.0))
lhcb1.new("ms.25r5.b1", "ms", at="1187.2407+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251790.0, assembly_id=103132.0))
lhcb1.new("mcbh.25r5.b1", "mcbh", at="1187.8337+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251792.0, assembly_id=103132.0))
lhcb1.new("mco.a26r5.b1", "mco", at="1188.9247+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251794.0, assembly_id=103133.0))
lhcb1.new("mcd.a26r5.b1", "mcd", at="1188.9262+(-258-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251795.0, assembly_id=103133.0))
lhcb1.new("mb.a26r5.b1", "mb", at="1196.4107+(-257.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835974.0, assembly_id=103133.0))
lhcb1.new("mcs.a26r5.b1", "mcs", at="1203.8347+(-257-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246008.0, assembly_id=103133.0))
lhcb1.new("mb.b26r5.b1", "mb", at="1212.0707+(-256.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52835998.0, assembly_id=103134.0))
lhcb1.new("mcs.b26r5.b1", "mcs", at="1219.4947+(-256-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246011.0, assembly_id=103134.0))
lhcb1.new("mco.b26r5.b1", "mco", at="1220.2447+(-256-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251798.0, assembly_id=103135.0))
lhcb1.new("mcd.b26r5.b1", "mcd", at="1220.2462+(-256-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251799.0, assembly_id=103135.0))
lhcb1.new("mb.c26r5.b1", "mb", at="1227.7307+(-255.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836022.0, assembly_id=103135.0))
lhcb1.new("mcs.c26r5.b1", "mcs", at="1235.1547+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246016.0, assembly_id=103135.0))
lhcb1.new("bpm.26r5.b1", "bpm", at="1236.0337+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246018.0, assembly_id=103136.0))
lhcb1.new("mo.26r5.b1", "mo", at="1236.7847+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308914.0, assembly_id=103136.0))
lhcb1.new("mq.26r5.b1", "mq", at="1238.7957+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308177.0, assembly_id=103136.0))
lhcb1.new("ms.26r5.b1", "ms", at="1240.6907+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251802.0, assembly_id=103136.0))
lhcb1.new("mcbv.26r5.b1", "mcbv_unplugged", at="1241.2837+(-255-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251804.0, assembly_id=103136.0))
lhcb1.new("mb.a27r5.b1", "mb", at="1249.8607+(-254.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836046.0, assembly_id=103137.0))
lhcb1.new("mcs.a27r5.b1", "mcs", at="1257.2847+(-254-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246024.0, assembly_id=103137.0))
lhcb1.new("mco.27r5.b1", "mco", at="1258.0347+(-254-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251806.0, assembly_id=103138.0))
lhcb1.new("mcd.27r5.b1", "mcd", at="1258.0362+(-254-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251807.0, assembly_id=103138.0))
lhcb1.new("mb.b27r5.b1", "mb", at="1265.5207+(-253.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836070.0, assembly_id=103138.0))
lhcb1.new("mcs.b27r5.b1", "mcs", at="1272.9447+(-253-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246029.0, assembly_id=103138.0))
lhcb1.new("mb.c27r5.b1", "mb", at="1281.1807+(-252.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836094.0, assembly_id=103139.0))
lhcb1.new("mcs.c27r5.b1", "mcs", at="1288.6047+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246032.0, assembly_id=103139.0))
lhcb1.new("bpm.27r5.b1", "bpm", at="1289.4837+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246034.0, assembly_id=103140.0))
lhcb1.new("mqs.27r5.b1", "mqs", at="1290.2377+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307675.0, assembly_id=103140.0))
lhcb1.new("mq.27r5.b1", "mq", at="1292.2457+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308206.0, assembly_id=103140.0))
lhcb1.new("ms.27r5.b1", "ms", at="1294.1407+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251810.0, assembly_id=103140.0))
lhcb1.new("mcbh.27r5.b1", "mcbh", at="1294.7337+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251812.0, assembly_id=103140.0))
lhcb1.new("mco.a28r5.b1", "mco", at="1295.8247+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251814.0, assembly_id=103141.0))
lhcb1.new("mcd.a28r5.b1", "mcd", at="1295.8262+(-252-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251815.0, assembly_id=103141.0))
lhcb1.new("mb.a28r5.b1", "mb", at="1303.3107+(-251.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836118.0, assembly_id=103141.0))
lhcb1.new("mcs.a28r5.b1", "mcs", at="1310.7347+(-251-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246042.0, assembly_id=103141.0))
lhcb1.new("mb.b28r5.b1", "mb", at="1318.9707+(-250.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836142.0, assembly_id=103142.0))
lhcb1.new("mcs.b28r5.b1", "mcs", at="1326.3947+(-250-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246045.0, assembly_id=103142.0))
lhcb1.new("mco.b28r5.b1", "mco", at="1327.1447+(-250-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251818.0, assembly_id=103143.0))
lhcb1.new("mcd.b28r5.b1", "mcd", at="1327.1462+(-250-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251819.0, assembly_id=103143.0))
lhcb1.new("mb.c28r5.b1", "mb", at="1334.6307+(-249.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836166.0, assembly_id=103143.0))
lhcb1.new("mcs.c28r5.b1", "mcs", at="1342.0547+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246050.0, assembly_id=103143.0))
lhcb1.new("bpm.28r5.b1", "bpm", at="1342.9337+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246052.0, assembly_id=103144.0))
lhcb1.new("mo.28r5.b1", "mo_unplugged", at="1343.6847+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308704.0, assembly_id=103144.0))
lhcb1.new("mq.28r5.b1", "mq", at="1345.6957+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307998.0, assembly_id=103144.0))
lhcb1.new("ms.28r5.b1", "ms", at="1347.5907+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251822.0, assembly_id=103144.0))
lhcb1.new("mcbv.28r5.b1", "mcbv", at="1348.1837+(-249-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251824.0, assembly_id=103144.0))
lhcb1.new("mb.a29r5.b1", "mb", at="1356.7607+(-248.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836190.0, assembly_id=103145.0))
lhcb1.new("mcs.a29r5.b1", "mcs", at="1364.1847+(-248-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246058.0, assembly_id=103145.0))
lhcb1.new("mco.29r5.b1", "mco", at="1364.9347+(-248-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251826.0, assembly_id=103146.0))
lhcb1.new("mcd.29r5.b1", "mcd", at="1364.9362+(-248-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251827.0, assembly_id=103146.0))
lhcb1.new("mb.b29r5.b1", "mb", at="1372.4207+(-247.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836214.0, assembly_id=103146.0))
lhcb1.new("mcs.b29r5.b1", "mcs", at="1379.8447+(-247-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246063.0, assembly_id=103146.0))
lhcb1.new("mb.c29r5.b1", "mb", at="1388.0807+(-246.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836238.0, assembly_id=103147.0))
lhcb1.new("mcs.c29r5.b1", "mcs", at="1395.5047+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246066.0, assembly_id=103147.0))
lhcb1.new("bpm.29r5.b1", "bpm", at="1396.3837+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246068.0, assembly_id=103148.0))
lhcb1.new("mo.29r5.b1", "mo", at="1397.1347+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308736.0, assembly_id=103148.0))
lhcb1.new("mq.29r5.b1", "mq", at="1399.1457+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308029.0, assembly_id=103148.0))
lhcb1.new("mss.29r5.b1", "mss", at="1401.0407+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251830.0, assembly_id=103148.0))
lhcb1.new("mcbh.29r5.b1", "mcbh", at="1401.6337+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251832.0, assembly_id=103148.0))
lhcb1.new("mco.a30r5.b1", "mco", at="1402.7247+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251834.0, assembly_id=103149.0))
lhcb1.new("mcd.a30r5.b1", "mcd", at="1402.7262+(-246-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251835.0, assembly_id=103149.0))
lhcb1.new("mb.a30r5.b1", "mb", at="1410.2107+(-245.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836262.0, assembly_id=103149.0))
lhcb1.new("mcs.a30r5.b1", "mcs", at="1417.6347+(-245-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246076.0, assembly_id=103149.0))
lhcb1.new("mb.b30r5.b1", "mb", at="1425.8707+(-244.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836286.0, assembly_id=103150.0))
lhcb1.new("mcs.b30r5.b1", "mcs", at="1433.2947+(-244-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246079.0, assembly_id=103150.0))
lhcb1.new("mco.b30r5.b1", "mco", at="1434.0447+(-244-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251838.0, assembly_id=103151.0))
lhcb1.new("mcd.b30r5.b1", "mcd", at="1434.0462+(-244-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251839.0, assembly_id=103151.0))
lhcb1.new("mb.c30r5.b1", "mb", at="1441.5307+(-243.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836310.0, assembly_id=103151.0))
lhcb1.new("mcs.c30r5.b1", "mcs", at="1448.9547+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246084.0, assembly_id=103151.0))
lhcb1.new("bpm.30r5.b1", "bpm", at="1449.8337+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246086.0, assembly_id=103152.0))
lhcb1.new("mo.30r5.b1", "mo", at="1450.5847+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308767.0, assembly_id=103152.0))
lhcb1.new("mq.30r5.b1", "mq", at="1452.5957+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308058.0, assembly_id=103152.0))
lhcb1.new("ms.30r5.b1", "ms", at="1454.4907+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251842.0, assembly_id=103152.0))
lhcb1.new("mcbv.30r5.b1", "mcbv", at="1455.0837+(-243-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251844.0, assembly_id=103152.0))
lhcb1.new("mb.a31r5.b1", "mb", at="1463.6607+(-242.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836334.0, assembly_id=103153.0))
lhcb1.new("mcs.a31r5.b1", "mcs", at="1471.0847+(-242-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246092.0, assembly_id=103153.0))
lhcb1.new("mco.31r5.b1", "mco", at="1471.8347+(-242-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251846.0, assembly_id=103154.0))
lhcb1.new("mcd.31r5.b1", "mcd", at="1471.8362+(-242-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251847.0, assembly_id=103154.0))
lhcb1.new("mb.b31r5.b1", "mb", at="1479.3207+(-241.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836358.0, assembly_id=103154.0))
lhcb1.new("mcs.b31r5.b1", "mcs", at="1486.7447+(-241-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246097.0, assembly_id=103154.0))
lhcb1.new("mb.c31r5.b1", "mb", at="1494.9807+(-240.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836382.0, assembly_id=103155.0))
lhcb1.new("mcs.c31r5.b1", "mcs", at="1502.4047+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246100.0, assembly_id=103155.0))
lhcb1.new("bpm.31r5.b1", "bpm", at="1503.2837+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246102.0, assembly_id=103156.0))
lhcb1.new("mo.31r5.b1", "mo", at="1504.0347+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308797.0, assembly_id=103156.0))
lhcb1.new("mq.31r5.b1", "mq", at="1506.0457+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307850.0, assembly_id=103156.0))
lhcb1.new("ms.31r5.b1", "ms", at="1507.9407+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251850.0, assembly_id=103156.0))
lhcb1.new("mcbh.31r5.b1", "mcbh", at="1508.5337+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251852.0, assembly_id=103156.0))
lhcb1.new("s.cell.56.b1", "omk", at="1509.2807+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a32r5.b1", "mco", at="1509.6247+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251854.0, assembly_id=103157.0))
lhcb1.new("mcd.a32r5.b1", "mcd", at="1509.6262+(-240-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251855.0, assembly_id=103157.0))
lhcb1.new("mb.a32r5.b1", "mb", at="1517.1107+(-239.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836406.0, assembly_id=103157.0))
lhcb1.new("mcs.a32r5.b1", "mcs", at="1524.5347+(-239-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246110.0, assembly_id=103157.0))
lhcb1.new("mb.b32r5.b1", "mb", at="1532.7707+(-238.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836430.0, assembly_id=103158.0))
lhcb1.new("mcs.b32r5.b1", "mcs", at="1540.1947+(-238-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246113.0, assembly_id=103158.0))
lhcb1.new("mco.b32r5.b1", "mco", at="1540.9447+(-238-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251858.0, assembly_id=103159.0))
lhcb1.new("mcd.b32r5.b1", "mcd", at="1540.9462+(-238-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251859.0, assembly_id=103159.0))
lhcb1.new("mb.c32r5.b1", "mb", at="1548.4307+(-237.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836454.0, assembly_id=103159.0))
lhcb1.new("mcs.c32r5.b1", "mcs", at="1555.8547+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246118.0, assembly_id=103159.0))
lhcb1.new("bpm.32r5.b1", "bpm", at="1556.7337+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246120.0, assembly_id=103160.0))
lhcb1.new("mo.32r5.b1", "mo", at="1557.4847+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308589.0, assembly_id=103160.0))
lhcb1.new("mq.32r5.b1", "mq", at="1559.4957+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307880.0, assembly_id=103160.0))
lhcb1.new("ms.32r5.b1", "ms", at="1561.3907+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251862.0, assembly_id=103160.0))
lhcb1.new("mcbv.32r5.b1", "mcbv", at="1561.9837+(-237-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251864.0, assembly_id=103160.0))
lhcb1.new("mb.a33r5.b1", "mb", at="1570.5607+(-236.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836478.0, assembly_id=103161.0))
lhcb1.new("mcs.a33r5.b1", "mcs", at="1577.9847+(-236-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246126.0, assembly_id=103161.0))
lhcb1.new("mco.33r5.b1", "mco", at="1578.7347+(-236-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251866.0, assembly_id=103162.0))
lhcb1.new("mcd.33r5.b1", "mcd", at="1578.7362+(-236-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251867.0, assembly_id=103162.0))
lhcb1.new("mb.b33r5.b1", "mb", at="1586.2207+(-235.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836502.0, assembly_id=103162.0))
lhcb1.new("mcs.b33r5.b1", "mcs", at="1593.6447+(-235-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246131.0, assembly_id=103162.0))
lhcb1.new("mb.c33r5.b1", "mb", at="1601.8807+(-234.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836526.0, assembly_id=103163.0))
lhcb1.new("mcs.c33r5.b1", "mcs", at="1609.3047+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246134.0, assembly_id=103163.0))
lhcb1.new("bpm.33r5.b1", "bpm", at="1610.1837+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246136.0, assembly_id=103164.0))
lhcb1.new("mo.33r5.b1", "mo", at="1610.9347+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308620.0, assembly_id=103164.0))
lhcb1.new("mq.33r5.b1", "mq", at="1612.9457+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307910.0, assembly_id=103164.0))
lhcb1.new("mss.33r5.b1", "mss", at="1614.8407+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251870.0, assembly_id=103164.0))
lhcb1.new("mcbh.33r5.b1", "mcbh", at="1615.4337+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251872.0, assembly_id=103164.0))
lhcb1.new("e.cell.56.b1", "omk", at="1616.1807+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a34r5.b1", "mco", at="1616.5247+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251874.0, assembly_id=103165.0))
lhcb1.new("mcd.a34r5.b1", "mcd", at="1616.5262+(-234-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251875.0, assembly_id=103165.0))
lhcb1.new("mb.a34r5.b1", "mb", at="1624.0107+(-233.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836550.0, assembly_id=103165.0))
lhcb1.new("mcs.a34r5.b1", "mcs", at="1631.4347+(-233-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246144.0, assembly_id=103165.0))
lhcb1.new("mb.b34r5.b1", "mb", at="1639.6707+(-232.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836574.0, assembly_id=103166.0))
lhcb1.new("mcs.b34r5.b1", "mcs", at="1647.0947+(-232-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246147.0, assembly_id=103166.0))
lhcb1.new("mco.b34r5.b1", "mco", at="1647.8447+(-232-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251878.0, assembly_id=103167.0))
lhcb1.new("mcd.b34r5.b1", "mcd", at="1647.8462+(-232-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251879.0, assembly_id=103167.0))
lhcb1.new("mb.c34r5.b1", "mb", at="1655.3307+(-231.5-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52836598.0, assembly_id=103167.0))
lhcb1.new("mcs.c34r5.b1", "mcs", at="1662.7547+(-231-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246152.0, assembly_id=103167.0))
lhcb1.new("bpm.34r5.b1", "bpm", at="1663.6337+(-231-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=246154.0, assembly_id=103168.0))
lhcb1.new("mo.34r5.b1", "mo", at="1664.3847+(-231-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308635.0, assembly_id=103168.0))
lhcb1.new("mq.34r5.b1", "mq", at="1666.3957+(-231-ip5ofs.b1)*ds", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307925.0, assembly_id=103168.0))
lhcb1.new("ms.34l6.b1", "ms", at="-1664.0697+(-231-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251882.0, assembly_id=103168.0))
lhcb1.new("mcbv.34l6.b1", "mcbv", at="-1663.4767+(-231-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251884.0, assembly_id=103168.0))
lhcb1.new("mb.c34l6.b1", "mb", at="-1654.8997+(-230.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836622.0, assembly_id=103169.0))
lhcb1.new("mcs.c34l6.b1", "mcs", at="-1647.4757+(-230-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246160.0, assembly_id=103169.0))
lhcb1.new("mco.34l6.b1", "mco", at="-1646.7257+(-230-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251886.0, assembly_id=103170.0))
lhcb1.new("mcd.34l6.b1", "mcd", at="-1646.7242+(-230-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251887.0, assembly_id=103170.0))
lhcb1.new("mb.b34l6.b1", "mb", at="-1639.2397+(-229.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836646.0, assembly_id=103170.0))
lhcb1.new("mcs.b34l6.b1", "mcs", at="-1631.8157+(-229-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246165.0, assembly_id=103170.0))
lhcb1.new("mb.a34l6.b1", "mb", at="-1623.5797+(-228.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836670.0, assembly_id=103171.0))
lhcb1.new("mcs.a34l6.b1", "mcs", at="-1616.1557+(-228-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246168.0, assembly_id=103171.0))
lhcb1.new("bpm.33l6.b1", "bpm", at="-1615.2767+(-228-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246170.0, assembly_id=103172.0))
lhcb1.new("mo.33l6.b1", "mo", at="-1614.5257+(-228-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308607.0, assembly_id=103172.0))
lhcb1.new("mq.33l6.b1", "mq", at="-1612.5147+(-228-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307897.0, assembly_id=103172.0))
lhcb1.new("mss.33l6.b1", "mss", at="-1610.6197+(-228-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251890.0, assembly_id=103172.0))
lhcb1.new("mcbh.33l6.b1", "mcbh", at="-1610.0267+(-228-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251892.0, assembly_id=103172.0))
lhcb1.new("mco.b33l6.b1", "mco", at="-1608.9357+(-228-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251894.0, assembly_id=103173.0))
lhcb1.new("mcd.b33l6.b1", "mcd", at="-1608.9342+(-228-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251895.0, assembly_id=103173.0))
lhcb1.new("mb.c33l6.b1", "mb", at="-1601.4497+(-227.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836694.0, assembly_id=103173.0))
lhcb1.new("mcs.c33l6.b1", "mcs", at="-1594.0257+(-227-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246178.0, assembly_id=103173.0))
lhcb1.new("mb.b33l6.b1", "mb", at="-1585.7897+(-226.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836718.0, assembly_id=103174.0))
lhcb1.new("mcs.b33l6.b1", "mcs", at="-1578.3657+(-226-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246181.0, assembly_id=103174.0))
lhcb1.new("mco.a33l6.b1", "mco", at="-1577.6157+(-226-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251898.0, assembly_id=103175.0))
lhcb1.new("mcd.a33l6.b1", "mcd", at="-1577.6142+(-226-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251899.0, assembly_id=103175.0))
lhcb1.new("mb.a33l6.b1", "mb", at="-1570.1297+(-225.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836742.0, assembly_id=103175.0))
lhcb1.new("mcs.a33l6.b1", "mcs", at="-1562.7057+(-225-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246186.0, assembly_id=103175.0))
lhcb1.new("bpm.32l6.b1", "bpm", at="-1561.8267+(-225-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246188.0, assembly_id=103176.0))
lhcb1.new("mo.32l6.b1", "mo", at="-1561.0757+(-225-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308575.0, assembly_id=103176.0))
lhcb1.new("mq.32l6.b1", "mq", at="-1559.0647+(-225-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307867.0, assembly_id=103176.0))
lhcb1.new("ms.32l6.b1", "ms", at="-1557.1697+(-225-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251902.0, assembly_id=103176.0))
lhcb1.new("mcbv.32l6.b1", "mcbv", at="-1556.5767+(-225-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251904.0, assembly_id=103176.0))
lhcb1.new("mb.c32l6.b1", "mb", at="-1547.9997+(-224.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836766.0, assembly_id=103177.0))
lhcb1.new("mcs.c32l6.b1", "mcs", at="-1540.5757+(-224-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246194.0, assembly_id=103177.0))
lhcb1.new("mco.32l6.b1", "mco", at="-1539.8257+(-224-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251906.0, assembly_id=103178.0))
lhcb1.new("mcd.32l6.b1", "mcd", at="-1539.8242+(-224-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251907.0, assembly_id=103178.0))
lhcb1.new("mb.b32l6.b1", "mb", at="-1532.3397+(-223.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836790.0, assembly_id=103178.0))
lhcb1.new("mcs.b32l6.b1", "mcs", at="-1524.9157+(-223-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246199.0, assembly_id=103178.0))
lhcb1.new("mb.a32l6.b1", "mb", at="-1516.6797+(-222.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836814.0, assembly_id=103179.0))
lhcb1.new("mcs.a32l6.b1", "mcs", at="-1509.2557+(-222-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246202.0, assembly_id=103179.0))
lhcb1.new("bpm.31l6.b1", "bpm", at="-1508.3767+(-222-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246204.0, assembly_id=103180.0))
lhcb1.new("mo.31l6.b1", "mo", at="-1507.6257+(-222-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308784.0, assembly_id=103180.0))
lhcb1.new("mq.31l6.b1", "mq", at="-1505.6147+(-222-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308075.0, assembly_id=103180.0))
lhcb1.new("ms.31l6.b1", "ms", at="-1503.7197+(-222-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251910.0, assembly_id=103180.0))
lhcb1.new("mcbh.31l6.b1", "mcbh", at="-1503.1267+(-222-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251912.0, assembly_id=103180.0))
lhcb1.new("mco.b31l6.b1", "mco", at="-1502.0357+(-222-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251914.0, assembly_id=103181.0))
lhcb1.new("mcd.b31l6.b1", "mcd", at="-1502.0342+(-222-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251915.0, assembly_id=103181.0))
lhcb1.new("mb.c31l6.b1", "mb", at="-1494.5497+(-221.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836838.0, assembly_id=103181.0))
lhcb1.new("mcs.c31l6.b1", "mcs", at="-1487.1257+(-221-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246212.0, assembly_id=103181.0))
lhcb1.new("mb.b31l6.b1", "mb", at="-1478.8897+(-220.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836862.0, assembly_id=103182.0))
lhcb1.new("mcs.b31l6.b1", "mcs", at="-1471.4657+(-220-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246215.0, assembly_id=103182.0))
lhcb1.new("mco.a31l6.b1", "mco", at="-1470.7157+(-220-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251918.0, assembly_id=103183.0))
lhcb1.new("mcd.a31l6.b1", "mcd", at="-1470.7142+(-220-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251919.0, assembly_id=103183.0))
lhcb1.new("mb.a31l6.b1", "mb", at="-1463.2297+(-219.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836886.0, assembly_id=103183.0))
lhcb1.new("mcs.a31l6.b1", "mcs", at="-1455.8057+(-219-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246220.0, assembly_id=103183.0))
lhcb1.new("bpm.30l6.b1", "bpm", at="-1454.9267+(-219-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246222.0, assembly_id=103184.0))
lhcb1.new("mo.30l6.b1", "mo", at="-1454.1757+(-219-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308754.0, assembly_id=103184.0))
lhcb1.new("mq.30l6.b1", "mq", at="-1452.1647+(-219-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308045.0, assembly_id=103184.0))
lhcb1.new("ms.30l6.b1", "ms", at="-1450.2697+(-219-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251922.0, assembly_id=103184.0))
lhcb1.new("mcbv.30l6.b1", "mcbv", at="-1449.6767+(-219-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251924.0, assembly_id=103184.0))
lhcb1.new("mb.c30l6.b1", "mb", at="-1441.0997+(-218.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836910.0, assembly_id=103185.0))
lhcb1.new("mcs.c30l6.b1", "mcs", at="-1433.6757+(-218-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246228.0, assembly_id=103185.0))
lhcb1.new("mco.30l6.b1", "mco", at="-1432.9257+(-218-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251926.0, assembly_id=103186.0))
lhcb1.new("mcd.30l6.b1", "mcd", at="-1432.9242+(-218-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251927.0, assembly_id=103186.0))
lhcb1.new("mb.b30l6.b1", "mb", at="-1425.4397+(-217.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836934.0, assembly_id=103186.0))
lhcb1.new("mcs.b30l6.b1", "mcs", at="-1418.0157+(-217-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246233.0, assembly_id=103186.0))
lhcb1.new("mb.a30l6.b1", "mb", at="-1409.7797+(-216.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836958.0, assembly_id=103187.0))
lhcb1.new("mcs.a30l6.b1", "mcs", at="-1402.3557+(-216-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246236.0, assembly_id=103187.0))
lhcb1.new("bpm.29l6.b1", "bpm", at="-1401.4767+(-216-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246238.0, assembly_id=103188.0))
lhcb1.new("mo.29l6.b1", "mo", at="-1400.7257+(-216-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308722.0, assembly_id=103188.0))
lhcb1.new("mq.29l6.b1", "mq", at="-1398.7147+(-216-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308016.0, assembly_id=103188.0))
lhcb1.new("mss.29l6.b1", "mss", at="-1396.8197+(-216-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251930.0, assembly_id=103188.0))
lhcb1.new("mcbh.29l6.b1", "mcbh", at="-1396.2267+(-216-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251932.0, assembly_id=103188.0))
lhcb1.new("mco.b29l6.b1", "mco", at="-1395.1357+(-216-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251934.0, assembly_id=103189.0))
lhcb1.new("mcd.b29l6.b1", "mcd", at="-1395.1342+(-216-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251935.0, assembly_id=103189.0))
lhcb1.new("mb.c29l6.b1", "mb", at="-1387.6497+(-215.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52836982.0, assembly_id=103189.0))
lhcb1.new("mcs.c29l6.b1", "mcs", at="-1380.2257+(-215-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246246.0, assembly_id=103189.0))
lhcb1.new("mb.b29l6.b1", "mb", at="-1371.9897+(-214.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837006.0, assembly_id=103190.0))
lhcb1.new("mcs.b29l6.b1", "mcs", at="-1364.5657+(-214-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246249.0, assembly_id=103190.0))
lhcb1.new("mco.a29l6.b1", "mco", at="-1363.8157+(-214-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251938.0, assembly_id=103191.0))
lhcb1.new("mcd.a29l6.b1", "mcd", at="-1363.8142+(-214-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251939.0, assembly_id=103191.0))
lhcb1.new("mb.a29l6.b1", "mb", at="-1356.3297+(-213.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837030.0, assembly_id=103191.0))
lhcb1.new("mcs.a29l6.b1", "mcs", at="-1348.9057+(-213-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246254.0, assembly_id=103191.0))
lhcb1.new("bpm.28l6.b1", "bpm", at="-1348.0267+(-213-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246256.0, assembly_id=103192.0))
lhcb1.new("mo.28l6.b1", "mo", at="-1347.2757+(-213-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2348497.0, assembly_id=103192.0))
lhcb1.new("mq.28l6.b1", "mq", at="-1345.2647+(-213-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307984.0, assembly_id=103192.0))
lhcb1.new("ms.28l6.b1", "ms", at="-1343.3697+(-213-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251942.0, assembly_id=103192.0))
lhcb1.new("mcbv.28l6.b1", "mcbv", at="-1342.7767+(-213-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251944.0, assembly_id=103192.0))
lhcb1.new("mb.c28l6.b1", "mb", at="-1334.1997+(-212.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837054.0, assembly_id=103193.0))
lhcb1.new("mcs.c28l6.b1", "mcs", at="-1326.7757+(-212-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246262.0, assembly_id=103193.0))
lhcb1.new("mco.28l6.b1", "mco", at="-1326.0257+(-212-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251946.0, assembly_id=103194.0))
lhcb1.new("mcd.28l6.b1", "mcd", at="-1326.0242+(-212-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251947.0, assembly_id=103194.0))
lhcb1.new("mb.b28l6.b1", "mb", at="-1318.5397+(-211.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837078.0, assembly_id=103194.0))
lhcb1.new("mcs.b28l6.b1", "mcs", at="-1311.1157+(-211-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246267.0, assembly_id=103194.0))
lhcb1.new("mb.a28l6.b1", "mb", at="-1302.8797+(-210.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837102.0, assembly_id=103195.0))
lhcb1.new("mcs.a28l6.b1", "mcs", at="-1295.4557+(-210-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246270.0, assembly_id=103195.0))
lhcb1.new("bpm.27l6.b1", "bpm", at="-1294.5767+(-210-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246272.0, assembly_id=103196.0))
lhcb1.new("mqs.27l6.b1", "mqs", at="-1293.8227+(-210-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307661.0, assembly_id=103196.0))
lhcb1.new("mq.27l6.b1", "mq", at="-1291.8147+(-210-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308193.0, assembly_id=103196.0))
lhcb1.new("ms.27l6.b1", "ms", at="-1289.9197+(-210-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251950.0, assembly_id=103196.0))
lhcb1.new("mcbh.27l6.b1", "mcbh", at="-1289.3267+(-210-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251952.0, assembly_id=103196.0))
lhcb1.new("mco.b27l6.b1", "mco", at="-1288.2357+(-210-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251954.0, assembly_id=103197.0))
lhcb1.new("mcd.b27l6.b1", "mcd", at="-1288.2342+(-210-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251955.0, assembly_id=103197.0))
lhcb1.new("mb.c27l6.b1", "mb", at="-1280.7497+(-209.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837126.0, assembly_id=103197.0))
lhcb1.new("mcs.c27l6.b1", "mcs", at="-1273.3257+(-209-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246280.0, assembly_id=103197.0))
lhcb1.new("mb.b27l6.b1", "mb", at="-1265.0897+(-208.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837150.0, assembly_id=103198.0))
lhcb1.new("mcs.b27l6.b1", "mcs", at="-1257.6657+(-208-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246283.0, assembly_id=103198.0))
lhcb1.new("mco.a27l6.b1", "mco", at="-1256.9157+(-208-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251958.0, assembly_id=103199.0))
lhcb1.new("mcd.a27l6.b1", "mcd", at="-1256.9142+(-208-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251959.0, assembly_id=103199.0))
lhcb1.new("mb.a27l6.b1", "mb", at="-1249.4297+(-207.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837174.0, assembly_id=103199.0))
lhcb1.new("mcs.a27l6.b1", "mcs", at="-1242.0057+(-207-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246288.0, assembly_id=103199.0))
lhcb1.new("bpm.26l6.b1", "bpm", at="-1241.1267+(-207-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246290.0, assembly_id=103200.0))
lhcb1.new("mo.26l6.b1", "mo", at="-1240.3757+(-207-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308901.0, assembly_id=103200.0))
lhcb1.new("mq.26l6.b1", "mq", at="-1238.3647+(-207-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308164.0, assembly_id=103200.0))
lhcb1.new("ms.26l6.b1", "ms", at="-1236.4697+(-207-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251962.0, assembly_id=103200.0))
lhcb1.new("mcbv.26l6.b1", "mcbv", at="-1235.8767+(-207-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251964.0, assembly_id=103200.0))
lhcb1.new("mb.c26l6.b1", "mb", at="-1227.2997+(-206.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837198.0, assembly_id=103201.0))
lhcb1.new("mcs.c26l6.b1", "mcs", at="-1219.8757+(-206-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246296.0, assembly_id=103201.0))
lhcb1.new("mco.26l6.b1", "mco", at="-1219.1257+(-206-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251966.0, assembly_id=103202.0))
lhcb1.new("mcd.26l6.b1", "mcd", at="-1219.1242+(-206-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251967.0, assembly_id=103202.0))
lhcb1.new("mb.b26l6.b1", "mb", at="-1211.6397+(-205.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837222.0, assembly_id=103202.0))
lhcb1.new("mcs.b26l6.b1", "mcs", at="-1204.2157+(-205-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246301.0, assembly_id=103202.0))
lhcb1.new("mb.a26l6.b1", "mb", at="-1195.9797+(-204.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837246.0, assembly_id=103203.0))
lhcb1.new("mcs.a26l6.b1", "mcs", at="-1188.5557+(-204-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246304.0, assembly_id=103203.0))
lhcb1.new("bpm.25l6.b1", "bpm", at="-1187.6767+(-204-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246306.0, assembly_id=103204.0))
lhcb1.new("mo.25l6.b1", "mo", at="-1186.9257+(-204-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308869.0, assembly_id=103204.0))
lhcb1.new("mq.25l6.b1", "mq", at="-1184.9147+(-204-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308132.0, assembly_id=103204.0))
lhcb1.new("ms.25l6.b1", "ms", at="-1183.0197+(-204-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251970.0, assembly_id=103204.0))
lhcb1.new("mcbh.25l6.b1", "mcbh", at="-1182.4267+(-204-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251972.0, assembly_id=103204.0))
lhcb1.new("mco.b25l6.b1", "mco", at="-1181.3357+(-204-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251974.0, assembly_id=103205.0))
lhcb1.new("mcd.b25l6.b1", "mcd", at="-1181.3342+(-204-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251975.0, assembly_id=103205.0))
lhcb1.new("mb.c25l6.b1", "mb", at="-1173.8497+(-203.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837270.0, assembly_id=103205.0))
lhcb1.new("mcs.c25l6.b1", "mcs", at="-1166.4257+(-203-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246314.0, assembly_id=103205.0))
lhcb1.new("mb.b25l6.b1", "mb", at="-1158.1897+(-202.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837294.0, assembly_id=103206.0))
lhcb1.new("mcs.b25l6.b1", "mcs", at="-1150.7657+(-202-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246317.0, assembly_id=103206.0))
lhcb1.new("mco.a25l6.b1", "mco", at="-1150.0157+(-202-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251978.0, assembly_id=103207.0))
lhcb1.new("mcd.a25l6.b1", "mcd", at="-1150.0142+(-202-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251979.0, assembly_id=103207.0))
lhcb1.new("mb.a25l6.b1", "mb", at="-1142.5297+(-201.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837318.0, assembly_id=103207.0))
lhcb1.new("mcs.a25l6.b1", "mcs", at="-1135.1057+(-201-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246322.0, assembly_id=103207.0))
lhcb1.new("bpm.24l6.b1", "bpm", at="-1134.2267+(-201-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246324.0, assembly_id=103208.0))
lhcb1.new("mo.24l6.b1", "mo", at="-1133.4757+(-201-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308838.0, assembly_id=103208.0))
lhcb1.new("mq.24l6.b1", "mq", at="-1131.4647+(-201-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308100.0, assembly_id=103208.0))
lhcb1.new("ms.24l6.b1", "ms", at="-1129.5697+(-201-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251982.0, assembly_id=103208.0))
lhcb1.new("mcbv.24l6.b1", "mcbv", at="-1128.9767+(-201-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251984.0, assembly_id=103208.0))
lhcb1.new("mb.c24l6.b1", "mb", at="-1120.3997+(-200.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837342.0, assembly_id=103209.0))
lhcb1.new("mcs.c24l6.b1", "mcs", at="-1112.9757+(-200-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246330.0, assembly_id=103209.0))
lhcb1.new("mco.24l6.b1", "mco", at="-1112.2257+(-200-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251986.0, assembly_id=103210.0))
lhcb1.new("mcd.24l6.b1", "mcd", at="-1112.2242+(-200-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251987.0, assembly_id=103210.0))
lhcb1.new("mb.b24l6.b1", "mb", at="-1104.7397+(-199.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837366.0, assembly_id=103210.0))
lhcb1.new("mcs.b24l6.b1", "mcs", at="-1097.3157+(-199-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246335.0, assembly_id=103210.0))
lhcb1.new("mb.a24l6.b1", "mb", at="-1089.0797+(-198.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837390.0, assembly_id=103211.0))
lhcb1.new("mcs.a24l6.b1", "mcs", at="-1081.6557+(-198-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246338.0, assembly_id=103211.0))
lhcb1.new("bpm.23l6.b1", "bpm", at="-1080.7767+(-198-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246340.0, assembly_id=103212.0))
lhcb1.new("mqs.23l6.b1", "mqs", at="-1080.0227+(-198-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307630.0, assembly_id=103212.0))
lhcb1.new("mq.23l6.b1", "mq", at="-1078.0147+(-198-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308311.0, assembly_id=103212.0))
lhcb1.new("ms.23l6.b1", "ms", at="-1076.1197+(-198-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251990.0, assembly_id=103212.0))
lhcb1.new("mcbh.23l6.b1", "mcbh", at="-1075.5267+(-198-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251992.0, assembly_id=103212.0))
lhcb1.new("mco.b23l6.b1", "mco", at="-1074.4357+(-198-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251994.0, assembly_id=103213.0))
lhcb1.new("mcd.b23l6.b1", "mcd", at="-1074.4342+(-198-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251995.0, assembly_id=103213.0))
lhcb1.new("mb.c23l6.b1", "mb", at="-1066.9497+(-197.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837414.0, assembly_id=103213.0))
lhcb1.new("mcs.c23l6.b1", "mcs", at="-1059.5257+(-197-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246348.0, assembly_id=103213.0))
lhcb1.new("mb.b23l6.b1", "mb", at="-1051.2897+(-196.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837438.0, assembly_id=103214.0))
lhcb1.new("mcs.b23l6.b1", "mcs", at="-1043.8657+(-196-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246351.0, assembly_id=103214.0))
lhcb1.new("mco.a23l6.b1", "mco", at="-1043.1157+(-196-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251998.0, assembly_id=103215.0))
lhcb1.new("mcd.a23l6.b1", "mcd", at="-1043.1142+(-196-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=251999.0, assembly_id=103215.0))
lhcb1.new("mb.a23l6.b1", "mb", at="-1035.6297+(-195.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837462.0, assembly_id=103215.0))
lhcb1.new("mcs.a23l6.b1", "mcs", at="-1028.2057+(-195-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246356.0, assembly_id=103215.0))
lhcb1.new("bpm.22l6.b1", "bpm", at="-1027.3267+(-195-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246358.0, assembly_id=103216.0))
lhcb1.new("mo.22l6.b1", "mo", at="-1026.5757+(-195-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308808.0, assembly_id=103216.0))
lhcb1.new("mq.22l6.b1", "mq", at="-1024.5647+(-195-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308279.0, assembly_id=103216.0))
lhcb1.new("ms.22l6.b1", "ms", at="-1022.6697+(-195-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252002.0, assembly_id=103216.0))
lhcb1.new("mcbv.22l6.b1", "mcbv", at="-1022.0767+(-195-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252004.0, assembly_id=103216.0))
lhcb1.new("mb.c22l6.b1", "mb", at="-1013.4997+(-194.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837486.0, assembly_id=103217.0))
lhcb1.new("mcs.c22l6.b1", "mcs", at="-1006.0757+(-194-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246364.0, assembly_id=103217.0))
lhcb1.new("mco.22l6.b1", "mco", at="-1005.3257+(-194-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252006.0, assembly_id=103218.0))
lhcb1.new("mcd.22l6.b1", "mcd", at="-1005.3242+(-194-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252007.0, assembly_id=103218.0))
lhcb1.new("mb.b22l6.b1", "mb", at="-997.8397+(-193.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837510.0, assembly_id=103218.0))
lhcb1.new("mcs.b22l6.b1", "mcs", at="-990.4157+(-193-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246369.0, assembly_id=103218.0))
lhcb1.new("mb.a22l6.b1", "mb", at="-982.1797+(-192.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837534.0, assembly_id=103219.0))
lhcb1.new("mcs.a22l6.b1", "mcs", at="-974.7557+(-192-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246372.0, assembly_id=103219.0))
lhcb1.new("bpm.21l6.b1", "bpm", at="-973.8767+(-192-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246374.0, assembly_id=103220.0))
lhcb1.new("mqt.21l6.b1", "mqt", at="-973.1227+(-192-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307263.0, assembly_id=103220.0))
lhcb1.new("mq.21l6.b1", "mq", at="-971.1147+(-192-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308247.0, assembly_id=103220.0))
lhcb1.new("ms.21l6.b1", "ms", at="-969.2197+(-192-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252010.0, assembly_id=103220.0))
lhcb1.new("mcbh.21l6.b1", "mcbh", at="-968.6267+(-192-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252012.0, assembly_id=103220.0))
lhcb1.new("mco.b21l6.b1", "mco", at="-967.5357+(-192-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252014.0, assembly_id=103221.0))
lhcb1.new("mcd.b21l6.b1", "mcd", at="-967.5342+(-192-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252015.0, assembly_id=103221.0))
lhcb1.new("mb.c21l6.b1", "mb", at="-960.0497+(-191.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837558.0, assembly_id=103221.0))
lhcb1.new("mcs.c21l6.b1", "mcs", at="-952.6257+(-191-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246382.0, assembly_id=103221.0))
lhcb1.new("mb.b21l6.b1", "mb", at="-944.3897+(-190.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837582.0, assembly_id=103222.0))
lhcb1.new("mcs.b21l6.b1", "mcs", at="-936.9657+(-190-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246385.0, assembly_id=103222.0))
lhcb1.new("mco.a21l6.b1", "mco", at="-936.2157+(-190-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252018.0, assembly_id=103223.0))
lhcb1.new("mcd.a21l6.b1", "mcd", at="-936.2142+(-190-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252019.0, assembly_id=103223.0))
lhcb1.new("mb.a21l6.b1", "mb", at="-928.7297+(-189.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837606.0, assembly_id=103223.0))
lhcb1.new("mcs.a21l6.b1", "mcs", at="-921.3057+(-189-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246390.0, assembly_id=103223.0))
lhcb1.new("bpm.20l6.b1", "bpm", at="-920.4267+(-189-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246392.0, assembly_id=103224.0))
lhcb1.new("mqt.20l6.b1", "mqt", at="-919.6727+(-189-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307466.0, assembly_id=103224.0))
lhcb1.new("mq.20l6.b1", "mq", at="-917.6647+(-189-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308217.0, assembly_id=103224.0))
lhcb1.new("ms.20l6.b1", "ms", at="-915.7697+(-189-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252022.0, assembly_id=103224.0))
lhcb1.new("mcbv.20l6.b1", "mcbv", at="-915.1767+(-189-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252024.0, assembly_id=103224.0))
lhcb1.new("mb.c20l6.b1", "mb", at="-906.5997+(-188.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837630.0, assembly_id=103225.0))
lhcb1.new("mcs.c20l6.b1", "mcs", at="-899.1757+(-188-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246398.0, assembly_id=103225.0))
lhcb1.new("mco.20l6.b1", "mco", at="-898.4257+(-188-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252026.0, assembly_id=103226.0))
lhcb1.new("mcd.20l6.b1", "mcd", at="-898.4242+(-188-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252027.0, assembly_id=103226.0))
lhcb1.new("mb.b20l6.b1", "mb", at="-890.9397+(-187.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837654.0, assembly_id=103226.0))
lhcb1.new("mcs.b20l6.b1", "mcs", at="-883.5157+(-187-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246403.0, assembly_id=103226.0))
lhcb1.new("mb.a20l6.b1", "mb", at="-875.2797+(-186.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837678.0, assembly_id=103227.0))
lhcb1.new("mcs.a20l6.b1", "mcs", at="-867.8557+(-186-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246406.0, assembly_id=103227.0))
lhcb1.new("bpm.19l6.b1", "bpm", at="-866.9767+(-186-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246408.0, assembly_id=103228.0))
lhcb1.new("mqt.19l6.b1", "mqt", at="-866.2227+(-186-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307436.0, assembly_id=103228.0))
lhcb1.new("mq.19l6.b1", "mq", at="-864.2147+(-186-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308426.0, assembly_id=103228.0))
lhcb1.new("ms.19l6.b1", "ms", at="-862.3197+(-186-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252030.0, assembly_id=103228.0))
lhcb1.new("mcbh.19l6.b1", "mcbh", at="-861.7267+(-186-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252032.0, assembly_id=103228.0))
lhcb1.new("mco.b19l6.b1", "mco", at="-860.6357+(-186-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252034.0, assembly_id=103229.0))
lhcb1.new("mcd.b19l6.b1", "mcd", at="-860.6342+(-186-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252035.0, assembly_id=103229.0))
lhcb1.new("mb.c19l6.b1", "mb", at="-853.1497+(-185.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837702.0, assembly_id=103229.0))
lhcb1.new("mcs.c19l6.b1", "mcs", at="-845.7257+(-185-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246416.0, assembly_id=103229.0))
lhcb1.new("mb.b19l6.b1", "mb", at="-837.4897+(-184.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837726.0, assembly_id=103230.0))
lhcb1.new("mcs.b19l6.b1", "mcs", at="-830.0657+(-184-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246419.0, assembly_id=103230.0))
lhcb1.new("mco.a19l6.b1", "mco", at="-829.3157+(-184-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252038.0, assembly_id=103231.0))
lhcb1.new("mcd.a19l6.b1", "mcd", at="-829.3142+(-184-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252039.0, assembly_id=103231.0))
lhcb1.new("mb.a19l6.b1", "mb", at="-821.8297+(-183.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837750.0, assembly_id=103231.0))
lhcb1.new("mcs.a19l6.b1", "mcs", at="-814.4057+(-183-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246424.0, assembly_id=103231.0))
lhcb1.new("bpm.18l6.b1", "bpm", at="-813.5267+(-183-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246426.0, assembly_id=103232.0))
lhcb1.new("mqt.18l6.b1", "mqt", at="-812.7727+(-183-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307405.0, assembly_id=103232.0))
lhcb1.new("mq.18l6.b1", "mq", at="-810.7647+(-183-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308394.0, assembly_id=103232.0))
lhcb1.new("ms.18l6.b1", "ms", at="-808.8697+(-183-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252042.0, assembly_id=103232.0))
lhcb1.new("mcbv.18l6.b1", "mcbv", at="-808.2767+(-183-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252044.0, assembly_id=103232.0))
lhcb1.new("mb.c18l6.b1", "mb", at="-799.6997+(-182.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837774.0, assembly_id=103233.0))
lhcb1.new("mcs.c18l6.b1", "mcs", at="-792.2757+(-182-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246432.0, assembly_id=103233.0))
lhcb1.new("mco.18l6.b1", "mco", at="-791.5257+(-182-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252046.0, assembly_id=103234.0))
lhcb1.new("mcd.18l6.b1", "mcd", at="-791.5242+(-182-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252047.0, assembly_id=103234.0))
lhcb1.new("mb.b18l6.b1", "mb", at="-784.0397+(-181.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837798.0, assembly_id=103234.0))
lhcb1.new("mcs.b18l6.b1", "mcs", at="-776.6157+(-181-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246437.0, assembly_id=103234.0))
lhcb1.new("mb.a18l6.b1", "mb", at="-768.3797+(-180.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837822.0, assembly_id=103235.0))
lhcb1.new("mcs.a18l6.b1", "mcs", at="-760.9557+(-180-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246440.0, assembly_id=103235.0))
lhcb1.new("bpm.17l6.b1", "bpm", at="-760.0767+(-180-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246442.0, assembly_id=103236.0))
lhcb1.new("mqt.17l6.b1", "mqt", at="-759.3227+(-180-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307373.0, assembly_id=103236.0))
lhcb1.new("mq.17l6.b1", "mq", at="-757.3147+(-180-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308365.0, assembly_id=103236.0))
lhcb1.new("ms.17l6.b1", "ms", at="-755.4197+(-180-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252050.0, assembly_id=103236.0))
lhcb1.new("mcbh.17l6.b1", "mcbh", at="-754.8267+(-180-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252052.0, assembly_id=103236.0))
lhcb1.new("mco.b17l6.b1", "mco", at="-753.7357+(-180-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252054.0, assembly_id=103237.0))
lhcb1.new("mcd.b17l6.b1", "mcd", at="-753.7342+(-180-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252055.0, assembly_id=103237.0))
lhcb1.new("mb.c17l6.b1", "mb", at="-746.2497+(-179.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837846.0, assembly_id=103237.0))
lhcb1.new("mcs.c17l6.b1", "mcs", at="-738.8257+(-179-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246450.0, assembly_id=103237.0))
lhcb1.new("mb.b17l6.b1", "mb", at="-730.5897+(-178.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837870.0, assembly_id=103238.0))
lhcb1.new("mcs.b17l6.b1", "mcs", at="-723.1657+(-178-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246453.0, assembly_id=103238.0))
lhcb1.new("mco.a17l6.b1", "mco", at="-722.4157+(-178-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252058.0, assembly_id=103239.0))
lhcb1.new("mcd.a17l6.b1", "mcd", at="-722.4142+(-178-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252059.0, assembly_id=103239.0))
lhcb1.new("mb.a17l6.b1", "mb", at="-714.9297+(-177.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837894.0, assembly_id=103239.0))
lhcb1.new("mcs.a17l6.b1", "mcs", at="-707.5057+(-177-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246458.0, assembly_id=103239.0))
lhcb1.new("bpm.16l6.b1", "bpm", at="-706.6267+(-177-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246460.0, assembly_id=103240.0))
lhcb1.new("mqt.16l6.b1", "mqt", at="-705.8727+(-177-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307580.0, assembly_id=103240.0))
lhcb1.new("mq.16l6.b1", "mq", at="-703.8647+(-177-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308335.0, assembly_id=103240.0))
lhcb1.new("ms.16l6.b1", "ms", at="-701.9697+(-177-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252062.0, assembly_id=103240.0))
lhcb1.new("mcbv.16l6.b1", "mcbv", at="-701.3767+(-177-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252064.0, assembly_id=103240.0))
lhcb1.new("mb.c16l6.b1", "mb", at="-692.7997+(-176.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837918.0, assembly_id=103241.0))
lhcb1.new("mcs.c16l6.b1", "mcs", at="-685.3757+(-176-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246466.0, assembly_id=103241.0))
lhcb1.new("mco.16l6.b1", "mco", at="-684.6257+(-176-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252066.0, assembly_id=103242.0))
lhcb1.new("mcd.16l6.b1", "mcd", at="-684.6242+(-176-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252067.0, assembly_id=103242.0))
lhcb1.new("mb.b16l6.b1", "mb", at="-677.1397+(-175.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837942.0, assembly_id=103242.0))
lhcb1.new("mcs.b16l6.b1", "mcs", at="-669.7157+(-175-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246471.0, assembly_id=103242.0))
lhcb1.new("mb.a16l6.b1", "mb", at="-661.4797+(-174.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837966.0, assembly_id=103243.0))
lhcb1.new("mcs.a16l6.b1", "mcs", at="-654.0557+(-174-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246474.0, assembly_id=103243.0))
lhcb1.new("bpm.15l6.b1", "bpm", at="-653.1767+(-174-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246476.0, assembly_id=103244.0))
lhcb1.new("mqt.15l6.b1", "mqt", at="-652.4227+(-174-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307549.0, assembly_id=103244.0))
lhcb1.new("mq.15l6.b1", "mq", at="-650.4147+(-174-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308541.0, assembly_id=103244.0))
lhcb1.new("ms.15l6.b1", "ms", at="-648.5197+(-174-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252070.0, assembly_id=103244.0))
lhcb1.new("mcbh.15l6.b1", "mcbh", at="-647.9267+(-174-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252072.0, assembly_id=103244.0))
lhcb1.new("mco.b15l6.b1", "mco", at="-646.8357+(-174-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252074.0, assembly_id=103245.0))
lhcb1.new("mcd.b15l6.b1", "mcd", at="-646.8342+(-174-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252075.0, assembly_id=103245.0))
lhcb1.new("mb.c15l6.b1", "mb", at="-639.3497+(-173.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52837990.0, assembly_id=103245.0))
lhcb1.new("mcs.c15l6.b1", "mcs", at="-631.9257+(-173-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246484.0, assembly_id=103245.0))
lhcb1.new("mb.b15l6.b1", "mb", at="-623.6897+(-172.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838014.0, assembly_id=103246.0))
lhcb1.new("mcs.b15l6.b1", "mcs", at="-616.2657+(-172-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246487.0, assembly_id=103246.0))
lhcb1.new("mco.a15l6.b1", "mco", at="-615.5157+(-172-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252078.0, assembly_id=103247.0))
lhcb1.new("mcd.a15l6.b1", "mcd", at="-615.5142+(-172-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252079.0, assembly_id=103247.0))
lhcb1.new("mb.a15l6.b1", "mb", at="-608.0297+(-171.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838038.0, assembly_id=103247.0))
lhcb1.new("mcs.a15l6.b1", "mcs", at="-600.6057+(-171-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246492.0, assembly_id=103247.0))
lhcb1.new("bpm.14l6.b1", "bpm", at="-599.7267+(-171-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246494.0, assembly_id=103248.0))
lhcb1.new("mqt.14l6.b1", "mqt", at="-598.9727+(-171-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307517.0, assembly_id=103248.0))
lhcb1.new("mq.14l6.b1", "mq", at="-596.9647+(-171-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308512.0, assembly_id=103248.0))
lhcb1.new("ms.14l6.b1", "ms", at="-595.0697+(-171-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252082.0, assembly_id=103248.0))
lhcb1.new("mcbv.14l6.b1", "mcbv", at="-594.4767+(-171-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252084.0, assembly_id=103248.0))
lhcb1.new("mb.c14l6.b1", "mb", at="-585.8997+(-170.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838062.0, assembly_id=103249.0))
lhcb1.new("mcs.c14l6.b1", "mcs", at="-578.4757+(-170-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246500.0, assembly_id=103249.0))
lhcb1.new("mco.14l6.b1", "mco", at="-577.7257+(-170-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252086.0, assembly_id=103250.0))
lhcb1.new("mcd.14l6.b1", "mcd", at="-577.7242+(-170-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252087.0, assembly_id=103250.0))
lhcb1.new("mb.b14l6.b1", "mb", at="-570.2397+(-169.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838086.0, assembly_id=103250.0))
lhcb1.new("mcs.b14l6.b1", "mcs", at="-562.8157+(-169-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246505.0, assembly_id=103250.0))
lhcb1.new("mb.a14l6.b1", "mb", at="-554.5797+(-168.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838110.0, assembly_id=103251.0))
lhcb1.new("mcs.a14l6.b1", "mcs", at="-547.1557+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246508.0, assembly_id=103251.0))
lhcb1.new("s.ds.l6.b1", "omk", at="-546.7497+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.13l6.b1", "bpm", at="-546.2767+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246510.0, assembly_id=103252.0))
lhcb1.new("mqt.13l6.b1", "mqt", at="-545.5227+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307725.0, assembly_id=103252.0))
lhcb1.new("mq.13l6.b1", "mq", at="-543.5147+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308482.0, assembly_id=103252.0))
lhcb1.new("ms.13l6.b1", "ms", at="-541.6197+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252090.0, assembly_id=103252.0))
lhcb1.new("mcbh.13l6.b1", "mcbh", at="-541.0267+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252092.0, assembly_id=103252.0))
lhcb1.new("mco.b13l6.b1", "mco", at="-539.9357+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252094.0, assembly_id=103253.0))
lhcb1.new("mcd.b13l6.b1", "mcd", at="-539.9342+(-168-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252095.0, assembly_id=103253.0))
lhcb1.new("mb.c13l6.b1", "mb", at="-532.4497+(-167.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838134.0, assembly_id=103253.0))
lhcb1.new("mcs.c13l6.b1", "mcs", at="-525.0257+(-167-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246518.0, assembly_id=103253.0))
lhcb1.new("mb.b13l6.b1", "mb", at="-516.7897+(-166.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838158.0, assembly_id=103254.0))
lhcb1.new("mcs.b13l6.b1", "mcs", at="-509.3657+(-166-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246521.0, assembly_id=103254.0))
lhcb1.new("mco.a13l6.b1", "mco", at="-508.6157+(-166-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252098.0, assembly_id=103255.0))
lhcb1.new("mcd.a13l6.b1", "mcd", at="-508.6142+(-166-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252099.0, assembly_id=103255.0))
lhcb1.new("mb.a13l6.b1", "mb", at="-501.1297+(-165.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838182.0, assembly_id=103255.0))
lhcb1.new("mcs.a13l6.b1", "mcs", at="-493.7057+(-165-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246526.0, assembly_id=103255.0))
lhcb1.new("bpm.12l6.b1", "bpm", at="-492.8267+(-165-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246528.0, assembly_id=103256.0))
lhcb1.new("mqt.12l6.b1", "mqt", at="-492.0727+(-165-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307693.0, assembly_id=103256.0))
lhcb1.new("mq.12l6.b1", "mq", at="-490.0647+(-165-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308452.0, assembly_id=103256.0))
lhcb1.new("ms.12l6.b1", "ms", at="-488.1697+(-165-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252102.0, assembly_id=103256.0))
lhcb1.new("mcbv.12l6.b1", "mcbv", at="-487.5767+(-165-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252104.0, assembly_id=103256.0))
lhcb1.new("mb.c12l6.b1", "mb", at="-478.9997+(-164.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838206.0, assembly_id=103257.0))
lhcb1.new("mcs.c12l6.b1", "mcs", at="-471.5757+(-164-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246534.0, assembly_id=103257.0))
lhcb1.new("mco.12l6.b1", "mco", at="-470.8257+(-164-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252106.0, assembly_id=103258.0))
lhcb1.new("mcd.12l6.b1", "mcd", at="-470.8242+(-164-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252107.0, assembly_id=103258.0))
lhcb1.new("mb.b12l6.b1", "mb", at="-463.3397+(-163.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838230.0, assembly_id=103258.0))
lhcb1.new("mcs.b12l6.b1", "mcs", at="-455.9157+(-163-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246539.0, assembly_id=103258.0))
lhcb1.new("mb.a12l6.b1", "mb", at="-447.6797+(-162.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838254.0, assembly_id=103259.0))
lhcb1.new("mcs.a12l6.b1", "mcs", at="-440.2557+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246542.0, assembly_id=103259.0))
lhcb1.new("e.arc.56.b1", "omk", at="-439.8497+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.11l6.b1", "bpm", at="-439.3767+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246544.0, assembly_id=103260.0))
lhcb1.new("mq.11l6.b1", "mq", at="-436.8297+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308659.0, assembly_id=103260.0))
lhcb1.new("mqtli.11l6.b1", "mqtli", at="-434.4607+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307347.0, assembly_id=103260.0))
lhcb1.new("ms.11l6.b1", "ms", at="-433.4487+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252110.0, assembly_id=103260.0))
lhcb1.new("mcbh.11l6.b1", "mcbh", at="-432.8557+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252112.0, assembly_id=103260.0))
lhcb1.new("lebr.11l6.b1", "lebr", at="-425.71735+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52997682.0, assembly_id=103261.0))
lhcb1.new("mco.11l6.b1", "mco", at="-418.986+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252114.0, assembly_id=103262.0))
lhcb1.new("mcd.11l6.b1", "mcd", at="-418.9845+(-162-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252115.0, assembly_id=103262.0))
lhcb1.new("mb.b11l6.b1", "mb", at="-411.5+(-161.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838278.0, assembly_id=103262.0))
lhcb1.new("mcs.b11l6.b1", "mcs", at="-404.076+(-161-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246552.0, assembly_id=103262.0))
lhcb1.new("mb.a11l6.b1", "mb", at="-395.84+(-160.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838302.0, assembly_id=103263.0))
lhcb1.new("mcs.a11l6.b1", "mcs", at="-388.416+(-160-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246555.0, assembly_id=103263.0))
lhcb1.new("bpm.10l6.b1", "bpm", at="-387.537+(-160-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246557.0, assembly_id=103264.0))
lhcb1.new("mqml.10l6.b1", "mqml", at="-384.392+(-160-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307812.0, assembly_id=103264.0))
lhcb1.new("mcbcv.10l6.b1", "mcbcv", at="-381.35+(-160-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252119.0, assembly_id=103264.0))
lhcb1.new("mco.10l6.b1", "mco", at="-379.921+(-160-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252120.0, assembly_id=103265.0))
lhcb1.new("mcd.10l6.b1", "mcd", at="-379.9195+(-160-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252121.0, assembly_id=103265.0))
lhcb1.new("mb.b10l6.b1", "mb", at="-372.435+(-159.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838326.0, assembly_id=103265.0))
lhcb1.new("mcs.b10l6.b1", "mcs", at="-365.011+(-159-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246564.0, assembly_id=103265.0))
lhcb1.new("mb.a10l6.b1", "mb", at="-356.775+(-158.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838350.0, assembly_id=103266.0))
lhcb1.new("mcs.a10l6.b1", "mcs", at="-349.351+(-158-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246567.0, assembly_id=103266.0))
lhcb1.new("bpm.9l6.b1", "bpm", at="-348.471+(-158-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246569.0, assembly_id=103267.0))
lhcb1.new("mqmc.9l6.b1", "mqmc", at="-346.495+(-158-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307789.0, assembly_id=103267.0))
lhcb1.new("mqm.9l6.b1", "mqm", at="-343.229+(-158-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307737.0, assembly_id=103267.0))
lhcb1.new("mcbch.9l6.b1", "mcbch", at="-340.888+(-158-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252125.0, assembly_id=103267.0))
lhcb1.new("mco.9l6.b1", "mco", at="-339.456+(-158-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252126.0, assembly_id=103268.0))
lhcb1.new("mcd.9l6.b1", "mcd", at="-339.4545+(-158-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252127.0, assembly_id=103268.0))
lhcb1.new("mb.b9l6.b1", "mb", at="-331.97+(-157.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838374.0, assembly_id=103268.0))
lhcb1.new("mcs.b9l6.b1", "mcs", at="-324.546+(-157-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246577.0, assembly_id=103268.0))
lhcb1.new("mb.a9l6.b1", "mb", at="-316.31+(-156.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838398.0, assembly_id=103269.0))
lhcb1.new("mcs.a9l6.b1", "mcs", at="-308.886+(-156-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246580.0, assembly_id=103269.0))
lhcb1.new("bpm.8l6.b1", "bpm", at="-308.007+(-156-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=378004.0, assembly_id=103270.0))
lhcb1.new("mqml.8l6.b1", "mqml", at="-304.862+(-156-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307844.0, assembly_id=103270.0))
lhcb1.new("mcbcv.8l6.b1", "mcbcv", at="-301.82+(-156-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=378116.0, assembly_id=103270.0))
lhcb1.new("mco.8l6.b1", "mco", at="-300.391+(-156-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252132.0, assembly_id=103271.0))
lhcb1.new("mcd.8l6.b1", "mcd", at="-300.3895+(-156-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252133.0, assembly_id=103271.0))
lhcb1.new("mb.b8l6.b1", "mb", at="-292.905+(-155.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838422.0, assembly_id=103271.0))
lhcb1.new("mcs.b8l6.b1", "mcs", at="-285.481+(-155-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246589.0, assembly_id=103271.0))
lhcb1.new("mb.a8l6.b1", "mb", at="-277.245+(-154.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838446.0, assembly_id=103272.0))
lhcb1.new("mcs.a8l6.b1", "mcs", at="-269.821+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246592.0, assembly_id=103272.0))
lhcb1.new("e.ds.l6.b1", "omk", at="-269.415+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(slot_id=100932.0))
lhcb1.new("lejl.5l6.b1", "lejl", at="-264.355+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52997970.0, assembly_id=791286.0))
lhcb1.new("dfbak.5l6.b1", "dfbak", at="-258.2075+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52996779.0, assembly_id=104686.0))
lhcb1.new("bpmya.5l6.b1", "bpmya", at="-210.918+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246594.0, assembly_id=103273.0))
lhcb1.new("mqy.5l6.b1", "mqy", at="-208.2+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2303186.0, assembly_id=103273.0))
lhcb1.new("mcbyh.5l6.b1", "mcbyh", at="-205.853+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252137.0, assembly_id=103273.0))
lhcb1.new("mkd.o5l6.b1", "mkd", at="-202.9315+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134574.0))
lhcb1.new("mkd.n5l6.b1", "mkd", at="-201.2285+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134575.0))
lhcb1.new("mkd.m5l6.b1", "mkd", at="-199.2455+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134576.0))
lhcb1.new("mkd.l5l6.b1", "mkd", at="-197.5425+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134577.0))
lhcb1.new("mkd.k5l6.b1", "mkd", at="-195.5595+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134578.0))
lhcb1.new("mkd.j5l6.b1", "mkd", at="-193.7015+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134579.0))
lhcb1.new("mkd.i5l6.b1", "mkd", at="-191.7185+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134580.0))
lhcb1.new("mkd.h5l6.b1", "mkd", at="-190.0155+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134581.0))
lhcb1.new("mkd.g5l6.b1", "mkd", at="-188.3125+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134582.0))
lhcb1.new("mkd.f5l6.b1", "mkd", at="-186.3295+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134583.0))
lhcb1.new("mkd.e5l6.b1", "mkd", at="-184.4715+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134584.0))
lhcb1.new("mkd.d5l6.b1", "mkd", at="-182.4885+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134585.0))
lhcb1.new("mkd.c5l6.b1", "mkd", at="-180.7855+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134586.0))
lhcb1.new("mkd.b5l6.b1", "mkd", at="-178.8025+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134587.0))
lhcb1.new("mkd.a5l6.b1", "mkd", at="-177.0995+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=134588.0))
lhcb1.new("bpmyb.4l6.b1", "bpmyb", at="-174.518+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=298234.0, assembly_id=103275.0))
lhcb1.new("mqy.4l6.b1", "mqy", at="-171.8+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=241849.0, assembly_id=103275.0))
lhcb1.new("mcbyv.4l6.b1", "mcbyv", at="-169.453+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252139.0, assembly_id=103275.0))
lhcb1.new("tcdqm.b4l6.b1", "tcdqm", at="-166.448+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52998752.0, assembly_id=377626.0))
lhcb1.new("tcdqm.a4l6.b1", "tcdqm", at="-165.098+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52998800.0, assembly_id=829888.0))
lhcb1.new("bpmsx.b4l6.b1", "bpmsx004", at="-138.9775+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=377630.0))
lhcb1.new("bpmsx.b4l6.b1_itlk", "bpmsx002", at="-138.9775+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=14271446.0, assembly_id=377630.0))
lhcb1.new("bpmsx.a4l6.b1", "bpmsx004", at="-138.3925+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=377631.0))
lhcb1.new("bpmsx.a4l6.b1_itlk", "bpmsx002", at="-138.3925+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=14271448.0, assembly_id=377631.0))
lhcb1.new("bpmse.4l6.b1", "bpmse", at="-45.2675+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.244, slot_id=181625.0))
lhcb1.new("btvse.a4l6.b1", "btvse", at="-44.575+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.244, slot_id=181626.0))
lhcb1.new("tcdsa.4l6.b1", "tcdsa", at="-42.375+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.244, slot_id=631488.0, assembly_id=103279.0))
lhcb1.new("tcdsb.4l6.b1", "tcdsb", at="-38.825+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.2451, slot_id=631492.0, assembly_id=616848.0))
lhcb1.new("msda.e4l6.b1", "msda", at="-34.37+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1875, slot_id=134591.0))
lhcb1.new("msda.d4l6.b1", "msda", at="-29.46+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1894, slot_id=134593.0))
lhcb1.new("msda.c4l6.b1", "msda", at="-24.55+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1914, slot_id=134595.0))
lhcb1.new("msda.b4l6.b1", "msda", at="-19.64+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1933, slot_id=134597.0))
lhcb1.new("msda.a4l6.b1", "msda", at="-14.73+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1953, slot_id=134600.0))
lhcb1.new("msdb.c4l6.b1", "msdb", at="-9.82+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1911, slot_id=134601.0))
lhcb1.new("msdb.b4l6.b1", "msdb", at="-4.91+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.193, slot_id=134604.0))
lhcb1.new("msdb2.4l6.b1", "msdb2", at="-1.022+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1946, slot_id=52895867.0, assembly_id=134605.0))
lhcb1.new("ip6", "omk", at="pip6+ip6ofs.b1*ds")
lhcb1.new("msdb2.4r6.b1", "msdb2", at="1.022+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1954, slot_id=52895905.0, assembly_id=134605.0))
lhcb1.new("msdb.a4r6.b1", "msdb", at="4.91+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1969, slot_id=134608.0))
lhcb1.new("msdb.b4r6.b1", "msdb", at="9.82+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1989, slot_id=134610.0))
lhcb1.new("msdc.a4r6.b1", "msdc", at="14.73+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1927, slot_id=134612.0))
lhcb1.new("msdc.b4r6.b1", "msdc", at="19.64+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.195, slot_id=134613.0))
lhcb1.new("msdc.c4r6.b1", "msdc", at="24.55+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1973, slot_id=134615.0))
lhcb1.new("msdc.d4r6.b1", "msdc", at="29.46+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.1996, slot_id=134617.0))
lhcb1.new("msdc.e4r6.b1", "msdc", at="34.37+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.202, slot_id=134620.0))
lhcb1.new("bpmsa.4r6.b1", "bpmsa", at="46.3025+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=377633.0))
lhcb1.new("bpmsi.a4r6.b1_itlk", "bpmsi002", at="139.5625+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=14305619.0, assembly_id=377636.0))
lhcb1.new("bpmsi.b4r6.b1_itlk", "bpmsi002", at="140.1975+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=14305621.0, assembly_id=377637.0))
lhcb1.new("tcdqa.a4r6.b1", "tcdqa", at="143.24+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.214, slot_id=629261.0, assembly_id=103282.0))
lhcb1.new("tcdqa.c4r6.b1", "tcdqa", at="146.79+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.214, slot_id=6030088.0, assembly_id=6030087.0))
lhcb1.new("tcdqa.b4r6.b1", "tcdqa", at="150.34+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.214, slot_id=629255.0, assembly_id=616960.0))
lhcb1.new("bptuh.a4r6.b1", "bptuh", at="153.655+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=10338511.0, assembly_id=377638.0))
lhcb1.new("tcsp.a4r6.b1", "tcsp", at="154.25+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=377638.0))
lhcb1.new("bptdh.a4r6.b1", "bptdh", at="154.845+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=10338509.0, assembly_id=377638.0))
lhcb1.new("tcdqm.a4r6.b1", "tcdqm", at="165.098+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52998824.0, assembly_id=829889.0))
lhcb1.new("tcdqm.b4r6.b1", "tcdqm", at="166.448+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52998776.0, assembly_id=377639.0))
lhcb1.new("bpmya.4r6.b1", "bpmya", at="169.082+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246606.0, assembly_id=103285.0))
lhcb1.new("mqy.4r6.b1", "mqy", at="171.8+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2303141.0, assembly_id=103285.0))
lhcb1.new("mcbyh.4r6.b1", "mcbyh", at="174.147+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252141.0, assembly_id=103285.0))
lhcb1.new("bpmyb.5r6.b1", "bpmyb", at="205.482+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=298236.0, assembly_id=103287.0))
lhcb1.new("mqy.5r6.b1", "mqy", at="208.2+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2302997.0, assembly_id=103287.0))
lhcb1.new("mcbyv.5r6.b1", "mcbyv", at="210.547+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252143.0, assembly_id=103287.0))
lhcb1.new("dfbal.5r6.b1", "dfbal", at="268.0775+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52996803.0, assembly_id=104687.0))
lhcb1.new("s.ds.r6.b1", "omk", at="269.415+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(slot_id=100932.0))
lhcb1.new("mco.8r6.b1", "mco", at="269.759+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252144.0, assembly_id=103288.0))
lhcb1.new("mcd.8r6.b1", "mcd", at="269.7605+(-154-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252145.0, assembly_id=103288.0))
lhcb1.new("mb.a8r6.b1", "mb", at="277.245+(-153.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838470.0, assembly_id=103288.0))
lhcb1.new("mcs.a8r6.b1", "mcs", at="284.669+(-153-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246617.0, assembly_id=103288.0))
lhcb1.new("mb.b8r6.b1", "mb", at="292.905+(-152.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838494.0, assembly_id=103289.0))
lhcb1.new("mcs.b8r6.b1", "mcs", at="300.329+(-152-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246620.0, assembly_id=103289.0))
lhcb1.new("bpm.8r6.b1", "bpm", at="301.208+(-152-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246622.0, assembly_id=103290.0))
lhcb1.new("mqml.8r6.b1", "mqml", at="304.353+(-152-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307617.0, assembly_id=103290.0))
lhcb1.new("mcbch.8r6.b1", "mcbch", at="307.395+(-152-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252149.0, assembly_id=103290.0))
lhcb1.new("mco.9r6.b1", "mco", at="308.824+(-152-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252150.0, assembly_id=103291.0))
lhcb1.new("mcd.9r6.b1", "mcd", at="308.8255+(-152-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252151.0, assembly_id=103291.0))
lhcb1.new("mb.a9r6.b1", "mb", at="316.31+(-151.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838518.0, assembly_id=103291.0))
lhcb1.new("mcs.a9r6.b1", "mcs", at="323.734+(-151-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246629.0, assembly_id=103291.0))
lhcb1.new("mb.b9r6.b1", "mb", at="331.97+(-150.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52849678.0, assembly_id=103292.0))
lhcb1.new("mcs.b9r6.b1", "mcs", at="339.394+(-150-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=357322.0, assembly_id=103292.0))
lhcb1.new("bpm.9r6.b1", "bpm", at="340.274+(-150-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246634.0, assembly_id=103293.0))
lhcb1.new("mqmc.9r6.b1", "mqmc", at="342.25+(-150-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307800.0, assembly_id=103293.0))
lhcb1.new("mqm.9r6.b1", "mqm", at="345.516+(-150-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307748.0, assembly_id=103293.0))
lhcb1.new("mcbcv.9r6.b1", "mcbcv", at="347.857+(-150-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252155.0, assembly_id=103293.0))
lhcb1.new("mco.10r6.b1", "mco", at="349.289+(-150-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252156.0, assembly_id=103294.0))
lhcb1.new("mcd.10r6.b1", "mcd", at="349.2905+(-150-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252157.0, assembly_id=103294.0))
lhcb1.new("mb.a10r6.b1", "mb", at="356.775+(-149.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838542.0, assembly_id=103294.0))
lhcb1.new("mcs.a10r6.b1", "mcs", at="364.199+(-149-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246642.0, assembly_id=103294.0))
lhcb1.new("mb.b10r6.b1", "mb", at="372.435+(-148.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838566.0, assembly_id=103295.0))
lhcb1.new("mcs.b10r6.b1", "mcs", at="379.859+(-148-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246645.0, assembly_id=103295.0))
lhcb1.new("bpm.10r6.b1", "bpm", at="380.738+(-148-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246647.0, assembly_id=103296.0))
lhcb1.new("mqml.10r6.b1", "mqml", at="383.883+(-148-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307824.0, assembly_id=103296.0))
lhcb1.new("mcbch.10r6.b1", "mcbch", at="386.925+(-148-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252161.0, assembly_id=103296.0))
lhcb1.new("mco.11r6.b1", "mco", at="388.354+(-148-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252162.0, assembly_id=103297.0))
lhcb1.new("mcd.11r6.b1", "mcd", at="388.3555+(-148-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252163.0, assembly_id=103297.0))
lhcb1.new("mb.a11r6.b1", "mb", at="395.84+(-147.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838590.0, assembly_id=103297.0))
lhcb1.new("mcs.a11r6.b1", "mcs", at="403.264+(-147-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246654.0, assembly_id=103297.0))
lhcb1.new("mb.b11r6.b1", "mb", at="411.5+(-146.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838614.0, assembly_id=103298.0))
lhcb1.new("mcs.b11r6.b1", "mcs", at="418.924+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246657.0, assembly_id=103298.0))
lhcb1.new("lear.11r6.b1", "lear", at="425.71735+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52997610.0, assembly_id=103299.0))
lhcb1.new("bpm.11r6.b1", "bpm", at="432.5777+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246659.0, assembly_id=103300.0))
lhcb1.new("mq.11r6.b1", "mq", at="435.1247+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308674.0, assembly_id=103300.0))
lhcb1.new("mqtli.11r6.b1", "mqtli", at="437.4937+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307362.0, assembly_id=103300.0))
lhcb1.new("ms.11r6.b1", "ms", at="438.5057+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252166.0, assembly_id=103300.0))
lhcb1.new("mcbv.11r6.b1", "mcbv", at="439.0987+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252168.0, assembly_id=103300.0))
lhcb1.new("s.arc.67.b1", "omk", at="439.8497+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a12r6.b1", "mco", at="440.1937+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252170.0, assembly_id=103301.0))
lhcb1.new("mcd.a12r6.b1", "mcd", at="440.1952+(-146-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252171.0, assembly_id=103301.0))
lhcb1.new("mb.a12r6.b1", "mb", at="447.6797+(-145.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838638.0, assembly_id=103301.0))
lhcb1.new("mcs.a12r6.b1", "mcs", at="455.1037+(-145-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246667.0, assembly_id=103301.0))
lhcb1.new("mb.b12r6.b1", "mb", at="463.3397+(-144.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838662.0, assembly_id=103302.0))
lhcb1.new("mcs.b12r6.b1", "mcs", at="470.7637+(-144-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246670.0, assembly_id=103302.0))
lhcb1.new("mco.b12r6.b1", "mco", at="471.5137+(-144-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252174.0, assembly_id=103303.0))
lhcb1.new("mcd.b12r6.b1", "mcd", at="471.5152+(-144-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252175.0, assembly_id=103303.0))
lhcb1.new("mb.c12r6.b1", "mb", at="478.9997+(-143.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838686.0, assembly_id=103303.0))
lhcb1.new("mcs.c12r6.b1", "mcs", at="486.4237+(-143-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246675.0, assembly_id=103303.0))
lhcb1.new("bpm.12r6.b1", "bpm", at="487.3027+(-143-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246677.0, assembly_id=103304.0))
lhcb1.new("mqt.12r6.b1", "mqt", at="488.0567+(-143-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307709.0, assembly_id=103304.0))
lhcb1.new("mq.12r6.b1", "mq", at="490.0647+(-143-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308467.0, assembly_id=103304.0))
lhcb1.new("ms.12r6.b1", "ms", at="491.9597+(-143-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252178.0, assembly_id=103304.0))
lhcb1.new("mcbh.12r6.b1", "mcbh", at="492.5527+(-143-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252180.0, assembly_id=103304.0))
lhcb1.new("mb.a13r6.b1", "mb", at="501.1297+(-142.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838710.0, assembly_id=103305.0))
lhcb1.new("mcs.a13r6.b1", "mcs", at="508.5537+(-142-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246683.0, assembly_id=103305.0))
lhcb1.new("mco.13r6.b1", "mco", at="509.3037+(-142-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252182.0, assembly_id=103306.0))
lhcb1.new("mcd.13r6.b1", "mcd", at="509.3052+(-142-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252183.0, assembly_id=103306.0))
lhcb1.new("mb.b13r6.b1", "mb", at="516.7897+(-141.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838734.0, assembly_id=103306.0))
lhcb1.new("mcs.b13r6.b1", "mcs", at="524.2137+(-141-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246688.0, assembly_id=103306.0))
lhcb1.new("mb.c13r6.b1", "mb", at="532.4497+(-140.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838758.0, assembly_id=103307.0))
lhcb1.new("mcs.c13r6.b1", "mcs", at="539.8737+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246691.0, assembly_id=103307.0))
lhcb1.new("bpm.13r6.b1", "bpm", at="540.7527+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246693.0, assembly_id=103308.0))
lhcb1.new("mqt.13r6.b1", "mqt", at="541.5067+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307501.0, assembly_id=103308.0))
lhcb1.new("mq.13r6.b1", "mq", at="543.5147+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308497.0, assembly_id=103308.0))
lhcb1.new("ms.13r6.b1", "ms", at="545.4097+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252186.0, assembly_id=103308.0))
lhcb1.new("mcbv.13r6.b1", "mcbv", at="546.0027+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252188.0, assembly_id=103308.0))
lhcb1.new("e.ds.r6.b1", "omk", at="546.7497+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a14r6.b1", "mco", at="547.0937+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252190.0, assembly_id=103309.0))
lhcb1.new("mcd.a14r6.b1", "mcd", at="547.0952+(-140-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252191.0, assembly_id=103309.0))
lhcb1.new("mb.a14r6.b1", "mb", at="554.5797+(-139.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838782.0, assembly_id=103309.0))
lhcb1.new("mcs.a14r6.b1", "mcs", at="562.0037+(-139-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246701.0, assembly_id=103309.0))
lhcb1.new("mb.b14r6.b1", "mb", at="570.2397+(-138.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838806.0, assembly_id=103310.0))
lhcb1.new("mcs.b14r6.b1", "mcs", at="577.6637+(-138-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246704.0, assembly_id=103310.0))
lhcb1.new("mco.b14r6.b1", "mco", at="578.4137+(-138-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252194.0, assembly_id=103311.0))
lhcb1.new("mcd.b14r6.b1", "mcd", at="578.4152+(-138-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252195.0, assembly_id=103311.0))
lhcb1.new("mb.c14r6.b1", "mb", at="585.8997+(-137.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838830.0, assembly_id=103311.0))
lhcb1.new("mcs.c14r6.b1", "mcs", at="593.3237+(-137-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246709.0, assembly_id=103311.0))
lhcb1.new("bpm.14r6.b1", "bpm", at="594.2027+(-137-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246711.0, assembly_id=103312.0))
lhcb1.new("mqt.14r6.b1", "mqt", at="594.9567+(-137-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307533.0, assembly_id=103312.0))
lhcb1.new("mq.14r6.b1", "mq", at="596.9647+(-137-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2348489.0, assembly_id=103312.0))
lhcb1.new("ms.14r6.b1", "ms", at="598.8597+(-137-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252198.0, assembly_id=103312.0))
lhcb1.new("mcbh.14r6.b1", "mcbh", at="599.4527+(-137-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252200.0, assembly_id=103312.0))
lhcb1.new("mb.a15r6.b1", "mb", at="608.0297+(-136.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838854.0, assembly_id=103313.0))
lhcb1.new("mcs.a15r6.b1", "mcs", at="615.4537+(-136-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246717.0, assembly_id=103313.0))
lhcb1.new("mco.15r6.b1", "mco", at="616.2037+(-136-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252202.0, assembly_id=103314.0))
lhcb1.new("mcd.15r6.b1", "mcd", at="616.2052+(-136-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252203.0, assembly_id=103314.0))
lhcb1.new("mb.b15r6.b1", "mb", at="623.6897+(-135.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838878.0, assembly_id=103314.0))
lhcb1.new("mcs.b15r6.b1", "mcs", at="631.1137+(-135-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246722.0, assembly_id=103314.0))
lhcb1.new("mb.c15r6.b1", "mb", at="639.3497+(-134.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838902.0, assembly_id=103315.0))
lhcb1.new("mcs.c15r6.b1", "mcs", at="646.7737+(-134-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246725.0, assembly_id=103315.0))
lhcb1.new("bpm.15r6.b1", "bpm", at="647.6527+(-134-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=266530.0, assembly_id=103316.0))
lhcb1.new("mqt.15r6.b1", "mqt", at="648.4067+(-134-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307565.0, assembly_id=103316.0))
lhcb1.new("mq.15r6.b1", "mq", at="650.4147+(-134-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308557.0, assembly_id=103316.0))
lhcb1.new("ms.15r6.b1", "ms", at="652.3097+(-134-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252206.0, assembly_id=103316.0))
lhcb1.new("mcbv.15r6.b1", "mcbv", at="652.9027+(-134-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252208.0, assembly_id=103316.0))
lhcb1.new("mco.a16r6.b1", "mco", at="653.9937+(-134-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252210.0, assembly_id=103317.0))
lhcb1.new("mcd.a16r6.b1", "mcd", at="653.9952+(-134-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252211.0, assembly_id=103317.0))
lhcb1.new("mb.a16r6.b1", "mb", at="661.4797+(-133.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838926.0, assembly_id=103317.0))
lhcb1.new("mcs.a16r6.b1", "mcs", at="668.9037+(-133-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246733.0, assembly_id=103317.0))
lhcb1.new("mb.b16r6.b1", "mb", at="677.1397+(-132.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838950.0, assembly_id=103318.0))
lhcb1.new("mcs.b16r6.b1", "mcs", at="684.5637+(-132-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246736.0, assembly_id=103318.0))
lhcb1.new("mco.b16r6.b1", "mco", at="685.3137+(-132-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252214.0, assembly_id=103319.0))
lhcb1.new("mcd.b16r6.b1", "mcd", at="685.3152+(-132-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252215.0, assembly_id=103319.0))
lhcb1.new("mb.c16r6.b1", "mb", at="692.7997+(-131.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838974.0, assembly_id=103319.0))
lhcb1.new("mcs.c16r6.b1", "mcs", at="700.2237+(-131-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246741.0, assembly_id=103319.0))
lhcb1.new("bpm.16r6.b1", "bpm", at="701.1027+(-131-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246743.0, assembly_id=103320.0))
lhcb1.new("mqt.16r6.b1", "mqt", at="701.8567+(-131-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307595.0, assembly_id=103320.0))
lhcb1.new("mq.16r6.b1", "mq", at="703.8647+(-131-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308350.0, assembly_id=103320.0))
lhcb1.new("ms.16r6.b1", "ms", at="705.7597+(-131-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252218.0, assembly_id=103320.0))
lhcb1.new("mcbh.16r6.b1", "mcbh", at="706.3527+(-131-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252220.0, assembly_id=103320.0))
lhcb1.new("mb.a17r6.b1", "mb", at="714.9297+(-130.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52838998.0, assembly_id=103321.0))
lhcb1.new("mcs.a17r6.b1", "mcs", at="722.3537+(-130-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246749.0, assembly_id=103321.0))
lhcb1.new("mco.17r6.b1", "mco", at="723.1037+(-130-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252222.0, assembly_id=103322.0))
lhcb1.new("mcd.17r6.b1", "mcd", at="723.1052+(-130-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252223.0, assembly_id=103322.0))
lhcb1.new("mb.b17r6.b1", "mb", at="730.5897+(-129.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839022.0, assembly_id=103322.0))
lhcb1.new("mcs.b17r6.b1", "mcs", at="738.0137+(-129-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246754.0, assembly_id=103322.0))
lhcb1.new("mb.c17r6.b1", "mb", at="746.2497+(-128.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839046.0, assembly_id=103323.0))
lhcb1.new("mcs.c17r6.b1", "mcs", at="753.6737+(-128-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246757.0, assembly_id=103323.0))
lhcb1.new("bpm.17r6.b1", "bpm", at="754.5527+(-128-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246759.0, assembly_id=103324.0))
lhcb1.new("mqt.17r6.b1", "mqt", at="755.3067+(-128-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307389.0, assembly_id=103324.0))
lhcb1.new("mq.17r6.b1", "mq", at="757.3147+(-128-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2348482.0, assembly_id=103324.0))
lhcb1.new("ms.17r6.b1", "ms", at="759.2097+(-128-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252226.0, assembly_id=103324.0))
lhcb1.new("mcbv.17r6.b1", "mcbv", at="759.8027+(-128-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252228.0, assembly_id=103324.0))
lhcb1.new("mco.a18r6.b1", "mco", at="760.8937+(-128-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252230.0, assembly_id=103325.0))
lhcb1.new("mcd.a18r6.b1", "mcd", at="760.8952+(-128-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252231.0, assembly_id=103325.0))
lhcb1.new("mb.a18r6.b1", "mb", at="768.3797+(-127.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839070.0, assembly_id=103325.0))
lhcb1.new("mcs.a18r6.b1", "mcs", at="775.8037+(-127-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246767.0, assembly_id=103325.0))
lhcb1.new("mb.b18r6.b1", "mb", at="784.0397+(-126.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839094.0, assembly_id=103326.0))
lhcb1.new("mcs.b18r6.b1", "mcs", at="791.4637+(-126-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246770.0, assembly_id=103326.0))
lhcb1.new("mco.b18r6.b1", "mco", at="792.2137+(-126-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252234.0, assembly_id=103327.0))
lhcb1.new("mcd.b18r6.b1", "mcd", at="792.2152+(-126-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252235.0, assembly_id=103327.0))
lhcb1.new("mb.c18r6.b1", "mb", at="799.6997+(-125.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839118.0, assembly_id=103327.0))
lhcb1.new("mcs.c18r6.b1", "mcs", at="807.1237+(-125-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246775.0, assembly_id=103327.0))
lhcb1.new("bpm.18r6.b1", "bpm", at="808.0027+(-125-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246777.0, assembly_id=103328.0))
lhcb1.new("mqt.18r6.b1", "mqt", at="808.7567+(-125-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307421.0, assembly_id=103328.0))
lhcb1.new("mq.18r6.b1", "mq", at="810.7647+(-125-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308410.0, assembly_id=103328.0))
lhcb1.new("ms.18r6.b1", "ms", at="812.6597+(-125-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252238.0, assembly_id=103328.0))
lhcb1.new("mcbh.18r6.b1", "mcbh", at="813.2527+(-125-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252240.0, assembly_id=103328.0))
lhcb1.new("mb.a19r6.b1", "mb", at="821.8297+(-124.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839142.0, assembly_id=103329.0))
lhcb1.new("mcs.a19r6.b1", "mcs", at="829.2537+(-124-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246783.0, assembly_id=103329.0))
lhcb1.new("mco.19r6.b1", "mco", at="830.0037+(-124-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252242.0, assembly_id=103330.0))
lhcb1.new("mcd.19r6.b1", "mcd", at="830.0052+(-124-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252243.0, assembly_id=103330.0))
lhcb1.new("mb.b19r6.b1", "mb", at="837.4897+(-123.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839166.0, assembly_id=103330.0))
lhcb1.new("mcs.b19r6.b1", "mcs", at="844.9137+(-123-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246788.0, assembly_id=103330.0))
lhcb1.new("mb.c19r6.b1", "mb", at="853.1497+(-122.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839190.0, assembly_id=103331.0))
lhcb1.new("mcs.c19r6.b1", "mcs", at="860.5737+(-122-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246791.0, assembly_id=103331.0))
lhcb1.new("bpm.19r6.b1", "bpm", at="861.4527+(-122-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=266532.0, assembly_id=103332.0))
lhcb1.new("mqt.19r6.b1", "mqt", at="862.2067+(-122-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307451.0, assembly_id=103332.0))
lhcb1.new("mq.19r6.b1", "mq", at="864.2147+(-122-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308442.0, assembly_id=103332.0))
lhcb1.new("ms.19r6.b1", "ms", at="866.1097+(-122-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252246.0, assembly_id=103332.0))
lhcb1.new("mcbv.19r6.b1", "mcbv", at="866.7027+(-122-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252248.0, assembly_id=103332.0))
lhcb1.new("mco.a20r6.b1", "mco", at="867.7937+(-122-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252250.0, assembly_id=103333.0))
lhcb1.new("mcd.a20r6.b1", "mcd", at="867.7952+(-122-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252251.0, assembly_id=103333.0))
lhcb1.new("mb.a20r6.b1", "mb", at="875.2797+(-121.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839214.0, assembly_id=103333.0))
lhcb1.new("mcs.a20r6.b1", "mcs", at="882.7037+(-121-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246799.0, assembly_id=103333.0))
lhcb1.new("mb.b20r6.b1", "mb", at="890.9397+(-120.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839238.0, assembly_id=103334.0))
lhcb1.new("mcs.b20r6.b1", "mcs", at="898.3637+(-120-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246802.0, assembly_id=103334.0))
lhcb1.new("mco.b20r6.b1", "mco", at="899.1137+(-120-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252254.0, assembly_id=103335.0))
lhcb1.new("mcd.b20r6.b1", "mcd", at="899.1152+(-120-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252255.0, assembly_id=103335.0))
lhcb1.new("mb.c20r6.b1", "mb", at="906.5997+(-119.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839262.0, assembly_id=103335.0))
lhcb1.new("mcs.c20r6.b1", "mcs", at="914.0237+(-119-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246807.0, assembly_id=103335.0))
lhcb1.new("bpm.20r6.b1", "bpm", at="914.9027+(-119-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246809.0, assembly_id=103336.0))
lhcb1.new("mqt.20r6.b1", "mqt", at="915.6567+(-119-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307481.0, assembly_id=103336.0))
lhcb1.new("mq.20r6.b1", "mq", at="917.6647+(-119-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308232.0, assembly_id=103336.0))
lhcb1.new("ms.20r6.b1", "ms", at="919.5597+(-119-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252258.0, assembly_id=103336.0))
lhcb1.new("mcbh.20r6.b1", "mcbh", at="920.1527+(-119-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252260.0, assembly_id=103336.0))
lhcb1.new("mb.a21r6.b1", "mb", at="928.7297+(-118.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839286.0, assembly_id=103337.0))
lhcb1.new("mcs.a21r6.b1", "mcs", at="936.1537+(-118-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246815.0, assembly_id=103337.0))
lhcb1.new("mco.21r6.b1", "mco", at="936.9037+(-118-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252262.0, assembly_id=103338.0))
lhcb1.new("mcd.21r6.b1", "mcd", at="936.9052+(-118-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252263.0, assembly_id=103338.0))
lhcb1.new("mb.b21r6.b1", "mb", at="944.3897+(-117.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839310.0, assembly_id=103338.0))
lhcb1.new("mcs.b21r6.b1", "mcs", at="951.8137+(-117-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246820.0, assembly_id=103338.0))
lhcb1.new("mb.c21r6.b1", "mb", at="960.0497+(-116.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839334.0, assembly_id=103339.0))
lhcb1.new("mcs.c21r6.b1", "mcs", at="967.4737+(-116-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246823.0, assembly_id=103339.0))
lhcb1.new("bpm.21r6.b1", "bpm", at="968.3527+(-116-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246825.0, assembly_id=103340.0))
lhcb1.new("mqt.21r6.b1", "mqt", at="969.1067+(-116-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307279.0, assembly_id=103340.0))
lhcb1.new("mq.21r6.b1", "mq", at="971.1147+(-116-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308263.0, assembly_id=103340.0))
lhcb1.new("ms.21r6.b1", "ms", at="973.0097+(-116-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252266.0, assembly_id=103340.0))
lhcb1.new("mcbv.21r6.b1", "mcbv", at="973.6027+(-116-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252268.0, assembly_id=103340.0))
lhcb1.new("mco.a22r6.b1", "mco", at="974.6937+(-116-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252270.0, assembly_id=103341.0))
lhcb1.new("mcd.a22r6.b1", "mcd", at="974.6952+(-116-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252271.0, assembly_id=103341.0))
lhcb1.new("mb.a22r6.b1", "mb", at="982.1797+(-115.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839358.0, assembly_id=103341.0))
lhcb1.new("mcs.a22r6.b1", "mcs", at="989.6037+(-115-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246833.0, assembly_id=103341.0))
lhcb1.new("mb.b22r6.b1", "mb", at="997.8397+(-114.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839382.0, assembly_id=103342.0))
lhcb1.new("mcs.b22r6.b1", "mcs", at="1005.2637+(-114-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246836.0, assembly_id=103342.0))
lhcb1.new("mco.b22r6.b1", "mco", at="1006.0137+(-114-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252274.0, assembly_id=103343.0))
lhcb1.new("mcd.b22r6.b1", "mcd", at="1006.0152+(-114-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252275.0, assembly_id=103343.0))
lhcb1.new("mb.c22r6.b1", "mb", at="1013.4997+(-113.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839406.0, assembly_id=103343.0))
lhcb1.new("mcs.c22r6.b1", "mcs", at="1020.9237+(-113-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246841.0, assembly_id=103343.0))
lhcb1.new("bpm.22r6.b1", "bpm", at="1021.8027+(-113-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246843.0, assembly_id=103344.0))
lhcb1.new("mo.22r6.b1", "mo", at="1022.5537+(-113-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308823.0, assembly_id=103344.0))
lhcb1.new("mq.22r6.b1", "mq", at="1024.5647+(-113-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308295.0, assembly_id=103344.0))
lhcb1.new("ms.22r6.b1", "ms", at="1026.4597+(-113-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252278.0, assembly_id=103344.0))
lhcb1.new("mcbh.22r6.b1", "mcbh", at="1027.0527+(-113-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252280.0, assembly_id=103344.0))
lhcb1.new("mb.a23r6.b1", "mb", at="1035.6297+(-112.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839430.0, assembly_id=103345.0))
lhcb1.new("mcs.a23r6.b1", "mcs", at="1043.0537+(-112-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246849.0, assembly_id=103345.0))
lhcb1.new("mco.23r6.b1", "mco", at="1043.8037+(-112-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252282.0, assembly_id=103346.0))
lhcb1.new("mcd.23r6.b1", "mcd", at="1043.8052+(-112-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252283.0, assembly_id=103346.0))
lhcb1.new("mb.b23r6.b1", "mb", at="1051.2897+(-111.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839454.0, assembly_id=103346.0))
lhcb1.new("mcs.b23r6.b1", "mcs", at="1058.7137+(-111-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246854.0, assembly_id=103346.0))
lhcb1.new("mb.c23r6.b1", "mb", at="1066.9497+(-110.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839478.0, assembly_id=103347.0))
lhcb1.new("mcs.c23r6.b1", "mcs", at="1074.3737+(-110-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246857.0, assembly_id=103347.0))
lhcb1.new("bpm.23r6.b1", "bpm", at="1075.2527+(-110-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246859.0, assembly_id=103348.0))
lhcb1.new("mqs.23r6.b1", "mqs", at="1076.0067+(-110-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307645.0, assembly_id=103348.0))
lhcb1.new("mq.23r6.b1", "mq", at="1078.0147+(-110-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2348478.0, assembly_id=103348.0))
lhcb1.new("ms.23r6.b1", "ms", at="1079.9097+(-110-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252286.0, assembly_id=103348.0))
lhcb1.new("mcbv.23r6.b1", "mcbv", at="1080.5027+(-110-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252288.0, assembly_id=103348.0))
lhcb1.new("mco.a24r6.b1", "mco", at="1081.5937+(-110-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252290.0, assembly_id=103349.0))
lhcb1.new("mcd.a24r6.b1", "mcd", at="1081.5952+(-110-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252291.0, assembly_id=103349.0))
lhcb1.new("mb.a24r6.b1", "mb", at="1089.0797+(-109.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839502.0, assembly_id=103349.0))
lhcb1.new("mcs.a24r6.b1", "mcs", at="1096.5037+(-109-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246867.0, assembly_id=103349.0))
lhcb1.new("mb.b24r6.b1", "mb", at="1104.7397+(-108.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839526.0, assembly_id=103350.0))
lhcb1.new("mcs.b24r6.b1", "mcs", at="1112.1637+(-108-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246870.0, assembly_id=103350.0))
lhcb1.new("mco.b24r6.b1", "mco", at="1112.9137+(-108-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252294.0, assembly_id=103351.0))
lhcb1.new("mcd.b24r6.b1", "mcd", at="1112.9152+(-108-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252295.0, assembly_id=103351.0))
lhcb1.new("mb.c24r6.b1", "mb", at="1120.3997+(-107.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839550.0, assembly_id=103351.0))
lhcb1.new("mcs.c24r6.b1", "mcs", at="1127.8237+(-107-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246875.0, assembly_id=103351.0))
lhcb1.new("bpm.24r6.b1", "bpm", at="1128.7027+(-107-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246877.0, assembly_id=103352.0))
lhcb1.new("mo.24r6.b1", "mo", at="1129.4537+(-107-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308853.0, assembly_id=103352.0))
lhcb1.new("mq.24r6.b1", "mq", at="1131.4647+(-107-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308116.0, assembly_id=103352.0))
lhcb1.new("ms.24r6.b1", "ms", at="1133.3597+(-107-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252298.0, assembly_id=103352.0))
lhcb1.new("mcbh.24r6.b1", "mcbh", at="1133.9527+(-107-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252300.0, assembly_id=103352.0))
lhcb1.new("mb.a25r6.b1", "mb", at="1142.5297+(-106.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839574.0, assembly_id=103353.0))
lhcb1.new("mcs.a25r6.b1", "mcs", at="1149.9537+(-106-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246883.0, assembly_id=103353.0))
lhcb1.new("mco.25r6.b1", "mco", at="1150.7037+(-106-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252302.0, assembly_id=103354.0))
lhcb1.new("mcd.25r6.b1", "mcd", at="1150.7052+(-106-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252303.0, assembly_id=103354.0))
lhcb1.new("mb.b25r6.b1", "mb", at="1158.1897+(-105.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839598.0, assembly_id=103354.0))
lhcb1.new("mcs.b25r6.b1", "mcs", at="1165.6137+(-105-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246888.0, assembly_id=103354.0))
lhcb1.new("mb.c25r6.b1", "mb", at="1173.8497+(-104.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839622.0, assembly_id=103355.0))
lhcb1.new("mcs.c25r6.b1", "mcs", at="1181.2737+(-104-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246891.0, assembly_id=103355.0))
lhcb1.new("bpm.25r6.b1", "bpm", at="1182.1527+(-104-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246893.0, assembly_id=103356.0))
lhcb1.new("mo.25r6.b1", "mo", at="1182.9037+(-104-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308885.0, assembly_id=103356.0))
lhcb1.new("mq.25r6.b1", "mq", at="1184.9147+(-104-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308148.0, assembly_id=103356.0))
lhcb1.new("ms.25r6.b1", "ms", at="1186.8097+(-104-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252306.0, assembly_id=103356.0))
lhcb1.new("mcbv.25r6.b1", "mcbv", at="1187.4027+(-104-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252308.0, assembly_id=103356.0))
lhcb1.new("mco.a26r6.b1", "mco", at="1188.4937+(-104-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252310.0, assembly_id=103357.0))
lhcb1.new("mcd.a26r6.b1", "mcd", at="1188.4952+(-104-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252311.0, assembly_id=103357.0))
lhcb1.new("mb.a26r6.b1", "mb", at="1195.9797+(-103.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839646.0, assembly_id=103357.0))
lhcb1.new("mcs.a26r6.b1", "mcs", at="1203.4037+(-103-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246901.0, assembly_id=103357.0))
lhcb1.new("mb.b26r6.b1", "mb", at="1211.6397+(-102.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839670.0, assembly_id=103358.0))
lhcb1.new("mcs.b26r6.b1", "mcs", at="1219.0637+(-102-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246904.0, assembly_id=103358.0))
lhcb1.new("mco.b26r6.b1", "mco", at="1219.8137+(-102-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252314.0, assembly_id=103359.0))
lhcb1.new("mcd.b26r6.b1", "mcd", at="1219.8152+(-102-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252315.0, assembly_id=103359.0))
lhcb1.new("mb.c26r6.b1", "mb", at="1227.2997+(-101.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839694.0, assembly_id=103359.0))
lhcb1.new("mcs.c26r6.b1", "mcs", at="1234.7237+(-101-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246909.0, assembly_id=103359.0))
lhcb1.new("bpm.26r6.b1", "bpm", at="1235.6027+(-101-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246911.0, assembly_id=103360.0))
lhcb1.new("mo.26r6.b1", "mo", at="1236.3537+(-101-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308916.0, assembly_id=103360.0))
lhcb1.new("mq.26r6.b1", "mq", at="1238.3647+(-101-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308178.0, assembly_id=103360.0))
lhcb1.new("ms.26r6.b1", "ms", at="1240.2597+(-101-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252318.0, assembly_id=103360.0))
lhcb1.new("mcbh.26r6.b1", "mcbh", at="1240.8527+(-101-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252320.0, assembly_id=103360.0))
lhcb1.new("mb.a27r6.b1", "mb", at="1249.4297+(-100.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839718.0, assembly_id=103361.0))
lhcb1.new("mcs.a27r6.b1", "mcs", at="1256.8537+(-100-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246917.0, assembly_id=103361.0))
lhcb1.new("mco.27r6.b1", "mco", at="1257.6037+(-100-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252322.0, assembly_id=103362.0))
lhcb1.new("mcd.27r6.b1", "mcd", at="1257.6052+(-100-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252323.0, assembly_id=103362.0))
lhcb1.new("mb.b27r6.b1", "mb", at="1265.0897+(-99.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839742.0, assembly_id=103362.0))
lhcb1.new("mcs.b27r6.b1", "mcs", at="1272.5137+(-99-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246922.0, assembly_id=103362.0))
lhcb1.new("mb.c27r6.b1", "mb", at="1280.7497+(-98.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839766.0, assembly_id=103363.0))
lhcb1.new("mcs.c27r6.b1", "mcs", at="1288.1737+(-98-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246925.0, assembly_id=103363.0))
lhcb1.new("bpm.27r6.b1", "bpm", at="1289.0527+(-98-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246927.0, assembly_id=103364.0))
lhcb1.new("mqs.27r6.b1", "mqs", at="1289.8067+(-98-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307677.0, assembly_id=103364.0))
lhcb1.new("mq.27r6.b1", "mq", at="1291.8147+(-98-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307968.0, assembly_id=103364.0))
lhcb1.new("ms.27r6.b1", "ms", at="1293.7097+(-98-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252326.0, assembly_id=103364.0))
lhcb1.new("mcbv.27r6.b1", "mcbv", at="1294.3027+(-98-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252328.0, assembly_id=103364.0))
lhcb1.new("mco.a28r6.b1", "mco", at="1295.3937+(-98-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252330.0, assembly_id=103365.0))
lhcb1.new("mcd.a28r6.b1", "mcd", at="1295.3952+(-98-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252331.0, assembly_id=103365.0))
lhcb1.new("mb.a28r6.b1", "mb", at="1302.8797+(-97.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839790.0, assembly_id=103365.0))
lhcb1.new("mcs.a28r6.b1", "mcs", at="1310.3037+(-97-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246935.0, assembly_id=103365.0))
lhcb1.new("mb.b28r6.b1", "mb", at="1318.5397+(-96.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839814.0, assembly_id=103366.0))
lhcb1.new("mcs.b28r6.b1", "mcs", at="1325.9637+(-96-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246938.0, assembly_id=103366.0))
lhcb1.new("mco.b28r6.b1", "mco", at="1326.7137+(-96-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252334.0, assembly_id=103367.0))
lhcb1.new("mcd.b28r6.b1", "mcd", at="1326.7152+(-96-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252335.0, assembly_id=103367.0))
lhcb1.new("mb.c28r6.b1", "mb", at="1334.1997+(-95.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839838.0, assembly_id=103367.0))
lhcb1.new("mcs.c28r6.b1", "mcs", at="1341.6237+(-95-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246943.0, assembly_id=103367.0))
lhcb1.new("bpm.28r6.b1", "bpm", at="1342.5027+(-95-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246945.0, assembly_id=103368.0))
lhcb1.new("mo.28r6.b1", "mo", at="1343.2537+(-95-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308706.0, assembly_id=103368.0))
lhcb1.new("mq.28r6.b1", "mq", at="1345.2647+(-95-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308000.0, assembly_id=103368.0))
lhcb1.new("ms.28r6.b1", "ms", at="1347.1597+(-95-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252338.0, assembly_id=103368.0))
lhcb1.new("mcbh.28r6.b1", "mcbh", at="1347.7527+(-95-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252340.0, assembly_id=103368.0))
lhcb1.new("mb.a29r6.b1", "mb", at="1356.3297+(-94.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839862.0, assembly_id=103369.0))
lhcb1.new("mcs.a29r6.b1", "mcs", at="1363.7537+(-94-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246951.0, assembly_id=103369.0))
lhcb1.new("mco.29r6.b1", "mco", at="1364.5037+(-94-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252342.0, assembly_id=103370.0))
lhcb1.new("mcd.29r6.b1", "mcd", at="1364.5052+(-94-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252343.0, assembly_id=103370.0))
lhcb1.new("mb.b29r6.b1", "mb", at="1371.9897+(-93.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839886.0, assembly_id=103370.0))
lhcb1.new("mcs.b29r6.b1", "mcs", at="1379.4137+(-93-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246956.0, assembly_id=103370.0))
lhcb1.new("mb.c29r6.b1", "mb", at="1387.6497+(-92.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839910.0, assembly_id=103371.0))
lhcb1.new("mcs.c29r6.b1", "mcs", at="1395.0737+(-92-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246959.0, assembly_id=103371.0))
lhcb1.new("bpm.29r6.b1", "bpm", at="1395.9527+(-92-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246961.0, assembly_id=103372.0))
lhcb1.new("mo.29r6.b1", "mo", at="1396.7037+(-92-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308738.0, assembly_id=103372.0))
lhcb1.new("mq.29r6.b1", "mq", at="1398.7147+(-92-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2348465.0, assembly_id=103372.0))
lhcb1.new("ms.29r6.b1", "ms", at="1400.6097+(-92-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252346.0, assembly_id=103372.0))
lhcb1.new("mcbv.29r6.b1", "mcbv", at="1401.2027+(-92-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252348.0, assembly_id=103372.0))
lhcb1.new("mco.a30r6.b1", "mco", at="1402.2937+(-92-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252350.0, assembly_id=103373.0))
lhcb1.new("mcd.a30r6.b1", "mcd", at="1402.2952+(-92-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252351.0, assembly_id=103373.0))
lhcb1.new("mb.a30r6.b1", "mb", at="1409.7797+(-91.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839934.0, assembly_id=103373.0))
lhcb1.new("mcs.a30r6.b1", "mcs", at="1417.2037+(-91-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246969.0, assembly_id=103373.0))
lhcb1.new("mb.b30r6.b1", "mb", at="1425.4397+(-90.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839958.0, assembly_id=103374.0))
lhcb1.new("mcs.b30r6.b1", "mcs", at="1432.8637+(-90-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246972.0, assembly_id=103374.0))
lhcb1.new("mco.b30r6.b1", "mco", at="1433.6137+(-90-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252354.0, assembly_id=103375.0))
lhcb1.new("mcd.b30r6.b1", "mcd", at="1433.6152+(-90-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252355.0, assembly_id=103375.0))
lhcb1.new("mb.c30r6.b1", "mb", at="1441.0997+(-89.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52839982.0, assembly_id=103375.0))
lhcb1.new("mcs.c30r6.b1", "mcs", at="1448.5237+(-89-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246977.0, assembly_id=103375.0))
lhcb1.new("bpm.30r6.b1", "bpm", at="1449.4027+(-89-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246979.0, assembly_id=103376.0))
lhcb1.new("mo.30r6.b1", "mo", at="1450.1537+(-89-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308769.0, assembly_id=103376.0))
lhcb1.new("mq.30r6.b1", "mq", at="1452.1647+(-89-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308060.0, assembly_id=103376.0))
lhcb1.new("mss.30r6.b1", "mss", at="1454.0597+(-89-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252358.0, assembly_id=103376.0))
lhcb1.new("mcbh.30r6.b1", "mcbh", at="1454.6527+(-89-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252360.0, assembly_id=103376.0))
lhcb1.new("mb.a31r6.b1", "mb", at="1463.2297+(-88.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840006.0, assembly_id=103377.0))
lhcb1.new("mcs.a31r6.b1", "mcs", at="1470.6537+(-88-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246985.0, assembly_id=103377.0))
lhcb1.new("mco.31r6.b1", "mco", at="1471.4037+(-88-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252362.0, assembly_id=103378.0))
lhcb1.new("mcd.31r6.b1", "mcd", at="1471.4052+(-88-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252363.0, assembly_id=103378.0))
lhcb1.new("mb.b31r6.b1", "mb", at="1478.8897+(-87.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840030.0, assembly_id=103378.0))
lhcb1.new("mcs.b31r6.b1", "mcs", at="1486.3137+(-87-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246990.0, assembly_id=103378.0))
lhcb1.new("mb.c31r6.b1", "mb", at="1494.5497+(-86.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840054.0, assembly_id=103379.0))
lhcb1.new("mcs.c31r6.b1", "mcs", at="1501.9737+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246993.0, assembly_id=103379.0))
lhcb1.new("bpm.31r6.b1", "bpm", at="1502.8527+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=246995.0, assembly_id=103380.0))
lhcb1.new("mo.31r6.b1", "mo", at="1503.6037+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2348501.0, assembly_id=103380.0))
lhcb1.new("mq.31r6.b1", "mq", at="1505.6147+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307852.0, assembly_id=103380.0))
lhcb1.new("ms.31r6.b1", "ms", at="1507.5097+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252366.0, assembly_id=103380.0))
lhcb1.new("mcbv.31r6.b1", "mcbv", at="1508.1027+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252368.0, assembly_id=103380.0))
lhcb1.new("s.cell.67.b1", "omk", at="1508.8497+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a32r6.b1", "mco", at="1509.1937+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252370.0, assembly_id=103381.0))
lhcb1.new("mcd.a32r6.b1", "mcd", at="1509.1952+(-86-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252371.0, assembly_id=103381.0))
lhcb1.new("mb.a32r6.b1", "mb", at="1516.6797+(-85.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840078.0, assembly_id=103381.0))
lhcb1.new("mcs.a32r6.b1", "mcs", at="1524.1037+(-85-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247003.0, assembly_id=103381.0))
lhcb1.new("mb.b32r6.b1", "mb", at="1532.3397+(-84.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840102.0, assembly_id=103382.0))
lhcb1.new("mcs.b32r6.b1", "mcs", at="1539.7637+(-84-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247006.0, assembly_id=103382.0))
lhcb1.new("mco.b32r6.b1", "mco", at="1540.5137+(-84-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252374.0, assembly_id=103383.0))
lhcb1.new("mcd.b32r6.b1", "mcd", at="1540.5152+(-84-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252375.0, assembly_id=103383.0))
lhcb1.new("mb.c32r6.b1", "mb", at="1547.9997+(-83.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840126.0, assembly_id=103383.0))
lhcb1.new("mcs.c32r6.b1", "mcs", at="1555.4237+(-83-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247011.0, assembly_id=103383.0))
lhcb1.new("bpm.32r6.b1", "bpm", at="1556.3027+(-83-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247013.0, assembly_id=103384.0))
lhcb1.new("mo.32r6.b1", "mo", at="1557.0537+(-83-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308591.0, assembly_id=103384.0))
lhcb1.new("mq.32r6.b1", "mq", at="1559.0647+(-83-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307882.0, assembly_id=103384.0))
lhcb1.new("ms.32r6.b1", "ms", at="1560.9597+(-83-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252378.0, assembly_id=103384.0))
lhcb1.new("mcbh.32r6.b1", "mcbh", at="1561.5527+(-83-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252380.0, assembly_id=103384.0))
lhcb1.new("mb.a33r6.b1", "mb", at="1570.1297+(-82.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840150.0, assembly_id=103385.0))
lhcb1.new("mcs.a33r6.b1", "mcs", at="1577.5537+(-82-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247019.0, assembly_id=103385.0))
lhcb1.new("mco.33r6.b1", "mco", at="1578.3037+(-82-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252382.0, assembly_id=103386.0))
lhcb1.new("mcd.33r6.b1", "mcd", at="1578.3052+(-82-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252383.0, assembly_id=103386.0))
lhcb1.new("mb.b33r6.b1", "mb", at="1585.7897+(-81.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840174.0, assembly_id=103386.0))
lhcb1.new("mcs.b33r6.b1", "mcs", at="1593.2137+(-81-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247024.0, assembly_id=103386.0))
lhcb1.new("mb.c33r6.b1", "mb", at="1601.4497+(-80.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840198.0, assembly_id=103387.0))
lhcb1.new("mcs.c33r6.b1", "mcs", at="1608.8737+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247027.0, assembly_id=103387.0))
lhcb1.new("bpm.33r6.b1", "bpm", at="1609.7527+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247029.0, assembly_id=103388.0))
lhcb1.new("mo.33r6.b1", "mo", at="1610.5037+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2308622.0, assembly_id=103388.0))
lhcb1.new("mq.33r6.b1", "mq", at="1612.5147+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307912.0, assembly_id=103388.0))
lhcb1.new("ms.33r6.b1", "ms", at="1614.4097+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252386.0, assembly_id=103388.0))
lhcb1.new("mcbv.33r6.b1", "mcbv", at="1615.0027+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252388.0, assembly_id=103388.0))
lhcb1.new("e.cell.67.b1", "omk", at="1615.7497+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a34r6.b1", "mco", at="1616.0937+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252390.0, assembly_id=103389.0))
lhcb1.new("mcd.a34r6.b1", "mcd", at="1616.0952+(-80-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252391.0, assembly_id=103389.0))
lhcb1.new("mb.a34r6.b1", "mb", at="1623.5797+(-79.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840222.0, assembly_id=103389.0))
lhcb1.new("mcs.a34r6.b1", "mcs", at="1631.0037+(-79-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247037.0, assembly_id=103389.0))
lhcb1.new("mb.b34r6.b1", "mb", at="1639.2397+(-78.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840246.0, assembly_id=103390.0))
lhcb1.new("mcs.b34r6.b1", "mcs", at="1646.6637+(-78-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247040.0, assembly_id=103390.0))
lhcb1.new("mco.b34r6.b1", "mco", at="1647.4137+(-78-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252394.0, assembly_id=103391.0))
lhcb1.new("mcd.b34r6.b1", "mcd", at="1647.4152+(-78-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=252395.0, assembly_id=103391.0))
lhcb1.new("mb.c34r6.b1", "mb", at="1654.8997+(-77.5-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=52840270.0, assembly_id=103391.0))
lhcb1.new("mcs.c34r6.b1", "mcs", at="1662.3237+(-77-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247045.0, assembly_id=103391.0))
lhcb1.new("bpm.34r6.b1", "bpm", at="1663.2027+(-77-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=247047.0, assembly_id=103392.0))
lhcb1.new("mo.34r6.b1", "mo", at="1663.9537+(-77-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2348493.0, assembly_id=103392.0))
lhcb1.new("mq.34r6.b1", "mq", at="1665.9647+(-77-ip6ofs.b1)*ds", from_="ip6", extra=dict(mech_sep=0.194, slot_id=2307927.0, assembly_id=103392.0))
lhcb1.new("mss.34l7.b1", "mss", at="-1664.5007+(-77-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252398.0, assembly_id=103392.0))
lhcb1.new("mcbh.34l7.b1", "mcbh", at="-1663.9077+(-77-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252400.0, assembly_id=103392.0))
lhcb1.new("mb.c34l7.b1", "mb", at="-1655.3307+(-76.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840294.0, assembly_id=103393.0))
lhcb1.new("mcs.c34l7.b1", "mcs", at="-1647.9067+(-76-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247053.0, assembly_id=103393.0))
lhcb1.new("mco.34l7.b1", "mco", at="-1647.1567+(-76-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252402.0, assembly_id=103394.0))
lhcb1.new("mcd.34l7.b1", "mcd", at="-1647.1552+(-76-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252403.0, assembly_id=103394.0))
lhcb1.new("mb.b34l7.b1", "mb", at="-1639.6707+(-75.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840318.0, assembly_id=103394.0))
lhcb1.new("mcs.b34l7.b1", "mcs", at="-1632.2467+(-75-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247058.0, assembly_id=103394.0))
lhcb1.new("mb.a34l7.b1", "mb", at="-1624.0107+(-74.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840342.0, assembly_id=103395.0))
lhcb1.new("mcs.a34l7.b1", "mcs", at="-1616.5867+(-74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247061.0, assembly_id=103395.0))
lhcb1.new("bpm.33l7.b1", "bpm", at="-1615.7077+(-74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247063.0, assembly_id=103396.0))
lhcb1.new("mo.33l7.b1", "mo", at="-1614.9567+(-74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308609.0, assembly_id=103396.0))
lhcb1.new("mq.33l7.b1", "mq", at="-1612.9457+(-74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307899.0, assembly_id=103396.0))
lhcb1.new("ms.33l7.b1", "ms", at="-1611.0507+(-74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252406.0, assembly_id=103396.0))
lhcb1.new("mcbv.33l7.b1", "mcbv", at="-1610.4577+(-74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252408.0, assembly_id=103396.0))
lhcb1.new("mco.b33l7.b1", "mco", at="-1609.3667+(-74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252410.0, assembly_id=103397.0))
lhcb1.new("mcd.b33l7.b1", "mcd", at="-1609.3652+(-74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252411.0, assembly_id=103397.0))
lhcb1.new("mb.c33l7.b1", "mb", at="-1601.8807+(-73.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840366.0, assembly_id=103397.0))
lhcb1.new("mcs.c33l7.b1", "mcs", at="-1594.4567+(-73-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247071.0, assembly_id=103397.0))
lhcb1.new("mb.b33l7.b1", "mb", at="-1586.2207+(-72.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840390.0, assembly_id=103398.0))
lhcb1.new("mcs.b33l7.b1", "mcs", at="-1578.7967+(-72-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247074.0, assembly_id=103398.0))
lhcb1.new("mco.a33l7.b1", "mco", at="-1578.0467+(-72-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252414.0, assembly_id=103399.0))
lhcb1.new("mcd.a33l7.b1", "mcd", at="-1578.0452+(-72-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252415.0, assembly_id=103399.0))
lhcb1.new("mb.a33l7.b1", "mb", at="-1570.5607+(-71.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840414.0, assembly_id=103399.0))
lhcb1.new("mcs.a33l7.b1", "mcs", at="-1563.1367+(-71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247079.0, assembly_id=103399.0))
lhcb1.new("bpm.32l7.b1", "bpm", at="-1562.2577+(-71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247081.0, assembly_id=103400.0))
lhcb1.new("mo.32l7.b1", "mo", at="-1561.5067+(-71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308577.0, assembly_id=103400.0))
lhcb1.new("mq.32l7.b1", "mq", at="-1559.4957+(-71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307869.0, assembly_id=103400.0))
lhcb1.new("mss.32l7.b1", "mss", at="-1557.6007+(-71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252418.0, assembly_id=103400.0))
lhcb1.new("mcbh.32l7.b1", "mcbh", at="-1557.0077+(-71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252420.0, assembly_id=103400.0))
lhcb1.new("mb.c32l7.b1", "mb", at="-1548.4307+(-70.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840438.0, assembly_id=103401.0))
lhcb1.new("mcs.c32l7.b1", "mcs", at="-1541.0067+(-70-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247087.0, assembly_id=103401.0))
lhcb1.new("mco.32l7.b1", "mco", at="-1540.2567+(-70-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252422.0, assembly_id=103402.0))
lhcb1.new("mcd.32l7.b1", "mcd", at="-1540.2552+(-70-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252423.0, assembly_id=103402.0))
lhcb1.new("mb.b32l7.b1", "mb", at="-1532.7707+(-69.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840462.0, assembly_id=103402.0))
lhcb1.new("mcs.b32l7.b1", "mcs", at="-1525.3467+(-69-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247092.0, assembly_id=103402.0))
lhcb1.new("mb.a32l7.b1", "mb", at="-1517.1107+(-68.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840486.0, assembly_id=103403.0))
lhcb1.new("mcs.a32l7.b1", "mcs", at="-1509.6867+(-68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247095.0, assembly_id=103403.0))
lhcb1.new("bpm.31l7.b1", "bpm", at="-1508.8077+(-68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247097.0, assembly_id=103404.0))
lhcb1.new("mo.31l7.b1", "mo", at="-1508.0567+(-68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308785.0, assembly_id=103404.0))
lhcb1.new("mq.31l7.b1", "mq", at="-1506.0457+(-68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308077.0, assembly_id=103404.0))
lhcb1.new("ms.31l7.b1", "ms", at="-1504.1507+(-68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252426.0, assembly_id=103404.0))
lhcb1.new("mcbv.31l7.b1", "mcbv", at="-1503.5577+(-68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252428.0, assembly_id=103404.0))
lhcb1.new("mco.b31l7.b1", "mco", at="-1502.4667+(-68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252430.0, assembly_id=103405.0))
lhcb1.new("mcd.b31l7.b1", "mcd", at="-1502.4652+(-68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252431.0, assembly_id=103405.0))
lhcb1.new("mb.c31l7.b1", "mb", at="-1494.9807+(-67.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840510.0, assembly_id=103405.0))
lhcb1.new("mcs.c31l7.b1", "mcs", at="-1487.5567+(-67-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247105.0, assembly_id=103405.0))
lhcb1.new("mb.b31l7.b1", "mb", at="-1479.3207+(-66.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840534.0, assembly_id=103406.0))
lhcb1.new("mcs.b31l7.b1", "mcs", at="-1471.8967+(-66-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247108.0, assembly_id=103406.0))
lhcb1.new("mco.a31l7.b1", "mco", at="-1471.1467+(-66-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252434.0, assembly_id=103407.0))
lhcb1.new("mcd.a31l7.b1", "mcd", at="-1471.1452+(-66-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252435.0, assembly_id=103407.0))
lhcb1.new("mb.a31l7.b1", "mb", at="-1463.6607+(-65.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840558.0, assembly_id=103407.0))
lhcb1.new("mcs.a31l7.b1", "mcs", at="-1456.2367+(-65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247113.0, assembly_id=103407.0))
lhcb1.new("bpm.30l7.b1", "bpm", at="-1455.3577+(-65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247115.0, assembly_id=103408.0))
lhcb1.new("mo.30l7.b1", "mo", at="-1454.6067+(-65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308756.0, assembly_id=103408.0))
lhcb1.new("mq.30l7.b1", "mq", at="-1452.5957+(-65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308047.0, assembly_id=103408.0))
lhcb1.new("ms.30l7.b1", "ms", at="-1450.7007+(-65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252438.0, assembly_id=103408.0))
lhcb1.new("mcbh.30l7.b1", "mcbh", at="-1450.1077+(-65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252440.0, assembly_id=103408.0))
lhcb1.new("mb.c30l7.b1", "mb", at="-1441.5307+(-64.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840582.0, assembly_id=103409.0))
lhcb1.new("mcs.c30l7.b1", "mcs", at="-1434.1067+(-64-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247121.0, assembly_id=103409.0))
lhcb1.new("mco.30l7.b1", "mco", at="-1433.3567+(-64-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252442.0, assembly_id=103410.0))
lhcb1.new("mcd.30l7.b1", "mcd", at="-1433.3552+(-64-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252443.0, assembly_id=103410.0))
lhcb1.new("mb.b30l7.b1", "mb", at="-1425.8707+(-63.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840606.0, assembly_id=103410.0))
lhcb1.new("mcs.b30l7.b1", "mcs", at="-1418.4467+(-63-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247126.0, assembly_id=103410.0))
lhcb1.new("mb.a30l7.b1", "mb", at="-1410.2107+(-62.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840630.0, assembly_id=103411.0))
lhcb1.new("mcs.a30l7.b1", "mcs", at="-1402.7867+(-62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247129.0, assembly_id=103411.0))
lhcb1.new("bpm.29l7.b1", "bpm", at="-1401.9077+(-62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247131.0, assembly_id=103412.0))
lhcb1.new("mo.29l7.b1", "mo", at="-1401.1567+(-62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308724.0, assembly_id=103412.0))
lhcb1.new("mq.29l7.b1", "mq", at="-1399.1457+(-62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2348464.0, assembly_id=103412.0))
lhcb1.new("ms.29l7.b1", "ms", at="-1397.2507+(-62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252446.0, assembly_id=103412.0))
lhcb1.new("mcbv.29l7.b1", "mcbv", at="-1396.6577+(-62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252448.0, assembly_id=103412.0))
lhcb1.new("mco.b29l7.b1", "mco", at="-1395.5667+(-62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252450.0, assembly_id=103413.0))
lhcb1.new("mcd.b29l7.b1", "mcd", at="-1395.5652+(-62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252451.0, assembly_id=103413.0))
lhcb1.new("mb.c29l7.b1", "mb", at="-1388.0807+(-61.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840654.0, assembly_id=103413.0))
lhcb1.new("mcs.c29l7.b1", "mcs", at="-1380.6567+(-61-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247139.0, assembly_id=103413.0))
lhcb1.new("mb.b29l7.b1", "mb", at="-1372.4207+(-60.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840678.0, assembly_id=103414.0))
lhcb1.new("mcs.b29l7.b1", "mcs", at="-1364.9967+(-60-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247142.0, assembly_id=103414.0))
lhcb1.new("mco.a29l7.b1", "mco", at="-1364.2467+(-60-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252454.0, assembly_id=103415.0))
lhcb1.new("mcd.a29l7.b1", "mcd", at="-1364.2452+(-60-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252455.0, assembly_id=103415.0))
lhcb1.new("mb.a29l7.b1", "mb", at="-1356.7607+(-59.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840702.0, assembly_id=103415.0))
lhcb1.new("mcs.a29l7.b1", "mcs", at="-1349.3367+(-59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247147.0, assembly_id=103415.0))
lhcb1.new("bpm.28l7.b1", "bpm", at="-1348.4577+(-59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247149.0, assembly_id=103416.0))
lhcb1.new("mo.28l7.b1", "mo", at="-1347.7067+(-59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308692.0, assembly_id=103416.0))
lhcb1.new("mq.28l7.b1", "mq", at="-1345.6957+(-59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307986.0, assembly_id=103416.0))
lhcb1.new("mss.28l7.b1", "mss", at="-1343.8007+(-59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252458.0, assembly_id=103416.0))
lhcb1.new("mcbh.28l7.b1", "mcbh", at="-1343.2077+(-59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252460.0, assembly_id=103416.0))
lhcb1.new("mb.c28l7.b1", "mb", at="-1334.6307+(-58.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840726.0, assembly_id=103417.0))
lhcb1.new("mcs.c28l7.b1", "mcs", at="-1327.2067+(-58-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247155.0, assembly_id=103417.0))
lhcb1.new("mco.28l7.b1", "mco", at="-1326.4567+(-58-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252462.0, assembly_id=103418.0))
lhcb1.new("mcd.28l7.b1", "mcd", at="-1326.4552+(-58-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252463.0, assembly_id=103418.0))
lhcb1.new("mb.b28l7.b1", "mb", at="-1318.9707+(-57.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840750.0, assembly_id=103418.0))
lhcb1.new("mcs.b28l7.b1", "mcs", at="-1311.5467+(-57-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247160.0, assembly_id=103418.0))
lhcb1.new("mb.a28l7.b1", "mb", at="-1303.3107+(-56.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840774.0, assembly_id=103419.0))
lhcb1.new("mcs.a28l7.b1", "mcs", at="-1295.8867+(-56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247163.0, assembly_id=103419.0))
lhcb1.new("bpm.27l7.b1", "bpm", at="-1295.0077+(-56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247165.0, assembly_id=103420.0))
lhcb1.new("mqs.27l7.b1", "mqs", at="-1294.2537+(-56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307663.0, assembly_id=103420.0))
lhcb1.new("mq.27l7.b1", "mq", at="-1292.2457+(-56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308195.0, assembly_id=103420.0))
lhcb1.new("ms.27l7.b1", "ms", at="-1290.3507+(-56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252466.0, assembly_id=103420.0))
lhcb1.new("mcbv.27l7.b1", "mcbv", at="-1289.7577+(-56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252468.0, assembly_id=103420.0))
lhcb1.new("mco.b27l7.b1", "mco", at="-1288.6667+(-56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252470.0, assembly_id=103421.0))
lhcb1.new("mcd.b27l7.b1", "mcd", at="-1288.6652+(-56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252471.0, assembly_id=103421.0))
lhcb1.new("mb.c27l7.b1", "mb", at="-1281.1807+(-55.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840798.0, assembly_id=103421.0))
lhcb1.new("mcs.c27l7.b1", "mcs", at="-1273.7567+(-55-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247173.0, assembly_id=103421.0))
lhcb1.new("mb.b27l7.b1", "mb", at="-1265.5207+(-54.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840822.0, assembly_id=103422.0))
lhcb1.new("mcs.b27l7.b1", "mcs", at="-1258.0967+(-54-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247176.0, assembly_id=103422.0))
lhcb1.new("mco.a27l7.b1", "mco", at="-1257.3467+(-54-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252474.0, assembly_id=103423.0))
lhcb1.new("mcd.a27l7.b1", "mcd", at="-1257.3452+(-54-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252475.0, assembly_id=103423.0))
lhcb1.new("mb.a27l7.b1", "mb", at="-1249.8607+(-53.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840846.0, assembly_id=103423.0))
lhcb1.new("mcs.a27l7.b1", "mcs", at="-1242.4367+(-53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247181.0, assembly_id=103423.0))
lhcb1.new("bpm.26l7.b1", "bpm", at="-1241.5577+(-53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247183.0, assembly_id=103424.0))
lhcb1.new("mo.26l7.b1", "mo", at="-1240.8067+(-53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308903.0, assembly_id=103424.0))
lhcb1.new("mq.26l7.b1", "mq", at="-1238.7957+(-53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308165.0, assembly_id=103424.0))
lhcb1.new("ms.26l7.b1", "ms", at="-1236.9007+(-53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252478.0, assembly_id=103424.0))
lhcb1.new("mcbh.26l7.b1", "mcbh", at="-1236.3077+(-53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252480.0, assembly_id=103424.0))
lhcb1.new("mb.c26l7.b1", "mb", at="-1227.7307+(-52.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840870.0, assembly_id=103425.0))
lhcb1.new("mcs.c26l7.b1", "mcs", at="-1220.3067+(-52-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247189.0, assembly_id=103425.0))
lhcb1.new("mco.26l7.b1", "mco", at="-1219.5567+(-52-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252482.0, assembly_id=103426.0))
lhcb1.new("mcd.26l7.b1", "mcd", at="-1219.5552+(-52-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252483.0, assembly_id=103426.0))
lhcb1.new("mb.b26l7.b1", "mb", at="-1212.0707+(-51.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840894.0, assembly_id=103426.0))
lhcb1.new("mcs.b26l7.b1", "mcs", at="-1204.6467+(-51-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247194.0, assembly_id=103426.0))
lhcb1.new("mb.a26l7.b1", "mb", at="-1196.4107+(-50.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840918.0, assembly_id=103427.0))
lhcb1.new("mcs.a26l7.b1", "mcs", at="-1188.9867+(-50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247197.0, assembly_id=103427.0))
lhcb1.new("bpm.25l7.b1", "bpm", at="-1188.1077+(-50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247199.0, assembly_id=103428.0))
lhcb1.new("mo.25l7.b1", "mo", at="-1187.3567+(-50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308871.0, assembly_id=103428.0))
lhcb1.new("mq.25l7.b1", "mq", at="-1185.3457+(-50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308134.0, assembly_id=103428.0))
lhcb1.new("ms.25l7.b1", "ms", at="-1183.4507+(-50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252486.0, assembly_id=103428.0))
lhcb1.new("mcbv.25l7.b1", "mcbv", at="-1182.8577+(-50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252488.0, assembly_id=103428.0))
lhcb1.new("mco.b25l7.b1", "mco", at="-1181.7667+(-50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252490.0, assembly_id=103429.0))
lhcb1.new("mcd.b25l7.b1", "mcd", at="-1181.7652+(-50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252491.0, assembly_id=103429.0))
lhcb1.new("mb.c25l7.b1", "mb", at="-1174.2807+(-49.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840942.0, assembly_id=103429.0))
lhcb1.new("mcs.c25l7.b1", "mcs", at="-1166.8567+(-49-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247207.0, assembly_id=103429.0))
lhcb1.new("mb.b25l7.b1", "mb", at="-1158.6207+(-48.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840966.0, assembly_id=103430.0))
lhcb1.new("mcs.b25l7.b1", "mcs", at="-1151.1967+(-48-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247210.0, assembly_id=103430.0))
lhcb1.new("mco.a25l7.b1", "mco", at="-1150.4467+(-48-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252494.0, assembly_id=103431.0))
lhcb1.new("mcd.a25l7.b1", "mcd", at="-1150.4452+(-48-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252495.0, assembly_id=103431.0))
lhcb1.new("mb.a25l7.b1", "mb", at="-1142.9607+(-47.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52840990.0, assembly_id=103431.0))
lhcb1.new("mcs.a25l7.b1", "mcs", at="-1135.5367+(-47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247215.0, assembly_id=103431.0))
lhcb1.new("bpm.24l7.b1", "bpm", at="-1134.6577+(-47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247217.0, assembly_id=103432.0))
lhcb1.new("mo.24l7.b1", "mo", at="-1133.9067+(-47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308839.0, assembly_id=103432.0))
lhcb1.new("mq.24l7.b1", "mq", at="-1131.8957+(-47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308102.0, assembly_id=103432.0))
lhcb1.new("ms.24l7.b1", "ms", at="-1130.0007+(-47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252498.0, assembly_id=103432.0))
lhcb1.new("mcbh.24l7.b1", "mcbh", at="-1129.4077+(-47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252500.0, assembly_id=103432.0))
lhcb1.new("mb.c24l7.b1", "mb", at="-1120.8307+(-46.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841014.0, assembly_id=103433.0))
lhcb1.new("mcs.c24l7.b1", "mcs", at="-1113.4067+(-46-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247223.0, assembly_id=103433.0))
lhcb1.new("mco.24l7.b1", "mco", at="-1112.6567+(-46-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252502.0, assembly_id=103434.0))
lhcb1.new("mcd.24l7.b1", "mcd", at="-1112.6552+(-46-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252503.0, assembly_id=103434.0))
lhcb1.new("mb.b24l7.b1", "mb", at="-1105.1707+(-45.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841038.0, assembly_id=103434.0))
lhcb1.new("mcs.b24l7.b1", "mcs", at="-1097.7467+(-45-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247228.0, assembly_id=103434.0))
lhcb1.new("mb.a24l7.b1", "mb", at="-1089.5107+(-44.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841062.0, assembly_id=103435.0))
lhcb1.new("mcs.a24l7.b1", "mcs", at="-1082.0867+(-44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247231.0, assembly_id=103435.0))
lhcb1.new("bpm.23l7.b1", "bpm", at="-1081.2077+(-44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247233.0, assembly_id=103436.0))
lhcb1.new("mqs.23l7.b1", "mqs", at="-1080.4537+(-44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307632.0, assembly_id=103436.0))
lhcb1.new("mq.23l7.b1", "mq", at="-1078.4457+(-44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2348477.0, assembly_id=103436.0))
lhcb1.new("ms.23l7.b1", "ms", at="-1076.5507+(-44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252506.0, assembly_id=103436.0))
lhcb1.new("mcbv.23l7.b1", "mcbv", at="-1075.9577+(-44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252508.0, assembly_id=103436.0))
lhcb1.new("mco.b23l7.b1", "mco", at="-1074.8667+(-44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252510.0, assembly_id=103437.0))
lhcb1.new("mcd.b23l7.b1", "mcd", at="-1074.8652+(-44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252511.0, assembly_id=103437.0))
lhcb1.new("mb.c23l7.b1", "mb", at="-1067.3807+(-43.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841086.0, assembly_id=103437.0))
lhcb1.new("mcs.c23l7.b1", "mcs", at="-1059.9567+(-43-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247241.0, assembly_id=103437.0))
lhcb1.new("mb.b23l7.b1", "mb", at="-1051.7207+(-42.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841110.0, assembly_id=103438.0))
lhcb1.new("mcs.b23l7.b1", "mcs", at="-1044.2967+(-42-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247244.0, assembly_id=103438.0))
lhcb1.new("mco.a23l7.b1", "mco", at="-1043.5467+(-42-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252514.0, assembly_id=103439.0))
lhcb1.new("mcd.a23l7.b1", "mcd", at="-1043.5452+(-42-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252515.0, assembly_id=103439.0))
lhcb1.new("mb.a23l7.b1", "mb", at="-1036.0607+(-41.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841134.0, assembly_id=103439.0))
lhcb1.new("mcs.a23l7.b1", "mcs", at="-1028.6367+(-41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247249.0, assembly_id=103439.0))
lhcb1.new("bpm.22l7.b1", "bpm", at="-1027.7577+(-41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247251.0, assembly_id=103440.0))
lhcb1.new("mo.22l7.b1", "mo", at="-1027.0067+(-41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308810.0, assembly_id=103440.0))
lhcb1.new("mq.22l7.b1", "mq", at="-1024.9957+(-41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308281.0, assembly_id=103440.0))
lhcb1.new("ms.22l7.b1", "ms", at="-1023.1007+(-41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252518.0, assembly_id=103440.0))
lhcb1.new("mcbh.22l7.b1", "mcbh", at="-1022.5077+(-41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252520.0, assembly_id=103440.0))
lhcb1.new("mb.c22l7.b1", "mb", at="-1013.9307+(-40.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841158.0, assembly_id=103441.0))
lhcb1.new("mcs.c22l7.b1", "mcs", at="-1006.5067+(-40-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247257.0, assembly_id=103441.0))
lhcb1.new("mco.22l7.b1", "mco", at="-1005.7567+(-40-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252522.0, assembly_id=103442.0))
lhcb1.new("mcd.22l7.b1", "mcd", at="-1005.7552+(-40-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252523.0, assembly_id=103442.0))
lhcb1.new("mb.b22l7.b1", "mb", at="-998.2707+(-39.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841182.0, assembly_id=103442.0))
lhcb1.new("mcs.b22l7.b1", "mcs", at="-990.8467+(-39-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247262.0, assembly_id=103442.0))
lhcb1.new("mb.a22l7.b1", "mb", at="-982.6107+(-38.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841206.0, assembly_id=103443.0))
lhcb1.new("mcs.a22l7.b1", "mcs", at="-975.1867+(-38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247265.0, assembly_id=103443.0))
lhcb1.new("bpm.21l7.b1", "bpm", at="-974.3077+(-38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247267.0, assembly_id=103444.0))
lhcb1.new("mqt.21l7.b1", "mqt", at="-973.5537+(-38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307265.0, assembly_id=103444.0))
lhcb1.new("mq.21l7.b1", "mq", at="-971.5457+(-38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308249.0, assembly_id=103444.0))
lhcb1.new("ms.21l7.b1", "ms", at="-969.6507+(-38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252526.0, assembly_id=103444.0))
lhcb1.new("mcbv.21l7.b1", "mcbv", at="-969.0577+(-38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252528.0, assembly_id=103444.0))
lhcb1.new("mco.b21l7.b1", "mco", at="-967.9667+(-38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252530.0, assembly_id=103445.0))
lhcb1.new("mcd.b21l7.b1", "mcd", at="-967.9652+(-38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252531.0, assembly_id=103445.0))
lhcb1.new("mb.c21l7.b1", "mb", at="-960.4807+(-37.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841230.0, assembly_id=103445.0))
lhcb1.new("mcs.c21l7.b1", "mcs", at="-953.0567+(-37-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247275.0, assembly_id=103445.0))
lhcb1.new("mb.b21l7.b1", "mb", at="-944.8207+(-36.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841254.0, assembly_id=103446.0))
lhcb1.new("mcs.b21l7.b1", "mcs", at="-937.3967+(-36-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247278.0, assembly_id=103446.0))
lhcb1.new("mco.a21l7.b1", "mco", at="-936.6467+(-36-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252534.0, assembly_id=103447.0))
lhcb1.new("mcd.a21l7.b1", "mcd", at="-936.6452+(-36-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252535.0, assembly_id=103447.0))
lhcb1.new("mb.a21l7.b1", "mb", at="-929.1607+(-35.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841278.0, assembly_id=103447.0))
lhcb1.new("mcs.a21l7.b1", "mcs", at="-921.7367+(-35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247283.0, assembly_id=103447.0))
lhcb1.new("bpm.20l7.b1", "bpm", at="-920.8577+(-35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247285.0, assembly_id=103448.0))
lhcb1.new("mqt.20l7.b1", "mqt", at="-920.1037+(-35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307468.0, assembly_id=103448.0))
lhcb1.new("mq.20l7.b1", "mq", at="-918.0957+(-35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308219.0, assembly_id=103448.0))
lhcb1.new("ms.20l7.b1", "ms", at="-916.2007+(-35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252538.0, assembly_id=103448.0))
lhcb1.new("mcbh.20l7.b1", "mcbh", at="-915.6077+(-35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252540.0, assembly_id=103448.0))
lhcb1.new("mb.c20l7.b1", "mb", at="-907.0307+(-34.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841302.0, assembly_id=103449.0))
lhcb1.new("mcs.c20l7.b1", "mcs", at="-899.6067+(-34-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247291.0, assembly_id=103449.0))
lhcb1.new("mco.20l7.b1", "mco", at="-898.8567+(-34-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252542.0, assembly_id=103450.0))
lhcb1.new("mcd.20l7.b1", "mcd", at="-898.8552+(-34-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252543.0, assembly_id=103450.0))
lhcb1.new("mb.b20l7.b1", "mb", at="-891.3707+(-33.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841326.0, assembly_id=103450.0))
lhcb1.new("mcs.b20l7.b1", "mcs", at="-883.9467+(-33-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247296.0, assembly_id=103450.0))
lhcb1.new("mb.a20l7.b1", "mb", at="-875.7107+(-32.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841350.0, assembly_id=103451.0))
lhcb1.new("mcs.a20l7.b1", "mcs", at="-868.2867+(-32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247299.0, assembly_id=103451.0))
lhcb1.new("bpm.19l7.b1", "bpm", at="-867.4077+(-32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=266534.0, assembly_id=103452.0))
lhcb1.new("mqt.19l7.b1", "mqt", at="-866.6537+(-32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307438.0, assembly_id=103452.0))
lhcb1.new("mq.19l7.b1", "mq", at="-864.6457+(-32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308428.0, assembly_id=103452.0))
lhcb1.new("ms.19l7.b1", "ms", at="-862.7507+(-32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252546.0, assembly_id=103452.0))
lhcb1.new("mcbv.19l7.b1", "mcbv", at="-862.1577+(-32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252548.0, assembly_id=103452.0))
lhcb1.new("mco.b19l7.b1", "mco", at="-861.0667+(-32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252550.0, assembly_id=103453.0))
lhcb1.new("mcd.b19l7.b1", "mcd", at="-861.0652+(-32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252551.0, assembly_id=103453.0))
lhcb1.new("mb.c19l7.b1", "mb", at="-853.5807+(-31.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841374.0, assembly_id=103453.0))
lhcb1.new("mcs.c19l7.b1", "mcs", at="-846.1567+(-31-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247307.0, assembly_id=103453.0))
lhcb1.new("mb.b19l7.b1", "mb", at="-837.9207+(-30.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841398.0, assembly_id=103454.0))
lhcb1.new("mcs.b19l7.b1", "mcs", at="-830.4967+(-30-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247310.0, assembly_id=103454.0))
lhcb1.new("mco.a19l7.b1", "mco", at="-829.7467+(-30-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252554.0, assembly_id=103455.0))
lhcb1.new("mcd.a19l7.b1", "mcd", at="-829.7452+(-30-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252555.0, assembly_id=103455.0))
lhcb1.new("mb.a19l7.b1", "mb", at="-822.2607+(-29.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841422.0, assembly_id=103455.0))
lhcb1.new("mcs.a19l7.b1", "mcs", at="-814.8367+(-29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247315.0, assembly_id=103455.0))
lhcb1.new("bpm.18l7.b1", "bpm", at="-813.9577+(-29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247317.0, assembly_id=103456.0))
lhcb1.new("mqt.18l7.b1", "mqt", at="-813.2037+(-29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307407.0, assembly_id=103456.0))
lhcb1.new("mq.18l7.b1", "mq", at="-811.1957+(-29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308396.0, assembly_id=103456.0))
lhcb1.new("ms.18l7.b1", "ms", at="-809.3007+(-29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252558.0, assembly_id=103456.0))
lhcb1.new("mcbh.18l7.b1", "mcbh", at="-808.7077+(-29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252560.0, assembly_id=103456.0))
lhcb1.new("mb.c18l7.b1", "mb", at="-800.1307+(-28.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841446.0, assembly_id=103457.0))
lhcb1.new("mcs.c18l7.b1", "mcs", at="-792.7067+(-28-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247323.0, assembly_id=103457.0))
lhcb1.new("mco.18l7.b1", "mco", at="-791.9567+(-28-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252562.0, assembly_id=103458.0))
lhcb1.new("mcd.18l7.b1", "mcd", at="-791.9552+(-28-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252563.0, assembly_id=103458.0))
lhcb1.new("mb.b18l7.b1", "mb", at="-784.4707+(-27.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841470.0, assembly_id=103458.0))
lhcb1.new("mcs.b18l7.b1", "mcs", at="-777.0467+(-27-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247328.0, assembly_id=103458.0))
lhcb1.new("mb.a18l7.b1", "mb", at="-768.8107+(-26.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841494.0, assembly_id=103459.0))
lhcb1.new("mcs.a18l7.b1", "mcs", at="-761.3867+(-26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247331.0, assembly_id=103459.0))
lhcb1.new("bpm.17l7.b1", "bpm", at="-760.5077+(-26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247333.0, assembly_id=103460.0))
lhcb1.new("mqt.17l7.b1", "mqt", at="-759.7537+(-26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307375.0, assembly_id=103460.0))
lhcb1.new("mq.17l7.b1", "mq", at="-757.7457+(-26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308366.0, assembly_id=103460.0))
lhcb1.new("ms.17l7.b1", "ms", at="-755.8507+(-26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252566.0, assembly_id=103460.0))
lhcb1.new("mcbv.17l7.b1", "mcbv", at="-755.2577+(-26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252568.0, assembly_id=103460.0))
lhcb1.new("mco.b17l7.b1", "mco", at="-754.1667+(-26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252570.0, assembly_id=103461.0))
lhcb1.new("mcd.b17l7.b1", "mcd", at="-754.1652+(-26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252571.0, assembly_id=103461.0))
lhcb1.new("mb.c17l7.b1", "mb", at="-746.6807+(-25.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841518.0, assembly_id=103461.0))
lhcb1.new("mcs.c17l7.b1", "mcs", at="-739.2567+(-25-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247341.0, assembly_id=103461.0))
lhcb1.new("mb.b17l7.b1", "mb", at="-731.0207+(-24.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841542.0, assembly_id=103462.0))
lhcb1.new("mcs.b17l7.b1", "mcs", at="-723.5967+(-24-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247344.0, assembly_id=103462.0))
lhcb1.new("mco.a17l7.b1", "mco", at="-722.8467+(-24-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252574.0, assembly_id=103463.0))
lhcb1.new("mcd.a17l7.b1", "mcd", at="-722.8452+(-24-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252575.0, assembly_id=103463.0))
lhcb1.new("mb.a17l7.b1", "mb", at="-715.3607+(-23.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841566.0, assembly_id=103463.0))
lhcb1.new("mcs.a17l7.b1", "mcs", at="-707.9367+(-23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247349.0, assembly_id=103463.0))
lhcb1.new("bpm.16l7.b1", "bpm", at="-707.0577+(-23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247351.0, assembly_id=103464.0))
lhcb1.new("mqt.16l7.b1", "mqt", at="-706.3037+(-23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307582.0, assembly_id=103464.0))
lhcb1.new("mq.16l7.b1", "mq", at="-704.2957+(-23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308337.0, assembly_id=103464.0))
lhcb1.new("ms.16l7.b1", "ms", at="-702.4007+(-23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252578.0, assembly_id=103464.0))
lhcb1.new("mcbh.16l7.b1", "mcbh", at="-701.8077+(-23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252580.0, assembly_id=103464.0))
lhcb1.new("mb.c16l7.b1", "mb", at="-693.2307+(-22.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841590.0, assembly_id=103465.0))
lhcb1.new("mcs.c16l7.b1", "mcs", at="-685.8067+(-22-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247357.0, assembly_id=103465.0))
lhcb1.new("mco.16l7.b1", "mco", at="-685.0567+(-22-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252582.0, assembly_id=103466.0))
lhcb1.new("mcd.16l7.b1", "mcd", at="-685.0552+(-22-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252583.0, assembly_id=103466.0))
lhcb1.new("mb.b16l7.b1", "mb", at="-677.5707+(-21.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841614.0, assembly_id=103466.0))
lhcb1.new("mcs.b16l7.b1", "mcs", at="-670.1467+(-21-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247362.0, assembly_id=103466.0))
lhcb1.new("mb.a16l7.b1", "mb", at="-661.9107+(-20.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841638.0, assembly_id=103467.0))
lhcb1.new("mcs.a16l7.b1", "mcs", at="-654.4867+(-20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247365.0, assembly_id=103467.0))
lhcb1.new("bpm.15l7.b1", "bpm", at="-653.6077+(-20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=266536.0, assembly_id=103468.0))
lhcb1.new("mqt.15l7.b1", "mqt", at="-652.8537+(-20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307551.0, assembly_id=103468.0))
lhcb1.new("mq.15l7.b1", "mq", at="-650.8457+(-20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308543.0, assembly_id=103468.0))
lhcb1.new("ms.15l7.b1", "ms", at="-648.9507+(-20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252586.0, assembly_id=103468.0))
lhcb1.new("mcbv.15l7.b1", "mcbv", at="-648.3577+(-20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252588.0, assembly_id=103468.0))
lhcb1.new("mco.b15l7.b1", "mco", at="-647.2667+(-20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252590.0, assembly_id=103469.0))
lhcb1.new("mcd.b15l7.b1", "mcd", at="-647.2652+(-20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252591.0, assembly_id=103469.0))
lhcb1.new("mb.c15l7.b1", "mb", at="-639.7807+(-19.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841662.0, assembly_id=103469.0))
lhcb1.new("mcs.c15l7.b1", "mcs", at="-632.3567+(-19-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247373.0, assembly_id=103469.0))
lhcb1.new("mb.b15l7.b1", "mb", at="-624.1207+(-18.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841686.0, assembly_id=103470.0))
lhcb1.new("mcs.b15l7.b1", "mcs", at="-616.6967+(-18-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247376.0, assembly_id=103470.0))
lhcb1.new("mco.a15l7.b1", "mco", at="-615.9467+(-18-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252594.0, assembly_id=103471.0))
lhcb1.new("mcd.a15l7.b1", "mcd", at="-615.9452+(-18-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252595.0, assembly_id=103471.0))
lhcb1.new("mb.a15l7.b1", "mb", at="-608.4607+(-17.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841710.0, assembly_id=103471.0))
lhcb1.new("mcs.a15l7.b1", "mcs", at="-601.0367+(-17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247381.0, assembly_id=103471.0))
lhcb1.new("bpm.14l7.b1", "bpm", at="-600.1577+(-17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247383.0, assembly_id=103472.0))
lhcb1.new("mqt.14l7.b1", "mqt", at="-599.4037+(-17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307519.0, assembly_id=103472.0))
lhcb1.new("mq.14l7.b1", "mq", at="-597.3957+(-17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2348488.0, assembly_id=103472.0))
lhcb1.new("ms.14l7.b1", "ms", at="-595.5007+(-17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252598.0, assembly_id=103472.0))
lhcb1.new("mcbh.14l7.b1", "mcbh", at="-594.9077+(-17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252600.0, assembly_id=103472.0))
lhcb1.new("mb.c14l7.b1", "mb", at="-586.3307+(-16.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841734.0, assembly_id=103473.0))
lhcb1.new("mcs.c14l7.b1", "mcs", at="-578.9067+(-16-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247389.0, assembly_id=103473.0))
lhcb1.new("mco.14l7.b1", "mco", at="-578.1567+(-16-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252602.0, assembly_id=103474.0))
lhcb1.new("mcd.14l7.b1", "mcd", at="-578.1552+(-16-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252603.0, assembly_id=103474.0))
lhcb1.new("mb.b14l7.b1", "mb", at="-570.6707+(-15.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841758.0, assembly_id=103474.0))
lhcb1.new("mcs.b14l7.b1", "mcs", at="-563.2467+(-15-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247394.0, assembly_id=103474.0))
lhcb1.new("mb.a14l7.b1", "mb", at="-555.0107+(-14.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841782.0, assembly_id=103475.0))
lhcb1.new("mcs.a14l7.b1", "mcs", at="-547.5867+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247397.0, assembly_id=103475.0))
lhcb1.new("s.ds.l7.b1", "omk", at="-547.1807+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.13l7.b1", "bpm", at="-546.7077+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247399.0, assembly_id=103476.0))
lhcb1.new("mqt.13l7.b1", "mqt", at="-545.9537+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307726.0, assembly_id=103476.0))
lhcb1.new("mq.13l7.b1", "mq", at="-543.9457+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308484.0, assembly_id=103476.0))
lhcb1.new("ms.13l7.b1", "ms", at="-542.0507+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252606.0, assembly_id=103476.0))
lhcb1.new("mcbv.13l7.b1", "mcbv", at="-541.4577+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252608.0, assembly_id=103476.0))
lhcb1.new("mco.b13l7.b1", "mco", at="-540.3667+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252610.0, assembly_id=103477.0))
lhcb1.new("mcd.b13l7.b1", "mcd", at="-540.3652+(-14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252611.0, assembly_id=103477.0))
lhcb1.new("mb.c13l7.b1", "mb", at="-532.8807+(-13.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841806.0, assembly_id=103477.0))
lhcb1.new("mcs.c13l7.b1", "mcs", at="-525.4567+(-13-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247407.0, assembly_id=103477.0))
lhcb1.new("mb.b13l7.b1", "mb", at="-517.2207+(-12.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841830.0, assembly_id=103478.0))
lhcb1.new("mcs.b13l7.b1", "mcs", at="-509.7967+(-12-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247410.0, assembly_id=103478.0))
lhcb1.new("mco.a13l7.b1", "mco", at="-509.0467+(-12-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252614.0, assembly_id=103479.0))
lhcb1.new("mcd.a13l7.b1", "mcd", at="-509.0452+(-12-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252615.0, assembly_id=103479.0))
lhcb1.new("mb.a13l7.b1", "mb", at="-501.5607+(-11.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841854.0, assembly_id=103479.0))
lhcb1.new("mcs.a13l7.b1", "mcs", at="-494.1367+(-11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247415.0, assembly_id=103479.0))
lhcb1.new("bpm.12l7.b1", "bpm", at="-493.2577+(-11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247417.0, assembly_id=103480.0))
lhcb1.new("mqt.12l7.b1", "mqt", at="-492.5037+(-11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307695.0, assembly_id=103480.0))
lhcb1.new("mq.12l7.b1", "mq", at="-490.4957+(-11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308454.0, assembly_id=103480.0))
lhcb1.new("ms.12l7.b1", "ms", at="-488.6007+(-11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252618.0, assembly_id=103480.0))
lhcb1.new("mcbh.12l7.b1", "mcbh", at="-488.0077+(-11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252620.0, assembly_id=103480.0))
lhcb1.new("mb.c12l7.b1", "mb", at="-479.4307+(-10.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841878.0, assembly_id=103481.0))
lhcb1.new("mcs.c12l7.b1", "mcs", at="-472.0067+(-10-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247423.0, assembly_id=103481.0))
lhcb1.new("mco.12l7.b1", "mco", at="-471.2567+(-10-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252622.0, assembly_id=103482.0))
lhcb1.new("mcd.12l7.b1", "mcd", at="-471.2552+(-10-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252623.0, assembly_id=103482.0))
lhcb1.new("mb.b12l7.b1", "mb", at="-463.7707+(-9.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841902.0, assembly_id=103482.0))
lhcb1.new("mcs.b12l7.b1", "mcs", at="-456.3467+(-9-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247428.0, assembly_id=103482.0))
lhcb1.new("mb.a12l7.b1", "mb", at="-448.1107+(-8.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841926.0, assembly_id=103483.0))
lhcb1.new("mcs.a12l7.b1", "mcs", at="-440.6867+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247431.0, assembly_id=103483.0))
lhcb1.new("e.arc.67.b1", "omk", at="-440.2807+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.11l7.b1", "bpm", at="-439.8077+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247433.0, assembly_id=103484.0))
lhcb1.new("mq.11l7.b1", "mq", at="-437.2607+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308661.0, assembly_id=103484.0))
lhcb1.new("mqtli.11l7.b1", "mqtli", at="-434.8917+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307349.0, assembly_id=103484.0))
lhcb1.new("ms.11l7.b1", "ms", at="-433.8797+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252626.0, assembly_id=103484.0))
lhcb1.new("mcbv.11l7.b1", "mcbv", at="-433.2867+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252628.0, assembly_id=103484.0))
lhcb1.new("leir.11l7.b1", "leir", at="-425.67735+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52997946.0, assembly_id=103485.0))
lhcb1.new("mco.11l7.b1", "mco", at="-418.475+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252630.0, assembly_id=103486.0))
lhcb1.new("mcd.11l7.b1", "mcd", at="-418.4735+(-8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252631.0, assembly_id=103486.0))
lhcb1.new("mb.b11l7.b1", "mb", at="-410.989+(-7.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841950.0, assembly_id=103486.0))
lhcb1.new("mcs.b11l7.b1", "mcs", at="-403.565+(-7-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247441.0, assembly_id=103486.0))
lhcb1.new("mb.a11l7.b1", "mb", at="-395.329+(-6.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841974.0, assembly_id=103487.0))
lhcb1.new("mcs.a11l7.b1", "mcs", at="-387.905+(-6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247444.0, assembly_id=103487.0))
lhcb1.new("bpm.10l7.b1", "bpm", at="-387.026+(-6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247446.0, assembly_id=103488.0))
lhcb1.new("mq.10l7.b1", "mq", at="-384.479+(-6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308644.0, assembly_id=103488.0))
lhcb1.new("mqtli.10l7.b1", "mqtli", at="-382.11+(-6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307332.0, assembly_id=103488.0))
lhcb1.new("mcbch.10l7.b1", "mcbch", at="-380.82+(-6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252634.0, assembly_id=103488.0))
lhcb1.new("mco.10l7.b1", "mco", at="-379.41+(-6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252636.0, assembly_id=103489.0))
lhcb1.new("mcd.10l7.b1", "mcd", at="-379.4085+(-6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252637.0, assembly_id=103489.0))
lhcb1.new("mb.b10l7.b1", "mb", at="-371.924+(-5.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52841998.0, assembly_id=103489.0))
lhcb1.new("mcs.b10l7.b1", "mcs", at="-364.5+(-5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247454.0, assembly_id=103489.0))
lhcb1.new("mb.a10l7.b1", "mb", at="-356.264+(-4.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842022.0, assembly_id=103490.0))
lhcb1.new("mcs.a10l7.b1", "mcs", at="-348.84+(-4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247457.0, assembly_id=103490.0))
lhcb1.new("bpm.9l7.b1", "bpm", at="-347.96+(-4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247459.0, assembly_id=103491.0))
lhcb1.new("mq.9l7.b1", "mq", at="-345.413+(-4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307949.0, assembly_id=103491.0))
lhcb1.new("mqtli.b9l7.b1", "mqtli", at="-343.044+(-4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307159.0, assembly_id=103491.0))
lhcb1.new("mqtli.a9l7.b1", "mqtli", at="-341.589+(-4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307152.0, assembly_id=103491.0))
lhcb1.new("mcbcv.9l7.b1", "mcbcv", at="-340.299+(-4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252640.0, assembly_id=103491.0))
lhcb1.new("mco.9l7.b1", "mco", at="-338.945+(-4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252642.0, assembly_id=103492.0))
lhcb1.new("mcd.9l7.b1", "mcd", at="-338.9435+(-4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252643.0, assembly_id=103492.0))
lhcb1.new("mb.b9l7.b1", "mb", at="-331.459+(-3.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842046.0, assembly_id=103492.0))
lhcb1.new("mcs.b9l7.b1", "mcs", at="-324.035+(-3-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247468.0, assembly_id=103492.0))
lhcb1.new("mb.a9l7.b1", "mb", at="-315.799+(-2.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842070.0, assembly_id=103493.0))
lhcb1.new("mcs.a9l7.b1", "mcs", at="-308.375+(-2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247471.0, assembly_id=103493.0))
lhcb1.new("bpm.8l7.b1", "bpm", at="-307.496+(-2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247473.0, assembly_id=103494.0))
lhcb1.new("mq.8l7.b1", "mq", at="-304.949+(-2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307941.0, assembly_id=103494.0))
lhcb1.new("mqtli.8l7.b1", "mqtli", at="-302.58+(-2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307144.0, assembly_id=103494.0))
lhcb1.new("mcbch.8l7.b1", "mcbch", at="-301.29+(-2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252646.0, assembly_id=103494.0))
lhcb1.new("mco.8l7.b1", "mco", at="-299.88+(-2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252648.0, assembly_id=103495.0))
lhcb1.new("mcd.8l7.b1", "mcd", at="-299.8785+(-2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252649.0, assembly_id=103495.0))
lhcb1.new("mb.b8l7.b1", "mb", at="-292.394+(-1.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842094.0, assembly_id=103495.0))
lhcb1.new("mcs.b8l7.b1", "mcs", at="-284.97+(-1-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247481.0, assembly_id=103495.0))
lhcb1.new("mb.a8l7.b1", "mb", at="-276.734+(-.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52849702.0, assembly_id=103496.0))
lhcb1.new("mcs.a8l7.b1", "mcs", at="-269.31+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=357325.0, assembly_id=103496.0))
lhcb1.new("e.ds.l7.b1", "omk", at="-268.904+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.7l7.b1", "bpm", at="-268.431+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247486.0, assembly_id=103497.0))
lhcb1.new("mq.7l7.b1", "mq", at="-265.884+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307934.0, assembly_id=103497.0))
lhcb1.new("mqtli.7l7.b1", "mqtli", at="-263.515+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307370.0, assembly_id=103497.0))
lhcb1.new("mcbcv.7l7.b1", "mcbcv", at="-262.225+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252652.0, assembly_id=103497.0))
lhcb1.new("dfbam.7l7.b1", "dfbam", at="-260.0715+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52996827.0, assembly_id=104688.0))
lhcb1.new("bpm.6l7.b1", "bpm", at="-233.613+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=378023.0, assembly_id=103498.0))
lhcb1.new("mqtlh.f6l7.b1", "mqtlh", at="-232.243+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307325.0, assembly_id=103498.0))
lhcb1.new("mqtlh.e6l7.b1", "mqtlh", at="-230.788+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307317.0, assembly_id=103498.0))
lhcb1.new("mqtlh.d6l7.b1", "mqtlh", at="-229.333+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307310.0, assembly_id=103498.0))
lhcb1.new("mqtlh.c6l7.b1", "mqtlh", at="-227.878+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307302.0, assembly_id=103498.0))
lhcb1.new("mqtlh.b6l7.b1", "mqtlh", at="-226.422+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307295.0, assembly_id=103498.0))
lhcb1.new("mqtlh.a6l7.b1", "mqtlh", at="-224.966+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307287.0, assembly_id=103498.0))
lhcb1.new("mcbch.6l7.b1", "mcbch", at="-223.675+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252655.0, assembly_id=103498.0))
lhcb1.new("bpmwc.6l7.b1", "bpmwc", at="-221.5105+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=181644.0))
lhcb1.new("mbw.d6l7.b1", "mbw", at="-214.413+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52820086.0))
lhcb1.new("mbw.c6l7.b1", "mbw", at="-210.178+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52820110.0))
lhcb1.new("bptuh.d6l7.b1", "bptuh", at="-205.6635+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.199, slot_id=50605666.0, assembly_id=103500.0))
lhcb1.new("bptuv.d6l7.b1", "bptuv", at="-205.573+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.1991, slot_id=50605668.0, assembly_id=103500.0))
lhcb1.new("tcp.d6l7.b1", "tcppm", at="-204.978+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.1996, slot_id=103500.0))
lhcb1.new("bptdv.d6l7.b1", "bptdv", at="-204.383+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.2, slot_id=50605664.0, assembly_id=103500.0))
lhcb1.new("bptuv.c6l7.b1", "bptuv", at="-203.6635+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.2004, slot_id=50605659.0, assembly_id=103501.0))
lhcb1.new("bptuh.c6l7.b1", "bptuh", at="-203.573+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.2005, slot_id=40084941.0, assembly_id=103501.0))
lhcb1.new("tcp.c6l7.b1", "tcppm", at="-202.978+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.201, slot_id=103501.0))
lhcb1.new("bptdh.c6l7.b1", "bptdh", at="-202.383+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.2014, slot_id=40084939.0, assembly_id=103501.0))
lhcb1.new("tcp.b6l7.b1", "tcp", at="-200.978+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.2026, slot_id=103502.0))
lhcb1.new("tcapa.6l7.b1", "tcapa019", at="-177.9735+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.222, slot_id=820100.0))
lhcb1.new("mbw.b6l7.b1", "mbw", at="-175.0235+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52820134.0))
lhcb1.new("tcapb.6l7.b1", "tcapb", at="-172.4885+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=820112.0))
lhcb1.new("mbw.a6l7.b1", "mbw", at="-170.0885+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52820158.0))
lhcb1.new("tcsg.a6l7.b1", "tcsg", at="-161.4835+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=103507.0))
lhcb1.new("tcpcv.a6l7.b1", "tcpcv", at="-150.5385+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=10402980.0))
lhcb1.new("tcapc.6l7.b1", "tcapc", at="-145.161+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=820154.0))
lhcb1.new("bpmwe.5l7.b1", "bpmwe007", at="-144.4565+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=297897.0))
lhcb1.new("mqwa.d5l7.b1", "mqwa", at="-138.566+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241770.0))
lhcb1.new("mqwa.c5l7.b1", "mqwa", at="-134.766+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241771.0))
lhcb1.new("mqwa.f5l7.b1", "mqwa", at="-130.966+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52778395.0))
lhcb1.new("mqwa.b5l7.b1", "mqwa", at="-127.166+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241772.0))
lhcb1.new("mqwa.a5l7.b1", "mqwa", at="-123.366+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241773.0))
lhcb1.new("bpmw.5l7.b1", "bpmw_014", at="-121.2515+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=297889.0))
lhcb1.new("mcbwv.5l7.b1", "mcbwv", at="-119.761+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=297888.0))
lhcb1.new("tcsg.b5l7.b1", "tcsg", at="-102.256+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=281859.0))
lhcb1.new("tcsg.a5l7.b1", "tcsg", at="-98.256+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=281861.0))
lhcb1.new("bpmwe.4l7.b1", "bpmwe009", at="-86.1665+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=297885.0))
lhcb1.new("mqwa.e4l7.b1", "mqwa", at="-84.076+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241775.0))
lhcb1.new("mqwa.d4l7.b1", "mqwa", at="-80.276+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241776.0))
lhcb1.new("bptuh.d4l7.b1", "bptuh", at="-77.6115+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52502345.0))
lhcb1.new("bptuv.d4l7.b1", "bptuv", at="-77.521+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52502326.0))
lhcb1.new("tcsg.d4l7.b1", "tcspm", at="-76.926+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52431366.0))
lhcb1.new("bptdv.d4l7.b1", "bptdv", at="-76.331+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52502335.0))
lhcb1.new("tcpch.a4l7.b1", "tcpch", at="-74.6635+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=10402981.0))
lhcb1.new("mqwa.c4l7.b1", "mqwa", at="-71.576+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241777.0))
lhcb1.new("mqwb.4l7.b1", "mqwb", at="-67.776+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241774.0))
lhcb1.new("mqwa.b4l7.b1", "mqwa", at="-63.976+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241778.0))
lhcb1.new("mqwa.a4l7.b1", "mqwa", at="-60.176+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241779.0))
lhcb1.new("bpmw.4l7.b1", "bpmw_013", at="-58.0615+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=297875.0))
lhcb1.new("mcbwh.4l7.b1", "mcbwh", at="-56.521+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=297874.0))
lhcb1.new("tcsg.b4l7.b1", "tcsg", at="-7+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=281867.0))
lhcb1.new("bptuv.b4l7.b1", "bptuv", at="-5.6855+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=50331199.0, assembly_id=52430718.0))
lhcb1.new("bptuh.b4l7.b1", "bptuh", at="-5.595+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.448, slot_id=50331190.0, assembly_id=52430718.0))
lhcb1.new("tcspm.b4l7.b1", "tcspm", at="-5+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52430718.0))
lhcb1.new("bptdh.b4l7.b1", "bptdh", at="-4.405+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.448, slot_id=50331208.0, assembly_id=52430718.0))
lhcb1.new("tcsg.a4l7.b1", "tcsg", at="-3+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=281869.0))
lhcb1.new("ip7", "omk", at="pip7+ip7ofs.b1*ds")
lhcb1.new("tcsg.a4r7.b1", "tcsg", at="1+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=103518.0))
lhcb1.new("mcbwv.4r7.b1", "mcbwv", at="54.191+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=134665.0))
lhcb1.new("bpmw.4r7.b1", "bpmw_015", at="57.9855+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=182521.0))
lhcb1.new("mqwa.a4r7.b1", "mqwa", at="60.176+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241781.0))
lhcb1.new("mqwa.b4r7.b1", "mqwa", at="63.976+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241782.0))
lhcb1.new("mqwb.4r7.b1", "mqwb", at="67.776+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241780.0))
lhcb1.new("mqwa.c4r7.b1", "mqwa", at="71.576+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=2348356.0))
lhcb1.new("mqwa.d4r7.b1", "mqwa", at="80.276+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241783.0))
lhcb1.new("mqwa.e4r7.b1", "mqwa", at="84.076+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241784.0))
lhcb1.new("bpmwe.4r7.b1", "bpmwe008", at="86.0905+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=182522.0))
lhcb1.new("tcsg.b5r7.b1", "tcsg", at="92.256+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=281877.0))
lhcb1.new("tcsg.d5r7.b1", "tcsg", at="108.256+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=281885.0))
lhcb1.new("tcsg.e5r7.b1", "tcsg", at="112.256+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=103525.0))
lhcb1.new("bptut.e5r7.b1", "bptut", at="113.5705+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52650713.0, assembly_id=52430780.0))
lhcb1.new("bptuj.e5r7.b1", "bptuj", at="113.661+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=50622398.0, assembly_id=52430780.0))
lhcb1.new("tcspm.e5r7.b1", "tcspm", at="114.256+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52430780.0))
lhcb1.new("bptdj.e5r7.b1", "bptdj", at="114.851+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52505009.0, assembly_id=52430780.0))
lhcb1.new("mcbwh.5r7.b1", "mcbwh", at="117.431+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=134673.0))
lhcb1.new("bpmw.5r7.b1", "bpmw_010", at="121.1755+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=182523.0))
lhcb1.new("mqwa.a5r7.b1", "mqwa", at="123.366+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241786.0))
lhcb1.new("mqwa.b5r7.b1", "mqwa", at="127.166+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241787.0))
lhcb1.new("mqwa.f5r7.b1", "mqwa", at="130.966+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52778539.0))
lhcb1.new("mqwa.c5r7.b1", "mqwa", at="134.766+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241788.0))
lhcb1.new("mqwa.d5r7.b1", "mqwa", at="138.566+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=241789.0))
lhcb1.new("bpmwe.5r7.b1", "bpmwe003", at="144.3805+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=182524.0))
lhcb1.new("tcsg.6r7.b1", "tcsg", at="146.861+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=281887.0))
lhcb1.new("bptuv.6r7.b1", "bptuv", at="148.1755+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=50331470.0, assembly_id=52430911.0))
lhcb1.new("bptuh.6r7.b1", "bptuh", at="148.266+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=50331452.0, assembly_id=52430911.0))
lhcb1.new("tcspm.6r7.b1", "tcspm", at="148.861+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52430911.0))
lhcb1.new("bptdh.6r7.b1", "bptdh", at="149.456+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=50331461.0, assembly_id=52430911.0))
lhcb1.new("tcla.a6r7.b1", "tcla", at="153.927+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=691005.0))
lhcb1.new("mbw.a6r7.b1", "mbw", at="170.0885+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52820182.0))
lhcb1.new("mbw.b6r7.b1", "mbw", at="175.0235+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.224, slot_id=52820206.0))
lhcb1.new("tcla.b6r7.b1", "tcla", at="184.801+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.2148, slot_id=691006.0))
lhcb1.new("mbw.c6r7.b1", "mbw", at="210.178+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52820230.0))
lhcb1.new("mbw.d6r7.b1", "mbw", at="214.413+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52820254.0))
lhcb1.new("tcla.c6r7.b1", "tcla", at="218.07+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=691007.0))
lhcb1.new("tcla.d6r7.b1", "tcla", at="220.07+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=691008.0))
lhcb1.new("bpmr.6r7.b1", "bpmr", at="223.596+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=378033.0, assembly_id=103537.0))
lhcb1.new("mqtlh.a6r7.b1", "mqtlh", at="224.966+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307291.0, assembly_id=103537.0))
lhcb1.new("mqtlh.b6r7.b1", "mqtlh", at="226.421+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307298.0, assembly_id=103537.0))
lhcb1.new("mqtlh.c6r7.b1", "mqtlh", at="227.876+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307306.0, assembly_id=103537.0))
lhcb1.new("mqtlh.d6r7.b1", "mqtlh", at="229.331+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307313.0, assembly_id=103537.0))
lhcb1.new("mqtlh.e6r7.b1", "mqtlh", at="230.787+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307321.0, assembly_id=103537.0))
lhcb1.new("mqtlh.f6r7.b1", "mqtlh", at="232.243+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307328.0, assembly_id=103537.0))
lhcb1.new("mcbcv.6r7.b1", "mcbcv", at="233.534+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252657.0, assembly_id=103537.0))
lhcb1.new("tcla.a7r7.b1", "tcla", at="237.698+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=691009.0))
lhcb1.new("dfban.7r7.b1", "dfban", at="259.8215+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52996851.0, assembly_id=104689.0))
lhcb1.new("bpm_a.7r7.b1", "bpm_a", at="261.632+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=378035.0, assembly_id=103538.0))
lhcb1.new("mq.7r7.b1", "mq", at="264.179+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307938.0, assembly_id=103538.0))
lhcb1.new("mqtli.7r7.b1", "mqtli", at="266.548+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2348428.0, assembly_id=103538.0))
lhcb1.new("mcbch.7r7.b1", "mcbch", at="267.838+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252658.0, assembly_id=103538.0))
lhcb1.new("s.ds.r7.b1", "omk", at="268.904+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(slot_id=100932.0))
lhcb1.new("mco.8r7.b1", "mco_unplugged", at="269.248+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252660.0, assembly_id=103539.0))
lhcb1.new("mcd.8r7.b1", "mcd", at="269.2495+(0-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252661.0, assembly_id=103539.0))
lhcb1.new("mb.a8r7.b1", "mb", at="276.734+(.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842118.0, assembly_id=103539.0))
lhcb1.new("mcs.a8r7.b1", "mcs", at="284.158+(1-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247575.0, assembly_id=103539.0))
lhcb1.new("mb.b8r7.b1", "mb", at="292.394+(1.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842142.0, assembly_id=103540.0))
lhcb1.new("mcs.b8r7.b1", "mcs", at="299.818+(2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247578.0, assembly_id=103540.0))
lhcb1.new("bpm.8r7.b1", "bpm", at="300.697+(2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247580.0, assembly_id=103541.0))
lhcb1.new("mq.8r7.b1", "mq", at="303.244+(2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307945.0, assembly_id=103541.0))
lhcb1.new("mqtli.8r7.b1", "mqtli", at="305.613+(2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307148.0, assembly_id=103541.0))
lhcb1.new("mcbcv.8r7.b1", "mcbcv", at="306.903+(2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252664.0, assembly_id=103541.0))
lhcb1.new("mco.9r7.b1", "mco_unplugged", at="308.313+(2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252666.0, assembly_id=103542.0))
lhcb1.new("mcd.9r7.b1", "mcd", at="308.3145+(2-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252667.0, assembly_id=103542.0))
lhcb1.new("mb.a9r7.b1", "mb", at="315.799+(2.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842166.0, assembly_id=103542.0))
lhcb1.new("mcs.a9r7.b1", "mcs", at="323.223+(3-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247588.0, assembly_id=103542.0))
lhcb1.new("mb.b9r7.b1", "mb", at="331.459+(3.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842190.0, assembly_id=103543.0))
lhcb1.new("mcs.b9r7.b1", "mcs", at="338.883+(4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247591.0, assembly_id=103543.0))
lhcb1.new("bpm.9r7.b1", "bpm", at="339.763+(4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247593.0, assembly_id=103544.0))
lhcb1.new("mq.9r7.b1", "mq", at="342.31+(4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307953.0, assembly_id=103544.0))
lhcb1.new("mqtli.a9r7.b1", "mqtli", at="344.679+(4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307155.0, assembly_id=103544.0))
lhcb1.new("mqtli.b9r7.b1", "mqtli", at="346.134+(4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307163.0, assembly_id=103544.0))
lhcb1.new("mcbch.9r7.b1", "mcbch", at="347.424+(4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252670.0, assembly_id=103544.0))
lhcb1.new("mco.10r7.b1", "mco_unplugged", at="348.778+(4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252672.0, assembly_id=103545.0))
lhcb1.new("mcd.10r7.b1", "mcd", at="348.7795+(4-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252673.0, assembly_id=103545.0))
lhcb1.new("mb.a10r7.b1", "mb", at="356.264+(4.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842214.0, assembly_id=103545.0))
lhcb1.new("mcs.a10r7.b1", "mcs", at="363.688+(5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247602.0, assembly_id=103545.0))
lhcb1.new("mb.b10r7.b1", "mb", at="371.924+(5.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842238.0, assembly_id=103546.0))
lhcb1.new("mcs.b10r7.b1", "mcs", at="379.348+(6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247605.0, assembly_id=103546.0))
lhcb1.new("bpm.10r7.b1", "bpm", at="380.227+(6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247607.0, assembly_id=103547.0))
lhcb1.new("mq.10r7.b1", "mq", at="382.774+(6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308648.0, assembly_id=103547.0))
lhcb1.new("mqtli.10r7.b1", "mqtli", at="385.143+(6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307336.0, assembly_id=103547.0))
lhcb1.new("mcbcv.10r7.b1", "mcbcv", at="386.433+(6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252676.0, assembly_id=103547.0))
lhcb1.new("mco.11r7.b1", "mco_unplugged", at="387.843+(6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252678.0, assembly_id=103548.0))
lhcb1.new("mcd.11r7.b1", "mcd", at="387.8445+(6-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252679.0, assembly_id=103548.0))
lhcb1.new("mb.a11r7.b1", "mb", at="395.329+(6.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842262.0, assembly_id=103548.0))
lhcb1.new("mcs.a11r7.b1", "mcs", at="402.753+(7-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247615.0, assembly_id=103548.0))
lhcb1.new("mb.b11r7.b1", "mb", at="410.989+(7.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842286.0, assembly_id=103549.0))
lhcb1.new("mcs.b11r7.b1", "mcs", at="418.413+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247618.0, assembly_id=103549.0))
lhcb1.new("ledr.11r7.b1", "ledr", at="425.67735+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52997778.0, assembly_id=103550.0))
lhcb1.new("bpm.11r7.b1", "bpm", at="433.0087+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247620.0, assembly_id=103551.0))
lhcb1.new("mq.11r7.b1", "mq", at="435.5557+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308676.0, assembly_id=103551.0))
lhcb1.new("mqtli.11r7.b1", "mqtli", at="437.9247+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307364.0, assembly_id=103551.0))
lhcb1.new("ms.11r7.b1", "ms", at="438.9367+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252682.0, assembly_id=103551.0))
lhcb1.new("mcbh.11r7.b1", "mcbh", at="439.5297+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252684.0, assembly_id=103551.0))
lhcb1.new("s.arc.78.b1", "omk", at="440.2807+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a12r7.b1", "mco_unplugged", at="440.6247+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252686.0, assembly_id=103552.0))
lhcb1.new("mcd.a12r7.b1", "mcd", at="440.6262+(8-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252687.0, assembly_id=103552.0))
lhcb1.new("mb.a12r7.b1", "mb", at="448.1107+(8.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842310.0, assembly_id=103552.0))
lhcb1.new("mcs.a12r7.b1", "mcs", at="455.5347+(9-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247628.0, assembly_id=103552.0))
lhcb1.new("mb.b12r7.b1", "mb", at="463.7707+(9.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842334.0, assembly_id=103553.0))
lhcb1.new("mcs.b12r7.b1", "mcs", at="471.1947+(10-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247631.0, assembly_id=103553.0))
lhcb1.new("mco.b12r7.b1", "mco_unplugged", at="471.9447+(10-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252690.0, assembly_id=103554.0))
lhcb1.new("mcd.b12r7.b1", "mcd", at="471.9462+(10-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252691.0, assembly_id=103554.0))
lhcb1.new("mb.c12r7.b1", "mb", at="479.4307+(10.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842358.0, assembly_id=103554.0))
lhcb1.new("mcs.c12r7.b1", "mcs", at="486.8547+(11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247636.0, assembly_id=103554.0))
lhcb1.new("bpm.12r7.b1", "bpm", at="487.7337+(11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247638.0, assembly_id=103555.0))
lhcb1.new("mqt.12r7.b1", "mqt", at="488.4877+(11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307711.0, assembly_id=103555.0))
lhcb1.new("mq.12r7.b1", "mq", at="490.4957+(11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308469.0, assembly_id=103555.0))
lhcb1.new("ms.12r7.b1", "ms", at="492.3907+(11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252694.0, assembly_id=103555.0))
lhcb1.new("mcbv.12r7.b1", "mcbv", at="492.9837+(11-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252696.0, assembly_id=103555.0))
lhcb1.new("mb.a13r7.b1", "mb", at="501.5607+(11.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842382.0, assembly_id=103556.0))
lhcb1.new("mcs.a13r7.b1", "mcs", at="508.9847+(12-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247644.0, assembly_id=103556.0))
lhcb1.new("mco.13r7.b1", "mco_unplugged", at="509.7347+(12-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252698.0, assembly_id=103557.0))
lhcb1.new("mcd.13r7.b1", "mcd", at="509.7362+(12-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252699.0, assembly_id=103557.0))
lhcb1.new("mb.b13r7.b1", "mb", at="517.2207+(12.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842406.0, assembly_id=103557.0))
lhcb1.new("mcs.b13r7.b1", "mcs", at="524.6447+(13-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247649.0, assembly_id=103557.0))
lhcb1.new("mb.c13r7.b1", "mb", at="532.8807+(13.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842430.0, assembly_id=103558.0))
lhcb1.new("mcs.c13r7.b1", "mcs", at="540.3047+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247652.0, assembly_id=103558.0))
lhcb1.new("bpm.13r7.b1", "bpm", at="541.1837+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247654.0, assembly_id=103559.0))
lhcb1.new("mqt.13r7.b1", "mqt", at="541.9377+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307503.0, assembly_id=103559.0))
lhcb1.new("mq.13r7.b1", "mq", at="543.9457+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308499.0, assembly_id=103559.0))
lhcb1.new("ms.13r7.b1", "ms", at="545.8407+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252702.0, assembly_id=103559.0))
lhcb1.new("mcbh.13r7.b1", "mcbh", at="546.4337+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252704.0, assembly_id=103559.0))
lhcb1.new("e.ds.r7.b1", "omk", at="547.1807+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a14r7.b1", "mco_unplugged", at="547.5247+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252706.0, assembly_id=103560.0))
lhcb1.new("mcd.a14r7.b1", "mcd", at="547.5262+(14-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252707.0, assembly_id=103560.0))
lhcb1.new("mb.a14r7.b1", "mb", at="555.0107+(14.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842454.0, assembly_id=103560.0))
lhcb1.new("mcs.a14r7.b1", "mcs", at="562.4347+(15-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247662.0, assembly_id=103560.0))
lhcb1.new("mb.b14r7.b1", "mb", at="570.6707+(15.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842478.0, assembly_id=103561.0))
lhcb1.new("mcs.b14r7.b1", "mcs", at="578.0947+(16-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247665.0, assembly_id=103561.0))
lhcb1.new("mco.b14r7.b1", "mco_unplugged", at="578.8447+(16-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252710.0, assembly_id=103562.0))
lhcb1.new("mcd.b14r7.b1", "mcd", at="578.8462+(16-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252711.0, assembly_id=103562.0))
lhcb1.new("mb.c14r7.b1", "mb", at="586.3307+(16.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842502.0, assembly_id=103562.0))
lhcb1.new("mcs.c14r7.b1", "mcs", at="593.7547+(17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247670.0, assembly_id=103562.0))
lhcb1.new("bpm.14r7.b1", "bpm", at="594.6337+(17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247672.0, assembly_id=103563.0))
lhcb1.new("mqt.14r7.b1", "mqt", at="595.3877+(17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307535.0, assembly_id=103563.0))
lhcb1.new("mq.14r7.b1", "mq", at="597.3957+(17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308528.0, assembly_id=103563.0))
lhcb1.new("ms.14r7.b1", "ms", at="599.2907+(17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252714.0, assembly_id=103563.0))
lhcb1.new("mcbv.14r7.b1", "mcbv", at="599.8837+(17-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252716.0, assembly_id=103563.0))
lhcb1.new("mb.a15r7.b1", "mb", at="608.4607+(17.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842526.0, assembly_id=103564.0))
lhcb1.new("mcs.a15r7.b1", "mcs", at="615.8847+(18-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247678.0, assembly_id=103564.0))
lhcb1.new("mco.15r7.b1", "mco_unplugged", at="616.6347+(18-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252718.0, assembly_id=103565.0))
lhcb1.new("mcd.15r7.b1", "mcd", at="616.6362+(18-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252719.0, assembly_id=103565.0))
lhcb1.new("mb.b15r7.b1", "mb", at="624.1207+(18.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842550.0, assembly_id=103565.0))
lhcb1.new("mcs.b15r7.b1", "mcs", at="631.5447+(19-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247683.0, assembly_id=103565.0))
lhcb1.new("mb.c15r7.b1", "mb", at="639.7807+(19.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842574.0, assembly_id=103566.0))
lhcb1.new("mcs.c15r7.b1", "mcs", at="647.2047+(20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247686.0, assembly_id=103566.0))
lhcb1.new("bpm.15r7.b1", "bpm", at="648.0837+(20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247688.0, assembly_id=103567.0))
lhcb1.new("mqt.15r7.b1", "mqt", at="648.8377+(20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307567.0, assembly_id=103567.0))
lhcb1.new("mq.15r7.b1", "mq", at="650.8457+(20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308559.0, assembly_id=103567.0))
lhcb1.new("ms.15r7.b1", "ms", at="652.7407+(20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252722.0, assembly_id=103567.0))
lhcb1.new("mcbh.15r7.b1", "mcbh", at="653.3337+(20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252724.0, assembly_id=103567.0))
lhcb1.new("mco.a16r7.b1", "mco_unplugged", at="654.4247+(20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252726.0, assembly_id=103568.0))
lhcb1.new("mcd.a16r7.b1", "mcd", at="654.4262+(20-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252727.0, assembly_id=103568.0))
lhcb1.new("mb.a16r7.b1", "mb", at="661.9107+(20.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842598.0, assembly_id=103568.0))
lhcb1.new("mcs.a16r7.b1", "mcs", at="669.3347+(21-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247696.0, assembly_id=103568.0))
lhcb1.new("mb.b16r7.b1", "mb", at="677.5707+(21.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842622.0, assembly_id=103569.0))
lhcb1.new("mcs.b16r7.b1", "mcs", at="684.9947+(22-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247699.0, assembly_id=103569.0))
lhcb1.new("mco.b16r7.b1", "mco_unplugged", at="685.7447+(22-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252730.0, assembly_id=103570.0))
lhcb1.new("mcd.b16r7.b1", "mcd", at="685.7462+(22-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252731.0, assembly_id=103570.0))
lhcb1.new("mb.c16r7.b1", "mb", at="693.2307+(22.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842646.0, assembly_id=103570.0))
lhcb1.new("mcs.c16r7.b1", "mcs", at="700.6547+(23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247704.0, assembly_id=103570.0))
lhcb1.new("bpm.16r7.b1", "bpm", at="701.5337+(23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247706.0, assembly_id=103571.0))
lhcb1.new("mqt.16r7.b1", "mqt", at="702.2877+(23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307597.0, assembly_id=103571.0))
lhcb1.new("mq.16r7.b1", "mq", at="704.2957+(23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308352.0, assembly_id=103571.0))
lhcb1.new("ms.16r7.b1", "ms", at="706.1907+(23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252734.0, assembly_id=103571.0))
lhcb1.new("mcbv.16r7.b1", "mcbv", at="706.7837+(23-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252736.0, assembly_id=103571.0))
lhcb1.new("mb.a17r7.b1", "mb", at="715.3607+(23.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842670.0, assembly_id=103572.0))
lhcb1.new("mcs.a17r7.b1", "mcs", at="722.7847+(24-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247712.0, assembly_id=103572.0))
lhcb1.new("mco.17r7.b1", "mco_unplugged", at="723.5347+(24-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252738.0, assembly_id=103573.0))
lhcb1.new("mcd.17r7.b1", "mcd", at="723.5362+(24-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252739.0, assembly_id=103573.0))
lhcb1.new("mb.b17r7.b1", "mb", at="731.0207+(24.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842694.0, assembly_id=103573.0))
lhcb1.new("mcs.b17r7.b1", "mcs", at="738.4447+(25-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247717.0, assembly_id=103573.0))
lhcb1.new("mb.c17r7.b1", "mb", at="746.6807+(25.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842718.0, assembly_id=103574.0))
lhcb1.new("mcs.c17r7.b1", "mcs", at="754.1047+(26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247720.0, assembly_id=103574.0))
lhcb1.new("bpm.17r7.b1", "bpm", at="754.9837+(26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247722.0, assembly_id=103575.0))
lhcb1.new("mqt.17r7.b1", "mqt", at="755.7377+(26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307391.0, assembly_id=103575.0))
lhcb1.new("mq.17r7.b1", "mq", at="757.7457+(26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308381.0, assembly_id=103575.0))
lhcb1.new("ms.17r7.b1", "ms", at="759.6407+(26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252742.0, assembly_id=103575.0))
lhcb1.new("mcbh.17r7.b1", "mcbh", at="760.2337+(26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252744.0, assembly_id=103575.0))
lhcb1.new("mco.a18r7.b1", "mco_unplugged", at="761.3247+(26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252746.0, assembly_id=103576.0))
lhcb1.new("mcd.a18r7.b1", "mcd", at="761.3262+(26-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252747.0, assembly_id=103576.0))
lhcb1.new("mb.a18r7.b1", "mb", at="768.8107+(26.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842742.0, assembly_id=103576.0))
lhcb1.new("mcs.a18r7.b1", "mcs", at="776.2347+(27-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247730.0, assembly_id=103576.0))
lhcb1.new("mb.b18r7.b1", "mb", at="784.4707+(27.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842766.0, assembly_id=103577.0))
lhcb1.new("mcs.b18r7.b1", "mcs", at="791.8947+(28-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247733.0, assembly_id=103577.0))
lhcb1.new("mco.b18r7.b1", "mco_unplugged", at="792.6447+(28-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252750.0, assembly_id=103578.0))
lhcb1.new("mcd.b18r7.b1", "mcd", at="792.6462+(28-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252751.0, assembly_id=103578.0))
lhcb1.new("mb.c18r7.b1", "mb", at="800.1307+(28.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842790.0, assembly_id=103578.0))
lhcb1.new("mcs.c18r7.b1", "mcs", at="807.5547+(29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247738.0, assembly_id=103578.0))
lhcb1.new("bpm.18r7.b1", "bpm", at="808.4337+(29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247740.0, assembly_id=103579.0))
lhcb1.new("mqt.18r7.b1", "mqt", at="809.1877+(29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307423.0, assembly_id=103579.0))
lhcb1.new("mq.18r7.b1", "mq", at="811.1957+(29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308412.0, assembly_id=103579.0))
lhcb1.new("ms.18r7.b1", "ms", at="813.0907+(29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252754.0, assembly_id=103579.0))
lhcb1.new("mcbv.18r7.b1", "mcbv", at="813.6837+(29-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252756.0, assembly_id=103579.0))
lhcb1.new("mb.a19r7.b1", "mb", at="822.2607+(29.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842814.0, assembly_id=103580.0))
lhcb1.new("mcs.a19r7.b1", "mcs", at="829.6847+(30-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247746.0, assembly_id=103580.0))
lhcb1.new("mco.19r7.b1", "mco_unplugged", at="830.4347+(30-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252758.0, assembly_id=103581.0))
lhcb1.new("mcd.19r7.b1", "mcd", at="830.4362+(30-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252759.0, assembly_id=103581.0))
lhcb1.new("mb.b19r7.b1", "mb", at="837.9207+(30.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842838.0, assembly_id=103581.0))
lhcb1.new("mcs.b19r7.b1", "mcs", at="845.3447+(31-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247751.0, assembly_id=103581.0))
lhcb1.new("mb.c19r7.b1", "mb", at="853.5807+(31.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842862.0, assembly_id=103582.0))
lhcb1.new("mcs.c19r7.b1", "mcs", at="861.0047+(32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247754.0, assembly_id=103582.0))
lhcb1.new("bpm.19r7.b1", "bpm", at="861.8837+(32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247756.0, assembly_id=103583.0))
lhcb1.new("mqt.19r7.b1", "mqt", at="862.6377+(32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307453.0, assembly_id=103583.0))
lhcb1.new("mq.19r7.b1", "mq", at="864.6457+(32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308444.0, assembly_id=103583.0))
lhcb1.new("ms.19r7.b1", "ms", at="866.5407+(32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252762.0, assembly_id=103583.0))
lhcb1.new("mcbh.19r7.b1", "mcbh", at="867.1337+(32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252764.0, assembly_id=103583.0))
lhcb1.new("mco.a20r7.b1", "mco_unplugged", at="868.2247+(32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252766.0, assembly_id=103584.0))
lhcb1.new("mcd.a20r7.b1", "mcd", at="868.2262+(32-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252767.0, assembly_id=103584.0))
lhcb1.new("mb.a20r7.b1", "mb", at="875.7107+(32.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842886.0, assembly_id=103584.0))
lhcb1.new("mcs.a20r7.b1", "mcs", at="883.1347+(33-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247764.0, assembly_id=103584.0))
lhcb1.new("mb.b20r7.b1", "mb", at="891.3707+(33.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842910.0, assembly_id=103585.0))
lhcb1.new("mcs.b20r7.b1", "mcs", at="898.7947+(34-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247767.0, assembly_id=103585.0))
lhcb1.new("mco.b20r7.b1", "mco_unplugged", at="899.5447+(34-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252770.0, assembly_id=103586.0))
lhcb1.new("mcd.b20r7.b1", "mcd", at="899.5462+(34-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252771.0, assembly_id=103586.0))
lhcb1.new("mb.c20r7.b1", "mb", at="907.0307+(34.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842934.0, assembly_id=103586.0))
lhcb1.new("mcs.c20r7.b1", "mcs", at="914.4547+(35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247772.0, assembly_id=103586.0))
lhcb1.new("bpm.20r7.b1", "bpm", at="915.3337+(35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247774.0, assembly_id=103587.0))
lhcb1.new("mqt.20r7.b1", "mqt", at="916.0877+(35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307483.0, assembly_id=103587.0))
lhcb1.new("mq.20r7.b1", "mq", at="918.0957+(35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308234.0, assembly_id=103587.0))
lhcb1.new("ms.20r7.b1", "ms", at="919.9907+(35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252774.0, assembly_id=103587.0))
lhcb1.new("mcbv.20r7.b1", "mcbv", at="920.5837+(35-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252776.0, assembly_id=103587.0))
lhcb1.new("mb.a21r7.b1", "mb", at="929.1607+(35.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842958.0, assembly_id=103588.0))
lhcb1.new("mcs.a21r7.b1", "mcs", at="936.5847+(36-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247780.0, assembly_id=103588.0))
lhcb1.new("mco.21r7.b1", "mco_unplugged", at="937.3347+(36-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252778.0, assembly_id=103589.0))
lhcb1.new("mcd.21r7.b1", "mcd", at="937.3362+(36-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252779.0, assembly_id=103589.0))
lhcb1.new("mb.b21r7.b1", "mb", at="944.8207+(36.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52842982.0, assembly_id=103589.0))
lhcb1.new("mcs.b21r7.b1", "mcs", at="952.2447+(37-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247785.0, assembly_id=103589.0))
lhcb1.new("mb.c21r7.b1", "mb", at="960.4807+(37.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843006.0, assembly_id=103590.0))
lhcb1.new("mcs.c21r7.b1", "mcs", at="967.9047+(38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247788.0, assembly_id=103590.0))
lhcb1.new("bpm.21r7.b1", "bpm", at="968.7837+(38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247790.0, assembly_id=103591.0))
lhcb1.new("mqt.21r7.b1", "mqt", at="969.5377+(38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307281.0, assembly_id=103591.0))
lhcb1.new("mq.21r7.b1", "mq", at="971.5457+(38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308265.0, assembly_id=103591.0))
lhcb1.new("ms.21r7.b1", "ms", at="973.4407+(38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252782.0, assembly_id=103591.0))
lhcb1.new("mcbh.21r7.b1", "mcbh", at="974.0337+(38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252784.0, assembly_id=103591.0))
lhcb1.new("mco.a22r7.b1", "mco_unplugged", at="975.1247+(38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252786.0, assembly_id=103592.0))
lhcb1.new("mcd.a22r7.b1", "mcd", at="975.1262+(38-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252787.0, assembly_id=103592.0))
lhcb1.new("mb.a22r7.b1", "mb", at="982.6107+(38.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843030.0, assembly_id=103592.0))
lhcb1.new("mcs.a22r7.b1", "mcs", at="990.0347+(39-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247798.0, assembly_id=103592.0))
lhcb1.new("mb.b22r7.b1", "mb", at="998.2707+(39.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843054.0, assembly_id=103593.0))
lhcb1.new("mcs.b22r7.b1", "mcs", at="1005.6947+(40-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247801.0, assembly_id=103593.0))
lhcb1.new("mco.b22r7.b1", "mco_unplugged", at="1006.4447+(40-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252790.0, assembly_id=103594.0))
lhcb1.new("mcd.b22r7.b1", "mcd", at="1006.4462+(40-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252791.0, assembly_id=103594.0))
lhcb1.new("mb.c22r7.b1", "mb", at="1013.9307+(40.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843078.0, assembly_id=103594.0))
lhcb1.new("mcs.c22r7.b1", "mcs", at="1021.3547+(41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247806.0, assembly_id=103594.0))
lhcb1.new("bpm.22r7.b1", "bpm", at="1022.2337+(41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247808.0, assembly_id=103595.0))
lhcb1.new("mo.22r7.b1", "mo", at="1022.9847+(41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2348503.0, assembly_id=103595.0))
lhcb1.new("mq.22r7.b1", "mq", at="1024.9957+(41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308297.0, assembly_id=103595.0))
lhcb1.new("ms.22r7.b1", "ms", at="1026.8907+(41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252794.0, assembly_id=103595.0))
lhcb1.new("mcbv.22r7.b1", "mcbv", at="1027.4837+(41-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252796.0, assembly_id=103595.0))
lhcb1.new("mb.a23r7.b1", "mb", at="1036.0607+(41.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843102.0, assembly_id=103596.0))
lhcb1.new("mcs.a23r7.b1", "mcs", at="1043.4847+(42-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247814.0, assembly_id=103596.0))
lhcb1.new("mco.23r7.b1", "mco_unplugged", at="1044.2347+(42-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252798.0, assembly_id=103597.0))
lhcb1.new("mcd.23r7.b1", "mcd", at="1044.2362+(42-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252799.0, assembly_id=103597.0))
lhcb1.new("mb.b23r7.b1", "mb", at="1051.7207+(42.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843126.0, assembly_id=103597.0))
lhcb1.new("mcs.b23r7.b1", "mcs", at="1059.1447+(43-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247819.0, assembly_id=103597.0))
lhcb1.new("mb.c23r7.b1", "mb", at="1067.3807+(43.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843150.0, assembly_id=103598.0))
lhcb1.new("mcs.c23r7.b1", "mcs", at="1074.8047+(44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247822.0, assembly_id=103598.0))
lhcb1.new("bpm.23r7.b1", "bpm", at="1075.6837+(44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247824.0, assembly_id=103599.0))
lhcb1.new("mqs.23r7.b1", "mqs", at="1076.4377+(44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307647.0, assembly_id=103599.0))
lhcb1.new("mq.23r7.b1", "mq", at="1078.4457+(44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308086.0, assembly_id=103599.0))
lhcb1.new("ms.23r7.b1", "ms", at="1080.3407+(44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252802.0, assembly_id=103599.0))
lhcb1.new("mcbh.23r7.b1", "mcbh", at="1080.9337+(44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252804.0, assembly_id=103599.0))
lhcb1.new("mco.a24r7.b1", "mco_unplugged", at="1082.0247+(44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252806.0, assembly_id=103600.0))
lhcb1.new("mcd.a24r7.b1", "mcd", at="1082.0262+(44-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252807.0, assembly_id=103600.0))
lhcb1.new("mb.a24r7.b1", "mb", at="1089.5107+(44.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843174.0, assembly_id=103600.0))
lhcb1.new("mcs.a24r7.b1", "mcs", at="1096.9347+(45-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247832.0, assembly_id=103600.0))
lhcb1.new("mb.b24r7.b1", "mb", at="1105.1707+(45.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843198.0, assembly_id=103601.0))
lhcb1.new("mcs.b24r7.b1", "mcs", at="1112.5947+(46-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247835.0, assembly_id=103601.0))
lhcb1.new("mco.b24r7.b1", "mco_unplugged", at="1113.3447+(46-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252810.0, assembly_id=103602.0))
lhcb1.new("mcd.b24r7.b1", "mcd", at="1113.3462+(46-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252811.0, assembly_id=103602.0))
lhcb1.new("mb.c24r7.b1", "mb", at="1120.8307+(46.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843222.0, assembly_id=103602.0))
lhcb1.new("mcs.c24r7.b1", "mcs", at="1128.2547+(47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247840.0, assembly_id=103602.0))
lhcb1.new("bpm.24r7.b1", "bpm", at="1129.1337+(47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247842.0, assembly_id=103603.0))
lhcb1.new("mo.24r7.b1", "mo", at="1129.8847+(47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308855.0, assembly_id=103603.0))
lhcb1.new("mq.24r7.b1", "mq", at="1131.8957+(47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308118.0, assembly_id=103603.0))
lhcb1.new("ms.24r7.b1", "ms", at="1133.7907+(47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252814.0, assembly_id=103603.0))
lhcb1.new("mcbv.24r7.b1", "mcbv", at="1134.3837+(47-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252816.0, assembly_id=103603.0))
lhcb1.new("mb.a25r7.b1", "mb", at="1142.9607+(47.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843246.0, assembly_id=103604.0))
lhcb1.new("mcs.a25r7.b1", "mcs", at="1150.3847+(48-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247848.0, assembly_id=103604.0))
lhcb1.new("mco.25r7.b1", "mco_unplugged", at="1151.1347+(48-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252818.0, assembly_id=103605.0))
lhcb1.new("mcd.25r7.b1", "mcd", at="1151.1362+(48-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252819.0, assembly_id=103605.0))
lhcb1.new("mb.b25r7.b1", "mb", at="1158.6207+(48.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843270.0, assembly_id=103605.0))
lhcb1.new("mcs.b25r7.b1", "mcs", at="1166.0447+(49-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247853.0, assembly_id=103605.0))
lhcb1.new("mb.c25r7.b1", "mb", at="1174.2807+(49.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843294.0, assembly_id=103606.0))
lhcb1.new("mcs.c25r7.b1", "mcs", at="1181.7047+(50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247856.0, assembly_id=103606.0))
lhcb1.new("bpm.25r7.b1", "bpm", at="1182.5837+(50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247858.0, assembly_id=103607.0))
lhcb1.new("mo.25r7.b1", "mo", at="1183.3347+(50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308887.0, assembly_id=103607.0))
lhcb1.new("mq.25r7.b1", "mq", at="1185.3457+(50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308150.0, assembly_id=103607.0))
lhcb1.new("ms.25r7.b1", "ms", at="1187.2407+(50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252822.0, assembly_id=103607.0))
lhcb1.new("mcbh.25r7.b1", "mcbh", at="1187.8337+(50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252824.0, assembly_id=103607.0))
lhcb1.new("mco.a26r7.b1", "mco_unplugged", at="1188.9247+(50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252826.0, assembly_id=103608.0))
lhcb1.new("mcd.a26r7.b1", "mcd", at="1188.9262+(50-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252827.0, assembly_id=103608.0))
lhcb1.new("mb.a26r7.b1", "mb", at="1196.4107+(50.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843318.0, assembly_id=103608.0))
lhcb1.new("mcs.a26r7.b1", "mcs", at="1203.8347+(51-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247866.0, assembly_id=103608.0))
lhcb1.new("mb.b26r7.b1", "mb", at="1212.0707+(51.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843342.0, assembly_id=103609.0))
lhcb1.new("mcs.b26r7.b1", "mcs", at="1219.4947+(52-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247869.0, assembly_id=103609.0))
lhcb1.new("mco.b26r7.b1", "mco_unplugged", at="1220.2447+(52-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252830.0, assembly_id=103610.0))
lhcb1.new("mcd.b26r7.b1", "mcd", at="1220.2462+(52-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252831.0, assembly_id=103610.0))
lhcb1.new("mb.c26r7.b1", "mb", at="1227.7307+(52.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843366.0, assembly_id=103610.0))
lhcb1.new("mcs.c26r7.b1", "mcs", at="1235.1547+(53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247874.0, assembly_id=103610.0))
lhcb1.new("bpm.26r7.b1", "bpm", at="1236.0337+(53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247876.0, assembly_id=103611.0))
lhcb1.new("mo.26r7.b1", "mo", at="1236.7847+(53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308918.0, assembly_id=103611.0))
lhcb1.new("mq.26r7.b1", "mq", at="1238.7957+(53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308180.0, assembly_id=103611.0))
lhcb1.new("ms.26r7.b1", "ms", at="1240.6907+(53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252834.0, assembly_id=103611.0))
lhcb1.new("mcbv.26r7.b1", "mcbv", at="1241.2837+(53-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252836.0, assembly_id=103611.0))
lhcb1.new("mb.a27r7.b1", "mb", at="1249.8607+(53.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843390.0, assembly_id=103612.0))
lhcb1.new("mcs.a27r7.b1", "mcs", at="1257.2847+(54-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247882.0, assembly_id=103612.0))
lhcb1.new("mco.27r7.b1", "mco_unplugged", at="1258.0347+(54-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252838.0, assembly_id=103613.0))
lhcb1.new("mcd.27r7.b1", "mcd", at="1258.0362+(54-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252839.0, assembly_id=103613.0))
lhcb1.new("mb.b27r7.b1", "mb", at="1265.5207+(54.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843414.0, assembly_id=103613.0))
lhcb1.new("mcs.b27r7.b1", "mcs", at="1272.9447+(55-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247887.0, assembly_id=103613.0))
lhcb1.new("mb.c27r7.b1", "mb", at="1281.1807+(55.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843438.0, assembly_id=103614.0))
lhcb1.new("mcs.c27r7.b1", "mcs", at="1288.6047+(56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247890.0, assembly_id=103614.0))
lhcb1.new("bpm.27r7.b1", "bpm", at="1289.4837+(56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247892.0, assembly_id=103615.0))
lhcb1.new("mqs.27r7.b1", "mqs", at="1290.2377+(56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307679.0, assembly_id=103615.0))
lhcb1.new("mq.27r7.b1", "mq", at="1292.2457+(56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307970.0, assembly_id=103615.0))
lhcb1.new("ms.27r7.b1", "ms", at="1294.1407+(56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252842.0, assembly_id=103615.0))
lhcb1.new("mcbh.27r7.b1", "mcbh", at="1294.7337+(56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252844.0, assembly_id=103615.0))
lhcb1.new("mco.a28r7.b1", "mco_unplugged", at="1295.8247+(56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252846.0, assembly_id=103616.0))
lhcb1.new("mcd.a28r7.b1", "mcd", at="1295.8262+(56-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252847.0, assembly_id=103616.0))
lhcb1.new("mb.a28r7.b1", "mb", at="1303.3107+(56.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843462.0, assembly_id=103616.0))
lhcb1.new("mcs.a28r7.b1", "mcs", at="1310.7347+(57-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247900.0, assembly_id=103616.0))
lhcb1.new("mb.b28r7.b1", "mb", at="1318.9707+(57.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843486.0, assembly_id=103617.0))
lhcb1.new("mcs.b28r7.b1", "mcs", at="1326.3947+(58-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247903.0, assembly_id=103617.0))
lhcb1.new("mco.b28r7.b1", "mco_unplugged", at="1327.1447+(58-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252850.0, assembly_id=103618.0))
lhcb1.new("mcd.b28r7.b1", "mcd", at="1327.1462+(58-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252851.0, assembly_id=103618.0))
lhcb1.new("mb.c28r7.b1", "mb", at="1334.6307+(58.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843510.0, assembly_id=103618.0))
lhcb1.new("mcs.c28r7.b1", "mcs", at="1342.0547+(59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247908.0, assembly_id=103618.0))
lhcb1.new("bpm.28r7.b1", "bpm", at="1342.9337+(59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247910.0, assembly_id=103619.0))
lhcb1.new("mo.28r7.b1", "mo", at="1343.6847+(59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308708.0, assembly_id=103619.0))
lhcb1.new("mq.28r7.b1", "mq", at="1345.6957+(59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308002.0, assembly_id=103619.0))
lhcb1.new("ms.28r7.b1", "ms", at="1347.5907+(59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252854.0, assembly_id=103619.0))
lhcb1.new("mcbv.28r7.b1", "mcbv", at="1348.1837+(59-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252856.0, assembly_id=103619.0))
lhcb1.new("mb.a29r7.b1", "mb", at="1356.7607+(59.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843534.0, assembly_id=103620.0))
lhcb1.new("mcs.a29r7.b1", "mcs", at="1364.1847+(60-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247916.0, assembly_id=103620.0))
lhcb1.new("mco.29r7.b1", "mco_unplugged", at="1364.9347+(60-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252858.0, assembly_id=103621.0))
lhcb1.new("mcd.29r7.b1", "mcd", at="1364.9362+(60-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252859.0, assembly_id=103621.0))
lhcb1.new("mb.b29r7.b1", "mb", at="1372.4207+(60.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843558.0, assembly_id=103621.0))
lhcb1.new("mcs.b29r7.b1", "mcs", at="1379.8447+(61-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247921.0, assembly_id=103621.0))
lhcb1.new("mb.c29r7.b1", "mb", at="1388.0807+(61.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843582.0, assembly_id=103622.0))
lhcb1.new("mcs.c29r7.b1", "mcs", at="1395.5047+(62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247924.0, assembly_id=103622.0))
lhcb1.new("bpm.29r7.b1", "bpm", at="1396.3837+(62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247926.0, assembly_id=103623.0))
lhcb1.new("mo.29r7.b1", "mo", at="1397.1347+(62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308740.0, assembly_id=103623.0))
lhcb1.new("mq.29r7.b1", "mq", at="1399.1457+(62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308032.0, assembly_id=103623.0))
lhcb1.new("mss.29r7.b1", "mss", at="1401.0407+(62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252862.0, assembly_id=103623.0))
lhcb1.new("mcbh.29r7.b1", "mcbh", at="1401.6337+(62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252864.0, assembly_id=103623.0))
lhcb1.new("mco.a30r7.b1", "mco_unplugged", at="1402.7247+(62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252866.0, assembly_id=103624.0))
lhcb1.new("mcd.a30r7.b1", "mcd", at="1402.7262+(62-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252867.0, assembly_id=103624.0))
lhcb1.new("mb.a30r7.b1", "mb", at="1410.2107+(62.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843606.0, assembly_id=103624.0))
lhcb1.new("mcs.a30r7.b1", "mcs", at="1417.6347+(63-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247934.0, assembly_id=103624.0))
lhcb1.new("mb.b30r7.b1", "mb", at="1425.8707+(63.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843630.0, assembly_id=103625.0))
lhcb1.new("mcs.b30r7.b1", "mcs", at="1433.2947+(64-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247937.0, assembly_id=103625.0))
lhcb1.new("mco.b30r7.b1", "mco_unplugged", at="1434.0447+(64-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252870.0, assembly_id=103626.0))
lhcb1.new("mcd.b30r7.b1", "mcd", at="1434.0462+(64-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252871.0, assembly_id=103626.0))
lhcb1.new("mb.c30r7.b1", "mb", at="1441.5307+(64.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843654.0, assembly_id=103626.0))
lhcb1.new("mcs.c30r7.b1", "mcs", at="1448.9547+(65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247942.0, assembly_id=103626.0))
lhcb1.new("bpm.30r7.b1", "bpm", at="1449.8337+(65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247944.0, assembly_id=103627.0))
lhcb1.new("mo.30r7.b1", "mo", at="1450.5847+(65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308771.0, assembly_id=103627.0))
lhcb1.new("mq.30r7.b1", "mq", at="1452.5957+(65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308062.0, assembly_id=103627.0))
lhcb1.new("ms.30r7.b1", "ms", at="1454.4907+(65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252874.0, assembly_id=103627.0))
lhcb1.new("mcbv.30r7.b1", "mcbv", at="1455.0837+(65-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252876.0, assembly_id=103627.0))
lhcb1.new("mb.a31r7.b1", "mb", at="1463.6607+(65.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843678.0, assembly_id=103628.0))
lhcb1.new("mcs.a31r7.b1", "mcs", at="1471.0847+(66-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247950.0, assembly_id=103628.0))
lhcb1.new("mco.31r7.b1", "mco_unplugged", at="1471.8347+(66-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252878.0, assembly_id=103629.0))
lhcb1.new("mcd.31r7.b1", "mcd", at="1471.8362+(66-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252879.0, assembly_id=103629.0))
lhcb1.new("mb.b31r7.b1", "mb", at="1479.3207+(66.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843702.0, assembly_id=103629.0))
lhcb1.new("mcs.b31r7.b1", "mcs", at="1486.7447+(67-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247955.0, assembly_id=103629.0))
lhcb1.new("mb.c31r7.b1", "mb", at="1494.9807+(67.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843726.0, assembly_id=103630.0))
lhcb1.new("mcs.c31r7.b1", "mcs", at="1502.4047+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247958.0, assembly_id=103630.0))
lhcb1.new("bpm.31r7.b1", "bpm", at="1503.2837+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247960.0, assembly_id=103631.0))
lhcb1.new("mo.31r7.b1", "mo", at="1504.0347+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308800.0, assembly_id=103631.0))
lhcb1.new("mq.31r7.b1", "mq", at="1506.0457+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307854.0, assembly_id=103631.0))
lhcb1.new("ms.31r7.b1", "ms", at="1507.9407+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252882.0, assembly_id=103631.0))
lhcb1.new("mcbh.31r7.b1", "mcbh_unplugged", at="1508.5337+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252884.0, assembly_id=103631.0))
lhcb1.new("s.cell.78.b1", "omk", at="1509.2807+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a32r7.b1", "mco_unplugged", at="1509.6247+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252886.0, assembly_id=103632.0))
lhcb1.new("mcd.a32r7.b1", "mcd", at="1509.6262+(68-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252887.0, assembly_id=103632.0))
lhcb1.new("mb.a32r7.b1", "mb", at="1517.1107+(68.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843750.0, assembly_id=103632.0))
lhcb1.new("mcs.a32r7.b1", "mcs", at="1524.5347+(69-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247968.0, assembly_id=103632.0))
lhcb1.new("mb.b32r7.b1", "mb", at="1532.7707+(69.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843774.0, assembly_id=103633.0))
lhcb1.new("mcs.b32r7.b1", "mcs", at="1540.1947+(70-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247971.0, assembly_id=103633.0))
lhcb1.new("mco.b32r7.b1", "mco_unplugged", at="1540.9447+(70-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252890.0, assembly_id=103634.0))
lhcb1.new("mcd.b32r7.b1", "mcd", at="1540.9462+(70-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252891.0, assembly_id=103634.0))
lhcb1.new("mb.c32r7.b1", "mb", at="1548.4307+(70.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843798.0, assembly_id=103634.0))
lhcb1.new("mcs.c32r7.b1", "mcs", at="1555.8547+(71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247976.0, assembly_id=103634.0))
lhcb1.new("bpm.32r7.b1", "bpm", at="1556.7337+(71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247978.0, assembly_id=103635.0))
lhcb1.new("mo.32r7.b1", "mo", at="1557.4847+(71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308593.0, assembly_id=103635.0))
lhcb1.new("mq.32r7.b1", "mq", at="1559.4957+(71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307884.0, assembly_id=103635.0))
lhcb1.new("ms.32r7.b1", "ms", at="1561.3907+(71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252894.0, assembly_id=103635.0))
lhcb1.new("mcbv.32r7.b1", "mcbv", at="1561.9837+(71-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252896.0, assembly_id=103635.0))
lhcb1.new("mb.a33r7.b1", "mb", at="1570.5607+(71.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843822.0, assembly_id=103636.0))
lhcb1.new("mcs.a33r7.b1", "mcs", at="1577.9847+(72-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247984.0, assembly_id=103636.0))
lhcb1.new("mco.33r7.b1", "mco_unplugged", at="1578.7347+(72-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252898.0, assembly_id=103637.0))
lhcb1.new("mcd.33r7.b1", "mcd", at="1578.7362+(72-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252899.0, assembly_id=103637.0))
lhcb1.new("mb.b33r7.b1", "mb", at="1586.2207+(72.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843846.0, assembly_id=103637.0))
lhcb1.new("mcs.b33r7.b1", "mcs", at="1593.6447+(73-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247989.0, assembly_id=103637.0))
lhcb1.new("mb.c33r7.b1", "mb", at="1601.8807+(73.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843870.0, assembly_id=103638.0))
lhcb1.new("mcs.c33r7.b1", "mcs", at="1609.3047+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247992.0, assembly_id=103638.0))
lhcb1.new("bpm.33r7.b1", "bpm", at="1610.1837+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=247994.0, assembly_id=103639.0))
lhcb1.new("mo.33r7.b1", "mo", at="1610.9347+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2348492.0, assembly_id=103639.0))
lhcb1.new("mq.33r7.b1", "mq", at="1612.9457+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2348461.0, assembly_id=103639.0))
lhcb1.new("mss.33r7.b1", "mss", at="1614.8407+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252902.0, assembly_id=103639.0))
lhcb1.new("mcbh.33r7.b1", "mcbh", at="1615.4337+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252904.0, assembly_id=103639.0))
lhcb1.new("e.cell.78.b1", "omk", at="1616.1807+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a34r7.b1", "mco_unplugged", at="1616.5247+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252906.0, assembly_id=103640.0))
lhcb1.new("mcd.a34r7.b1", "mcd", at="1616.5262+(74-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252907.0, assembly_id=103640.0))
lhcb1.new("mb.a34r7.b1", "mb", at="1624.0107+(74.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843894.0, assembly_id=103640.0))
lhcb1.new("mcs.a34r7.b1", "mcs", at="1631.4347+(75-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=248002.0, assembly_id=103640.0))
lhcb1.new("mb.b34r7.b1", "mb", at="1639.6707+(75.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843918.0, assembly_id=103641.0))
lhcb1.new("mcs.b34r7.b1", "mcs", at="1647.0947+(76-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=248005.0, assembly_id=103641.0))
lhcb1.new("mco.b34r7.b1", "mco_unplugged", at="1647.8447+(76-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252910.0, assembly_id=103642.0))
lhcb1.new("mcd.b34r7.b1", "mcd", at="1647.8462+(76-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=252911.0, assembly_id=103642.0))
lhcb1.new("mb.c34r7.b1", "mb", at="1655.3307+(76.5-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=52843942.0, assembly_id=103642.0))
lhcb1.new("mcs.c34r7.b1", "mcs", at="1662.7547+(77-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=248010.0, assembly_id=103642.0))
lhcb1.new("bpm.34r7.b1", "bpm", at="1663.6337+(77-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=248012.0, assembly_id=103643.0))
lhcb1.new("mo.34r7.b1", "mo", at="1664.3847+(77-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2308638.0, assembly_id=103643.0))
lhcb1.new("mq.34r7.b1", "mq", at="1666.3957+(77-ip7ofs.b1)*ds", from_="ip7", extra=dict(mech_sep=0.194, slot_id=2307928.0, assembly_id=103643.0))
lhcb1.new("ms.34l8.b1", "ms", at="-1652.8497+(77-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252914.0, assembly_id=103643.0))
lhcb1.new("mcbv.34l8.b1", "mcbv", at="-1652.2567+(77-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252916.0, assembly_id=103643.0))
lhcb1.new("mb.c34l8.b1", "mb", at="-1643.6797+(77.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52843966.0, assembly_id=103644.0))
lhcb1.new("mcs.c34l8.b1", "mcs", at="-1636.2557+(78-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248018.0, assembly_id=103644.0))
lhcb1.new("mco.34l8.b1", "mco_unplugged", at="-1635.5057+(78-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252918.0, assembly_id=103645.0))
lhcb1.new("mcd.34l8.b1", "mcd", at="-1635.5042+(78-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252919.0, assembly_id=103645.0))
lhcb1.new("mb.b34l8.b1", "mb", at="-1628.0197+(78.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52843990.0, assembly_id=103645.0))
lhcb1.new("mcs.b34l8.b1", "mcs", at="-1620.5957+(79-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248023.0, assembly_id=103645.0))
lhcb1.new("mb.a34l8.b1", "mb", at="-1612.3597+(79.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844014.0, assembly_id=103646.0))
lhcb1.new("mcs.a34l8.b1", "mcs", at="-1604.9357+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248026.0, assembly_id=103646.0))
lhcb1.new("bpm.33l8.b1", "bpm", at="-1604.0567+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248028.0, assembly_id=103647.0))
lhcb1.new("mo.33l8.b1", "mo", at="-1603.3057+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2348491.0, assembly_id=103647.0))
lhcb1.new("mq.33l8.b1", "mq", at="-1601.2947+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2348460.0, assembly_id=103647.0))
lhcb1.new("mss.33l8.b1", "mss", at="-1599.3997+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252922.0, assembly_id=103647.0))
lhcb1.new("mcbh.33l8.b1", "mcbh", at="-1598.8067+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252924.0, assembly_id=103647.0))
lhcb1.new("mco.b33l8.b1", "mco_unplugged", at="-1597.7157+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252926.0, assembly_id=103648.0))
lhcb1.new("mcd.b33l8.b1", "mcd", at="-1597.7142+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252927.0, assembly_id=103648.0))
lhcb1.new("mb.c33l8.b1", "mb", at="-1590.2297+(80.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844038.0, assembly_id=103648.0))
lhcb1.new("mcs.c33l8.b1", "mcs", at="-1582.8057+(81-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248036.0, assembly_id=103648.0))
lhcb1.new("mb.b33l8.b1", "mb", at="-1574.5697+(81.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844062.0, assembly_id=103649.0))
lhcb1.new("mcs.b33l8.b1", "mcs", at="-1567.1457+(82-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248039.0, assembly_id=103649.0))
lhcb1.new("mco.a33l8.b1", "mco_unplugged", at="-1566.3957+(82-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252930.0, assembly_id=103650.0))
lhcb1.new("mcd.a33l8.b1", "mcd", at="-1566.3942+(82-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252931.0, assembly_id=103650.0))
lhcb1.new("mb.a33l8.b1", "mb", at="-1558.9097+(82.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844086.0, assembly_id=103650.0))
lhcb1.new("mcs.a33l8.b1", "mcs", at="-1551.4857+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248044.0, assembly_id=103650.0))
lhcb1.new("bpm.32l8.b1", "bpm", at="-1550.6067+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248046.0, assembly_id=103651.0))
lhcb1.new("mo.32l8.b1", "mo", at="-1549.8557+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308579.0, assembly_id=103651.0))
lhcb1.new("mq.32l8.b1", "mq", at="-1547.8447+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307871.0, assembly_id=103651.0))
lhcb1.new("ms.32l8.b1", "ms", at="-1545.9497+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252934.0, assembly_id=103651.0))
lhcb1.new("mcbv.32l8.b1", "mcbv", at="-1545.3567+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252936.0, assembly_id=103651.0))
lhcb1.new("mb.c32l8.b1", "mb", at="-1536.7797+(83.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844110.0, assembly_id=103652.0))
lhcb1.new("mcs.c32l8.b1", "mcs", at="-1529.3557+(84-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248052.0, assembly_id=103652.0))
lhcb1.new("mco.32l8.b1", "mco_unplugged", at="-1528.6057+(84-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252938.0, assembly_id=103653.0))
lhcb1.new("mcd.32l8.b1", "mcd", at="-1528.6042+(84-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252939.0, assembly_id=103653.0))
lhcb1.new("mb.b32l8.b1", "mb", at="-1521.1197+(84.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844134.0, assembly_id=103653.0))
lhcb1.new("mcs.b32l8.b1", "mcs", at="-1513.6957+(85-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248057.0, assembly_id=103653.0))
lhcb1.new("mb.a32l8.b1", "mb", at="-1505.4597+(85.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844158.0, assembly_id=103654.0))
lhcb1.new("mcs.a32l8.b1", "mcs", at="-1498.0357+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248060.0, assembly_id=103654.0))
lhcb1.new("bpm.31l8.b1", "bpm", at="-1497.1567+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248062.0, assembly_id=103655.0))
lhcb1.new("mo.31l8.b1", "mo", at="-1496.4057+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308787.0, assembly_id=103655.0))
lhcb1.new("mq.31l8.b1", "mq", at="-1494.3947+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308079.0, assembly_id=103655.0))
lhcb1.new("ms.31l8.b1", "ms", at="-1492.4997+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252942.0, assembly_id=103655.0))
lhcb1.new("mcbh.31l8.b1", "mcbh", at="-1491.9067+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252944.0, assembly_id=103655.0))
lhcb1.new("mco.b31l8.b1", "mco_unplugged", at="-1490.8157+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252946.0, assembly_id=103656.0))
lhcb1.new("mcd.b31l8.b1", "mcd", at="-1490.8142+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252947.0, assembly_id=103656.0))
lhcb1.new("mb.c31l8.b1", "mb", at="-1483.3297+(86.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844182.0, assembly_id=103656.0))
lhcb1.new("mcs.c31l8.b1", "mcs", at="-1475.9057+(87-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248070.0, assembly_id=103656.0))
lhcb1.new("mb.b31l8.b1", "mb", at="-1467.6697+(87.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844206.0, assembly_id=103657.0))
lhcb1.new("mcs.b31l8.b1", "mcs", at="-1460.2457+(88-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248073.0, assembly_id=103657.0))
lhcb1.new("mco.a31l8.b1", "mco_unplugged", at="-1459.4957+(88-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252950.0, assembly_id=103658.0))
lhcb1.new("mcd.a31l8.b1", "mcd", at="-1459.4942+(88-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252951.0, assembly_id=103658.0))
lhcb1.new("mb.a31l8.b1", "mb", at="-1452.0097+(88.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844230.0, assembly_id=103658.0))
lhcb1.new("mcs.a31l8.b1", "mcs", at="-1444.5857+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248078.0, assembly_id=103658.0))
lhcb1.new("bpm.30l8.b1", "bpm", at="-1443.7067+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248080.0, assembly_id=103659.0))
lhcb1.new("mo.30l8.b1", "mo", at="-1442.9557+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308758.0, assembly_id=103659.0))
lhcb1.new("mq.30l8.b1", "mq", at="-1440.9447+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308049.0, assembly_id=103659.0))
lhcb1.new("ms.30l8.b1", "ms", at="-1439.0497+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252954.0, assembly_id=103659.0))
lhcb1.new("mcbv.30l8.b1", "mcbv", at="-1438.4567+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252956.0, assembly_id=103659.0))
lhcb1.new("mb.c30l8.b1", "mb", at="-1429.8797+(89.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844254.0, assembly_id=103660.0))
lhcb1.new("mcs.c30l8.b1", "mcs", at="-1422.4557+(90-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248086.0, assembly_id=103660.0))
lhcb1.new("mco.30l8.b1", "mco_unplugged", at="-1421.7057+(90-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252958.0, assembly_id=103661.0))
lhcb1.new("mcd.30l8.b1", "mcd", at="-1421.7042+(90-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252959.0, assembly_id=103661.0))
lhcb1.new("mb.b30l8.b1", "mb", at="-1414.2197+(90.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844278.0, assembly_id=103661.0))
lhcb1.new("mcs.b30l8.b1", "mcs", at="-1406.7957+(91-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248091.0, assembly_id=103661.0))
lhcb1.new("mb.a30l8.b1", "mb", at="-1398.5597+(91.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844302.0, assembly_id=103662.0))
lhcb1.new("mcs.a30l8.b1", "mcs", at="-1391.1357+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248094.0, assembly_id=103662.0))
lhcb1.new("bpm.29l8.b1", "bpm", at="-1390.2567+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248096.0, assembly_id=103663.0))
lhcb1.new("mo.29l8.b1", "mo", at="-1389.5057+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308726.0, assembly_id=103663.0))
lhcb1.new("mq.29l8.b1", "mq", at="-1387.4947+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308019.0, assembly_id=103663.0))
lhcb1.new("mss.29l8.b1", "mss", at="-1385.5997+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252962.0, assembly_id=103663.0))
lhcb1.new("mcbh.29l8.b1", "mcbh", at="-1385.0067+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252964.0, assembly_id=103663.0))
lhcb1.new("mco.b29l8.b1", "mco_unplugged", at="-1383.9157+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252966.0, assembly_id=103664.0))
lhcb1.new("mcd.b29l8.b1", "mcd", at="-1383.9142+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252967.0, assembly_id=103664.0))
lhcb1.new("mb.c29l8.b1", "mb", at="-1376.4297+(92.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844326.0, assembly_id=103664.0))
lhcb1.new("mcs.c29l8.b1", "mcs", at="-1369.0057+(93-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248104.0, assembly_id=103664.0))
lhcb1.new("mb.b29l8.b1", "mb", at="-1360.7697+(93.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844350.0, assembly_id=103665.0))
lhcb1.new("mcs.b29l8.b1", "mcs", at="-1353.3457+(94-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248107.0, assembly_id=103665.0))
lhcb1.new("mco.a29l8.b1", "mco_unplugged", at="-1352.5957+(94-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252970.0, assembly_id=103666.0))
lhcb1.new("mcd.a29l8.b1", "mcd", at="-1352.5942+(94-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252971.0, assembly_id=103666.0))
lhcb1.new("mb.a29l8.b1", "mb", at="-1345.1097+(94.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844374.0, assembly_id=103666.0))
lhcb1.new("mcs.a29l8.b1", "mcs", at="-1337.6857+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248112.0, assembly_id=103666.0))
lhcb1.new("bpm.28l8.b1", "bpm", at="-1336.8067+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248114.0, assembly_id=103667.0))
lhcb1.new("mo.28l8.b1", "mo", at="-1336.0557+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308694.0, assembly_id=103667.0))
lhcb1.new("mq.28l8.b1", "mq", at="-1334.0447+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307988.0, assembly_id=103667.0))
lhcb1.new("ms.28l8.b1", "ms", at="-1332.1497+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252974.0, assembly_id=103667.0))
lhcb1.new("mcbv.28l8.b1", "mcbv", at="-1331.5567+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252976.0, assembly_id=103667.0))
lhcb1.new("mb.c28l8.b1", "mb", at="-1322.9797+(95.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844398.0, assembly_id=103668.0))
lhcb1.new("mcs.c28l8.b1", "mcs", at="-1315.5557+(96-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248120.0, assembly_id=103668.0))
lhcb1.new("mco.28l8.b1", "mco_unplugged", at="-1314.8057+(96-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252978.0, assembly_id=103669.0))
lhcb1.new("mcd.28l8.b1", "mcd", at="-1314.8042+(96-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252979.0, assembly_id=103669.0))
lhcb1.new("mb.b28l8.b1", "mb", at="-1307.3197+(96.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844422.0, assembly_id=103669.0))
lhcb1.new("mcs.b28l8.b1", "mcs", at="-1299.8957+(97-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248125.0, assembly_id=103669.0))
lhcb1.new("mb.a28l8.b1", "mb", at="-1291.6597+(97.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844446.0, assembly_id=103670.0))
lhcb1.new("mcs.a28l8.b1", "mcs", at="-1284.2357+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248128.0, assembly_id=103670.0))
lhcb1.new("bpm.27l8.b1", "bpm", at="-1283.3567+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248130.0, assembly_id=103671.0))
lhcb1.new("mqs.27l8.b1", "mqs", at="-1282.6027+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307665.0, assembly_id=103671.0))
lhcb1.new("mq.27l8.b1", "mq", at="-1280.5947+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308197.0, assembly_id=103671.0))
lhcb1.new("ms.27l8.b1", "ms", at="-1278.6997+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252982.0, assembly_id=103671.0))
lhcb1.new("mcbh.27l8.b1", "mcbh", at="-1278.1067+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252984.0, assembly_id=103671.0))
lhcb1.new("mco.b27l8.b1", "mco_unplugged", at="-1277.0157+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252986.0, assembly_id=103672.0))
lhcb1.new("mcd.b27l8.b1", "mcd", at="-1277.0142+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252987.0, assembly_id=103672.0))
lhcb1.new("mb.c27l8.b1", "mb", at="-1269.5297+(98.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844470.0, assembly_id=103672.0))
lhcb1.new("mcs.c27l8.b1", "mcs", at="-1262.1057+(99-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248138.0, assembly_id=103672.0))
lhcb1.new("mb.b27l8.b1", "mb", at="-1253.8697+(99.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844494.0, assembly_id=103673.0))
lhcb1.new("mcs.b27l8.b1", "mcs", at="-1246.4457+(100-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248141.0, assembly_id=103673.0))
lhcb1.new("mco.a27l8.b1", "mco_unplugged", at="-1245.6957+(100-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252990.0, assembly_id=103674.0))
lhcb1.new("mcd.a27l8.b1", "mcd", at="-1245.6942+(100-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252991.0, assembly_id=103674.0))
lhcb1.new("mb.a27l8.b1", "mb", at="-1238.2097+(100.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844518.0, assembly_id=103674.0))
lhcb1.new("mcs.a27l8.b1", "mcs", at="-1230.7857+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248146.0, assembly_id=103674.0))
lhcb1.new("bpm.26l8.b1", "bpm", at="-1229.9067+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248148.0, assembly_id=103675.0))
lhcb1.new("mo.26l8.b1", "mo", at="-1229.1557+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308905.0, assembly_id=103675.0))
lhcb1.new("mq.26l8.b1", "mq", at="-1227.1447+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308167.0, assembly_id=103675.0))
lhcb1.new("ms.26l8.b1", "ms", at="-1225.2497+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252994.0, assembly_id=103675.0))
lhcb1.new("mcbv.26l8.b1", "mcbv", at="-1224.6567+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252996.0, assembly_id=103675.0))
lhcb1.new("mb.c26l8.b1", "mb", at="-1216.0797+(101.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844542.0, assembly_id=103676.0))
lhcb1.new("mcs.c26l8.b1", "mcs", at="-1208.6557+(102-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248154.0, assembly_id=103676.0))
lhcb1.new("mco.26l8.b1", "mco_unplugged", at="-1207.9057+(102-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252998.0, assembly_id=103677.0))
lhcb1.new("mcd.26l8.b1", "mcd", at="-1207.9042+(102-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=252999.0, assembly_id=103677.0))
lhcb1.new("mb.b26l8.b1", "mb", at="-1200.4197+(102.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844566.0, assembly_id=103677.0))
lhcb1.new("mcs.b26l8.b1", "mcs", at="-1192.9957+(103-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248159.0, assembly_id=103677.0))
lhcb1.new("mb.a26l8.b1", "mb", at="-1184.7597+(103.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844590.0, assembly_id=103678.0))
lhcb1.new("mcs.a26l8.b1", "mcs", at="-1177.3357+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248162.0, assembly_id=103678.0))
lhcb1.new("bpm.25l8.b1", "bpm", at="-1176.4567+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248164.0, assembly_id=103679.0))
lhcb1.new("mo.25l8.b1", "mo", at="-1175.7057+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308873.0, assembly_id=103679.0))
lhcb1.new("mq.25l8.b1", "mq", at="-1173.6947+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308136.0, assembly_id=103679.0))
lhcb1.new("ms.25l8.b1", "ms", at="-1171.7997+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253002.0, assembly_id=103679.0))
lhcb1.new("mcbh.25l8.b1", "mcbh", at="-1171.2067+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253004.0, assembly_id=103679.0))
lhcb1.new("mco.b25l8.b1", "mco_unplugged", at="-1170.1157+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253006.0, assembly_id=103680.0))
lhcb1.new("mcd.b25l8.b1", "mcd", at="-1170.1142+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253007.0, assembly_id=103680.0))
lhcb1.new("mb.c25l8.b1", "mb", at="-1162.6297+(104.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844614.0, assembly_id=103680.0))
lhcb1.new("mcs.c25l8.b1", "mcs", at="-1155.2057+(105-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248172.0, assembly_id=103680.0))
lhcb1.new("mb.b25l8.b1", "mb", at="-1146.9697+(105.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844638.0, assembly_id=103681.0))
lhcb1.new("mcs.b25l8.b1", "mcs", at="-1139.5457+(106-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248175.0, assembly_id=103681.0))
lhcb1.new("mco.a25l8.b1", "mco_unplugged", at="-1138.7957+(106-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253010.0, assembly_id=103682.0))
lhcb1.new("mcd.a25l8.b1", "mcd", at="-1138.7942+(106-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253011.0, assembly_id=103682.0))
lhcb1.new("mb.a25l8.b1", "mb", at="-1131.3097+(106.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844662.0, assembly_id=103682.0))
lhcb1.new("mcs.a25l8.b1", "mcs", at="-1123.8857+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248180.0, assembly_id=103682.0))
lhcb1.new("bpm.24l8.b1", "bpm", at="-1123.0067+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248182.0, assembly_id=103683.0))
lhcb1.new("mo.24l8.b1", "mo", at="-1122.2557+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308841.0, assembly_id=103683.0))
lhcb1.new("mq.24l8.b1", "mq", at="-1120.2447+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308104.0, assembly_id=103683.0))
lhcb1.new("ms.24l8.b1", "ms", at="-1118.3497+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253014.0, assembly_id=103683.0))
lhcb1.new("mcbv.24l8.b1", "mcbv", at="-1117.7567+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253016.0, assembly_id=103683.0))
lhcb1.new("mb.c24l8.b1", "mb", at="-1109.1797+(107.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844686.0, assembly_id=103684.0))
lhcb1.new("mcs.c24l8.b1", "mcs", at="-1101.7557+(108-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248188.0, assembly_id=103684.0))
lhcb1.new("mco.24l8.b1", "mco_unplugged", at="-1101.0057+(108-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253018.0, assembly_id=103685.0))
lhcb1.new("mcd.24l8.b1", "mcd", at="-1101.0042+(108-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253019.0, assembly_id=103685.0))
lhcb1.new("mb.b24l8.b1", "mb", at="-1093.5197+(108.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844710.0, assembly_id=103685.0))
lhcb1.new("mcs.b24l8.b1", "mcs", at="-1086.0957+(109-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248193.0, assembly_id=103685.0))
lhcb1.new("mb.a24l8.b1", "mb", at="-1077.8597+(109.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844734.0, assembly_id=103686.0))
lhcb1.new("mcs.a24l8.b1", "mcs", at="-1070.4357+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248196.0, assembly_id=103686.0))
lhcb1.new("bpm.23l8.b1", "bpm", at="-1069.5567+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248198.0, assembly_id=103687.0))
lhcb1.new("mqs.23l8.b1", "mqs", at="-1068.8027+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307634.0, assembly_id=103687.0))
lhcb1.new("mq.23l8.b1", "mq", at="-1066.7947+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308314.0, assembly_id=103687.0))
lhcb1.new("ms.23l8.b1", "ms", at="-1064.8997+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253022.0, assembly_id=103687.0))
lhcb1.new("mcbh.23l8.b1", "mcbh", at="-1064.3067+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253024.0, assembly_id=103687.0))
lhcb1.new("mco.b23l8.b1", "mco_unplugged", at="-1063.2157+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253026.0, assembly_id=103688.0))
lhcb1.new("mcd.b23l8.b1", "mcd", at="-1063.2142+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253027.0, assembly_id=103688.0))
lhcb1.new("mb.c23l8.b1", "mb", at="-1055.7297+(110.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844758.0, assembly_id=103688.0))
lhcb1.new("mcs.c23l8.b1", "mcs", at="-1048.3057+(111-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248206.0, assembly_id=103688.0))
lhcb1.new("mb.b23l8.b1", "mb", at="-1040.0697+(111.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844782.0, assembly_id=103689.0))
lhcb1.new("mcs.b23l8.b1", "mcs", at="-1032.6457+(112-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248209.0, assembly_id=103689.0))
lhcb1.new("mco.a23l8.b1", "mco_unplugged", at="-1031.8957+(112-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253030.0, assembly_id=103690.0))
lhcb1.new("mcd.a23l8.b1", "mcd", at="-1031.8942+(112-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253031.0, assembly_id=103690.0))
lhcb1.new("mb.a23l8.b1", "mb", at="-1024.4097+(112.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844806.0, assembly_id=103690.0))
lhcb1.new("mcs.a23l8.b1", "mcs", at="-1016.9857+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248214.0, assembly_id=103690.0))
lhcb1.new("bpm.22l8.b1", "bpm", at="-1016.1067+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248216.0, assembly_id=103691.0))
lhcb1.new("mo.22l8.b1", "mo", at="-1015.3557+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2348502.0, assembly_id=103691.0))
lhcb1.new("mq.22l8.b1", "mq", at="-1013.3447+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308283.0, assembly_id=103691.0))
lhcb1.new("ms.22l8.b1", "ms", at="-1011.4497+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253034.0, assembly_id=103691.0))
lhcb1.new("mcbv.22l8.b1", "mcbv", at="-1010.8567+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253036.0, assembly_id=103691.0))
lhcb1.new("mb.c22l8.b1", "mb", at="-1002.2797+(113.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844830.0, assembly_id=103692.0))
lhcb1.new("mcs.c22l8.b1", "mcs", at="-994.8557+(114-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248222.0, assembly_id=103692.0))
lhcb1.new("mco.22l8.b1", "mco_unplugged", at="-994.1057+(114-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253038.0, assembly_id=103693.0))
lhcb1.new("mcd.22l8.b1", "mcd", at="-994.1042+(114-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253039.0, assembly_id=103693.0))
lhcb1.new("mb.b22l8.b1", "mb", at="-986.6197+(114.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844854.0, assembly_id=103693.0))
lhcb1.new("mcs.b22l8.b1", "mcs", at="-979.1957+(115-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248227.0, assembly_id=103693.0))
lhcb1.new("mb.a22l8.b1", "mb", at="-970.9597+(115.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844878.0, assembly_id=103694.0))
lhcb1.new("mcs.a22l8.b1", "mcs", at="-963.5357+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248230.0, assembly_id=103694.0))
lhcb1.new("bpm.21l8.b1", "bpm", at="-962.6567+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248232.0, assembly_id=103695.0))
lhcb1.new("mqt.21l8.b1", "mqt", at="-961.9027+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307267.0, assembly_id=103695.0))
lhcb1.new("mq.21l8.b1", "mq", at="-959.8947+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308251.0, assembly_id=103695.0))
lhcb1.new("ms.21l8.b1", "ms", at="-957.9997+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253042.0, assembly_id=103695.0))
lhcb1.new("mcbh.21l8.b1", "mcbh", at="-957.4067+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253044.0, assembly_id=103695.0))
lhcb1.new("mco.b21l8.b1", "mco_unplugged", at="-956.3157+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253046.0, assembly_id=103696.0))
lhcb1.new("mcd.b21l8.b1", "mcd", at="-956.3142+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253047.0, assembly_id=103696.0))
lhcb1.new("mb.c21l8.b1", "mb", at="-948.8297+(116.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844902.0, assembly_id=103696.0))
lhcb1.new("mcs.c21l8.b1", "mcs", at="-941.4057+(117-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248240.0, assembly_id=103696.0))
lhcb1.new("mb.b21l8.b1", "mb", at="-933.1697+(117.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844926.0, assembly_id=103697.0))
lhcb1.new("mcs.b21l8.b1", "mcs", at="-925.7457+(118-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248243.0, assembly_id=103697.0))
lhcb1.new("mco.a21l8.b1", "mco_unplugged", at="-924.9957+(118-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253050.0, assembly_id=103698.0))
lhcb1.new("mcd.a21l8.b1", "mcd", at="-924.9942+(118-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253051.0, assembly_id=103698.0))
lhcb1.new("mb.a21l8.b1", "mb", at="-917.5097+(118.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844950.0, assembly_id=103698.0))
lhcb1.new("mcs.a21l8.b1", "mcs", at="-910.0857+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248248.0, assembly_id=103698.0))
lhcb1.new("bpm.20l8.b1", "bpm", at="-909.2067+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248250.0, assembly_id=103699.0))
lhcb1.new("mqt.20l8.b1", "mqt", at="-908.4527+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307470.0, assembly_id=103699.0))
lhcb1.new("mq.20l8.b1", "mq", at="-906.4447+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308221.0, assembly_id=103699.0))
lhcb1.new("ms.20l8.b1", "ms", at="-904.5497+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253054.0, assembly_id=103699.0))
lhcb1.new("mcbv.20l8.b1", "mcbv", at="-903.9567+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253056.0, assembly_id=103699.0))
lhcb1.new("mb.c20l8.b1", "mb", at="-895.3797+(119.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844974.0, assembly_id=103700.0))
lhcb1.new("mcs.c20l8.b1", "mcs", at="-887.9557+(120-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248256.0, assembly_id=103700.0))
lhcb1.new("mco.20l8.b1", "mco_unplugged", at="-887.2057+(120-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253058.0, assembly_id=103701.0))
lhcb1.new("mcd.20l8.b1", "mcd", at="-887.2042+(120-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253059.0, assembly_id=103701.0))
lhcb1.new("mb.b20l8.b1", "mb", at="-879.7197+(120.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52844998.0, assembly_id=103701.0))
lhcb1.new("mcs.b20l8.b1", "mcs", at="-872.2957+(121-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248261.0, assembly_id=103701.0))
lhcb1.new("mb.a20l8.b1", "mb", at="-864.0597+(121.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845022.0, assembly_id=103702.0))
lhcb1.new("mcs.a20l8.b1", "mcs", at="-856.6357+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248264.0, assembly_id=103702.0))
lhcb1.new("bpm.19l8.b1", "bpm", at="-855.7567+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248266.0, assembly_id=103703.0))
lhcb1.new("mqt.19l8.b1", "mqt", at="-855.0027+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307440.0, assembly_id=103703.0))
lhcb1.new("mq.19l8.b1", "mq", at="-852.9947+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308430.0, assembly_id=103703.0))
lhcb1.new("ms.19l8.b1", "ms", at="-851.0997+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253062.0, assembly_id=103703.0))
lhcb1.new("mcbh.19l8.b1", "mcbh", at="-850.5067+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253064.0, assembly_id=103703.0))
lhcb1.new("mco.b19l8.b1", "mco_unplugged", at="-849.4157+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253066.0, assembly_id=103704.0))
lhcb1.new("mcd.b19l8.b1", "mcd", at="-849.4142+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253067.0, assembly_id=103704.0))
lhcb1.new("mb.c19l8.b1", "mb", at="-841.9297+(122.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845046.0, assembly_id=103704.0))
lhcb1.new("mcs.c19l8.b1", "mcs", at="-834.5057+(123-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248274.0, assembly_id=103704.0))
lhcb1.new("mb.b19l8.b1", "mb", at="-826.2697+(123.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845070.0, assembly_id=103705.0))
lhcb1.new("mcs.b19l8.b1", "mcs", at="-818.8457+(124-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248277.0, assembly_id=103705.0))
lhcb1.new("mco.a19l8.b1", "mco_unplugged", at="-818.0957+(124-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253070.0, assembly_id=103706.0))
lhcb1.new("mcd.a19l8.b1", "mcd", at="-818.0942+(124-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253071.0, assembly_id=103706.0))
lhcb1.new("mb.a19l8.b1", "mb", at="-810.6097+(124.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845094.0, assembly_id=103706.0))
lhcb1.new("mcs.a19l8.b1", "mcs", at="-803.1857+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248282.0, assembly_id=103706.0))
lhcb1.new("bpm.18l8.b1", "bpm", at="-802.3067+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248284.0, assembly_id=103707.0))
lhcb1.new("mqt.18l8.b1", "mqt", at="-801.5527+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307409.0, assembly_id=103707.0))
lhcb1.new("mq.18l8.b1", "mq", at="-799.5447+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308398.0, assembly_id=103707.0))
lhcb1.new("ms.18l8.b1", "ms", at="-797.6497+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253074.0, assembly_id=103707.0))
lhcb1.new("mcbv.18l8.b1", "mcbv", at="-797.0567+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253076.0, assembly_id=103707.0))
lhcb1.new("mb.c18l8.b1", "mb", at="-788.4797+(125.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845118.0, assembly_id=103708.0))
lhcb1.new("mcs.c18l8.b1", "mcs", at="-781.0557+(126-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248290.0, assembly_id=103708.0))
lhcb1.new("mco.18l8.b1", "mco_unplugged", at="-780.3057+(126-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253078.0, assembly_id=103709.0))
lhcb1.new("mcd.18l8.b1", "mcd", at="-780.3042+(126-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253079.0, assembly_id=103709.0))
lhcb1.new("mb.b18l8.b1", "mb", at="-772.8197+(126.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845142.0, assembly_id=103709.0))
lhcb1.new("mcs.b18l8.b1", "mcs", at="-765.3957+(127-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248295.0, assembly_id=103709.0))
lhcb1.new("mb.a18l8.b1", "mb", at="-757.1597+(127.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845166.0, assembly_id=103710.0))
lhcb1.new("mcs.a18l8.b1", "mcs", at="-749.7357+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248298.0, assembly_id=103710.0))
lhcb1.new("bpm.17l8.b1", "bpm", at="-748.8567+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248300.0, assembly_id=103711.0))
lhcb1.new("mqt.17l8.b1", "mqt", at="-748.1027+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307377.0, assembly_id=103711.0))
lhcb1.new("mq.17l8.b1", "mq", at="-746.0947+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308368.0, assembly_id=103711.0))
lhcb1.new("ms.17l8.b1", "ms", at="-744.1997+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253082.0, assembly_id=103711.0))
lhcb1.new("mcbh.17l8.b1", "mcbh", at="-743.6067+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253084.0, assembly_id=103711.0))
lhcb1.new("mco.b17l8.b1", "mco_unplugged", at="-742.5157+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253086.0, assembly_id=103712.0))
lhcb1.new("mcd.b17l8.b1", "mcd", at="-742.5142+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253087.0, assembly_id=103712.0))
lhcb1.new("mb.c17l8.b1", "mb", at="-735.0297+(128.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845190.0, assembly_id=103712.0))
lhcb1.new("mcs.c17l8.b1", "mcs", at="-727.6057+(129-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248308.0, assembly_id=103712.0))
lhcb1.new("mb.b17l8.b1", "mb", at="-719.3697+(129.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845214.0, assembly_id=103713.0))
lhcb1.new("mcs.b17l8.b1", "mcs", at="-711.9457+(130-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248311.0, assembly_id=103713.0))
lhcb1.new("mco.a17l8.b1", "mco_unplugged", at="-711.1957+(130-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253090.0, assembly_id=103714.0))
lhcb1.new("mcd.a17l8.b1", "mcd", at="-711.1942+(130-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253091.0, assembly_id=103714.0))
lhcb1.new("mb.a17l8.b1", "mb", at="-703.7097+(130.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845238.0, assembly_id=103714.0))
lhcb1.new("mcs.a17l8.b1", "mcs", at="-696.2857+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248316.0, assembly_id=103714.0))
lhcb1.new("bpm.16l8.b1", "bpm", at="-695.4067+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248318.0, assembly_id=103715.0))
lhcb1.new("mqt.16l8.b1", "mqt", at="-694.6527+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307584.0, assembly_id=103715.0))
lhcb1.new("mq.16l8.b1", "mq", at="-692.6447+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308339.0, assembly_id=103715.0))
lhcb1.new("ms.16l8.b1", "ms", at="-690.7497+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253094.0, assembly_id=103715.0))
lhcb1.new("mcbv.16l8.b1", "mcbv", at="-690.1567+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253096.0, assembly_id=103715.0))
lhcb1.new("mb.c16l8.b1", "mb", at="-681.5797+(131.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845262.0, assembly_id=103716.0))
lhcb1.new("mcs.c16l8.b1", "mcs", at="-674.1557+(132-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248324.0, assembly_id=103716.0))
lhcb1.new("mco.16l8.b1", "mco_unplugged", at="-673.4057+(132-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253098.0, assembly_id=103717.0))
lhcb1.new("mcd.16l8.b1", "mcd", at="-673.4042+(132-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253099.0, assembly_id=103717.0))
lhcb1.new("mb.b16l8.b1", "mb", at="-665.9197+(132.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845286.0, assembly_id=103717.0))
lhcb1.new("mcs.b16l8.b1", "mcs", at="-658.4957+(133-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248329.0, assembly_id=103717.0))
lhcb1.new("mb.a16l8.b1", "mb", at="-650.2597+(133.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845310.0, assembly_id=103718.0))
lhcb1.new("mcs.a16l8.b1", "mcs", at="-642.8357+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248332.0, assembly_id=103718.0))
lhcb1.new("bpm.15l8.b1", "bpm", at="-641.9567+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248334.0, assembly_id=103719.0))
lhcb1.new("mqt.15l8.b1", "mqt", at="-641.2027+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307553.0, assembly_id=103719.0))
lhcb1.new("mq.15l8.b1", "mq", at="-639.1947+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308545.0, assembly_id=103719.0))
lhcb1.new("ms.15l8.b1", "ms", at="-637.2997+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253102.0, assembly_id=103719.0))
lhcb1.new("mcbh.15l8.b1", "mcbh", at="-636.7067+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253104.0, assembly_id=103719.0))
lhcb1.new("mco.b15l8.b1", "mco_unplugged", at="-635.6157+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253106.0, assembly_id=103720.0))
lhcb1.new("mcd.b15l8.b1", "mcd", at="-635.6142+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253107.0, assembly_id=103720.0))
lhcb1.new("mb.c15l8.b1", "mb", at="-628.1297+(134.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845334.0, assembly_id=103720.0))
lhcb1.new("mcs.c15l8.b1", "mcs", at="-620.7057+(135-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248342.0, assembly_id=103720.0))
lhcb1.new("mb.b15l8.b1", "mb", at="-612.4697+(135.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845358.0, assembly_id=103721.0))
lhcb1.new("mcs.b15l8.b1", "mcs", at="-605.0457+(136-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248345.0, assembly_id=103721.0))
lhcb1.new("mco.a15l8.b1", "mco_unplugged", at="-604.2957+(136-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253110.0, assembly_id=103722.0))
lhcb1.new("mcd.a15l8.b1", "mcd", at="-604.2942+(136-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253111.0, assembly_id=103722.0))
lhcb1.new("mb.a15l8.b1", "mb", at="-596.8097+(136.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845382.0, assembly_id=103722.0))
lhcb1.new("mcs.a15l8.b1", "mcs", at="-589.3857+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248350.0, assembly_id=103722.0))
lhcb1.new("bpm.14l8.b1", "bpm", at="-588.5067+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248352.0, assembly_id=103723.0))
lhcb1.new("mqt.14l8.b1", "mqt", at="-587.7527+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307521.0, assembly_id=103723.0))
lhcb1.new("mq.14l8.b1", "mq", at="-585.7447+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308515.0, assembly_id=103723.0))
lhcb1.new("ms.14l8.b1", "ms", at="-583.8497+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253114.0, assembly_id=103723.0))
lhcb1.new("mcbv.14l8.b1", "mcbv", at="-583.2567+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253116.0, assembly_id=103723.0))
lhcb1.new("mb.c14l8.b1", "mb", at="-574.6797+(137.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845406.0, assembly_id=103724.0))
lhcb1.new("mcs.c14l8.b1", "mcs", at="-567.2557+(138-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248358.0, assembly_id=103724.0))
lhcb1.new("mco.14l8.b1", "mco_unplugged", at="-566.5057+(138-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253118.0, assembly_id=103725.0))
lhcb1.new("mcd.14l8.b1", "mcd", at="-566.5042+(138-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253119.0, assembly_id=103725.0))
lhcb1.new("mb.b14l8.b1", "mb", at="-559.0197+(138.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845430.0, assembly_id=103725.0))
lhcb1.new("mcs.b14l8.b1", "mcs", at="-551.5957+(139-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248363.0, assembly_id=103725.0))
lhcb1.new("mb.a14l8.b1", "mb", at="-543.3597+(139.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845454.0, assembly_id=103726.0))
lhcb1.new("mcs.a14l8.b1", "mcs", at="-535.9357+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248366.0, assembly_id=103726.0))
lhcb1.new("s.ds.l8.b1", "omk", at="-535.5297+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.13l8.b1", "bpm", at="-535.0567+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248368.0, assembly_id=103727.0))
lhcb1.new("mqt.13l8.b1", "mqt", at="-534.3027+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307728.0, assembly_id=103727.0))
lhcb1.new("mq.13l8.b1", "mq", at="-532.2947+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308486.0, assembly_id=103727.0))
lhcb1.new("ms.13l8.b1", "ms", at="-530.3997+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253122.0, assembly_id=103727.0))
lhcb1.new("mcbh.13l8.b1", "mcbh", at="-529.8067+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253124.0, assembly_id=103727.0))
lhcb1.new("mco.b13l8.b1", "mco_unplugged", at="-528.7157+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253126.0, assembly_id=103728.0))
lhcb1.new("mcd.b13l8.b1", "mcd", at="-528.7142+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253127.0, assembly_id=103728.0))
lhcb1.new("mb.c13l8.b1", "mb", at="-521.2297+(140.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845478.0, assembly_id=103728.0))
lhcb1.new("mcs.c13l8.b1", "mcs", at="-513.8057+(141-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248376.0, assembly_id=103728.0))
lhcb1.new("mb.b13l8.b1", "mb", at="-505.5697+(141.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845502.0, assembly_id=103729.0))
lhcb1.new("mcs.b13l8.b1", "mcs", at="-498.1457+(142-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248379.0, assembly_id=103729.0))
lhcb1.new("mco.a13l8.b1", "mco_unplugged", at="-497.3957+(142-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253130.0, assembly_id=103730.0))
lhcb1.new("mcd.a13l8.b1", "mcd", at="-497.3942+(142-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253131.0, assembly_id=103730.0))
lhcb1.new("mb.a13l8.b1", "mb", at="-489.9097+(142.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845526.0, assembly_id=103730.0))
lhcb1.new("mcs.a13l8.b1", "mcs", at="-482.4857+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248384.0, assembly_id=103730.0))
lhcb1.new("bpm.12l8.b1", "bpm", at="-481.6067+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248386.0, assembly_id=103731.0))
lhcb1.new("mqt.12l8.b1", "mqt", at="-480.8527+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307697.0, assembly_id=103731.0))
lhcb1.new("mq.12l8.b1", "mq", at="-478.8447+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308456.0, assembly_id=103731.0))
lhcb1.new("ms.12l8.b1", "ms", at="-476.9497+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253134.0, assembly_id=103731.0))
lhcb1.new("mcbv.12l8.b1", "mcbv", at="-476.3567+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253136.0, assembly_id=103731.0))
lhcb1.new("mb.c12l8.b1", "mb", at="-467.7797+(143.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845550.0, assembly_id=103732.0))
lhcb1.new("mcs.c12l8.b1", "mcs", at="-460.3557+(144-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248392.0, assembly_id=103732.0))
lhcb1.new("mco.12l8.b1", "mco_unplugged", at="-459.6057+(144-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253138.0, assembly_id=103733.0))
lhcb1.new("mcd.12l8.b1", "mcd", at="-459.6042+(144-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253139.0, assembly_id=103733.0))
lhcb1.new("mb.b12l8.b1", "mb", at="-452.1197+(144.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845574.0, assembly_id=103733.0))
lhcb1.new("mcs.b12l8.b1", "mcs", at="-444.6957+(145-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248397.0, assembly_id=103733.0))
lhcb1.new("mb.a12l8.b1", "mb", at="-436.4597+(145.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845598.0, assembly_id=103734.0))
lhcb1.new("mcs.a12l8.b1", "mcs", at="-429.0357+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248400.0, assembly_id=103734.0))
lhcb1.new("e.arc.78.b1", "omk", at="-428.6297+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.11l8.b1", "bpm", at="-428.1567+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248402.0, assembly_id=103735.0))
lhcb1.new("mq.11l8.b1", "mq", at="-425.6097+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308663.0, assembly_id=103735.0))
lhcb1.new("mqtli.11l8.b1", "mqtli", at="-423.2407+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307351.0, assembly_id=103735.0))
lhcb1.new("ms.11l8.b1", "ms", at="-422.2287+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253142.0, assembly_id=103735.0))
lhcb1.new("mcbh.11l8.b1", "mcbh", at="-421.6357+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253144.0, assembly_id=103735.0))
lhcb1.new("lebr.11l8.b1", "lebr", at="-414.49735+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52997706.0, assembly_id=103736.0))
lhcb1.new("mco.11l8.b1", "mco_unplugged", at="-407.766+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253146.0, assembly_id=103737.0))
lhcb1.new("mcd.11l8.b1", "mcd", at="-407.7645+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253147.0, assembly_id=103737.0))
lhcb1.new("mb.b11l8.b1", "mb", at="-400.28+(146.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845622.0, assembly_id=103737.0))
lhcb1.new("mcs.b11l8.b1", "mcs", at="-392.856+(147-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248410.0, assembly_id=103737.0))
lhcb1.new("mb.a11l8.b1", "mb", at="-384.62+(147.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52849726.0, assembly_id=103738.0))
lhcb1.new("mcs.a11l8.b1", "mcs", at="-377.196+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=357328.0, assembly_id=103738.0))
lhcb1.new("bpm.10l8.b1", "bpm", at="-376.317+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378039.0, assembly_id=103739.0))
lhcb1.new("mqml.10l8.b1", "mqml", at="-373.172+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307814.0, assembly_id=103739.0))
lhcb1.new("mcbcv.10l8.b1", "mcbcv", at="-370.13+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378120.0, assembly_id=103739.0))
lhcb1.new("mco.10l8.b1", "mco_unplugged", at="-368.701+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253152.0, assembly_id=103740.0))
lhcb1.new("mcd.10l8.b1", "mcd", at="-368.6995+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253153.0, assembly_id=103740.0))
lhcb1.new("mb.b10l8.b1", "mb", at="-361.215+(148.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845646.0, assembly_id=103740.0))
lhcb1.new("mcs.b10l8.b1", "mcs", at="-353.791+(149-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248422.0, assembly_id=103740.0))
lhcb1.new("mb.a10l8.b1", "mb", at="-345.555+(149.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845670.0, assembly_id=103741.0))
lhcb1.new("mcs.a10l8.b1", "mcs", at="-338.131+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248425.0, assembly_id=103741.0))
lhcb1.new("bpm.9l8.b1", "bpm", at="-337.251+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378044.0, assembly_id=103742.0))
lhcb1.new("mqmc.9l8.b1", "mqmc", at="-335.275+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307791.0, assembly_id=103742.0))
lhcb1.new("mqm.9l8.b1", "mqm", at="-332.009+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307739.0, assembly_id=103742.0))
lhcb1.new("mcbch.9l8.b1", "mcbch", at="-329.668+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378127.0, assembly_id=103742.0))
lhcb1.new("mco.9l8.b1", "mco_unplugged", at="-328.236+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253158.0, assembly_id=103743.0))
lhcb1.new("mcd.9l8.b1", "mcd", at="-328.2345+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253159.0, assembly_id=103743.0))
lhcb1.new("mb.b9l8.b1", "mb", at="-320.75+(150.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845694.0, assembly_id=103743.0))
lhcb1.new("mcs.b9l8.b1", "mcs", at="-313.326+(151-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248435.0, assembly_id=103743.0))
lhcb1.new("mb.a9l8.b1", "mb", at="-305.09+(151.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845718.0, assembly_id=103744.0))
lhcb1.new("mcs.a9l8.b1", "mcs", at="-297.666+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248438.0, assembly_id=103744.0))
lhcb1.new("bpm.8l8.b1", "bpm", at="-296.787+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378048.0, assembly_id=103745.0))
lhcb1.new("mqml.8l8.b1", "mqml", at="-293.642+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307846.0, assembly_id=103745.0))
lhcb1.new("mcbcv.8l8.b1", "mcbcv", at="-290.6+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378130.0, assembly_id=103745.0))
lhcb1.new("mco.8l8.b1", "mco_unplugged", at="-289.171+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253164.0, assembly_id=103746.0))
lhcb1.new("mcd.8l8.b1", "mcd", at="-289.1695+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253165.0, assembly_id=103746.0))
lhcb1.new("mb.b8l8.b1", "mb", at="-281.685+(152.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845742.0, assembly_id=103746.0))
lhcb1.new("mcs.b8l8.b1", "mcs", at="-274.261+(153-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248447.0, assembly_id=103746.0))
lhcb1.new("mb.a8l8.b1", "mb", at="-266.025+(153.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52849750.0, assembly_id=103747.0))
lhcb1.new("mcs.a8l8.b1", "mcs", at="-258.601+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=357331.0, assembly_id=103747.0))
lhcb1.new("e.ds.l8.b1", "omk", at="-258.195+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.7l8.b1", "bpm", at="-257.72+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248452.0, assembly_id=103748.0))
lhcb1.new("mqm.b7l8.b1", "mqm", at="-255.275+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307772.0, assembly_id=103748.0))
lhcb1.new("mqm.a7l8.b1", "mqm", at="-251.508+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307757.0, assembly_id=103748.0))
lhcb1.new("mcbch.7l8.b1", "mcbch", at="-249.167+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253169.0, assembly_id=103748.0))
lhcb1.new("dfbao.7l8.b1", "dfbao", at="-246.9875+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52996875.0, assembly_id=104690.0))
lhcb1.new("mcbcv.6l8.b1", "mcbcv", at="-235.207+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253170.0, assembly_id=103750.0))
lhcb1.new("mqml.6l8.b1", "mqml", at="-232.165+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307830.0, assembly_id=103750.0))
lhcb1.new("mqm.6l8.b1", "mqm", at="-227.698+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307957.0, assembly_id=103750.0))
lhcb1.new("bpmr.6l8.b1", "bpmr", at="-225.251+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248461.0, assembly_id=103750.0))
lhcb1.new("tclim.6l8.b1", "tclim", at="-223.428+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52998872.0, assembly_id=357149.0))
lhcb1.new("mcbch.b5l8.b1", "mcbch", at="-175.742+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=298448.0, assembly_id=103752.0))
lhcb1.new("mcbcv.5l8.b1", "mcbcv", at="-174.595+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=298449.0, assembly_id=103752.0))
lhcb1.new("mcbch.a5l8.b1", "mcbch", at="-173.449+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=298452.0, assembly_id=103752.0))
lhcb1.new("mqm.b5l8.b1", "mqm", at="-171.102+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2303172.0, assembly_id=103752.0))
lhcb1.new("mqm.a5l8.b1", "mqm", at="-167.321+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2303171.0, assembly_id=103752.0))
lhcb1.new("bpm.5l8.b1", "bpm", at="-164.832+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=298292.0, assembly_id=103752.0))
lhcb1.new("bptx.5l8.b1", "bptx", at="-145.3615+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=104669.0))
lhcb1.new("bpmyb.4l8.b1", "bpmyb", at="-144.065+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248471.0, assembly_id=103753.0))
lhcb1.new("mqy.b4l8.b1", "mqy", at="-141.371+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2303004.0, assembly_id=103753.0))
lhcb1.new("mqy.a4l8.b1", "mqy", at="-137.59+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2303003.0, assembly_id=103753.0))
lhcb1.new("mcbyv.b4l8.b1", "mcbyv", at="-135.243+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253179.0, assembly_id=103753.0))
lhcb1.new("mcbyh.4l8.b1", "mcbyh", at="-134.096+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253181.0, assembly_id=103753.0))
lhcb1.new("mcbyv.a4l8.b1", "mcbyv", at="-132.95+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253183.0, assembly_id=103753.0))
lhcb1.new("mbrc.4l8.b1", "mbrc", at="-126.403+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.188, slot_id=52819728.0, assembly_id=103754.0))
lhcb1.new("tanb.a4l8.b1", "tanb", at="-119.4855+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.174, slot_id=52999643.0, assembly_id=51650555.0))
lhcb1.new("bptuh.a4l8.b1", "bptuh", at="-118.828+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.172, slot_id=6789713.0, assembly_id=377640.0))
lhcb1.new("tctph.4l8.b1", "tctph", at="-118.233+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.1689, slot_id=377640.0))
lhcb1.new("bptdh.a4l8.b1", "bptdh", at="-117.638+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.172, slot_id=6789715.0, assembly_id=377640.0))
lhcb1.new("bptuv.a4l8.b1", "bptuv", at="-116.828+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.166, slot_id=6789727.0, assembly_id=6154654.0))
lhcb1.new("tctpv.4l8.b1", "tctpv", at="-116.233+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.1629, slot_id=6154654.0))
lhcb1.new("bptdv.a4l8.b1", "bptdv", at="-115.638+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.166, slot_id=6789730.0, assembly_id=6154654.0))
lhcb1.new("bpmwb.4l8.b1", "bpmwb", at="-114.8685+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.159, slot_id=181645.0, assembly_id=51650538.0))
lhcb1.new("branc.4l8", "branc", at="-113.588+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=55373986.0))
lhcb1.new("tclia.4l8", "tclia", at="-73.748+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=357150.0))
lhcb1.new("bpmsx.4l8.b1", "bpmsx003", at="-69.5005+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0194, slot_id=43190480.0, assembly_id=104616.0))
lhcb1.new("mbx.4l8", "mbx", at="-63.108+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248483.0, assembly_id=103755.0))
lhcb1.new("dfbxg.3l8", "dfbxg", at="-56.3085+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=104691.0))
lhcb1.new("mcosx.3l8", "mcosx", at="-54.297+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282252.0, assembly_id=103756.0))
lhcb1.new("mcox.3l8", "mcox", at="-54.297+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282251.0, assembly_id=103756.0))
lhcb1.new("mcssx.3l8", "mcssx", at="-54.297+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282250.0, assembly_id=103756.0))
lhcb1.new("mcbxh.3l8", "mcbxh", at="-53.814+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253184.0, assembly_id=103756.0))
lhcb1.new("mcbxv.3l8", "mcbxv", at="-53.814+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253185.0, assembly_id=103756.0))
lhcb1.new("mcsx.3l8", "mcsx", at="-53.814+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253186.0, assembly_id=103756.0))
lhcb1.new("mctx.3l8", "mctx", at="-53.814+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253187.0, assembly_id=103756.0))
lhcb1.new("mqxa.3l8", "mqxa", at="-50.15+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248485.0, assembly_id=103756.0))
lhcb1.new("mqsx.3l8", "mqsx", at="-46.608+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282207.0, assembly_id=103756.0))
lhcb1.new("mqxb.b2l8", "mqxb", at="-41.3+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248487.0, assembly_id=103757.0))
lhcb1.new("mcbxh.2l8", "mcbxh", at="-38.019+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253192.0, assembly_id=103757.0))
lhcb1.new("mcbxv.2l8", "mcbxv", at="-38.019+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253193.0, assembly_id=103757.0))
lhcb1.new("mqxb.a2l8", "mqxb", at="-34.8+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248489.0, assembly_id=103757.0))
lhcb1.new("bpms.2l8.b1", "bpms_003", at="-31.529+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=47564253.0, assembly_id=103757.0))
lhcb1.new("mcbxh.1l8", "mcbxh", at="-29.842+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253194.0, assembly_id=103758.0))
lhcb1.new("mcbxv.1l8", "mcbxv", at="-29.842+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253195.0, assembly_id=103758.0))
lhcb1.new("mqxa.1l8", "mqxa", at="-26.15+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248492.0, assembly_id=103758.0))
lhcb1.new("bpmsw.1l8.b1", "bpmsw002", at="-21.595+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=10428878.0, assembly_id=104617.0))
lhcb1.new("bpmsw.1l8.b1_doros", "bpmsw002", at="-21.595+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=12907565.0, assembly_id=104617.0))
lhcb1.new("mbxws.1l8", "mbxws", at="-20.765+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=103997.0))
lhcb1.new("mbxwh.1l8", "mbxwh", at="-5.25+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=103998.0))
lhcb1.new("ip8", "omk", at="pip8+ip8ofs.b1*ds")
lhcb1.new("mblw.1r8", "mblw", at="5.25+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=104001.0))
lhcb1.new("mbxws.1r8", "mbxws", at="20.765+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=103999.0))
lhcb1.new("bpmsw.1r8.b1", "bpmsw002", at="21.595+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=10428864.0, assembly_id=104618.0))
lhcb1.new("bpmsw.1r8.b1_doros", "bpmsw002", at="21.595+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=12907557.0, assembly_id=104618.0))
lhcb1.new("mqxa.1r8", "mqxa", at="26.15+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248498.0, assembly_id=103759.0))
lhcb1.new("mcbxh.1r8", "mcbxh", at="29.842+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253196.0, assembly_id=103759.0))
lhcb1.new("mcbxv.1r8", "mcbxv", at="29.842+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253197.0, assembly_id=103759.0))
lhcb1.new("bpms.2r8.b1", "bpms_003", at="31.529+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=47564243.0, assembly_id=103760.0))
lhcb1.new("mqxb.a2r8", "mqxb", at="34.8+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248501.0, assembly_id=103760.0))
lhcb1.new("mcbxh.2r8", "mcbxh", at="38.019+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253198.0, assembly_id=103760.0))
lhcb1.new("mcbxv.2r8", "mcbxv", at="38.019+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253199.0, assembly_id=103760.0))
lhcb1.new("mqxb.b2r8", "mqxb", at="41.3+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248503.0, assembly_id=103760.0))
lhcb1.new("mqsx.3r8", "mqsx", at="46.608+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282208.0, assembly_id=103761.0))
lhcb1.new("mqxa.3r8", "mqxa", at="50.15+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248505.0, assembly_id=103761.0))
lhcb1.new("mcbxh.3r8", "mcbxh", at="53.814+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253204.0, assembly_id=103761.0))
lhcb1.new("mcbxv.3r8", "mcbxv", at="53.814+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253205.0, assembly_id=103761.0))
lhcb1.new("mcsx.3r8", "mcsx", at="53.814+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253206.0, assembly_id=103761.0))
lhcb1.new("mctx.3r8", "mctx", at="53.814+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253207.0, assembly_id=103761.0))
lhcb1.new("mcosx.3r8", "mcosx", at="54.297+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282255.0, assembly_id=103761.0))
lhcb1.new("mcox.3r8", "mcox", at="54.297+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282254.0, assembly_id=103761.0))
lhcb1.new("mcssx.3r8", "mcssx", at="54.297+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282253.0, assembly_id=103761.0))
lhcb1.new("dfbxh.3r8", "dfbxh", at="56.3085+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=104692.0))
lhcb1.new("mbx.4r8", "mbx", at="63.108+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248507.0, assembly_id=103762.0))
lhcb1.new("bpmsx.4r8.b1", "bpmsx003", at="69.3805+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.0194, slot_id=43190481.0, assembly_id=104619.0))
lhcb1.new("tcddm.4r8", "tcddm", at="71.358+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=103763.0))
lhcb1.new("btvst.a4r8", "btvst064", at="85.441+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.08, slot_id=181630.0))
lhcb1.new("branc.4r8", "branc", at="113.588+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=0.0, slot_id=55374023.0))
lhcb1.new("bpmwb.4r8.b1", "bpmwb", at="114.7925+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.174, slot_id=181646.0, assembly_id=51710752.0))
lhcb1.new("tanb.a4r8.b1", "tanb", at="119.4855+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.174, slot_id=52999667.0, assembly_id=51710761.0))
lhcb1.new("mbrc.4r8.b1", "mbrc", at="126.403+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.188, slot_id=52819752.0, assembly_id=103765.0))
lhcb1.new("mcbyh.a4r8.b1", "mcbyh", at="132.95+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253209.0, assembly_id=103766.0))
lhcb1.new("mcbyv.4r8.b1", "mcbyv", at="134.096+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253211.0, assembly_id=103766.0))
lhcb1.new("mcbyh.b4r8.b1", "mcbyh", at="135.243+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253213.0, assembly_id=103766.0))
lhcb1.new("mqy.a4r8.b1", "mqy", at="137.59+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2303145.0, assembly_id=103766.0))
lhcb1.new("mqy.b4r8.b1", "mqy", at="141.371+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2303144.0, assembly_id=103766.0))
lhcb1.new("bpmyb.4r8.b1", "bpmyb", at="144.065+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248521.0, assembly_id=103766.0))
lhcb1.new("bpmyb.5r8.b1", "bpmyb", at="164.642+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248523.0, assembly_id=103768.0))
lhcb1.new("mqy.a5r8.b1", "mqy", at="167.336+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2303010.0, assembly_id=103768.0))
lhcb1.new("mqy.b5r8.b1", "mqy", at="171.117+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2303009.0, assembly_id=103768.0))
lhcb1.new("mcbyv.a5r8.b1", "mcbyv", at="173.464+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253214.0, assembly_id=103768.0))
lhcb1.new("mcbyh.5r8.b1", "mcbyh", at="174.61+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253216.0, assembly_id=103768.0))
lhcb1.new("mcbyv.b5r8.b1", "mcbyv", at="175.757+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253218.0, assembly_id=103768.0))
lhcb1.new("msia.a6r8.b1", "msia", at="194.923+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52849898.0, assembly_id=134685.0))
lhcb1.new("msia.b6r8.b1", "msia", at="199.373+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52849924.0, assembly_id=134686.0))
lhcb1.new("msib.a6r8.b1", "msib", at="203.823+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52850028.0, assembly_id=134687.0))
lhcb1.new("msib.b6r8.b1", "msib", at="208.273+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52850054.0, assembly_id=134688.0))
lhcb1.new("msib.c6r8.b1", "msib", at="212.723+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52850080.0, assembly_id=134689.0))
lhcb1.new("mcbch.6r8.b1", "mcbch", at="238.794+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253221.0, assembly_id=103770.0))
lhcb1.new("mqml.6r8.b1", "mqml", at="241.836+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307834.0, assembly_id=103770.0))
lhcb1.new("mqm.6r8.b1", "mqm", at="246.303+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307961.0, assembly_id=103770.0))
lhcb1.new("bpm.6r8.b1", "bpm", at="248.75+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=298296.0, assembly_id=103770.0))
lhcb1.new("dfbap.7r8.b1", "dfbap", at="269.1775+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52996899.0, assembly_id=104693.0))
lhcb1.new("bpm_a.7r8.b1", "bpm_a", at="270.99+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=378057.0, assembly_id=103771.0))
lhcb1.new("mqm.a7r8.b1", "mqm", at="273.435+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307765.0, assembly_id=103771.0))
lhcb1.new("mqm.b7r8.b1", "mqm", at="277.202+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307780.0, assembly_id=103771.0))
lhcb1.new("mcbcv.7r8.b1", "mcbcv", at="279.543+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253222.0, assembly_id=103771.0))
lhcb1.new("s.ds.r8.b1", "omk", at="280.635+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(slot_id=100932.0))
lhcb1.new("mco.8r8.b1", "mco", at="280.979+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253226.0, assembly_id=103772.0))
lhcb1.new("mcd.8r8.b1", "mcd", at="280.9805+(154-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253227.0, assembly_id=103772.0))
lhcb1.new("mb.a8r8.b1", "mb", at="288.465+(153.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845766.0, assembly_id=103772.0))
lhcb1.new("mcs.a8r8.b1", "mcs", at="295.889+(153-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248543.0, assembly_id=103772.0))
lhcb1.new("mb.b8r8.b1", "mb", at="304.125+(152.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845790.0, assembly_id=103773.0))
lhcb1.new("mcs.b8r8.b1", "mcs", at="311.549+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248546.0, assembly_id=103773.0))
lhcb1.new("bpm.8r8.b1", "bpm", at="312.428+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248548.0, assembly_id=103774.0))
lhcb1.new("mqml.8r8.b1", "mqml", at="315.573+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307619.0, assembly_id=103774.0))
lhcb1.new("mcbch.8r8.b1", "mcbch", at="318.615+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253228.0, assembly_id=103774.0))
lhcb1.new("mco.9r8.b1", "mco", at="320.044+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253232.0, assembly_id=103775.0))
lhcb1.new("mcd.9r8.b1", "mcd", at="320.0455+(152-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253233.0, assembly_id=103775.0))
lhcb1.new("mb.a9r8.b1", "mb", at="327.53+(151.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845814.0, assembly_id=103775.0))
lhcb1.new("mcs.a9r8.b1", "mcs", at="334.954+(151-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248555.0, assembly_id=103775.0))
lhcb1.new("mb.b9r8.b1", "mb", at="343.19+(150.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845838.0, assembly_id=103776.0))
lhcb1.new("mcs.b9r8.b1", "mcs", at="350.614+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248558.0, assembly_id=103776.0))
lhcb1.new("bpm.9r8.b1", "bpm", at="351.494+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248560.0, assembly_id=103777.0))
lhcb1.new("mqmc.9r8.b1", "mqmc", at="353.47+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307802.0, assembly_id=103777.0))
lhcb1.new("mqm.9r8.b1", "mqm", at="356.736+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307750.0, assembly_id=103777.0))
lhcb1.new("mcbcv.9r8.b1", "mcbcv", at="359.077+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253234.0, assembly_id=103777.0))
lhcb1.new("mco.10r8.b1", "mco", at="360.509+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253238.0, assembly_id=103778.0))
lhcb1.new("mcd.10r8.b1", "mcd", at="360.5105+(150-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253239.0, assembly_id=103778.0))
lhcb1.new("mb.a10r8.b1", "mb", at="367.995+(149.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845862.0, assembly_id=103778.0))
lhcb1.new("mcs.a10r8.b1", "mcs", at="375.419+(149-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248568.0, assembly_id=103778.0))
lhcb1.new("mb.b10r8.b1", "mb", at="383.655+(148.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845886.0, assembly_id=103779.0))
lhcb1.new("mcs.b10r8.b1", "mcs", at="391.079+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248571.0, assembly_id=103779.0))
lhcb1.new("bpm.10r8.b1", "bpm", at="391.958+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248573.0, assembly_id=103780.0))
lhcb1.new("mqml.10r8.b1", "mqml", at="395.103+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307826.0, assembly_id=103780.0))
lhcb1.new("mcbch.10r8.b1", "mcbch", at="398.145+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253240.0, assembly_id=103780.0))
lhcb1.new("mco.11r8.b1", "mco", at="399.574+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253244.0, assembly_id=103781.0))
lhcb1.new("mcd.11r8.b1", "mcd", at="399.5755+(148-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253245.0, assembly_id=103781.0))
lhcb1.new("mb.a11r8.b1", "mb", at="407.06+(147.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845910.0, assembly_id=103781.0))
lhcb1.new("mcs.a11r8.b1", "mcs", at="414.484+(147-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248580.0, assembly_id=103781.0))
lhcb1.new("mb.b11r8.b1", "mb", at="422.72+(146.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52849774.0, assembly_id=103782.0))
lhcb1.new("mcs.b11r8.b1", "mcs", at="430.144+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=357341.0, assembly_id=103782.0))
lhcb1.new("lecl.11r8.b1", "lecl", at="436.93735+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52997754.0, assembly_id=103783.0))
lhcb1.new("bpm.11r8.b1", "bpm", at="443.7977+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248585.0, assembly_id=103784.0))
lhcb1.new("mq.11r8.b1", "mq", at="446.3447+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308677.0, assembly_id=103784.0))
lhcb1.new("mqtli.11r8.b1", "mqtli", at="448.7137+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307366.0, assembly_id=103784.0))
lhcb1.new("ms.11r8.b1", "ms", at="449.7257+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253247.0, assembly_id=103784.0))
lhcb1.new("mcbv.11r8.b1", "mcbv", at="450.3187+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253249.0, assembly_id=103784.0))
lhcb1.new("s.arc.81.b1", "omk", at="451.0697+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a12r8.b1", "mco", at="451.4137+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253252.0, assembly_id=103785.0))
lhcb1.new("mcd.a12r8.b1", "mcd", at="451.4152+(146-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253253.0, assembly_id=103785.0))
lhcb1.new("mb.a12r8.b1", "mb", at="458.8997+(145.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845934.0, assembly_id=103785.0))
lhcb1.new("mcs.a12r8.b1", "mcs", at="466.3237+(145-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248593.0, assembly_id=103785.0))
lhcb1.new("mb.b12r8.b1", "mb", at="474.5597+(144.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845958.0, assembly_id=103786.0))
lhcb1.new("mcs.b12r8.b1", "mcs", at="481.9837+(144-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248596.0, assembly_id=103786.0))
lhcb1.new("mco.b12r8.b1", "mco", at="482.7337+(144-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253256.0, assembly_id=103787.0))
lhcb1.new("mcd.b12r8.b1", "mcd", at="482.7352+(144-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253257.0, assembly_id=103787.0))
lhcb1.new("mb.c12r8.b1", "mb", at="490.2197+(143.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845982.0, assembly_id=103787.0))
lhcb1.new("mcs.c12r8.b1", "mcs", at="497.6437+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248601.0, assembly_id=103787.0))
lhcb1.new("bpm.12r8.b1", "bpm", at="498.5227+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248603.0, assembly_id=103788.0))
lhcb1.new("mqt.12r8.b1", "mqt", at="499.2767+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307713.0, assembly_id=103788.0))
lhcb1.new("mq.12r8.b1", "mq", at="501.2847+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308471.0, assembly_id=103788.0))
lhcb1.new("ms.12r8.b1", "ms", at="503.1797+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253259.0, assembly_id=103788.0))
lhcb1.new("mcbh.12r8.b1", "mcbh", at="503.7727+(143-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253261.0, assembly_id=103788.0))
lhcb1.new("mb.a13r8.b1", "mb", at="512.3497+(142.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846006.0, assembly_id=103789.0))
lhcb1.new("mcs.a13r8.b1", "mcs", at="519.7737+(142-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248609.0, assembly_id=103789.0))
lhcb1.new("mco.13r8.b1", "mco", at="520.5237+(142-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253264.0, assembly_id=103790.0))
lhcb1.new("mcd.13r8.b1", "mcd", at="520.5252+(142-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253265.0, assembly_id=103790.0))
lhcb1.new("mb.b13r8.b1", "mb", at="528.0097+(141.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846030.0, assembly_id=103790.0))
lhcb1.new("mcs.b13r8.b1", "mcs", at="535.4337+(141-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248614.0, assembly_id=103790.0))
lhcb1.new("mb.c13r8.b1", "mb", at="543.6697+(140.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846054.0, assembly_id=103791.0))
lhcb1.new("mcs.c13r8.b1", "mcs", at="551.0937+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248617.0, assembly_id=103791.0))
lhcb1.new("bpm.13r8.b1", "bpm", at="551.9727+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248619.0, assembly_id=103792.0))
lhcb1.new("mqt.13r8.b1", "mqt", at="552.7267+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307505.0, assembly_id=103792.0))
lhcb1.new("mq.13r8.b1", "mq", at="554.7347+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2348487.0, assembly_id=103792.0))
lhcb1.new("ms.13r8.b1", "ms", at="556.6297+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253267.0, assembly_id=103792.0))
lhcb1.new("mcbv.13r8.b1", "mcbv", at="557.2227+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253269.0, assembly_id=103792.0))
lhcb1.new("e.ds.r8.b1", "omk", at="557.9697+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a14r8.b1", "mco", at="558.3137+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253272.0, assembly_id=103793.0))
lhcb1.new("mcd.a14r8.b1", "mcd", at="558.3152+(140-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253273.0, assembly_id=103793.0))
lhcb1.new("mb.a14r8.b1", "mb", at="565.7997+(139.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846078.0, assembly_id=103793.0))
lhcb1.new("mcs.a14r8.b1", "mcs", at="573.2237+(139-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248627.0, assembly_id=103793.0))
lhcb1.new("mb.b14r8.b1", "mb", at="581.4597+(138.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846102.0, assembly_id=103794.0))
lhcb1.new("mcs.b14r8.b1", "mcs", at="588.8837+(138-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248630.0, assembly_id=103794.0))
lhcb1.new("mco.b14r8.b1", "mco", at="589.6337+(138-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253276.0, assembly_id=103795.0))
lhcb1.new("mcd.b14r8.b1", "mcd", at="589.6352+(138-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253277.0, assembly_id=103795.0))
lhcb1.new("mb.c14r8.b1", "mb", at="597.1197+(137.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846126.0, assembly_id=103795.0))
lhcb1.new("mcs.c14r8.b1", "mcs", at="604.5437+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248635.0, assembly_id=103795.0))
lhcb1.new("bpm.14r8.b1", "bpm", at="605.4227+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248637.0, assembly_id=103796.0))
lhcb1.new("mqt.14r8.b1", "mqt", at="606.1767+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307537.0, assembly_id=103796.0))
lhcb1.new("mq.14r8.b1", "mq", at="608.1847+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308530.0, assembly_id=103796.0))
lhcb1.new("ms.14r8.b1", "ms", at="610.0797+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253279.0, assembly_id=103796.0))
lhcb1.new("mcbh.14r8.b1", "mcbh", at="610.6727+(137-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253281.0, assembly_id=103796.0))
lhcb1.new("mb.a15r8.b1", "mb", at="619.2497+(136.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846150.0, assembly_id=103797.0))
lhcb1.new("mcs.a15r8.b1", "mcs", at="626.6737+(136-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248643.0, assembly_id=103797.0))
lhcb1.new("mco.15r8.b1", "mco", at="627.4237+(136-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253284.0, assembly_id=103798.0))
lhcb1.new("mcd.15r8.b1", "mcd", at="627.4252+(136-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253285.0, assembly_id=103798.0))
lhcb1.new("mb.b15r8.b1", "mb", at="634.9097+(135.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846174.0, assembly_id=103798.0))
lhcb1.new("mcs.b15r8.b1", "mcs", at="642.3337+(135-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248648.0, assembly_id=103798.0))
lhcb1.new("mb.c15r8.b1", "mb", at="650.5697+(134.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846198.0, assembly_id=103799.0))
lhcb1.new("mcs.c15r8.b1", "mcs", at="657.9937+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248651.0, assembly_id=103799.0))
lhcb1.new("bpm.15r8.b1", "bpm", at="658.8727+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248653.0, assembly_id=103800.0))
lhcb1.new("mqt.15r8.b1", "mqt", at="659.6267+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307569.0, assembly_id=103800.0))
lhcb1.new("mq.15r8.b1", "mq", at="661.6347+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308561.0, assembly_id=103800.0))
lhcb1.new("ms.15r8.b1", "ms", at="663.5297+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253287.0, assembly_id=103800.0))
lhcb1.new("mcbv.15r8.b1", "mcbv", at="664.1227+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253289.0, assembly_id=103800.0))
lhcb1.new("mco.a16r8.b1", "mco", at="665.2137+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253292.0, assembly_id=103801.0))
lhcb1.new("mcd.a16r8.b1", "mcd", at="665.2152+(134-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253293.0, assembly_id=103801.0))
lhcb1.new("mb.a16r8.b1", "mb", at="672.6997+(133.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846222.0, assembly_id=103801.0))
lhcb1.new("mcs.a16r8.b1", "mcs", at="680.1237+(133-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248661.0, assembly_id=103801.0))
lhcb1.new("mb.b16r8.b1", "mb", at="688.3597+(132.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846246.0, assembly_id=103802.0))
lhcb1.new("mcs.b16r8.b1", "mcs", at="695.7837+(132-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248664.0, assembly_id=103802.0))
lhcb1.new("mco.b16r8.b1", "mco", at="696.5337+(132-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253296.0, assembly_id=103803.0))
lhcb1.new("mcd.b16r8.b1", "mcd", at="696.5352+(132-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253297.0, assembly_id=103803.0))
lhcb1.new("mb.c16r8.b1", "mb", at="704.0197+(131.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846270.0, assembly_id=103803.0))
lhcb1.new("mcs.c16r8.b1", "mcs", at="711.4437+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248669.0, assembly_id=103803.0))
lhcb1.new("bpm.16r8.b1", "bpm", at="712.3227+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248671.0, assembly_id=103804.0))
lhcb1.new("mqt.16r8.b1", "mqt", at="713.0767+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307598.0, assembly_id=103804.0))
lhcb1.new("mq.16r8.b1", "mq", at="715.0847+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308353.0, assembly_id=103804.0))
lhcb1.new("ms.16r8.b1", "ms", at="716.9797+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253299.0, assembly_id=103804.0))
lhcb1.new("mcbh.16r8.b1", "mcbh", at="717.5727+(131-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253301.0, assembly_id=103804.0))
lhcb1.new("mb.a17r8.b1", "mb", at="726.1497+(130.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846294.0, assembly_id=103805.0))
lhcb1.new("mcs.a17r8.b1", "mcs", at="733.5737+(130-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248677.0, assembly_id=103805.0))
lhcb1.new("mco.17r8.b1", "mco", at="734.3237+(130-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253304.0, assembly_id=103806.0))
lhcb1.new("mcd.17r8.b1", "mcd", at="734.3252+(130-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253305.0, assembly_id=103806.0))
lhcb1.new("mb.b17r8.b1", "mb", at="741.8097+(129.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846318.0, assembly_id=103806.0))
lhcb1.new("mcs.b17r8.b1", "mcs", at="749.2337+(129-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248682.0, assembly_id=103806.0))
lhcb1.new("mb.c17r8.b1", "mb", at="757.4697+(128.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846342.0, assembly_id=103807.0))
lhcb1.new("mcs.c17r8.b1", "mcs", at="764.8937+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248685.0, assembly_id=103807.0))
lhcb1.new("bpm.17r8.b1", "bpm", at="765.7727+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248687.0, assembly_id=103808.0))
lhcb1.new("mqt.17r8.b1", "mqt", at="766.5267+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307393.0, assembly_id=103808.0))
lhcb1.new("mq.17r8.b1", "mq", at="768.5347+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308383.0, assembly_id=103808.0))
lhcb1.new("ms.17r8.b1", "ms", at="770.4297+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253307.0, assembly_id=103808.0))
lhcb1.new("mcbv.17r8.b1", "mcbv", at="771.0227+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253309.0, assembly_id=103808.0))
lhcb1.new("mco.a18r8.b1", "mco", at="772.1137+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253312.0, assembly_id=103809.0))
lhcb1.new("mcd.a18r8.b1", "mcd", at="772.1152+(128-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253313.0, assembly_id=103809.0))
lhcb1.new("mb.a18r8.b1", "mb", at="779.5997+(127.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846366.0, assembly_id=103809.0))
lhcb1.new("mcs.a18r8.b1", "mcs", at="787.0237+(127-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248695.0, assembly_id=103809.0))
lhcb1.new("mb.b18r8.b1", "mb", at="795.2597+(126.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846390.0, assembly_id=103810.0))
lhcb1.new("mcs.b18r8.b1", "mcs", at="802.6837+(126-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248698.0, assembly_id=103810.0))
lhcb1.new("mco.b18r8.b1", "mco", at="803.4337+(126-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253316.0, assembly_id=103811.0))
lhcb1.new("mcd.b18r8.b1", "mcd", at="803.4352+(126-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253317.0, assembly_id=103811.0))
lhcb1.new("mb.c18r8.b1", "mb", at="810.9197+(125.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846414.0, assembly_id=103811.0))
lhcb1.new("mcs.c18r8.b1", "mcs", at="818.3437+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248703.0, assembly_id=103811.0))
lhcb1.new("bpm.18r8.b1", "bpm", at="819.2227+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248705.0, assembly_id=103812.0))
lhcb1.new("mqt.18r8.b1", "mqt", at="819.9767+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307425.0, assembly_id=103812.0))
lhcb1.new("mq.18r8.b1", "mq", at="821.9847+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308414.0, assembly_id=103812.0))
lhcb1.new("ms.18r8.b1", "ms", at="823.8797+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253319.0, assembly_id=103812.0))
lhcb1.new("mcbh.18r8.b1", "mcbh", at="824.4727+(125-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253321.0, assembly_id=103812.0))
lhcb1.new("mb.a19r8.b1", "mb", at="833.0497+(124.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846438.0, assembly_id=103813.0))
lhcb1.new("mcs.a19r8.b1", "mcs", at="840.4737+(124-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248711.0, assembly_id=103813.0))
lhcb1.new("mco.19r8.b1", "mco", at="841.2237+(124-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253324.0, assembly_id=103814.0))
lhcb1.new("mcd.19r8.b1", "mcd", at="841.2252+(124-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253325.0, assembly_id=103814.0))
lhcb1.new("mb.b19r8.b1", "mb", at="848.7097+(123.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846462.0, assembly_id=103814.0))
lhcb1.new("mcs.b19r8.b1", "mcs", at="856.1337+(123-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248716.0, assembly_id=103814.0))
lhcb1.new("mb.c19r8.b1", "mb", at="864.3697+(122.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846486.0, assembly_id=103815.0))
lhcb1.new("mcs.c19r8.b1", "mcs", at="871.7937+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248719.0, assembly_id=103815.0))
lhcb1.new("bpm.19r8.b1", "bpm", at="872.6727+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248721.0, assembly_id=103816.0))
lhcb1.new("mqt.19r8.b1", "mqt", at="873.4267+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307455.0, assembly_id=103816.0))
lhcb1.new("mq.19r8.b1", "mq", at="875.4347+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308446.0, assembly_id=103816.0))
lhcb1.new("ms.19r8.b1", "ms", at="877.3297+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253327.0, assembly_id=103816.0))
lhcb1.new("mcbv.19r8.b1", "mcbv", at="877.9227+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253329.0, assembly_id=103816.0))
lhcb1.new("mco.a20r8.b1", "mco", at="879.0137+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253332.0, assembly_id=103817.0))
lhcb1.new("mcd.a20r8.b1", "mcd", at="879.0152+(122-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253333.0, assembly_id=103817.0))
lhcb1.new("mb.a20r8.b1", "mb", at="886.4997+(121.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846510.0, assembly_id=103817.0))
lhcb1.new("mcs.a20r8.b1", "mcs", at="893.9237+(121-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248729.0, assembly_id=103817.0))
lhcb1.new("mb.b20r8.b1", "mb", at="902.1597+(120.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846534.0, assembly_id=103818.0))
lhcb1.new("mcs.b20r8.b1", "mcs", at="909.5837+(120-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248732.0, assembly_id=103818.0))
lhcb1.new("mco.b20r8.b1", "mco", at="910.3337+(120-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253336.0, assembly_id=103819.0))
lhcb1.new("mcd.b20r8.b1", "mcd", at="910.3352+(120-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253337.0, assembly_id=103819.0))
lhcb1.new("mb.c20r8.b1", "mb", at="917.8197+(119.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846558.0, assembly_id=103819.0))
lhcb1.new("mcs.c20r8.b1", "mcs", at="925.2437+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248737.0, assembly_id=103819.0))
lhcb1.new("bpm.20r8.b1", "bpm", at="926.1227+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248739.0, assembly_id=103820.0))
lhcb1.new("mqt.20r8.b1", "mqt", at="926.8767+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307485.0, assembly_id=103820.0))
lhcb1.new("mq.20r8.b1", "mq", at="928.8847+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308236.0, assembly_id=103820.0))
lhcb1.new("ms.20r8.b1", "ms", at="930.7797+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253339.0, assembly_id=103820.0))
lhcb1.new("mcbh.20r8.b1", "mcbh", at="931.3727+(119-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253341.0, assembly_id=103820.0))
lhcb1.new("mb.a21r8.b1", "mb", at="939.9497+(118.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846582.0, assembly_id=103821.0))
lhcb1.new("mcs.a21r8.b1", "mcs", at="947.3737+(118-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248745.0, assembly_id=103821.0))
lhcb1.new("mco.21r8.b1", "mco", at="948.1237+(118-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253344.0, assembly_id=103822.0))
lhcb1.new("mcd.21r8.b1", "mcd", at="948.1252+(118-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253345.0, assembly_id=103822.0))
lhcb1.new("mb.b21r8.b1", "mb", at="955.6097+(117.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846606.0, assembly_id=103822.0))
lhcb1.new("mcs.b21r8.b1", "mcs", at="963.0337+(117-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248750.0, assembly_id=103822.0))
lhcb1.new("mb.c21r8.b1", "mb", at="971.2697+(116.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846630.0, assembly_id=103823.0))
lhcb1.new("mcs.c21r8.b1", "mcs", at="978.6937+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248753.0, assembly_id=103823.0))
lhcb1.new("bpm.21r8.b1", "bpm", at="979.5727+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248755.0, assembly_id=103824.0))
lhcb1.new("mqt.21r8.b1", "mqt", at="980.3267+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307283.0, assembly_id=103824.0))
lhcb1.new("mq.21r8.b1", "mq", at="982.3347+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308267.0, assembly_id=103824.0))
lhcb1.new("ms.21r8.b1", "ms", at="984.2297+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253347.0, assembly_id=103824.0))
lhcb1.new("mcbv.21r8.b1", "mcbv", at="984.8227+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253349.0, assembly_id=103824.0))
lhcb1.new("mco.a22r8.b1", "mco", at="985.9137+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253352.0, assembly_id=103825.0))
lhcb1.new("mcd.a22r8.b1", "mcd", at="985.9152+(116-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253353.0, assembly_id=103825.0))
lhcb1.new("mb.a22r8.b1", "mb", at="993.3997+(115.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846654.0, assembly_id=103825.0))
lhcb1.new("mcs.a22r8.b1", "mcs", at="1000.8237+(115-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248763.0, assembly_id=103825.0))
lhcb1.new("mb.b22r8.b1", "mb", at="1009.0597+(114.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846678.0, assembly_id=103826.0))
lhcb1.new("mcs.b22r8.b1", "mcs", at="1016.4837+(114-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248766.0, assembly_id=103826.0))
lhcb1.new("mco.b22r8.b1", "mco", at="1017.2337+(114-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253356.0, assembly_id=103827.0))
lhcb1.new("mcd.b22r8.b1", "mcd", at="1017.2352+(114-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253357.0, assembly_id=103827.0))
lhcb1.new("mb.c22r8.b1", "mb", at="1024.7197+(113.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846702.0, assembly_id=103827.0))
lhcb1.new("mcs.c22r8.b1", "mcs", at="1032.1437+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248771.0, assembly_id=103827.0))
lhcb1.new("bpm.22r8.b1", "bpm", at="1033.0227+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248773.0, assembly_id=103828.0))
lhcb1.new("mo.22r8.b1", "mo", at="1033.7737+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308826.0, assembly_id=103828.0))
lhcb1.new("mq.22r8.b1", "mq", at="1035.7847+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308299.0, assembly_id=103828.0))
lhcb1.new("ms.22r8.b1", "ms", at="1037.6797+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253359.0, assembly_id=103828.0))
lhcb1.new("mcbh.22r8.b1", "mcbh", at="1038.2727+(113-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253361.0, assembly_id=103828.0))
lhcb1.new("mb.a23r8.b1", "mb", at="1046.8497+(112.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846726.0, assembly_id=103829.0))
lhcb1.new("mcs.a23r8.b1", "mcs", at="1054.2737+(112-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248779.0, assembly_id=103829.0))
lhcb1.new("mco.23r8.b1", "mco", at="1055.0237+(112-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253364.0, assembly_id=103830.0))
lhcb1.new("mcd.23r8.b1", "mcd", at="1055.0252+(112-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253365.0, assembly_id=103830.0))
lhcb1.new("mb.b23r8.b1", "mb", at="1062.5097+(111.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846750.0, assembly_id=103830.0))
lhcb1.new("mcs.b23r8.b1", "mcs", at="1069.9337+(111-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248784.0, assembly_id=103830.0))
lhcb1.new("mb.c23r8.b1", "mb", at="1078.1697+(110.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846774.0, assembly_id=103831.0))
lhcb1.new("mcs.c23r8.b1", "mcs", at="1085.5937+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248787.0, assembly_id=103831.0))
lhcb1.new("bpm.23r8.b1", "bpm", at="1086.4727+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=266509.0, assembly_id=103832.0))
lhcb1.new("mqs.23r8.b1", "mqs", at="1087.2267+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307649.0, assembly_id=103832.0))
lhcb1.new("mq.23r8.b1", "mq", at="1089.2347+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308088.0, assembly_id=103832.0))
lhcb1.new("ms.23r8.b1", "ms", at="1091.1297+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253367.0, assembly_id=103832.0))
lhcb1.new("mcbv.23r8.b1", "mcbv", at="1091.7227+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253369.0, assembly_id=103832.0))
lhcb1.new("mco.a24r8.b1", "mco", at="1092.8137+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253372.0, assembly_id=103833.0))
lhcb1.new("mcd.a24r8.b1", "mcd", at="1092.8152+(110-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253373.0, assembly_id=103833.0))
lhcb1.new("mb.a24r8.b1", "mb", at="1100.2997+(109.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846798.0, assembly_id=103833.0))
lhcb1.new("mcs.a24r8.b1", "mcs", at="1107.7237+(109-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248795.0, assembly_id=103833.0))
lhcb1.new("mb.b24r8.b1", "mb", at="1115.9597+(108.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846822.0, assembly_id=103834.0))
lhcb1.new("mcs.b24r8.b1", "mcs", at="1123.3837+(108-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248798.0, assembly_id=103834.0))
lhcb1.new("mco.b24r8.b1", "mco", at="1124.1337+(108-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253376.0, assembly_id=103835.0))
lhcb1.new("mcd.b24r8.b1", "mcd", at="1124.1352+(108-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253377.0, assembly_id=103835.0))
lhcb1.new("mb.c24r8.b1", "mb", at="1131.6197+(107.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846846.0, assembly_id=103835.0))
lhcb1.new("mcs.c24r8.b1", "mcs", at="1139.0437+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248803.0, assembly_id=103835.0))
lhcb1.new("bpm.24r8.b1", "bpm", at="1139.9227+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248805.0, assembly_id=103836.0))
lhcb1.new("mo.24r8.b1", "mo", at="1140.6737+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308857.0, assembly_id=103836.0))
lhcb1.new("mq.24r8.b1", "mq", at="1142.6847+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308120.0, assembly_id=103836.0))
lhcb1.new("ms.24r8.b1", "ms", at="1144.5797+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253379.0, assembly_id=103836.0))
lhcb1.new("mcbh.24r8.b1", "mcbh", at="1145.1727+(107-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253381.0, assembly_id=103836.0))
lhcb1.new("mb.a25r8.b1", "mb", at="1153.7497+(106.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846870.0, assembly_id=103837.0))
lhcb1.new("mcs.a25r8.b1", "mcs", at="1161.1737+(106-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248811.0, assembly_id=103837.0))
lhcb1.new("mco.25r8.b1", "mco", at="1161.9237+(106-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253384.0, assembly_id=103838.0))
lhcb1.new("mcd.25r8.b1", "mcd", at="1161.9252+(106-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253385.0, assembly_id=103838.0))
lhcb1.new("mb.b25r8.b1", "mb", at="1169.4097+(105.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846894.0, assembly_id=103838.0))
lhcb1.new("mcs.b25r8.b1", "mcs", at="1176.8337+(105-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248816.0, assembly_id=103838.0))
lhcb1.new("mb.c25r8.b1", "mb", at="1185.0697+(104.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846918.0, assembly_id=103839.0))
lhcb1.new("mcs.c25r8.b1", "mcs", at="1192.4937+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248819.0, assembly_id=103839.0))
lhcb1.new("bpm.25r8.b1", "bpm", at="1193.3727+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248821.0, assembly_id=103840.0))
lhcb1.new("mo.25r8.b1", "mo", at="1194.1237+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308889.0, assembly_id=103840.0))
lhcb1.new("mq.25r8.b1", "mq", at="1196.1347+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308152.0, assembly_id=103840.0))
lhcb1.new("ms.25r8.b1", "ms", at="1198.0297+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253387.0, assembly_id=103840.0))
lhcb1.new("mcbv.25r8.b1", "mcbv", at="1198.6227+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253389.0, assembly_id=103840.0))
lhcb1.new("mco.a26r8.b1", "mco", at="1199.7137+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253392.0, assembly_id=103841.0))
lhcb1.new("mcd.a26r8.b1", "mcd", at="1199.7152+(104-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253393.0, assembly_id=103841.0))
lhcb1.new("mb.a26r8.b1", "mb", at="1207.1997+(103.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846942.0, assembly_id=103841.0))
lhcb1.new("mcs.a26r8.b1", "mcs", at="1214.6237+(103-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248829.0, assembly_id=103841.0))
lhcb1.new("mb.b26r8.b1", "mb", at="1222.8597+(102.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846966.0, assembly_id=103842.0))
lhcb1.new("mcs.b26r8.b1", "mcs", at="1230.2837+(102-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248832.0, assembly_id=103842.0))
lhcb1.new("mco.b26r8.b1", "mco", at="1231.0337+(102-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253396.0, assembly_id=103843.0))
lhcb1.new("mcd.b26r8.b1", "mcd", at="1231.0352+(102-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253397.0, assembly_id=103843.0))
lhcb1.new("mb.c26r8.b1", "mb", at="1238.5197+(101.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52846990.0, assembly_id=103843.0))
lhcb1.new("mcs.c26r8.b1", "mcs", at="1245.9437+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248837.0, assembly_id=103843.0))
lhcb1.new("bpm.26r8.b1", "bpm", at="1246.8227+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248839.0, assembly_id=103844.0))
lhcb1.new("mo.26r8.b1", "mo", at="1247.5737+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308920.0, assembly_id=103844.0))
lhcb1.new("mq.26r8.b1", "mq", at="1249.5847+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308182.0, assembly_id=103844.0))
lhcb1.new("ms.26r8.b1", "ms", at="1251.4797+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253399.0, assembly_id=103844.0))
lhcb1.new("mcbh.26r8.b1", "mcbh", at="1252.0727+(101-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253401.0, assembly_id=103844.0))
lhcb1.new("mb.a27r8.b1", "mb", at="1260.6497+(100.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847014.0, assembly_id=103845.0))
lhcb1.new("mcs.a27r8.b1", "mcs", at="1268.0737+(100-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248845.0, assembly_id=103845.0))
lhcb1.new("mco.27r8.b1", "mco", at="1268.8237+(100-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253404.0, assembly_id=103846.0))
lhcb1.new("mcd.27r8.b1", "mcd", at="1268.8252+(100-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253405.0, assembly_id=103846.0))
lhcb1.new("mb.b27r8.b1", "mb", at="1276.3097+(99.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847038.0, assembly_id=103846.0))
lhcb1.new("mcs.b27r8.b1", "mcs", at="1283.7337+(99-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248850.0, assembly_id=103846.0))
lhcb1.new("mb.c27r8.b1", "mb", at="1291.9697+(98.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847062.0, assembly_id=103847.0))
lhcb1.new("mcs.c27r8.b1", "mcs", at="1299.3937+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248853.0, assembly_id=103847.0))
lhcb1.new("bpm.27r8.b1", "bpm", at="1300.2727+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=266511.0, assembly_id=103848.0))
lhcb1.new("mqs.27r8.b1", "mqs", at="1301.0267+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307681.0, assembly_id=103848.0))
lhcb1.new("mq.27r8.b1", "mq", at="1303.0347+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307972.0, assembly_id=103848.0))
lhcb1.new("ms.27r8.b1", "ms", at="1304.9297+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253407.0, assembly_id=103848.0))
lhcb1.new("mcbv.27r8.b1", "mcbv", at="1305.5227+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253409.0, assembly_id=103848.0))
lhcb1.new("mco.a28r8.b1", "mco", at="1306.6137+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253412.0, assembly_id=103849.0))
lhcb1.new("mcd.a28r8.b1", "mcd", at="1306.6152+(98-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253413.0, assembly_id=103849.0))
lhcb1.new("mb.a28r8.b1", "mb", at="1314.0997+(97.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847086.0, assembly_id=103849.0))
lhcb1.new("mcs.a28r8.b1", "mcs", at="1321.5237+(97-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248861.0, assembly_id=103849.0))
lhcb1.new("mb.b28r8.b1", "mb", at="1329.7597+(96.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847110.0, assembly_id=103850.0))
lhcb1.new("mcs.b28r8.b1", "mcs", at="1337.1837+(96-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248864.0, assembly_id=103850.0))
lhcb1.new("mco.b28r8.b1", "mco", at="1337.9337+(96-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253416.0, assembly_id=103851.0))
lhcb1.new("mcd.b28r8.b1", "mcd", at="1337.9352+(96-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253417.0, assembly_id=103851.0))
lhcb1.new("mb.c28r8.b1", "mb", at="1345.4197+(95.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847134.0, assembly_id=103851.0))
lhcb1.new("mcs.c28r8.b1", "mcs", at="1352.8437+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248869.0, assembly_id=103851.0))
lhcb1.new("bpm.28r8.b1", "bpm", at="1353.7227+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248871.0, assembly_id=103852.0))
lhcb1.new("mo.28r8.b1", "mo", at="1354.4737+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308710.0, assembly_id=103852.0))
lhcb1.new("mq.28r8.b1", "mq", at="1356.4847+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308004.0, assembly_id=103852.0))
lhcb1.new("ms.28r8.b1", "ms", at="1358.3797+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253419.0, assembly_id=103852.0))
lhcb1.new("mcbh.28r8.b1", "mcbh", at="1358.9727+(95-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253421.0, assembly_id=103852.0))
lhcb1.new("mb.a29r8.b1", "mb", at="1367.5497+(94.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847158.0, assembly_id=103853.0))
lhcb1.new("mcs.a29r8.b1", "mcs", at="1374.9737+(94-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248877.0, assembly_id=103853.0))
lhcb1.new("mco.29r8.b1", "mco", at="1375.7237+(94-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253424.0, assembly_id=103854.0))
lhcb1.new("mcd.29r8.b1", "mcd", at="1375.7252+(94-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253425.0, assembly_id=103854.0))
lhcb1.new("mb.b29r8.b1", "mb", at="1383.2097+(93.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847182.0, assembly_id=103854.0))
lhcb1.new("mcs.b29r8.b1", "mcs", at="1390.6337+(93-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248882.0, assembly_id=103854.0))
lhcb1.new("mb.c29r8.b1", "mb", at="1398.8697+(92.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847206.0, assembly_id=103855.0))
lhcb1.new("mcs.c29r8.b1", "mcs", at="1406.2937+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248885.0, assembly_id=103855.0))
lhcb1.new("bpm.29r8.b1", "bpm", at="1407.1727+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248887.0, assembly_id=103856.0))
lhcb1.new("mo.29r8.b1", "mo", at="1407.9237+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308742.0, assembly_id=103856.0))
lhcb1.new("mq.29r8.b1", "mq", at="1409.9347+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308034.0, assembly_id=103856.0))
lhcb1.new("ms.29r8.b1", "ms", at="1411.8297+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253427.0, assembly_id=103856.0))
lhcb1.new("mcbv.29r8.b1", "mcbv", at="1412.4227+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253429.0, assembly_id=103856.0))
lhcb1.new("mco.a30r8.b1", "mco", at="1413.5137+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253432.0, assembly_id=103857.0))
lhcb1.new("mcd.a30r8.b1", "mcd", at="1413.5152+(92-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253433.0, assembly_id=103857.0))
lhcb1.new("mb.a30r8.b1", "mb", at="1420.9997+(91.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847230.0, assembly_id=103857.0))
lhcb1.new("mcs.a30r8.b1", "mcs", at="1428.4237+(91-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248895.0, assembly_id=103857.0))
lhcb1.new("mb.b30r8.b1", "mb", at="1436.6597+(90.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847254.0, assembly_id=103858.0))
lhcb1.new("mcs.b30r8.b1", "mcs", at="1444.0837+(90-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248898.0, assembly_id=103858.0))
lhcb1.new("mco.b30r8.b1", "mco", at="1444.8337+(90-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253436.0, assembly_id=103859.0))
lhcb1.new("mcd.b30r8.b1", "mcd", at="1444.8352+(90-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253437.0, assembly_id=103859.0))
lhcb1.new("mb.c30r8.b1", "mb", at="1452.3197+(89.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847278.0, assembly_id=103859.0))
lhcb1.new("mcs.c30r8.b1", "mcs", at="1459.7437+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248903.0, assembly_id=103859.0))
lhcb1.new("bpm.30r8.b1", "bpm", at="1460.6227+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248905.0, assembly_id=103860.0))
lhcb1.new("mo.30r8.b1", "mo", at="1461.3737+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308772.0, assembly_id=103860.0))
lhcb1.new("mq.30r8.b1", "mq", at="1463.3847+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308064.0, assembly_id=103860.0))
lhcb1.new("mss.30r8.b1", "mss", at="1465.2797+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253439.0, assembly_id=103860.0))
lhcb1.new("mcbh.30r8.b1", "mcbh", at="1465.8727+(89-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253441.0, assembly_id=103860.0))
lhcb1.new("mb.a31r8.b1", "mb", at="1474.4497+(88.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847302.0, assembly_id=103861.0))
lhcb1.new("mcs.a31r8.b1", "mcs", at="1481.8737+(88-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248911.0, assembly_id=103861.0))
lhcb1.new("mco.31r8.b1", "mco", at="1482.6237+(88-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253444.0, assembly_id=103862.0))
lhcb1.new("mcd.31r8.b1", "mcd", at="1482.6252+(88-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253445.0, assembly_id=103862.0))
lhcb1.new("mb.b31r8.b1", "mb", at="1490.1097+(87.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847326.0, assembly_id=103862.0))
lhcb1.new("mcs.b31r8.b1", "mcs", at="1497.5337+(87-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248916.0, assembly_id=103862.0))
lhcb1.new("mb.c31r8.b1", "mb", at="1505.7697+(86.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847350.0, assembly_id=103863.0))
lhcb1.new("mcs.c31r8.b1", "mcs", at="1513.1937+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248919.0, assembly_id=103863.0))
lhcb1.new("bpm.31r8.b1", "bpm", at="1514.0727+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248921.0, assembly_id=103864.0))
lhcb1.new("mo.31r8.b1", "mo", at="1514.8237+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308802.0, assembly_id=103864.0))
lhcb1.new("mq.31r8.b1", "mq", at="1516.8347+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307856.0, assembly_id=103864.0))
lhcb1.new("ms.31r8.b1", "ms", at="1518.7297+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253447.0, assembly_id=103864.0))
lhcb1.new("mcbv.31r8.b1", "mcbv", at="1519.3227+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253449.0, assembly_id=103864.0))
lhcb1.new("s.cell.81.b1", "omk", at="1520.0697+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a32r8.b1", "mco", at="1520.4137+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253452.0, assembly_id=103865.0))
lhcb1.new("mcd.a32r8.b1", "mcd", at="1520.4152+(86-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253453.0, assembly_id=103865.0))
lhcb1.new("mb.a32r8.b1", "mb", at="1527.8997+(85.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847374.0, assembly_id=103865.0))
lhcb1.new("mcs.a32r8.b1", "mcs", at="1535.3237+(85-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248929.0, assembly_id=103865.0))
lhcb1.new("mb.b32r8.b1", "mb", at="1543.5597+(84.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847398.0, assembly_id=103866.0))
lhcb1.new("mcs.b32r8.b1", "mcs", at="1550.9837+(84-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248932.0, assembly_id=103866.0))
lhcb1.new("mco.b32r8.b1", "mco", at="1551.7337+(84-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253456.0, assembly_id=103867.0))
lhcb1.new("mcd.b32r8.b1", "mcd", at="1551.7352+(84-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253457.0, assembly_id=103867.0))
lhcb1.new("mb.c32r8.b1", "mb", at="1559.2197+(83.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847422.0, assembly_id=103867.0))
lhcb1.new("mcs.c32r8.b1", "mcs", at="1566.6437+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248937.0, assembly_id=103867.0))
lhcb1.new("bpm.32r8.b1", "bpm", at="1567.5227+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248939.0, assembly_id=103868.0))
lhcb1.new("mo.32r8.b1", "mo", at="1568.2737+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308595.0, assembly_id=103868.0))
lhcb1.new("mq.32r8.b1", "mq", at="1570.2847+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307886.0, assembly_id=103868.0))
lhcb1.new("ms.32r8.b1", "ms", at="1572.1797+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253459.0, assembly_id=103868.0))
lhcb1.new("mcbh.32r8.b1", "mcbh", at="1572.7727+(83-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253461.0, assembly_id=103868.0))
lhcb1.new("mb.a33r8.b1", "mb", at="1581.3497+(82.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847446.0, assembly_id=103869.0))
lhcb1.new("mcs.a33r8.b1", "mcs", at="1588.7737+(82-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248945.0, assembly_id=103869.0))
lhcb1.new("mco.33r8.b1", "mco", at="1589.5237+(82-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253464.0, assembly_id=103870.0))
lhcb1.new("mcd.33r8.b1", "mcd", at="1589.5252+(82-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253465.0, assembly_id=103870.0))
lhcb1.new("mb.b33r8.b1", "mb", at="1597.0097+(81.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847470.0, assembly_id=103870.0))
lhcb1.new("mcs.b33r8.b1", "mcs", at="1604.4337+(81-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248950.0, assembly_id=103870.0))
lhcb1.new("mb.c33r8.b1", "mb", at="1612.6697+(80.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847494.0, assembly_id=103871.0))
lhcb1.new("mcs.c33r8.b1", "mcs", at="1620.0937+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248953.0, assembly_id=103871.0))
lhcb1.new("bpm.33r8.b1", "bpm", at="1620.9727+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248955.0, assembly_id=103872.0))
lhcb1.new("mo.33r8.b1", "mo", at="1621.7237+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308625.0, assembly_id=103872.0))
lhcb1.new("mq.33r8.b1", "mq", at="1623.7347+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307915.0, assembly_id=103872.0))
lhcb1.new("ms.33r8.b1", "ms", at="1625.6297+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253467.0, assembly_id=103872.0))
lhcb1.new("mcbv.33r8.b1", "mcbv", at="1626.2227+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253469.0, assembly_id=103872.0))
lhcb1.new("e.cell.81.b1", "omk", at="1626.9697+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(slot_id=100932.0))
lhcb1.new("mco.a34r8.b1", "mco", at="1627.3137+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253472.0, assembly_id=103873.0))
lhcb1.new("mcd.a34r8.b1", "mcd", at="1627.3152+(80-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253473.0, assembly_id=103873.0))
lhcb1.new("mb.a34r8.b1", "mb", at="1634.7997+(79.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847518.0, assembly_id=103873.0))
lhcb1.new("mcs.a34r8.b1", "mcs", at="1642.2237+(79-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248963.0, assembly_id=103873.0))
lhcb1.new("mb.b34r8.b1", "mb", at="1650.4597+(78.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847542.0, assembly_id=103874.0))
lhcb1.new("mcs.b34r8.b1", "mcs", at="1657.8837+(78-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248966.0, assembly_id=103874.0))
lhcb1.new("mco.b34r8.b1", "mco", at="1658.6337+(78-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253476.0, assembly_id=103875.0))
lhcb1.new("mcd.b34r8.b1", "mcd", at="1658.6352+(78-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253477.0, assembly_id=103875.0))
lhcb1.new("mb.c34r8.b1", "mb", at="1666.1197+(77.5-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52847566.0, assembly_id=103875.0))
lhcb1.new("mcs.c34r8.b1", "mcs", at="1673.5437+(77-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248971.0, assembly_id=103875.0))
lhcb1.new("bpm.34r8.b1", "bpm", at="1674.4227+(77-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248973.0, assembly_id=103876.0))
lhcb1.new("mo.34r8.b1", "mo", at="1675.1737+(77-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308640.0, assembly_id=103876.0))
lhcb1.new("mq.34r8.b1", "mq", at="1677.1847+(77-ip8ofs.b1)*ds", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307930.0, assembly_id=103876.0))
lhcb1.new("mss.34l1.b1", "mss", at="-1664.5007+(77-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253479.0, assembly_id=103876.0))
lhcb1.new("mcbh.34l1.b1", "mcbh", at="-1663.9077+(77-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253481.0, assembly_id=103876.0))
lhcb1.new("mb.c34l1.b1", "mb", at="-1655.3307+(76.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847590.0, assembly_id=103877.0))
lhcb1.new("mcs.c34l1.b1", "mcs", at="-1647.9067+(76-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=248979.0, assembly_id=103877.0))
lhcb1.new("mco.34l1.b1", "mco", at="-1647.1567+(76-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253484.0, assembly_id=103878.0))
lhcb1.new("mcd.34l1.b1", "mcd", at="-1647.1552+(76-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253485.0, assembly_id=103878.0))
lhcb1.new("mb.b34l1.b1", "mb", at="-1639.6707+(75.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847614.0, assembly_id=103878.0))
lhcb1.new("mcs.b34l1.b1", "mcs", at="-1632.2467+(75-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=248984.0, assembly_id=103878.0))
lhcb1.new("mb.a34l1.b1", "mb", at="-1624.0107+(74.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847638.0, assembly_id=103879.0))
lhcb1.new("mcs.a34l1.b1", "mcs", at="-1616.5867+(74-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=248987.0, assembly_id=103879.0))
lhcb1.new("bpm.33l1.b1", "bpm", at="-1615.7077+(74-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=248989.0, assembly_id=103880.0))
lhcb1.new("mo.33l1.b1", "mo", at="-1614.9567+(74-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308597.0, assembly_id=103880.0))
lhcb1.new("mq.33l1.b1", "mq", at="-1612.9457+(74-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2348459.0, assembly_id=103880.0))
lhcb1.new("ms.33l1.b1", "ms", at="-1611.0507+(74-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253487.0, assembly_id=103880.0))
lhcb1.new("mcbv.33l1.b1", "mcbv", at="-1610.4577+(74-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253489.0, assembly_id=103880.0))
lhcb1.new("mco.b33l1.b1", "mco", at="-1609.3667+(74-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253492.0, assembly_id=103881.0))
lhcb1.new("mcd.b33l1.b1", "mcd", at="-1609.3652+(74-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253493.0, assembly_id=103881.0))
lhcb1.new("mb.c33l1.b1", "mb", at="-1601.8807+(73.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847662.0, assembly_id=103881.0))
lhcb1.new("mcs.c33l1.b1", "mcs", at="-1594.4567+(73-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=248997.0, assembly_id=103881.0))
lhcb1.new("mb.b33l1.b1", "mb", at="-1586.2207+(72.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847686.0, assembly_id=103882.0))
lhcb1.new("mcs.b33l1.b1", "mcs", at="-1578.7967+(72-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249000.0, assembly_id=103882.0))
lhcb1.new("mco.a33l1.b1", "mco", at="-1578.0467+(72-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253496.0, assembly_id=103883.0))
lhcb1.new("mcd.a33l1.b1", "mcd", at="-1578.0452+(72-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253497.0, assembly_id=103883.0))
lhcb1.new("mb.a33l1.b1", "mb", at="-1570.5607+(71.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847710.0, assembly_id=103883.0))
lhcb1.new("mcs.a33l1.b1", "mcs", at="-1563.1367+(71-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249005.0, assembly_id=103883.0))
lhcb1.new("bpm.32l1.b1", "bpm", at="-1562.2577+(71-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249007.0, assembly_id=103884.0))
lhcb1.new("mo.32l1.b1", "mo", at="-1561.5067+(71-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308565.0, assembly_id=103884.0))
lhcb1.new("mq.32l1.b1", "mq", at="-1559.4957+(71-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307858.0, assembly_id=103884.0))
lhcb1.new("mss.32l1.b1", "mss", at="-1557.6007+(71-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253499.0, assembly_id=103884.0))
lhcb1.new("mcbh.32l1.b1", "mcbh", at="-1557.0077+(71-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253501.0, assembly_id=103884.0))
lhcb1.new("mb.c32l1.b1", "mb", at="-1548.4307+(70.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847734.0, assembly_id=103885.0))
lhcb1.new("mcs.c32l1.b1", "mcs", at="-1541.0067+(70-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249013.0, assembly_id=103885.0))
lhcb1.new("mco.32l1.b1", "mco", at="-1540.2567+(70-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253504.0, assembly_id=103886.0))
lhcb1.new("mcd.32l1.b1", "mcd", at="-1540.2552+(70-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253505.0, assembly_id=103886.0))
lhcb1.new("mb.b32l1.b1", "mb", at="-1532.7707+(69.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847758.0, assembly_id=103886.0))
lhcb1.new("mcs.b32l1.b1", "mcs", at="-1525.3467+(69-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249018.0, assembly_id=103886.0))
lhcb1.new("mb.a32l1.b1", "mb", at="-1517.1107+(68.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847782.0, assembly_id=103887.0))
lhcb1.new("mcs.a32l1.b1", "mcs", at="-1509.6867+(68-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249021.0, assembly_id=103887.0))
lhcb1.new("bpm.31l1.b1", "bpm", at="-1508.8077+(68-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249023.0, assembly_id=103888.0))
lhcb1.new("mo.31l1.b1", "mo", at="-1508.0567+(68-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308774.0, assembly_id=103888.0))
lhcb1.new("mq.31l1.b1", "mq", at="-1506.0457+(68-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308066.0, assembly_id=103888.0))
lhcb1.new("ms.31l1.b1", "ms", at="-1504.1507+(68-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253507.0, assembly_id=103888.0))
lhcb1.new("mcbv.31l1.b1", "mcbv", at="-1503.5577+(68-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253509.0, assembly_id=103888.0))
lhcb1.new("mco.b31l1.b1", "mco", at="-1502.4667+(68-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253512.0, assembly_id=103889.0))
lhcb1.new("mcd.b31l1.b1", "mcd", at="-1502.4652+(68-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253513.0, assembly_id=103889.0))
lhcb1.new("mb.c31l1.b1", "mb", at="-1494.9807+(67.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847806.0, assembly_id=103889.0))
lhcb1.new("mcs.c31l1.b1", "mcs", at="-1487.5567+(67-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249031.0, assembly_id=103889.0))
lhcb1.new("mb.b31l1.b1", "mb", at="-1479.3207+(66.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847830.0, assembly_id=103890.0))
lhcb1.new("mcs.b31l1.b1", "mcs", at="-1471.8967+(66-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249034.0, assembly_id=103890.0))
lhcb1.new("mco.a31l1.b1", "mco", at="-1471.1467+(66-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253516.0, assembly_id=103891.0))
lhcb1.new("mcd.a31l1.b1", "mcd", at="-1471.1452+(66-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253517.0, assembly_id=103891.0))
lhcb1.new("mb.a31l1.b1", "mb", at="-1463.6607+(65.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847854.0, assembly_id=103891.0))
lhcb1.new("mcs.a31l1.b1", "mcs", at="-1456.2367+(65-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249039.0, assembly_id=103891.0))
lhcb1.new("bpm.30l1.b1", "bpm", at="-1455.3577+(65-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249041.0, assembly_id=103892.0))
lhcb1.new("mo.30l1.b1", "mo", at="-1454.6067+(65-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308744.0, assembly_id=103892.0))
lhcb1.new("mq.30l1.b1", "mq", at="-1452.5957+(65-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308036.0, assembly_id=103892.0))
lhcb1.new("ms.30l1.b1", "ms", at="-1450.7007+(65-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253519.0, assembly_id=103892.0))
lhcb1.new("mcbh.30l1.b1", "mcbh", at="-1450.1077+(65-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253521.0, assembly_id=103892.0))
lhcb1.new("mb.c30l1.b1", "mb", at="-1441.5307+(64.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847878.0, assembly_id=103893.0))
lhcb1.new("mcs.c30l1.b1", "mcs", at="-1434.1067+(64-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249047.0, assembly_id=103893.0))
lhcb1.new("mco.30l1.b1", "mco", at="-1433.3567+(64-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253524.0, assembly_id=103894.0))
lhcb1.new("mcd.30l1.b1", "mcd", at="-1433.3552+(64-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253525.0, assembly_id=103894.0))
lhcb1.new("mb.b30l1.b1", "mb", at="-1425.8707+(63.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847902.0, assembly_id=103894.0))
lhcb1.new("mcs.b30l1.b1", "mcs", at="-1418.4467+(63-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249052.0, assembly_id=103894.0))
lhcb1.new("mb.a30l1.b1", "mb", at="-1410.2107+(62.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847926.0, assembly_id=103895.0))
lhcb1.new("mcs.a30l1.b1", "mcs", at="-1402.7867+(62-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249055.0, assembly_id=103895.0))
lhcb1.new("bpm.29l1.b1", "bpm", at="-1401.9077+(62-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249057.0, assembly_id=103896.0))
lhcb1.new("mo.29l1.b1", "mo", at="-1401.1567+(62-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308712.0, assembly_id=103896.0))
lhcb1.new("mq.29l1.b1", "mq", at="-1399.1457+(62-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308006.0, assembly_id=103896.0))
lhcb1.new("ms.29l1.b1", "ms", at="-1397.2507+(62-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253527.0, assembly_id=103896.0))
lhcb1.new("mcbv.29l1.b1", "mcbv", at="-1396.6577+(62-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253529.0, assembly_id=103896.0))
lhcb1.new("mco.b29l1.b1", "mco", at="-1395.5667+(62-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253532.0, assembly_id=103897.0))
lhcb1.new("mcd.b29l1.b1", "mcd", at="-1395.5652+(62-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253533.0, assembly_id=103897.0))
lhcb1.new("mb.c29l1.b1", "mb", at="-1388.0807+(61.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847950.0, assembly_id=103897.0))
lhcb1.new("mcs.c29l1.b1", "mcs", at="-1380.6567+(61-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249065.0, assembly_id=103897.0))
lhcb1.new("mb.b29l1.b1", "mb", at="-1372.4207+(60.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847974.0, assembly_id=103898.0))
lhcb1.new("mcs.b29l1.b1", "mcs", at="-1364.9967+(60-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249068.0, assembly_id=103898.0))
lhcb1.new("mco.a29l1.b1", "mco", at="-1364.2467+(60-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253536.0, assembly_id=103899.0))
lhcb1.new("mcd.a29l1.b1", "mcd", at="-1364.2452+(60-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253537.0, assembly_id=103899.0))
lhcb1.new("mb.a29l1.b1", "mb", at="-1356.7607+(59.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52847998.0, assembly_id=103899.0))
lhcb1.new("mcs.a29l1.b1", "mcs", at="-1349.3367+(59-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249073.0, assembly_id=103899.0))
lhcb1.new("bpm.28l1.b1", "bpm", at="-1348.4577+(59-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249075.0, assembly_id=103900.0))
lhcb1.new("mo.28l1.b1", "mo", at="-1347.7067+(59-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308922.0, assembly_id=103900.0))
lhcb1.new("mq.28l1.b1", "mq", at="-1345.6957+(59-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307974.0, assembly_id=103900.0))
lhcb1.new("mss.28l1.b1", "mss", at="-1343.8007+(59-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253539.0, assembly_id=103900.0))
lhcb1.new("mcbh.28l1.b1", "mcbh", at="-1343.2077+(59-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253541.0, assembly_id=103900.0))
lhcb1.new("mb.c28l1.b1", "mb", at="-1334.6307+(58.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848022.0, assembly_id=103901.0))
lhcb1.new("mcs.c28l1.b1", "mcs", at="-1327.2067+(58-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249081.0, assembly_id=103901.0))
lhcb1.new("mco.28l1.b1", "mco", at="-1326.4567+(58-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253544.0, assembly_id=103902.0))
lhcb1.new("mcd.28l1.b1", "mcd", at="-1326.4552+(58-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253545.0, assembly_id=103902.0))
lhcb1.new("mb.b28l1.b1", "mb", at="-1318.9707+(57.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848046.0, assembly_id=103902.0))
lhcb1.new("mcs.b28l1.b1", "mcs", at="-1311.5467+(57-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249086.0, assembly_id=103902.0))
lhcb1.new("mb.a28l1.b1", "mb", at="-1303.3107+(56.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848070.0, assembly_id=103903.0))
lhcb1.new("mcs.a28l1.b1", "mcs", at="-1295.8867+(56-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249089.0, assembly_id=103903.0))
lhcb1.new("bpm.27l1.b1", "bpm", at="-1295.0077+(56-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=266513.0, assembly_id=103904.0))
lhcb1.new("mqs.27l1.b1", "mqs", at="-1294.2537+(56-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307651.0, assembly_id=103904.0))
lhcb1.new("mq.27l1.b1", "mq", at="-1292.2457+(56-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308184.0, assembly_id=103904.0))
lhcb1.new("ms.27l1.b1", "ms", at="-1290.3507+(56-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253547.0, assembly_id=103904.0))
lhcb1.new("mcbv.27l1.b1", "mcbv", at="-1289.7577+(56-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253549.0, assembly_id=103904.0))
lhcb1.new("mco.b27l1.b1", "mco", at="-1288.6667+(56-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253552.0, assembly_id=103905.0))
lhcb1.new("mcd.b27l1.b1", "mcd", at="-1288.6652+(56-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253553.0, assembly_id=103905.0))
lhcb1.new("mb.c27l1.b1", "mb", at="-1281.1807+(55.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848094.0, assembly_id=103905.0))
lhcb1.new("mcs.c27l1.b1", "mcs", at="-1273.7567+(55-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249097.0, assembly_id=103905.0))
lhcb1.new("mb.b27l1.b1", "mb", at="-1265.5207+(54.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848118.0, assembly_id=103906.0))
lhcb1.new("mcs.b27l1.b1", "mcs", at="-1258.0967+(54-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249100.0, assembly_id=103906.0))
lhcb1.new("mco.a27l1.b1", "mco", at="-1257.3467+(54-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253556.0, assembly_id=103907.0))
lhcb1.new("mcd.a27l1.b1", "mcd", at="-1257.3452+(54-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253557.0, assembly_id=103907.0))
lhcb1.new("mb.a27l1.b1", "mb", at="-1249.8607+(53.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848142.0, assembly_id=103907.0))
lhcb1.new("mcs.a27l1.b1", "mcs", at="-1242.4367+(53-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249105.0, assembly_id=103907.0))
lhcb1.new("bpm.26l1.b1", "bpm", at="-1241.5577+(53-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249107.0, assembly_id=103908.0))
lhcb1.new("mo.26l1.b1", "mo", at="-1240.8067+(53-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308891.0, assembly_id=103908.0))
lhcb1.new("mq.26l1.b1", "mq", at="-1238.7957+(53-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308154.0, assembly_id=103908.0))
lhcb1.new("ms.26l1.b1", "ms", at="-1236.9007+(53-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253559.0, assembly_id=103908.0))
lhcb1.new("mcbh.26l1.b1", "mcbh", at="-1236.3077+(53-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253561.0, assembly_id=103908.0))
lhcb1.new("mb.c26l1.b1", "mb", at="-1227.7307+(52.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848166.0, assembly_id=103909.0))
lhcb1.new("mcs.c26l1.b1", "mcs", at="-1220.3067+(52-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249113.0, assembly_id=103909.0))
lhcb1.new("mco.26l1.b1", "mco", at="-1219.5567+(52-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253564.0, assembly_id=103910.0))
lhcb1.new("mcd.26l1.b1", "mcd", at="-1219.5552+(52-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253565.0, assembly_id=103910.0))
lhcb1.new("mb.b26l1.b1", "mb", at="-1212.0707+(51.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848190.0, assembly_id=103910.0))
lhcb1.new("mcs.b26l1.b1", "mcs", at="-1204.6467+(51-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249118.0, assembly_id=103910.0))
lhcb1.new("mb.a26l1.b1", "mb", at="-1196.4107+(50.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848214.0, assembly_id=103911.0))
lhcb1.new("mcs.a26l1.b1", "mcs", at="-1188.9867+(50-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249121.0, assembly_id=103911.0))
lhcb1.new("bpm.25l1.b1", "bpm", at="-1188.1077+(50-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249123.0, assembly_id=103912.0))
lhcb1.new("mo.25l1.b1", "mo", at="-1187.3567+(50-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308859.0, assembly_id=103912.0))
lhcb1.new("mq.25l1.b1", "mq", at="-1185.3457+(50-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308122.0, assembly_id=103912.0))
lhcb1.new("ms.25l1.b1", "ms", at="-1183.4507+(50-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253567.0, assembly_id=103912.0))
lhcb1.new("mcbv.25l1.b1", "mcbv", at="-1182.8577+(50-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253569.0, assembly_id=103912.0))
lhcb1.new("mco.b25l1.b1", "mco", at="-1181.7667+(50-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253572.0, assembly_id=103913.0))
lhcb1.new("mcd.b25l1.b1", "mcd", at="-1181.7652+(50-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253573.0, assembly_id=103913.0))
lhcb1.new("mb.c25l1.b1", "mb", at="-1174.2807+(49.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848238.0, assembly_id=103913.0))
lhcb1.new("mcs.c25l1.b1", "mcs", at="-1166.8567+(49-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249131.0, assembly_id=103913.0))
lhcb1.new("mb.b25l1.b1", "mb", at="-1158.6207+(48.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848262.0, assembly_id=103914.0))
lhcb1.new("mcs.b25l1.b1", "mcs", at="-1151.1967+(48-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249134.0, assembly_id=103914.0))
lhcb1.new("mco.a25l1.b1", "mco", at="-1150.4467+(48-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253576.0, assembly_id=103915.0))
lhcb1.new("mcd.a25l1.b1", "mcd", at="-1150.4452+(48-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253577.0, assembly_id=103915.0))
lhcb1.new("mb.a25l1.b1", "mb", at="-1142.9607+(47.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848286.0, assembly_id=103915.0))
lhcb1.new("mcs.a25l1.b1", "mcs", at="-1135.5367+(47-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249139.0, assembly_id=103915.0))
lhcb1.new("bpm.24l1.b1", "bpm", at="-1134.6577+(47-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249141.0, assembly_id=103916.0))
lhcb1.new("mo.24l1.b1", "mo", at="-1133.9067+(47-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308828.0, assembly_id=103916.0))
lhcb1.new("mq.24l1.b1", "mq", at="-1131.8957+(47-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308090.0, assembly_id=103916.0))
lhcb1.new("ms.24l1.b1", "ms", at="-1130.0007+(47-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253579.0, assembly_id=103916.0))
lhcb1.new("mcbh.24l1.b1", "mcbh", at="-1129.4077+(47-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253581.0, assembly_id=103916.0))
lhcb1.new("mb.c24l1.b1", "mb", at="-1120.8307+(46.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848310.0, assembly_id=103917.0))
lhcb1.new("mcs.c24l1.b1", "mcs", at="-1113.4067+(46-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249147.0, assembly_id=103917.0))
lhcb1.new("mco.24l1.b1", "mco", at="-1112.6567+(46-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253584.0, assembly_id=103918.0))
lhcb1.new("mcd.24l1.b1", "mcd", at="-1112.6552+(46-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253585.0, assembly_id=103918.0))
lhcb1.new("mb.b24l1.b1", "mb", at="-1105.1707+(45.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848334.0, assembly_id=103918.0))
lhcb1.new("mcs.b24l1.b1", "mcs", at="-1097.7467+(45-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249152.0, assembly_id=103918.0))
lhcb1.new("mb.a24l1.b1", "mb", at="-1089.5107+(44.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848358.0, assembly_id=103919.0))
lhcb1.new("mcs.a24l1.b1", "mcs", at="-1082.0867+(44-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249155.0, assembly_id=103919.0))
lhcb1.new("bpm.23l1.b1", "bpm", at="-1081.2077+(44-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=266515.0, assembly_id=103920.0))
lhcb1.new("mqs.23l1.b1", "mqs", at="-1080.4537+(44-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307621.0, assembly_id=103920.0))
lhcb1.new("mq.23l1.b1", "mq", at="-1078.4457+(44-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308301.0, assembly_id=103920.0))
lhcb1.new("ms.23l1.b1", "ms", at="-1076.5507+(44-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253587.0, assembly_id=103920.0))
lhcb1.new("mcbv.23l1.b1", "mcbv", at="-1075.9577+(44-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253589.0, assembly_id=103920.0))
lhcb1.new("mco.b23l1.b1", "mco", at="-1074.8667+(44-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253592.0, assembly_id=103921.0))
lhcb1.new("mcd.b23l1.b1", "mcd", at="-1074.8652+(44-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253593.0, assembly_id=103921.0))
lhcb1.new("mb.c23l1.b1", "mb", at="-1067.3807+(43.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848382.0, assembly_id=103921.0))
lhcb1.new("mcs.c23l1.b1", "mcs", at="-1059.9567+(43-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249163.0, assembly_id=103921.0))
lhcb1.new("mb.b23l1.b1", "mb", at="-1051.7207+(42.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848406.0, assembly_id=103922.0))
lhcb1.new("mcs.b23l1.b1", "mcs", at="-1044.2967+(42-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249166.0, assembly_id=103922.0))
lhcb1.new("mco.a23l1.b1", "mco", at="-1043.5467+(42-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253596.0, assembly_id=103923.0))
lhcb1.new("mcd.a23l1.b1", "mcd", at="-1043.5452+(42-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253597.0, assembly_id=103923.0))
lhcb1.new("mb.a23l1.b1", "mb", at="-1036.0607+(41.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848430.0, assembly_id=103923.0))
lhcb1.new("mcs.a23l1.b1", "mcs", at="-1028.6367+(41-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249171.0, assembly_id=103923.0))
lhcb1.new("bpm.22l1.b1", "bpm", at="-1027.7577+(41-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249173.0, assembly_id=103924.0))
lhcb1.new("mo.22l1.b1", "mo", at="-1027.0067+(41-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2309035.0, assembly_id=103924.0))
lhcb1.new("mq.22l1.b1", "mq", at="-1024.9957+(41-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308269.0, assembly_id=103924.0))
lhcb1.new("ms.22l1.b1", "ms", at="-1023.1007+(41-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253599.0, assembly_id=103924.0))
lhcb1.new("mcbh.22l1.b1", "mcbh", at="-1022.5077+(41-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253601.0, assembly_id=103924.0))
lhcb1.new("mb.c22l1.b1", "mb", at="-1013.9307+(40.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848454.0, assembly_id=103925.0))
lhcb1.new("mcs.c22l1.b1", "mcs", at="-1006.5067+(40-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249179.0, assembly_id=103925.0))
lhcb1.new("mco.22l1.b1", "mco", at="-1005.7567+(40-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253604.0, assembly_id=103926.0))
lhcb1.new("mcd.22l1.b1", "mcd", at="-1005.7552+(40-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253605.0, assembly_id=103926.0))
lhcb1.new("mb.b22l1.b1", "mb", at="-998.2707+(39.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848478.0, assembly_id=103926.0))
lhcb1.new("mcs.b22l1.b1", "mcs", at="-990.8467+(39-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249184.0, assembly_id=103926.0))
lhcb1.new("mb.a22l1.b1", "mb", at="-982.6107+(38.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848502.0, assembly_id=103927.0))
lhcb1.new("mcs.a22l1.b1", "mcs", at="-975.1867+(38-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249187.0, assembly_id=103927.0))
lhcb1.new("bpm.21l1.b1", "bpm", at="-974.3077+(38-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249189.0, assembly_id=103928.0))
lhcb1.new("mqt.21l1.b1", "mqt", at="-973.5537+(38-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307486.0, assembly_id=103928.0))
lhcb1.new("mq.21l1.b1", "mq", at="-971.5457+(38-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308238.0, assembly_id=103928.0))
lhcb1.new("ms.21l1.b1", "ms", at="-969.6507+(38-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253607.0, assembly_id=103928.0))
lhcb1.new("mcbv.21l1.b1", "mcbv", at="-969.0577+(38-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253609.0, assembly_id=103928.0))
lhcb1.new("mco.b21l1.b1", "mco", at="-967.9667+(38-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253612.0, assembly_id=103929.0))
lhcb1.new("mcd.b21l1.b1", "mcd", at="-967.9652+(38-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253613.0, assembly_id=103929.0))
lhcb1.new("mb.c21l1.b1", "mb", at="-960.4807+(37.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848526.0, assembly_id=103929.0))
lhcb1.new("mcs.c21l1.b1", "mcs", at="-953.0567+(37-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249197.0, assembly_id=103929.0))
lhcb1.new("mb.b21l1.b1", "mb", at="-944.8207+(36.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848550.0, assembly_id=103930.0))
lhcb1.new("mcs.b21l1.b1", "mcs", at="-937.3967+(36-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249200.0, assembly_id=103930.0))
lhcb1.new("mco.a21l1.b1", "mco", at="-936.6467+(36-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253616.0, assembly_id=103931.0))
lhcb1.new("mcd.a21l1.b1", "mcd", at="-936.6452+(36-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253617.0, assembly_id=103931.0))
lhcb1.new("mb.a21l1.b1", "mb", at="-929.1607+(35.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848574.0, assembly_id=103931.0))
lhcb1.new("mcs.a21l1.b1", "mcs", at="-921.7367+(35-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249205.0, assembly_id=103931.0))
lhcb1.new("bpm.20l1.b1", "bpm", at="-920.8577+(35-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249207.0, assembly_id=103932.0))
lhcb1.new("mqt.20l1.b1", "mqt_unplugged", at="-920.1037+(35-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307457.0, assembly_id=103932.0))
lhcb1.new("mq.20l1.b1", "mq", at="-918.0957+(35-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308208.0, assembly_id=103932.0))
lhcb1.new("ms.20l1.b1", "ms", at="-916.2007+(35-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253619.0, assembly_id=103932.0))
lhcb1.new("mcbh.20l1.b1", "mcbh", at="-915.6077+(35-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253621.0, assembly_id=103932.0))
lhcb1.new("mb.c20l1.b1", "mb", at="-907.0307+(34.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848598.0, assembly_id=103933.0))
lhcb1.new("mcs.c20l1.b1", "mcs", at="-899.6067+(34-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249213.0, assembly_id=103933.0))
lhcb1.new("mco.20l1.b1", "mco", at="-898.8567+(34-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253624.0, assembly_id=103934.0))
lhcb1.new("mcd.20l1.b1", "mcd", at="-898.8552+(34-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253625.0, assembly_id=103934.0))
lhcb1.new("mb.b20l1.b1", "mb", at="-891.3707+(33.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848622.0, assembly_id=103934.0))
lhcb1.new("mcs.b20l1.b1", "mcs", at="-883.9467+(33-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249218.0, assembly_id=103934.0))
lhcb1.new("mb.a20l1.b1", "mb", at="-875.7107+(32.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848646.0, assembly_id=103935.0))
lhcb1.new("mcs.a20l1.b1", "mcs", at="-868.2867+(32-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249221.0, assembly_id=103935.0))
lhcb1.new("bpm.19l1.b1", "bpm", at="-867.4077+(32-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249223.0, assembly_id=103936.0))
lhcb1.new("mqt.19l1.b1", "mqt", at="-866.6537+(32-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307427.0, assembly_id=103936.0))
lhcb1.new("mq.19l1.b1", "mq", at="-864.6457+(32-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308416.0, assembly_id=103936.0))
lhcb1.new("ms.19l1.b1", "ms", at="-862.7507+(32-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253627.0, assembly_id=103936.0))
lhcb1.new("mcbv.19l1.b1", "mcbv", at="-862.1577+(32-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253629.0, assembly_id=103936.0))
lhcb1.new("mco.b19l1.b1", "mco", at="-861.0667+(32-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253632.0, assembly_id=103937.0))
lhcb1.new("mcd.b19l1.b1", "mcd", at="-861.0652+(32-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253633.0, assembly_id=103937.0))
lhcb1.new("mb.c19l1.b1", "mb", at="-853.5807+(31.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848670.0, assembly_id=103937.0))
lhcb1.new("mcs.c19l1.b1", "mcs", at="-846.1567+(31-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249231.0, assembly_id=103937.0))
lhcb1.new("mb.b19l1.b1", "mb", at="-837.9207+(30.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848694.0, assembly_id=103938.0))
lhcb1.new("mcs.b19l1.b1", "mcs", at="-830.4967+(30-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249234.0, assembly_id=103938.0))
lhcb1.new("mco.a19l1.b1", "mco", at="-829.7467+(30-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253636.0, assembly_id=103939.0))
lhcb1.new("mcd.a19l1.b1", "mcd", at="-829.7452+(30-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253637.0, assembly_id=103939.0))
lhcb1.new("mb.a19l1.b1", "mb", at="-822.2607+(29.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848718.0, assembly_id=103939.0))
lhcb1.new("mcs.a19l1.b1", "mcs", at="-814.8367+(29-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249239.0, assembly_id=103939.0))
lhcb1.new("bpm.18l1.b1", "bpm", at="-813.9577+(29-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249241.0, assembly_id=103940.0))
lhcb1.new("mqt.18l1.b1", "mqt_unplugged", at="-813.2037+(29-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307395.0, assembly_id=103940.0))
lhcb1.new("mq.18l1.b1", "mq", at="-811.1957+(29-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308385.0, assembly_id=103940.0))
lhcb1.new("ms.18l1.b1", "ms", at="-809.3007+(29-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253639.0, assembly_id=103940.0))
lhcb1.new("mcbh.18l1.b1", "mcbh", at="-808.7077+(29-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253641.0, assembly_id=103940.0))
lhcb1.new("mb.c18l1.b1", "mb", at="-800.1307+(28.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848742.0, assembly_id=103941.0))
lhcb1.new("mcs.c18l1.b1", "mcs", at="-792.7067+(28-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249247.0, assembly_id=103941.0))
lhcb1.new("mco.18l1.b1", "mco", at="-791.9567+(28-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253644.0, assembly_id=103942.0))
lhcb1.new("mcd.18l1.b1", "mcd", at="-791.9552+(28-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253645.0, assembly_id=103942.0))
lhcb1.new("mb.b18l1.b1", "mb", at="-784.4707+(27.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848766.0, assembly_id=103942.0))
lhcb1.new("mcs.b18l1.b1", "mcs", at="-777.0467+(27-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249252.0, assembly_id=103942.0))
lhcb1.new("mb.a18l1.b1", "mb", at="-768.8107+(26.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848790.0, assembly_id=103943.0))
lhcb1.new("mcs.a18l1.b1", "mcs", at="-761.3867+(26-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249255.0, assembly_id=103943.0))
lhcb1.new("bpm.17l1.b1", "bpm", at="-760.5077+(26-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249257.0, assembly_id=103944.0))
lhcb1.new("mqt.17l1.b1", "mqt", at="-759.7537+(26-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307600.0, assembly_id=103944.0))
lhcb1.new("mq.17l1.b1", "mq", at="-757.7457+(26-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308355.0, assembly_id=103944.0))
lhcb1.new("ms.17l1.b1", "ms", at="-755.8507+(26-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253647.0, assembly_id=103944.0))
lhcb1.new("mcbv.17l1.b1", "mcbv", at="-755.2577+(26-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253649.0, assembly_id=103944.0))
lhcb1.new("mco.b17l1.b1", "mco", at="-754.1667+(26-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253652.0, assembly_id=103945.0))
lhcb1.new("mcd.b17l1.b1", "mcd", at="-754.1652+(26-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253653.0, assembly_id=103945.0))
lhcb1.new("mb.c17l1.b1", "mb", at="-746.6807+(25.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848814.0, assembly_id=103945.0))
lhcb1.new("mcs.c17l1.b1", "mcs", at="-739.2567+(25-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249265.0, assembly_id=103945.0))
lhcb1.new("mb.b17l1.b1", "mb", at="-731.0207+(24.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848838.0, assembly_id=103946.0))
lhcb1.new("mcs.b17l1.b1", "mcs", at="-723.5967+(24-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249268.0, assembly_id=103946.0))
lhcb1.new("mco.a17l1.b1", "mco", at="-722.8467+(24-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253656.0, assembly_id=103947.0))
lhcb1.new("mcd.a17l1.b1", "mcd", at="-722.8452+(24-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253657.0, assembly_id=103947.0))
lhcb1.new("mb.a17l1.b1", "mb", at="-715.3607+(23.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848862.0, assembly_id=103947.0))
lhcb1.new("mcs.a17l1.b1", "mcs", at="-707.9367+(23-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249273.0, assembly_id=103947.0))
lhcb1.new("bpm.16l1.b1", "bpm", at="-707.0577+(23-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249275.0, assembly_id=103948.0))
lhcb1.new("mqt.16l1.b1", "mqt_unplugged", at="-706.3037+(23-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2348445.0, assembly_id=103948.0))
lhcb1.new("mq.16l1.b1", "mq", at="-704.2957+(23-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308563.0, assembly_id=103948.0))
lhcb1.new("ms.16l1.b1", "ms", at="-702.4007+(23-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253659.0, assembly_id=103948.0))
lhcb1.new("mcbh.16l1.b1", "mcbh", at="-701.8077+(23-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253661.0, assembly_id=103948.0))
lhcb1.new("mb.c16l1.b1", "mb", at="-693.2307+(22.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848886.0, assembly_id=103949.0))
lhcb1.new("mcs.c16l1.b1", "mcs", at="-685.8067+(22-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249281.0, assembly_id=103949.0))
lhcb1.new("mco.16l1.b1", "mco", at="-685.0567+(22-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253664.0, assembly_id=103950.0))
lhcb1.new("mcd.16l1.b1", "mcd", at="-685.0552+(22-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253665.0, assembly_id=103950.0))
lhcb1.new("mb.b16l1.b1", "mb", at="-677.5707+(21.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848910.0, assembly_id=103950.0))
lhcb1.new("mcs.b16l1.b1", "mcs", at="-670.1467+(21-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249286.0, assembly_id=103950.0))
lhcb1.new("mb.a16l1.b1", "mb", at="-661.9107+(20.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848934.0, assembly_id=103951.0))
lhcb1.new("mcs.a16l1.b1", "mcs", at="-654.4867+(20-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249289.0, assembly_id=103951.0))
lhcb1.new("bpm.15l1.b1", "bpm", at="-653.6077+(20-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249291.0, assembly_id=103952.0))
lhcb1.new("mqt.15l1.b1", "mqt", at="-652.8537+(20-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307539.0, assembly_id=103952.0))
lhcb1.new("mq.15l1.b1", "mq", at="-650.8457+(20-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308532.0, assembly_id=103952.0))
lhcb1.new("ms.15l1.b1", "ms", at="-648.9507+(20-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253667.0, assembly_id=103952.0))
lhcb1.new("mcbv.15l1.b1", "mcbv", at="-648.3577+(20-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253669.0, assembly_id=103952.0))
lhcb1.new("mco.b15l1.b1", "mco", at="-647.2667+(20-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253672.0, assembly_id=103953.0))
lhcb1.new("mcd.b15l1.b1", "mcd", at="-647.2652+(20-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253673.0, assembly_id=103953.0))
lhcb1.new("mb.c15l1.b1", "mb", at="-639.7807+(19.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848958.0, assembly_id=103953.0))
lhcb1.new("mcs.c15l1.b1", "mcs", at="-632.3567+(19-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249299.0, assembly_id=103953.0))
lhcb1.new("mb.b15l1.b1", "mb", at="-624.1207+(18.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52848982.0, assembly_id=103954.0))
lhcb1.new("mcs.b15l1.b1", "mcs", at="-616.6967+(18-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249302.0, assembly_id=103954.0))
lhcb1.new("mco.a15l1.b1", "mco", at="-615.9467+(18-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253676.0, assembly_id=103955.0))
lhcb1.new("mcd.a15l1.b1", "mcd", at="-615.9452+(18-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253677.0, assembly_id=103955.0))
lhcb1.new("mb.a15l1.b1", "mb", at="-608.4607+(17.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849006.0, assembly_id=103955.0))
lhcb1.new("mcs.a15l1.b1", "mcs", at="-601.0367+(17-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249307.0, assembly_id=103955.0))
lhcb1.new("bpm.14l1.b1", "bpm", at="-600.1577+(17-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249309.0, assembly_id=103956.0))
lhcb1.new("mqt.14l1.b1", "mqt_unplugged", at="-599.4037+(17-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307507.0, assembly_id=103956.0))
lhcb1.new("mq.14l1.b1", "mq", at="-597.3957+(17-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308502.0, assembly_id=103956.0))
lhcb1.new("ms.14l1.b1", "ms", at="-595.5007+(17-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253679.0, assembly_id=103956.0))
lhcb1.new("mcbh.14l1.b1", "mcbh", at="-594.9077+(17-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253681.0, assembly_id=103956.0))
lhcb1.new("mb.c14l1.b1", "mb", at="-586.3307+(16.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849030.0, assembly_id=103957.0))
lhcb1.new("mcs.c14l1.b1", "mcs", at="-578.9067+(16-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249315.0, assembly_id=103957.0))
lhcb1.new("mco.14l1.b1", "mco", at="-578.1567+(16-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253684.0, assembly_id=103958.0))
lhcb1.new("mcd.14l1.b1", "mcd", at="-578.1552+(16-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253685.0, assembly_id=103958.0))
lhcb1.new("mb.b14l1.b1", "mb", at="-570.6707+(15.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849054.0, assembly_id=103958.0))
lhcb1.new("mcs.b14l1.b1", "mcs", at="-563.2467+(15-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249320.0, assembly_id=103958.0))
lhcb1.new("mb.a14l1.b1", "mb", at="-555.0107+(14.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849078.0, assembly_id=103959.0))
lhcb1.new("mcs.a14l1.b1", "mcs", at="-547.5867+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249323.0, assembly_id=103959.0))
lhcb1.new("s.ds.l1.b1", "omk", at="-547.1807+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.13l1.b1", "bpm", at="-546.7077+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249325.0, assembly_id=103960.0))
lhcb1.new("mqt.13l1.b1", "mqt", at="-545.9537+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307715.0, assembly_id=103960.0))
lhcb1.new("mq.13l1.b1", "mq", at="-543.9457+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308473.0, assembly_id=103960.0))
lhcb1.new("ms.13l1.b1", "ms", at="-542.0507+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253687.0, assembly_id=103960.0))
lhcb1.new("mcbv.13l1.b1", "mcbv", at="-541.4577+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253689.0, assembly_id=103960.0))
lhcb1.new("mco.b13l1.b1", "mco", at="-540.3667+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253692.0, assembly_id=103961.0))
lhcb1.new("mcd.b13l1.b1", "mcd", at="-540.3652+(14-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253693.0, assembly_id=103961.0))
lhcb1.new("mb.c13l1.b1", "mb", at="-532.8807+(13.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849102.0, assembly_id=103961.0))
lhcb1.new("mcs.c13l1.b1", "mcs", at="-525.4567+(13-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249333.0, assembly_id=103961.0))
lhcb1.new("mb.b13l1.b1", "mb", at="-517.2207+(12.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849126.0, assembly_id=103962.0))
lhcb1.new("mcs.b13l1.b1", "mcs", at="-509.7967+(12-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249336.0, assembly_id=103962.0))
lhcb1.new("mco.a13l1.b1", "mco", at="-509.0467+(12-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253696.0, assembly_id=103963.0))
lhcb1.new("mcd.a13l1.b1", "mcd", at="-509.0452+(12-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253697.0, assembly_id=103963.0))
lhcb1.new("mb.a13l1.b1", "mb", at="-501.5607+(11.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849150.0, assembly_id=103963.0))
lhcb1.new("mcs.a13l1.b1", "mcs", at="-494.1367+(11-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249341.0, assembly_id=103963.0))
lhcb1.new("bpm.12l1.b1", "bpm", at="-493.2577+(11-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249343.0, assembly_id=103964.0))
lhcb1.new("mqt.12l1.b1", "mqt", at="-492.5037+(11-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307683.0, assembly_id=103964.0))
lhcb1.new("mq.12l1.b1", "mq", at="-490.4957+(11-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308679.0, assembly_id=103964.0))
lhcb1.new("ms.12l1.b1", "ms", at="-488.6007+(11-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253699.0, assembly_id=103964.0))
lhcb1.new("mcbh.12l1.b1", "mcbh", at="-488.0077+(11-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253701.0, assembly_id=103964.0))
lhcb1.new("mb.c12l1.b1", "mb", at="-479.4307+(10.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849174.0, assembly_id=103965.0))
lhcb1.new("mcs.c12l1.b1", "mcs", at="-472.0067+(10-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249349.0, assembly_id=103965.0))
lhcb1.new("mco.12l1.b1", "mco", at="-471.2567+(10-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253704.0, assembly_id=103966.0))
lhcb1.new("mcd.12l1.b1", "mcd", at="-471.2552+(10-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253705.0, assembly_id=103966.0))
lhcb1.new("mb.b12l1.b1", "mb", at="-463.7707+(9.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849198.0, assembly_id=103966.0))
lhcb1.new("mcs.b12l1.b1", "mcs", at="-456.3467+(9-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249354.0, assembly_id=103966.0))
lhcb1.new("mb.a12l1.b1", "mb", at="-448.1107+(8.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849222.0, assembly_id=103967.0))
lhcb1.new("mcs.a12l1.b1", "mcs", at="-440.6867+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249357.0, assembly_id=103967.0))
lhcb1.new("e.arc.81.b1", "omk", at="-440.2807+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=100932.0))
lhcb1.new("bpm.11l1.b1", "bpm", at="-439.8077+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249359.0, assembly_id=103968.0))
lhcb1.new("mq.11l1.b1", "mq", at="-437.2607+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2308650.0, assembly_id=103968.0))
lhcb1.new("mqtli.11l1.b1", "mqtli", at="-434.8917+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307338.0, assembly_id=103968.0))
lhcb1.new("ms.11l1.b1", "ms", at="-433.8797+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253707.0, assembly_id=103968.0))
lhcb1.new("mcbv.11l1.b1", "mcbv", at="-433.2867+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253709.0, assembly_id=103968.0))
lhcb1.new("lefl.11l1.b1", "lefl", at="-425.67735+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52997874.0, assembly_id=103969.0))
lhcb1.new("mco.11l1.b1", "mco", at="-418.475+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253712.0, assembly_id=103970.0))
lhcb1.new("mcd.11l1.b1", "mcd", at="-418.4735+(8-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253713.0, assembly_id=103970.0))
lhcb1.new("mb.b11l1.b1", "mb", at="-410.989+(7.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849246.0, assembly_id=103970.0))
lhcb1.new("mcs.b11l1.b1", "mcs", at="-403.565+(7-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249367.0, assembly_id=103970.0))
lhcb1.new("mb.a11l1.b1", "mb", at="-395.329+(6.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849798.0, assembly_id=103971.0))
lhcb1.new("mcs.a11l1.b1", "mcs", at="-387.905+(6-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=357343.0, assembly_id=103971.0))
lhcb1.new("bpm.10l1.b1", "bpm", at="-387.026+(6-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249372.0, assembly_id=103972.0))
lhcb1.new("mqml.10l1.b1", "mqml", at="-383.881+(6-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307804.0, assembly_id=103972.0))
lhcb1.new("mcbch.10l1.b1", "mcbch", at="-380.839+(6-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253714.0, assembly_id=103972.0))
lhcb1.new("mco.10l1.b1", "mco", at="-379.41+(6-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253718.0, assembly_id=103973.0))
lhcb1.new("mcd.10l1.b1", "mcd", at="-379.4085+(6-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253719.0, assembly_id=103973.0))
lhcb1.new("mb.b10l1.b1", "mb", at="-371.924+(5.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849270.0, assembly_id=103973.0))
lhcb1.new("mcs.b10l1.b1", "mcs", at="-364.5+(5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249379.0, assembly_id=103973.0))
lhcb1.new("mb.a10l1.b1", "mb", at="-356.264+(4.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849294.0, assembly_id=103974.0))
lhcb1.new("mcs.a10l1.b1", "mcs", at="-348.84+(4-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249382.0, assembly_id=103974.0))
lhcb1.new("bpm.9l1.b1", "bpm", at="-347.96+(4-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249384.0, assembly_id=103975.0))
lhcb1.new("mqmc.9l1.b1", "mqmc", at="-345.984+(4-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307781.0, assembly_id=103975.0))
lhcb1.new("mqm.9l1.b1", "mqm", at="-342.718+(4-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307729.0, assembly_id=103975.0))
lhcb1.new("mcbcv.9l1.b1", "mcbcv", at="-340.377+(4-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253720.0, assembly_id=103975.0))
lhcb1.new("mco.9l1.b1", "mco", at="-338.945+(4-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253724.0, assembly_id=103976.0))
lhcb1.new("mcd.9l1.b1", "mcd", at="-338.9435+(4-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253725.0, assembly_id=103976.0))
lhcb1.new("mb.b9l1.b1", "mb", at="-331.459+(3.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849318.0, assembly_id=103976.0))
lhcb1.new("mcs.b9l1.b1", "mcs", at="-324.035+(3-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249392.0, assembly_id=103976.0))
lhcb1.new("mb.a9l1.b1", "mb", at="-315.799+(2.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849342.0, assembly_id=103977.0))
lhcb1.new("mcs.a9l1.b1", "mcs", at="-308.375+(2-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249395.0, assembly_id=103977.0))
lhcb1.new("bpm.8l1.b1", "bpm", at="-307.496+(2-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249397.0, assembly_id=103978.0))
lhcb1.new("mqml.8l1.b1", "mqml", at="-304.351+(2-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307836.0, assembly_id=103978.0))
lhcb1.new("mcbch.8l1.b1", "mcbch", at="-301.309+(2-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253726.0, assembly_id=103978.0))
lhcb1.new("mco.8l1.b1", "mco", at="-299.88+(2-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253730.0, assembly_id=103979.0))
lhcb1.new("mcd.8l1.b1", "mcd", at="-299.8785+(2-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253731.0, assembly_id=103979.0))
lhcb1.new("mb.b8l1.b1", "mb", at="-292.394+(1.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849366.0, assembly_id=103979.0))
lhcb1.new("mcs.b8l1.b1", "mcs", at="-284.97+(1-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249404.0, assembly_id=103979.0))
lhcb1.new("mb.a8l1.b1", "mb", at="-276.734+(.5-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52849822.0, assembly_id=103980.0))
lhcb1.new("mcs.a8l1.b1", "mcs", at="-269.31+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=357346.0, assembly_id=103980.0))
lhcb1.new("e.ds.l1.b1", "omk", at="-268.904+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=100932.0))
lhcb1.new("bpmr.7l1.b1", "bpmr", at="-268.429+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=378062.0, assembly_id=103981.0))
lhcb1.new("mqm.b7l1.b1", "mqm", at="-265.984+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2348454.0, assembly_id=103981.0))
lhcb1.new("mqm.a7l1.b1", "mqm", at="-262.217+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2307752.0, assembly_id=103981.0))
lhcb1.new("mcbcv.7l1.b1", "mcbcv", at="-259.876+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=378136.0, assembly_id=103981.0))
lhcb1.new("dfbaa.7l1.b1", "dfbaa", at="-257.6965+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=52996539.0, assembly_id=104694.0))
lhcb1.new("mcbch.6l1.b1", "mcbch", at="-231.432+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253735.0, assembly_id=103982.0))
lhcb1.new("mqml.6l1.b1", "mqml", at="-228.39+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2303177.0, assembly_id=103982.0))
lhcb1.new("bpm.6l1.b1", "bpm", at="-225.245+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=378064.0, assembly_id=103982.0))
lhcb1.new("mcbcv.5l1.b1", "mcbcv", at="-199.532+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253737.0, assembly_id=103983.0))
lhcb1.new("mqml.5l1.b1", "mqml", at="-196.49+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2303181.0, assembly_id=103983.0))
lhcb1.new("bpmr.5l1.b1", "bpmr", at="-193.345+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=378066.0, assembly_id=103983.0))
lhcb1.new("bptx.5l1.b1", "bptx", at="-174.6425+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=104671.0))
lhcb1.new("bpmya.4l1.b1", "bpmya", at="-172.227+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=249423.0, assembly_id=103985.0))
lhcb1.new("mqy.4l1.b1", "mqy", at="-169.553+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=2303022.0, assembly_id=103985.0))
lhcb1.new("mcbyh.b4l1.b1", "mcbyh", at="-167.031+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253738.0, assembly_id=103985.0))
lhcb1.new("mcbyv.4l1.b1", "mcbyv", at="-165.735+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253740.0, assembly_id=103985.0))
lhcb1.new("mcbyh.a4l1.b1", "mcbyh", at="-164.439+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.194, slot_id=253742.0, assembly_id=103985.0))
lhcb1.new("mbrc.4l1.b1", "mbrc", at="-157.9+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.188, slot_id=52819774.0, assembly_id=103986.0))
lhcb1.new("bpmwb.4l1.b1", "bpmwb", at="-151.0945+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.178, slot_id=104621.0))
lhcb1.new("bptuh.a4l1.b1", "bptuh", at="-148.54+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.1762, slot_id=10402640.0, assembly_id=377649.0))
lhcb1.new("tctph.4l1.b1", "tctph", at="-147.945+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.1715, slot_id=377649.0))
lhcb1.new("bptdh.a4l1.b1", "bptdh", at="-147.35+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.1735, slot_id=10402643.0, assembly_id=377649.0))
lhcb1.new("bbcwb.a4l1.u.b1", "bbcwb", at="-146.54+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.168, slot_id=52668829.0, assembly_id=52657542.0))
lhcb1.new("bbcwt.a4l1.u.b1", "bbcwt", at="-146.54+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.168, slot_id=52668814.0, assembly_id=52657542.0))
lhcb1.new("bptuv.a4l1.b1", "bptuv", at="-146.49+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.1683, slot_id=52668853.0, assembly_id=52657542.0))
lhcb1.new("tctpv.4l1.b1", "tctwv", at="-145.945+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.167, slot_id=52657542.0))
lhcb1.new("bptdv.a4l1.b1", "bptdv", at="-145.4+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.1658, slot_id=52668844.0, assembly_id=52657542.0))
lhcb1.new("bbcwb.a4l1.d.b1", "bbcwb", at="-145.35+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.166, slot_id=52668799.0, assembly_id=52657542.0))
lhcb1.new("bbcwt.a4l1.d.b1", "bbcwt", at="-145.35+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=-0.166, slot_id=52668784.0, assembly_id=52657542.0))
lhcb1.new("e.tan_c.4l1", "omk", at="-144.5+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb1.new("e.tan_i.4l1", "omk", at="-144.5+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb1.new("tanal.4l1", "tanal", at="-142.754+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=103988.0))
lhcb1.new("e.tan_d.4l1", "omk", at="-142.019+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb1.new("x1zdc.a4l1", "x1zdc001", at="-141.71+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=2019579.0, assembly_id=103988.0))
lhcb1.new("brana.4l1", "brana", at="-141.36+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=883499.0, assembly_id=103988.0))
lhcb1.new("x1zdc.b4l1", "x1zdc002", at="-141.16+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=2019582.0, assembly_id=103988.0))
lhcb1.new("s.tan_d.4l1", "omk", at="-141.019+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb1.new("s.tan_c.4l1", "omk", at="-141.008+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb1.new("e.tan_m.4l1", "omk", at="-140.7+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb1.new("s.tan_i.4l1", "omk", at="-140.7+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb1.new("s.tan_m.4l1", "omk", at="-140.25+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb1.new("mbxw.f4l1", "mbxw", at="-82.652+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134690.0))
lhcb1.new("mbxw.e4l1", "mbxw", at="-78.386+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134691.0))
lhcb1.new("mbxw.d4l1", "mbxw", at="-74.12+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134692.0))
lhcb1.new("mbxw.c4l1", "mbxw", at="-69.854+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134693.0))
lhcb1.new("mbxw.b4l1", "mbxw", at="-65.588+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134694.0))
lhcb1.new("mbxw.a4l1", "mbxw", at="-61.322+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134695.0))
lhcb1.new("bpmsy.4l1.b1", "bpmsy002", at="-58.3745+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=47562520.0, assembly_id=104622.0))
lhcb1.new("dfbxa.3l1", "dfbxa", at="-56.427+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=104695.0))
lhcb1.new("mcosx.3l1", "mcosx_unplugged", at="-54.297+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282258.0, assembly_id=103990.0))
lhcb1.new("mcox.3l1", "mcox", at="-54.297+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282257.0, assembly_id=103990.0))
lhcb1.new("mcssx.3l1", "mcssx", at="-54.297+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282256.0, assembly_id=103990.0))
lhcb1.new("mcbxh.3l1", "mcbxh", at="-53.814+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253744.0, assembly_id=103990.0))
lhcb1.new("mcbxv.3l1", "mcbxv", at="-53.814+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253745.0, assembly_id=103990.0))
lhcb1.new("mcsx.3l1", "mcsx", at="-53.814+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253746.0, assembly_id=103990.0))
lhcb1.new("mctx.3l1", "mctx", at="-53.814+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253747.0, assembly_id=103990.0))
lhcb1.new("mqxa.3l1", "mqxa", at="-50.15+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=249436.0, assembly_id=103990.0))
lhcb1.new("mqsx.3l1", "mqsx", at="-46.608+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282209.0, assembly_id=103990.0))
lhcb1.new("tasb.3l1", "tasb", at="-45.342+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=249438.0, assembly_id=103990.0))
lhcb1.new("mqxb.b2l1", "mqxb", at="-41.3+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=249439.0, assembly_id=103991.0))
lhcb1.new("mcbxh.2l1", "mcbxh", at="-38.019+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253752.0, assembly_id=103991.0))
lhcb1.new("mcbxv.2l1", "mcbxv", at="-38.019+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253753.0, assembly_id=103991.0))
lhcb1.new("mqxb.a2l1", "mqxb", at="-34.8+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=249441.0, assembly_id=103991.0))
lhcb1.new("bpms.2l1.b1", "bpms_003", at="-31.529+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=47564255.0, assembly_id=103991.0))
lhcb1.new("mcbxh.1l1", "mcbxh", at="-29.842+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282219.0, assembly_id=103992.0))
lhcb1.new("mcbxv.1l1", "mcbxv", at="-29.842+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282218.0, assembly_id=103992.0))
lhcb1.new("mqxa.1l1", "mqxa", at="-26.15+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282210.0, assembly_id=103992.0))
lhcb1.new("bpmwf.a1l1.b1", "bpmwf", at="-21.766+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=6080255.0, assembly_id=6080223.0))
lhcb1.new("bpmsw.1l1.b1", "bpmsw002", at="-21.579+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=6080251.0, assembly_id=6080223.0))
lhcb1.new("bpmsw.1l1.b1_doros", "bpmsw002", at="-21.579+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=10429438.0, assembly_id=6080223.0))
lhcb1.new("tas.1l1", "tas", at="-19.979+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=103993.0))
lhcb1.new("mbas2.1l1", "mbas2", at="-1.5+(0-ip1ofs.b1)*ds", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=51937873.0))
lhcb1.new("ip1.l1", "omk", at="pip1.l1+ip1ofs.b1*ds")
lhcb1.build()

lhcb2 = env.new_builder(name="lhcb2")
lhcb2.new("ip1", "omk", at="lhclength-(pip1+ip1ofs.b2*ds)")
lhcb2.new("mbas2.1r1", "mbas2", at="lhclength-(1.5+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=51937884.0))
lhcb2.new("tas.1r1", "tas", at="lhclength-(19.95+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=102103.0))
lhcb2.new("bpmsw.1r1.b2", "bpmsw002", at="lhclength-(21.564+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=6080260.0, assembly_id=6080224.0))
lhcb2.new("bpmsw.1r1.b2_doros", "bpmsw002", at="lhclength-(21.564+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=10429421.0, assembly_id=6080224.0))
lhcb2.new("bpmwf.a1r1.b2", "bpmwf", at="lhclength-(21.697+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=6080268.0, assembly_id=6080224.0))
lhcb2.new("mqxa.1r1", "mqxa", at="lhclength-(26.15+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282126.0, assembly_id=102104.0))
lhcb2.new("mcbxh.1r1", "mcbxh", at="lhclength-(29.842+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282213.0, assembly_id=102104.0))
lhcb2.new("mcbxv.1r1", "mcbxv", at="lhclength-(29.842+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282212.0, assembly_id=102104.0))
lhcb2.new("bpms.2r1.b2", "bpms_003", at="lhclength-(31.529+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=47564245.0, assembly_id=102105.0))
lhcb2.new("mqxb.a2r1", "mqxb", at="lhclength-(34.8+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=241890.0, assembly_id=102105.0))
lhcb2.new("mcbxh.2r1", "mcbxh", at="lhclength-(38.019+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249450.0, assembly_id=102105.0))
lhcb2.new("mcbxv.2r1", "mcbxv", at="lhclength-(38.019+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249451.0, assembly_id=102105.0))
lhcb2.new("mqxb.b2r1", "mqxb", at="lhclength-(41.3+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=241892.0, assembly_id=102105.0))
lhcb2.new("tasb.3r1", "tasb", at="lhclength-(45.342+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=241893.0, assembly_id=102106.0))
lhcb2.new("mqsx.3r1", "mqsx", at="lhclength-(46.608+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282127.0, assembly_id=102106.0))
lhcb2.new("mqxa.3r1", "mqxa", at="lhclength-(50.15+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=241895.0, assembly_id=102106.0))
lhcb2.new("mcbxh.3r1", "mcbxh", at="lhclength-(53.814+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249456.0, assembly_id=102106.0))
lhcb2.new("mcbxv.3r1", "mcbxv", at="lhclength-(53.814+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249457.0, assembly_id=102106.0))
lhcb2.new("mcsx.3r1", "mcsx", at="lhclength-(53.814+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249458.0, assembly_id=102106.0))
lhcb2.new("mctx.3r1", "mctx", at="lhclength-(53.814+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=249459.0, assembly_id=102106.0))
lhcb2.new("mcosx.3r1", "mcosx", at="lhclength-(54.297+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282237.0, assembly_id=102106.0))
lhcb2.new("mcox.3r1", "mcox", at="lhclength-(54.297+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282236.0, assembly_id=102106.0))
lhcb2.new("mcssx.3r1", "mcssx", at="lhclength-(54.297+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=282235.0, assembly_id=102106.0))
lhcb2.new("dfbxb.3r1", "dfbxb", at="lhclength-(56.427+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=104672.0))
lhcb2.new("bpmsy.4r1.b2", "bpmsy002", at="lhclength-(58.3745+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=47562522.0, assembly_id=104595.0))
lhcb2.new("mbxw.a4r1", "mbxw", at="lhclength-(61.322+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134500.0))
lhcb2.new("mbxw.b4r1", "mbxw", at="lhclength-(65.588+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134501.0))
lhcb2.new("mbxw.c4r1", "mbxw", at="lhclength-(69.854+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134502.0))
lhcb2.new("mbxw.d4r1", "mbxw", at="lhclength-(74.12+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134503.0))
lhcb2.new("mbxw.e4r1", "mbxw", at="lhclength-(78.386+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134504.0))
lhcb2.new("mbxw.f4r1", "mbxw", at="lhclength-(82.652+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=134505.0))
lhcb2.new("x1zdc.b4r1", "x1zdc002", at="lhclength-(141.16+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=2019588.0, assembly_id=102108.0))
lhcb2.new("brand.4r1", "brand", at="lhclength-(141.476+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=55374060.0, assembly_id=102108.0))
lhcb2.new("x1zdc.a4r1", "x1zdc001", at="lhclength-(141.71+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=2019586.0, assembly_id=102108.0))
lhcb2.new("tanar.4r1", "tanar", at="lhclength-(142.754+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=0.0, slot_id=102108.0))
lhcb2.new("bbcwb.a4r1.d.b2", "bbcwb", at="lhclength-(145.35+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.166, slot_id=42859748.0, assembly_id=54973368.0))
lhcb2.new("bbcwt.a4r1.d.b2", "bbcwt", at="lhclength-(145.35+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.166, slot_id=42859744.0, assembly_id=54973368.0))
lhcb2.new("bptdv.a4r1.b2", "bptdv", at="lhclength-(145.35+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.1654, slot_id=10402725.0, assembly_id=54973368.0))
lhcb2.new("tctpv.4r1.b2", "tctwv", at="lhclength-(145.945+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.167, slot_id=54973368.0))
lhcb2.new("bbcwb.a4r1.u.b2", "bbcwb", at="lhclength-(146.54+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.166, slot_id=42859760.0, assembly_id=54973368.0))
lhcb2.new("bbcwt.a4r1.u.b2", "bbcwt", at="lhclength-(146.54+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.166, slot_id=42859757.0, assembly_id=54973368.0))
lhcb2.new("bptuv.a4r1.b2", "bptuv", at="lhclength-(146.54+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.1654, slot_id=10402716.0, assembly_id=54973368.0))
lhcb2.new("bptdh.a4r1.b2", "bptdh", at="lhclength-(147.35+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.166, slot_id=10402636.0, assembly_id=377590.0))
lhcb2.new("tctph.4r1.b2", "tctph", at="lhclength-(147.945+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.1715, slot_id=377590.0))
lhcb2.new("bptuh.a4r1.b2", "bptuh", at="lhclength-(148.54+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.17, slot_id=10402633.0, assembly_id=377590.0))
lhcb2.new("bpmwb.4r1.b2", "bpmwb", at="lhclength-(151.1705+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.178, slot_id=104596.0))
lhcb2.new("mbrc.4r1.b2", "mbrc", at="lhclength-(157.9+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.188, slot_id=52819625.0, assembly_id=102110.0))
lhcb2.new("mcbyh.a4r1.b2", "mcbyh", at="lhclength-(164.439+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249461.0, assembly_id=102111.0))
lhcb2.new("mcbyv.4r1.b2", "mcbyv", at="lhclength-(165.735+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249463.0, assembly_id=102111.0))
lhcb2.new("mcbyh.b4r1.b2", "mcbyh", at="lhclength-(167.031+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249465.0, assembly_id=102111.0))
lhcb2.new("mqy.4r1.b2", "mqy", at="lhclength-(169.553+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2302957.0, assembly_id=102111.0))
lhcb2.new("bpmya.4r1.b2", "bpmya", at="lhclength-(172.227+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241909.0, assembly_id=102111.0))
lhcb2.new("bptx.5r1.b2", "bptx", at="lhclength-(174.7185+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=104664.0))
lhcb2.new("mcbcv.5r1.b2", "mcbcv", at="lhclength-(193.448+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249467.0, assembly_id=102113.0))
lhcb2.new("mqml.5r1.b2", "mqml", at="lhclength-(196.49+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2302965.0, assembly_id=102113.0))
lhcb2.new("bpmr.5r1.b2", "bpmr", at="lhclength-(199.635+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=377900.0, assembly_id=102113.0))
lhcb2.new("mcbch.6r1.b2", "mcbch", at="lhclength-(225.348+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249469.0, assembly_id=102114.0))
lhcb2.new("mqml.6r1.b2", "mqml", at="lhclength-(228.39+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2303153.0, assembly_id=102114.0))
lhcb2.new("bpm.6r1.b2", "bpm", at="lhclength-(231.535+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=377902.0, assembly_id=102114.0))
lhcb2.new("dfbab.7r1.b2", "dfbab", at="lhclength-(257.4465+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52996575.0, assembly_id=104673.0))
lhcb2.new("bpmra.7r1.b2", "bpmra", at="lhclength-(259.259+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=377906.0, assembly_id=102115.0))
lhcb2.new("mqm.a7r1.b2", "mqm", at="lhclength-(261.704+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307760.0, assembly_id=102115.0))
lhcb2.new("mqm.b7r1.b2", "mqm", at="lhclength-(265.471+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307775.0, assembly_id=102115.0))
lhcb2.new("mcbcv.7r1.b2", "mcbcv", at="lhclength-(267.812+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=378076.0, assembly_id=102115.0))
lhcb2.new("s.ds.r1.b2", "omk", at="lhclength-(268.904+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(slot_id=100932.0))
lhcb2.new("mco.8r1.b2", "mco", at="lhclength-(269.248+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249474.0, assembly_id=102116.0))
lhcb2.new("mcd.8r1.b2", "mcd", at="lhclength-(269.2495+(0-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249475.0, assembly_id=102116.0))
lhcb2.new("mb.a8r1.b2", "mb", at="lhclength-(276.734+(-.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820290.0, assembly_id=102116.0))
lhcb2.new("mcs.a8r1.b2", "mcs", at="lhclength-(284.158+(-1-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241928.0, assembly_id=102116.0))
lhcb2.new("mb.b8r1.b2", "mb", at="lhclength-(292.394+(-1.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820314.0, assembly_id=102117.0))
lhcb2.new("mcs.b8r1.b2", "mcs", at="lhclength-(299.818+(-2-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241931.0, assembly_id=102117.0))
lhcb2.new("bpm.8r1.b2", "bpm", at="lhclength-(300.697+(-2-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=377912.0, assembly_id=102118.0))
lhcb2.new("mqml.8r1.b2", "mqml", at="lhclength-(303.842+(-2-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307611.0, assembly_id=102118.0))
lhcb2.new("mcbch.8r1.b2", "mcbch", at="lhclength-(306.884+(-2-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=378081.0, assembly_id=102118.0))
lhcb2.new("mco.9r1.b2", "mco", at="lhclength-(308.313+(-2-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249480.0, assembly_id=102119.0))
lhcb2.new("mcd.9r1.b2", "mcd", at="lhclength-(308.3145+(-2-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249481.0, assembly_id=102119.0))
lhcb2.new("mb.a9r1.b2", "mb", at="lhclength-(315.799+(-2.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820338.0, assembly_id=102119.0))
lhcb2.new("mcs.a9r1.b2", "mcs", at="lhclength-(323.223+(-3-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241940.0, assembly_id=102119.0))
lhcb2.new("mb.b9r1.b2", "mb", at="lhclength-(331.459+(-3.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820362.0, assembly_id=102120.0))
lhcb2.new("mcs.b9r1.b2", "mcs", at="lhclength-(338.883+(-4-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241943.0, assembly_id=102120.0))
lhcb2.new("bpm.9r1.b2", "bpm", at="lhclength-(339.763+(-4-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=377915.0, assembly_id=102121.0))
lhcb2.new("mqmc.9r1.b2", "mqmc", at="lhclength-(341.739+(-4-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2348456.0, assembly_id=102121.0))
lhcb2.new("mqm.9r1.b2", "mqm", at="lhclength-(345.005+(-4-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307741.0, assembly_id=102121.0))
lhcb2.new("mcbcv.9r1.b2", "mcbcv", at="lhclength-(347.346+(-4-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=378086.0, assembly_id=102121.0))
lhcb2.new("mco.10r1.b2", "mco", at="lhclength-(348.778+(-4-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249486.0, assembly_id=102122.0))
lhcb2.new("mcd.10r1.b2", "mcd", at="lhclength-(348.7795+(-4-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249487.0, assembly_id=102122.0))
lhcb2.new("mb.a10r1.b2", "mb", at="lhclength-(356.264+(-4.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820386.0, assembly_id=102122.0))
lhcb2.new("mcs.a10r1.b2", "mcs", at="lhclength-(363.688+(-5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241953.0, assembly_id=102122.0))
lhcb2.new("mb.b10r1.b2", "mb", at="lhclength-(371.924+(-5.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820410.0, assembly_id=102123.0))
lhcb2.new("mcs.b10r1.b2", "mcs", at="lhclength-(379.348+(-6-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241956.0, assembly_id=102123.0))
lhcb2.new("bpm.10r1.b2", "bpm", at="lhclength-(380.227+(-6-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=377921.0, assembly_id=102124.0))
lhcb2.new("mqml.10r1.b2", "mqml", at="lhclength-(383.372+(-6-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307817.0, assembly_id=102124.0))
lhcb2.new("mcbch.10r1.b2", "mcbch", at="lhclength-(386.414+(-6-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=378091.0, assembly_id=102124.0))
lhcb2.new("mco.11r1.b2", "mco", at="lhclength-(387.843+(-6-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249492.0, assembly_id=102125.0))
lhcb2.new("mcd.11r1.b2", "mcd", at="lhclength-(387.8445+(-6-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249493.0, assembly_id=102125.0))
lhcb2.new("mb.a11r1.b2", "mb", at="lhclength-(395.329+(-6.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820434.0, assembly_id=102125.0))
lhcb2.new("mcs.a11r1.b2", "mcs", at="lhclength-(402.753+(-7-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241965.0, assembly_id=102125.0))
lhcb2.new("mb.b11r1.b2", "mb", at="lhclength-(410.989+(-7.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52849402.0, assembly_id=102126.0))
lhcb2.new("mcs.b11r1.b2", "mcs", at="lhclength-(418.413+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=357282.0, assembly_id=102126.0))
lhcb2.new("lehr.11r1.b2", "lehr", at="lhclength-(425.67735+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52997934.0, assembly_id=102127.0))
lhcb2.new("bpm.11r1.b2", "bpm", at="lhclength-(433.0087+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241970.0, assembly_id=102128.0))
lhcb2.new("mq.11r1.b2", "mq", at="lhclength-(435.5557+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308665.0, assembly_id=102128.0))
lhcb2.new("mqtli.11r1.b2", "mqtli", at="lhclength-(437.9247+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2348438.0, assembly_id=102128.0))
lhcb2.new("ms.11r1.b2", "ms", at="lhclength-(438.9367+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249495.0, assembly_id=102128.0))
lhcb2.new("mcbv.11r1.b2", "mcbv", at="lhclength-(439.5297+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249497.0, assembly_id=102128.0))
lhcb2.new("s.arc.12.b2", "omk", at="lhclength-(440.2807+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a12r1.b2", "mco", at="lhclength-(440.6247+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249500.0, assembly_id=102129.0))
lhcb2.new("mcd.a12r1.b2", "mcd", at="lhclength-(440.6262+(-8-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249501.0, assembly_id=102129.0))
lhcb2.new("mb.a12r1.b2", "mb", at="lhclength-(448.1107+(-8.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820458.0, assembly_id=102129.0))
lhcb2.new("mcs.a12r1.b2", "mcs", at="lhclength-(455.5347+(-9-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241978.0, assembly_id=102129.0))
lhcb2.new("mb.b12r1.b2", "mb", at="lhclength-(463.7707+(-9.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820482.0, assembly_id=102130.0))
lhcb2.new("mcs.b12r1.b2", "mcs", at="lhclength-(471.1947+(-10-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241981.0, assembly_id=102130.0))
lhcb2.new("mco.b12r1.b2", "mco", at="lhclength-(471.9447+(-10-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249504.0, assembly_id=102131.0))
lhcb2.new("mcd.b12r1.b2", "mcd", at="lhclength-(471.9462+(-10-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249505.0, assembly_id=102131.0))
lhcb2.new("mb.c12r1.b2", "mb", at="lhclength-(479.4307+(-10.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820506.0, assembly_id=102131.0))
lhcb2.new("mcs.c12r1.b2", "mcs", at="lhclength-(486.8547+(-11-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241986.0, assembly_id=102131.0))
lhcb2.new("bpm.12r1.b2", "bpm", at="lhclength-(487.7337+(-11-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241988.0, assembly_id=102132.0))
lhcb2.new("mqt.12r1.b2", "mqt", at="lhclength-(488.4877+(-11-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307700.0, assembly_id=102132.0))
lhcb2.new("mq.12r1.b2", "mq", at="lhclength-(490.4957+(-11-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308459.0, assembly_id=102132.0))
lhcb2.new("ms.12r1.b2", "ms", at="lhclength-(492.3907+(-11-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249507.0, assembly_id=102132.0))
lhcb2.new("mcbh.12r1.b2", "mcbh", at="lhclength-(492.9837+(-11-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249509.0, assembly_id=102132.0))
lhcb2.new("mb.a13r1.b2", "mb", at="lhclength-(501.5607+(-11.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820530.0, assembly_id=102133.0))
lhcb2.new("mcs.a13r1.b2", "mcs", at="lhclength-(508.9847+(-12-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241994.0, assembly_id=102133.0))
lhcb2.new("mco.13r1.b2", "mco", at="lhclength-(509.7347+(-12-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249512.0, assembly_id=102134.0))
lhcb2.new("mcd.13r1.b2", "mcd", at="lhclength-(509.7362+(-12-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249513.0, assembly_id=102134.0))
lhcb2.new("mb.b13r1.b2", "mb", at="lhclength-(517.2207+(-12.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820554.0, assembly_id=102134.0))
lhcb2.new("mcs.b13r1.b2", "mcs", at="lhclength-(524.6447+(-13-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=241999.0, assembly_id=102134.0))
lhcb2.new("mb.c13r1.b2", "mb", at="lhclength-(532.8807+(-13.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820578.0, assembly_id=102135.0))
lhcb2.new("mcs.c13r1.b2", "mcs", at="lhclength-(540.3047+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242002.0, assembly_id=102135.0))
lhcb2.new("bpm.13r1.b2", "bpm", at="lhclength-(541.1837+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242004.0, assembly_id=102136.0))
lhcb2.new("mqt.13r1.b2", "mqt", at="lhclength-(541.9377+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307493.0, assembly_id=102136.0))
lhcb2.new("mq.13r1.b2", "mq", at="lhclength-(543.9457+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308488.0, assembly_id=102136.0))
lhcb2.new("ms.13r1.b2", "ms", at="lhclength-(545.8407+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249515.0, assembly_id=102136.0))
lhcb2.new("mcbv.13r1.b2", "mcbv", at="lhclength-(546.4337+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249517.0, assembly_id=102136.0))
lhcb2.new("e.ds.r1.b2", "omk", at="lhclength-(547.1807+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a14r1.b2", "mco", at="lhclength-(547.5247+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249520.0, assembly_id=102137.0))
lhcb2.new("mcd.a14r1.b2", "mcd", at="lhclength-(547.5262+(-14-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249521.0, assembly_id=102137.0))
lhcb2.new("mb.a14r1.b2", "mb", at="lhclength-(555.0107+(-14.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820602.0, assembly_id=102137.0))
lhcb2.new("mcs.a14r1.b2", "mcs", at="lhclength-(562.4347+(-15-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242012.0, assembly_id=102137.0))
lhcb2.new("mb.b14r1.b2", "mb", at="lhclength-(570.6707+(-15.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820626.0, assembly_id=102138.0))
lhcb2.new("mcs.b14r1.b2", "mcs", at="lhclength-(578.0947+(-16-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242015.0, assembly_id=102138.0))
lhcb2.new("mco.b14r1.b2", "mco", at="lhclength-(578.8447+(-16-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249524.0, assembly_id=102139.0))
lhcb2.new("mcd.b14r1.b2", "mcd", at="lhclength-(578.8462+(-16-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249525.0, assembly_id=102139.0))
lhcb2.new("mb.c14r1.b2", "mb", at="lhclength-(586.3307+(-16.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820650.0, assembly_id=102139.0))
lhcb2.new("mcs.c14r1.b2", "mcs", at="lhclength-(593.7547+(-17-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242020.0, assembly_id=102139.0))
lhcb2.new("bpm.14r1.b2", "bpm", at="lhclength-(594.6337+(-17-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242022.0, assembly_id=102140.0))
lhcb2.new("mqt.14r1.b2", "mqt", at="lhclength-(595.3877+(-17-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307524.0, assembly_id=102140.0))
lhcb2.new("mq.14r1.b2", "mq", at="lhclength-(597.3957+(-17-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308518.0, assembly_id=102140.0))
lhcb2.new("ms.14r1.b2", "ms", at="lhclength-(599.2907+(-17-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249527.0, assembly_id=102140.0))
lhcb2.new("mcbh.14r1.b2", "mcbh", at="lhclength-(599.8837+(-17-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249529.0, assembly_id=102140.0))
lhcb2.new("mb.a15r1.b2", "mb", at="lhclength-(608.4607+(-17.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820674.0, assembly_id=102141.0))
lhcb2.new("mcs.a15r1.b2", "mcs", at="lhclength-(615.8847+(-18-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242028.0, assembly_id=102141.0))
lhcb2.new("mco.15r1.b2", "mco", at="lhclength-(616.6347+(-18-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249532.0, assembly_id=102142.0))
lhcb2.new("mcd.15r1.b2", "mcd", at="lhclength-(616.6362+(-18-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249533.0, assembly_id=102142.0))
lhcb2.new("mb.b15r1.b2", "mb", at="lhclength-(624.1207+(-18.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820698.0, assembly_id=102142.0))
lhcb2.new("mcs.b15r1.b2", "mcs", at="lhclength-(631.5447+(-19-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242033.0, assembly_id=102142.0))
lhcb2.new("mb.c15r1.b2", "mb", at="lhclength-(639.7807+(-19.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820722.0, assembly_id=102143.0))
lhcb2.new("mcs.c15r1.b2", "mcs", at="lhclength-(647.2047+(-20-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242036.0, assembly_id=102143.0))
lhcb2.new("bpm.15r1.b2", "bpm", at="lhclength-(648.0837+(-20-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242038.0, assembly_id=102144.0))
lhcb2.new("mqt.15r1.b2", "mqt", at="lhclength-(648.8377+(-20-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307556.0, assembly_id=102144.0))
lhcb2.new("mq.15r1.b2", "mq", at="lhclength-(650.8457+(-20-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308548.0, assembly_id=102144.0))
lhcb2.new("ms.15r1.b2", "ms", at="lhclength-(652.7407+(-20-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249535.0, assembly_id=102144.0))
lhcb2.new("mcbv.15r1.b2", "mcbv", at="lhclength-(653.3337+(-20-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249537.0, assembly_id=102144.0))
lhcb2.new("mco.a16r1.b2", "mco", at="lhclength-(654.4247+(-20-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249540.0, assembly_id=102145.0))
lhcb2.new("mcd.a16r1.b2", "mcd", at="lhclength-(654.4262+(-20-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249541.0, assembly_id=102145.0))
lhcb2.new("mb.a16r1.b2", "mb", at="lhclength-(661.9107+(-20.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820746.0, assembly_id=102145.0))
lhcb2.new("mcs.a16r1.b2", "mcs", at="lhclength-(669.3347+(-21-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242046.0, assembly_id=102145.0))
lhcb2.new("mb.b16r1.b2", "mb", at="lhclength-(677.5707+(-21.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820770.0, assembly_id=102146.0))
lhcb2.new("mcs.b16r1.b2", "mcs", at="lhclength-(684.9947+(-22-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242049.0, assembly_id=102146.0))
lhcb2.new("mco.b16r1.b2", "mco", at="lhclength-(685.7447+(-22-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249544.0, assembly_id=102147.0))
lhcb2.new("mcd.b16r1.b2", "mcd", at="lhclength-(685.7462+(-22-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249545.0, assembly_id=102147.0))
lhcb2.new("mb.c16r1.b2", "mb", at="lhclength-(693.2307+(-22.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820794.0, assembly_id=102147.0))
lhcb2.new("mcs.c16r1.b2", "mcs", at="lhclength-(700.6547+(-23-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242054.0, assembly_id=102147.0))
lhcb2.new("bpm.16r1.b2", "bpm", at="lhclength-(701.5337+(-23-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242056.0, assembly_id=102148.0))
lhcb2.new("mqt.16r1.b2", "mqt", at="lhclength-(702.2877+(-23-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307586.0, assembly_id=102148.0))
lhcb2.new("mq.16r1.b2", "mq", at="lhclength-(704.2957+(-23-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308341.0, assembly_id=102148.0))
lhcb2.new("ms.16r1.b2", "ms", at="lhclength-(706.1907+(-23-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249547.0, assembly_id=102148.0))
lhcb2.new("mcbh.16r1.b2", "mcbh", at="lhclength-(706.7837+(-23-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249549.0, assembly_id=102148.0))
lhcb2.new("mb.a17r1.b2", "mb", at="lhclength-(715.3607+(-23.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820818.0, assembly_id=102149.0))
lhcb2.new("mcs.a17r1.b2", "mcs", at="lhclength-(722.7847+(-24-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242062.0, assembly_id=102149.0))
lhcb2.new("mco.17r1.b2", "mco", at="lhclength-(723.5347+(-24-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249552.0, assembly_id=102150.0))
lhcb2.new("mcd.17r1.b2", "mcd", at="lhclength-(723.5362+(-24-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249553.0, assembly_id=102150.0))
lhcb2.new("mb.b17r1.b2", "mb", at="lhclength-(731.0207+(-24.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820842.0, assembly_id=102150.0))
lhcb2.new("mcs.b17r1.b2", "mcs", at="lhclength-(738.4447+(-25-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242067.0, assembly_id=102150.0))
lhcb2.new("mb.c17r1.b2", "mb", at="lhclength-(746.6807+(-25.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820866.0, assembly_id=102151.0))
lhcb2.new("mcs.c17r1.b2", "mcs", at="lhclength-(754.1047+(-26-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242070.0, assembly_id=102151.0))
lhcb2.new("bpm.17r1.b2", "bpm", at="lhclength-(754.9837+(-26-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242072.0, assembly_id=102152.0))
lhcb2.new("mqt.17r1.b2", "mqt", at="lhclength-(755.7377+(-26-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307380.0, assembly_id=102152.0))
lhcb2.new("mq.17r1.b2", "mq", at="lhclength-(757.7457+(-26-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308371.0, assembly_id=102152.0))
lhcb2.new("ms.17r1.b2", "ms", at="lhclength-(759.6407+(-26-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249555.0, assembly_id=102152.0))
lhcb2.new("mcbv.17r1.b2", "mcbv", at="lhclength-(760.2337+(-26-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249557.0, assembly_id=102152.0))
lhcb2.new("mco.a18r1.b2", "mco", at="lhclength-(761.3247+(-26-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249560.0, assembly_id=102153.0))
lhcb2.new("mcd.a18r1.b2", "mcd", at="lhclength-(761.3262+(-26-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249561.0, assembly_id=102153.0))
lhcb2.new("mb.a18r1.b2", "mb", at="lhclength-(768.8107+(-26.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820890.0, assembly_id=102153.0))
lhcb2.new("mcs.a18r1.b2", "mcs", at="lhclength-(776.2347+(-27-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242080.0, assembly_id=102153.0))
lhcb2.new("mb.b18r1.b2", "mb", at="lhclength-(784.4707+(-27.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820914.0, assembly_id=102154.0))
lhcb2.new("mcs.b18r1.b2", "mcs", at="lhclength-(791.8947+(-28-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242083.0, assembly_id=102154.0))
lhcb2.new("mco.b18r1.b2", "mco", at="lhclength-(792.6447+(-28-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249564.0, assembly_id=102155.0))
lhcb2.new("mcd.b18r1.b2", "mcd", at="lhclength-(792.6462+(-28-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249565.0, assembly_id=102155.0))
lhcb2.new("mb.c18r1.b2", "mb", at="lhclength-(800.1307+(-28.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820938.0, assembly_id=102155.0))
lhcb2.new("mcs.c18r1.b2", "mcs", at="lhclength-(807.5547+(-29-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242088.0, assembly_id=102155.0))
lhcb2.new("bpm.18r1.b2", "bpm", at="lhclength-(808.4337+(-29-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242090.0, assembly_id=102156.0))
lhcb2.new("mqt.18r1.b2", "mqt", at="lhclength-(809.1877+(-29-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307412.0, assembly_id=102156.0))
lhcb2.new("mq.18r1.b2", "mq", at="lhclength-(811.1957+(-29-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308401.0, assembly_id=102156.0))
lhcb2.new("ms.18r1.b2", "ms", at="lhclength-(813.0907+(-29-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249567.0, assembly_id=102156.0))
lhcb2.new("mcbh.18r1.b2", "mcbh", at="lhclength-(813.6837+(-29-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249569.0, assembly_id=102156.0))
lhcb2.new("mb.a19r1.b2", "mb", at="lhclength-(822.2607+(-29.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820962.0, assembly_id=102157.0))
lhcb2.new("mcs.a19r1.b2", "mcs_unplugged", at="lhclength-(829.6847+(-30-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242096.0, assembly_id=102157.0))
lhcb2.new("mco.19r1.b2", "mco", at="lhclength-(830.4347+(-30-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249572.0, assembly_id=102158.0))
lhcb2.new("mcd.19r1.b2", "mcd", at="lhclength-(830.4362+(-30-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249573.0, assembly_id=102158.0))
lhcb2.new("mb.b19r1.b2", "mb", at="lhclength-(837.9207+(-30.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52820986.0, assembly_id=102158.0))
lhcb2.new("mcs.b19r1.b2", "mcs", at="lhclength-(845.3447+(-31-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242101.0, assembly_id=102158.0))
lhcb2.new("mb.c19r1.b2", "mb", at="lhclength-(853.5807+(-31.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821010.0, assembly_id=102159.0))
lhcb2.new("mcs.c19r1.b2", "mcs", at="lhclength-(861.0047+(-32-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242104.0, assembly_id=102159.0))
lhcb2.new("bpm.19r1.b2", "bpm", at="lhclength-(861.8837+(-32-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242106.0, assembly_id=102160.0))
lhcb2.new("mqt.19r1.b2", "mqt", at="lhclength-(862.6377+(-32-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307443.0, assembly_id=102160.0))
lhcb2.new("mq.19r1.b2", "mq", at="lhclength-(864.6457+(-32-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308433.0, assembly_id=102160.0))
lhcb2.new("ms.19r1.b2", "ms", at="lhclength-(866.5407+(-32-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249575.0, assembly_id=102160.0))
lhcb2.new("mcbv.19r1.b2", "mcbv", at="lhclength-(867.1337+(-32-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249577.0, assembly_id=102160.0))
lhcb2.new("mco.a20r1.b2", "mco", at="lhclength-(868.2247+(-32-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249580.0, assembly_id=102161.0))
lhcb2.new("mcd.a20r1.b2", "mcd", at="lhclength-(868.2262+(-32-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249581.0, assembly_id=102161.0))
lhcb2.new("mb.a20r1.b2", "mb", at="lhclength-(875.7107+(-32.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821034.0, assembly_id=102161.0))
lhcb2.new("mcs.a20r1.b2", "mcs", at="lhclength-(883.1347+(-33-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242114.0, assembly_id=102161.0))
lhcb2.new("mb.b20r1.b2", "mb", at="lhclength-(891.3707+(-33.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821058.0, assembly_id=102162.0))
lhcb2.new("mcs.b20r1.b2", "mcs", at="lhclength-(898.7947+(-34-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242117.0, assembly_id=102162.0))
lhcb2.new("mco.b20r1.b2", "mco", at="lhclength-(899.5447+(-34-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249584.0, assembly_id=102163.0))
lhcb2.new("mcd.b20r1.b2", "mcd", at="lhclength-(899.5462+(-34-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249585.0, assembly_id=102163.0))
lhcb2.new("mb.c20r1.b2", "mb", at="lhclength-(907.0307+(-34.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821082.0, assembly_id=102163.0))
lhcb2.new("mcs.c20r1.b2", "mcs", at="lhclength-(914.4547+(-35-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242122.0, assembly_id=102163.0))
lhcb2.new("bpm.20r1.b2", "bpm", at="lhclength-(915.3337+(-35-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242124.0, assembly_id=102164.0))
lhcb2.new("mqt.20r1.b2", "mqt", at="lhclength-(916.0877+(-35-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2348442.0, assembly_id=102164.0))
lhcb2.new("mq.20r1.b2", "mq", at="lhclength-(918.0957+(-35-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308224.0, assembly_id=102164.0))
lhcb2.new("ms.20r1.b2", "ms", at="lhclength-(919.9907+(-35-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249587.0, assembly_id=102164.0))
lhcb2.new("mcbh.20r1.b2", "mcbh", at="lhclength-(920.5837+(-35-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249589.0, assembly_id=102164.0))
lhcb2.new("mb.a21r1.b2", "mb", at="lhclength-(929.1607+(-35.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821106.0, assembly_id=102165.0))
lhcb2.new("mcs.a21r1.b2", "mcs", at="lhclength-(936.5847+(-36-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242130.0, assembly_id=102165.0))
lhcb2.new("mco.21r1.b2", "mco", at="lhclength-(937.3347+(-36-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249592.0, assembly_id=102166.0))
lhcb2.new("mcd.21r1.b2", "mcd", at="lhclength-(937.3362+(-36-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249593.0, assembly_id=102166.0))
lhcb2.new("mb.b21r1.b2", "mb", at="lhclength-(944.8207+(-36.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821130.0, assembly_id=102166.0))
lhcb2.new("mcs.b21r1.b2", "mcs", at="lhclength-(952.2447+(-37-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242135.0, assembly_id=102166.0))
lhcb2.new("mb.c21r1.b2", "mb", at="lhclength-(960.4807+(-37.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821154.0, assembly_id=102167.0))
lhcb2.new("mcs.c21r1.b2", "mcs", at="lhclength-(967.9047+(-38-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242138.0, assembly_id=102167.0))
lhcb2.new("bpm.21r1.b2", "bpm", at="lhclength-(968.7837+(-38-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242140.0, assembly_id=102168.0))
lhcb2.new("mqt.21r1.b2", "mqt", at="lhclength-(969.5377+(-38-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307270.0, assembly_id=102168.0))
lhcb2.new("mq.21r1.b2", "mq", at="lhclength-(971.5457+(-38-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308254.0, assembly_id=102168.0))
lhcb2.new("ms.21r1.b2", "ms", at="lhclength-(973.4407+(-38-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249595.0, assembly_id=102168.0))
lhcb2.new("mcbv.21r1.b2", "mcbv", at="lhclength-(974.0337+(-38-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249597.0, assembly_id=102168.0))
lhcb2.new("mco.a22r1.b2", "mco", at="lhclength-(975.1247+(-38-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249600.0, assembly_id=102169.0))
lhcb2.new("mcd.a22r1.b2", "mcd", at="lhclength-(975.1262+(-38-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249601.0, assembly_id=102169.0))
lhcb2.new("mb.a22r1.b2", "mb", at="lhclength-(982.6107+(-38.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821178.0, assembly_id=102169.0))
lhcb2.new("mcs.a22r1.b2", "mcs", at="lhclength-(990.0347+(-39-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242148.0, assembly_id=102169.0))
lhcb2.new("mb.b22r1.b2", "mb", at="lhclength-(998.2707+(-39.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821202.0, assembly_id=102170.0))
lhcb2.new("mcs.b22r1.b2", "mcs", at="lhclength-(1005.6947+(-40-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242151.0, assembly_id=102170.0))
lhcb2.new("mco.b22r1.b2", "mco", at="lhclength-(1006.4447+(-40-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249604.0, assembly_id=102171.0))
lhcb2.new("mcd.b22r1.b2", "mcd", at="lhclength-(1006.4462+(-40-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249605.0, assembly_id=102171.0))
lhcb2.new("mb.c22r1.b2", "mb", at="lhclength-(1013.9307+(-40.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821226.0, assembly_id=102171.0))
lhcb2.new("mcs.c22r1.b2", "mcs", at="lhclength-(1021.3547+(-41-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242156.0, assembly_id=102171.0))
lhcb2.new("bpm.22r1.b2", "bpm", at="lhclength-(1022.2337+(-41-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242158.0, assembly_id=102172.0))
lhcb2.new("mo.22r1.b2", "mo", at="lhclength-(1022.9847+(-41-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308814.0, assembly_id=102172.0))
lhcb2.new("mq.22r1.b2", "mq", at="lhclength-(1024.9957+(-41-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308286.0, assembly_id=102172.0))
lhcb2.new("ms.22r1.b2", "ms", at="lhclength-(1026.8907+(-41-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249607.0, assembly_id=102172.0))
lhcb2.new("mcbh.22r1.b2", "mcbh", at="lhclength-(1027.4837+(-41-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249609.0, assembly_id=102172.0))
lhcb2.new("mb.a23r1.b2", "mb", at="lhclength-(1036.0607+(-41.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821250.0, assembly_id=102173.0))
lhcb2.new("mcs.a23r1.b2", "mcs", at="lhclength-(1043.4847+(-42-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242164.0, assembly_id=102173.0))
lhcb2.new("mco.23r1.b2", "mco", at="lhclength-(1044.2347+(-42-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249612.0, assembly_id=102174.0))
lhcb2.new("mcd.23r1.b2", "mcd", at="lhclength-(1044.2362+(-42-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249613.0, assembly_id=102174.0))
lhcb2.new("mb.b23r1.b2", "mb", at="lhclength-(1051.7207+(-42.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821274.0, assembly_id=102174.0))
lhcb2.new("mcs.b23r1.b2", "mcs", at="lhclength-(1059.1447+(-43-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242169.0, assembly_id=102174.0))
lhcb2.new("mb.c23r1.b2", "mb", at="lhclength-(1067.3807+(-43.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821298.0, assembly_id=102175.0))
lhcb2.new("mcs.c23r1.b2", "mcs", at="lhclength-(1074.8047+(-44-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242172.0, assembly_id=102175.0))
lhcb2.new("bpm.23r1.b2", "bpm", at="lhclength-(1075.6837+(-44-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242174.0, assembly_id=102176.0))
lhcb2.new("mqs.23r1.b2", "mqs", at="lhclength-(1076.4377+(-44-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307637.0, assembly_id=102176.0))
lhcb2.new("mq.23r1.b2", "mq", at="lhclength-(1078.4457+(-44-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308317.0, assembly_id=102176.0))
lhcb2.new("ms.23r1.b2", "ms", at="lhclength-(1080.3407+(-44-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249615.0, assembly_id=102176.0))
lhcb2.new("mcbv.23r1.b2", "mcbv", at="lhclength-(1080.9337+(-44-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249617.0, assembly_id=102176.0))
lhcb2.new("mco.a24r1.b2", "mco", at="lhclength-(1082.0247+(-44-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249620.0, assembly_id=102177.0))
lhcb2.new("mcd.a24r1.b2", "mcd", at="lhclength-(1082.0262+(-44-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249621.0, assembly_id=102177.0))
lhcb2.new("mb.a24r1.b2", "mb", at="lhclength-(1089.5107+(-44.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821322.0, assembly_id=102177.0))
lhcb2.new("mcs.a24r1.b2", "mcs", at="lhclength-(1096.9347+(-45-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242182.0, assembly_id=102177.0))
lhcb2.new("mb.b24r1.b2", "mb", at="lhclength-(1105.1707+(-45.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821346.0, assembly_id=102178.0))
lhcb2.new("mcs.b24r1.b2", "mcs", at="lhclength-(1112.5947+(-46-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242185.0, assembly_id=102178.0))
lhcb2.new("mco.b24r1.b2", "mco", at="lhclength-(1113.3447+(-46-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249624.0, assembly_id=102179.0))
lhcb2.new("mcd.b24r1.b2", "mcd", at="lhclength-(1113.3462+(-46-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249625.0, assembly_id=102179.0))
lhcb2.new("mb.c24r1.b2", "mb", at="lhclength-(1120.8307+(-46.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821370.0, assembly_id=102179.0))
lhcb2.new("mcs.c24r1.b2", "mcs", at="lhclength-(1128.2547+(-47-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242190.0, assembly_id=102179.0))
lhcb2.new("bpm.24r1.b2", "bpm", at="lhclength-(1129.1337+(-47-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242192.0, assembly_id=102180.0))
lhcb2.new("mo.24r1.b2", "mo", at="lhclength-(1129.8847+(-47-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308844.0, assembly_id=102180.0))
lhcb2.new("mq.24r1.b2", "mq", at="lhclength-(1131.8957+(-47-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308107.0, assembly_id=102180.0))
lhcb2.new("ms.24r1.b2", "ms", at="lhclength-(1133.7907+(-47-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249627.0, assembly_id=102180.0))
lhcb2.new("mcbh.24r1.b2", "mcbh", at="lhclength-(1134.3837+(-47-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249629.0, assembly_id=102180.0))
lhcb2.new("mb.a25r1.b2", "mb", at="lhclength-(1142.9607+(-47.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821394.0, assembly_id=102181.0))
lhcb2.new("mcs.a25r1.b2", "mcs", at="lhclength-(1150.3847+(-48-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242198.0, assembly_id=102181.0))
lhcb2.new("mco.25r1.b2", "mco", at="lhclength-(1151.1347+(-48-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249632.0, assembly_id=102182.0))
lhcb2.new("mcd.25r1.b2", "mcd", at="lhclength-(1151.1362+(-48-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249633.0, assembly_id=102182.0))
lhcb2.new("mb.b25r1.b2", "mb", at="lhclength-(1158.6207+(-48.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821418.0, assembly_id=102182.0))
lhcb2.new("mcs.b25r1.b2", "mcs", at="lhclength-(1166.0447+(-49-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242203.0, assembly_id=102182.0))
lhcb2.new("mb.c25r1.b2", "mb", at="lhclength-(1174.2807+(-49.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821442.0, assembly_id=102183.0))
lhcb2.new("mcs.c25r1.b2", "mcs", at="lhclength-(1181.7047+(-50-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242206.0, assembly_id=102183.0))
lhcb2.new("bpm.25r1.b2", "bpm", at="lhclength-(1182.5837+(-50-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242208.0, assembly_id=102184.0))
lhcb2.new("mo.25r1.b2", "mo", at="lhclength-(1183.3347+(-50-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308876.0, assembly_id=102184.0))
lhcb2.new("mq.25r1.b2", "mq", at="lhclength-(1185.3457+(-50-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308139.0, assembly_id=102184.0))
lhcb2.new("ms.25r1.b2", "ms", at="lhclength-(1187.2407+(-50-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249635.0, assembly_id=102184.0))
lhcb2.new("mcbv.25r1.b2", "mcbv", at="lhclength-(1187.8337+(-50-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249637.0, assembly_id=102184.0))
lhcb2.new("mco.a26r1.b2", "mco", at="lhclength-(1188.9247+(-50-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249640.0, assembly_id=102185.0))
lhcb2.new("mcd.a26r1.b2", "mcd", at="lhclength-(1188.9262+(-50-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249641.0, assembly_id=102185.0))
lhcb2.new("mb.a26r1.b2", "mb", at="lhclength-(1196.4107+(-50.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821466.0, assembly_id=102185.0))
lhcb2.new("mcs.a26r1.b2", "mcs", at="lhclength-(1203.8347+(-51-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242216.0, assembly_id=102185.0))
lhcb2.new("mb.b26r1.b2", "mb", at="lhclength-(1212.0707+(-51.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821490.0, assembly_id=102186.0))
lhcb2.new("mcs.b26r1.b2", "mcs", at="lhclength-(1219.4947+(-52-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242219.0, assembly_id=102186.0))
lhcb2.new("mco.b26r1.b2", "mco", at="lhclength-(1220.2447+(-52-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249644.0, assembly_id=102187.0))
lhcb2.new("mcd.b26r1.b2", "mcd", at="lhclength-(1220.2462+(-52-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249645.0, assembly_id=102187.0))
lhcb2.new("mb.c26r1.b2", "mb", at="lhclength-(1227.7307+(-52.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821514.0, assembly_id=102187.0))
lhcb2.new("mcs.c26r1.b2", "mcs", at="lhclength-(1235.1547+(-53-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242224.0, assembly_id=102187.0))
lhcb2.new("bpm.26r1.b2", "bpm", at="lhclength-(1236.0337+(-53-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242226.0, assembly_id=102188.0))
lhcb2.new("mo.26r1.b2", "mo", at="lhclength-(1236.7847+(-53-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308908.0, assembly_id=102188.0))
lhcb2.new("mq.26r1.b2", "mq", at="lhclength-(1238.7957+(-53-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308170.0, assembly_id=102188.0))
lhcb2.new("ms.26r1.b2", "ms", at="lhclength-(1240.6907+(-53-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249647.0, assembly_id=102188.0))
lhcb2.new("mcbh.26r1.b2", "mcbh", at="lhclength-(1241.2837+(-53-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249649.0, assembly_id=102188.0))
lhcb2.new("mb.a27r1.b2", "mb", at="lhclength-(1249.8607+(-53.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821538.0, assembly_id=102189.0))
lhcb2.new("mcs.a27r1.b2", "mcs", at="lhclength-(1257.2847+(-54-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242232.0, assembly_id=102189.0))
lhcb2.new("mco.27r1.b2", "mco", at="lhclength-(1258.0347+(-54-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249652.0, assembly_id=102190.0))
lhcb2.new("mcd.27r1.b2", "mcd", at="lhclength-(1258.0362+(-54-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249653.0, assembly_id=102190.0))
lhcb2.new("mb.b27r1.b2", "mb", at="lhclength-(1265.5207+(-54.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821562.0, assembly_id=102190.0))
lhcb2.new("mcs.b27r1.b2", "mcs", at="lhclength-(1272.9447+(-55-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242237.0, assembly_id=102190.0))
lhcb2.new("mb.c27r1.b2", "mb", at="lhclength-(1281.1807+(-55.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821586.0, assembly_id=102191.0))
lhcb2.new("mcs.c27r1.b2", "mcs", at="lhclength-(1288.6047+(-56-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242240.0, assembly_id=102191.0))
lhcb2.new("bpm.27r1.b2", "bpm", at="lhclength-(1289.4837+(-56-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242242.0, assembly_id=102192.0))
lhcb2.new("mqs.27r1.b2", "mqs", at="lhclength-(1290.2377+(-56-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307668.0, assembly_id=102192.0))
lhcb2.new("mq.27r1.b2", "mq", at="lhclength-(1292.2457+(-56-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308200.0, assembly_id=102192.0))
lhcb2.new("ms.27r1.b2", "ms", at="lhclength-(1294.1407+(-56-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249655.0, assembly_id=102192.0))
lhcb2.new("mcbv.27r1.b2", "mcbv", at="lhclength-(1294.7337+(-56-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249657.0, assembly_id=102192.0))
lhcb2.new("mco.a28r1.b2", "mco", at="lhclength-(1295.8247+(-56-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249660.0, assembly_id=102193.0))
lhcb2.new("mcd.a28r1.b2", "mcd", at="lhclength-(1295.8262+(-56-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249661.0, assembly_id=102193.0))
lhcb2.new("mb.a28r1.b2", "mb", at="lhclength-(1303.3107+(-56.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821610.0, assembly_id=102193.0))
lhcb2.new("mcs.a28r1.b2", "mcs", at="lhclength-(1310.7347+(-57-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242250.0, assembly_id=102193.0))
lhcb2.new("mb.b28r1.b2", "mb", at="lhclength-(1318.9707+(-57.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821634.0, assembly_id=102194.0))
lhcb2.new("mcs.b28r1.b2", "mcs", at="lhclength-(1326.3947+(-58-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242253.0, assembly_id=102194.0))
lhcb2.new("mco.b28r1.b2", "mco", at="lhclength-(1327.1447+(-58-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249664.0, assembly_id=102195.0))
lhcb2.new("mcd.b28r1.b2", "mcd", at="lhclength-(1327.1462+(-58-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249665.0, assembly_id=102195.0))
lhcb2.new("mb.c28r1.b2", "mb", at="lhclength-(1334.6307+(-58.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821658.0, assembly_id=102195.0))
lhcb2.new("mcs.c28r1.b2", "mcs", at="lhclength-(1342.0547+(-59-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242258.0, assembly_id=102195.0))
lhcb2.new("bpm.28r1.b2", "bpm", at="lhclength-(1342.9337+(-59-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242260.0, assembly_id=102196.0))
lhcb2.new("mo.28r1.b2", "mo", at="lhclength-(1343.6847+(-59-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308697.0, assembly_id=102196.0))
lhcb2.new("mq.28r1.b2", "mq", at="lhclength-(1345.6957+(-59-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307991.0, assembly_id=102196.0))
lhcb2.new("ms.28r1.b2", "ms", at="lhclength-(1347.5907+(-59-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249667.0, assembly_id=102196.0))
lhcb2.new("mcbh.28r1.b2", "mcbh", at="lhclength-(1348.1837+(-59-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249669.0, assembly_id=102196.0))
lhcb2.new("mb.a29r1.b2", "mb", at="lhclength-(1356.7607+(-59.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821682.0, assembly_id=102197.0))
lhcb2.new("mcs.a29r1.b2", "mcs", at="lhclength-(1364.1847+(-60-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242266.0, assembly_id=102197.0))
lhcb2.new("mco.29r1.b2", "mco", at="lhclength-(1364.9347+(-60-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249672.0, assembly_id=102198.0))
lhcb2.new("mcd.29r1.b2", "mcd", at="lhclength-(1364.9362+(-60-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249673.0, assembly_id=102198.0))
lhcb2.new("mb.b29r1.b2", "mb", at="lhclength-(1372.4207+(-60.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821706.0, assembly_id=102198.0))
lhcb2.new("mcs.b29r1.b2", "mcs", at="lhclength-(1379.8447+(-61-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242271.0, assembly_id=102198.0))
lhcb2.new("mb.c29r1.b2", "mb", at="lhclength-(1388.0807+(-61.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821730.0, assembly_id=102199.0))
lhcb2.new("mcs.c29r1.b2", "mcs", at="lhclength-(1395.5047+(-62-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242274.0, assembly_id=102199.0))
lhcb2.new("bpm.29r1.b2", "bpm", at="lhclength-(1396.3837+(-62-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242276.0, assembly_id=102200.0))
lhcb2.new("mo.29r1.b2", "mo", at="lhclength-(1397.1347+(-62-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308729.0, assembly_id=102200.0))
lhcb2.new("mq.29r1.b2", "mq", at="lhclength-(1399.1457+(-62-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308022.0, assembly_id=102200.0))
lhcb2.new("ms.29r1.b2", "ms", at="lhclength-(1401.0407+(-62-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249675.0, assembly_id=102200.0))
lhcb2.new("mcbv.29r1.b2", "mcbv", at="lhclength-(1401.6337+(-62-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249677.0, assembly_id=102200.0))
lhcb2.new("mco.a30r1.b2", "mco", at="lhclength-(1402.7247+(-62-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249680.0, assembly_id=102201.0))
lhcb2.new("mcd.a30r1.b2", "mcd", at="lhclength-(1402.7262+(-62-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249681.0, assembly_id=102201.0))
lhcb2.new("mb.a30r1.b2", "mb", at="lhclength-(1410.2107+(-62.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821754.0, assembly_id=102201.0))
lhcb2.new("mcs.a30r1.b2", "mcs", at="lhclength-(1417.6347+(-63-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242284.0, assembly_id=102201.0))
lhcb2.new("mb.b30r1.b2", "mb", at="lhclength-(1425.8707+(-63.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821778.0, assembly_id=102202.0))
lhcb2.new("mcs.b30r1.b2", "mcs", at="lhclength-(1433.2947+(-64-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242287.0, assembly_id=102202.0))
lhcb2.new("mco.b30r1.b2", "mco", at="lhclength-(1434.0447+(-64-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249684.0, assembly_id=102203.0))
lhcb2.new("mcd.b30r1.b2", "mcd", at="lhclength-(1434.0462+(-64-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249685.0, assembly_id=102203.0))
lhcb2.new("mb.c30r1.b2", "mb", at="lhclength-(1441.5307+(-64.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821802.0, assembly_id=102203.0))
lhcb2.new("mcs.c30r1.b2", "mcs", at="lhclength-(1448.9547+(-65-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242292.0, assembly_id=102203.0))
lhcb2.new("bpm.30r1.b2", "bpm", at="lhclength-(1449.8337+(-65-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242294.0, assembly_id=102204.0))
lhcb2.new("mo.30r1.b2", "mo", at="lhclength-(1450.5847+(-65-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308760.0, assembly_id=102204.0))
lhcb2.new("mq.30r1.b2", "mq", at="lhclength-(1452.5957+(-65-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308052.0, assembly_id=102204.0))
lhcb2.new("mss.30r1.b2", "mss", at="lhclength-(1454.4907+(-65-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249687.0, assembly_id=102204.0))
lhcb2.new("mcbh.30r1.b2", "mcbh", at="lhclength-(1455.0837+(-65-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249689.0, assembly_id=102204.0))
lhcb2.new("mb.a31r1.b2", "mb", at="lhclength-(1463.6607+(-65.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821826.0, assembly_id=102205.0))
lhcb2.new("mcs.a31r1.b2", "mcs", at="lhclength-(1471.0847+(-66-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242300.0, assembly_id=102205.0))
lhcb2.new("mco.31r1.b2", "mco", at="lhclength-(1471.8347+(-66-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249692.0, assembly_id=102206.0))
lhcb2.new("mcd.31r1.b2", "mcd", at="lhclength-(1471.8362+(-66-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249693.0, assembly_id=102206.0))
lhcb2.new("mb.b31r1.b2", "mb", at="lhclength-(1479.3207+(-66.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821850.0, assembly_id=102206.0))
lhcb2.new("mcs.b31r1.b2", "mcs", at="lhclength-(1486.7447+(-67-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242305.0, assembly_id=102206.0))
lhcb2.new("mb.c31r1.b2", "mb", at="lhclength-(1494.9807+(-67.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821874.0, assembly_id=102207.0))
lhcb2.new("mcs.c31r1.b2", "mcs", at="lhclength-(1502.4047+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242308.0, assembly_id=102207.0))
lhcb2.new("bpm.31r1.b2", "bpm", at="lhclength-(1503.2837+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242310.0, assembly_id=102208.0))
lhcb2.new("mo.31r1.b2", "mo", at="lhclength-(1504.0347+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308790.0, assembly_id=102208.0))
lhcb2.new("mq.31r1.b2", "mq", at="lhclength-(1506.0457+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308082.0, assembly_id=102208.0))
lhcb2.new("ms.31r1.b2", "ms", at="lhclength-(1507.9407+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249695.0, assembly_id=102208.0))
lhcb2.new("mcbv.31r1.b2", "mcbv", at="lhclength-(1508.5337+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249697.0, assembly_id=102208.0))
lhcb2.new("s.cell.12.b2", "omk", at="lhclength-(1509.2807+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a32r1.b2", "mco", at="lhclength-(1509.6247+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249700.0, assembly_id=102209.0))
lhcb2.new("mcd.a32r1.b2", "mcd", at="lhclength-(1509.6262+(-68-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249701.0, assembly_id=102209.0))
lhcb2.new("mb.a32r1.b2", "mb", at="lhclength-(1517.1107+(-68.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821898.0, assembly_id=102209.0))
lhcb2.new("mcs.a32r1.b2", "mcs", at="lhclength-(1524.5347+(-69-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242318.0, assembly_id=102209.0))
lhcb2.new("mb.b32r1.b2", "mb", at="lhclength-(1532.7707+(-69.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821922.0, assembly_id=102210.0))
lhcb2.new("mcs.b32r1.b2", "mcs", at="lhclength-(1540.1947+(-70-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242321.0, assembly_id=102210.0))
lhcb2.new("mco.b32r1.b2", "mco", at="lhclength-(1540.9447+(-70-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249704.0, assembly_id=102211.0))
lhcb2.new("mcd.b32r1.b2", "mcd", at="lhclength-(1540.9462+(-70-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249705.0, assembly_id=102211.0))
lhcb2.new("mb.c32r1.b2", "mb", at="lhclength-(1548.4307+(-70.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821946.0, assembly_id=102211.0))
lhcb2.new("mcs.c32r1.b2", "mcs", at="lhclength-(1555.8547+(-71-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242326.0, assembly_id=102211.0))
lhcb2.new("bpm.32r1.b2", "bpm", at="lhclength-(1556.7337+(-71-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242328.0, assembly_id=102212.0))
lhcb2.new("mo.32r1.b2", "mo", at="lhclength-(1557.4847+(-71-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308582.0, assembly_id=102212.0))
lhcb2.new("mq.32r1.b2", "mq", at="lhclength-(1559.4957+(-71-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307874.0, assembly_id=102212.0))
lhcb2.new("ms.32r1.b2", "ms", at="lhclength-(1561.3907+(-71-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249707.0, assembly_id=102212.0))
lhcb2.new("mcbh.32r1.b2", "mcbh", at="lhclength-(1561.9837+(-71-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249709.0, assembly_id=102212.0))
lhcb2.new("mb.a33r1.b2", "mb", at="lhclength-(1570.5607+(-71.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821970.0, assembly_id=102213.0))
lhcb2.new("mcs.a33r1.b2", "mcs", at="lhclength-(1577.9847+(-72-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242334.0, assembly_id=102213.0))
lhcb2.new("mco.33r1.b2", "mco", at="lhclength-(1578.7347+(-72-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249712.0, assembly_id=102214.0))
lhcb2.new("mcd.33r1.b2", "mcd", at="lhclength-(1578.7362+(-72-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249713.0, assembly_id=102214.0))
lhcb2.new("mb.b33r1.b2", "mb", at="lhclength-(1586.2207+(-72.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52821994.0, assembly_id=102214.0))
lhcb2.new("mcs.b33r1.b2", "mcs", at="lhclength-(1593.6447+(-73-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242339.0, assembly_id=102214.0))
lhcb2.new("mb.c33r1.b2", "mb", at="lhclength-(1601.8807+(-73.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52822018.0, assembly_id=102215.0))
lhcb2.new("mcs.c33r1.b2", "mcs", at="lhclength-(1609.3047+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242342.0, assembly_id=102215.0))
lhcb2.new("bpm.33r1.b2", "bpm", at="lhclength-(1610.1837+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242344.0, assembly_id=102216.0))
lhcb2.new("mo.33r1.b2", "mo", at="lhclength-(1610.9347+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308613.0, assembly_id=102216.0))
lhcb2.new("mq.33r1.b2", "mq", at="lhclength-(1612.9457+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307903.0, assembly_id=102216.0))
lhcb2.new("ms.33r1.b2", "ms", at="lhclength-(1614.8407+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249715.0, assembly_id=102216.0))
lhcb2.new("mcbv.33r1.b2", "mcbv", at="lhclength-(1615.4337+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249717.0, assembly_id=102216.0))
lhcb2.new("e.cell.12.b2", "omk", at="lhclength-(1616.1807+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a34r1.b2", "mco", at="lhclength-(1616.5247+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249720.0, assembly_id=102217.0))
lhcb2.new("mcd.a34r1.b2", "mcd", at="lhclength-(1616.5262+(-74-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249721.0, assembly_id=102217.0))
lhcb2.new("mb.a34r1.b2", "mb", at="lhclength-(1624.0107+(-74.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52822042.0, assembly_id=102217.0))
lhcb2.new("mcs.a34r1.b2", "mcs", at="lhclength-(1631.4347+(-75-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242352.0, assembly_id=102217.0))
lhcb2.new("mb.b34r1.b2", "mb", at="lhclength-(1639.6707+(-75.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52822066.0, assembly_id=102218.0))
lhcb2.new("mcs.b34r1.b2", "mcs", at="lhclength-(1647.0947+(-76-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242355.0, assembly_id=102218.0))
lhcb2.new("mco.b34r1.b2", "mco", at="lhclength-(1647.8447+(-76-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249724.0, assembly_id=102219.0))
lhcb2.new("mcd.b34r1.b2", "mcd", at="lhclength-(1647.8462+(-76-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=249725.0, assembly_id=102219.0))
lhcb2.new("mb.c34r1.b2", "mb", at="lhclength-(1655.3307+(-76.5-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=52822090.0, assembly_id=102219.0))
lhcb2.new("mcs.c34r1.b2", "mcs", at="lhclength-(1662.7547+(-77-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242360.0, assembly_id=102219.0))
lhcb2.new("bpm.34r1.b2", "bpm", at="lhclength-(1663.6337+(-77-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=242362.0, assembly_id=102220.0))
lhcb2.new("mo.34r1.b2", "mo", at="lhclength-(1664.3847+(-77-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2308628.0, assembly_id=102220.0))
lhcb2.new("mq.34r1.b2", "mq", at="lhclength-(1666.3957+(-77-ip1ofs.b2)*ds)", from_="ip1", extra=dict(mech_sep=-0.194, slot_id=2307918.0, assembly_id=102220.0))
lhcb2.new("mss.34l2.b2", "mss", at="lhclength-(-1664.0697+(-77-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249727.0, assembly_id=102220.0))
lhcb2.new("mcbh.34l2.b2", "mcbh", at="lhclength-(-1663.4767+(-77-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249729.0, assembly_id=102220.0))
lhcb2.new("mb.c34l2.b2", "mb", at="lhclength-(-1654.8997+(-77.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822114.0, assembly_id=102221.0))
lhcb2.new("mcs.c34l2.b2", "mcs", at="lhclength-(-1647.4757+(-78-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242368.0, assembly_id=102221.0))
lhcb2.new("mco.34l2.b2", "mco", at="lhclength-(-1646.7257+(-78-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249732.0, assembly_id=102222.0))
lhcb2.new("mcd.34l2.b2", "mcd", at="lhclength-(-1646.7242+(-78-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249733.0, assembly_id=102222.0))
lhcb2.new("mb.b34l2.b2", "mb", at="lhclength-(-1639.2397+(-78.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822138.0, assembly_id=102222.0))
lhcb2.new("mcs.b34l2.b2", "mcs", at="lhclength-(-1631.8157+(-79-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242373.0, assembly_id=102222.0))
lhcb2.new("mb.a34l2.b2", "mb", at="lhclength-(-1623.5797+(-79.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822162.0, assembly_id=102223.0))
lhcb2.new("mcs.a34l2.b2", "mcs", at="lhclength-(-1616.1557+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242376.0, assembly_id=102223.0))
lhcb2.new("bpm.33l2.b2", "bpm", at="lhclength-(-1615.2767+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242378.0, assembly_id=102224.0))
lhcb2.new("mo.33l2.b2", "mo", at="lhclength-(-1614.5257+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308600.0, assembly_id=102224.0))
lhcb2.new("mq.33l2.b2", "mq", at="lhclength-(-1612.5147+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307890.0, assembly_id=102224.0))
lhcb2.new("ms.33l2.b2", "ms", at="lhclength-(-1610.6197+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249735.0, assembly_id=102224.0))
lhcb2.new("mcbv.33l2.b2", "mcbv", at="lhclength-(-1610.0267+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249737.0, assembly_id=102224.0))
lhcb2.new("mco.b33l2.b2", "mco", at="lhclength-(-1608.9357+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249740.0, assembly_id=102225.0))
lhcb2.new("mcd.b33l2.b2", "mcd", at="lhclength-(-1608.9342+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249741.0, assembly_id=102225.0))
lhcb2.new("mb.c33l2.b2", "mb", at="lhclength-(-1601.4497+(-80.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822186.0, assembly_id=102225.0))
lhcb2.new("mcs.c33l2.b2", "mcs", at="lhclength-(-1594.0257+(-81-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242386.0, assembly_id=102225.0))
lhcb2.new("mb.b33l2.b2", "mb", at="lhclength-(-1585.7897+(-81.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822210.0, assembly_id=102226.0))
lhcb2.new("mcs.b33l2.b2", "mcs", at="lhclength-(-1578.3657+(-82-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242389.0, assembly_id=102226.0))
lhcb2.new("mco.a33l2.b2", "mco", at="lhclength-(-1577.6157+(-82-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249744.0, assembly_id=102227.0))
lhcb2.new("mcd.a33l2.b2", "mcd", at="lhclength-(-1577.6142+(-82-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249745.0, assembly_id=102227.0))
lhcb2.new("mb.a33l2.b2", "mb", at="lhclength-(-1570.1297+(-82.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822234.0, assembly_id=102227.0))
lhcb2.new("mcs.a33l2.b2", "mcs", at="lhclength-(-1562.7057+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242394.0, assembly_id=102227.0))
lhcb2.new("bpm.32l2.b2", "bpm", at="lhclength-(-1561.8267+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242396.0, assembly_id=102228.0))
lhcb2.new("mo.32l2.b2", "mo", at="lhclength-(-1561.0757+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308568.0, assembly_id=102228.0))
lhcb2.new("mq.32l2.b2", "mq", at="lhclength-(-1559.0647+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307861.0, assembly_id=102228.0))
lhcb2.new("mss.32l2.b2", "mss", at="lhclength-(-1557.1697+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249747.0, assembly_id=102228.0))
lhcb2.new("mcbh.32l2.b2", "mcbh", at="lhclength-(-1556.5767+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249749.0, assembly_id=102228.0))
lhcb2.new("mb.c32l2.b2", "mb", at="lhclength-(-1547.9997+(-83.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822258.0, assembly_id=102229.0))
lhcb2.new("mcs.c32l2.b2", "mcs", at="lhclength-(-1540.5757+(-84-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242402.0, assembly_id=102229.0))
lhcb2.new("mco.32l2.b2", "mco", at="lhclength-(-1539.8257+(-84-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249752.0, assembly_id=102230.0))
lhcb2.new("mcd.32l2.b2", "mcd", at="lhclength-(-1539.8242+(-84-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249753.0, assembly_id=102230.0))
lhcb2.new("mb.b32l2.b2", "mb", at="lhclength-(-1532.3397+(-84.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822282.0, assembly_id=102230.0))
lhcb2.new("mcs.b32l2.b2", "mcs", at="lhclength-(-1524.9157+(-85-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242407.0, assembly_id=102230.0))
lhcb2.new("mb.a32l2.b2", "mb", at="lhclength-(-1516.6797+(-85.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822306.0, assembly_id=102231.0))
lhcb2.new("mcs.a32l2.b2", "mcs", at="lhclength-(-1509.2557+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242410.0, assembly_id=102231.0))
lhcb2.new("bpm.31l2.b2", "bpm", at="lhclength-(-1508.3767+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242412.0, assembly_id=102232.0))
lhcb2.new("mo.31l2.b2", "mo", at="lhclength-(-1507.6257+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308777.0, assembly_id=102232.0))
lhcb2.new("mq.31l2.b2", "mq", at="lhclength-(-1505.6147+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308069.0, assembly_id=102232.0))
lhcb2.new("ms.31l2.b2", "ms", at="lhclength-(-1503.7197+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249755.0, assembly_id=102232.0))
lhcb2.new("mcbv.31l2.b2", "mcbv", at="lhclength-(-1503.1267+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249757.0, assembly_id=102232.0))
lhcb2.new("mco.b31l2.b2", "mco", at="lhclength-(-1502.0357+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249760.0, assembly_id=102233.0))
lhcb2.new("mcd.b31l2.b2", "mcd", at="lhclength-(-1502.0342+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249761.0, assembly_id=102233.0))
lhcb2.new("mb.c31l2.b2", "mb", at="lhclength-(-1494.5497+(-86.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822330.0, assembly_id=102233.0))
lhcb2.new("mcs.c31l2.b2", "mcs", at="lhclength-(-1487.1257+(-87-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242420.0, assembly_id=102233.0))
lhcb2.new("mb.b31l2.b2", "mb", at="lhclength-(-1478.8897+(-87.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822354.0, assembly_id=102234.0))
lhcb2.new("mcs.b31l2.b2", "mcs", at="lhclength-(-1471.4657+(-88-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242423.0, assembly_id=102234.0))
lhcb2.new("mco.a31l2.b2", "mco", at="lhclength-(-1470.7157+(-88-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249764.0, assembly_id=102235.0))
lhcb2.new("mcd.a31l2.b2", "mcd", at="lhclength-(-1470.7142+(-88-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249765.0, assembly_id=102235.0))
lhcb2.new("mb.a31l2.b2", "mb", at="lhclength-(-1463.2297+(-88.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822378.0, assembly_id=102235.0))
lhcb2.new("mcs.a31l2.b2", "mcs", at="lhclength-(-1455.8057+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242428.0, assembly_id=102235.0))
lhcb2.new("bpm.30l2.b2", "bpm", at="lhclength-(-1454.9267+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242430.0, assembly_id=102236.0))
lhcb2.new("mo.30l2.b2", "mo", at="lhclength-(-1454.1757+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308747.0, assembly_id=102236.0))
lhcb2.new("mq.30l2.b2", "mq", at="lhclength-(-1452.1647+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308039.0, assembly_id=102236.0))
lhcb2.new("ms.30l2.b2", "ms", at="lhclength-(-1450.2697+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249767.0, assembly_id=102236.0))
lhcb2.new("mcbh.30l2.b2", "mcbh", at="lhclength-(-1449.6767+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249769.0, assembly_id=102236.0))
lhcb2.new("mb.c30l2.b2", "mb", at="lhclength-(-1441.0997+(-89.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822402.0, assembly_id=102237.0))
lhcb2.new("mcs.c30l2.b2", "mcs", at="lhclength-(-1433.6757+(-90-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242436.0, assembly_id=102237.0))
lhcb2.new("mco.30l2.b2", "mco", at="lhclength-(-1432.9257+(-90-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249772.0, assembly_id=102238.0))
lhcb2.new("mcd.30l2.b2", "mcd", at="lhclength-(-1432.9242+(-90-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249773.0, assembly_id=102238.0))
lhcb2.new("mb.b30l2.b2", "mb", at="lhclength-(-1425.4397+(-90.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822426.0, assembly_id=102238.0))
lhcb2.new("mcs.b30l2.b2", "mcs", at="lhclength-(-1418.0157+(-91-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242441.0, assembly_id=102238.0))
lhcb2.new("mb.a30l2.b2", "mb", at="lhclength-(-1409.7797+(-91.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822450.0, assembly_id=102239.0))
lhcb2.new("mcs.a30l2.b2", "mcs", at="lhclength-(-1402.3557+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242444.0, assembly_id=102239.0))
lhcb2.new("bpm.29l2.b2", "bpm", at="lhclength-(-1401.4767+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242446.0, assembly_id=102240.0))
lhcb2.new("mo.29l2.b2", "mo", at="lhclength-(-1400.7257+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308715.0, assembly_id=102240.0))
lhcb2.new("mq.29l2.b2", "mq", at="lhclength-(-1398.7147+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308009.0, assembly_id=102240.0))
lhcb2.new("ms.29l2.b2", "ms", at="lhclength-(-1396.8197+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249775.0, assembly_id=102240.0))
lhcb2.new("mcbv.29l2.b2", "mcbv", at="lhclength-(-1396.2267+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249777.0, assembly_id=102240.0))
lhcb2.new("mco.b29l2.b2", "mco", at="lhclength-(-1395.1357+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249780.0, assembly_id=102241.0))
lhcb2.new("mcd.b29l2.b2", "mcd", at="lhclength-(-1395.1342+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249781.0, assembly_id=102241.0))
lhcb2.new("mb.c29l2.b2", "mb", at="lhclength-(-1387.6497+(-92.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822474.0, assembly_id=102241.0))
lhcb2.new("mcs.c29l2.b2", "mcs", at="lhclength-(-1380.2257+(-93-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242454.0, assembly_id=102241.0))
lhcb2.new("mb.b29l2.b2", "mb", at="lhclength-(-1371.9897+(-93.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822498.0, assembly_id=102242.0))
lhcb2.new("mcs.b29l2.b2", "mcs", at="lhclength-(-1364.5657+(-94-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242457.0, assembly_id=102242.0))
lhcb2.new("mco.a29l2.b2", "mco", at="lhclength-(-1363.8157+(-94-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249784.0, assembly_id=102243.0))
lhcb2.new("mcd.a29l2.b2", "mcd", at="lhclength-(-1363.8142+(-94-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249785.0, assembly_id=102243.0))
lhcb2.new("mb.a29l2.b2", "mb", at="lhclength-(-1356.3297+(-94.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822522.0, assembly_id=102243.0))
lhcb2.new("mcs.a29l2.b2", "mcs", at="lhclength-(-1348.9057+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242462.0, assembly_id=102243.0))
lhcb2.new("bpm.28l2.b2", "bpm", at="lhclength-(-1348.0267+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242464.0, assembly_id=102244.0))
lhcb2.new("mo.28l2.b2", "mo", at="lhclength-(-1347.2757+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308684.0, assembly_id=102244.0))
lhcb2.new("mq.28l2.b2", "mq", at="lhclength-(-1345.2647+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307977.0, assembly_id=102244.0))
lhcb2.new("mss.28l2.b2", "mss", at="lhclength-(-1343.3697+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249787.0, assembly_id=102244.0))
lhcb2.new("mcbh.28l2.b2", "mcbh", at="lhclength-(-1342.7767+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249789.0, assembly_id=102244.0))
lhcb2.new("mb.c28l2.b2", "mb", at="lhclength-(-1334.1997+(-95.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822546.0, assembly_id=102245.0))
lhcb2.new("mcs.c28l2.b2", "mcs", at="lhclength-(-1326.7757+(-96-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242470.0, assembly_id=102245.0))
lhcb2.new("mco.28l2.b2", "mco", at="lhclength-(-1326.0257+(-96-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249792.0, assembly_id=102246.0))
lhcb2.new("mcd.28l2.b2", "mcd", at="lhclength-(-1326.0242+(-96-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249793.0, assembly_id=102246.0))
lhcb2.new("mb.b28l2.b2", "mb", at="lhclength-(-1318.5397+(-96.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822570.0, assembly_id=102246.0))
lhcb2.new("mcs.b28l2.b2", "mcs", at="lhclength-(-1311.1157+(-97-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242475.0, assembly_id=102246.0))
lhcb2.new("mb.a28l2.b2", "mb", at="lhclength-(-1302.8797+(-97.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822594.0, assembly_id=102247.0))
lhcb2.new("mcs.a28l2.b2", "mcs", at="lhclength-(-1295.4557+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242478.0, assembly_id=102247.0))
lhcb2.new("bpm.27l2.b2", "bpm", at="lhclength-(-1294.5767+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242480.0, assembly_id=102248.0))
lhcb2.new("mqs.27l2.b2", "mqs", at="lhclength-(-1293.8227+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307654.0, assembly_id=102248.0))
lhcb2.new("mq.27l2.b2", "mq", at="lhclength-(-1291.8147+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308187.0, assembly_id=102248.0))
lhcb2.new("ms.27l2.b2", "ms", at="lhclength-(-1289.9197+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249795.0, assembly_id=102248.0))
lhcb2.new("mcbv.27l2.b2", "mcbv", at="lhclength-(-1289.3267+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249797.0, assembly_id=102248.0))
lhcb2.new("mco.b27l2.b2", "mco", at="lhclength-(-1288.2357+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249800.0, assembly_id=102249.0))
lhcb2.new("mcd.b27l2.b2", "mcd", at="lhclength-(-1288.2342+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249801.0, assembly_id=102249.0))
lhcb2.new("mb.c27l2.b2", "mb", at="lhclength-(-1280.7497+(-98.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822618.0, assembly_id=102249.0))
lhcb2.new("mcs.c27l2.b2", "mcs", at="lhclength-(-1273.3257+(-99-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242488.0, assembly_id=102249.0))
lhcb2.new("mb.b27l2.b2", "mb", at="lhclength-(-1265.0897+(-99.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822642.0, assembly_id=102250.0))
lhcb2.new("mcs.b27l2.b2", "mcs", at="lhclength-(-1257.6657+(-100-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242491.0, assembly_id=102250.0))
lhcb2.new("mco.a27l2.b2", "mco", at="lhclength-(-1256.9157+(-100-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249804.0, assembly_id=102251.0))
lhcb2.new("mcd.a27l2.b2", "mcd", at="lhclength-(-1256.9142+(-100-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249805.0, assembly_id=102251.0))
lhcb2.new("mb.a27l2.b2", "mb", at="lhclength-(-1249.4297+(-100.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822666.0, assembly_id=102251.0))
lhcb2.new("mcs.a27l2.b2", "mcs", at="lhclength-(-1242.0057+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242496.0, assembly_id=102251.0))
lhcb2.new("bpm.26l2.b2", "bpm", at="lhclength-(-1241.1267+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242498.0, assembly_id=102252.0))
lhcb2.new("mo.26l2.b2", "mo", at="lhclength-(-1240.3757+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308894.0, assembly_id=102252.0))
lhcb2.new("mq.26l2.b2", "mq", at="lhclength-(-1238.3647+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308157.0, assembly_id=102252.0))
lhcb2.new("ms.26l2.b2", "ms", at="lhclength-(-1236.4697+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249807.0, assembly_id=102252.0))
lhcb2.new("mcbh.26l2.b2", "mcbh", at="lhclength-(-1235.8767+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249809.0, assembly_id=102252.0))
lhcb2.new("mb.c26l2.b2", "mb", at="lhclength-(-1227.2997+(-101.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822690.0, assembly_id=102253.0))
lhcb2.new("mcs.c26l2.b2", "mcs", at="lhclength-(-1219.8757+(-102-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242504.0, assembly_id=102253.0))
lhcb2.new("mco.26l2.b2", "mco", at="lhclength-(-1219.1257+(-102-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249812.0, assembly_id=102254.0))
lhcb2.new("mcd.26l2.b2", "mcd", at="lhclength-(-1219.1242+(-102-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249813.0, assembly_id=102254.0))
lhcb2.new("mb.b26l2.b2", "mb", at="lhclength-(-1211.6397+(-102.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822714.0, assembly_id=102254.0))
lhcb2.new("mcs.b26l2.b2", "mcs", at="lhclength-(-1204.2157+(-103-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242509.0, assembly_id=102254.0))
lhcb2.new("mb.a26l2.b2", "mb", at="lhclength-(-1195.9797+(-103.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822738.0, assembly_id=102255.0))
lhcb2.new("mcs.a26l2.b2", "mcs", at="lhclength-(-1188.5557+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242512.0, assembly_id=102255.0))
lhcb2.new("bpm.25l2.b2", "bpm", at="lhclength-(-1187.6767+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242514.0, assembly_id=102256.0))
lhcb2.new("mo.25l2.b2", "mo", at="lhclength-(-1186.9257+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308862.0, assembly_id=102256.0))
lhcb2.new("mq.25l2.b2", "mq", at="lhclength-(-1184.9147+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308125.0, assembly_id=102256.0))
lhcb2.new("ms.25l2.b2", "ms", at="lhclength-(-1183.0197+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249815.0, assembly_id=102256.0))
lhcb2.new("mcbv.25l2.b2", "mcbv", at="lhclength-(-1182.4267+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249817.0, assembly_id=102256.0))
lhcb2.new("mco.b25l2.b2", "mco", at="lhclength-(-1181.3357+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249820.0, assembly_id=102257.0))
lhcb2.new("mcd.b25l2.b2", "mcd", at="lhclength-(-1181.3342+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249821.0, assembly_id=102257.0))
lhcb2.new("mb.c25l2.b2", "mb", at="lhclength-(-1173.8497+(-104.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822762.0, assembly_id=102257.0))
lhcb2.new("mcs.c25l2.b2", "mcs", at="lhclength-(-1166.4257+(-105-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242522.0, assembly_id=102257.0))
lhcb2.new("mb.b25l2.b2", "mb", at="lhclength-(-1158.1897+(-105.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822786.0, assembly_id=102258.0))
lhcb2.new("mcs.b25l2.b2", "mcs", at="lhclength-(-1150.7657+(-106-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242525.0, assembly_id=102258.0))
lhcb2.new("mco.a25l2.b2", "mco", at="lhclength-(-1150.0157+(-106-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249824.0, assembly_id=102259.0))
lhcb2.new("mcd.a25l2.b2", "mcd", at="lhclength-(-1150.0142+(-106-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249825.0, assembly_id=102259.0))
lhcb2.new("mb.a25l2.b2", "mb", at="lhclength-(-1142.5297+(-106.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822810.0, assembly_id=102259.0))
lhcb2.new("mcs.a25l2.b2", "mcs", at="lhclength-(-1135.1057+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242530.0, assembly_id=102259.0))
lhcb2.new("bpm.24l2.b2", "bpm", at="lhclength-(-1134.2267+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242532.0, assembly_id=102260.0))
lhcb2.new("mo.24l2.b2", "mo", at="lhclength-(-1133.4757+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308831.0, assembly_id=102260.0))
lhcb2.new("mq.24l2.b2", "mq", at="lhclength-(-1131.4647+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308093.0, assembly_id=102260.0))
lhcb2.new("ms.24l2.b2", "ms", at="lhclength-(-1129.5697+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249827.0, assembly_id=102260.0))
lhcb2.new("mcbh.24l2.b2", "mcbh", at="lhclength-(-1128.9767+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249829.0, assembly_id=102260.0))
lhcb2.new("mb.c24l2.b2", "mb", at="lhclength-(-1120.3997+(-107.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822834.0, assembly_id=102261.0))
lhcb2.new("mcs.c24l2.b2", "mcs", at="lhclength-(-1112.9757+(-108-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242538.0, assembly_id=102261.0))
lhcb2.new("mco.24l2.b2", "mco", at="lhclength-(-1112.2257+(-108-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249832.0, assembly_id=102262.0))
lhcb2.new("mcd.24l2.b2", "mcd", at="lhclength-(-1112.2242+(-108-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249833.0, assembly_id=102262.0))
lhcb2.new("mb.b24l2.b2", "mb", at="lhclength-(-1104.7397+(-108.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822858.0, assembly_id=102262.0))
lhcb2.new("mcs.b24l2.b2", "mcs", at="lhclength-(-1097.3157+(-109-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242543.0, assembly_id=102262.0))
lhcb2.new("mb.a24l2.b2", "mb", at="lhclength-(-1089.0797+(-109.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822882.0, assembly_id=102263.0))
lhcb2.new("mcs.a24l2.b2", "mcs", at="lhclength-(-1081.6557+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242546.0, assembly_id=102263.0))
lhcb2.new("bpm.23l2.b2", "bpm", at="lhclength-(-1080.7767+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242548.0, assembly_id=102264.0))
lhcb2.new("mqs.23l2.b2", "mqs", at="lhclength-(-1080.0227+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307624.0, assembly_id=102264.0))
lhcb2.new("mq.23l2.b2", "mq", at="lhclength-(-1078.0147+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308304.0, assembly_id=102264.0))
lhcb2.new("ms.23l2.b2", "ms", at="lhclength-(-1076.1197+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249835.0, assembly_id=102264.0))
lhcb2.new("mcbv.23l2.b2", "mcbv", at="lhclength-(-1075.5267+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249837.0, assembly_id=102264.0))
lhcb2.new("mco.b23l2.b2", "mco", at="lhclength-(-1074.4357+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249840.0, assembly_id=102265.0))
lhcb2.new("mcd.b23l2.b2", "mcd", at="lhclength-(-1074.4342+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249841.0, assembly_id=102265.0))
lhcb2.new("mb.c23l2.b2", "mb", at="lhclength-(-1066.9497+(-110.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822906.0, assembly_id=102265.0))
lhcb2.new("mcs.c23l2.b2", "mcs", at="lhclength-(-1059.5257+(-111-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242556.0, assembly_id=102265.0))
lhcb2.new("mb.b23l2.b2", "mb", at="lhclength-(-1051.2897+(-111.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822930.0, assembly_id=102266.0))
lhcb2.new("mcs.b23l2.b2", "mcs", at="lhclength-(-1043.8657+(-112-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242559.0, assembly_id=102266.0))
lhcb2.new("mco.a23l2.b2", "mco", at="lhclength-(-1043.1157+(-112-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249844.0, assembly_id=102267.0))
lhcb2.new("mcd.a23l2.b2", "mcd", at="lhclength-(-1043.1142+(-112-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249845.0, assembly_id=102267.0))
lhcb2.new("mb.a23l2.b2", "mb", at="lhclength-(-1035.6297+(-112.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822954.0, assembly_id=102267.0))
lhcb2.new("mcs.a23l2.b2", "mcs", at="lhclength-(-1028.2057+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242564.0, assembly_id=102267.0))
lhcb2.new("bpm.22l2.b2", "bpm", at="lhclength-(-1027.3267+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242566.0, assembly_id=102268.0))
lhcb2.new("mo.22l2.b2", "mo", at="lhclength-(-1026.5757+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2309038.0, assembly_id=102268.0))
lhcb2.new("mq.22l2.b2", "mq", at="lhclength-(-1024.5647+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308272.0, assembly_id=102268.0))
lhcb2.new("ms.22l2.b2", "ms", at="lhclength-(-1022.6697+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249847.0, assembly_id=102268.0))
lhcb2.new("mcbh.22l2.b2", "mcbh", at="lhclength-(-1022.0767+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249849.0, assembly_id=102268.0))
lhcb2.new("mb.c22l2.b2", "mb", at="lhclength-(-1013.4997+(-113.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52822978.0, assembly_id=102269.0))
lhcb2.new("mcs.c22l2.b2", "mcs", at="lhclength-(-1006.0757+(-114-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242572.0, assembly_id=102269.0))
lhcb2.new("mco.22l2.b2", "mco", at="lhclength-(-1005.3257+(-114-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249852.0, assembly_id=102270.0))
lhcb2.new("mcd.22l2.b2", "mcd", at="lhclength-(-1005.3242+(-114-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249853.0, assembly_id=102270.0))
lhcb2.new("mb.b22l2.b2", "mb", at="lhclength-(-997.8397+(-114.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823002.0, assembly_id=102270.0))
lhcb2.new("mcs.b22l2.b2", "mcs", at="lhclength-(-990.4157+(-115-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242577.0, assembly_id=102270.0))
lhcb2.new("mb.a22l2.b2", "mb", at="lhclength-(-982.1797+(-115.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823026.0, assembly_id=102271.0))
lhcb2.new("mcs.a22l2.b2", "mcs", at="lhclength-(-974.7557+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242580.0, assembly_id=102271.0))
lhcb2.new("bpm.21l2.b2", "bpm", at="lhclength-(-973.8767+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242582.0, assembly_id=102272.0))
lhcb2.new("mqt.21l2.b2", "mqt", at="lhclength-(-973.1227+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307489.0, assembly_id=102272.0))
lhcb2.new("mq.21l2.b2", "mq", at="lhclength-(-971.1147+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308241.0, assembly_id=102272.0))
lhcb2.new("ms.21l2.b2", "ms", at="lhclength-(-969.2197+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249855.0, assembly_id=102272.0))
lhcb2.new("mcbv.21l2.b2", "mcbv", at="lhclength-(-968.6267+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249857.0, assembly_id=102272.0))
lhcb2.new("mco.b21l2.b2", "mco", at="lhclength-(-967.5357+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249860.0, assembly_id=102273.0))
lhcb2.new("mcd.b21l2.b2", "mcd", at="lhclength-(-967.5342+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249861.0, assembly_id=102273.0))
lhcb2.new("mb.c21l2.b2", "mb", at="lhclength-(-960.0497+(-116.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823050.0, assembly_id=102273.0))
lhcb2.new("mcs.c21l2.b2", "mcs", at="lhclength-(-952.6257+(-117-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242590.0, assembly_id=102273.0))
lhcb2.new("mb.b21l2.b2", "mb", at="lhclength-(-944.3897+(-117.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823074.0, assembly_id=102274.0))
lhcb2.new("mcs.b21l2.b2", "mcs", at="lhclength-(-936.9657+(-118-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242593.0, assembly_id=102274.0))
lhcb2.new("mco.a21l2.b2", "mco", at="lhclength-(-936.2157+(-118-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249864.0, assembly_id=102275.0))
lhcb2.new("mcd.a21l2.b2", "mcd", at="lhclength-(-936.2142+(-118-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249865.0, assembly_id=102275.0))
lhcb2.new("mb.a21l2.b2", "mb", at="lhclength-(-928.7297+(-118.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823098.0, assembly_id=102275.0))
lhcb2.new("mcs.a21l2.b2", "mcs", at="lhclength-(-921.3057+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242598.0, assembly_id=102275.0))
lhcb2.new("bpm.20l2.b2", "bpm", at="lhclength-(-920.4267+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242600.0, assembly_id=102276.0))
lhcb2.new("mqt.20l2.b2", "mqt", at="lhclength-(-919.6727+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307459.0, assembly_id=102276.0))
lhcb2.new("mq.20l2.b2", "mq", at="lhclength-(-917.6647+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308211.0, assembly_id=102276.0))
lhcb2.new("ms.20l2.b2", "ms", at="lhclength-(-915.7697+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249867.0, assembly_id=102276.0))
lhcb2.new("mcbh.20l2.b2", "mcbh", at="lhclength-(-915.1767+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249869.0, assembly_id=102276.0))
lhcb2.new("mb.c20l2.b2", "mb", at="lhclength-(-906.5997+(-119.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823122.0, assembly_id=102277.0))
lhcb2.new("mcs.c20l2.b2", "mcs", at="lhclength-(-899.1757+(-120-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242606.0, assembly_id=102277.0))
lhcb2.new("mco.20l2.b2", "mco", at="lhclength-(-898.4257+(-120-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249872.0, assembly_id=102278.0))
lhcb2.new("mcd.20l2.b2", "mcd", at="lhclength-(-898.4242+(-120-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249873.0, assembly_id=102278.0))
lhcb2.new("mb.b20l2.b2", "mb", at="lhclength-(-890.9397+(-120.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823146.0, assembly_id=102278.0))
lhcb2.new("mcs.b20l2.b2", "mcs", at="lhclength-(-883.5157+(-121-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242611.0, assembly_id=102278.0))
lhcb2.new("mb.a20l2.b2", "mb", at="lhclength-(-875.2797+(-121.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823170.0, assembly_id=102279.0))
lhcb2.new("mcs.a20l2.b2", "mcs", at="lhclength-(-867.8557+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242614.0, assembly_id=102279.0))
lhcb2.new("bpm.19l2.b2", "bpm", at="lhclength-(-866.9767+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242616.0, assembly_id=102280.0))
lhcb2.new("mqt.19l2.b2", "mqt", at="lhclength-(-866.2227+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307430.0, assembly_id=102280.0))
lhcb2.new("mq.19l2.b2", "mq", at="lhclength-(-864.2147+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308419.0, assembly_id=102280.0))
lhcb2.new("ms.19l2.b2", "ms", at="lhclength-(-862.3197+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249875.0, assembly_id=102280.0))
lhcb2.new("mcbv.19l2.b2", "mcbv", at="lhclength-(-861.7267+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249877.0, assembly_id=102280.0))
lhcb2.new("mco.b19l2.b2", "mco", at="lhclength-(-860.6357+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249880.0, assembly_id=102281.0))
lhcb2.new("mcd.b19l2.b2", "mcd", at="lhclength-(-860.6342+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249881.0, assembly_id=102281.0))
lhcb2.new("mb.c19l2.b2", "mb", at="lhclength-(-853.1497+(-122.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823194.0, assembly_id=102281.0))
lhcb2.new("mcs.c19l2.b2", "mcs", at="lhclength-(-845.7257+(-123-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242624.0, assembly_id=102281.0))
lhcb2.new("mb.b19l2.b2", "mb", at="lhclength-(-837.4897+(-123.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823218.0, assembly_id=102282.0))
lhcb2.new("mcs.b19l2.b2", "mcs", at="lhclength-(-830.0657+(-124-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242627.0, assembly_id=102282.0))
lhcb2.new("mco.a19l2.b2", "mco", at="lhclength-(-829.3157+(-124-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249884.0, assembly_id=102283.0))
lhcb2.new("mcd.a19l2.b2", "mcd", at="lhclength-(-829.3142+(-124-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249885.0, assembly_id=102283.0))
lhcb2.new("mb.a19l2.b2", "mb", at="lhclength-(-821.8297+(-124.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823242.0, assembly_id=102283.0))
lhcb2.new("mcs.a19l2.b2", "mcs", at="lhclength-(-814.4057+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242632.0, assembly_id=102283.0))
lhcb2.new("bpm.18l2.b2", "bpm", at="lhclength-(-813.5267+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242634.0, assembly_id=102284.0))
lhcb2.new("mqt.18l2.b2", "mqt", at="lhclength-(-812.7727+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307398.0, assembly_id=102284.0))
lhcb2.new("mq.18l2.b2", "mq", at="lhclength-(-810.7647+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308388.0, assembly_id=102284.0))
lhcb2.new("ms.18l2.b2", "ms", at="lhclength-(-808.8697+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249887.0, assembly_id=102284.0))
lhcb2.new("mcbh.18l2.b2", "mcbh", at="lhclength-(-808.2767+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249889.0, assembly_id=102284.0))
lhcb2.new("mb.c18l2.b2", "mb", at="lhclength-(-799.6997+(-125.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823266.0, assembly_id=102285.0))
lhcb2.new("mcs.c18l2.b2", "mcs", at="lhclength-(-792.2757+(-126-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242640.0, assembly_id=102285.0))
lhcb2.new("mco.18l2.b2", "mco", at="lhclength-(-791.5257+(-126-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249892.0, assembly_id=102286.0))
lhcb2.new("mcd.18l2.b2", "mcd", at="lhclength-(-791.5242+(-126-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249893.0, assembly_id=102286.0))
lhcb2.new("mb.b18l2.b2", "mb", at="lhclength-(-784.0397+(-126.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823290.0, assembly_id=102286.0))
lhcb2.new("mcs.b18l2.b2", "mcs", at="lhclength-(-776.6157+(-127-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242645.0, assembly_id=102286.0))
lhcb2.new("mb.a18l2.b2", "mb", at="lhclength-(-768.3797+(-127.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823314.0, assembly_id=102287.0))
lhcb2.new("mcs.a18l2.b2", "mcs", at="lhclength-(-760.9557+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242648.0, assembly_id=102287.0))
lhcb2.new("bpm.17l2.b2", "bpm", at="lhclength-(-760.0767+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242650.0, assembly_id=102288.0))
lhcb2.new("mqt.17l2.b2", "mqt", at="lhclength-(-759.3227+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307603.0, assembly_id=102288.0))
lhcb2.new("mq.17l2.b2", "mq", at="lhclength-(-757.3147+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308358.0, assembly_id=102288.0))
lhcb2.new("ms.17l2.b2", "ms", at="lhclength-(-755.4197+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249895.0, assembly_id=102288.0))
lhcb2.new("mcbv.17l2.b2", "mcbv", at="lhclength-(-754.8267+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249897.0, assembly_id=102288.0))
lhcb2.new("mco.b17l2.b2", "mco", at="lhclength-(-753.7357+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249900.0, assembly_id=102289.0))
lhcb2.new("mcd.b17l2.b2", "mcd", at="lhclength-(-753.7342+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249901.0, assembly_id=102289.0))
lhcb2.new("mb.c17l2.b2", "mb", at="lhclength-(-746.2497+(-128.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823338.0, assembly_id=102289.0))
lhcb2.new("mcs.c17l2.b2", "mcs", at="lhclength-(-738.8257+(-129-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242658.0, assembly_id=102289.0))
lhcb2.new("mb.b17l2.b2", "mb", at="lhclength-(-730.5897+(-129.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823362.0, assembly_id=102290.0))
lhcb2.new("mcs.b17l2.b2", "mcs", at="lhclength-(-723.1657+(-130-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242661.0, assembly_id=102290.0))
lhcb2.new("mco.a17l2.b2", "mco", at="lhclength-(-722.4157+(-130-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249904.0, assembly_id=102291.0))
lhcb2.new("mcd.a17l2.b2", "mcd", at="lhclength-(-722.4142+(-130-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249905.0, assembly_id=102291.0))
lhcb2.new("mb.a17l2.b2", "mb", at="lhclength-(-714.9297+(-130.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823386.0, assembly_id=102291.0))
lhcb2.new("mcs.a17l2.b2", "mcs", at="lhclength-(-707.5057+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242666.0, assembly_id=102291.0))
lhcb2.new("bpm.16l2.b2", "bpm", at="lhclength-(-706.6267+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242668.0, assembly_id=102292.0))
lhcb2.new("mqt.16l2.b2", "mqt", at="lhclength-(-705.8727+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307573.0, assembly_id=102292.0))
lhcb2.new("mq.16l2.b2", "mq", at="lhclength-(-703.8647+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308328.0, assembly_id=102292.0))
lhcb2.new("ms.16l2.b2", "ms", at="lhclength-(-701.9697+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249907.0, assembly_id=102292.0))
lhcb2.new("mcbh.16l2.b2", "mcbh", at="lhclength-(-701.3767+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249909.0, assembly_id=102292.0))
lhcb2.new("mb.c16l2.b2", "mb", at="lhclength-(-692.7997+(-131.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823410.0, assembly_id=102293.0))
lhcb2.new("mcs.c16l2.b2", "mcs", at="lhclength-(-685.3757+(-132-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242674.0, assembly_id=102293.0))
lhcb2.new("mco.16l2.b2", "mco", at="lhclength-(-684.6257+(-132-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249912.0, assembly_id=102294.0))
lhcb2.new("mcd.16l2.b2", "mcd", at="lhclength-(-684.6242+(-132-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249913.0, assembly_id=102294.0))
lhcb2.new("mb.b16l2.b2", "mb", at="lhclength-(-677.1397+(-132.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823434.0, assembly_id=102294.0))
lhcb2.new("mcs.b16l2.b2", "mcs", at="lhclength-(-669.7157+(-133-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242679.0, assembly_id=102294.0))
lhcb2.new("mb.a16l2.b2", "mb", at="lhclength-(-661.4797+(-133.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823458.0, assembly_id=102295.0))
lhcb2.new("mcs.a16l2.b2", "mcs", at="lhclength-(-654.0557+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242682.0, assembly_id=102295.0))
lhcb2.new("bpm.15l2.b2", "bpm", at="lhclength-(-653.1767+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242684.0, assembly_id=102296.0))
lhcb2.new("mqt.15l2.b2", "mqt", at="lhclength-(-652.4227+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307542.0, assembly_id=102296.0))
lhcb2.new("mq.15l2.b2", "mq", at="lhclength-(-650.4147+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308535.0, assembly_id=102296.0))
lhcb2.new("ms.15l2.b2", "ms", at="lhclength-(-648.5197+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249915.0, assembly_id=102296.0))
lhcb2.new("mcbv.15l2.b2", "mcbv", at="lhclength-(-647.9267+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249917.0, assembly_id=102296.0))
lhcb2.new("mco.b15l2.b2", "mco", at="lhclength-(-646.8357+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249920.0, assembly_id=102297.0))
lhcb2.new("mcd.b15l2.b2", "mcd", at="lhclength-(-646.8342+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249921.0, assembly_id=102297.0))
lhcb2.new("mb.c15l2.b2", "mb", at="lhclength-(-639.3497+(-134.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823482.0, assembly_id=102297.0))
lhcb2.new("mcs.c15l2.b2", "mcs", at="lhclength-(-631.9257+(-135-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242692.0, assembly_id=102297.0))
lhcb2.new("mb.b15l2.b2", "mb", at="lhclength-(-623.6897+(-135.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823506.0, assembly_id=102298.0))
lhcb2.new("mcs.b15l2.b2", "mcs", at="lhclength-(-616.2657+(-136-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242695.0, assembly_id=102298.0))
lhcb2.new("mco.a15l2.b2", "mco", at="lhclength-(-615.5157+(-136-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249924.0, assembly_id=102299.0))
lhcb2.new("mcd.a15l2.b2", "mcd", at="lhclength-(-615.5142+(-136-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249925.0, assembly_id=102299.0))
lhcb2.new("mb.a15l2.b2", "mb", at="lhclength-(-608.0297+(-136.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823530.0, assembly_id=102299.0))
lhcb2.new("mcs.a15l2.b2", "mcs", at="lhclength-(-600.6057+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242700.0, assembly_id=102299.0))
lhcb2.new("bpm.14l2.b2", "bpm", at="lhclength-(-599.7267+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242702.0, assembly_id=102300.0))
lhcb2.new("mqt.14l2.b2", "mqt", at="lhclength-(-598.9727+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307510.0, assembly_id=102300.0))
lhcb2.new("mq.14l2.b2", "mq", at="lhclength-(-596.9647+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308505.0, assembly_id=102300.0))
lhcb2.new("ms.14l2.b2", "ms", at="lhclength-(-595.0697+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249927.0, assembly_id=102300.0))
lhcb2.new("mcbh.14l2.b2", "mcbh", at="lhclength-(-594.4767+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249929.0, assembly_id=102300.0))
lhcb2.new("mb.c14l2.b2", "mb", at="lhclength-(-585.8997+(-137.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823554.0, assembly_id=102301.0))
lhcb2.new("mcs.c14l2.b2", "mcs", at="lhclength-(-578.4757+(-138-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242708.0, assembly_id=102301.0))
lhcb2.new("mco.14l2.b2", "mco", at="lhclength-(-577.7257+(-138-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249932.0, assembly_id=102302.0))
lhcb2.new("mcd.14l2.b2", "mcd", at="lhclength-(-577.7242+(-138-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249933.0, assembly_id=102302.0))
lhcb2.new("mb.b14l2.b2", "mb", at="lhclength-(-570.2397+(-138.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823578.0, assembly_id=102302.0))
lhcb2.new("mcs.b14l2.b2", "mcs", at="lhclength-(-562.8157+(-139-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242713.0, assembly_id=102302.0))
lhcb2.new("mb.a14l2.b2", "mb", at="lhclength-(-554.5797+(-139.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823602.0, assembly_id=102303.0))
lhcb2.new("mcs.a14l2.b2", "mcs", at="lhclength-(-547.1557+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242716.0, assembly_id=102303.0))
lhcb2.new("s.ds.l2.b2", "omk", at="lhclength-(-546.7497+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.13l2.b2", "bpm", at="lhclength-(-546.2767+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242718.0, assembly_id=102304.0))
lhcb2.new("mqt.13l2.b2", "mqt", at="lhclength-(-545.5227+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307718.0, assembly_id=102304.0))
lhcb2.new("mq.13l2.b2", "mq", at="lhclength-(-543.5147+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308475.0, assembly_id=102304.0))
lhcb2.new("ms.13l2.b2", "ms", at="lhclength-(-541.6197+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249935.0, assembly_id=102304.0))
lhcb2.new("mcbv.13l2.b2", "mcbv", at="lhclength-(-541.0267+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249937.0, assembly_id=102304.0))
lhcb2.new("mco.b13l2.b2", "mco", at="lhclength-(-539.9357+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249940.0, assembly_id=102305.0))
lhcb2.new("mcd.b13l2.b2", "mcd", at="lhclength-(-539.9342+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249941.0, assembly_id=102305.0))
lhcb2.new("mb.c13l2.b2", "mb", at="lhclength-(-532.4497+(-140.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823626.0, assembly_id=102305.0))
lhcb2.new("mcs.c13l2.b2", "mcs", at="lhclength-(-525.0257+(-141-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242726.0, assembly_id=102305.0))
lhcb2.new("mb.b13l2.b2", "mb", at="lhclength-(-516.7897+(-141.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823650.0, assembly_id=102306.0))
lhcb2.new("mcs.b13l2.b2", "mcs", at="lhclength-(-509.3657+(-142-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242729.0, assembly_id=102306.0))
lhcb2.new("mco.a13l2.b2", "mco", at="lhclength-(-508.6157+(-142-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249944.0, assembly_id=102307.0))
lhcb2.new("mcd.a13l2.b2", "mcd", at="lhclength-(-508.6142+(-142-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249945.0, assembly_id=102307.0))
lhcb2.new("mb.a13l2.b2", "mb", at="lhclength-(-501.1297+(-142.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823674.0, assembly_id=102307.0))
lhcb2.new("mcs.a13l2.b2", "mcs", at="lhclength-(-493.7057+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242734.0, assembly_id=102307.0))
lhcb2.new("bpm.12l2.b2", "bpm", at="lhclength-(-492.8267+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242736.0, assembly_id=102308.0))
lhcb2.new("mqt.12l2.b2", "mqt", at="lhclength-(-492.0727+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307686.0, assembly_id=102308.0))
lhcb2.new("mq.12l2.b2", "mq", at="lhclength-(-490.0647+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308682.0, assembly_id=102308.0))
lhcb2.new("ms.12l2.b2", "ms", at="lhclength-(-488.1697+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249947.0, assembly_id=102308.0))
lhcb2.new("mcbh.12l2.b2", "mcbh", at="lhclength-(-487.5767+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249949.0, assembly_id=102308.0))
lhcb2.new("mb.c12l2.b2", "mb", at="lhclength-(-478.9997+(-143.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823698.0, assembly_id=102309.0))
lhcb2.new("mcs.c12l2.b2", "mcs", at="lhclength-(-471.5757+(-144-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242742.0, assembly_id=102309.0))
lhcb2.new("mco.12l2.b2", "mco", at="lhclength-(-470.8257+(-144-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249952.0, assembly_id=102310.0))
lhcb2.new("mcd.12l2.b2", "mcd", at="lhclength-(-470.8242+(-144-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249953.0, assembly_id=102310.0))
lhcb2.new("mb.b12l2.b2", "mb", at="lhclength-(-463.3397+(-144.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823722.0, assembly_id=102310.0))
lhcb2.new("mcs.b12l2.b2", "mcs", at="lhclength-(-455.9157+(-145-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242747.0, assembly_id=102310.0))
lhcb2.new("mb.a12l2.b2", "mb", at="lhclength-(-447.6797+(-145.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823746.0, assembly_id=102311.0))
lhcb2.new("mcs.a12l2.b2", "mcs", at="lhclength-(-440.2557+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242750.0, assembly_id=102311.0))
lhcb2.new("e.arc.12.b2", "omk", at="lhclength-(-439.8497+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.11l2.b2", "bpm", at="lhclength-(-439.3767+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242752.0, assembly_id=102312.0))
lhcb2.new("mq.11l2.b2", "mq", at="lhclength-(-436.8297+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2308652.0, assembly_id=102312.0))
lhcb2.new("mqtli.11l2.b2", "mqtli", at="lhclength-(-434.4607+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307340.0, assembly_id=102312.0))
lhcb2.new("ms.11l2.b2", "ms", at="lhclength-(-433.4487+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249955.0, assembly_id=102312.0))
lhcb2.new("mcbv.11l2.b2", "mcbv", at="lhclength-(-432.8557+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249957.0, assembly_id=102312.0))
lhcb2.new("leprb.11l2.b2", "leprb", at="lhclength-(-429.450025+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52998174.0, assembly_id=43344242.0))
lhcb2.new("bptdh.a11l2.b2", "bptdh", at="lhclength-(-426.07035+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52697748.0, assembly_id=43347335.0))
lhcb2.new("tcld.a11l2.b2", "tcld", at="lhclength-(-425.71735+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52506114.0, assembly_id=43347335.0))
lhcb2.new("bptuh.a11l2.b2", "bptuh", at="lhclength-(-425.36435+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52697739.0, assembly_id=43347335.0))
lhcb2.new("lepra.11l2.b2", "lepra", at="lhclength-(-421.984675+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52998150.0, assembly_id=43347323.0))
lhcb2.new("mco.11l2.b2", "mco", at="lhclength-(-418.986+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249960.0, assembly_id=102314.0))
lhcb2.new("mcd.11l2.b2", "mcd", at="lhclength-(-418.9845+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249961.0, assembly_id=102314.0))
lhcb2.new("mb.b11l2.b2", "mb", at="lhclength-(-411.5+(-146.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823770.0, assembly_id=102314.0))
lhcb2.new("mcs.b11l2.b2", "mcs", at="lhclength-(-404.076+(-147-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242760.0, assembly_id=102314.0))
lhcb2.new("mb.a11l2.b2", "mb", at="lhclength-(-395.84+(-147.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52849426.0, assembly_id=102315.0))
lhcb2.new("mcs.a11l2.b2", "mcs", at="lhclength-(-388.416+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=357285.0, assembly_id=102315.0))
lhcb2.new("bpm.10l2.b2", "bpm", at="lhclength-(-387.537+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=377925.0, assembly_id=102316.0))
lhcb2.new("mqml.10l2.b2", "mqml", at="lhclength-(-384.392+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307807.0, assembly_id=102316.0))
lhcb2.new("mcbch.10l2.b2", "mcbch", at="lhclength-(-381.35+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=378095.0, assembly_id=102316.0))
lhcb2.new("mco.10l2.b2", "mco", at="lhclength-(-379.921+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249966.0, assembly_id=102317.0))
lhcb2.new("mcd.10l2.b2", "mcd", at="lhclength-(-379.9195+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249967.0, assembly_id=102317.0))
lhcb2.new("mb.b10l2.b2", "mb", at="lhclength-(-372.435+(-148.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823794.0, assembly_id=102317.0))
lhcb2.new("mcs.b10l2.b2", "mcs", at="lhclength-(-365.011+(-149-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242772.0, assembly_id=102317.0))
lhcb2.new("mb.a10l2.b2", "mb", at="lhclength-(-356.775+(-149.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823818.0, assembly_id=102318.0))
lhcb2.new("mcs.a10l2.b2", "mcs", at="lhclength-(-349.351+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242775.0, assembly_id=102318.0))
lhcb2.new("bpm.9l2.b2", "bpm", at="lhclength-(-348.471+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=377927.0, assembly_id=102319.0))
lhcb2.new("mqmc.9l2.b2", "mqmc", at="lhclength-(-346.495+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307784.0, assembly_id=102319.0))
lhcb2.new("mqm.9l2.b2", "mqm", at="lhclength-(-343.229+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307732.0, assembly_id=102319.0))
lhcb2.new("mcbcv.9l2.b2", "mcbcv", at="lhclength-(-340.888+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=378100.0, assembly_id=102319.0))
lhcb2.new("mco.9l2.b2", "mco", at="lhclength-(-339.456+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249972.0, assembly_id=102320.0))
lhcb2.new("mcd.9l2.b2", "mcd", at="lhclength-(-339.4545+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249973.0, assembly_id=102320.0))
lhcb2.new("mb.b9l2.b2", "mb", at="lhclength-(-331.97+(-150.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823842.0, assembly_id=102320.0))
lhcb2.new("mcs.b9l2.b2", "mcs", at="lhclength-(-324.546+(-151-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242785.0, assembly_id=102320.0))
lhcb2.new("mb.a9l2.b2", "mb", at="lhclength-(-316.31+(-151.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823866.0, assembly_id=102321.0))
lhcb2.new("mcs.a9l2.b2", "mcs", at="lhclength-(-308.886+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242788.0, assembly_id=102321.0))
lhcb2.new("bpm.8l2.b2", "bpm", at="lhclength-(-308.007+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=377933.0, assembly_id=102322.0))
lhcb2.new("mqml.8l2.b2", "mqml", at="lhclength-(-304.862+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307839.0, assembly_id=102322.0))
lhcb2.new("mcbch.8l2.b2", "mcbch", at="lhclength-(-301.82+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=378105.0, assembly_id=102322.0))
lhcb2.new("mco.8l2.b2", "mco", at="lhclength-(-300.391+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249978.0, assembly_id=102323.0))
lhcb2.new("mcd.8l2.b2", "mcd", at="lhclength-(-300.3895+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249979.0, assembly_id=102323.0))
lhcb2.new("mb.b8l2.b2", "mb", at="lhclength-(-292.905+(-152.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52823890.0, assembly_id=102323.0))
lhcb2.new("mcs.b8l2.b2", "mcs", at="lhclength-(-285.481+(-153-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242797.0, assembly_id=102323.0))
lhcb2.new("mb.a8l2.b2", "mb", at="lhclength-(-277.245+(-153.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52849450.0, assembly_id=102324.0))
lhcb2.new("mcs.a8l2.b2", "mcs", at="lhclength-(-269.821+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=357289.0, assembly_id=102324.0))
lhcb2.new("e.ds.l2.b2", "omk", at="lhclength-(-269.415+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.7l2.b2", "bpm", at="lhclength-(-268.94+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242802.0, assembly_id=102325.0))
lhcb2.new("mqm.b7l2.b2", "mqm", at="lhclength-(-266.495+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307769.0, assembly_id=102325.0))
lhcb2.new("mqm.a7l2.b2", "mqm", at="lhclength-(-262.728+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307754.0, assembly_id=102325.0))
lhcb2.new("mcbcv.7l2.b2", "mcbcv", at="lhclength-(-260.387+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249980.0, assembly_id=102325.0))
lhcb2.new("dfbac.7l2.b2", "dfbac", at="lhclength-(-258.2075+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52996599.0, assembly_id=104674.0))
lhcb2.new("mcbch.6l2.b2", "mcbch", at="lhclength-(-246.79+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249983.0, assembly_id=102326.0))
lhcb2.new("mqml.6l2.b2", "mqml", at="lhclength-(-243.748+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307829.0, assembly_id=102326.0))
lhcb2.new("mqm.6l2.b2", "mqm", at="lhclength-(-239.281+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2307956.0, assembly_id=102326.0))
lhcb2.new("bpm.6l2.b2", "bpm", at="lhclength-(-236.834+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=298147.0, assembly_id=102326.0))
lhcb2.new("msib.c6l2.b2", "msib", at="lhclength-(-212.723+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52849963.0, assembly_id=134506.0))
lhcb2.new("msib.b6l2.b2", "msib", at="lhclength-(-208.273+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52849989.0, assembly_id=134507.0))
lhcb2.new("msib.a6l2.b2", "msib", at="lhclength-(-203.823+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52850015.0, assembly_id=134508.0))
lhcb2.new("msia.b6l2.b2", "msia", at="lhclength-(-199.373+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52849859.0, assembly_id=134509.0))
lhcb2.new("msia.a6l2.b2", "msia", at="lhclength-(-194.923+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=52849885.0, assembly_id=134510.0))
lhcb2.new("mcbyv.b5l2.b2", "mcbyv", at="lhclength-(-175.75+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249985.0, assembly_id=102328.0))
lhcb2.new("mcbyh.5l2.b2", "mcbyh", at="lhclength-(-174.604+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249987.0, assembly_id=102328.0))
lhcb2.new("mcbyv.a5l2.b2", "mcbyv", at="lhclength-(-173.457+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249989.0, assembly_id=102328.0))
lhcb2.new("mqy.b5l2.b2", "mqy", at="lhclength-(-171.11+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2302971.0, assembly_id=102328.0))
lhcb2.new("mqy.a5l2.b2", "mqy", at="lhclength-(-167.329+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2302970.0, assembly_id=102328.0))
lhcb2.new("bpmyb.5l2.b2", "bpmyb", at="lhclength-(-164.635+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242817.0, assembly_id=102328.0))
lhcb2.new("bpmyb.4l2.b2", "bpmyb", at="lhclength-(-144.065+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=242819.0, assembly_id=102330.0))
lhcb2.new("mqy.b4l2.b2", "mqy", at="lhclength-(-141.371+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2302981.0, assembly_id=102330.0))
lhcb2.new("mqy.a4l2.b2", "mqy", at="lhclength-(-137.59+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=2302980.0, assembly_id=102330.0))
lhcb2.new("mcbyh.b4l2.b2", "mcbyh", at="lhclength-(-135.243+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249990.0, assembly_id=102330.0))
lhcb2.new("mcbyv.4l2.b2", "mcbyv", at="lhclength-(-134.096+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249992.0, assembly_id=102330.0))
lhcb2.new("mcbyh.a4l2.b2", "mcbyh", at="lhclength-(-132.95+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.194, slot_id=249994.0, assembly_id=102330.0))
lhcb2.new("mbrc.4l2.b2", "mbrc", at="lhclength-(-126.403+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.188, slot_id=52819648.0, assembly_id=102331.0))
lhcb2.new("bpmwb.4l2.b2", "bpmwb", at="lhclength-(-119.6735+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.174, slot_id=181635.0))
lhcb2.new("x2zdc.4l2", "x2zdc001", at="lhclength-(-113.3245+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=102332.0))
lhcb2.new("branc.4l2", "branc", at="lhclength-(-111.5104+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=55373880.0))
lhcb2.new("btvst.a4l2", "btvst065", at="lhclength-(-85.433+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.08, slot_id=181617.0))
lhcb2.new("tcdd.4l2", "tcdd", at="lhclength-(-71.228+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=102334.0))
lhcb2.new("bpmsx.4l2.b2", "bpmsx003", at="lhclength-(-69.3805+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=-0.0194, slot_id=43068868.0, assembly_id=104598.0))
lhcb2.new("mbx.4l2", "mbx", at="lhclength-(-63.108+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242833.0, assembly_id=102335.0))
lhcb2.new("dfbxc.3l2", "dfbxc", at="lhclength-(-56.3085+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=104675.0))
lhcb2.new("mcosx.3l2", "mcosx_unplugged", at="lhclength-(-54.297+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282240.0, assembly_id=102336.0))
lhcb2.new("mcox.3l2", "mcox_unplugged", at="lhclength-(-54.297+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282239.0, assembly_id=102336.0))
lhcb2.new("mcssx.3l2", "mcssx_unplugged", at="lhclength-(-54.297+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282238.0, assembly_id=102336.0))
lhcb2.new("mcbxh.3l2", "mcbxh", at="lhclength-(-53.814+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=249996.0, assembly_id=102336.0))
lhcb2.new("mcbxv.3l2", "mcbxv", at="lhclength-(-53.814+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=249997.0, assembly_id=102336.0))
lhcb2.new("mcsx.3l2", "mcsx", at="lhclength-(-53.814+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=249998.0, assembly_id=102336.0))
lhcb2.new("mctx.3l2", "mctx", at="lhclength-(-53.814+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=249999.0, assembly_id=102336.0))
lhcb2.new("mqxa.3l2", "mqxa", at="lhclength-(-50.15+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242835.0, assembly_id=102336.0))
lhcb2.new("mqsx.3l2", "mqsx", at="lhclength-(-46.608+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282128.0, assembly_id=102336.0))
lhcb2.new("mqxb.b2l2", "mqxb", at="lhclength-(-41.3+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242837.0, assembly_id=102337.0))
lhcb2.new("mcbxh.2l2", "mcbxh", at="lhclength-(-38.019+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250004.0, assembly_id=102337.0))
lhcb2.new("mcbxv.2l2", "mcbxv", at="lhclength-(-38.019+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250005.0, assembly_id=102337.0))
lhcb2.new("mqxb.a2l2", "mqxb", at="lhclength-(-34.8+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242839.0, assembly_id=102337.0))
lhcb2.new("bpms.2l2.b2", "bpms_003", at="lhclength-(-31.529+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=43068883.0, assembly_id=102337.0))
lhcb2.new("mcbxh.1l2", "mcbxh_unplugged", at="lhclength-(-29.842+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250006.0, assembly_id=102338.0))
lhcb2.new("mcbxv.1l2", "mcbxv", at="lhclength-(-29.842+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250007.0, assembly_id=102338.0))
lhcb2.new("mqxa.1l2", "mqxa", at="lhclength-(-26.15+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242842.0, assembly_id=102338.0))
lhcb2.new("bpmsw.1l2.b2", "bpmsw002", at="lhclength-(-21.595+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=10428872.0, assembly_id=104599.0))
lhcb2.new("bpmsw.1l2.b2_doros", "bpmsw002", at="lhclength-(-21.595+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=12907567.0, assembly_id=104599.0))
lhcb2.new("mbxwt.1l2", "mbxwt", at="lhclength-(-20.49+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=103994.0))
lhcb2.new("mbwmd.1l2", "mbwmd", at="lhclength-(-10.75+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242845.0))
lhcb2.new("mbls2.1l2", "mbls2", at="lhclength-(-3.025+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=52895785.0, assembly_id=2212849.0))
lhcb2.new("ip2", "omk", at="lhclength-(pip2+ip2ofs.b2*ds)")
lhcb2.new("mbls2.1r2", "mbls2", at="lhclength-(3.025+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=52895804.0, assembly_id=2212849.0))
lhcb2.new("mbaw.1r2", "mbaw", at="lhclength-(9.75+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=104000.0))
lhcb2.new("mbxwt.1r2", "mbxwt", at="lhclength-(20.49+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=103996.0))
lhcb2.new("bpmsw.1r2.b2", "bpmsw002", at="lhclength-(21.595+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=10428866.0, assembly_id=104600.0))
lhcb2.new("bpmsw.1r2.b2_doros", "bpmsw002", at="lhclength-(21.595+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=12907559.0, assembly_id=104600.0))
lhcb2.new("mqxa.1r2", "mqxa", at="lhclength-(26.15+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242848.0, assembly_id=102339.0))
lhcb2.new("mcbxh.1r2", "mcbxh", at="lhclength-(29.842+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250008.0, assembly_id=102339.0))
lhcb2.new("mcbxv.1r2", "mcbxv", at="lhclength-(29.842+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250009.0, assembly_id=102339.0))
lhcb2.new("bpms.2r2.b2", "bpms_003", at="lhclength-(31.529+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=43068879.0, assembly_id=102340.0))
lhcb2.new("mqxb.a2r2", "mqxb", at="lhclength-(34.8+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242851.0, assembly_id=102340.0))
lhcb2.new("mcbxh.2r2", "mcbxh", at="lhclength-(38.019+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250010.0, assembly_id=102340.0))
lhcb2.new("mcbxv.2r2", "mcbxv", at="lhclength-(38.019+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250011.0, assembly_id=102340.0))
lhcb2.new("mqxb.b2r2", "mqxb", at="lhclength-(41.3+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242853.0, assembly_id=102340.0))
lhcb2.new("mqsx.3r2", "mqsx", at="lhclength-(46.608+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282129.0, assembly_id=102341.0))
lhcb2.new("mqxa.3r2", "mqxa", at="lhclength-(50.15+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242855.0, assembly_id=102341.0))
lhcb2.new("mcbxh.3r2", "mcbxh", at="lhclength-(53.814+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250016.0, assembly_id=102341.0))
lhcb2.new("mcbxv.3r2", "mcbxv", at="lhclength-(53.814+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250017.0, assembly_id=102341.0))
lhcb2.new("mcsx.3r2", "mcsx", at="lhclength-(53.814+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250018.0, assembly_id=102341.0))
lhcb2.new("mctx.3r2", "mctx", at="lhclength-(53.814+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=250019.0, assembly_id=102341.0))
lhcb2.new("mcosx.3r2", "mcosx", at="lhclength-(54.297+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282243.0, assembly_id=102341.0))
lhcb2.new("mcox.3r2", "mcox", at="lhclength-(54.297+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282242.0, assembly_id=102341.0))
lhcb2.new("mcssx.3r2", "mcssx", at="lhclength-(54.297+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=282241.0, assembly_id=102341.0))
lhcb2.new("dfbxd.3r2", "dfbxd", at="lhclength-(56.3085+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=104676.0))
lhcb2.new("mbx.4r2", "mbx", at="lhclength-(63.108+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=242857.0, assembly_id=102342.0))
lhcb2.new("bpmsx.4r2.b2", "bpmsx003", at="lhclength-(69.5005+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0194, slot_id=43068870.0, assembly_id=104601.0))
lhcb2.new("tclia.4r2", "tclia", at="lhclength-(71.548+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=357146.0))
lhcb2.new("branc.4r2", "branc", at="lhclength-(111.609+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=55373933.0))
lhcb2.new("x2zdc.4r2", "x2zdc002", at="lhclength-(113.3245+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.0, slot_id=102343.0))
lhcb2.new("bptdv.a4r2.b2", "bptdv", at="lhclength-(115.938+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.162, slot_id=10429556.0, assembly_id=5619144.0))
lhcb2.new("tctpv.4r2.b2", "tctpv", at="lhclength-(116.533+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.1637, slot_id=5619144.0))
lhcb2.new("bptuv.a4r2.b2", "bptuv", at="lhclength-(117.128+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.162, slot_id=10429558.0, assembly_id=5619144.0))
lhcb2.new("bptdh.a4r2.b2", "bptdh", at="lhclength-(117.938+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.168, slot_id=10402844.0, assembly_id=377597.0))
lhcb2.new("tctph.4r2.b2", "tctph", at="lhclength-(118.533+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.167, slot_id=377597.0))
lhcb2.new("bptuh.a4r2.b2", "bptuh", at="lhclength-(119.128+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.168, slot_id=10925425.0, assembly_id=377597.0))
lhcb2.new("bpmwb.4r2.b2", "bpmwb", at="lhclength-(119.5975+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.174, slot_id=181636.0))
lhcb2.new("mbrc.4r2.b2", "mbrc", at="lhclength-(126.403+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.188, slot_id=52819671.0, assembly_id=102344.0))
lhcb2.new("mcbyv.a4r2.b2", "mcbyv", at="lhclength-(132.95+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250020.0, assembly_id=102345.0))
lhcb2.new("mcbyh.4r2.b2", "mcbyh", at="lhclength-(134.096+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250022.0, assembly_id=102345.0))
lhcb2.new("mcbyv.b4r2.b2", "mcbyv", at="lhclength-(135.243+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250024.0, assembly_id=102345.0))
lhcb2.new("mqy.a4r2.b2", "mqy", at="lhclength-(137.59+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2303163.0, assembly_id=102345.0))
lhcb2.new("mqy.b4r2.b2", "mqy", at="lhclength-(141.371+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2303162.0, assembly_id=102345.0))
lhcb2.new("bpmyb.4r2.b2", "bpmyb", at="lhclength-(144.065+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242869.0, assembly_id=102345.0))
lhcb2.new("bptx.5r2.b2", "bptx", at="lhclength-(145.2855+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=104666.0))
lhcb2.new("mcbch.a5r2.b2", "mcbch", at="lhclength-(162.689+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=298306.0, assembly_id=102346.0))
lhcb2.new("mcbcv.5r2.b2", "mcbcv", at="lhclength-(163.836+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=298307.0, assembly_id=102346.0))
lhcb2.new("mcbch.b5r2.b2", "mcbch", at="lhclength-(164.982+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=298310.0, assembly_id=102346.0))
lhcb2.new("mqm.a5r2.b2", "mqm", at="lhclength-(167.329+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2303031.0, assembly_id=102346.0))
lhcb2.new("mqm.b5r2.b2", "mqm", at="lhclength-(171.11+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2303030.0, assembly_id=102346.0))
lhcb2.new("bpm.5r2.b2", "bpm", at="lhclength-(173.599+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=298148.0, assembly_id=102346.0))
lhcb2.new("tclim.6r2.b2", "tclim", at="lhclength-(234.399+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52998860.0, assembly_id=357147.0))
lhcb2.new("mcbcv.6r2.b2", "mcbcv", at="lhclength-(236.939+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250032.0, assembly_id=102348.0))
lhcb2.new("mqml.6r2.b2", "mqml", at="lhclength-(239.981+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307833.0, assembly_id=102348.0))
lhcb2.new("mqm.6r2.b2", "mqm", at="lhclength-(244.448+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307960.0, assembly_id=102348.0))
lhcb2.new("bpmr.6r2.b2", "bpmr", at="lhclength-(246.895+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242882.0, assembly_id=102348.0))
lhcb2.new("dfbad.7r2.b2", "dfbad", at="lhclength-(257.9575+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52996623.0, assembly_id=104677.0))
lhcb2.new("bpm_a.7r2.b2", "bpm_a", at="lhclength-(259.77+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=377942.0, assembly_id=102350.0))
lhcb2.new("mqm.a7r2.b2", "mqm", at="lhclength-(262.215+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307762.0, assembly_id=102350.0))
lhcb2.new("mqm.b7r2.b2", "mqm", at="lhclength-(265.982+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307777.0, assembly_id=102350.0))
lhcb2.new("mcbch.7r2.b2", "mcbch", at="lhclength-(268.323+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250035.0, assembly_id=102350.0))
lhcb2.new("s.ds.r2.b2", "omk", at="lhclength-(269.415+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(slot_id=100932.0))
lhcb2.new("mco.8r2.b2", "mco", at="lhclength-(269.759+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250036.0, assembly_id=102351.0))
lhcb2.new("mcd.8r2.b2", "mcd", at="lhclength-(269.7605+(-154-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250037.0, assembly_id=102351.0))
lhcb2.new("mb.a8r2.b2", "mb", at="lhclength-(277.245+(-153.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823914.0, assembly_id=102351.0))
lhcb2.new("mcs.a8r2.b2", "mcs", at="lhclength-(284.669+(-153-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242893.0, assembly_id=102351.0))
lhcb2.new("mb.b8r2.b2", "mb", at="lhclength-(292.905+(-152.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823938.0, assembly_id=102352.0))
lhcb2.new("mcs.b8r2.b2", "mcs", at="lhclength-(300.329+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242896.0, assembly_id=102352.0))
lhcb2.new("bpm.8r2.b2", "bpm", at="lhclength-(301.208+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242898.0, assembly_id=102353.0))
lhcb2.new("mqml.8r2.b2", "mqml", at="lhclength-(304.353+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307612.0, assembly_id=102353.0))
lhcb2.new("mcbcv.8r2.b2", "mcbcv", at="lhclength-(307.395+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250041.0, assembly_id=102353.0))
lhcb2.new("mco.9r2.b2", "mco", at="lhclength-(308.824+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250042.0, assembly_id=102354.0))
lhcb2.new("mcd.9r2.b2", "mcd", at="lhclength-(308.8255+(-152-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250043.0, assembly_id=102354.0))
lhcb2.new("mb.a9r2.b2", "mb", at="lhclength-(316.31+(-151.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823962.0, assembly_id=102354.0))
lhcb2.new("mcs.a9r2.b2", "mcs", at="lhclength-(323.734+(-151-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242905.0, assembly_id=102354.0))
lhcb2.new("mb.b9r2.b2", "mb", at="lhclength-(331.97+(-150.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52823986.0, assembly_id=102355.0))
lhcb2.new("mcs.b9r2.b2", "mcs", at="lhclength-(339.394+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242908.0, assembly_id=102355.0))
lhcb2.new("bpm.9r2.b2", "bpm", at="lhclength-(340.274+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242910.0, assembly_id=102356.0))
lhcb2.new("mqmc.9r2.b2", "mqmc", at="lhclength-(342.25+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307795.0, assembly_id=102356.0))
lhcb2.new("mqm.9r2.b2", "mqm", at="lhclength-(345.516+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307743.0, assembly_id=102356.0))
lhcb2.new("mcbch.9r2.b2", "mcbch", at="lhclength-(347.857+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250047.0, assembly_id=102356.0))
lhcb2.new("mco.10r2.b2", "mco", at="lhclength-(349.289+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250048.0, assembly_id=102357.0))
lhcb2.new("mcd.10r2.b2", "mcd", at="lhclength-(349.2905+(-150-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250049.0, assembly_id=102357.0))
lhcb2.new("mb.a10r2.b2", "mb", at="lhclength-(356.775+(-149.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824010.0, assembly_id=102357.0))
lhcb2.new("mcs.a10r2.b2", "mcs", at="lhclength-(364.199+(-149-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242918.0, assembly_id=102357.0))
lhcb2.new("mb.b10r2.b2", "mb", at="lhclength-(372.435+(-148.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824034.0, assembly_id=102358.0))
lhcb2.new("mcs.b10r2.b2", "mcs", at="lhclength-(379.859+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242921.0, assembly_id=102358.0))
lhcb2.new("bpm.10r2.b2", "bpm", at="lhclength-(380.738+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242923.0, assembly_id=102359.0))
lhcb2.new("mqml.10r2.b2", "mqml", at="lhclength-(383.883+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307819.0, assembly_id=102359.0))
lhcb2.new("mcbcv.10r2.b2", "mcbcv", at="lhclength-(386.925+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250053.0, assembly_id=102359.0))
lhcb2.new("mco.11r2.b2", "mco", at="lhclength-(388.354+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250054.0, assembly_id=102360.0))
lhcb2.new("mcd.11r2.b2", "mcd", at="lhclength-(388.3555+(-148-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250055.0, assembly_id=102360.0))
lhcb2.new("mb.a11r2.b2", "mb", at="lhclength-(395.84+(-147.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824058.0, assembly_id=102360.0))
lhcb2.new("mcs.a11r2.b2", "mcs", at="lhclength-(403.264+(-147-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242930.0, assembly_id=102360.0))
lhcb2.new("mb.b11r2.b2", "mb", at="lhclength-(411.5+(-146.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52849474.0, assembly_id=102361.0))
lhcb2.new("mcs.b11r2.b2", "mcs", at="lhclength-(418.924+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=357295.0, assembly_id=102361.0))
lhcb2.new("lepla.11r2.b2", "lepla", at="lhclength-(421.984675+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52998102.0, assembly_id=52433772.0))
lhcb2.new("lenla.11r2.b2", "lenla", at="lhclength-(425.71735+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52998006.0, assembly_id=52433988.0))
lhcb2.new("leplb.11r2.b2", "leplb", at="lhclength-(429.450025+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52998126.0, assembly_id=52433791.0))
lhcb2.new("bpm.11r2.b2", "bpm", at="lhclength-(432.5777+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242935.0, assembly_id=102363.0))
lhcb2.new("mq.11r2.b2", "mq", at="lhclength-(435.1247+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308667.0, assembly_id=102363.0))
lhcb2.new("mqtli.11r2.b2", "mqtli", at="lhclength-(437.4937+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307355.0, assembly_id=102363.0))
lhcb2.new("ms.11r2.b2", "ms", at="lhclength-(438.5057+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250058.0, assembly_id=102363.0))
lhcb2.new("mcbh.11r2.b2", "mcbh", at="lhclength-(439.0987+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250060.0, assembly_id=102363.0))
lhcb2.new("s.arc.23.b2", "omk", at="lhclength-(439.8497+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a12r2.b2", "mco", at="lhclength-(440.1937+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250062.0, assembly_id=102364.0))
lhcb2.new("mcd.a12r2.b2", "mcd", at="lhclength-(440.1952+(-146-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250063.0, assembly_id=102364.0))
lhcb2.new("mb.a12r2.b2", "mb", at="lhclength-(447.6797+(-145.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824082.0, assembly_id=102364.0))
lhcb2.new("mcs.a12r2.b2", "mcs", at="lhclength-(455.1037+(-145-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242943.0, assembly_id=102364.0))
lhcb2.new("mb.b12r2.b2", "mb", at="lhclength-(463.3397+(-144.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824106.0, assembly_id=102365.0))
lhcb2.new("mcs.b12r2.b2", "mcs", at="lhclength-(470.7637+(-144-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242946.0, assembly_id=102365.0))
lhcb2.new("mco.b12r2.b2", "mco", at="lhclength-(471.5137+(-144-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250066.0, assembly_id=102366.0))
lhcb2.new("mcd.b12r2.b2", "mcd", at="lhclength-(471.5152+(-144-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250067.0, assembly_id=102366.0))
lhcb2.new("mb.c12r2.b2", "mb", at="lhclength-(478.9997+(-143.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824130.0, assembly_id=102366.0))
lhcb2.new("mcs.c12r2.b2", "mcs", at="lhclength-(486.4237+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242951.0, assembly_id=102366.0))
lhcb2.new("bpm.12r2.b2", "bpm", at="lhclength-(487.3027+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242953.0, assembly_id=102367.0))
lhcb2.new("mqt.12r2.b2", "mqt", at="lhclength-(488.0567+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307702.0, assembly_id=102367.0))
lhcb2.new("mq.12r2.b2", "mq", at="lhclength-(490.0647+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2348484.0, assembly_id=102367.0))
lhcb2.new("ms.12r2.b2", "ms", at="lhclength-(491.9597+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250070.0, assembly_id=102367.0))
lhcb2.new("mcbv.12r2.b2", "mcbv", at="lhclength-(492.5527+(-143-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250072.0, assembly_id=102367.0))
lhcb2.new("mb.a13r2.b2", "mb", at="lhclength-(501.1297+(-142.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824154.0, assembly_id=102368.0))
lhcb2.new("mcs.a13r2.b2", "mcs", at="lhclength-(508.5537+(-142-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242959.0, assembly_id=102368.0))
lhcb2.new("mco.13r2.b2", "mco", at="lhclength-(509.3037+(-142-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250074.0, assembly_id=102369.0))
lhcb2.new("mcd.13r2.b2", "mcd", at="lhclength-(509.3052+(-142-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250075.0, assembly_id=102369.0))
lhcb2.new("mb.b13r2.b2", "mb", at="lhclength-(516.7897+(-141.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824178.0, assembly_id=102369.0))
lhcb2.new("mcs.b13r2.b2", "mcs", at="lhclength-(524.2137+(-141-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242964.0, assembly_id=102369.0))
lhcb2.new("mb.c13r2.b2", "mb", at="lhclength-(532.4497+(-140.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824202.0, assembly_id=102370.0))
lhcb2.new("mcs.c13r2.b2", "mcs", at="lhclength-(539.8737+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242967.0, assembly_id=102370.0))
lhcb2.new("bpm.13r2.b2", "bpm", at="lhclength-(540.7527+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242969.0, assembly_id=102371.0))
lhcb2.new("mqt.13r2.b2", "mqt", at="lhclength-(541.5067+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307495.0, assembly_id=102371.0))
lhcb2.new("mq.13r2.b2", "mq", at="lhclength-(543.5147+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308490.0, assembly_id=102371.0))
lhcb2.new("ms.13r2.b2", "ms", at="lhclength-(545.4097+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250078.0, assembly_id=102371.0))
lhcb2.new("mcbh.13r2.b2", "mcbh", at="lhclength-(546.0027+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250080.0, assembly_id=102371.0))
lhcb2.new("e.ds.r2.b2", "omk", at="lhclength-(546.7497+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a14r2.b2", "mco", at="lhclength-(547.0937+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250082.0, assembly_id=102372.0))
lhcb2.new("mcd.a14r2.b2", "mcd", at="lhclength-(547.0952+(-140-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250083.0, assembly_id=102372.0))
lhcb2.new("mb.a14r2.b2", "mb", at="lhclength-(554.5797+(-139.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824226.0, assembly_id=102372.0))
lhcb2.new("mcs.a14r2.b2", "mcs", at="lhclength-(562.0037+(-139-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242977.0, assembly_id=102372.0))
lhcb2.new("mb.b14r2.b2", "mb", at="lhclength-(570.2397+(-138.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824250.0, assembly_id=102373.0))
lhcb2.new("mcs.b14r2.b2", "mcs", at="lhclength-(577.6637+(-138-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242980.0, assembly_id=102373.0))
lhcb2.new("mco.b14r2.b2", "mco", at="lhclength-(578.4137+(-138-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250086.0, assembly_id=102374.0))
lhcb2.new("mcd.b14r2.b2", "mcd", at="lhclength-(578.4152+(-138-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250087.0, assembly_id=102374.0))
lhcb2.new("mb.c14r2.b2", "mb", at="lhclength-(585.8997+(-137.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824274.0, assembly_id=102374.0))
lhcb2.new("mcs.c14r2.b2", "mcs", at="lhclength-(593.3237+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242985.0, assembly_id=102374.0))
lhcb2.new("bpm.14r2.b2", "bpm", at="lhclength-(594.2027+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242987.0, assembly_id=102375.0))
lhcb2.new("mqt.14r2.b2", "mqt", at="lhclength-(594.9567+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307526.0, assembly_id=102375.0))
lhcb2.new("mq.14r2.b2", "mq", at="lhclength-(596.9647+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308520.0, assembly_id=102375.0))
lhcb2.new("ms.14r2.b2", "ms", at="lhclength-(598.8597+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250090.0, assembly_id=102375.0))
lhcb2.new("mcbv.14r2.b2", "mcbv", at="lhclength-(599.4527+(-137-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250092.0, assembly_id=102375.0))
lhcb2.new("mb.a15r2.b2", "mb", at="lhclength-(608.0297+(-136.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824298.0, assembly_id=102376.0))
lhcb2.new("mcs.a15r2.b2", "mcs", at="lhclength-(615.4537+(-136-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242993.0, assembly_id=102376.0))
lhcb2.new("mco.15r2.b2", "mco", at="lhclength-(616.2037+(-136-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250094.0, assembly_id=102377.0))
lhcb2.new("mcd.15r2.b2", "mcd", at="lhclength-(616.2052+(-136-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250095.0, assembly_id=102377.0))
lhcb2.new("mb.b15r2.b2", "mb", at="lhclength-(623.6897+(-135.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824322.0, assembly_id=102377.0))
lhcb2.new("mcs.b15r2.b2", "mcs", at="lhclength-(631.1137+(-135-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=242998.0, assembly_id=102377.0))
lhcb2.new("mb.c15r2.b2", "mb", at="lhclength-(639.3497+(-134.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824346.0, assembly_id=102378.0))
lhcb2.new("mcs.c15r2.b2", "mcs", at="lhclength-(646.7737+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243001.0, assembly_id=102378.0))
lhcb2.new("bpm.15r2.b2", "bpm", at="lhclength-(647.6527+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243003.0, assembly_id=102379.0))
lhcb2.new("mqt.15r2.b2", "mqt", at="lhclength-(648.4067+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307558.0, assembly_id=102379.0))
lhcb2.new("mq.15r2.b2", "mq", at="lhclength-(650.4147+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308550.0, assembly_id=102379.0))
lhcb2.new("ms.15r2.b2", "ms", at="lhclength-(652.3097+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250098.0, assembly_id=102379.0))
lhcb2.new("mcbh.15r2.b2", "mcbh", at="lhclength-(652.9027+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250100.0, assembly_id=102379.0))
lhcb2.new("mco.a16r2.b2", "mco", at="lhclength-(653.9937+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250102.0, assembly_id=102380.0))
lhcb2.new("mcd.a16r2.b2", "mcd", at="lhclength-(653.9952+(-134-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250103.0, assembly_id=102380.0))
lhcb2.new("mb.a16r2.b2", "mb", at="lhclength-(661.4797+(-133.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824370.0, assembly_id=102380.0))
lhcb2.new("mcs.a16r2.b2", "mcs", at="lhclength-(668.9037+(-133-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243011.0, assembly_id=102380.0))
lhcb2.new("mb.b16r2.b2", "mb", at="lhclength-(677.1397+(-132.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824394.0, assembly_id=102381.0))
lhcb2.new("mcs.b16r2.b2", "mcs", at="lhclength-(684.5637+(-132-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243014.0, assembly_id=102381.0))
lhcb2.new("mco.b16r2.b2", "mco", at="lhclength-(685.3137+(-132-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250106.0, assembly_id=102382.0))
lhcb2.new("mcd.b16r2.b2", "mcd", at="lhclength-(685.3152+(-132-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250107.0, assembly_id=102382.0))
lhcb2.new("mb.c16r2.b2", "mb", at="lhclength-(692.7997+(-131.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824418.0, assembly_id=102382.0))
lhcb2.new("mcs.c16r2.b2", "mcs", at="lhclength-(700.2237+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243019.0, assembly_id=102382.0))
lhcb2.new("bpm.16r2.b2", "bpm", at="lhclength-(701.1027+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243021.0, assembly_id=102383.0))
lhcb2.new("mqt.16r2.b2", "mqt", at="lhclength-(701.8567+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307588.0, assembly_id=102383.0))
lhcb2.new("mq.16r2.b2", "mq", at="lhclength-(703.8647+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308343.0, assembly_id=102383.0))
lhcb2.new("ms.16r2.b2", "ms", at="lhclength-(705.7597+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250110.0, assembly_id=102383.0))
lhcb2.new("mcbv.16r2.b2", "mcbv", at="lhclength-(706.3527+(-131-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250112.0, assembly_id=102383.0))
lhcb2.new("mb.a17r2.b2", "mb", at="lhclength-(714.9297+(-130.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824442.0, assembly_id=102384.0))
lhcb2.new("mcs.a17r2.b2", "mcs", at="lhclength-(722.3537+(-130-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243027.0, assembly_id=102384.0))
lhcb2.new("mco.17r2.b2", "mco", at="lhclength-(723.1037+(-130-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250114.0, assembly_id=102385.0))
lhcb2.new("mcd.17r2.b2", "mcd", at="lhclength-(723.1052+(-130-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250115.0, assembly_id=102385.0))
lhcb2.new("mb.b17r2.b2", "mb", at="lhclength-(730.5897+(-129.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824466.0, assembly_id=102385.0))
lhcb2.new("mcs.b17r2.b2", "mcs", at="lhclength-(738.0137+(-129-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243032.0, assembly_id=102385.0))
lhcb2.new("mb.c17r2.b2", "mb", at="lhclength-(746.2497+(-128.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824490.0, assembly_id=102386.0))
lhcb2.new("mcs.c17r2.b2", "mcs", at="lhclength-(753.6737+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243035.0, assembly_id=102386.0))
lhcb2.new("bpm.17r2.b2", "bpm", at="lhclength-(754.5527+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243037.0, assembly_id=102387.0))
lhcb2.new("mqt.17r2.b2", "mqt", at="lhclength-(755.3067+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307382.0, assembly_id=102387.0))
lhcb2.new("mq.17r2.b2", "mq", at="lhclength-(757.3147+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308373.0, assembly_id=102387.0))
lhcb2.new("ms.17r2.b2", "ms", at="lhclength-(759.2097+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250118.0, assembly_id=102387.0))
lhcb2.new("mcbh.17r2.b2", "mcbh", at="lhclength-(759.8027+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250120.0, assembly_id=102387.0))
lhcb2.new("mco.a18r2.b2", "mco", at="lhclength-(760.8937+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250122.0, assembly_id=102388.0))
lhcb2.new("mcd.a18r2.b2", "mcd", at="lhclength-(760.8952+(-128-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250123.0, assembly_id=102388.0))
lhcb2.new("mb.a18r2.b2", "mb", at="lhclength-(768.3797+(-127.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824514.0, assembly_id=102388.0))
lhcb2.new("mcs.a18r2.b2", "mcs", at="lhclength-(775.8037+(-127-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243045.0, assembly_id=102388.0))
lhcb2.new("mb.b18r2.b2", "mb", at="lhclength-(784.0397+(-126.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824538.0, assembly_id=102389.0))
lhcb2.new("mcs.b18r2.b2", "mcs", at="lhclength-(791.4637+(-126-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243048.0, assembly_id=102389.0))
lhcb2.new("mco.b18r2.b2", "mco", at="lhclength-(792.2137+(-126-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250126.0, assembly_id=102390.0))
lhcb2.new("mcd.b18r2.b2", "mcd", at="lhclength-(792.2152+(-126-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250127.0, assembly_id=102390.0))
lhcb2.new("mb.c18r2.b2", "mb", at="lhclength-(799.6997+(-125.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824562.0, assembly_id=102390.0))
lhcb2.new("mcs.c18r2.b2", "mcs", at="lhclength-(807.1237+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243053.0, assembly_id=102390.0))
lhcb2.new("bpm.18r2.b2", "bpm", at="lhclength-(808.0027+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243055.0, assembly_id=102391.0))
lhcb2.new("mqt.18r2.b2", "mqt", at="lhclength-(808.7567+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307414.0, assembly_id=102391.0))
lhcb2.new("mq.18r2.b2", "mq", at="lhclength-(810.7647+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308403.0, assembly_id=102391.0))
lhcb2.new("ms.18r2.b2", "ms", at="lhclength-(812.6597+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250130.0, assembly_id=102391.0))
lhcb2.new("mcbv.18r2.b2", "mcbv", at="lhclength-(813.2527+(-125-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250132.0, assembly_id=102391.0))
lhcb2.new("mb.a19r2.b2", "mb", at="lhclength-(821.8297+(-124.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824586.0, assembly_id=102392.0))
lhcb2.new("mcs.a19r2.b2", "mcs", at="lhclength-(829.2537+(-124-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243061.0, assembly_id=102392.0))
lhcb2.new("mco.19r2.b2", "mco", at="lhclength-(830.0037+(-124-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250134.0, assembly_id=102393.0))
lhcb2.new("mcd.19r2.b2", "mcd", at="lhclength-(830.0052+(-124-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250135.0, assembly_id=102393.0))
lhcb2.new("mb.b19r2.b2", "mb", at="lhclength-(837.4897+(-123.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824610.0, assembly_id=102393.0))
lhcb2.new("mcs.b19r2.b2", "mcs", at="lhclength-(844.9137+(-123-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243066.0, assembly_id=102393.0))
lhcb2.new("mb.c19r2.b2", "mb", at="lhclength-(853.1497+(-122.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824634.0, assembly_id=102394.0))
lhcb2.new("mcs.c19r2.b2", "mcs", at="lhclength-(860.5737+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243069.0, assembly_id=102394.0))
lhcb2.new("bpm.19r2.b2", "bpm", at="lhclength-(861.4527+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243071.0, assembly_id=102395.0))
lhcb2.new("mqt.19r2.b2", "mqt", at="lhclength-(862.2067+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307445.0, assembly_id=102395.0))
lhcb2.new("mq.19r2.b2", "mq", at="lhclength-(864.2147+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308435.0, assembly_id=102395.0))
lhcb2.new("ms.19r2.b2", "ms", at="lhclength-(866.1097+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250138.0, assembly_id=102395.0))
lhcb2.new("mcbh.19r2.b2", "mcbh", at="lhclength-(866.7027+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250140.0, assembly_id=102395.0))
lhcb2.new("mco.a20r2.b2", "mco", at="lhclength-(867.7937+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250142.0, assembly_id=102396.0))
lhcb2.new("mcd.a20r2.b2", "mcd", at="lhclength-(867.7952+(-122-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250143.0, assembly_id=102396.0))
lhcb2.new("mb.a20r2.b2", "mb", at="lhclength-(875.2797+(-121.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824658.0, assembly_id=102396.0))
lhcb2.new("mcs.a20r2.b2", "mcs", at="lhclength-(882.7037+(-121-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243079.0, assembly_id=102396.0))
lhcb2.new("mb.b20r2.b2", "mb", at="lhclength-(890.9397+(-120.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824682.0, assembly_id=102397.0))
lhcb2.new("mcs.b20r2.b2", "mcs", at="lhclength-(898.3637+(-120-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243082.0, assembly_id=102397.0))
lhcb2.new("mco.b20r2.b2", "mco", at="lhclength-(899.1137+(-120-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250146.0, assembly_id=102398.0))
lhcb2.new("mcd.b20r2.b2", "mcd", at="lhclength-(899.1152+(-120-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250147.0, assembly_id=102398.0))
lhcb2.new("mb.c20r2.b2", "mb", at="lhclength-(906.5997+(-119.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824706.0, assembly_id=102398.0))
lhcb2.new("mcs.c20r2.b2", "mcs", at="lhclength-(914.0237+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243087.0, assembly_id=102398.0))
lhcb2.new("bpm.20r2.b2", "bpm", at="lhclength-(914.9027+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243089.0, assembly_id=102399.0))
lhcb2.new("mqt.20r2.b2", "mqt", at="lhclength-(915.6567+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307474.0, assembly_id=102399.0))
lhcb2.new("mq.20r2.b2", "mq", at="lhclength-(917.6647+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308226.0, assembly_id=102399.0))
lhcb2.new("ms.20r2.b2", "ms", at="lhclength-(919.5597+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250150.0, assembly_id=102399.0))
lhcb2.new("mcbv.20r2.b2", "mcbv", at="lhclength-(920.1527+(-119-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250152.0, assembly_id=102399.0))
lhcb2.new("mb.a21r2.b2", "mb", at="lhclength-(928.7297+(-118.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824730.0, assembly_id=102400.0))
lhcb2.new("mcs.a21r2.b2", "mcs", at="lhclength-(936.1537+(-118-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243095.0, assembly_id=102400.0))
lhcb2.new("mco.21r2.b2", "mco", at="lhclength-(936.9037+(-118-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250154.0, assembly_id=102401.0))
lhcb2.new("mcd.21r2.b2", "mcd", at="lhclength-(936.9052+(-118-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250155.0, assembly_id=102401.0))
lhcb2.new("mb.b21r2.b2", "mb", at="lhclength-(944.3897+(-117.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824754.0, assembly_id=102401.0))
lhcb2.new("mcs.b21r2.b2", "mcs", at="lhclength-(951.8137+(-117-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243100.0, assembly_id=102401.0))
lhcb2.new("mb.c21r2.b2", "mb", at="lhclength-(960.0497+(-116.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824778.0, assembly_id=102402.0))
lhcb2.new("mcs.c21r2.b2", "mcs", at="lhclength-(967.4737+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243103.0, assembly_id=102402.0))
lhcb2.new("bpm.21r2.b2", "bpm", at="lhclength-(968.3527+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243105.0, assembly_id=102403.0))
lhcb2.new("mqt.21r2.b2", "mqt", at="lhclength-(969.1067+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307272.0, assembly_id=102403.0))
lhcb2.new("mq.21r2.b2", "mq", at="lhclength-(971.1147+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308256.0, assembly_id=102403.0))
lhcb2.new("ms.21r2.b2", "ms", at="lhclength-(973.0097+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250158.0, assembly_id=102403.0))
lhcb2.new("mcbh.21r2.b2", "mcbh", at="lhclength-(973.6027+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250160.0, assembly_id=102403.0))
lhcb2.new("mco.a22r2.b2", "mco", at="lhclength-(974.6937+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250162.0, assembly_id=102404.0))
lhcb2.new("mcd.a22r2.b2", "mcd", at="lhclength-(974.6952+(-116-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250163.0, assembly_id=102404.0))
lhcb2.new("mb.a22r2.b2", "mb", at="lhclength-(982.1797+(-115.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824802.0, assembly_id=102404.0))
lhcb2.new("mcs.a22r2.b2", "mcs", at="lhclength-(989.6037+(-115-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243113.0, assembly_id=102404.0))
lhcb2.new("mb.b22r2.b2", "mb", at="lhclength-(997.8397+(-114.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824826.0, assembly_id=102405.0))
lhcb2.new("mcs.b22r2.b2", "mcs", at="lhclength-(1005.2637+(-114-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243116.0, assembly_id=102405.0))
lhcb2.new("mco.b22r2.b2", "mco", at="lhclength-(1006.0137+(-114-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250166.0, assembly_id=102406.0))
lhcb2.new("mcd.b22r2.b2", "mcd", at="lhclength-(1006.0152+(-114-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250167.0, assembly_id=102406.0))
lhcb2.new("mb.c22r2.b2", "mb", at="lhclength-(1013.4997+(-113.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824850.0, assembly_id=102406.0))
lhcb2.new("mcs.c22r2.b2", "mcs", at="lhclength-(1020.9237+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243121.0, assembly_id=102406.0))
lhcb2.new("bpm.22r2.b2", "bpm", at="lhclength-(1021.8027+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243123.0, assembly_id=102407.0))
lhcb2.new("mo.22r2.b2", "mo", at="lhclength-(1022.5537+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308816.0, assembly_id=102407.0))
lhcb2.new("mq.22r2.b2", "mq", at="lhclength-(1024.5647+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308288.0, assembly_id=102407.0))
lhcb2.new("ms.22r2.b2", "ms", at="lhclength-(1026.4597+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250170.0, assembly_id=102407.0))
lhcb2.new("mcbv.22r2.b2", "mcbv", at="lhclength-(1027.0527+(-113-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250172.0, assembly_id=102407.0))
lhcb2.new("mb.a23r2.b2", "mb", at="lhclength-(1035.6297+(-112.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824874.0, assembly_id=102408.0))
lhcb2.new("mcs.a23r2.b2", "mcs", at="lhclength-(1043.0537+(-112-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243129.0, assembly_id=102408.0))
lhcb2.new("mco.23r2.b2", "mco", at="lhclength-(1043.8037+(-112-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250174.0, assembly_id=102409.0))
lhcb2.new("mcd.23r2.b2", "mcd", at="lhclength-(1043.8052+(-112-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250175.0, assembly_id=102409.0))
lhcb2.new("mb.b23r2.b2", "mb", at="lhclength-(1051.2897+(-111.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824898.0, assembly_id=102409.0))
lhcb2.new("mcs.b23r2.b2", "mcs", at="lhclength-(1058.7137+(-111-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243134.0, assembly_id=102409.0))
lhcb2.new("mb.c23r2.b2", "mb", at="lhclength-(1066.9497+(-110.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824922.0, assembly_id=102410.0))
lhcb2.new("mcs.c23r2.b2", "mcs", at="lhclength-(1074.3737+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243137.0, assembly_id=102410.0))
lhcb2.new("bpm.23r2.b2", "bpm", at="lhclength-(1075.2527+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=266500.0, assembly_id=102411.0))
lhcb2.new("mqs.23r2.b2", "mqs", at="lhclength-(1076.0067+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2348450.0, assembly_id=102411.0))
lhcb2.new("mq.23r2.b2", "mq", at="lhclength-(1078.0147+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308319.0, assembly_id=102411.0))
lhcb2.new("ms.23r2.b2", "ms", at="lhclength-(1079.9097+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250178.0, assembly_id=102411.0))
lhcb2.new("mcbh.23r2.b2", "mcbh", at="lhclength-(1080.5027+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250180.0, assembly_id=102411.0))
lhcb2.new("mco.a24r2.b2", "mco", at="lhclength-(1081.5937+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250182.0, assembly_id=102412.0))
lhcb2.new("mcd.a24r2.b2", "mcd", at="lhclength-(1081.5952+(-110-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250183.0, assembly_id=102412.0))
lhcb2.new("mb.a24r2.b2", "mb", at="lhclength-(1089.0797+(-109.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824946.0, assembly_id=102412.0))
lhcb2.new("mcs.a24r2.b2", "mcs", at="lhclength-(1096.5037+(-109-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243145.0, assembly_id=102412.0))
lhcb2.new("mb.b24r2.b2", "mb", at="lhclength-(1104.7397+(-108.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824970.0, assembly_id=102413.0))
lhcb2.new("mcs.b24r2.b2", "mcs", at="lhclength-(1112.1637+(-108-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243148.0, assembly_id=102413.0))
lhcb2.new("mco.b24r2.b2", "mco", at="lhclength-(1112.9137+(-108-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250186.0, assembly_id=102414.0))
lhcb2.new("mcd.b24r2.b2", "mcd", at="lhclength-(1112.9152+(-108-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250187.0, assembly_id=102414.0))
lhcb2.new("mb.c24r2.b2", "mb", at="lhclength-(1120.3997+(-107.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52824994.0, assembly_id=102414.0))
lhcb2.new("mcs.c24r2.b2", "mcs", at="lhclength-(1127.8237+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243153.0, assembly_id=102414.0))
lhcb2.new("bpm.24r2.b2", "bpm", at="lhclength-(1128.7027+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243155.0, assembly_id=102415.0))
lhcb2.new("mo.24r2.b2", "mo", at="lhclength-(1129.4537+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308846.0, assembly_id=102415.0))
lhcb2.new("mq.24r2.b2", "mq", at="lhclength-(1131.4647+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308109.0, assembly_id=102415.0))
lhcb2.new("ms.24r2.b2", "ms", at="lhclength-(1133.3597+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250190.0, assembly_id=102415.0))
lhcb2.new("mcbv.24r2.b2", "mcbv", at="lhclength-(1133.9527+(-107-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250192.0, assembly_id=102415.0))
lhcb2.new("mb.a25r2.b2", "mb", at="lhclength-(1142.5297+(-106.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825018.0, assembly_id=102416.0))
lhcb2.new("mcs.a25r2.b2", "mcs", at="lhclength-(1149.9537+(-106-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243161.0, assembly_id=102416.0))
lhcb2.new("mco.25r2.b2", "mco", at="lhclength-(1150.7037+(-106-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250194.0, assembly_id=102417.0))
lhcb2.new("mcd.25r2.b2", "mcd", at="lhclength-(1150.7052+(-106-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250195.0, assembly_id=102417.0))
lhcb2.new("mb.b25r2.b2", "mb", at="lhclength-(1158.1897+(-105.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825042.0, assembly_id=102417.0))
lhcb2.new("mcs.b25r2.b2", "mcs", at="lhclength-(1165.6137+(-105-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243166.0, assembly_id=102417.0))
lhcb2.new("mb.c25r2.b2", "mb", at="lhclength-(1173.8497+(-104.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825066.0, assembly_id=102418.0))
lhcb2.new("mcs.c25r2.b2", "mcs", at="lhclength-(1181.2737+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243169.0, assembly_id=102418.0))
lhcb2.new("bpm.25r2.b2", "bpm", at="lhclength-(1182.1527+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243171.0, assembly_id=102419.0))
lhcb2.new("mo.25r2.b2", "mo", at="lhclength-(1182.9037+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308878.0, assembly_id=102419.0))
lhcb2.new("mq.25r2.b2", "mq", at="lhclength-(1184.9147+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308141.0, assembly_id=102419.0))
lhcb2.new("ms.25r2.b2", "ms", at="lhclength-(1186.8097+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250198.0, assembly_id=102419.0))
lhcb2.new("mcbh.25r2.b2", "mcbh", at="lhclength-(1187.4027+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250200.0, assembly_id=102419.0))
lhcb2.new("mco.a26r2.b2", "mco", at="lhclength-(1188.4937+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250202.0, assembly_id=102420.0))
lhcb2.new("mcd.a26r2.b2", "mcd", at="lhclength-(1188.4952+(-104-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250203.0, assembly_id=102420.0))
lhcb2.new("mb.a26r2.b2", "mb", at="lhclength-(1195.9797+(-103.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825090.0, assembly_id=102420.0))
lhcb2.new("mcs.a26r2.b2", "mcs", at="lhclength-(1203.4037+(-103-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243179.0, assembly_id=102420.0))
lhcb2.new("mb.b26r2.b2", "mb", at="lhclength-(1211.6397+(-102.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825114.0, assembly_id=102421.0))
lhcb2.new("mcs.b26r2.b2", "mcs", at="lhclength-(1219.0637+(-102-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243182.0, assembly_id=102421.0))
lhcb2.new("mco.b26r2.b2", "mco", at="lhclength-(1219.8137+(-102-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250206.0, assembly_id=102422.0))
lhcb2.new("mcd.b26r2.b2", "mcd", at="lhclength-(1219.8152+(-102-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250207.0, assembly_id=102422.0))
lhcb2.new("mb.c26r2.b2", "mb", at="lhclength-(1227.2997+(-101.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825138.0, assembly_id=102422.0))
lhcb2.new("mcs.c26r2.b2", "mcs", at="lhclength-(1234.7237+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243187.0, assembly_id=102422.0))
lhcb2.new("bpm.26r2.b2", "bpm", at="lhclength-(1235.6027+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243189.0, assembly_id=102423.0))
lhcb2.new("mo.26r2.b2", "mo", at="lhclength-(1236.3537+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308910.0, assembly_id=102423.0))
lhcb2.new("mq.26r2.b2", "mq", at="lhclength-(1238.3647+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308172.0, assembly_id=102423.0))
lhcb2.new("ms.26r2.b2", "ms", at="lhclength-(1240.2597+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250210.0, assembly_id=102423.0))
lhcb2.new("mcbv.26r2.b2", "mcbv", at="lhclength-(1240.8527+(-101-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250212.0, assembly_id=102423.0))
lhcb2.new("mb.a27r2.b2", "mb", at="lhclength-(1249.4297+(-100.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825162.0, assembly_id=102424.0))
lhcb2.new("mcs.a27r2.b2", "mcs", at="lhclength-(1256.8537+(-100-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243195.0, assembly_id=102424.0))
lhcb2.new("mco.27r2.b2", "mco", at="lhclength-(1257.6037+(-100-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250214.0, assembly_id=102425.0))
lhcb2.new("mcd.27r2.b2", "mcd", at="lhclength-(1257.6052+(-100-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250215.0, assembly_id=102425.0))
lhcb2.new("mb.b27r2.b2", "mb", at="lhclength-(1265.0897+(-99.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825186.0, assembly_id=102425.0))
lhcb2.new("mcs.b27r2.b2", "mcs", at="lhclength-(1272.5137+(-99-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243200.0, assembly_id=102425.0))
lhcb2.new("mb.c27r2.b2", "mb", at="lhclength-(1280.7497+(-98.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825210.0, assembly_id=102426.0))
lhcb2.new("mcs.c27r2.b2", "mcs", at="lhclength-(1288.1737+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243203.0, assembly_id=102426.0))
lhcb2.new("bpm.27r2.b2", "bpm", at="lhclength-(1289.0527+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=266502.0, assembly_id=102427.0))
lhcb2.new("mqs.27r2.b2", "mqs", at="lhclength-(1289.8067+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307670.0, assembly_id=102427.0))
lhcb2.new("mq.27r2.b2", "mq", at="lhclength-(1291.8147+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308202.0, assembly_id=102427.0))
lhcb2.new("ms.27r2.b2", "ms", at="lhclength-(1293.7097+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250218.0, assembly_id=102427.0))
lhcb2.new("mcbh.27r2.b2", "mcbh", at="lhclength-(1294.3027+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250220.0, assembly_id=102427.0))
lhcb2.new("mco.a28r2.b2", "mco", at="lhclength-(1295.3937+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250222.0, assembly_id=102428.0))
lhcb2.new("mcd.a28r2.b2", "mcd", at="lhclength-(1295.3952+(-98-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250223.0, assembly_id=102428.0))
lhcb2.new("mb.a28r2.b2", "mb", at="lhclength-(1302.8797+(-97.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825234.0, assembly_id=102428.0))
lhcb2.new("mcs.a28r2.b2", "mcs", at="lhclength-(1310.3037+(-97-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243211.0, assembly_id=102428.0))
lhcb2.new("mb.b28r2.b2", "mb", at="lhclength-(1318.5397+(-96.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825258.0, assembly_id=102429.0))
lhcb2.new("mcs.b28r2.b2", "mcs", at="lhclength-(1325.9637+(-96-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243214.0, assembly_id=102429.0))
lhcb2.new("mco.b28r2.b2", "mco", at="lhclength-(1326.7137+(-96-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250226.0, assembly_id=102430.0))
lhcb2.new("mcd.b28r2.b2", "mcd", at="lhclength-(1326.7152+(-96-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250227.0, assembly_id=102430.0))
lhcb2.new("mb.c28r2.b2", "mb", at="lhclength-(1334.1997+(-95.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825282.0, assembly_id=102430.0))
lhcb2.new("mcs.c28r2.b2", "mcs", at="lhclength-(1341.6237+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243219.0, assembly_id=102430.0))
lhcb2.new("bpm.28r2.b2", "bpm", at="lhclength-(1342.5027+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243221.0, assembly_id=102431.0))
lhcb2.new("mo.28r2.b2", "mo", at="lhclength-(1343.2537+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308699.0, assembly_id=102431.0))
lhcb2.new("mq.28r2.b2", "mq", at="lhclength-(1345.2647+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307993.0, assembly_id=102431.0))
lhcb2.new("ms.28r2.b2", "ms", at="lhclength-(1347.1597+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250230.0, assembly_id=102431.0))
lhcb2.new("mcbv.28r2.b2", "mcbv", at="lhclength-(1347.7527+(-95-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250232.0, assembly_id=102431.0))
lhcb2.new("mb.a29r2.b2", "mb", at="lhclength-(1356.3297+(-94.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825306.0, assembly_id=102432.0))
lhcb2.new("mcs.a29r2.b2", "mcs", at="lhclength-(1363.7537+(-94-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243227.0, assembly_id=102432.0))
lhcb2.new("mco.29r2.b2", "mco", at="lhclength-(1364.5037+(-94-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250234.0, assembly_id=102433.0))
lhcb2.new("mcd.29r2.b2", "mcd", at="lhclength-(1364.5052+(-94-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250235.0, assembly_id=102433.0))
lhcb2.new("mb.b29r2.b2", "mb", at="lhclength-(1371.9897+(-93.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825330.0, assembly_id=102433.0))
lhcb2.new("mcs.b29r2.b2", "mcs", at="lhclength-(1379.4137+(-93-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243232.0, assembly_id=102433.0))
lhcb2.new("mb.c29r2.b2", "mb", at="lhclength-(1387.6497+(-92.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825354.0, assembly_id=102434.0))
lhcb2.new("mcs.c29r2.b2", "mcs", at="lhclength-(1395.0737+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243235.0, assembly_id=102434.0))
lhcb2.new("bpm.29r2.b2", "bpm", at="lhclength-(1395.9527+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243237.0, assembly_id=102435.0))
lhcb2.new("mo.29r2.b2", "mo", at="lhclength-(1396.7037+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308731.0, assembly_id=102435.0))
lhcb2.new("mq.29r2.b2", "mq", at="lhclength-(1398.7147+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308024.0, assembly_id=102435.0))
lhcb2.new("mss.29r2.b2", "mss", at="lhclength-(1400.6097+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250238.0, assembly_id=102435.0))
lhcb2.new("mcbh.29r2.b2", "mcbh", at="lhclength-(1401.2027+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250240.0, assembly_id=102435.0))
lhcb2.new("mco.a30r2.b2", "mco", at="lhclength-(1402.2937+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250242.0, assembly_id=102436.0))
lhcb2.new("mcd.a30r2.b2", "mcd", at="lhclength-(1402.2952+(-92-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250243.0, assembly_id=102436.0))
lhcb2.new("mb.a30r2.b2", "mb", at="lhclength-(1409.7797+(-91.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825378.0, assembly_id=102436.0))
lhcb2.new("mcs.a30r2.b2", "mcs", at="lhclength-(1417.2037+(-91-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243245.0, assembly_id=102436.0))
lhcb2.new("mb.b30r2.b2", "mb", at="lhclength-(1425.4397+(-90.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825402.0, assembly_id=102437.0))
lhcb2.new("mcs.b30r2.b2", "mcs", at="lhclength-(1432.8637+(-90-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243248.0, assembly_id=102437.0))
lhcb2.new("mco.b30r2.b2", "mco", at="lhclength-(1433.6137+(-90-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250246.0, assembly_id=102438.0))
lhcb2.new("mcd.b30r2.b2", "mcd", at="lhclength-(1433.6152+(-90-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250247.0, assembly_id=102438.0))
lhcb2.new("mb.c30r2.b2", "mb", at="lhclength-(1441.0997+(-89.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825426.0, assembly_id=102438.0))
lhcb2.new("mcs.c30r2.b2", "mcs", at="lhclength-(1448.5237+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243253.0, assembly_id=102438.0))
lhcb2.new("bpm.30r2.b2", "bpm", at="lhclength-(1449.4027+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243255.0, assembly_id=102439.0))
lhcb2.new("mo.30r2.b2", "mo", at="lhclength-(1450.1537+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308762.0, assembly_id=102439.0))
lhcb2.new("mq.30r2.b2", "mq", at="lhclength-(1452.1647+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308054.0, assembly_id=102439.0))
lhcb2.new("ms.30r2.b2", "ms", at="lhclength-(1454.0597+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250250.0, assembly_id=102439.0))
lhcb2.new("mcbv.30r2.b2", "mcbv", at="lhclength-(1454.6527+(-89-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250252.0, assembly_id=102439.0))
lhcb2.new("mb.a31r2.b2", "mb", at="lhclength-(1463.2297+(-88.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825450.0, assembly_id=102440.0))
lhcb2.new("mcs.a31r2.b2", "mcs", at="lhclength-(1470.6537+(-88-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243261.0, assembly_id=102440.0))
lhcb2.new("mco.31r2.b2", "mco", at="lhclength-(1471.4037+(-88-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250254.0, assembly_id=102441.0))
lhcb2.new("mcd.31r2.b2", "mcd", at="lhclength-(1471.4052+(-88-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250255.0, assembly_id=102441.0))
lhcb2.new("mb.b31r2.b2", "mb", at="lhclength-(1478.8897+(-87.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825474.0, assembly_id=102441.0))
lhcb2.new("mcs.b31r2.b2", "mcs", at="lhclength-(1486.3137+(-87-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243266.0, assembly_id=102441.0))
lhcb2.new("mb.c31r2.b2", "mb", at="lhclength-(1494.5497+(-86.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825498.0, assembly_id=102442.0))
lhcb2.new("mcs.c31r2.b2", "mcs", at="lhclength-(1501.9737+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243269.0, assembly_id=102442.0))
lhcb2.new("bpm.31r2.b2", "bpm", at="lhclength-(1502.8527+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243271.0, assembly_id=102443.0))
lhcb2.new("mo.31r2.b2", "mo", at="lhclength-(1503.6037+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308792.0, assembly_id=102443.0))
lhcb2.new("mq.31r2.b2", "mq", at="lhclength-(1505.6147+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2348469.0, assembly_id=102443.0))
lhcb2.new("ms.31r2.b2", "ms", at="lhclength-(1507.5097+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250258.0, assembly_id=102443.0))
lhcb2.new("mcbh.31r2.b2", "mcbh", at="lhclength-(1508.1027+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250260.0, assembly_id=102443.0))
lhcb2.new("s.cell.23.b2", "omk", at="lhclength-(1508.8497+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a32r2.b2", "mco", at="lhclength-(1509.1937+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250262.0, assembly_id=102444.0))
lhcb2.new("mcd.a32r2.b2", "mcd", at="lhclength-(1509.1952+(-86-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250263.0, assembly_id=102444.0))
lhcb2.new("mb.a32r2.b2", "mb", at="lhclength-(1516.6797+(-85.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825522.0, assembly_id=102444.0))
lhcb2.new("mcs.a32r2.b2", "mcs", at="lhclength-(1524.1037+(-85-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243279.0, assembly_id=102444.0))
lhcb2.new("mb.b32r2.b2", "mb", at="lhclength-(1532.3397+(-84.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825546.0, assembly_id=102445.0))
lhcb2.new("mcs.b32r2.b2", "mcs", at="lhclength-(1539.7637+(-84-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243282.0, assembly_id=102445.0))
lhcb2.new("mco.b32r2.b2", "mco", at="lhclength-(1540.5137+(-84-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250266.0, assembly_id=102446.0))
lhcb2.new("mcd.b32r2.b2", "mcd", at="lhclength-(1540.5152+(-84-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250267.0, assembly_id=102446.0))
lhcb2.new("mb.c32r2.b2", "mb", at="lhclength-(1547.9997+(-83.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825570.0, assembly_id=102446.0))
lhcb2.new("mcs.c32r2.b2", "mcs", at="lhclength-(1555.4237+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243287.0, assembly_id=102446.0))
lhcb2.new("bpm.32r2.b2", "bpm", at="lhclength-(1556.3027+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243289.0, assembly_id=102447.0))
lhcb2.new("mo.32r2.b2", "mo", at="lhclength-(1557.0537+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308584.0, assembly_id=102447.0))
lhcb2.new("mq.32r2.b2", "mq", at="lhclength-(1559.0647+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307875.0, assembly_id=102447.0))
lhcb2.new("ms.32r2.b2", "ms", at="lhclength-(1560.9597+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250270.0, assembly_id=102447.0))
lhcb2.new("mcbv.32r2.b2", "mcbv", at="lhclength-(1561.5527+(-83-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250272.0, assembly_id=102447.0))
lhcb2.new("mb.a33r2.b2", "mb", at="lhclength-(1570.1297+(-82.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825594.0, assembly_id=102448.0))
lhcb2.new("mcs.a33r2.b2", "mcs", at="lhclength-(1577.5537+(-82-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243295.0, assembly_id=102448.0))
lhcb2.new("mco.33r2.b2", "mco", at="lhclength-(1578.3037+(-82-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250274.0, assembly_id=102449.0))
lhcb2.new("mcd.33r2.b2", "mcd", at="lhclength-(1578.3052+(-82-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250275.0, assembly_id=102449.0))
lhcb2.new("mb.b33r2.b2", "mb", at="lhclength-(1585.7897+(-81.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825618.0, assembly_id=102449.0))
lhcb2.new("mcs.b33r2.b2", "mcs", at="lhclength-(1593.2137+(-81-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243300.0, assembly_id=102449.0))
lhcb2.new("mb.c33r2.b2", "mb", at="lhclength-(1601.4497+(-80.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825642.0, assembly_id=102450.0))
lhcb2.new("mcs.c33r2.b2", "mcs", at="lhclength-(1608.8737+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243303.0, assembly_id=102450.0))
lhcb2.new("bpm.33r2.b2", "bpm", at="lhclength-(1609.7527+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243305.0, assembly_id=102451.0))
lhcb2.new("mo.33r2.b2", "mo", at="lhclength-(1610.5037+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308615.0, assembly_id=102451.0))
lhcb2.new("mq.33r2.b2", "mq", at="lhclength-(1612.5147+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307905.0, assembly_id=102451.0))
lhcb2.new("mss.33r2.b2", "mss", at="lhclength-(1614.4097+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250278.0, assembly_id=102451.0))
lhcb2.new("mcbh.33r2.b2", "mcbh", at="lhclength-(1615.0027+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250280.0, assembly_id=102451.0))
lhcb2.new("e.cell.23.b2", "omk", at="lhclength-(1615.7497+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a34r2.b2", "mco", at="lhclength-(1616.0937+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250282.0, assembly_id=102452.0))
lhcb2.new("mcd.a34r2.b2", "mcd", at="lhclength-(1616.0952+(-80-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250283.0, assembly_id=102452.0))
lhcb2.new("mb.a34r2.b2", "mb", at="lhclength-(1623.5797+(-79.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825666.0, assembly_id=102452.0))
lhcb2.new("mcs.a34r2.b2", "mcs", at="lhclength-(1631.0037+(-79-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243313.0, assembly_id=102452.0))
lhcb2.new("mb.b34r2.b2", "mb", at="lhclength-(1639.2397+(-78.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825690.0, assembly_id=102453.0))
lhcb2.new("mcs.b34r2.b2", "mcs", at="lhclength-(1646.6637+(-78-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243316.0, assembly_id=102453.0))
lhcb2.new("mco.b34r2.b2", "mco", at="lhclength-(1647.4137+(-78-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250286.0, assembly_id=102454.0))
lhcb2.new("mcd.b34r2.b2", "mcd", at="lhclength-(1647.4152+(-78-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=250287.0, assembly_id=102454.0))
lhcb2.new("mb.c34r2.b2", "mb", at="lhclength-(1654.8997+(-77.5-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=52825714.0, assembly_id=102454.0))
lhcb2.new("mcs.c34r2.b2", "mcs", at="lhclength-(1662.3237+(-77-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243321.0, assembly_id=102454.0))
lhcb2.new("bpm.34r2.b2", "bpm", at="lhclength-(1663.2027+(-77-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=243323.0, assembly_id=102455.0))
lhcb2.new("mo.34r2.b2", "mo", at="lhclength-(1663.9537+(-77-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2308630.0, assembly_id=102455.0))
lhcb2.new("mq.34r2.b2", "mq", at="lhclength-(1665.9647+(-77-ip2ofs.b2)*ds)", from_="ip2", extra=dict(mech_sep=0.194, slot_id=2307920.0, assembly_id=102455.0))
lhcb2.new("ms.34l3.b2", "ms", at="lhclength-(-1664.5007+(-77-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250290.0, assembly_id=102455.0))
lhcb2.new("mcbv.34l3.b2", "mcbv", at="lhclength-(-1663.9077+(-77-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250292.0, assembly_id=102455.0))
lhcb2.new("mb.c34l3.b2", "mb", at="lhclength-(-1655.3307+(-76.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825738.0, assembly_id=102456.0))
lhcb2.new("mcs.c34l3.b2", "mcs", at="lhclength-(-1647.9067+(-76-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243329.0, assembly_id=102456.0))
lhcb2.new("mco.34l3.b2", "mco", at="lhclength-(-1647.1567+(-76-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250294.0, assembly_id=102457.0))
lhcb2.new("mcd.34l3.b2", "mcd", at="lhclength-(-1647.1552+(-76-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250295.0, assembly_id=102457.0))
lhcb2.new("mb.b34l3.b2", "mb", at="lhclength-(-1639.6707+(-75.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825762.0, assembly_id=102457.0))
lhcb2.new("mcs.b34l3.b2", "mcs", at="lhclength-(-1632.2467+(-75-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243334.0, assembly_id=102457.0))
lhcb2.new("mb.a34l3.b2", "mb", at="lhclength-(-1624.0107+(-74.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825786.0, assembly_id=102458.0))
lhcb2.new("mcs.a34l3.b2", "mcs", at="lhclength-(-1616.5867+(-74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243337.0, assembly_id=102458.0))
lhcb2.new("bpm.33l3.b2", "bpm", at="lhclength-(-1615.7077+(-74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243339.0, assembly_id=102459.0))
lhcb2.new("mo.33l3.b2", "mo", at="lhclength-(-1614.9567+(-74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308602.0, assembly_id=102459.0))
lhcb2.new("mq.33l3.b2", "mq", at="lhclength-(-1612.9457+(-74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307892.0, assembly_id=102459.0))
lhcb2.new("mss.33l3.b2", "mss", at="lhclength-(-1611.0507+(-74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250298.0, assembly_id=102459.0))
lhcb2.new("mcbh.33l3.b2", "mcbh", at="lhclength-(-1610.4577+(-74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250300.0, assembly_id=102459.0))
lhcb2.new("mco.b33l3.b2", "mco", at="lhclength-(-1609.3667+(-74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250302.0, assembly_id=102460.0))
lhcb2.new("mcd.b33l3.b2", "mcd", at="lhclength-(-1609.3652+(-74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250303.0, assembly_id=102460.0))
lhcb2.new("mb.c33l3.b2", "mb", at="lhclength-(-1601.8807+(-73.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825810.0, assembly_id=102460.0))
lhcb2.new("mcs.c33l3.b2", "mcs", at="lhclength-(-1594.4567+(-73-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243347.0, assembly_id=102460.0))
lhcb2.new("mb.b33l3.b2", "mb", at="lhclength-(-1586.2207+(-72.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825834.0, assembly_id=102461.0))
lhcb2.new("mcs.b33l3.b2", "mcs", at="lhclength-(-1578.7967+(-72-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243350.0, assembly_id=102461.0))
lhcb2.new("mco.a33l3.b2", "mco", at="lhclength-(-1578.0467+(-72-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250306.0, assembly_id=102462.0))
lhcb2.new("mcd.a33l3.b2", "mcd", at="lhclength-(-1578.0452+(-72-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250307.0, assembly_id=102462.0))
lhcb2.new("mb.a33l3.b2", "mb", at="lhclength-(-1570.5607+(-71.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825858.0, assembly_id=102462.0))
lhcb2.new("mcs.a33l3.b2", "mcs", at="lhclength-(-1563.1367+(-71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243355.0, assembly_id=102462.0))
lhcb2.new("bpm.32l3.b2", "bpm", at="lhclength-(-1562.2577+(-71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243357.0, assembly_id=102463.0))
lhcb2.new("mo.32l3.b2", "mo", at="lhclength-(-1561.5067+(-71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308570.0, assembly_id=102463.0))
lhcb2.new("mq.32l3.b2", "mq", at="lhclength-(-1559.4957+(-71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307862.0, assembly_id=102463.0))
lhcb2.new("ms.32l3.b2", "ms", at="lhclength-(-1557.6007+(-71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250310.0, assembly_id=102463.0))
lhcb2.new("mcbv.32l3.b2", "mcbv", at="lhclength-(-1557.0077+(-71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250312.0, assembly_id=102463.0))
lhcb2.new("mb.c32l3.b2", "mb", at="lhclength-(-1548.4307+(-70.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825882.0, assembly_id=102464.0))
lhcb2.new("mcs.c32l3.b2", "mcs", at="lhclength-(-1541.0067+(-70-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243363.0, assembly_id=102464.0))
lhcb2.new("mco.32l3.b2", "mco", at="lhclength-(-1540.2567+(-70-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250314.0, assembly_id=102465.0))
lhcb2.new("mcd.32l3.b2", "mcd", at="lhclength-(-1540.2552+(-70-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250315.0, assembly_id=102465.0))
lhcb2.new("mb.b32l3.b2", "mb", at="lhclength-(-1532.7707+(-69.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825906.0, assembly_id=102465.0))
lhcb2.new("mcs.b32l3.b2", "mcs", at="lhclength-(-1525.3467+(-69-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243368.0, assembly_id=102465.0))
lhcb2.new("mb.a32l3.b2", "mb", at="lhclength-(-1517.1107+(-68.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825930.0, assembly_id=102466.0))
lhcb2.new("mcs.a32l3.b2", "mcs", at="lhclength-(-1509.6867+(-68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243371.0, assembly_id=102466.0))
lhcb2.new("bpm.31l3.b2", "bpm", at="lhclength-(-1508.8077+(-68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243373.0, assembly_id=102467.0))
lhcb2.new("mo.31l3.b2", "mo", at="lhclength-(-1508.0567+(-68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308779.0, assembly_id=102467.0))
lhcb2.new("mq.31l3.b2", "mq", at="lhclength-(-1506.0457+(-68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2348468.0, assembly_id=102467.0))
lhcb2.new("ms.31l3.b2", "ms", at="lhclength-(-1504.1507+(-68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250318.0, assembly_id=102467.0))
lhcb2.new("mcbh.31l3.b2", "mcbh", at="lhclength-(-1503.5577+(-68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250320.0, assembly_id=102467.0))
lhcb2.new("mco.b31l3.b2", "mco", at="lhclength-(-1502.4667+(-68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250322.0, assembly_id=102468.0))
lhcb2.new("mcd.b31l3.b2", "mcd", at="lhclength-(-1502.4652+(-68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250323.0, assembly_id=102468.0))
lhcb2.new("mb.c31l3.b2", "mb", at="lhclength-(-1494.9807+(-67.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825954.0, assembly_id=102468.0))
lhcb2.new("mcs.c31l3.b2", "mcs", at="lhclength-(-1487.5567+(-67-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243381.0, assembly_id=102468.0))
lhcb2.new("mb.b31l3.b2", "mb", at="lhclength-(-1479.3207+(-66.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52825978.0, assembly_id=102469.0))
lhcb2.new("mcs.b31l3.b2", "mcs", at="lhclength-(-1471.8967+(-66-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243384.0, assembly_id=102469.0))
lhcb2.new("mco.a31l3.b2", "mco", at="lhclength-(-1471.1467+(-66-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250326.0, assembly_id=102470.0))
lhcb2.new("mcd.a31l3.b2", "mcd", at="lhclength-(-1471.1452+(-66-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250327.0, assembly_id=102470.0))
lhcb2.new("mb.a31l3.b2", "mb", at="lhclength-(-1463.6607+(-65.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826002.0, assembly_id=102470.0))
lhcb2.new("mcs.a31l3.b2", "mcs", at="lhclength-(-1456.2367+(-65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243389.0, assembly_id=102470.0))
lhcb2.new("bpm.30l3.b2", "bpm", at="lhclength-(-1455.3577+(-65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243391.0, assembly_id=102471.0))
lhcb2.new("mo.30l3.b2", "mo", at="lhclength-(-1454.6067+(-65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308749.0, assembly_id=102471.0))
lhcb2.new("mq.30l3.b2", "mq", at="lhclength-(-1452.5957+(-65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308041.0, assembly_id=102471.0))
lhcb2.new("ms.30l3.b2", "ms", at="lhclength-(-1450.7007+(-65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250330.0, assembly_id=102471.0))
lhcb2.new("mcbv.30l3.b2", "mcbv", at="lhclength-(-1450.1077+(-65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250332.0, assembly_id=102471.0))
lhcb2.new("mb.c30l3.b2", "mb", at="lhclength-(-1441.5307+(-64.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826026.0, assembly_id=102472.0))
lhcb2.new("mcs.c30l3.b2", "mcs", at="lhclength-(-1434.1067+(-64-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243397.0, assembly_id=102472.0))
lhcb2.new("mco.30l3.b2", "mco", at="lhclength-(-1433.3567+(-64-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250334.0, assembly_id=102473.0))
lhcb2.new("mcd.30l3.b2", "mcd", at="lhclength-(-1433.3552+(-64-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250335.0, assembly_id=102473.0))
lhcb2.new("mb.b30l3.b2", "mb", at="lhclength-(-1425.8707+(-63.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826050.0, assembly_id=102473.0))
lhcb2.new("mcs.b30l3.b2", "mcs", at="lhclength-(-1418.4467+(-63-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243402.0, assembly_id=102473.0))
lhcb2.new("mb.a30l3.b2", "mb", at="lhclength-(-1410.2107+(-62.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826074.0, assembly_id=102474.0))
lhcb2.new("mcs.a30l3.b2", "mcs", at="lhclength-(-1402.7867+(-62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243405.0, assembly_id=102474.0))
lhcb2.new("bpm.29l3.b2", "bpm", at="lhclength-(-1401.9077+(-62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243407.0, assembly_id=102475.0))
lhcb2.new("mo.29l3.b2", "mo", at="lhclength-(-1401.1567+(-62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308717.0, assembly_id=102475.0))
lhcb2.new("mq.29l3.b2", "mq", at="lhclength-(-1399.1457+(-62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308011.0, assembly_id=102475.0))
lhcb2.new("mss.29l3.b2", "mss", at="lhclength-(-1397.2507+(-62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250338.0, assembly_id=102475.0))
lhcb2.new("mcbh.29l3.b2", "mcbh", at="lhclength-(-1396.6577+(-62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250340.0, assembly_id=102475.0))
lhcb2.new("mco.b29l3.b2", "mco", at="lhclength-(-1395.5667+(-62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250342.0, assembly_id=102476.0))
lhcb2.new("mcd.b29l3.b2", "mcd", at="lhclength-(-1395.5652+(-62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250343.0, assembly_id=102476.0))
lhcb2.new("mb.c29l3.b2", "mb", at="lhclength-(-1388.0807+(-61.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826098.0, assembly_id=102476.0))
lhcb2.new("mcs.c29l3.b2", "mcs", at="lhclength-(-1380.6567+(-61-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243415.0, assembly_id=102476.0))
lhcb2.new("mb.b29l3.b2", "mb", at="lhclength-(-1372.4207+(-60.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826122.0, assembly_id=102477.0))
lhcb2.new("mcs.b29l3.b2", "mcs", at="lhclength-(-1364.9967+(-60-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243418.0, assembly_id=102477.0))
lhcb2.new("mco.a29l3.b2", "mco", at="lhclength-(-1364.2467+(-60-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250346.0, assembly_id=102478.0))
lhcb2.new("mcd.a29l3.b2", "mcd", at="lhclength-(-1364.2452+(-60-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250347.0, assembly_id=102478.0))
lhcb2.new("mb.a29l3.b2", "mb", at="lhclength-(-1356.7607+(-59.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826146.0, assembly_id=102478.0))
lhcb2.new("mcs.a29l3.b2", "mcs", at="lhclength-(-1349.3367+(-59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243423.0, assembly_id=102478.0))
lhcb2.new("bpm.28l3.b2", "bpm", at="lhclength-(-1348.4577+(-59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243425.0, assembly_id=102479.0))
lhcb2.new("mo.28l3.b2", "mo", at="lhclength-(-1347.7067+(-59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308686.0, assembly_id=102479.0))
lhcb2.new("mq.28l3.b2", "mq", at="lhclength-(-1345.6957+(-59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307979.0, assembly_id=102479.0))
lhcb2.new("ms.28l3.b2", "ms", at="lhclength-(-1343.8007+(-59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250350.0, assembly_id=102479.0))
lhcb2.new("mcbv.28l3.b2", "mcbv", at="lhclength-(-1343.2077+(-59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250352.0, assembly_id=102479.0))
lhcb2.new("mb.c28l3.b2", "mb", at="lhclength-(-1334.6307+(-58.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826170.0, assembly_id=102480.0))
lhcb2.new("mcs.c28l3.b2", "mcs", at="lhclength-(-1327.2067+(-58-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243431.0, assembly_id=102480.0))
lhcb2.new("mco.28l3.b2", "mco", at="lhclength-(-1326.4567+(-58-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250354.0, assembly_id=102481.0))
lhcb2.new("mcd.28l3.b2", "mcd", at="lhclength-(-1326.4552+(-58-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250355.0, assembly_id=102481.0))
lhcb2.new("mb.b28l3.b2", "mb", at="lhclength-(-1318.9707+(-57.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826194.0, assembly_id=102481.0))
lhcb2.new("mcs.b28l3.b2", "mcs", at="lhclength-(-1311.5467+(-57-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243436.0, assembly_id=102481.0))
lhcb2.new("mb.a28l3.b2", "mb", at="lhclength-(-1303.3107+(-56.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826218.0, assembly_id=102482.0))
lhcb2.new("mcs.a28l3.b2", "mcs", at="lhclength-(-1295.8867+(-56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243439.0, assembly_id=102482.0))
lhcb2.new("bpm.27l3.b2", "bpm", at="lhclength-(-1295.0077+(-56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=266504.0, assembly_id=102483.0))
lhcb2.new("mqs.27l3.b2", "mqs", at="lhclength-(-1294.2537+(-56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307656.0, assembly_id=102483.0))
lhcb2.new("mq.27l3.b2", "mq", at="lhclength-(-1292.2457+(-56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308189.0, assembly_id=102483.0))
lhcb2.new("ms.27l3.b2", "ms", at="lhclength-(-1290.3507+(-56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250358.0, assembly_id=102483.0))
lhcb2.new("mcbh.27l3.b2", "mcbh", at="lhclength-(-1289.7577+(-56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250360.0, assembly_id=102483.0))
lhcb2.new("mco.b27l3.b2", "mco", at="lhclength-(-1288.6667+(-56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250362.0, assembly_id=102484.0))
lhcb2.new("mcd.b27l3.b2", "mcd", at="lhclength-(-1288.6652+(-56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250363.0, assembly_id=102484.0))
lhcb2.new("mb.c27l3.b2", "mb", at="lhclength-(-1281.1807+(-55.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826242.0, assembly_id=102484.0))
lhcb2.new("mcs.c27l3.b2", "mcs", at="lhclength-(-1273.7567+(-55-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243447.0, assembly_id=102484.0))
lhcb2.new("mb.b27l3.b2", "mb", at="lhclength-(-1265.5207+(-54.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826266.0, assembly_id=102485.0))
lhcb2.new("mcs.b27l3.b2", "mcs", at="lhclength-(-1258.0967+(-54-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243450.0, assembly_id=102485.0))
lhcb2.new("mco.a27l3.b2", "mco", at="lhclength-(-1257.3467+(-54-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250366.0, assembly_id=102486.0))
lhcb2.new("mcd.a27l3.b2", "mcd", at="lhclength-(-1257.3452+(-54-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250367.0, assembly_id=102486.0))
lhcb2.new("mb.a27l3.b2", "mb", at="lhclength-(-1249.8607+(-53.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826290.0, assembly_id=102486.0))
lhcb2.new("mcs.a27l3.b2", "mcs", at="lhclength-(-1242.4367+(-53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243455.0, assembly_id=102486.0))
lhcb2.new("bpm.26l3.b2", "bpm", at="lhclength-(-1241.5577+(-53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243457.0, assembly_id=102487.0))
lhcb2.new("mo.26l3.b2", "mo", at="lhclength-(-1240.8067+(-53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308896.0, assembly_id=102487.0))
lhcb2.new("mq.26l3.b2", "mq", at="lhclength-(-1238.7957+(-53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308159.0, assembly_id=102487.0))
lhcb2.new("ms.26l3.b2", "ms", at="lhclength-(-1236.9007+(-53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250370.0, assembly_id=102487.0))
lhcb2.new("mcbv.26l3.b2", "mcbv", at="lhclength-(-1236.3077+(-53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250372.0, assembly_id=102487.0))
lhcb2.new("mb.c26l3.b2", "mb", at="lhclength-(-1227.7307+(-52.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826314.0, assembly_id=102488.0))
lhcb2.new("mcs.c26l3.b2", "mcs", at="lhclength-(-1220.3067+(-52-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243463.0, assembly_id=102488.0))
lhcb2.new("mco.26l3.b2", "mco", at="lhclength-(-1219.5567+(-52-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250374.0, assembly_id=102489.0))
lhcb2.new("mcd.26l3.b2", "mcd", at="lhclength-(-1219.5552+(-52-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250375.0, assembly_id=102489.0))
lhcb2.new("mb.b26l3.b2", "mb", at="lhclength-(-1212.0707+(-51.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826338.0, assembly_id=102489.0))
lhcb2.new("mcs.b26l3.b2", "mcs", at="lhclength-(-1204.6467+(-51-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243468.0, assembly_id=102489.0))
lhcb2.new("mb.a26l3.b2", "mb", at="lhclength-(-1196.4107+(-50.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826362.0, assembly_id=102490.0))
lhcb2.new("mcs.a26l3.b2", "mcs", at="lhclength-(-1188.9867+(-50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243471.0, assembly_id=102490.0))
lhcb2.new("bpm.25l3.b2", "bpm", at="lhclength-(-1188.1077+(-50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243473.0, assembly_id=102491.0))
lhcb2.new("mo.25l3.b2", "mo", at="lhclength-(-1187.3567+(-50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308864.0, assembly_id=102491.0))
lhcb2.new("mq.25l3.b2", "mq", at="lhclength-(-1185.3457+(-50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308127.0, assembly_id=102491.0))
lhcb2.new("ms.25l3.b2", "ms", at="lhclength-(-1183.4507+(-50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250378.0, assembly_id=102491.0))
lhcb2.new("mcbh.25l3.b2", "mcbh", at="lhclength-(-1182.8577+(-50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250380.0, assembly_id=102491.0))
lhcb2.new("mco.b25l3.b2", "mco", at="lhclength-(-1181.7667+(-50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250382.0, assembly_id=102492.0))
lhcb2.new("mcd.b25l3.b2", "mcd", at="lhclength-(-1181.7652+(-50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250383.0, assembly_id=102492.0))
lhcb2.new("mb.c25l3.b2", "mb", at="lhclength-(-1174.2807+(-49.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826386.0, assembly_id=102492.0))
lhcb2.new("mcs.c25l3.b2", "mcs", at="lhclength-(-1166.8567+(-49-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243481.0, assembly_id=102492.0))
lhcb2.new("mb.b25l3.b2", "mb", at="lhclength-(-1158.6207+(-48.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826410.0, assembly_id=102493.0))
lhcb2.new("mcs.b25l3.b2", "mcs", at="lhclength-(-1151.1967+(-48-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243484.0, assembly_id=102493.0))
lhcb2.new("mco.a25l3.b2", "mco", at="lhclength-(-1150.4467+(-48-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250386.0, assembly_id=102494.0))
lhcb2.new("mcd.a25l3.b2", "mcd", at="lhclength-(-1150.4452+(-48-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250387.0, assembly_id=102494.0))
lhcb2.new("mb.a25l3.b2", "mb", at="lhclength-(-1142.9607+(-47.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826434.0, assembly_id=102494.0))
lhcb2.new("mcs.a25l3.b2", "mcs", at="lhclength-(-1135.5367+(-47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243489.0, assembly_id=102494.0))
lhcb2.new("bpm.24l3.b2", "bpm", at="lhclength-(-1134.6577+(-47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243491.0, assembly_id=102495.0))
lhcb2.new("mo.24l3.b2", "mo", at="lhclength-(-1133.9067+(-47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308833.0, assembly_id=102495.0))
lhcb2.new("mq.24l3.b2", "mq", at="lhclength-(-1131.8957+(-47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308095.0, assembly_id=102495.0))
lhcb2.new("ms.24l3.b2", "ms", at="lhclength-(-1130.0007+(-47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250390.0, assembly_id=102495.0))
lhcb2.new("mcbv.24l3.b2", "mcbv", at="lhclength-(-1129.4077+(-47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250392.0, assembly_id=102495.0))
lhcb2.new("mb.c24l3.b2", "mb", at="lhclength-(-1120.8307+(-46.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826458.0, assembly_id=102496.0))
lhcb2.new("mcs.c24l3.b2", "mcs", at="lhclength-(-1113.4067+(-46-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243497.0, assembly_id=102496.0))
lhcb2.new("mco.24l3.b2", "mco", at="lhclength-(-1112.6567+(-46-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250394.0, assembly_id=102497.0))
lhcb2.new("mcd.24l3.b2", "mcd", at="lhclength-(-1112.6552+(-46-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250395.0, assembly_id=102497.0))
lhcb2.new("mb.b24l3.b2", "mb", at="lhclength-(-1105.1707+(-45.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826482.0, assembly_id=102497.0))
lhcb2.new("mcs.b24l3.b2", "mcs", at="lhclength-(-1097.7467+(-45-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243502.0, assembly_id=102497.0))
lhcb2.new("mb.a24l3.b2", "mb", at="lhclength-(-1089.5107+(-44.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826506.0, assembly_id=102498.0))
lhcb2.new("mcs.a24l3.b2", "mcs", at="lhclength-(-1082.0867+(-44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243505.0, assembly_id=102498.0))
lhcb2.new("bpm.23l3.b2", "bpm", at="lhclength-(-1081.2077+(-44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=266506.0, assembly_id=102499.0))
lhcb2.new("mqs.23l3.b2", "mqs", at="lhclength-(-1080.4537+(-44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307625.0, assembly_id=102499.0))
lhcb2.new("mq.23l3.b2", "mq", at="lhclength-(-1078.4457+(-44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308306.0, assembly_id=102499.0))
lhcb2.new("ms.23l3.b2", "ms", at="lhclength-(-1076.5507+(-44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250398.0, assembly_id=102499.0))
lhcb2.new("mcbh.23l3.b2", "mcbh", at="lhclength-(-1075.9577+(-44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250400.0, assembly_id=102499.0))
lhcb2.new("mco.b23l3.b2", "mco", at="lhclength-(-1074.8667+(-44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250402.0, assembly_id=102500.0))
lhcb2.new("mcd.b23l3.b2", "mcd", at="lhclength-(-1074.8652+(-44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250403.0, assembly_id=102500.0))
lhcb2.new("mb.c23l3.b2", "mb", at="lhclength-(-1067.3807+(-43.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826530.0, assembly_id=102500.0))
lhcb2.new("mcs.c23l3.b2", "mcs", at="lhclength-(-1059.9567+(-43-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243513.0, assembly_id=102500.0))
lhcb2.new("mb.b23l3.b2", "mb", at="lhclength-(-1051.7207+(-42.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826554.0, assembly_id=102501.0))
lhcb2.new("mcs.b23l3.b2", "mcs", at="lhclength-(-1044.2967+(-42-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243516.0, assembly_id=102501.0))
lhcb2.new("mco.a23l3.b2", "mco", at="lhclength-(-1043.5467+(-42-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250406.0, assembly_id=102502.0))
lhcb2.new("mcd.a23l3.b2", "mcd", at="lhclength-(-1043.5452+(-42-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250407.0, assembly_id=102502.0))
lhcb2.new("mb.a23l3.b2", "mb", at="lhclength-(-1036.0607+(-41.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826578.0, assembly_id=102502.0))
lhcb2.new("mcs.a23l3.b2", "mcs", at="lhclength-(-1028.6367+(-41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243521.0, assembly_id=102502.0))
lhcb2.new("bpm.22l3.b2", "bpm", at="lhclength-(-1027.7577+(-41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243523.0, assembly_id=102503.0))
lhcb2.new("mo.22l3.b2", "mo", at="lhclength-(-1027.0067+(-41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2309040.0, assembly_id=102503.0))
lhcb2.new("mq.22l3.b2", "mq", at="lhclength-(-1024.9957+(-41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308274.0, assembly_id=102503.0))
lhcb2.new("ms.22l3.b2", "ms", at="lhclength-(-1023.1007+(-41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250410.0, assembly_id=102503.0))
lhcb2.new("mcbv.22l3.b2", "mcbv", at="lhclength-(-1022.5077+(-41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250412.0, assembly_id=102503.0))
lhcb2.new("mb.c22l3.b2", "mb", at="lhclength-(-1013.9307+(-40.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826602.0, assembly_id=102504.0))
lhcb2.new("mcs.c22l3.b2", "mcs", at="lhclength-(-1006.5067+(-40-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243529.0, assembly_id=102504.0))
lhcb2.new("mco.22l3.b2", "mco", at="lhclength-(-1005.7567+(-40-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250414.0, assembly_id=102505.0))
lhcb2.new("mcd.22l3.b2", "mcd", at="lhclength-(-1005.7552+(-40-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250415.0, assembly_id=102505.0))
lhcb2.new("mb.b22l3.b2", "mb", at="lhclength-(-998.2707+(-39.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826626.0, assembly_id=102505.0))
lhcb2.new("mcs.b22l3.b2", "mcs", at="lhclength-(-990.8467+(-39-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243534.0, assembly_id=102505.0))
lhcb2.new("mb.a22l3.b2", "mb", at="lhclength-(-982.6107+(-38.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826650.0, assembly_id=102506.0))
lhcb2.new("mcs.a22l3.b2", "mcs", at="lhclength-(-975.1867+(-38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243537.0, assembly_id=102506.0))
lhcb2.new("bpm.21l3.b2", "bpm", at="lhclength-(-974.3077+(-38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243539.0, assembly_id=102507.0))
lhcb2.new("mqt.21l3.b2", "mqt", at="lhclength-(-973.5537+(-38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307258.0, assembly_id=102507.0))
lhcb2.new("mq.21l3.b2", "mq", at="lhclength-(-971.5457+(-38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308243.0, assembly_id=102507.0))
lhcb2.new("ms.21l3.b2", "ms", at="lhclength-(-969.6507+(-38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250418.0, assembly_id=102507.0))
lhcb2.new("mcbh.21l3.b2", "mcbh", at="lhclength-(-969.0577+(-38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250420.0, assembly_id=102507.0))
lhcb2.new("mco.b21l3.b2", "mco", at="lhclength-(-967.9667+(-38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250422.0, assembly_id=102508.0))
lhcb2.new("mcd.b21l3.b2", "mcd", at="lhclength-(-967.9652+(-38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250423.0, assembly_id=102508.0))
lhcb2.new("mb.c21l3.b2", "mb", at="lhclength-(-960.4807+(-37.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826674.0, assembly_id=102508.0))
lhcb2.new("mcs.c21l3.b2", "mcs", at="lhclength-(-953.0567+(-37-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243547.0, assembly_id=102508.0))
lhcb2.new("mb.b21l3.b2", "mb", at="lhclength-(-944.8207+(-36.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826698.0, assembly_id=102509.0))
lhcb2.new("mcs.b21l3.b2", "mcs", at="lhclength-(-937.3967+(-36-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243550.0, assembly_id=102509.0))
lhcb2.new("mco.a21l3.b2", "mco", at="lhclength-(-936.6467+(-36-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250426.0, assembly_id=102510.0))
lhcb2.new("mcd.a21l3.b2", "mcd", at="lhclength-(-936.6452+(-36-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250427.0, assembly_id=102510.0))
lhcb2.new("mb.a21l3.b2", "mb", at="lhclength-(-929.1607+(-35.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826722.0, assembly_id=102510.0))
lhcb2.new("mcs.a21l3.b2", "mcs", at="lhclength-(-921.7367+(-35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243555.0, assembly_id=102510.0))
lhcb2.new("bpm.20l3.b2", "bpm", at="lhclength-(-920.8577+(-35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243557.0, assembly_id=102511.0))
lhcb2.new("mqt.20l3.b2", "mqt", at="lhclength-(-920.1037+(-35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307461.0, assembly_id=102511.0))
lhcb2.new("mq.20l3.b2", "mq", at="lhclength-(-918.0957+(-35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308213.0, assembly_id=102511.0))
lhcb2.new("ms.20l3.b2", "ms", at="lhclength-(-916.2007+(-35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250430.0, assembly_id=102511.0))
lhcb2.new("mcbv.20l3.b2", "mcbv", at="lhclength-(-915.6077+(-35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250432.0, assembly_id=102511.0))
lhcb2.new("mb.c20l3.b2", "mb", at="lhclength-(-907.0307+(-34.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826746.0, assembly_id=102512.0))
lhcb2.new("mcs.c20l3.b2", "mcs", at="lhclength-(-899.6067+(-34-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243563.0, assembly_id=102512.0))
lhcb2.new("mco.20l3.b2", "mco", at="lhclength-(-898.8567+(-34-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250434.0, assembly_id=102513.0))
lhcb2.new("mcd.20l3.b2", "mcd", at="lhclength-(-898.8552+(-34-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250435.0, assembly_id=102513.0))
lhcb2.new("mb.b20l3.b2", "mb", at="lhclength-(-891.3707+(-33.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826770.0, assembly_id=102513.0))
lhcb2.new("mcs.b20l3.b2", "mcs", at="lhclength-(-883.9467+(-33-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243568.0, assembly_id=102513.0))
lhcb2.new("mb.a20l3.b2", "mb", at="lhclength-(-875.7107+(-32.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826794.0, assembly_id=102514.0))
lhcb2.new("mcs.a20l3.b2", "mcs", at="lhclength-(-868.2867+(-32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243571.0, assembly_id=102514.0))
lhcb2.new("bpm.19l3.b2", "bpm", at="lhclength-(-867.4077+(-32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243573.0, assembly_id=102515.0))
lhcb2.new("mqt.19l3.b2", "mqt", at="lhclength-(-866.6537+(-32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307432.0, assembly_id=102515.0))
lhcb2.new("mq.19l3.b2", "mq", at="lhclength-(-864.6457+(-32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308421.0, assembly_id=102515.0))
lhcb2.new("ms.19l3.b2", "ms", at="lhclength-(-862.7507+(-32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250438.0, assembly_id=102515.0))
lhcb2.new("mcbh.19l3.b2", "mcbh", at="lhclength-(-862.1577+(-32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250440.0, assembly_id=102515.0))
lhcb2.new("mco.b19l3.b2", "mco", at="lhclength-(-861.0667+(-32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250442.0, assembly_id=102516.0))
lhcb2.new("mcd.b19l3.b2", "mcd", at="lhclength-(-861.0652+(-32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250443.0, assembly_id=102516.0))
lhcb2.new("mb.c19l3.b2", "mb", at="lhclength-(-853.5807+(-31.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826818.0, assembly_id=102516.0))
lhcb2.new("mcs.c19l3.b2", "mcs", at="lhclength-(-846.1567+(-31-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243581.0, assembly_id=102516.0))
lhcb2.new("mb.b19l3.b2", "mb", at="lhclength-(-837.9207+(-30.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826842.0, assembly_id=102517.0))
lhcb2.new("mcs.b19l3.b2", "mcs", at="lhclength-(-830.4967+(-30-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243584.0, assembly_id=102517.0))
lhcb2.new("mco.a19l3.b2", "mco", at="lhclength-(-829.7467+(-30-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250446.0, assembly_id=102518.0))
lhcb2.new("mcd.a19l3.b2", "mcd", at="lhclength-(-829.7452+(-30-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250447.0, assembly_id=102518.0))
lhcb2.new("mb.a19l3.b2", "mb", at="lhclength-(-822.2607+(-29.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826866.0, assembly_id=102518.0))
lhcb2.new("mcs.a19l3.b2", "mcs", at="lhclength-(-814.8367+(-29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243589.0, assembly_id=102518.0))
lhcb2.new("bpm.18l3.b2", "bpm", at="lhclength-(-813.9577+(-29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243591.0, assembly_id=102519.0))
lhcb2.new("mqt.18l3.b2", "mqt", at="lhclength-(-813.2037+(-29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307400.0, assembly_id=102519.0))
lhcb2.new("mq.18l3.b2", "mq", at="lhclength-(-811.1957+(-29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308390.0, assembly_id=102519.0))
lhcb2.new("ms.18l3.b2", "ms", at="lhclength-(-809.3007+(-29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250450.0, assembly_id=102519.0))
lhcb2.new("mcbv.18l3.b2", "mcbv", at="lhclength-(-808.7077+(-29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250452.0, assembly_id=102519.0))
lhcb2.new("mb.c18l3.b2", "mb", at="lhclength-(-800.1307+(-28.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826890.0, assembly_id=102520.0))
lhcb2.new("mcs.c18l3.b2", "mcs", at="lhclength-(-792.7067+(-28-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243597.0, assembly_id=102520.0))
lhcb2.new("mco.18l3.b2", "mco", at="lhclength-(-791.9567+(-28-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250454.0, assembly_id=102521.0))
lhcb2.new("mcd.18l3.b2", "mcd", at="lhclength-(-791.9552+(-28-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250455.0, assembly_id=102521.0))
lhcb2.new("mb.b18l3.b2", "mb", at="lhclength-(-784.4707+(-27.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826914.0, assembly_id=102521.0))
lhcb2.new("mcs.b18l3.b2", "mcs", at="lhclength-(-777.0467+(-27-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243602.0, assembly_id=102521.0))
lhcb2.new("mb.a18l3.b2", "mb", at="lhclength-(-768.8107+(-26.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826938.0, assembly_id=102522.0))
lhcb2.new("mcs.a18l3.b2", "mcs", at="lhclength-(-761.3867+(-26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243605.0, assembly_id=102522.0))
lhcb2.new("bpm.17l3.b2", "bpm", at="lhclength-(-760.5077+(-26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243607.0, assembly_id=102523.0))
lhcb2.new("mqt.17l3.b2", "mqt", at="lhclength-(-759.7537+(-26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307605.0, assembly_id=102523.0))
lhcb2.new("mq.17l3.b2", "mq", at="lhclength-(-757.7457+(-26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308360.0, assembly_id=102523.0))
lhcb2.new("ms.17l3.b2", "ms", at="lhclength-(-755.8507+(-26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250458.0, assembly_id=102523.0))
lhcb2.new("mcbh.17l3.b2", "mcbh", at="lhclength-(-755.2577+(-26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250460.0, assembly_id=102523.0))
lhcb2.new("mco.b17l3.b2", "mco", at="lhclength-(-754.1667+(-26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250462.0, assembly_id=102524.0))
lhcb2.new("mcd.b17l3.b2", "mcd", at="lhclength-(-754.1652+(-26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250463.0, assembly_id=102524.0))
lhcb2.new("mb.c17l3.b2", "mb", at="lhclength-(-746.6807+(-25.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826962.0, assembly_id=102524.0))
lhcb2.new("mcs.c17l3.b2", "mcs", at="lhclength-(-739.2567+(-25-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243615.0, assembly_id=102524.0))
lhcb2.new("mb.b17l3.b2", "mb", at="lhclength-(-731.0207+(-24.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52826986.0, assembly_id=102525.0))
lhcb2.new("mcs.b17l3.b2", "mcs", at="lhclength-(-723.5967+(-24-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243618.0, assembly_id=102525.0))
lhcb2.new("mco.a17l3.b2", "mco", at="lhclength-(-722.8467+(-24-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250466.0, assembly_id=102526.0))
lhcb2.new("mcd.a17l3.b2", "mcd", at="lhclength-(-722.8452+(-24-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250467.0, assembly_id=102526.0))
lhcb2.new("mb.a17l3.b2", "mb", at="lhclength-(-715.3607+(-23.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827010.0, assembly_id=102526.0))
lhcb2.new("mcs.a17l3.b2", "mcs", at="lhclength-(-707.9367+(-23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243623.0, assembly_id=102526.0))
lhcb2.new("bpm.16l3.b2", "bpm", at="lhclength-(-707.0577+(-23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243625.0, assembly_id=102527.0))
lhcb2.new("mqt.16l3.b2", "mqt", at="lhclength-(-706.3037+(-23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307575.0, assembly_id=102527.0))
lhcb2.new("mq.16l3.b2", "mq", at="lhclength-(-704.2957+(-23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308330.0, assembly_id=102527.0))
lhcb2.new("ms.16l3.b2", "ms", at="lhclength-(-702.4007+(-23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250470.0, assembly_id=102527.0))
lhcb2.new("mcbv.16l3.b2", "mcbv", at="lhclength-(-701.8077+(-23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250472.0, assembly_id=102527.0))
lhcb2.new("mb.c16l3.b2", "mb", at="lhclength-(-693.2307+(-22.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827034.0, assembly_id=102528.0))
lhcb2.new("mcs.c16l3.b2", "mcs", at="lhclength-(-685.8067+(-22-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243631.0, assembly_id=102528.0))
lhcb2.new("mco.16l3.b2", "mco", at="lhclength-(-685.0567+(-22-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250474.0, assembly_id=102529.0))
lhcb2.new("mcd.16l3.b2", "mcd", at="lhclength-(-685.0552+(-22-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250475.0, assembly_id=102529.0))
lhcb2.new("mb.b16l3.b2", "mb", at="lhclength-(-677.5707+(-21.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827058.0, assembly_id=102529.0))
lhcb2.new("mcs.b16l3.b2", "mcs", at="lhclength-(-670.1467+(-21-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243636.0, assembly_id=102529.0))
lhcb2.new("mb.a16l3.b2", "mb", at="lhclength-(-661.9107+(-20.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827082.0, assembly_id=102530.0))
lhcb2.new("mcs.a16l3.b2", "mcs", at="lhclength-(-654.4867+(-20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243639.0, assembly_id=102530.0))
lhcb2.new("bpm.15l3.b2", "bpm", at="lhclength-(-653.6077+(-20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243641.0, assembly_id=102531.0))
lhcb2.new("mqt.15l3.b2", "mqt", at="lhclength-(-652.8537+(-20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307544.0, assembly_id=102531.0))
lhcb2.new("mq.15l3.b2", "mq", at="lhclength-(-650.8457+(-20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308537.0, assembly_id=102531.0))
lhcb2.new("ms.15l3.b2", "ms", at="lhclength-(-648.9507+(-20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250478.0, assembly_id=102531.0))
lhcb2.new("mcbh.15l3.b2", "mcbh", at="lhclength-(-648.3577+(-20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250480.0, assembly_id=102531.0))
lhcb2.new("mco.b15l3.b2", "mco", at="lhclength-(-647.2667+(-20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250482.0, assembly_id=102532.0))
lhcb2.new("mcd.b15l3.b2", "mcd", at="lhclength-(-647.2652+(-20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250483.0, assembly_id=102532.0))
lhcb2.new("mb.c15l3.b2", "mb", at="lhclength-(-639.7807+(-19.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827106.0, assembly_id=102532.0))
lhcb2.new("mcs.c15l3.b2", "mcs", at="lhclength-(-632.3567+(-19-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243649.0, assembly_id=102532.0))
lhcb2.new("mb.b15l3.b2", "mb", at="lhclength-(-624.1207+(-18.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827130.0, assembly_id=102533.0))
lhcb2.new("mcs.b15l3.b2", "mcs", at="lhclength-(-616.6967+(-18-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243652.0, assembly_id=102533.0))
lhcb2.new("mco.a15l3.b2", "mco", at="lhclength-(-615.9467+(-18-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250486.0, assembly_id=102534.0))
lhcb2.new("mcd.a15l3.b2", "mcd", at="lhclength-(-615.9452+(-18-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250487.0, assembly_id=102534.0))
lhcb2.new("mb.a15l3.b2", "mb", at="lhclength-(-608.4607+(-17.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827154.0, assembly_id=102534.0))
lhcb2.new("mcs.a15l3.b2", "mcs", at="lhclength-(-601.0367+(-17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243657.0, assembly_id=102534.0))
lhcb2.new("bpm.14l3.b2", "bpm", at="lhclength-(-600.1577+(-17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243659.0, assembly_id=102535.0))
lhcb2.new("mqt.14l3.b2", "mqt", at="lhclength-(-599.4037+(-17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307512.0, assembly_id=102535.0))
lhcb2.new("mq.14l3.b2", "mq", at="lhclength-(-597.3957+(-17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308507.0, assembly_id=102535.0))
lhcb2.new("ms.14l3.b2", "ms", at="lhclength-(-595.5007+(-17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250490.0, assembly_id=102535.0))
lhcb2.new("mcbv.14l3.b2", "mcbv", at="lhclength-(-594.9077+(-17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250492.0, assembly_id=102535.0))
lhcb2.new("mb.c14l3.b2", "mb", at="lhclength-(-586.3307+(-16.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827178.0, assembly_id=102536.0))
lhcb2.new("mcs.c14l3.b2", "mcs", at="lhclength-(-578.9067+(-16-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243665.0, assembly_id=102536.0))
lhcb2.new("mco.14l3.b2", "mco", at="lhclength-(-578.1567+(-16-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250494.0, assembly_id=102537.0))
lhcb2.new("mcd.14l3.b2", "mcd", at="lhclength-(-578.1552+(-16-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250495.0, assembly_id=102537.0))
lhcb2.new("mb.b14l3.b2", "mb", at="lhclength-(-570.6707+(-15.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827202.0, assembly_id=102537.0))
lhcb2.new("mcs.b14l3.b2", "mcs", at="lhclength-(-563.2467+(-15-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243670.0, assembly_id=102537.0))
lhcb2.new("mb.a14l3.b2", "mb", at="lhclength-(-555.0107+(-14.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827226.0, assembly_id=102538.0))
lhcb2.new("mcs.a14l3.b2", "mcs", at="lhclength-(-547.5867+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243673.0, assembly_id=102538.0))
lhcb2.new("s.ds.l3.b2", "omk", at="lhclength-(-547.1807+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.13l3.b2", "bpm", at="lhclength-(-546.7077+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243675.0, assembly_id=102539.0))
lhcb2.new("mqt.13l3.b2", "mqt", at="lhclength-(-545.9537+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307720.0, assembly_id=102539.0))
lhcb2.new("mq.13l3.b2", "mq", at="lhclength-(-543.9457+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308477.0, assembly_id=102539.0))
lhcb2.new("ms.13l3.b2", "ms", at="lhclength-(-542.0507+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250498.0, assembly_id=102539.0))
lhcb2.new("mcbh.13l3.b2", "mcbh", at="lhclength-(-541.4577+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250500.0, assembly_id=102539.0))
lhcb2.new("mco.b13l3.b2", "mco", at="lhclength-(-540.3667+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250502.0, assembly_id=102540.0))
lhcb2.new("mcd.b13l3.b2", "mcd", at="lhclength-(-540.3652+(-14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250503.0, assembly_id=102540.0))
lhcb2.new("mb.c13l3.b2", "mb", at="lhclength-(-532.8807+(-13.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827250.0, assembly_id=102540.0))
lhcb2.new("mcs.c13l3.b2", "mcs", at="lhclength-(-525.4567+(-13-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243683.0, assembly_id=102540.0))
lhcb2.new("mb.b13l3.b2", "mb", at="lhclength-(-517.2207+(-12.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827274.0, assembly_id=102541.0))
lhcb2.new("mcs.b13l3.b2", "mcs", at="lhclength-(-509.7967+(-12-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243686.0, assembly_id=102541.0))
lhcb2.new("mco.a13l3.b2", "mco", at="lhclength-(-509.0467+(-12-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250506.0, assembly_id=102542.0))
lhcb2.new("mcd.a13l3.b2", "mcd", at="lhclength-(-509.0452+(-12-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250507.0, assembly_id=102542.0))
lhcb2.new("mb.a13l3.b2", "mb", at="lhclength-(-501.5607+(-11.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827298.0, assembly_id=102542.0))
lhcb2.new("mcs.a13l3.b2", "mcs", at="lhclength-(-494.1367+(-11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243691.0, assembly_id=102542.0))
lhcb2.new("bpm.12l3.b2", "bpm", at="lhclength-(-493.2577+(-11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243693.0, assembly_id=102543.0))
lhcb2.new("mqt.12l3.b2", "mqt", at="lhclength-(-492.5037+(-11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307688.0, assembly_id=102543.0))
lhcb2.new("mq.12l3.b2", "mq", at="lhclength-(-490.4957+(-11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308447.0, assembly_id=102543.0))
lhcb2.new("ms.12l3.b2", "ms", at="lhclength-(-488.6007+(-11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250510.0, assembly_id=102543.0))
lhcb2.new("mcbv.12l3.b2", "mcbv", at="lhclength-(-488.0077+(-11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250512.0, assembly_id=102543.0))
lhcb2.new("mb.c12l3.b2", "mb", at="lhclength-(-479.4307+(-10.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827322.0, assembly_id=102544.0))
lhcb2.new("mcs.c12l3.b2", "mcs", at="lhclength-(-472.0067+(-10-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243699.0, assembly_id=102544.0))
lhcb2.new("mco.12l3.b2", "mco", at="lhclength-(-471.2567+(-10-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250514.0, assembly_id=102545.0))
lhcb2.new("mcd.12l3.b2", "mcd", at="lhclength-(-471.2552+(-10-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250515.0, assembly_id=102545.0))
lhcb2.new("mb.b12l3.b2", "mb", at="lhclength-(-463.7707+(-9.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827346.0, assembly_id=102545.0))
lhcb2.new("mcs.b12l3.b2", "mcs", at="lhclength-(-456.3467+(-9-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243704.0, assembly_id=102545.0))
lhcb2.new("mb.a12l3.b2", "mb", at="lhclength-(-448.1107+(-8.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827370.0, assembly_id=102546.0))
lhcb2.new("mcs.a12l3.b2", "mcs", at="lhclength-(-440.6867+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243707.0, assembly_id=102546.0))
lhcb2.new("e.arc.23.b2", "omk", at="lhclength-(-440.2807+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.11l3.b2", "bpm", at="lhclength-(-439.8077+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243709.0, assembly_id=102547.0))
lhcb2.new("mq.11l3.b2", "mq", at="lhclength-(-437.2607+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308654.0, assembly_id=102547.0))
lhcb2.new("mqtli.11l3.b2", "mqtli", at="lhclength-(-434.8917+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307342.0, assembly_id=102547.0))
lhcb2.new("ms.11l3.b2", "ms", at="lhclength-(-433.8797+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250518.0, assembly_id=102547.0))
lhcb2.new("mcbh.11l3.b2", "mcbh", at="lhclength-(-433.2867+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250520.0, assembly_id=102547.0))
lhcb2.new("lefl.11l3.b2", "lefl", at="lhclength-(-425.67735+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52997838.0, assembly_id=102548.0))
lhcb2.new("mco.11l3.b2", "mco", at="lhclength-(-418.475+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250522.0, assembly_id=102549.0))
lhcb2.new("mcd.11l3.b2", "mcd", at="lhclength-(-418.4735+(-8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250523.0, assembly_id=102549.0))
lhcb2.new("mb.b11l3.b2", "mb", at="lhclength-(-410.989+(-7.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827394.0, assembly_id=102549.0))
lhcb2.new("mcs.b11l3.b2", "mcs", at="lhclength-(-403.565+(-7-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243717.0, assembly_id=102549.0))
lhcb2.new("mb.a11l3.b2", "mb", at="lhclength-(-395.329+(-6.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827418.0, assembly_id=102550.0))
lhcb2.new("mcs.a11l3.b2", "mcs", at="lhclength-(-387.905+(-6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243720.0, assembly_id=102550.0))
lhcb2.new("bpm.10l3.b2", "bpm", at="lhclength-(-387.026+(-6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243722.0, assembly_id=102551.0))
lhcb2.new("mq.10l3.b2", "mq", at="lhclength-(-384.479+(-6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308643.0, assembly_id=102551.0))
lhcb2.new("mqtli.10l3.b2", "mqtli", at="lhclength-(-382.11+(-6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307331.0, assembly_id=102551.0))
lhcb2.new("mcbcv.10l3.b2", "mcbcv", at="lhclength-(-380.82+(-6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250526.0, assembly_id=102551.0))
lhcb2.new("mco.10l3.b2", "mco", at="lhclength-(-379.41+(-6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250528.0, assembly_id=102552.0))
lhcb2.new("mcd.10l3.b2", "mcd", at="lhclength-(-379.4085+(-6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250529.0, assembly_id=102552.0))
lhcb2.new("mb.b10l3.b2", "mb", at="lhclength-(-371.924+(-5.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827442.0, assembly_id=102552.0))
lhcb2.new("mcs.b10l3.b2", "mcs", at="lhclength-(-364.5+(-5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243730.0, assembly_id=102552.0))
lhcb2.new("mb.a10l3.b2", "mb", at="lhclength-(-356.264+(-4.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827466.0, assembly_id=102553.0))
lhcb2.new("mcs.a10l3.b2", "mcs", at="lhclength-(-348.84+(-4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243733.0, assembly_id=102553.0))
lhcb2.new("bpm.9l3.b2", "bpm", at="lhclength-(-347.96+(-4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243735.0, assembly_id=102554.0))
lhcb2.new("mq.9l3.b2", "mq", at="lhclength-(-345.413+(-4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307948.0, assembly_id=102554.0))
lhcb2.new("mqtli.b9l3.b2", "mqtli", at="lhclength-(-343.044+(-4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307158.0, assembly_id=102554.0))
lhcb2.new("mqtli.a9l3.b2", "mqtli", at="lhclength-(-341.589+(-4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307151.0, assembly_id=102554.0))
lhcb2.new("mcbch.9l3.b2", "mcbch", at="lhclength-(-340.299+(-4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250532.0, assembly_id=102554.0))
lhcb2.new("mco.9l3.b2", "mco", at="lhclength-(-338.945+(-4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250534.0, assembly_id=102555.0))
lhcb2.new("mcd.9l3.b2", "mcd", at="lhclength-(-338.9435+(-4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250535.0, assembly_id=102555.0))
lhcb2.new("mb.b9l3.b2", "mb", at="lhclength-(-331.459+(-3.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827490.0, assembly_id=102555.0))
lhcb2.new("mcs.b9l3.b2", "mcs", at="lhclength-(-324.035+(-3-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243744.0, assembly_id=102555.0))
lhcb2.new("mb.a9l3.b2", "mb", at="lhclength-(-315.799+(-2.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827514.0, assembly_id=102556.0))
lhcb2.new("mcs.a9l3.b2", "mcs", at="lhclength-(-308.375+(-2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243747.0, assembly_id=102556.0))
lhcb2.new("bpm.8l3.b2", "bpm", at="lhclength-(-307.496+(-2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243749.0, assembly_id=102557.0))
lhcb2.new("mq.8l3.b2", "mq", at="lhclength-(-304.949+(-2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2348463.0, assembly_id=102557.0))
lhcb2.new("mqtli.8l3.b2", "mqtli", at="lhclength-(-302.58+(-2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307143.0, assembly_id=102557.0))
lhcb2.new("mcbcv.8l3.b2", "mcbcv", at="lhclength-(-301.29+(-2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250538.0, assembly_id=102557.0))
lhcb2.new("mco.8l3.b2", "mco", at="lhclength-(-299.88+(-2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250540.0, assembly_id=102558.0))
lhcb2.new("mcd.8l3.b2", "mcd", at="lhclength-(-299.8785+(-2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250541.0, assembly_id=102558.0))
lhcb2.new("mb.b8l3.b2", "mb", at="lhclength-(-292.394+(-1.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827538.0, assembly_id=102558.0))
lhcb2.new("mcs.b8l3.b2", "mcs", at="lhclength-(-284.97+(-1-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243757.0, assembly_id=102558.0))
lhcb2.new("mb.a8l3.b2", "mb", at="lhclength-(-276.734+(-.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52849498.0, assembly_id=102559.0))
lhcb2.new("mcs.a8l3.b2", "mcs", at="lhclength-(-269.31+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=357298.0, assembly_id=102559.0))
lhcb2.new("e.ds.l3.b2", "omk", at="lhclength-(-268.904+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.7l3.b2", "bpm", at="lhclength-(-268.431+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243762.0, assembly_id=102560.0))
lhcb2.new("mq.7l3.b2", "mq", at="lhclength-(-265.884+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307933.0, assembly_id=102560.0))
lhcb2.new("mqtli.7l3.b2", "mqtli", at="lhclength-(-263.515+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307369.0, assembly_id=102560.0))
lhcb2.new("mcbch.7l3.b2", "mcbch", at="lhclength-(-262.225+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250544.0, assembly_id=102560.0))
lhcb2.new("dfbae.7l3.b2", "dfbae", at="lhclength-(-260.0715+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52996647.0, assembly_id=104678.0))
lhcb2.new("tcla.7l3.b2", "tcla", at="lhclength-(-250.455+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=479332.0))
lhcb2.new("btvm.7l3.b2", "btvm", at="lhclength-(-239.855+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=357148.0))
lhcb2.new("mcbcv.6l3.b2", "mcbcv", at="lhclength-(-205.73+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250546.0, assembly_id=102561.0))
lhcb2.new("mqtlh.f6l3.b2", "mqtlh", at="lhclength-(-204.439+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307324.0, assembly_id=102561.0))
lhcb2.new("mqtlh.e6l3.b2", "mqtlh", at="lhclength-(-202.983+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307316.0, assembly_id=102561.0))
lhcb2.new("mqtlh.d6l3.b2", "mqtlh", at="lhclength-(-201.527+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307309.0, assembly_id=102561.0))
lhcb2.new("mqtlh.c6l3.b2", "mqtlh", at="lhclength-(-200.072+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307301.0, assembly_id=102561.0))
lhcb2.new("mqtlh.b6l3.b2", "mqtlh", at="lhclength-(-198.617+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307294.0, assembly_id=102561.0))
lhcb2.new("mqtlh.a6l3.b2", "mqtlh", at="lhclength-(-197.162+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307286.0, assembly_id=102561.0))
lhcb2.new("bpmr.6l3.b2", "bpmr", at="lhclength-(-195.792+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=377944.0, assembly_id=102561.0))
lhcb2.new("mbw.f6l3.b2", "mbw", at="lhclength-(-191.466+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52819810.0))
lhcb2.new("mbw.e6l3.b2", "mbw", at="lhclength-(-187.231+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52819834.0))
lhcb2.new("mbw.d6l3.b2", "mbw", at="lhclength-(-182.996+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52819858.0))
lhcb2.new("tcla.6l3.b2", "tcla", at="lhclength-(-179.0495+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.2032, slot_id=479333.0))
lhcb2.new("mbw.c6l3.b2", "mbw", at="lhclength-(-164.973+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=52819882.0))
lhcb2.new("mbw.b6l3.b2", "mbw", at="lhclength-(-160.738+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=52819906.0))
lhcb2.new("mbw.a6l3.b2", "mbw", at="lhclength-(-156.503+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=52819930.0))
lhcb2.new("bpmwj.a5l3.b2", "bpmwj", at="lhclength-(-154.1635+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=6703874.0))
lhcb2.new("mqwa.e5l3.b2", "mqwa", at="lhclength-(-150.548+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303037.0))
lhcb2.new("mqwa.d5l3.b2", "mqwa", at="lhclength-(-146.748+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303038.0))
lhcb2.new("mqwa.c5l3.b2", "mqwa", at="lhclength-(-138.708+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303039.0))
lhcb2.new("mqwb.5l3.b2", "mqwb", at="lhclength-(-134.908+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2305278.0))
lhcb2.new("mqwa.b5l3.b2", "mqwa", at="lhclength-(-131.108+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303040.0))
lhcb2.new("mqwa.a5l3.b2", "mqwa", at="lhclength-(-127.308+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303041.0))
lhcb2.new("bpmw.5l3.b2", "bpmw_013", at="lhclength-(-125.1935+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=297847.0))
lhcb2.new("mcbwh.5l3.b2", "mcbwh", at="lhclength-(-123.653+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=297845.0))
lhcb2.new("tcla.b5l3.b2", "tcla", at="lhclength-(-92.5+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=479335.0))
lhcb2.new("tcla.a5l3.b2", "tcla", at="lhclength-(-90.5+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=479336.0))
lhcb2.new("tcsg.b5l3.b2", "tcsg", at="lhclength-(-60.02+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=102567.0))
lhcb2.new("tcsg.a5l3.b2", "tcsg", at="lhclength-(-54.2+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=281846.0))
lhcb2.new("bpmwe.4l3.b2", "bpmwe007", at="lhclength-(-50.0655+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=297871.0))
lhcb2.new("mqwa.e4l3.b2", "mqwa", at="lhclength-(-47.875+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303044.0))
lhcb2.new("tcsg.4l3.b2", "tcsg", at="lhclength-(-42.855+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=297868.0))
lhcb2.new("mqwa.d4l3.b2", "mqwa", at="lhclength-(-39.835+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303045.0))
lhcb2.new("mqwa.c4l3.b2", "mqwa", at="lhclength-(-36.035+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303046.0))
lhcb2.new("mqwb.4l3.b2", "mqwb", at="lhclength-(-32.235+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303043.0))
lhcb2.new("mqwa.b4l3.b2", "mqwa", at="lhclength-(-28.435+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303047.0))
lhcb2.new("mqwa.a4l3.b2", "mqwa", at="lhclength-(-24.635+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303048.0))
lhcb2.new("bpmw.4l3.b2", "bpmw_014", at="lhclength-(-22.5205+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=297861.0))
lhcb2.new("mcbwv.4l3.b2", "mcbwv", at="lhclength-(-21.03+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=297860.0))
lhcb2.new("ip3", "omk", at="lhclength-(pip3+ip3ofs.b2*ds)")
lhcb2.new("mcbwh.4r3.b2", "mcbwh", at="lhclength-(18.7+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=134547.0))
lhcb2.new("bpmw.4r3.b2", "bpmw_010", at="lhclength-(22.4445+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=182513.0))
lhcb2.new("mqwa.a4r3.b2", "mqwa", at="lhclength-(24.635+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2348364.0))
lhcb2.new("mqwa.b4r3.b2", "mqwa", at="lhclength-(28.435+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303051.0))
lhcb2.new("mqwb.4r3.b2", "mqwb", at="lhclength-(32.235+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=2303050.0))
lhcb2.new("mqwa.c4r3.b2", "mqwa", at="lhclength-(36.035+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241700.0))
lhcb2.new("mqwa.d4r3.b2", "mqwa", at="lhclength-(39.835+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241701.0))
lhcb2.new("mqwa.e4r3.b2", "mqwa", at="lhclength-(47.875+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241702.0))
lhcb2.new("bpmwe.4r3.b2", "bpmwe003", at="lhclength-(49.9895+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=182514.0))
lhcb2.new("mcbwv.5r3.b2", "mcbwv", at="lhclength-(121.323+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=134555.0))
lhcb2.new("bpmw.5r3.b2", "bpmw_015", at="lhclength-(125.1175+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=182516.0))
lhcb2.new("mqwa.a5r3.b2", "mqwa", at="lhclength-(127.308+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241705.0))
lhcb2.new("mqwa.b5r3.b2", "mqwa", at="lhclength-(131.108+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241706.0))
lhcb2.new("mqwb.5r3.b2", "mqwb", at="lhclength-(134.908+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241704.0))
lhcb2.new("mqwa.c5r3.b2", "mqwa", at="lhclength-(138.708+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241707.0))
lhcb2.new("tcsg.5r3.b2", "tcsg", at="lhclength-(143.728+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=114819.0))
lhcb2.new("mqwa.d5r3.b2", "mqwa", at="lhclength-(146.748+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241708.0))
lhcb2.new("mqwa.e5r3.b2", "mqwa", at="lhclength-(150.548+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=241709.0))
lhcb2.new("tcapd.5r3.b2", "tcapd", at="lhclength-(153.051+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=6703862.0))
lhcb2.new("bpmwe.a5r3.b2", "bpmwe008", at="lhclength-(153.8355+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=182515.0))
lhcb2.new("mbw.a6r3.b2", "mbw", at="lhclength-(156.351+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=52819954.0))
lhcb2.new("mbw.b6r3.b2", "mbw", at="lhclength-(160.586+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=52819978.0))
lhcb2.new("mbw.c6r3.b2", "mbw", at="lhclength-(164.821+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.224, slot_id=52820002.0))
lhcb2.new("tcapa.6r3.b2", "tcapa020", at="lhclength-(168.173+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.2212, slot_id=691019.0))
lhcb2.new("tcp.6r3.b2", "tcp", at="lhclength-(177.0495+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.2054, slot_id=281848.0))
lhcb2.new("mbw.d6r3.b2", "mbw", at="lhclength-(182.844+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.1986, slot_id=52820026.0))
lhcb2.new("mbw.e6r3.b2", "mbw", at="lhclength-(187.079+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52820050.0))
lhcb2.new("mbw.f6r3.b2", "mbw", at="lhclength-(191.314+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52820074.0))
lhcb2.new("bpmwc.6r3.b2", "bpmwc", at="lhclength-(193.6535+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=181637.0))
lhcb2.new("mcbch.6r3.b2", "mcbch", at="lhclength-(195.87+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250548.0, assembly_id=102578.0))
lhcb2.new("mqtlh.a6r3.b2", "mqtlh", at="lhclength-(197.161+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307290.0, assembly_id=102578.0))
lhcb2.new("mqtlh.b6r3.b2", "mqtlh", at="lhclength-(198.617+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2348434.0, assembly_id=102578.0))
lhcb2.new("mqtlh.c6r3.b2", "mqtlh", at="lhclength-(200.073+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307305.0, assembly_id=102578.0))
lhcb2.new("mqtlh.d6r3.b2", "mqtlh", at="lhclength-(201.528+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307312.0, assembly_id=102578.0))
lhcb2.new("mqtlh.e6r3.b2", "mqtlh", at="lhclength-(202.983+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307320.0, assembly_id=102578.0))
lhcb2.new("mqtlh.f6r3.b2", "mqtlh", at="lhclength-(204.438+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307327.0, assembly_id=102578.0))
lhcb2.new("bpm.6r3.b2", "bpm", at="lhclength-(205.808+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=377946.0, assembly_id=102578.0))
lhcb2.new("dfbaf.7r3.b2", "dfbaf", at="lhclength-(259.8215+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52996671.0, assembly_id=104679.0))
lhcb2.new("bpm_a.7r3.b2", "bpm_a", at="lhclength-(261.632+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=377947.0, assembly_id=102579.0))
lhcb2.new("mq.7r3.b2", "mq", at="lhclength-(264.179+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307937.0, assembly_id=102579.0))
lhcb2.new("mqtli.7r3.b2", "mqtli", at="lhclength-(266.548+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307140.0, assembly_id=102579.0))
lhcb2.new("mcbcv.7r3.b2", "mcbcv", at="lhclength-(267.838+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250550.0, assembly_id=102579.0))
lhcb2.new("s.ds.r3.b2", "omk", at="lhclength-(268.904+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(slot_id=100932.0))
lhcb2.new("mco.8r3.b2", "mco", at="lhclength-(269.248+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250552.0, assembly_id=102580.0))
lhcb2.new("mcd.8r3.b2", "mcd", at="lhclength-(269.2495+(0-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250553.0, assembly_id=102580.0))
lhcb2.new("mb.a8r3.b2", "mb", at="lhclength-(276.734+(.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827562.0, assembly_id=102580.0))
lhcb2.new("mcs.a8r3.b2", "mcs", at="lhclength-(284.158+(1-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243823.0, assembly_id=102580.0))
lhcb2.new("mb.b8r3.b2", "mb", at="lhclength-(292.394+(1.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827586.0, assembly_id=102581.0))
lhcb2.new("mcs.b8r3.b2", "mcs", at="lhclength-(299.818+(2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243826.0, assembly_id=102581.0))
lhcb2.new("bpm.8r3.b2", "bpm", at="lhclength-(300.697+(2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243828.0, assembly_id=102582.0))
lhcb2.new("mq.8r3.b2", "mq", at="lhclength-(303.244+(2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307944.0, assembly_id=102582.0))
lhcb2.new("mqtli.8r3.b2", "mqtli", at="lhclength-(305.613+(2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307147.0, assembly_id=102582.0))
lhcb2.new("mcbch.8r3.b2", "mcbch", at="lhclength-(306.903+(2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250556.0, assembly_id=102582.0))
lhcb2.new("mco.9r3.b2", "mco", at="lhclength-(308.313+(2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250558.0, assembly_id=102583.0))
lhcb2.new("mcd.9r3.b2", "mcd", at="lhclength-(308.3145+(2-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250559.0, assembly_id=102583.0))
lhcb2.new("mb.a9r3.b2", "mb", at="lhclength-(315.799+(2.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827610.0, assembly_id=102583.0))
lhcb2.new("mcs.a9r3.b2", "mcs", at="lhclength-(323.223+(3-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243836.0, assembly_id=102583.0))
lhcb2.new("mb.b9r3.b2", "mb", at="lhclength-(331.459+(3.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827634.0, assembly_id=102584.0))
lhcb2.new("mcs.b9r3.b2", "mcs", at="lhclength-(338.883+(4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243839.0, assembly_id=102584.0))
lhcb2.new("bpm.9r3.b2", "bpm", at="lhclength-(339.763+(4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243841.0, assembly_id=102585.0))
lhcb2.new("mq.9r3.b2", "mq", at="lhclength-(342.31+(4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307952.0, assembly_id=102585.0))
lhcb2.new("mqtli.a9r3.b2", "mqtli", at="lhclength-(344.679+(4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2348429.0, assembly_id=102585.0))
lhcb2.new("mqtli.b9r3.b2", "mqtli", at="lhclength-(346.134+(4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307162.0, assembly_id=102585.0))
lhcb2.new("mcbcv.9r3.b2", "mcbcv", at="lhclength-(347.424+(4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250562.0, assembly_id=102585.0))
lhcb2.new("mco.10r3.b2", "mco", at="lhclength-(348.778+(4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250564.0, assembly_id=102586.0))
lhcb2.new("mcd.10r3.b2", "mcd", at="lhclength-(348.7795+(4-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250565.0, assembly_id=102586.0))
lhcb2.new("mb.a10r3.b2", "mb", at="lhclength-(356.264+(4.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827658.0, assembly_id=102586.0))
lhcb2.new("mcs.a10r3.b2", "mcs", at="lhclength-(363.688+(5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243850.0, assembly_id=102586.0))
lhcb2.new("mb.b10r3.b2", "mb", at="lhclength-(371.924+(5.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827682.0, assembly_id=102587.0))
lhcb2.new("mcs.b10r3.b2", "mcs", at="lhclength-(379.348+(6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243853.0, assembly_id=102587.0))
lhcb2.new("bpm.10r3.b2", "bpm", at="lhclength-(380.227+(6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243855.0, assembly_id=102588.0))
lhcb2.new("mq.10r3.b2", "mq", at="lhclength-(382.774+(6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308647.0, assembly_id=102588.0))
lhcb2.new("mqtli.10r3.b2", "mqtli", at="lhclength-(385.143+(6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307335.0, assembly_id=102588.0))
lhcb2.new("mcbch.10r3.b2", "mcbch", at="lhclength-(386.433+(6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250568.0, assembly_id=102588.0))
lhcb2.new("mco.11r3.b2", "mco", at="lhclength-(387.843+(6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250570.0, assembly_id=102589.0))
lhcb2.new("mcd.11r3.b2", "mcd", at="lhclength-(387.8445+(6-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250571.0, assembly_id=102589.0))
lhcb2.new("mb.a11r3.b2", "mb", at="lhclength-(395.329+(6.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827706.0, assembly_id=102589.0))
lhcb2.new("mcs.a11r3.b2", "mcs", at="lhclength-(402.753+(7-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243863.0, assembly_id=102589.0))
lhcb2.new("mb.b11r3.b2", "mb", at="lhclength-(410.989+(7.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52849522.0, assembly_id=102590.0))
lhcb2.new("mcs.b11r3.b2", "mcs", at="lhclength-(418.413+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=357301.0, assembly_id=102590.0))
lhcb2.new("leel.11r3.b2", "leel", at="lhclength-(425.67735+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52997814.0, assembly_id=102591.0))
lhcb2.new("bpm.11r3.b2", "bpm", at="lhclength-(433.0087+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243868.0, assembly_id=102592.0))
lhcb2.new("mq.11r3.b2", "mq", at="lhclength-(435.5557+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308669.0, assembly_id=102592.0))
lhcb2.new("mqtli.11r3.b2", "mqtli", at="lhclength-(437.9247+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307357.0, assembly_id=102592.0))
lhcb2.new("ms.11r3.b2", "ms", at="lhclength-(438.9367+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250574.0, assembly_id=102592.0))
lhcb2.new("mcbv.11r3.b2", "mcbv", at="lhclength-(439.5297+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250576.0, assembly_id=102592.0))
lhcb2.new("s.arc.34.b2", "omk", at="lhclength-(440.2807+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a12r3.b2", "mco", at="lhclength-(440.6247+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250578.0, assembly_id=102593.0))
lhcb2.new("mcd.a12r3.b2", "mcd", at="lhclength-(440.6262+(8-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250579.0, assembly_id=102593.0))
lhcb2.new("mb.a12r3.b2", "mb", at="lhclength-(448.1107+(8.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827730.0, assembly_id=102593.0))
lhcb2.new("mcs.a12r3.b2", "mcs", at="lhclength-(455.5347+(9-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243876.0, assembly_id=102593.0))
lhcb2.new("mb.b12r3.b2", "mb", at="lhclength-(463.7707+(9.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827754.0, assembly_id=102594.0))
lhcb2.new("mcs.b12r3.b2", "mcs", at="lhclength-(471.1947+(10-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243879.0, assembly_id=102594.0))
lhcb2.new("mco.b12r3.b2", "mco", at="lhclength-(471.9447+(10-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250582.0, assembly_id=102595.0))
lhcb2.new("mcd.b12r3.b2", "mcd", at="lhclength-(471.9462+(10-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250583.0, assembly_id=102595.0))
lhcb2.new("mb.c12r3.b2", "mb", at="lhclength-(479.4307+(10.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827778.0, assembly_id=102595.0))
lhcb2.new("mcs.c12r3.b2", "mcs", at="lhclength-(486.8547+(11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243884.0, assembly_id=102595.0))
lhcb2.new("bpm.12r3.b2", "bpm", at="lhclength-(487.7337+(11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243886.0, assembly_id=102596.0))
lhcb2.new("mqt.12r3.b2", "mqt", at="lhclength-(488.4877+(11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307704.0, assembly_id=102596.0))
lhcb2.new("mq.12r3.b2", "mq", at="lhclength-(490.4957+(11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308462.0, assembly_id=102596.0))
lhcb2.new("ms.12r3.b2", "ms", at="lhclength-(492.3907+(11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250586.0, assembly_id=102596.0))
lhcb2.new("mcbh.12r3.b2", "mcbh", at="lhclength-(492.9837+(11-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250588.0, assembly_id=102596.0))
lhcb2.new("mb.a13r3.b2", "mb", at="lhclength-(501.5607+(11.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827802.0, assembly_id=102597.0))
lhcb2.new("mcs.a13r3.b2", "mcs", at="lhclength-(508.9847+(12-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243892.0, assembly_id=102597.0))
lhcb2.new("mco.13r3.b2", "mco", at="lhclength-(509.7347+(12-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250590.0, assembly_id=102598.0))
lhcb2.new("mcd.13r3.b2", "mcd", at="lhclength-(509.7362+(12-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250591.0, assembly_id=102598.0))
lhcb2.new("mb.b13r3.b2", "mb", at="lhclength-(517.2207+(12.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827826.0, assembly_id=102598.0))
lhcb2.new("mcs.b13r3.b2", "mcs", at="lhclength-(524.6447+(13-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243897.0, assembly_id=102598.0))
lhcb2.new("mb.c13r3.b2", "mb", at="lhclength-(532.8807+(13.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827850.0, assembly_id=102599.0))
lhcb2.new("mcs.c13r3.b2", "mcs", at="lhclength-(540.3047+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243900.0, assembly_id=102599.0))
lhcb2.new("bpm.13r3.b2", "bpm", at="lhclength-(541.1837+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243902.0, assembly_id=102600.0))
lhcb2.new("mqt.13r3.b2", "mqt", at="lhclength-(541.9377+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307497.0, assembly_id=102600.0))
lhcb2.new("mq.13r3.b2", "mq", at="lhclength-(543.9457+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308492.0, assembly_id=102600.0))
lhcb2.new("ms.13r3.b2", "ms", at="lhclength-(545.8407+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250594.0, assembly_id=102600.0))
lhcb2.new("mcbv.13r3.b2", "mcbv", at="lhclength-(546.4337+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250596.0, assembly_id=102600.0))
lhcb2.new("e.ds.r3.b2", "omk", at="lhclength-(547.1807+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a14r3.b2", "mco", at="lhclength-(547.5247+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250598.0, assembly_id=102601.0))
lhcb2.new("mcd.a14r3.b2", "mcd", at="lhclength-(547.5262+(14-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250599.0, assembly_id=102601.0))
lhcb2.new("mb.a14r3.b2", "mb", at="lhclength-(555.0107+(14.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827874.0, assembly_id=102601.0))
lhcb2.new("mcs.a14r3.b2", "mcs", at="lhclength-(562.4347+(15-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243910.0, assembly_id=102601.0))
lhcb2.new("mb.b14r3.b2", "mb", at="lhclength-(570.6707+(15.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827898.0, assembly_id=102602.0))
lhcb2.new("mcs.b14r3.b2", "mcs", at="lhclength-(578.0947+(16-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243913.0, assembly_id=102602.0))
lhcb2.new("mco.b14r3.b2", "mco", at="lhclength-(578.8447+(16-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250602.0, assembly_id=102603.0))
lhcb2.new("mcd.b14r3.b2", "mcd", at="lhclength-(578.8462+(16-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250603.0, assembly_id=102603.0))
lhcb2.new("mb.c14r3.b2", "mb", at="lhclength-(586.3307+(16.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827922.0, assembly_id=102603.0))
lhcb2.new("mcs.c14r3.b2", "mcs", at="lhclength-(593.7547+(17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243918.0, assembly_id=102603.0))
lhcb2.new("bpm.14r3.b2", "bpm", at="lhclength-(594.6337+(17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243920.0, assembly_id=102604.0))
lhcb2.new("mqt.14r3.b2", "mqt", at="lhclength-(595.3877+(17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307528.0, assembly_id=102604.0))
lhcb2.new("mq.14r3.b2", "mq", at="lhclength-(597.3957+(17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308522.0, assembly_id=102604.0))
lhcb2.new("ms.14r3.b2", "ms", at="lhclength-(599.2907+(17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250606.0, assembly_id=102604.0))
lhcb2.new("mcbh.14r3.b2", "mcbh", at="lhclength-(599.8837+(17-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250608.0, assembly_id=102604.0))
lhcb2.new("mb.a15r3.b2", "mb", at="lhclength-(608.4607+(17.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827946.0, assembly_id=102605.0))
lhcb2.new("mcs.a15r3.b2", "mcs", at="lhclength-(615.8847+(18-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243926.0, assembly_id=102605.0))
lhcb2.new("mco.15r3.b2", "mco", at="lhclength-(616.6347+(18-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250610.0, assembly_id=102606.0))
lhcb2.new("mcd.15r3.b2", "mcd", at="lhclength-(616.6362+(18-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250611.0, assembly_id=102606.0))
lhcb2.new("mb.b15r3.b2", "mb", at="lhclength-(624.1207+(18.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827970.0, assembly_id=102606.0))
lhcb2.new("mcs.b15r3.b2", "mcs", at="lhclength-(631.5447+(19-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243931.0, assembly_id=102606.0))
lhcb2.new("mb.c15r3.b2", "mb", at="lhclength-(639.7807+(19.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52827994.0, assembly_id=102607.0))
lhcb2.new("mcs.c15r3.b2", "mcs", at="lhclength-(647.2047+(20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243934.0, assembly_id=102607.0))
lhcb2.new("bpm.15r3.b2", "bpm", at="lhclength-(648.0837+(20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243936.0, assembly_id=102608.0))
lhcb2.new("mqt.15r3.b2", "mqt", at="lhclength-(648.8377+(20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307560.0, assembly_id=102608.0))
lhcb2.new("mq.15r3.b2", "mq", at="lhclength-(650.8457+(20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308552.0, assembly_id=102608.0))
lhcb2.new("ms.15r3.b2", "ms", at="lhclength-(652.7407+(20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250614.0, assembly_id=102608.0))
lhcb2.new("mcbv.15r3.b2", "mcbv", at="lhclength-(653.3337+(20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250616.0, assembly_id=102608.0))
lhcb2.new("mco.a16r3.b2", "mco", at="lhclength-(654.4247+(20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250618.0, assembly_id=102609.0))
lhcb2.new("mcd.a16r3.b2", "mcd", at="lhclength-(654.4262+(20-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250619.0, assembly_id=102609.0))
lhcb2.new("mb.a16r3.b2", "mb", at="lhclength-(661.9107+(20.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828018.0, assembly_id=102609.0))
lhcb2.new("mcs.a16r3.b2", "mcs", at="lhclength-(669.3347+(21-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243944.0, assembly_id=102609.0))
lhcb2.new("mb.b16r3.b2", "mb", at="lhclength-(677.5707+(21.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828042.0, assembly_id=102610.0))
lhcb2.new("mcs.b16r3.b2", "mcs", at="lhclength-(684.9947+(22-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243947.0, assembly_id=102610.0))
lhcb2.new("mco.b16r3.b2", "mco", at="lhclength-(685.7447+(22-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250622.0, assembly_id=102611.0))
lhcb2.new("mcd.b16r3.b2", "mcd", at="lhclength-(685.7462+(22-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250623.0, assembly_id=102611.0))
lhcb2.new("mb.c16r3.b2", "mb", at="lhclength-(693.2307+(22.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828066.0, assembly_id=102611.0))
lhcb2.new("mcs.c16r3.b2", "mcs", at="lhclength-(700.6547+(23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243952.0, assembly_id=102611.0))
lhcb2.new("bpm.16r3.b2", "bpm", at="lhclength-(701.5337+(23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243954.0, assembly_id=102612.0))
lhcb2.new("mqt.16r3.b2", "mqt", at="lhclength-(702.2877+(23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307590.0, assembly_id=102612.0))
lhcb2.new("mq.16r3.b2", "mq", at="lhclength-(704.2957+(23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308345.0, assembly_id=102612.0))
lhcb2.new("ms.16r3.b2", "ms", at="lhclength-(706.1907+(23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250626.0, assembly_id=102612.0))
lhcb2.new("mcbh.16r3.b2", "mcbh", at="lhclength-(706.7837+(23-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250628.0, assembly_id=102612.0))
lhcb2.new("mb.a17r3.b2", "mb", at="lhclength-(715.3607+(23.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828090.0, assembly_id=102613.0))
lhcb2.new("mcs.a17r3.b2", "mcs", at="lhclength-(722.7847+(24-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243960.0, assembly_id=102613.0))
lhcb2.new("mco.17r3.b2", "mco", at="lhclength-(723.5347+(24-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250630.0, assembly_id=102614.0))
lhcb2.new("mcd.17r3.b2", "mcd", at="lhclength-(723.5362+(24-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250631.0, assembly_id=102614.0))
lhcb2.new("mb.b17r3.b2", "mb", at="lhclength-(731.0207+(24.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828114.0, assembly_id=102614.0))
lhcb2.new("mcs.b17r3.b2", "mcs", at="lhclength-(738.4447+(25-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243965.0, assembly_id=102614.0))
lhcb2.new("mb.c17r3.b2", "mb", at="lhclength-(746.6807+(25.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828138.0, assembly_id=102615.0))
lhcb2.new("mcs.c17r3.b2", "mcs", at="lhclength-(754.1047+(26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243968.0, assembly_id=102615.0))
lhcb2.new("bpm.17r3.b2", "bpm", at="lhclength-(754.9837+(26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243970.0, assembly_id=102616.0))
lhcb2.new("mqt.17r3.b2", "mqt", at="lhclength-(755.7377+(26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307384.0, assembly_id=102616.0))
lhcb2.new("mq.17r3.b2", "mq", at="lhclength-(757.7457+(26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308375.0, assembly_id=102616.0))
lhcb2.new("ms.17r3.b2", "ms", at="lhclength-(759.6407+(26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250634.0, assembly_id=102616.0))
lhcb2.new("mcbv.17r3.b2", "mcbv", at="lhclength-(760.2337+(26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250636.0, assembly_id=102616.0))
lhcb2.new("mco.a18r3.b2", "mco", at="lhclength-(761.3247+(26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250638.0, assembly_id=102617.0))
lhcb2.new("mcd.a18r3.b2", "mcd", at="lhclength-(761.3262+(26-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250639.0, assembly_id=102617.0))
lhcb2.new("mb.a18r3.b2", "mb", at="lhclength-(768.8107+(26.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828162.0, assembly_id=102617.0))
lhcb2.new("mcs.a18r3.b2", "mcs", at="lhclength-(776.2347+(27-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243978.0, assembly_id=102617.0))
lhcb2.new("mb.b18r3.b2", "mb", at="lhclength-(784.4707+(27.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828186.0, assembly_id=102618.0))
lhcb2.new("mcs.b18r3.b2", "mcs", at="lhclength-(791.8947+(28-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243981.0, assembly_id=102618.0))
lhcb2.new("mco.b18r3.b2", "mco", at="lhclength-(792.6447+(28-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250642.0, assembly_id=102619.0))
lhcb2.new("mcd.b18r3.b2", "mcd", at="lhclength-(792.6462+(28-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250643.0, assembly_id=102619.0))
lhcb2.new("mb.c18r3.b2", "mb", at="lhclength-(800.1307+(28.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828210.0, assembly_id=102619.0))
lhcb2.new("mcs.c18r3.b2", "mcs", at="lhclength-(807.5547+(29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243986.0, assembly_id=102619.0))
lhcb2.new("bpm.18r3.b2", "bpm", at="lhclength-(808.4337+(29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243988.0, assembly_id=102620.0))
lhcb2.new("mqt.18r3.b2", "mqt", at="lhclength-(809.1877+(29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307416.0, assembly_id=102620.0))
lhcb2.new("mq.18r3.b2", "mq", at="lhclength-(811.1957+(29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308405.0, assembly_id=102620.0))
lhcb2.new("ms.18r3.b2", "ms", at="lhclength-(813.0907+(29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250646.0, assembly_id=102620.0))
lhcb2.new("mcbh.18r3.b2", "mcbh", at="lhclength-(813.6837+(29-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250648.0, assembly_id=102620.0))
lhcb2.new("mb.a19r3.b2", "mb", at="lhclength-(822.2607+(29.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828234.0, assembly_id=102621.0))
lhcb2.new("mcs.a19r3.b2", "mcs", at="lhclength-(829.6847+(30-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243994.0, assembly_id=102621.0))
lhcb2.new("mco.19r3.b2", "mco", at="lhclength-(830.4347+(30-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250650.0, assembly_id=102622.0))
lhcb2.new("mcd.19r3.b2", "mcd", at="lhclength-(830.4362+(30-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250651.0, assembly_id=102622.0))
lhcb2.new("mb.b19r3.b2", "mb", at="lhclength-(837.9207+(30.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828258.0, assembly_id=102622.0))
lhcb2.new("mcs.b19r3.b2", "mcs", at="lhclength-(845.3447+(31-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=243999.0, assembly_id=102622.0))
lhcb2.new("mb.c19r3.b2", "mb", at="lhclength-(853.5807+(31.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828282.0, assembly_id=102623.0))
lhcb2.new("mcs.c19r3.b2", "mcs", at="lhclength-(861.0047+(32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244002.0, assembly_id=102623.0))
lhcb2.new("bpm.19r3.b2", "bpm", at="lhclength-(861.8837+(32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244004.0, assembly_id=102624.0))
lhcb2.new("mqt.19r3.b2", "mqt", at="lhclength-(862.6377+(32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307446.0, assembly_id=102624.0))
lhcb2.new("mq.19r3.b2", "mq", at="lhclength-(864.6457+(32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308437.0, assembly_id=102624.0))
lhcb2.new("ms.19r3.b2", "ms", at="lhclength-(866.5407+(32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250654.0, assembly_id=102624.0))
lhcb2.new("mcbv.19r3.b2", "mcbv", at="lhclength-(867.1337+(32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250656.0, assembly_id=102624.0))
lhcb2.new("mco.a20r3.b2", "mco", at="lhclength-(868.2247+(32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250658.0, assembly_id=102625.0))
lhcb2.new("mcd.a20r3.b2", "mcd", at="lhclength-(868.2262+(32-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250659.0, assembly_id=102625.0))
lhcb2.new("mb.a20r3.b2", "mb", at="lhclength-(875.7107+(32.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828306.0, assembly_id=102625.0))
lhcb2.new("mcs.a20r3.b2", "mcs", at="lhclength-(883.1347+(33-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244012.0, assembly_id=102625.0))
lhcb2.new("mb.b20r3.b2", "mb", at="lhclength-(891.3707+(33.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828330.0, assembly_id=102626.0))
lhcb2.new("mcs.b20r3.b2", "mcs", at="lhclength-(898.7947+(34-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244015.0, assembly_id=102626.0))
lhcb2.new("mco.b20r3.b2", "mco", at="lhclength-(899.5447+(34-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250662.0, assembly_id=102627.0))
lhcb2.new("mcd.b20r3.b2", "mcd", at="lhclength-(899.5462+(34-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250663.0, assembly_id=102627.0))
lhcb2.new("mb.c20r3.b2", "mb", at="lhclength-(907.0307+(34.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828354.0, assembly_id=102627.0))
lhcb2.new("mcs.c20r3.b2", "mcs", at="lhclength-(914.4547+(35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244020.0, assembly_id=102627.0))
lhcb2.new("bpm.20r3.b2", "bpm", at="lhclength-(915.3337+(35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244022.0, assembly_id=102628.0))
lhcb2.new("mqt.20r3.b2", "mqt", at="lhclength-(916.0877+(35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307476.0, assembly_id=102628.0))
lhcb2.new("mq.20r3.b2", "mq", at="lhclength-(918.0957+(35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308228.0, assembly_id=102628.0))
lhcb2.new("ms.20r3.b2", "ms", at="lhclength-(919.9907+(35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250666.0, assembly_id=102628.0))
lhcb2.new("mcbh.20r3.b2", "mcbh", at="lhclength-(920.5837+(35-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250668.0, assembly_id=102628.0))
lhcb2.new("mb.a21r3.b2", "mb", at="lhclength-(929.1607+(35.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828378.0, assembly_id=102629.0))
lhcb2.new("mcs.a21r3.b2", "mcs", at="lhclength-(936.5847+(36-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244028.0, assembly_id=102629.0))
lhcb2.new("mco.21r3.b2", "mco", at="lhclength-(937.3347+(36-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250670.0, assembly_id=102630.0))
lhcb2.new("mcd.21r3.b2", "mcd", at="lhclength-(937.3362+(36-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250671.0, assembly_id=102630.0))
lhcb2.new("mb.b21r3.b2", "mb", at="lhclength-(944.8207+(36.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828402.0, assembly_id=102630.0))
lhcb2.new("mcs.b21r3.b2", "mcs", at="lhclength-(952.2447+(37-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244033.0, assembly_id=102630.0))
lhcb2.new("mb.c21r3.b2", "mb", at="lhclength-(960.4807+(37.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828426.0, assembly_id=102631.0))
lhcb2.new("mcs.c21r3.b2", "mcs", at="lhclength-(967.9047+(38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244036.0, assembly_id=102631.0))
lhcb2.new("bpm.21r3.b2", "bpm", at="lhclength-(968.7837+(38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244038.0, assembly_id=102632.0))
lhcb2.new("mqt.21r3.b2", "mqt", at="lhclength-(969.5377+(38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307274.0, assembly_id=102632.0))
lhcb2.new("mq.21r3.b2", "mq", at="lhclength-(971.5457+(38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308258.0, assembly_id=102632.0))
lhcb2.new("ms.21r3.b2", "ms", at="lhclength-(973.4407+(38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250674.0, assembly_id=102632.0))
lhcb2.new("mcbv.21r3.b2", "mcbv", at="lhclength-(974.0337+(38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250676.0, assembly_id=102632.0))
lhcb2.new("mco.a22r3.b2", "mco", at="lhclength-(975.1247+(38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250678.0, assembly_id=102633.0))
lhcb2.new("mcd.a22r3.b2", "mcd", at="lhclength-(975.1262+(38-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250679.0, assembly_id=102633.0))
lhcb2.new("mb.a22r3.b2", "mb", at="lhclength-(982.6107+(38.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828450.0, assembly_id=102633.0))
lhcb2.new("mcs.a22r3.b2", "mcs", at="lhclength-(990.0347+(39-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244046.0, assembly_id=102633.0))
lhcb2.new("mb.b22r3.b2", "mb", at="lhclength-(998.2707+(39.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828474.0, assembly_id=102634.0))
lhcb2.new("mcs.b22r3.b2", "mcs", at="lhclength-(1005.6947+(40-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244049.0, assembly_id=102634.0))
lhcb2.new("mco.b22r3.b2", "mco", at="lhclength-(1006.4447+(40-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250682.0, assembly_id=102635.0))
lhcb2.new("mcd.b22r3.b2", "mcd", at="lhclength-(1006.4462+(40-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250683.0, assembly_id=102635.0))
lhcb2.new("mb.c22r3.b2", "mb", at="lhclength-(1013.9307+(40.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828498.0, assembly_id=102635.0))
lhcb2.new("mcs.c22r3.b2", "mcs", at="lhclength-(1021.3547+(41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244054.0, assembly_id=102635.0))
lhcb2.new("bpm.22r3.b2", "bpm", at="lhclength-(1022.2337+(41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244056.0, assembly_id=102636.0))
lhcb2.new("mo.22r3.b2", "mo", at="lhclength-(1022.9847+(41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308818.0, assembly_id=102636.0))
lhcb2.new("mq.22r3.b2", "mq", at="lhclength-(1024.9957+(41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308290.0, assembly_id=102636.0))
lhcb2.new("ms.22r3.b2", "ms", at="lhclength-(1026.8907+(41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250686.0, assembly_id=102636.0))
lhcb2.new("mcbh.22r3.b2", "mcbh", at="lhclength-(1027.4837+(41-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250688.0, assembly_id=102636.0))
lhcb2.new("mb.a23r3.b2", "mb", at="lhclength-(1036.0607+(41.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828522.0, assembly_id=102637.0))
lhcb2.new("mcs.a23r3.b2", "mcs", at="lhclength-(1043.4847+(42-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244062.0, assembly_id=102637.0))
lhcb2.new("mco.23r3.b2", "mco", at="lhclength-(1044.2347+(42-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250690.0, assembly_id=102638.0))
lhcb2.new("mcd.23r3.b2", "mcd", at="lhclength-(1044.2362+(42-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250691.0, assembly_id=102638.0))
lhcb2.new("mb.b23r3.b2", "mb", at="lhclength-(1051.7207+(42.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828546.0, assembly_id=102638.0))
lhcb2.new("mcs.b23r3.b2", "mcs", at="lhclength-(1059.1447+(43-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244067.0, assembly_id=102638.0))
lhcb2.new("mb.c23r3.b2", "mb", at="lhclength-(1067.3807+(43.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828570.0, assembly_id=102639.0))
lhcb2.new("mcs.c23r3.b2", "mcs", at="lhclength-(1074.8047+(44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244070.0, assembly_id=102639.0))
lhcb2.new("bpm.23r3.b2", "bpm", at="lhclength-(1075.6837+(44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244072.0, assembly_id=102640.0))
lhcb2.new("mqs.23r3.b2", "mqs", at="lhclength-(1076.4377+(44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307640.0, assembly_id=102640.0))
lhcb2.new("mq.23r3.b2", "mq", at="lhclength-(1078.4457+(44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308321.0, assembly_id=102640.0))
lhcb2.new("ms.23r3.b2", "ms", at="lhclength-(1080.3407+(44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250694.0, assembly_id=102640.0))
lhcb2.new("mcbv.23r3.b2", "mcbv", at="lhclength-(1080.9337+(44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250696.0, assembly_id=102640.0))
lhcb2.new("mco.a24r3.b2", "mco", at="lhclength-(1082.0247+(44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250698.0, assembly_id=102641.0))
lhcb2.new("mcd.a24r3.b2", "mcd", at="lhclength-(1082.0262+(44-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250699.0, assembly_id=102641.0))
lhcb2.new("mb.a24r3.b2", "mb", at="lhclength-(1089.5107+(44.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828594.0, assembly_id=102641.0))
lhcb2.new("mcs.a24r3.b2", "mcs", at="lhclength-(1096.9347+(45-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244080.0, assembly_id=102641.0))
lhcb2.new("mb.b24r3.b2", "mb", at="lhclength-(1105.1707+(45.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828618.0, assembly_id=102642.0))
lhcb2.new("mcs.b24r3.b2", "mcs", at="lhclength-(1112.5947+(46-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244083.0, assembly_id=102642.0))
lhcb2.new("mco.b24r3.b2", "mco", at="lhclength-(1113.3447+(46-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250702.0, assembly_id=102643.0))
lhcb2.new("mcd.b24r3.b2", "mcd", at="lhclength-(1113.3462+(46-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250703.0, assembly_id=102643.0))
lhcb2.new("mb.c24r3.b2", "mb", at="lhclength-(1120.8307+(46.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828642.0, assembly_id=102643.0))
lhcb2.new("mcs.c24r3.b2", "mcs", at="lhclength-(1128.2547+(47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244088.0, assembly_id=102643.0))
lhcb2.new("bpm.24r3.b2", "bpm", at="lhclength-(1129.1337+(47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244090.0, assembly_id=102644.0))
lhcb2.new("mo.24r3.b2", "mo", at="lhclength-(1129.8847+(47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308848.0, assembly_id=102644.0))
lhcb2.new("mq.24r3.b2", "mq", at="lhclength-(1131.8957+(47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308111.0, assembly_id=102644.0))
lhcb2.new("ms.24r3.b2", "ms", at="lhclength-(1133.7907+(47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250706.0, assembly_id=102644.0))
lhcb2.new("mcbh.24r3.b2", "mcbh", at="lhclength-(1134.3837+(47-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250708.0, assembly_id=102644.0))
lhcb2.new("mb.a25r3.b2", "mb", at="lhclength-(1142.9607+(47.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828666.0, assembly_id=102645.0))
lhcb2.new("mcs.a25r3.b2", "mcs", at="lhclength-(1150.3847+(48-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244096.0, assembly_id=102645.0))
lhcb2.new("mco.25r3.b2", "mco", at="lhclength-(1151.1347+(48-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250710.0, assembly_id=102646.0))
lhcb2.new("mcd.25r3.b2", "mcd", at="lhclength-(1151.1362+(48-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250711.0, assembly_id=102646.0))
lhcb2.new("mb.b25r3.b2", "mb", at="lhclength-(1158.6207+(48.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828690.0, assembly_id=102646.0))
lhcb2.new("mcs.b25r3.b2", "mcs", at="lhclength-(1166.0447+(49-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244101.0, assembly_id=102646.0))
lhcb2.new("mb.c25r3.b2", "mb", at="lhclength-(1174.2807+(49.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828714.0, assembly_id=102647.0))
lhcb2.new("mcs.c25r3.b2", "mcs", at="lhclength-(1181.7047+(50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244104.0, assembly_id=102647.0))
lhcb2.new("bpm.25r3.b2", "bpm", at="lhclength-(1182.5837+(50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244106.0, assembly_id=102648.0))
lhcb2.new("mo.25r3.b2", "mo", at="lhclength-(1183.3347+(50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308880.0, assembly_id=102648.0))
lhcb2.new("mq.25r3.b2", "mq", at="lhclength-(1185.3457+(50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308143.0, assembly_id=102648.0))
lhcb2.new("ms.25r3.b2", "ms", at="lhclength-(1187.2407+(50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250714.0, assembly_id=102648.0))
lhcb2.new("mcbv.25r3.b2", "mcbv", at="lhclength-(1187.8337+(50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250716.0, assembly_id=102648.0))
lhcb2.new("mco.a26r3.b2", "mco", at="lhclength-(1188.9247+(50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250718.0, assembly_id=102649.0))
lhcb2.new("mcd.a26r3.b2", "mcd", at="lhclength-(1188.9262+(50-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250719.0, assembly_id=102649.0))
lhcb2.new("mb.a26r3.b2", "mb", at="lhclength-(1196.4107+(50.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828738.0, assembly_id=102649.0))
lhcb2.new("mcs.a26r3.b2", "mcs", at="lhclength-(1203.8347+(51-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244114.0, assembly_id=102649.0))
lhcb2.new("mb.b26r3.b2", "mb", at="lhclength-(1212.0707+(51.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828762.0, assembly_id=102650.0))
lhcb2.new("mcs.b26r3.b2", "mcs", at="lhclength-(1219.4947+(52-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244117.0, assembly_id=102650.0))
lhcb2.new("mco.b26r3.b2", "mco", at="lhclength-(1220.2447+(52-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250722.0, assembly_id=102651.0))
lhcb2.new("mcd.b26r3.b2", "mcd", at="lhclength-(1220.2462+(52-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250723.0, assembly_id=102651.0))
lhcb2.new("mb.c26r3.b2", "mb", at="lhclength-(1227.7307+(52.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828786.0, assembly_id=102651.0))
lhcb2.new("mcs.c26r3.b2", "mcs", at="lhclength-(1235.1547+(53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244122.0, assembly_id=102651.0))
lhcb2.new("bpm.26r3.b2", "bpm", at="lhclength-(1236.0337+(53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244124.0, assembly_id=102652.0))
lhcb2.new("mo.26r3.b2", "mo", at="lhclength-(1236.7847+(53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308912.0, assembly_id=102652.0))
lhcb2.new("mq.26r3.b2", "mq", at="lhclength-(1238.7957+(53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308174.0, assembly_id=102652.0))
lhcb2.new("ms.26r3.b2", "ms", at="lhclength-(1240.6907+(53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250726.0, assembly_id=102652.0))
lhcb2.new("mcbh.26r3.b2", "mcbh", at="lhclength-(1241.2837+(53-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250728.0, assembly_id=102652.0))
lhcb2.new("mb.a27r3.b2", "mb", at="lhclength-(1249.8607+(53.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828810.0, assembly_id=102653.0))
lhcb2.new("mcs.a27r3.b2", "mcs", at="lhclength-(1257.2847+(54-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244130.0, assembly_id=102653.0))
lhcb2.new("mco.27r3.b2", "mco", at="lhclength-(1258.0347+(54-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250730.0, assembly_id=102654.0))
lhcb2.new("mcd.27r3.b2", "mcd", at="lhclength-(1258.0362+(54-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250731.0, assembly_id=102654.0))
lhcb2.new("mb.b27r3.b2", "mb", at="lhclength-(1265.5207+(54.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828834.0, assembly_id=102654.0))
lhcb2.new("mcs.b27r3.b2", "mcs", at="lhclength-(1272.9447+(55-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244135.0, assembly_id=102654.0))
lhcb2.new("mb.c27r3.b2", "mb", at="lhclength-(1281.1807+(55.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828858.0, assembly_id=102655.0))
lhcb2.new("mcs.c27r3.b2", "mcs", at="lhclength-(1288.6047+(56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244138.0, assembly_id=102655.0))
lhcb2.new("bpm.27r3.b2", "bpm", at="lhclength-(1289.4837+(56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244140.0, assembly_id=102656.0))
lhcb2.new("mqs.27r3.b2", "mqs", at="lhclength-(1290.2377+(56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307672.0, assembly_id=102656.0))
lhcb2.new("mq.27r3.b2", "mq", at="lhclength-(1292.2457+(56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2348473.0, assembly_id=102656.0))
lhcb2.new("ms.27r3.b2", "ms", at="lhclength-(1294.1407+(56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250734.0, assembly_id=102656.0))
lhcb2.new("mcbv.27r3.b2", "mcbv", at="lhclength-(1294.7337+(56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250736.0, assembly_id=102656.0))
lhcb2.new("mco.a28r3.b2", "mco", at="lhclength-(1295.8247+(56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250738.0, assembly_id=102657.0))
lhcb2.new("mcd.a28r3.b2", "mcd", at="lhclength-(1295.8262+(56-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250739.0, assembly_id=102657.0))
lhcb2.new("mb.a28r3.b2", "mb", at="lhclength-(1303.3107+(56.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828882.0, assembly_id=102657.0))
lhcb2.new("mcs.a28r3.b2", "mcs", at="lhclength-(1310.7347+(57-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244148.0, assembly_id=102657.0))
lhcb2.new("mb.b28r3.b2", "mb", at="lhclength-(1318.9707+(57.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828906.0, assembly_id=102658.0))
lhcb2.new("mcs.b28r3.b2", "mcs", at="lhclength-(1326.3947+(58-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244151.0, assembly_id=102658.0))
lhcb2.new("mco.b28r3.b2", "mco", at="lhclength-(1327.1447+(58-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250742.0, assembly_id=102659.0))
lhcb2.new("mcd.b28r3.b2", "mcd", at="lhclength-(1327.1462+(58-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250743.0, assembly_id=102659.0))
lhcb2.new("mb.c28r3.b2", "mb", at="lhclength-(1334.6307+(58.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828930.0, assembly_id=102659.0))
lhcb2.new("mcs.c28r3.b2", "mcs", at="lhclength-(1342.0547+(59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244156.0, assembly_id=102659.0))
lhcb2.new("bpm.28r3.b2", "bpm", at="lhclength-(1342.9337+(59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51849016.0, assembly_id=51848980.0))
lhcb2.new("mo.28r3.b2", "mo", at="lhclength-(1343.6877+(59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51849068.0, assembly_id=51848980.0))
lhcb2.new("mq.28r3.b2", "mq", at="lhclength-(1345.6957+(59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51849070.0, assembly_id=51848980.0))
lhcb2.new("ms.28r3.b2", "ms", at="lhclength-(1347.5907+(59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51849021.0, assembly_id=51848980.0))
lhcb2.new("mcbh.28r3.b2", "mcbh", at="lhclength-(1348.1837+(59-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51849023.0, assembly_id=51848980.0))
lhcb2.new("mb.a29r3.b2", "mb", at="lhclength-(1356.7607+(59.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828954.0, assembly_id=102661.0))
lhcb2.new("mcs.a29r3.b2", "mcs", at="lhclength-(1364.1847+(60-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244164.0, assembly_id=102661.0))
lhcb2.new("mco.29r3.b2", "mco", at="lhclength-(1364.9347+(60-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250750.0, assembly_id=102662.0))
lhcb2.new("mcd.29r3.b2", "mcd", at="lhclength-(1364.9362+(60-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250751.0, assembly_id=102662.0))
lhcb2.new("mb.b29r3.b2", "mb", at="lhclength-(1372.4207+(60.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52828978.0, assembly_id=102662.0))
lhcb2.new("mcs.b29r3.b2", "mcs", at="lhclength-(1379.8447+(61-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244169.0, assembly_id=102662.0))
lhcb2.new("mb.c29r3.b2", "mb", at="lhclength-(1388.0807+(61.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829002.0, assembly_id=102663.0))
lhcb2.new("mcs.c29r3.b2", "mcs", at="lhclength-(1395.5047+(62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244172.0, assembly_id=102663.0))
lhcb2.new("bpm.29r3.b2", "bpm", at="lhclength-(1396.3837+(62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244174.0, assembly_id=102664.0))
lhcb2.new("mo.29r3.b2", "mo", at="lhclength-(1397.1347+(62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308733.0, assembly_id=102664.0))
lhcb2.new("mq.29r3.b2", "mq", at="lhclength-(1399.1457+(62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308026.0, assembly_id=102664.0))
lhcb2.new("ms.29r3.b2", "ms", at="lhclength-(1401.0407+(62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250754.0, assembly_id=102664.0))
lhcb2.new("mcbv.29r3.b2", "mcbv", at="lhclength-(1401.6337+(62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250756.0, assembly_id=102664.0))
lhcb2.new("mco.a30r3.b2", "mco", at="lhclength-(1402.7247+(62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250758.0, assembly_id=102665.0))
lhcb2.new("mcd.a30r3.b2", "mcd", at="lhclength-(1402.7262+(62-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250759.0, assembly_id=102665.0))
lhcb2.new("mb.a30r3.b2", "mb", at="lhclength-(1410.2107+(62.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829026.0, assembly_id=102665.0))
lhcb2.new("mcs.a30r3.b2", "mcs", at="lhclength-(1417.6347+(63-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244182.0, assembly_id=102665.0))
lhcb2.new("mb.b30r3.b2", "mb", at="lhclength-(1425.8707+(63.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829050.0, assembly_id=102666.0))
lhcb2.new("mcs.b30r3.b2", "mcs", at="lhclength-(1433.2947+(64-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244185.0, assembly_id=102666.0))
lhcb2.new("mco.b30r3.b2", "mco_unplugged", at="lhclength-(1434.0447+(64-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250762.0, assembly_id=102667.0))
lhcb2.new("mcd.b30r3.b2", "mcd", at="lhclength-(1434.0462+(64-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250763.0, assembly_id=102667.0))
lhcb2.new("mb.c30r3.b2", "mb", at="lhclength-(1441.5307+(64.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829074.0, assembly_id=102667.0))
lhcb2.new("mcs.c30r3.b2", "mcs", at="lhclength-(1448.9547+(65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244190.0, assembly_id=102667.0))
lhcb2.new("bpm.30r3.b2", "bpm", at="lhclength-(1449.8337+(65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244192.0, assembly_id=102668.0))
lhcb2.new("mo.30r3.b2", "mo", at="lhclength-(1450.5847+(65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308764.0, assembly_id=102668.0))
lhcb2.new("mq.30r3.b2", "mq", at="lhclength-(1452.5957+(65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308056.0, assembly_id=102668.0))
lhcb2.new("mss.30r3.b2", "mss", at="lhclength-(1454.4907+(65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250766.0, assembly_id=102668.0))
lhcb2.new("mcbh.30r3.b2", "mcbh", at="lhclength-(1455.0837+(65-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250768.0, assembly_id=102668.0))
lhcb2.new("mb.a31r3.b2", "mb", at="lhclength-(1463.6607+(65.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829098.0, assembly_id=102669.0))
lhcb2.new("mcs.a31r3.b2", "mcs", at="lhclength-(1471.0847+(66-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244198.0, assembly_id=102669.0))
lhcb2.new("mco.31r3.b2", "mco", at="lhclength-(1471.8347+(66-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250770.0, assembly_id=102670.0))
lhcb2.new("mcd.31r3.b2", "mcd", at="lhclength-(1471.8362+(66-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250771.0, assembly_id=102670.0))
lhcb2.new("mb.b31r3.b2", "mb", at="lhclength-(1479.3207+(66.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829122.0, assembly_id=102670.0))
lhcb2.new("mcs.b31r3.b2", "mcs", at="lhclength-(1486.7447+(67-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244203.0, assembly_id=102670.0))
lhcb2.new("mb.c31r3.b2", "mb", at="lhclength-(1494.9807+(67.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829146.0, assembly_id=102671.0))
lhcb2.new("mcs.c31r3.b2", "mcs", at="lhclength-(1502.4047+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244206.0, assembly_id=102671.0))
lhcb2.new("bpm.31r3.b2", "bpm", at="lhclength-(1503.2837+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244208.0, assembly_id=102672.0))
lhcb2.new("mo.31r3.b2", "mo", at="lhclength-(1504.0347+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308794.0, assembly_id=102672.0))
lhcb2.new("mq.31r3.b2", "mq", at="lhclength-(1506.0457+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308085.0, assembly_id=102672.0))
lhcb2.new("ms.31r3.b2", "ms", at="lhclength-(1507.9407+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250774.0, assembly_id=102672.0))
lhcb2.new("mcbv.31r3.b2", "mcbv", at="lhclength-(1508.5337+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250776.0, assembly_id=102672.0))
lhcb2.new("s.cell.34.b2", "omk", at="lhclength-(1509.2807+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a32r3.b2", "mco", at="lhclength-(1509.6247+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250778.0, assembly_id=102673.0))
lhcb2.new("mcd.a32r3.b2", "mcd", at="lhclength-(1509.6262+(68-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250779.0, assembly_id=102673.0))
lhcb2.new("mb.a32r3.b2", "mb", at="lhclength-(1517.1107+(68.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829170.0, assembly_id=102673.0))
lhcb2.new("mcs.a32r3.b2", "mcs", at="lhclength-(1524.5347+(69-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244216.0, assembly_id=102673.0))
lhcb2.new("mb.b32r3.b2", "mb", at="lhclength-(1532.7707+(69.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829194.0, assembly_id=102674.0))
lhcb2.new("mcs.b32r3.b2", "mcs", at="lhclength-(1540.1947+(70-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244219.0, assembly_id=102674.0))
lhcb2.new("mco.b32r3.b2", "mco", at="lhclength-(1540.9447+(70-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250782.0, assembly_id=102675.0))
lhcb2.new("mcd.b32r3.b2", "mcd", at="lhclength-(1540.9462+(70-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250783.0, assembly_id=102675.0))
lhcb2.new("mb.c32r3.b2", "mb", at="lhclength-(1548.4307+(70.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829218.0, assembly_id=102675.0))
lhcb2.new("mcs.c32r3.b2", "mcs", at="lhclength-(1555.8547+(71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244224.0, assembly_id=102675.0))
lhcb2.new("bpm.32r3.b2", "bpm", at="lhclength-(1556.7337+(71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51851049.0, assembly_id=51851014.0))
lhcb2.new("mo.32r3.b2", "mo", at="lhclength-(1557.4877+(71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51851083.0, assembly_id=51851014.0))
lhcb2.new("mq.32r3.b2", "mq", at="lhclength-(1559.4957+(71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51851085.0, assembly_id=51851014.0))
lhcb2.new("ms.32r3.b2", "ms", at="lhclength-(1561.3907+(71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51851054.0, assembly_id=51851014.0))
lhcb2.new("mcbh.32r3.b2", "mcbh", at="lhclength-(1561.9837+(71-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=51851056.0, assembly_id=51851014.0))
lhcb2.new("mb.a33r3.b2", "mb", at="lhclength-(1570.5607+(71.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829242.0, assembly_id=102677.0))
lhcb2.new("mcs.a33r3.b2", "mcs", at="lhclength-(1577.9847+(72-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244232.0, assembly_id=102677.0))
lhcb2.new("mco.33r3.b2", "mco", at="lhclength-(1578.7347+(72-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250790.0, assembly_id=102678.0))
lhcb2.new("mcd.33r3.b2", "mcd", at="lhclength-(1578.7362+(72-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250791.0, assembly_id=102678.0))
lhcb2.new("mb.b33r3.b2", "mb", at="lhclength-(1586.2207+(72.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829266.0, assembly_id=102678.0))
lhcb2.new("mcs.b33r3.b2", "mcs", at="lhclength-(1593.6447+(73-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244237.0, assembly_id=102678.0))
lhcb2.new("mb.c33r3.b2", "mb", at="lhclength-(1601.8807+(73.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829290.0, assembly_id=102679.0))
lhcb2.new("mcs.c33r3.b2", "mcs", at="lhclength-(1609.3047+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244240.0, assembly_id=102679.0))
lhcb2.new("bpm.33r3.b2", "bpm", at="lhclength-(1610.1837+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244242.0, assembly_id=102680.0))
lhcb2.new("mo.33r3.b2", "mo", at="lhclength-(1610.9347+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308617.0, assembly_id=102680.0))
lhcb2.new("mq.33r3.b2", "mq", at="lhclength-(1612.9457+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307907.0, assembly_id=102680.0))
lhcb2.new("ms.33r3.b2", "ms", at="lhclength-(1614.8407+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250794.0, assembly_id=102680.0))
lhcb2.new("mcbv.33r3.b2", "mcbv", at="lhclength-(1615.4337+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250796.0, assembly_id=102680.0))
lhcb2.new("e.cell.34.b2", "omk", at="lhclength-(1616.1807+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a34r3.b2", "mco", at="lhclength-(1616.5247+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250798.0, assembly_id=102681.0))
lhcb2.new("mcd.a34r3.b2", "mcd", at="lhclength-(1616.5262+(74-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250799.0, assembly_id=102681.0))
lhcb2.new("mb.a34r3.b2", "mb", at="lhclength-(1624.0107+(74.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829314.0, assembly_id=102681.0))
lhcb2.new("mcs.a34r3.b2", "mcs", at="lhclength-(1631.4347+(75-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244250.0, assembly_id=102681.0))
lhcb2.new("mb.b34r3.b2", "mb", at="lhclength-(1639.6707+(75.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829338.0, assembly_id=102682.0))
lhcb2.new("mcs.b34r3.b2", "mcs", at="lhclength-(1647.0947+(76-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244253.0, assembly_id=102682.0))
lhcb2.new("mco.b34r3.b2", "mco", at="lhclength-(1647.8447+(76-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250802.0, assembly_id=102683.0))
lhcb2.new("mcd.b34r3.b2", "mcd", at="lhclength-(1647.8462+(76-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=250803.0, assembly_id=102683.0))
lhcb2.new("mb.c34r3.b2", "mb", at="lhclength-(1655.3307+(76.5-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=52829362.0, assembly_id=102683.0))
lhcb2.new("mcs.c34r3.b2", "mcs", at="lhclength-(1662.7547+(77-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244258.0, assembly_id=102683.0))
lhcb2.new("bpm.34r3.b2", "bpm", at="lhclength-(1663.6337+(77-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=244260.0, assembly_id=102684.0))
lhcb2.new("mo.34r3.b2", "mo", at="lhclength-(1664.3847+(77-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2308632.0, assembly_id=102684.0))
lhcb2.new("mq.34r3.b2", "mq", at="lhclength-(1666.3957+(77-ip3ofs.b2)*ds)", from_="ip3", extra=dict(mech_sep=0.194, slot_id=2307922.0, assembly_id=102684.0))
lhcb2.new("mss.34l4.b2", "mss", at="lhclength-(-1664.0697+(77-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250806.0, assembly_id=102684.0))
lhcb2.new("mcbh.34l4.b2", "mcbh", at="lhclength-(-1663.4767+(77-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250808.0, assembly_id=102684.0))
lhcb2.new("mb.c34l4.b2", "mb", at="lhclength-(-1654.8997+(77.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829386.0, assembly_id=102685.0))
lhcb2.new("mcs.c34l4.b2", "mcs", at="lhclength-(-1647.4757+(78-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244266.0, assembly_id=102685.0))
lhcb2.new("mco.34l4.b2", "mco", at="lhclength-(-1646.7257+(78-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250810.0, assembly_id=102686.0))
lhcb2.new("mcd.34l4.b2", "mcd", at="lhclength-(-1646.7242+(78-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250811.0, assembly_id=102686.0))
lhcb2.new("mb.b34l4.b2", "mb", at="lhclength-(-1639.2397+(78.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829410.0, assembly_id=102686.0))
lhcb2.new("mcs.b34l4.b2", "mcs", at="lhclength-(-1631.8157+(79-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244271.0, assembly_id=102686.0))
lhcb2.new("mb.a34l4.b2", "mb", at="lhclength-(-1623.5797+(79.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829434.0, assembly_id=102687.0))
lhcb2.new("mcs.a34l4.b2", "mcs", at="lhclength-(-1616.1557+(80-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244274.0, assembly_id=102687.0))
lhcb2.new("bpm.33l4.b2", "bpm", at="lhclength-(-1615.2767+(80-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244276.0, assembly_id=102688.0))
lhcb2.new("mo.33l4.b2", "mo", at="lhclength-(-1614.5257+(80-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308604.0, assembly_id=102688.0))
lhcb2.new("mq.33l4.b2", "mq", at="lhclength-(-1612.5147+(80-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307894.0, assembly_id=102688.0))
lhcb2.new("ms.33l4.b2", "ms", at="lhclength-(-1610.6197+(80-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250814.0, assembly_id=102688.0))
lhcb2.new("mcbv.33l4.b2", "mcbv", at="lhclength-(-1610.0267+(80-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250816.0, assembly_id=102688.0))
lhcb2.new("mco.b33l4.b2", "mco", at="lhclength-(-1608.9357+(80-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250818.0, assembly_id=102689.0))
lhcb2.new("mcd.b33l4.b2", "mcd", at="lhclength-(-1608.9342+(80-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250819.0, assembly_id=102689.0))
lhcb2.new("mb.c33l4.b2", "mb", at="lhclength-(-1601.4497+(80.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829458.0, assembly_id=102689.0))
lhcb2.new("mcs.c33l4.b2", "mcs", at="lhclength-(-1594.0257+(81-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244284.0, assembly_id=102689.0))
lhcb2.new("mb.b33l4.b2", "mb", at="lhclength-(-1585.7897+(81.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829482.0, assembly_id=102690.0))
lhcb2.new("mcs.b33l4.b2", "mcs", at="lhclength-(-1578.3657+(82-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244287.0, assembly_id=102690.0))
lhcb2.new("mco.a33l4.b2", "mco", at="lhclength-(-1577.6157+(82-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250822.0, assembly_id=102691.0))
lhcb2.new("mcd.a33l4.b2", "mcd", at="lhclength-(-1577.6142+(82-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250823.0, assembly_id=102691.0))
lhcb2.new("mb.a33l4.b2", "mb", at="lhclength-(-1570.1297+(82.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829506.0, assembly_id=102691.0))
lhcb2.new("mcs.a33l4.b2", "mcs", at="lhclength-(-1562.7057+(83-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244292.0, assembly_id=102691.0))
lhcb2.new("bpm.32l4.b2", "bpm", at="lhclength-(-1561.8267+(83-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244294.0, assembly_id=102692.0))
lhcb2.new("mo.32l4.b2", "mo", at="lhclength-(-1561.0757+(83-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308572.0, assembly_id=102692.0))
lhcb2.new("mq.32l4.b2", "mq", at="lhclength-(-1559.0647+(83-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307864.0, assembly_id=102692.0))
lhcb2.new("mss.32l4.b2", "mss", at="lhclength-(-1557.1697+(83-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250826.0, assembly_id=102692.0))
lhcb2.new("mcbh.32l4.b2", "mcbh", at="lhclength-(-1556.5767+(83-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250828.0, assembly_id=102692.0))
lhcb2.new("mb.c32l4.b2", "mb", at="lhclength-(-1547.9997+(83.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829530.0, assembly_id=102693.0))
lhcb2.new("mcs.c32l4.b2", "mcs", at="lhclength-(-1540.5757+(84-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244300.0, assembly_id=102693.0))
lhcb2.new("mco.32l4.b2", "mco", at="lhclength-(-1539.8257+(84-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250830.0, assembly_id=102694.0))
lhcb2.new("mcd.32l4.b2", "mcd", at="lhclength-(-1539.8242+(84-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250831.0, assembly_id=102694.0))
lhcb2.new("mb.b32l4.b2", "mb", at="lhclength-(-1532.3397+(84.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829554.0, assembly_id=102694.0))
lhcb2.new("mcs.b32l4.b2", "mcs", at="lhclength-(-1524.9157+(85-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244305.0, assembly_id=102694.0))
lhcb2.new("mb.a32l4.b2", "mb", at="lhclength-(-1516.6797+(85.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829578.0, assembly_id=102695.0))
lhcb2.new("mcs.a32l4.b2", "mcs", at="lhclength-(-1509.2557+(86-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244308.0, assembly_id=102695.0))
lhcb2.new("bpm.31l4.b2", "bpm", at="lhclength-(-1508.3767+(86-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244310.0, assembly_id=102696.0))
lhcb2.new("mo.31l4.b2", "mo", at="lhclength-(-1507.6257+(86-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308781.0, assembly_id=102696.0))
lhcb2.new("mq.31l4.b2", "mq", at="lhclength-(-1505.6147+(86-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308072.0, assembly_id=102696.0))
lhcb2.new("ms.31l4.b2", "ms", at="lhclength-(-1503.7197+(86-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250834.0, assembly_id=102696.0))
lhcb2.new("mcbv.31l4.b2", "mcbv", at="lhclength-(-1503.1267+(86-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250836.0, assembly_id=102696.0))
lhcb2.new("mco.b31l4.b2", "mco", at="lhclength-(-1502.0357+(86-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250838.0, assembly_id=102697.0))
lhcb2.new("mcd.b31l4.b2", "mcd", at="lhclength-(-1502.0342+(86-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250839.0, assembly_id=102697.0))
lhcb2.new("mb.c31l4.b2", "mb", at="lhclength-(-1494.5497+(86.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829602.0, assembly_id=102697.0))
lhcb2.new("mcs.c31l4.b2", "mcs", at="lhclength-(-1487.1257+(87-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244318.0, assembly_id=102697.0))
lhcb2.new("mb.b31l4.b2", "mb", at="lhclength-(-1478.8897+(87.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829626.0, assembly_id=102698.0))
lhcb2.new("mcs.b31l4.b2", "mcs", at="lhclength-(-1471.4657+(88-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244321.0, assembly_id=102698.0))
lhcb2.new("mco.a31l4.b2", "mco", at="lhclength-(-1470.7157+(88-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250842.0, assembly_id=102699.0))
lhcb2.new("mcd.a31l4.b2", "mcd", at="lhclength-(-1470.7142+(88-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250843.0, assembly_id=102699.0))
lhcb2.new("mb.a31l4.b2", "mb", at="lhclength-(-1463.2297+(88.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829650.0, assembly_id=102699.0))
lhcb2.new("mcs.a31l4.b2", "mcs", at="lhclength-(-1455.8057+(89-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244326.0, assembly_id=102699.0))
lhcb2.new("bpm.30l4.b2", "bpm", at="lhclength-(-1454.9267+(89-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244328.0, assembly_id=102700.0))
lhcb2.new("mo.30l4.b2", "mo", at="lhclength-(-1454.1757+(89-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308751.0, assembly_id=102700.0))
lhcb2.new("mq.30l4.b2", "mq", at="lhclength-(-1452.1647+(89-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308043.0, assembly_id=102700.0))
lhcb2.new("ms.30l4.b2", "ms", at="lhclength-(-1450.2697+(89-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250846.0, assembly_id=102700.0))
lhcb2.new("mcbh.30l4.b2", "mcbh", at="lhclength-(-1449.6767+(89-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250848.0, assembly_id=102700.0))
lhcb2.new("mb.c30l4.b2", "mb", at="lhclength-(-1441.0997+(89.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829674.0, assembly_id=102701.0))
lhcb2.new("mcs.c30l4.b2", "mcs", at="lhclength-(-1433.6757+(90-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244334.0, assembly_id=102701.0))
lhcb2.new("mco.30l4.b2", "mco", at="lhclength-(-1432.9257+(90-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250850.0, assembly_id=102702.0))
lhcb2.new("mcd.30l4.b2", "mcd", at="lhclength-(-1432.9242+(90-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250851.0, assembly_id=102702.0))
lhcb2.new("mb.b30l4.b2", "mb", at="lhclength-(-1425.4397+(90.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829698.0, assembly_id=102702.0))
lhcb2.new("mcs.b30l4.b2", "mcs", at="lhclength-(-1418.0157+(91-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244339.0, assembly_id=102702.0))
lhcb2.new("mb.a30l4.b2", "mb", at="lhclength-(-1409.7797+(91.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829722.0, assembly_id=102703.0))
lhcb2.new("mcs.a30l4.b2", "mcs", at="lhclength-(-1402.3557+(92-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244342.0, assembly_id=102703.0))
lhcb2.new("bpm.29l4.b2", "bpm", at="lhclength-(-1401.4767+(92-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244344.0, assembly_id=102704.0))
lhcb2.new("mo.29l4.b2", "mo", at="lhclength-(-1400.7257+(92-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308719.0, assembly_id=102704.0))
lhcb2.new("mq.29l4.b2", "mq", at="lhclength-(-1398.7147+(92-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308013.0, assembly_id=102704.0))
lhcb2.new("ms.29l4.b2", "ms", at="lhclength-(-1396.8197+(92-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250854.0, assembly_id=102704.0))
lhcb2.new("mcbv.29l4.b2", "mcbv", at="lhclength-(-1396.2267+(92-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250856.0, assembly_id=102704.0))
lhcb2.new("mco.b29l4.b2", "mco", at="lhclength-(-1395.1357+(92-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250858.0, assembly_id=102705.0))
lhcb2.new("mcd.b29l4.b2", "mcd", at="lhclength-(-1395.1342+(92-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250859.0, assembly_id=102705.0))
lhcb2.new("mb.c29l4.b2", "mb", at="lhclength-(-1387.6497+(92.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829746.0, assembly_id=102705.0))
lhcb2.new("mcs.c29l4.b2", "mcs", at="lhclength-(-1380.2257+(93-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244352.0, assembly_id=102705.0))
lhcb2.new("mb.b29l4.b2", "mb", at="lhclength-(-1371.9897+(93.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829770.0, assembly_id=102706.0))
lhcb2.new("mcs.b29l4.b2", "mcs", at="lhclength-(-1364.5657+(94-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244355.0, assembly_id=102706.0))
lhcb2.new("mco.a29l4.b2", "mco", at="lhclength-(-1363.8157+(94-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250862.0, assembly_id=102707.0))
lhcb2.new("mcd.a29l4.b2", "mcd", at="lhclength-(-1363.8142+(94-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250863.0, assembly_id=102707.0))
lhcb2.new("mb.a29l4.b2", "mb", at="lhclength-(-1356.3297+(94.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829794.0, assembly_id=102707.0))
lhcb2.new("mcs.a29l4.b2", "mcs", at="lhclength-(-1348.9057+(95-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244360.0, assembly_id=102707.0))
lhcb2.new("bpm.28l4.b2", "bpm", at="lhclength-(-1348.0267+(95-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244362.0, assembly_id=102708.0))
lhcb2.new("mo.28l4.b2", "mo", at="lhclength-(-1347.2757+(95-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308688.0, assembly_id=102708.0))
lhcb2.new("mq.28l4.b2", "mq", at="lhclength-(-1345.2647+(95-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307981.0, assembly_id=102708.0))
lhcb2.new("mss.28l4.b2", "mss", at="lhclength-(-1343.3697+(95-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250866.0, assembly_id=102708.0))
lhcb2.new("mcbh.28l4.b2", "mcbh", at="lhclength-(-1342.7767+(95-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250868.0, assembly_id=102708.0))
lhcb2.new("mb.c28l4.b2", "mb", at="lhclength-(-1334.1997+(95.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829818.0, assembly_id=102709.0))
lhcb2.new("mcs.c28l4.b2", "mcs", at="lhclength-(-1326.7757+(96-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244368.0, assembly_id=102709.0))
lhcb2.new("mco.28l4.b2", "mco", at="lhclength-(-1326.0257+(96-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250870.0, assembly_id=102710.0))
lhcb2.new("mcd.28l4.b2", "mcd", at="lhclength-(-1326.0242+(96-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250871.0, assembly_id=102710.0))
lhcb2.new("mb.b28l4.b2", "mb", at="lhclength-(-1318.5397+(96.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829842.0, assembly_id=102710.0))
lhcb2.new("mcs.b28l4.b2", "mcs", at="lhclength-(-1311.1157+(97-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244373.0, assembly_id=102710.0))
lhcb2.new("mb.a28l4.b2", "mb", at="lhclength-(-1302.8797+(97.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829866.0, assembly_id=102711.0))
lhcb2.new("mcs.a28l4.b2", "mcs", at="lhclength-(-1295.4557+(98-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244376.0, assembly_id=102711.0))
lhcb2.new("bpm.27l4.b2", "bpm", at="lhclength-(-1294.5767+(98-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244378.0, assembly_id=102712.0))
lhcb2.new("mqs.27l4.b2", "mqs", at="lhclength-(-1293.8227+(98-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307658.0, assembly_id=102712.0))
lhcb2.new("mq.27l4.b2", "mq", at="lhclength-(-1291.8147+(98-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2348472.0, assembly_id=102712.0))
lhcb2.new("ms.27l4.b2", "ms", at="lhclength-(-1289.9197+(98-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250874.0, assembly_id=102712.0))
lhcb2.new("mcbv.27l4.b2", "mcbv", at="lhclength-(-1289.3267+(98-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250876.0, assembly_id=102712.0))
lhcb2.new("mco.b27l4.b2", "mco", at="lhclength-(-1288.2357+(98-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250878.0, assembly_id=102713.0))
lhcb2.new("mcd.b27l4.b2", "mcd", at="lhclength-(-1288.2342+(98-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250879.0, assembly_id=102713.0))
lhcb2.new("mb.c27l4.b2", "mb", at="lhclength-(-1280.7497+(98.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829890.0, assembly_id=102713.0))
lhcb2.new("mcs.c27l4.b2", "mcs", at="lhclength-(-1273.3257+(99-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244386.0, assembly_id=102713.0))
lhcb2.new("mb.b27l4.b2", "mb", at="lhclength-(-1265.0897+(99.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829914.0, assembly_id=102714.0))
lhcb2.new("mcs.b27l4.b2", "mcs", at="lhclength-(-1257.6657+(100-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244389.0, assembly_id=102714.0))
lhcb2.new("mco.a27l4.b2", "mco", at="lhclength-(-1256.9157+(100-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250882.0, assembly_id=102715.0))
lhcb2.new("mcd.a27l4.b2", "mcd", at="lhclength-(-1256.9142+(100-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250883.0, assembly_id=102715.0))
lhcb2.new("mb.a27l4.b2", "mb", at="lhclength-(-1249.4297+(100.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829938.0, assembly_id=102715.0))
lhcb2.new("mcs.a27l4.b2", "mcs", at="lhclength-(-1242.0057+(101-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244394.0, assembly_id=102715.0))
lhcb2.new("bpm.26l4.b2", "bpm", at="lhclength-(-1241.1267+(101-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244396.0, assembly_id=102716.0))
lhcb2.new("mo.26l4.b2", "mo", at="lhclength-(-1240.3757+(101-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308898.0, assembly_id=102716.0))
lhcb2.new("mq.26l4.b2", "mq", at="lhclength-(-1238.3647+(101-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308161.0, assembly_id=102716.0))
lhcb2.new("ms.26l4.b2", "ms", at="lhclength-(-1236.4697+(101-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250886.0, assembly_id=102716.0))
lhcb2.new("mcbh.26l4.b2", "mcbh", at="lhclength-(-1235.8767+(101-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250888.0, assembly_id=102716.0))
lhcb2.new("mb.c26l4.b2", "mb", at="lhclength-(-1227.2997+(101.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829962.0, assembly_id=102717.0))
lhcb2.new("mcs.c26l4.b2", "mcs", at="lhclength-(-1219.8757+(102-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244402.0, assembly_id=102717.0))
lhcb2.new("mco.26l4.b2", "mco", at="lhclength-(-1219.1257+(102-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250890.0, assembly_id=102718.0))
lhcb2.new("mcd.26l4.b2", "mcd", at="lhclength-(-1219.1242+(102-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250891.0, assembly_id=102718.0))
lhcb2.new("mb.b26l4.b2", "mb", at="lhclength-(-1211.6397+(102.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52829986.0, assembly_id=102718.0))
lhcb2.new("mcs.b26l4.b2", "mcs", at="lhclength-(-1204.2157+(103-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244407.0, assembly_id=102718.0))
lhcb2.new("mb.a26l4.b2", "mb", at="lhclength-(-1195.9797+(103.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830010.0, assembly_id=102719.0))
lhcb2.new("mcs.a26l4.b2", "mcs", at="lhclength-(-1188.5557+(104-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244410.0, assembly_id=102719.0))
lhcb2.new("bpm.25l4.b2", "bpm", at="lhclength-(-1187.6767+(104-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244412.0, assembly_id=102720.0))
lhcb2.new("mo.25l4.b2", "mo", at="lhclength-(-1186.9257+(104-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308866.0, assembly_id=102720.0))
lhcb2.new("mq.25l4.b2", "mq", at="lhclength-(-1184.9147+(104-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308129.0, assembly_id=102720.0))
lhcb2.new("ms.25l4.b2", "ms", at="lhclength-(-1183.0197+(104-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250894.0, assembly_id=102720.0))
lhcb2.new("mcbv.25l4.b2", "mcbv", at="lhclength-(-1182.4267+(104-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250896.0, assembly_id=102720.0))
lhcb2.new("mco.b25l4.b2", "mco", at="lhclength-(-1181.3357+(104-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250898.0, assembly_id=102721.0))
lhcb2.new("mcd.b25l4.b2", "mcd", at="lhclength-(-1181.3342+(104-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250899.0, assembly_id=102721.0))
lhcb2.new("mb.c25l4.b2", "mb", at="lhclength-(-1173.8497+(104.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830034.0, assembly_id=102721.0))
lhcb2.new("mcs.c25l4.b2", "mcs", at="lhclength-(-1166.4257+(105-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244420.0, assembly_id=102721.0))
lhcb2.new("mb.b25l4.b2", "mb", at="lhclength-(-1158.1897+(105.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830058.0, assembly_id=102722.0))
lhcb2.new("mcs.b25l4.b2", "mcs", at="lhclength-(-1150.7657+(106-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244423.0, assembly_id=102722.0))
lhcb2.new("mco.a25l4.b2", "mco", at="lhclength-(-1150.0157+(106-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250902.0, assembly_id=102723.0))
lhcb2.new("mcd.a25l4.b2", "mcd", at="lhclength-(-1150.0142+(106-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250903.0, assembly_id=102723.0))
lhcb2.new("mb.a25l4.b2", "mb", at="lhclength-(-1142.5297+(106.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830082.0, assembly_id=102723.0))
lhcb2.new("mcs.a25l4.b2", "mcs", at="lhclength-(-1135.1057+(107-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244428.0, assembly_id=102723.0))
lhcb2.new("bpm.24l4.b2", "bpm", at="lhclength-(-1134.2267+(107-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244430.0, assembly_id=102724.0))
lhcb2.new("mo.24l4.b2", "mo", at="lhclength-(-1133.4757+(107-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308835.0, assembly_id=102724.0))
lhcb2.new("mq.24l4.b2", "mq", at="lhclength-(-1131.4647+(107-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308097.0, assembly_id=102724.0))
lhcb2.new("ms.24l4.b2", "ms", at="lhclength-(-1129.5697+(107-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250906.0, assembly_id=102724.0))
lhcb2.new("mcbh.24l4.b2", "mcbh", at="lhclength-(-1128.9767+(107-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250908.0, assembly_id=102724.0))
lhcb2.new("mb.c24l4.b2", "mb", at="lhclength-(-1120.3997+(107.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830106.0, assembly_id=102725.0))
lhcb2.new("mcs.c24l4.b2", "mcs", at="lhclength-(-1112.9757+(108-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244436.0, assembly_id=102725.0))
lhcb2.new("mco.24l4.b2", "mco", at="lhclength-(-1112.2257+(108-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250910.0, assembly_id=102726.0))
lhcb2.new("mcd.24l4.b2", "mcd", at="lhclength-(-1112.2242+(108-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250911.0, assembly_id=102726.0))
lhcb2.new("mb.b24l4.b2", "mb", at="lhclength-(-1104.7397+(108.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830130.0, assembly_id=102726.0))
lhcb2.new("mcs.b24l4.b2", "mcs", at="lhclength-(-1097.3157+(109-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244441.0, assembly_id=102726.0))
lhcb2.new("mb.a24l4.b2", "mb", at="lhclength-(-1089.0797+(109.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830154.0, assembly_id=102727.0))
lhcb2.new("mcs.a24l4.b2", "mcs", at="lhclength-(-1081.6557+(110-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244444.0, assembly_id=102727.0))
lhcb2.new("bpm.23l4.b2", "bpm", at="lhclength-(-1080.7767+(110-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=266528.0, assembly_id=102728.0))
lhcb2.new("mqs.23l4.b2", "mqs", at="lhclength-(-1080.0227+(110-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307627.0, assembly_id=102728.0))
lhcb2.new("mq.23l4.b2", "mq", at="lhclength-(-1078.0147+(110-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308308.0, assembly_id=102728.0))
lhcb2.new("ms.23l4.b2", "ms", at="lhclength-(-1076.1197+(110-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250914.0, assembly_id=102728.0))
lhcb2.new("mcbv.23l4.b2", "mcbv", at="lhclength-(-1075.5267+(110-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250916.0, assembly_id=102728.0))
lhcb2.new("mco.b23l4.b2", "mco", at="lhclength-(-1074.4357+(110-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250918.0, assembly_id=102729.0))
lhcb2.new("mcd.b23l4.b2", "mcd", at="lhclength-(-1074.4342+(110-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250919.0, assembly_id=102729.0))
lhcb2.new("mb.c23l4.b2", "mb", at="lhclength-(-1066.9497+(110.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830178.0, assembly_id=102729.0))
lhcb2.new("mcs.c23l4.b2", "mcs", at="lhclength-(-1059.5257+(111-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244452.0, assembly_id=102729.0))
lhcb2.new("mb.b23l4.b2", "mb", at="lhclength-(-1051.2897+(111.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830202.0, assembly_id=102730.0))
lhcb2.new("mcs.b23l4.b2", "mcs", at="lhclength-(-1043.8657+(112-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244455.0, assembly_id=102730.0))
lhcb2.new("mco.a23l4.b2", "mco", at="lhclength-(-1043.1157+(112-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250922.0, assembly_id=102731.0))
lhcb2.new("mcd.a23l4.b2", "mcd", at="lhclength-(-1043.1142+(112-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250923.0, assembly_id=102731.0))
lhcb2.new("mb.a23l4.b2", "mb", at="lhclength-(-1035.6297+(112.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830226.0, assembly_id=102731.0))
lhcb2.new("mcs.a23l4.b2", "mcs", at="lhclength-(-1028.2057+(113-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244460.0, assembly_id=102731.0))
lhcb2.new("bpm.22l4.b2", "bpm", at="lhclength-(-1027.3267+(113-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244462.0, assembly_id=102732.0))
lhcb2.new("mo.22l4.b2", "mo", at="lhclength-(-1026.5757+(113-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308805.0, assembly_id=102732.0))
lhcb2.new("mq.22l4.b2", "mq", at="lhclength-(-1024.5647+(113-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308276.0, assembly_id=102732.0))
lhcb2.new("ms.22l4.b2", "ms", at="lhclength-(-1022.6697+(113-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250926.0, assembly_id=102732.0))
lhcb2.new("mcbh.22l4.b2", "mcbh", at="lhclength-(-1022.0767+(113-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250928.0, assembly_id=102732.0))
lhcb2.new("mb.c22l4.b2", "mb", at="lhclength-(-1013.4997+(113.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830250.0, assembly_id=102733.0))
lhcb2.new("mcs.c22l4.b2", "mcs", at="lhclength-(-1006.0757+(114-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244468.0, assembly_id=102733.0))
lhcb2.new("mco.22l4.b2", "mco", at="lhclength-(-1005.3257+(114-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250930.0, assembly_id=102734.0))
lhcb2.new("mcd.22l4.b2", "mcd", at="lhclength-(-1005.3242+(114-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250931.0, assembly_id=102734.0))
lhcb2.new("mb.b22l4.b2", "mb", at="lhclength-(-997.8397+(114.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830274.0, assembly_id=102734.0))
lhcb2.new("mcs.b22l4.b2", "mcs", at="lhclength-(-990.4157+(115-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244473.0, assembly_id=102734.0))
lhcb2.new("mb.a22l4.b2", "mb", at="lhclength-(-982.1797+(115.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830298.0, assembly_id=102735.0))
lhcb2.new("mcs.a22l4.b2", "mcs_unplugged", at="lhclength-(-974.7557+(116-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244476.0, assembly_id=102735.0))
lhcb2.new("bpm.21l4.b2", "bpm", at="lhclength-(-973.8767+(116-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244478.0, assembly_id=102736.0))
lhcb2.new("mqt.21l4.b2", "mqt", at="lhclength-(-973.1227+(116-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307260.0, assembly_id=102736.0))
lhcb2.new("mq.21l4.b2", "mq", at="lhclength-(-971.1147+(116-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308244.0, assembly_id=102736.0))
lhcb2.new("ms.21l4.b2", "ms", at="lhclength-(-969.2197+(116-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250934.0, assembly_id=102736.0))
lhcb2.new("mcbv.21l4.b2", "mcbv", at="lhclength-(-968.6267+(116-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250936.0, assembly_id=102736.0))
lhcb2.new("mco.b21l4.b2", "mco", at="lhclength-(-967.5357+(116-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250938.0, assembly_id=102737.0))
lhcb2.new("mcd.b21l4.b2", "mcd", at="lhclength-(-967.5342+(116-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250939.0, assembly_id=102737.0))
lhcb2.new("mb.c21l4.b2", "mb", at="lhclength-(-960.0497+(116.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830322.0, assembly_id=102737.0))
lhcb2.new("mcs.c21l4.b2", "mcs", at="lhclength-(-952.6257+(117-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244486.0, assembly_id=102737.0))
lhcb2.new("mb.b21l4.b2", "mb", at="lhclength-(-944.3897+(117.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830346.0, assembly_id=102738.0))
lhcb2.new("mcs.b21l4.b2", "mcs", at="lhclength-(-936.9657+(118-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244489.0, assembly_id=102738.0))
lhcb2.new("mco.a21l4.b2", "mco", at="lhclength-(-936.2157+(118-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250942.0, assembly_id=102739.0))
lhcb2.new("mcd.a21l4.b2", "mcd", at="lhclength-(-936.2142+(118-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250943.0, assembly_id=102739.0))
lhcb2.new("mb.a21l4.b2", "mb", at="lhclength-(-928.7297+(118.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830370.0, assembly_id=102739.0))
lhcb2.new("mcs.a21l4.b2", "mcs", at="lhclength-(-921.3057+(119-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244494.0, assembly_id=102739.0))
lhcb2.new("bpm.20l4.b2", "bpm", at="lhclength-(-920.4267+(119-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244496.0, assembly_id=102740.0))
lhcb2.new("mqt.20l4.b2", "mqt", at="lhclength-(-919.6727+(119-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307463.0, assembly_id=102740.0))
lhcb2.new("mq.20l4.b2", "mq", at="lhclength-(-917.6647+(119-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308215.0, assembly_id=102740.0))
lhcb2.new("ms.20l4.b2", "ms", at="lhclength-(-915.7697+(119-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250946.0, assembly_id=102740.0))
lhcb2.new("mcbh.20l4.b2", "mcbh", at="lhclength-(-915.1767+(119-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250948.0, assembly_id=102740.0))
lhcb2.new("mb.c20l4.b2", "mb", at="lhclength-(-906.5997+(119.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830394.0, assembly_id=102741.0))
lhcb2.new("mcs.c20l4.b2", "mcs", at="lhclength-(-899.1757+(120-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244502.0, assembly_id=102741.0))
lhcb2.new("mco.20l4.b2", "mco", at="lhclength-(-898.4257+(120-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250950.0, assembly_id=102742.0))
lhcb2.new("mcd.20l4.b2", "mcd", at="lhclength-(-898.4242+(120-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250951.0, assembly_id=102742.0))
lhcb2.new("mb.b20l4.b2", "mb", at="lhclength-(-890.9397+(120.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830418.0, assembly_id=102742.0))
lhcb2.new("mcs.b20l4.b2", "mcs", at="lhclength-(-883.5157+(121-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244507.0, assembly_id=102742.0))
lhcb2.new("mb.a20l4.b2", "mb", at="lhclength-(-875.2797+(121.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830442.0, assembly_id=102743.0))
lhcb2.new("mcs.a20l4.b2", "mcs", at="lhclength-(-867.8557+(122-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244510.0, assembly_id=102743.0))
lhcb2.new("bpm.19l4.b2", "bpm", at="lhclength-(-866.9767+(122-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244512.0, assembly_id=102744.0))
lhcb2.new("mqt.19l4.b2", "mqt", at="lhclength-(-866.2227+(122-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307433.0, assembly_id=102744.0))
lhcb2.new("mq.19l4.b2", "mq", at="lhclength-(-864.2147+(122-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308423.0, assembly_id=102744.0))
lhcb2.new("ms.19l4.b2", "ms", at="lhclength-(-862.3197+(122-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250954.0, assembly_id=102744.0))
lhcb2.new("mcbv.19l4.b2", "mcbv", at="lhclength-(-861.7267+(122-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250956.0, assembly_id=102744.0))
lhcb2.new("mco.b19l4.b2", "mco", at="lhclength-(-860.6357+(122-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250958.0, assembly_id=102745.0))
lhcb2.new("mcd.b19l4.b2", "mcd", at="lhclength-(-860.6342+(122-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250959.0, assembly_id=102745.0))
lhcb2.new("mb.c19l4.b2", "mb", at="lhclength-(-853.1497+(122.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830466.0, assembly_id=102745.0))
lhcb2.new("mcs.c19l4.b2", "mcs", at="lhclength-(-845.7257+(123-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244520.0, assembly_id=102745.0))
lhcb2.new("mb.b19l4.b2", "mb", at="lhclength-(-837.4897+(123.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830490.0, assembly_id=102746.0))
lhcb2.new("mcs.b19l4.b2", "mcs", at="lhclength-(-830.0657+(124-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244523.0, assembly_id=102746.0))
lhcb2.new("mco.a19l4.b2", "mco", at="lhclength-(-829.3157+(124-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250962.0, assembly_id=102747.0))
lhcb2.new("mcd.a19l4.b2", "mcd", at="lhclength-(-829.3142+(124-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250963.0, assembly_id=102747.0))
lhcb2.new("mb.a19l4.b2", "mb", at="lhclength-(-821.8297+(124.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830514.0, assembly_id=102747.0))
lhcb2.new("mcs.a19l4.b2", "mcs", at="lhclength-(-814.4057+(125-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244528.0, assembly_id=102747.0))
lhcb2.new("bpm.18l4.b2", "bpm", at="lhclength-(-813.5267+(125-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244530.0, assembly_id=102748.0))
lhcb2.new("mqt.18l4.b2", "mqt", at="lhclength-(-812.7727+(125-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307402.0, assembly_id=102748.0))
lhcb2.new("mq.18l4.b2", "mq", at="lhclength-(-810.7647+(125-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308392.0, assembly_id=102748.0))
lhcb2.new("ms.18l4.b2", "ms", at="lhclength-(-808.8697+(125-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250966.0, assembly_id=102748.0))
lhcb2.new("mcbh.18l4.b2", "mcbh", at="lhclength-(-808.2767+(125-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250968.0, assembly_id=102748.0))
lhcb2.new("mb.c18l4.b2", "mb", at="lhclength-(-799.6997+(125.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830538.0, assembly_id=102749.0))
lhcb2.new("mcs.c18l4.b2", "mcs", at="lhclength-(-792.2757+(126-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244536.0, assembly_id=102749.0))
lhcb2.new("mco.18l4.b2", "mco", at="lhclength-(-791.5257+(126-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250970.0, assembly_id=102750.0))
lhcb2.new("mcd.18l4.b2", "mcd", at="lhclength-(-791.5242+(126-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250971.0, assembly_id=102750.0))
lhcb2.new("mb.b18l4.b2", "mb", at="lhclength-(-784.0397+(126.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830562.0, assembly_id=102750.0))
lhcb2.new("mcs.b18l4.b2", "mcs_unplugged", at="lhclength-(-776.6157+(127-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244541.0, assembly_id=102750.0))
lhcb2.new("mb.a18l4.b2", "mb", at="lhclength-(-768.3797+(127.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830586.0, assembly_id=102751.0))
lhcb2.new("mcs.a18l4.b2", "mcs", at="lhclength-(-760.9557+(128-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244544.0, assembly_id=102751.0))
lhcb2.new("bpm.17l4.b2", "bpm", at="lhclength-(-760.0767+(128-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244546.0, assembly_id=102752.0))
lhcb2.new("mqt.17l4.b2", "mqt", at="lhclength-(-759.3227+(128-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307607.0, assembly_id=102752.0))
lhcb2.new("mq.17l4.b2", "mq", at="lhclength-(-757.3147+(128-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308362.0, assembly_id=102752.0))
lhcb2.new("ms.17l4.b2", "ms", at="lhclength-(-755.4197+(128-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250974.0, assembly_id=102752.0))
lhcb2.new("mcbv.17l4.b2", "mcbv", at="lhclength-(-754.8267+(128-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250976.0, assembly_id=102752.0))
lhcb2.new("mco.b17l4.b2", "mco", at="lhclength-(-753.7357+(128-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250978.0, assembly_id=102753.0))
lhcb2.new("mcd.b17l4.b2", "mcd", at="lhclength-(-753.7342+(128-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250979.0, assembly_id=102753.0))
lhcb2.new("mb.c17l4.b2", "mb", at="lhclength-(-746.2497+(128.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830610.0, assembly_id=102753.0))
lhcb2.new("mcs.c17l4.b2", "mcs", at="lhclength-(-738.8257+(129-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244554.0, assembly_id=102753.0))
lhcb2.new("mb.b17l4.b2", "mb", at="lhclength-(-730.5897+(129.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830634.0, assembly_id=102754.0))
lhcb2.new("mcs.b17l4.b2", "mcs", at="lhclength-(-723.1657+(130-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244557.0, assembly_id=102754.0))
lhcb2.new("mco.a17l4.b2", "mco", at="lhclength-(-722.4157+(130-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250982.0, assembly_id=102755.0))
lhcb2.new("mcd.a17l4.b2", "mcd", at="lhclength-(-722.4142+(130-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250983.0, assembly_id=102755.0))
lhcb2.new("mb.a17l4.b2", "mb", at="lhclength-(-714.9297+(130.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830658.0, assembly_id=102755.0))
lhcb2.new("mcs.a17l4.b2", "mcs", at="lhclength-(-707.5057+(131-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244562.0, assembly_id=102755.0))
lhcb2.new("bpm.16l4.b2", "bpm", at="lhclength-(-706.6267+(131-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244564.0, assembly_id=102756.0))
lhcb2.new("mqt.16l4.b2", "mqt", at="lhclength-(-705.8727+(131-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307577.0, assembly_id=102756.0))
lhcb2.new("mq.16l4.b2", "mq", at="lhclength-(-703.8647+(131-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308332.0, assembly_id=102756.0))
lhcb2.new("ms.16l4.b2", "ms", at="lhclength-(-701.9697+(131-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250986.0, assembly_id=102756.0))
lhcb2.new("mcbh.16l4.b2", "mcbh", at="lhclength-(-701.3767+(131-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250988.0, assembly_id=102756.0))
lhcb2.new("mb.c16l4.b2", "mb", at="lhclength-(-692.7997+(131.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830682.0, assembly_id=102757.0))
lhcb2.new("mcs.c16l4.b2", "mcs", at="lhclength-(-685.3757+(132-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244570.0, assembly_id=102757.0))
lhcb2.new("mco.16l4.b2", "mco", at="lhclength-(-684.6257+(132-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250990.0, assembly_id=102758.0))
lhcb2.new("mcd.16l4.b2", "mcd", at="lhclength-(-684.6242+(132-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250991.0, assembly_id=102758.0))
lhcb2.new("mb.b16l4.b2", "mb", at="lhclength-(-677.1397+(132.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830706.0, assembly_id=102758.0))
lhcb2.new("mcs.b16l4.b2", "mcs", at="lhclength-(-669.7157+(133-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244575.0, assembly_id=102758.0))
lhcb2.new("mb.a16l4.b2", "mb", at="lhclength-(-661.4797+(133.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830730.0, assembly_id=102759.0))
lhcb2.new("mcs.a16l4.b2", "mcs", at="lhclength-(-654.0557+(134-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244578.0, assembly_id=102759.0))
lhcb2.new("bpm.15l4.b2", "bpm", at="lhclength-(-653.1767+(134-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244580.0, assembly_id=102760.0))
lhcb2.new("mqt.15l4.b2", "mqt", at="lhclength-(-652.4227+(134-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307546.0, assembly_id=102760.0))
lhcb2.new("mq.15l4.b2", "mq", at="lhclength-(-650.4147+(134-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308539.0, assembly_id=102760.0))
lhcb2.new("ms.15l4.b2", "ms", at="lhclength-(-648.5197+(134-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250994.0, assembly_id=102760.0))
lhcb2.new("mcbv.15l4.b2", "mcbv", at="lhclength-(-647.9267+(134-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250996.0, assembly_id=102760.0))
lhcb2.new("mco.b15l4.b2", "mco", at="lhclength-(-646.8357+(134-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250998.0, assembly_id=102761.0))
lhcb2.new("mcd.b15l4.b2", "mcd", at="lhclength-(-646.8342+(134-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=250999.0, assembly_id=102761.0))
lhcb2.new("mb.c15l4.b2", "mb", at="lhclength-(-639.3497+(134.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830754.0, assembly_id=102761.0))
lhcb2.new("mcs.c15l4.b2", "mcs", at="lhclength-(-631.9257+(135-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244588.0, assembly_id=102761.0))
lhcb2.new("mb.b15l4.b2", "mb", at="lhclength-(-623.6897+(135.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830778.0, assembly_id=102762.0))
lhcb2.new("mcs.b15l4.b2", "mcs_unplugged", at="lhclength-(-616.2657+(136-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244591.0, assembly_id=102762.0))
lhcb2.new("mco.a15l4.b2", "mco", at="lhclength-(-615.5157+(136-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251002.0, assembly_id=102763.0))
lhcb2.new("mcd.a15l4.b2", "mcd", at="lhclength-(-615.5142+(136-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251003.0, assembly_id=102763.0))
lhcb2.new("mb.a15l4.b2", "mb", at="lhclength-(-608.0297+(136.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830802.0, assembly_id=102763.0))
lhcb2.new("mcs.a15l4.b2", "mcs", at="lhclength-(-600.6057+(137-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244596.0, assembly_id=102763.0))
lhcb2.new("bpm.14l4.b2", "bpm", at="lhclength-(-599.7267+(137-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244598.0, assembly_id=102764.0))
lhcb2.new("mqt.14l4.b2", "mqt", at="lhclength-(-598.9727+(137-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307514.0, assembly_id=102764.0))
lhcb2.new("mq.14l4.b2", "mq", at="lhclength-(-596.9647+(137-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308509.0, assembly_id=102764.0))
lhcb2.new("ms.14l4.b2", "ms", at="lhclength-(-595.0697+(137-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251006.0, assembly_id=102764.0))
lhcb2.new("mcbh.14l4.b2", "mcbh", at="lhclength-(-594.4767+(137-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251008.0, assembly_id=102764.0))
lhcb2.new("mb.c14l4.b2", "mb", at="lhclength-(-585.8997+(137.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830826.0, assembly_id=102765.0))
lhcb2.new("mcs.c14l4.b2", "mcs", at="lhclength-(-578.4757+(138-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244604.0, assembly_id=102765.0))
lhcb2.new("mco.14l4.b2", "mco", at="lhclength-(-577.7257+(138-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251010.0, assembly_id=102766.0))
lhcb2.new("mcd.14l4.b2", "mcd", at="lhclength-(-577.7242+(138-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251011.0, assembly_id=102766.0))
lhcb2.new("mb.b14l4.b2", "mb", at="lhclength-(-570.2397+(138.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830850.0, assembly_id=102766.0))
lhcb2.new("mcs.b14l4.b2", "mcs", at="lhclength-(-562.8157+(139-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244609.0, assembly_id=102766.0))
lhcb2.new("mb.a14l4.b2", "mb", at="lhclength-(-554.5797+(139.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830874.0, assembly_id=102767.0))
lhcb2.new("mcs.a14l4.b2", "mcs", at="lhclength-(-547.1557+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244612.0, assembly_id=102767.0))
lhcb2.new("s.ds.l4.b2", "omk", at="lhclength-(-546.7497+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.13l4.b2", "bpm", at="lhclength-(-546.2767+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244614.0, assembly_id=102768.0))
lhcb2.new("mqt.13l4.b2", "mqt", at="lhclength-(-545.5227+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307722.0, assembly_id=102768.0))
lhcb2.new("mq.13l4.b2", "mq", at="lhclength-(-543.5147+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308479.0, assembly_id=102768.0))
lhcb2.new("ms.13l4.b2", "ms", at="lhclength-(-541.6197+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251014.0, assembly_id=102768.0))
lhcb2.new("mcbv.13l4.b2", "mcbv", at="lhclength-(-541.0267+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251016.0, assembly_id=102768.0))
lhcb2.new("mco.b13l4.b2", "mco", at="lhclength-(-539.9357+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251018.0, assembly_id=102769.0))
lhcb2.new("mcd.b13l4.b2", "mcd", at="lhclength-(-539.9342+(140-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251019.0, assembly_id=102769.0))
lhcb2.new("mb.c13l4.b2", "mb", at="lhclength-(-532.4497+(140.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830898.0, assembly_id=102769.0))
lhcb2.new("mcs.c13l4.b2", "mcs", at="lhclength-(-525.0257+(141-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244622.0, assembly_id=102769.0))
lhcb2.new("mb.b13l4.b2", "mb", at="lhclength-(-516.7897+(141.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830922.0, assembly_id=102770.0))
lhcb2.new("mcs.b13l4.b2", "mcs", at="lhclength-(-509.3657+(142-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244625.0, assembly_id=102770.0))
lhcb2.new("mco.a13l4.b2", "mco", at="lhclength-(-508.6157+(142-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251022.0, assembly_id=102771.0))
lhcb2.new("mcd.a13l4.b2", "mcd", at="lhclength-(-508.6142+(142-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251023.0, assembly_id=102771.0))
lhcb2.new("mb.a13l4.b2", "mb", at="lhclength-(-501.1297+(142.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830946.0, assembly_id=102771.0))
lhcb2.new("mcs.a13l4.b2", "mcs", at="lhclength-(-493.7057+(143-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244630.0, assembly_id=102771.0))
lhcb2.new("bpm.12l4.b2", "bpm", at="lhclength-(-492.8267+(143-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244632.0, assembly_id=102772.0))
lhcb2.new("mqt.12l4.b2", "mqt", at="lhclength-(-492.0727+(143-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307690.0, assembly_id=102772.0))
lhcb2.new("mq.12l4.b2", "mq", at="lhclength-(-490.0647+(143-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308449.0, assembly_id=102772.0))
lhcb2.new("ms.12l4.b2", "ms", at="lhclength-(-488.1697+(143-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251026.0, assembly_id=102772.0))
lhcb2.new("mcbh.12l4.b2", "mcbh", at="lhclength-(-487.5767+(143-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251028.0, assembly_id=102772.0))
lhcb2.new("mb.c12l4.b2", "mb", at="lhclength-(-478.9997+(143.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830970.0, assembly_id=102773.0))
lhcb2.new("mcs.c12l4.b2", "mcs", at="lhclength-(-471.5757+(144-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244638.0, assembly_id=102773.0))
lhcb2.new("mco.12l4.b2", "mco", at="lhclength-(-470.8257+(144-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251030.0, assembly_id=102774.0))
lhcb2.new("mcd.12l4.b2", "mcd", at="lhclength-(-470.8242+(144-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251031.0, assembly_id=102774.0))
lhcb2.new("mb.b12l4.b2", "mb", at="lhclength-(-463.3397+(144.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52830994.0, assembly_id=102774.0))
lhcb2.new("mcs.b12l4.b2", "mcs", at="lhclength-(-455.9157+(145-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244643.0, assembly_id=102774.0))
lhcb2.new("mb.a12l4.b2", "mb", at="lhclength-(-447.6797+(145.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831018.0, assembly_id=102775.0))
lhcb2.new("mcs.a12l4.b2", "mcs", at="lhclength-(-440.2557+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244646.0, assembly_id=102775.0))
lhcb2.new("e.arc.34.b2", "omk", at="lhclength-(-439.8497+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.11l4.b2", "bpm", at="lhclength-(-439.3767+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244648.0, assembly_id=102776.0))
lhcb2.new("mq.11l4.b2", "mq", at="lhclength-(-436.8297+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308656.0, assembly_id=102776.0))
lhcb2.new("mqtli.11l4.b2", "mqtli", at="lhclength-(-434.4607+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307344.0, assembly_id=102776.0))
lhcb2.new("ms.11l4.b2", "ms", at="lhclength-(-433.4487+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251034.0, assembly_id=102776.0))
lhcb2.new("mcbv.11l4.b2", "mcbv", at="lhclength-(-432.8557+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251036.0, assembly_id=102776.0))
lhcb2.new("lebl.11l4.b2", "lebl", at="lhclength-(-425.71735+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52997646.0, assembly_id=102777.0))
lhcb2.new("mco.11l4.b2", "mco", at="lhclength-(-418.986+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251038.0, assembly_id=102778.0))
lhcb2.new("mcd.11l4.b2", "mcd", at="lhclength-(-418.9845+(146-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251039.0, assembly_id=102778.0))
lhcb2.new("mb.b11l4.b2", "mb", at="lhclength-(-411.5+(146.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831042.0, assembly_id=102778.0))
lhcb2.new("mcs.b11l4.b2", "mcs", at="lhclength-(-404.076+(147-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244656.0, assembly_id=102778.0))
lhcb2.new("mb.a11l4.b2", "mb", at="lhclength-(-395.84+(147.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52849546.0, assembly_id=102779.0))
lhcb2.new("mcs.a11l4.b2", "mcs", at="lhclength-(-388.416+(148-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=357304.0, assembly_id=102779.0))
lhcb2.new("bpmcs.10l4.b2", "bpmcs", at="lhclength-(-387.729+(148-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773696.0, assembly_id=102780.0))
lhcb2.new("bpm.10l4.b2", "bpm", at="lhclength-(-387.537+(148-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773660.0, assembly_id=102780.0))
lhcb2.new("mqml.10l4.b2", "mqml", at="lhclength-(-384.392+(148-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307809.0, assembly_id=102780.0))
lhcb2.new("mcbch.10l4.b2", "mcbch", at="lhclength-(-381.35+(148-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251043.0, assembly_id=102780.0))
lhcb2.new("mco.10l4.b2", "mco", at="lhclength-(-379.921+(148-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251044.0, assembly_id=102781.0))
lhcb2.new("mcd.10l4.b2", "mcd", at="lhclength-(-379.9195+(148-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251045.0, assembly_id=102781.0))
lhcb2.new("mb.b10l4.b2", "mb", at="lhclength-(-372.435+(148.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831066.0, assembly_id=102781.0))
lhcb2.new("mcs.b10l4.b2", "mcs", at="lhclength-(-365.011+(149-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244668.0, assembly_id=102781.0))
lhcb2.new("mb.a10l4.b2", "mb", at="lhclength-(-356.775+(149.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831090.0, assembly_id=102782.0))
lhcb2.new("mcs.a10l4.b2", "mcs", at="lhclength-(-349.351+(150-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244671.0, assembly_id=102782.0))
lhcb2.new("bpmcs.9l4.b2", "bpmcs", at="lhclength-(-348.663+(150-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773699.0, assembly_id=102783.0))
lhcb2.new("bpm.9l4.b2", "bpm", at="lhclength-(-348.471+(150-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773663.0, assembly_id=102783.0))
lhcb2.new("mqmc.9l4.b2", "mqmc", at="lhclength-(-346.495+(150-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307786.0, assembly_id=102783.0))
lhcb2.new("mqm.9l4.b2", "mqm", at="lhclength-(-343.229+(150-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307734.0, assembly_id=102783.0))
lhcb2.new("mcbcv.9l4.b2", "mcbcv", at="lhclength-(-340.888+(150-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251049.0, assembly_id=102783.0))
lhcb2.new("mco.9l4.b2", "mco", at="lhclength-(-339.456+(150-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251050.0, assembly_id=102784.0))
lhcb2.new("mcd.9l4.b2", "mcd", at="lhclength-(-339.4545+(150-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251051.0, assembly_id=102784.0))
lhcb2.new("mb.b9l4.b2", "mb", at="lhclength-(-331.97+(150.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831114.0, assembly_id=102784.0))
lhcb2.new("mcs.b9l4.b2", "mcs", at="lhclength-(-324.546+(151-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244681.0, assembly_id=102784.0))
lhcb2.new("mb.a9l4.b2", "mb", at="lhclength-(-316.31+(151.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831138.0, assembly_id=102785.0))
lhcb2.new("mcs.a9l4.b2", "mcs", at="lhclength-(-308.886+(152-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244684.0, assembly_id=102785.0))
lhcb2.new("bpmcs.8l4.b2", "bpmcs", at="lhclength-(-308.199+(152-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773703.0, assembly_id=102786.0))
lhcb2.new("bpm.8l4.b2", "bpm", at="lhclength-(-308.007+(152-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773667.0, assembly_id=102786.0))
lhcb2.new("mqml.8l4.b2", "mqml", at="lhclength-(-304.862+(152-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307841.0, assembly_id=102786.0))
lhcb2.new("mcbch.8l4.b2", "mcbch", at="lhclength-(-301.82+(152-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251055.0, assembly_id=102786.0))
lhcb2.new("mco.8l4.b2", "mco", at="lhclength-(-300.391+(152-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251056.0, assembly_id=102787.0))
lhcb2.new("mcd.8l4.b2", "mcd", at="lhclength-(-300.3895+(152-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251057.0, assembly_id=102787.0))
lhcb2.new("mb.b8l4.b2", "mb", at="lhclength-(-292.905+(152.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831162.0, assembly_id=102787.0))
lhcb2.new("mcs.b8l4.b2", "mcs", at="lhclength-(-285.481+(153-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244693.0, assembly_id=102787.0))
lhcb2.new("mb.a8l4.b2", "mb", at="lhclength-(-277.245+(153.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52849570.0, assembly_id=102788.0))
lhcb2.new("mcs.a8l4.b2", "mcs", at="lhclength-(-269.821+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=357307.0, assembly_id=102788.0))
lhcb2.new("e.ds.l4.b2", "omk", at="lhclength-(-269.415+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(slot_id=100932.0))
lhcb2.new("bpmcs.7l4.b2", "bpmcs", at="lhclength-(-269.134+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773707.0, assembly_id=102789.0))
lhcb2.new("bpm.7l4.b2", "bpm", at="lhclength-(-268.942+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773671.0, assembly_id=102789.0))
lhcb2.new("mqm.7l4.b2", "mqm", at="lhclength-(-266.367+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307964.0, assembly_id=102789.0))
lhcb2.new("mcbcv.7l4.b2", "mcbcv", at="lhclength-(-264.026+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251061.0, assembly_id=102789.0))
lhcb2.new("dfbag.7l4.b2", "dfbag", at="lhclength-(-261.8575+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52996695.0, assembly_id=104680.0))
lhcb2.new("bgvca.c7l4.b2", "bgvca004", at="lhclength-(-222.69865+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=10410410.0, assembly_id=12990150.0))
lhcb2.new("bgvca.b7l4.b2", "bgvca001", at="lhclength-(-221.04565+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=10410409.0, assembly_id=12990150.0))
lhcb2.new("bgvca.a7l4.b2", "bgvca003", at="lhclength-(-219.29655+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=10410408.0))
lhcb2.new("bplh.b7l4.b2", "bplh", at="lhclength-(-174.752+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635725.0))
lhcb2.new("bplh.a7l4.b2", "bplh", at="lhclength-(-173.952+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635726.0))
lhcb2.new("bpmya.6l4.b2", "bpmya", at="lhclength-(-172.338+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244702.0, assembly_id=102790.0))
lhcb2.new("mqy.6l4.b2", "mqy", at="lhclength-(-169.62+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2303130.0, assembly_id=102790.0))
lhcb2.new("mcbyh.6l4.b2", "mcbyh", at="lhclength-(-167.273+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251063.0, assembly_id=102790.0))
lhcb2.new("mkqa.6l4.b2", "mkqa", at="lhclength-(-153.1285+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=377746.0))
lhcb2.new("btvm.6l4.b2", "btvm", at="lhclength-(-148.17+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635732.0))
lhcb2.new("apwl.b6l4.b2", "apwl", at="lhclength-(-143.0883+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=694131.0))
lhcb2.new("bpmyb.5l4.b2", "bpmyb", at="lhclength-(-135.338+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=298214.0, assembly_id=102791.0))
lhcb2.new("mqy.5l4.b2", "mqy", at="lhclength-(-132.62+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2302988.0, assembly_id=102791.0))
lhcb2.new("mcbyv.5l4.b2", "mcbyv", at="lhclength-(-130.273+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251065.0, assembly_id=102791.0))
lhcb2.new("mbrb.5l4.b2", "mbrb", at="lhclength-(-123.684+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52819578.0, assembly_id=102792.0))
lhcb2.new("bplv.b5l4.b2", "bplv", at="lhclength-(-116.559+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.2169, slot_id=635727.0))
lhcb2.new("bplv.a5l4.b2", "bplv", at="lhclength-(-115.759+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.2189, slot_id=635728.0))
lhcb2.new("bws.5l4.b2", "bws", at="lhclength-(-84.876+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.316, slot_id=642429.0))
lhcb2.new("bsrto.a5l4.b2", "bsrto002", at="lhclength-(-73.381+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.376, slot_id=42551668.0, assembly_id=635735.0))
lhcb2.new("bsrtm.5l4.b2", "bsrtm", at="lhclength-(-73.081+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.376, slot_id=635735.0))
lhcb2.new("bsrtr.5l4.b2", "bsrtr", at="lhclength-(-58.781+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.404, slot_id=635737.0))
lhcb2.new("mbrs.5l4.b2", "mbrs", at="lhclength-(-51.783+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244711.0, assembly_id=102793.0))
lhcb2.new("mu.d5l4.b2", "mu", at="lhclength-(-46.051+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=266542.0, assembly_id=102794.0))
lhcb2.new("mu.c5l4.b2", "mu", at="lhclength-(-45.911+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=266543.0, assembly_id=102794.0))
lhcb2.new("mu.b5l4.b2", "mu", at="lhclength-(-45.771+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=266544.0, assembly_id=102794.0))
lhcb2.new("mu.a5l4.b2", "mu", at="lhclength-(-45.631+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=266545.0, assembly_id=102794.0))
lhcb2.new("bpmwa.b5l4.b2", "bpmwa", at="lhclength-(-32.9475+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=181638.0))
lhcb2.new("adtkv.d5l4.b2", "adtkv", at="lhclength-(-31.767+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=627390.0, assembly_id=102799.0))
lhcb2.new("adtkv.c5l4.b2", "adtkv", at="lhclength-(-30.167+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=627402.0, assembly_id=102799.0))
lhcb2.new("adtkv.b5l4.b2", "adtkv", at="lhclength-(-27.567+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=627392.0, assembly_id=102801.0))
lhcb2.new("adtkv.a5l4.b2", "adtkv", at="lhclength-(-25.967+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=627408.0, assembly_id=102801.0))
lhcb2.new("bpmwa.a5l4.b2", "bpmwa", at="lhclength-(-24.0625+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=181639.0))
lhcb2.new("apwl.b5l4.b2", "apwl", at="lhclength-(-18.15+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=479343.0))
lhcb2.new("apwl.5l4.b2", "apwl", at="lhclength-(-17.25+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=479344.0))
lhcb2.new("acsph.e5l4.b2", "acsph002", at="lhclength-(-6.85825+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538105.0, assembly_id=102805.0))
lhcb2.new("acsca.d5l4.b2", "acsca", at="lhclength-(-6.567+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244727.0, assembly_id=102805.0))
lhcb2.new("acsph.a5l4.b2", "acsph001", at="lhclength-(-6.31075+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538097.0, assembly_id=102805.0))
lhcb2.new("acsph.f5l4.b2", "acsph002", at="lhclength-(-5.36225+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538107.0, assembly_id=102805.0))
lhcb2.new("acsca.c5l4.b2", "acsca", at="lhclength-(-5.071+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244726.0, assembly_id=102805.0))
lhcb2.new("acsph.b5l4.b2", "acsph001", at="lhclength-(-4.81475+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538099.0, assembly_id=102805.0))
lhcb2.new("acsph.g5l4.b2", "acsph002", at="lhclength-(-3.86625+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538109.0, assembly_id=102805.0))
lhcb2.new("acsca.b5l4.b2", "acsca", at="lhclength-(-3.575+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244725.0, assembly_id=102805.0))
lhcb2.new("acsph.c5l4.b2", "acsph001", at="lhclength-(-3.31875+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538101.0, assembly_id=102805.0))
lhcb2.new("acsph.h5l4.b2", "acsph002", at="lhclength-(-2.37025+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538111.0, assembly_id=102805.0))
lhcb2.new("acsca.a5l4.b2", "acsca", at="lhclength-(-2.079+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244728.0, assembly_id=102805.0))
lhcb2.new("acsph.d5l4.b2", "acsph001", at="lhclength-(-1.82275+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538103.0, assembly_id=102805.0))
lhcb2.new("ip4", "omk", at="lhclength-(pip4+ip4ofs.b2*ds)")
lhcb2.new("acsph.e5r4.b2", "acsph002", at="lhclength-(1.42775+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538441.0, assembly_id=102806.0))
lhcb2.new("acsca.a5r4.b2", "acsca", at="lhclength-(1.719+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244732.0, assembly_id=102806.0))
lhcb2.new("acsph.a5r4.b2", "acsph001", at="lhclength-(1.97525+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538429.0, assembly_id=102806.0))
lhcb2.new("acsph.f5r4.b2", "acsph002", at="lhclength-(2.92375+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538443.0, assembly_id=102806.0))
lhcb2.new("acsca.b5r4.b2", "acsca", at="lhclength-(3.215+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244731.0, assembly_id=102806.0))
lhcb2.new("acsph.b5r4.b2", "acsph001", at="lhclength-(3.47125+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538431.0, assembly_id=102806.0))
lhcb2.new("acsph.g5r4.b2", "acsph002", at="lhclength-(4.41975+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538445.0, assembly_id=102806.0))
lhcb2.new("acsca.c5r4.b2", "acsca", at="lhclength-(4.711+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244730.0, assembly_id=102806.0))
lhcb2.new("acsph.c5r4.b2", "acsph001", at="lhclength-(4.96725+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538433.0, assembly_id=102806.0))
lhcb2.new("acsph.h5r4.b2", "acsph002", at="lhclength-(5.91575+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538447.0, assembly_id=102806.0))
lhcb2.new("acsca.d5r4.b2", "acsca", at="lhclength-(6.207+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244729.0, assembly_id=102806.0))
lhcb2.new("acsph.d5r4.b2", "acsph001", at="lhclength-(6.46325+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=40538435.0, assembly_id=102806.0))
lhcb2.new("bpmwa.a5r4.b2", "bpmwa", at="lhclength-(23.9865+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=181640.0))
lhcb2.new("adtkh.a5r4.b2", "adtkh", at="lhclength-(25.167+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=627718.0, assembly_id=102809.0))
lhcb2.new("adtkh.b5r4.b2", "adtkh", at="lhclength-(26.767+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=627722.0, assembly_id=102809.0))
lhcb2.new("adtkh.c5r4.b2", "adtkh", at="lhclength-(29.367+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=627720.0, assembly_id=102810.0))
lhcb2.new("adtkh.d5r4.b2", "adtkh", at="lhclength-(30.967+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=627724.0, assembly_id=102810.0))
lhcb2.new("bpmwa.b5r4.b2", "bpmwa", at="lhclength-(32.8715+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=181641.0))
lhcb2.new("mbrs.5r4.b2", "mbrs", at="lhclength-(51.783+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.42, slot_id=244745.0, assembly_id=102818.0))
lhcb2.new("bpmwi.a5r4.b2", "bpmwi", at="lhclength-(58.7355+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.398, slot_id=6729056.0))
lhcb2.new("mgmwv.a5r4.b2", "mgmwv", at="lhclength-(60.7959+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.3915, slot_id=642437.0))
lhcb2.new("mgmwv.c5r4.b2", "mgmwv003", at="lhclength-(62.22905+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.3898, slot_id=2068555.0))
lhcb2.new("mgmwh.c5r4.b2", "mgmwh003", at="lhclength-(64.01925+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.384, slot_id=2068586.0))
lhcb2.new("mgmwh.a5r4.b2", "mgmwh", at="lhclength-(65.4459+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.3762, slot_id=642435.0))
lhcb2.new("bqsh.5r4.b2", "bqsh", at="lhclength-(114.409+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.224, slot_id=635693.0))
lhcb2.new("mbrb.5r4.b2", "mbrb", at="lhclength-(123.684+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52819602.0, assembly_id=102819.0))
lhcb2.new("mcbyh.5r4.b2", "mcbyh", at="lhclength-(130.273+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251066.0, assembly_id=102820.0))
lhcb2.new("mqy.5r4.b2", "mqy", at="lhclength-(132.62+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2303036.0, assembly_id=102820.0))
lhcb2.new("bpmya.5r4.b2", "bpmya", at="lhclength-(135.338+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244750.0, assembly_id=102820.0))
lhcb2.new("bplh.6r4.b2", "bplh", at="lhclength-(136.952+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635705.0))
lhcb2.new("bqkh.a6r4.b2", "bqkh", at="lhclength-(140.452+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635699.0))
lhcb2.new("bplx.d6r4.b2", "bplx", at="lhclength-(148.872+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=6731968.0))
lhcb2.new("bplx.b6r4.b2", "bplx", at="lhclength-(151.252+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635714.0))
lhcb2.new("bctdc.a6r4.b2", "bctdc", at="lhclength-(154.998+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635719.0))
lhcb2.new("bctdc.b6r4.b2", "bctdc", at="lhclength-(155.918+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635720.0))
lhcb2.new("bctfr.a6r4.b2", "bctfr", at="lhclength-(156.918+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635721.0))
lhcb2.new("bctfr.b6r4.b2", "bctfr", at="lhclength-(157.838+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635722.0))
lhcb2.new("bqkv.6r4.b2", "bqkv", at="lhclength-(164.988+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635700.0))
lhcb2.new("bpmyb.6r4.b2", "bpmyb", at="lhclength-(166.902+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=298216.0, assembly_id=102821.0))
lhcb2.new("mqy.6r4.b2", "mqy", at="lhclength-(169.62+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2303098.0, assembly_id=102821.0))
lhcb2.new("mcbyv.6r4.b2", "mcbyv", at="lhclength-(171.967+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251069.0, assembly_id=102821.0))
lhcb2.new("bqsv.7r4.b2", "bqsv", at="lhclength-(176.702+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635696.0))
lhcb2.new("bplv.7r4.b2", "bplv", at="lhclength-(178.752+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=635712.0))
lhcb2.new("dfbah.7r4.b2", "dfbah", at="lhclength-(261.6075+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52996719.0, assembly_id=104681.0))
lhcb2.new("bpmcs.7r4.b2", "bpmcs", at="lhclength-(263.226+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773711.0, assembly_id=102822.0))
lhcb2.new("bpm.7r4.b2", "bpm", at="lhclength-(263.418+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773675.0, assembly_id=102822.0))
lhcb2.new("mqm.7r4.b2", "mqm", at="lhclength-(265.993+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307966.0, assembly_id=102822.0))
lhcb2.new("mcbch.7r4.b2", "mcbch", at="lhclength-(268.334+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251071.0, assembly_id=102822.0))
lhcb2.new("s.ds.r4.b2", "omk", at="lhclength-(269.415+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(slot_id=100932.0))
lhcb2.new("mco.8r4.b2", "mco", at="lhclength-(269.759+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251072.0, assembly_id=102823.0))
lhcb2.new("mcd.8r4.b2", "mcd", at="lhclength-(269.7605+(154-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251073.0, assembly_id=102823.0))
lhcb2.new("mb.a8r4.b2", "mb", at="lhclength-(277.245+(154.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831186.0, assembly_id=102823.0))
lhcb2.new("mcs.a8r4.b2", "mcs", at="lhclength-(284.669+(155-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244763.0, assembly_id=102823.0))
lhcb2.new("mb.b8r4.b2", "mb", at="lhclength-(292.905+(155.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831210.0, assembly_id=102824.0))
lhcb2.new("mcs.b8r4.b2", "mcs", at="lhclength-(300.329+(156-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244766.0, assembly_id=102824.0))
lhcb2.new("bpmcs.8r4.b2", "bpmcs", at="lhclength-(301.016+(156-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773719.0, assembly_id=102825.0))
lhcb2.new("bpm.8r4.b2", "bpm", at="lhclength-(301.208+(156-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773683.0, assembly_id=102825.0))
lhcb2.new("mqml.8r4.b2", "mqml", at="lhclength-(304.353+(156-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307614.0, assembly_id=102825.0))
lhcb2.new("mcbcv.8r4.b2", "mcbcv", at="lhclength-(307.395+(156-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251077.0, assembly_id=102825.0))
lhcb2.new("mco.9r4.b2", "mco", at="lhclength-(308.824+(156-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251078.0, assembly_id=102826.0))
lhcb2.new("mcd.9r4.b2", "mcd", at="lhclength-(308.8255+(156-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251079.0, assembly_id=102826.0))
lhcb2.new("mb.a9r4.b2", "mb", at="lhclength-(316.31+(156.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831234.0, assembly_id=102826.0))
lhcb2.new("mcs.a9r4.b2", "mcs", at="lhclength-(323.734+(157-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244775.0, assembly_id=102826.0))
lhcb2.new("mb.b9r4.b2", "mb", at="lhclength-(331.97+(157.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831258.0, assembly_id=102827.0))
lhcb2.new("mcs.b9r4.b2", "mcs", at="lhclength-(339.394+(158-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244778.0, assembly_id=102827.0))
lhcb2.new("bpmcs.9r4.b2", "bpmcs", at="lhclength-(340.082+(158-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773723.0, assembly_id=102828.0))
lhcb2.new("bpm.9r4.b2", "bpm", at="lhclength-(340.274+(158-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773687.0, assembly_id=102828.0))
lhcb2.new("mqmc.9r4.b2", "mqmc", at="lhclength-(342.25+(158-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307797.0, assembly_id=102828.0))
lhcb2.new("mqm.9r4.b2", "mqm", at="lhclength-(345.516+(158-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307745.0, assembly_id=102828.0))
lhcb2.new("mcbch.9r4.b2", "mcbch", at="lhclength-(347.857+(158-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251083.0, assembly_id=102828.0))
lhcb2.new("mco.10r4.b2", "mco", at="lhclength-(349.289+(158-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251084.0, assembly_id=102829.0))
lhcb2.new("mcd.10r4.b2", "mcd", at="lhclength-(349.2905+(158-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251085.0, assembly_id=102829.0))
lhcb2.new("mb.a10r4.b2", "mb", at="lhclength-(356.775+(158.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831282.0, assembly_id=102829.0))
lhcb2.new("mcs.a10r4.b2", "mcs", at="lhclength-(364.199+(159-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244788.0, assembly_id=102829.0))
lhcb2.new("mb.b10r4.b2", "mb", at="lhclength-(372.435+(159.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831306.0, assembly_id=102830.0))
lhcb2.new("mcs.b10r4.b2", "mcs", at="lhclength-(379.859+(160-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244791.0, assembly_id=102830.0))
lhcb2.new("bpmcs.10r4.b2", "bpmcs", at="lhclength-(380.546+(160-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773727.0, assembly_id=102831.0))
lhcb2.new("bpm.10r4.b2", "bpm", at="lhclength-(380.738+(160-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=4773691.0, assembly_id=102831.0))
lhcb2.new("mqml.10r4.b2", "mqml", at="lhclength-(383.883+(160-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307821.0, assembly_id=102831.0))
lhcb2.new("mcbcv.10r4.b2", "mcbcv", at="lhclength-(386.925+(160-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251089.0, assembly_id=102831.0))
lhcb2.new("mco.11r4.b2", "mco", at="lhclength-(388.354+(160-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251090.0, assembly_id=102832.0))
lhcb2.new("mcd.11r4.b2", "mcd", at="lhclength-(388.3555+(160-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251091.0, assembly_id=102832.0))
lhcb2.new("mb.a11r4.b2", "mb", at="lhclength-(395.84+(160.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831330.0, assembly_id=102832.0))
lhcb2.new("mcs.a11r4.b2", "mcs", at="lhclength-(403.264+(161-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244800.0, assembly_id=102832.0))
lhcb2.new("mb.b11r4.b2", "mb", at="lhclength-(411.5+(161.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831354.0, assembly_id=102833.0))
lhcb2.new("mcs.b11r4.b2", "mcs", at="lhclength-(418.924+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244803.0, assembly_id=102833.0))
lhcb2.new("leal.11r4.b2", "leal", at="lhclength-(425.71735+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52997598.0, assembly_id=102834.0))
lhcb2.new("bpm.11r4.b2", "bpm", at="lhclength-(432.5777+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244805.0, assembly_id=102835.0))
lhcb2.new("mq.11r4.b2", "mq", at="lhclength-(435.1247+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308671.0, assembly_id=102835.0))
lhcb2.new("mqtli.11r4.b2", "mqtli", at="lhclength-(437.4937+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307359.0, assembly_id=102835.0))
lhcb2.new("ms.11r4.b2", "ms", at="lhclength-(438.5057+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251094.0, assembly_id=102835.0))
lhcb2.new("mcbh.11r4.b2", "mcbh", at="lhclength-(439.0987+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251096.0, assembly_id=102835.0))
lhcb2.new("s.arc.45.b2", "omk", at="lhclength-(439.8497+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a12r4.b2", "mco", at="lhclength-(440.1937+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251098.0, assembly_id=102836.0))
lhcb2.new("mcd.a12r4.b2", "mcd", at="lhclength-(440.1952+(162-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251099.0, assembly_id=102836.0))
lhcb2.new("mb.a12r4.b2", "mb", at="lhclength-(447.6797+(162.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831378.0, assembly_id=102836.0))
lhcb2.new("mcs.a12r4.b2", "mcs", at="lhclength-(455.1037+(163-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244813.0, assembly_id=102836.0))
lhcb2.new("mb.b12r4.b2", "mb", at="lhclength-(463.3397+(163.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831402.0, assembly_id=102837.0))
lhcb2.new("mcs.b12r4.b2", "mcs", at="lhclength-(470.7637+(164-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244816.0, assembly_id=102837.0))
lhcb2.new("mco.b12r4.b2", "mco", at="lhclength-(471.5137+(164-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251102.0, assembly_id=102838.0))
lhcb2.new("mcd.b12r4.b2", "mcd", at="lhclength-(471.5152+(164-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251103.0, assembly_id=102838.0))
lhcb2.new("mb.c12r4.b2", "mb", at="lhclength-(478.9997+(164.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831426.0, assembly_id=102838.0))
lhcb2.new("mcs.c12r4.b2", "mcs", at="lhclength-(486.4237+(165-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244821.0, assembly_id=102838.0))
lhcb2.new("bpm.12r4.b2", "bpm", at="lhclength-(487.3027+(165-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244823.0, assembly_id=102839.0))
lhcb2.new("mqt.12r4.b2", "mqt", at="lhclength-(488.0567+(165-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307706.0, assembly_id=102839.0))
lhcb2.new("mq.12r4.b2", "mq", at="lhclength-(490.0647+(165-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308464.0, assembly_id=102839.0))
lhcb2.new("ms.12r4.b2", "ms", at="lhclength-(491.9597+(165-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251106.0, assembly_id=102839.0))
lhcb2.new("mcbv.12r4.b2", "mcbv", at="lhclength-(492.5527+(165-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251108.0, assembly_id=102839.0))
lhcb2.new("mb.a13r4.b2", "mb", at="lhclength-(501.1297+(165.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831450.0, assembly_id=102840.0))
lhcb2.new("mcs.a13r4.b2", "mcs", at="lhclength-(508.5537+(166-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244829.0, assembly_id=102840.0))
lhcb2.new("mco.13r4.b2", "mco", at="lhclength-(509.3037+(166-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251110.0, assembly_id=102841.0))
lhcb2.new("mcd.13r4.b2", "mcd", at="lhclength-(509.3052+(166-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251111.0, assembly_id=102841.0))
lhcb2.new("mb.b13r4.b2", "mb", at="lhclength-(516.7897+(166.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831474.0, assembly_id=102841.0))
lhcb2.new("mcs.b13r4.b2", "mcs", at="lhclength-(524.2137+(167-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244834.0, assembly_id=102841.0))
lhcb2.new("mb.c13r4.b2", "mb", at="lhclength-(532.4497+(167.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831498.0, assembly_id=102842.0))
lhcb2.new("mcs.c13r4.b2", "mcs", at="lhclength-(539.8737+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244837.0, assembly_id=102842.0))
lhcb2.new("bpm.13r4.b2", "bpm", at="lhclength-(540.7527+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244839.0, assembly_id=102843.0))
lhcb2.new("mqt.13r4.b2", "mqt", at="lhclength-(541.5067+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307499.0, assembly_id=102843.0))
lhcb2.new("mq.13r4.b2", "mq", at="lhclength-(543.5147+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308494.0, assembly_id=102843.0))
lhcb2.new("ms.13r4.b2", "ms", at="lhclength-(545.4097+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251114.0, assembly_id=102843.0))
lhcb2.new("mcbh.13r4.b2", "mcbh", at="lhclength-(546.0027+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251116.0, assembly_id=102843.0))
lhcb2.new("e.ds.r4.b2", "omk", at="lhclength-(546.7497+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a14r4.b2", "mco", at="lhclength-(547.0937+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251118.0, assembly_id=102844.0))
lhcb2.new("mcd.a14r4.b2", "mcd", at="lhclength-(547.0952+(168-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251119.0, assembly_id=102844.0))
lhcb2.new("mb.a14r4.b2", "mb", at="lhclength-(554.5797+(168.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831522.0, assembly_id=102844.0))
lhcb2.new("mcs.a14r4.b2", "mcs", at="lhclength-(562.0037+(169-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244847.0, assembly_id=102844.0))
lhcb2.new("mb.b14r4.b2", "mb", at="lhclength-(570.2397+(169.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831546.0, assembly_id=102845.0))
lhcb2.new("mcs.b14r4.b2", "mcs", at="lhclength-(577.6637+(170-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244850.0, assembly_id=102845.0))
lhcb2.new("mco.b14r4.b2", "mco", at="lhclength-(578.4137+(170-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251122.0, assembly_id=102846.0))
lhcb2.new("mcd.b14r4.b2", "mcd", at="lhclength-(578.4152+(170-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251123.0, assembly_id=102846.0))
lhcb2.new("mb.c14r4.b2", "mb", at="lhclength-(585.8997+(170.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831570.0, assembly_id=102846.0))
lhcb2.new("mcs.c14r4.b2", "mcs", at="lhclength-(593.3237+(171-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244855.0, assembly_id=102846.0))
lhcb2.new("bpm.14r4.b2", "bpm", at="lhclength-(594.2027+(171-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244857.0, assembly_id=102847.0))
lhcb2.new("mqt.14r4.b2", "mqt", at="lhclength-(594.9567+(171-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307530.0, assembly_id=102847.0))
lhcb2.new("mq.14r4.b2", "mq", at="lhclength-(596.9647+(171-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308524.0, assembly_id=102847.0))
lhcb2.new("ms.14r4.b2", "ms", at="lhclength-(598.8597+(171-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251126.0, assembly_id=102847.0))
lhcb2.new("mcbv.14r4.b2", "mcbv", at="lhclength-(599.4527+(171-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251128.0, assembly_id=102847.0))
lhcb2.new("mb.a15r4.b2", "mb", at="lhclength-(608.0297+(171.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831594.0, assembly_id=102848.0))
lhcb2.new("mcs.a15r4.b2", "mcs", at="lhclength-(615.4537+(172-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244863.0, assembly_id=102848.0))
lhcb2.new("mco.15r4.b2", "mco", at="lhclength-(616.2037+(172-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251130.0, assembly_id=102849.0))
lhcb2.new("mcd.15r4.b2", "mcd", at="lhclength-(616.2052+(172-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251131.0, assembly_id=102849.0))
lhcb2.new("mb.b15r4.b2", "mb", at="lhclength-(623.6897+(172.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831618.0, assembly_id=102849.0))
lhcb2.new("mcs.b15r4.b2", "mcs", at="lhclength-(631.1137+(173-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244868.0, assembly_id=102849.0))
lhcb2.new("mb.c15r4.b2", "mb", at="lhclength-(639.3497+(173.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831642.0, assembly_id=102850.0))
lhcb2.new("mcs.c15r4.b2", "mcs", at="lhclength-(646.7737+(174-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244871.0, assembly_id=102850.0))
lhcb2.new("bpm.15r4.b2", "bpm", at="lhclength-(647.6527+(174-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244873.0, assembly_id=102851.0))
lhcb2.new("mqt.15r4.b2", "mqt", at="lhclength-(648.4067+(174-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307562.0, assembly_id=102851.0))
lhcb2.new("mq.15r4.b2", "mq", at="lhclength-(650.4147+(174-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308554.0, assembly_id=102851.0))
lhcb2.new("ms.15r4.b2", "ms", at="lhclength-(652.3097+(174-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251134.0, assembly_id=102851.0))
lhcb2.new("mcbh.15r4.b2", "mcbh", at="lhclength-(652.9027+(174-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251136.0, assembly_id=102851.0))
lhcb2.new("mco.a16r4.b2", "mco", at="lhclength-(653.9937+(174-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251138.0, assembly_id=102852.0))
lhcb2.new("mcd.a16r4.b2", "mcd", at="lhclength-(653.9952+(174-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251139.0, assembly_id=102852.0))
lhcb2.new("mb.a16r4.b2", "mb", at="lhclength-(661.4797+(174.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831666.0, assembly_id=102852.0))
lhcb2.new("mcs.a16r4.b2", "mcs", at="lhclength-(668.9037+(175-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244881.0, assembly_id=102852.0))
lhcb2.new("mb.b16r4.b2", "mb", at="lhclength-(677.1397+(175.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831690.0, assembly_id=102853.0))
lhcb2.new("mcs.b16r4.b2", "mcs", at="lhclength-(684.5637+(176-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244884.0, assembly_id=102853.0))
lhcb2.new("mco.b16r4.b2", "mco", at="lhclength-(685.3137+(176-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251142.0, assembly_id=102854.0))
lhcb2.new("mcd.b16r4.b2", "mcd", at="lhclength-(685.3152+(176-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251143.0, assembly_id=102854.0))
lhcb2.new("mb.c16r4.b2", "mb", at="lhclength-(692.7997+(176.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831714.0, assembly_id=102854.0))
lhcb2.new("mcs.c16r4.b2", "mcs", at="lhclength-(700.2237+(177-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244889.0, assembly_id=102854.0))
lhcb2.new("bpm.16r4.b2", "bpm", at="lhclength-(701.1027+(177-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244891.0, assembly_id=102855.0))
lhcb2.new("mqt.16r4.b2", "mqt", at="lhclength-(701.8567+(177-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307592.0, assembly_id=102855.0))
lhcb2.new("mq.16r4.b2", "mq", at="lhclength-(703.8647+(177-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308347.0, assembly_id=102855.0))
lhcb2.new("ms.16r4.b2", "ms", at="lhclength-(705.7597+(177-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251146.0, assembly_id=102855.0))
lhcb2.new("mcbv.16r4.b2", "mcbv", at="lhclength-(706.3527+(177-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251148.0, assembly_id=102855.0))
lhcb2.new("mb.a17r4.b2", "mb", at="lhclength-(714.9297+(177.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831738.0, assembly_id=102856.0))
lhcb2.new("mcs.a17r4.b2", "mcs", at="lhclength-(722.3537+(178-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244897.0, assembly_id=102856.0))
lhcb2.new("mco.17r4.b2", "mco", at="lhclength-(723.1037+(178-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251150.0, assembly_id=102857.0))
lhcb2.new("mcd.17r4.b2", "mcd", at="lhclength-(723.1052+(178-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251151.0, assembly_id=102857.0))
lhcb2.new("mb.b17r4.b2", "mb", at="lhclength-(730.5897+(178.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831762.0, assembly_id=102857.0))
lhcb2.new("mcs.b17r4.b2", "mcs", at="lhclength-(738.0137+(179-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244902.0, assembly_id=102857.0))
lhcb2.new("mb.c17r4.b2", "mb", at="lhclength-(746.2497+(179.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831786.0, assembly_id=102858.0))
lhcb2.new("mcs.c17r4.b2", "mcs", at="lhclength-(753.6737+(180-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244905.0, assembly_id=102858.0))
lhcb2.new("bpm.17r4.b2", "bpm", at="lhclength-(754.5527+(180-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244907.0, assembly_id=102859.0))
lhcb2.new("mqt.17r4.b2", "mqt", at="lhclength-(755.3067+(180-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307386.0, assembly_id=102859.0))
lhcb2.new("mq.17r4.b2", "mq", at="lhclength-(757.3147+(180-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308377.0, assembly_id=102859.0))
lhcb2.new("ms.17r4.b2", "ms", at="lhclength-(759.2097+(180-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251154.0, assembly_id=102859.0))
lhcb2.new("mcbh.17r4.b2", "mcbh", at="lhclength-(759.8027+(180-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251156.0, assembly_id=102859.0))
lhcb2.new("mco.a18r4.b2", "mco", at="lhclength-(760.8937+(180-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251158.0, assembly_id=102860.0))
lhcb2.new("mcd.a18r4.b2", "mcd", at="lhclength-(760.8952+(180-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251159.0, assembly_id=102860.0))
lhcb2.new("mb.a18r4.b2", "mb", at="lhclength-(768.3797+(180.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831810.0, assembly_id=102860.0))
lhcb2.new("mcs.a18r4.b2", "mcs", at="lhclength-(775.8037+(181-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244915.0, assembly_id=102860.0))
lhcb2.new("mb.b18r4.b2", "mb", at="lhclength-(784.0397+(181.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831834.0, assembly_id=102861.0))
lhcb2.new("mcs.b18r4.b2", "mcs", at="lhclength-(791.4637+(182-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244918.0, assembly_id=102861.0))
lhcb2.new("mco.b18r4.b2", "mco", at="lhclength-(792.2137+(182-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251162.0, assembly_id=102862.0))
lhcb2.new("mcd.b18r4.b2", "mcd", at="lhclength-(792.2152+(182-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251163.0, assembly_id=102862.0))
lhcb2.new("mb.c18r4.b2", "mb", at="lhclength-(799.6997+(182.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831858.0, assembly_id=102862.0))
lhcb2.new("mcs.c18r4.b2", "mcs", at="lhclength-(807.1237+(183-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244923.0, assembly_id=102862.0))
lhcb2.new("bpm.18r4.b2", "bpm", at="lhclength-(808.0027+(183-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244925.0, assembly_id=102863.0))
lhcb2.new("mqt.18r4.b2", "mqt", at="lhclength-(808.7567+(183-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307418.0, assembly_id=102863.0))
lhcb2.new("mq.18r4.b2", "mq", at="lhclength-(810.7647+(183-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308407.0, assembly_id=102863.0))
lhcb2.new("ms.18r4.b2", "ms", at="lhclength-(812.6597+(183-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251166.0, assembly_id=102863.0))
lhcb2.new("mcbv.18r4.b2", "mcbv", at="lhclength-(813.2527+(183-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251168.0, assembly_id=102863.0))
lhcb2.new("mb.a19r4.b2", "mb", at="lhclength-(821.8297+(183.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831882.0, assembly_id=102864.0))
lhcb2.new("mcs.a19r4.b2", "mcs", at="lhclength-(829.2537+(184-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244931.0, assembly_id=102864.0))
lhcb2.new("mco.19r4.b2", "mco", at="lhclength-(830.0037+(184-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251170.0, assembly_id=102865.0))
lhcb2.new("mcd.19r4.b2", "mcd", at="lhclength-(830.0052+(184-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251171.0, assembly_id=102865.0))
lhcb2.new("mb.b19r4.b2", "mb", at="lhclength-(837.4897+(184.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831906.0, assembly_id=102865.0))
lhcb2.new("mcs.b19r4.b2", "mcs", at="lhclength-(844.9137+(185-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244936.0, assembly_id=102865.0))
lhcb2.new("mb.c19r4.b2", "mb", at="lhclength-(853.1497+(185.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831930.0, assembly_id=102866.0))
lhcb2.new("mcs.c19r4.b2", "mcs", at="lhclength-(860.5737+(186-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244939.0, assembly_id=102866.0))
lhcb2.new("bpm.19r4.b2", "bpm", at="lhclength-(861.4527+(186-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244941.0, assembly_id=102867.0))
lhcb2.new("mqt.19r4.b2", "mqt", at="lhclength-(862.2067+(186-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307448.0, assembly_id=102867.0))
lhcb2.new("mq.19r4.b2", "mq", at="lhclength-(864.2147+(186-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308439.0, assembly_id=102867.0))
lhcb2.new("ms.19r4.b2", "ms", at="lhclength-(866.1097+(186-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251174.0, assembly_id=102867.0))
lhcb2.new("mcbh.19r4.b2", "mcbh", at="lhclength-(866.7027+(186-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251176.0, assembly_id=102867.0))
lhcb2.new("mco.a20r4.b2", "mco", at="lhclength-(867.7937+(186-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251178.0, assembly_id=102868.0))
lhcb2.new("mcd.a20r4.b2", "mcd", at="lhclength-(867.7952+(186-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251179.0, assembly_id=102868.0))
lhcb2.new("mb.a20r4.b2", "mb", at="lhclength-(875.2797+(186.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831954.0, assembly_id=102868.0))
lhcb2.new("mcs.a20r4.b2", "mcs", at="lhclength-(882.7037+(187-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244949.0, assembly_id=102868.0))
lhcb2.new("mb.b20r4.b2", "mb", at="lhclength-(890.9397+(187.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52831978.0, assembly_id=102869.0))
lhcb2.new("mcs.b20r4.b2", "mcs", at="lhclength-(898.3637+(188-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244952.0, assembly_id=102869.0))
lhcb2.new("mco.b20r4.b2", "mco", at="lhclength-(899.1137+(188-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251182.0, assembly_id=102870.0))
lhcb2.new("mcd.b20r4.b2", "mcd", at="lhclength-(899.1152+(188-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251183.0, assembly_id=102870.0))
lhcb2.new("mb.c20r4.b2", "mb", at="lhclength-(906.5997+(188.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832002.0, assembly_id=102870.0))
lhcb2.new("mcs.c20r4.b2", "mcs", at="lhclength-(914.0237+(189-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244957.0, assembly_id=102870.0))
lhcb2.new("bpm.20r4.b2", "bpm", at="lhclength-(914.9027+(189-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244959.0, assembly_id=102871.0))
lhcb2.new("mqt.20r4.b2", "mqt", at="lhclength-(915.6567+(189-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307478.0, assembly_id=102871.0))
lhcb2.new("mq.20r4.b2", "mq", at="lhclength-(917.6647+(189-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308230.0, assembly_id=102871.0))
lhcb2.new("ms.20r4.b2", "ms", at="lhclength-(919.5597+(189-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251186.0, assembly_id=102871.0))
lhcb2.new("mcbv.20r4.b2", "mcbv", at="lhclength-(920.1527+(189-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251188.0, assembly_id=102871.0))
lhcb2.new("mb.a21r4.b2", "mb", at="lhclength-(928.7297+(189.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832026.0, assembly_id=102872.0))
lhcb2.new("mcs.a21r4.b2", "mcs", at="lhclength-(936.1537+(190-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244965.0, assembly_id=102872.0))
lhcb2.new("mco.21r4.b2", "mco", at="lhclength-(936.9037+(190-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251190.0, assembly_id=102873.0))
lhcb2.new("mcd.21r4.b2", "mcd", at="lhclength-(936.9052+(190-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251191.0, assembly_id=102873.0))
lhcb2.new("mb.b21r4.b2", "mb", at="lhclength-(944.3897+(190.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832050.0, assembly_id=102873.0))
lhcb2.new("mcs.b21r4.b2", "mcs", at="lhclength-(951.8137+(191-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244970.0, assembly_id=102873.0))
lhcb2.new("mb.c21r4.b2", "mb", at="lhclength-(960.0497+(191.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832074.0, assembly_id=102874.0))
lhcb2.new("mcs.c21r4.b2", "mcs", at="lhclength-(967.4737+(192-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244973.0, assembly_id=102874.0))
lhcb2.new("bpm.21r4.b2", "bpm", at="lhclength-(968.3527+(192-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244975.0, assembly_id=102875.0))
lhcb2.new("mqt.21r4.b2", "mqt", at="lhclength-(969.1067+(192-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307276.0, assembly_id=102875.0))
lhcb2.new("mq.21r4.b2", "mq", at="lhclength-(971.1147+(192-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308260.0, assembly_id=102875.0))
lhcb2.new("ms.21r4.b2", "ms", at="lhclength-(973.0097+(192-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251194.0, assembly_id=102875.0))
lhcb2.new("mcbh.21r4.b2", "mcbh", at="lhclength-(973.6027+(192-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251196.0, assembly_id=102875.0))
lhcb2.new("mco.a22r4.b2", "mco", at="lhclength-(974.6937+(192-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251198.0, assembly_id=102876.0))
lhcb2.new("mcd.a22r4.b2", "mcd", at="lhclength-(974.6952+(192-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251199.0, assembly_id=102876.0))
lhcb2.new("mb.a22r4.b2", "mb", at="lhclength-(982.1797+(192.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832098.0, assembly_id=102876.0))
lhcb2.new("mcs.a22r4.b2", "mcs", at="lhclength-(989.6037+(193-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244983.0, assembly_id=102876.0))
lhcb2.new("mb.b22r4.b2", "mb", at="lhclength-(997.8397+(193.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832122.0, assembly_id=102877.0))
lhcb2.new("mcs.b22r4.b2", "mcs", at="lhclength-(1005.2637+(194-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244986.0, assembly_id=102877.0))
lhcb2.new("mco.b22r4.b2", "mco", at="lhclength-(1006.0137+(194-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251202.0, assembly_id=102878.0))
lhcb2.new("mcd.b22r4.b2", "mcd", at="lhclength-(1006.0152+(194-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251203.0, assembly_id=102878.0))
lhcb2.new("mb.c22r4.b2", "mb", at="lhclength-(1013.4997+(194.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832146.0, assembly_id=102878.0))
lhcb2.new("mcs.c22r4.b2", "mcs", at="lhclength-(1020.9237+(195-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244991.0, assembly_id=102878.0))
lhcb2.new("bpm.22r4.b2", "bpm", at="lhclength-(1021.8027+(195-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244993.0, assembly_id=102879.0))
lhcb2.new("mo.22r4.b2", "mo", at="lhclength-(1022.5537+(195-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308820.0, assembly_id=102879.0))
lhcb2.new("mq.22r4.b2", "mq", at="lhclength-(1024.5647+(195-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308292.0, assembly_id=102879.0))
lhcb2.new("ms.22r4.b2", "ms", at="lhclength-(1026.4597+(195-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251206.0, assembly_id=102879.0))
lhcb2.new("mcbv.22r4.b2", "mcbv", at="lhclength-(1027.0527+(195-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251208.0, assembly_id=102879.0))
lhcb2.new("mb.a23r4.b2", "mb", at="lhclength-(1035.6297+(195.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832170.0, assembly_id=102880.0))
lhcb2.new("mcs.a23r4.b2", "mcs", at="lhclength-(1043.0537+(196-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=244999.0, assembly_id=102880.0))
lhcb2.new("mco.23r4.b2", "mco", at="lhclength-(1043.8037+(196-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251210.0, assembly_id=102881.0))
lhcb2.new("mcd.23r4.b2", "mcd", at="lhclength-(1043.8052+(196-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251211.0, assembly_id=102881.0))
lhcb2.new("mb.b23r4.b2", "mb", at="lhclength-(1051.2897+(196.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832194.0, assembly_id=102881.0))
lhcb2.new("mcs.b23r4.b2", "mcs", at="lhclength-(1058.7137+(197-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245004.0, assembly_id=102881.0))
lhcb2.new("mb.c23r4.b2", "mb", at="lhclength-(1066.9497+(197.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832218.0, assembly_id=102882.0))
lhcb2.new("mcs.c23r4.b2", "mcs", at="lhclength-(1074.3737+(198-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245007.0, assembly_id=102882.0))
lhcb2.new("bpm.23r4.b2", "bpm", at="lhclength-(1075.2527+(198-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245009.0, assembly_id=102883.0))
lhcb2.new("mqs.23r4.b2", "mqs", at="lhclength-(1076.0067+(198-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307642.0, assembly_id=102883.0))
lhcb2.new("mq.23r4.b2", "mq", at="lhclength-(1078.0147+(198-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308323.0, assembly_id=102883.0))
lhcb2.new("ms.23r4.b2", "ms", at="lhclength-(1079.9097+(198-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251214.0, assembly_id=102883.0))
lhcb2.new("mcbh.23r4.b2", "mcbh", at="lhclength-(1080.5027+(198-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251216.0, assembly_id=102883.0))
lhcb2.new("mco.a24r4.b2", "mco", at="lhclength-(1081.5937+(198-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251218.0, assembly_id=102884.0))
lhcb2.new("mcd.a24r4.b2", "mcd", at="lhclength-(1081.5952+(198-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251219.0, assembly_id=102884.0))
lhcb2.new("mb.a24r4.b2", "mb", at="lhclength-(1089.0797+(198.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832242.0, assembly_id=102884.0))
lhcb2.new("mcs.a24r4.b2", "mcs", at="lhclength-(1096.5037+(199-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245017.0, assembly_id=102884.0))
lhcb2.new("mb.b24r4.b2", "mb", at="lhclength-(1104.7397+(199.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832266.0, assembly_id=102885.0))
lhcb2.new("mcs.b24r4.b2", "mcs", at="lhclength-(1112.1637+(200-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245020.0, assembly_id=102885.0))
lhcb2.new("mco.b24r4.b2", "mco", at="lhclength-(1112.9137+(200-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251222.0, assembly_id=102886.0))
lhcb2.new("mcd.b24r4.b2", "mcd", at="lhclength-(1112.9152+(200-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251223.0, assembly_id=102886.0))
lhcb2.new("mb.c24r4.b2", "mb", at="lhclength-(1120.3997+(200.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832290.0, assembly_id=102886.0))
lhcb2.new("mcs.c24r4.b2", "mcs", at="lhclength-(1127.8237+(201-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245025.0, assembly_id=102886.0))
lhcb2.new("bpm.24r4.b2", "bpm", at="lhclength-(1128.7027+(201-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245027.0, assembly_id=102887.0))
lhcb2.new("mo.24r4.b2", "mo", at="lhclength-(1129.4537+(201-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308850.0, assembly_id=102887.0))
lhcb2.new("mq.24r4.b2", "mq", at="lhclength-(1131.4647+(201-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308113.0, assembly_id=102887.0))
lhcb2.new("ms.24r4.b2", "ms", at="lhclength-(1133.3597+(201-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251226.0, assembly_id=102887.0))
lhcb2.new("mcbv.24r4.b2", "mcbv", at="lhclength-(1133.9527+(201-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251228.0, assembly_id=102887.0))
lhcb2.new("mb.a25r4.b2", "mb", at="lhclength-(1142.5297+(201.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832314.0, assembly_id=102888.0))
lhcb2.new("mcs.a25r4.b2", "mcs", at="lhclength-(1149.9537+(202-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245033.0, assembly_id=102888.0))
lhcb2.new("mco.25r4.b2", "mco", at="lhclength-(1150.7037+(202-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251230.0, assembly_id=102889.0))
lhcb2.new("mcd.25r4.b2", "mcd", at="lhclength-(1150.7052+(202-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251231.0, assembly_id=102889.0))
lhcb2.new("mb.b25r4.b2", "mb", at="lhclength-(1158.1897+(202.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832338.0, assembly_id=102889.0))
lhcb2.new("mcs.b25r4.b2", "mcs", at="lhclength-(1165.6137+(203-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245038.0, assembly_id=102889.0))
lhcb2.new("mb.c25r4.b2", "mb", at="lhclength-(1173.8497+(203.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832362.0, assembly_id=102890.0))
lhcb2.new("mcs.c25r4.b2", "mcs", at="lhclength-(1181.2737+(204-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245041.0, assembly_id=102890.0))
lhcb2.new("bpm.25r4.b2", "bpm", at="lhclength-(1182.1527+(204-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245043.0, assembly_id=102891.0))
lhcb2.new("mo.25r4.b2", "mo", at="lhclength-(1182.9037+(204-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308882.0, assembly_id=102891.0))
lhcb2.new("mq.25r4.b2", "mq", at="lhclength-(1184.9147+(204-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308145.0, assembly_id=102891.0))
lhcb2.new("ms.25r4.b2", "ms", at="lhclength-(1186.8097+(204-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251234.0, assembly_id=102891.0))
lhcb2.new("mcbh.25r4.b2", "mcbh", at="lhclength-(1187.4027+(204-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251236.0, assembly_id=102891.0))
lhcb2.new("mco.a26r4.b2", "mco", at="lhclength-(1188.4937+(204-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251238.0, assembly_id=102892.0))
lhcb2.new("mcd.a26r4.b2", "mcd", at="lhclength-(1188.4952+(204-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251239.0, assembly_id=102892.0))
lhcb2.new("mb.a26r4.b2", "mb", at="lhclength-(1195.9797+(204.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832386.0, assembly_id=102892.0))
lhcb2.new("mcs.a26r4.b2", "mcs", at="lhclength-(1203.4037+(205-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245051.0, assembly_id=102892.0))
lhcb2.new("mb.b26r4.b2", "mb", at="lhclength-(1211.6397+(205.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832410.0, assembly_id=102893.0))
lhcb2.new("mcs.b26r4.b2", "mcs", at="lhclength-(1219.0637+(206-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245054.0, assembly_id=102893.0))
lhcb2.new("mco.b26r4.b2", "mco", at="lhclength-(1219.8137+(206-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251242.0, assembly_id=102894.0))
lhcb2.new("mcd.b26r4.b2", "mcd", at="lhclength-(1219.8152+(206-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251243.0, assembly_id=102894.0))
lhcb2.new("mb.c26r4.b2", "mb", at="lhclength-(1227.2997+(206.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832434.0, assembly_id=102894.0))
lhcb2.new("mcs.c26r4.b2", "mcs", at="lhclength-(1234.7237+(207-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245059.0, assembly_id=102894.0))
lhcb2.new("bpm.26r4.b2", "bpm", at="lhclength-(1235.6027+(207-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245061.0, assembly_id=102895.0))
lhcb2.new("mo.26r4.b2", "mo", at="lhclength-(1236.3537+(207-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308913.0, assembly_id=102895.0))
lhcb2.new("mq.26r4.b2", "mq", at="lhclength-(1238.3647+(207-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308176.0, assembly_id=102895.0))
lhcb2.new("ms.26r4.b2", "ms", at="lhclength-(1240.2597+(207-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251246.0, assembly_id=102895.0))
lhcb2.new("mcbv.26r4.b2", "mcbv", at="lhclength-(1240.8527+(207-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251248.0, assembly_id=102895.0))
lhcb2.new("mb.a27r4.b2", "mb", at="lhclength-(1249.4297+(207.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832458.0, assembly_id=102896.0))
lhcb2.new("mcs.a27r4.b2", "mcs", at="lhclength-(1256.8537+(208-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245067.0, assembly_id=102896.0))
lhcb2.new("mco.27r4.b2", "mco", at="lhclength-(1257.6037+(208-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251250.0, assembly_id=102897.0))
lhcb2.new("mcd.27r4.b2", "mcd", at="lhclength-(1257.6052+(208-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251251.0, assembly_id=102897.0))
lhcb2.new("mb.b27r4.b2", "mb", at="lhclength-(1265.0897+(208.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832482.0, assembly_id=102897.0))
lhcb2.new("mcs.b27r4.b2", "mcs", at="lhclength-(1272.5137+(209-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245072.0, assembly_id=102897.0))
lhcb2.new("mb.c27r4.b2", "mb", at="lhclength-(1280.7497+(209.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832506.0, assembly_id=102898.0))
lhcb2.new("mcs.c27r4.b2", "mcs", at="lhclength-(1288.1737+(210-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245075.0, assembly_id=102898.0))
lhcb2.new("bpm.27r4.b2", "bpm", at="lhclength-(1289.0527+(210-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245077.0, assembly_id=102899.0))
lhcb2.new("mqs.27r4.b2", "mqs", at="lhclength-(1289.8067+(210-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307674.0, assembly_id=102899.0))
lhcb2.new("mq.27r4.b2", "mq", at="lhclength-(1291.8147+(210-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308205.0, assembly_id=102899.0))
lhcb2.new("ms.27r4.b2", "ms", at="lhclength-(1293.7097+(210-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251254.0, assembly_id=102899.0))
lhcb2.new("mcbh.27r4.b2", "mcbh", at="lhclength-(1294.3027+(210-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251256.0, assembly_id=102899.0))
lhcb2.new("mco.a28r4.b2", "mco", at="lhclength-(1295.3937+(210-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251258.0, assembly_id=102900.0))
lhcb2.new("mcd.a28r4.b2", "mcd", at="lhclength-(1295.3952+(210-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251259.0, assembly_id=102900.0))
lhcb2.new("mb.a28r4.b2", "mb", at="lhclength-(1302.8797+(210.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832530.0, assembly_id=102900.0))
lhcb2.new("mcs.a28r4.b2", "mcs", at="lhclength-(1310.3037+(211-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245085.0, assembly_id=102900.0))
lhcb2.new("mb.b28r4.b2", "mb", at="lhclength-(1318.5397+(211.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832554.0, assembly_id=102901.0))
lhcb2.new("mcs.b28r4.b2", "mcs", at="lhclength-(1325.9637+(212-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245088.0, assembly_id=102901.0))
lhcb2.new("mco.b28r4.b2", "mco", at="lhclength-(1326.7137+(212-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251262.0, assembly_id=102902.0))
lhcb2.new("mcd.b28r4.b2", "mcd", at="lhclength-(1326.7152+(212-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251263.0, assembly_id=102902.0))
lhcb2.new("mb.c28r4.b2", "mb", at="lhclength-(1334.1997+(212.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832578.0, assembly_id=102902.0))
lhcb2.new("mcs.c28r4.b2", "mcs", at="lhclength-(1341.6237+(213-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245093.0, assembly_id=102902.0))
lhcb2.new("bpm.28r4.b2", "bpm", at="lhclength-(1342.5027+(213-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245095.0, assembly_id=102903.0))
lhcb2.new("mo.28r4.b2", "mo", at="lhclength-(1343.2537+(213-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308703.0, assembly_id=102903.0))
lhcb2.new("mq.28r4.b2", "mq", at="lhclength-(1345.2647+(213-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307997.0, assembly_id=102903.0))
lhcb2.new("ms.28r4.b2", "ms", at="lhclength-(1347.1597+(213-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251266.0, assembly_id=102903.0))
lhcb2.new("mcbv.28r4.b2", "mcbv", at="lhclength-(1347.7527+(213-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251268.0, assembly_id=102903.0))
lhcb2.new("mb.a29r4.b2", "mb", at="lhclength-(1356.3297+(213.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832602.0, assembly_id=102904.0))
lhcb2.new("mcs.a29r4.b2", "mcs", at="lhclength-(1363.7537+(214-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245101.0, assembly_id=102904.0))
lhcb2.new("mco.29r4.b2", "mco", at="lhclength-(1364.5037+(214-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251270.0, assembly_id=102905.0))
lhcb2.new("mcd.29r4.b2", "mcd", at="lhclength-(1364.5052+(214-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251271.0, assembly_id=102905.0))
lhcb2.new("mb.b29r4.b2", "mb", at="lhclength-(1371.9897+(214.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832626.0, assembly_id=102905.0))
lhcb2.new("mcs.b29r4.b2", "mcs", at="lhclength-(1379.4137+(215-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245106.0, assembly_id=102905.0))
lhcb2.new("mb.c29r4.b2", "mb", at="lhclength-(1387.6497+(215.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832650.0, assembly_id=102906.0))
lhcb2.new("mcs.c29r4.b2", "mcs", at="lhclength-(1395.0737+(216-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245109.0, assembly_id=102906.0))
lhcb2.new("bpm.29r4.b2", "bpm", at="lhclength-(1395.9527+(216-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245111.0, assembly_id=102907.0))
lhcb2.new("mo.29r4.b2", "mo", at="lhclength-(1396.7037+(216-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308735.0, assembly_id=102907.0))
lhcb2.new("mq.29r4.b2", "mq", at="lhclength-(1398.7147+(216-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308028.0, assembly_id=102907.0))
lhcb2.new("mss.29r4.b2", "mss", at="lhclength-(1400.6097+(216-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251274.0, assembly_id=102907.0))
lhcb2.new("mcbh.29r4.b2", "mcbh", at="lhclength-(1401.2027+(216-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251276.0, assembly_id=102907.0))
lhcb2.new("mco.a30r4.b2", "mco", at="lhclength-(1402.2937+(216-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251278.0, assembly_id=102908.0))
lhcb2.new("mcd.a30r4.b2", "mcd", at="lhclength-(1402.2952+(216-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251279.0, assembly_id=102908.0))
lhcb2.new("mb.a30r4.b2", "mb", at="lhclength-(1409.7797+(216.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832674.0, assembly_id=102908.0))
lhcb2.new("mcs.a30r4.b2", "mcs", at="lhclength-(1417.2037+(217-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245119.0, assembly_id=102908.0))
lhcb2.new("mb.b30r4.b2", "mb", at="lhclength-(1425.4397+(217.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832698.0, assembly_id=102909.0))
lhcb2.new("mcs.b30r4.b2", "mcs", at="lhclength-(1432.8637+(218-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245122.0, assembly_id=102909.0))
lhcb2.new("mco.b30r4.b2", "mco", at="lhclength-(1433.6137+(218-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251282.0, assembly_id=102910.0))
lhcb2.new("mcd.b30r4.b2", "mcd", at="lhclength-(1433.6152+(218-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251283.0, assembly_id=102910.0))
lhcb2.new("mb.c30r4.b2", "mb", at="lhclength-(1441.0997+(218.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832722.0, assembly_id=102910.0))
lhcb2.new("mcs.c30r4.b2", "mcs", at="lhclength-(1448.5237+(219-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245127.0, assembly_id=102910.0))
lhcb2.new("bpm.30r4.b2", "bpm", at="lhclength-(1449.4027+(219-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245129.0, assembly_id=102911.0))
lhcb2.new("mo.30r4.b2", "mo", at="lhclength-(1450.1537+(219-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308766.0, assembly_id=102911.0))
lhcb2.new("mq.30r4.b2", "mq", at="lhclength-(1452.1647+(219-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2348467.0, assembly_id=102911.0))
lhcb2.new("ms.30r4.b2", "ms", at="lhclength-(1454.0597+(219-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251286.0, assembly_id=102911.0))
lhcb2.new("mcbv.30r4.b2", "mcbv", at="lhclength-(1454.6527+(219-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251288.0, assembly_id=102911.0))
lhcb2.new("mb.a31r4.b2", "mb", at="lhclength-(1463.2297+(219.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832746.0, assembly_id=102912.0))
lhcb2.new("mcs.a31r4.b2", "mcs", at="lhclength-(1470.6537+(220-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245135.0, assembly_id=102912.0))
lhcb2.new("mco.31r4.b2", "mco", at="lhclength-(1471.4037+(220-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251290.0, assembly_id=102913.0))
lhcb2.new("mcd.31r4.b2", "mcd", at="lhclength-(1471.4052+(220-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251291.0, assembly_id=102913.0))
lhcb2.new("mb.b31r4.b2", "mb", at="lhclength-(1478.8897+(220.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832770.0, assembly_id=102913.0))
lhcb2.new("mcs.b31r4.b2", "mcs", at="lhclength-(1486.3137+(221-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245140.0, assembly_id=102913.0))
lhcb2.new("mb.c31r4.b2", "mb", at="lhclength-(1494.5497+(221.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832794.0, assembly_id=102914.0))
lhcb2.new("mcs.c31r4.b2", "mcs", at="lhclength-(1501.9737+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245143.0, assembly_id=102914.0))
lhcb2.new("bpm.31r4.b2", "bpm", at="lhclength-(1502.8527+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245145.0, assembly_id=102915.0))
lhcb2.new("mo.31r4.b2", "mo", at="lhclength-(1503.6037+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308796.0, assembly_id=102915.0))
lhcb2.new("mq.31r4.b2", "mq", at="lhclength-(1505.6147+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307849.0, assembly_id=102915.0))
lhcb2.new("ms.31r4.b2", "ms", at="lhclength-(1507.5097+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251294.0, assembly_id=102915.0))
lhcb2.new("mcbh.31r4.b2", "mcbh", at="lhclength-(1508.1027+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251296.0, assembly_id=102915.0))
lhcb2.new("s.cell.45.b2", "omk", at="lhclength-(1508.8497+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a32r4.b2", "mco", at="lhclength-(1509.1937+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251298.0, assembly_id=102916.0))
lhcb2.new("mcd.a32r4.b2", "mcd", at="lhclength-(1509.1952+(222-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251299.0, assembly_id=102916.0))
lhcb2.new("mb.a32r4.b2", "mb", at="lhclength-(1516.6797+(222.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832818.0, assembly_id=102916.0))
lhcb2.new("mcs.a32r4.b2", "mcs", at="lhclength-(1524.1037+(223-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245153.0, assembly_id=102916.0))
lhcb2.new("mb.b32r4.b2", "mb", at="lhclength-(1532.3397+(223.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832842.0, assembly_id=102917.0))
lhcb2.new("mcs.b32r4.b2", "mcs", at="lhclength-(1539.7637+(224-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245156.0, assembly_id=102917.0))
lhcb2.new("mco.b32r4.b2", "mco", at="lhclength-(1540.5137+(224-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251302.0, assembly_id=102918.0))
lhcb2.new("mcd.b32r4.b2", "mcd", at="lhclength-(1540.5152+(224-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251303.0, assembly_id=102918.0))
lhcb2.new("mb.c32r4.b2", "mb", at="lhclength-(1547.9997+(224.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832866.0, assembly_id=102918.0))
lhcb2.new("mcs.c32r4.b2", "mcs", at="lhclength-(1555.4237+(225-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245161.0, assembly_id=102918.0))
lhcb2.new("bpm.32r4.b2", "bpm", at="lhclength-(1556.3027+(225-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245163.0, assembly_id=102919.0))
lhcb2.new("mo.32r4.b2", "mo", at="lhclength-(1557.0537+(225-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308588.0, assembly_id=102919.0))
lhcb2.new("mq.32r4.b2", "mq", at="lhclength-(1559.0647+(225-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307879.0, assembly_id=102919.0))
lhcb2.new("ms.32r4.b2", "ms", at="lhclength-(1560.9597+(225-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251306.0, assembly_id=102919.0))
lhcb2.new("mcbv.32r4.b2", "mcbv", at="lhclength-(1561.5527+(225-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251308.0, assembly_id=102919.0))
lhcb2.new("mb.a33r4.b2", "mb", at="lhclength-(1570.1297+(225.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832890.0, assembly_id=102920.0))
lhcb2.new("mcs.a33r4.b2", "mcs", at="lhclength-(1577.5537+(226-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245169.0, assembly_id=102920.0))
lhcb2.new("mco.33r4.b2", "mco", at="lhclength-(1578.3037+(226-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251310.0, assembly_id=102921.0))
lhcb2.new("mcd.33r4.b2", "mcd", at="lhclength-(1578.3052+(226-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251311.0, assembly_id=102921.0))
lhcb2.new("mb.b33r4.b2", "mb", at="lhclength-(1585.7897+(226.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832914.0, assembly_id=102921.0))
lhcb2.new("mcs.b33r4.b2", "mcs", at="lhclength-(1593.2137+(227-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245174.0, assembly_id=102921.0))
lhcb2.new("mb.c33r4.b2", "mb", at="lhclength-(1601.4497+(227.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832938.0, assembly_id=102922.0))
lhcb2.new("mcs.c33r4.b2", "mcs", at="lhclength-(1608.8737+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245177.0, assembly_id=102922.0))
lhcb2.new("bpm.33r4.b2", "bpm", at="lhclength-(1609.7527+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245179.0, assembly_id=102923.0))
lhcb2.new("mo.33r4.b2", "mo", at="lhclength-(1610.5037+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308619.0, assembly_id=102923.0))
lhcb2.new("mq.33r4.b2", "mq", at="lhclength-(1612.5147+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307909.0, assembly_id=102923.0))
lhcb2.new("mss.33r4.b2", "mss", at="lhclength-(1614.4097+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251314.0, assembly_id=102923.0))
lhcb2.new("mcbh.33r4.b2", "mcbh", at="lhclength-(1615.0027+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251316.0, assembly_id=102923.0))
lhcb2.new("e.cell.45.b2", "omk", at="lhclength-(1615.7497+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a34r4.b2", "mco", at="lhclength-(1616.0937+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251318.0, assembly_id=102924.0))
lhcb2.new("mcd.a34r4.b2", "mcd", at="lhclength-(1616.0952+(228-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251319.0, assembly_id=102924.0))
lhcb2.new("mb.a34r4.b2", "mb", at="lhclength-(1623.5797+(228.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832962.0, assembly_id=102924.0))
lhcb2.new("mcs.a34r4.b2", "mcs", at="lhclength-(1631.0037+(229-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245187.0, assembly_id=102924.0))
lhcb2.new("mb.b34r4.b2", "mb", at="lhclength-(1639.2397+(229.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52832986.0, assembly_id=102925.0))
lhcb2.new("mcs.b34r4.b2", "mcs", at="lhclength-(1646.6637+(230-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245190.0, assembly_id=102925.0))
lhcb2.new("mco.b34r4.b2", "mco", at="lhclength-(1647.4137+(230-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251322.0, assembly_id=102926.0))
lhcb2.new("mcd.b34r4.b2", "mcd", at="lhclength-(1647.4152+(230-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=251323.0, assembly_id=102926.0))
lhcb2.new("mb.c34r4.b2", "mb", at="lhclength-(1654.8997+(230.5-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=52833010.0, assembly_id=102926.0))
lhcb2.new("mcs.c34r4.b2", "mcs", at="lhclength-(1662.3237+(231-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245195.0, assembly_id=102926.0))
lhcb2.new("bpm.34r4.b2", "bpm", at="lhclength-(1663.2027+(231-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=245197.0, assembly_id=102927.0))
lhcb2.new("mo.34r4.b2", "mo", at="lhclength-(1663.9537+(231-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2308634.0, assembly_id=102927.0))
lhcb2.new("mq.34r4.b2", "mq", at="lhclength-(1665.9647+(231-ip4ofs.b2)*ds)", from_="ip4", extra=dict(mech_sep=0.194, slot_id=2307924.0, assembly_id=102927.0))
lhcb2.new("ms.34l5.b2", "ms", at="lhclength-(-1664.5007+(231-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251326.0, assembly_id=102927.0))
lhcb2.new("mcbv.34l5.b2", "mcbv", at="lhclength-(-1663.9077+(231-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251328.0, assembly_id=102927.0))
lhcb2.new("mb.c34l5.b2", "mb", at="lhclength-(-1655.3307+(231.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833034.0, assembly_id=102928.0))
lhcb2.new("mcs.c34l5.b2", "mcs", at="lhclength-(-1647.9067+(232-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245203.0, assembly_id=102928.0))
lhcb2.new("mco.34l5.b2", "mco", at="lhclength-(-1647.1567+(232-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251330.0, assembly_id=102929.0))
lhcb2.new("mcd.34l5.b2", "mcd", at="lhclength-(-1647.1552+(232-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251331.0, assembly_id=102929.0))
lhcb2.new("mb.b34l5.b2", "mb", at="lhclength-(-1639.6707+(232.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833058.0, assembly_id=102929.0))
lhcb2.new("mcs.b34l5.b2", "mcs", at="lhclength-(-1632.2467+(233-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245208.0, assembly_id=102929.0))
lhcb2.new("mb.a34l5.b2", "mb", at="lhclength-(-1624.0107+(233.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833082.0, assembly_id=102930.0))
lhcb2.new("mcs.a34l5.b2", "mcs", at="lhclength-(-1616.5867+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245211.0, assembly_id=102930.0))
lhcb2.new("bpm.33l5.b2", "bpm", at="lhclength-(-1615.7077+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245213.0, assembly_id=102931.0))
lhcb2.new("mo.33l5.b2", "mo", at="lhclength-(-1614.9567+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308606.0, assembly_id=102931.0))
lhcb2.new("mq.33l5.b2", "mq", at="lhclength-(-1612.9457+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307896.0, assembly_id=102931.0))
lhcb2.new("mss.33l5.b2", "mss", at="lhclength-(-1611.0507+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251334.0, assembly_id=102931.0))
lhcb2.new("mcbh.33l5.b2", "mcbh", at="lhclength-(-1610.4577+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251336.0, assembly_id=102931.0))
lhcb2.new("mco.b33l5.b2", "mco", at="lhclength-(-1609.3667+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251338.0, assembly_id=102932.0))
lhcb2.new("mcd.b33l5.b2", "mcd", at="lhclength-(-1609.3652+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251339.0, assembly_id=102932.0))
lhcb2.new("mb.c33l5.b2", "mb", at="lhclength-(-1601.8807+(234.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833106.0, assembly_id=102932.0))
lhcb2.new("mcs.c33l5.b2", "mcs", at="lhclength-(-1594.4567+(235-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245221.0, assembly_id=102932.0))
lhcb2.new("mb.b33l5.b2", "mb", at="lhclength-(-1586.2207+(235.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833130.0, assembly_id=102933.0))
lhcb2.new("mcs.b33l5.b2", "mcs", at="lhclength-(-1578.7967+(236-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245224.0, assembly_id=102933.0))
lhcb2.new("mco.a33l5.b2", "mco", at="lhclength-(-1578.0467+(236-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251342.0, assembly_id=102934.0))
lhcb2.new("mcd.a33l5.b2", "mcd", at="lhclength-(-1578.0452+(236-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251343.0, assembly_id=102934.0))
lhcb2.new("mb.a33l5.b2", "mb", at="lhclength-(-1570.5607+(236.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833154.0, assembly_id=102934.0))
lhcb2.new("mcs.a33l5.b2", "mcs", at="lhclength-(-1563.1367+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245229.0, assembly_id=102934.0))
lhcb2.new("bpm.32l5.b2", "bpm", at="lhclength-(-1562.2577+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245231.0, assembly_id=102935.0))
lhcb2.new("mo.32l5.b2", "mo", at="lhclength-(-1561.5067+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308574.0, assembly_id=102935.0))
lhcb2.new("mq.32l5.b2", "mq", at="lhclength-(-1559.4957+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307866.0, assembly_id=102935.0))
lhcb2.new("ms.32l5.b2", "ms", at="lhclength-(-1557.6007+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251346.0, assembly_id=102935.0))
lhcb2.new("mcbv.32l5.b2", "mcbv", at="lhclength-(-1557.0077+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251348.0, assembly_id=102935.0))
lhcb2.new("mb.c32l5.b2", "mb", at="lhclength-(-1548.4307+(237.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833178.0, assembly_id=102936.0))
lhcb2.new("mcs.c32l5.b2", "mcs", at="lhclength-(-1541.0067+(238-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245237.0, assembly_id=102936.0))
lhcb2.new("mco.32l5.b2", "mco", at="lhclength-(-1540.2567+(238-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251350.0, assembly_id=102937.0))
lhcb2.new("mcd.32l5.b2", "mcd", at="lhclength-(-1540.2552+(238-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251351.0, assembly_id=102937.0))
lhcb2.new("mb.b32l5.b2", "mb", at="lhclength-(-1532.7707+(238.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833202.0, assembly_id=102937.0))
lhcb2.new("mcs.b32l5.b2", "mcs", at="lhclength-(-1525.3467+(239-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245242.0, assembly_id=102937.0))
lhcb2.new("mb.a32l5.b2", "mb", at="lhclength-(-1517.1107+(239.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833226.0, assembly_id=102938.0))
lhcb2.new("mcs.a32l5.b2", "mcs", at="lhclength-(-1509.6867+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245245.0, assembly_id=102938.0))
lhcb2.new("bpm.31l5.b2", "bpm", at="lhclength-(-1508.8077+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245247.0, assembly_id=102939.0))
lhcb2.new("mo.31l5.b2", "mo", at="lhclength-(-1508.0567+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308783.0, assembly_id=102939.0))
lhcb2.new("mq.31l5.b2", "mq", at="lhclength-(-1506.0457+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308074.0, assembly_id=102939.0))
lhcb2.new("ms.31l5.b2", "ms", at="lhclength-(-1504.1507+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251354.0, assembly_id=102939.0))
lhcb2.new("mcbh.31l5.b2", "mcbh", at="lhclength-(-1503.5577+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251356.0, assembly_id=102939.0))
lhcb2.new("mco.b31l5.b2", "mco", at="lhclength-(-1502.4667+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251358.0, assembly_id=102940.0))
lhcb2.new("mcd.b31l5.b2", "mcd", at="lhclength-(-1502.4652+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251359.0, assembly_id=102940.0))
lhcb2.new("mb.c31l5.b2", "mb", at="lhclength-(-1494.9807+(240.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833250.0, assembly_id=102940.0))
lhcb2.new("mcs.c31l5.b2", "mcs", at="lhclength-(-1487.5567+(241-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245255.0, assembly_id=102940.0))
lhcb2.new("mb.b31l5.b2", "mb", at="lhclength-(-1479.3207+(241.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833274.0, assembly_id=102941.0))
lhcb2.new("mcs.b31l5.b2", "mcs", at="lhclength-(-1471.8967+(242-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245258.0, assembly_id=102941.0))
lhcb2.new("mco.a31l5.b2", "mco", at="lhclength-(-1471.1467+(242-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251362.0, assembly_id=102942.0))
lhcb2.new("mcd.a31l5.b2", "mcd", at="lhclength-(-1471.1452+(242-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251363.0, assembly_id=102942.0))
lhcb2.new("mb.a31l5.b2", "mb", at="lhclength-(-1463.6607+(242.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833298.0, assembly_id=102942.0))
lhcb2.new("mcs.a31l5.b2", "mcs", at="lhclength-(-1456.2367+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245263.0, assembly_id=102942.0))
lhcb2.new("bpm.30l5.b2", "bpm", at="lhclength-(-1455.3577+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245265.0, assembly_id=102943.0))
lhcb2.new("mo.30l5.b2", "mo", at="lhclength-(-1454.6067+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308753.0, assembly_id=102943.0))
lhcb2.new("mq.30l5.b2", "mq", at="lhclength-(-1452.5957+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308044.0, assembly_id=102943.0))
lhcb2.new("ms.30l5.b2", "ms", at="lhclength-(-1450.7007+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251366.0, assembly_id=102943.0))
lhcb2.new("mcbv.30l5.b2", "mcbv", at="lhclength-(-1450.1077+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251368.0, assembly_id=102943.0))
lhcb2.new("mb.c30l5.b2", "mb", at="lhclength-(-1441.5307+(243.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833322.0, assembly_id=102944.0))
lhcb2.new("mcs.c30l5.b2", "mcs", at="lhclength-(-1434.1067+(244-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245271.0, assembly_id=102944.0))
lhcb2.new("mco.30l5.b2", "mco", at="lhclength-(-1433.3567+(244-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251370.0, assembly_id=102945.0))
lhcb2.new("mcd.30l5.b2", "mcd", at="lhclength-(-1433.3552+(244-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251371.0, assembly_id=102945.0))
lhcb2.new("mb.b30l5.b2", "mb", at="lhclength-(-1425.8707+(244.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833346.0, assembly_id=102945.0))
lhcb2.new("mcs.b30l5.b2", "mcs", at="lhclength-(-1418.4467+(245-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245276.0, assembly_id=102945.0))
lhcb2.new("mb.a30l5.b2", "mb", at="lhclength-(-1410.2107+(245.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833370.0, assembly_id=102946.0))
lhcb2.new("mcs.a30l5.b2", "mcs", at="lhclength-(-1402.7867+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245279.0, assembly_id=102946.0))
lhcb2.new("bpm.29l5.b2", "bpm", at="lhclength-(-1401.9077+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245281.0, assembly_id=102947.0))
lhcb2.new("mo.29l5.b2", "mo", at="lhclength-(-1401.1567+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308721.0, assembly_id=102947.0))
lhcb2.new("mq.29l5.b2", "mq", at="lhclength-(-1399.1457+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308015.0, assembly_id=102947.0))
lhcb2.new("mss.29l5.b2", "mss", at="lhclength-(-1397.2507+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251374.0, assembly_id=102947.0))
lhcb2.new("mcbh.29l5.b2", "mcbh", at="lhclength-(-1396.6577+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251376.0, assembly_id=102947.0))
lhcb2.new("mco.b29l5.b2", "mco", at="lhclength-(-1395.5667+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251378.0, assembly_id=102948.0))
lhcb2.new("mcd.b29l5.b2", "mcd", at="lhclength-(-1395.5652+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251379.0, assembly_id=102948.0))
lhcb2.new("mb.c29l5.b2", "mb", at="lhclength-(-1388.0807+(246.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833394.0, assembly_id=102948.0))
lhcb2.new("mcs.c29l5.b2", "mcs", at="lhclength-(-1380.6567+(247-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245289.0, assembly_id=102948.0))
lhcb2.new("mb.b29l5.b2", "mb", at="lhclength-(-1372.4207+(247.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833418.0, assembly_id=102949.0))
lhcb2.new("mcs.b29l5.b2", "mcs", at="lhclength-(-1364.9967+(248-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245292.0, assembly_id=102949.0))
lhcb2.new("mco.a29l5.b2", "mco", at="lhclength-(-1364.2467+(248-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251382.0, assembly_id=102950.0))
lhcb2.new("mcd.a29l5.b2", "mcd", at="lhclength-(-1364.2452+(248-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251383.0, assembly_id=102950.0))
lhcb2.new("mb.a29l5.b2", "mb", at="lhclength-(-1356.7607+(248.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833442.0, assembly_id=102950.0))
lhcb2.new("mcs.a29l5.b2", "mcs", at="lhclength-(-1349.3367+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245297.0, assembly_id=102950.0))
lhcb2.new("bpm.28l5.b2", "bpm", at="lhclength-(-1348.4577+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245299.0, assembly_id=102951.0))
lhcb2.new("mo.28l5.b2", "mo", at="lhclength-(-1347.7067+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308690.0, assembly_id=102951.0))
lhcb2.new("mq.28l5.b2", "mq", at="lhclength-(-1345.6957+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307983.0, assembly_id=102951.0))
lhcb2.new("ms.28l5.b2", "ms", at="lhclength-(-1343.8007+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251386.0, assembly_id=102951.0))
lhcb2.new("mcbv.28l5.b2", "mcbv", at="lhclength-(-1343.2077+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251388.0, assembly_id=102951.0))
lhcb2.new("mb.c28l5.b2", "mb", at="lhclength-(-1334.6307+(249.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833466.0, assembly_id=102952.0))
lhcb2.new("mcs.c28l5.b2", "mcs", at="lhclength-(-1327.2067+(250-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245305.0, assembly_id=102952.0))
lhcb2.new("mco.28l5.b2", "mco", at="lhclength-(-1326.4567+(250-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251390.0, assembly_id=102953.0))
lhcb2.new("mcd.28l5.b2", "mcd", at="lhclength-(-1326.4552+(250-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251391.0, assembly_id=102953.0))
lhcb2.new("mb.b28l5.b2", "mb", at="lhclength-(-1318.9707+(250.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833490.0, assembly_id=102953.0))
lhcb2.new("mcs.b28l5.b2", "mcs", at="lhclength-(-1311.5467+(251-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245310.0, assembly_id=102953.0))
lhcb2.new("mb.a28l5.b2", "mb", at="lhclength-(-1303.3107+(251.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833514.0, assembly_id=102954.0))
lhcb2.new("mcs.a28l5.b2", "mcs", at="lhclength-(-1295.8867+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245313.0, assembly_id=102954.0))
lhcb2.new("bpm.27l5.b2", "bpm", at="lhclength-(-1295.0077+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245315.0, assembly_id=102955.0))
lhcb2.new("mqs.27l5.b2", "mqs", at="lhclength-(-1294.2537+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307660.0, assembly_id=102955.0))
lhcb2.new("mq.27l5.b2", "mq", at="lhclength-(-1292.2457+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308192.0, assembly_id=102955.0))
lhcb2.new("ms.27l5.b2", "ms", at="lhclength-(-1290.3507+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251394.0, assembly_id=102955.0))
lhcb2.new("mcbh.27l5.b2", "mcbh", at="lhclength-(-1289.7577+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251396.0, assembly_id=102955.0))
lhcb2.new("mco.b27l5.b2", "mco", at="lhclength-(-1288.6667+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251398.0, assembly_id=102956.0))
lhcb2.new("mcd.b27l5.b2", "mcd", at="lhclength-(-1288.6652+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251399.0, assembly_id=102956.0))
lhcb2.new("mb.c27l5.b2", "mb", at="lhclength-(-1281.1807+(252.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833538.0, assembly_id=102956.0))
lhcb2.new("mcs.c27l5.b2", "mcs", at="lhclength-(-1273.7567+(253-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245323.0, assembly_id=102956.0))
lhcb2.new("mb.b27l5.b2", "mb", at="lhclength-(-1265.5207+(253.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833562.0, assembly_id=102957.0))
lhcb2.new("mcs.b27l5.b2", "mcs", at="lhclength-(-1258.0967+(254-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245326.0, assembly_id=102957.0))
lhcb2.new("mco.a27l5.b2", "mco", at="lhclength-(-1257.3467+(254-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251402.0, assembly_id=102958.0))
lhcb2.new("mcd.a27l5.b2", "mcd", at="lhclength-(-1257.3452+(254-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251403.0, assembly_id=102958.0))
lhcb2.new("mb.a27l5.b2", "mb", at="lhclength-(-1249.8607+(254.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833586.0, assembly_id=102958.0))
lhcb2.new("mcs.a27l5.b2", "mcs", at="lhclength-(-1242.4367+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245331.0, assembly_id=102958.0))
lhcb2.new("bpm.26l5.b2", "bpm", at="lhclength-(-1241.5577+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245333.0, assembly_id=102959.0))
lhcb2.new("mo.26l5.b2", "mo", at="lhclength-(-1240.8067+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308900.0, assembly_id=102959.0))
lhcb2.new("mq.26l5.b2", "mq", at="lhclength-(-1238.7957+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308163.0, assembly_id=102959.0))
lhcb2.new("ms.26l5.b2", "ms", at="lhclength-(-1236.9007+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251406.0, assembly_id=102959.0))
lhcb2.new("mcbv.26l5.b2", "mcbv", at="lhclength-(-1236.3077+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251408.0, assembly_id=102959.0))
lhcb2.new("mb.c26l5.b2", "mb", at="lhclength-(-1227.7307+(255.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833610.0, assembly_id=102960.0))
lhcb2.new("mcs.c26l5.b2", "mcs", at="lhclength-(-1220.3067+(256-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245339.0, assembly_id=102960.0))
lhcb2.new("mco.26l5.b2", "mco", at="lhclength-(-1219.5567+(256-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251410.0, assembly_id=102961.0))
lhcb2.new("mcd.26l5.b2", "mcd", at="lhclength-(-1219.5552+(256-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251411.0, assembly_id=102961.0))
lhcb2.new("mb.b26l5.b2", "mb", at="lhclength-(-1212.0707+(256.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833634.0, assembly_id=102961.0))
lhcb2.new("mcs.b26l5.b2", "mcs", at="lhclength-(-1204.6467+(257-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245344.0, assembly_id=102961.0))
lhcb2.new("mb.a26l5.b2", "mb", at="lhclength-(-1196.4107+(257.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833658.0, assembly_id=102962.0))
lhcb2.new("mcs.a26l5.b2", "mcs", at="lhclength-(-1188.9867+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245347.0, assembly_id=102962.0))
lhcb2.new("bpm.25l5.b2", "bpm", at="lhclength-(-1188.1077+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245349.0, assembly_id=102963.0))
lhcb2.new("mo.25l5.b2", "mo", at="lhclength-(-1187.3567+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308868.0, assembly_id=102963.0))
lhcb2.new("mq.25l5.b2", "mq", at="lhclength-(-1185.3457+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308131.0, assembly_id=102963.0))
lhcb2.new("ms.25l5.b2", "ms", at="lhclength-(-1183.4507+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251414.0, assembly_id=102963.0))
lhcb2.new("mcbh.25l5.b2", "mcbh", at="lhclength-(-1182.8577+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251416.0, assembly_id=102963.0))
lhcb2.new("mco.b25l5.b2", "mco", at="lhclength-(-1181.7667+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251418.0, assembly_id=102964.0))
lhcb2.new("mcd.b25l5.b2", "mcd", at="lhclength-(-1181.7652+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251419.0, assembly_id=102964.0))
lhcb2.new("mb.c25l5.b2", "mb", at="lhclength-(-1174.2807+(258.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833682.0, assembly_id=102964.0))
lhcb2.new("mcs.c25l5.b2", "mcs", at="lhclength-(-1166.8567+(259-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245357.0, assembly_id=102964.0))
lhcb2.new("mb.b25l5.b2", "mb", at="lhclength-(-1158.6207+(259.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833706.0, assembly_id=102965.0))
lhcb2.new("mcs.b25l5.b2", "mcs", at="lhclength-(-1151.1967+(260-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245360.0, assembly_id=102965.0))
lhcb2.new("mco.a25l5.b2", "mco", at="lhclength-(-1150.4467+(260-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251422.0, assembly_id=102966.0))
lhcb2.new("mcd.a25l5.b2", "mcd", at="lhclength-(-1150.4452+(260-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251423.0, assembly_id=102966.0))
lhcb2.new("mb.a25l5.b2", "mb", at="lhclength-(-1142.9607+(260.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833730.0, assembly_id=102966.0))
lhcb2.new("mcs.a25l5.b2", "mcs", at="lhclength-(-1135.5367+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245365.0, assembly_id=102966.0))
lhcb2.new("bpm.24l5.b2", "bpm", at="lhclength-(-1134.6577+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245367.0, assembly_id=102967.0))
lhcb2.new("mo.24l5.b2", "mo", at="lhclength-(-1133.9067+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308837.0, assembly_id=102967.0))
lhcb2.new("mq.24l5.b2", "mq", at="lhclength-(-1131.8957+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308099.0, assembly_id=102967.0))
lhcb2.new("ms.24l5.b2", "ms", at="lhclength-(-1130.0007+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251426.0, assembly_id=102967.0))
lhcb2.new("mcbv.24l5.b2", "mcbv", at="lhclength-(-1129.4077+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251428.0, assembly_id=102967.0))
lhcb2.new("mb.c24l5.b2", "mb", at="lhclength-(-1120.8307+(261.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833754.0, assembly_id=102968.0))
lhcb2.new("mcs.c24l5.b2", "mcs", at="lhclength-(-1113.4067+(262-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245373.0, assembly_id=102968.0))
lhcb2.new("mco.24l5.b2", "mco", at="lhclength-(-1112.6567+(262-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251430.0, assembly_id=102969.0))
lhcb2.new("mcd.24l5.b2", "mcd", at="lhclength-(-1112.6552+(262-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251431.0, assembly_id=102969.0))
lhcb2.new("mb.b24l5.b2", "mb", at="lhclength-(-1105.1707+(262.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833778.0, assembly_id=102969.0))
lhcb2.new("mcs.b24l5.b2", "mcs", at="lhclength-(-1097.7467+(263-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245378.0, assembly_id=102969.0))
lhcb2.new("mb.a24l5.b2", "mb", at="lhclength-(-1089.5107+(263.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833802.0, assembly_id=102970.0))
lhcb2.new("mcs.a24l5.b2", "mcs", at="lhclength-(-1082.0867+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245381.0, assembly_id=102970.0))
lhcb2.new("bpm.23l5.b2", "bpm", at="lhclength-(-1081.2077+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245383.0, assembly_id=102971.0))
lhcb2.new("mqs.23l5.b2", "mqs", at="lhclength-(-1080.4537+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307629.0, assembly_id=102971.0))
lhcb2.new("mq.23l5.b2", "mq", at="lhclength-(-1078.4457+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308310.0, assembly_id=102971.0))
lhcb2.new("ms.23l5.b2", "ms", at="lhclength-(-1076.5507+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251434.0, assembly_id=102971.0))
lhcb2.new("mcbh.23l5.b2", "mcbh", at="lhclength-(-1075.9577+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251436.0, assembly_id=102971.0))
lhcb2.new("mco.b23l5.b2", "mco", at="lhclength-(-1074.8667+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251438.0, assembly_id=102972.0))
lhcb2.new("mcd.b23l5.b2", "mcd", at="lhclength-(-1074.8652+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251439.0, assembly_id=102972.0))
lhcb2.new("mb.c23l5.b2", "mb", at="lhclength-(-1067.3807+(264.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833826.0, assembly_id=102972.0))
lhcb2.new("mcs.c23l5.b2", "mcs", at="lhclength-(-1059.9567+(265-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245391.0, assembly_id=102972.0))
lhcb2.new("mb.b23l5.b2", "mb", at="lhclength-(-1051.7207+(265.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833850.0, assembly_id=102973.0))
lhcb2.new("mcs.b23l5.b2", "mcs", at="lhclength-(-1044.2967+(266-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245394.0, assembly_id=102973.0))
lhcb2.new("mco.a23l5.b2", "mco", at="lhclength-(-1043.5467+(266-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251442.0, assembly_id=102974.0))
lhcb2.new("mcd.a23l5.b2", "mcd", at="lhclength-(-1043.5452+(266-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251443.0, assembly_id=102974.0))
lhcb2.new("mb.a23l5.b2", "mb", at="lhclength-(-1036.0607+(266.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833874.0, assembly_id=102974.0))
lhcb2.new("mcs.a23l5.b2", "mcs", at="lhclength-(-1028.6367+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245399.0, assembly_id=102974.0))
lhcb2.new("bpm.22l5.b2", "bpm", at="lhclength-(-1027.7577+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245401.0, assembly_id=102975.0))
lhcb2.new("mo.22l5.b2", "mo", at="lhclength-(-1027.0067+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308807.0, assembly_id=102975.0))
lhcb2.new("mq.22l5.b2", "mq", at="lhclength-(-1024.9957+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308278.0, assembly_id=102975.0))
lhcb2.new("ms.22l5.b2", "ms", at="lhclength-(-1023.1007+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251446.0, assembly_id=102975.0))
lhcb2.new("mcbv.22l5.b2", "mcbv", at="lhclength-(-1022.5077+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251448.0, assembly_id=102975.0))
lhcb2.new("mb.c22l5.b2", "mb", at="lhclength-(-1013.9307+(267.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833898.0, assembly_id=102976.0))
lhcb2.new("mcs.c22l5.b2", "mcs", at="lhclength-(-1006.5067+(268-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245407.0, assembly_id=102976.0))
lhcb2.new("mco.22l5.b2", "mco", at="lhclength-(-1005.7567+(268-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251450.0, assembly_id=102977.0))
lhcb2.new("mcd.22l5.b2", "mcd", at="lhclength-(-1005.7552+(268-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251451.0, assembly_id=102977.0))
lhcb2.new("mb.b22l5.b2", "mb", at="lhclength-(-998.2707+(268.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833922.0, assembly_id=102977.0))
lhcb2.new("mcs.b22l5.b2", "mcs", at="lhclength-(-990.8467+(269-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245412.0, assembly_id=102977.0))
lhcb2.new("mb.a22l5.b2", "mb", at="lhclength-(-982.6107+(269.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833946.0, assembly_id=102978.0))
lhcb2.new("mcs.a22l5.b2", "mcs", at="lhclength-(-975.1867+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245415.0, assembly_id=102978.0))
lhcb2.new("bpm.21l5.b2", "bpm", at="lhclength-(-974.3077+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245417.0, assembly_id=102979.0))
lhcb2.new("mqt.21l5.b2", "mqt", at="lhclength-(-973.5537+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307262.0, assembly_id=102979.0))
lhcb2.new("mq.21l5.b2", "mq", at="lhclength-(-971.5457+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308246.0, assembly_id=102979.0))
lhcb2.new("ms.21l5.b2", "ms", at="lhclength-(-969.6507+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251454.0, assembly_id=102979.0))
lhcb2.new("mcbh.21l5.b2", "mcbh", at="lhclength-(-969.0577+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251456.0, assembly_id=102979.0))
lhcb2.new("mco.b21l5.b2", "mco", at="lhclength-(-967.9667+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251458.0, assembly_id=102980.0))
lhcb2.new("mcd.b21l5.b2", "mcd", at="lhclength-(-967.9652+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251459.0, assembly_id=102980.0))
lhcb2.new("mb.c21l5.b2", "mb", at="lhclength-(-960.4807+(270.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833970.0, assembly_id=102980.0))
lhcb2.new("mcs.c21l5.b2", "mcs", at="lhclength-(-953.0567+(271-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245425.0, assembly_id=102980.0))
lhcb2.new("mb.b21l5.b2", "mb", at="lhclength-(-944.8207+(271.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52833994.0, assembly_id=102981.0))
lhcb2.new("mcs.b21l5.b2", "mcs", at="lhclength-(-937.3967+(272-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245428.0, assembly_id=102981.0))
lhcb2.new("mco.a21l5.b2", "mco", at="lhclength-(-936.6467+(272-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251462.0, assembly_id=102982.0))
lhcb2.new("mcd.a21l5.b2", "mcd", at="lhclength-(-936.6452+(272-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251463.0, assembly_id=102982.0))
lhcb2.new("mb.a21l5.b2", "mb", at="lhclength-(-929.1607+(272.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834018.0, assembly_id=102982.0))
lhcb2.new("mcs.a21l5.b2", "mcs", at="lhclength-(-921.7367+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245433.0, assembly_id=102982.0))
lhcb2.new("bpm.20l5.b2", "bpm", at="lhclength-(-920.8577+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245435.0, assembly_id=102983.0))
lhcb2.new("mqt.20l5.b2", "mqt", at="lhclength-(-920.1037+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307465.0, assembly_id=102983.0))
lhcb2.new("mq.20l5.b2", "mq", at="lhclength-(-918.0957+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2348474.0, assembly_id=102983.0))
lhcb2.new("ms.20l5.b2", "ms", at="lhclength-(-916.2007+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251466.0, assembly_id=102983.0))
lhcb2.new("mcbv.20l5.b2", "mcbv", at="lhclength-(-915.6077+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251468.0, assembly_id=102983.0))
lhcb2.new("mb.c20l5.b2", "mb", at="lhclength-(-907.0307+(273.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834042.0, assembly_id=102984.0))
lhcb2.new("mcs.c20l5.b2", "mcs", at="lhclength-(-899.6067+(274-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245441.0, assembly_id=102984.0))
lhcb2.new("mco.20l5.b2", "mco", at="lhclength-(-898.8567+(274-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251470.0, assembly_id=102985.0))
lhcb2.new("mcd.20l5.b2", "mcd", at="lhclength-(-898.8552+(274-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251471.0, assembly_id=102985.0))
lhcb2.new("mb.b20l5.b2", "mb", at="lhclength-(-891.3707+(274.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834066.0, assembly_id=102985.0))
lhcb2.new("mcs.b20l5.b2", "mcs", at="lhclength-(-883.9467+(275-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245446.0, assembly_id=102985.0))
lhcb2.new("mb.a20l5.b2", "mb", at="lhclength-(-875.7107+(275.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834090.0, assembly_id=102986.0))
lhcb2.new("mcs.a20l5.b2", "mcs", at="lhclength-(-868.2867+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245449.0, assembly_id=102986.0))
lhcb2.new("bpm.19l5.b2", "bpm", at="lhclength-(-867.4077+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245451.0, assembly_id=102987.0))
lhcb2.new("mqt.19l5.b2", "mqt", at="lhclength-(-866.6537+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307435.0, assembly_id=102987.0))
lhcb2.new("mq.19l5.b2", "mq", at="lhclength-(-864.6457+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308425.0, assembly_id=102987.0))
lhcb2.new("ms.19l5.b2", "ms", at="lhclength-(-862.7507+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251474.0, assembly_id=102987.0))
lhcb2.new("mcbh.19l5.b2", "mcbh", at="lhclength-(-862.1577+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251476.0, assembly_id=102987.0))
lhcb2.new("mco.b19l5.b2", "mco", at="lhclength-(-861.0667+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251478.0, assembly_id=102988.0))
lhcb2.new("mcd.b19l5.b2", "mcd", at="lhclength-(-861.0652+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251479.0, assembly_id=102988.0))
lhcb2.new("mb.c19l5.b2", "mb", at="lhclength-(-853.5807+(276.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834114.0, assembly_id=102988.0))
lhcb2.new("mcs.c19l5.b2", "mcs", at="lhclength-(-846.1567+(277-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245459.0, assembly_id=102988.0))
lhcb2.new("mb.b19l5.b2", "mb", at="lhclength-(-837.9207+(277.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834138.0, assembly_id=102989.0))
lhcb2.new("mcs.b19l5.b2", "mcs", at="lhclength-(-830.4967+(278-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245462.0, assembly_id=102989.0))
lhcb2.new("mco.a19l5.b2", "mco", at="lhclength-(-829.7467+(278-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251482.0, assembly_id=102990.0))
lhcb2.new("mcd.a19l5.b2", "mcd", at="lhclength-(-829.7452+(278-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251483.0, assembly_id=102990.0))
lhcb2.new("mb.a19l5.b2", "mb", at="lhclength-(-822.2607+(278.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834162.0, assembly_id=102990.0))
lhcb2.new("mcs.a19l5.b2", "mcs", at="lhclength-(-814.8367+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245467.0, assembly_id=102990.0))
lhcb2.new("bpm.18l5.b2", "bpm", at="lhclength-(-813.9577+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245469.0, assembly_id=102991.0))
lhcb2.new("mqt.18l5.b2", "mqt", at="lhclength-(-813.2037+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307404.0, assembly_id=102991.0))
lhcb2.new("mq.18l5.b2", "mq", at="lhclength-(-811.1957+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308393.0, assembly_id=102991.0))
lhcb2.new("ms.18l5.b2", "ms", at="lhclength-(-809.3007+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251486.0, assembly_id=102991.0))
lhcb2.new("mcbv.18l5.b2", "mcbv", at="lhclength-(-808.7077+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251488.0, assembly_id=102991.0))
lhcb2.new("mb.c18l5.b2", "mb", at="lhclength-(-800.1307+(279.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834186.0, assembly_id=102992.0))
lhcb2.new("mcs.c18l5.b2", "mcs", at="lhclength-(-792.7067+(280-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245475.0, assembly_id=102992.0))
lhcb2.new("mco.18l5.b2", "mco", at="lhclength-(-791.9567+(280-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251490.0, assembly_id=102993.0))
lhcb2.new("mcd.18l5.b2", "mcd", at="lhclength-(-791.9552+(280-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251491.0, assembly_id=102993.0))
lhcb2.new("mb.b18l5.b2", "mb", at="lhclength-(-784.4707+(280.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834210.0, assembly_id=102993.0))
lhcb2.new("mcs.b18l5.b2", "mcs", at="lhclength-(-777.0467+(281-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245480.0, assembly_id=102993.0))
lhcb2.new("mb.a18l5.b2", "mb", at="lhclength-(-768.8107+(281.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834234.0, assembly_id=102994.0))
lhcb2.new("mcs.a18l5.b2", "mcs", at="lhclength-(-761.3867+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245483.0, assembly_id=102994.0))
lhcb2.new("bpm.17l5.b2", "bpm", at="lhclength-(-760.5077+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245485.0, assembly_id=102995.0))
lhcb2.new("mqt.17l5.b2", "mqt", at="lhclength-(-759.7537+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307609.0, assembly_id=102995.0))
lhcb2.new("mq.17l5.b2", "mq", at="lhclength-(-757.7457+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308364.0, assembly_id=102995.0))
lhcb2.new("ms.17l5.b2", "ms", at="lhclength-(-755.8507+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251494.0, assembly_id=102995.0))
lhcb2.new("mcbh.17l5.b2", "mcbh", at="lhclength-(-755.2577+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251496.0, assembly_id=102995.0))
lhcb2.new("mco.b17l5.b2", "mco", at="lhclength-(-754.1667+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251498.0, assembly_id=102996.0))
lhcb2.new("mcd.b17l5.b2", "mcd", at="lhclength-(-754.1652+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251499.0, assembly_id=102996.0))
lhcb2.new("mb.c17l5.b2", "mb", at="lhclength-(-746.6807+(282.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834258.0, assembly_id=102996.0))
lhcb2.new("mcs.c17l5.b2", "mcs", at="lhclength-(-739.2567+(283-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245493.0, assembly_id=102996.0))
lhcb2.new("mb.b17l5.b2", "mb", at="lhclength-(-731.0207+(283.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834282.0, assembly_id=102997.0))
lhcb2.new("mcs.b17l5.b2", "mcs", at="lhclength-(-723.5967+(284-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245496.0, assembly_id=102997.0))
lhcb2.new("mco.a17l5.b2", "mco", at="lhclength-(-722.8467+(284-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251502.0, assembly_id=102998.0))
lhcb2.new("mcd.a17l5.b2", "mcd", at="lhclength-(-722.8452+(284-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251503.0, assembly_id=102998.0))
lhcb2.new("mb.a17l5.b2", "mb", at="lhclength-(-715.3607+(284.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834306.0, assembly_id=102998.0))
lhcb2.new("mcs.a17l5.b2", "mcs", at="lhclength-(-707.9367+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245501.0, assembly_id=102998.0))
lhcb2.new("bpm.16l5.b2", "bpm", at="lhclength-(-707.0577+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245503.0, assembly_id=102999.0))
lhcb2.new("mqt.16l5.b2", "mqt", at="lhclength-(-706.3037+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307579.0, assembly_id=102999.0))
lhcb2.new("mq.16l5.b2", "mq", at="lhclength-(-704.2957+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308334.0, assembly_id=102999.0))
lhcb2.new("ms.16l5.b2", "ms", at="lhclength-(-702.4007+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251506.0, assembly_id=102999.0))
lhcb2.new("mcbv.16l5.b2", "mcbv", at="lhclength-(-701.8077+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251508.0, assembly_id=102999.0))
lhcb2.new("mb.c16l5.b2", "mb", at="lhclength-(-693.2307+(285.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834330.0, assembly_id=103000.0))
lhcb2.new("mcs.c16l5.b2", "mcs", at="lhclength-(-685.8067+(286-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245509.0, assembly_id=103000.0))
lhcb2.new("mco.16l5.b2", "mco", at="lhclength-(-685.0567+(286-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251510.0, assembly_id=103001.0))
lhcb2.new("mcd.16l5.b2", "mcd", at="lhclength-(-685.0552+(286-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251511.0, assembly_id=103001.0))
lhcb2.new("mb.b16l5.b2", "mb", at="lhclength-(-677.5707+(286.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834354.0, assembly_id=103001.0))
lhcb2.new("mcs.b16l5.b2", "mcs", at="lhclength-(-670.1467+(287-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245514.0, assembly_id=103001.0))
lhcb2.new("mb.a16l5.b2", "mb", at="lhclength-(-661.9107+(287.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834378.0, assembly_id=103002.0))
lhcb2.new("mcs.a16l5.b2", "mcs", at="lhclength-(-654.4867+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245517.0, assembly_id=103002.0))
lhcb2.new("bpm.15l5.b2", "bpm", at="lhclength-(-653.6077+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245519.0, assembly_id=103003.0))
lhcb2.new("mqt.15l5.b2", "mqt", at="lhclength-(-652.8537+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307548.0, assembly_id=103003.0))
lhcb2.new("mq.15l5.b2", "mq", at="lhclength-(-650.8457+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2348490.0, assembly_id=103003.0))
lhcb2.new("ms.15l5.b2", "ms", at="lhclength-(-648.9507+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251514.0, assembly_id=103003.0))
lhcb2.new("mcbh.15l5.b2", "mcbh", at="lhclength-(-648.3577+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251516.0, assembly_id=103003.0))
lhcb2.new("mco.b15l5.b2", "mco", at="lhclength-(-647.2667+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251518.0, assembly_id=103004.0))
lhcb2.new("mcd.b15l5.b2", "mcd", at="lhclength-(-647.2652+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251519.0, assembly_id=103004.0))
lhcb2.new("mb.c15l5.b2", "mb", at="lhclength-(-639.7807+(288.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834402.0, assembly_id=103004.0))
lhcb2.new("mcs.c15l5.b2", "mcs", at="lhclength-(-632.3567+(289-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245527.0, assembly_id=103004.0))
lhcb2.new("mb.b15l5.b2", "mb", at="lhclength-(-624.1207+(289.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834426.0, assembly_id=103005.0))
lhcb2.new("mcs.b15l5.b2", "mcs", at="lhclength-(-616.6967+(290-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245530.0, assembly_id=103005.0))
lhcb2.new("mco.a15l5.b2", "mco", at="lhclength-(-615.9467+(290-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251522.0, assembly_id=103006.0))
lhcb2.new("mcd.a15l5.b2", "mcd", at="lhclength-(-615.9452+(290-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251523.0, assembly_id=103006.0))
lhcb2.new("mb.a15l5.b2", "mb", at="lhclength-(-608.4607+(290.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834450.0, assembly_id=103006.0))
lhcb2.new("mcs.a15l5.b2", "mcs", at="lhclength-(-601.0367+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245535.0, assembly_id=103006.0))
lhcb2.new("bpm.14l5.b2", "bpm", at="lhclength-(-600.1577+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245537.0, assembly_id=103007.0))
lhcb2.new("mqt.14l5.b2", "mqt", at="lhclength-(-599.4037+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307516.0, assembly_id=103007.0))
lhcb2.new("mq.14l5.b2", "mq", at="lhclength-(-597.3957+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308511.0, assembly_id=103007.0))
lhcb2.new("ms.14l5.b2", "ms", at="lhclength-(-595.5007+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251526.0, assembly_id=103007.0))
lhcb2.new("mcbv.14l5.b2", "mcbv", at="lhclength-(-594.9077+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251528.0, assembly_id=103007.0))
lhcb2.new("mb.c14l5.b2", "mb", at="lhclength-(-586.3307+(291.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834474.0, assembly_id=103008.0))
lhcb2.new("mcs.c14l5.b2", "mcs", at="lhclength-(-578.9067+(292-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245543.0, assembly_id=103008.0))
lhcb2.new("mco.14l5.b2", "mco", at="lhclength-(-578.1567+(292-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251530.0, assembly_id=103009.0))
lhcb2.new("mcd.14l5.b2", "mcd", at="lhclength-(-578.1552+(292-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251531.0, assembly_id=103009.0))
lhcb2.new("mb.b14l5.b2", "mb", at="lhclength-(-570.6707+(292.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834498.0, assembly_id=103009.0))
lhcb2.new("mcs.b14l5.b2", "mcs", at="lhclength-(-563.2467+(293-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245548.0, assembly_id=103009.0))
lhcb2.new("mb.a14l5.b2", "mb", at="lhclength-(-555.0107+(293.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834522.0, assembly_id=103010.0))
lhcb2.new("mcs.a14l5.b2", "mcs", at="lhclength-(-547.5867+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245551.0, assembly_id=103010.0))
lhcb2.new("s.ds.l5.b2", "omk", at="lhclength-(-547.1807+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.13l5.b2", "bpm", at="lhclength-(-546.7077+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245553.0, assembly_id=103011.0))
lhcb2.new("mqt.13l5.b2", "mqt", at="lhclength-(-545.9537+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307724.0, assembly_id=103011.0))
lhcb2.new("mq.13l5.b2", "mq", at="lhclength-(-543.9457+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308481.0, assembly_id=103011.0))
lhcb2.new("ms.13l5.b2", "ms", at="lhclength-(-542.0507+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251534.0, assembly_id=103011.0))
lhcb2.new("mcbh.13l5.b2", "mcbh", at="lhclength-(-541.4577+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251536.0, assembly_id=103011.0))
lhcb2.new("mco.b13l5.b2", "mco", at="lhclength-(-540.3667+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251538.0, assembly_id=103012.0))
lhcb2.new("mcd.b13l5.b2", "mcd", at="lhclength-(-540.3652+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251539.0, assembly_id=103012.0))
lhcb2.new("mb.c13l5.b2", "mb", at="lhclength-(-532.8807+(294.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834546.0, assembly_id=103012.0))
lhcb2.new("mcs.c13l5.b2", "mcs", at="lhclength-(-525.4567+(295-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245561.0, assembly_id=103012.0))
lhcb2.new("mb.b13l5.b2", "mb", at="lhclength-(-517.2207+(295.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834570.0, assembly_id=103013.0))
lhcb2.new("mcs.b13l5.b2", "mcs", at="lhclength-(-509.7967+(296-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245564.0, assembly_id=103013.0))
lhcb2.new("mco.a13l5.b2", "mco", at="lhclength-(-509.0467+(296-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251542.0, assembly_id=103014.0))
lhcb2.new("mcd.a13l5.b2", "mcd", at="lhclength-(-509.0452+(296-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251543.0, assembly_id=103014.0))
lhcb2.new("mb.a13l5.b2", "mb", at="lhclength-(-501.5607+(296.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834594.0, assembly_id=103014.0))
lhcb2.new("mcs.a13l5.b2", "mcs", at="lhclength-(-494.1367+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245569.0, assembly_id=103014.0))
lhcb2.new("bpm.12l5.b2", "bpm", at="lhclength-(-493.2577+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245571.0, assembly_id=103015.0))
lhcb2.new("mqt.12l5.b2", "mqt", at="lhclength-(-492.5037+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307692.0, assembly_id=103015.0))
lhcb2.new("mq.12l5.b2", "mq", at="lhclength-(-490.4957+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308451.0, assembly_id=103015.0))
lhcb2.new("ms.12l5.b2", "ms", at="lhclength-(-488.6007+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251546.0, assembly_id=103015.0))
lhcb2.new("mcbv.12l5.b2", "mcbv", at="lhclength-(-488.0077+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251548.0, assembly_id=103015.0))
lhcb2.new("mb.c12l5.b2", "mb", at="lhclength-(-479.4307+(297.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834618.0, assembly_id=103016.0))
lhcb2.new("mcs.c12l5.b2", "mcs", at="lhclength-(-472.0067+(298-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245577.0, assembly_id=103016.0))
lhcb2.new("mco.12l5.b2", "mco", at="lhclength-(-471.2567+(298-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251550.0, assembly_id=103017.0))
lhcb2.new("mcd.12l5.b2", "mcd", at="lhclength-(-471.2552+(298-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251551.0, assembly_id=103017.0))
lhcb2.new("mb.b12l5.b2", "mb", at="lhclength-(-463.7707+(298.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834642.0, assembly_id=103017.0))
lhcb2.new("mcs.b12l5.b2", "mcs", at="lhclength-(-456.3467+(299-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245582.0, assembly_id=103017.0))
lhcb2.new("mb.a12l5.b2", "mb", at="lhclength-(-448.1107+(299.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834666.0, assembly_id=103018.0))
lhcb2.new("mcs.a12l5.b2", "mcs", at="lhclength-(-440.6867+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245585.0, assembly_id=103018.0))
lhcb2.new("e.arc.45.b2", "omk", at="lhclength-(-440.2807+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.11l5.b2", "bpm", at="lhclength-(-439.8077+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245587.0, assembly_id=103019.0))
lhcb2.new("mq.11l5.b2", "mq", at="lhclength-(-437.2607+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2308658.0, assembly_id=103019.0))
lhcb2.new("mqtli.11l5.b2", "mqtli", at="lhclength-(-434.8917+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307346.0, assembly_id=103019.0))
lhcb2.new("ms.11l5.b2", "ms", at="lhclength-(-433.8797+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251554.0, assembly_id=103019.0))
lhcb2.new("mcbh.11l5.b2", "mcbh", at="lhclength-(-433.2867+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251556.0, assembly_id=103019.0))
lhcb2.new("lefl.11l5.b2", "lefl", at="lhclength-(-425.67735+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52997862.0, assembly_id=103020.0))
lhcb2.new("mco.11l5.b2", "mco", at="lhclength-(-418.475+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251558.0, assembly_id=103021.0))
lhcb2.new("mcd.11l5.b2", "mcd", at="lhclength-(-418.4735+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251559.0, assembly_id=103021.0))
lhcb2.new("mb.b11l5.b2", "mb", at="lhclength-(-410.989+(300.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834690.0, assembly_id=103021.0))
lhcb2.new("mcs.b11l5.b2", "mcs", at="lhclength-(-403.565+(301-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245595.0, assembly_id=103021.0))
lhcb2.new("mb.a11l5.b2", "mb", at="lhclength-(-395.329+(301.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52849594.0, assembly_id=103022.0))
lhcb2.new("mcs.a11l5.b2", "mcs", at="lhclength-(-387.905+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=357310.0, assembly_id=103022.0))
lhcb2.new("bpm.10l5.b2", "bpm", at="lhclength-(-387.026+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245600.0, assembly_id=103023.0))
lhcb2.new("mqml.10l5.b2", "mqml", at="lhclength-(-383.881+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307811.0, assembly_id=103023.0))
lhcb2.new("mcbcv.10l5.b2", "mcbcv", at="lhclength-(-380.839+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251563.0, assembly_id=103023.0))
lhcb2.new("mco.10l5.b2", "mco", at="lhclength-(-379.41+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251564.0, assembly_id=103024.0))
lhcb2.new("mcd.10l5.b2", "mcd", at="lhclength-(-379.4085+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251565.0, assembly_id=103024.0))
lhcb2.new("mb.b10l5.b2", "mb", at="lhclength-(-371.924+(302.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834714.0, assembly_id=103024.0))
lhcb2.new("mcs.b10l5.b2", "mcs", at="lhclength-(-364.5+(303-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245607.0, assembly_id=103024.0))
lhcb2.new("mb.a10l5.b2", "mb", at="lhclength-(-356.264+(303.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52849618.0, assembly_id=103025.0))
lhcb2.new("mcs.a10l5.b2", "mcs", at="lhclength-(-348.84+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=357313.0, assembly_id=103025.0))
lhcb2.new("bpm.9l5.b2", "bpm", at="lhclength-(-347.96+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245612.0, assembly_id=103026.0))
lhcb2.new("mqmc.9l5.b2", "mqmc", at="lhclength-(-345.984+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307788.0, assembly_id=103026.0))
lhcb2.new("mqm.9l5.b2", "mqm", at="lhclength-(-342.718+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307736.0, assembly_id=103026.0))
lhcb2.new("mcbch.9l5.b2", "mcbch", at="lhclength-(-340.377+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251569.0, assembly_id=103026.0))
lhcb2.new("mco.9l5.b2", "mco", at="lhclength-(-338.945+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251570.0, assembly_id=103027.0))
lhcb2.new("mcd.9l5.b2", "mcd", at="lhclength-(-338.9435+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251571.0, assembly_id=103027.0))
lhcb2.new("mb.b9l5.b2", "mb", at="lhclength-(-331.459+(304.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834738.0, assembly_id=103027.0))
lhcb2.new("mcs.b9l5.b2", "mcs", at="lhclength-(-324.035+(305-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245620.0, assembly_id=103027.0))
lhcb2.new("mb.a9l5.b2", "mb", at="lhclength-(-315.799+(305.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52849642.0, assembly_id=103028.0))
lhcb2.new("mcs.a9l5.b2", "mcs", at="lhclength-(-308.375+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=357316.0, assembly_id=103028.0))
lhcb2.new("bpm.8l5.b2", "bpm", at="lhclength-(-307.496+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245625.0, assembly_id=103029.0))
lhcb2.new("mqml.8l5.b2", "mqml", at="lhclength-(-304.351+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307843.0, assembly_id=103029.0))
lhcb2.new("mcbcv.8l5.b2", "mcbcv", at="lhclength-(-301.309+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251575.0, assembly_id=103029.0))
lhcb2.new("mco.8l5.b2", "mco", at="lhclength-(-299.88+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251576.0, assembly_id=103030.0))
lhcb2.new("mcd.8l5.b2", "mcd", at="lhclength-(-299.8785+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251577.0, assembly_id=103030.0))
lhcb2.new("mb.b8l5.b2", "mb", at="lhclength-(-292.394+(306.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52834762.0, assembly_id=103030.0))
lhcb2.new("mcs.b8l5.b2", "mcs", at="lhclength-(-284.97+(307-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245632.0, assembly_id=103030.0))
lhcb2.new("mb.a8l5.b2", "mb", at="lhclength-(-276.734+(307.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52849666.0, assembly_id=103031.0))
lhcb2.new("mcs.a8l5.b2", "mcs", at="lhclength-(-269.31+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=357319.0, assembly_id=103031.0))
lhcb2.new("e.ds.l5.b2", "omk", at="lhclength-(-268.904+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.7l5.b2", "bpm", at="lhclength-(-268.429+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245637.0, assembly_id=103032.0))
lhcb2.new("mqm.b7l5.b2", "mqm", at="lhclength-(-265.984+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307771.0, assembly_id=103032.0))
lhcb2.new("mqm.a7l5.b2", "mqm", at="lhclength-(-262.217+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2307756.0, assembly_id=103032.0))
lhcb2.new("mcbch.7l5.b2", "mcbch", at="lhclength-(-259.876+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251581.0, assembly_id=103032.0))
lhcb2.new("dfbai.7l5.b2", "dfbai", at="lhclength-(-257.6965+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=52996743.0, assembly_id=104682.0))
lhcb2.new("bpmr.6l5.b2", "bpmr", at="lhclength-(-231.535+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=377976.0, assembly_id=103033.0))
lhcb2.new("mqml.6l5.b2", "mqml", at="lhclength-(-228.39+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2303105.0, assembly_id=103033.0))
lhcb2.new("mcbcv.6l5.b2", "mcbcv", at="lhclength-(-225.348+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251583.0, assembly_id=103033.0))
lhcb2.new("tcl.6l5.b2", "tcl", at="lhclength-(-221.564+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=12962653.0))
lhcb2.new("bpmwt.b6l5.b2", "bpmwt", at="lhclength-(-220.225+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826595.0, assembly_id=825708.0))
lhcb2.new("xrpv.b6l5.b2", "xrpv", at="lhclength-(-220+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826619.0, assembly_id=825708.0))
lhcb2.new("xrph.b6l5.b2", "xrph", at="lhclength-(-219.551+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826607.0, assembly_id=825708.0))
lhcb2.new("xrph.e6l5.b2", "xrph", at="lhclength-(-215.71+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=12978123.0, assembly_id=12978113.0))
lhcb2.new("xrph.a6l5.b2", "xrph", at="lhclength-(-215.077+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826643.0, assembly_id=825709.0))
lhcb2.new("xrpv.a6l5.b2", "xrpv", at="lhclength-(-214.628+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826655.0, assembly_id=825709.0))
lhcb2.new("bpmwt.a6l5.b2", "bpmwt", at="lhclength-(-214.403+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=826631.0, assembly_id=825709.0))
lhcb2.new("bpmwt.d6l5.b2", "bpmwt", at="lhclength-(-213.225+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738958.0, assembly_id=6738949.0))
lhcb2.new("xrpv.d6l5.b2", "xrpv", at="lhclength-(-213+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738962.0, assembly_id=6738949.0))
lhcb2.new("xrph.d6l5.b2", "xrph", at="lhclength-(-212.551+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738960.0, assembly_id=6738949.0))
lhcb2.new("xrpv.c6l5.b2", "xrpv", at="lhclength-(-203.377+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738956.0, assembly_id=6738950.0))
lhcb2.new("bpmwt.c6l5.b2", "bpmwt", at="lhclength-(-203.152+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=6738952.0, assembly_id=6738950.0))
lhcb2.new("bpm.5l5.b2", "bpm", at="lhclength-(-199.635+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=377978.0, assembly_id=103035.0))
lhcb2.new("mqml.5l5.b2", "mqml", at="lhclength-(-196.49+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2303137.0, assembly_id=103035.0))
lhcb2.new("mcbch.5l5.b2", "mcbch", at="lhclength-(-193.448+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251585.0, assembly_id=103035.0))
lhcb2.new("tcl.5l5.b2", "tcl", at="lhclength-(-184.357+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=103036.0))
lhcb2.new("bpmya.4l5.b2", "bpmya", at="lhclength-(-172.229+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=245651.0, assembly_id=103038.0))
lhcb2.new("mqy.4l5.b2", "mqy", at="lhclength-(-169.553+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=2303113.0, assembly_id=103038.0))
lhcb2.new("mcbyv.b4l5.b2", "mcbyv", at="lhclength-(-167.031+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251587.0, assembly_id=103038.0))
lhcb2.new("mcbyh.4l5.b2", "mcbyh", at="lhclength-(-165.735+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251589.0, assembly_id=103038.0))
lhcb2.new("mcbyv.a4l5.b2", "mcbyv", at="lhclength-(-164.439+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.194, slot_id=251591.0, assembly_id=103038.0))
lhcb2.new("mbrc.4l5.b2", "mbrc", at="lhclength-(-157.9+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.188, slot_id=52819694.0, assembly_id=103039.0))
lhcb2.new("bpmwb.4l5.b2", "bpmwb", at="lhclength-(-151.1705+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.178, slot_id=181642.0))
lhcb2.new("tcl.4l5.b2", "tcl", at="lhclength-(-150.03+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.1763, slot_id=52659116.0))
lhcb2.new("tanc.4l5", "tanc", at="lhclength-(-142.754+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=103042.0))
lhcb2.new("x5zdc.b4l5", "x5zdc001", at="lhclength-(-141.6225+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=2019606.0, assembly_id=103042.0))
lhcb2.new("brand.4l5", "brand", at="lhclength-(-141.185+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=55374093.0, assembly_id=103042.0))
lhcb2.new("x5zdc.a4l5", "x5zdc002", at="lhclength-(-141.0725+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=2019602.0, assembly_id=103042.0))
lhcb2.new("x5fcb.a4l5", "x5fcb", at="lhclength-(-114.13+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593911.0))
lhcb2.new("x5fca.b4l5", "x5fca", at="lhclength-(-85.08+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593908.0))
lhcb2.new("mbxw.f4l5", "mbxw", at="lhclength-(-82.652+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134562.0))
lhcb2.new("mbxw.e4l5", "mbxw", at="lhclength-(-78.386+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134563.0))
lhcb2.new("mbxw.d4l5", "mbxw", at="lhclength-(-74.12+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134564.0))
lhcb2.new("mbxw.c4l5", "mbxw", at="lhclength-(-69.854+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134565.0))
lhcb2.new("mbxw.b4l5", "mbxw", at="lhclength-(-65.588+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134566.0))
lhcb2.new("mbxw.a4l5", "mbxw", at="lhclength-(-61.322+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134567.0))
lhcb2.new("x5fca.a4l5", "x5fca", at="lhclength-(-59.24+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593907.0))
lhcb2.new("bpmsy.4l5.b2", "bpmsy002", at="lhclength-(-58.2545+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=47562524.0, assembly_id=104609.0))
lhcb2.new("dfbxe.3l5", "dfbxe", at="lhclength-(-56.427+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=104683.0))
lhcb2.new("mcosx.3l5", "mcosx", at="lhclength-(-54.297+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282246.0, assembly_id=103044.0))
lhcb2.new("mcox.3l5", "mcox", at="lhclength-(-54.297+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282245.0, assembly_id=103044.0))
lhcb2.new("mcssx.3l5", "mcssx", at="lhclength-(-54.297+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282244.0, assembly_id=103044.0))
lhcb2.new("mcbxh.3l5", "mcbxh", at="lhclength-(-53.814+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251592.0, assembly_id=103044.0))
lhcb2.new("mcbxv.3l5", "mcbxv", at="lhclength-(-53.814+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251593.0, assembly_id=103044.0))
lhcb2.new("mcsx.3l5", "mcsx", at="lhclength-(-53.814+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251594.0, assembly_id=103044.0))
lhcb2.new("mctx.3l5", "mctx", at="lhclength-(-53.814+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251595.0, assembly_id=103044.0))
lhcb2.new("mqxa.3l5", "mqxa", at="lhclength-(-50.15+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245665.0, assembly_id=103044.0))
lhcb2.new("mqsx.3l5", "mqsx", at="lhclength-(-46.608+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282142.0, assembly_id=103044.0))
lhcb2.new("tasb.3l5", "tasb", at="lhclength-(-45.342+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245667.0, assembly_id=103044.0))
lhcb2.new("mqxb.b2l5", "mqxb", at="lhclength-(-41.3+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245668.0, assembly_id=103045.0))
lhcb2.new("mcbxh.2l5", "mcbxh", at="lhclength-(-38.019+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251600.0, assembly_id=103045.0))
lhcb2.new("mcbxv.2l5", "mcbxv", at="lhclength-(-38.019+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251601.0, assembly_id=103045.0))
lhcb2.new("mqxb.a2l5", "mqxb", at="lhclength-(-34.8+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245670.0, assembly_id=103045.0))
lhcb2.new("bpms.2l5.b2", "bpms_003", at="lhclength-(-31.529+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=47564257.0, assembly_id=103045.0))
lhcb2.new("mcbxh.1l5", "mcbxh", at="lhclength-(-29.842+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282215.0, assembly_id=103046.0))
lhcb2.new("mcbxv.1l5", "mcbxv", at="lhclength-(-29.842+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282214.0, assembly_id=103046.0))
lhcb2.new("mqxa.1l5", "mqxa", at="lhclength-(-26.15+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282143.0, assembly_id=103046.0))
lhcb2.new("bpmwf.a1l5.b2", "bpmwf", at="lhclength-(-21.751+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=6080248.0, assembly_id=6080226.0))
lhcb2.new("bpmsw.1l5.b2", "bpmsw002", at="lhclength-(-21.564+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=6080244.0, assembly_id=6080226.0))
lhcb2.new("bpmsw.1l5.b2_doros", "bpmsw002", at="lhclength-(-21.564+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=10429429.0, assembly_id=6080226.0))
lhcb2.new("tas.1l5", "tas", at="lhclength-(-19.95+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=103047.0))
lhcb2.new("mbcs2.1l5", "mbcs2", at="lhclength-(-3.25+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=52895730.0, assembly_id=2209455.0))
lhcb2.new("ip5", "omk", at="lhclength-(pip5+ip5ofs.b2*ds)")
lhcb2.new("mbcs2.1r5", "mbcs2", at="lhclength-(3.25+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=52895762.0, assembly_id=2209455.0))
lhcb2.new("tas.1r5", "tas", at="lhclength-(19.95+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=103048.0))
lhcb2.new("bpmsw.1r5.b2", "bpmsw002", at="lhclength-(21.564+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=6080262.0, assembly_id=6080227.0))
lhcb2.new("bpmsw.1r5.b2_doros", "bpmsw002", at="lhclength-(21.564+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=10429435.0, assembly_id=6080227.0))
lhcb2.new("bpmwf.a1r5.b2", "bpmwf", at="lhclength-(21.697+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=6080270.0, assembly_id=6080227.0))
lhcb2.new("mqxa.1r5", "mqxa", at="lhclength-(26.15+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282146.0, assembly_id=103049.0))
lhcb2.new("mcbxh.1r5", "mcbxh", at="lhclength-(29.842+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282217.0, assembly_id=103049.0))
lhcb2.new("mcbxv.1r5", "mcbxv", at="lhclength-(29.842+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282216.0, assembly_id=103049.0))
lhcb2.new("bpms.2r5.b2", "bpms_003", at="lhclength-(31.529+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=47564247.0, assembly_id=103050.0))
lhcb2.new("mqxb.a2r5", "mqxb", at="lhclength-(34.8+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245683.0, assembly_id=103050.0))
lhcb2.new("mcbxh.2r5", "mcbxh", at="lhclength-(38.019+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251606.0, assembly_id=103050.0))
lhcb2.new("mcbxv.2r5", "mcbxv", at="lhclength-(38.019+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251607.0, assembly_id=103050.0))
lhcb2.new("mqxb.b2r5", "mqxb", at="lhclength-(41.3+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245685.0, assembly_id=103050.0))
lhcb2.new("tasb.3r5", "tasb", at="lhclength-(45.342+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245686.0, assembly_id=103051.0))
lhcb2.new("mqsx.3r5", "mqsx", at="lhclength-(46.608+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282147.0, assembly_id=103051.0))
lhcb2.new("mqxa.3r5", "mqxa", at="lhclength-(50.15+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=245688.0, assembly_id=103051.0))
lhcb2.new("mcbxh.3r5", "mcbxh", at="lhclength-(53.814+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251612.0, assembly_id=103051.0))
lhcb2.new("mcbxv.3r5", "mcbxv", at="lhclength-(53.814+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251613.0, assembly_id=103051.0))
lhcb2.new("mcsx.3r5", "mcsx", at="lhclength-(53.814+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251614.0, assembly_id=103051.0))
lhcb2.new("mctx.3r5", "mctx", at="lhclength-(53.814+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=251615.0, assembly_id=103051.0))
lhcb2.new("mcosx.3r5", "mcosx", at="lhclength-(54.297+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282249.0, assembly_id=103051.0))
lhcb2.new("mcox.3r5", "mcox", at="lhclength-(54.297+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282248.0, assembly_id=103051.0))
lhcb2.new("mcssx.3r5", "mcssx", at="lhclength-(54.297+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=282247.0, assembly_id=103051.0))
lhcb2.new("dfbxf.3r5", "dfbxf", at="lhclength-(56.427+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=104684.0))
lhcb2.new("bpmsy.4r5.b2", "bpmsy002", at="lhclength-(58.3745+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=47562526.0, assembly_id=104612.0))
lhcb2.new("x5fca.b4r5", "x5fca", at="lhclength-(59.24+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593910.0))
lhcb2.new("mbxw.a4r5", "mbxw", at="lhclength-(61.322+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134568.0))
lhcb2.new("mbxw.b4r5", "mbxw", at="lhclength-(65.588+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134569.0))
lhcb2.new("mbxw.c4r5", "mbxw", at="lhclength-(69.854+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134570.0))
lhcb2.new("mbxw.d4r5", "mbxw", at="lhclength-(74.12+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134571.0))
lhcb2.new("mbxw.e4r5", "mbxw", at="lhclength-(78.386+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134572.0))
lhcb2.new("mbxw.f4r5", "mbxw", at="lhclength-(82.652+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=134573.0))
lhcb2.new("x5fca.a4r5", "x5fca", at="lhclength-(84.94+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593909.0))
lhcb2.new("x5fcb.a4r5", "x5fcb", at="lhclength-(114.15+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=5593912.0))
lhcb2.new("x5zdc.b4r5", "x5zdc002", at="lhclength-(141.0725+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=2019608.0, assembly_id=103053.0))
lhcb2.new("brana.4r5", "brana", at="lhclength-(141.185+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=883604.0, assembly_id=103053.0))
lhcb2.new("x5zdc.a4r5", "x5zdc001", at="lhclength-(141.6225+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=2019604.0, assembly_id=103053.0))
lhcb2.new("tanc.4r5", "tanc", at="lhclength-(142.754+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=0.0, slot_id=103053.0))
lhcb2.new("bptdv.a4r5.b2", "bptdv", at="lhclength-(145.35+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.162, slot_id=10402727.0, assembly_id=377617.0))
lhcb2.new("tctpv.4r5.b2", "tctpv", at="lhclength-(145.945+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.1669, slot_id=377617.0))
lhcb2.new("bptuv.a4r5.b2", "bptuv", at="lhclength-(146.54+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.166, slot_id=10402718.0, assembly_id=377617.0))
lhcb2.new("bbcwe.4r5.d.b2", "bbcwe", at="lhclength-(147.35+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.088, slot_id=39833745.0, assembly_id=54812586.0))
lhcb2.new("bbcwi.4r5.d.b2", "bbcwi", at="lhclength-(147.35+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.248, slot_id=39829972.0, assembly_id=54812586.0))
lhcb2.new("bptdh.a4r5.b2", "bptdh", at="lhclength-(147.35+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.1668, slot_id=10402850.0, assembly_id=54812586.0))
lhcb2.new("tctph.4r5.b2", "tctwh", at="lhclength-(147.945+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.1716, slot_id=54812586.0))
lhcb2.new("bbcwe.4r5.u.b2", "bbcwe", at="lhclength-(148.54+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.092, slot_id=39829970.0, assembly_id=54812586.0))
lhcb2.new("bbcwi.4r5.u.b2", "bbcwi", at="lhclength-(148.54+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.252, slot_id=39833747.0, assembly_id=54812586.0))
lhcb2.new("bptuh.a4r5.b2", "bptuh", at="lhclength-(148.54+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.1694, slot_id=10402852.0, assembly_id=54812586.0))
lhcb2.new("bpmwb.4r5.b2", "bpmwb", at="lhclength-(151.1705+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.178, slot_id=104613.0))
lhcb2.new("mbrc.4r5.b2", "mbrc", at="lhclength-(157.9+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.188, slot_id=52819717.0, assembly_id=103056.0))
lhcb2.new("mcbyh.a4r5.b2", "mcbyh", at="lhclength-(164.439+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251617.0, assembly_id=103057.0))
lhcb2.new("mcbyv.4r5.b2", "mcbyv", at="lhclength-(165.735+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251619.0, assembly_id=103057.0))
lhcb2.new("mcbyh.b4r5.b2", "mcbyh", at="lhclength-(167.031+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251621.0, assembly_id=103057.0))
lhcb2.new("mqy.4r5.b2", "mqy", at="lhclength-(169.553+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2303121.0, assembly_id=103057.0))
lhcb2.new("bpmya.4r5.b2", "bpmya", at="lhclength-(172.227+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245702.0, assembly_id=103057.0))
lhcb2.new("bptx.5r5.b2", "bptx", at="lhclength-(174.7185+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=104668.0))
lhcb2.new("bpmr.5r5.b2", "bpmr", at="lhclength-(193.345+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=377989.0, assembly_id=103060.0))
lhcb2.new("mqml.5r5.b2", "mqml", at="lhclength-(196.49+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2303125.0, assembly_id=103060.0))
lhcb2.new("mcbcv.5r5.b2", "mcbcv", at="lhclength-(199.532+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251622.0, assembly_id=103060.0))
lhcb2.new("bpm.6r5.b2", "bpm", at="lhclength-(225.245+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=377991.0, assembly_id=103062.0))
lhcb2.new("mqml.6r5.b2", "mqml", at="lhclength-(228.39+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2303129.0, assembly_id=103062.0))
lhcb2.new("mcbch.6r5.b2", "mcbch", at="lhclength-(231.432+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251624.0, assembly_id=103062.0))
lhcb2.new("dfbaj.7r5.b2", "dfbaj", at="lhclength-(257.4465+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52996767.0, assembly_id=104685.0))
lhcb2.new("bpmra.7r5.b2", "bpmra", at="lhclength-(259.259+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=377992.0, assembly_id=103063.0))
lhcb2.new("mqm.a7r5.b2", "mqm", at="lhclength-(261.704+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307764.0, assembly_id=103063.0))
lhcb2.new("mqm.b7r5.b2", "mqm", at="lhclength-(265.471+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307779.0, assembly_id=103063.0))
lhcb2.new("mcbcv.7r5.b2", "mcbcv", at="lhclength-(267.812+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251626.0, assembly_id=103063.0))
lhcb2.new("s.ds.r5.b2", "omk", at="lhclength-(268.904+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(slot_id=100932.0))
lhcb2.new("mco.8r5.b2", "mco", at="lhclength-(269.248+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251630.0, assembly_id=103064.0))
lhcb2.new("mcd.8r5.b2", "mcd", at="lhclength-(269.2495+(308-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251631.0, assembly_id=103064.0))
lhcb2.new("mb.a8r5.b2", "mb", at="lhclength-(276.734+(307.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834786.0, assembly_id=103064.0))
lhcb2.new("mcs.a8r5.b2", "mcs", at="lhclength-(284.158+(307-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245721.0, assembly_id=103064.0))
lhcb2.new("mb.b8r5.b2", "mb", at="lhclength-(292.394+(306.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834810.0, assembly_id=103065.0))
lhcb2.new("mcs.b8r5.b2", "mcs", at="lhclength-(299.818+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245724.0, assembly_id=103065.0))
lhcb2.new("bpm.8r5.b2", "bpm", at="lhclength-(300.697+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=377995.0, assembly_id=103066.0))
lhcb2.new("mqml.8r5.b2", "mqml", at="lhclength-(303.842+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307616.0, assembly_id=103066.0))
lhcb2.new("mcbch.8r5.b2", "mcbch", at="lhclength-(306.884+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=378109.0, assembly_id=103066.0))
lhcb2.new("mco.9r5.b2", "mco", at="lhclength-(308.313+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251636.0, assembly_id=103067.0))
lhcb2.new("mcd.9r5.b2", "mcd", at="lhclength-(308.3145+(306-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251637.0, assembly_id=103067.0))
lhcb2.new("mb.a9r5.b2", "mb", at="lhclength-(315.799+(305.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834834.0, assembly_id=103067.0))
lhcb2.new("mcs.a9r5.b2", "mcs", at="lhclength-(323.223+(305-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245733.0, assembly_id=103067.0))
lhcb2.new("mb.b9r5.b2", "mb", at="lhclength-(331.459+(304.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834858.0, assembly_id=103068.0))
lhcb2.new("mcs.b9r5.b2", "mcs", at="lhclength-(338.883+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245736.0, assembly_id=103068.0))
lhcb2.new("bpm.9r5.b2", "bpm", at="lhclength-(339.763+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=383966.0, assembly_id=103069.0))
lhcb2.new("mqmc.9r5.b2", "mqmc", at="lhclength-(341.739+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307799.0, assembly_id=103069.0))
lhcb2.new("mqm.9r5.b2", "mqm", at="lhclength-(345.005+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307747.0, assembly_id=103069.0))
lhcb2.new("mcbcv.9r5.b2", "mcbcv", at="lhclength-(347.346+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=383972.0, assembly_id=103069.0))
lhcb2.new("mco.10r5.b2", "mco", at="lhclength-(348.778+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251642.0, assembly_id=103070.0))
lhcb2.new("mcd.10r5.b2", "mcd", at="lhclength-(348.7795+(304-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251643.0, assembly_id=103070.0))
lhcb2.new("mb.a10r5.b2", "mb", at="lhclength-(356.264+(303.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834882.0, assembly_id=103070.0))
lhcb2.new("mcs.a10r5.b2", "mcs", at="lhclength-(363.688+(303-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245746.0, assembly_id=103070.0))
lhcb2.new("mb.b10r5.b2", "mb", at="lhclength-(371.924+(302.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834906.0, assembly_id=103071.0))
lhcb2.new("mcs.b10r5.b2", "mcs", at="lhclength-(379.348+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245749.0, assembly_id=103071.0))
lhcb2.new("bpm.10r5.b2", "bpm", at="lhclength-(380.227+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=377999.0, assembly_id=103072.0))
lhcb2.new("mqml.10r5.b2", "mqml", at="lhclength-(383.372+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307823.0, assembly_id=103072.0))
lhcb2.new("mcbch.10r5.b2", "mcbch", at="lhclength-(386.414+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=378113.0, assembly_id=103072.0))
lhcb2.new("mco.11r5.b2", "mco", at="lhclength-(387.843+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251648.0, assembly_id=103073.0))
lhcb2.new("mcd.11r5.b2", "mcd", at="lhclength-(387.8445+(302-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251649.0, assembly_id=103073.0))
lhcb2.new("mb.a11r5.b2", "mb", at="lhclength-(395.329+(301.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834930.0, assembly_id=103073.0))
lhcb2.new("mcs.a11r5.b2", "mcs", at="lhclength-(402.753+(301-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245758.0, assembly_id=103073.0))
lhcb2.new("mb.b11r5.b2", "mb", at="lhclength-(410.989+(300.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834954.0, assembly_id=103074.0))
lhcb2.new("mcs.b11r5.b2", "mcs", at="lhclength-(418.413+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245761.0, assembly_id=103074.0))
lhcb2.new("legr.11r5.b2", "legr", at="lhclength-(425.67735+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52997910.0, assembly_id=103075.0))
lhcb2.new("bpm.11r5.b2", "bpm", at="lhclength-(433.0087+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245763.0, assembly_id=103076.0))
lhcb2.new("mq.11r5.b2", "mq", at="lhclength-(435.5557+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308673.0, assembly_id=103076.0))
lhcb2.new("mqtli.11r5.b2", "mqtli", at="lhclength-(437.9247+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307361.0, assembly_id=103076.0))
lhcb2.new("ms.11r5.b2", "ms", at="lhclength-(438.9367+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251651.0, assembly_id=103076.0))
lhcb2.new("mcbv.11r5.b2", "mcbv", at="lhclength-(439.5297+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251653.0, assembly_id=103076.0))
lhcb2.new("s.arc.56.b2", "omk", at="lhclength-(440.2807+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a12r5.b2", "mco", at="lhclength-(440.6247+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251656.0, assembly_id=103077.0))
lhcb2.new("mcd.a12r5.b2", "mcd", at="lhclength-(440.6262+(300-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251657.0, assembly_id=103077.0))
lhcb2.new("mb.a12r5.b2", "mb", at="lhclength-(448.1107+(299.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52834978.0, assembly_id=103077.0))
lhcb2.new("mcs.a12r5.b2", "mcs", at="lhclength-(455.5347+(299-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245771.0, assembly_id=103077.0))
lhcb2.new("mb.b12r5.b2", "mb", at="lhclength-(463.7707+(298.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835002.0, assembly_id=103078.0))
lhcb2.new("mcs.b12r5.b2", "mcs", at="lhclength-(471.1947+(298-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245774.0, assembly_id=103078.0))
lhcb2.new("mco.b12r5.b2", "mco", at="lhclength-(471.9447+(298-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251660.0, assembly_id=103079.0))
lhcb2.new("mcd.b12r5.b2", "mcd", at="lhclength-(471.9462+(298-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251661.0, assembly_id=103079.0))
lhcb2.new("mb.c12r5.b2", "mb", at="lhclength-(479.4307+(297.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835026.0, assembly_id=103079.0))
lhcb2.new("mcs.c12r5.b2", "mcs", at="lhclength-(486.8547+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245779.0, assembly_id=103079.0))
lhcb2.new("bpm.12r5.b2", "bpm", at="lhclength-(487.7337+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245781.0, assembly_id=103080.0))
lhcb2.new("mqt.12r5.b2", "mqt", at="lhclength-(488.4877+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307708.0, assembly_id=103080.0))
lhcb2.new("mq.12r5.b2", "mq", at="lhclength-(490.4957+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308466.0, assembly_id=103080.0))
lhcb2.new("ms.12r5.b2", "ms", at="lhclength-(492.3907+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251663.0, assembly_id=103080.0))
lhcb2.new("mcbh.12r5.b2", "mcbh", at="lhclength-(492.9837+(297-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251665.0, assembly_id=103080.0))
lhcb2.new("mb.a13r5.b2", "mb", at="lhclength-(501.5607+(296.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835050.0, assembly_id=103081.0))
lhcb2.new("mcs.a13r5.b2", "mcs", at="lhclength-(508.9847+(296-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245787.0, assembly_id=103081.0))
lhcb2.new("mco.13r5.b2", "mco", at="lhclength-(509.7347+(296-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251668.0, assembly_id=103082.0))
lhcb2.new("mcd.13r5.b2", "mcd", at="lhclength-(509.7362+(296-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251669.0, assembly_id=103082.0))
lhcb2.new("mb.b13r5.b2", "mb", at="lhclength-(517.2207+(295.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835074.0, assembly_id=103082.0))
lhcb2.new("mcs.b13r5.b2", "mcs", at="lhclength-(524.6447+(295-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245792.0, assembly_id=103082.0))
lhcb2.new("mb.c13r5.b2", "mb", at="lhclength-(532.8807+(294.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835098.0, assembly_id=103083.0))
lhcb2.new("mcs.c13r5.b2", "mcs", at="lhclength-(540.3047+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245795.0, assembly_id=103083.0))
lhcb2.new("bpm.13r5.b2", "bpm", at="lhclength-(541.1837+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245797.0, assembly_id=103084.0))
lhcb2.new("mqt.13r5.b2", "mqt", at="lhclength-(541.9377+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307500.0, assembly_id=103084.0))
lhcb2.new("mq.13r5.b2", "mq", at="lhclength-(543.9457+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308496.0, assembly_id=103084.0))
lhcb2.new("ms.13r5.b2", "ms", at="lhclength-(545.8407+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251671.0, assembly_id=103084.0))
lhcb2.new("mcbv.13r5.b2", "mcbv", at="lhclength-(546.4337+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251673.0, assembly_id=103084.0))
lhcb2.new("e.ds.r5.b2", "omk", at="lhclength-(547.1807+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a14r5.b2", "mco", at="lhclength-(547.5247+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251676.0, assembly_id=103085.0))
lhcb2.new("mcd.a14r5.b2", "mcd", at="lhclength-(547.5262+(294-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251677.0, assembly_id=103085.0))
lhcb2.new("mb.a14r5.b2", "mb", at="lhclength-(555.0107+(293.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835122.0, assembly_id=103085.0))
lhcb2.new("mcs.a14r5.b2", "mcs", at="lhclength-(562.4347+(293-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245805.0, assembly_id=103085.0))
lhcb2.new("mb.b14r5.b2", "mb", at="lhclength-(570.6707+(292.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835146.0, assembly_id=103086.0))
lhcb2.new("mcs.b14r5.b2", "mcs", at="lhclength-(578.0947+(292-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245808.0, assembly_id=103086.0))
lhcb2.new("mco.b14r5.b2", "mco", at="lhclength-(578.8447+(292-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251680.0, assembly_id=103087.0))
lhcb2.new("mcd.b14r5.b2", "mcd", at="lhclength-(578.8462+(292-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251681.0, assembly_id=103087.0))
lhcb2.new("mb.c14r5.b2", "mb", at="lhclength-(586.3307+(291.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835170.0, assembly_id=103087.0))
lhcb2.new("mcs.c14r5.b2", "mcs", at="lhclength-(593.7547+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245813.0, assembly_id=103087.0))
lhcb2.new("bpm.14r5.b2", "bpm", at="lhclength-(594.6337+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245815.0, assembly_id=103088.0))
lhcb2.new("mqt.14r5.b2", "mqt", at="lhclength-(595.3877+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307532.0, assembly_id=103088.0))
lhcb2.new("mq.14r5.b2", "mq", at="lhclength-(597.3957+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308526.0, assembly_id=103088.0))
lhcb2.new("ms.14r5.b2", "ms", at="lhclength-(599.2907+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251683.0, assembly_id=103088.0))
lhcb2.new("mcbh.14r5.b2", "mcbh", at="lhclength-(599.8837+(291-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251685.0, assembly_id=103088.0))
lhcb2.new("mb.a15r5.b2", "mb", at="lhclength-(608.4607+(290.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835194.0, assembly_id=103089.0))
lhcb2.new("mcs.a15r5.b2", "mcs", at="lhclength-(615.8847+(290-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245821.0, assembly_id=103089.0))
lhcb2.new("mco.15r5.b2", "mco", at="lhclength-(616.6347+(290-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251688.0, assembly_id=103090.0))
lhcb2.new("mcd.15r5.b2", "mcd", at="lhclength-(616.6362+(290-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251689.0, assembly_id=103090.0))
lhcb2.new("mb.b15r5.b2", "mb", at="lhclength-(624.1207+(289.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835218.0, assembly_id=103090.0))
lhcb2.new("mcs.b15r5.b2", "mcs", at="lhclength-(631.5447+(289-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245826.0, assembly_id=103090.0))
lhcb2.new("mb.c15r5.b2", "mb", at="lhclength-(639.7807+(288.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835242.0, assembly_id=103091.0))
lhcb2.new("mcs.c15r5.b2", "mcs", at="lhclength-(647.2047+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245829.0, assembly_id=103091.0))
lhcb2.new("bpm.15r5.b2", "bpm", at="lhclength-(648.0837+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245831.0, assembly_id=103092.0))
lhcb2.new("mqt.15r5.b2", "mqt", at="lhclength-(648.8377+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307564.0, assembly_id=103092.0))
lhcb2.new("mq.15r5.b2", "mq", at="lhclength-(650.8457+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308556.0, assembly_id=103092.0))
lhcb2.new("ms.15r5.b2", "ms", at="lhclength-(652.7407+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251691.0, assembly_id=103092.0))
lhcb2.new("mcbv.15r5.b2", "mcbv", at="lhclength-(653.3337+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251693.0, assembly_id=103092.0))
lhcb2.new("mco.a16r5.b2", "mco", at="lhclength-(654.4247+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251696.0, assembly_id=103093.0))
lhcb2.new("mcd.a16r5.b2", "mcd", at="lhclength-(654.4262+(288-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251697.0, assembly_id=103093.0))
lhcb2.new("mb.a16r5.b2", "mb", at="lhclength-(661.9107+(287.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835266.0, assembly_id=103093.0))
lhcb2.new("mcs.a16r5.b2", "mcs", at="lhclength-(669.3347+(287-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245839.0, assembly_id=103093.0))
lhcb2.new("mb.b16r5.b2", "mb", at="lhclength-(677.5707+(286.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835290.0, assembly_id=103094.0))
lhcb2.new("mcs.b16r5.b2", "mcs", at="lhclength-(684.9947+(286-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245842.0, assembly_id=103094.0))
lhcb2.new("mco.b16r5.b2", "mco", at="lhclength-(685.7447+(286-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251700.0, assembly_id=103095.0))
lhcb2.new("mcd.b16r5.b2", "mcd", at="lhclength-(685.7462+(286-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251701.0, assembly_id=103095.0))
lhcb2.new("mb.c16r5.b2", "mb", at="lhclength-(693.2307+(285.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835314.0, assembly_id=103095.0))
lhcb2.new("mcs.c16r5.b2", "mcs", at="lhclength-(700.6547+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245847.0, assembly_id=103095.0))
lhcb2.new("bpm.16r5.b2", "bpm", at="lhclength-(701.5337+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245849.0, assembly_id=103096.0))
lhcb2.new("mqt.16r5.b2", "mqt", at="lhclength-(702.2877+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307594.0, assembly_id=103096.0))
lhcb2.new("mq.16r5.b2", "mq", at="lhclength-(704.2957+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308349.0, assembly_id=103096.0))
lhcb2.new("ms.16r5.b2", "ms", at="lhclength-(706.1907+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251703.0, assembly_id=103096.0))
lhcb2.new("mcbh.16r5.b2", "mcbh", at="lhclength-(706.7837+(285-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251705.0, assembly_id=103096.0))
lhcb2.new("mb.a17r5.b2", "mb", at="lhclength-(715.3607+(284.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835338.0, assembly_id=103097.0))
lhcb2.new("mcs.a17r5.b2", "mcs", at="lhclength-(722.7847+(284-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245855.0, assembly_id=103097.0))
lhcb2.new("mco.17r5.b2", "mco", at="lhclength-(723.5347+(284-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251708.0, assembly_id=103098.0))
lhcb2.new("mcd.17r5.b2", "mcd", at="lhclength-(723.5362+(284-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251709.0, assembly_id=103098.0))
lhcb2.new("mb.b17r5.b2", "mb", at="lhclength-(731.0207+(283.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835362.0, assembly_id=103098.0))
lhcb2.new("mcs.b17r5.b2", "mcs", at="lhclength-(738.4447+(283-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245860.0, assembly_id=103098.0))
lhcb2.new("mb.c17r5.b2", "mb", at="lhclength-(746.6807+(282.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835386.0, assembly_id=103099.0))
lhcb2.new("mcs.c17r5.b2", "mcs", at="lhclength-(754.1047+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245863.0, assembly_id=103099.0))
lhcb2.new("bpm.17r5.b2", "bpm", at="lhclength-(754.9837+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245865.0, assembly_id=103100.0))
lhcb2.new("mqt.17r5.b2", "mqt", at="lhclength-(755.7377+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307388.0, assembly_id=103100.0))
lhcb2.new("mq.17r5.b2", "mq", at="lhclength-(757.7457+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308379.0, assembly_id=103100.0))
lhcb2.new("ms.17r5.b2", "ms", at="lhclength-(759.6407+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251711.0, assembly_id=103100.0))
lhcb2.new("mcbv.17r5.b2", "mcbv", at="lhclength-(760.2337+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251713.0, assembly_id=103100.0))
lhcb2.new("mco.a18r5.b2", "mco", at="lhclength-(761.3247+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251716.0, assembly_id=103101.0))
lhcb2.new("mcd.a18r5.b2", "mcd", at="lhclength-(761.3262+(282-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251717.0, assembly_id=103101.0))
lhcb2.new("mb.a18r5.b2", "mb", at="lhclength-(768.8107+(281.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835410.0, assembly_id=103101.0))
lhcb2.new("mcs.a18r5.b2", "mcs", at="lhclength-(776.2347+(281-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245873.0, assembly_id=103101.0))
lhcb2.new("mb.b18r5.b2", "mb", at="lhclength-(784.4707+(280.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835434.0, assembly_id=103102.0))
lhcb2.new("mcs.b18r5.b2", "mcs", at="lhclength-(791.8947+(280-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245876.0, assembly_id=103102.0))
lhcb2.new("mco.b18r5.b2", "mco", at="lhclength-(792.6447+(280-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251720.0, assembly_id=103103.0))
lhcb2.new("mcd.b18r5.b2", "mcd", at="lhclength-(792.6462+(280-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251721.0, assembly_id=103103.0))
lhcb2.new("mb.c18r5.b2", "mb", at="lhclength-(800.1307+(279.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835458.0, assembly_id=103103.0))
lhcb2.new("mcs.c18r5.b2", "mcs", at="lhclength-(807.5547+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245881.0, assembly_id=103103.0))
lhcb2.new("bpm.18r5.b2", "bpm", at="lhclength-(808.4337+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245883.0, assembly_id=103104.0))
lhcb2.new("mqt.18r5.b2", "mqt", at="lhclength-(809.1877+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307420.0, assembly_id=103104.0))
lhcb2.new("mq.18r5.b2", "mq", at="lhclength-(811.1957+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308409.0, assembly_id=103104.0))
lhcb2.new("ms.18r5.b2", "ms", at="lhclength-(813.0907+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251723.0, assembly_id=103104.0))
lhcb2.new("mcbh.18r5.b2", "mcbh", at="lhclength-(813.6837+(279-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251725.0, assembly_id=103104.0))
lhcb2.new("mb.a19r5.b2", "mb", at="lhclength-(822.2607+(278.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835482.0, assembly_id=103105.0))
lhcb2.new("mcs.a19r5.b2", "mcs", at="lhclength-(829.6847+(278-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245889.0, assembly_id=103105.0))
lhcb2.new("mco.19r5.b2", "mco", at="lhclength-(830.4347+(278-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251728.0, assembly_id=103106.0))
lhcb2.new("mcd.19r5.b2", "mcd", at="lhclength-(830.4362+(278-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251729.0, assembly_id=103106.0))
lhcb2.new("mb.b19r5.b2", "mb", at="lhclength-(837.9207+(277.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835506.0, assembly_id=103106.0))
lhcb2.new("mcs.b19r5.b2", "mcs", at="lhclength-(845.3447+(277-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245894.0, assembly_id=103106.0))
lhcb2.new("mb.c19r5.b2", "mb", at="lhclength-(853.5807+(276.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835530.0, assembly_id=103107.0))
lhcb2.new("mcs.c19r5.b2", "mcs", at="lhclength-(861.0047+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245897.0, assembly_id=103107.0))
lhcb2.new("bpm.19r5.b2", "bpm", at="lhclength-(861.8837+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245899.0, assembly_id=103108.0))
lhcb2.new("mqt.19r5.b2", "mqt", at="lhclength-(862.6377+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307450.0, assembly_id=103108.0))
lhcb2.new("mq.19r5.b2", "mq", at="lhclength-(864.6457+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308441.0, assembly_id=103108.0))
lhcb2.new("ms.19r5.b2", "ms", at="lhclength-(866.5407+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251731.0, assembly_id=103108.0))
lhcb2.new("mcbv.19r5.b2", "mcbv", at="lhclength-(867.1337+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251733.0, assembly_id=103108.0))
lhcb2.new("mco.a20r5.b2", "mco", at="lhclength-(868.2247+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251736.0, assembly_id=103109.0))
lhcb2.new("mcd.a20r5.b2", "mcd", at="lhclength-(868.2262+(276-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251737.0, assembly_id=103109.0))
lhcb2.new("mb.a20r5.b2", "mb", at="lhclength-(875.7107+(275.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835554.0, assembly_id=103109.0))
lhcb2.new("mcs.a20r5.b2", "mcs", at="lhclength-(883.1347+(275-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245907.0, assembly_id=103109.0))
lhcb2.new("mb.b20r5.b2", "mb", at="lhclength-(891.3707+(274.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835578.0, assembly_id=103110.0))
lhcb2.new("mcs.b20r5.b2", "mcs", at="lhclength-(898.7947+(274-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245910.0, assembly_id=103110.0))
lhcb2.new("mco.b20r5.b2", "mco", at="lhclength-(899.5447+(274-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251740.0, assembly_id=103111.0))
lhcb2.new("mcd.b20r5.b2", "mcd", at="lhclength-(899.5462+(274-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251741.0, assembly_id=103111.0))
lhcb2.new("mb.c20r5.b2", "mb", at="lhclength-(907.0307+(273.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835602.0, assembly_id=103111.0))
lhcb2.new("mcs.c20r5.b2", "mcs", at="lhclength-(914.4547+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245915.0, assembly_id=103111.0))
lhcb2.new("bpm.20r5.b2", "bpm", at="lhclength-(915.3337+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245917.0, assembly_id=103112.0))
lhcb2.new("mqt.20r5.b2", "mqt", at="lhclength-(916.0877+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307480.0, assembly_id=103112.0))
lhcb2.new("mq.20r5.b2", "mq", at="lhclength-(918.0957+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308231.0, assembly_id=103112.0))
lhcb2.new("ms.20r5.b2", "ms", at="lhclength-(919.9907+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251743.0, assembly_id=103112.0))
lhcb2.new("mcbh.20r5.b2", "mcbh", at="lhclength-(920.5837+(273-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251745.0, assembly_id=103112.0))
lhcb2.new("mb.a21r5.b2", "mb", at="lhclength-(929.1607+(272.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835626.0, assembly_id=103113.0))
lhcb2.new("mcs.a21r5.b2", "mcs", at="lhclength-(936.5847+(272-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245923.0, assembly_id=103113.0))
lhcb2.new("mco.21r5.b2", "mco", at="lhclength-(937.3347+(272-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251748.0, assembly_id=103114.0))
lhcb2.new("mcd.21r5.b2", "mcd", at="lhclength-(937.3362+(272-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251749.0, assembly_id=103114.0))
lhcb2.new("mb.b21r5.b2", "mb", at="lhclength-(944.8207+(271.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835650.0, assembly_id=103114.0))
lhcb2.new("mcs.b21r5.b2", "mcs", at="lhclength-(952.2447+(271-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245928.0, assembly_id=103114.0))
lhcb2.new("mb.c21r5.b2", "mb", at="lhclength-(960.4807+(270.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835674.0, assembly_id=103115.0))
lhcb2.new("mcs.c21r5.b2", "mcs", at="lhclength-(967.9047+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245931.0, assembly_id=103115.0))
lhcb2.new("bpm.21r5.b2", "bpm", at="lhclength-(968.7837+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245933.0, assembly_id=103116.0))
lhcb2.new("mqt.21r5.b2", "mqt", at="lhclength-(969.5377+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307278.0, assembly_id=103116.0))
lhcb2.new("mq.21r5.b2", "mq", at="lhclength-(971.5457+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308262.0, assembly_id=103116.0))
lhcb2.new("ms.21r5.b2", "ms", at="lhclength-(973.4407+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251751.0, assembly_id=103116.0))
lhcb2.new("mcbv.21r5.b2", "mcbv", at="lhclength-(974.0337+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251753.0, assembly_id=103116.0))
lhcb2.new("mco.a22r5.b2", "mco", at="lhclength-(975.1247+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251756.0, assembly_id=103117.0))
lhcb2.new("mcd.a22r5.b2", "mcd", at="lhclength-(975.1262+(270-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251757.0, assembly_id=103117.0))
lhcb2.new("mb.a22r5.b2", "mb", at="lhclength-(982.6107+(269.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835698.0, assembly_id=103117.0))
lhcb2.new("mcs.a22r5.b2", "mcs", at="lhclength-(990.0347+(269-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245941.0, assembly_id=103117.0))
lhcb2.new("mb.b22r5.b2", "mb", at="lhclength-(998.2707+(268.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835722.0, assembly_id=103118.0))
lhcb2.new("mcs.b22r5.b2", "mcs", at="lhclength-(1005.6947+(268-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245944.0, assembly_id=103118.0))
lhcb2.new("mco.b22r5.b2", "mco", at="lhclength-(1006.4447+(268-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251760.0, assembly_id=103119.0))
lhcb2.new("mcd.b22r5.b2", "mcd", at="lhclength-(1006.4462+(268-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251761.0, assembly_id=103119.0))
lhcb2.new("mb.c22r5.b2", "mb", at="lhclength-(1013.9307+(267.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835746.0, assembly_id=103119.0))
lhcb2.new("mcs.c22r5.b2", "mcs", at="lhclength-(1021.3547+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245949.0, assembly_id=103119.0))
lhcb2.new("bpm.22r5.b2", "bpm", at="lhclength-(1022.2337+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245951.0, assembly_id=103120.0))
lhcb2.new("mo.22r5.b2", "mo", at="lhclength-(1022.9847+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308822.0, assembly_id=103120.0))
lhcb2.new("mq.22r5.b2", "mq", at="lhclength-(1024.9957+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308294.0, assembly_id=103120.0))
lhcb2.new("ms.22r5.b2", "ms", at="lhclength-(1026.8907+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251763.0, assembly_id=103120.0))
lhcb2.new("mcbh.22r5.b2", "mcbh", at="lhclength-(1027.4837+(267-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251765.0, assembly_id=103120.0))
lhcb2.new("mb.a23r5.b2", "mb", at="lhclength-(1036.0607+(266.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835770.0, assembly_id=103121.0))
lhcb2.new("mcs.a23r5.b2", "mcs", at="lhclength-(1043.4847+(266-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245957.0, assembly_id=103121.0))
lhcb2.new("mco.23r5.b2", "mco", at="lhclength-(1044.2347+(266-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251768.0, assembly_id=103122.0))
lhcb2.new("mcd.23r5.b2", "mcd", at="lhclength-(1044.2362+(266-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251769.0, assembly_id=103122.0))
lhcb2.new("mb.b23r5.b2", "mb", at="lhclength-(1051.7207+(265.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835794.0, assembly_id=103122.0))
lhcb2.new("mcs.b23r5.b2", "mcs", at="lhclength-(1059.1447+(265-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245962.0, assembly_id=103122.0))
lhcb2.new("mb.c23r5.b2", "mb", at="lhclength-(1067.3807+(264.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835818.0, assembly_id=103123.0))
lhcb2.new("mcs.c23r5.b2", "mcs", at="lhclength-(1074.8047+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245965.0, assembly_id=103123.0))
lhcb2.new("bpm.23r5.b2", "bpm", at="lhclength-(1075.6837+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245967.0, assembly_id=103124.0))
lhcb2.new("mqs.23r5.b2", "mqs", at="lhclength-(1076.4377+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307644.0, assembly_id=103124.0))
lhcb2.new("mq.23r5.b2", "mq", at="lhclength-(1078.4457+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308325.0, assembly_id=103124.0))
lhcb2.new("ms.23r5.b2", "ms", at="lhclength-(1080.3407+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251771.0, assembly_id=103124.0))
lhcb2.new("mcbv.23r5.b2", "mcbv", at="lhclength-(1080.9337+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251773.0, assembly_id=103124.0))
lhcb2.new("mco.a24r5.b2", "mco", at="lhclength-(1082.0247+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251776.0, assembly_id=103125.0))
lhcb2.new("mcd.a24r5.b2", "mcd", at="lhclength-(1082.0262+(264-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251777.0, assembly_id=103125.0))
lhcb2.new("mb.a24r5.b2", "mb", at="lhclength-(1089.5107+(263.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835842.0, assembly_id=103125.0))
lhcb2.new("mcs.a24r5.b2", "mcs", at="lhclength-(1096.9347+(263-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245975.0, assembly_id=103125.0))
lhcb2.new("mb.b24r5.b2", "mb", at="lhclength-(1105.1707+(262.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835866.0, assembly_id=103126.0))
lhcb2.new("mcs.b24r5.b2", "mcs", at="lhclength-(1112.5947+(262-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245978.0, assembly_id=103126.0))
lhcb2.new("mco.b24r5.b2", "mco", at="lhclength-(1113.3447+(262-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251780.0, assembly_id=103127.0))
lhcb2.new("mcd.b24r5.b2", "mcd", at="lhclength-(1113.3462+(262-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251781.0, assembly_id=103127.0))
lhcb2.new("mb.c24r5.b2", "mb", at="lhclength-(1120.8307+(261.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835890.0, assembly_id=103127.0))
lhcb2.new("mcs.c24r5.b2", "mcs", at="lhclength-(1128.2547+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245983.0, assembly_id=103127.0))
lhcb2.new("bpm.24r5.b2", "bpm", at="lhclength-(1129.1337+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245985.0, assembly_id=103128.0))
lhcb2.new("mo.24r5.b2", "mo", at="lhclength-(1129.8847+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308852.0, assembly_id=103128.0))
lhcb2.new("mq.24r5.b2", "mq", at="lhclength-(1131.8957+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308115.0, assembly_id=103128.0))
lhcb2.new("ms.24r5.b2", "ms", at="lhclength-(1133.7907+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251783.0, assembly_id=103128.0))
lhcb2.new("mcbh.24r5.b2", "mcbh", at="lhclength-(1134.3837+(261-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251785.0, assembly_id=103128.0))
lhcb2.new("mb.a25r5.b2", "mb", at="lhclength-(1142.9607+(260.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835914.0, assembly_id=103129.0))
lhcb2.new("mcs.a25r5.b2", "mcs", at="lhclength-(1150.3847+(260-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245991.0, assembly_id=103129.0))
lhcb2.new("mco.25r5.b2", "mco", at="lhclength-(1151.1347+(260-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251788.0, assembly_id=103130.0))
lhcb2.new("mcd.25r5.b2", "mcd", at="lhclength-(1151.1362+(260-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251789.0, assembly_id=103130.0))
lhcb2.new("mb.b25r5.b2", "mb", at="lhclength-(1158.6207+(259.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835938.0, assembly_id=103130.0))
lhcb2.new("mcs.b25r5.b2", "mcs", at="lhclength-(1166.0447+(259-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245996.0, assembly_id=103130.0))
lhcb2.new("mb.c25r5.b2", "mb", at="lhclength-(1174.2807+(258.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835962.0, assembly_id=103131.0))
lhcb2.new("mcs.c25r5.b2", "mcs", at="lhclength-(1181.7047+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=245999.0, assembly_id=103131.0))
lhcb2.new("bpm.25r5.b2", "bpm", at="lhclength-(1182.5837+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246001.0, assembly_id=103132.0))
lhcb2.new("mo.25r5.b2", "mo", at="lhclength-(1183.3347+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308884.0, assembly_id=103132.0))
lhcb2.new("mq.25r5.b2", "mq", at="lhclength-(1185.3457+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308147.0, assembly_id=103132.0))
lhcb2.new("ms.25r5.b2", "ms", at="lhclength-(1187.2407+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251791.0, assembly_id=103132.0))
lhcb2.new("mcbv.25r5.b2", "mcbv", at="lhclength-(1187.8337+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251793.0, assembly_id=103132.0))
lhcb2.new("mco.a26r5.b2", "mco", at="lhclength-(1188.9247+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251796.0, assembly_id=103133.0))
lhcb2.new("mcd.a26r5.b2", "mcd", at="lhclength-(1188.9262+(258-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251797.0, assembly_id=103133.0))
lhcb2.new("mb.a26r5.b2", "mb", at="lhclength-(1196.4107+(257.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52835986.0, assembly_id=103133.0))
lhcb2.new("mcs.a26r5.b2", "mcs", at="lhclength-(1203.8347+(257-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246009.0, assembly_id=103133.0))
lhcb2.new("mb.b26r5.b2", "mb", at="lhclength-(1212.0707+(256.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836010.0, assembly_id=103134.0))
lhcb2.new("mcs.b26r5.b2", "mcs", at="lhclength-(1219.4947+(256-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246012.0, assembly_id=103134.0))
lhcb2.new("mco.b26r5.b2", "mco", at="lhclength-(1220.2447+(256-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251800.0, assembly_id=103135.0))
lhcb2.new("mcd.b26r5.b2", "mcd", at="lhclength-(1220.2462+(256-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251801.0, assembly_id=103135.0))
lhcb2.new("mb.c26r5.b2", "mb", at="lhclength-(1227.7307+(255.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836034.0, assembly_id=103135.0))
lhcb2.new("mcs.c26r5.b2", "mcs", at="lhclength-(1235.1547+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246017.0, assembly_id=103135.0))
lhcb2.new("bpm.26r5.b2", "bpm", at="lhclength-(1236.0337+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246019.0, assembly_id=103136.0))
lhcb2.new("mo.26r5.b2", "mo", at="lhclength-(1236.7847+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308915.0, assembly_id=103136.0))
lhcb2.new("mq.26r5.b2", "mq", at="lhclength-(1238.7957+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2348471.0, assembly_id=103136.0))
lhcb2.new("ms.26r5.b2", "ms", at="lhclength-(1240.6907+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251803.0, assembly_id=103136.0))
lhcb2.new("mcbh.26r5.b2", "mcbh", at="lhclength-(1241.2837+(255-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251805.0, assembly_id=103136.0))
lhcb2.new("mb.a27r5.b2", "mb", at="lhclength-(1249.8607+(254.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836058.0, assembly_id=103137.0))
lhcb2.new("mcs.a27r5.b2", "mcs", at="lhclength-(1257.2847+(254-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246025.0, assembly_id=103137.0))
lhcb2.new("mco.27r5.b2", "mco", at="lhclength-(1258.0347+(254-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251808.0, assembly_id=103138.0))
lhcb2.new("mcd.27r5.b2", "mcd", at="lhclength-(1258.0362+(254-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251809.0, assembly_id=103138.0))
lhcb2.new("mb.b27r5.b2", "mb", at="lhclength-(1265.5207+(253.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836082.0, assembly_id=103138.0))
lhcb2.new("mcs.b27r5.b2", "mcs", at="lhclength-(1272.9447+(253-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246030.0, assembly_id=103138.0))
lhcb2.new("mb.c27r5.b2", "mb", at="lhclength-(1281.1807+(252.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836106.0, assembly_id=103139.0))
lhcb2.new("mcs.c27r5.b2", "mcs", at="lhclength-(1288.6047+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246033.0, assembly_id=103139.0))
lhcb2.new("bpm.27r5.b2", "bpm", at="lhclength-(1289.4837+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246035.0, assembly_id=103140.0))
lhcb2.new("mqs.27r5.b2", "mqs", at="lhclength-(1290.2377+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307676.0, assembly_id=103140.0))
lhcb2.new("mq.27r5.b2", "mq", at="lhclength-(1292.2457+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307967.0, assembly_id=103140.0))
lhcb2.new("ms.27r5.b2", "ms", at="lhclength-(1294.1407+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251811.0, assembly_id=103140.0))
lhcb2.new("mcbv.27r5.b2", "mcbv", at="lhclength-(1294.7337+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251813.0, assembly_id=103140.0))
lhcb2.new("mco.a28r5.b2", "mco", at="lhclength-(1295.8247+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251816.0, assembly_id=103141.0))
lhcb2.new("mcd.a28r5.b2", "mcd", at="lhclength-(1295.8262+(252-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251817.0, assembly_id=103141.0))
lhcb2.new("mb.a28r5.b2", "mb", at="lhclength-(1303.3107+(251.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836130.0, assembly_id=103141.0))
lhcb2.new("mcs.a28r5.b2", "mcs", at="lhclength-(1310.7347+(251-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246043.0, assembly_id=103141.0))
lhcb2.new("mb.b28r5.b2", "mb", at="lhclength-(1318.9707+(250.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836154.0, assembly_id=103142.0))
lhcb2.new("mcs.b28r5.b2", "mcs", at="lhclength-(1326.3947+(250-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246046.0, assembly_id=103142.0))
lhcb2.new("mco.b28r5.b2", "mco", at="lhclength-(1327.1447+(250-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251820.0, assembly_id=103143.0))
lhcb2.new("mcd.b28r5.b2", "mcd", at="lhclength-(1327.1462+(250-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251821.0, assembly_id=103143.0))
lhcb2.new("mb.c28r5.b2", "mb", at="lhclength-(1334.6307+(249.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836178.0, assembly_id=103143.0))
lhcb2.new("mcs.c28r5.b2", "mcs", at="lhclength-(1342.0547+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246051.0, assembly_id=103143.0))
lhcb2.new("bpm.28r5.b2", "bpm", at="lhclength-(1342.9337+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246053.0, assembly_id=103144.0))
lhcb2.new("mo.28r5.b2", "mo", at="lhclength-(1343.6847+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308705.0, assembly_id=103144.0))
lhcb2.new("mq.28r5.b2", "mq", at="lhclength-(1345.6957+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307999.0, assembly_id=103144.0))
lhcb2.new("ms.28r5.b2", "ms", at="lhclength-(1347.5907+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251823.0, assembly_id=103144.0))
lhcb2.new("mcbh.28r5.b2", "mcbh", at="lhclength-(1348.1837+(249-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251825.0, assembly_id=103144.0))
lhcb2.new("mb.a29r5.b2", "mb", at="lhclength-(1356.7607+(248.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836202.0, assembly_id=103145.0))
lhcb2.new("mcs.a29r5.b2", "mcs", at="lhclength-(1364.1847+(248-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246059.0, assembly_id=103145.0))
lhcb2.new("mco.29r5.b2", "mco", at="lhclength-(1364.9347+(248-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251828.0, assembly_id=103146.0))
lhcb2.new("mcd.29r5.b2", "mcd", at="lhclength-(1364.9362+(248-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251829.0, assembly_id=103146.0))
lhcb2.new("mb.b29r5.b2", "mb", at="lhclength-(1372.4207+(247.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836226.0, assembly_id=103146.0))
lhcb2.new("mcs.b29r5.b2", "mcs", at="lhclength-(1379.8447+(247-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246064.0, assembly_id=103146.0))
lhcb2.new("mb.c29r5.b2", "mb", at="lhclength-(1388.0807+(246.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836250.0, assembly_id=103147.0))
lhcb2.new("mcs.c29r5.b2", "mcs", at="lhclength-(1395.5047+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246067.0, assembly_id=103147.0))
lhcb2.new("bpm.29r5.b2", "bpm", at="lhclength-(1396.3837+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246069.0, assembly_id=103148.0))
lhcb2.new("mo.29r5.b2", "mo", at="lhclength-(1397.1347+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308737.0, assembly_id=103148.0))
lhcb2.new("mq.29r5.b2", "mq", at="lhclength-(1399.1457+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308030.0, assembly_id=103148.0))
lhcb2.new("ms.29r5.b2", "ms", at="lhclength-(1401.0407+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251831.0, assembly_id=103148.0))
lhcb2.new("mcbv.29r5.b2", "mcbv", at="lhclength-(1401.6337+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251833.0, assembly_id=103148.0))
lhcb2.new("mco.a30r5.b2", "mco", at="lhclength-(1402.7247+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251836.0, assembly_id=103149.0))
lhcb2.new("mcd.a30r5.b2", "mcd", at="lhclength-(1402.7262+(246-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251837.0, assembly_id=103149.0))
lhcb2.new("mb.a30r5.b2", "mb", at="lhclength-(1410.2107+(245.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836274.0, assembly_id=103149.0))
lhcb2.new("mcs.a30r5.b2", "mcs", at="lhclength-(1417.6347+(245-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246077.0, assembly_id=103149.0))
lhcb2.new("mb.b30r5.b2", "mb", at="lhclength-(1425.8707+(244.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836298.0, assembly_id=103150.0))
lhcb2.new("mcs.b30r5.b2", "mcs", at="lhclength-(1433.2947+(244-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246080.0, assembly_id=103150.0))
lhcb2.new("mco.b30r5.b2", "mco", at="lhclength-(1434.0447+(244-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251840.0, assembly_id=103151.0))
lhcb2.new("mcd.b30r5.b2", "mcd", at="lhclength-(1434.0462+(244-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251841.0, assembly_id=103151.0))
lhcb2.new("mb.c30r5.b2", "mb", at="lhclength-(1441.5307+(243.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836322.0, assembly_id=103151.0))
lhcb2.new("mcs.c30r5.b2", "mcs", at="lhclength-(1448.9547+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246085.0, assembly_id=103151.0))
lhcb2.new("bpm.30r5.b2", "bpm", at="lhclength-(1449.8337+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246087.0, assembly_id=103152.0))
lhcb2.new("mo.30r5.b2", "mo", at="lhclength-(1450.5847+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308768.0, assembly_id=103152.0))
lhcb2.new("mq.30r5.b2", "mq", at="lhclength-(1452.5957+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308059.0, assembly_id=103152.0))
lhcb2.new("mss.30r5.b2", "mss", at="lhclength-(1454.4907+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251843.0, assembly_id=103152.0))
lhcb2.new("mcbh.30r5.b2", "mcbh", at="lhclength-(1455.0837+(243-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251845.0, assembly_id=103152.0))
lhcb2.new("mb.a31r5.b2", "mb", at="lhclength-(1463.6607+(242.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836346.0, assembly_id=103153.0))
lhcb2.new("mcs.a31r5.b2", "mcs", at="lhclength-(1471.0847+(242-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246093.0, assembly_id=103153.0))
lhcb2.new("mco.31r5.b2", "mco", at="lhclength-(1471.8347+(242-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251848.0, assembly_id=103154.0))
lhcb2.new("mcd.31r5.b2", "mcd", at="lhclength-(1471.8362+(242-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251849.0, assembly_id=103154.0))
lhcb2.new("mb.b31r5.b2", "mb", at="lhclength-(1479.3207+(241.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836370.0, assembly_id=103154.0))
lhcb2.new("mcs.b31r5.b2", "mcs", at="lhclength-(1486.7447+(241-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246098.0, assembly_id=103154.0))
lhcb2.new("mb.c31r5.b2", "mb", at="lhclength-(1494.9807+(240.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836394.0, assembly_id=103155.0))
lhcb2.new("mcs.c31r5.b2", "mcs", at="lhclength-(1502.4047+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246101.0, assembly_id=103155.0))
lhcb2.new("bpm.31r5.b2", "bpm", at="lhclength-(1503.2837+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246103.0, assembly_id=103156.0))
lhcb2.new("mo.31r5.b2", "mo", at="lhclength-(1504.0347+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308798.0, assembly_id=103156.0))
lhcb2.new("mq.31r5.b2", "mq", at="lhclength-(1506.0457+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307851.0, assembly_id=103156.0))
lhcb2.new("ms.31r5.b2", "ms", at="lhclength-(1507.9407+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251851.0, assembly_id=103156.0))
lhcb2.new("mcbv.31r5.b2", "mcbv", at="lhclength-(1508.5337+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251853.0, assembly_id=103156.0))
lhcb2.new("s.cell.56.b2", "omk", at="lhclength-(1509.2807+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a32r5.b2", "mco", at="lhclength-(1509.6247+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251856.0, assembly_id=103157.0))
lhcb2.new("mcd.a32r5.b2", "mcd", at="lhclength-(1509.6262+(240-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251857.0, assembly_id=103157.0))
lhcb2.new("mb.a32r5.b2", "mb", at="lhclength-(1517.1107+(239.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836418.0, assembly_id=103157.0))
lhcb2.new("mcs.a32r5.b2", "mcs", at="lhclength-(1524.5347+(239-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246111.0, assembly_id=103157.0))
lhcb2.new("mb.b32r5.b2", "mb", at="lhclength-(1532.7707+(238.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836442.0, assembly_id=103158.0))
lhcb2.new("mcs.b32r5.b2", "mcs", at="lhclength-(1540.1947+(238-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246114.0, assembly_id=103158.0))
lhcb2.new("mco.b32r5.b2", "mco", at="lhclength-(1540.9447+(238-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251860.0, assembly_id=103159.0))
lhcb2.new("mcd.b32r5.b2", "mcd", at="lhclength-(1540.9462+(238-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251861.0, assembly_id=103159.0))
lhcb2.new("mb.c32r5.b2", "mb", at="lhclength-(1548.4307+(237.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836466.0, assembly_id=103159.0))
lhcb2.new("mcs.c32r5.b2", "mcs", at="lhclength-(1555.8547+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246119.0, assembly_id=103159.0))
lhcb2.new("bpm.32r5.b2", "bpm", at="lhclength-(1556.7337+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246121.0, assembly_id=103160.0))
lhcb2.new("mo.32r5.b2", "mo", at="lhclength-(1557.4847+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308590.0, assembly_id=103160.0))
lhcb2.new("mq.32r5.b2", "mq", at="lhclength-(1559.4957+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307881.0, assembly_id=103160.0))
lhcb2.new("ms.32r5.b2", "ms", at="lhclength-(1561.3907+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251863.0, assembly_id=103160.0))
lhcb2.new("mcbh.32r5.b2", "mcbh", at="lhclength-(1561.9837+(237-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251865.0, assembly_id=103160.0))
lhcb2.new("mb.a33r5.b2", "mb", at="lhclength-(1570.5607+(236.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836490.0, assembly_id=103161.0))
lhcb2.new("mcs.a33r5.b2", "mcs", at="lhclength-(1577.9847+(236-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246127.0, assembly_id=103161.0))
lhcb2.new("mco.33r5.b2", "mco", at="lhclength-(1578.7347+(236-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251868.0, assembly_id=103162.0))
lhcb2.new("mcd.33r5.b2", "mcd", at="lhclength-(1578.7362+(236-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251869.0, assembly_id=103162.0))
lhcb2.new("mb.b33r5.b2", "mb", at="lhclength-(1586.2207+(235.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836514.0, assembly_id=103162.0))
lhcb2.new("mcs.b33r5.b2", "mcs", at="lhclength-(1593.6447+(235-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246132.0, assembly_id=103162.0))
lhcb2.new("mb.c33r5.b2", "mb", at="lhclength-(1601.8807+(234.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836538.0, assembly_id=103163.0))
lhcb2.new("mcs.c33r5.b2", "mcs", at="lhclength-(1609.3047+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246135.0, assembly_id=103163.0))
lhcb2.new("bpm.33r5.b2", "bpm", at="lhclength-(1610.1837+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246137.0, assembly_id=103164.0))
lhcb2.new("mo.33r5.b2", "mo", at="lhclength-(1610.9347+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308621.0, assembly_id=103164.0))
lhcb2.new("mq.33r5.b2", "mq", at="lhclength-(1612.9457+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307911.0, assembly_id=103164.0))
lhcb2.new("ms.33r5.b2", "ms", at="lhclength-(1614.8407+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251871.0, assembly_id=103164.0))
lhcb2.new("mcbv.33r5.b2", "mcbv", at="lhclength-(1615.4337+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251873.0, assembly_id=103164.0))
lhcb2.new("e.cell.56.b2", "omk", at="lhclength-(1616.1807+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a34r5.b2", "mco", at="lhclength-(1616.5247+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251876.0, assembly_id=103165.0))
lhcb2.new("mcd.a34r5.b2", "mcd", at="lhclength-(1616.5262+(234-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251877.0, assembly_id=103165.0))
lhcb2.new("mb.a34r5.b2", "mb", at="lhclength-(1624.0107+(233.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836562.0, assembly_id=103165.0))
lhcb2.new("mcs.a34r5.b2", "mcs", at="lhclength-(1631.4347+(233-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246145.0, assembly_id=103165.0))
lhcb2.new("mb.b34r5.b2", "mb", at="lhclength-(1639.6707+(232.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836586.0, assembly_id=103166.0))
lhcb2.new("mcs.b34r5.b2", "mcs", at="lhclength-(1647.0947+(232-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246148.0, assembly_id=103166.0))
lhcb2.new("mco.b34r5.b2", "mco", at="lhclength-(1647.8447+(232-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251880.0, assembly_id=103167.0))
lhcb2.new("mcd.b34r5.b2", "mcd", at="lhclength-(1647.8462+(232-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=251881.0, assembly_id=103167.0))
lhcb2.new("mb.c34r5.b2", "mb", at="lhclength-(1655.3307+(231.5-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=52836610.0, assembly_id=103167.0))
lhcb2.new("mcs.c34r5.b2", "mcs", at="lhclength-(1662.7547+(231-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246153.0, assembly_id=103167.0))
lhcb2.new("bpm.34r5.b2", "bpm", at="lhclength-(1663.6337+(231-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=246155.0, assembly_id=103168.0))
lhcb2.new("mo.34r5.b2", "mo", at="lhclength-(1664.3847+(231-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2308636.0, assembly_id=103168.0))
lhcb2.new("mq.34r5.b2", "mq", at="lhclength-(1666.3957+(231-ip5ofs.b2)*ds)", from_="ip5", extra=dict(mech_sep=-0.194, slot_id=2307926.0, assembly_id=103168.0))
lhcb2.new("mss.34l6.b2", "mss", at="lhclength-(-1664.0697+(231-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251883.0, assembly_id=103168.0))
lhcb2.new("mcbh.34l6.b2", "mcbh", at="lhclength-(-1663.4767+(231-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251885.0, assembly_id=103168.0))
lhcb2.new("mb.c34l6.b2", "mb", at="lhclength-(-1654.8997+(230.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836634.0, assembly_id=103169.0))
lhcb2.new("mcs.c34l6.b2", "mcs", at="lhclength-(-1647.4757+(230-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246161.0, assembly_id=103169.0))
lhcb2.new("mco.34l6.b2", "mco", at="lhclength-(-1646.7257+(230-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251888.0, assembly_id=103170.0))
lhcb2.new("mcd.34l6.b2", "mcd", at="lhclength-(-1646.7242+(230-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251889.0, assembly_id=103170.0))
lhcb2.new("mb.b34l6.b2", "mb", at="lhclength-(-1639.2397+(229.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836658.0, assembly_id=103170.0))
lhcb2.new("mcs.b34l6.b2", "mcs", at="lhclength-(-1631.8157+(229-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246166.0, assembly_id=103170.0))
lhcb2.new("mb.a34l6.b2", "mb", at="lhclength-(-1623.5797+(228.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836682.0, assembly_id=103171.0))
lhcb2.new("mcs.a34l6.b2", "mcs", at="lhclength-(-1616.1557+(228-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246169.0, assembly_id=103171.0))
lhcb2.new("bpm.33l6.b2", "bpm", at="lhclength-(-1615.2767+(228-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246171.0, assembly_id=103172.0))
lhcb2.new("mo.33l6.b2", "mo", at="lhclength-(-1614.5257+(228-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308608.0, assembly_id=103172.0))
lhcb2.new("mq.33l6.b2", "mq", at="lhclength-(-1612.5147+(228-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307898.0, assembly_id=103172.0))
lhcb2.new("ms.33l6.b2", "ms", at="lhclength-(-1610.6197+(228-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251891.0, assembly_id=103172.0))
lhcb2.new("mcbv.33l6.b2", "mcbv", at="lhclength-(-1610.0267+(228-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251893.0, assembly_id=103172.0))
lhcb2.new("mco.b33l6.b2", "mco", at="lhclength-(-1608.9357+(228-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251896.0, assembly_id=103173.0))
lhcb2.new("mcd.b33l6.b2", "mcd", at="lhclength-(-1608.9342+(228-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251897.0, assembly_id=103173.0))
lhcb2.new("mb.c33l6.b2", "mb", at="lhclength-(-1601.4497+(227.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836706.0, assembly_id=103173.0))
lhcb2.new("mcs.c33l6.b2", "mcs", at="lhclength-(-1594.0257+(227-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246179.0, assembly_id=103173.0))
lhcb2.new("mb.b33l6.b2", "mb", at="lhclength-(-1585.7897+(226.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836730.0, assembly_id=103174.0))
lhcb2.new("mcs.b33l6.b2", "mcs", at="lhclength-(-1578.3657+(226-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246182.0, assembly_id=103174.0))
lhcb2.new("mco.a33l6.b2", "mco", at="lhclength-(-1577.6157+(226-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251900.0, assembly_id=103175.0))
lhcb2.new("mcd.a33l6.b2", "mcd", at="lhclength-(-1577.6142+(226-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251901.0, assembly_id=103175.0))
lhcb2.new("mb.a33l6.b2", "mb", at="lhclength-(-1570.1297+(225.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836754.0, assembly_id=103175.0))
lhcb2.new("mcs.a33l6.b2", "mcs", at="lhclength-(-1562.7057+(225-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246187.0, assembly_id=103175.0))
lhcb2.new("bpm.32l6.b2", "bpm", at="lhclength-(-1561.8267+(225-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246189.0, assembly_id=103176.0))
lhcb2.new("mo.32l6.b2", "mo", at="lhclength-(-1561.0757+(225-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308576.0, assembly_id=103176.0))
lhcb2.new("mq.32l6.b2", "mq", at="lhclength-(-1559.0647+(225-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307868.0, assembly_id=103176.0))
lhcb2.new("mss.32l6.b2", "mss", at="lhclength-(-1557.1697+(225-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251903.0, assembly_id=103176.0))
lhcb2.new("mcbh.32l6.b2", "mcbh", at="lhclength-(-1556.5767+(225-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251905.0, assembly_id=103176.0))
lhcb2.new("mb.c32l6.b2", "mb", at="lhclength-(-1547.9997+(224.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836778.0, assembly_id=103177.0))
lhcb2.new("mcs.c32l6.b2", "mcs", at="lhclength-(-1540.5757+(224-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246195.0, assembly_id=103177.0))
lhcb2.new("mco.32l6.b2", "mco", at="lhclength-(-1539.8257+(224-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251908.0, assembly_id=103178.0))
lhcb2.new("mcd.32l6.b2", "mcd", at="lhclength-(-1539.8242+(224-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251909.0, assembly_id=103178.0))
lhcb2.new("mb.b32l6.b2", "mb", at="lhclength-(-1532.3397+(223.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836802.0, assembly_id=103178.0))
lhcb2.new("mcs.b32l6.b2", "mcs", at="lhclength-(-1524.9157+(223-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246200.0, assembly_id=103178.0))
lhcb2.new("mb.a32l6.b2", "mb", at="lhclength-(-1516.6797+(222.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836826.0, assembly_id=103179.0))
lhcb2.new("mcs.a32l6.b2", "mcs", at="lhclength-(-1509.2557+(222-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246203.0, assembly_id=103179.0))
lhcb2.new("bpm.31l6.b2", "bpm", at="lhclength-(-1508.3767+(222-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246205.0, assembly_id=103180.0))
lhcb2.new("mo.31l6.b2", "mo", at="lhclength-(-1507.6257+(222-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2348500.0, assembly_id=103180.0))
lhcb2.new("mq.31l6.b2", "mq", at="lhclength-(-1505.6147+(222-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308076.0, assembly_id=103180.0))
lhcb2.new("ms.31l6.b2", "ms", at="lhclength-(-1503.7197+(222-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251911.0, assembly_id=103180.0))
lhcb2.new("mcbv.31l6.b2", "mcbv", at="lhclength-(-1503.1267+(222-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251913.0, assembly_id=103180.0))
lhcb2.new("mco.b31l6.b2", "mco", at="lhclength-(-1502.0357+(222-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251916.0, assembly_id=103181.0))
lhcb2.new("mcd.b31l6.b2", "mcd", at="lhclength-(-1502.0342+(222-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251917.0, assembly_id=103181.0))
lhcb2.new("mb.c31l6.b2", "mb", at="lhclength-(-1494.5497+(221.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836850.0, assembly_id=103181.0))
lhcb2.new("mcs.c31l6.b2", "mcs", at="lhclength-(-1487.1257+(221-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246213.0, assembly_id=103181.0))
lhcb2.new("mb.b31l6.b2", "mb", at="lhclength-(-1478.8897+(220.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836874.0, assembly_id=103182.0))
lhcb2.new("mcs.b31l6.b2", "mcs", at="lhclength-(-1471.4657+(220-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246216.0, assembly_id=103182.0))
lhcb2.new("mco.a31l6.b2", "mco", at="lhclength-(-1470.7157+(220-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251920.0, assembly_id=103183.0))
lhcb2.new("mcd.a31l6.b2", "mcd", at="lhclength-(-1470.7142+(220-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251921.0, assembly_id=103183.0))
lhcb2.new("mb.a31l6.b2", "mb", at="lhclength-(-1463.2297+(219.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836898.0, assembly_id=103183.0))
lhcb2.new("mcs.a31l6.b2", "mcs", at="lhclength-(-1455.8057+(219-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246221.0, assembly_id=103183.0))
lhcb2.new("bpm.30l6.b2", "bpm", at="lhclength-(-1454.9267+(219-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246223.0, assembly_id=103184.0))
lhcb2.new("mo.30l6.b2", "mo", at="lhclength-(-1454.1757+(219-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308755.0, assembly_id=103184.0))
lhcb2.new("mq.30l6.b2", "mq", at="lhclength-(-1452.1647+(219-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308046.0, assembly_id=103184.0))
lhcb2.new("ms.30l6.b2", "ms", at="lhclength-(-1450.2697+(219-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251923.0, assembly_id=103184.0))
lhcb2.new("mcbh.30l6.b2", "mcbh", at="lhclength-(-1449.6767+(219-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251925.0, assembly_id=103184.0))
lhcb2.new("mb.c30l6.b2", "mb", at="lhclength-(-1441.0997+(218.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836922.0, assembly_id=103185.0))
lhcb2.new("mcs.c30l6.b2", "mcs", at="lhclength-(-1433.6757+(218-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246229.0, assembly_id=103185.0))
lhcb2.new("mco.30l6.b2", "mco", at="lhclength-(-1432.9257+(218-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251928.0, assembly_id=103186.0))
lhcb2.new("mcd.30l6.b2", "mcd", at="lhclength-(-1432.9242+(218-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251929.0, assembly_id=103186.0))
lhcb2.new("mb.b30l6.b2", "mb", at="lhclength-(-1425.4397+(217.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836946.0, assembly_id=103186.0))
lhcb2.new("mcs.b30l6.b2", "mcs", at="lhclength-(-1418.0157+(217-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246234.0, assembly_id=103186.0))
lhcb2.new("mb.a30l6.b2", "mb", at="lhclength-(-1409.7797+(216.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836970.0, assembly_id=103187.0))
lhcb2.new("mcs.a30l6.b2", "mcs", at="lhclength-(-1402.3557+(216-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246237.0, assembly_id=103187.0))
lhcb2.new("bpm.29l6.b2", "bpm", at="lhclength-(-1401.4767+(216-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246239.0, assembly_id=103188.0))
lhcb2.new("mo.29l6.b2", "mo", at="lhclength-(-1400.7257+(216-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308723.0, assembly_id=103188.0))
lhcb2.new("mq.29l6.b2", "mq", at="lhclength-(-1398.7147+(216-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308017.0, assembly_id=103188.0))
lhcb2.new("ms.29l6.b2", "ms", at="lhclength-(-1396.8197+(216-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251931.0, assembly_id=103188.0))
lhcb2.new("mcbv.29l6.b2", "mcbv", at="lhclength-(-1396.2267+(216-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251933.0, assembly_id=103188.0))
lhcb2.new("mco.b29l6.b2", "mco", at="lhclength-(-1395.1357+(216-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251936.0, assembly_id=103189.0))
lhcb2.new("mcd.b29l6.b2", "mcd", at="lhclength-(-1395.1342+(216-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251937.0, assembly_id=103189.0))
lhcb2.new("mb.c29l6.b2", "mb", at="lhclength-(-1387.6497+(215.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52836994.0, assembly_id=103189.0))
lhcb2.new("mcs.c29l6.b2", "mcs", at="lhclength-(-1380.2257+(215-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246247.0, assembly_id=103189.0))
lhcb2.new("mb.b29l6.b2", "mb", at="lhclength-(-1371.9897+(214.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837018.0, assembly_id=103190.0))
lhcb2.new("mcs.b29l6.b2", "mcs", at="lhclength-(-1364.5657+(214-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246250.0, assembly_id=103190.0))
lhcb2.new("mco.a29l6.b2", "mco", at="lhclength-(-1363.8157+(214-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251940.0, assembly_id=103191.0))
lhcb2.new("mcd.a29l6.b2", "mcd", at="lhclength-(-1363.8142+(214-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251941.0, assembly_id=103191.0))
lhcb2.new("mb.a29l6.b2", "mb", at="lhclength-(-1356.3297+(213.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837042.0, assembly_id=103191.0))
lhcb2.new("mcs.a29l6.b2", "mcs", at="lhclength-(-1348.9057+(213-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246255.0, assembly_id=103191.0))
lhcb2.new("bpm.28l6.b2", "bpm", at="lhclength-(-1348.0267+(213-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246257.0, assembly_id=103192.0))
lhcb2.new("mo.28l6.b2", "mo", at="lhclength-(-1347.2757+(213-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308691.0, assembly_id=103192.0))
lhcb2.new("mq.28l6.b2", "mq", at="lhclength-(-1345.2647+(213-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307985.0, assembly_id=103192.0))
lhcb2.new("mss.28l6.b2", "mss", at="lhclength-(-1343.3697+(213-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251943.0, assembly_id=103192.0))
lhcb2.new("mcbh.28l6.b2", "mcbh", at="lhclength-(-1342.7767+(213-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251945.0, assembly_id=103192.0))
lhcb2.new("mb.c28l6.b2", "mb", at="lhclength-(-1334.1997+(212.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837066.0, assembly_id=103193.0))
lhcb2.new("mcs.c28l6.b2", "mcs", at="lhclength-(-1326.7757+(212-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246263.0, assembly_id=103193.0))
lhcb2.new("mco.28l6.b2", "mco", at="lhclength-(-1326.0257+(212-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251948.0, assembly_id=103194.0))
lhcb2.new("mcd.28l6.b2", "mcd", at="lhclength-(-1326.0242+(212-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251949.0, assembly_id=103194.0))
lhcb2.new("mb.b28l6.b2", "mb", at="lhclength-(-1318.5397+(211.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837090.0, assembly_id=103194.0))
lhcb2.new("mcs.b28l6.b2", "mcs", at="lhclength-(-1311.1157+(211-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246268.0, assembly_id=103194.0))
lhcb2.new("mb.a28l6.b2", "mb", at="lhclength-(-1302.8797+(210.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837114.0, assembly_id=103195.0))
lhcb2.new("mcs.a28l6.b2", "mcs", at="lhclength-(-1295.4557+(210-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246271.0, assembly_id=103195.0))
lhcb2.new("bpm.27l6.b2", "bpm", at="lhclength-(-1294.5767+(210-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246273.0, assembly_id=103196.0))
lhcb2.new("mqs.27l6.b2", "mqs", at="lhclength-(-1293.8227+(210-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307662.0, assembly_id=103196.0))
lhcb2.new("mq.27l6.b2", "mq", at="lhclength-(-1291.8147+(210-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308194.0, assembly_id=103196.0))
lhcb2.new("ms.27l6.b2", "ms", at="lhclength-(-1289.9197+(210-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251951.0, assembly_id=103196.0))
lhcb2.new("mcbv.27l6.b2", "mcbv", at="lhclength-(-1289.3267+(210-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251953.0, assembly_id=103196.0))
lhcb2.new("mco.b27l6.b2", "mco", at="lhclength-(-1288.2357+(210-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251956.0, assembly_id=103197.0))
lhcb2.new("mcd.b27l6.b2", "mcd", at="lhclength-(-1288.2342+(210-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251957.0, assembly_id=103197.0))
lhcb2.new("mb.c27l6.b2", "mb", at="lhclength-(-1280.7497+(209.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837138.0, assembly_id=103197.0))
lhcb2.new("mcs.c27l6.b2", "mcs", at="lhclength-(-1273.3257+(209-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246281.0, assembly_id=103197.0))
lhcb2.new("mb.b27l6.b2", "mb", at="lhclength-(-1265.0897+(208.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837162.0, assembly_id=103198.0))
lhcb2.new("mcs.b27l6.b2", "mcs", at="lhclength-(-1257.6657+(208-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246284.0, assembly_id=103198.0))
lhcb2.new("mco.a27l6.b2", "mco", at="lhclength-(-1256.9157+(208-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251960.0, assembly_id=103199.0))
lhcb2.new("mcd.a27l6.b2", "mcd", at="lhclength-(-1256.9142+(208-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251961.0, assembly_id=103199.0))
lhcb2.new("mb.a27l6.b2", "mb", at="lhclength-(-1249.4297+(207.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837186.0, assembly_id=103199.0))
lhcb2.new("mcs.a27l6.b2", "mcs", at="lhclength-(-1242.0057+(207-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246289.0, assembly_id=103199.0))
lhcb2.new("bpm.26l6.b2", "bpm", at="lhclength-(-1241.1267+(207-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246291.0, assembly_id=103200.0))
lhcb2.new("mo.26l6.b2", "mo", at="lhclength-(-1240.3757+(207-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308902.0, assembly_id=103200.0))
lhcb2.new("mq.26l6.b2", "mq", at="lhclength-(-1238.3647+(207-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2348470.0, assembly_id=103200.0))
lhcb2.new("ms.26l6.b2", "ms", at="lhclength-(-1236.4697+(207-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251963.0, assembly_id=103200.0))
lhcb2.new("mcbh.26l6.b2", "mcbh", at="lhclength-(-1235.8767+(207-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251965.0, assembly_id=103200.0))
lhcb2.new("mb.c26l6.b2", "mb", at="lhclength-(-1227.2997+(206.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837210.0, assembly_id=103201.0))
lhcb2.new("mcs.c26l6.b2", "mcs", at="lhclength-(-1219.8757+(206-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246297.0, assembly_id=103201.0))
lhcb2.new("mco.26l6.b2", "mco", at="lhclength-(-1219.1257+(206-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251968.0, assembly_id=103202.0))
lhcb2.new("mcd.26l6.b2", "mcd", at="lhclength-(-1219.1242+(206-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251969.0, assembly_id=103202.0))
lhcb2.new("mb.b26l6.b2", "mb", at="lhclength-(-1211.6397+(205.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837234.0, assembly_id=103202.0))
lhcb2.new("mcs.b26l6.b2", "mcs", at="lhclength-(-1204.2157+(205-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246302.0, assembly_id=103202.0))
lhcb2.new("mb.a26l6.b2", "mb", at="lhclength-(-1195.9797+(204.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837258.0, assembly_id=103203.0))
lhcb2.new("mcs.a26l6.b2", "mcs", at="lhclength-(-1188.5557+(204-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246305.0, assembly_id=103203.0))
lhcb2.new("bpm.25l6.b2", "bpm", at="lhclength-(-1187.6767+(204-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246307.0, assembly_id=103204.0))
lhcb2.new("mo.25l6.b2", "mo", at="lhclength-(-1186.9257+(204-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308870.0, assembly_id=103204.0))
lhcb2.new("mq.25l6.b2", "mq", at="lhclength-(-1184.9147+(204-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308133.0, assembly_id=103204.0))
lhcb2.new("ms.25l6.b2", "ms", at="lhclength-(-1183.0197+(204-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251971.0, assembly_id=103204.0))
lhcb2.new("mcbv.25l6.b2", "mcbv", at="lhclength-(-1182.4267+(204-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251973.0, assembly_id=103204.0))
lhcb2.new("mco.b25l6.b2", "mco", at="lhclength-(-1181.3357+(204-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251976.0, assembly_id=103205.0))
lhcb2.new("mcd.b25l6.b2", "mcd", at="lhclength-(-1181.3342+(204-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251977.0, assembly_id=103205.0))
lhcb2.new("mb.c25l6.b2", "mb", at="lhclength-(-1173.8497+(203.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837282.0, assembly_id=103205.0))
lhcb2.new("mcs.c25l6.b2", "mcs", at="lhclength-(-1166.4257+(203-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246315.0, assembly_id=103205.0))
lhcb2.new("mb.b25l6.b2", "mb", at="lhclength-(-1158.1897+(202.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837306.0, assembly_id=103206.0))
lhcb2.new("mcs.b25l6.b2", "mcs", at="lhclength-(-1150.7657+(202-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246318.0, assembly_id=103206.0))
lhcb2.new("mco.a25l6.b2", "mco", at="lhclength-(-1150.0157+(202-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251980.0, assembly_id=103207.0))
lhcb2.new("mcd.a25l6.b2", "mcd", at="lhclength-(-1150.0142+(202-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251981.0, assembly_id=103207.0))
lhcb2.new("mb.a25l6.b2", "mb", at="lhclength-(-1142.5297+(201.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837330.0, assembly_id=103207.0))
lhcb2.new("mcs.a25l6.b2", "mcs", at="lhclength-(-1135.1057+(201-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246323.0, assembly_id=103207.0))
lhcb2.new("bpm.24l6.b2", "bpm", at="lhclength-(-1134.2267+(201-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246325.0, assembly_id=103208.0))
lhcb2.new("mo.24l6.b2", "mo", at="lhclength-(-1133.4757+(201-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2348504.0, assembly_id=103208.0))
lhcb2.new("mq.24l6.b2", "mq", at="lhclength-(-1131.4647+(201-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308101.0, assembly_id=103208.0))
lhcb2.new("ms.24l6.b2", "ms", at="lhclength-(-1129.5697+(201-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251983.0, assembly_id=103208.0))
lhcb2.new("mcbh.24l6.b2", "mcbh", at="lhclength-(-1128.9767+(201-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251985.0, assembly_id=103208.0))
lhcb2.new("mb.c24l6.b2", "mb", at="lhclength-(-1120.3997+(200.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837354.0, assembly_id=103209.0))
lhcb2.new("mcs.c24l6.b2", "mcs", at="lhclength-(-1112.9757+(200-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246331.0, assembly_id=103209.0))
lhcb2.new("mco.24l6.b2", "mco", at="lhclength-(-1112.2257+(200-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251988.0, assembly_id=103210.0))
lhcb2.new("mcd.24l6.b2", "mcd", at="lhclength-(-1112.2242+(200-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251989.0, assembly_id=103210.0))
lhcb2.new("mb.b24l6.b2", "mb", at="lhclength-(-1104.7397+(199.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837378.0, assembly_id=103210.0))
lhcb2.new("mcs.b24l6.b2", "mcs", at="lhclength-(-1097.3157+(199-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246336.0, assembly_id=103210.0))
lhcb2.new("mb.a24l6.b2", "mb", at="lhclength-(-1089.0797+(198.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837402.0, assembly_id=103211.0))
lhcb2.new("mcs.a24l6.b2", "mcs", at="lhclength-(-1081.6557+(198-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246339.0, assembly_id=103211.0))
lhcb2.new("bpm.23l6.b2", "bpm", at="lhclength-(-1080.7767+(198-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246341.0, assembly_id=103212.0))
lhcb2.new("mqs.23l6.b2", "mqs", at="lhclength-(-1080.0227+(198-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307631.0, assembly_id=103212.0))
lhcb2.new("mq.23l6.b2", "mq", at="lhclength-(-1078.0147+(198-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308312.0, assembly_id=103212.0))
lhcb2.new("ms.23l6.b2", "ms", at="lhclength-(-1076.1197+(198-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251991.0, assembly_id=103212.0))
lhcb2.new("mcbv.23l6.b2", "mcbv", at="lhclength-(-1075.5267+(198-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251993.0, assembly_id=103212.0))
lhcb2.new("mco.b23l6.b2", "mco", at="lhclength-(-1074.4357+(198-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251996.0, assembly_id=103213.0))
lhcb2.new("mcd.b23l6.b2", "mcd", at="lhclength-(-1074.4342+(198-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=251997.0, assembly_id=103213.0))
lhcb2.new("mb.c23l6.b2", "mb", at="lhclength-(-1066.9497+(197.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837426.0, assembly_id=103213.0))
lhcb2.new("mcs.c23l6.b2", "mcs", at="lhclength-(-1059.5257+(197-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246349.0, assembly_id=103213.0))
lhcb2.new("mb.b23l6.b2", "mb", at="lhclength-(-1051.2897+(196.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837450.0, assembly_id=103214.0))
lhcb2.new("mcs.b23l6.b2", "mcs", at="lhclength-(-1043.8657+(196-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246352.0, assembly_id=103214.0))
lhcb2.new("mco.a23l6.b2", "mco", at="lhclength-(-1043.1157+(196-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252000.0, assembly_id=103215.0))
lhcb2.new("mcd.a23l6.b2", "mcd", at="lhclength-(-1043.1142+(196-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252001.0, assembly_id=103215.0))
lhcb2.new("mb.a23l6.b2", "mb", at="lhclength-(-1035.6297+(195.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837474.0, assembly_id=103215.0))
lhcb2.new("mcs.a23l6.b2", "mcs", at="lhclength-(-1028.2057+(195-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246357.0, assembly_id=103215.0))
lhcb2.new("bpm.22l6.b2", "bpm", at="lhclength-(-1027.3267+(195-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246359.0, assembly_id=103216.0))
lhcb2.new("mo.22l6.b2", "mo", at="lhclength-(-1026.5757+(195-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308809.0, assembly_id=103216.0))
lhcb2.new("mq.22l6.b2", "mq", at="lhclength-(-1024.5647+(195-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308280.0, assembly_id=103216.0))
lhcb2.new("ms.22l6.b2", "ms", at="lhclength-(-1022.6697+(195-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252003.0, assembly_id=103216.0))
lhcb2.new("mcbh.22l6.b2", "mcbh", at="lhclength-(-1022.0767+(195-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252005.0, assembly_id=103216.0))
lhcb2.new("mb.c22l6.b2", "mb", at="lhclength-(-1013.4997+(194.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837498.0, assembly_id=103217.0))
lhcb2.new("mcs.c22l6.b2", "mcs", at="lhclength-(-1006.0757+(194-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246365.0, assembly_id=103217.0))
lhcb2.new("mco.22l6.b2", "mco", at="lhclength-(-1005.3257+(194-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252008.0, assembly_id=103218.0))
lhcb2.new("mcd.22l6.b2", "mcd", at="lhclength-(-1005.3242+(194-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252009.0, assembly_id=103218.0))
lhcb2.new("mb.b22l6.b2", "mb", at="lhclength-(-997.8397+(193.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837522.0, assembly_id=103218.0))
lhcb2.new("mcs.b22l6.b2", "mcs", at="lhclength-(-990.4157+(193-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246370.0, assembly_id=103218.0))
lhcb2.new("mb.a22l6.b2", "mb", at="lhclength-(-982.1797+(192.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837546.0, assembly_id=103219.0))
lhcb2.new("mcs.a22l6.b2", "mcs", at="lhclength-(-974.7557+(192-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246373.0, assembly_id=103219.0))
lhcb2.new("bpm.21l6.b2", "bpm", at="lhclength-(-973.8767+(192-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246375.0, assembly_id=103220.0))
lhcb2.new("mqt.21l6.b2", "mqt", at="lhclength-(-973.1227+(192-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307264.0, assembly_id=103220.0))
lhcb2.new("mq.21l6.b2", "mq", at="lhclength-(-971.1147+(192-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308248.0, assembly_id=103220.0))
lhcb2.new("ms.21l6.b2", "ms", at="lhclength-(-969.2197+(192-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252011.0, assembly_id=103220.0))
lhcb2.new("mcbv.21l6.b2", "mcbv", at="lhclength-(-968.6267+(192-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252013.0, assembly_id=103220.0))
lhcb2.new("mco.b21l6.b2", "mco", at="lhclength-(-967.5357+(192-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252016.0, assembly_id=103221.0))
lhcb2.new("mcd.b21l6.b2", "mcd", at="lhclength-(-967.5342+(192-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252017.0, assembly_id=103221.0))
lhcb2.new("mb.c21l6.b2", "mb", at="lhclength-(-960.0497+(191.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837570.0, assembly_id=103221.0))
lhcb2.new("mcs.c21l6.b2", "mcs", at="lhclength-(-952.6257+(191-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246383.0, assembly_id=103221.0))
lhcb2.new("mb.b21l6.b2", "mb", at="lhclength-(-944.3897+(190.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837594.0, assembly_id=103222.0))
lhcb2.new("mcs.b21l6.b2", "mcs", at="lhclength-(-936.9657+(190-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246386.0, assembly_id=103222.0))
lhcb2.new("mco.a21l6.b2", "mco", at="lhclength-(-936.2157+(190-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252020.0, assembly_id=103223.0))
lhcb2.new("mcd.a21l6.b2", "mcd", at="lhclength-(-936.2142+(190-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252021.0, assembly_id=103223.0))
lhcb2.new("mb.a21l6.b2", "mb", at="lhclength-(-928.7297+(189.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837618.0, assembly_id=103223.0))
lhcb2.new("mcs.a21l6.b2", "mcs", at="lhclength-(-921.3057+(189-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246391.0, assembly_id=103223.0))
lhcb2.new("bpm.20l6.b2", "bpm", at="lhclength-(-920.4267+(189-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246393.0, assembly_id=103224.0))
lhcb2.new("mqt.20l6.b2", "mqt", at="lhclength-(-919.6727+(189-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307467.0, assembly_id=103224.0))
lhcb2.new("mq.20l6.b2", "mq", at="lhclength-(-917.6647+(189-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308218.0, assembly_id=103224.0))
lhcb2.new("ms.20l6.b2", "ms", at="lhclength-(-915.7697+(189-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252023.0, assembly_id=103224.0))
lhcb2.new("mcbh.20l6.b2", "mcbh", at="lhclength-(-915.1767+(189-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252025.0, assembly_id=103224.0))
lhcb2.new("mb.c20l6.b2", "mb", at="lhclength-(-906.5997+(188.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837642.0, assembly_id=103225.0))
lhcb2.new("mcs.c20l6.b2", "mcs", at="lhclength-(-899.1757+(188-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246399.0, assembly_id=103225.0))
lhcb2.new("mco.20l6.b2", "mco", at="lhclength-(-898.4257+(188-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252028.0, assembly_id=103226.0))
lhcb2.new("mcd.20l6.b2", "mcd", at="lhclength-(-898.4242+(188-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252029.0, assembly_id=103226.0))
lhcb2.new("mb.b20l6.b2", "mb", at="lhclength-(-890.9397+(187.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837666.0, assembly_id=103226.0))
lhcb2.new("mcs.b20l6.b2", "mcs", at="lhclength-(-883.5157+(187-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246404.0, assembly_id=103226.0))
lhcb2.new("mb.a20l6.b2", "mb", at="lhclength-(-875.2797+(186.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837690.0, assembly_id=103227.0))
lhcb2.new("mcs.a20l6.b2", "mcs", at="lhclength-(-867.8557+(186-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246407.0, assembly_id=103227.0))
lhcb2.new("bpm.19l6.b2", "bpm", at="lhclength-(-866.9767+(186-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246409.0, assembly_id=103228.0))
lhcb2.new("mqt.19l6.b2", "mqt", at="lhclength-(-866.2227+(186-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307437.0, assembly_id=103228.0))
lhcb2.new("mq.19l6.b2", "mq", at="lhclength-(-864.2147+(186-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308427.0, assembly_id=103228.0))
lhcb2.new("ms.19l6.b2", "ms", at="lhclength-(-862.3197+(186-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252031.0, assembly_id=103228.0))
lhcb2.new("mcbv.19l6.b2", "mcbv", at="lhclength-(-861.7267+(186-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252033.0, assembly_id=103228.0))
lhcb2.new("mco.b19l6.b2", "mco", at="lhclength-(-860.6357+(186-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252036.0, assembly_id=103229.0))
lhcb2.new("mcd.b19l6.b2", "mcd", at="lhclength-(-860.6342+(186-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252037.0, assembly_id=103229.0))
lhcb2.new("mb.c19l6.b2", "mb", at="lhclength-(-853.1497+(185.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837714.0, assembly_id=103229.0))
lhcb2.new("mcs.c19l6.b2", "mcs", at="lhclength-(-845.7257+(185-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246417.0, assembly_id=103229.0))
lhcb2.new("mb.b19l6.b2", "mb", at="lhclength-(-837.4897+(184.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837738.0, assembly_id=103230.0))
lhcb2.new("mcs.b19l6.b2", "mcs", at="lhclength-(-830.0657+(184-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246420.0, assembly_id=103230.0))
lhcb2.new("mco.a19l6.b2", "mco", at="lhclength-(-829.3157+(184-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252040.0, assembly_id=103231.0))
lhcb2.new("mcd.a19l6.b2", "mcd", at="lhclength-(-829.3142+(184-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252041.0, assembly_id=103231.0))
lhcb2.new("mb.a19l6.b2", "mb", at="lhclength-(-821.8297+(183.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837762.0, assembly_id=103231.0))
lhcb2.new("mcs.a19l6.b2", "mcs", at="lhclength-(-814.4057+(183-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246425.0, assembly_id=103231.0))
lhcb2.new("bpm.18l6.b2", "bpm", at="lhclength-(-813.5267+(183-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246427.0, assembly_id=103232.0))
lhcb2.new("mqt.18l6.b2", "mqt", at="lhclength-(-812.7727+(183-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307406.0, assembly_id=103232.0))
lhcb2.new("mq.18l6.b2", "mq", at="lhclength-(-810.7647+(183-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308395.0, assembly_id=103232.0))
lhcb2.new("ms.18l6.b2", "ms", at="lhclength-(-808.8697+(183-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252043.0, assembly_id=103232.0))
lhcb2.new("mcbh.18l6.b2", "mcbh", at="lhclength-(-808.2767+(183-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252045.0, assembly_id=103232.0))
lhcb2.new("mb.c18l6.b2", "mb", at="lhclength-(-799.6997+(182.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837786.0, assembly_id=103233.0))
lhcb2.new("mcs.c18l6.b2", "mcs", at="lhclength-(-792.2757+(182-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246433.0, assembly_id=103233.0))
lhcb2.new("mco.18l6.b2", "mco", at="lhclength-(-791.5257+(182-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252048.0, assembly_id=103234.0))
lhcb2.new("mcd.18l6.b2", "mcd", at="lhclength-(-791.5242+(182-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252049.0, assembly_id=103234.0))
lhcb2.new("mb.b18l6.b2", "mb", at="lhclength-(-784.0397+(181.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837810.0, assembly_id=103234.0))
lhcb2.new("mcs.b18l6.b2", "mcs", at="lhclength-(-776.6157+(181-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246438.0, assembly_id=103234.0))
lhcb2.new("mb.a18l6.b2", "mb", at="lhclength-(-768.3797+(180.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837834.0, assembly_id=103235.0))
lhcb2.new("mcs.a18l6.b2", "mcs", at="lhclength-(-760.9557+(180-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246441.0, assembly_id=103235.0))
lhcb2.new("bpm.17l6.b2", "bpm", at="lhclength-(-760.0767+(180-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246443.0, assembly_id=103236.0))
lhcb2.new("mqt.17l6.b2", "mqt", at="lhclength-(-759.3227+(180-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307374.0, assembly_id=103236.0))
lhcb2.new("mq.17l6.b2", "mq", at="lhclength-(-757.3147+(180-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2348481.0, assembly_id=103236.0))
lhcb2.new("ms.17l6.b2", "ms", at="lhclength-(-755.4197+(180-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252051.0, assembly_id=103236.0))
lhcb2.new("mcbv.17l6.b2", "mcbv", at="lhclength-(-754.8267+(180-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252053.0, assembly_id=103236.0))
lhcb2.new("mco.b17l6.b2", "mco", at="lhclength-(-753.7357+(180-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252056.0, assembly_id=103237.0))
lhcb2.new("mcd.b17l6.b2", "mcd", at="lhclength-(-753.7342+(180-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252057.0, assembly_id=103237.0))
lhcb2.new("mb.c17l6.b2", "mb", at="lhclength-(-746.2497+(179.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837858.0, assembly_id=103237.0))
lhcb2.new("mcs.c17l6.b2", "mcs", at="lhclength-(-738.8257+(179-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246451.0, assembly_id=103237.0))
lhcb2.new("mb.b17l6.b2", "mb", at="lhclength-(-730.5897+(178.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837882.0, assembly_id=103238.0))
lhcb2.new("mcs.b17l6.b2", "mcs", at="lhclength-(-723.1657+(178-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246454.0, assembly_id=103238.0))
lhcb2.new("mco.a17l6.b2", "mco", at="lhclength-(-722.4157+(178-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252060.0, assembly_id=103239.0))
lhcb2.new("mcd.a17l6.b2", "mcd", at="lhclength-(-722.4142+(178-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252061.0, assembly_id=103239.0))
lhcb2.new("mb.a17l6.b2", "mb", at="lhclength-(-714.9297+(177.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837906.0, assembly_id=103239.0))
lhcb2.new("mcs.a17l6.b2", "mcs", at="lhclength-(-707.5057+(177-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246459.0, assembly_id=103239.0))
lhcb2.new("bpm.16l6.b2", "bpm", at="lhclength-(-706.6267+(177-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246461.0, assembly_id=103240.0))
lhcb2.new("mqt.16l6.b2", "mqt", at="lhclength-(-705.8727+(177-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307581.0, assembly_id=103240.0))
lhcb2.new("mq.16l6.b2", "mq", at="lhclength-(-703.8647+(177-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308336.0, assembly_id=103240.0))
lhcb2.new("ms.16l6.b2", "ms", at="lhclength-(-701.9697+(177-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252063.0, assembly_id=103240.0))
lhcb2.new("mcbh.16l6.b2", "mcbh", at="lhclength-(-701.3767+(177-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252065.0, assembly_id=103240.0))
lhcb2.new("mb.c16l6.b2", "mb", at="lhclength-(-692.7997+(176.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837930.0, assembly_id=103241.0))
lhcb2.new("mcs.c16l6.b2", "mcs", at="lhclength-(-685.3757+(176-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246467.0, assembly_id=103241.0))
lhcb2.new("mco.16l6.b2", "mco", at="lhclength-(-684.6257+(176-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252068.0, assembly_id=103242.0))
lhcb2.new("mcd.16l6.b2", "mcd", at="lhclength-(-684.6242+(176-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252069.0, assembly_id=103242.0))
lhcb2.new("mb.b16l6.b2", "mb", at="lhclength-(-677.1397+(175.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837954.0, assembly_id=103242.0))
lhcb2.new("mcs.b16l6.b2", "mcs", at="lhclength-(-669.7157+(175-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246472.0, assembly_id=103242.0))
lhcb2.new("mb.a16l6.b2", "mb", at="lhclength-(-661.4797+(174.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52837978.0, assembly_id=103243.0))
lhcb2.new("mcs.a16l6.b2", "mcs", at="lhclength-(-654.0557+(174-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246475.0, assembly_id=103243.0))
lhcb2.new("bpm.15l6.b2", "bpm", at="lhclength-(-653.1767+(174-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246477.0, assembly_id=103244.0))
lhcb2.new("mqt.15l6.b2", "mqt", at="lhclength-(-652.4227+(174-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307550.0, assembly_id=103244.0))
lhcb2.new("mq.15l6.b2", "mq", at="lhclength-(-650.4147+(174-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308542.0, assembly_id=103244.0))
lhcb2.new("ms.15l6.b2", "ms", at="lhclength-(-648.5197+(174-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252071.0, assembly_id=103244.0))
lhcb2.new("mcbv.15l6.b2", "mcbv", at="lhclength-(-647.9267+(174-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252073.0, assembly_id=103244.0))
lhcb2.new("mco.b15l6.b2", "mco", at="lhclength-(-646.8357+(174-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252076.0, assembly_id=103245.0))
lhcb2.new("mcd.b15l6.b2", "mcd", at="lhclength-(-646.8342+(174-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252077.0, assembly_id=103245.0))
lhcb2.new("mb.c15l6.b2", "mb", at="lhclength-(-639.3497+(173.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838002.0, assembly_id=103245.0))
lhcb2.new("mcs.c15l6.b2", "mcs", at="lhclength-(-631.9257+(173-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246485.0, assembly_id=103245.0))
lhcb2.new("mb.b15l6.b2", "mb", at="lhclength-(-623.6897+(172.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838026.0, assembly_id=103246.0))
lhcb2.new("mcs.b15l6.b2", "mcs", at="lhclength-(-616.2657+(172-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246488.0, assembly_id=103246.0))
lhcb2.new("mco.a15l6.b2", "mco", at="lhclength-(-615.5157+(172-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252080.0, assembly_id=103247.0))
lhcb2.new("mcd.a15l6.b2", "mcd", at="lhclength-(-615.5142+(172-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252081.0, assembly_id=103247.0))
lhcb2.new("mb.a15l6.b2", "mb", at="lhclength-(-608.0297+(171.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838050.0, assembly_id=103247.0))
lhcb2.new("mcs.a15l6.b2", "mcs", at="lhclength-(-600.6057+(171-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246493.0, assembly_id=103247.0))
lhcb2.new("bpm.14l6.b2", "bpm", at="lhclength-(-599.7267+(171-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246495.0, assembly_id=103248.0))
lhcb2.new("mqt.14l6.b2", "mqt", at="lhclength-(-598.9727+(171-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307518.0, assembly_id=103248.0))
lhcb2.new("mq.14l6.b2", "mq", at="lhclength-(-596.9647+(171-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308513.0, assembly_id=103248.0))
lhcb2.new("ms.14l6.b2", "ms", at="lhclength-(-595.0697+(171-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252083.0, assembly_id=103248.0))
lhcb2.new("mcbh.14l6.b2", "mcbh", at="lhclength-(-594.4767+(171-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252085.0, assembly_id=103248.0))
lhcb2.new("mb.c14l6.b2", "mb", at="lhclength-(-585.8997+(170.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838074.0, assembly_id=103249.0))
lhcb2.new("mcs.c14l6.b2", "mcs", at="lhclength-(-578.4757+(170-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246501.0, assembly_id=103249.0))
lhcb2.new("mco.14l6.b2", "mco", at="lhclength-(-577.7257+(170-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252088.0, assembly_id=103250.0))
lhcb2.new("mcd.14l6.b2", "mcd", at="lhclength-(-577.7242+(170-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252089.0, assembly_id=103250.0))
lhcb2.new("mb.b14l6.b2", "mb", at="lhclength-(-570.2397+(169.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838098.0, assembly_id=103250.0))
lhcb2.new("mcs.b14l6.b2", "mcs", at="lhclength-(-562.8157+(169-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246506.0, assembly_id=103250.0))
lhcb2.new("mb.a14l6.b2", "mb", at="lhclength-(-554.5797+(168.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838122.0, assembly_id=103251.0))
lhcb2.new("mcs.a14l6.b2", "mcs", at="lhclength-(-547.1557+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246509.0, assembly_id=103251.0))
lhcb2.new("s.ds.l6.b2", "omk", at="lhclength-(-546.7497+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.13l6.b2", "bpm", at="lhclength-(-546.2767+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246511.0, assembly_id=103252.0))
lhcb2.new("mqt.13l6.b2", "mqt", at="lhclength-(-545.5227+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2348451.0, assembly_id=103252.0))
lhcb2.new("mq.13l6.b2", "mq", at="lhclength-(-543.5147+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308483.0, assembly_id=103252.0))
lhcb2.new("ms.13l6.b2", "ms", at="lhclength-(-541.6197+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252091.0, assembly_id=103252.0))
lhcb2.new("mcbv.13l6.b2", "mcbv", at="lhclength-(-541.0267+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252093.0, assembly_id=103252.0))
lhcb2.new("mco.b13l6.b2", "mco", at="lhclength-(-539.9357+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252096.0, assembly_id=103253.0))
lhcb2.new("mcd.b13l6.b2", "mcd", at="lhclength-(-539.9342+(168-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252097.0, assembly_id=103253.0))
lhcb2.new("mb.c13l6.b2", "mb", at="lhclength-(-532.4497+(167.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838146.0, assembly_id=103253.0))
lhcb2.new("mcs.c13l6.b2", "mcs", at="lhclength-(-525.0257+(167-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246519.0, assembly_id=103253.0))
lhcb2.new("mb.b13l6.b2", "mb", at="lhclength-(-516.7897+(166.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838170.0, assembly_id=103254.0))
lhcb2.new("mcs.b13l6.b2", "mcs", at="lhclength-(-509.3657+(166-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246522.0, assembly_id=103254.0))
lhcb2.new("mco.a13l6.b2", "mco", at="lhclength-(-508.6157+(166-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252100.0, assembly_id=103255.0))
lhcb2.new("mcd.a13l6.b2", "mcd", at="lhclength-(-508.6142+(166-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252101.0, assembly_id=103255.0))
lhcb2.new("mb.a13l6.b2", "mb", at="lhclength-(-501.1297+(165.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838194.0, assembly_id=103255.0))
lhcb2.new("mcs.a13l6.b2", "mcs", at="lhclength-(-493.7057+(165-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246527.0, assembly_id=103255.0))
lhcb2.new("bpm.12l6.b2", "bpm", at="lhclength-(-492.8267+(165-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246529.0, assembly_id=103256.0))
lhcb2.new("mqt.12l6.b2", "mqt", at="lhclength-(-492.0727+(165-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307694.0, assembly_id=103256.0))
lhcb2.new("mq.12l6.b2", "mq", at="lhclength-(-490.0647+(165-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308453.0, assembly_id=103256.0))
lhcb2.new("ms.12l6.b2", "ms", at="lhclength-(-488.1697+(165-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252103.0, assembly_id=103256.0))
lhcb2.new("mcbh.12l6.b2", "mcbh", at="lhclength-(-487.5767+(165-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252105.0, assembly_id=103256.0))
lhcb2.new("mb.c12l6.b2", "mb", at="lhclength-(-478.9997+(164.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838218.0, assembly_id=103257.0))
lhcb2.new("mcs.c12l6.b2", "mcs", at="lhclength-(-471.5757+(164-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246535.0, assembly_id=103257.0))
lhcb2.new("mco.12l6.b2", "mco", at="lhclength-(-470.8257+(164-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252108.0, assembly_id=103258.0))
lhcb2.new("mcd.12l6.b2", "mcd", at="lhclength-(-470.8242+(164-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252109.0, assembly_id=103258.0))
lhcb2.new("mb.b12l6.b2", "mb", at="lhclength-(-463.3397+(163.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838242.0, assembly_id=103258.0))
lhcb2.new("mcs.b12l6.b2", "mcs", at="lhclength-(-455.9157+(163-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246540.0, assembly_id=103258.0))
lhcb2.new("mb.a12l6.b2", "mb", at="lhclength-(-447.6797+(162.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838266.0, assembly_id=103259.0))
lhcb2.new("mcs.a12l6.b2", "mcs", at="lhclength-(-440.2557+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246543.0, assembly_id=103259.0))
lhcb2.new("e.arc.56.b2", "omk", at="lhclength-(-439.8497+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.11l6.b2", "bpm", at="lhclength-(-439.3767+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246545.0, assembly_id=103260.0))
lhcb2.new("mq.11l6.b2", "mq", at="lhclength-(-436.8297+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308660.0, assembly_id=103260.0))
lhcb2.new("mqtli.11l6.b2", "mqtli", at="lhclength-(-434.4607+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307348.0, assembly_id=103260.0))
lhcb2.new("ms.11l6.b2", "ms", at="lhclength-(-433.4487+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252111.0, assembly_id=103260.0))
lhcb2.new("mcbv.11l6.b2", "mcbv", at="lhclength-(-432.8557+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252113.0, assembly_id=103260.0))
lhcb2.new("lebr.11l6.b2", "lebr", at="lhclength-(-425.71735+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52997694.0, assembly_id=103261.0))
lhcb2.new("mco.11l6.b2", "mco", at="lhclength-(-418.986+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252116.0, assembly_id=103262.0))
lhcb2.new("mcd.11l6.b2", "mcd", at="lhclength-(-418.9845+(162-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252117.0, assembly_id=103262.0))
lhcb2.new("mb.b11l6.b2", "mb", at="lhclength-(-411.5+(161.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838290.0, assembly_id=103262.0))
lhcb2.new("mcs.b11l6.b2", "mcs", at="lhclength-(-404.076+(161-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246553.0, assembly_id=103262.0))
lhcb2.new("mb.a11l6.b2", "mb", at="lhclength-(-395.84+(160.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838314.0, assembly_id=103263.0))
lhcb2.new("mcs.a11l6.b2", "mcs", at="lhclength-(-388.416+(160-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246556.0, assembly_id=103263.0))
lhcb2.new("bpm.10l6.b2", "bpm", at="lhclength-(-387.537+(160-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246558.0, assembly_id=103264.0))
lhcb2.new("mqml.10l6.b2", "mqml", at="lhclength-(-384.392+(160-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307813.0, assembly_id=103264.0))
lhcb2.new("mcbch.10l6.b2", "mcbch", at="lhclength-(-381.35+(160-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252118.0, assembly_id=103264.0))
lhcb2.new("mco.10l6.b2", "mco", at="lhclength-(-379.921+(160-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252122.0, assembly_id=103265.0))
lhcb2.new("mcd.10l6.b2", "mcd", at="lhclength-(-379.9195+(160-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252123.0, assembly_id=103265.0))
lhcb2.new("mb.b10l6.b2", "mb", at="lhclength-(-372.435+(159.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838338.0, assembly_id=103265.0))
lhcb2.new("mcs.b10l6.b2", "mcs", at="lhclength-(-365.011+(159-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246565.0, assembly_id=103265.0))
lhcb2.new("mb.a10l6.b2", "mb", at="lhclength-(-356.775+(158.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838362.0, assembly_id=103266.0))
lhcb2.new("mcs.a10l6.b2", "mcs", at="lhclength-(-349.351+(158-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246568.0, assembly_id=103266.0))
lhcb2.new("bpm.9l6.b2", "bpm", at="lhclength-(-348.471+(158-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246570.0, assembly_id=103267.0))
lhcb2.new("mqmc.9l6.b2", "mqmc", at="lhclength-(-346.495+(158-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307790.0, assembly_id=103267.0))
lhcb2.new("mqm.9l6.b2", "mqm", at="lhclength-(-343.229+(158-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307738.0, assembly_id=103267.0))
lhcb2.new("mcbcv.9l6.b2", "mcbcv", at="lhclength-(-340.888+(158-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252124.0, assembly_id=103267.0))
lhcb2.new("mco.9l6.b2", "mco", at="lhclength-(-339.456+(158-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252128.0, assembly_id=103268.0))
lhcb2.new("mcd.9l6.b2", "mcd", at="lhclength-(-339.4545+(158-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252129.0, assembly_id=103268.0))
lhcb2.new("mb.b9l6.b2", "mb", at="lhclength-(-331.97+(157.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838386.0, assembly_id=103268.0))
lhcb2.new("mcs.b9l6.b2", "mcs", at="lhclength-(-324.546+(157-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246578.0, assembly_id=103268.0))
lhcb2.new("mb.a9l6.b2", "mb", at="lhclength-(-316.31+(156.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838410.0, assembly_id=103269.0))
lhcb2.new("mcs.a9l6.b2", "mcs", at="lhclength-(-308.886+(156-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246581.0, assembly_id=103269.0))
lhcb2.new("bpm.8l6.b2", "bpm", at="lhclength-(-308.007+(156-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=378005.0, assembly_id=103270.0))
lhcb2.new("mqml.8l6.b2", "mqml", at="lhclength-(-304.862+(156-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307845.0, assembly_id=103270.0))
lhcb2.new("mcbch.8l6.b2", "mcbch", at="lhclength-(-301.82+(156-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=378117.0, assembly_id=103270.0))
lhcb2.new("mco.8l6.b2", "mco", at="lhclength-(-300.391+(156-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252134.0, assembly_id=103271.0))
lhcb2.new("mcd.8l6.b2", "mcd", at="lhclength-(-300.3895+(156-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252135.0, assembly_id=103271.0))
lhcb2.new("mb.b8l6.b2", "mb", at="lhclength-(-292.905+(155.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838434.0, assembly_id=103271.0))
lhcb2.new("mcs.b8l6.b2", "mcs", at="lhclength-(-285.481+(155-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246590.0, assembly_id=103271.0))
lhcb2.new("mb.a8l6.b2", "mb", at="lhclength-(-277.245+(154.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838458.0, assembly_id=103272.0))
lhcb2.new("mcs.a8l6.b2", "mcs", at="lhclength-(-269.821+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246593.0, assembly_id=103272.0))
lhcb2.new("e.ds.l6.b2", "omk", at="lhclength-(-269.415+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(slot_id=100932.0))
lhcb2.new("lejl.5l6.b2", "lejl", at="lhclength-(-264.355+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52997982.0, assembly_id=791286.0))
lhcb2.new("dfbak.5l6.b2", "dfbak", at="lhclength-(-258.2075+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52996791.0, assembly_id=104686.0))
lhcb2.new("bpmyb.5l6.b2", "bpmyb", at="lhclength-(-210.918+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=298233.0, assembly_id=103273.0))
lhcb2.new("mqy.5l6.b2", "mqy", at="lhclength-(-208.2+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2303185.0, assembly_id=103273.0))
lhcb2.new("mcbyv.5l6.b2", "mcbyv", at="lhclength-(-205.853+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252136.0, assembly_id=103273.0))
lhcb2.new("bpmya.4l6.b2", "bpmya", at="lhclength-(-174.518+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246599.0, assembly_id=103275.0))
lhcb2.new("mqy.4l6.b2", "mqy", at="lhclength-(-171.8+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=241848.0, assembly_id=103275.0))
lhcb2.new("mcbyh.4l6.b2", "mcbyh", at="lhclength-(-169.453+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252138.0, assembly_id=103275.0))
lhcb2.new("tcdqm.b4l6.b2", "tcdqm", at="lhclength-(-166.448+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52998764.0, assembly_id=377626.0))
lhcb2.new("tcdqm.a4l6.b2", "tcdqm", at="lhclength-(-165.098+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52998812.0, assembly_id=829888.0))
lhcb2.new("bptdh.a4l6.b2", "bptdh", at="lhclength-(-154.845+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=10338545.0, assembly_id=377627.0))
lhcb2.new("tcsp.a4l6.b2", "tcsp", at="lhclength-(-154.25+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=377627.0))
lhcb2.new("bptuh.a4l6.b2", "bptuh", at="lhclength-(-153.655+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=10338547.0, assembly_id=377627.0))
lhcb2.new("tcdqa.b4l6.b2", "tcdqa", at="lhclength-(-150.34+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.214, slot_id=629257.0, assembly_id=103278.0))
lhcb2.new("tcdqa.c4l6.b2", "tcdqa", at="lhclength-(-146.79+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.214, slot_id=6030079.0, assembly_id=6030066.0))
lhcb2.new("tcdqa.a4l6.b2", "tcdqa", at="lhclength-(-143.24+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.214, slot_id=629263.0, assembly_id=616959.0))
lhcb2.new("bpmsi.b4l6.b2_itlk", "bpmsi002", at="lhclength-(-140.1975+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=14305625.0, assembly_id=377628.0))
lhcb2.new("bpmsi.a4l6.b2_itlk", "bpmsi002", at="lhclength-(-139.5625+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=14305627.0, assembly_id=377629.0))
lhcb2.new("bpmsa.4l6.b2", "bpmsa", at="lhclength-(-46.3025+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=377632.0))
lhcb2.new("msdc.e4l6.b2", "msdc", at="lhclength-(-34.37+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.2041, slot_id=134592.0))
lhcb2.new("msdc.d4l6.b2", "msdc", at="lhclength-(-29.46+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.2018, slot_id=134594.0))
lhcb2.new("msdc.c4l6.b2", "msdc", at="lhclength-(-24.55+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1995, slot_id=134596.0))
lhcb2.new("msdc.b4l6.b2", "msdc", at="lhclength-(-19.64+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1972, slot_id=134598.0))
lhcb2.new("msdc.a4l6.b2", "msdc", at="lhclength-(-14.73+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1949, slot_id=134599.0))
lhcb2.new("msdb.c4l6.b2", "msdb", at="lhclength-(-9.82+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.2007, slot_id=134602.0))
lhcb2.new("msdb.b4l6.b2", "msdb", at="lhclength-(-4.91+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1988, slot_id=134603.0))
lhcb2.new("msdb2.4l6.b2", "msdb2", at="lhclength-(-1.022+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1972, slot_id=52895942.0, assembly_id=134606.0))
lhcb2.new("ip6", "omk", at="lhclength-(pip6+ip6ofs.b2*ds)")
lhcb2.new("msdb2.4r6.b2", "msdb2", at="lhclength-(1.022+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1964, slot_id=52895971.0, assembly_id=134606.0))
lhcb2.new("msdb.a4r6.b2", "msdb", at="lhclength-(4.91+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1948, slot_id=134607.0))
lhcb2.new("msdb.b4r6.b2", "msdb", at="lhclength-(9.82+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1929, slot_id=134609.0))
lhcb2.new("msda.a4r6.b2", "msda", at="lhclength-(14.73+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1971, slot_id=134611.0))
lhcb2.new("msda.b4r6.b2", "msda", at="lhclength-(19.64+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1952, slot_id=134614.0))
lhcb2.new("msda.c4r6.b2", "msda", at="lhclength-(24.55+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1932, slot_id=134616.0))
lhcb2.new("msda.d4r6.b2", "msda", at="lhclength-(29.46+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1912, slot_id=134618.0))
lhcb2.new("msda.e4r6.b2", "msda", at="lhclength-(34.37+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.1893, slot_id=134619.0))
lhcb2.new("tcdsb.4r6.b2", "tcdsb", at="lhclength-(38.825+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.2461, slot_id=631494.0, assembly_id=103281.0))
lhcb2.new("tcdsa.4r6.b2", "tcdsa", at="lhclength-(42.375+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.245, slot_id=631490.0, assembly_id=616849.0))
lhcb2.new("btvse.a4r6.b2", "btvse", at="lhclength-(44.575+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.244, slot_id=181627.0))
lhcb2.new("bpmse.4r6.b2", "bpmse", at="lhclength-(45.2675+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.244, slot_id=181628.0))
lhcb2.new("bpmsx.a4r6.b2", "bpmsx004", at="lhclength-(138.3925+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=377634.0))
lhcb2.new("bpmsx.a4r6.b2_itlk", "bpmsx002", at="lhclength-(138.3925+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=14271450.0, assembly_id=377634.0))
lhcb2.new("bpmsx.b4r6.b2", "bpmsx004", at="lhclength-(138.9775+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=377635.0))
lhcb2.new("bpmsx.b4r6.b2_itlk", "bpmsx002", at="lhclength-(138.9775+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=14271452.0, assembly_id=377635.0))
lhcb2.new("tcdqm.a4r6.b2", "tcdqm", at="lhclength-(165.098+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52998836.0, assembly_id=829889.0))
lhcb2.new("tcdqm.b4r6.b2", "tcdqm", at="lhclength-(166.448+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52998788.0, assembly_id=377639.0))
lhcb2.new("bpmyb.4r6.b2", "bpmyb", at="lhclength-(169.082+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=298235.0, assembly_id=103285.0))
lhcb2.new("mqy.4r6.b2", "mqy", at="lhclength-(171.8+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2303140.0, assembly_id=103285.0))
lhcb2.new("mcbyv.4r6.b2", "mcbyv", at="lhclength-(174.147+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252140.0, assembly_id=103285.0))
lhcb2.new("mkd.a5r6.b2", "mkd", at="lhclength-(177.0995+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134623.0))
lhcb2.new("mkd.b5r6.b2", "mkd", at="lhclength-(178.8025+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134624.0))
lhcb2.new("mkd.c5r6.b2", "mkd", at="lhclength-(180.7855+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134625.0))
lhcb2.new("mkd.d5r6.b2", "mkd", at="lhclength-(182.4885+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134626.0))
lhcb2.new("mkd.e5r6.b2", "mkd", at="lhclength-(184.4715+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134627.0))
lhcb2.new("mkd.f5r6.b2", "mkd", at="lhclength-(186.3295+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134628.0))
lhcb2.new("mkd.g5r6.b2", "mkd", at="lhclength-(188.3125+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134629.0))
lhcb2.new("mkd.h5r6.b2", "mkd", at="lhclength-(190.0155+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134630.0))
lhcb2.new("mkd.i5r6.b2", "mkd", at="lhclength-(191.7185+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134631.0))
lhcb2.new("mkd.j5r6.b2", "mkd", at="lhclength-(193.7015+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134632.0))
lhcb2.new("mkd.k5r6.b2", "mkd", at="lhclength-(195.5595+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134633.0))
lhcb2.new("mkd.l5r6.b2", "mkd", at="lhclength-(197.5425+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134634.0))
lhcb2.new("mkd.m5r6.b2", "mkd", at="lhclength-(199.2455+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134635.0))
lhcb2.new("mkd.n5r6.b2", "mkd", at="lhclength-(201.2285+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134636.0))
lhcb2.new("mkd.o5r6.b2", "mkd", at="lhclength-(202.9315+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=134637.0))
lhcb2.new("bpmya.5r6.b2", "bpmya", at="lhclength-(205.482+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246611.0, assembly_id=103287.0))
lhcb2.new("mqy.5r6.b2", "mqy", at="lhclength-(208.2+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2302996.0, assembly_id=103287.0))
lhcb2.new("mcbyh.5r6.b2", "mcbyh", at="lhclength-(210.547+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252142.0, assembly_id=103287.0))
lhcb2.new("dfbal.5r6.b2", "dfbal", at="lhclength-(268.0775+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52996815.0, assembly_id=104687.0))
lhcb2.new("s.ds.r6.b2", "omk", at="lhclength-(269.415+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(slot_id=100932.0))
lhcb2.new("mco.8r6.b2", "mco", at="lhclength-(269.759+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252146.0, assembly_id=103288.0))
lhcb2.new("mcd.8r6.b2", "mcd", at="lhclength-(269.7605+(154-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252147.0, assembly_id=103288.0))
lhcb2.new("mb.a8r6.b2", "mb", at="lhclength-(277.245+(153.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838482.0, assembly_id=103288.0))
lhcb2.new("mcs.a8r6.b2", "mcs", at="lhclength-(284.669+(153-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246618.0, assembly_id=103288.0))
lhcb2.new("mb.b8r6.b2", "mb", at="lhclength-(292.905+(152.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838506.0, assembly_id=103289.0))
lhcb2.new("mcs.b8r6.b2", "mcs", at="lhclength-(300.329+(152-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246621.0, assembly_id=103289.0))
lhcb2.new("bpm.8r6.b2", "bpm", at="lhclength-(301.208+(152-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246623.0, assembly_id=103290.0))
lhcb2.new("mqml.8r6.b2", "mqml", at="lhclength-(304.353+(152-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307618.0, assembly_id=103290.0))
lhcb2.new("mcbcv.8r6.b2", "mcbcv", at="lhclength-(307.395+(152-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252148.0, assembly_id=103290.0))
lhcb2.new("mco.9r6.b2", "mco", at="lhclength-(308.824+(152-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252152.0, assembly_id=103291.0))
lhcb2.new("mcd.9r6.b2", "mcd", at="lhclength-(308.8255+(152-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252153.0, assembly_id=103291.0))
lhcb2.new("mb.a9r6.b2", "mb", at="lhclength-(316.31+(151.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838530.0, assembly_id=103291.0))
lhcb2.new("mcs.a9r6.b2", "mcs", at="lhclength-(323.734+(151-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246630.0, assembly_id=103291.0))
lhcb2.new("mb.b9r6.b2", "mb", at="lhclength-(331.97+(150.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52849690.0, assembly_id=103292.0))
lhcb2.new("mcs.b9r6.b2", "mcs", at="lhclength-(339.394+(150-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=357323.0, assembly_id=103292.0))
lhcb2.new("bpm.9r6.b2", "bpm", at="lhclength-(340.274+(150-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246635.0, assembly_id=103293.0))
lhcb2.new("mqmc.9r6.b2", "mqmc", at="lhclength-(342.25+(150-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307801.0, assembly_id=103293.0))
lhcb2.new("mqm.9r6.b2", "mqm", at="lhclength-(345.516+(150-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307749.0, assembly_id=103293.0))
lhcb2.new("mcbch.9r6.b2", "mcbch", at="lhclength-(347.857+(150-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252154.0, assembly_id=103293.0))
lhcb2.new("mco.10r6.b2", "mco", at="lhclength-(349.289+(150-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252158.0, assembly_id=103294.0))
lhcb2.new("mcd.10r6.b2", "mcd", at="lhclength-(349.2905+(150-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252159.0, assembly_id=103294.0))
lhcb2.new("mb.a10r6.b2", "mb", at="lhclength-(356.775+(149.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838554.0, assembly_id=103294.0))
lhcb2.new("mcs.a10r6.b2", "mcs", at="lhclength-(364.199+(149-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246643.0, assembly_id=103294.0))
lhcb2.new("mb.b10r6.b2", "mb", at="lhclength-(372.435+(148.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838578.0, assembly_id=103295.0))
lhcb2.new("mcs.b10r6.b2", "mcs", at="lhclength-(379.859+(148-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246646.0, assembly_id=103295.0))
lhcb2.new("bpm.10r6.b2", "bpm", at="lhclength-(380.738+(148-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246648.0, assembly_id=103296.0))
lhcb2.new("mqml.10r6.b2", "mqml", at="lhclength-(383.883+(148-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307825.0, assembly_id=103296.0))
lhcb2.new("mcbcv.10r6.b2", "mcbcv", at="lhclength-(386.925+(148-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252160.0, assembly_id=103296.0))
lhcb2.new("mco.11r6.b2", "mco", at="lhclength-(388.354+(148-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252164.0, assembly_id=103297.0))
lhcb2.new("mcd.11r6.b2", "mcd", at="lhclength-(388.3555+(148-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252165.0, assembly_id=103297.0))
lhcb2.new("mb.a11r6.b2", "mb", at="lhclength-(395.84+(147.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838602.0, assembly_id=103297.0))
lhcb2.new("mcs.a11r6.b2", "mcs", at="lhclength-(403.264+(147-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246655.0, assembly_id=103297.0))
lhcb2.new("mb.b11r6.b2", "mb", at="lhclength-(411.5+(146.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838626.0, assembly_id=103298.0))
lhcb2.new("mcs.b11r6.b2", "mcs", at="lhclength-(418.924+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246658.0, assembly_id=103298.0))
lhcb2.new("lear.11r6.b2", "lear", at="lhclength-(425.71735+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52997622.0, assembly_id=103299.0))
lhcb2.new("bpm.11r6.b2", "bpm", at="lhclength-(432.5777+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246660.0, assembly_id=103300.0))
lhcb2.new("mq.11r6.b2", "mq", at="lhclength-(435.1247+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308675.0, assembly_id=103300.0))
lhcb2.new("mqtli.11r6.b2", "mqtli", at="lhclength-(437.4937+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307363.0, assembly_id=103300.0))
lhcb2.new("ms.11r6.b2", "ms", at="lhclength-(438.5057+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252167.0, assembly_id=103300.0))
lhcb2.new("mcbh.11r6.b2", "mcbh", at="lhclength-(439.0987+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252169.0, assembly_id=103300.0))
lhcb2.new("s.arc.67.b2", "omk", at="lhclength-(439.8497+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a12r6.b2", "mco", at="lhclength-(440.1937+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252172.0, assembly_id=103301.0))
lhcb2.new("mcd.a12r6.b2", "mcd", at="lhclength-(440.1952+(146-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252173.0, assembly_id=103301.0))
lhcb2.new("mb.a12r6.b2", "mb", at="lhclength-(447.6797+(145.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838650.0, assembly_id=103301.0))
lhcb2.new("mcs.a12r6.b2", "mcs", at="lhclength-(455.1037+(145-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246668.0, assembly_id=103301.0))
lhcb2.new("mb.b12r6.b2", "mb", at="lhclength-(463.3397+(144.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838674.0, assembly_id=103302.0))
lhcb2.new("mcs.b12r6.b2", "mcs", at="lhclength-(470.7637+(144-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246671.0, assembly_id=103302.0))
lhcb2.new("mco.b12r6.b2", "mco", at="lhclength-(471.5137+(144-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252176.0, assembly_id=103303.0))
lhcb2.new("mcd.b12r6.b2", "mcd", at="lhclength-(471.5152+(144-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252177.0, assembly_id=103303.0))
lhcb2.new("mb.c12r6.b2", "mb", at="lhclength-(478.9997+(143.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838698.0, assembly_id=103303.0))
lhcb2.new("mcs.c12r6.b2", "mcs", at="lhclength-(486.4237+(143-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246676.0, assembly_id=103303.0))
lhcb2.new("bpm.12r6.b2", "bpm", at="lhclength-(487.3027+(143-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246678.0, assembly_id=103304.0))
lhcb2.new("mqt.12r6.b2", "mqt", at="lhclength-(488.0567+(143-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307710.0, assembly_id=103304.0))
lhcb2.new("mq.12r6.b2", "mq", at="lhclength-(490.0647+(143-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308468.0, assembly_id=103304.0))
lhcb2.new("ms.12r6.b2", "ms", at="lhclength-(491.9597+(143-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252179.0, assembly_id=103304.0))
lhcb2.new("mcbv.12r6.b2", "mcbv", at="lhclength-(492.5527+(143-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252181.0, assembly_id=103304.0))
lhcb2.new("mb.a13r6.b2", "mb", at="lhclength-(501.1297+(142.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838722.0, assembly_id=103305.0))
lhcb2.new("mcs.a13r6.b2", "mcs", at="lhclength-(508.5537+(142-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246684.0, assembly_id=103305.0))
lhcb2.new("mco.13r6.b2", "mco", at="lhclength-(509.3037+(142-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252184.0, assembly_id=103306.0))
lhcb2.new("mcd.13r6.b2", "mcd", at="lhclength-(509.3052+(142-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252185.0, assembly_id=103306.0))
lhcb2.new("mb.b13r6.b2", "mb", at="lhclength-(516.7897+(141.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838746.0, assembly_id=103306.0))
lhcb2.new("mcs.b13r6.b2", "mcs", at="lhclength-(524.2137+(141-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246689.0, assembly_id=103306.0))
lhcb2.new("mb.c13r6.b2", "mb", at="lhclength-(532.4497+(140.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838770.0, assembly_id=103307.0))
lhcb2.new("mcs.c13r6.b2", "mcs", at="lhclength-(539.8737+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246692.0, assembly_id=103307.0))
lhcb2.new("bpm.13r6.b2", "bpm", at="lhclength-(540.7527+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246694.0, assembly_id=103308.0))
lhcb2.new("mqt.13r6.b2", "mqt", at="lhclength-(541.5067+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307502.0, assembly_id=103308.0))
lhcb2.new("mq.13r6.b2", "mq", at="lhclength-(543.5147+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308498.0, assembly_id=103308.0))
lhcb2.new("ms.13r6.b2", "ms", at="lhclength-(545.4097+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252187.0, assembly_id=103308.0))
lhcb2.new("mcbh.13r6.b2", "mcbh", at="lhclength-(546.0027+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252189.0, assembly_id=103308.0))
lhcb2.new("e.ds.r6.b2", "omk", at="lhclength-(546.7497+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a14r6.b2", "mco", at="lhclength-(547.0937+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252192.0, assembly_id=103309.0))
lhcb2.new("mcd.a14r6.b2", "mcd", at="lhclength-(547.0952+(140-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252193.0, assembly_id=103309.0))
lhcb2.new("mb.a14r6.b2", "mb", at="lhclength-(554.5797+(139.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838794.0, assembly_id=103309.0))
lhcb2.new("mcs.a14r6.b2", "mcs", at="lhclength-(562.0037+(139-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246702.0, assembly_id=103309.0))
lhcb2.new("mb.b14r6.b2", "mb", at="lhclength-(570.2397+(138.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838818.0, assembly_id=103310.0))
lhcb2.new("mcs.b14r6.b2", "mcs", at="lhclength-(577.6637+(138-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246705.0, assembly_id=103310.0))
lhcb2.new("mco.b14r6.b2", "mco", at="lhclength-(578.4137+(138-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252196.0, assembly_id=103311.0))
lhcb2.new("mcd.b14r6.b2", "mcd", at="lhclength-(578.4152+(138-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252197.0, assembly_id=103311.0))
lhcb2.new("mb.c14r6.b2", "mb", at="lhclength-(585.8997+(137.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838842.0, assembly_id=103311.0))
lhcb2.new("mcs.c14r6.b2", "mcs", at="lhclength-(593.3237+(137-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246710.0, assembly_id=103311.0))
lhcb2.new("bpm.14r6.b2", "bpm", at="lhclength-(594.2027+(137-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246712.0, assembly_id=103312.0))
lhcb2.new("mqt.14r6.b2", "mqt", at="lhclength-(594.9567+(137-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307534.0, assembly_id=103312.0))
lhcb2.new("mq.14r6.b2", "mq", at="lhclength-(596.9647+(137-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308527.0, assembly_id=103312.0))
lhcb2.new("ms.14r6.b2", "ms", at="lhclength-(598.8597+(137-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252199.0, assembly_id=103312.0))
lhcb2.new("mcbv.14r6.b2", "mcbv", at="lhclength-(599.4527+(137-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252201.0, assembly_id=103312.0))
lhcb2.new("mb.a15r6.b2", "mb", at="lhclength-(608.0297+(136.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838866.0, assembly_id=103313.0))
lhcb2.new("mcs.a15r6.b2", "mcs", at="lhclength-(615.4537+(136-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246718.0, assembly_id=103313.0))
lhcb2.new("mco.15r6.b2", "mco", at="lhclength-(616.2037+(136-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252204.0, assembly_id=103314.0))
lhcb2.new("mcd.15r6.b2", "mcd", at="lhclength-(616.2052+(136-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252205.0, assembly_id=103314.0))
lhcb2.new("mb.b15r6.b2", "mb", at="lhclength-(623.6897+(135.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838890.0, assembly_id=103314.0))
lhcb2.new("mcs.b15r6.b2", "mcs", at="lhclength-(631.1137+(135-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246723.0, assembly_id=103314.0))
lhcb2.new("mb.c15r6.b2", "mb", at="lhclength-(639.3497+(134.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838914.0, assembly_id=103315.0))
lhcb2.new("mcs.c15r6.b2", "mcs", at="lhclength-(646.7737+(134-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246726.0, assembly_id=103315.0))
lhcb2.new("bpm.15r6.b2", "bpm", at="lhclength-(647.6527+(134-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=266531.0, assembly_id=103316.0))
lhcb2.new("mqt.15r6.b2", "mqt", at="lhclength-(648.4067+(134-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307566.0, assembly_id=103316.0))
lhcb2.new("mq.15r6.b2", "mq", at="lhclength-(650.4147+(134-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308558.0, assembly_id=103316.0))
lhcb2.new("ms.15r6.b2", "ms", at="lhclength-(652.3097+(134-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252207.0, assembly_id=103316.0))
lhcb2.new("mcbh.15r6.b2", "mcbh", at="lhclength-(652.9027+(134-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252209.0, assembly_id=103316.0))
lhcb2.new("mco.a16r6.b2", "mco", at="lhclength-(653.9937+(134-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252212.0, assembly_id=103317.0))
lhcb2.new("mcd.a16r6.b2", "mcd", at="lhclength-(653.9952+(134-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252213.0, assembly_id=103317.0))
lhcb2.new("mb.a16r6.b2", "mb", at="lhclength-(661.4797+(133.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838938.0, assembly_id=103317.0))
lhcb2.new("mcs.a16r6.b2", "mcs", at="lhclength-(668.9037+(133-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246734.0, assembly_id=103317.0))
lhcb2.new("mb.b16r6.b2", "mb", at="lhclength-(677.1397+(132.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838962.0, assembly_id=103318.0))
lhcb2.new("mcs.b16r6.b2", "mcs", at="lhclength-(684.5637+(132-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246737.0, assembly_id=103318.0))
lhcb2.new("mco.b16r6.b2", "mco", at="lhclength-(685.3137+(132-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252216.0, assembly_id=103319.0))
lhcb2.new("mcd.b16r6.b2", "mcd", at="lhclength-(685.3152+(132-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252217.0, assembly_id=103319.0))
lhcb2.new("mb.c16r6.b2", "mb", at="lhclength-(692.7997+(131.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52838986.0, assembly_id=103319.0))
lhcb2.new("mcs.c16r6.b2", "mcs", at="lhclength-(700.2237+(131-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246742.0, assembly_id=103319.0))
lhcb2.new("bpm.16r6.b2", "bpm", at="lhclength-(701.1027+(131-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246744.0, assembly_id=103320.0))
lhcb2.new("mqt.16r6.b2", "mqt", at="lhclength-(701.8567+(131-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307596.0, assembly_id=103320.0))
lhcb2.new("mq.16r6.b2", "mq", at="lhclength-(703.8647+(131-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308351.0, assembly_id=103320.0))
lhcb2.new("ms.16r6.b2", "ms", at="lhclength-(705.7597+(131-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252219.0, assembly_id=103320.0))
lhcb2.new("mcbv.16r6.b2", "mcbv", at="lhclength-(706.3527+(131-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252221.0, assembly_id=103320.0))
lhcb2.new("mb.a17r6.b2", "mb", at="lhclength-(714.9297+(130.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839010.0, assembly_id=103321.0))
lhcb2.new("mcs.a17r6.b2", "mcs", at="lhclength-(722.3537+(130-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246750.0, assembly_id=103321.0))
lhcb2.new("mco.17r6.b2", "mco", at="lhclength-(723.1037+(130-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252224.0, assembly_id=103322.0))
lhcb2.new("mcd.17r6.b2", "mcd", at="lhclength-(723.1052+(130-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252225.0, assembly_id=103322.0))
lhcb2.new("mb.b17r6.b2", "mb", at="lhclength-(730.5897+(129.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839034.0, assembly_id=103322.0))
lhcb2.new("mcs.b17r6.b2", "mcs", at="lhclength-(738.0137+(129-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246755.0, assembly_id=103322.0))
lhcb2.new("mb.c17r6.b2", "mb", at="lhclength-(746.2497+(128.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839058.0, assembly_id=103323.0))
lhcb2.new("mcs.c17r6.b2", "mcs", at="lhclength-(753.6737+(128-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246758.0, assembly_id=103323.0))
lhcb2.new("bpm.17r6.b2", "bpm", at="lhclength-(754.5527+(128-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246760.0, assembly_id=103324.0))
lhcb2.new("mqt.17r6.b2", "mqt", at="lhclength-(755.3067+(128-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307390.0, assembly_id=103324.0))
lhcb2.new("mq.17r6.b2", "mq", at="lhclength-(757.3147+(128-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308380.0, assembly_id=103324.0))
lhcb2.new("ms.17r6.b2", "ms", at="lhclength-(759.2097+(128-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252227.0, assembly_id=103324.0))
lhcb2.new("mcbh.17r6.b2", "mcbh", at="lhclength-(759.8027+(128-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252229.0, assembly_id=103324.0))
lhcb2.new("mco.a18r6.b2", "mco", at="lhclength-(760.8937+(128-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252232.0, assembly_id=103325.0))
lhcb2.new("mcd.a18r6.b2", "mcd", at="lhclength-(760.8952+(128-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252233.0, assembly_id=103325.0))
lhcb2.new("mb.a18r6.b2", "mb", at="lhclength-(768.3797+(127.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839082.0, assembly_id=103325.0))
lhcb2.new("mcs.a18r6.b2", "mcs", at="lhclength-(775.8037+(127-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246768.0, assembly_id=103325.0))
lhcb2.new("mb.b18r6.b2", "mb", at="lhclength-(784.0397+(126.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839106.0, assembly_id=103326.0))
lhcb2.new("mcs.b18r6.b2", "mcs", at="lhclength-(791.4637+(126-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246771.0, assembly_id=103326.0))
lhcb2.new("mco.b18r6.b2", "mco", at="lhclength-(792.2137+(126-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252236.0, assembly_id=103327.0))
lhcb2.new("mcd.b18r6.b2", "mcd", at="lhclength-(792.2152+(126-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252237.0, assembly_id=103327.0))
lhcb2.new("mb.c18r6.b2", "mb", at="lhclength-(799.6997+(125.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839130.0, assembly_id=103327.0))
lhcb2.new("mcs.c18r6.b2", "mcs", at="lhclength-(807.1237+(125-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246776.0, assembly_id=103327.0))
lhcb2.new("bpm.18r6.b2", "bpm", at="lhclength-(808.0027+(125-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246778.0, assembly_id=103328.0))
lhcb2.new("mqt.18r6.b2", "mqt", at="lhclength-(808.7567+(125-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307422.0, assembly_id=103328.0))
lhcb2.new("mq.18r6.b2", "mq", at="lhclength-(810.7647+(125-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308411.0, assembly_id=103328.0))
lhcb2.new("ms.18r6.b2", "ms", at="lhclength-(812.6597+(125-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252239.0, assembly_id=103328.0))
lhcb2.new("mcbv.18r6.b2", "mcbv", at="lhclength-(813.2527+(125-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252241.0, assembly_id=103328.0))
lhcb2.new("mb.a19r6.b2", "mb", at="lhclength-(821.8297+(124.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839154.0, assembly_id=103329.0))
lhcb2.new("mcs.a19r6.b2", "mcs", at="lhclength-(829.2537+(124-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246784.0, assembly_id=103329.0))
lhcb2.new("mco.19r6.b2", "mco", at="lhclength-(830.0037+(124-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252244.0, assembly_id=103330.0))
lhcb2.new("mcd.19r6.b2", "mcd", at="lhclength-(830.0052+(124-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252245.0, assembly_id=103330.0))
lhcb2.new("mb.b19r6.b2", "mb", at="lhclength-(837.4897+(123.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839178.0, assembly_id=103330.0))
lhcb2.new("mcs.b19r6.b2", "mcs", at="lhclength-(844.9137+(123-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246789.0, assembly_id=103330.0))
lhcb2.new("mb.c19r6.b2", "mb", at="lhclength-(853.1497+(122.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839202.0, assembly_id=103331.0))
lhcb2.new("mcs.c19r6.b2", "mcs", at="lhclength-(860.5737+(122-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246792.0, assembly_id=103331.0))
lhcb2.new("bpm.19r6.b2", "bpm", at="lhclength-(861.4527+(122-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=266533.0, assembly_id=103332.0))
lhcb2.new("mqt.19r6.b2", "mqt", at="lhclength-(862.2067+(122-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307452.0, assembly_id=103332.0))
lhcb2.new("mq.19r6.b2", "mq", at="lhclength-(864.2147+(122-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308443.0, assembly_id=103332.0))
lhcb2.new("ms.19r6.b2", "ms", at="lhclength-(866.1097+(122-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252247.0, assembly_id=103332.0))
lhcb2.new("mcbh.19r6.b2", "mcbh", at="lhclength-(866.7027+(122-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252249.0, assembly_id=103332.0))
lhcb2.new("mco.a20r6.b2", "mco", at="lhclength-(867.7937+(122-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252252.0, assembly_id=103333.0))
lhcb2.new("mcd.a20r6.b2", "mcd", at="lhclength-(867.7952+(122-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252253.0, assembly_id=103333.0))
lhcb2.new("mb.a20r6.b2", "mb", at="lhclength-(875.2797+(121.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839226.0, assembly_id=103333.0))
lhcb2.new("mcs.a20r6.b2", "mcs", at="lhclength-(882.7037+(121-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246800.0, assembly_id=103333.0))
lhcb2.new("mb.b20r6.b2", "mb", at="lhclength-(890.9397+(120.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839250.0, assembly_id=103334.0))
lhcb2.new("mcs.b20r6.b2", "mcs", at="lhclength-(898.3637+(120-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246803.0, assembly_id=103334.0))
lhcb2.new("mco.b20r6.b2", "mco", at="lhclength-(899.1137+(120-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252256.0, assembly_id=103335.0))
lhcb2.new("mcd.b20r6.b2", "mcd", at="lhclength-(899.1152+(120-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252257.0, assembly_id=103335.0))
lhcb2.new("mb.c20r6.b2", "mb", at="lhclength-(906.5997+(119.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839274.0, assembly_id=103335.0))
lhcb2.new("mcs.c20r6.b2", "mcs", at="lhclength-(914.0237+(119-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246808.0, assembly_id=103335.0))
lhcb2.new("bpm.20r6.b2", "bpm", at="lhclength-(914.9027+(119-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246810.0, assembly_id=103336.0))
lhcb2.new("mqt.20r6.b2", "mqt", at="lhclength-(915.6567+(119-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307482.0, assembly_id=103336.0))
lhcb2.new("mq.20r6.b2", "mq", at="lhclength-(917.6647+(119-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308233.0, assembly_id=103336.0))
lhcb2.new("ms.20r6.b2", "ms", at="lhclength-(919.5597+(119-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252259.0, assembly_id=103336.0))
lhcb2.new("mcbv.20r6.b2", "mcbv", at="lhclength-(920.1527+(119-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252261.0, assembly_id=103336.0))
lhcb2.new("mb.a21r6.b2", "mb", at="lhclength-(928.7297+(118.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839298.0, assembly_id=103337.0))
lhcb2.new("mcs.a21r6.b2", "mcs", at="lhclength-(936.1537+(118-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246816.0, assembly_id=103337.0))
lhcb2.new("mco.21r6.b2", "mco", at="lhclength-(936.9037+(118-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252264.0, assembly_id=103338.0))
lhcb2.new("mcd.21r6.b2", "mcd", at="lhclength-(936.9052+(118-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252265.0, assembly_id=103338.0))
lhcb2.new("mb.b21r6.b2", "mb", at="lhclength-(944.3897+(117.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839322.0, assembly_id=103338.0))
lhcb2.new("mcs.b21r6.b2", "mcs", at="lhclength-(951.8137+(117-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246821.0, assembly_id=103338.0))
lhcb2.new("mb.c21r6.b2", "mb", at="lhclength-(960.0497+(116.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839346.0, assembly_id=103339.0))
lhcb2.new("mcs.c21r6.b2", "mcs", at="lhclength-(967.4737+(116-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246824.0, assembly_id=103339.0))
lhcb2.new("bpm.21r6.b2", "bpm", at="lhclength-(968.3527+(116-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246826.0, assembly_id=103340.0))
lhcb2.new("mqt.21r6.b2", "mqt", at="lhclength-(969.1067+(116-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307280.0, assembly_id=103340.0))
lhcb2.new("mq.21r6.b2", "mq", at="lhclength-(971.1147+(116-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308264.0, assembly_id=103340.0))
lhcb2.new("ms.21r6.b2", "ms", at="lhclength-(973.0097+(116-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252267.0, assembly_id=103340.0))
lhcb2.new("mcbh.21r6.b2", "mcbh", at="lhclength-(973.6027+(116-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252269.0, assembly_id=103340.0))
lhcb2.new("mco.a22r6.b2", "mco", at="lhclength-(974.6937+(116-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252272.0, assembly_id=103341.0))
lhcb2.new("mcd.a22r6.b2", "mcd", at="lhclength-(974.6952+(116-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252273.0, assembly_id=103341.0))
lhcb2.new("mb.a22r6.b2", "mb", at="lhclength-(982.1797+(115.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839370.0, assembly_id=103341.0))
lhcb2.new("mcs.a22r6.b2", "mcs", at="lhclength-(989.6037+(115-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246834.0, assembly_id=103341.0))
lhcb2.new("mb.b22r6.b2", "mb", at="lhclength-(997.8397+(114.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839394.0, assembly_id=103342.0))
lhcb2.new("mcs.b22r6.b2", "mcs", at="lhclength-(1005.2637+(114-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246837.0, assembly_id=103342.0))
lhcb2.new("mco.b22r6.b2", "mco", at="lhclength-(1006.0137+(114-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252276.0, assembly_id=103343.0))
lhcb2.new("mcd.b22r6.b2", "mcd", at="lhclength-(1006.0152+(114-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252277.0, assembly_id=103343.0))
lhcb2.new("mb.c22r6.b2", "mb", at="lhclength-(1013.4997+(113.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839418.0, assembly_id=103343.0))
lhcb2.new("mcs.c22r6.b2", "mcs", at="lhclength-(1020.9237+(113-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246842.0, assembly_id=103343.0))
lhcb2.new("bpm.22r6.b2", "bpm", at="lhclength-(1021.8027+(113-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246844.0, assembly_id=103344.0))
lhcb2.new("mo.22r6.b2", "mo", at="lhclength-(1022.5537+(113-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308824.0, assembly_id=103344.0))
lhcb2.new("mq.22r6.b2", "mq", at="lhclength-(1024.5647+(113-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308296.0, assembly_id=103344.0))
lhcb2.new("ms.22r6.b2", "ms", at="lhclength-(1026.4597+(113-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252279.0, assembly_id=103344.0))
lhcb2.new("mcbv.22r6.b2", "mcbv", at="lhclength-(1027.0527+(113-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252281.0, assembly_id=103344.0))
lhcb2.new("mb.a23r6.b2", "mb", at="lhclength-(1035.6297+(112.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839442.0, assembly_id=103345.0))
lhcb2.new("mcs.a23r6.b2", "mcs", at="lhclength-(1043.0537+(112-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246850.0, assembly_id=103345.0))
lhcb2.new("mco.23r6.b2", "mco", at="lhclength-(1043.8037+(112-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252284.0, assembly_id=103346.0))
lhcb2.new("mcd.23r6.b2", "mcd", at="lhclength-(1043.8052+(112-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252285.0, assembly_id=103346.0))
lhcb2.new("mb.b23r6.b2", "mb", at="lhclength-(1051.2897+(111.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839466.0, assembly_id=103346.0))
lhcb2.new("mcs.b23r6.b2", "mcs", at="lhclength-(1058.7137+(111-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246855.0, assembly_id=103346.0))
lhcb2.new("mb.c23r6.b2", "mb", at="lhclength-(1066.9497+(110.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839490.0, assembly_id=103347.0))
lhcb2.new("mcs.c23r6.b2", "mcs", at="lhclength-(1074.3737+(110-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246858.0, assembly_id=103347.0))
lhcb2.new("bpm.23r6.b2", "bpm", at="lhclength-(1075.2527+(110-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246860.0, assembly_id=103348.0))
lhcb2.new("mqs.23r6.b2", "mqs", at="lhclength-(1076.0067+(110-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307646.0, assembly_id=103348.0))
lhcb2.new("mq.23r6.b2", "mq", at="lhclength-(1078.0147+(110-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308326.0, assembly_id=103348.0))
lhcb2.new("ms.23r6.b2", "ms", at="lhclength-(1079.9097+(110-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252287.0, assembly_id=103348.0))
lhcb2.new("mcbh.23r6.b2", "mcbh", at="lhclength-(1080.5027+(110-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252289.0, assembly_id=103348.0))
lhcb2.new("mco.a24r6.b2", "mco", at="lhclength-(1081.5937+(110-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252292.0, assembly_id=103349.0))
lhcb2.new("mcd.a24r6.b2", "mcd", at="lhclength-(1081.5952+(110-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252293.0, assembly_id=103349.0))
lhcb2.new("mb.a24r6.b2", "mb", at="lhclength-(1089.0797+(109.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839514.0, assembly_id=103349.0))
lhcb2.new("mcs.a24r6.b2", "mcs", at="lhclength-(1096.5037+(109-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246868.0, assembly_id=103349.0))
lhcb2.new("mb.b24r6.b2", "mb", at="lhclength-(1104.7397+(108.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839538.0, assembly_id=103350.0))
lhcb2.new("mcs.b24r6.b2", "mcs", at="lhclength-(1112.1637+(108-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246871.0, assembly_id=103350.0))
lhcb2.new("mco.b24r6.b2", "mco", at="lhclength-(1112.9137+(108-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252296.0, assembly_id=103351.0))
lhcb2.new("mcd.b24r6.b2", "mcd", at="lhclength-(1112.9152+(108-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252297.0, assembly_id=103351.0))
lhcb2.new("mb.c24r6.b2", "mb", at="lhclength-(1120.3997+(107.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839562.0, assembly_id=103351.0))
lhcb2.new("mcs.c24r6.b2", "mcs", at="lhclength-(1127.8237+(107-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246876.0, assembly_id=103351.0))
lhcb2.new("bpm.24r6.b2", "bpm", at="lhclength-(1128.7027+(107-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246878.0, assembly_id=103352.0))
lhcb2.new("mo.24r6.b2", "mo", at="lhclength-(1129.4537+(107-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308854.0, assembly_id=103352.0))
lhcb2.new("mq.24r6.b2", "mq", at="lhclength-(1131.4647+(107-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308117.0, assembly_id=103352.0))
lhcb2.new("ms.24r6.b2", "ms", at="lhclength-(1133.3597+(107-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252299.0, assembly_id=103352.0))
lhcb2.new("mcbv.24r6.b2", "mcbv", at="lhclength-(1133.9527+(107-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252301.0, assembly_id=103352.0))
lhcb2.new("mb.a25r6.b2", "mb", at="lhclength-(1142.5297+(106.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839586.0, assembly_id=103353.0))
lhcb2.new("mcs.a25r6.b2", "mcs", at="lhclength-(1149.9537+(106-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246884.0, assembly_id=103353.0))
lhcb2.new("mco.25r6.b2", "mco", at="lhclength-(1150.7037+(106-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252304.0, assembly_id=103354.0))
lhcb2.new("mcd.25r6.b2", "mcd", at="lhclength-(1150.7052+(106-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252305.0, assembly_id=103354.0))
lhcb2.new("mb.b25r6.b2", "mb", at="lhclength-(1158.1897+(105.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839610.0, assembly_id=103354.0))
lhcb2.new("mcs.b25r6.b2", "mcs", at="lhclength-(1165.6137+(105-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246889.0, assembly_id=103354.0))
lhcb2.new("mb.c25r6.b2", "mb", at="lhclength-(1173.8497+(104.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839634.0, assembly_id=103355.0))
lhcb2.new("mcs.c25r6.b2", "mcs", at="lhclength-(1181.2737+(104-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246892.0, assembly_id=103355.0))
lhcb2.new("bpm.25r6.b2", "bpm", at="lhclength-(1182.1527+(104-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246894.0, assembly_id=103356.0))
lhcb2.new("mo.25r6.b2", "mo", at="lhclength-(1182.9037+(104-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308886.0, assembly_id=103356.0))
lhcb2.new("mq.25r6.b2", "mq", at="lhclength-(1184.9147+(104-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308149.0, assembly_id=103356.0))
lhcb2.new("ms.25r6.b2", "ms", at="lhclength-(1186.8097+(104-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252307.0, assembly_id=103356.0))
lhcb2.new("mcbh.25r6.b2", "mcbh", at="lhclength-(1187.4027+(104-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252309.0, assembly_id=103356.0))
lhcb2.new("mco.a26r6.b2", "mco", at="lhclength-(1188.4937+(104-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252312.0, assembly_id=103357.0))
lhcb2.new("mcd.a26r6.b2", "mcd", at="lhclength-(1188.4952+(104-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252313.0, assembly_id=103357.0))
lhcb2.new("mb.a26r6.b2", "mb", at="lhclength-(1195.9797+(103.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839658.0, assembly_id=103357.0))
lhcb2.new("mcs.a26r6.b2", "mcs", at="lhclength-(1203.4037+(103-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246902.0, assembly_id=103357.0))
lhcb2.new("mb.b26r6.b2", "mb", at="lhclength-(1211.6397+(102.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839682.0, assembly_id=103358.0))
lhcb2.new("mcs.b26r6.b2", "mcs", at="lhclength-(1219.0637+(102-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246905.0, assembly_id=103358.0))
lhcb2.new("mco.b26r6.b2", "mco", at="lhclength-(1219.8137+(102-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252316.0, assembly_id=103359.0))
lhcb2.new("mcd.b26r6.b2", "mcd", at="lhclength-(1219.8152+(102-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252317.0, assembly_id=103359.0))
lhcb2.new("mb.c26r6.b2", "mb", at="lhclength-(1227.2997+(101.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839706.0, assembly_id=103359.0))
lhcb2.new("mcs.c26r6.b2", "mcs", at="lhclength-(1234.7237+(101-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246910.0, assembly_id=103359.0))
lhcb2.new("bpm.26r6.b2", "bpm", at="lhclength-(1235.6027+(101-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246912.0, assembly_id=103360.0))
lhcb2.new("mo.26r6.b2", "mo", at="lhclength-(1236.3537+(101-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308917.0, assembly_id=103360.0))
lhcb2.new("mq.26r6.b2", "mq", at="lhclength-(1238.3647+(101-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308179.0, assembly_id=103360.0))
lhcb2.new("ms.26r6.b2", "ms", at="lhclength-(1240.2597+(101-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252319.0, assembly_id=103360.0))
lhcb2.new("mcbv.26r6.b2", "mcbv", at="lhclength-(1240.8527+(101-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252321.0, assembly_id=103360.0))
lhcb2.new("mb.a27r6.b2", "mb", at="lhclength-(1249.4297+(100.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839730.0, assembly_id=103361.0))
lhcb2.new("mcs.a27r6.b2", "mcs", at="lhclength-(1256.8537+(100-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246918.0, assembly_id=103361.0))
lhcb2.new("mco.27r6.b2", "mco", at="lhclength-(1257.6037+(100-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252324.0, assembly_id=103362.0))
lhcb2.new("mcd.27r6.b2", "mcd", at="lhclength-(1257.6052+(100-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252325.0, assembly_id=103362.0))
lhcb2.new("mb.b27r6.b2", "mb", at="lhclength-(1265.0897+(99.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839754.0, assembly_id=103362.0))
lhcb2.new("mcs.b27r6.b2", "mcs", at="lhclength-(1272.5137+(99-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246923.0, assembly_id=103362.0))
lhcb2.new("mb.c27r6.b2", "mb", at="lhclength-(1280.7497+(98.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839778.0, assembly_id=103363.0))
lhcb2.new("mcs.c27r6.b2", "mcs", at="lhclength-(1288.1737+(98-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246926.0, assembly_id=103363.0))
lhcb2.new("bpm.27r6.b2", "bpm", at="lhclength-(1289.0527+(98-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246928.0, assembly_id=103364.0))
lhcb2.new("mqs.27r6.b2", "mqs", at="lhclength-(1289.8067+(98-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307678.0, assembly_id=103364.0))
lhcb2.new("mq.27r6.b2", "mq", at="lhclength-(1291.8147+(98-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307969.0, assembly_id=103364.0))
lhcb2.new("ms.27r6.b2", "ms", at="lhclength-(1293.7097+(98-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252327.0, assembly_id=103364.0))
lhcb2.new("mcbh.27r6.b2", "mcbh", at="lhclength-(1294.3027+(98-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252329.0, assembly_id=103364.0))
lhcb2.new("mco.a28r6.b2", "mco", at="lhclength-(1295.3937+(98-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252332.0, assembly_id=103365.0))
lhcb2.new("mcd.a28r6.b2", "mcd", at="lhclength-(1295.3952+(98-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252333.0, assembly_id=103365.0))
lhcb2.new("mb.a28r6.b2", "mb", at="lhclength-(1302.8797+(97.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839802.0, assembly_id=103365.0))
lhcb2.new("mcs.a28r6.b2", "mcs", at="lhclength-(1310.3037+(97-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246936.0, assembly_id=103365.0))
lhcb2.new("mb.b28r6.b2", "mb", at="lhclength-(1318.5397+(96.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839826.0, assembly_id=103366.0))
lhcb2.new("mcs.b28r6.b2", "mcs", at="lhclength-(1325.9637+(96-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246939.0, assembly_id=103366.0))
lhcb2.new("mco.b28r6.b2", "mco", at="lhclength-(1326.7137+(96-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252336.0, assembly_id=103367.0))
lhcb2.new("mcd.b28r6.b2", "mcd", at="lhclength-(1326.7152+(96-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252337.0, assembly_id=103367.0))
lhcb2.new("mb.c28r6.b2", "mb", at="lhclength-(1334.1997+(95.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839850.0, assembly_id=103367.0))
lhcb2.new("mcs.c28r6.b2", "mcs", at="lhclength-(1341.6237+(95-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246944.0, assembly_id=103367.0))
lhcb2.new("bpm.28r6.b2", "bpm", at="lhclength-(1342.5027+(95-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246946.0, assembly_id=103368.0))
lhcb2.new("mo.28r6.b2", "mo", at="lhclength-(1343.2537+(95-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308707.0, assembly_id=103368.0))
lhcb2.new("mq.28r6.b2", "mq", at="lhclength-(1345.2647+(95-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308001.0, assembly_id=103368.0))
lhcb2.new("ms.28r6.b2", "ms", at="lhclength-(1347.1597+(95-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252339.0, assembly_id=103368.0))
lhcb2.new("mcbv.28r6.b2", "mcbv", at="lhclength-(1347.7527+(95-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252341.0, assembly_id=103368.0))
lhcb2.new("mb.a29r6.b2", "mb", at="lhclength-(1356.3297+(94.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839874.0, assembly_id=103369.0))
lhcb2.new("mcs.a29r6.b2", "mcs", at="lhclength-(1363.7537+(94-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246952.0, assembly_id=103369.0))
lhcb2.new("mco.29r6.b2", "mco", at="lhclength-(1364.5037+(94-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252344.0, assembly_id=103370.0))
lhcb2.new("mcd.29r6.b2", "mcd", at="lhclength-(1364.5052+(94-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252345.0, assembly_id=103370.0))
lhcb2.new("mb.b29r6.b2", "mb", at="lhclength-(1371.9897+(93.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839898.0, assembly_id=103370.0))
lhcb2.new("mcs.b29r6.b2", "mcs", at="lhclength-(1379.4137+(93-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246957.0, assembly_id=103370.0))
lhcb2.new("mb.c29r6.b2", "mb", at="lhclength-(1387.6497+(92.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839922.0, assembly_id=103371.0))
lhcb2.new("mcs.c29r6.b2", "mcs", at="lhclength-(1395.0737+(92-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246960.0, assembly_id=103371.0))
lhcb2.new("bpm.29r6.b2", "bpm", at="lhclength-(1395.9527+(92-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246962.0, assembly_id=103372.0))
lhcb2.new("mo.29r6.b2", "mo", at="lhclength-(1396.7037+(92-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308739.0, assembly_id=103372.0))
lhcb2.new("mq.29r6.b2", "mq", at="lhclength-(1398.7147+(92-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308031.0, assembly_id=103372.0))
lhcb2.new("mss.29r6.b2", "mss", at="lhclength-(1400.6097+(92-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252347.0, assembly_id=103372.0))
lhcb2.new("mcbh.29r6.b2", "mcbh", at="lhclength-(1401.2027+(92-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252349.0, assembly_id=103372.0))
lhcb2.new("mco.a30r6.b2", "mco", at="lhclength-(1402.2937+(92-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252352.0, assembly_id=103373.0))
lhcb2.new("mcd.a30r6.b2", "mcd", at="lhclength-(1402.2952+(92-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252353.0, assembly_id=103373.0))
lhcb2.new("mb.a30r6.b2", "mb", at="lhclength-(1409.7797+(91.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839946.0, assembly_id=103373.0))
lhcb2.new("mcs.a30r6.b2", "mcs", at="lhclength-(1417.2037+(91-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246970.0, assembly_id=103373.0))
lhcb2.new("mb.b30r6.b2", "mb", at="lhclength-(1425.4397+(90.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839970.0, assembly_id=103374.0))
lhcb2.new("mcs.b30r6.b2", "mcs", at="lhclength-(1432.8637+(90-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246973.0, assembly_id=103374.0))
lhcb2.new("mco.b30r6.b2", "mco", at="lhclength-(1433.6137+(90-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252356.0, assembly_id=103375.0))
lhcb2.new("mcd.b30r6.b2", "mcd", at="lhclength-(1433.6152+(90-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252357.0, assembly_id=103375.0))
lhcb2.new("mb.c30r6.b2", "mb", at="lhclength-(1441.0997+(89.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52839994.0, assembly_id=103375.0))
lhcb2.new("mcs.c30r6.b2", "mcs", at="lhclength-(1448.5237+(89-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246978.0, assembly_id=103375.0))
lhcb2.new("bpm.30r6.b2", "bpm", at="lhclength-(1449.4027+(89-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246980.0, assembly_id=103376.0))
lhcb2.new("mo.30r6.b2", "mo", at="lhclength-(1450.1537+(89-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308770.0, assembly_id=103376.0))
lhcb2.new("mq.30r6.b2", "mq", at="lhclength-(1452.1647+(89-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308061.0, assembly_id=103376.0))
lhcb2.new("ms.30r6.b2", "ms", at="lhclength-(1454.0597+(89-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252359.0, assembly_id=103376.0))
lhcb2.new("mcbv.30r6.b2", "mcbv", at="lhclength-(1454.6527+(89-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252361.0, assembly_id=103376.0))
lhcb2.new("mb.a31r6.b2", "mb", at="lhclength-(1463.2297+(88.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840018.0, assembly_id=103377.0))
lhcb2.new("mcs.a31r6.b2", "mcs", at="lhclength-(1470.6537+(88-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246986.0, assembly_id=103377.0))
lhcb2.new("mco.31r6.b2", "mco", at="lhclength-(1471.4037+(88-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252364.0, assembly_id=103378.0))
lhcb2.new("mcd.31r6.b2", "mcd", at="lhclength-(1471.4052+(88-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252365.0, assembly_id=103378.0))
lhcb2.new("mb.b31r6.b2", "mb", at="lhclength-(1478.8897+(87.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840042.0, assembly_id=103378.0))
lhcb2.new("mcs.b31r6.b2", "mcs", at="lhclength-(1486.3137+(87-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246991.0, assembly_id=103378.0))
lhcb2.new("mb.c31r6.b2", "mb", at="lhclength-(1494.5497+(86.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840066.0, assembly_id=103379.0))
lhcb2.new("mcs.c31r6.b2", "mcs", at="lhclength-(1501.9737+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246994.0, assembly_id=103379.0))
lhcb2.new("bpm.31r6.b2", "bpm", at="lhclength-(1502.8527+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=246996.0, assembly_id=103380.0))
lhcb2.new("mo.31r6.b2", "mo", at="lhclength-(1503.6037+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308799.0, assembly_id=103380.0))
lhcb2.new("mq.31r6.b2", "mq", at="lhclength-(1505.6147+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307853.0, assembly_id=103380.0))
lhcb2.new("ms.31r6.b2", "ms", at="lhclength-(1507.5097+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252367.0, assembly_id=103380.0))
lhcb2.new("mcbh.31r6.b2", "mcbh", at="lhclength-(1508.1027+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252369.0, assembly_id=103380.0))
lhcb2.new("s.cell.67.b2", "omk", at="lhclength-(1508.8497+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a32r6.b2", "mco", at="lhclength-(1509.1937+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252372.0, assembly_id=103381.0))
lhcb2.new("mcd.a32r6.b2", "mcd", at="lhclength-(1509.1952+(86-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252373.0, assembly_id=103381.0))
lhcb2.new("mb.a32r6.b2", "mb", at="lhclength-(1516.6797+(85.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840090.0, assembly_id=103381.0))
lhcb2.new("mcs.a32r6.b2", "mcs", at="lhclength-(1524.1037+(85-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247004.0, assembly_id=103381.0))
lhcb2.new("mb.b32r6.b2", "mb", at="lhclength-(1532.3397+(84.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840114.0, assembly_id=103382.0))
lhcb2.new("mcs.b32r6.b2", "mcs", at="lhclength-(1539.7637+(84-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247007.0, assembly_id=103382.0))
lhcb2.new("mco.b32r6.b2", "mco", at="lhclength-(1540.5137+(84-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252376.0, assembly_id=103383.0))
lhcb2.new("mcd.b32r6.b2", "mcd", at="lhclength-(1540.5152+(84-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252377.0, assembly_id=103383.0))
lhcb2.new("mb.c32r6.b2", "mb", at="lhclength-(1547.9997+(83.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840138.0, assembly_id=103383.0))
lhcb2.new("mcs.c32r6.b2", "mcs", at="lhclength-(1555.4237+(83-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247012.0, assembly_id=103383.0))
lhcb2.new("bpm.32r6.b2", "bpm", at="lhclength-(1556.3027+(83-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247014.0, assembly_id=103384.0))
lhcb2.new("mo.32r6.b2", "mo", at="lhclength-(1557.0537+(83-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308592.0, assembly_id=103384.0))
lhcb2.new("mq.32r6.b2", "mq", at="lhclength-(1559.0647+(83-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307883.0, assembly_id=103384.0))
lhcb2.new("ms.32r6.b2", "ms", at="lhclength-(1560.9597+(83-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252379.0, assembly_id=103384.0))
lhcb2.new("mcbv.32r6.b2", "mcbv", at="lhclength-(1561.5527+(83-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252381.0, assembly_id=103384.0))
lhcb2.new("mb.a33r6.b2", "mb", at="lhclength-(1570.1297+(82.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840162.0, assembly_id=103385.0))
lhcb2.new("mcs.a33r6.b2", "mcs", at="lhclength-(1577.5537+(82-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247020.0, assembly_id=103385.0))
lhcb2.new("mco.33r6.b2", "mco", at="lhclength-(1578.3037+(82-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252384.0, assembly_id=103386.0))
lhcb2.new("mcd.33r6.b2", "mcd", at="lhclength-(1578.3052+(82-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252385.0, assembly_id=103386.0))
lhcb2.new("mb.b33r6.b2", "mb", at="lhclength-(1585.7897+(81.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840186.0, assembly_id=103386.0))
lhcb2.new("mcs.b33r6.b2", "mcs", at="lhclength-(1593.2137+(81-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247025.0, assembly_id=103386.0))
lhcb2.new("mb.c33r6.b2", "mb", at="lhclength-(1601.4497+(80.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840210.0, assembly_id=103387.0))
lhcb2.new("mcs.c33r6.b2", "mcs", at="lhclength-(1608.8737+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247028.0, assembly_id=103387.0))
lhcb2.new("bpm.33r6.b2", "bpm", at="lhclength-(1609.7527+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247030.0, assembly_id=103388.0))
lhcb2.new("mo.33r6.b2", "mo", at="lhclength-(1610.5037+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308623.0, assembly_id=103388.0))
lhcb2.new("mq.33r6.b2", "mq", at="lhclength-(1612.5147+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2307913.0, assembly_id=103388.0))
lhcb2.new("mss.33r6.b2", "mss", at="lhclength-(1614.4097+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252387.0, assembly_id=103388.0))
lhcb2.new("mcbh.33r6.b2", "mcbh", at="lhclength-(1615.0027+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252389.0, assembly_id=103388.0))
lhcb2.new("e.cell.67.b2", "omk", at="lhclength-(1615.7497+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a34r6.b2", "mco", at="lhclength-(1616.0937+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252392.0, assembly_id=103389.0))
lhcb2.new("mcd.a34r6.b2", "mcd", at="lhclength-(1616.0952+(80-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252393.0, assembly_id=103389.0))
lhcb2.new("mb.a34r6.b2", "mb", at="lhclength-(1623.5797+(79.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840234.0, assembly_id=103389.0))
lhcb2.new("mcs.a34r6.b2", "mcs", at="lhclength-(1631.0037+(79-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247038.0, assembly_id=103389.0))
lhcb2.new("mb.b34r6.b2", "mb", at="lhclength-(1639.2397+(78.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840258.0, assembly_id=103390.0))
lhcb2.new("mcs.b34r6.b2", "mcs", at="lhclength-(1646.6637+(78-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247041.0, assembly_id=103390.0))
lhcb2.new("mco.b34r6.b2", "mco", at="lhclength-(1647.4137+(78-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252396.0, assembly_id=103391.0))
lhcb2.new("mcd.b34r6.b2", "mcd", at="lhclength-(1647.4152+(78-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=252397.0, assembly_id=103391.0))
lhcb2.new("mb.c34r6.b2", "mb", at="lhclength-(1654.8997+(77.5-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=52840282.0, assembly_id=103391.0))
lhcb2.new("mcs.c34r6.b2", "mcs", at="lhclength-(1662.3237+(77-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247046.0, assembly_id=103391.0))
lhcb2.new("bpm.34r6.b2", "bpm", at="lhclength-(1663.2027+(77-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=247048.0, assembly_id=103392.0))
lhcb2.new("mo.34r6.b2", "mo", at="lhclength-(1663.9537+(77-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2308637.0, assembly_id=103392.0))
lhcb2.new("mq.34r6.b2", "mq", at="lhclength-(1665.9647+(77-ip6ofs.b2)*ds)", from_="ip6", extra=dict(mech_sep=-0.194, slot_id=2348462.0, assembly_id=103392.0))
lhcb2.new("ms.34l7.b2", "ms", at="lhclength-(-1664.5007+(77-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252399.0, assembly_id=103392.0))
lhcb2.new("mcbv.34l7.b2", "mcbv", at="lhclength-(-1663.9077+(77-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252401.0, assembly_id=103392.0))
lhcb2.new("mb.c34l7.b2", "mb", at="lhclength-(-1655.3307+(76.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840306.0, assembly_id=103393.0))
lhcb2.new("mcs.c34l7.b2", "mcs", at="lhclength-(-1647.9067+(76-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247054.0, assembly_id=103393.0))
lhcb2.new("mco.34l7.b2", "mco", at="lhclength-(-1647.1567+(76-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252404.0, assembly_id=103394.0))
lhcb2.new("mcd.34l7.b2", "mcd", at="lhclength-(-1647.1552+(76-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252405.0, assembly_id=103394.0))
lhcb2.new("mb.b34l7.b2", "mb", at="lhclength-(-1639.6707+(75.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840330.0, assembly_id=103394.0))
lhcb2.new("mcs.b34l7.b2", "mcs", at="lhclength-(-1632.2467+(75-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247059.0, assembly_id=103394.0))
lhcb2.new("mb.a34l7.b2", "mb", at="lhclength-(-1624.0107+(74.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840354.0, assembly_id=103395.0))
lhcb2.new("mcs.a34l7.b2", "mcs", at="lhclength-(-1616.5867+(74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247062.0, assembly_id=103395.0))
lhcb2.new("bpm.33l7.b2", "bpm", at="lhclength-(-1615.7077+(74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247064.0, assembly_id=103396.0))
lhcb2.new("mo.33l7.b2", "mo", at="lhclength-(-1614.9567+(74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308610.0, assembly_id=103396.0))
lhcb2.new("mq.33l7.b2", "mq", at="lhclength-(-1612.9457+(74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307900.0, assembly_id=103396.0))
lhcb2.new("mss.33l7.b2", "mss", at="lhclength-(-1611.0507+(74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252407.0, assembly_id=103396.0))
lhcb2.new("mcbh.33l7.b2", "mcbh", at="lhclength-(-1610.4577+(74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252409.0, assembly_id=103396.0))
lhcb2.new("mco.b33l7.b2", "mco", at="lhclength-(-1609.3667+(74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252412.0, assembly_id=103397.0))
lhcb2.new("mcd.b33l7.b2", "mcd", at="lhclength-(-1609.3652+(74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252413.0, assembly_id=103397.0))
lhcb2.new("mb.c33l7.b2", "mb", at="lhclength-(-1601.8807+(73.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840378.0, assembly_id=103397.0))
lhcb2.new("mcs.c33l7.b2", "mcs", at="lhclength-(-1594.4567+(73-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247072.0, assembly_id=103397.0))
lhcb2.new("mb.b33l7.b2", "mb", at="lhclength-(-1586.2207+(72.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840402.0, assembly_id=103398.0))
lhcb2.new("mcs.b33l7.b2", "mcs", at="lhclength-(-1578.7967+(72-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247075.0, assembly_id=103398.0))
lhcb2.new("mco.a33l7.b2", "mco", at="lhclength-(-1578.0467+(72-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252416.0, assembly_id=103399.0))
lhcb2.new("mcd.a33l7.b2", "mcd", at="lhclength-(-1578.0452+(72-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252417.0, assembly_id=103399.0))
lhcb2.new("mb.a33l7.b2", "mb", at="lhclength-(-1570.5607+(71.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840426.0, assembly_id=103399.0))
lhcb2.new("mcs.a33l7.b2", "mcs", at="lhclength-(-1563.1367+(71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247080.0, assembly_id=103399.0))
lhcb2.new("bpm.32l7.b2", "bpm", at="lhclength-(-1562.2577+(71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247082.0, assembly_id=103400.0))
lhcb2.new("mo.32l7.b2", "mo", at="lhclength-(-1561.5067+(71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308578.0, assembly_id=103400.0))
lhcb2.new("mq.32l7.b2", "mq", at="lhclength-(-1559.4957+(71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307870.0, assembly_id=103400.0))
lhcb2.new("ms.32l7.b2", "ms", at="lhclength-(-1557.6007+(71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252419.0, assembly_id=103400.0))
lhcb2.new("mcbv.32l7.b2", "mcbv", at="lhclength-(-1557.0077+(71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252421.0, assembly_id=103400.0))
lhcb2.new("mb.c32l7.b2", "mb", at="lhclength-(-1548.4307+(70.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840450.0, assembly_id=103401.0))
lhcb2.new("mcs.c32l7.b2", "mcs", at="lhclength-(-1541.0067+(70-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247088.0, assembly_id=103401.0))
lhcb2.new("mco.32l7.b2", "mco", at="lhclength-(-1540.2567+(70-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252424.0, assembly_id=103402.0))
lhcb2.new("mcd.32l7.b2", "mcd", at="lhclength-(-1540.2552+(70-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252425.0, assembly_id=103402.0))
lhcb2.new("mb.b32l7.b2", "mb", at="lhclength-(-1532.7707+(69.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840474.0, assembly_id=103402.0))
lhcb2.new("mcs.b32l7.b2", "mcs", at="lhclength-(-1525.3467+(69-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247093.0, assembly_id=103402.0))
lhcb2.new("mb.a32l7.b2", "mb", at="lhclength-(-1517.1107+(68.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840498.0, assembly_id=103403.0))
lhcb2.new("mcs.a32l7.b2", "mcs", at="lhclength-(-1509.6867+(68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247096.0, assembly_id=103403.0))
lhcb2.new("bpm.31l7.b2", "bpm", at="lhclength-(-1508.8077+(68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247098.0, assembly_id=103404.0))
lhcb2.new("mo.31l7.b2", "mo", at="lhclength-(-1508.0567+(68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308786.0, assembly_id=103404.0))
lhcb2.new("mq.31l7.b2", "mq", at="lhclength-(-1506.0457+(68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308078.0, assembly_id=103404.0))
lhcb2.new("ms.31l7.b2", "ms", at="lhclength-(-1504.1507+(68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252427.0, assembly_id=103404.0))
lhcb2.new("mcbh.31l7.b2", "mcbh", at="lhclength-(-1503.5577+(68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252429.0, assembly_id=103404.0))
lhcb2.new("mco.b31l7.b2", "mco", at="lhclength-(-1502.4667+(68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252432.0, assembly_id=103405.0))
lhcb2.new("mcd.b31l7.b2", "mcd", at="lhclength-(-1502.4652+(68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252433.0, assembly_id=103405.0))
lhcb2.new("mb.c31l7.b2", "mb", at="lhclength-(-1494.9807+(67.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840522.0, assembly_id=103405.0))
lhcb2.new("mcs.c31l7.b2", "mcs", at="lhclength-(-1487.5567+(67-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247106.0, assembly_id=103405.0))
lhcb2.new("mb.b31l7.b2", "mb", at="lhclength-(-1479.3207+(66.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840546.0, assembly_id=103406.0))
lhcb2.new("mcs.b31l7.b2", "mcs", at="lhclength-(-1471.8967+(66-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247109.0, assembly_id=103406.0))
lhcb2.new("mco.a31l7.b2", "mco", at="lhclength-(-1471.1467+(66-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252436.0, assembly_id=103407.0))
lhcb2.new("mcd.a31l7.b2", "mcd", at="lhclength-(-1471.1452+(66-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252437.0, assembly_id=103407.0))
lhcb2.new("mb.a31l7.b2", "mb", at="lhclength-(-1463.6607+(65.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840570.0, assembly_id=103407.0))
lhcb2.new("mcs.a31l7.b2", "mcs", at="lhclength-(-1456.2367+(65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247114.0, assembly_id=103407.0))
lhcb2.new("bpm.30l7.b2", "bpm", at="lhclength-(-1455.3577+(65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247116.0, assembly_id=103408.0))
lhcb2.new("mo.30l7.b2", "mo", at="lhclength-(-1454.6067+(65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308757.0, assembly_id=103408.0))
lhcb2.new("mq.30l7.b2", "mq", at="lhclength-(-1452.5957+(65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308048.0, assembly_id=103408.0))
lhcb2.new("ms.30l7.b2", "ms", at="lhclength-(-1450.7007+(65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252439.0, assembly_id=103408.0))
lhcb2.new("mcbv.30l7.b2", "mcbv", at="lhclength-(-1450.1077+(65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252441.0, assembly_id=103408.0))
lhcb2.new("mb.c30l7.b2", "mb", at="lhclength-(-1441.5307+(64.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840594.0, assembly_id=103409.0))
lhcb2.new("mcs.c30l7.b2", "mcs", at="lhclength-(-1434.1067+(64-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247122.0, assembly_id=103409.0))
lhcb2.new("mco.30l7.b2", "mco", at="lhclength-(-1433.3567+(64-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252444.0, assembly_id=103410.0))
lhcb2.new("mcd.30l7.b2", "mcd", at="lhclength-(-1433.3552+(64-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252445.0, assembly_id=103410.0))
lhcb2.new("mb.b30l7.b2", "mb", at="lhclength-(-1425.8707+(63.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840618.0, assembly_id=103410.0))
lhcb2.new("mcs.b30l7.b2", "mcs", at="lhclength-(-1418.4467+(63-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247127.0, assembly_id=103410.0))
lhcb2.new("mb.a30l7.b2", "mb", at="lhclength-(-1410.2107+(62.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840642.0, assembly_id=103411.0))
lhcb2.new("mcs.a30l7.b2", "mcs", at="lhclength-(-1402.7867+(62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247130.0, assembly_id=103411.0))
lhcb2.new("bpm.29l7.b2", "bpm", at="lhclength-(-1401.9077+(62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247132.0, assembly_id=103412.0))
lhcb2.new("mo.29l7.b2", "mo", at="lhclength-(-1401.1567+(62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308725.0, assembly_id=103412.0))
lhcb2.new("mq.29l7.b2", "mq", at="lhclength-(-1399.1457+(62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308018.0, assembly_id=103412.0))
lhcb2.new("mss.29l7.b2", "mss", at="lhclength-(-1397.2507+(62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252447.0, assembly_id=103412.0))
lhcb2.new("mcbh.29l7.b2", "mcbh", at="lhclength-(-1396.6577+(62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252449.0, assembly_id=103412.0))
lhcb2.new("mco.b29l7.b2", "mco", at="lhclength-(-1395.5667+(62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252452.0, assembly_id=103413.0))
lhcb2.new("mcd.b29l7.b2", "mcd", at="lhclength-(-1395.5652+(62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252453.0, assembly_id=103413.0))
lhcb2.new("mb.c29l7.b2", "mb", at="lhclength-(-1388.0807+(61.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840666.0, assembly_id=103413.0))
lhcb2.new("mcs.c29l7.b2", "mcs", at="lhclength-(-1380.6567+(61-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247140.0, assembly_id=103413.0))
lhcb2.new("mb.b29l7.b2", "mb", at="lhclength-(-1372.4207+(60.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840690.0, assembly_id=103414.0))
lhcb2.new("mcs.b29l7.b2", "mcs", at="lhclength-(-1364.9967+(60-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247143.0, assembly_id=103414.0))
lhcb2.new("mco.a29l7.b2", "mco", at="lhclength-(-1364.2467+(60-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252456.0, assembly_id=103415.0))
lhcb2.new("mcd.a29l7.b2", "mcd", at="lhclength-(-1364.2452+(60-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252457.0, assembly_id=103415.0))
lhcb2.new("mb.a29l7.b2", "mb", at="lhclength-(-1356.7607+(59.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840714.0, assembly_id=103415.0))
lhcb2.new("mcs.a29l7.b2", "mcs", at="lhclength-(-1349.3367+(59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247148.0, assembly_id=103415.0))
lhcb2.new("bpm.28l7.b2", "bpm", at="lhclength-(-1348.4577+(59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247150.0, assembly_id=103416.0))
lhcb2.new("mo.28l7.b2", "mo", at="lhclength-(-1347.7067+(59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308693.0, assembly_id=103416.0))
lhcb2.new("mq.28l7.b2", "mq", at="lhclength-(-1345.6957+(59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307987.0, assembly_id=103416.0))
lhcb2.new("ms.28l7.b2", "ms", at="lhclength-(-1343.8007+(59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252459.0, assembly_id=103416.0))
lhcb2.new("mcbv.28l7.b2", "mcbv", at="lhclength-(-1343.2077+(59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252461.0, assembly_id=103416.0))
lhcb2.new("mb.c28l7.b2", "mb", at="lhclength-(-1334.6307+(58.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840738.0, assembly_id=103417.0))
lhcb2.new("mcs.c28l7.b2", "mcs", at="lhclength-(-1327.2067+(58-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247156.0, assembly_id=103417.0))
lhcb2.new("mco.28l7.b2", "mco", at="lhclength-(-1326.4567+(58-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252464.0, assembly_id=103418.0))
lhcb2.new("mcd.28l7.b2", "mcd", at="lhclength-(-1326.4552+(58-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252465.0, assembly_id=103418.0))
lhcb2.new("mb.b28l7.b2", "mb", at="lhclength-(-1318.9707+(57.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840762.0, assembly_id=103418.0))
lhcb2.new("mcs.b28l7.b2", "mcs", at="lhclength-(-1311.5467+(57-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247161.0, assembly_id=103418.0))
lhcb2.new("mb.a28l7.b2", "mb", at="lhclength-(-1303.3107+(56.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840786.0, assembly_id=103419.0))
lhcb2.new("mcs.a28l7.b2", "mcs", at="lhclength-(-1295.8867+(56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247164.0, assembly_id=103419.0))
lhcb2.new("bpm.27l7.b2", "bpm", at="lhclength-(-1295.0077+(56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247166.0, assembly_id=103420.0))
lhcb2.new("mqs.27l7.b2", "mqs", at="lhclength-(-1294.2537+(56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307664.0, assembly_id=103420.0))
lhcb2.new("mq.27l7.b2", "mq", at="lhclength-(-1292.2457+(56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308196.0, assembly_id=103420.0))
lhcb2.new("ms.27l7.b2", "ms", at="lhclength-(-1290.3507+(56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252467.0, assembly_id=103420.0))
lhcb2.new("mcbh.27l7.b2", "mcbh", at="lhclength-(-1289.7577+(56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252469.0, assembly_id=103420.0))
lhcb2.new("mco.b27l7.b2", "mco", at="lhclength-(-1288.6667+(56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252472.0, assembly_id=103421.0))
lhcb2.new("mcd.b27l7.b2", "mcd", at="lhclength-(-1288.6652+(56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252473.0, assembly_id=103421.0))
lhcb2.new("mb.c27l7.b2", "mb", at="lhclength-(-1281.1807+(55.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840810.0, assembly_id=103421.0))
lhcb2.new("mcs.c27l7.b2", "mcs", at="lhclength-(-1273.7567+(55-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247174.0, assembly_id=103421.0))
lhcb2.new("mb.b27l7.b2", "mb", at="lhclength-(-1265.5207+(54.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840834.0, assembly_id=103422.0))
lhcb2.new("mcs.b27l7.b2", "mcs", at="lhclength-(-1258.0967+(54-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247177.0, assembly_id=103422.0))
lhcb2.new("mco.a27l7.b2", "mco", at="lhclength-(-1257.3467+(54-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252476.0, assembly_id=103423.0))
lhcb2.new("mcd.a27l7.b2", "mcd", at="lhclength-(-1257.3452+(54-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252477.0, assembly_id=103423.0))
lhcb2.new("mb.a27l7.b2", "mb", at="lhclength-(-1249.8607+(53.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840858.0, assembly_id=103423.0))
lhcb2.new("mcs.a27l7.b2", "mcs", at="lhclength-(-1242.4367+(53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247182.0, assembly_id=103423.0))
lhcb2.new("bpm.26l7.b2", "bpm", at="lhclength-(-1241.5577+(53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247184.0, assembly_id=103424.0))
lhcb2.new("mo.26l7.b2", "mo", at="lhclength-(-1240.8067+(53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308904.0, assembly_id=103424.0))
lhcb2.new("mq.26l7.b2", "mq", at="lhclength-(-1238.7957+(53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308166.0, assembly_id=103424.0))
lhcb2.new("ms.26l7.b2", "ms", at="lhclength-(-1236.9007+(53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252479.0, assembly_id=103424.0))
lhcb2.new("mcbv.26l7.b2", "mcbv", at="lhclength-(-1236.3077+(53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252481.0, assembly_id=103424.0))
lhcb2.new("mb.c26l7.b2", "mb", at="lhclength-(-1227.7307+(52.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840882.0, assembly_id=103425.0))
lhcb2.new("mcs.c26l7.b2", "mcs", at="lhclength-(-1220.3067+(52-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247190.0, assembly_id=103425.0))
lhcb2.new("mco.26l7.b2", "mco", at="lhclength-(-1219.5567+(52-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252484.0, assembly_id=103426.0))
lhcb2.new("mcd.26l7.b2", "mcd", at="lhclength-(-1219.5552+(52-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252485.0, assembly_id=103426.0))
lhcb2.new("mb.b26l7.b2", "mb", at="lhclength-(-1212.0707+(51.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840906.0, assembly_id=103426.0))
lhcb2.new("mcs.b26l7.b2", "mcs", at="lhclength-(-1204.6467+(51-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247195.0, assembly_id=103426.0))
lhcb2.new("mb.a26l7.b2", "mb", at="lhclength-(-1196.4107+(50.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840930.0, assembly_id=103427.0))
lhcb2.new("mcs.a26l7.b2", "mcs", at="lhclength-(-1188.9867+(50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247198.0, assembly_id=103427.0))
lhcb2.new("bpm.25l7.b2", "bpm", at="lhclength-(-1188.1077+(50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247200.0, assembly_id=103428.0))
lhcb2.new("mo.25l7.b2", "mo", at="lhclength-(-1187.3567+(50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308872.0, assembly_id=103428.0))
lhcb2.new("mq.25l7.b2", "mq", at="lhclength-(-1185.3457+(50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308135.0, assembly_id=103428.0))
lhcb2.new("ms.25l7.b2", "ms", at="lhclength-(-1183.4507+(50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252487.0, assembly_id=103428.0))
lhcb2.new("mcbh.25l7.b2", "mcbh", at="lhclength-(-1182.8577+(50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252489.0, assembly_id=103428.0))
lhcb2.new("mco.b25l7.b2", "mco", at="lhclength-(-1181.7667+(50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252492.0, assembly_id=103429.0))
lhcb2.new("mcd.b25l7.b2", "mcd", at="lhclength-(-1181.7652+(50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252493.0, assembly_id=103429.0))
lhcb2.new("mb.c25l7.b2", "mb", at="lhclength-(-1174.2807+(49.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840954.0, assembly_id=103429.0))
lhcb2.new("mcs.c25l7.b2", "mcs", at="lhclength-(-1166.8567+(49-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247208.0, assembly_id=103429.0))
lhcb2.new("mb.b25l7.b2", "mb", at="lhclength-(-1158.6207+(48.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52840978.0, assembly_id=103430.0))
lhcb2.new("mcs.b25l7.b2", "mcs", at="lhclength-(-1151.1967+(48-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247211.0, assembly_id=103430.0))
lhcb2.new("mco.a25l7.b2", "mco", at="lhclength-(-1150.4467+(48-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252496.0, assembly_id=103431.0))
lhcb2.new("mcd.a25l7.b2", "mcd", at="lhclength-(-1150.4452+(48-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252497.0, assembly_id=103431.0))
lhcb2.new("mb.a25l7.b2", "mb", at="lhclength-(-1142.9607+(47.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841002.0, assembly_id=103431.0))
lhcb2.new("mcs.a25l7.b2", "mcs", at="lhclength-(-1135.5367+(47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247216.0, assembly_id=103431.0))
lhcb2.new("bpm.24l7.b2", "bpm", at="lhclength-(-1134.6577+(47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247218.0, assembly_id=103432.0))
lhcb2.new("mo.24l7.b2", "mo", at="lhclength-(-1133.9067+(47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308840.0, assembly_id=103432.0))
lhcb2.new("mq.24l7.b2", "mq", at="lhclength-(-1131.8957+(47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308103.0, assembly_id=103432.0))
lhcb2.new("ms.24l7.b2", "ms", at="lhclength-(-1130.0007+(47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252499.0, assembly_id=103432.0))
lhcb2.new("mcbv.24l7.b2", "mcbv", at="lhclength-(-1129.4077+(47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252501.0, assembly_id=103432.0))
lhcb2.new("mb.c24l7.b2", "mb", at="lhclength-(-1120.8307+(46.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841026.0, assembly_id=103433.0))
lhcb2.new("mcs.c24l7.b2", "mcs", at="lhclength-(-1113.4067+(46-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247224.0, assembly_id=103433.0))
lhcb2.new("mco.24l7.b2", "mco", at="lhclength-(-1112.6567+(46-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252504.0, assembly_id=103434.0))
lhcb2.new("mcd.24l7.b2", "mcd", at="lhclength-(-1112.6552+(46-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252505.0, assembly_id=103434.0))
lhcb2.new("mb.b24l7.b2", "mb", at="lhclength-(-1105.1707+(45.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841050.0, assembly_id=103434.0))
lhcb2.new("mcs.b24l7.b2", "mcs", at="lhclength-(-1097.7467+(45-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247229.0, assembly_id=103434.0))
lhcb2.new("mb.a24l7.b2", "mb", at="lhclength-(-1089.5107+(44.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841074.0, assembly_id=103435.0))
lhcb2.new("mcs.a24l7.b2", "mcs", at="lhclength-(-1082.0867+(44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247232.0, assembly_id=103435.0))
lhcb2.new("bpm.23l7.b2", "bpm", at="lhclength-(-1081.2077+(44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247234.0, assembly_id=103436.0))
lhcb2.new("mqs.23l7.b2", "mqs", at="lhclength-(-1080.4537+(44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307633.0, assembly_id=103436.0))
lhcb2.new("mq.23l7.b2", "mq", at="lhclength-(-1078.4457+(44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308313.0, assembly_id=103436.0))
lhcb2.new("ms.23l7.b2", "ms", at="lhclength-(-1076.5507+(44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252507.0, assembly_id=103436.0))
lhcb2.new("mcbh.23l7.b2", "mcbh", at="lhclength-(-1075.9577+(44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252509.0, assembly_id=103436.0))
lhcb2.new("mco.b23l7.b2", "mco", at="lhclength-(-1074.8667+(44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252512.0, assembly_id=103437.0))
lhcb2.new("mcd.b23l7.b2", "mcd", at="lhclength-(-1074.8652+(44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252513.0, assembly_id=103437.0))
lhcb2.new("mb.c23l7.b2", "mb", at="lhclength-(-1067.3807+(43.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841098.0, assembly_id=103437.0))
lhcb2.new("mcs.c23l7.b2", "mcs", at="lhclength-(-1059.9567+(43-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247242.0, assembly_id=103437.0))
lhcb2.new("mb.b23l7.b2", "mb", at="lhclength-(-1051.7207+(42.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841122.0, assembly_id=103438.0))
lhcb2.new("mcs.b23l7.b2", "mcs", at="lhclength-(-1044.2967+(42-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247245.0, assembly_id=103438.0))
lhcb2.new("mco.a23l7.b2", "mco", at="lhclength-(-1043.5467+(42-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252516.0, assembly_id=103439.0))
lhcb2.new("mcd.a23l7.b2", "mcd", at="lhclength-(-1043.5452+(42-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252517.0, assembly_id=103439.0))
lhcb2.new("mb.a23l7.b2", "mb", at="lhclength-(-1036.0607+(41.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841146.0, assembly_id=103439.0))
lhcb2.new("mcs.a23l7.b2", "mcs", at="lhclength-(-1028.6367+(41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247250.0, assembly_id=103439.0))
lhcb2.new("bpm.22l7.b2", "bpm", at="lhclength-(-1027.7577+(41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247252.0, assembly_id=103440.0))
lhcb2.new("mo.22l7.b2", "mo", at="lhclength-(-1027.0067+(41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308811.0, assembly_id=103440.0))
lhcb2.new("mq.22l7.b2", "mq", at="lhclength-(-1024.9957+(41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308282.0, assembly_id=103440.0))
lhcb2.new("ms.22l7.b2", "ms", at="lhclength-(-1023.1007+(41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252519.0, assembly_id=103440.0))
lhcb2.new("mcbv.22l7.b2", "mcbv", at="lhclength-(-1022.5077+(41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252521.0, assembly_id=103440.0))
lhcb2.new("mb.c22l7.b2", "mb", at="lhclength-(-1013.9307+(40.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841170.0, assembly_id=103441.0))
lhcb2.new("mcs.c22l7.b2", "mcs", at="lhclength-(-1006.5067+(40-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247258.0, assembly_id=103441.0))
lhcb2.new("mco.22l7.b2", "mco", at="lhclength-(-1005.7567+(40-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252524.0, assembly_id=103442.0))
lhcb2.new("mcd.22l7.b2", "mcd", at="lhclength-(-1005.7552+(40-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252525.0, assembly_id=103442.0))
lhcb2.new("mb.b22l7.b2", "mb", at="lhclength-(-998.2707+(39.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841194.0, assembly_id=103442.0))
lhcb2.new("mcs.b22l7.b2", "mcs", at="lhclength-(-990.8467+(39-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247263.0, assembly_id=103442.0))
lhcb2.new("mb.a22l7.b2", "mb", at="lhclength-(-982.6107+(38.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841218.0, assembly_id=103443.0))
lhcb2.new("mcs.a22l7.b2", "mcs", at="lhclength-(-975.1867+(38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247266.0, assembly_id=103443.0))
lhcb2.new("bpm.21l7.b2", "bpm", at="lhclength-(-974.3077+(38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247268.0, assembly_id=103444.0))
lhcb2.new("mqt.21l7.b2", "mqt", at="lhclength-(-973.5537+(38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307266.0, assembly_id=103444.0))
lhcb2.new("mq.21l7.b2", "mq", at="lhclength-(-971.5457+(38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308250.0, assembly_id=103444.0))
lhcb2.new("ms.21l7.b2", "ms", at="lhclength-(-969.6507+(38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252527.0, assembly_id=103444.0))
lhcb2.new("mcbh.21l7.b2", "mcbh", at="lhclength-(-969.0577+(38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252529.0, assembly_id=103444.0))
lhcb2.new("mco.b21l7.b2", "mco", at="lhclength-(-967.9667+(38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252532.0, assembly_id=103445.0))
lhcb2.new("mcd.b21l7.b2", "mcd", at="lhclength-(-967.9652+(38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252533.0, assembly_id=103445.0))
lhcb2.new("mb.c21l7.b2", "mb", at="lhclength-(-960.4807+(37.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841242.0, assembly_id=103445.0))
lhcb2.new("mcs.c21l7.b2", "mcs", at="lhclength-(-953.0567+(37-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247276.0, assembly_id=103445.0))
lhcb2.new("mb.b21l7.b2", "mb", at="lhclength-(-944.8207+(36.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841266.0, assembly_id=103446.0))
lhcb2.new("mcs.b21l7.b2", "mcs", at="lhclength-(-937.3967+(36-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247279.0, assembly_id=103446.0))
lhcb2.new("mco.a21l7.b2", "mco", at="lhclength-(-936.6467+(36-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252536.0, assembly_id=103447.0))
lhcb2.new("mcd.a21l7.b2", "mcd", at="lhclength-(-936.6452+(36-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252537.0, assembly_id=103447.0))
lhcb2.new("mb.a21l7.b2", "mb", at="lhclength-(-929.1607+(35.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841290.0, assembly_id=103447.0))
lhcb2.new("mcs.a21l7.b2", "mcs", at="lhclength-(-921.7367+(35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247284.0, assembly_id=103447.0))
lhcb2.new("bpm.20l7.b2", "bpm", at="lhclength-(-920.8577+(35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247286.0, assembly_id=103448.0))
lhcb2.new("mqt.20l7.b2", "mqt", at="lhclength-(-920.1037+(35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307469.0, assembly_id=103448.0))
lhcb2.new("mq.20l7.b2", "mq", at="lhclength-(-918.0957+(35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308220.0, assembly_id=103448.0))
lhcb2.new("ms.20l7.b2", "ms", at="lhclength-(-916.2007+(35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252539.0, assembly_id=103448.0))
lhcb2.new("mcbv.20l7.b2", "mcbv", at="lhclength-(-915.6077+(35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252541.0, assembly_id=103448.0))
lhcb2.new("mb.c20l7.b2", "mb", at="lhclength-(-907.0307+(34.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841314.0, assembly_id=103449.0))
lhcb2.new("mcs.c20l7.b2", "mcs", at="lhclength-(-899.6067+(34-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247292.0, assembly_id=103449.0))
lhcb2.new("mco.20l7.b2", "mco", at="lhclength-(-898.8567+(34-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252544.0, assembly_id=103450.0))
lhcb2.new("mcd.20l7.b2", "mcd", at="lhclength-(-898.8552+(34-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252545.0, assembly_id=103450.0))
lhcb2.new("mb.b20l7.b2", "mb", at="lhclength-(-891.3707+(33.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841338.0, assembly_id=103450.0))
lhcb2.new("mcs.b20l7.b2", "mcs", at="lhclength-(-883.9467+(33-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247297.0, assembly_id=103450.0))
lhcb2.new("mb.a20l7.b2", "mb", at="lhclength-(-875.7107+(32.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841362.0, assembly_id=103451.0))
lhcb2.new("mcs.a20l7.b2", "mcs", at="lhclength-(-868.2867+(32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247300.0, assembly_id=103451.0))
lhcb2.new("bpm.19l7.b2", "bpm", at="lhclength-(-867.4077+(32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=266535.0, assembly_id=103452.0))
lhcb2.new("mqt.19l7.b2", "mqt", at="lhclength-(-866.6537+(32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307439.0, assembly_id=103452.0))
lhcb2.new("mq.19l7.b2", "mq", at="lhclength-(-864.6457+(32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308429.0, assembly_id=103452.0))
lhcb2.new("ms.19l7.b2", "ms", at="lhclength-(-862.7507+(32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252547.0, assembly_id=103452.0))
lhcb2.new("mcbh.19l7.b2", "mcbh", at="lhclength-(-862.1577+(32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252549.0, assembly_id=103452.0))
lhcb2.new("mco.b19l7.b2", "mco", at="lhclength-(-861.0667+(32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252552.0, assembly_id=103453.0))
lhcb2.new("mcd.b19l7.b2", "mcd", at="lhclength-(-861.0652+(32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252553.0, assembly_id=103453.0))
lhcb2.new("mb.c19l7.b2", "mb", at="lhclength-(-853.5807+(31.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841386.0, assembly_id=103453.0))
lhcb2.new("mcs.c19l7.b2", "mcs", at="lhclength-(-846.1567+(31-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247308.0, assembly_id=103453.0))
lhcb2.new("mb.b19l7.b2", "mb", at="lhclength-(-837.9207+(30.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841410.0, assembly_id=103454.0))
lhcb2.new("mcs.b19l7.b2", "mcs", at="lhclength-(-830.4967+(30-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247311.0, assembly_id=103454.0))
lhcb2.new("mco.a19l7.b2", "mco", at="lhclength-(-829.7467+(30-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252556.0, assembly_id=103455.0))
lhcb2.new("mcd.a19l7.b2", "mcd", at="lhclength-(-829.7452+(30-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252557.0, assembly_id=103455.0))
lhcb2.new("mb.a19l7.b2", "mb", at="lhclength-(-822.2607+(29.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841434.0, assembly_id=103455.0))
lhcb2.new("mcs.a19l7.b2", "mcs", at="lhclength-(-814.8367+(29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247316.0, assembly_id=103455.0))
lhcb2.new("bpm.18l7.b2", "bpm", at="lhclength-(-813.9577+(29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247318.0, assembly_id=103456.0))
lhcb2.new("mqt.18l7.b2", "mqt", at="lhclength-(-813.2037+(29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307408.0, assembly_id=103456.0))
lhcb2.new("mq.18l7.b2", "mq", at="lhclength-(-811.1957+(29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308397.0, assembly_id=103456.0))
lhcb2.new("ms.18l7.b2", "ms", at="lhclength-(-809.3007+(29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252559.0, assembly_id=103456.0))
lhcb2.new("mcbv.18l7.b2", "mcbv", at="lhclength-(-808.7077+(29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252561.0, assembly_id=103456.0))
lhcb2.new("mb.c18l7.b2", "mb", at="lhclength-(-800.1307+(28.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841458.0, assembly_id=103457.0))
lhcb2.new("mcs.c18l7.b2", "mcs", at="lhclength-(-792.7067+(28-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247324.0, assembly_id=103457.0))
lhcb2.new("mco.18l7.b2", "mco", at="lhclength-(-791.9567+(28-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252564.0, assembly_id=103458.0))
lhcb2.new("mcd.18l7.b2", "mcd", at="lhclength-(-791.9552+(28-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252565.0, assembly_id=103458.0))
lhcb2.new("mb.b18l7.b2", "mb", at="lhclength-(-784.4707+(27.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841482.0, assembly_id=103458.0))
lhcb2.new("mcs.b18l7.b2", "mcs", at="lhclength-(-777.0467+(27-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247329.0, assembly_id=103458.0))
lhcb2.new("mb.a18l7.b2", "mb", at="lhclength-(-768.8107+(26.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841506.0, assembly_id=103459.0))
lhcb2.new("mcs.a18l7.b2", "mcs", at="lhclength-(-761.3867+(26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247332.0, assembly_id=103459.0))
lhcb2.new("bpm.17l7.b2", "bpm", at="lhclength-(-760.5077+(26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247334.0, assembly_id=103460.0))
lhcb2.new("mqt.17l7.b2", "mqt", at="lhclength-(-759.7537+(26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307376.0, assembly_id=103460.0))
lhcb2.new("mq.17l7.b2", "mq", at="lhclength-(-757.7457+(26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308367.0, assembly_id=103460.0))
lhcb2.new("ms.17l7.b2", "ms", at="lhclength-(-755.8507+(26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252567.0, assembly_id=103460.0))
lhcb2.new("mcbh.17l7.b2", "mcbh", at="lhclength-(-755.2577+(26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252569.0, assembly_id=103460.0))
lhcb2.new("mco.b17l7.b2", "mco", at="lhclength-(-754.1667+(26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252572.0, assembly_id=103461.0))
lhcb2.new("mcd.b17l7.b2", "mcd", at="lhclength-(-754.1652+(26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252573.0, assembly_id=103461.0))
lhcb2.new("mb.c17l7.b2", "mb", at="lhclength-(-746.6807+(25.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841530.0, assembly_id=103461.0))
lhcb2.new("mcs.c17l7.b2", "mcs", at="lhclength-(-739.2567+(25-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247342.0, assembly_id=103461.0))
lhcb2.new("mb.b17l7.b2", "mb", at="lhclength-(-731.0207+(24.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841554.0, assembly_id=103462.0))
lhcb2.new("mcs.b17l7.b2", "mcs", at="lhclength-(-723.5967+(24-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247345.0, assembly_id=103462.0))
lhcb2.new("mco.a17l7.b2", "mco", at="lhclength-(-722.8467+(24-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252576.0, assembly_id=103463.0))
lhcb2.new("mcd.a17l7.b2", "mcd", at="lhclength-(-722.8452+(24-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252577.0, assembly_id=103463.0))
lhcb2.new("mb.a17l7.b2", "mb", at="lhclength-(-715.3607+(23.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841578.0, assembly_id=103463.0))
lhcb2.new("mcs.a17l7.b2", "mcs", at="lhclength-(-707.9367+(23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247350.0, assembly_id=103463.0))
lhcb2.new("bpm.16l7.b2", "bpm", at="lhclength-(-707.0577+(23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247352.0, assembly_id=103464.0))
lhcb2.new("mqt.16l7.b2", "mqt", at="lhclength-(-706.3037+(23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307583.0, assembly_id=103464.0))
lhcb2.new("mq.16l7.b2", "mq", at="lhclength-(-704.2957+(23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308338.0, assembly_id=103464.0))
lhcb2.new("ms.16l7.b2", "ms", at="lhclength-(-702.4007+(23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252579.0, assembly_id=103464.0))
lhcb2.new("mcbv.16l7.b2", "mcbv", at="lhclength-(-701.8077+(23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252581.0, assembly_id=103464.0))
lhcb2.new("mb.c16l7.b2", "mb", at="lhclength-(-693.2307+(22.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841602.0, assembly_id=103465.0))
lhcb2.new("mcs.c16l7.b2", "mcs", at="lhclength-(-685.8067+(22-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247358.0, assembly_id=103465.0))
lhcb2.new("mco.16l7.b2", "mco", at="lhclength-(-685.0567+(22-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252584.0, assembly_id=103466.0))
lhcb2.new("mcd.16l7.b2", "mcd", at="lhclength-(-685.0552+(22-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252585.0, assembly_id=103466.0))
lhcb2.new("mb.b16l7.b2", "mb", at="lhclength-(-677.5707+(21.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841626.0, assembly_id=103466.0))
lhcb2.new("mcs.b16l7.b2", "mcs", at="lhclength-(-670.1467+(21-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247363.0, assembly_id=103466.0))
lhcb2.new("mb.a16l7.b2", "mb", at="lhclength-(-661.9107+(20.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841650.0, assembly_id=103467.0))
lhcb2.new("mcs.a16l7.b2", "mcs", at="lhclength-(-654.4867+(20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247366.0, assembly_id=103467.0))
lhcb2.new("bpm.15l7.b2", "bpm", at="lhclength-(-653.6077+(20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=266537.0, assembly_id=103468.0))
lhcb2.new("mqt.15l7.b2", "mqt", at="lhclength-(-652.8537+(20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307552.0, assembly_id=103468.0))
lhcb2.new("mq.15l7.b2", "mq", at="lhclength-(-650.8457+(20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308544.0, assembly_id=103468.0))
lhcb2.new("ms.15l7.b2", "ms", at="lhclength-(-648.9507+(20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252587.0, assembly_id=103468.0))
lhcb2.new("mcbh.15l7.b2", "mcbh", at="lhclength-(-648.3577+(20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252589.0, assembly_id=103468.0))
lhcb2.new("mco.b15l7.b2", "mco", at="lhclength-(-647.2667+(20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252592.0, assembly_id=103469.0))
lhcb2.new("mcd.b15l7.b2", "mcd", at="lhclength-(-647.2652+(20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252593.0, assembly_id=103469.0))
lhcb2.new("mb.c15l7.b2", "mb", at="lhclength-(-639.7807+(19.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841674.0, assembly_id=103469.0))
lhcb2.new("mcs.c15l7.b2", "mcs", at="lhclength-(-632.3567+(19-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247374.0, assembly_id=103469.0))
lhcb2.new("mb.b15l7.b2", "mb", at="lhclength-(-624.1207+(18.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841698.0, assembly_id=103470.0))
lhcb2.new("mcs.b15l7.b2", "mcs", at="lhclength-(-616.6967+(18-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247377.0, assembly_id=103470.0))
lhcb2.new("mco.a15l7.b2", "mco", at="lhclength-(-615.9467+(18-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252596.0, assembly_id=103471.0))
lhcb2.new("mcd.a15l7.b2", "mcd", at="lhclength-(-615.9452+(18-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252597.0, assembly_id=103471.0))
lhcb2.new("mb.a15l7.b2", "mb", at="lhclength-(-608.4607+(17.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841722.0, assembly_id=103471.0))
lhcb2.new("mcs.a15l7.b2", "mcs", at="lhclength-(-601.0367+(17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247382.0, assembly_id=103471.0))
lhcb2.new("bpm.14l7.b2", "bpm", at="lhclength-(-600.1577+(17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247384.0, assembly_id=103472.0))
lhcb2.new("mqt.14l7.b2", "mqt", at="lhclength-(-599.4037+(17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307520.0, assembly_id=103472.0))
lhcb2.new("mq.14l7.b2", "mq", at="lhclength-(-597.3957+(17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308514.0, assembly_id=103472.0))
lhcb2.new("ms.14l7.b2", "ms", at="lhclength-(-595.5007+(17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252599.0, assembly_id=103472.0))
lhcb2.new("mcbv.14l7.b2", "mcbv", at="lhclength-(-594.9077+(17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252601.0, assembly_id=103472.0))
lhcb2.new("mb.c14l7.b2", "mb", at="lhclength-(-586.3307+(16.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841746.0, assembly_id=103473.0))
lhcb2.new("mcs.c14l7.b2", "mcs", at="lhclength-(-578.9067+(16-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247390.0, assembly_id=103473.0))
lhcb2.new("mco.14l7.b2", "mco", at="lhclength-(-578.1567+(16-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252604.0, assembly_id=103474.0))
lhcb2.new("mcd.14l7.b2", "mcd", at="lhclength-(-578.1552+(16-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252605.0, assembly_id=103474.0))
lhcb2.new("mb.b14l7.b2", "mb", at="lhclength-(-570.6707+(15.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841770.0, assembly_id=103474.0))
lhcb2.new("mcs.b14l7.b2", "mcs", at="lhclength-(-563.2467+(15-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247395.0, assembly_id=103474.0))
lhcb2.new("mb.a14l7.b2", "mb", at="lhclength-(-555.0107+(14.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841794.0, assembly_id=103475.0))
lhcb2.new("mcs.a14l7.b2", "mcs", at="lhclength-(-547.5867+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247398.0, assembly_id=103475.0))
lhcb2.new("s.ds.l7.b2", "omk", at="lhclength-(-547.1807+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.13l7.b2", "bpm", at="lhclength-(-546.7077+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247400.0, assembly_id=103476.0))
lhcb2.new("mqt.13l7.b2", "mqt", at="lhclength-(-545.9537+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307727.0, assembly_id=103476.0))
lhcb2.new("mq.13l7.b2", "mq", at="lhclength-(-543.9457+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308485.0, assembly_id=103476.0))
lhcb2.new("ms.13l7.b2", "ms", at="lhclength-(-542.0507+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252607.0, assembly_id=103476.0))
lhcb2.new("mcbh.13l7.b2", "mcbh", at="lhclength-(-541.4577+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252609.0, assembly_id=103476.0))
lhcb2.new("mco.b13l7.b2", "mco", at="lhclength-(-540.3667+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252612.0, assembly_id=103477.0))
lhcb2.new("mcd.b13l7.b2", "mcd", at="lhclength-(-540.3652+(14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252613.0, assembly_id=103477.0))
lhcb2.new("mb.c13l7.b2", "mb", at="lhclength-(-532.8807+(13.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841818.0, assembly_id=103477.0))
lhcb2.new("mcs.c13l7.b2", "mcs", at="lhclength-(-525.4567+(13-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247408.0, assembly_id=103477.0))
lhcb2.new("mb.b13l7.b2", "mb", at="lhclength-(-517.2207+(12.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841842.0, assembly_id=103478.0))
lhcb2.new("mcs.b13l7.b2", "mcs", at="lhclength-(-509.7967+(12-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247411.0, assembly_id=103478.0))
lhcb2.new("mco.a13l7.b2", "mco", at="lhclength-(-509.0467+(12-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252616.0, assembly_id=103479.0))
lhcb2.new("mcd.a13l7.b2", "mcd", at="lhclength-(-509.0452+(12-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252617.0, assembly_id=103479.0))
lhcb2.new("mb.a13l7.b2", "mb", at="lhclength-(-501.5607+(11.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841866.0, assembly_id=103479.0))
lhcb2.new("mcs.a13l7.b2", "mcs", at="lhclength-(-494.1367+(11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247416.0, assembly_id=103479.0))
lhcb2.new("bpm.12l7.b2", "bpm", at="lhclength-(-493.2577+(11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247418.0, assembly_id=103480.0))
lhcb2.new("mqt.12l7.b2", "mqt", at="lhclength-(-492.5037+(11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307696.0, assembly_id=103480.0))
lhcb2.new("mq.12l7.b2", "mq", at="lhclength-(-490.4957+(11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308455.0, assembly_id=103480.0))
lhcb2.new("ms.12l7.b2", "ms", at="lhclength-(-488.6007+(11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252619.0, assembly_id=103480.0))
lhcb2.new("mcbv.12l7.b2", "mcbv", at="lhclength-(-488.0077+(11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252621.0, assembly_id=103480.0))
lhcb2.new("mb.c12l7.b2", "mb", at="lhclength-(-479.4307+(10.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841890.0, assembly_id=103481.0))
lhcb2.new("mcs.c12l7.b2", "mcs", at="lhclength-(-472.0067+(10-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247424.0, assembly_id=103481.0))
lhcb2.new("mco.12l7.b2", "mco", at="lhclength-(-471.2567+(10-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252624.0, assembly_id=103482.0))
lhcb2.new("mcd.12l7.b2", "mcd", at="lhclength-(-471.2552+(10-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252625.0, assembly_id=103482.0))
lhcb2.new("mb.b12l7.b2", "mb", at="lhclength-(-463.7707+(9.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841914.0, assembly_id=103482.0))
lhcb2.new("mcs.b12l7.b2", "mcs", at="lhclength-(-456.3467+(9-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247429.0, assembly_id=103482.0))
lhcb2.new("mb.a12l7.b2", "mb", at="lhclength-(-448.1107+(8.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841938.0, assembly_id=103483.0))
lhcb2.new("mcs.a12l7.b2", "mcs", at="lhclength-(-440.6867+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247432.0, assembly_id=103483.0))
lhcb2.new("e.arc.67.b2", "omk", at="lhclength-(-440.2807+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.11l7.b2", "bpm", at="lhclength-(-439.8077+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247434.0, assembly_id=103484.0))
lhcb2.new("mq.11l7.b2", "mq", at="lhclength-(-437.2607+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308662.0, assembly_id=103484.0))
lhcb2.new("mqtli.11l7.b2", "mqtli", at="lhclength-(-434.8917+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307350.0, assembly_id=103484.0))
lhcb2.new("ms.11l7.b2", "ms", at="lhclength-(-433.8797+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252627.0, assembly_id=103484.0))
lhcb2.new("mcbh.11l7.b2", "mcbh", at="lhclength-(-433.2867+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252629.0, assembly_id=103484.0))
lhcb2.new("leir.11l7.b2", "leir", at="lhclength-(-425.67735+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52997958.0, assembly_id=103485.0))
lhcb2.new("mco.11l7.b2", "mco", at="lhclength-(-418.475+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252632.0, assembly_id=103486.0))
lhcb2.new("mcd.11l7.b2", "mcd", at="lhclength-(-418.4735+(8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252633.0, assembly_id=103486.0))
lhcb2.new("mb.b11l7.b2", "mb", at="lhclength-(-410.989+(7.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841962.0, assembly_id=103486.0))
lhcb2.new("mcs.b11l7.b2", "mcs", at="lhclength-(-403.565+(7-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247442.0, assembly_id=103486.0))
lhcb2.new("mb.a11l7.b2", "mb", at="lhclength-(-395.329+(6.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52841986.0, assembly_id=103487.0))
lhcb2.new("mcs.a11l7.b2", "mcs", at="lhclength-(-387.905+(6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247445.0, assembly_id=103487.0))
lhcb2.new("bpm.10l7.b2", "bpm", at="lhclength-(-387.026+(6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247447.0, assembly_id=103488.0))
lhcb2.new("mq.10l7.b2", "mq", at="lhclength-(-384.479+(6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308645.0, assembly_id=103488.0))
lhcb2.new("mqtli.10l7.b2", "mqtli", at="lhclength-(-382.11+(6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307333.0, assembly_id=103488.0))
lhcb2.new("mcbcv.10l7.b2", "mcbcv", at="lhclength-(-380.82+(6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252635.0, assembly_id=103488.0))
lhcb2.new("mco.10l7.b2", "mco", at="lhclength-(-379.41+(6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252638.0, assembly_id=103489.0))
lhcb2.new("mcd.10l7.b2", "mcd", at="lhclength-(-379.4085+(6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252639.0, assembly_id=103489.0))
lhcb2.new("mb.b10l7.b2", "mb", at="lhclength-(-371.924+(5.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842010.0, assembly_id=103489.0))
lhcb2.new("mcs.b10l7.b2", "mcs", at="lhclength-(-364.5+(5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247455.0, assembly_id=103489.0))
lhcb2.new("mb.a10l7.b2", "mb", at="lhclength-(-356.264+(4.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842034.0, assembly_id=103490.0))
lhcb2.new("mcs.a10l7.b2", "mcs", at="lhclength-(-348.84+(4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247458.0, assembly_id=103490.0))
lhcb2.new("bpm.9l7.b2", "bpm", at="lhclength-(-347.96+(4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247460.0, assembly_id=103491.0))
lhcb2.new("mq.9l7.b2", "mq", at="lhclength-(-345.413+(4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307950.0, assembly_id=103491.0))
lhcb2.new("mqtli.b9l7.b2", "mqtli", at="lhclength-(-343.044+(4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307160.0, assembly_id=103491.0))
lhcb2.new("mqtli.a9l7.b2", "mqtli", at="lhclength-(-341.589+(4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307153.0, assembly_id=103491.0))
lhcb2.new("mcbch.9l7.b2", "mcbch", at="lhclength-(-340.299+(4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252641.0, assembly_id=103491.0))
lhcb2.new("mco.9l7.b2", "mco", at="lhclength-(-338.945+(4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252644.0, assembly_id=103492.0))
lhcb2.new("mcd.9l7.b2", "mcd", at="lhclength-(-338.9435+(4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252645.0, assembly_id=103492.0))
lhcb2.new("mb.b9l7.b2", "mb", at="lhclength-(-331.459+(3.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842058.0, assembly_id=103492.0))
lhcb2.new("mcs.b9l7.b2", "mcs", at="lhclength-(-324.035+(3-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247469.0, assembly_id=103492.0))
lhcb2.new("mb.a9l7.b2", "mb", at="lhclength-(-315.799+(2.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842082.0, assembly_id=103493.0))
lhcb2.new("mcs.a9l7.b2", "mcs", at="lhclength-(-308.375+(2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247472.0, assembly_id=103493.0))
lhcb2.new("bpm.8l7.b2", "bpm", at="lhclength-(-307.496+(2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247474.0, assembly_id=103494.0))
lhcb2.new("mq.8l7.b2", "mq", at="lhclength-(-304.949+(2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307942.0, assembly_id=103494.0))
lhcb2.new("mqtli.8l7.b2", "mqtli", at="lhclength-(-302.58+(2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307145.0, assembly_id=103494.0))
lhcb2.new("mcbcv.8l7.b2", "mcbcv", at="lhclength-(-301.29+(2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252647.0, assembly_id=103494.0))
lhcb2.new("mco.8l7.b2", "mco", at="lhclength-(-299.88+(2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252650.0, assembly_id=103495.0))
lhcb2.new("mcd.8l7.b2", "mcd", at="lhclength-(-299.8785+(2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252651.0, assembly_id=103495.0))
lhcb2.new("mb.b8l7.b2", "mb", at="lhclength-(-292.394+(1.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842106.0, assembly_id=103495.0))
lhcb2.new("mcs.b8l7.b2", "mcs", at="lhclength-(-284.97+(1-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247482.0, assembly_id=103495.0))
lhcb2.new("mb.a8l7.b2", "mb", at="lhclength-(-276.734+(.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52849714.0, assembly_id=103496.0))
lhcb2.new("mcs.a8l7.b2", "mcs", at="lhclength-(-269.31+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=357326.0, assembly_id=103496.0))
lhcb2.new("e.ds.l7.b2", "omk", at="lhclength-(-268.904+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.7l7.b2", "bpm", at="lhclength-(-268.431+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247487.0, assembly_id=103497.0))
lhcb2.new("mq.7l7.b2", "mq", at="lhclength-(-265.884+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307935.0, assembly_id=103497.0))
lhcb2.new("mqtli.7l7.b2", "mqtli", at="lhclength-(-263.515+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307371.0, assembly_id=103497.0))
lhcb2.new("mcbch.7l7.b2", "mcbch", at="lhclength-(-262.225+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252653.0, assembly_id=103497.0))
lhcb2.new("dfbam.7l7.b2", "dfbam", at="lhclength-(-260.0715+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52996839.0, assembly_id=104688.0))
lhcb2.new("tcla.a7l7.b2", "tcla", at="lhclength-(-237.698+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=691015.0))
lhcb2.new("bpmr.6l7.b2", "bpmr", at="lhclength-(-233.613+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=378022.0, assembly_id=103498.0))
lhcb2.new("mqtlh.f6l7.b2", "mqtlh", at="lhclength-(-232.243+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2348436.0, assembly_id=103498.0))
lhcb2.new("mqtlh.e6l7.b2", "mqtlh", at="lhclength-(-230.788+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307318.0, assembly_id=103498.0))
lhcb2.new("mqtlh.d6l7.b2", "mqtlh", at="lhclength-(-229.333+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307311.0, assembly_id=103498.0))
lhcb2.new("mqtlh.c6l7.b2", "mqtlh", at="lhclength-(-227.878+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307303.0, assembly_id=103498.0))
lhcb2.new("mqtlh.b6l7.b2", "mqtlh", at="lhclength-(-226.422+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307296.0, assembly_id=103498.0))
lhcb2.new("mqtlh.a6l7.b2", "mqtlh", at="lhclength-(-224.966+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307288.0, assembly_id=103498.0))
lhcb2.new("mcbcv.6l7.b2", "mcbcv", at="lhclength-(-223.675+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252654.0, assembly_id=103498.0))
lhcb2.new("bpmwc.6l7.b2", "bpmwc", at="lhclength-(-221.4345+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=104614.0))
lhcb2.new("tcla.d6l7.b2", "tcla", at="lhclength-(-220.07+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=691014.0))
lhcb2.new("tcla.c6l7.b2", "tcla", at="lhclength-(-218.07+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=691013.0))
lhcb2.new("mbw.d6l7.b2", "mbw", at="lhclength-(-214.413+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52820098.0))
lhcb2.new("mbw.c6l7.b2", "mbw", at="lhclength-(-210.178+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52820122.0))
lhcb2.new("tcla.b6l7.b2", "tcla", at="lhclength-(-184.801+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.2148, slot_id=691012.0))
lhcb2.new("mbw.b6l7.b2", "mbw", at="lhclength-(-175.0235+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52820146.0))
lhcb2.new("mbw.a6l7.b2", "mbw", at="lhclength-(-170.0885+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52820170.0))
lhcb2.new("tcla.a6l7.b2", "tcla", at="lhclength-(-153.927+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=691011.0))
lhcb2.new("bptdh.6l7.b2", "bptdh", at="lhclength-(-149.456+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52650820.0, assembly_id=52431267.0))
lhcb2.new("tcspm.6l7.b2", "tcspm", at="lhclength-(-148.861+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52431267.0))
lhcb2.new("bptuh.6l7.b2", "bptuh", at="lhclength-(-148.266+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52650805.0, assembly_id=52431267.0))
lhcb2.new("bptuv.6l7.b2", "bptuv", at="lhclength-(-148.1755+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52650835.0, assembly_id=52431267.0))
lhcb2.new("tcsg.6l7.b2", "tcsg", at="lhclength-(-146.861+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=281854.0))
lhcb2.new("bpmwe.5l7.b2", "bpmwe003", at="lhclength-(-144.3805+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=297898.0))
lhcb2.new("mqwa.d5l7.b2", "mqwa", at="lhclength-(-138.566+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241715.0))
lhcb2.new("mqwa.c5l7.b2", "mqwa", at="lhclength-(-134.766+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241716.0))
lhcb2.new("mqwa.f5l7.b2", "mqwa", at="lhclength-(-130.966+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52778374.0))
lhcb2.new("mqwa.b5l7.b2", "mqwa", at="lhclength-(-127.166+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241717.0))
lhcb2.new("mqwa.a5l7.b2", "mqwa", at="lhclength-(-123.366+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241718.0))
lhcb2.new("bpmw.5l7.b2", "bpmw_010", at="lhclength-(-121.1755+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=297890.0))
lhcb2.new("mcbwh.5l7.b2", "mcbwh", at="lhclength-(-117.431+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=297887.0))
lhcb2.new("bptdj.e5l7.b2", "bptdj", at="lhclength-(-114.851+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52650775.0, assembly_id=52431144.0))
lhcb2.new("tcspm.e5l7.b2", "tcspm", at="lhclength-(-114.256+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52431144.0))
lhcb2.new("bptuj.e5l7.b2", "bptuj", at="lhclength-(-113.661+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52650760.0, assembly_id=52431144.0))
lhcb2.new("bptut.e5l7.b2", "bptut", at="lhclength-(-113.5705+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52650790.0, assembly_id=52431144.0))
lhcb2.new("tcsg.e5l7.b2", "tcsg", at="lhclength-(-112.256+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=103510.0))
lhcb2.new("tcsg.d5l7.b2", "tcsg", at="lhclength-(-108.256+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=281856.0))
lhcb2.new("tcsg.b5l7.b2", "tcsg", at="lhclength-(-92.256+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=281864.0))
lhcb2.new("bpmwe.4l7.b2", "bpmwe008", at="lhclength-(-86.0905+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=297886.0))
lhcb2.new("mqwa.e4l7.b2", "mqwa", at="lhclength-(-84.076+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241721.0))
lhcb2.new("mqwa.d4l7.b2", "mqwa", at="lhclength-(-80.276+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241722.0))
lhcb2.new("mqwa.c4l7.b2", "mqwa", at="lhclength-(-71.576+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241723.0))
lhcb2.new("mqwb.4l7.b2", "mqwb", at="lhclength-(-67.776+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241720.0))
lhcb2.new("mqwa.b4l7.b2", "mqwa", at="lhclength-(-63.976+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241724.0))
lhcb2.new("mqwa.a4l7.b2", "mqwa", at="lhclength-(-60.176+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241725.0))
lhcb2.new("bpmw.4l7.b2", "bpmw_015", at="lhclength-(-57.9855+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=297876.0))
lhcb2.new("mcbwv.4l7.b2", "mcbwv", at="lhclength-(-54.191+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=297873.0))
lhcb2.new("tcsg.a4l7.b2", "tcsg", at="lhclength-(-9+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=103517.0))
lhcb2.new("ip7", "omk", at="lhclength-(pip7+ip7ofs.b2*ds)")
lhcb2.new("tcsg.a4r7.b2", "tcsg", at="lhclength-(7+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=103521.0))
lhcb2.new("bptdh.b4r7.b2", "bptdh", at="lhclength-(8.405+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52502427.0, assembly_id=52431037.0))
lhcb2.new("tcspm.b4r7.b2", "tcspm", at="lhclength-(9+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52431037.0))
lhcb2.new("bptuh.b4r7.b2", "bptuh", at="lhclength-(9.595+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52502418.0, assembly_id=52431037.0))
lhcb2.new("bptuv.b4r7.b2", "bptuv", at="lhclength-(9.6855+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52502436.0, assembly_id=52431037.0))
lhcb2.new("tcsg.b4r7.b2", "tcsg", at="lhclength-(11+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=103523.0))
lhcb2.new("mcbwh.4r7.b2", "mcbwh", at="lhclength-(56.521+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=134658.0))
lhcb2.new("bpmw.4r7.b2", "bpmw_013", at="lhclength-(58.0615+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=134748.0))
lhcb2.new("mqwa.a4r7.b2", "mqwa", at="lhclength-(60.176+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241728.0))
lhcb2.new("mqwa.b4r7.b2", "mqwa", at="lhclength-(63.976+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241729.0))
lhcb2.new("mqwb.4r7.b2", "mqwb", at="lhclength-(67.776+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241727.0))
lhcb2.new("mqwa.c4r7.b2", "mqwa", at="lhclength-(71.576+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241730.0))
lhcb2.new("bptdv.a4r7.b2", "bptdv", at="lhclength-(74.331+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=39989922.0))
lhcb2.new("tcspm.d4r7.b2", "tcspm", at="lhclength-(74.926+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=53749744.0))
lhcb2.new("bptuv.a4r7.b2", "bptuv", at="lhclength-(75.521+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=39989976.0))
lhcb2.new("bptuh.a4r7.b2", "bptuh", at="lhclength-(75.6115+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=39989924.0))
lhcb2.new("bptdv.d4r7.b2", "bptdv", at="lhclength-(76.331+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52502369.0))
lhcb2.new("tcsg.d4r7.b2", "tcspm", at="lhclength-(76.926+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52431456.0))
lhcb2.new("bptuv.d4r7.b2", "bptuv", at="lhclength-(77.521+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52502360.0))
lhcb2.new("bptuh.d4r7.b2", "bptuh", at="lhclength-(77.6115+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52502378.0))
lhcb2.new("mqwa.d4r7.b2", "mqwa", at="lhclength-(80.276+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241731.0))
lhcb2.new("mqwa.e4r7.b2", "mqwa", at="lhclength-(84.076+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241732.0))
lhcb2.new("bpmwe.4r7.b2", "bpmwe009", at="lhclength-(86.1665+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=134749.0))
lhcb2.new("tcpch.a5r7.b2", "tcpch", at="lhclength-(95.9935+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=281879.0))
lhcb2.new("tcsg.a5r7.b2", "tcsg", at="lhclength-(98.256+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=281880.0))
lhcb2.new("tcsg.b5r7.b2", "tcsg", at="lhclength-(102.256+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=281882.0))
lhcb2.new("mcbwv.5r7.b2", "mcbwv", at="lhclength-(119.761+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=134666.0))
lhcb2.new("bpmw.5r7.b2", "bpmw_014", at="lhclength-(121.2515+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=134750.0))
lhcb2.new("mqwa.a5r7.b2", "mqwa", at="lhclength-(123.366+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241735.0))
lhcb2.new("mqwa.b5r7.b2", "mqwa", at="lhclength-(127.166+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241736.0))
lhcb2.new("mqwa.f5r7.b2", "mqwa", at="lhclength-(130.966+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52778518.0))
lhcb2.new("mqwa.c5r7.b2", "mqwa", at="lhclength-(134.766+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241737.0))
lhcb2.new("mqwa.d5r7.b2", "mqwa", at="lhclength-(138.566+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=241738.0))
lhcb2.new("bpmwe.5r7.b2", "bpmwe007", at="lhclength-(144.4565+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=134751.0))
lhcb2.new("tcapc.6r7.b2", "tcapc", at="lhclength-(145.161+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=820155.0))
lhcb2.new("tcpcv.a6r7.b2", "tcpcv", at="lhclength-(150.5385+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=40086475.0))
lhcb2.new("tcsg.a6r7.b2", "tcsg", at="lhclength-(161.4835+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=103528.0))
lhcb2.new("mbw.a6r7.b2", "mbw", at="lhclength-(170.0885+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52820194.0))
lhcb2.new("tcapb.6r7.b2", "tcapb", at="lhclength-(172.4885+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=820121.0))
lhcb2.new("mbw.b6r7.b2", "mbw", at="lhclength-(175.0235+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.224, slot_id=52820218.0))
lhcb2.new("tcapa.6r7.b2", "tcapa019", at="lhclength-(177.9735+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.222, slot_id=820101.0))
lhcb2.new("tcp.b6r7.b2", "tcp", at="lhclength-(200.978+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.2026, slot_id=281890.0))
lhcb2.new("bptdh.c6r7.b2", "bptdh", at="lhclength-(202.383+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.2014, slot_id=50605684.0, assembly_id=281891.0))
lhcb2.new("tcp.c6r7.b2", "tcppm", at="lhclength-(202.978+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.201, slot_id=281891.0))
lhcb2.new("bptuh.c6r7.b2", "bptuh", at="lhclength-(203.573+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.2005, slot_id=50605686.0, assembly_id=281891.0))
lhcb2.new("bptuv.c6r7.b2", "bptuv", at="lhclength-(203.6635+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.2004, slot_id=50605688.0, assembly_id=281891.0))
lhcb2.new("bptdv.d6r7.b2", "bptdv", at="lhclength-(204.383+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.219, slot_id=50605675.0, assembly_id=281892.0))
lhcb2.new("tcp.d6r7.b2", "tcppm", at="lhclength-(204.978+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.2186, slot_id=281892.0))
lhcb2.new("bptuv.d6r7.b2", "bptuv", at="lhclength-(205.573+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.2181, slot_id=50605679.0, assembly_id=281892.0))
lhcb2.new("bptuh.d6r7.b2", "bptuh", at="lhclength-(205.6635+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.218, slot_id=50605677.0, assembly_id=281892.0))
lhcb2.new("mbw.c6r7.b2", "mbw", at="lhclength-(210.178+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52820242.0))
lhcb2.new("mbw.d6r7.b2", "mbw", at="lhclength-(214.413+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52820266.0))
lhcb2.new("bpm.6r7.b2", "bpm", at="lhclength-(223.596+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=378032.0, assembly_id=103537.0))
lhcb2.new("mqtlh.a6r7.b2", "mqtlh", at="lhclength-(224.966+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307292.0, assembly_id=103537.0))
lhcb2.new("mqtlh.b6r7.b2", "mqtlh", at="lhclength-(226.421+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307299.0, assembly_id=103537.0))
lhcb2.new("mqtlh.c6r7.b2", "mqtlh", at="lhclength-(227.876+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307307.0, assembly_id=103537.0))
lhcb2.new("mqtlh.d6r7.b2", "mqtlh", at="lhclength-(229.331+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307314.0, assembly_id=103537.0))
lhcb2.new("mqtlh.e6r7.b2", "mqtlh", at="lhclength-(230.787+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307322.0, assembly_id=103537.0))
lhcb2.new("mqtlh.f6r7.b2", "mqtlh", at="lhclength-(232.243+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307329.0, assembly_id=103537.0))
lhcb2.new("mcbch.6r7.b2", "mcbch", at="lhclength-(233.534+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252656.0, assembly_id=103537.0))
lhcb2.new("btvsi.a7r7.b2", "btvsi088", at="lhclength-(235.844+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=181629.0))
lhcb2.new("dfban.7r7.b2", "dfban", at="lhclength-(259.8215+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52996863.0, assembly_id=104689.0))
lhcb2.new("bpm_a.7r7.b2", "bpm_a", at="lhclength-(261.632+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=378034.0, assembly_id=103538.0))
lhcb2.new("mq.7r7.b2", "mq", at="lhclength-(264.179+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307939.0, assembly_id=103538.0))
lhcb2.new("mqtli.7r7.b2", "mqtli", at="lhclength-(266.548+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307141.0, assembly_id=103538.0))
lhcb2.new("mcbcv.7r7.b2", "mcbcv", at="lhclength-(267.838+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252659.0, assembly_id=103538.0))
lhcb2.new("s.ds.r7.b2", "omk", at="lhclength-(268.904+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(slot_id=100932.0))
lhcb2.new("mco.8r7.b2", "mco_unplugged", at="lhclength-(269.248+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252662.0, assembly_id=103539.0))
lhcb2.new("mcd.8r7.b2", "mcd", at="lhclength-(269.2495+(0-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252663.0, assembly_id=103539.0))
lhcb2.new("mb.a8r7.b2", "mb", at="lhclength-(276.734+(-.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842130.0, assembly_id=103539.0))
lhcb2.new("mcs.a8r7.b2", "mcs", at="lhclength-(284.158+(-1-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247576.0, assembly_id=103539.0))
lhcb2.new("mb.b8r7.b2", "mb", at="lhclength-(292.394+(-1.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842154.0, assembly_id=103540.0))
lhcb2.new("mcs.b8r7.b2", "mcs", at="lhclength-(299.818+(-2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247579.0, assembly_id=103540.0))
lhcb2.new("bpm.8r7.b2", "bpm", at="lhclength-(300.697+(-2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247581.0, assembly_id=103541.0))
lhcb2.new("mq.8r7.b2", "mq", at="lhclength-(303.244+(-2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307946.0, assembly_id=103541.0))
lhcb2.new("mqtli.8r7.b2", "mqtli", at="lhclength-(305.613+(-2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307149.0, assembly_id=103541.0))
lhcb2.new("mcbch.8r7.b2", "mcbch", at="lhclength-(306.903+(-2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252665.0, assembly_id=103541.0))
lhcb2.new("mco.9r7.b2", "mco_unplugged", at="lhclength-(308.313+(-2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252668.0, assembly_id=103542.0))
lhcb2.new("mcd.9r7.b2", "mcd", at="lhclength-(308.3145+(-2-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252669.0, assembly_id=103542.0))
lhcb2.new("mb.a9r7.b2", "mb", at="lhclength-(315.799+(-2.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842178.0, assembly_id=103542.0))
lhcb2.new("mcs.a9r7.b2", "mcs", at="lhclength-(323.223+(-3-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247589.0, assembly_id=103542.0))
lhcb2.new("mb.b9r7.b2", "mb", at="lhclength-(331.459+(-3.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842202.0, assembly_id=103543.0))
lhcb2.new("mcs.b9r7.b2", "mcs", at="lhclength-(338.883+(-4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247592.0, assembly_id=103543.0))
lhcb2.new("bpm.9r7.b2", "bpm", at="lhclength-(339.763+(-4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247594.0, assembly_id=103544.0))
lhcb2.new("mq.9r7.b2", "mq", at="lhclength-(342.31+(-4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307954.0, assembly_id=103544.0))
lhcb2.new("mqtli.a9r7.b2", "mqtli", at="lhclength-(344.679+(-4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307156.0, assembly_id=103544.0))
lhcb2.new("mqtli.b9r7.b2", "mqtli", at="lhclength-(346.134+(-4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307164.0, assembly_id=103544.0))
lhcb2.new("mcbcv.9r7.b2", "mcbcv", at="lhclength-(347.424+(-4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252671.0, assembly_id=103544.0))
lhcb2.new("mco.10r7.b2", "mco_unplugged", at="lhclength-(348.778+(-4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252674.0, assembly_id=103545.0))
lhcb2.new("mcd.10r7.b2", "mcd", at="lhclength-(348.7795+(-4-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252675.0, assembly_id=103545.0))
lhcb2.new("mb.a10r7.b2", "mb", at="lhclength-(356.264+(-4.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842226.0, assembly_id=103545.0))
lhcb2.new("mcs.a10r7.b2", "mcs", at="lhclength-(363.688+(-5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247603.0, assembly_id=103545.0))
lhcb2.new("mb.b10r7.b2", "mb", at="lhclength-(371.924+(-5.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842250.0, assembly_id=103546.0))
lhcb2.new("mcs.b10r7.b2", "mcs", at="lhclength-(379.348+(-6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247606.0, assembly_id=103546.0))
lhcb2.new("bpm.10r7.b2", "bpm", at="lhclength-(380.227+(-6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247608.0, assembly_id=103547.0))
lhcb2.new("mq.10r7.b2", "mq", at="lhclength-(382.774+(-6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308649.0, assembly_id=103547.0))
lhcb2.new("mqtli.10r7.b2", "mqtli", at="lhclength-(385.143+(-6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307337.0, assembly_id=103547.0))
lhcb2.new("mcbch.10r7.b2", "mcbch", at="lhclength-(386.433+(-6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252677.0, assembly_id=103547.0))
lhcb2.new("mco.11r7.b2", "mco_unplugged", at="lhclength-(387.843+(-6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252680.0, assembly_id=103548.0))
lhcb2.new("mcd.11r7.b2", "mcd", at="lhclength-(387.8445+(-6-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252681.0, assembly_id=103548.0))
lhcb2.new("mb.a11r7.b2", "mb", at="lhclength-(395.329+(-6.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842274.0, assembly_id=103548.0))
lhcb2.new("mcs.a11r7.b2", "mcs", at="lhclength-(402.753+(-7-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247616.0, assembly_id=103548.0))
lhcb2.new("mb.b11r7.b2", "mb", at="lhclength-(410.989+(-7.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842298.0, assembly_id=103549.0))
lhcb2.new("mcs.b11r7.b2", "mcs", at="lhclength-(418.413+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247619.0, assembly_id=103549.0))
lhcb2.new("ledr.11r7.b2", "ledr", at="lhclength-(425.67735+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52997790.0, assembly_id=103550.0))
lhcb2.new("bpm.11r7.b2", "bpm", at="lhclength-(433.0087+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247621.0, assembly_id=103551.0))
lhcb2.new("mq.11r7.b2", "mq", at="lhclength-(435.5557+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2348496.0, assembly_id=103551.0))
lhcb2.new("mqtli.11r7.b2", "mqtli", at="lhclength-(437.9247+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307365.0, assembly_id=103551.0))
lhcb2.new("ms.11r7.b2", "ms", at="lhclength-(438.9367+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252683.0, assembly_id=103551.0))
lhcb2.new("mcbv.11r7.b2", "mcbv", at="lhclength-(439.5297+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252685.0, assembly_id=103551.0))
lhcb2.new("s.arc.78.b2", "omk", at="lhclength-(440.2807+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a12r7.b2", "mco_unplugged", at="lhclength-(440.6247+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252688.0, assembly_id=103552.0))
lhcb2.new("mcd.a12r7.b2", "mcd", at="lhclength-(440.6262+(-8-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252689.0, assembly_id=103552.0))
lhcb2.new("mb.a12r7.b2", "mb", at="lhclength-(448.1107+(-8.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842322.0, assembly_id=103552.0))
lhcb2.new("mcs.a12r7.b2", "mcs", at="lhclength-(455.5347+(-9-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247629.0, assembly_id=103552.0))
lhcb2.new("mb.b12r7.b2", "mb", at="lhclength-(463.7707+(-9.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842346.0, assembly_id=103553.0))
lhcb2.new("mcs.b12r7.b2", "mcs", at="lhclength-(471.1947+(-10-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247632.0, assembly_id=103553.0))
lhcb2.new("mco.b12r7.b2", "mco_unplugged", at="lhclength-(471.9447+(-10-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252692.0, assembly_id=103554.0))
lhcb2.new("mcd.b12r7.b2", "mcd", at="lhclength-(471.9462+(-10-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252693.0, assembly_id=103554.0))
lhcb2.new("mb.c12r7.b2", "mb", at="lhclength-(479.4307+(-10.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842370.0, assembly_id=103554.0))
lhcb2.new("mcs.c12r7.b2", "mcs", at="lhclength-(486.8547+(-11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247637.0, assembly_id=103554.0))
lhcb2.new("bpm.12r7.b2", "bpm", at="lhclength-(487.7337+(-11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247639.0, assembly_id=103555.0))
lhcb2.new("mqt.12r7.b2", "mqt", at="lhclength-(488.4877+(-11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307712.0, assembly_id=103555.0))
lhcb2.new("mq.12r7.b2", "mq", at="lhclength-(490.4957+(-11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308470.0, assembly_id=103555.0))
lhcb2.new("ms.12r7.b2", "ms", at="lhclength-(492.3907+(-11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252695.0, assembly_id=103555.0))
lhcb2.new("mcbh.12r7.b2", "mcbh", at="lhclength-(492.9837+(-11-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252697.0, assembly_id=103555.0))
lhcb2.new("mb.a13r7.b2", "mb", at="lhclength-(501.5607+(-11.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842394.0, assembly_id=103556.0))
lhcb2.new("mcs.a13r7.b2", "mcs", at="lhclength-(508.9847+(-12-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247645.0, assembly_id=103556.0))
lhcb2.new("mco.13r7.b2", "mco_unplugged", at="lhclength-(509.7347+(-12-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252700.0, assembly_id=103557.0))
lhcb2.new("mcd.13r7.b2", "mcd", at="lhclength-(509.7362+(-12-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252701.0, assembly_id=103557.0))
lhcb2.new("mb.b13r7.b2", "mb", at="lhclength-(517.2207+(-12.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842418.0, assembly_id=103557.0))
lhcb2.new("mcs.b13r7.b2", "mcs", at="lhclength-(524.6447+(-13-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247650.0, assembly_id=103557.0))
lhcb2.new("mb.c13r7.b2", "mb", at="lhclength-(532.8807+(-13.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842442.0, assembly_id=103558.0))
lhcb2.new("mcs.c13r7.b2", "mcs", at="lhclength-(540.3047+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247653.0, assembly_id=103558.0))
lhcb2.new("bpm.13r7.b2", "bpm", at="lhclength-(541.1837+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247655.0, assembly_id=103559.0))
lhcb2.new("mqt.13r7.b2", "mqt", at="lhclength-(541.9377+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307504.0, assembly_id=103559.0))
lhcb2.new("mq.13r7.b2", "mq", at="lhclength-(543.9457+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308500.0, assembly_id=103559.0))
lhcb2.new("ms.13r7.b2", "ms", at="lhclength-(545.8407+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252703.0, assembly_id=103559.0))
lhcb2.new("mcbv.13r7.b2", "mcbv", at="lhclength-(546.4337+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252705.0, assembly_id=103559.0))
lhcb2.new("e.ds.r7.b2", "omk", at="lhclength-(547.1807+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a14r7.b2", "mco_unplugged", at="lhclength-(547.5247+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252708.0, assembly_id=103560.0))
lhcb2.new("mcd.a14r7.b2", "mcd", at="lhclength-(547.5262+(-14-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252709.0, assembly_id=103560.0))
lhcb2.new("mb.a14r7.b2", "mb", at="lhclength-(555.0107+(-14.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842466.0, assembly_id=103560.0))
lhcb2.new("mcs.a14r7.b2", "mcs", at="lhclength-(562.4347+(-15-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247663.0, assembly_id=103560.0))
lhcb2.new("mb.b14r7.b2", "mb", at="lhclength-(570.6707+(-15.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842490.0, assembly_id=103561.0))
lhcb2.new("mcs.b14r7.b2", "mcs", at="lhclength-(578.0947+(-16-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247666.0, assembly_id=103561.0))
lhcb2.new("mco.b14r7.b2", "mco_unplugged", at="lhclength-(578.8447+(-16-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252712.0, assembly_id=103562.0))
lhcb2.new("mcd.b14r7.b2", "mcd", at="lhclength-(578.8462+(-16-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252713.0, assembly_id=103562.0))
lhcb2.new("mb.c14r7.b2", "mb", at="lhclength-(586.3307+(-16.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842514.0, assembly_id=103562.0))
lhcb2.new("mcs.c14r7.b2", "mcs", at="lhclength-(593.7547+(-17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247671.0, assembly_id=103562.0))
lhcb2.new("bpm.14r7.b2", "bpm", at="lhclength-(594.6337+(-17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247673.0, assembly_id=103563.0))
lhcb2.new("mqt.14r7.b2", "mqt", at="lhclength-(595.3877+(-17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307536.0, assembly_id=103563.0))
lhcb2.new("mq.14r7.b2", "mq", at="lhclength-(597.3957+(-17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308529.0, assembly_id=103563.0))
lhcb2.new("ms.14r7.b2", "ms", at="lhclength-(599.2907+(-17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252715.0, assembly_id=103563.0))
lhcb2.new("mcbh.14r7.b2", "mcbh", at="lhclength-(599.8837+(-17-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252717.0, assembly_id=103563.0))
lhcb2.new("mb.a15r7.b2", "mb", at="lhclength-(608.4607+(-17.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842538.0, assembly_id=103564.0))
lhcb2.new("mcs.a15r7.b2", "mcs", at="lhclength-(615.8847+(-18-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247679.0, assembly_id=103564.0))
lhcb2.new("mco.15r7.b2", "mco_unplugged", at="lhclength-(616.6347+(-18-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252720.0, assembly_id=103565.0))
lhcb2.new("mcd.15r7.b2", "mcd", at="lhclength-(616.6362+(-18-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252721.0, assembly_id=103565.0))
lhcb2.new("mb.b15r7.b2", "mb", at="lhclength-(624.1207+(-18.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842562.0, assembly_id=103565.0))
lhcb2.new("mcs.b15r7.b2", "mcs", at="lhclength-(631.5447+(-19-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247684.0, assembly_id=103565.0))
lhcb2.new("mb.c15r7.b2", "mb", at="lhclength-(639.7807+(-19.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842586.0, assembly_id=103566.0))
lhcb2.new("mcs.c15r7.b2", "mcs", at="lhclength-(647.2047+(-20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247687.0, assembly_id=103566.0))
lhcb2.new("bpm.15r7.b2", "bpm", at="lhclength-(648.0837+(-20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247689.0, assembly_id=103567.0))
lhcb2.new("mqt.15r7.b2", "mqt", at="lhclength-(648.8377+(-20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307568.0, assembly_id=103567.0))
lhcb2.new("mq.15r7.b2", "mq", at="lhclength-(650.8457+(-20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308560.0, assembly_id=103567.0))
lhcb2.new("ms.15r7.b2", "ms", at="lhclength-(652.7407+(-20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252723.0, assembly_id=103567.0))
lhcb2.new("mcbv.15r7.b2", "mcbv", at="lhclength-(653.3337+(-20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252725.0, assembly_id=103567.0))
lhcb2.new("mco.a16r7.b2", "mco_unplugged", at="lhclength-(654.4247+(-20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252728.0, assembly_id=103568.0))
lhcb2.new("mcd.a16r7.b2", "mcd", at="lhclength-(654.4262+(-20-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252729.0, assembly_id=103568.0))
lhcb2.new("mb.a16r7.b2", "mb", at="lhclength-(661.9107+(-20.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842610.0, assembly_id=103568.0))
lhcb2.new("mcs.a16r7.b2", "mcs", at="lhclength-(669.3347+(-21-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247697.0, assembly_id=103568.0))
lhcb2.new("mb.b16r7.b2", "mb", at="lhclength-(677.5707+(-21.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842634.0, assembly_id=103569.0))
lhcb2.new("mcs.b16r7.b2", "mcs", at="lhclength-(684.9947+(-22-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247700.0, assembly_id=103569.0))
lhcb2.new("mco.b16r7.b2", "mco_unplugged", at="lhclength-(685.7447+(-22-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252732.0, assembly_id=103570.0))
lhcb2.new("mcd.b16r7.b2", "mcd", at="lhclength-(685.7462+(-22-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252733.0, assembly_id=103570.0))
lhcb2.new("mb.c16r7.b2", "mb", at="lhclength-(693.2307+(-22.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842658.0, assembly_id=103570.0))
lhcb2.new("mcs.c16r7.b2", "mcs", at="lhclength-(700.6547+(-23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247705.0, assembly_id=103570.0))
lhcb2.new("bpm.16r7.b2", "bpm", at="lhclength-(701.5337+(-23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247707.0, assembly_id=103571.0))
lhcb2.new("mqt.16r7.b2", "mqt", at="lhclength-(702.2877+(-23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2348447.0, assembly_id=103571.0))
lhcb2.new("mq.16r7.b2", "mq", at="lhclength-(704.2957+(-23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2348480.0, assembly_id=103571.0))
lhcb2.new("ms.16r7.b2", "ms", at="lhclength-(706.1907+(-23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252735.0, assembly_id=103571.0))
lhcb2.new("mcbh.16r7.b2", "mcbh", at="lhclength-(706.7837+(-23-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252737.0, assembly_id=103571.0))
lhcb2.new("mb.a17r7.b2", "mb", at="lhclength-(715.3607+(-23.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842682.0, assembly_id=103572.0))
lhcb2.new("mcs.a17r7.b2", "mcs", at="lhclength-(722.7847+(-24-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247713.0, assembly_id=103572.0))
lhcb2.new("mco.17r7.b2", "mco_unplugged", at="lhclength-(723.5347+(-24-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252740.0, assembly_id=103573.0))
lhcb2.new("mcd.17r7.b2", "mcd", at="lhclength-(723.5362+(-24-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252741.0, assembly_id=103573.0))
lhcb2.new("mb.b17r7.b2", "mb", at="lhclength-(731.0207+(-24.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842706.0, assembly_id=103573.0))
lhcb2.new("mcs.b17r7.b2", "mcs", at="lhclength-(738.4447+(-25-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247718.0, assembly_id=103573.0))
lhcb2.new("mb.c17r7.b2", "mb", at="lhclength-(746.6807+(-25.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842730.0, assembly_id=103574.0))
lhcb2.new("mcs.c17r7.b2", "mcs", at="lhclength-(754.1047+(-26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247721.0, assembly_id=103574.0))
lhcb2.new("bpm.17r7.b2", "bpm", at="lhclength-(754.9837+(-26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247723.0, assembly_id=103575.0))
lhcb2.new("mqt.17r7.b2", "mqt", at="lhclength-(755.7377+(-26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307392.0, assembly_id=103575.0))
lhcb2.new("mq.17r7.b2", "mq", at="lhclength-(757.7457+(-26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308382.0, assembly_id=103575.0))
lhcb2.new("ms.17r7.b2", "ms", at="lhclength-(759.6407+(-26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252743.0, assembly_id=103575.0))
lhcb2.new("mcbv.17r7.b2", "mcbv", at="lhclength-(760.2337+(-26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252745.0, assembly_id=103575.0))
lhcb2.new("mco.a18r7.b2", "mco_unplugged", at="lhclength-(761.3247+(-26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252748.0, assembly_id=103576.0))
lhcb2.new("mcd.a18r7.b2", "mcd", at="lhclength-(761.3262+(-26-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252749.0, assembly_id=103576.0))
lhcb2.new("mb.a18r7.b2", "mb", at="lhclength-(768.8107+(-26.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842754.0, assembly_id=103576.0))
lhcb2.new("mcs.a18r7.b2", "mcs", at="lhclength-(776.2347+(-27-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247731.0, assembly_id=103576.0))
lhcb2.new("mb.b18r7.b2", "mb", at="lhclength-(784.4707+(-27.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842778.0, assembly_id=103577.0))
lhcb2.new("mcs.b18r7.b2", "mcs", at="lhclength-(791.8947+(-28-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247734.0, assembly_id=103577.0))
lhcb2.new("mco.b18r7.b2", "mco_unplugged", at="lhclength-(792.6447+(-28-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252752.0, assembly_id=103578.0))
lhcb2.new("mcd.b18r7.b2", "mcd", at="lhclength-(792.6462+(-28-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252753.0, assembly_id=103578.0))
lhcb2.new("mb.c18r7.b2", "mb", at="lhclength-(800.1307+(-28.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842802.0, assembly_id=103578.0))
lhcb2.new("mcs.c18r7.b2", "mcs", at="lhclength-(807.5547+(-29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247739.0, assembly_id=103578.0))
lhcb2.new("bpm.18r7.b2", "bpm", at="lhclength-(808.4337+(-29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247741.0, assembly_id=103579.0))
lhcb2.new("mqt.18r7.b2", "mqt", at="lhclength-(809.1877+(-29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307424.0, assembly_id=103579.0))
lhcb2.new("mq.18r7.b2", "mq", at="lhclength-(811.1957+(-29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308413.0, assembly_id=103579.0))
lhcb2.new("ms.18r7.b2", "ms", at="lhclength-(813.0907+(-29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252755.0, assembly_id=103579.0))
lhcb2.new("mcbh.18r7.b2", "mcbh", at="lhclength-(813.6837+(-29-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252757.0, assembly_id=103579.0))
lhcb2.new("mb.a19r7.b2", "mb", at="lhclength-(822.2607+(-29.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842826.0, assembly_id=103580.0))
lhcb2.new("mcs.a19r7.b2", "mcs", at="lhclength-(829.6847+(-30-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247747.0, assembly_id=103580.0))
lhcb2.new("mco.19r7.b2", "mco_unplugged", at="lhclength-(830.4347+(-30-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252760.0, assembly_id=103581.0))
lhcb2.new("mcd.19r7.b2", "mcd", at="lhclength-(830.4362+(-30-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252761.0, assembly_id=103581.0))
lhcb2.new("mb.b19r7.b2", "mb", at="lhclength-(837.9207+(-30.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842850.0, assembly_id=103581.0))
lhcb2.new("mcs.b19r7.b2", "mcs", at="lhclength-(845.3447+(-31-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247752.0, assembly_id=103581.0))
lhcb2.new("mb.c19r7.b2", "mb", at="lhclength-(853.5807+(-31.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842874.0, assembly_id=103582.0))
lhcb2.new("mcs.c19r7.b2", "mcs", at="lhclength-(861.0047+(-32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247755.0, assembly_id=103582.0))
lhcb2.new("bpm.19r7.b2", "bpm", at="lhclength-(861.8837+(-32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247757.0, assembly_id=103583.0))
lhcb2.new("mqt.19r7.b2", "mqt", at="lhclength-(862.6377+(-32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307454.0, assembly_id=103583.0))
lhcb2.new("mq.19r7.b2", "mq", at="lhclength-(864.6457+(-32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308445.0, assembly_id=103583.0))
lhcb2.new("ms.19r7.b2", "ms", at="lhclength-(866.5407+(-32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252763.0, assembly_id=103583.0))
lhcb2.new("mcbv.19r7.b2", "mcbv", at="lhclength-(867.1337+(-32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252765.0, assembly_id=103583.0))
lhcb2.new("mco.a20r7.b2", "mco_unplugged", at="lhclength-(868.2247+(-32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252768.0, assembly_id=103584.0))
lhcb2.new("mcd.a20r7.b2", "mcd", at="lhclength-(868.2262+(-32-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252769.0, assembly_id=103584.0))
lhcb2.new("mb.a20r7.b2", "mb", at="lhclength-(875.7107+(-32.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842898.0, assembly_id=103584.0))
lhcb2.new("mcs.a20r7.b2", "mcs", at="lhclength-(883.1347+(-33-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247765.0, assembly_id=103584.0))
lhcb2.new("mb.b20r7.b2", "mb", at="lhclength-(891.3707+(-33.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842922.0, assembly_id=103585.0))
lhcb2.new("mcs.b20r7.b2", "mcs", at="lhclength-(898.7947+(-34-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247768.0, assembly_id=103585.0))
lhcb2.new("mco.b20r7.b2", "mco_unplugged", at="lhclength-(899.5447+(-34-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252772.0, assembly_id=103586.0))
lhcb2.new("mcd.b20r7.b2", "mcd", at="lhclength-(899.5462+(-34-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252773.0, assembly_id=103586.0))
lhcb2.new("mb.c20r7.b2", "mb", at="lhclength-(907.0307+(-34.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842946.0, assembly_id=103586.0))
lhcb2.new("mcs.c20r7.b2", "mcs", at="lhclength-(914.4547+(-35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247773.0, assembly_id=103586.0))
lhcb2.new("bpm.20r7.b2", "bpm", at="lhclength-(915.3337+(-35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247775.0, assembly_id=103587.0))
lhcb2.new("mqt.20r7.b2", "mqt", at="lhclength-(916.0877+(-35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307484.0, assembly_id=103587.0))
lhcb2.new("mq.20r7.b2", "mq", at="lhclength-(918.0957+(-35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308235.0, assembly_id=103587.0))
lhcb2.new("ms.20r7.b2", "ms", at="lhclength-(919.9907+(-35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252775.0, assembly_id=103587.0))
lhcb2.new("mcbh.20r7.b2", "mcbh", at="lhclength-(920.5837+(-35-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252777.0, assembly_id=103587.0))
lhcb2.new("mb.a21r7.b2", "mb", at="lhclength-(929.1607+(-35.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842970.0, assembly_id=103588.0))
lhcb2.new("mcs.a21r7.b2", "mcs", at="lhclength-(936.5847+(-36-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247781.0, assembly_id=103588.0))
lhcb2.new("mco.21r7.b2", "mco_unplugged", at="lhclength-(937.3347+(-36-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252780.0, assembly_id=103589.0))
lhcb2.new("mcd.21r7.b2", "mcd", at="lhclength-(937.3362+(-36-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252781.0, assembly_id=103589.0))
lhcb2.new("mb.b21r7.b2", "mb", at="lhclength-(944.8207+(-36.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52842994.0, assembly_id=103589.0))
lhcb2.new("mcs.b21r7.b2", "mcs", at="lhclength-(952.2447+(-37-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247786.0, assembly_id=103589.0))
lhcb2.new("mb.c21r7.b2", "mb", at="lhclength-(960.4807+(-37.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843018.0, assembly_id=103590.0))
lhcb2.new("mcs.c21r7.b2", "mcs", at="lhclength-(967.9047+(-38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247789.0, assembly_id=103590.0))
lhcb2.new("bpm.21r7.b2", "bpm", at="lhclength-(968.7837+(-38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247791.0, assembly_id=103591.0))
lhcb2.new("mqt.21r7.b2", "mqt", at="lhclength-(969.5377+(-38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307282.0, assembly_id=103591.0))
lhcb2.new("mq.21r7.b2", "mq", at="lhclength-(971.5457+(-38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308266.0, assembly_id=103591.0))
lhcb2.new("ms.21r7.b2", "ms", at="lhclength-(973.4407+(-38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252783.0, assembly_id=103591.0))
lhcb2.new("mcbv.21r7.b2", "mcbv", at="lhclength-(974.0337+(-38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252785.0, assembly_id=103591.0))
lhcb2.new("mco.a22r7.b2", "mco_unplugged", at="lhclength-(975.1247+(-38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252788.0, assembly_id=103592.0))
lhcb2.new("mcd.a22r7.b2", "mcd", at="lhclength-(975.1262+(-38-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252789.0, assembly_id=103592.0))
lhcb2.new("mb.a22r7.b2", "mb", at="lhclength-(982.6107+(-38.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843042.0, assembly_id=103592.0))
lhcb2.new("mcs.a22r7.b2", "mcs", at="lhclength-(990.0347+(-39-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247799.0, assembly_id=103592.0))
lhcb2.new("mb.b22r7.b2", "mb", at="lhclength-(998.2707+(-39.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843066.0, assembly_id=103593.0))
lhcb2.new("mcs.b22r7.b2", "mcs", at="lhclength-(1005.6947+(-40-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247802.0, assembly_id=103593.0))
lhcb2.new("mco.b22r7.b2", "mco_unplugged", at="lhclength-(1006.4447+(-40-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252792.0, assembly_id=103594.0))
lhcb2.new("mcd.b22r7.b2", "mcd", at="lhclength-(1006.4462+(-40-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252793.0, assembly_id=103594.0))
lhcb2.new("mb.c22r7.b2", "mb", at="lhclength-(1013.9307+(-40.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843090.0, assembly_id=103594.0))
lhcb2.new("mcs.c22r7.b2", "mcs", at="lhclength-(1021.3547+(-41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247807.0, assembly_id=103594.0))
lhcb2.new("bpm.22r7.b2", "bpm", at="lhclength-(1022.2337+(-41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247809.0, assembly_id=103595.0))
lhcb2.new("mo.22r7.b2", "mo", at="lhclength-(1022.9847+(-41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308825.0, assembly_id=103595.0))
lhcb2.new("mq.22r7.b2", "mq", at="lhclength-(1024.9957+(-41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308298.0, assembly_id=103595.0))
lhcb2.new("ms.22r7.b2", "ms", at="lhclength-(1026.8907+(-41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252795.0, assembly_id=103595.0))
lhcb2.new("mcbh.22r7.b2", "mcbh", at="lhclength-(1027.4837+(-41-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252797.0, assembly_id=103595.0))
lhcb2.new("mb.a23r7.b2", "mb", at="lhclength-(1036.0607+(-41.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843114.0, assembly_id=103596.0))
lhcb2.new("mcs.a23r7.b2", "mcs", at="lhclength-(1043.4847+(-42-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247815.0, assembly_id=103596.0))
lhcb2.new("mco.23r7.b2", "mco_unplugged", at="lhclength-(1044.2347+(-42-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252800.0, assembly_id=103597.0))
lhcb2.new("mcd.23r7.b2", "mcd", at="lhclength-(1044.2362+(-42-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252801.0, assembly_id=103597.0))
lhcb2.new("mb.b23r7.b2", "mb", at="lhclength-(1051.7207+(-42.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843138.0, assembly_id=103597.0))
lhcb2.new("mcs.b23r7.b2", "mcs", at="lhclength-(1059.1447+(-43-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247820.0, assembly_id=103597.0))
lhcb2.new("mb.c23r7.b2", "mb", at="lhclength-(1067.3807+(-43.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843162.0, assembly_id=103598.0))
lhcb2.new("mcs.c23r7.b2", "mcs", at="lhclength-(1074.8047+(-44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247823.0, assembly_id=103598.0))
lhcb2.new("bpm.23r7.b2", "bpm", at="lhclength-(1075.6837+(-44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247825.0, assembly_id=103599.0))
lhcb2.new("mqs.23r7.b2", "mqs", at="lhclength-(1076.4377+(-44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307648.0, assembly_id=103599.0))
lhcb2.new("mq.23r7.b2", "mq", at="lhclength-(1078.4457+(-44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308087.0, assembly_id=103599.0))
lhcb2.new("ms.23r7.b2", "ms", at="lhclength-(1080.3407+(-44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252803.0, assembly_id=103599.0))
lhcb2.new("mcbv.23r7.b2", "mcbv", at="lhclength-(1080.9337+(-44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252805.0, assembly_id=103599.0))
lhcb2.new("mco.a24r7.b2", "mco_unplugged", at="lhclength-(1082.0247+(-44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252808.0, assembly_id=103600.0))
lhcb2.new("mcd.a24r7.b2", "mcd", at="lhclength-(1082.0262+(-44-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252809.0, assembly_id=103600.0))
lhcb2.new("mb.a24r7.b2", "mb", at="lhclength-(1089.5107+(-44.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843186.0, assembly_id=103600.0))
lhcb2.new("mcs.a24r7.b2", "mcs", at="lhclength-(1096.9347+(-45-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247833.0, assembly_id=103600.0))
lhcb2.new("mb.b24r7.b2", "mb", at="lhclength-(1105.1707+(-45.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843210.0, assembly_id=103601.0))
lhcb2.new("mcs.b24r7.b2", "mcs", at="lhclength-(1112.5947+(-46-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247836.0, assembly_id=103601.0))
lhcb2.new("mco.b24r7.b2", "mco_unplugged", at="lhclength-(1113.3447+(-46-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252812.0, assembly_id=103602.0))
lhcb2.new("mcd.b24r7.b2", "mcd", at="lhclength-(1113.3462+(-46-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252813.0, assembly_id=103602.0))
lhcb2.new("mb.c24r7.b2", "mb", at="lhclength-(1120.8307+(-46.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843234.0, assembly_id=103602.0))
lhcb2.new("mcs.c24r7.b2", "mcs", at="lhclength-(1128.2547+(-47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247841.0, assembly_id=103602.0))
lhcb2.new("bpm.24r7.b2", "bpm", at="lhclength-(1129.1337+(-47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247843.0, assembly_id=103603.0))
lhcb2.new("mo.24r7.b2", "mo", at="lhclength-(1129.8847+(-47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308856.0, assembly_id=103603.0))
lhcb2.new("mq.24r7.b2", "mq", at="lhclength-(1131.8957+(-47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308119.0, assembly_id=103603.0))
lhcb2.new("ms.24r7.b2", "ms", at="lhclength-(1133.7907+(-47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252815.0, assembly_id=103603.0))
lhcb2.new("mcbh.24r7.b2", "mcbh", at="lhclength-(1134.3837+(-47-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252817.0, assembly_id=103603.0))
lhcb2.new("mb.a25r7.b2", "mb", at="lhclength-(1142.9607+(-47.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843258.0, assembly_id=103604.0))
lhcb2.new("mcs.a25r7.b2", "mcs", at="lhclength-(1150.3847+(-48-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247849.0, assembly_id=103604.0))
lhcb2.new("mco.25r7.b2", "mco_unplugged", at="lhclength-(1151.1347+(-48-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252820.0, assembly_id=103605.0))
lhcb2.new("mcd.25r7.b2", "mcd", at="lhclength-(1151.1362+(-48-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252821.0, assembly_id=103605.0))
lhcb2.new("mb.b25r7.b2", "mb", at="lhclength-(1158.6207+(-48.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843282.0, assembly_id=103605.0))
lhcb2.new("mcs.b25r7.b2", "mcs", at="lhclength-(1166.0447+(-49-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247854.0, assembly_id=103605.0))
lhcb2.new("mb.c25r7.b2", "mb", at="lhclength-(1174.2807+(-49.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843306.0, assembly_id=103606.0))
lhcb2.new("mcs.c25r7.b2", "mcs", at="lhclength-(1181.7047+(-50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247857.0, assembly_id=103606.0))
lhcb2.new("bpm.25r7.b2", "bpm", at="lhclength-(1182.5837+(-50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247859.0, assembly_id=103607.0))
lhcb2.new("mo.25r7.b2", "mo", at="lhclength-(1183.3347+(-50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308888.0, assembly_id=103607.0))
lhcb2.new("mq.25r7.b2", "mq", at="lhclength-(1185.3457+(-50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308151.0, assembly_id=103607.0))
lhcb2.new("ms.25r7.b2", "ms", at="lhclength-(1187.2407+(-50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252823.0, assembly_id=103607.0))
lhcb2.new("mcbv.25r7.b2", "mcbv", at="lhclength-(1187.8337+(-50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252825.0, assembly_id=103607.0))
lhcb2.new("mco.a26r7.b2", "mco_unplugged", at="lhclength-(1188.9247+(-50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252828.0, assembly_id=103608.0))
lhcb2.new("mcd.a26r7.b2", "mcd", at="lhclength-(1188.9262+(-50-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252829.0, assembly_id=103608.0))
lhcb2.new("mb.a26r7.b2", "mb", at="lhclength-(1196.4107+(-50.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843330.0, assembly_id=103608.0))
lhcb2.new("mcs.a26r7.b2", "mcs", at="lhclength-(1203.8347+(-51-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247867.0, assembly_id=103608.0))
lhcb2.new("mb.b26r7.b2", "mb", at="lhclength-(1212.0707+(-51.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843354.0, assembly_id=103609.0))
lhcb2.new("mcs.b26r7.b2", "mcs", at="lhclength-(1219.4947+(-52-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247870.0, assembly_id=103609.0))
lhcb2.new("mco.b26r7.b2", "mco_unplugged", at="lhclength-(1220.2447+(-52-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252832.0, assembly_id=103610.0))
lhcb2.new("mcd.b26r7.b2", "mcd", at="lhclength-(1220.2462+(-52-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252833.0, assembly_id=103610.0))
lhcb2.new("mb.c26r7.b2", "mb", at="lhclength-(1227.7307+(-52.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843378.0, assembly_id=103610.0))
lhcb2.new("mcs.c26r7.b2", "mcs", at="lhclength-(1235.1547+(-53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247875.0, assembly_id=103610.0))
lhcb2.new("bpm.26r7.b2", "bpm", at="lhclength-(1236.0337+(-53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247877.0, assembly_id=103611.0))
lhcb2.new("mo.26r7.b2", "mo", at="lhclength-(1236.7847+(-53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308919.0, assembly_id=103611.0))
lhcb2.new("mq.26r7.b2", "mq", at="lhclength-(1238.7957+(-53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308181.0, assembly_id=103611.0))
lhcb2.new("ms.26r7.b2", "ms", at="lhclength-(1240.6907+(-53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252835.0, assembly_id=103611.0))
lhcb2.new("mcbh.26r7.b2", "mcbh", at="lhclength-(1241.2837+(-53-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252837.0, assembly_id=103611.0))
lhcb2.new("mb.a27r7.b2", "mb", at="lhclength-(1249.8607+(-53.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843402.0, assembly_id=103612.0))
lhcb2.new("mcs.a27r7.b2", "mcs", at="lhclength-(1257.2847+(-54-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247883.0, assembly_id=103612.0))
lhcb2.new("mco.27r7.b2", "mco_unplugged", at="lhclength-(1258.0347+(-54-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252840.0, assembly_id=103613.0))
lhcb2.new("mcd.27r7.b2", "mcd", at="lhclength-(1258.0362+(-54-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252841.0, assembly_id=103613.0))
lhcb2.new("mb.b27r7.b2", "mb", at="lhclength-(1265.5207+(-54.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843426.0, assembly_id=103613.0))
lhcb2.new("mcs.b27r7.b2", "mcs", at="lhclength-(1272.9447+(-55-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247888.0, assembly_id=103613.0))
lhcb2.new("mb.c27r7.b2", "mb", at="lhclength-(1281.1807+(-55.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843450.0, assembly_id=103614.0))
lhcb2.new("mcs.c27r7.b2", "mcs_unplugged", at="lhclength-(1288.6047+(-56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247891.0, assembly_id=103614.0))
lhcb2.new("bpm.27r7.b2", "bpm", at="lhclength-(1289.4837+(-56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247893.0, assembly_id=103615.0))
lhcb2.new("mqs.27r7.b2", "mqs", at="lhclength-(1290.2377+(-56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307680.0, assembly_id=103615.0))
lhcb2.new("mq.27r7.b2", "mq", at="lhclength-(1292.2457+(-56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307971.0, assembly_id=103615.0))
lhcb2.new("ms.27r7.b2", "ms", at="lhclength-(1294.1407+(-56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252843.0, assembly_id=103615.0))
lhcb2.new("mcbv.27r7.b2", "mcbv", at="lhclength-(1294.7337+(-56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252845.0, assembly_id=103615.0))
lhcb2.new("mco.a28r7.b2", "mco_unplugged", at="lhclength-(1295.8247+(-56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252848.0, assembly_id=103616.0))
lhcb2.new("mcd.a28r7.b2", "mcd", at="lhclength-(1295.8262+(-56-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252849.0, assembly_id=103616.0))
lhcb2.new("mb.a28r7.b2", "mb", at="lhclength-(1303.3107+(-56.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843474.0, assembly_id=103616.0))
lhcb2.new("mcs.a28r7.b2", "mcs", at="lhclength-(1310.7347+(-57-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247901.0, assembly_id=103616.0))
lhcb2.new("mb.b28r7.b2", "mb", at="lhclength-(1318.9707+(-57.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843498.0, assembly_id=103617.0))
lhcb2.new("mcs.b28r7.b2", "mcs_unplugged", at="lhclength-(1326.3947+(-58-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247904.0, assembly_id=103617.0))
lhcb2.new("mco.b28r7.b2", "mco_unplugged", at="lhclength-(1327.1447+(-58-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252852.0, assembly_id=103618.0))
lhcb2.new("mcd.b28r7.b2", "mcd", at="lhclength-(1327.1462+(-58-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252853.0, assembly_id=103618.0))
lhcb2.new("mb.c28r7.b2", "mb", at="lhclength-(1334.6307+(-58.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843522.0, assembly_id=103618.0))
lhcb2.new("mcs.c28r7.b2", "mcs", at="lhclength-(1342.0547+(-59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247909.0, assembly_id=103618.0))
lhcb2.new("bpm.28r7.b2", "bpm", at="lhclength-(1342.9337+(-59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247911.0, assembly_id=103619.0))
lhcb2.new("mo.28r7.b2", "mo", at="lhclength-(1343.6847+(-59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308709.0, assembly_id=103619.0))
lhcb2.new("mq.28r7.b2", "mq", at="lhclength-(1345.6957+(-59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308003.0, assembly_id=103619.0))
lhcb2.new("ms.28r7.b2", "ms", at="lhclength-(1347.5907+(-59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252855.0, assembly_id=103619.0))
lhcb2.new("mcbh.28r7.b2", "mcbh", at="lhclength-(1348.1837+(-59-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252857.0, assembly_id=103619.0))
lhcb2.new("mb.a29r7.b2", "mb", at="lhclength-(1356.7607+(-59.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843546.0, assembly_id=103620.0))
lhcb2.new("mcs.a29r7.b2", "mcs_unplugged", at="lhclength-(1364.1847+(-60-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247917.0, assembly_id=103620.0))
lhcb2.new("mco.29r7.b2", "mco_unplugged", at="lhclength-(1364.9347+(-60-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252860.0, assembly_id=103621.0))
lhcb2.new("mcd.29r7.b2", "mcd", at="lhclength-(1364.9362+(-60-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252861.0, assembly_id=103621.0))
lhcb2.new("mb.b29r7.b2", "mb", at="lhclength-(1372.4207+(-60.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843570.0, assembly_id=103621.0))
lhcb2.new("mcs.b29r7.b2", "mcs", at="lhclength-(1379.8447+(-61-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247922.0, assembly_id=103621.0))
lhcb2.new("mb.c29r7.b2", "mb", at="lhclength-(1388.0807+(-61.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843594.0, assembly_id=103622.0))
lhcb2.new("mcs.c29r7.b2", "mcs_unplugged", at="lhclength-(1395.5047+(-62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247925.0, assembly_id=103622.0))
lhcb2.new("bpm.29r7.b2", "bpm", at="lhclength-(1396.3837+(-62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247927.0, assembly_id=103623.0))
lhcb2.new("mo.29r7.b2", "mo", at="lhclength-(1397.1347+(-62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308741.0, assembly_id=103623.0))
lhcb2.new("mq.29r7.b2", "mq", at="lhclength-(1399.1457+(-62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308033.0, assembly_id=103623.0))
lhcb2.new("ms.29r7.b2", "ms", at="lhclength-(1401.0407+(-62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252863.0, assembly_id=103623.0))
lhcb2.new("mcbv.29r7.b2", "mcbv", at="lhclength-(1401.6337+(-62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252865.0, assembly_id=103623.0))
lhcb2.new("mco.a30r7.b2", "mco_unplugged", at="lhclength-(1402.7247+(-62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252868.0, assembly_id=103624.0))
lhcb2.new("mcd.a30r7.b2", "mcd", at="lhclength-(1402.7262+(-62-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252869.0, assembly_id=103624.0))
lhcb2.new("mb.a30r7.b2", "mb", at="lhclength-(1410.2107+(-62.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843618.0, assembly_id=103624.0))
lhcb2.new("mcs.a30r7.b2", "mcs", at="lhclength-(1417.6347+(-63-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247935.0, assembly_id=103624.0))
lhcb2.new("mb.b30r7.b2", "mb", at="lhclength-(1425.8707+(-63.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843642.0, assembly_id=103625.0))
lhcb2.new("mcs.b30r7.b2", "mcs", at="lhclength-(1433.2947+(-64-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247938.0, assembly_id=103625.0))
lhcb2.new("mco.b30r7.b2", "mco_unplugged", at="lhclength-(1434.0447+(-64-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252872.0, assembly_id=103626.0))
lhcb2.new("mcd.b30r7.b2", "mcd", at="lhclength-(1434.0462+(-64-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252873.0, assembly_id=103626.0))
lhcb2.new("mb.c30r7.b2", "mb", at="lhclength-(1441.5307+(-64.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843666.0, assembly_id=103626.0))
lhcb2.new("mcs.c30r7.b2", "mcs", at="lhclength-(1448.9547+(-65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247943.0, assembly_id=103626.0))
lhcb2.new("bpm.30r7.b2", "bpm", at="lhclength-(1449.8337+(-65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247945.0, assembly_id=103627.0))
lhcb2.new("mo.30r7.b2", "mo", at="lhclength-(1450.5847+(-65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2348499.0, assembly_id=103627.0))
lhcb2.new("mq.30r7.b2", "mq", at="lhclength-(1452.5957+(-65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308063.0, assembly_id=103627.0))
lhcb2.new("mss.30r7.b2", "mss", at="lhclength-(1454.4907+(-65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252875.0, assembly_id=103627.0))
lhcb2.new("mcbh.30r7.b2", "mcbh", at="lhclength-(1455.0837+(-65-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252877.0, assembly_id=103627.0))
lhcb2.new("mb.a31r7.b2", "mb", at="lhclength-(1463.6607+(-65.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843690.0, assembly_id=103628.0))
lhcb2.new("mcs.a31r7.b2", "mcs", at="lhclength-(1471.0847+(-66-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247951.0, assembly_id=103628.0))
lhcb2.new("mco.31r7.b2", "mco_unplugged", at="lhclength-(1471.8347+(-66-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252880.0, assembly_id=103629.0))
lhcb2.new("mcd.31r7.b2", "mcd", at="lhclength-(1471.8362+(-66-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252881.0, assembly_id=103629.0))
lhcb2.new("mb.b31r7.b2", "mb", at="lhclength-(1479.3207+(-66.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843714.0, assembly_id=103629.0))
lhcb2.new("mcs.b31r7.b2", "mcs", at="lhclength-(1486.7447+(-67-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247956.0, assembly_id=103629.0))
lhcb2.new("mb.c31r7.b2", "mb", at="lhclength-(1494.9807+(-67.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843738.0, assembly_id=103630.0))
lhcb2.new("mcs.c31r7.b2", "mcs", at="lhclength-(1502.4047+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247959.0, assembly_id=103630.0))
lhcb2.new("bpm.31r7.b2", "bpm", at="lhclength-(1503.2837+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247961.0, assembly_id=103631.0))
lhcb2.new("mo.31r7.b2", "mo", at="lhclength-(1504.0347+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308801.0, assembly_id=103631.0))
lhcb2.new("mq.31r7.b2", "mq", at="lhclength-(1506.0457+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307855.0, assembly_id=103631.0))
lhcb2.new("ms.31r7.b2", "ms", at="lhclength-(1507.9407+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252883.0, assembly_id=103631.0))
lhcb2.new("mcbv.31r7.b2", "mcbv", at="lhclength-(1508.5337+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252885.0, assembly_id=103631.0))
lhcb2.new("s.cell.78.b2", "omk", at="lhclength-(1509.2807+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a32r7.b2", "mco_unplugged", at="lhclength-(1509.6247+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252888.0, assembly_id=103632.0))
lhcb2.new("mcd.a32r7.b2", "mcd", at="lhclength-(1509.6262+(-68-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252889.0, assembly_id=103632.0))
lhcb2.new("mb.a32r7.b2", "mb", at="lhclength-(1517.1107+(-68.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843762.0, assembly_id=103632.0))
lhcb2.new("mcs.a32r7.b2", "mcs", at="lhclength-(1524.5347+(-69-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247969.0, assembly_id=103632.0))
lhcb2.new("mb.b32r7.b2", "mb", at="lhclength-(1532.7707+(-69.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843786.0, assembly_id=103633.0))
lhcb2.new("mcs.b32r7.b2", "mcs", at="lhclength-(1540.1947+(-70-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247972.0, assembly_id=103633.0))
lhcb2.new("mco.b32r7.b2", "mco_unplugged", at="lhclength-(1540.9447+(-70-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252892.0, assembly_id=103634.0))
lhcb2.new("mcd.b32r7.b2", "mcd", at="lhclength-(1540.9462+(-70-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252893.0, assembly_id=103634.0))
lhcb2.new("mb.c32r7.b2", "mb", at="lhclength-(1548.4307+(-70.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843810.0, assembly_id=103634.0))
lhcb2.new("mcs.c32r7.b2", "mcs", at="lhclength-(1555.8547+(-71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247977.0, assembly_id=103634.0))
lhcb2.new("bpm.32r7.b2", "bpm", at="lhclength-(1556.7337+(-71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247979.0, assembly_id=103635.0))
lhcb2.new("mo.32r7.b2", "mo", at="lhclength-(1557.4847+(-71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308594.0, assembly_id=103635.0))
lhcb2.new("mq.32r7.b2", "mq", at="lhclength-(1559.4957+(-71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307885.0, assembly_id=103635.0))
lhcb2.new("ms.32r7.b2", "ms", at="lhclength-(1561.3907+(-71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252895.0, assembly_id=103635.0))
lhcb2.new("mcbh.32r7.b2", "mcbh", at="lhclength-(1561.9837+(-71-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252897.0, assembly_id=103635.0))
lhcb2.new("mb.a33r7.b2", "mb", at="lhclength-(1570.5607+(-71.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843834.0, assembly_id=103636.0))
lhcb2.new("mcs.a33r7.b2", "mcs", at="lhclength-(1577.9847+(-72-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247985.0, assembly_id=103636.0))
lhcb2.new("mco.33r7.b2", "mco_unplugged", at="lhclength-(1578.7347+(-72-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252900.0, assembly_id=103637.0))
lhcb2.new("mcd.33r7.b2", "mcd", at="lhclength-(1578.7362+(-72-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252901.0, assembly_id=103637.0))
lhcb2.new("mb.b33r7.b2", "mb", at="lhclength-(1586.2207+(-72.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843858.0, assembly_id=103637.0))
lhcb2.new("mcs.b33r7.b2", "mcs", at="lhclength-(1593.6447+(-73-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247990.0, assembly_id=103637.0))
lhcb2.new("mb.c33r7.b2", "mb", at="lhclength-(1601.8807+(-73.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843882.0, assembly_id=103638.0))
lhcb2.new("mcs.c33r7.b2", "mcs", at="lhclength-(1609.3047+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247993.0, assembly_id=103638.0))
lhcb2.new("bpm.33r7.b2", "bpm", at="lhclength-(1610.1837+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=247995.0, assembly_id=103639.0))
lhcb2.new("mo.33r7.b2", "mo", at="lhclength-(1610.9347+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308624.0, assembly_id=103639.0))
lhcb2.new("mq.33r7.b2", "mq", at="lhclength-(1612.9457+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307914.0, assembly_id=103639.0))
lhcb2.new("ms.33r7.b2", "ms", at="lhclength-(1614.8407+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252903.0, assembly_id=103639.0))
lhcb2.new("mcbv.33r7.b2", "mcbv", at="lhclength-(1615.4337+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252905.0, assembly_id=103639.0))
lhcb2.new("e.cell.78.b2", "omk", at="lhclength-(1616.1807+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a34r7.b2", "mco_unplugged", at="lhclength-(1616.5247+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252908.0, assembly_id=103640.0))
lhcb2.new("mcd.a34r7.b2", "mcd", at="lhclength-(1616.5262+(-74-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252909.0, assembly_id=103640.0))
lhcb2.new("mb.a34r7.b2", "mb", at="lhclength-(1624.0107+(-74.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843906.0, assembly_id=103640.0))
lhcb2.new("mcs.a34r7.b2", "mcs", at="lhclength-(1631.4347+(-75-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=248003.0, assembly_id=103640.0))
lhcb2.new("mb.b34r7.b2", "mb", at="lhclength-(1639.6707+(-75.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843930.0, assembly_id=103641.0))
lhcb2.new("mcs.b34r7.b2", "mcs", at="lhclength-(1647.0947+(-76-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=248006.0, assembly_id=103641.0))
lhcb2.new("mco.b34r7.b2", "mco_unplugged", at="lhclength-(1647.8447+(-76-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252912.0, assembly_id=103642.0))
lhcb2.new("mcd.b34r7.b2", "mcd", at="lhclength-(1647.8462+(-76-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=252913.0, assembly_id=103642.0))
lhcb2.new("mb.c34r7.b2", "mb", at="lhclength-(1655.3307+(-76.5-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=52843954.0, assembly_id=103642.0))
lhcb2.new("mcs.c34r7.b2", "mcs", at="lhclength-(1662.7547+(-77-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=248011.0, assembly_id=103642.0))
lhcb2.new("bpm.34r7.b2", "bpm", at="lhclength-(1663.6337+(-77-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=248013.0, assembly_id=103643.0))
lhcb2.new("mo.34r7.b2", "mo", at="lhclength-(1664.3847+(-77-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2308639.0, assembly_id=103643.0))
lhcb2.new("mq.34r7.b2", "mq", at="lhclength-(1666.3957+(-77-ip7ofs.b2)*ds)", from_="ip7", extra=dict(mech_sep=-0.194, slot_id=2307929.0, assembly_id=103643.0))
lhcb2.new("mss.34l8.b2", "mss", at="lhclength-(-1652.8497+(-77-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252915.0, assembly_id=103643.0))
lhcb2.new("mcbh.34l8.b2", "mcbh", at="lhclength-(-1652.2567+(-77-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252917.0, assembly_id=103643.0))
lhcb2.new("mb.c34l8.b2", "mb", at="lhclength-(-1643.6797+(-77.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52843978.0, assembly_id=103644.0))
lhcb2.new("mcs.c34l8.b2", "mcs", at="lhclength-(-1636.2557+(-78-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248019.0, assembly_id=103644.0))
lhcb2.new("mco.34l8.b2", "mco_unplugged", at="lhclength-(-1635.5057+(-78-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252920.0, assembly_id=103645.0))
lhcb2.new("mcd.34l8.b2", "mcd", at="lhclength-(-1635.5042+(-78-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252921.0, assembly_id=103645.0))
lhcb2.new("mb.b34l8.b2", "mb", at="lhclength-(-1628.0197+(-78.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844002.0, assembly_id=103645.0))
lhcb2.new("mcs.b34l8.b2", "mcs", at="lhclength-(-1620.5957+(-79-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248024.0, assembly_id=103645.0))
lhcb2.new("mb.a34l8.b2", "mb", at="lhclength-(-1612.3597+(-79.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844026.0, assembly_id=103646.0))
lhcb2.new("mcs.a34l8.b2", "mcs", at="lhclength-(-1604.9357+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248027.0, assembly_id=103646.0))
lhcb2.new("bpm.33l8.b2", "bpm", at="lhclength-(-1604.0567+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248029.0, assembly_id=103647.0))
lhcb2.new("mo.33l8.b2", "mo", at="lhclength-(-1603.3057+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308611.0, assembly_id=103647.0))
lhcb2.new("mq.33l8.b2", "mq", at="lhclength-(-1601.2947+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307901.0, assembly_id=103647.0))
lhcb2.new("ms.33l8.b2", "ms", at="lhclength-(-1599.3997+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252923.0, assembly_id=103647.0))
lhcb2.new("mcbv.33l8.b2", "mcbv", at="lhclength-(-1598.8067+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252925.0, assembly_id=103647.0))
lhcb2.new("mco.b33l8.b2", "mco_unplugged", at="lhclength-(-1597.7157+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252928.0, assembly_id=103648.0))
lhcb2.new("mcd.b33l8.b2", "mcd", at="lhclength-(-1597.7142+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252929.0, assembly_id=103648.0))
lhcb2.new("mb.c33l8.b2", "mb", at="lhclength-(-1590.2297+(-80.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844050.0, assembly_id=103648.0))
lhcb2.new("mcs.c33l8.b2", "mcs", at="lhclength-(-1582.8057+(-81-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248037.0, assembly_id=103648.0))
lhcb2.new("mb.b33l8.b2", "mb", at="lhclength-(-1574.5697+(-81.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844074.0, assembly_id=103649.0))
lhcb2.new("mcs.b33l8.b2", "mcs", at="lhclength-(-1567.1457+(-82-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248040.0, assembly_id=103649.0))
lhcb2.new("mco.a33l8.b2", "mco_unplugged", at="lhclength-(-1566.3957+(-82-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252932.0, assembly_id=103650.0))
lhcb2.new("mcd.a33l8.b2", "mcd", at="lhclength-(-1566.3942+(-82-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252933.0, assembly_id=103650.0))
lhcb2.new("mb.a33l8.b2", "mb", at="lhclength-(-1558.9097+(-82.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844098.0, assembly_id=103650.0))
lhcb2.new("mcs.a33l8.b2", "mcs", at="lhclength-(-1551.4857+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248045.0, assembly_id=103650.0))
lhcb2.new("bpm.32l8.b2", "bpm", at="lhclength-(-1550.6067+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248047.0, assembly_id=103651.0))
lhcb2.new("mo.32l8.b2", "mo", at="lhclength-(-1549.8557+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308580.0, assembly_id=103651.0))
lhcb2.new("mq.32l8.b2", "mq", at="lhclength-(-1547.8447+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307872.0, assembly_id=103651.0))
lhcb2.new("mss.32l8.b2", "mss", at="lhclength-(-1545.9497+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252935.0, assembly_id=103651.0))
lhcb2.new("mcbh.32l8.b2", "mcbh", at="lhclength-(-1545.3567+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252937.0, assembly_id=103651.0))
lhcb2.new("mb.c32l8.b2", "mb", at="lhclength-(-1536.7797+(-83.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844122.0, assembly_id=103652.0))
lhcb2.new("mcs.c32l8.b2", "mcs", at="lhclength-(-1529.3557+(-84-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248053.0, assembly_id=103652.0))
lhcb2.new("mco.32l8.b2", "mco_unplugged", at="lhclength-(-1528.6057+(-84-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252940.0, assembly_id=103653.0))
lhcb2.new("mcd.32l8.b2", "mcd", at="lhclength-(-1528.6042+(-84-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252941.0, assembly_id=103653.0))
lhcb2.new("mb.b32l8.b2", "mb", at="lhclength-(-1521.1197+(-84.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844146.0, assembly_id=103653.0))
lhcb2.new("mcs.b32l8.b2", "mcs", at="lhclength-(-1513.6957+(-85-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248058.0, assembly_id=103653.0))
lhcb2.new("mb.a32l8.b2", "mb", at="lhclength-(-1505.4597+(-85.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844170.0, assembly_id=103654.0))
lhcb2.new("mcs.a32l8.b2", "mcs", at="lhclength-(-1498.0357+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248061.0, assembly_id=103654.0))
lhcb2.new("bpm.31l8.b2", "bpm", at="lhclength-(-1497.1567+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248063.0, assembly_id=103655.0))
lhcb2.new("mo.31l8.b2", "mo", at="lhclength-(-1496.4057+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308788.0, assembly_id=103655.0))
lhcb2.new("mq.31l8.b2", "mq", at="lhclength-(-1494.3947+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308080.0, assembly_id=103655.0))
lhcb2.new("ms.31l8.b2", "ms", at="lhclength-(-1492.4997+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252943.0, assembly_id=103655.0))
lhcb2.new("mcbv.31l8.b2", "mcbv", at="lhclength-(-1491.9067+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252945.0, assembly_id=103655.0))
lhcb2.new("mco.b31l8.b2", "mco_unplugged", at="lhclength-(-1490.8157+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252948.0, assembly_id=103656.0))
lhcb2.new("mcd.b31l8.b2", "mcd", at="lhclength-(-1490.8142+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252949.0, assembly_id=103656.0))
lhcb2.new("mb.c31l8.b2", "mb", at="lhclength-(-1483.3297+(-86.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844194.0, assembly_id=103656.0))
lhcb2.new("mcs.c31l8.b2", "mcs", at="lhclength-(-1475.9057+(-87-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248071.0, assembly_id=103656.0))
lhcb2.new("mb.b31l8.b2", "mb", at="lhclength-(-1467.6697+(-87.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844218.0, assembly_id=103657.0))
lhcb2.new("mcs.b31l8.b2", "mcs", at="lhclength-(-1460.2457+(-88-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248074.0, assembly_id=103657.0))
lhcb2.new("mco.a31l8.b2", "mco_unplugged", at="lhclength-(-1459.4957+(-88-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252952.0, assembly_id=103658.0))
lhcb2.new("mcd.a31l8.b2", "mcd", at="lhclength-(-1459.4942+(-88-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252953.0, assembly_id=103658.0))
lhcb2.new("mb.a31l8.b2", "mb", at="lhclength-(-1452.0097+(-88.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844242.0, assembly_id=103658.0))
lhcb2.new("mcs.a31l8.b2", "mcs", at="lhclength-(-1444.5857+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248079.0, assembly_id=103658.0))
lhcb2.new("bpm.30l8.b2", "bpm", at="lhclength-(-1443.7067+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248081.0, assembly_id=103659.0))
lhcb2.new("mo.30l8.b2", "mo", at="lhclength-(-1442.9557+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2348498.0, assembly_id=103659.0))
lhcb2.new("mq.30l8.b2", "mq", at="lhclength-(-1440.9447+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308050.0, assembly_id=103659.0))
lhcb2.new("ms.30l8.b2", "ms", at="lhclength-(-1439.0497+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252955.0, assembly_id=103659.0))
lhcb2.new("mcbh.30l8.b2", "mcbh", at="lhclength-(-1438.4567+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252957.0, assembly_id=103659.0))
lhcb2.new("mb.c30l8.b2", "mb", at="lhclength-(-1429.8797+(-89.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844266.0, assembly_id=103660.0))
lhcb2.new("mcs.c30l8.b2", "mcs", at="lhclength-(-1422.4557+(-90-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248087.0, assembly_id=103660.0))
lhcb2.new("mco.30l8.b2", "mco_unplugged", at="lhclength-(-1421.7057+(-90-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252960.0, assembly_id=103661.0))
lhcb2.new("mcd.30l8.b2", "mcd", at="lhclength-(-1421.7042+(-90-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252961.0, assembly_id=103661.0))
lhcb2.new("mb.b30l8.b2", "mb", at="lhclength-(-1414.2197+(-90.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844290.0, assembly_id=103661.0))
lhcb2.new("mcs.b30l8.b2", "mcs", at="lhclength-(-1406.7957+(-91-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248092.0, assembly_id=103661.0))
lhcb2.new("mb.a30l8.b2", "mb", at="lhclength-(-1398.5597+(-91.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844314.0, assembly_id=103662.0))
lhcb2.new("mcs.a30l8.b2", "mcs", at="lhclength-(-1391.1357+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248095.0, assembly_id=103662.0))
lhcb2.new("bpm.29l8.b2", "bpm", at="lhclength-(-1390.2567+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248097.0, assembly_id=103663.0))
lhcb2.new("mo.29l8.b2", "mo", at="lhclength-(-1389.5057+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308727.0, assembly_id=103663.0))
lhcb2.new("mq.29l8.b2", "mq", at="lhclength-(-1387.4947+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308020.0, assembly_id=103663.0))
lhcb2.new("ms.29l8.b2", "ms", at="lhclength-(-1385.5997+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252963.0, assembly_id=103663.0))
lhcb2.new("mcbv.29l8.b2", "mcbv", at="lhclength-(-1385.0067+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252965.0, assembly_id=103663.0))
lhcb2.new("mco.b29l8.b2", "mco_unplugged", at="lhclength-(-1383.9157+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252968.0, assembly_id=103664.0))
lhcb2.new("mcd.b29l8.b2", "mcd", at="lhclength-(-1383.9142+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252969.0, assembly_id=103664.0))
lhcb2.new("mb.c29l8.b2", "mb", at="lhclength-(-1376.4297+(-92.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844338.0, assembly_id=103664.0))
lhcb2.new("mcs.c29l8.b2", "mcs", at="lhclength-(-1369.0057+(-93-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248105.0, assembly_id=103664.0))
lhcb2.new("mb.b29l8.b2", "mb", at="lhclength-(-1360.7697+(-93.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844362.0, assembly_id=103665.0))
lhcb2.new("mcs.b29l8.b2", "mcs", at="lhclength-(-1353.3457+(-94-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248108.0, assembly_id=103665.0))
lhcb2.new("mco.a29l8.b2", "mco_unplugged", at="lhclength-(-1352.5957+(-94-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252972.0, assembly_id=103666.0))
lhcb2.new("mcd.a29l8.b2", "mcd", at="lhclength-(-1352.5942+(-94-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252973.0, assembly_id=103666.0))
lhcb2.new("mb.a29l8.b2", "mb", at="lhclength-(-1345.1097+(-94.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844386.0, assembly_id=103666.0))
lhcb2.new("mcs.a29l8.b2", "mcs", at="lhclength-(-1337.6857+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248113.0, assembly_id=103666.0))
lhcb2.new("bpm.28l8.b2", "bpm", at="lhclength-(-1336.8067+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248115.0, assembly_id=103667.0))
lhcb2.new("mo.28l8.b2", "mo", at="lhclength-(-1336.0557+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308695.0, assembly_id=103667.0))
lhcb2.new("mq.28l8.b2", "mq", at="lhclength-(-1334.0447+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307989.0, assembly_id=103667.0))
lhcb2.new("mss.28l8.b2", "mss", at="lhclength-(-1332.1497+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252975.0, assembly_id=103667.0))
lhcb2.new("mcbh.28l8.b2", "mcbh", at="lhclength-(-1331.5567+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252977.0, assembly_id=103667.0))
lhcb2.new("mb.c28l8.b2", "mb", at="lhclength-(-1322.9797+(-95.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844410.0, assembly_id=103668.0))
lhcb2.new("mcs.c28l8.b2", "mcs", at="lhclength-(-1315.5557+(-96-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248121.0, assembly_id=103668.0))
lhcb2.new("mco.28l8.b2", "mco_unplugged", at="lhclength-(-1314.8057+(-96-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252980.0, assembly_id=103669.0))
lhcb2.new("mcd.28l8.b2", "mcd", at="lhclength-(-1314.8042+(-96-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252981.0, assembly_id=103669.0))
lhcb2.new("mb.b28l8.b2", "mb", at="lhclength-(-1307.3197+(-96.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844434.0, assembly_id=103669.0))
lhcb2.new("mcs.b28l8.b2", "mcs", at="lhclength-(-1299.8957+(-97-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248126.0, assembly_id=103669.0))
lhcb2.new("mb.a28l8.b2", "mb", at="lhclength-(-1291.6597+(-97.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844458.0, assembly_id=103670.0))
lhcb2.new("mcs.a28l8.b2", "mcs", at="lhclength-(-1284.2357+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248129.0, assembly_id=103670.0))
lhcb2.new("bpm.27l8.b2", "bpm", at="lhclength-(-1283.3567+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248131.0, assembly_id=103671.0))
lhcb2.new("mqs.27l8.b2", "mqs", at="lhclength-(-1282.6027+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307666.0, assembly_id=103671.0))
lhcb2.new("mq.27l8.b2", "mq", at="lhclength-(-1280.5947+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308198.0, assembly_id=103671.0))
lhcb2.new("ms.27l8.b2", "ms", at="lhclength-(-1278.6997+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252983.0, assembly_id=103671.0))
lhcb2.new("mcbv.27l8.b2", "mcbv", at="lhclength-(-1278.1067+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252985.0, assembly_id=103671.0))
lhcb2.new("mco.b27l8.b2", "mco_unplugged", at="lhclength-(-1277.0157+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252988.0, assembly_id=103672.0))
lhcb2.new("mcd.b27l8.b2", "mcd", at="lhclength-(-1277.0142+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252989.0, assembly_id=103672.0))
lhcb2.new("mb.c27l8.b2", "mb", at="lhclength-(-1269.5297+(-98.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844482.0, assembly_id=103672.0))
lhcb2.new("mcs.c27l8.b2", "mcs", at="lhclength-(-1262.1057+(-99-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248139.0, assembly_id=103672.0))
lhcb2.new("mb.b27l8.b2", "mb", at="lhclength-(-1253.8697+(-99.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844506.0, assembly_id=103673.0))
lhcb2.new("mcs.b27l8.b2", "mcs", at="lhclength-(-1246.4457+(-100-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248142.0, assembly_id=103673.0))
lhcb2.new("mco.a27l8.b2", "mco_unplugged", at="lhclength-(-1245.6957+(-100-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252992.0, assembly_id=103674.0))
lhcb2.new("mcd.a27l8.b2", "mcd", at="lhclength-(-1245.6942+(-100-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252993.0, assembly_id=103674.0))
lhcb2.new("mb.a27l8.b2", "mb", at="lhclength-(-1238.2097+(-100.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844530.0, assembly_id=103674.0))
lhcb2.new("mcs.a27l8.b2", "mcs", at="lhclength-(-1230.7857+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248147.0, assembly_id=103674.0))
lhcb2.new("bpm.26l8.b2", "bpm", at="lhclength-(-1229.9067+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248149.0, assembly_id=103675.0))
lhcb2.new("mo.26l8.b2", "mo", at="lhclength-(-1229.1557+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308906.0, assembly_id=103675.0))
lhcb2.new("mq.26l8.b2", "mq", at="lhclength-(-1227.1447+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308168.0, assembly_id=103675.0))
lhcb2.new("ms.26l8.b2", "ms", at="lhclength-(-1225.2497+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252995.0, assembly_id=103675.0))
lhcb2.new("mcbh.26l8.b2", "mcbh", at="lhclength-(-1224.6567+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=252997.0, assembly_id=103675.0))
lhcb2.new("mb.c26l8.b2", "mb", at="lhclength-(-1216.0797+(-101.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844554.0, assembly_id=103676.0))
lhcb2.new("mcs.c26l8.b2", "mcs", at="lhclength-(-1208.6557+(-102-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248155.0, assembly_id=103676.0))
lhcb2.new("mco.26l8.b2", "mco_unplugged", at="lhclength-(-1207.9057+(-102-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253000.0, assembly_id=103677.0))
lhcb2.new("mcd.26l8.b2", "mcd", at="lhclength-(-1207.9042+(-102-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253001.0, assembly_id=103677.0))
lhcb2.new("mb.b26l8.b2", "mb", at="lhclength-(-1200.4197+(-102.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844578.0, assembly_id=103677.0))
lhcb2.new("mcs.b26l8.b2", "mcs", at="lhclength-(-1192.9957+(-103-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248160.0, assembly_id=103677.0))
lhcb2.new("mb.a26l8.b2", "mb", at="lhclength-(-1184.7597+(-103.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844602.0, assembly_id=103678.0))
lhcb2.new("mcs.a26l8.b2", "mcs", at="lhclength-(-1177.3357+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248163.0, assembly_id=103678.0))
lhcb2.new("bpm.25l8.b2", "bpm", at="lhclength-(-1176.4567+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248165.0, assembly_id=103679.0))
lhcb2.new("mo.25l8.b2", "mo", at="lhclength-(-1175.7057+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308874.0, assembly_id=103679.0))
lhcb2.new("mq.25l8.b2", "mq", at="lhclength-(-1173.6947+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308137.0, assembly_id=103679.0))
lhcb2.new("ms.25l8.b2", "ms", at="lhclength-(-1171.7997+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253003.0, assembly_id=103679.0))
lhcb2.new("mcbv.25l8.b2", "mcbv", at="lhclength-(-1171.2067+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253005.0, assembly_id=103679.0))
lhcb2.new("mco.b25l8.b2", "mco_unplugged", at="lhclength-(-1170.1157+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253008.0, assembly_id=103680.0))
lhcb2.new("mcd.b25l8.b2", "mcd", at="lhclength-(-1170.1142+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253009.0, assembly_id=103680.0))
lhcb2.new("mb.c25l8.b2", "mb", at="lhclength-(-1162.6297+(-104.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844626.0, assembly_id=103680.0))
lhcb2.new("mcs.c25l8.b2", "mcs", at="lhclength-(-1155.2057+(-105-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248173.0, assembly_id=103680.0))
lhcb2.new("mb.b25l8.b2", "mb", at="lhclength-(-1146.9697+(-105.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844650.0, assembly_id=103681.0))
lhcb2.new("mcs.b25l8.b2", "mcs", at="lhclength-(-1139.5457+(-106-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248176.0, assembly_id=103681.0))
lhcb2.new("mco.a25l8.b2", "mco_unplugged", at="lhclength-(-1138.7957+(-106-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253012.0, assembly_id=103682.0))
lhcb2.new("mcd.a25l8.b2", "mcd", at="lhclength-(-1138.7942+(-106-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253013.0, assembly_id=103682.0))
lhcb2.new("mb.a25l8.b2", "mb", at="lhclength-(-1131.3097+(-106.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844674.0, assembly_id=103682.0))
lhcb2.new("mcs.a25l8.b2", "mcs", at="lhclength-(-1123.8857+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248181.0, assembly_id=103682.0))
lhcb2.new("bpm.24l8.b2", "bpm", at="lhclength-(-1123.0067+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248183.0, assembly_id=103683.0))
lhcb2.new("mo.24l8.b2", "mo", at="lhclength-(-1122.2557+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308842.0, assembly_id=103683.0))
lhcb2.new("mq.24l8.b2", "mq", at="lhclength-(-1120.2447+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308105.0, assembly_id=103683.0))
lhcb2.new("ms.24l8.b2", "ms", at="lhclength-(-1118.3497+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253015.0, assembly_id=103683.0))
lhcb2.new("mcbh.24l8.b2", "mcbh", at="lhclength-(-1117.7567+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253017.0, assembly_id=103683.0))
lhcb2.new("mb.c24l8.b2", "mb", at="lhclength-(-1109.1797+(-107.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844698.0, assembly_id=103684.0))
lhcb2.new("mcs.c24l8.b2", "mcs", at="lhclength-(-1101.7557+(-108-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248189.0, assembly_id=103684.0))
lhcb2.new("mco.24l8.b2", "mco_unplugged", at="lhclength-(-1101.0057+(-108-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253020.0, assembly_id=103685.0))
lhcb2.new("mcd.24l8.b2", "mcd", at="lhclength-(-1101.0042+(-108-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253021.0, assembly_id=103685.0))
lhcb2.new("mb.b24l8.b2", "mb", at="lhclength-(-1093.5197+(-108.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844722.0, assembly_id=103685.0))
lhcb2.new("mcs.b24l8.b2", "mcs", at="lhclength-(-1086.0957+(-109-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248194.0, assembly_id=103685.0))
lhcb2.new("mb.a24l8.b2", "mb", at="lhclength-(-1077.8597+(-109.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844746.0, assembly_id=103686.0))
lhcb2.new("mcs.a24l8.b2", "mcs", at="lhclength-(-1070.4357+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248197.0, assembly_id=103686.0))
lhcb2.new("bpm.23l8.b2", "bpm", at="lhclength-(-1069.5567+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248199.0, assembly_id=103687.0))
lhcb2.new("mqs.23l8.b2", "mqs", at="lhclength-(-1068.8027+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307635.0, assembly_id=103687.0))
lhcb2.new("mq.23l8.b2", "mq", at="lhclength-(-1066.7947+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308315.0, assembly_id=103687.0))
lhcb2.new("ms.23l8.b2", "ms", at="lhclength-(-1064.8997+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253023.0, assembly_id=103687.0))
lhcb2.new("mcbv.23l8.b2", "mcbv", at="lhclength-(-1064.3067+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253025.0, assembly_id=103687.0))
lhcb2.new("mco.b23l8.b2", "mco_unplugged", at="lhclength-(-1063.2157+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253028.0, assembly_id=103688.0))
lhcb2.new("mcd.b23l8.b2", "mcd", at="lhclength-(-1063.2142+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253029.0, assembly_id=103688.0))
lhcb2.new("mb.c23l8.b2", "mb", at="lhclength-(-1055.7297+(-110.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844770.0, assembly_id=103688.0))
lhcb2.new("mcs.c23l8.b2", "mcs", at="lhclength-(-1048.3057+(-111-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248207.0, assembly_id=103688.0))
lhcb2.new("mb.b23l8.b2", "mb", at="lhclength-(-1040.0697+(-111.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844794.0, assembly_id=103689.0))
lhcb2.new("mcs.b23l8.b2", "mcs", at="lhclength-(-1032.6457+(-112-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248210.0, assembly_id=103689.0))
lhcb2.new("mco.a23l8.b2", "mco_unplugged", at="lhclength-(-1031.8957+(-112-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253032.0, assembly_id=103690.0))
lhcb2.new("mcd.a23l8.b2", "mcd", at="lhclength-(-1031.8942+(-112-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253033.0, assembly_id=103690.0))
lhcb2.new("mb.a23l8.b2", "mb", at="lhclength-(-1024.4097+(-112.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844818.0, assembly_id=103690.0))
lhcb2.new("mcs.a23l8.b2", "mcs", at="lhclength-(-1016.9857+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248215.0, assembly_id=103690.0))
lhcb2.new("bpm.22l8.b2", "bpm", at="lhclength-(-1016.1067+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248217.0, assembly_id=103691.0))
lhcb2.new("mo.22l8.b2", "mo", at="lhclength-(-1015.3557+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308812.0, assembly_id=103691.0))
lhcb2.new("mq.22l8.b2", "mq", at="lhclength-(-1013.3447+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308284.0, assembly_id=103691.0))
lhcb2.new("ms.22l8.b2", "ms", at="lhclength-(-1011.4497+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253035.0, assembly_id=103691.0))
lhcb2.new("mcbh.22l8.b2", "mcbh", at="lhclength-(-1010.8567+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253037.0, assembly_id=103691.0))
lhcb2.new("mb.c22l8.b2", "mb", at="lhclength-(-1002.2797+(-113.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844842.0, assembly_id=103692.0))
lhcb2.new("mcs.c22l8.b2", "mcs", at="lhclength-(-994.8557+(-114-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248223.0, assembly_id=103692.0))
lhcb2.new("mco.22l8.b2", "mco_unplugged", at="lhclength-(-994.1057+(-114-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253040.0, assembly_id=103693.0))
lhcb2.new("mcd.22l8.b2", "mcd", at="lhclength-(-994.1042+(-114-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253041.0, assembly_id=103693.0))
lhcb2.new("mb.b22l8.b2", "mb", at="lhclength-(-986.6197+(-114.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844866.0, assembly_id=103693.0))
lhcb2.new("mcs.b22l8.b2", "mcs", at="lhclength-(-979.1957+(-115-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248228.0, assembly_id=103693.0))
lhcb2.new("mb.a22l8.b2", "mb", at="lhclength-(-970.9597+(-115.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844890.0, assembly_id=103694.0))
lhcb2.new("mcs.a22l8.b2", "mcs", at="lhclength-(-963.5357+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248231.0, assembly_id=103694.0))
lhcb2.new("bpm.21l8.b2", "bpm", at="lhclength-(-962.6567+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248233.0, assembly_id=103695.0))
lhcb2.new("mqt.21l8.b2", "mqt", at="lhclength-(-961.9027+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307268.0, assembly_id=103695.0))
lhcb2.new("mq.21l8.b2", "mq", at="lhclength-(-959.8947+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308252.0, assembly_id=103695.0))
lhcb2.new("ms.21l8.b2", "ms", at="lhclength-(-957.9997+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253043.0, assembly_id=103695.0))
lhcb2.new("mcbv.21l8.b2", "mcbv", at="lhclength-(-957.4067+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253045.0, assembly_id=103695.0))
lhcb2.new("mco.b21l8.b2", "mco_unplugged", at="lhclength-(-956.3157+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253048.0, assembly_id=103696.0))
lhcb2.new("mcd.b21l8.b2", "mcd", at="lhclength-(-956.3142+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253049.0, assembly_id=103696.0))
lhcb2.new("mb.c21l8.b2", "mb", at="lhclength-(-948.8297+(-116.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844914.0, assembly_id=103696.0))
lhcb2.new("mcs.c21l8.b2", "mcs", at="lhclength-(-941.4057+(-117-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248241.0, assembly_id=103696.0))
lhcb2.new("mb.b21l8.b2", "mb", at="lhclength-(-933.1697+(-117.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844938.0, assembly_id=103697.0))
lhcb2.new("mcs.b21l8.b2", "mcs", at="lhclength-(-925.7457+(-118-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248244.0, assembly_id=103697.0))
lhcb2.new("mco.a21l8.b2", "mco_unplugged", at="lhclength-(-924.9957+(-118-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253052.0, assembly_id=103698.0))
lhcb2.new("mcd.a21l8.b2", "mcd", at="lhclength-(-924.9942+(-118-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253053.0, assembly_id=103698.0))
lhcb2.new("mb.a21l8.b2", "mb", at="lhclength-(-917.5097+(-118.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844962.0, assembly_id=103698.0))
lhcb2.new("mcs.a21l8.b2", "mcs", at="lhclength-(-910.0857+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248249.0, assembly_id=103698.0))
lhcb2.new("bpm.20l8.b2", "bpm", at="lhclength-(-909.2067+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248251.0, assembly_id=103699.0))
lhcb2.new("mqt.20l8.b2", "mqt", at="lhclength-(-908.4527+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307471.0, assembly_id=103699.0))
lhcb2.new("mq.20l8.b2", "mq", at="lhclength-(-906.4447+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308222.0, assembly_id=103699.0))
lhcb2.new("ms.20l8.b2", "ms", at="lhclength-(-904.5497+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253055.0, assembly_id=103699.0))
lhcb2.new("mcbh.20l8.b2", "mcbh", at="lhclength-(-903.9567+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253057.0, assembly_id=103699.0))
lhcb2.new("mb.c20l8.b2", "mb", at="lhclength-(-895.3797+(-119.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52844986.0, assembly_id=103700.0))
lhcb2.new("mcs.c20l8.b2", "mcs", at="lhclength-(-887.9557+(-120-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248257.0, assembly_id=103700.0))
lhcb2.new("mco.20l8.b2", "mco_unplugged", at="lhclength-(-887.2057+(-120-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253060.0, assembly_id=103701.0))
lhcb2.new("mcd.20l8.b2", "mcd", at="lhclength-(-887.2042+(-120-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253061.0, assembly_id=103701.0))
lhcb2.new("mb.b20l8.b2", "mb", at="lhclength-(-879.7197+(-120.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845010.0, assembly_id=103701.0))
lhcb2.new("mcs.b20l8.b2", "mcs", at="lhclength-(-872.2957+(-121-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248262.0, assembly_id=103701.0))
lhcb2.new("mb.a20l8.b2", "mb", at="lhclength-(-864.0597+(-121.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845034.0, assembly_id=103702.0))
lhcb2.new("mcs.a20l8.b2", "mcs", at="lhclength-(-856.6357+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248265.0, assembly_id=103702.0))
lhcb2.new("bpm.19l8.b2", "bpm", at="lhclength-(-855.7567+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248267.0, assembly_id=103703.0))
lhcb2.new("mqt.19l8.b2", "mqt", at="lhclength-(-855.0027+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307441.0, assembly_id=103703.0))
lhcb2.new("mq.19l8.b2", "mq", at="lhclength-(-852.9947+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308431.0, assembly_id=103703.0))
lhcb2.new("ms.19l8.b2", "ms", at="lhclength-(-851.0997+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253063.0, assembly_id=103703.0))
lhcb2.new("mcbv.19l8.b2", "mcbv", at="lhclength-(-850.5067+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253065.0, assembly_id=103703.0))
lhcb2.new("mco.b19l8.b2", "mco_unplugged", at="lhclength-(-849.4157+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253068.0, assembly_id=103704.0))
lhcb2.new("mcd.b19l8.b2", "mcd", at="lhclength-(-849.4142+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253069.0, assembly_id=103704.0))
lhcb2.new("mb.c19l8.b2", "mb", at="lhclength-(-841.9297+(-122.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845058.0, assembly_id=103704.0))
lhcb2.new("mcs.c19l8.b2", "mcs", at="lhclength-(-834.5057+(-123-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248275.0, assembly_id=103704.0))
lhcb2.new("mb.b19l8.b2", "mb", at="lhclength-(-826.2697+(-123.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845082.0, assembly_id=103705.0))
lhcb2.new("mcs.b19l8.b2", "mcs", at="lhclength-(-818.8457+(-124-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248278.0, assembly_id=103705.0))
lhcb2.new("mco.a19l8.b2", "mco_unplugged", at="lhclength-(-818.0957+(-124-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253072.0, assembly_id=103706.0))
lhcb2.new("mcd.a19l8.b2", "mcd", at="lhclength-(-818.0942+(-124-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253073.0, assembly_id=103706.0))
lhcb2.new("mb.a19l8.b2", "mb", at="lhclength-(-810.6097+(-124.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845106.0, assembly_id=103706.0))
lhcb2.new("mcs.a19l8.b2", "mcs", at="lhclength-(-803.1857+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248283.0, assembly_id=103706.0))
lhcb2.new("bpm.18l8.b2", "bpm", at="lhclength-(-802.3067+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248285.0, assembly_id=103707.0))
lhcb2.new("mqt.18l8.b2", "mqt", at="lhclength-(-801.5527+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307410.0, assembly_id=103707.0))
lhcb2.new("mq.18l8.b2", "mq", at="lhclength-(-799.5447+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308399.0, assembly_id=103707.0))
lhcb2.new("ms.18l8.b2", "ms", at="lhclength-(-797.6497+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253075.0, assembly_id=103707.0))
lhcb2.new("mcbh.18l8.b2", "mcbh", at="lhclength-(-797.0567+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253077.0, assembly_id=103707.0))
lhcb2.new("mb.c18l8.b2", "mb", at="lhclength-(-788.4797+(-125.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845130.0, assembly_id=103708.0))
lhcb2.new("mcs.c18l8.b2", "mcs", at="lhclength-(-781.0557+(-126-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248291.0, assembly_id=103708.0))
lhcb2.new("mco.18l8.b2", "mco_unplugged", at="lhclength-(-780.3057+(-126-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253080.0, assembly_id=103709.0))
lhcb2.new("mcd.18l8.b2", "mcd", at="lhclength-(-780.3042+(-126-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253081.0, assembly_id=103709.0))
lhcb2.new("mb.b18l8.b2", "mb", at="lhclength-(-772.8197+(-126.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845154.0, assembly_id=103709.0))
lhcb2.new("mcs.b18l8.b2", "mcs", at="lhclength-(-765.3957+(-127-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248296.0, assembly_id=103709.0))
lhcb2.new("mb.a18l8.b2", "mb", at="lhclength-(-757.1597+(-127.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845178.0, assembly_id=103710.0))
lhcb2.new("mcs.a18l8.b2", "mcs", at="lhclength-(-749.7357+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248299.0, assembly_id=103710.0))
lhcb2.new("bpm.17l8.b2", "bpm", at="lhclength-(-748.8567+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248301.0, assembly_id=103711.0))
lhcb2.new("mqt.17l8.b2", "mqt", at="lhclength-(-748.1027+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307378.0, assembly_id=103711.0))
lhcb2.new("mq.17l8.b2", "mq", at="lhclength-(-746.0947+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308369.0, assembly_id=103711.0))
lhcb2.new("ms.17l8.b2", "ms", at="lhclength-(-744.1997+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253083.0, assembly_id=103711.0))
lhcb2.new("mcbv.17l8.b2", "mcbv", at="lhclength-(-743.6067+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253085.0, assembly_id=103711.0))
lhcb2.new("mco.b17l8.b2", "mco_unplugged", at="lhclength-(-742.5157+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253088.0, assembly_id=103712.0))
lhcb2.new("mcd.b17l8.b2", "mcd", at="lhclength-(-742.5142+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253089.0, assembly_id=103712.0))
lhcb2.new("mb.c17l8.b2", "mb", at="lhclength-(-735.0297+(-128.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845202.0, assembly_id=103712.0))
lhcb2.new("mcs.c17l8.b2", "mcs", at="lhclength-(-727.6057+(-129-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248309.0, assembly_id=103712.0))
lhcb2.new("mb.b17l8.b2", "mb", at="lhclength-(-719.3697+(-129.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845226.0, assembly_id=103713.0))
lhcb2.new("mcs.b17l8.b2", "mcs", at="lhclength-(-711.9457+(-130-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248312.0, assembly_id=103713.0))
lhcb2.new("mco.a17l8.b2", "mco_unplugged", at="lhclength-(-711.1957+(-130-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253092.0, assembly_id=103714.0))
lhcb2.new("mcd.a17l8.b2", "mcd", at="lhclength-(-711.1942+(-130-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253093.0, assembly_id=103714.0))
lhcb2.new("mb.a17l8.b2", "mb", at="lhclength-(-703.7097+(-130.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845250.0, assembly_id=103714.0))
lhcb2.new("mcs.a17l8.b2", "mcs", at="lhclength-(-696.2857+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248317.0, assembly_id=103714.0))
lhcb2.new("bpm.16l8.b2", "bpm", at="lhclength-(-695.4067+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248319.0, assembly_id=103715.0))
lhcb2.new("mqt.16l8.b2", "mqt", at="lhclength-(-694.6527+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2348446.0, assembly_id=103715.0))
lhcb2.new("mq.16l8.b2", "mq", at="lhclength-(-692.6447+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2348479.0, assembly_id=103715.0))
lhcb2.new("ms.16l8.b2", "ms", at="lhclength-(-690.7497+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253095.0, assembly_id=103715.0))
lhcb2.new("mcbh.16l8.b2", "mcbh", at="lhclength-(-690.1567+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253097.0, assembly_id=103715.0))
lhcb2.new("mb.c16l8.b2", "mb", at="lhclength-(-681.5797+(-131.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845274.0, assembly_id=103716.0))
lhcb2.new("mcs.c16l8.b2", "mcs", at="lhclength-(-674.1557+(-132-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248325.0, assembly_id=103716.0))
lhcb2.new("mco.16l8.b2", "mco_unplugged", at="lhclength-(-673.4057+(-132-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253100.0, assembly_id=103717.0))
lhcb2.new("mcd.16l8.b2", "mcd", at="lhclength-(-673.4042+(-132-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253101.0, assembly_id=103717.0))
lhcb2.new("mb.b16l8.b2", "mb", at="lhclength-(-665.9197+(-132.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845298.0, assembly_id=103717.0))
lhcb2.new("mcs.b16l8.b2", "mcs", at="lhclength-(-658.4957+(-133-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248330.0, assembly_id=103717.0))
lhcb2.new("mb.a16l8.b2", "mb", at="lhclength-(-650.2597+(-133.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845322.0, assembly_id=103718.0))
lhcb2.new("mcs.a16l8.b2", "mcs", at="lhclength-(-642.8357+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248333.0, assembly_id=103718.0))
lhcb2.new("bpm.15l8.b2", "bpm", at="lhclength-(-641.9567+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248335.0, assembly_id=103719.0))
lhcb2.new("mqt.15l8.b2", "mqt", at="lhclength-(-641.2027+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307554.0, assembly_id=103719.0))
lhcb2.new("mq.15l8.b2", "mq", at="lhclength-(-639.1947+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308546.0, assembly_id=103719.0))
lhcb2.new("ms.15l8.b2", "ms", at="lhclength-(-637.2997+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253103.0, assembly_id=103719.0))
lhcb2.new("mcbv.15l8.b2", "mcbv", at="lhclength-(-636.7067+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253105.0, assembly_id=103719.0))
lhcb2.new("mco.b15l8.b2", "mco_unplugged", at="lhclength-(-635.6157+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253108.0, assembly_id=103720.0))
lhcb2.new("mcd.b15l8.b2", "mcd", at="lhclength-(-635.6142+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253109.0, assembly_id=103720.0))
lhcb2.new("mb.c15l8.b2", "mb", at="lhclength-(-628.1297+(-134.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845346.0, assembly_id=103720.0))
lhcb2.new("mcs.c15l8.b2", "mcs", at="lhclength-(-620.7057+(-135-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248343.0, assembly_id=103720.0))
lhcb2.new("mb.b15l8.b2", "mb", at="lhclength-(-612.4697+(-135.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845370.0, assembly_id=103721.0))
lhcb2.new("mcs.b15l8.b2", "mcs", at="lhclength-(-605.0457+(-136-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248346.0, assembly_id=103721.0))
lhcb2.new("mco.a15l8.b2", "mco_unplugged", at="lhclength-(-604.2957+(-136-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253112.0, assembly_id=103722.0))
lhcb2.new("mcd.a15l8.b2", "mcd", at="lhclength-(-604.2942+(-136-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253113.0, assembly_id=103722.0))
lhcb2.new("mb.a15l8.b2", "mb", at="lhclength-(-596.8097+(-136.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845394.0, assembly_id=103722.0))
lhcb2.new("mcs.a15l8.b2", "mcs", at="lhclength-(-589.3857+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248351.0, assembly_id=103722.0))
lhcb2.new("bpm.14l8.b2", "bpm", at="lhclength-(-588.5067+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248353.0, assembly_id=103723.0))
lhcb2.new("mqt.14l8.b2", "mqt", at="lhclength-(-587.7527+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307522.0, assembly_id=103723.0))
lhcb2.new("mq.14l8.b2", "mq", at="lhclength-(-585.7447+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308516.0, assembly_id=103723.0))
lhcb2.new("ms.14l8.b2", "ms", at="lhclength-(-583.8497+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253115.0, assembly_id=103723.0))
lhcb2.new("mcbh.14l8.b2", "mcbh", at="lhclength-(-583.2567+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253117.0, assembly_id=103723.0))
lhcb2.new("mb.c14l8.b2", "mb", at="lhclength-(-574.6797+(-137.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845418.0, assembly_id=103724.0))
lhcb2.new("mcs.c14l8.b2", "mcs", at="lhclength-(-567.2557+(-138-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248359.0, assembly_id=103724.0))
lhcb2.new("mco.14l8.b2", "mco_unplugged", at="lhclength-(-566.5057+(-138-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253120.0, assembly_id=103725.0))
lhcb2.new("mcd.14l8.b2", "mcd", at="lhclength-(-566.5042+(-138-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253121.0, assembly_id=103725.0))
lhcb2.new("mb.b14l8.b2", "mb", at="lhclength-(-559.0197+(-138.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845442.0, assembly_id=103725.0))
lhcb2.new("mcs.b14l8.b2", "mcs", at="lhclength-(-551.5957+(-139-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248364.0, assembly_id=103725.0))
lhcb2.new("mb.a14l8.b2", "mb", at="lhclength-(-543.3597+(-139.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845466.0, assembly_id=103726.0))
lhcb2.new("mcs.a14l8.b2", "mcs", at="lhclength-(-535.9357+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248367.0, assembly_id=103726.0))
lhcb2.new("s.ds.l8.b2", "omk", at="lhclength-(-535.5297+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.13l8.b2", "bpm", at="lhclength-(-535.0567+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248369.0, assembly_id=103727.0))
lhcb2.new("mqt.13l8.b2", "mqt", at="lhclength-(-534.3027+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307491.0, assembly_id=103727.0))
lhcb2.new("mq.13l8.b2", "mq", at="lhclength-(-532.2947+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2348486.0, assembly_id=103727.0))
lhcb2.new("ms.13l8.b2", "ms", at="lhclength-(-530.3997+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253123.0, assembly_id=103727.0))
lhcb2.new("mcbv.13l8.b2", "mcbv", at="lhclength-(-529.8067+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253125.0, assembly_id=103727.0))
lhcb2.new("mco.b13l8.b2", "mco_unplugged", at="lhclength-(-528.7157+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253128.0, assembly_id=103728.0))
lhcb2.new("mcd.b13l8.b2", "mcd", at="lhclength-(-528.7142+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253129.0, assembly_id=103728.0))
lhcb2.new("mb.c13l8.b2", "mb", at="lhclength-(-521.2297+(-140.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845490.0, assembly_id=103728.0))
lhcb2.new("mcs.c13l8.b2", "mcs", at="lhclength-(-513.8057+(-141-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248377.0, assembly_id=103728.0))
lhcb2.new("mb.b13l8.b2", "mb", at="lhclength-(-505.5697+(-141.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845514.0, assembly_id=103729.0))
lhcb2.new("mcs.b13l8.b2", "mcs", at="lhclength-(-498.1457+(-142-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248380.0, assembly_id=103729.0))
lhcb2.new("mco.a13l8.b2", "mco_unplugged", at="lhclength-(-497.3957+(-142-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253132.0, assembly_id=103730.0))
lhcb2.new("mcd.a13l8.b2", "mcd", at="lhclength-(-497.3942+(-142-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253133.0, assembly_id=103730.0))
lhcb2.new("mb.a13l8.b2", "mb", at="lhclength-(-489.9097+(-142.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845538.0, assembly_id=103730.0))
lhcb2.new("mcs.a13l8.b2", "mcs", at="lhclength-(-482.4857+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248385.0, assembly_id=103730.0))
lhcb2.new("bpm.12l8.b2", "bpm", at="lhclength-(-481.6067+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248387.0, assembly_id=103731.0))
lhcb2.new("mqt.12l8.b2", "mqt", at="lhclength-(-480.8527+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307698.0, assembly_id=103731.0))
lhcb2.new("mq.12l8.b2", "mq", at="lhclength-(-478.8447+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2308457.0, assembly_id=103731.0))
lhcb2.new("ms.12l8.b2", "ms", at="lhclength-(-476.9497+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253135.0, assembly_id=103731.0))
lhcb2.new("mcbh.12l8.b2", "mcbh", at="lhclength-(-476.3567+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253137.0, assembly_id=103731.0))
lhcb2.new("mb.c12l8.b2", "mb", at="lhclength-(-467.7797+(-143.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845562.0, assembly_id=103732.0))
lhcb2.new("mcs.c12l8.b2", "mcs", at="lhclength-(-460.3557+(-144-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248393.0, assembly_id=103732.0))
lhcb2.new("mco.12l8.b2", "mco_unplugged", at="lhclength-(-459.6057+(-144-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253140.0, assembly_id=103733.0))
lhcb2.new("mcd.12l8.b2", "mcd", at="lhclength-(-459.6042+(-144-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253141.0, assembly_id=103733.0))
lhcb2.new("mb.b12l8.b2", "mb", at="lhclength-(-452.1197+(-144.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845586.0, assembly_id=103733.0))
lhcb2.new("mcs.b12l8.b2", "mcs", at="lhclength-(-444.6957+(-145-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248398.0, assembly_id=103733.0))
lhcb2.new("mb.a12l8.b2", "mb", at="lhclength-(-436.4597+(-145.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845610.0, assembly_id=103734.0))
lhcb2.new("mcs.a12l8.b2", "mcs", at="lhclength-(-429.0357+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248401.0, assembly_id=103734.0))
lhcb2.new("e.arc.78.b2", "omk", at="lhclength-(-428.6297+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.11l8.b2", "bpm", at="lhclength-(-428.1567+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248403.0, assembly_id=103735.0))
lhcb2.new("mq.11l8.b2", "mq", at="lhclength-(-425.6097+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2348495.0, assembly_id=103735.0))
lhcb2.new("mqtli.11l8.b2", "mqtli", at="lhclength-(-423.2407+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307352.0, assembly_id=103735.0))
lhcb2.new("ms.11l8.b2", "ms", at="lhclength-(-422.2287+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253143.0, assembly_id=103735.0))
lhcb2.new("mcbv.11l8.b2", "mcbv", at="lhclength-(-421.6357+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253145.0, assembly_id=103735.0))
lhcb2.new("lebr.11l8.b2", "lebr", at="lhclength-(-414.49735+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52997718.0, assembly_id=103736.0))
lhcb2.new("mco.11l8.b2", "mco_unplugged", at="lhclength-(-407.766+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253148.0, assembly_id=103737.0))
lhcb2.new("mcd.11l8.b2", "mcd", at="lhclength-(-407.7645+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253149.0, assembly_id=103737.0))
lhcb2.new("mb.b11l8.b2", "mb", at="lhclength-(-400.28+(-146.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845634.0, assembly_id=103737.0))
lhcb2.new("mcs.b11l8.b2", "mcs", at="lhclength-(-392.856+(-147-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248411.0, assembly_id=103737.0))
lhcb2.new("mb.a11l8.b2", "mb", at="lhclength-(-384.62+(-147.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52849738.0, assembly_id=103738.0))
lhcb2.new("mcs.a11l8.b2", "mcs", at="lhclength-(-377.196+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=357329.0, assembly_id=103738.0))
lhcb2.new("bpm.10l8.b2", "bpm", at="lhclength-(-376.317+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=378038.0, assembly_id=103739.0))
lhcb2.new("mqml.10l8.b2", "mqml", at="lhclength-(-373.172+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307815.0, assembly_id=103739.0))
lhcb2.new("mcbch.10l8.b2", "mcbch", at="lhclength-(-370.13+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=378121.0, assembly_id=103739.0))
lhcb2.new("mco.10l8.b2", "mco_unplugged", at="lhclength-(-368.701+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253154.0, assembly_id=103740.0))
lhcb2.new("mcd.10l8.b2", "mcd", at="lhclength-(-368.6995+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253155.0, assembly_id=103740.0))
lhcb2.new("mb.b10l8.b2", "mb", at="lhclength-(-361.215+(-148.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845658.0, assembly_id=103740.0))
lhcb2.new("mcs.b10l8.b2", "mcs", at="lhclength-(-353.791+(-149-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248423.0, assembly_id=103740.0))
lhcb2.new("mb.a10l8.b2", "mb", at="lhclength-(-345.555+(-149.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845682.0, assembly_id=103741.0))
lhcb2.new("mcs.a10l8.b2", "mcs", at="lhclength-(-338.131+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248426.0, assembly_id=103741.0))
lhcb2.new("bpm.9l8.b2", "bpm", at="lhclength-(-337.251+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=378043.0, assembly_id=103742.0))
lhcb2.new("mqmc.9l8.b2", "mqmc", at="lhclength-(-335.275+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307792.0, assembly_id=103742.0))
lhcb2.new("mqm.9l8.b2", "mqm", at="lhclength-(-332.009+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2348452.0, assembly_id=103742.0))
lhcb2.new("mcbcv.9l8.b2", "mcbcv", at="lhclength-(-329.668+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=378126.0, assembly_id=103742.0))
lhcb2.new("mco.9l8.b2", "mco_unplugged", at="lhclength-(-328.236+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253160.0, assembly_id=103743.0))
lhcb2.new("mcd.9l8.b2", "mcd", at="lhclength-(-328.2345+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253161.0, assembly_id=103743.0))
lhcb2.new("mb.b9l8.b2", "mb", at="lhclength-(-320.75+(-150.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845706.0, assembly_id=103743.0))
lhcb2.new("mcs.b9l8.b2", "mcs", at="lhclength-(-313.326+(-151-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248436.0, assembly_id=103743.0))
lhcb2.new("mb.a9l8.b2", "mb", at="lhclength-(-305.09+(-151.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845730.0, assembly_id=103744.0))
lhcb2.new("mcs.a9l8.b2", "mcs", at="lhclength-(-297.666+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248439.0, assembly_id=103744.0))
lhcb2.new("bpm.8l8.b2", "bpm", at="lhclength-(-296.787+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=378047.0, assembly_id=103745.0))
lhcb2.new("mqml.8l8.b2", "mqml", at="lhclength-(-293.642+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307847.0, assembly_id=103745.0))
lhcb2.new("mcbch.8l8.b2", "mcbch", at="lhclength-(-290.6+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=378131.0, assembly_id=103745.0))
lhcb2.new("mco.8l8.b2", "mco_unplugged", at="lhclength-(-289.171+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253166.0, assembly_id=103746.0))
lhcb2.new("mcd.8l8.b2", "mcd", at="lhclength-(-289.1695+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253167.0, assembly_id=103746.0))
lhcb2.new("mb.b8l8.b2", "mb", at="lhclength-(-281.685+(-152.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52845754.0, assembly_id=103746.0))
lhcb2.new("mcs.b8l8.b2", "mcs", at="lhclength-(-274.261+(-153-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248448.0, assembly_id=103746.0))
lhcb2.new("mb.a8l8.b2", "mb", at="lhclength-(-266.025+(-153.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52849762.0, assembly_id=103747.0))
lhcb2.new("mcs.a8l8.b2", "mcs", at="lhclength-(-258.601+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=357332.0, assembly_id=103747.0))
lhcb2.new("e.ds.l8.b2", "omk", at="lhclength-(-258.195+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.7l8.b2", "bpm", at="lhclength-(-257.72+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248453.0, assembly_id=103748.0))
lhcb2.new("mqm.b7l8.b2", "mqm", at="lhclength-(-255.275+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307773.0, assembly_id=103748.0))
lhcb2.new("mqm.a7l8.b2", "mqm", at="lhclength-(-251.508+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307758.0, assembly_id=103748.0))
lhcb2.new("mcbcv.7l8.b2", "mcbcv", at="lhclength-(-249.167+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253168.0, assembly_id=103748.0))
lhcb2.new("dfbao.7l8.b2", "dfbao", at="lhclength-(-246.9875+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52996887.0, assembly_id=104690.0))
lhcb2.new("mcbch.6l8.b2", "mcbch", at="lhclength-(-235.207+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253171.0, assembly_id=103750.0))
lhcb2.new("mqml.6l8.b2", "mqml", at="lhclength-(-232.165+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307831.0, assembly_id=103750.0))
lhcb2.new("mqm.6l8.b2", "mqm", at="lhclength-(-227.698+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2307958.0, assembly_id=103750.0))
lhcb2.new("bpm.6l8.b2", "bpm", at="lhclength-(-225.251+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=298291.0, assembly_id=103750.0))
lhcb2.new("tclim.6l8.b2", "tclim", at="lhclength-(-223.428+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=52998884.0, assembly_id=357149.0))
lhcb2.new("tclib.6l8.b2", "tclib", at="lhclength-(-216.683+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=103751.0))
lhcb2.new("mcbcv.b5l8.b2", "mcbcv", at="lhclength-(-175.742+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=298447.0, assembly_id=103752.0))
lhcb2.new("mcbch.5l8.b2", "mcbch", at="lhclength-(-174.595+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=298450.0, assembly_id=103752.0))
lhcb2.new("mcbcv.a5l8.b2", "mcbcv", at="lhclength-(-173.449+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=298451.0, assembly_id=103752.0))
lhcb2.new("mqm.b5l8.b2", "mqm", at="lhclength-(-171.102+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2303174.0, assembly_id=103752.0))
lhcb2.new("mqm.a5l8.b2", "mqm", at="lhclength-(-167.321+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2303173.0, assembly_id=103752.0))
lhcb2.new("bpmr.5l8.b2", "bpmr", at="lhclength-(-164.832+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248470.0, assembly_id=103752.0))
lhcb2.new("bpmwi.a5l8.b2", "bpmwi", at="lhclength-(-163.3305+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=54987223.0))
lhcb2.new("bpmyb.4l8.b2", "bpmyb", at="lhclength-(-144.065+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=248472.0, assembly_id=103753.0))
lhcb2.new("mqy.b4l8.b2", "mqy", at="lhclength-(-141.371+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2303006.0, assembly_id=103753.0))
lhcb2.new("mqy.a4l8.b2", "mqy", at="lhclength-(-137.59+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=2303005.0, assembly_id=103753.0))
lhcb2.new("mcbyh.b4l8.b2", "mcbyh", at="lhclength-(-135.243+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253178.0, assembly_id=103753.0))
lhcb2.new("mcbyv.4l8.b2", "mcbyv", at="lhclength-(-134.096+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253180.0, assembly_id=103753.0))
lhcb2.new("mcbyh.a4l8.b2", "mcbyh", at="lhclength-(-132.95+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.194, slot_id=253182.0, assembly_id=103753.0))
lhcb2.new("mbrc.4l8.b2", "mbrc", at="lhclength-(-126.403+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.188, slot_id=52819740.0, assembly_id=103754.0))
lhcb2.new("tanb.a4l8.b2", "tanb", at="lhclength-(-119.4855+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.174, slot_id=52999655.0, assembly_id=51650555.0))
lhcb2.new("bpmwb.4l8.b2", "bpmwb", at="lhclength-(-114.7925+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.1611, slot_id=104615.0, assembly_id=51650538.0))
lhcb2.new("branc.4l8", "branc", at="lhclength-(-113.588+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=55373986.0))
lhcb2.new("tclia.4l8", "tclia", at="lhclength-(-73.748+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=357150.0))
lhcb2.new("bpmsx.4l8.b2", "bpmsx003", at="lhclength-(-69.3805+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.0194, slot_id=43190482.0, assembly_id=104616.0))
lhcb2.new("mbx.4l8", "mbx", at="lhclength-(-63.108+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248483.0, assembly_id=103755.0))
lhcb2.new("dfbxg.3l8", "dfbxg", at="lhclength-(-56.3085+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=104691.0))
lhcb2.new("mcosx.3l8", "mcosx", at="lhclength-(-54.297+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282252.0, assembly_id=103756.0))
lhcb2.new("mcox.3l8", "mcox", at="lhclength-(-54.297+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282251.0, assembly_id=103756.0))
lhcb2.new("mcssx.3l8", "mcssx", at="lhclength-(-54.297+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282250.0, assembly_id=103756.0))
lhcb2.new("mcbxh.3l8", "mcbxh", at="lhclength-(-53.814+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253184.0, assembly_id=103756.0))
lhcb2.new("mcbxv.3l8", "mcbxv", at="lhclength-(-53.814+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253185.0, assembly_id=103756.0))
lhcb2.new("mcsx.3l8", "mcsx", at="lhclength-(-53.814+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253186.0, assembly_id=103756.0))
lhcb2.new("mctx.3l8", "mctx", at="lhclength-(-53.814+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253187.0, assembly_id=103756.0))
lhcb2.new("mqxa.3l8", "mqxa", at="lhclength-(-50.15+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248485.0, assembly_id=103756.0))
lhcb2.new("mqsx.3l8", "mqsx", at="lhclength-(-46.608+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282207.0, assembly_id=103756.0))
lhcb2.new("mqxb.b2l8", "mqxb", at="lhclength-(-41.3+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248487.0, assembly_id=103757.0))
lhcb2.new("mcbxh.2l8", "mcbxh", at="lhclength-(-38.019+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253192.0, assembly_id=103757.0))
lhcb2.new("mcbxv.2l8", "mcbxv", at="lhclength-(-38.019+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253193.0, assembly_id=103757.0))
lhcb2.new("mqxb.a2l8", "mqxb", at="lhclength-(-34.8+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248489.0, assembly_id=103757.0))
lhcb2.new("bpms.2l8.b2", "bpms_003", at="lhclength-(-31.529+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=47564259.0, assembly_id=103757.0))
lhcb2.new("mcbxh.1l8", "mcbxh", at="lhclength-(-29.842+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253194.0, assembly_id=103758.0))
lhcb2.new("mcbxv.1l8", "mcbxv", at="lhclength-(-29.842+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253195.0, assembly_id=103758.0))
lhcb2.new("mqxa.1l8", "mqxa", at="lhclength-(-26.15+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248492.0, assembly_id=103758.0))
lhcb2.new("bpmsw.1l8.b2", "bpmsw002", at="lhclength-(-21.595+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=10428874.0, assembly_id=104617.0))
lhcb2.new("bpmsw.1l8.b2_doros", "bpmsw002", at="lhclength-(-21.595+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=12907569.0, assembly_id=104617.0))
lhcb2.new("mbxws.1l8", "mbxws", at="lhclength-(-20.765+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=103997.0))
lhcb2.new("mbxwh.1l8", "mbxwh", at="lhclength-(-5.25+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=103998.0))
lhcb2.new("ip8", "omk", at="lhclength-(pip8+ip8ofs.b2*ds)")
lhcb2.new("mblw.1r8", "mblw", at="lhclength-(5.25+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=104001.0))
lhcb2.new("mbxws.1r8", "mbxws", at="lhclength-(20.765+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=103999.0))
lhcb2.new("bpmsw.1r8.b2", "bpmsw002", at="lhclength-(21.595+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=10428868.0, assembly_id=104618.0))
lhcb2.new("bpmsw.1r8.b2_doros", "bpmsw002", at="lhclength-(21.595+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=12907561.0, assembly_id=104618.0))
lhcb2.new("mqxa.1r8", "mqxa", at="lhclength-(26.15+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248498.0, assembly_id=103759.0))
lhcb2.new("mcbxh.1r8", "mcbxh", at="lhclength-(29.842+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253196.0, assembly_id=103759.0))
lhcb2.new("mcbxv.1r8", "mcbxv", at="lhclength-(29.842+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253197.0, assembly_id=103759.0))
lhcb2.new("bpms.2r8.b2", "bpms_003", at="lhclength-(31.529+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=47564249.0, assembly_id=103760.0))
lhcb2.new("mqxb.a2r8", "mqxb", at="lhclength-(34.8+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248501.0, assembly_id=103760.0))
lhcb2.new("mcbxh.2r8", "mcbxh", at="lhclength-(38.019+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253198.0, assembly_id=103760.0))
lhcb2.new("mcbxv.2r8", "mcbxv", at="lhclength-(38.019+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253199.0, assembly_id=103760.0))
lhcb2.new("mqxb.b2r8", "mqxb", at="lhclength-(41.3+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248503.0, assembly_id=103760.0))
lhcb2.new("mqsx.3r8", "mqsx", at="lhclength-(46.608+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282208.0, assembly_id=103761.0))
lhcb2.new("mqxa.3r8", "mqxa", at="lhclength-(50.15+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248505.0, assembly_id=103761.0))
lhcb2.new("mcbxh.3r8", "mcbxh", at="lhclength-(53.814+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253204.0, assembly_id=103761.0))
lhcb2.new("mcbxv.3r8", "mcbxv", at="lhclength-(53.814+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253205.0, assembly_id=103761.0))
lhcb2.new("mcsx.3r8", "mcsx", at="lhclength-(53.814+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253206.0, assembly_id=103761.0))
lhcb2.new("mctx.3r8", "mctx", at="lhclength-(53.814+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=253207.0, assembly_id=103761.0))
lhcb2.new("mcosx.3r8", "mcosx", at="lhclength-(54.297+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282255.0, assembly_id=103761.0))
lhcb2.new("mcox.3r8", "mcox", at="lhclength-(54.297+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282254.0, assembly_id=103761.0))
lhcb2.new("mcssx.3r8", "mcssx", at="lhclength-(54.297+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=282253.0, assembly_id=103761.0))
lhcb2.new("dfbxh.3r8", "dfbxh", at="lhclength-(56.3085+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=104692.0))
lhcb2.new("mbx.4r8", "mbx", at="lhclength-(63.108+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=248507.0, assembly_id=103762.0))
lhcb2.new("bpmsx.4r8.b2", "bpmsx003", at="lhclength-(69.5005+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0194, slot_id=43190483.0, assembly_id=104619.0))
lhcb2.new("tcddm.4r8", "tcddm", at="lhclength-(71.358+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=103763.0))
lhcb2.new("tdisc.a4r8.b2", "tdisc", at="lhclength-(79.583+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.074, slot_id=48194677.0, assembly_id=47940368.0))
lhcb2.new("tdisb.a4r8.b2", "tdisb", at="lhclength-(81.163+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.074, slot_id=47948772.0, assembly_id=47940368.0))
lhcb2.new("tdisa.a4r8.b2", "tdisa", at="lhclength-(82.743+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.074, slot_id=47940456.0, assembly_id=47940368.0))
lhcb2.new("btvst.a4r8", "btvst064", at="lhclength-(85.441+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=-0.08, slot_id=181630.0))
lhcb2.new("branc.4r8", "branc", at="lhclength-(113.588+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.0, slot_id=55374023.0))
lhcb2.new("bpmwi.4r8.b2", "bpmwi", at="lhclength-(114.6885+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.174, slot_id=104620.0, assembly_id=51710752.0))
lhcb2.new("bptdv.a4r8.b2", "bptdv", at="lhclength-(115.638+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.16, slot_id=8370250.0, assembly_id=8370246.0))
lhcb2.new("tctpv.4r8.b2", "tctpv", at="lhclength-(116.233+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.1628, slot_id=8370246.0))
lhcb2.new("bptuv.a4r8.b2", "bptuv", at="lhclength-(116.828+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.16, slot_id=8370252.0, assembly_id=8370246.0))
lhcb2.new("bptdh.a4r8.b2", "bptdh", at="lhclength-(117.638+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.166, slot_id=8370233.0, assembly_id=377645.0))
lhcb2.new("tctph.4r8.b2", "tctph", at="lhclength-(118.233+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.1689, slot_id=377645.0))
lhcb2.new("bptuh.a4r8.b2", "bptuh", at="lhclength-(118.828+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.166, slot_id=8370235.0, assembly_id=377645.0))
lhcb2.new("tanb.a4r8.b2", "tanb", at="lhclength-(119.4855+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.174, slot_id=52999678.0, assembly_id=51710761.0))
lhcb2.new("mbrc.4r8.b2", "mbrc", at="lhclength-(126.403+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.188, slot_id=52819763.0, assembly_id=103765.0))
lhcb2.new("mcbyv.a4r8.b2", "mcbyv", at="lhclength-(132.95+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253208.0, assembly_id=103766.0))
lhcb2.new("mcbyh.4r8.b2", "mcbyh", at="lhclength-(134.096+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253210.0, assembly_id=103766.0))
lhcb2.new("mcbyv.b4r8.b2", "mcbyv", at="lhclength-(135.243+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253212.0, assembly_id=103766.0))
lhcb2.new("mqy.a4r8.b2", "mqy", at="lhclength-(137.59+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2303143.0, assembly_id=103766.0))
lhcb2.new("mqy.b4r8.b2", "mqy", at="lhclength-(141.371+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2303142.0, assembly_id=103766.0))
lhcb2.new("lhcinj.b2", "omk", at="lhclength-(143.071+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("bpmyb.4r8.b2", "bpmyb", at="lhclength-(144.065+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248520.0, assembly_id=103766.0))
lhcb2.new("btvsi.a5r8.b2", "btvsi084", at="lhclength-(145.431+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=181631.0))
lhcb2.new("bptx.5r8.b2", "bptx", at="lhclength-(146.1615+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=104670.0))
lhcb2.new("mki.a5r8.b2", "mkima193", at="lhclength-(148.404+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378211.0))
lhcb2.new("mki.b5r8.b2", "mkima193", at="lhclength-(152.368+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378212.0))
lhcb2.new("mki.c5r8.b2", "mkima193", at="lhclength-(156.332+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378213.0))
lhcb2.new("mki.d5r8.b2", "mkima193", at="lhclength-(160.296+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378214.0))
lhcb2.new("btvsi.c5r8.b2", "btvsi084", at="lhclength-(163.276+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=181632.0))
lhcb2.new("bpmyb.5r8.b2", "bpmyb", at="lhclength-(164.642+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248522.0, assembly_id=103768.0))
lhcb2.new("mqy.a5r8.b2", "mqy", at="lhclength-(167.336+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2303008.0, assembly_id=103768.0))
lhcb2.new("mqy.b5r8.b2", "mqy", at="lhclength-(171.117+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2303007.0, assembly_id=103768.0))
lhcb2.new("mcbyh.a5r8.b2", "mcbyh", at="lhclength-(173.464+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253215.0, assembly_id=103768.0))
lhcb2.new("mcbyv.5r8.b2", "mcbyv", at="lhclength-(174.61+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253217.0, assembly_id=103768.0))
lhcb2.new("mcbyh.b5r8.b2", "mcbyh", at="lhclength-(175.757+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253219.0, assembly_id=103768.0))
lhcb2.new("btvss.6r8.b2", "btvss074", at="lhclength-(192.173+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=181633.0))
lhcb2.new("msia.exit.b2", "omk", at="lhclength-(192.923+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("msia.a6r8.b2", "msia", at="lhclength-(194.923+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52849911.0, assembly_id=134685.0))
lhcb2.new("msia.b6r8.b2", "msia", at="lhclength-(199.373+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52849937.0, assembly_id=134686.0))
lhcb2.new("msib.a6r8.b2", "msib", at="lhclength-(203.823+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52850041.0, assembly_id=134687.0))
lhcb2.new("msib.b6r8.b2", "msib", at="lhclength-(208.273+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52850067.0, assembly_id=134688.0))
lhcb2.new("msib.c6r8.b2", "msib", at="lhclength-(212.723+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52850093.0, assembly_id=134689.0))
lhcb2.new("mcbcv.6r8.b2", "mcbcv", at="lhclength-(238.794+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253220.0, assembly_id=103770.0))
lhcb2.new("mqml.6r8.b2", "mqml", at="lhclength-(241.836+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307835.0, assembly_id=103770.0))
lhcb2.new("mqm.6r8.b2", "mqm", at="lhclength-(246.303+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307962.0, assembly_id=103770.0))
lhcb2.new("bpmr.6r8.b2", "bpmr", at="lhclength-(248.75+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248532.0, assembly_id=103770.0))
lhcb2.new("dfbap.7r8.b2", "dfbap", at="lhclength-(269.1775+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52996911.0, assembly_id=104693.0))
lhcb2.new("bpm_a.7r8.b2", "bpm_a", at="lhclength-(270.99+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=378058.0, assembly_id=103771.0))
lhcb2.new("mqm.a7r8.b2", "mqm", at="lhclength-(273.435+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307766.0, assembly_id=103771.0))
lhcb2.new("mqm.b7r8.b2", "mqm", at="lhclength-(277.202+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2348455.0, assembly_id=103771.0))
lhcb2.new("mcbch.7r8.b2", "mcbch", at="lhclength-(279.543+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253223.0, assembly_id=103771.0))
lhcb2.new("s.ds.r8.b2", "omk", at="lhclength-(280.635+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("mco.8r8.b2", "mco", at="lhclength-(280.979+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253224.0, assembly_id=103772.0))
lhcb2.new("mcd.8r8.b2", "mcd", at="lhclength-(280.9805+(-154-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253225.0, assembly_id=103772.0))
lhcb2.new("mb.a8r8.b2", "mb", at="lhclength-(288.465+(-153.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845778.0, assembly_id=103772.0))
lhcb2.new("mcs.a8r8.b2", "mcs", at="lhclength-(295.889+(-153-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248542.0, assembly_id=103772.0))
lhcb2.new("mb.b8r8.b2", "mb", at="lhclength-(304.125+(-152.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845802.0, assembly_id=103773.0))
lhcb2.new("mcs.b8r8.b2", "mcs", at="lhclength-(311.549+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248545.0, assembly_id=103773.0))
lhcb2.new("bpm.8r8.b2", "bpm", at="lhclength-(312.428+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248547.0, assembly_id=103774.0))
lhcb2.new("mqml.8r8.b2", "mqml", at="lhclength-(315.573+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307620.0, assembly_id=103774.0))
lhcb2.new("mcbcv.8r8.b2", "mcbcv", at="lhclength-(318.615+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253229.0, assembly_id=103774.0))
lhcb2.new("mco.9r8.b2", "mco", at="lhclength-(320.044+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253230.0, assembly_id=103775.0))
lhcb2.new("mcd.9r8.b2", "mcd", at="lhclength-(320.0455+(-152-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253231.0, assembly_id=103775.0))
lhcb2.new("mb.a9r8.b2", "mb", at="lhclength-(327.53+(-151.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845826.0, assembly_id=103775.0))
lhcb2.new("mcs.a9r8.b2", "mcs", at="lhclength-(334.954+(-151-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248554.0, assembly_id=103775.0))
lhcb2.new("mb.b9r8.b2", "mb", at="lhclength-(343.19+(-150.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845850.0, assembly_id=103776.0))
lhcb2.new("mcs.b9r8.b2", "mcs", at="lhclength-(350.614+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248557.0, assembly_id=103776.0))
lhcb2.new("bpm.9r8.b2", "bpm", at="lhclength-(351.494+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248559.0, assembly_id=103777.0))
lhcb2.new("mqmc.9r8.b2", "mqmc", at="lhclength-(353.47+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307803.0, assembly_id=103777.0))
lhcb2.new("mqm.9r8.b2", "mqm", at="lhclength-(356.736+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307751.0, assembly_id=103777.0))
lhcb2.new("mcbch.9r8.b2", "mcbch", at="lhclength-(359.077+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253235.0, assembly_id=103777.0))
lhcb2.new("mco.10r8.b2", "mco", at="lhclength-(360.509+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253236.0, assembly_id=103778.0))
lhcb2.new("mcd.10r8.b2", "mcd", at="lhclength-(360.5105+(-150-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253237.0, assembly_id=103778.0))
lhcb2.new("mb.a10r8.b2", "mb", at="lhclength-(367.995+(-149.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845874.0, assembly_id=103778.0))
lhcb2.new("mcs.a10r8.b2", "mcs", at="lhclength-(375.419+(-149-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248567.0, assembly_id=103778.0))
lhcb2.new("mb.b10r8.b2", "mb", at="lhclength-(383.655+(-148.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845898.0, assembly_id=103779.0))
lhcb2.new("mcs.b10r8.b2", "mcs", at="lhclength-(391.079+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248570.0, assembly_id=103779.0))
lhcb2.new("bpm.10r8.b2", "bpm", at="lhclength-(391.958+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248572.0, assembly_id=103780.0))
lhcb2.new("mqml.10r8.b2", "mqml", at="lhclength-(395.103+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307827.0, assembly_id=103780.0))
lhcb2.new("mcbcv.10r8.b2", "mcbcv", at="lhclength-(398.145+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253241.0, assembly_id=103780.0))
lhcb2.new("mco.11r8.b2", "mco", at="lhclength-(399.574+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253242.0, assembly_id=103781.0))
lhcb2.new("mcd.11r8.b2", "mcd", at="lhclength-(399.5755+(-148-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253243.0, assembly_id=103781.0))
lhcb2.new("mb.a11r8.b2", "mb", at="lhclength-(407.06+(-147.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845922.0, assembly_id=103781.0))
lhcb2.new("mcs.a11r8.b2", "mcs", at="lhclength-(414.484+(-147-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248579.0, assembly_id=103781.0))
lhcb2.new("mb.b11r8.b2", "mb", at="lhclength-(422.72+(-146.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52849786.0, assembly_id=103782.0))
lhcb2.new("mcs.b11r8.b2", "mcs", at="lhclength-(430.144+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=357339.0, assembly_id=103782.0))
lhcb2.new("lecl.11r8.b2", "lecl", at="lhclength-(436.93735+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52997766.0, assembly_id=103783.0))
lhcb2.new("bpm.11r8.b2", "bpm", at="lhclength-(443.7977+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248584.0, assembly_id=103784.0))
lhcb2.new("mq.11r8.b2", "mq", at="lhclength-(446.3447+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308678.0, assembly_id=103784.0))
lhcb2.new("mqtli.11r8.b2", "mqtli", at="lhclength-(448.7137+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307367.0, assembly_id=103784.0))
lhcb2.new("ms.11r8.b2", "ms", at="lhclength-(449.7257+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253246.0, assembly_id=103784.0))
lhcb2.new("mcbh.11r8.b2", "mcbh", at="lhclength-(450.3187+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253248.0, assembly_id=103784.0))
lhcb2.new("s.arc.81.b2", "omk", at="lhclength-(451.0697+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a12r8.b2", "mco", at="lhclength-(451.4137+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253250.0, assembly_id=103785.0))
lhcb2.new("mcd.a12r8.b2", "mcd", at="lhclength-(451.4152+(-146-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253251.0, assembly_id=103785.0))
lhcb2.new("mb.a12r8.b2", "mb", at="lhclength-(458.8997+(-145.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845946.0, assembly_id=103785.0))
lhcb2.new("mcs.a12r8.b2", "mcs", at="lhclength-(466.3237+(-145-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248592.0, assembly_id=103785.0))
lhcb2.new("mb.b12r8.b2", "mb", at="lhclength-(474.5597+(-144.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845970.0, assembly_id=103786.0))
lhcb2.new("mcs.b12r8.b2", "mcs", at="lhclength-(481.9837+(-144-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248595.0, assembly_id=103786.0))
lhcb2.new("mco.b12r8.b2", "mco", at="lhclength-(482.7337+(-144-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253254.0, assembly_id=103787.0))
lhcb2.new("mcd.b12r8.b2", "mcd", at="lhclength-(482.7352+(-144-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253255.0, assembly_id=103787.0))
lhcb2.new("mb.c12r8.b2", "mb", at="lhclength-(490.2197+(-143.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52845994.0, assembly_id=103787.0))
lhcb2.new("mcs.c12r8.b2", "mcs", at="lhclength-(497.6437+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248600.0, assembly_id=103787.0))
lhcb2.new("bpm.12r8.b2", "bpm", at="lhclength-(498.5227+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248602.0, assembly_id=103788.0))
lhcb2.new("mqt.12r8.b2", "mqt", at="lhclength-(499.2767+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307714.0, assembly_id=103788.0))
lhcb2.new("mq.12r8.b2", "mq", at="lhclength-(501.2847+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308472.0, assembly_id=103788.0))
lhcb2.new("ms.12r8.b2", "ms", at="lhclength-(503.1797+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253258.0, assembly_id=103788.0))
lhcb2.new("mcbv.12r8.b2", "mcbv", at="lhclength-(503.7727+(-143-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253260.0, assembly_id=103788.0))
lhcb2.new("mb.a13r8.b2", "mb", at="lhclength-(512.3497+(-142.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846018.0, assembly_id=103789.0))
lhcb2.new("mcs.a13r8.b2", "mcs", at="lhclength-(519.7737+(-142-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248608.0, assembly_id=103789.0))
lhcb2.new("mco.13r8.b2", "mco", at="lhclength-(520.5237+(-142-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253262.0, assembly_id=103790.0))
lhcb2.new("mcd.13r8.b2", "mcd", at="lhclength-(520.5252+(-142-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253263.0, assembly_id=103790.0))
lhcb2.new("mb.b13r8.b2", "mb", at="lhclength-(528.0097+(-141.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846042.0, assembly_id=103790.0))
lhcb2.new("mcs.b13r8.b2", "mcs", at="lhclength-(535.4337+(-141-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248613.0, assembly_id=103790.0))
lhcb2.new("mb.c13r8.b2", "mb", at="lhclength-(543.6697+(-140.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846066.0, assembly_id=103791.0))
lhcb2.new("mcs.c13r8.b2", "mcs", at="lhclength-(551.0937+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248616.0, assembly_id=103791.0))
lhcb2.new("bpm.13r8.b2", "bpm", at="lhclength-(551.9727+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248618.0, assembly_id=103792.0))
lhcb2.new("mqt.13r8.b2", "mqt", at="lhclength-(552.7267+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307506.0, assembly_id=103792.0))
lhcb2.new("mq.13r8.b2", "mq", at="lhclength-(554.7347+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308501.0, assembly_id=103792.0))
lhcb2.new("ms.13r8.b2", "ms", at="lhclength-(556.6297+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253266.0, assembly_id=103792.0))
lhcb2.new("mcbh.13r8.b2", "mcbh", at="lhclength-(557.2227+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253268.0, assembly_id=103792.0))
lhcb2.new("e.ds.r8.b2", "omk", at="lhclength-(557.9697+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a14r8.b2", "mco", at="lhclength-(558.3137+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253270.0, assembly_id=103793.0))
lhcb2.new("mcd.a14r8.b2", "mcd", at="lhclength-(558.3152+(-140-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253271.0, assembly_id=103793.0))
lhcb2.new("mb.a14r8.b2", "mb", at="lhclength-(565.7997+(-139.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846090.0, assembly_id=103793.0))
lhcb2.new("mcs.a14r8.b2", "mcs", at="lhclength-(573.2237+(-139-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248626.0, assembly_id=103793.0))
lhcb2.new("mb.b14r8.b2", "mb", at="lhclength-(581.4597+(-138.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846114.0, assembly_id=103794.0))
lhcb2.new("mcs.b14r8.b2", "mcs", at="lhclength-(588.8837+(-138-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248629.0, assembly_id=103794.0))
lhcb2.new("mco.b14r8.b2", "mco", at="lhclength-(589.6337+(-138-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253274.0, assembly_id=103795.0))
lhcb2.new("mcd.b14r8.b2", "mcd", at="lhclength-(589.6352+(-138-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253275.0, assembly_id=103795.0))
lhcb2.new("mb.c14r8.b2", "mb", at="lhclength-(597.1197+(-137.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846138.0, assembly_id=103795.0))
lhcb2.new("mcs.c14r8.b2", "mcs", at="lhclength-(604.5437+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248634.0, assembly_id=103795.0))
lhcb2.new("bpm.14r8.b2", "bpm", at="lhclength-(605.4227+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248636.0, assembly_id=103796.0))
lhcb2.new("mqt.14r8.b2", "mqt", at="lhclength-(606.1767+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307538.0, assembly_id=103796.0))
lhcb2.new("mq.14r8.b2", "mq", at="lhclength-(608.1847+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308531.0, assembly_id=103796.0))
lhcb2.new("ms.14r8.b2", "ms", at="lhclength-(610.0797+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253278.0, assembly_id=103796.0))
lhcb2.new("mcbv.14r8.b2", "mcbv", at="lhclength-(610.6727+(-137-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253280.0, assembly_id=103796.0))
lhcb2.new("mb.a15r8.b2", "mb", at="lhclength-(619.2497+(-136.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846162.0, assembly_id=103797.0))
lhcb2.new("mcs.a15r8.b2", "mcs", at="lhclength-(626.6737+(-136-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248642.0, assembly_id=103797.0))
lhcb2.new("mco.15r8.b2", "mco", at="lhclength-(627.4237+(-136-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253282.0, assembly_id=103798.0))
lhcb2.new("mcd.15r8.b2", "mcd", at="lhclength-(627.4252+(-136-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253283.0, assembly_id=103798.0))
lhcb2.new("mb.b15r8.b2", "mb", at="lhclength-(634.9097+(-135.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846186.0, assembly_id=103798.0))
lhcb2.new("mcs.b15r8.b2", "mcs", at="lhclength-(642.3337+(-135-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248647.0, assembly_id=103798.0))
lhcb2.new("mb.c15r8.b2", "mb", at="lhclength-(650.5697+(-134.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846210.0, assembly_id=103799.0))
lhcb2.new("mcs.c15r8.b2", "mcs", at="lhclength-(657.9937+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248650.0, assembly_id=103799.0))
lhcb2.new("bpm.15r8.b2", "bpm", at="lhclength-(658.8727+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248652.0, assembly_id=103800.0))
lhcb2.new("mqt.15r8.b2", "mqt", at="lhclength-(659.6267+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307570.0, assembly_id=103800.0))
lhcb2.new("mq.15r8.b2", "mq", at="lhclength-(661.6347+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308562.0, assembly_id=103800.0))
lhcb2.new("ms.15r8.b2", "ms", at="lhclength-(663.5297+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253286.0, assembly_id=103800.0))
lhcb2.new("mcbh.15r8.b2", "mcbh", at="lhclength-(664.1227+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253288.0, assembly_id=103800.0))
lhcb2.new("mco.a16r8.b2", "mco", at="lhclength-(665.2137+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253290.0, assembly_id=103801.0))
lhcb2.new("mcd.a16r8.b2", "mcd", at="lhclength-(665.2152+(-134-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253291.0, assembly_id=103801.0))
lhcb2.new("mb.a16r8.b2", "mb", at="lhclength-(672.6997+(-133.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846234.0, assembly_id=103801.0))
lhcb2.new("mcs.a16r8.b2", "mcs", at="lhclength-(680.1237+(-133-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248660.0, assembly_id=103801.0))
lhcb2.new("mb.b16r8.b2", "mb", at="lhclength-(688.3597+(-132.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846258.0, assembly_id=103802.0))
lhcb2.new("mcs.b16r8.b2", "mcs", at="lhclength-(695.7837+(-132-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248663.0, assembly_id=103802.0))
lhcb2.new("mco.b16r8.b2", "mco", at="lhclength-(696.5337+(-132-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253294.0, assembly_id=103803.0))
lhcb2.new("mcd.b16r8.b2", "mcd", at="lhclength-(696.5352+(-132-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253295.0, assembly_id=103803.0))
lhcb2.new("mb.c16r8.b2", "mb", at="lhclength-(704.0197+(-131.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846282.0, assembly_id=103803.0))
lhcb2.new("mcs.c16r8.b2", "mcs", at="lhclength-(711.4437+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248668.0, assembly_id=103803.0))
lhcb2.new("bpm.16r8.b2", "bpm", at="lhclength-(712.3227+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248670.0, assembly_id=103804.0))
lhcb2.new("mqt.16r8.b2", "mqt", at="lhclength-(713.0767+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307599.0, assembly_id=103804.0))
lhcb2.new("mq.16r8.b2", "mq", at="lhclength-(715.0847+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308354.0, assembly_id=103804.0))
lhcb2.new("ms.16r8.b2", "ms", at="lhclength-(716.9797+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253298.0, assembly_id=103804.0))
lhcb2.new("mcbv.16r8.b2", "mcbv", at="lhclength-(717.5727+(-131-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253300.0, assembly_id=103804.0))
lhcb2.new("mb.a17r8.b2", "mb", at="lhclength-(726.1497+(-130.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846306.0, assembly_id=103805.0))
lhcb2.new("mcs.a17r8.b2", "mcs", at="lhclength-(733.5737+(-130-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248676.0, assembly_id=103805.0))
lhcb2.new("mco.17r8.b2", "mco", at="lhclength-(734.3237+(-130-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253302.0, assembly_id=103806.0))
lhcb2.new("mcd.17r8.b2", "mcd", at="lhclength-(734.3252+(-130-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253303.0, assembly_id=103806.0))
lhcb2.new("mb.b17r8.b2", "mb", at="lhclength-(741.8097+(-129.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846330.0, assembly_id=103806.0))
lhcb2.new("mcs.b17r8.b2", "mcs", at="lhclength-(749.2337+(-129-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248681.0, assembly_id=103806.0))
lhcb2.new("mb.c17r8.b2", "mb", at="lhclength-(757.4697+(-128.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846354.0, assembly_id=103807.0))
lhcb2.new("mcs.c17r8.b2", "mcs", at="lhclength-(764.8937+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248684.0, assembly_id=103807.0))
lhcb2.new("bpm.17r8.b2", "bpm", at="lhclength-(765.7727+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248686.0, assembly_id=103808.0))
lhcb2.new("mqt.17r8.b2", "mqt", at="lhclength-(766.5267+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307394.0, assembly_id=103808.0))
lhcb2.new("mq.17r8.b2", "mq", at="lhclength-(768.5347+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308384.0, assembly_id=103808.0))
lhcb2.new("ms.17r8.b2", "ms", at="lhclength-(770.4297+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253306.0, assembly_id=103808.0))
lhcb2.new("mcbh.17r8.b2", "mcbh", at="lhclength-(771.0227+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253308.0, assembly_id=103808.0))
lhcb2.new("mco.a18r8.b2", "mco", at="lhclength-(772.1137+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253310.0, assembly_id=103809.0))
lhcb2.new("mcd.a18r8.b2", "mcd", at="lhclength-(772.1152+(-128-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253311.0, assembly_id=103809.0))
lhcb2.new("mb.a18r8.b2", "mb", at="lhclength-(779.5997+(-127.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846378.0, assembly_id=103809.0))
lhcb2.new("mcs.a18r8.b2", "mcs", at="lhclength-(787.0237+(-127-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248694.0, assembly_id=103809.0))
lhcb2.new("mb.b18r8.b2", "mb", at="lhclength-(795.2597+(-126.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846402.0, assembly_id=103810.0))
lhcb2.new("mcs.b18r8.b2", "mcs", at="lhclength-(802.6837+(-126-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248697.0, assembly_id=103810.0))
lhcb2.new("mco.b18r8.b2", "mco", at="lhclength-(803.4337+(-126-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253314.0, assembly_id=103811.0))
lhcb2.new("mcd.b18r8.b2", "mcd", at="lhclength-(803.4352+(-126-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253315.0, assembly_id=103811.0))
lhcb2.new("mb.c18r8.b2", "mb", at="lhclength-(810.9197+(-125.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846426.0, assembly_id=103811.0))
lhcb2.new("mcs.c18r8.b2", "mcs", at="lhclength-(818.3437+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248702.0, assembly_id=103811.0))
lhcb2.new("bpm.18r8.b2", "bpm", at="lhclength-(819.2227+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248704.0, assembly_id=103812.0))
lhcb2.new("mqt.18r8.b2", "mqt", at="lhclength-(819.9767+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307426.0, assembly_id=103812.0))
lhcb2.new("mq.18r8.b2", "mq", at="lhclength-(821.9847+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308415.0, assembly_id=103812.0))
lhcb2.new("ms.18r8.b2", "ms", at="lhclength-(823.8797+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253318.0, assembly_id=103812.0))
lhcb2.new("mcbv.18r8.b2", "mcbv", at="lhclength-(824.4727+(-125-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253320.0, assembly_id=103812.0))
lhcb2.new("mb.a19r8.b2", "mb", at="lhclength-(833.0497+(-124.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846450.0, assembly_id=103813.0))
lhcb2.new("mcs.a19r8.b2", "mcs", at="lhclength-(840.4737+(-124-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248710.0, assembly_id=103813.0))
lhcb2.new("mco.19r8.b2", "mco", at="lhclength-(841.2237+(-124-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253322.0, assembly_id=103814.0))
lhcb2.new("mcd.19r8.b2", "mcd", at="lhclength-(841.2252+(-124-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253323.0, assembly_id=103814.0))
lhcb2.new("mb.b19r8.b2", "mb", at="lhclength-(848.7097+(-123.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846474.0, assembly_id=103814.0))
lhcb2.new("mcs.b19r8.b2", "mcs", at="lhclength-(856.1337+(-123-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248715.0, assembly_id=103814.0))
lhcb2.new("mb.c19r8.b2", "mb", at="lhclength-(864.3697+(-122.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846498.0, assembly_id=103815.0))
lhcb2.new("mcs.c19r8.b2", "mcs", at="lhclength-(871.7937+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248718.0, assembly_id=103815.0))
lhcb2.new("bpm.19r8.b2", "bpm", at="lhclength-(872.6727+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248720.0, assembly_id=103816.0))
lhcb2.new("mqt.19r8.b2", "mqt", at="lhclength-(873.4267+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307456.0, assembly_id=103816.0))
lhcb2.new("mq.19r8.b2", "mq", at="lhclength-(875.4347+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308207.0, assembly_id=103816.0))
lhcb2.new("ms.19r8.b2", "ms", at="lhclength-(877.3297+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253326.0, assembly_id=103816.0))
lhcb2.new("mcbh.19r8.b2", "mcbh", at="lhclength-(877.9227+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253328.0, assembly_id=103816.0))
lhcb2.new("mco.a20r8.b2", "mco", at="lhclength-(879.0137+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253330.0, assembly_id=103817.0))
lhcb2.new("mcd.a20r8.b2", "mcd", at="lhclength-(879.0152+(-122-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253331.0, assembly_id=103817.0))
lhcb2.new("mb.a20r8.b2", "mb", at="lhclength-(886.4997+(-121.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846522.0, assembly_id=103817.0))
lhcb2.new("mcs.a20r8.b2", "mcs", at="lhclength-(893.9237+(-121-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248728.0, assembly_id=103817.0))
lhcb2.new("mb.b20r8.b2", "mb", at="lhclength-(902.1597+(-120.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846546.0, assembly_id=103818.0))
lhcb2.new("mcs.b20r8.b2", "mcs", at="lhclength-(909.5837+(-120-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248731.0, assembly_id=103818.0))
lhcb2.new("mco.b20r8.b2", "mco", at="lhclength-(910.3337+(-120-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253334.0, assembly_id=103819.0))
lhcb2.new("mcd.b20r8.b2", "mcd", at="lhclength-(910.3352+(-120-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253335.0, assembly_id=103819.0))
lhcb2.new("mb.c20r8.b2", "mb", at="lhclength-(917.8197+(-119.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846570.0, assembly_id=103819.0))
lhcb2.new("mcs.c20r8.b2", "mcs", at="lhclength-(925.2437+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248736.0, assembly_id=103819.0))
lhcb2.new("bpm.20r8.b2", "bpm", at="lhclength-(926.1227+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248738.0, assembly_id=103820.0))
lhcb2.new("mqt.20r8.b2", "mqt", at="lhclength-(926.8767+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2348443.0, assembly_id=103820.0))
lhcb2.new("mq.20r8.b2", "mq", at="lhclength-(928.8847+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308237.0, assembly_id=103820.0))
lhcb2.new("ms.20r8.b2", "ms", at="lhclength-(930.7797+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253338.0, assembly_id=103820.0))
lhcb2.new("mcbv.20r8.b2", "mcbv", at="lhclength-(931.3727+(-119-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253340.0, assembly_id=103820.0))
lhcb2.new("mb.a21r8.b2", "mb", at="lhclength-(939.9497+(-118.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846594.0, assembly_id=103821.0))
lhcb2.new("mcs.a21r8.b2", "mcs", at="lhclength-(947.3737+(-118-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248744.0, assembly_id=103821.0))
lhcb2.new("mco.21r8.b2", "mco", at="lhclength-(948.1237+(-118-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253342.0, assembly_id=103822.0))
lhcb2.new("mcd.21r8.b2", "mcd", at="lhclength-(948.1252+(-118-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253343.0, assembly_id=103822.0))
lhcb2.new("mb.b21r8.b2", "mb", at="lhclength-(955.6097+(-117.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846618.0, assembly_id=103822.0))
lhcb2.new("mcs.b21r8.b2", "mcs", at="lhclength-(963.0337+(-117-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248749.0, assembly_id=103822.0))
lhcb2.new("mb.c21r8.b2", "mb", at="lhclength-(971.2697+(-116.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846642.0, assembly_id=103823.0))
lhcb2.new("mcs.c21r8.b2", "mcs", at="lhclength-(978.6937+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248752.0, assembly_id=103823.0))
lhcb2.new("bpm.21r8.b2", "bpm", at="lhclength-(979.5727+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248754.0, assembly_id=103824.0))
lhcb2.new("mqt.21r8.b2", "mqt", at="lhclength-(980.3267+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307284.0, assembly_id=103824.0))
lhcb2.new("mq.21r8.b2", "mq", at="lhclength-(982.3347+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308268.0, assembly_id=103824.0))
lhcb2.new("ms.21r8.b2", "ms", at="lhclength-(984.2297+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253346.0, assembly_id=103824.0))
lhcb2.new("mcbh.21r8.b2", "mcbh", at="lhclength-(984.8227+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253348.0, assembly_id=103824.0))
lhcb2.new("mco.a22r8.b2", "mco", at="lhclength-(985.9137+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253350.0, assembly_id=103825.0))
lhcb2.new("mcd.a22r8.b2", "mcd", at="lhclength-(985.9152+(-116-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253351.0, assembly_id=103825.0))
lhcb2.new("mb.a22r8.b2", "mb", at="lhclength-(993.3997+(-115.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846666.0, assembly_id=103825.0))
lhcb2.new("mcs.a22r8.b2", "mcs", at="lhclength-(1000.8237+(-115-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248762.0, assembly_id=103825.0))
lhcb2.new("mb.b22r8.b2", "mb", at="lhclength-(1009.0597+(-114.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846690.0, assembly_id=103826.0))
lhcb2.new("mcs.b22r8.b2", "mcs", at="lhclength-(1016.4837+(-114-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248765.0, assembly_id=103826.0))
lhcb2.new("mco.b22r8.b2", "mco", at="lhclength-(1017.2337+(-114-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253354.0, assembly_id=103827.0))
lhcb2.new("mcd.b22r8.b2", "mcd", at="lhclength-(1017.2352+(-114-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253355.0, assembly_id=103827.0))
lhcb2.new("mb.c22r8.b2", "mb", at="lhclength-(1024.7197+(-113.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846714.0, assembly_id=103827.0))
lhcb2.new("mcs.c22r8.b2", "mcs", at="lhclength-(1032.1437+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248770.0, assembly_id=103827.0))
lhcb2.new("bpm.22r8.b2", "bpm", at="lhclength-(1033.0227+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248772.0, assembly_id=103828.0))
lhcb2.new("mo.22r8.b2", "mo", at="lhclength-(1033.7737+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308827.0, assembly_id=103828.0))
lhcb2.new("mq.22r8.b2", "mq", at="lhclength-(1035.7847+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308300.0, assembly_id=103828.0))
lhcb2.new("ms.22r8.b2", "ms", at="lhclength-(1037.6797+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253358.0, assembly_id=103828.0))
lhcb2.new("mcbv.22r8.b2", "mcbv", at="lhclength-(1038.2727+(-113-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253360.0, assembly_id=103828.0))
lhcb2.new("mb.a23r8.b2", "mb", at="lhclength-(1046.8497+(-112.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846738.0, assembly_id=103829.0))
lhcb2.new("mcs.a23r8.b2", "mcs", at="lhclength-(1054.2737+(-112-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248778.0, assembly_id=103829.0))
lhcb2.new("mco.23r8.b2", "mco", at="lhclength-(1055.0237+(-112-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253362.0, assembly_id=103830.0))
lhcb2.new("mcd.23r8.b2", "mcd", at="lhclength-(1055.0252+(-112-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253363.0, assembly_id=103830.0))
lhcb2.new("mb.b23r8.b2", "mb", at="lhclength-(1062.5097+(-111.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846762.0, assembly_id=103830.0))
lhcb2.new("mcs.b23r8.b2", "mcs", at="lhclength-(1069.9337+(-111-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248783.0, assembly_id=103830.0))
lhcb2.new("mb.c23r8.b2", "mb", at="lhclength-(1078.1697+(-110.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846786.0, assembly_id=103831.0))
lhcb2.new("mcs.c23r8.b2", "mcs", at="lhclength-(1085.5937+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248786.0, assembly_id=103831.0))
lhcb2.new("bpm.23r8.b2", "bpm", at="lhclength-(1086.4727+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=266508.0, assembly_id=103832.0))
lhcb2.new("mqs.23r8.b2", "mqs", at="lhclength-(1087.2267+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307650.0, assembly_id=103832.0))
lhcb2.new("mq.23r8.b2", "mq", at="lhclength-(1089.2347+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308089.0, assembly_id=103832.0))
lhcb2.new("ms.23r8.b2", "ms", at="lhclength-(1091.1297+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253366.0, assembly_id=103832.0))
lhcb2.new("mcbh.23r8.b2", "mcbh", at="lhclength-(1091.7227+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253368.0, assembly_id=103832.0))
lhcb2.new("mco.a24r8.b2", "mco", at="lhclength-(1092.8137+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253370.0, assembly_id=103833.0))
lhcb2.new("mcd.a24r8.b2", "mcd", at="lhclength-(1092.8152+(-110-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253371.0, assembly_id=103833.0))
lhcb2.new("mb.a24r8.b2", "mb", at="lhclength-(1100.2997+(-109.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846810.0, assembly_id=103833.0))
lhcb2.new("mcs.a24r8.b2", "mcs", at="lhclength-(1107.7237+(-109-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248794.0, assembly_id=103833.0))
lhcb2.new("mb.b24r8.b2", "mb", at="lhclength-(1115.9597+(-108.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846834.0, assembly_id=103834.0))
lhcb2.new("mcs.b24r8.b2", "mcs", at="lhclength-(1123.3837+(-108-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248797.0, assembly_id=103834.0))
lhcb2.new("mco.b24r8.b2", "mco", at="lhclength-(1124.1337+(-108-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253374.0, assembly_id=103835.0))
lhcb2.new("mcd.b24r8.b2", "mcd", at="lhclength-(1124.1352+(-108-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253375.0, assembly_id=103835.0))
lhcb2.new("mb.c24r8.b2", "mb", at="lhclength-(1131.6197+(-107.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846858.0, assembly_id=103835.0))
lhcb2.new("mcs.c24r8.b2", "mcs", at="lhclength-(1139.0437+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248802.0, assembly_id=103835.0))
lhcb2.new("bpm.24r8.b2", "bpm", at="lhclength-(1139.9227+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248804.0, assembly_id=103836.0))
lhcb2.new("mo.24r8.b2", "mo", at="lhclength-(1140.6737+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308858.0, assembly_id=103836.0))
lhcb2.new("mq.24r8.b2", "mq", at="lhclength-(1142.6847+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308121.0, assembly_id=103836.0))
lhcb2.new("ms.24r8.b2", "ms", at="lhclength-(1144.5797+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253378.0, assembly_id=103836.0))
lhcb2.new("mcbv.24r8.b2", "mcbv", at="lhclength-(1145.1727+(-107-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253380.0, assembly_id=103836.0))
lhcb2.new("mb.a25r8.b2", "mb", at="lhclength-(1153.7497+(-106.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846882.0, assembly_id=103837.0))
lhcb2.new("mcs.a25r8.b2", "mcs", at="lhclength-(1161.1737+(-106-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248810.0, assembly_id=103837.0))
lhcb2.new("mco.25r8.b2", "mco", at="lhclength-(1161.9237+(-106-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253382.0, assembly_id=103838.0))
lhcb2.new("mcd.25r8.b2", "mcd", at="lhclength-(1161.9252+(-106-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253383.0, assembly_id=103838.0))
lhcb2.new("mb.b25r8.b2", "mb", at="lhclength-(1169.4097+(-105.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846906.0, assembly_id=103838.0))
lhcb2.new("mcs.b25r8.b2", "mcs", at="lhclength-(1176.8337+(-105-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248815.0, assembly_id=103838.0))
lhcb2.new("mb.c25r8.b2", "mb", at="lhclength-(1185.0697+(-104.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846930.0, assembly_id=103839.0))
lhcb2.new("mcs.c25r8.b2", "mcs", at="lhclength-(1192.4937+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248818.0, assembly_id=103839.0))
lhcb2.new("bpm.25r8.b2", "bpm", at="lhclength-(1193.3727+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248820.0, assembly_id=103840.0))
lhcb2.new("mo.25r8.b2", "mo", at="lhclength-(1194.1237+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308890.0, assembly_id=103840.0))
lhcb2.new("mq.25r8.b2", "mq", at="lhclength-(1196.1347+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308153.0, assembly_id=103840.0))
lhcb2.new("ms.25r8.b2", "ms", at="lhclength-(1198.0297+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253386.0, assembly_id=103840.0))
lhcb2.new("mcbh.25r8.b2", "mcbh", at="lhclength-(1198.6227+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253388.0, assembly_id=103840.0))
lhcb2.new("mco.a26r8.b2", "mco", at="lhclength-(1199.7137+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253390.0, assembly_id=103841.0))
lhcb2.new("mcd.a26r8.b2", "mcd", at="lhclength-(1199.7152+(-104-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253391.0, assembly_id=103841.0))
lhcb2.new("mb.a26r8.b2", "mb", at="lhclength-(1207.1997+(-103.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846954.0, assembly_id=103841.0))
lhcb2.new("mcs.a26r8.b2", "mcs", at="lhclength-(1214.6237+(-103-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248828.0, assembly_id=103841.0))
lhcb2.new("mb.b26r8.b2", "mb", at="lhclength-(1222.8597+(-102.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52846978.0, assembly_id=103842.0))
lhcb2.new("mcs.b26r8.b2", "mcs", at="lhclength-(1230.2837+(-102-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248831.0, assembly_id=103842.0))
lhcb2.new("mco.b26r8.b2", "mco", at="lhclength-(1231.0337+(-102-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253394.0, assembly_id=103843.0))
lhcb2.new("mcd.b26r8.b2", "mcd", at="lhclength-(1231.0352+(-102-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253395.0, assembly_id=103843.0))
lhcb2.new("mb.c26r8.b2", "mb", at="lhclength-(1238.5197+(-101.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847002.0, assembly_id=103843.0))
lhcb2.new("mcs.c26r8.b2", "mcs", at="lhclength-(1245.9437+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248836.0, assembly_id=103843.0))
lhcb2.new("bpm.26r8.b2", "bpm", at="lhclength-(1246.8227+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248838.0, assembly_id=103844.0))
lhcb2.new("mo.26r8.b2", "mo", at="lhclength-(1247.5737+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308921.0, assembly_id=103844.0))
lhcb2.new("mq.26r8.b2", "mq", at="lhclength-(1249.5847+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308183.0, assembly_id=103844.0))
lhcb2.new("ms.26r8.b2", "ms", at="lhclength-(1251.4797+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253398.0, assembly_id=103844.0))
lhcb2.new("mcbv.26r8.b2", "mcbv", at="lhclength-(1252.0727+(-101-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253400.0, assembly_id=103844.0))
lhcb2.new("mb.a27r8.b2", "mb", at="lhclength-(1260.6497+(-100.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847026.0, assembly_id=103845.0))
lhcb2.new("mcs.a27r8.b2", "mcs", at="lhclength-(1268.0737+(-100-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248844.0, assembly_id=103845.0))
lhcb2.new("mco.27r8.b2", "mco", at="lhclength-(1268.8237+(-100-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253402.0, assembly_id=103846.0))
lhcb2.new("mcd.27r8.b2", "mcd", at="lhclength-(1268.8252+(-100-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253403.0, assembly_id=103846.0))
lhcb2.new("mb.b27r8.b2", "mb", at="lhclength-(1276.3097+(-99.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847050.0, assembly_id=103846.0))
lhcb2.new("mcs.b27r8.b2", "mcs", at="lhclength-(1283.7337+(-99-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248849.0, assembly_id=103846.0))
lhcb2.new("mb.c27r8.b2", "mb", at="lhclength-(1291.9697+(-98.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847074.0, assembly_id=103847.0))
lhcb2.new("mcs.c27r8.b2", "mcs", at="lhclength-(1299.3937+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248852.0, assembly_id=103847.0))
lhcb2.new("bpm.27r8.b2", "bpm", at="lhclength-(1300.2727+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=266510.0, assembly_id=103848.0))
lhcb2.new("mqs.27r8.b2", "mqs", at="lhclength-(1301.0267+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307682.0, assembly_id=103848.0))
lhcb2.new("mq.27r8.b2", "mq", at="lhclength-(1303.0347+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307973.0, assembly_id=103848.0))
lhcb2.new("ms.27r8.b2", "ms", at="lhclength-(1304.9297+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253406.0, assembly_id=103848.0))
lhcb2.new("mcbh.27r8.b2", "mcbh", at="lhclength-(1305.5227+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253408.0, assembly_id=103848.0))
lhcb2.new("mco.a28r8.b2", "mco", at="lhclength-(1306.6137+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253410.0, assembly_id=103849.0))
lhcb2.new("mcd.a28r8.b2", "mcd", at="lhclength-(1306.6152+(-98-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253411.0, assembly_id=103849.0))
lhcb2.new("mb.a28r8.b2", "mb", at="lhclength-(1314.0997+(-97.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847098.0, assembly_id=103849.0))
lhcb2.new("mcs.a28r8.b2", "mcs", at="lhclength-(1321.5237+(-97-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248860.0, assembly_id=103849.0))
lhcb2.new("mb.b28r8.b2", "mb", at="lhclength-(1329.7597+(-96.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847122.0, assembly_id=103850.0))
lhcb2.new("mcs.b28r8.b2", "mcs", at="lhclength-(1337.1837+(-96-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248863.0, assembly_id=103850.0))
lhcb2.new("mco.b28r8.b2", "mco", at="lhclength-(1337.9337+(-96-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253414.0, assembly_id=103851.0))
lhcb2.new("mcd.b28r8.b2", "mcd", at="lhclength-(1337.9352+(-96-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253415.0, assembly_id=103851.0))
lhcb2.new("mb.c28r8.b2", "mb", at="lhclength-(1345.4197+(-95.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847146.0, assembly_id=103851.0))
lhcb2.new("mcs.c28r8.b2", "mcs", at="lhclength-(1352.8437+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248868.0, assembly_id=103851.0))
lhcb2.new("bpm.28r8.b2", "bpm", at="lhclength-(1353.7227+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248870.0, assembly_id=103852.0))
lhcb2.new("mo.28r8.b2", "mo", at="lhclength-(1354.4737+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308711.0, assembly_id=103852.0))
lhcb2.new("mq.28r8.b2", "mq", at="lhclength-(1356.4847+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308005.0, assembly_id=103852.0))
lhcb2.new("ms.28r8.b2", "ms", at="lhclength-(1358.3797+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253418.0, assembly_id=103852.0))
lhcb2.new("mcbv.28r8.b2", "mcbv", at="lhclength-(1358.9727+(-95-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253420.0, assembly_id=103852.0))
lhcb2.new("mb.a29r8.b2", "mb", at="lhclength-(1367.5497+(-94.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847170.0, assembly_id=103853.0))
lhcb2.new("mcs.a29r8.b2", "mcs", at="lhclength-(1374.9737+(-94-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248876.0, assembly_id=103853.0))
lhcb2.new("mco.29r8.b2", "mco", at="lhclength-(1375.7237+(-94-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253422.0, assembly_id=103854.0))
lhcb2.new("mcd.29r8.b2", "mcd", at="lhclength-(1375.7252+(-94-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253423.0, assembly_id=103854.0))
lhcb2.new("mb.b29r8.b2", "mb", at="lhclength-(1383.2097+(-93.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847194.0, assembly_id=103854.0))
lhcb2.new("mcs.b29r8.b2", "mcs", at="lhclength-(1390.6337+(-93-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248881.0, assembly_id=103854.0))
lhcb2.new("mb.c29r8.b2", "mb", at="lhclength-(1398.8697+(-92.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847218.0, assembly_id=103855.0))
lhcb2.new("mcs.c29r8.b2", "mcs", at="lhclength-(1406.2937+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248884.0, assembly_id=103855.0))
lhcb2.new("bpm.29r8.b2", "bpm", at="lhclength-(1407.1727+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248886.0, assembly_id=103856.0))
lhcb2.new("mo.29r8.b2", "mo", at="lhclength-(1407.9237+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308743.0, assembly_id=103856.0))
lhcb2.new("mq.29r8.b2", "mq", at="lhclength-(1409.9347+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308035.0, assembly_id=103856.0))
lhcb2.new("mss.29r8.b2", "mss", at="lhclength-(1411.8297+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253426.0, assembly_id=103856.0))
lhcb2.new("mcbh.29r8.b2", "mcbh", at="lhclength-(1412.4227+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253428.0, assembly_id=103856.0))
lhcb2.new("mco.a30r8.b2", "mco", at="lhclength-(1413.5137+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253430.0, assembly_id=103857.0))
lhcb2.new("mcd.a30r8.b2", "mcd", at="lhclength-(1413.5152+(-92-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253431.0, assembly_id=103857.0))
lhcb2.new("mb.a30r8.b2", "mb", at="lhclength-(1420.9997+(-91.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847242.0, assembly_id=103857.0))
lhcb2.new("mcs.a30r8.b2", "mcs", at="lhclength-(1428.4237+(-91-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248894.0, assembly_id=103857.0))
lhcb2.new("mb.b30r8.b2", "mb", at="lhclength-(1436.6597+(-90.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847266.0, assembly_id=103858.0))
lhcb2.new("mcs.b30r8.b2", "mcs", at="lhclength-(1444.0837+(-90-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248897.0, assembly_id=103858.0))
lhcb2.new("mco.b30r8.b2", "mco", at="lhclength-(1444.8337+(-90-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253434.0, assembly_id=103859.0))
lhcb2.new("mcd.b30r8.b2", "mcd", at="lhclength-(1444.8352+(-90-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253435.0, assembly_id=103859.0))
lhcb2.new("mb.c30r8.b2", "mb", at="lhclength-(1452.3197+(-89.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847290.0, assembly_id=103859.0))
lhcb2.new("mcs.c30r8.b2", "mcs", at="lhclength-(1459.7437+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248902.0, assembly_id=103859.0))
lhcb2.new("bpm.30r8.b2", "bpm", at="lhclength-(1460.6227+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248904.0, assembly_id=103860.0))
lhcb2.new("mo.30r8.b2", "mo", at="lhclength-(1461.3737+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308773.0, assembly_id=103860.0))
lhcb2.new("mq.30r8.b2", "mq", at="lhclength-(1463.3847+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308065.0, assembly_id=103860.0))
lhcb2.new("ms.30r8.b2", "ms", at="lhclength-(1465.2797+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253438.0, assembly_id=103860.0))
lhcb2.new("mcbv.30r8.b2", "mcbv", at="lhclength-(1465.8727+(-89-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253440.0, assembly_id=103860.0))
lhcb2.new("mb.a31r8.b2", "mb", at="lhclength-(1474.4497+(-88.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847314.0, assembly_id=103861.0))
lhcb2.new("mcs.a31r8.b2", "mcs", at="lhclength-(1481.8737+(-88-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248910.0, assembly_id=103861.0))
lhcb2.new("mco.31r8.b2", "mco", at="lhclength-(1482.6237+(-88-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253442.0, assembly_id=103862.0))
lhcb2.new("mcd.31r8.b2", "mcd", at="lhclength-(1482.6252+(-88-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253443.0, assembly_id=103862.0))
lhcb2.new("mb.b31r8.b2", "mb", at="lhclength-(1490.1097+(-87.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847338.0, assembly_id=103862.0))
lhcb2.new("mcs.b31r8.b2", "mcs", at="lhclength-(1497.5337+(-87-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248915.0, assembly_id=103862.0))
lhcb2.new("mb.c31r8.b2", "mb", at="lhclength-(1505.7697+(-86.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847362.0, assembly_id=103863.0))
lhcb2.new("mcs.c31r8.b2", "mcs", at="lhclength-(1513.1937+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248918.0, assembly_id=103863.0))
lhcb2.new("bpm.31r8.b2", "bpm", at="lhclength-(1514.0727+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248920.0, assembly_id=103864.0))
lhcb2.new("mo.31r8.b2", "mo", at="lhclength-(1514.8237+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308803.0, assembly_id=103864.0))
lhcb2.new("mq.31r8.b2", "mq", at="lhclength-(1516.8347+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307857.0, assembly_id=103864.0))
lhcb2.new("ms.31r8.b2", "ms", at="lhclength-(1518.7297+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253446.0, assembly_id=103864.0))
lhcb2.new("mcbh.31r8.b2", "mcbh", at="lhclength-(1519.3227+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253448.0, assembly_id=103864.0))
lhcb2.new("s.cell.81.b2", "omk", at="lhclength-(1520.0697+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a32r8.b2", "mco", at="lhclength-(1520.4137+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253450.0, assembly_id=103865.0))
lhcb2.new("mcd.a32r8.b2", "mcd", at="lhclength-(1520.4152+(-86-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253451.0, assembly_id=103865.0))
lhcb2.new("mb.a32r8.b2", "mb", at="lhclength-(1527.8997+(-85.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847386.0, assembly_id=103865.0))
lhcb2.new("mcs.a32r8.b2", "mcs", at="lhclength-(1535.3237+(-85-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248928.0, assembly_id=103865.0))
lhcb2.new("mb.b32r8.b2", "mb", at="lhclength-(1543.5597+(-84.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847410.0, assembly_id=103866.0))
lhcb2.new("mcs.b32r8.b2", "mcs", at="lhclength-(1550.9837+(-84-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248931.0, assembly_id=103866.0))
lhcb2.new("mco.b32r8.b2", "mco", at="lhclength-(1551.7337+(-84-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253454.0, assembly_id=103867.0))
lhcb2.new("mcd.b32r8.b2", "mcd", at="lhclength-(1551.7352+(-84-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253455.0, assembly_id=103867.0))
lhcb2.new("mb.c32r8.b2", "mb", at="lhclength-(1559.2197+(-83.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847434.0, assembly_id=103867.0))
lhcb2.new("mcs.c32r8.b2", "mcs", at="lhclength-(1566.6437+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248936.0, assembly_id=103867.0))
lhcb2.new("bpm.32r8.b2", "bpm", at="lhclength-(1567.5227+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248938.0, assembly_id=103868.0))
lhcb2.new("mo.32r8.b2", "mo", at="lhclength-(1568.2737+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308596.0, assembly_id=103868.0))
lhcb2.new("mq.32r8.b2", "mq", at="lhclength-(1570.2847+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307887.0, assembly_id=103868.0))
lhcb2.new("ms.32r8.b2", "ms", at="lhclength-(1572.1797+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253458.0, assembly_id=103868.0))
lhcb2.new("mcbv.32r8.b2", "mcbv", at="lhclength-(1572.7727+(-83-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253460.0, assembly_id=103868.0))
lhcb2.new("mb.a33r8.b2", "mb", at="lhclength-(1581.3497+(-82.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847458.0, assembly_id=103869.0))
lhcb2.new("mcs.a33r8.b2", "mcs", at="lhclength-(1588.7737+(-82-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248944.0, assembly_id=103869.0))
lhcb2.new("mco.33r8.b2", "mco", at="lhclength-(1589.5237+(-82-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253462.0, assembly_id=103870.0))
lhcb2.new("mcd.33r8.b2", "mcd", at="lhclength-(1589.5252+(-82-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253463.0, assembly_id=103870.0))
lhcb2.new("mb.b33r8.b2", "mb", at="lhclength-(1597.0097+(-81.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847482.0, assembly_id=103870.0))
lhcb2.new("mcs.b33r8.b2", "mcs", at="lhclength-(1604.4337+(-81-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248949.0, assembly_id=103870.0))
lhcb2.new("mb.c33r8.b2", "mb", at="lhclength-(1612.6697+(-80.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847506.0, assembly_id=103871.0))
lhcb2.new("mcs.c33r8.b2", "mcs", at="lhclength-(1620.0937+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248952.0, assembly_id=103871.0))
lhcb2.new("bpm.33r8.b2", "bpm", at="lhclength-(1620.9727+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248954.0, assembly_id=103872.0))
lhcb2.new("mo.33r8.b2", "mo", at="lhclength-(1621.7237+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308626.0, assembly_id=103872.0))
lhcb2.new("mq.33r8.b2", "mq", at="lhclength-(1623.7347+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307916.0, assembly_id=103872.0))
lhcb2.new("mss.33r8.b2", "mss", at="lhclength-(1625.6297+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253466.0, assembly_id=103872.0))
lhcb2.new("mcbh.33r8.b2", "mcbh", at="lhclength-(1626.2227+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253468.0, assembly_id=103872.0))
lhcb2.new("e.cell.81.b2", "omk", at="lhclength-(1626.9697+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(slot_id=100932.0))
lhcb2.new("mco.a34r8.b2", "mco", at="lhclength-(1627.3137+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253470.0, assembly_id=103873.0))
lhcb2.new("mcd.a34r8.b2", "mcd", at="lhclength-(1627.3152+(-80-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253471.0, assembly_id=103873.0))
lhcb2.new("mb.a34r8.b2", "mb", at="lhclength-(1634.7997+(-79.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847530.0, assembly_id=103873.0))
lhcb2.new("mcs.a34r8.b2", "mcs", at="lhclength-(1642.2237+(-79-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248962.0, assembly_id=103873.0))
lhcb2.new("mb.b34r8.b2", "mb", at="lhclength-(1650.4597+(-78.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847554.0, assembly_id=103874.0))
lhcb2.new("mcs.b34r8.b2", "mcs", at="lhclength-(1657.8837+(-78-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248965.0, assembly_id=103874.0))
lhcb2.new("mco.b34r8.b2", "mco", at="lhclength-(1658.6337+(-78-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253474.0, assembly_id=103875.0))
lhcb2.new("mcd.b34r8.b2", "mcd", at="lhclength-(1658.6352+(-78-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=253475.0, assembly_id=103875.0))
lhcb2.new("mb.c34r8.b2", "mb", at="lhclength-(1666.1197+(-77.5-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=52847578.0, assembly_id=103875.0))
lhcb2.new("mcs.c34r8.b2", "mcs", at="lhclength-(1673.5437+(-77-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248970.0, assembly_id=103875.0))
lhcb2.new("bpm.34r8.b2", "bpm", at="lhclength-(1674.4227+(-77-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=248972.0, assembly_id=103876.0))
lhcb2.new("mo.34r8.b2", "mo", at="lhclength-(1675.1737+(-77-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2308641.0, assembly_id=103876.0))
lhcb2.new("mq.34r8.b2", "mq", at="lhclength-(1677.1847+(-77-ip8ofs.b2)*ds)", from_="ip8", extra=dict(mech_sep=0.194, slot_id=2307931.0, assembly_id=103876.0))
lhcb2.new("ms.34l1.b2", "ms", at="lhclength-(-1664.5007+(-77-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253478.0, assembly_id=103876.0))
lhcb2.new("mcbv.34l1.b2", "mcbv", at="lhclength-(-1663.9077+(-77-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253480.0, assembly_id=103876.0))
lhcb2.new("mb.c34l1.b2", "mb", at="lhclength-(-1655.3307+(-76.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847602.0, assembly_id=103877.0))
lhcb2.new("mcs.c34l1.b2", "mcs", at="lhclength-(-1647.9067+(-76-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=248978.0, assembly_id=103877.0))
lhcb2.new("mco.34l1.b2", "mco", at="lhclength-(-1647.1567+(-76-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253482.0, assembly_id=103878.0))
lhcb2.new("mcd.34l1.b2", "mcd", at="lhclength-(-1647.1552+(-76-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253483.0, assembly_id=103878.0))
lhcb2.new("mb.b34l1.b2", "mb", at="lhclength-(-1639.6707+(-75.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847626.0, assembly_id=103878.0))
lhcb2.new("mcs.b34l1.b2", "mcs", at="lhclength-(-1632.2467+(-75-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=248983.0, assembly_id=103878.0))
lhcb2.new("mb.a34l1.b2", "mb", at="lhclength-(-1624.0107+(-74.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847650.0, assembly_id=103879.0))
lhcb2.new("mcs.a34l1.b2", "mcs", at="lhclength-(-1616.5867+(-74-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=248986.0, assembly_id=103879.0))
lhcb2.new("bpm.33l1.b2", "bpm", at="lhclength-(-1615.7077+(-74-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=248988.0, assembly_id=103880.0))
lhcb2.new("mo.33l1.b2", "mo", at="lhclength-(-1614.9567+(-74-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308598.0, assembly_id=103880.0))
lhcb2.new("mq.33l1.b2", "mq", at="lhclength-(-1612.9457+(-74-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307888.0, assembly_id=103880.0))
lhcb2.new("mss.33l1.b2", "mss", at="lhclength-(-1611.0507+(-74-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253486.0, assembly_id=103880.0))
lhcb2.new("mcbh.33l1.b2", "mcbh", at="lhclength-(-1610.4577+(-74-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253488.0, assembly_id=103880.0))
lhcb2.new("mco.b33l1.b2", "mco", at="lhclength-(-1609.3667+(-74-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253490.0, assembly_id=103881.0))
lhcb2.new("mcd.b33l1.b2", "mcd", at="lhclength-(-1609.3652+(-74-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253491.0, assembly_id=103881.0))
lhcb2.new("mb.c33l1.b2", "mb", at="lhclength-(-1601.8807+(-73.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847674.0, assembly_id=103881.0))
lhcb2.new("mcs.c33l1.b2", "mcs", at="lhclength-(-1594.4567+(-73-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=248996.0, assembly_id=103881.0))
lhcb2.new("mb.b33l1.b2", "mb", at="lhclength-(-1586.2207+(-72.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847698.0, assembly_id=103882.0))
lhcb2.new("mcs.b33l1.b2", "mcs", at="lhclength-(-1578.7967+(-72-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=248999.0, assembly_id=103882.0))
lhcb2.new("mco.a33l1.b2", "mco", at="lhclength-(-1578.0467+(-72-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253494.0, assembly_id=103883.0))
lhcb2.new("mcd.a33l1.b2", "mcd", at="lhclength-(-1578.0452+(-72-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253495.0, assembly_id=103883.0))
lhcb2.new("mb.a33l1.b2", "mb", at="lhclength-(-1570.5607+(-71.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847722.0, assembly_id=103883.0))
lhcb2.new("mcs.a33l1.b2", "mcs", at="lhclength-(-1563.1367+(-71-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249004.0, assembly_id=103883.0))
lhcb2.new("bpm.32l1.b2", "bpm", at="lhclength-(-1562.2577+(-71-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249006.0, assembly_id=103884.0))
lhcb2.new("mo.32l1.b2", "mo", at="lhclength-(-1561.5067+(-71-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308566.0, assembly_id=103884.0))
lhcb2.new("mq.32l1.b2", "mq", at="lhclength-(-1559.4957+(-71-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307859.0, assembly_id=103884.0))
lhcb2.new("ms.32l1.b2", "ms", at="lhclength-(-1557.6007+(-71-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253498.0, assembly_id=103884.0))
lhcb2.new("mcbv.32l1.b2", "mcbv", at="lhclength-(-1557.0077+(-71-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253500.0, assembly_id=103884.0))
lhcb2.new("mb.c32l1.b2", "mb", at="lhclength-(-1548.4307+(-70.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847746.0, assembly_id=103885.0))
lhcb2.new("mcs.c32l1.b2", "mcs", at="lhclength-(-1541.0067+(-70-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249012.0, assembly_id=103885.0))
lhcb2.new("mco.32l1.b2", "mco", at="lhclength-(-1540.2567+(-70-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253502.0, assembly_id=103886.0))
lhcb2.new("mcd.32l1.b2", "mcd", at="lhclength-(-1540.2552+(-70-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253503.0, assembly_id=103886.0))
lhcb2.new("mb.b32l1.b2", "mb", at="lhclength-(-1532.7707+(-69.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847770.0, assembly_id=103886.0))
lhcb2.new("mcs.b32l1.b2", "mcs", at="lhclength-(-1525.3467+(-69-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249017.0, assembly_id=103886.0))
lhcb2.new("mb.a32l1.b2", "mb", at="lhclength-(-1517.1107+(-68.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847794.0, assembly_id=103887.0))
lhcb2.new("mcs.a32l1.b2", "mcs", at="lhclength-(-1509.6867+(-68-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249020.0, assembly_id=103887.0))
lhcb2.new("bpm.31l1.b2", "bpm", at="lhclength-(-1508.8077+(-68-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249022.0, assembly_id=103888.0))
lhcb2.new("mo.31l1.b2", "mo", at="lhclength-(-1508.0567+(-68-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308775.0, assembly_id=103888.0))
lhcb2.new("mq.31l1.b2", "mq", at="lhclength-(-1506.0457+(-68-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308067.0, assembly_id=103888.0))
lhcb2.new("ms.31l1.b2", "ms", at="lhclength-(-1504.1507+(-68-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253506.0, assembly_id=103888.0))
lhcb2.new("mcbh.31l1.b2", "mcbh", at="lhclength-(-1503.5577+(-68-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253508.0, assembly_id=103888.0))
lhcb2.new("mco.b31l1.b2", "mco", at="lhclength-(-1502.4667+(-68-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253510.0, assembly_id=103889.0))
lhcb2.new("mcd.b31l1.b2", "mcd", at="lhclength-(-1502.4652+(-68-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253511.0, assembly_id=103889.0))
lhcb2.new("mb.c31l1.b2", "mb", at="lhclength-(-1494.9807+(-67.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847818.0, assembly_id=103889.0))
lhcb2.new("mcs.c31l1.b2", "mcs", at="lhclength-(-1487.5567+(-67-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249030.0, assembly_id=103889.0))
lhcb2.new("mb.b31l1.b2", "mb", at="lhclength-(-1479.3207+(-66.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847842.0, assembly_id=103890.0))
lhcb2.new("mcs.b31l1.b2", "mcs", at="lhclength-(-1471.8967+(-66-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249033.0, assembly_id=103890.0))
lhcb2.new("mco.a31l1.b2", "mco", at="lhclength-(-1471.1467+(-66-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253514.0, assembly_id=103891.0))
lhcb2.new("mcd.a31l1.b2", "mcd", at="lhclength-(-1471.1452+(-66-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253515.0, assembly_id=103891.0))
lhcb2.new("mb.a31l1.b2", "mb", at="lhclength-(-1463.6607+(-65.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847866.0, assembly_id=103891.0))
lhcb2.new("mcs.a31l1.b2", "mcs", at="lhclength-(-1456.2367+(-65-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249038.0, assembly_id=103891.0))
lhcb2.new("bpm.30l1.b2", "bpm", at="lhclength-(-1455.3577+(-65-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249040.0, assembly_id=103892.0))
lhcb2.new("mo.30l1.b2", "mo", at="lhclength-(-1454.6067+(-65-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308745.0, assembly_id=103892.0))
lhcb2.new("mq.30l1.b2", "mq", at="lhclength-(-1452.5957+(-65-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308037.0, assembly_id=103892.0))
lhcb2.new("ms.30l1.b2", "ms", at="lhclength-(-1450.7007+(-65-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253518.0, assembly_id=103892.0))
lhcb2.new("mcbv.30l1.b2", "mcbv", at="lhclength-(-1450.1077+(-65-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253520.0, assembly_id=103892.0))
lhcb2.new("mb.c30l1.b2", "mb", at="lhclength-(-1441.5307+(-64.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847890.0, assembly_id=103893.0))
lhcb2.new("mcs.c30l1.b2", "mcs", at="lhclength-(-1434.1067+(-64-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249046.0, assembly_id=103893.0))
lhcb2.new("mco.30l1.b2", "mco", at="lhclength-(-1433.3567+(-64-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253522.0, assembly_id=103894.0))
lhcb2.new("mcd.30l1.b2", "mcd", at="lhclength-(-1433.3552+(-64-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253523.0, assembly_id=103894.0))
lhcb2.new("mb.b30l1.b2", "mb", at="lhclength-(-1425.8707+(-63.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847914.0, assembly_id=103894.0))
lhcb2.new("mcs.b30l1.b2", "mcs", at="lhclength-(-1418.4467+(-63-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249051.0, assembly_id=103894.0))
lhcb2.new("mb.a30l1.b2", "mb", at="lhclength-(-1410.2107+(-62.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847938.0, assembly_id=103895.0))
lhcb2.new("mcs.a30l1.b2", "mcs", at="lhclength-(-1402.7867+(-62-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249054.0, assembly_id=103895.0))
lhcb2.new("bpm.29l1.b2", "bpm", at="lhclength-(-1401.9077+(-62-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249056.0, assembly_id=103896.0))
lhcb2.new("mo.29l1.b2", "mo", at="lhclength-(-1401.1567+(-62-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308713.0, assembly_id=103896.0))
lhcb2.new("mq.29l1.b2", "mq", at="lhclength-(-1399.1457+(-62-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308007.0, assembly_id=103896.0))
lhcb2.new("mss.29l1.b2", "mss", at="lhclength-(-1397.2507+(-62-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253526.0, assembly_id=103896.0))
lhcb2.new("mcbh.29l1.b2", "mcbh", at="lhclength-(-1396.6577+(-62-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253528.0, assembly_id=103896.0))
lhcb2.new("mco.b29l1.b2", "mco", at="lhclength-(-1395.5667+(-62-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253530.0, assembly_id=103897.0))
lhcb2.new("mcd.b29l1.b2", "mcd", at="lhclength-(-1395.5652+(-62-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253531.0, assembly_id=103897.0))
lhcb2.new("mb.c29l1.b2", "mb", at="lhclength-(-1388.0807+(-61.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847962.0, assembly_id=103897.0))
lhcb2.new("mcs.c29l1.b2", "mcs", at="lhclength-(-1380.6567+(-61-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249064.0, assembly_id=103897.0))
lhcb2.new("mb.b29l1.b2", "mb", at="lhclength-(-1372.4207+(-60.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52847986.0, assembly_id=103898.0))
lhcb2.new("mcs.b29l1.b2", "mcs", at="lhclength-(-1364.9967+(-60-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249067.0, assembly_id=103898.0))
lhcb2.new("mco.a29l1.b2", "mco", at="lhclength-(-1364.2467+(-60-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253534.0, assembly_id=103899.0))
lhcb2.new("mcd.a29l1.b2", "mcd", at="lhclength-(-1364.2452+(-60-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253535.0, assembly_id=103899.0))
lhcb2.new("mb.a29l1.b2", "mb", at="lhclength-(-1356.7607+(-59.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848010.0, assembly_id=103899.0))
lhcb2.new("mcs.a29l1.b2", "mcs", at="lhclength-(-1349.3367+(-59-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249072.0, assembly_id=103899.0))
lhcb2.new("bpm.28l1.b2", "bpm", at="lhclength-(-1348.4577+(-59-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249074.0, assembly_id=103900.0))
lhcb2.new("mo.28l1.b2", "mo", at="lhclength-(-1347.7067+(-59-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308923.0, assembly_id=103900.0))
lhcb2.new("mq.28l1.b2", "mq", at="lhclength-(-1345.6957+(-59-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307975.0, assembly_id=103900.0))
lhcb2.new("ms.28l1.b2", "ms", at="lhclength-(-1343.8007+(-59-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253538.0, assembly_id=103900.0))
lhcb2.new("mcbv.28l1.b2", "mcbv", at="lhclength-(-1343.2077+(-59-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253540.0, assembly_id=103900.0))
lhcb2.new("mb.c28l1.b2", "mb", at="lhclength-(-1334.6307+(-58.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848034.0, assembly_id=103901.0))
lhcb2.new("mcs.c28l1.b2", "mcs", at="lhclength-(-1327.2067+(-58-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249080.0, assembly_id=103901.0))
lhcb2.new("mco.28l1.b2", "mco", at="lhclength-(-1326.4567+(-58-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253542.0, assembly_id=103902.0))
lhcb2.new("mcd.28l1.b2", "mcd", at="lhclength-(-1326.4552+(-58-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253543.0, assembly_id=103902.0))
lhcb2.new("mb.b28l1.b2", "mb", at="lhclength-(-1318.9707+(-57.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848058.0, assembly_id=103902.0))
lhcb2.new("mcs.b28l1.b2", "mcs", at="lhclength-(-1311.5467+(-57-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249085.0, assembly_id=103902.0))
lhcb2.new("mb.a28l1.b2", "mb", at="lhclength-(-1303.3107+(-56.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848082.0, assembly_id=103903.0))
lhcb2.new("mcs.a28l1.b2", "mcs", at="lhclength-(-1295.8867+(-56-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249088.0, assembly_id=103903.0))
lhcb2.new("bpm.27l1.b2", "bpm", at="lhclength-(-1295.0077+(-56-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=266512.0, assembly_id=103904.0))
lhcb2.new("mqs.27l1.b2", "mqs", at="lhclength-(-1294.2537+(-56-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307652.0, assembly_id=103904.0))
lhcb2.new("mq.27l1.b2", "mq", at="lhclength-(-1292.2457+(-56-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308185.0, assembly_id=103904.0))
lhcb2.new("ms.27l1.b2", "ms", at="lhclength-(-1290.3507+(-56-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253546.0, assembly_id=103904.0))
lhcb2.new("mcbh.27l1.b2", "mcbh", at="lhclength-(-1289.7577+(-56-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253548.0, assembly_id=103904.0))
lhcb2.new("mco.b27l1.b2", "mco", at="lhclength-(-1288.6667+(-56-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253550.0, assembly_id=103905.0))
lhcb2.new("mcd.b27l1.b2", "mcd", at="lhclength-(-1288.6652+(-56-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253551.0, assembly_id=103905.0))
lhcb2.new("mb.c27l1.b2", "mb", at="lhclength-(-1281.1807+(-55.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848106.0, assembly_id=103905.0))
lhcb2.new("mcs.c27l1.b2", "mcs", at="lhclength-(-1273.7567+(-55-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249096.0, assembly_id=103905.0))
lhcb2.new("mb.b27l1.b2", "mb", at="lhclength-(-1265.5207+(-54.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848130.0, assembly_id=103906.0))
lhcb2.new("mcs.b27l1.b2", "mcs", at="lhclength-(-1258.0967+(-54-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249099.0, assembly_id=103906.0))
lhcb2.new("mco.a27l1.b2", "mco", at="lhclength-(-1257.3467+(-54-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253554.0, assembly_id=103907.0))
lhcb2.new("mcd.a27l1.b2", "mcd", at="lhclength-(-1257.3452+(-54-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253555.0, assembly_id=103907.0))
lhcb2.new("mb.a27l1.b2", "mb", at="lhclength-(-1249.8607+(-53.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848154.0, assembly_id=103907.0))
lhcb2.new("mcs.a27l1.b2", "mcs", at="lhclength-(-1242.4367+(-53-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249104.0, assembly_id=103907.0))
lhcb2.new("bpm.26l1.b2", "bpm", at="lhclength-(-1241.5577+(-53-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249106.0, assembly_id=103908.0))
lhcb2.new("mo.26l1.b2", "mo", at="lhclength-(-1240.8067+(-53-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308892.0, assembly_id=103908.0))
lhcb2.new("mq.26l1.b2", "mq", at="lhclength-(-1238.7957+(-53-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308155.0, assembly_id=103908.0))
lhcb2.new("ms.26l1.b2", "ms", at="lhclength-(-1236.9007+(-53-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253558.0, assembly_id=103908.0))
lhcb2.new("mcbv.26l1.b2", "mcbv", at="lhclength-(-1236.3077+(-53-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253560.0, assembly_id=103908.0))
lhcb2.new("mb.c26l1.b2", "mb", at="lhclength-(-1227.7307+(-52.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848178.0, assembly_id=103909.0))
lhcb2.new("mcs.c26l1.b2", "mcs", at="lhclength-(-1220.3067+(-52-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249112.0, assembly_id=103909.0))
lhcb2.new("mco.26l1.b2", "mco", at="lhclength-(-1219.5567+(-52-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253562.0, assembly_id=103910.0))
lhcb2.new("mcd.26l1.b2", "mcd", at="lhclength-(-1219.5552+(-52-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253563.0, assembly_id=103910.0))
lhcb2.new("mb.b26l1.b2", "mb", at="lhclength-(-1212.0707+(-51.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848202.0, assembly_id=103910.0))
lhcb2.new("mcs.b26l1.b2", "mcs", at="lhclength-(-1204.6467+(-51-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249117.0, assembly_id=103910.0))
lhcb2.new("mb.a26l1.b2", "mb", at="lhclength-(-1196.4107+(-50.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848226.0, assembly_id=103911.0))
lhcb2.new("mcs.a26l1.b2", "mcs", at="lhclength-(-1188.9867+(-50-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249120.0, assembly_id=103911.0))
lhcb2.new("bpm.25l1.b2", "bpm", at="lhclength-(-1188.1077+(-50-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249122.0, assembly_id=103912.0))
lhcb2.new("mo.25l1.b2", "mo", at="lhclength-(-1187.3567+(-50-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308860.0, assembly_id=103912.0))
lhcb2.new("mq.25l1.b2", "mq", at="lhclength-(-1185.3457+(-50-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308123.0, assembly_id=103912.0))
lhcb2.new("ms.25l1.b2", "ms", at="lhclength-(-1183.4507+(-50-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253566.0, assembly_id=103912.0))
lhcb2.new("mcbh.25l1.b2", "mcbh", at="lhclength-(-1182.8577+(-50-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253568.0, assembly_id=103912.0))
lhcb2.new("mco.b25l1.b2", "mco", at="lhclength-(-1181.7667+(-50-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253570.0, assembly_id=103913.0))
lhcb2.new("mcd.b25l1.b2", "mcd", at="lhclength-(-1181.7652+(-50-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253571.0, assembly_id=103913.0))
lhcb2.new("mb.c25l1.b2", "mb", at="lhclength-(-1174.2807+(-49.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848250.0, assembly_id=103913.0))
lhcb2.new("mcs.c25l1.b2", "mcs", at="lhclength-(-1166.8567+(-49-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249130.0, assembly_id=103913.0))
lhcb2.new("mb.b25l1.b2", "mb", at="lhclength-(-1158.6207+(-48.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848274.0, assembly_id=103914.0))
lhcb2.new("mcs.b25l1.b2", "mcs", at="lhclength-(-1151.1967+(-48-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249133.0, assembly_id=103914.0))
lhcb2.new("mco.a25l1.b2", "mco", at="lhclength-(-1150.4467+(-48-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253574.0, assembly_id=103915.0))
lhcb2.new("mcd.a25l1.b2", "mcd", at="lhclength-(-1150.4452+(-48-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253575.0, assembly_id=103915.0))
lhcb2.new("mb.a25l1.b2", "mb", at="lhclength-(-1142.9607+(-47.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848298.0, assembly_id=103915.0))
lhcb2.new("mcs.a25l1.b2", "mcs", at="lhclength-(-1135.5367+(-47-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249138.0, assembly_id=103915.0))
lhcb2.new("bpm.24l1.b2", "bpm", at="lhclength-(-1134.6577+(-47-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249140.0, assembly_id=103916.0))
lhcb2.new("mo.24l1.b2", "mo", at="lhclength-(-1133.9067+(-47-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308829.0, assembly_id=103916.0))
lhcb2.new("mq.24l1.b2", "mq", at="lhclength-(-1131.8957+(-47-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308091.0, assembly_id=103916.0))
lhcb2.new("ms.24l1.b2", "ms", at="lhclength-(-1130.0007+(-47-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253578.0, assembly_id=103916.0))
lhcb2.new("mcbv.24l1.b2", "mcbv", at="lhclength-(-1129.4077+(-47-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253580.0, assembly_id=103916.0))
lhcb2.new("mb.c24l1.b2", "mb", at="lhclength-(-1120.8307+(-46.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848322.0, assembly_id=103917.0))
lhcb2.new("mcs.c24l1.b2", "mcs", at="lhclength-(-1113.4067+(-46-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249146.0, assembly_id=103917.0))
lhcb2.new("mco.24l1.b2", "mco", at="lhclength-(-1112.6567+(-46-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253582.0, assembly_id=103918.0))
lhcb2.new("mcd.24l1.b2", "mcd", at="lhclength-(-1112.6552+(-46-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253583.0, assembly_id=103918.0))
lhcb2.new("mb.b24l1.b2", "mb", at="lhclength-(-1105.1707+(-45.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848346.0, assembly_id=103918.0))
lhcb2.new("mcs.b24l1.b2", "mcs", at="lhclength-(-1097.7467+(-45-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249151.0, assembly_id=103918.0))
lhcb2.new("mb.a24l1.b2", "mb", at="lhclength-(-1089.5107+(-44.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848370.0, assembly_id=103919.0))
lhcb2.new("mcs.a24l1.b2", "mcs", at="lhclength-(-1082.0867+(-44-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249154.0, assembly_id=103919.0))
lhcb2.new("bpm.23l1.b2", "bpm", at="lhclength-(-1081.2077+(-44-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=266514.0, assembly_id=103920.0))
lhcb2.new("mqs.23l1.b2", "mqs", at="lhclength-(-1080.4537+(-44-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307622.0, assembly_id=103920.0))
lhcb2.new("mq.23l1.b2", "mq", at="lhclength-(-1078.4457+(-44-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308302.0, assembly_id=103920.0))
lhcb2.new("ms.23l1.b2", "ms", at="lhclength-(-1076.5507+(-44-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253586.0, assembly_id=103920.0))
lhcb2.new("mcbh.23l1.b2", "mcbh", at="lhclength-(-1075.9577+(-44-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253588.0, assembly_id=103920.0))
lhcb2.new("mco.b23l1.b2", "mco", at="lhclength-(-1074.8667+(-44-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253590.0, assembly_id=103921.0))
lhcb2.new("mcd.b23l1.b2", "mcd", at="lhclength-(-1074.8652+(-44-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253591.0, assembly_id=103921.0))
lhcb2.new("mb.c23l1.b2", "mb", at="lhclength-(-1067.3807+(-43.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848394.0, assembly_id=103921.0))
lhcb2.new("mcs.c23l1.b2", "mcs", at="lhclength-(-1059.9567+(-43-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249162.0, assembly_id=103921.0))
lhcb2.new("mb.b23l1.b2", "mb", at="lhclength-(-1051.7207+(-42.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848418.0, assembly_id=103922.0))
lhcb2.new("mcs.b23l1.b2", "mcs", at="lhclength-(-1044.2967+(-42-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249165.0, assembly_id=103922.0))
lhcb2.new("mco.a23l1.b2", "mco", at="lhclength-(-1043.5467+(-42-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253594.0, assembly_id=103923.0))
lhcb2.new("mcd.a23l1.b2", "mcd", at="lhclength-(-1043.5452+(-42-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253595.0, assembly_id=103923.0))
lhcb2.new("mb.a23l1.b2", "mb", at="lhclength-(-1036.0607+(-41.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848442.0, assembly_id=103923.0))
lhcb2.new("mcs.a23l1.b2", "mcs", at="lhclength-(-1028.6367+(-41-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249170.0, assembly_id=103923.0))
lhcb2.new("bpm.22l1.b2", "bpm", at="lhclength-(-1027.7577+(-41-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249172.0, assembly_id=103924.0))
lhcb2.new("mo.22l1.b2", "mo", at="lhclength-(-1027.0067+(-41-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2309036.0, assembly_id=103924.0))
lhcb2.new("mq.22l1.b2", "mq", at="lhclength-(-1024.9957+(-41-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308270.0, assembly_id=103924.0))
lhcb2.new("ms.22l1.b2", "ms", at="lhclength-(-1023.1007+(-41-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253598.0, assembly_id=103924.0))
lhcb2.new("mcbv.22l1.b2", "mcbv", at="lhclength-(-1022.5077+(-41-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253600.0, assembly_id=103924.0))
lhcb2.new("mb.c22l1.b2", "mb", at="lhclength-(-1013.9307+(-40.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848466.0, assembly_id=103925.0))
lhcb2.new("mcs.c22l1.b2", "mcs", at="lhclength-(-1006.5067+(-40-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249178.0, assembly_id=103925.0))
lhcb2.new("mco.22l1.b2", "mco", at="lhclength-(-1005.7567+(-40-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253602.0, assembly_id=103926.0))
lhcb2.new("mcd.22l1.b2", "mcd", at="lhclength-(-1005.7552+(-40-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253603.0, assembly_id=103926.0))
lhcb2.new("mb.b22l1.b2", "mb", at="lhclength-(-998.2707+(-39.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848490.0, assembly_id=103926.0))
lhcb2.new("mcs.b22l1.b2", "mcs", at="lhclength-(-990.8467+(-39-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249183.0, assembly_id=103926.0))
lhcb2.new("mb.a22l1.b2", "mb", at="lhclength-(-982.6107+(-38.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848514.0, assembly_id=103927.0))
lhcb2.new("mcs.a22l1.b2", "mcs", at="lhclength-(-975.1867+(-38-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249186.0, assembly_id=103927.0))
lhcb2.new("bpm.21l1.b2", "bpm", at="lhclength-(-974.3077+(-38-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249188.0, assembly_id=103928.0))
lhcb2.new("mqt.21l1.b2", "mqt", at="lhclength-(-973.5537+(-38-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307487.0, assembly_id=103928.0))
lhcb2.new("mq.21l1.b2", "mq", at="lhclength-(-971.5457+(-38-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308239.0, assembly_id=103928.0))
lhcb2.new("ms.21l1.b2", "ms", at="lhclength-(-969.6507+(-38-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253606.0, assembly_id=103928.0))
lhcb2.new("mcbh.21l1.b2", "mcbh", at="lhclength-(-969.0577+(-38-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253608.0, assembly_id=103928.0))
lhcb2.new("mco.b21l1.b2", "mco", at="lhclength-(-967.9667+(-38-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253610.0, assembly_id=103929.0))
lhcb2.new("mcd.b21l1.b2", "mcd", at="lhclength-(-967.9652+(-38-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253611.0, assembly_id=103929.0))
lhcb2.new("mb.c21l1.b2", "mb", at="lhclength-(-960.4807+(-37.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848538.0, assembly_id=103929.0))
lhcb2.new("mcs.c21l1.b2", "mcs", at="lhclength-(-953.0567+(-37-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249196.0, assembly_id=103929.0))
lhcb2.new("mb.b21l1.b2", "mb", at="lhclength-(-944.8207+(-36.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848562.0, assembly_id=103930.0))
lhcb2.new("mcs.b21l1.b2", "mcs", at="lhclength-(-937.3967+(-36-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249199.0, assembly_id=103930.0))
lhcb2.new("mco.a21l1.b2", "mco", at="lhclength-(-936.6467+(-36-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253614.0, assembly_id=103931.0))
lhcb2.new("mcd.a21l1.b2", "mcd", at="lhclength-(-936.6452+(-36-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253615.0, assembly_id=103931.0))
lhcb2.new("mb.a21l1.b2", "mb", at="lhclength-(-929.1607+(-35.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848586.0, assembly_id=103931.0))
lhcb2.new("mcs.a21l1.b2", "mcs", at="lhclength-(-921.7367+(-35-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249204.0, assembly_id=103931.0))
lhcb2.new("bpm.20l1.b2", "bpm", at="lhclength-(-920.8577+(-35-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249206.0, assembly_id=103932.0))
lhcb2.new("mqt.20l1.b2", "mqt", at="lhclength-(-920.1037+(-35-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307458.0, assembly_id=103932.0))
lhcb2.new("mq.20l1.b2", "mq", at="lhclength-(-918.0957+(-35-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308209.0, assembly_id=103932.0))
lhcb2.new("ms.20l1.b2", "ms", at="lhclength-(-916.2007+(-35-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253618.0, assembly_id=103932.0))
lhcb2.new("mcbv.20l1.b2", "mcbv", at="lhclength-(-915.6077+(-35-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253620.0, assembly_id=103932.0))
lhcb2.new("mb.c20l1.b2", "mb", at="lhclength-(-907.0307+(-34.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848610.0, assembly_id=103933.0))
lhcb2.new("mcs.c20l1.b2", "mcs", at="lhclength-(-899.6067+(-34-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249212.0, assembly_id=103933.0))
lhcb2.new("mco.20l1.b2", "mco", at="lhclength-(-898.8567+(-34-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253622.0, assembly_id=103934.0))
lhcb2.new("mcd.20l1.b2", "mcd", at="lhclength-(-898.8552+(-34-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253623.0, assembly_id=103934.0))
lhcb2.new("mb.b20l1.b2", "mb", at="lhclength-(-891.3707+(-33.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848634.0, assembly_id=103934.0))
lhcb2.new("mcs.b20l1.b2", "mcs", at="lhclength-(-883.9467+(-33-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249217.0, assembly_id=103934.0))
lhcb2.new("mb.a20l1.b2", "mb", at="lhclength-(-875.7107+(-32.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848658.0, assembly_id=103935.0))
lhcb2.new("mcs.a20l1.b2", "mcs", at="lhclength-(-868.2867+(-32-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249220.0, assembly_id=103935.0))
lhcb2.new("bpm.19l1.b2", "bpm", at="lhclength-(-867.4077+(-32-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249222.0, assembly_id=103936.0))
lhcb2.new("mqt.19l1.b2", "mqt", at="lhclength-(-866.6537+(-32-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307428.0, assembly_id=103936.0))
lhcb2.new("mq.19l1.b2", "mq", at="lhclength-(-864.6457+(-32-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308417.0, assembly_id=103936.0))
lhcb2.new("ms.19l1.b2", "ms", at="lhclength-(-862.7507+(-32-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253626.0, assembly_id=103936.0))
lhcb2.new("mcbh.19l1.b2", "mcbh", at="lhclength-(-862.1577+(-32-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253628.0, assembly_id=103936.0))
lhcb2.new("mco.b19l1.b2", "mco", at="lhclength-(-861.0667+(-32-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253630.0, assembly_id=103937.0))
lhcb2.new("mcd.b19l1.b2", "mcd", at="lhclength-(-861.0652+(-32-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253631.0, assembly_id=103937.0))
lhcb2.new("mb.c19l1.b2", "mb", at="lhclength-(-853.5807+(-31.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848682.0, assembly_id=103937.0))
lhcb2.new("mcs.c19l1.b2", "mcs", at="lhclength-(-846.1567+(-31-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249230.0, assembly_id=103937.0))
lhcb2.new("mb.b19l1.b2", "mb", at="lhclength-(-837.9207+(-30.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848706.0, assembly_id=103938.0))
lhcb2.new("mcs.b19l1.b2", "mcs", at="lhclength-(-830.4967+(-30-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249233.0, assembly_id=103938.0))
lhcb2.new("mco.a19l1.b2", "mco", at="lhclength-(-829.7467+(-30-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253634.0, assembly_id=103939.0))
lhcb2.new("mcd.a19l1.b2", "mcd", at="lhclength-(-829.7452+(-30-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253635.0, assembly_id=103939.0))
lhcb2.new("mb.a19l1.b2", "mb", at="lhclength-(-822.2607+(-29.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848730.0, assembly_id=103939.0))
lhcb2.new("mcs.a19l1.b2", "mcs", at="lhclength-(-814.8367+(-29-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249238.0, assembly_id=103939.0))
lhcb2.new("bpm.18l1.b2", "bpm", at="lhclength-(-813.9577+(-29-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249240.0, assembly_id=103940.0))
lhcb2.new("mqt.18l1.b2", "mqt", at="lhclength-(-813.2037+(-29-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307396.0, assembly_id=103940.0))
lhcb2.new("mq.18l1.b2", "mq", at="lhclength-(-811.1957+(-29-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308386.0, assembly_id=103940.0))
lhcb2.new("ms.18l1.b2", "ms", at="lhclength-(-809.3007+(-29-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253638.0, assembly_id=103940.0))
lhcb2.new("mcbv.18l1.b2", "mcbv", at="lhclength-(-808.7077+(-29-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253640.0, assembly_id=103940.0))
lhcb2.new("mb.c18l1.b2", "mb", at="lhclength-(-800.1307+(-28.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848754.0, assembly_id=103941.0))
lhcb2.new("mcs.c18l1.b2", "mcs", at="lhclength-(-792.7067+(-28-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249246.0, assembly_id=103941.0))
lhcb2.new("mco.18l1.b2", "mco", at="lhclength-(-791.9567+(-28-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253642.0, assembly_id=103942.0))
lhcb2.new("mcd.18l1.b2", "mcd", at="lhclength-(-791.9552+(-28-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253643.0, assembly_id=103942.0))
lhcb2.new("mb.b18l1.b2", "mb", at="lhclength-(-784.4707+(-27.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848778.0, assembly_id=103942.0))
lhcb2.new("mcs.b18l1.b2", "mcs", at="lhclength-(-777.0467+(-27-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249251.0, assembly_id=103942.0))
lhcb2.new("mb.a18l1.b2", "mb", at="lhclength-(-768.8107+(-26.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848802.0, assembly_id=103943.0))
lhcb2.new("mcs.a18l1.b2", "mcs", at="lhclength-(-761.3867+(-26-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249254.0, assembly_id=103943.0))
lhcb2.new("bpm.17l1.b2", "bpm", at="lhclength-(-760.5077+(-26-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249256.0, assembly_id=103944.0))
lhcb2.new("mqt.17l1.b2", "mqt", at="lhclength-(-759.7537+(-26-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307601.0, assembly_id=103944.0))
lhcb2.new("mq.17l1.b2", "mq", at="lhclength-(-757.7457+(-26-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308356.0, assembly_id=103944.0))
lhcb2.new("ms.17l1.b2", "ms", at="lhclength-(-755.8507+(-26-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253646.0, assembly_id=103944.0))
lhcb2.new("mcbh.17l1.b2", "mcbh", at="lhclength-(-755.2577+(-26-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253648.0, assembly_id=103944.0))
lhcb2.new("mco.b17l1.b2", "mco", at="lhclength-(-754.1667+(-26-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253650.0, assembly_id=103945.0))
lhcb2.new("mcd.b17l1.b2", "mcd", at="lhclength-(-754.1652+(-26-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253651.0, assembly_id=103945.0))
lhcb2.new("mb.c17l1.b2", "mb", at="lhclength-(-746.6807+(-25.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848826.0, assembly_id=103945.0))
lhcb2.new("mcs.c17l1.b2", "mcs", at="lhclength-(-739.2567+(-25-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249264.0, assembly_id=103945.0))
lhcb2.new("mb.b17l1.b2", "mb", at="lhclength-(-731.0207+(-24.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848850.0, assembly_id=103946.0))
lhcb2.new("mcs.b17l1.b2", "mcs", at="lhclength-(-723.5967+(-24-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249267.0, assembly_id=103946.0))
lhcb2.new("mco.a17l1.b2", "mco", at="lhclength-(-722.8467+(-24-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253654.0, assembly_id=103947.0))
lhcb2.new("mcd.a17l1.b2", "mcd", at="lhclength-(-722.8452+(-24-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253655.0, assembly_id=103947.0))
lhcb2.new("mb.a17l1.b2", "mb", at="lhclength-(-715.3607+(-23.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848874.0, assembly_id=103947.0))
lhcb2.new("mcs.a17l1.b2", "mcs", at="lhclength-(-707.9367+(-23-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249272.0, assembly_id=103947.0))
lhcb2.new("bpm.16l1.b2", "bpm", at="lhclength-(-707.0577+(-23-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249274.0, assembly_id=103948.0))
lhcb2.new("mqt.16l1.b2", "mqt", at="lhclength-(-706.3037+(-23-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307571.0, assembly_id=103948.0))
lhcb2.new("mq.16l1.b2", "mq", at="lhclength-(-704.2957+(-23-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308564.0, assembly_id=103948.0))
lhcb2.new("ms.16l1.b2", "ms", at="lhclength-(-702.4007+(-23-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253658.0, assembly_id=103948.0))
lhcb2.new("mcbv.16l1.b2", "mcbv", at="lhclength-(-701.8077+(-23-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253660.0, assembly_id=103948.0))
lhcb2.new("mb.c16l1.b2", "mb", at="lhclength-(-693.2307+(-22.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848898.0, assembly_id=103949.0))
lhcb2.new("mcs.c16l1.b2", "mcs", at="lhclength-(-685.8067+(-22-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249280.0, assembly_id=103949.0))
lhcb2.new("mco.16l1.b2", "mco", at="lhclength-(-685.0567+(-22-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253662.0, assembly_id=103950.0))
lhcb2.new("mcd.16l1.b2", "mcd", at="lhclength-(-685.0552+(-22-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253663.0, assembly_id=103950.0))
lhcb2.new("mb.b16l1.b2", "mb", at="lhclength-(-677.5707+(-21.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848922.0, assembly_id=103950.0))
lhcb2.new("mcs.b16l1.b2", "mcs", at="lhclength-(-670.1467+(-21-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249285.0, assembly_id=103950.0))
lhcb2.new("mb.a16l1.b2", "mb", at="lhclength-(-661.9107+(-20.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848946.0, assembly_id=103951.0))
lhcb2.new("mcs.a16l1.b2", "mcs", at="lhclength-(-654.4867+(-20-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249288.0, assembly_id=103951.0))
lhcb2.new("bpm.15l1.b2", "bpm", at="lhclength-(-653.6077+(-20-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249290.0, assembly_id=103952.0))
lhcb2.new("mqt.15l1.b2", "mqt", at="lhclength-(-652.8537+(-20-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307540.0, assembly_id=103952.0))
lhcb2.new("mq.15l1.b2", "mq", at="lhclength-(-650.8457+(-20-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308533.0, assembly_id=103952.0))
lhcb2.new("ms.15l1.b2", "ms", at="lhclength-(-648.9507+(-20-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253666.0, assembly_id=103952.0))
lhcb2.new("mcbh.15l1.b2", "mcbh", at="lhclength-(-648.3577+(-20-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253668.0, assembly_id=103952.0))
lhcb2.new("mco.b15l1.b2", "mco", at="lhclength-(-647.2667+(-20-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253670.0, assembly_id=103953.0))
lhcb2.new("mcd.b15l1.b2", "mcd", at="lhclength-(-647.2652+(-20-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253671.0, assembly_id=103953.0))
lhcb2.new("mb.c15l1.b2", "mb", at="lhclength-(-639.7807+(-19.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848970.0, assembly_id=103953.0))
lhcb2.new("mcs.c15l1.b2", "mcs", at="lhclength-(-632.3567+(-19-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249298.0, assembly_id=103953.0))
lhcb2.new("mb.b15l1.b2", "mb", at="lhclength-(-624.1207+(-18.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52848994.0, assembly_id=103954.0))
lhcb2.new("mcs.b15l1.b2", "mcs", at="lhclength-(-616.6967+(-18-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249301.0, assembly_id=103954.0))
lhcb2.new("mco.a15l1.b2", "mco", at="lhclength-(-615.9467+(-18-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253674.0, assembly_id=103955.0))
lhcb2.new("mcd.a15l1.b2", "mcd", at="lhclength-(-615.9452+(-18-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253675.0, assembly_id=103955.0))
lhcb2.new("mb.a15l1.b2", "mb", at="lhclength-(-608.4607+(-17.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849018.0, assembly_id=103955.0))
lhcb2.new("mcs.a15l1.b2", "mcs", at="lhclength-(-601.0367+(-17-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249306.0, assembly_id=103955.0))
lhcb2.new("bpm.14l1.b2", "bpm", at="lhclength-(-600.1577+(-17-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249308.0, assembly_id=103956.0))
lhcb2.new("mqt.14l1.b2", "mqt", at="lhclength-(-599.4037+(-17-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307508.0, assembly_id=103956.0))
lhcb2.new("mq.14l1.b2", "mq", at="lhclength-(-597.3957+(-17-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308503.0, assembly_id=103956.0))
lhcb2.new("ms.14l1.b2", "ms", at="lhclength-(-595.5007+(-17-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253678.0, assembly_id=103956.0))
lhcb2.new("mcbv.14l1.b2", "mcbv", at="lhclength-(-594.9077+(-17-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253680.0, assembly_id=103956.0))
lhcb2.new("mb.c14l1.b2", "mb", at="lhclength-(-586.3307+(-16.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849042.0, assembly_id=103957.0))
lhcb2.new("mcs.c14l1.b2", "mcs", at="lhclength-(-578.9067+(-16-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249314.0, assembly_id=103957.0))
lhcb2.new("mco.14l1.b2", "mco", at="lhclength-(-578.1567+(-16-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253682.0, assembly_id=103958.0))
lhcb2.new("mcd.14l1.b2", "mcd", at="lhclength-(-578.1552+(-16-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253683.0, assembly_id=103958.0))
lhcb2.new("mb.b14l1.b2", "mb", at="lhclength-(-570.6707+(-15.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849066.0, assembly_id=103958.0))
lhcb2.new("mcs.b14l1.b2", "mcs", at="lhclength-(-563.2467+(-15-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249319.0, assembly_id=103958.0))
lhcb2.new("mb.a14l1.b2", "mb", at="lhclength-(-555.0107+(-14.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849090.0, assembly_id=103959.0))
lhcb2.new("mcs.a14l1.b2", "mcs", at="lhclength-(-547.5867+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249322.0, assembly_id=103959.0))
lhcb2.new("s.ds.l1.b2", "omk", at="lhclength-(-547.1807+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.13l1.b2", "bpm", at="lhclength-(-546.7077+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249324.0, assembly_id=103960.0))
lhcb2.new("mqt.13l1.b2", "mqt", at="lhclength-(-545.9537+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307716.0, assembly_id=103960.0))
lhcb2.new("mq.13l1.b2", "mq", at="lhclength-(-543.9457+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2348485.0, assembly_id=103960.0))
lhcb2.new("ms.13l1.b2", "ms", at="lhclength-(-542.0507+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253686.0, assembly_id=103960.0))
lhcb2.new("mcbh.13l1.b2", "mcbh", at="lhclength-(-541.4577+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253688.0, assembly_id=103960.0))
lhcb2.new("mco.b13l1.b2", "mco", at="lhclength-(-540.3667+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253690.0, assembly_id=103961.0))
lhcb2.new("mcd.b13l1.b2", "mcd", at="lhclength-(-540.3652+(-14-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253691.0, assembly_id=103961.0))
lhcb2.new("mb.c13l1.b2", "mb", at="lhclength-(-532.8807+(-13.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849114.0, assembly_id=103961.0))
lhcb2.new("mcs.c13l1.b2", "mcs", at="lhclength-(-525.4567+(-13-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249332.0, assembly_id=103961.0))
lhcb2.new("mb.b13l1.b2", "mb", at="lhclength-(-517.2207+(-12.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849138.0, assembly_id=103962.0))
lhcb2.new("mcs.b13l1.b2", "mcs", at="lhclength-(-509.7967+(-12-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249335.0, assembly_id=103962.0))
lhcb2.new("mco.a13l1.b2", "mco", at="lhclength-(-509.0467+(-12-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253694.0, assembly_id=103963.0))
lhcb2.new("mcd.a13l1.b2", "mcd", at="lhclength-(-509.0452+(-12-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253695.0, assembly_id=103963.0))
lhcb2.new("mb.a13l1.b2", "mb", at="lhclength-(-501.5607+(-11.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849162.0, assembly_id=103963.0))
lhcb2.new("mcs.a13l1.b2", "mcs", at="lhclength-(-494.1367+(-11-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249340.0, assembly_id=103963.0))
lhcb2.new("bpm.12l1.b2", "bpm", at="lhclength-(-493.2577+(-11-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249342.0, assembly_id=103964.0))
lhcb2.new("mqt.12l1.b2", "mqt", at="lhclength-(-492.5037+(-11-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307684.0, assembly_id=103964.0))
lhcb2.new("mq.12l1.b2", "mq", at="lhclength-(-490.4957+(-11-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2308680.0, assembly_id=103964.0))
lhcb2.new("ms.12l1.b2", "ms", at="lhclength-(-488.6007+(-11-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253698.0, assembly_id=103964.0))
lhcb2.new("mcbv.12l1.b2", "mcbv", at="lhclength-(-488.0077+(-11-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253700.0, assembly_id=103964.0))
lhcb2.new("mb.c12l1.b2", "mb", at="lhclength-(-479.4307+(-10.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849186.0, assembly_id=103965.0))
lhcb2.new("mcs.c12l1.b2", "mcs", at="lhclength-(-472.0067+(-10-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249348.0, assembly_id=103965.0))
lhcb2.new("mco.12l1.b2", "mco_unplugged", at="lhclength-(-471.2567+(-10-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253702.0, assembly_id=103966.0))
lhcb2.new("mcd.12l1.b2", "mcd", at="lhclength-(-471.2552+(-10-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253703.0, assembly_id=103966.0))
lhcb2.new("mb.b12l1.b2", "mb", at="lhclength-(-463.7707+(-9.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849210.0, assembly_id=103966.0))
lhcb2.new("mcs.b12l1.b2", "mcs", at="lhclength-(-456.3467+(-9-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249353.0, assembly_id=103966.0))
lhcb2.new("mb.a12l1.b2", "mb", at="lhclength-(-448.1107+(-8.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849234.0, assembly_id=103967.0))
lhcb2.new("mcs.a12l1.b2", "mcs", at="lhclength-(-440.6867+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249356.0, assembly_id=103967.0))
lhcb2.new("e.arc.81.b2", "omk", at="lhclength-(-440.2807+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.11l1.b2", "bpm", at="lhclength-(-439.8077+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249358.0, assembly_id=103968.0))
lhcb2.new("mq.11l1.b2", "mq", at="lhclength-(-437.2607+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2348494.0, assembly_id=103968.0))
lhcb2.new("mqtli.11l1.b2", "mqtli", at="lhclength-(-434.8917+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307339.0, assembly_id=103968.0))
lhcb2.new("ms.11l1.b2", "ms", at="lhclength-(-433.8797+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253706.0, assembly_id=103968.0))
lhcb2.new("mcbh.11l1.b2", "mcbh", at="lhclength-(-433.2867+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253708.0, assembly_id=103968.0))
lhcb2.new("lefl.11l1.b2", "lefl", at="lhclength-(-425.67735+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52997886.0, assembly_id=103969.0))
lhcb2.new("mco.11l1.b2", "mco_unplugged", at="lhclength-(-418.475+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253710.0, assembly_id=103970.0))
lhcb2.new("mcd.11l1.b2", "mcd", at="lhclength-(-418.4735+(-8-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253711.0, assembly_id=103970.0))
lhcb2.new("mb.b11l1.b2", "mb", at="lhclength-(-410.989+(-7.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849258.0, assembly_id=103970.0))
lhcb2.new("mcs.b11l1.b2", "mcs", at="lhclength-(-403.565+(-7-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249366.0, assembly_id=103970.0))
lhcb2.new("mb.a11l1.b2", "mb", at="lhclength-(-395.329+(-6.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849810.0, assembly_id=103971.0))
lhcb2.new("mcs.a11l1.b2", "mcs", at="lhclength-(-387.905+(-6-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=357342.0, assembly_id=103971.0))
lhcb2.new("bpm.10l1.b2", "bpm", at="lhclength-(-387.026+(-6-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249371.0, assembly_id=103972.0))
lhcb2.new("mqml.10l1.b2", "mqml", at="lhclength-(-383.881+(-6-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307805.0, assembly_id=103972.0))
lhcb2.new("mcbcv.10l1.b2", "mcbcv", at="lhclength-(-380.839+(-6-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253715.0, assembly_id=103972.0))
lhcb2.new("mco.10l1.b2", "mco", at="lhclength-(-379.41+(-6-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253716.0, assembly_id=103973.0))
lhcb2.new("mcd.10l1.b2", "mcd", at="lhclength-(-379.4085+(-6-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253717.0, assembly_id=103973.0))
lhcb2.new("mb.b10l1.b2", "mb", at="lhclength-(-371.924+(-5.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849282.0, assembly_id=103973.0))
lhcb2.new("mcs.b10l1.b2", "mcs", at="lhclength-(-364.5+(-5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249378.0, assembly_id=103973.0))
lhcb2.new("mb.a10l1.b2", "mb", at="lhclength-(-356.264+(-4.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849306.0, assembly_id=103974.0))
lhcb2.new("mcs.a10l1.b2", "mcs", at="lhclength-(-348.84+(-4-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249381.0, assembly_id=103974.0))
lhcb2.new("bpm.9l1.b2", "bpm", at="lhclength-(-347.96+(-4-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249383.0, assembly_id=103975.0))
lhcb2.new("mqmc.9l1.b2", "mqmc", at="lhclength-(-345.984+(-4-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307782.0, assembly_id=103975.0))
lhcb2.new("mqm.9l1.b2", "mqm", at="lhclength-(-342.718+(-4-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307730.0, assembly_id=103975.0))
lhcb2.new("mcbch.9l1.b2", "mcbch", at="lhclength-(-340.377+(-4-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253721.0, assembly_id=103975.0))
lhcb2.new("mco.9l1.b2", "mco", at="lhclength-(-338.945+(-4-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253722.0, assembly_id=103976.0))
lhcb2.new("mcd.9l1.b2", "mcd", at="lhclength-(-338.9435+(-4-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253723.0, assembly_id=103976.0))
lhcb2.new("mb.b9l1.b2", "mb", at="lhclength-(-331.459+(-3.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849330.0, assembly_id=103976.0))
lhcb2.new("mcs.b9l1.b2", "mcs", at="lhclength-(-324.035+(-3-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249391.0, assembly_id=103976.0))
lhcb2.new("mb.a9l1.b2", "mb", at="lhclength-(-315.799+(-2.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849354.0, assembly_id=103977.0))
lhcb2.new("mcs.a9l1.b2", "mcs", at="lhclength-(-308.375+(-2-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249394.0, assembly_id=103977.0))
lhcb2.new("bpm.8l1.b2", "bpm", at="lhclength-(-307.496+(-2-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249396.0, assembly_id=103978.0))
lhcb2.new("mqml.8l1.b2", "mqml", at="lhclength-(-304.351+(-2-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307837.0, assembly_id=103978.0))
lhcb2.new("mcbcv.8l1.b2", "mcbcv", at="lhclength-(-301.309+(-2-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253727.0, assembly_id=103978.0))
lhcb2.new("mco.8l1.b2", "mco", at="lhclength-(-299.88+(-2-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253728.0, assembly_id=103979.0))
lhcb2.new("mcd.8l1.b2", "mcd", at="lhclength-(-299.8785+(-2-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253729.0, assembly_id=103979.0))
lhcb2.new("mb.b8l1.b2", "mb", at="lhclength-(-292.394+(-1.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849378.0, assembly_id=103979.0))
lhcb2.new("mcs.b8l1.b2", "mcs", at="lhclength-(-284.97+(-1-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249403.0, assembly_id=103979.0))
lhcb2.new("mb.a8l1.b2", "mb", at="lhclength-(-276.734+(-.5-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52849834.0, assembly_id=103980.0))
lhcb2.new("mcs.a8l1.b2", "mcs", at="lhclength-(-269.31+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=357345.0, assembly_id=103980.0))
lhcb2.new("e.ds.l1.b2", "omk", at="lhclength-(-268.904+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=100932.0))
lhcb2.new("bpm.7l1.b2", "bpm", at="lhclength-(-268.429+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=378063.0, assembly_id=103981.0))
lhcb2.new("mqm.b7l1.b2", "mqm", at="lhclength-(-265.984+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2307767.0, assembly_id=103981.0))
lhcb2.new("mqm.a7l1.b2", "mqm", at="lhclength-(-262.217+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2348453.0, assembly_id=103981.0))
lhcb2.new("mcbch.7l1.b2", "mcbch", at="lhclength-(-259.876+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=378137.0, assembly_id=103981.0))
lhcb2.new("dfbaa.7l1.b2", "dfbaa", at="lhclength-(-257.6965+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=52996551.0, assembly_id=104694.0))
lhcb2.new("xrpv.b7l1.b2", "xrpv", at="lhclength-(-245.656+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=389151.0, assembly_id=825697.0))
lhcb2.new("bpmsx.7l1.b2", "bpmsx004", at="lhclength-(-237.7505+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=826795.0))
lhcb2.new("xrpv.a7l1.b2", "xrpv", at="lhclength-(-237.398+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=389152.0, assembly_id=825698.0))
lhcb2.new("mcbcv.6l1.b2", "mcbcv", at="lhclength-(-231.432+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253734.0, assembly_id=103982.0))
lhcb2.new("mqml.6l1.b2", "mqml", at="lhclength-(-228.39+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2303178.0, assembly_id=103982.0))
lhcb2.new("bpmr.6l1.b2", "bpmr", at="lhclength-(-225.245+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=378065.0, assembly_id=103982.0))
lhcb2.new("tcl.6l1.b2", "tcl", at="lhclength-(-219.62+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=12962633.0))
lhcb2.new("bpmsa.a6l1.b2", "bpmsa", at="lhclength-(-218.2175+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=39831365.0))
lhcb2.new("xrph.b6l1.b2", "xrph", at="lhclength-(-217.909+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=39831394.0, assembly_id=39831386.0))
lhcb2.new("xrph.a6l1.b2", "xrph", at="lhclength-(-205.824+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=39831392.0, assembly_id=39831385.0))
lhcb2.new("mcbch.5l1.b2", "mcbch", at="lhclength-(-199.532+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253736.0, assembly_id=103983.0))
lhcb2.new("mqml.5l1.b2", "mqml", at="lhclength-(-196.49+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2303182.0, assembly_id=103983.0))
lhcb2.new("bpm.5l1.b2", "bpm", at="lhclength-(-193.345+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=378067.0, assembly_id=103983.0))
lhcb2.new("tcl.5l1.b2", "tcl", at="lhclength-(-184.264+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=103984.0))
lhcb2.new("bpmya.4l1.b2", "bpmya", at="lhclength-(-172.227+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=249422.0, assembly_id=103985.0))
lhcb2.new("mqy.4l1.b2", "mqy", at="lhclength-(-169.553+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=2303023.0, assembly_id=103985.0))
lhcb2.new("mcbyv.b4l1.b2", "mcbyv", at="lhclength-(-167.031+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253739.0, assembly_id=103985.0))
lhcb2.new("mcbyh.4l1.b2", "mcbyh", at="lhclength-(-165.735+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253741.0, assembly_id=103985.0))
lhcb2.new("mcbyv.a4l1.b2", "mcbyv", at="lhclength-(-164.439+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.194, slot_id=253743.0, assembly_id=103985.0))
lhcb2.new("mbrc.4l1.b2", "mbrc", at="lhclength-(-157.9+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.188, slot_id=52819786.0, assembly_id=103986.0))
lhcb2.new("bpmwb.4l1.b2", "bpmwb", at="lhclength-(-151.1705+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.178, slot_id=181647.0))
lhcb2.new("tcl.4l1.b2", "tcl", at="lhclength-(-150.03+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.1762, slot_id=103987.0))
lhcb2.new("e.tan_c.4l1", "omk", at="lhclength-(-144.5+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb2.new("e.tan_i.4l1", "omk", at="lhclength-(-144.5+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb2.new("tanal.4l1", "tanal", at="lhclength-(-142.754+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=103988.0))
lhcb2.new("e.tan_d.4l1", "omk", at="lhclength-(-142.019+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb2.new("x1zdc.a4l1", "x1zdc001", at="lhclength-(-141.71+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=2019579.0, assembly_id=103988.0))
lhcb2.new("brana.4l1", "brana", at="lhclength-(-141.36+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=883499.0, assembly_id=103988.0))
lhcb2.new("x1zdc.b4l1", "x1zdc002", at="lhclength-(-141.16+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=2019582.0, assembly_id=103988.0))
lhcb2.new("s.tan_d.4l1", "omk", at="lhclength-(-141.019+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb2.new("s.tan_c.4l1", "omk", at="lhclength-(-141.008+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb2.new("e.tan_m.4l1", "omk", at="lhclength-(-140.7+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb2.new("s.tan_i.4l1", "omk", at="lhclength-(-140.7+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb2.new("s.tan_m.4l1", "omk", at="lhclength-(-140.25+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(slot_id=103988.0))
lhcb2.new("mbxw.f4l1", "mbxw", at="lhclength-(-82.652+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134690.0))
lhcb2.new("mbxw.e4l1", "mbxw", at="lhclength-(-78.386+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134691.0))
lhcb2.new("mbxw.d4l1", "mbxw", at="lhclength-(-74.12+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134692.0))
lhcb2.new("mbxw.c4l1", "mbxw", at="lhclength-(-69.854+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134693.0))
lhcb2.new("mbxw.b4l1", "mbxw", at="lhclength-(-65.588+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134694.0))
lhcb2.new("mbxw.a4l1", "mbxw", at="lhclength-(-61.322+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=134695.0))
lhcb2.new("bpmsy.4l1.b2", "bpmsy002", at="lhclength-(-58.2545+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=47562528.0, assembly_id=104622.0))
lhcb2.new("dfbxa.3l1", "dfbxa", at="lhclength-(-56.427+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=104695.0))
lhcb2.new("mcosx.3l1", "mcosx_unplugged", at="lhclength-(-54.297+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282258.0, assembly_id=103990.0))
lhcb2.new("mcox.3l1", "mcox", at="lhclength-(-54.297+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282257.0, assembly_id=103990.0))
lhcb2.new("mcssx.3l1", "mcssx", at="lhclength-(-54.297+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282256.0, assembly_id=103990.0))
lhcb2.new("mcbxh.3l1", "mcbxh", at="lhclength-(-53.814+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253744.0, assembly_id=103990.0))
lhcb2.new("mcbxv.3l1", "mcbxv", at="lhclength-(-53.814+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253745.0, assembly_id=103990.0))
lhcb2.new("mcsx.3l1", "mcsx", at="lhclength-(-53.814+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253746.0, assembly_id=103990.0))
lhcb2.new("mctx.3l1", "mctx", at="lhclength-(-53.814+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253747.0, assembly_id=103990.0))
lhcb2.new("mqxa.3l1", "mqxa", at="lhclength-(-50.15+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=249436.0, assembly_id=103990.0))
lhcb2.new("mqsx.3l1", "mqsx", at="lhclength-(-46.608+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282209.0, assembly_id=103990.0))
lhcb2.new("tasb.3l1", "tasb", at="lhclength-(-45.342+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=249438.0, assembly_id=103990.0))
lhcb2.new("mqxb.b2l1", "mqxb", at="lhclength-(-41.3+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=249439.0, assembly_id=103991.0))
lhcb2.new("mcbxh.2l1", "mcbxh", at="lhclength-(-38.019+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253752.0, assembly_id=103991.0))
lhcb2.new("mcbxv.2l1", "mcbxv", at="lhclength-(-38.019+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=253753.0, assembly_id=103991.0))
lhcb2.new("mqxb.a2l1", "mqxb", at="lhclength-(-34.8+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=249441.0, assembly_id=103991.0))
lhcb2.new("bpms.2l1.b2", "bpms_003", at="lhclength-(-31.529+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=47564261.0, assembly_id=103991.0))
lhcb2.new("mcbxh.1l1", "mcbxh", at="lhclength-(-29.842+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282219.0, assembly_id=103992.0))
lhcb2.new("mcbxv.1l1", "mcbxv", at="lhclength-(-29.842+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282218.0, assembly_id=103992.0))
lhcb2.new("mqxa.1l1", "mqxa", at="lhclength-(-26.15+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=282210.0, assembly_id=103992.0))
lhcb2.new("bpmwf.a1l1.b2", "bpmwf", at="lhclength-(-21.766+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=6080256.0, assembly_id=6080223.0))
lhcb2.new("bpmsw.1l1.b2", "bpmsw002", at="lhclength-(-21.579+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=6080252.0, assembly_id=6080223.0))
lhcb2.new("bpmsw.1l1.b2_doros", "bpmsw002", at="lhclength-(-21.579+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=10429439.0, assembly_id=6080223.0))
lhcb2.new("tas.1l1", "tas", at="lhclength-(-19.979+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=103993.0))
lhcb2.new("mbas2.1l1", "mbas2", at="lhclength-(-1.5+(0-ip1ofs.b2)*ds)", from_="ip1.l1", extra=dict(mech_sep=0.0, slot_id=51937873.0))
lhcb2.new("ip1.l1", "omk", at="lhclength-(pip1.l1+ip1ofs.b2*ds)")
# lhcb2.reflect().build()

# /************************************************************************************/
# /*                       MAGNET-CONSTANT LHC SEQUENCE %B1                           */
# /************************************************************************************/

env.set("mbas2.1r1", ks="abas")
env.set("mqxa.1r1", k1="kqx.r1+ktqx1.r1", extra=dict(polarity=1.0))
env.set("mcbxh.1r1", knl=["-(acbxh1.r1)"], extra=dict(polarity=1.0))
env.set("mcbxv.1r1", ksl=["acbxv1.r1"], extra=dict(polarity=1.0))
env.set("mqxb.a2r1", k1="-kqx.r1-ktqx2.r1", extra=dict(polarity=-1.0))
env.set("mcbxh.2r1", knl=["-(acbxh2.r1)"], extra=dict(polarity=1.0))
env.set("mcbxv.2r1", ksl=["acbxv2.r1"], extra=dict(polarity=1.0))
env.set("mqxb.b2r1", k1="-kqx.r1-ktqx2.r1", extra=dict(polarity=-1.0))
env.set("mqsx.3r1", k1s="kqsx3.r1", extra=dict(polarity=-1.0))
env.set("mqxa.3r1", k1="kqx.r1", extra=dict(polarity=1.0))
env.set("mcbxh.3r1", knl=["-(acbxh3.r1)"], extra=dict(polarity=1.0))
env.set("mcbxv.3r1", ksl=["acbxv3.r1"], extra=dict(polarity=1.0))
env.set("mcsx.3r1", knl=[0.0, 0.0, "kcsx3.r1*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3r1", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.r1*l.mctx"], extra=dict(polarity=1.0))
env.set("mcosx.3r1", ksl=[0.0, 0.0, 0.0, "kcosx3.r1*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3r1", knl=[0.0, 0.0, 0.0, "kcox3.r1*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3r1", ksl=[0.0, 0.0, "kcssx3.r1*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mbxw.a4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.b4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.c4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.d4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.e4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.f4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbrc.4r1.b1", angle="ad2.r1", k0="kd2.r1", extra=dict(polarity=1.0))
env.set("mcbyv.a4r1.b1", ksl=["acbyvs4.r1b1"], extra=dict(polarity=1.0))
env.set("mcbyh.4r1.b1", knl=["-(acbyhs4.r1b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.b4r1.b1", ksl=["acbyv4.r1b1"], extra=dict(polarity=1.0))
env.set("mqy.4r1.b1", k1="kq4.r1b1", extra=dict(polarity=-1.0))
env.set("mcbch.5r1.b1", knl=["-(acbch5.r1b1)"], extra=dict(polarity=1.0))
env.set("mqml.5r1.b1", k1="kq5.r1b1", extra=dict(polarity=1.0))
env.set("mcbcv.6r1.b1", ksl=["acbcv6.r1b1"], extra=dict(polarity=1.0))
env.set("mqml.6r1.b1", k1="kq6.r1b1", extra=dict(polarity=-1.0))
env.set("mqm.a7r1.b1", k1="kq7.r1b1", extra=dict(polarity=1.0))
env.set("mqm.b7r1.b1", k1="kq7.r1b1", extra=dict(polarity=1.0))
env.set("mcbch.7r1.b1", knl=["-(acbch7.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.8r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a8r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b8r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b8r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqml.8r1.b1", k1="kq8.r1b1", extra=dict(polarity=-1.0))
env.set("mcbcv.8r1.b1", ksl=["acbcv8.r1b1"], extra=dict(polarity=1.0))
env.set("mcd.9r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a9r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b9r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b9r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqmc.9r1.b1", k1="kq9.r1b1", extra=dict(polarity=1.0))
env.set("mqm.9r1.b1", k1="kq9.r1b1", extra=dict(polarity=1.0))
env.set("mcbch.9r1.b1", knl=["-(acbch9.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.10r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a10r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b10r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b10r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqml.10r1.b1", k1="kq10.r1b1", extra=dict(polarity=-1.0))
env.set("mcbcv.10r1.b1", ksl=["acbcv10.r1b1"], extra=dict(polarity=1.0))
env.set("mcd.11r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a11r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b11r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b11r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mq.11r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("mqtli.11r1.b1", k1="kqtl11.r1b1", extra=dict(polarity=1.0))
env.set("ms.11r1.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a12r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a12r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b12r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b12r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b12r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c12r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.12r1.b1", k1="kqt12.r1b1", extra=dict(polarity=-1.0))
env.set("mq.12r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.12r1.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.12r1.b1", ksl=["acbv12.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a13r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a13r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.13r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b13r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c13r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c13r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.13r1.b1", k1="kqt13.r1b1", extra=dict(polarity=1.0))
env.set("mq.13r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.13r1.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.13r1.b1", knl=["-(acbh13.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a14r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a14r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b14r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b14r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b14r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c14r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.14r1.b1", k1="kqtd.a12b1", extra=dict(polarity=-1.0))
env.set("mq.14r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.14r1.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.14r1.b1", ksl=["acbv14.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a15r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a15r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.15r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b15r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c15r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c15r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.15r1.b1", k1="kqtf.a12b1", extra=dict(polarity=1.0))
env.set("mq.15r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.15r1.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.15r1.b1", knl=["-(acbh15.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a16r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a16r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b16r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b16r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b16r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c16r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.16r1.b1", k1="kqtd.a12b1", extra=dict(polarity=-1.0))
env.set("mq.16r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.16r1.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.16r1.b1", ksl=["acbv16.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a17r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a17r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.17r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b17r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c17r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c17r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.17r1.b1", k1="kqtf.a12b1", extra=dict(polarity=1.0))
env.set("mq.17r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.17r1.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.17r1.b1", knl=["-(acbh17.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a18r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a18r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b18r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b18r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b18r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c18r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.18r1.b1", k1="kqtd.a12b1", extra=dict(polarity=-1.0))
env.set("mq.18r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.18r1.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.18r1.b1", ksl=["acbv18.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a19r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a19r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.19r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b19r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c19r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c19r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.19r1.b1", k1="kqtf.a12b1", extra=dict(polarity=1.0))
env.set("mq.19r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.19r1.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.19r1.b1", knl=["-(acbh19.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a20r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a20r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b20r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b20r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b20r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c20r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.20r1.b1", k1="kqtd.a12b1", extra=dict(polarity=-1.0))
env.set("mq.20r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.20r1.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.20r1.b1", ksl=["acbv20.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a21r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a21r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.21r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b21r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c21r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c21r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.21r1.b1", k1="kqtf.a12b1", extra=dict(polarity=1.0))
env.set("mq.21r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.21r1.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.21r1.b1", knl=["-(acbh21.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a22r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a22r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b22r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b22r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b22r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c22r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.22r1.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.22r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.22r1.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.22r1.b1", ksl=["acbv22.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a23r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a23r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.23r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b23r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c23r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c23r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqs.23r1.b1", k1s="kqs.r1b1", extra=dict(polarity=-1.0))
env.set("mq.23r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.23r1.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.23r1.b1", knl=["-(acbh23.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a24r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a24r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b24r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b24r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b24r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c24r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.24r1.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.24r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.24r1.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.24r1.b1", ksl=["acbv24.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a25r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a25r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.25r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b25r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c25r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c25r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.25r1.b1", k3="kof.a12b1", extra=dict(polarity=1.0))
env.set("mq.25r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.25r1.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.25r1.b1", knl=["-(acbh25.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a26r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a26r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b26r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b26r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b26r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c26r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.26r1.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.26r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.26r1.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.26r1.b1", ksl=["acbv26.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a27r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a27r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.27r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b27r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c27r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c27r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqs.27r1.b1", k1s="kqs.r1b1", extra=dict(polarity=-1.0))
env.set("mq.27r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.27r1.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.27r1.b1", knl=["-(acbh27.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a28r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a28r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b28r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b28r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b28r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c28r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.28r1.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.28r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.28r1.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.28r1.b1", ksl=["acbv28.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a29r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a29r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.29r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b29r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c29r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c29r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.29r1.b1", k3="kof.a12b1", extra=dict(polarity=1.0))
env.set("mq.29r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("mss.29r1.b1", k2s="kss.a12b1", extra=dict(polarity=-1.0))
env.set("mcbh.29r1.b1", knl=["-(acbh29.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a30r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a30r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b30r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b30r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b30r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c30r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.30r1.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.30r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.30r1.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.30r1.b1", ksl=["acbv30.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a31r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a31r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.31r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b31r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c31r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c31r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.31r1.b1", k3="kof.a12b1", extra=dict(polarity=1.0))
env.set("mq.31r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.31r1.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.31r1.b1", knl=["-(acbh31.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a32r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a32r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b32r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b32r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b32r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c32r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.32r1.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.32r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.32r1.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.32r1.b1", ksl=["acbv32.r1b1"], extra=dict(polarity=1.0))
env.set("mb.a33r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a33r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.33r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b33r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.c33r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c33r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.33r1.b1", k3="kof.a12b1", extra=dict(polarity=1.0))
env.set("mq.33r1.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("mss.33r1.b1", k2s="kss.a12b1", extra=dict(polarity=-1.0))
env.set("mcbh.33r1.b1", knl=["-(acbh33.r1b1)"], extra=dict(polarity=1.0))
env.set("mcd.a34r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a34r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b34r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b34r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.b34r1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r1.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c34r1.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.34r1.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.34r1.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.34l2.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.34l2.b1", ksl=["acbv34.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c34l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c34l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b34l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b34l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a34l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a34l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.33l2.b1", k3="kof.a12b1", extra=dict(polarity=1.0))
env.set("mq.33l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("mss.33l2.b1", k2s="kss.a12b1", extra=dict(polarity=-1.0))
env.set("mcbh.33l2.b1", knl=["-(acbh33.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b33l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c33l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b33l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b33l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a33l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a33l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.32l2.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.32l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.32l2.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.32l2.b1", ksl=["acbv32.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c32l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c32l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.32l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b32l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a32l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a32l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.31l2.b1", k3="kof.a12b1", extra=dict(polarity=1.0))
env.set("mq.31l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.31l2.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.31l2.b1", knl=["-(acbh31.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b31l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c31l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b31l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b31l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a31l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a31l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.30l2.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.30l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.30l2.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.30l2.b1", ksl=["acbv30.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c30l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c30l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.30l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b30l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a30l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a30l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.29l2.b1", k3="kof.a12b1", extra=dict(polarity=1.0))
env.set("mq.29l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("mss.29l2.b1", k2s="kss.a12b1", extra=dict(polarity=-1.0))
env.set("mcbh.29l2.b1", knl=["-(acbh29.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b29l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c29l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b29l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b29l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a29l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a29l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.28l2.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.28l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.28l2.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.28l2.b1", ksl=["acbv28.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c28l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c28l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.28l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b28l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a28l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a28l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqs.27l2.b1", k1s="kqs.l2b1", extra=dict(polarity=-1.0))
env.set("mq.27l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.27l2.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.27l2.b1", knl=["-(acbh27.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b27l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c27l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b27l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b27l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a27l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a27l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.26l2.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.26l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.26l2.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.26l2.b1", ksl=["acbv26.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c26l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c26l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.26l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b26l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a26l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a26l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.25l2.b1", k3="kof.a12b1", extra=dict(polarity=1.0))
env.set("mq.25l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.25l2.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.25l2.b1", knl=["-(acbh25.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b25l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c25l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b25l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b25l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a25l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a25l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.24l2.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.24l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.24l2.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.24l2.b1", ksl=["acbv24.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c24l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c24l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.24l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b24l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a24l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a24l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqs.23l2.b1", k1s="kqs.l2b1", extra=dict(polarity=-1.0))
env.set("mq.23l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.23l2.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.23l2.b1", knl=["-(acbh23.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b23l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c23l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b23l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b23l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a23l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a23l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mo.22l2.b1", k3="kod.a12b1", extra=dict(polarity=-1.0))
env.set("mq.22l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.22l2.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.22l2.b1", ksl=["acbv22.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c22l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c22l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.22l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b22l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a22l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a22l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.21l2.b1", k1="kqtf.a12b1", extra=dict(polarity=1.0))
env.set("mq.21l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.21l2.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.21l2.b1", knl=["-(acbh21.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b21l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c21l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b21l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b21l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a21l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a21l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.20l2.b1", k1="kqtd.a12b1", extra=dict(polarity=-1.0))
env.set("mq.20l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.20l2.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.20l2.b1", ksl=["acbv20.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c20l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c20l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.20l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b20l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a20l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a20l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.19l2.b1", k1="kqtf.a12b1", extra=dict(polarity=1.0))
env.set("mq.19l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.19l2.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.19l2.b1", knl=["-(acbh19.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b19l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c19l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b19l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b19l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a19l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a19l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.18l2.b1", k1="kqtd.a12b1", extra=dict(polarity=-1.0))
env.set("mq.18l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.18l2.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.18l2.b1", ksl=["acbv18.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c18l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c18l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.18l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b18l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a18l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a18l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.17l2.b1", k1="kqtf.a12b1", extra=dict(polarity=1.0))
env.set("mq.17l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.17l2.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.17l2.b1", knl=["-(acbh17.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b17l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c17l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b17l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b17l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a17l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a17l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.16l2.b1", k1="kqtd.a12b1", extra=dict(polarity=-1.0))
env.set("mq.16l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.16l2.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.16l2.b1", ksl=["acbv16.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c16l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c16l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.16l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b16l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a16l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a16l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.15l2.b1", k1="kqtf.a12b1", extra=dict(polarity=1.0))
env.set("mq.15l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.15l2.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.15l2.b1", knl=["-(acbh15.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b15l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c15l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b15l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b15l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a15l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a15l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.14l2.b1", k1="kqtd.a12b1", extra=dict(polarity=-1.0))
env.set("mq.14l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.14l2.b1", k2="ksd2.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.14l2.b1", ksl=["acbv14.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c14l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c14l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.14l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b14l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a14l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a14l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.13l2.b1", k1="kqt13.l2b1", extra=dict(polarity=1.0))
env.set("mq.13l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("ms.13l2.b1", k2="ksf1.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.13l2.b1", knl=["-(acbh13.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.b13l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c13l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.b13l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b13l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.a13l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a13l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqt.12l2.b1", k1="kqt12.l2b1", extra=dict(polarity=-1.0))
env.set("mq.12l2.b1", k1="kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.12l2.b1", k2="ksd1.a12b1", extra=dict(polarity=-1.0))
env.set("mcbv.12l2.b1", ksl=["acbv12.l2b1"], extra=dict(polarity=1.0))
env.set("mb.c12l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c12l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mcd.12l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b12l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a12l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a12l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mq.11l2.b1", k1="kqf.a12", extra=dict(polarity=1.0))
env.set("mqtli.11l2.b1", k1="kqtl11.l2b1", extra=dict(polarity=1.0))
env.set("ms.11l2.b1", k2="ksf2.a12b1", extra=dict(polarity=1.0))
env.set("mcbh.11l2.b1", knl=["-(acbh11.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.11l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b11l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a11l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a11l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqml.10l2.b1", k1="kq10.l2b1", extra=dict(polarity=-1.0))
env.set("mcbcv.10l2.b1", ksl=["acbcv10.l2b1"], extra=dict(polarity=1.0))
env.set("mcd.10l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b10l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a10l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a10l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqmc.9l2.b1", k1="kq9.l2b1", extra=dict(polarity=1.0))
env.set("mqm.9l2.b1", k1="kq9.l2b1", extra=dict(polarity=1.0))
env.set("mcbch.9l2.b1", knl=["-(acbch9.l2b1)"], extra=dict(polarity=1.0))
env.set("mcd.9l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b9l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a9l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a9l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqml.8l2.b1", k1="kq8.l2b1", extra=dict(polarity=-1.0))
env.set("mcbcv.8l2.b1", ksl=["acbcv8.l2b1"], extra=dict(polarity=1.0))
env.set("mcd.8l2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a12b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b8l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mb.a8l2.b1", angle="ab.a12", k0="kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a8l2.b1", k2="kcs.a12b1", extra=dict(polarity=1.0))
env.set("mqm.b7l2.b1", k1="kq7.l2b1", extra=dict(polarity=1.0))
env.set("mqm.a7l2.b1", k1="kq7.l2b1", extra=dict(polarity=1.0))
env.set("mcbch.7l2.b1", knl=["-(acbch7.l2b1)"], extra=dict(polarity=1.0))
env.set("mcbcv.6l2.b1", ksl=["acbcv6.l2b1"], extra=dict(polarity=1.0))
env.set("mqml.6l2.b1", k1="kq6.l2b1", extra=dict(polarity=-1.0))
env.set("mqm.6l2.b1", k1="kq6.l2b1", extra=dict(polarity=-1.0))
env.set("msib.c6l2.b1", knl=["-(akmsib.l2b1)"], extra=dict(polarity=-1.0))
env.set("msib.b6l2.b1", knl=["-(akmsib.l2b1)"], extra=dict(polarity=-1.0))
env.set("msib.a6l2.b1", knl=["-(akmsib.l2b1)"], extra=dict(polarity=-1.0))
env.set("msia.b6l2.b1", knl=["-(akmsia.l2b1)"], extra=dict(polarity=-1.0))
env.set("msia.a6l2.b1", knl=["-(akmsia.l2b1)"], extra=dict(polarity=-1.0))
env.set("mcbyh.b5l2.b1", knl=["-(acbyhs5.l2b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.5l2.b1", ksl=["acbyvs5.l2b1"], extra=dict(polarity=1.0))
env.set("mcbyh.a5l2.b1", knl=["-(acbyh5.l2b1)"], extra=dict(polarity=1.0))
env.set("mqy.b5l2.b1", k1="kq5.l2b1", extra=dict(polarity=1.0))
env.set("mqy.a5l2.b1", k1="kq5.l2b1", extra=dict(polarity=1.0))
env.set("mki.d5l2.b1", ksl=["akmki"], extra=dict(polarity=1.0))
env.set("mki.c5l2.b1", ksl=["akmki"], extra=dict(polarity=1.0))
env.set("mki.b5l2.b1", ksl=["akmki"], extra=dict(polarity=1.0))
env.set("mki.a5l2.b1", ksl=["akmki"], extra=dict(polarity=1.0))
env.set("mqy.b4l2.b1", k1="kq4.l2b1", extra=dict(polarity=-1.0))
env.set("mqy.a4l2.b1", k1="kq4.l2b1", extra=dict(polarity=-1.0))
env.set("mcbyv.b4l2.b1", ksl=["acbyv4.l2b1"], extra=dict(polarity=1.0))
env.set("mcbyh.4l2.b1", knl=["-(acbyhs4.l2b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.a4l2.b1", ksl=["acbyvs4.l2b1"], extra=dict(polarity=1.0))
env.set("mbrc.4l2.b1", angle="ad2.l2", k0="kd2.l2", extra=dict(polarity=1.0))
env.set("mbx.4l2", angle="-ad1.l2", k0="-kd1.l2", extra=dict(polarity=-1.0))
env.set("mcbxh.3l2", knl=["-(acbxh3.l2)"], extra=dict(polarity=1.0))
env.set("mcbxv.3l2", ksl=["acbxv3.l2"], extra=dict(polarity=1.0))
env.set("mcsx.3l2", knl=[0.0, 0.0, "kcsx3.l2*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3l2", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.l2*l.mctx"], extra=dict(polarity=1.0))
env.set("mqxa.3l2", k1="kqx.l2", extra=dict(polarity=1.0))
env.set("mqsx.3l2", k1s="kqsx3.l2", extra=dict(polarity=-1.0))
env.set("mqxb.b2l2", k1="-kqx.l2-ktqx2.l2", extra=dict(polarity=-1.0))
env.set("mcbxh.2l2", knl=["-(acbxh2.l2)"], extra=dict(polarity=1.0))
env.set("mcbxv.2l2", ksl=["acbxv2.l2"], extra=dict(polarity=1.0))
env.set("mqxb.a2l2", k1="-kqx.l2-ktqx2.l2", extra=dict(polarity=-1.0))
env.set("mcbxv.1l2", ksl=["acbxv1.l2"], extra=dict(polarity=1.0))
env.set("mqxa.1l2", k1="kqx.l2+ktqx1.l2", extra=dict(polarity=1.0))
env.set("mbxwt.1l2", rot_s_rad=-0.004170381943025, ksl=["abxwt.l2"], extra=dict(polarity=1.0))
env.set("mbwmd.1l2", rot_s_rad=-0.004170381943025, ksl=["abwmd.l2"], extra=dict(polarity=1.0))
env.set("mbls2.1l2", ks="abls")
env.set("mbls2.1r2", ks="abls")
env.set("mbaw.1r2", rot_s_rad=-0.004170381943025, ksl=["abaw.r2"], extra=dict(polarity=-1.0))
env.set("mbxwt.1r2", rot_s_rad=-0.004170381943025, ksl=["abxwt.r2"], extra=dict(polarity=1.0))
env.set("mqxa.1r2", k1="kqx.r2+ktqx1.r2", extra=dict(polarity=-1.0))
env.set("mcbxh.1r2", knl=["-(acbxh1.r2)"], extra=dict(polarity=1.0))
env.set("mcbxv.1r2", ksl=["acbxv1.r2"], extra=dict(polarity=1.0))
env.set("mqxb.a2r2", k1="-kqx.r2-ktqx2.r2", extra=dict(polarity=1.0))
env.set("mcbxh.2r2", knl=["-(acbxh2.r2)"], extra=dict(polarity=1.0))
env.set("mcbxv.2r2", ksl=["acbxv2.r2"], extra=dict(polarity=1.0))
env.set("mqxb.b2r2", k1="-kqx.r2-ktqx2.r2", extra=dict(polarity=1.0))
env.set("mqsx.3r2", k1s="kqsx3.r2", extra=dict(polarity=-1.0))
env.set("mqxa.3r2", k1="kqx.r2", extra=dict(polarity=-1.0))
env.set("mcbxh.3r2", knl=["-(acbxh3.r2)"], extra=dict(polarity=1.0))
env.set("mcbxv.3r2", ksl=["acbxv3.r2"], extra=dict(polarity=1.0))
env.set("mcsx.3r2", knl=[0.0, 0.0, "kcsx3.r2*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3r2", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.r2*l.mctx"], extra=dict(polarity=1.0))
env.set("mcosx.3r2", ksl=[0.0, 0.0, 0.0, "kcosx3.r2*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3r2", knl=[0.0, 0.0, 0.0, "kcox3.r2*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3r2", ksl=[0.0, 0.0, "kcssx3.r2*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mbx.4r2", angle="ad1.r2", k0="kd1.r2", extra=dict(polarity=1.0))
env.set("mbrc.4r2.b1", angle="-ad2.r2", k0="-kd2.r2", extra=dict(polarity=-1.0))
env.set("mcbyh.a4r2.b1", knl=["-(acbyhs4.r2b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.4r2.b1", ksl=["acbyvs4.r2b1"], extra=dict(polarity=1.0))
env.set("mcbyh.b4r2.b1", knl=["-(acbyh4.r2b1)"], extra=dict(polarity=1.0))
env.set("mqy.a4r2.b1", k1="kq4.r2b1", extra=dict(polarity=1.0))
env.set("mqy.b4r2.b1", k1="kq4.r2b1", extra=dict(polarity=1.0))
env.set("mcbcv.a5r2.b1", ksl=["acbcvs5.r2b1"], extra=dict(polarity=1.0))
env.set("mcbch.5r2.b1", knl=["-(acbchs5.r2b1)"], extra=dict(polarity=1.0))
env.set("mcbcv.b5r2.b1", ksl=["acbcv5.r2b1"], extra=dict(polarity=1.0))
env.set("mqm.a5r2.b1", k1="kq5.r2b1", extra=dict(polarity=-1.0))
env.set("mqm.b5r2.b1", k1="kq5.r2b1", extra=dict(polarity=-1.0))
env.set("mcbch.6r2.b1", knl=["-(acbch6.r2b1)"], extra=dict(polarity=1.0))
env.set("mqml.6r2.b1", k1="kq6.r2b1", extra=dict(polarity=1.0))
env.set("mqm.6r2.b1", k1="kq6.r2b1", extra=dict(polarity=1.0))
env.set("mqm.a7r2.b1", k1="kq7.r2b1", extra=dict(polarity=-1.0))
env.set("mqm.b7r2.b1", k1="kq7.r2b1", extra=dict(polarity=-1.0))
env.set("mcbcv.7r2.b1", ksl=["acbcv7.r2b1"], extra=dict(polarity=1.0))
env.set("mco.8r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a8r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b8r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b8r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqml.8r2.b1", k1="kq8.r2b1", extra=dict(polarity=1.0))
env.set("mcbch.8r2.b1", knl=["-(acbch8.r2b1)"], extra=dict(polarity=1.0))
env.set("mco.9r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a9r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b9r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b9r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqmc.9r2.b1", k1="kq9.r2b1", extra=dict(polarity=-1.0))
env.set("mqm.9r2.b1", k1="kq9.r2b1", extra=dict(polarity=-1.0))
env.set("mcbcv.9r2.b1", ksl=["acbcv9.r2b1"], extra=dict(polarity=1.0))
env.set("mco.10r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a10r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b10r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b10r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqml.10r2.b1", k1="kq10.r2b1", extra=dict(polarity=1.0))
env.set("mcbch.10r2.b1", knl=["-(acbch10.r2b1)"], extra=dict(polarity=1.0))
env.set("mco.11r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a11r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b11r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b11r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mq.11r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("mqtli.11r2.b1", k1="kqtl11.r2b1", extra=dict(polarity=-1.0))
env.set("ms.11r2.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.11r2.b1", ksl=["acbv11.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a12r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a12r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b12r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b12r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b12r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c12r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.12r2.b1", k1="kqt12.r2b1", extra=dict(polarity=1.0))
env.set("mq.12r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.12r2.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.12r2.b1", knl=["-(acbh12.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a13r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a13r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.13r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b13r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c13r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c13r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.13r2.b1", k1="kqt13.r2b1", extra=dict(polarity=-1.0))
env.set("mq.13r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.13r2.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.13r2.b1", ksl=["acbv13.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a14r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a14r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b14r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b14r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b14r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c14r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.14r2.b1", k1="kqtf.a23b1", extra=dict(polarity=1.0))
env.set("mq.14r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.14r2.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.14r2.b1", knl=["-(acbh14.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a15r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a15r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.15r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b15r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c15r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c15r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.15r2.b1", k1="kqtd.a23b1", extra=dict(polarity=-1.0))
env.set("mq.15r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.15r2.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.15r2.b1", ksl=["acbv15.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a16r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a16r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b16r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b16r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b16r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c16r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.16r2.b1", k1="kqtf.a23b1", extra=dict(polarity=1.0))
env.set("mq.16r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.16r2.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.16r2.b1", knl=["-(acbh16.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a17r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a17r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.17r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b17r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c17r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c17r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.17r2.b1", k1="kqtd.a23b1", extra=dict(polarity=-1.0))
env.set("mq.17r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.17r2.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.17r2.b1", ksl=["acbv17.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a18r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a18r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b18r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b18r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b18r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c18r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.18r2.b1", k1="kqtf.a23b1", extra=dict(polarity=1.0))
env.set("mq.18r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.18r2.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.18r2.b1", knl=["-(acbh18.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a19r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a19r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.19r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b19r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c19r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c19r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.19r2.b1", k1="kqtd.a23b1", extra=dict(polarity=-1.0))
env.set("mq.19r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.19r2.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.19r2.b1", ksl=["acbv19.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a20r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a20r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b20r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b20r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b20r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c20r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.20r2.b1", k1="kqtf.a23b1", extra=dict(polarity=1.0))
env.set("mq.20r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.20r2.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.20r2.b1", knl=["-(acbh20.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a21r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a21r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.21r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b21r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c21r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c21r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.21r2.b1", k1="kqtd.a23b1", extra=dict(polarity=-1.0))
env.set("mq.21r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.21r2.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.21r2.b1", ksl=["acbv21.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a22r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a22r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b22r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b22r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b22r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c22r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.22r2.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.22r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.22r2.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.22r2.b1", knl=["-(acbh22.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a23r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a23r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.23r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b23r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c23r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c23r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqs.23r2.b1", k1s="kqs.a23b1", extra=dict(polarity=-1.0))
env.set("mq.23r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.23r2.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.23r2.b1", ksl=["acbv23.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a24r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a24r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b24r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b24r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b24r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c24r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.24r2.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.24r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.24r2.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.24r2.b1", knl=["-(acbh24.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a25r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a25r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.25r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b25r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c25r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c25r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.25r2.b1", k3="kod.a23b1", extra=dict(polarity=-1.0))
env.set("mq.25r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.25r2.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.25r2.b1", ksl=["acbv25.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a26r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a26r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b26r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b26r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b26r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c26r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.26r2.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.26r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.26r2.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.26r2.b1", knl=["-(acbh26.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a27r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a27r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.27r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b27r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c27r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c27r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqs.27r2.b1", k1s="kqs.a23b1", extra=dict(polarity=-1.0))
env.set("mq.27r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.27r2.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.27r2.b1", ksl=["acbv27.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a28r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a28r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b28r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b28r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b28r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c28r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.28r2.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.28r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.28r2.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.28r2.b1", knl=["-(acbh28.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a29r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a29r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.29r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b29r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c29r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c29r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.29r2.b1", k3="kod.a23b1", extra=dict(polarity=-1.0))
env.set("mq.29r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.29r2.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.29r2.b1", ksl=["acbv29.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a30r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a30r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b30r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b30r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b30r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c30r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.30r2.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.30r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("mss.30r2.b1", k2s="kss.a23b1", extra=dict(polarity=-1.0))
env.set("mcbh.30r2.b1", knl=["-(acbh30.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a31r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a31r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.31r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b31r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c31r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c31r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.31r2.b1", k3="kod.a23b1", extra=dict(polarity=-1.0))
env.set("mq.31r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.31r2.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.31r2.b1", ksl=["acbv31.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a32r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a32r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b32r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b32r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b32r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c32r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.32r2.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.32r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.32r2.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.32r2.b1", knl=["-(acbh32.r2b1)"], extra=dict(polarity=1.0))
env.set("mb.a33r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a33r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.33r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b33r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.c33r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c33r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.33r2.b1", k3="kod.a23b1", extra=dict(polarity=-1.0))
env.set("mq.33r2.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.33r2.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.33r2.b1", ksl=["acbv33.r2b1"], extra=dict(polarity=1.0))
env.set("mco.a34r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a34r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b34r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b34r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.b34r2.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r2.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r2.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c34r2.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.34r2.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.34r2.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("mss.34l3.b1", k2s="kss.a23b1", extra=dict(polarity=-1.0))
env.set("mcbh.34l3.b1", knl=["-(acbh34.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c34l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c34l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.34l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b34l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a34l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a34l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.33l3.b1", k3="kod.a23b1", extra=dict(polarity=-1.0))
env.set("mq.33l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.33l3.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.33l3.b1", ksl=["acbv33.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b33l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c33l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b33l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b33l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a33l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a33l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.32l3.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.32l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("mss.32l3.b1", k2s="kss.a23b1", extra=dict(polarity=-1.0))
env.set("mcbh.32l3.b1", knl=["-(acbh32.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c32l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c32l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.32l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b32l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a32l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a32l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.31l3.b1", k3="kod.a23b1", extra=dict(polarity=-1.0))
env.set("mq.31l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.31l3.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.31l3.b1", ksl=["acbv31.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b31l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c31l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b31l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b31l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a31l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a31l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.30l3.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.30l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.30l3.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.30l3.b1", knl=["-(acbh30.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c30l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c30l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.30l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b30l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a30l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a30l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.29l3.b1", k3="kod.a23b1", extra=dict(polarity=-1.0))
env.set("mq.29l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.29l3.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.29l3.b1", ksl=["acbv29.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b29l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c29l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b29l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b29l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a29l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a29l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.28l3.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.28l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("mss.28l3.b1", k2s="kss.a23b1", extra=dict(polarity=-1.0))
env.set("mcbh.28l3.b1", knl=["-(acbh28.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c28l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c28l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.28l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b28l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a28l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a28l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqs.27l3.b1", k1s="kqs.a23b1", extra=dict(polarity=-1.0))
env.set("mq.27l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.27l3.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.27l3.b1", ksl=["acbv27.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b27l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c27l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b27l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b27l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a27l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a27l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.26l3.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.26l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.26l3.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.26l3.b1", knl=["-(acbh26.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c26l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c26l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.26l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b26l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a26l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a26l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.25l3.b1", k3="kod.a23b1", extra=dict(polarity=-1.0))
env.set("mq.25l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.25l3.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.25l3.b1", ksl=["acbv25.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b25l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c25l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b25l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b25l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a25l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a25l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.24l3.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.24l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.24l3.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.24l3.b1", knl=["-(acbh24.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c24l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c24l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.24l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b24l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a24l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a24l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqs.23l3.b1", k1s="kqs.a23b1", extra=dict(polarity=-1.0))
env.set("mq.23l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.23l3.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.23l3.b1", ksl=["acbv23.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b23l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c23l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b23l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b23l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a23l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a23l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mo.22l3.b1", k3="kof.a23b1", extra=dict(polarity=1.0))
env.set("mq.22l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.22l3.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.22l3.b1", knl=["-(acbh22.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c22l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c22l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.22l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b22l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a22l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a22l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.21l3.b1", k1="kqtd.a23b1", extra=dict(polarity=-1.0))
env.set("mq.21l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.21l3.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.21l3.b1", ksl=["acbv21.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b21l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c21l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b21l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b21l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a21l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a21l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.20l3.b1", k1="kqtf.a23b1", extra=dict(polarity=1.0))
env.set("mq.20l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.20l3.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.20l3.b1", knl=["-(acbh20.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c20l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c20l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.20l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b20l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a20l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a20l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.19l3.b1", k1="kqtd.a23b1", extra=dict(polarity=-1.0))
env.set("mq.19l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.19l3.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.19l3.b1", ksl=["acbv19.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b19l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c19l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b19l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b19l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a19l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a19l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.18l3.b1", k1="kqtf.a23b1", extra=dict(polarity=1.0))
env.set("mq.18l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.18l3.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.18l3.b1", knl=["-(acbh18.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c18l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c18l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.18l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b18l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a18l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a18l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.17l3.b1", k1="kqtd.a23b1", extra=dict(polarity=-1.0))
env.set("mq.17l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.17l3.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.17l3.b1", ksl=["acbv17.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b17l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c17l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b17l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b17l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a17l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a17l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.16l3.b1", k1="kqtf.a23b1", extra=dict(polarity=1.0))
env.set("mq.16l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.16l3.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.16l3.b1", knl=["-(acbh16.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c16l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c16l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.16l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b16l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a16l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a16l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.15l3.b1", k1="kqtd.a23b1", extra=dict(polarity=-1.0))
env.set("mq.15l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.15l3.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.15l3.b1", ksl=["acbv15.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b15l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c15l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b15l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b15l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a15l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a15l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.14l3.b1", k1="kqtf.a23b1", extra=dict(polarity=1.0))
env.set("mq.14l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.14l3.b1", k2="ksf2.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.14l3.b1", knl=["-(acbh14.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c14l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c14l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.14l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b14l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a14l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a14l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.13l3.b1", k1="kqt13.l3b1", extra=dict(polarity=-1.0))
env.set("mq.13l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.13l3.b1", k2="ksd1.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.13l3.b1", ksl=["acbv13.l3b1"], extra=dict(polarity=1.0))
env.set("mco.b13l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c13l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.b13l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b13l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.a13l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a13l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mqt.12l3.b1", k1="kqt12.l3b1", extra=dict(polarity=1.0))
env.set("mq.12l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("ms.12l3.b1", k2="ksf1.a23b1", extra=dict(polarity=1.0))
env.set("mcbh.12l3.b1", knl=["-(acbh12.l3b1)"], extra=dict(polarity=1.0))
env.set("mb.c12l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c12l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mco.12l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b12l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a12l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a12l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mq.11l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("mqtli.11l3.b1", k1="kqtl11.l3b1", extra=dict(polarity=-1.0))
env.set("ms.11l3.b1", k2="ksd2.a23b1", extra=dict(polarity=-1.0))
env.set("mcbv.11l3.b1", ksl=["acbv11.l3b1"], extra=dict(polarity=1.0))
env.set("mco.11l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b11l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a11l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a11l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mq.10l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("mqtli.10l3.b1", k1="kqtl10.l3b1", extra=dict(polarity=1.0))
env.set("mcbch.10l3.b1", knl=["-(acbch10.l3b1)"], extra=dict(polarity=1.0))
env.set("mco.10l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b10l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a10l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a10l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mq.9l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("mqtli.b9l3.b1", k1="kqtl9.l3b1", extra=dict(polarity=-1.0))
env.set("mqtli.a9l3.b1", k1="kqtl9.l3b1", extra=dict(polarity=-1.0))
env.set("mcbcv.9l3.b1", ksl=["acbcv9.l3b1"], extra=dict(polarity=1.0))
env.set("mco.9l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b9l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a9l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a9l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mq.8l3.b1", k1="kqf.a23", extra=dict(polarity=1.0))
env.set("mqtli.8l3.b1", k1="kqtl8.l3b1", extra=dict(polarity=1.0))
env.set("mcbch.8l3.b1", knl=["-(acbch8.l3b1)"], extra=dict(polarity=1.0))
env.set("mco.8l3.b1", knl=[0.0, 0.0, 0.0, "kco.a23b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a23b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b8l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mb.a8l3.b1", angle="ab.a23", k0="kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a8l3.b1", k2="kcs.a23b1", extra=dict(polarity=1.0))
env.set("mq.7l3.b1", k1="kqd.a23", extra=dict(polarity=-1.0))
env.set("mqtli.7l3.b1", k1="kqtl7.l3b1", extra=dict(polarity=-1.0))
env.set("mcbcv.7l3.b1", ksl=["acbcv7.l3b1"], extra=dict(polarity=1.0))
env.set("mcbch.6l3.b1", knl=["-(acbch6.l3b1)"], extra=dict(polarity=1.0))
env.set("mqtlh.f6l3.b1", k1="kq6.l3b1", extra=dict(polarity=1.0))
env.set("mqtlh.e6l3.b1", k1="kq6.l3b1", extra=dict(polarity=1.0))
env.set("mqtlh.d6l3.b1", k1="kq6.l3b1", extra=dict(polarity=1.0))
env.set("mqtlh.c6l3.b1", k1="kq6.l3b1", extra=dict(polarity=1.0))
env.set("mqtlh.b6l3.b1", k1="kq6.l3b1", extra=dict(polarity=1.0))
env.set("mqtlh.a6l3.b1", k1="kq6.l3b1", extra=dict(polarity=1.0))
env.set("mbw.f6l3.b1", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.e6l3.b1", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.d6l3.b1", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.c6l3.b1", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.b6l3.b1", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.a6l3.b1", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.e5l3.b1", k1="kq5.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.d5l3.b1", k1="kq5.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.c5l3.b1", k1="kq5.lr3", extra=dict(polarity=-1.0))
env.set("mqwb.5l3.b1", k1="kqt5.l3", extra=dict(polarity=-1.0))
env.set("mqwa.b5l3.b1", k1="kq5.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.a5l3.b1", k1="kq5.lr3", extra=dict(polarity=-1.0))
env.set("mcbwv.5l3.b1", ksl=["acbwv5.l3b1"], extra=dict(polarity=1.0))
env.set("mqwa.e4l3.b1", k1="kq4.lr3", extra=dict(polarity=1.0))
env.set("mqwa.d4l3.b1", k1="kq4.lr3", extra=dict(polarity=1.0))
env.set("mqwa.c4l3.b1", k1="kq4.lr3", extra=dict(polarity=1.0))
env.set("mqwb.4l3.b1", k1="kqt4.l3", extra=dict(polarity=1.0))
env.set("mqwa.b4l3.b1", k1="kq4.lr3", extra=dict(polarity=1.0))
env.set("mqwa.a4l3.b1", k1="kq4.lr3", extra=dict(polarity=1.0))
env.set("mcbwh.4l3.b1", knl=["-(acbwh4.l3b1)"], extra=dict(polarity=1.0))
env.set("mcbwv.4r3.b1", ksl=["acbwv4.r3b1"], extra=dict(polarity=1.0))
env.set("mqwa.a4r3.b1", k1="-kq4.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.b4r3.b1", k1="-kq4.lr3", extra=dict(polarity=-1.0))
env.set("mqwb.4r3.b1", k1="kqt4.r3", extra=dict(polarity=-1.0))
env.set("mqwa.c4r3.b1", k1="-kq4.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.d4r3.b1", k1="-kq4.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.e4r3.b1", k1="-kq4.lr3", extra=dict(polarity=-1.0))
env.set("mcbwh.5r3.b1", knl=["-(acbwh5.r3b1)"], extra=dict(polarity=1.0))
env.set("mqwa.a5r3.b1", k1="-kq5.lr3", extra=dict(polarity=1.0))
env.set("mqwa.b5r3.b1", k1="-kq5.lr3", extra=dict(polarity=1.0))
env.set("mqwb.5r3.b1", k1="kqt5.r3", extra=dict(polarity=1.0))
env.set("mqwa.c5r3.b1", k1="-kq5.lr3", extra=dict(polarity=1.0))
env.set("mqwa.d5r3.b1", k1="-kq5.lr3", extra=dict(polarity=1.0))
env.set("mqwa.e5r3.b1", k1="-kq5.lr3", extra=dict(polarity=1.0))
env.set("mbw.a6r3.b1", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.b6r3.b1", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.c6r3.b1", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.d6r3.b1", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.e6r3.b1", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.f6r3.b1", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=1.0))
env.set("mcbcv.6r3.b1", ksl=["acbcv6.r3b1"], extra=dict(polarity=1.0))
env.set("mqtlh.a6r3.b1", k1="kq6.r3b1", extra=dict(polarity=-1.0))
env.set("mqtlh.b6r3.b1", k1="kq6.r3b1", extra=dict(polarity=-1.0))
env.set("mqtlh.c6r3.b1", k1="kq6.r3b1", extra=dict(polarity=-1.0))
env.set("mqtlh.d6r3.b1", k1="kq6.r3b1", extra=dict(polarity=-1.0))
env.set("mqtlh.e6r3.b1", k1="kq6.r3b1", extra=dict(polarity=-1.0))
env.set("mqtlh.f6r3.b1", k1="kq6.r3b1", extra=dict(polarity=-1.0))
env.set("mq.7r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("mqtli.7r3.b1", k1="kqtl7.r3b1", extra=dict(polarity=1.0))
env.set("mcbch.7r3.b1", knl=["-(acbch7.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.8r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a8r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b8r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b8r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mq.8r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("mqtli.8r3.b1", k1="kqtl8.r3b1", extra=dict(polarity=-1.0))
env.set("mcbcv.8r3.b1", ksl=["acbcv8.r3b1"], extra=dict(polarity=1.0))
env.set("mco.9r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a9r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b9r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b9r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mq.9r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("mqtli.a9r3.b1", k1="kqtl9.r3b1", extra=dict(polarity=1.0))
env.set("mqtli.b9r3.b1", k1="kqtl9.r3b1", extra=dict(polarity=1.0))
env.set("mcbch.9r3.b1", knl=["-(acbch9.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.10r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a10r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b10r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b10r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mq.10r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("mqtli.10r3.b1", k1="kqtl10.r3b1", extra=dict(polarity=-1.0))
env.set("mcbcv.10r3.b1", ksl=["acbcv10.r3b1"], extra=dict(polarity=1.0))
env.set("mco.11r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a11r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b11r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b11r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mq.11r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("mqtli.11r3.b1", k1="kqtl11.r3b1", extra=dict(polarity=1.0))
env.set("ms.11r3.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.11r3.b1", knl=["-(acbh11.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a12r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a12r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b12r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b12r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b12r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c12r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.12r3.b1", k1="kqt12.r3b1", extra=dict(polarity=-1.0))
env.set("mq.12r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.12r3.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.12r3.b1", ksl=["acbv12.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a13r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a13r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.13r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b13r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c13r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c13r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.13r3.b1", k1="kqt13.r3b1", extra=dict(polarity=1.0))
env.set("mq.13r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.13r3.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.13r3.b1", knl=["-(acbh13.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a14r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a14r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b14r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b14r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b14r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c14r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.14r3.b1", k1="kqtd.a34b1", extra=dict(polarity=-1.0))
env.set("mq.14r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.14r3.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.14r3.b1", ksl=["acbv14.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a15r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a15r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.15r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b15r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c15r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c15r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.15r3.b1", k1="kqtf.a34b1", extra=dict(polarity=1.0))
env.set("mq.15r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.15r3.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.15r3.b1", knl=["-(acbh15.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a16r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a16r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b16r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b16r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b16r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c16r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.16r3.b1", k1="kqtd.a34b1", extra=dict(polarity=-1.0))
env.set("mq.16r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.16r3.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.16r3.b1", ksl=["acbv16.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a17r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a17r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.17r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b17r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c17r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c17r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.17r3.b1", k1="kqtf.a34b1", extra=dict(polarity=1.0))
env.set("mq.17r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.17r3.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.17r3.b1", knl=["-(acbh17.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a18r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a18r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b18r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b18r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b18r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c18r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.18r3.b1", k1="kqtd.a34b1", extra=dict(polarity=-1.0))
env.set("mq.18r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.18r3.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.18r3.b1", ksl=["acbv18.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a19r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a19r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.19r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b19r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c19r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c19r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.19r3.b1", k1="kqtf.a34b1", extra=dict(polarity=1.0))
env.set("mq.19r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.19r3.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.19r3.b1", knl=["-(acbh19.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a20r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a20r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b20r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b20r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b20r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c20r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.20r3.b1", k1="kqtd.a34b1", extra=dict(polarity=-1.0))
env.set("mq.20r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.20r3.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.20r3.b1", ksl=["acbv20.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a21r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a21r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.21r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b21r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c21r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c21r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.21r3.b1", k1="kqtf.a34b1", extra=dict(polarity=1.0))
env.set("mq.21r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.21r3.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.21r3.b1", knl=["-(acbh21.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a22r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a22r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b22r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b22r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b22r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c22r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.22r3.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.22r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.22r3.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.22r3.b1", ksl=["acbv22.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a23r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a23r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.23r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b23r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c23r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c23r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqs.23r3.b1", k1s="kqs.r3b1", extra=dict(polarity=-1.0))
env.set("mq.23r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.23r3.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.23r3.b1", knl=["-(acbh23.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a24r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a24r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b24r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b24r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b24r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c24r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.24r3.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.24r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.24r3.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.24r3.b1", ksl=["acbv24.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a25r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a25r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.25r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b25r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c25r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c25r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.25r3.b1", k3="kof.a34b1", extra=dict(polarity=1.0))
env.set("mq.25r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.25r3.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.25r3.b1", knl=["-(acbh25.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a26r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a26r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b26r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b26r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b26r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c26r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.26r3.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.26r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.26r3.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.26r3.b1", ksl=["acbv26.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a27r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a27r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.27r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b27r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c27r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c27r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqs.27r3.b1", k1s="kqs.r3b1", extra=dict(polarity=-1.0))
env.set("mq.27r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.27r3.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.27r3.b1", knl=["-(acbh27.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a28r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a28r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b28r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b28r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b28r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c28r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.28r3.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.28r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.28r3.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.28r3.b1", ksl=["acbv28.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a29r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a29r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.29r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b29r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c29r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c29r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.29r3.b1", k3="kof.a34b1", extra=dict(polarity=1.0))
env.set("mq.29r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("mcbh.29r3.b1", knl=["-(acbh29.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a30r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a30r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b30r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b30r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b30r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c30r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.30r3.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.30r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.30r3.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.30r3.b1", ksl=["acbv30.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a31r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a31r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.31r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b31r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c31r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c31r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.31r3.b1", k3="kof.a34b1", extra=dict(polarity=1.0))
env.set("mq.31r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.31r3.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.31r3.b1", knl=["-(acbh31.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a32r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a32r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b32r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b32r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b32r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c32r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.32r3.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.32r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.32r3.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.32r3.b1", ksl=["acbv32.r3b1"], extra=dict(polarity=1.0))
env.set("mb.a33r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a33r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.33r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b33r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.c33r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c33r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.33r3.b1", k3="kof.a34b1", extra=dict(polarity=1.0))
env.set("mq.33r3.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("mcbh.33r3.b1", knl=["-(acbh33.r3b1)"], extra=dict(polarity=1.0))
env.set("mco.a34r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a34r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b34r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b34r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.b34r3.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r3.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r3.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c34r3.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.34r3.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.34r3.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.34l4.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.34l4.b1", ksl=["acbv34.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c34l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c34l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.34l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b34l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a34l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a34l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.33l4.b1", k3="kof.a34b1", extra=dict(polarity=1.0))
env.set("mq.33l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("mcbh.33l4.b1", knl=["-(acbh33.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b33l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c33l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b33l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b33l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a33l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a33l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.32l4.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.32l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.32l4.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.32l4.b1", ksl=["acbv32.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c32l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c32l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.32l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b32l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a32l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a32l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.31l4.b1", k3="kof.a34b1", extra=dict(polarity=1.0))
env.set("mq.31l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.31l4.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.31l4.b1", knl=["-(acbh31.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b31l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c31l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b31l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b31l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a31l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a31l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.30l4.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.30l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.30l4.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.30l4.b1", ksl=["acbv30.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c30l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c30l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.30l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b30l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a30l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a30l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.29l4.b1", k3="kof.a34b1", extra=dict(polarity=1.0))
env.set("mq.29l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("mcbh.29l4.b1", knl=["-(acbh29.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b29l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c29l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b29l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b29l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a29l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a29l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.28l4.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.28l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.28l4.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.28l4.b1", ksl=["acbv28.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c28l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c28l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.28l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b28l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a28l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a28l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqs.27l4.b1", k1s="kqs.l4b1", extra=dict(polarity=-1.0))
env.set("mq.27l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.27l4.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.27l4.b1", knl=["-(acbh27.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b27l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c27l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b27l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b27l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a27l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a27l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.26l4.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.26l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.26l4.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.26l4.b1", ksl=["acbv26.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c26l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c26l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.26l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b26l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a26l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a26l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.25l4.b1", k3="kof.a34b1", extra=dict(polarity=1.0))
env.set("mq.25l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.25l4.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.25l4.b1", knl=["-(acbh25.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b25l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c25l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b25l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b25l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a25l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a25l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.24l4.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.24l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.24l4.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.24l4.b1", ksl=["acbv24.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c24l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c24l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.24l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b24l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a24l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a24l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqs.23l4.b1", k1s="kqs.l4b1", extra=dict(polarity=-1.0))
env.set("mq.23l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.23l4.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.23l4.b1", knl=["-(acbh23.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b23l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c23l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b23l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b23l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a23l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a23l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mo.22l4.b1", k3="kod.a34b1", extra=dict(polarity=-1.0))
env.set("mq.22l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.22l4.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.22l4.b1", ksl=["acbv22.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c22l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c22l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.22l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b22l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a22l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a22l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.21l4.b1", k1="kqtf.a34b1", extra=dict(polarity=1.0))
env.set("mq.21l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.21l4.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.21l4.b1", knl=["-(acbh21.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b21l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c21l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b21l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b21l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a21l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a21l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.20l4.b1", k1="kqtd.a34b1", extra=dict(polarity=-1.0))
env.set("mq.20l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.20l4.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.20l4.b1", ksl=["acbv20.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c20l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c20l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.20l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b20l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a20l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a20l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.19l4.b1", k1="kqtf.a34b1", extra=dict(polarity=1.0))
env.set("mq.19l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.19l4.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.19l4.b1", knl=["-(acbh19.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b19l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c19l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b19l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b19l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a19l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a19l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.18l4.b1", k1="kqtd.a34b1", extra=dict(polarity=-1.0))
env.set("mq.18l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.18l4.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.18l4.b1", ksl=["acbv18.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c18l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c18l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.18l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b18l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a18l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a18l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.17l4.b1", k1="kqtf.a34b1", extra=dict(polarity=1.0))
env.set("mq.17l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.17l4.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.17l4.b1", knl=["-(acbh17.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b17l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c17l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b17l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b17l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a17l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a17l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.16l4.b1", k1="kqtd.a34b1", extra=dict(polarity=-1.0))
env.set("mq.16l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.16l4.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.16l4.b1", ksl=["acbv16.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c16l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c16l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.16l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b16l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a16l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a16l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.15l4.b1", k1="kqtf.a34b1", extra=dict(polarity=1.0))
env.set("mq.15l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.15l4.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.15l4.b1", knl=["-(acbh15.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b15l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c15l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b15l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b15l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a15l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a15l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.14l4.b1", k1="kqtd.a34b1", extra=dict(polarity=-1.0))
env.set("mq.14l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.14l4.b1", k2="ksd2.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.14l4.b1", ksl=["acbv14.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c14l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c14l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.14l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b14l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a14l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a14l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.13l4.b1", k1="kqt13.l4b1", extra=dict(polarity=1.0))
env.set("mq.13l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("ms.13l4.b1", k2="ksf1.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.13l4.b1", knl=["-(acbh13.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.b13l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c13l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.b13l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b13l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.a13l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a13l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqt.12l4.b1", k1="kqt12.l4b1", extra=dict(polarity=-1.0))
env.set("mq.12l4.b1", k1="kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.12l4.b1", k2="ksd1.a34b1", extra=dict(polarity=-1.0))
env.set("mcbv.12l4.b1", ksl=["acbv12.l4b1"], extra=dict(polarity=1.0))
env.set("mb.c12l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c12l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mco.12l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b12l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a12l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a12l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mq.11l4.b1", k1="kqf.a34", extra=dict(polarity=1.0))
env.set("mqtli.11l4.b1", k1="kqtl11.l4b1", extra=dict(polarity=1.0))
env.set("ms.11l4.b1", k2="ksf2.a34b1", extra=dict(polarity=1.0))
env.set("mcbh.11l4.b1", knl=["-(acbh11.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.11l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b11l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a11l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a11l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqml.10l4.b1", k1="kq10.l4b1", extra=dict(polarity=-1.0))
env.set("mcbcv.10l4.b1", ksl=["acbcv10.l4b1"], extra=dict(polarity=1.0))
env.set("mco.10l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b10l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a10l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a10l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqmc.9l4.b1", k1="kq9.l4b1", extra=dict(polarity=1.0))
env.set("mqm.9l4.b1", k1="kq9.l4b1", extra=dict(polarity=1.0))
env.set("mcbch.9l4.b1", knl=["-(acbch9.l4b1)"], extra=dict(polarity=1.0))
env.set("mco.9l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b9l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a9l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a9l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqml.8l4.b1", k1="kq8.l4b1", extra=dict(polarity=-1.0))
env.set("mcbcv.8l4.b1", ksl=["acbcv8.l4b1"], extra=dict(polarity=1.0))
env.set("mco.8l4.b1", knl=[0.0, 0.0, 0.0, "kco.a34b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a34b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b8l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mb.a8l4.b1", angle="ab.a34", k0="kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a8l4.b1", k2="kcs.a34b1", extra=dict(polarity=1.0))
env.set("mqm.7l4.b1", k1="kq7.l4b1", extra=dict(polarity=1.0))
env.set("mcbch.7l4.b1", knl=["-(acbch7.l4b1)"], extra=dict(polarity=1.0))
env.set("mqy.6l4.b1", k1="kq6.l4b1", extra=dict(polarity=-1.0))
env.set("mcbyv.6l4.b1", ksl=["acbyv6.l4b1"], extra=dict(polarity=1.0))
env.set("bqkv.6l4.b1", ksl=["akbqkv.l4b1"])
env.set("mkqa.6l4.b1", knl=["-(khmkqa.l4b1)"], ksl=["kvmkqa.l4b1"])
env.set("bqkh.b6l4.b1", knl=["-(akbqkh.l4b1)"])
env.set("mqy.5l4.b1", k1="kq5.l4b1", extra=dict(polarity=1.0))
env.set("mcbyh.5l4.b1", knl=["-(acbyh5.l4b1)"], extra=dict(polarity=1.0))
env.set("mbrb.5l4.b1", angle="ad4.l4", k0="kd4.l4", extra=dict(polarity=1.0))
env.set("mgmwh.a5l4.b1", knl=["-(-kgmwh.l4b1)"], extra=dict(polarity=-1.0))
env.set("mgmwh.c5l4.b1", knl=["-(kgmwh.l4b1)"], extra=dict(polarity=1.0))
env.set("mgmwv.c5l4.b1", ksl=["kgmwv.l4b1"], extra=dict(polarity=-1.0))
env.set("mgmwv.a5l4.b1", ksl=["-kgmwv.l4b1"], extra=dict(polarity=1.0))
env.set("mbrs.5l4.b1", angle="-ad3.l4", k0="-kd3.l4", extra=dict(polarity=-1.0))
env.set("adtkh.d5l4.b1", knl=["-(akadtkh.l4b1)"])
env.set("adtkh.c5l4.b1", knl=["-(akadtkh.l4b1)"])
env.set("adtkh.b5l4.b1", knl=["-(akadtkh.l4b1)"])
env.set("adtkh.a5l4.b1", knl=["-(akadtkh.l4b1)"])
env.set("adtkv.a5r4.b1", ksl=["akadtkv.r4b1"])
env.set("adtkv.b5r4.b1", ksl=["akadtkv.r4b1"])
env.set("adtkv.c5r4.b1", ksl=["akadtkv.r4b1"])
env.set("adtkv.d5r4.b1", ksl=["akadtkv.r4b1"])
env.set("mu.a5r4.b1", knl=["-(kmu.r4b1)"], extra=dict(polarity=1.0))
env.set("mu.b5r4.b1", knl=["-(kmu.r4b1)"], extra=dict(polarity=1.0))
env.set("mu.c5r4.b1", knl=["-(kmu.r4b1)"], extra=dict(polarity=1.0))
env.set("mu.d5r4.b1", knl=["-(kmu.r4b1)"], extra=dict(polarity=1.0))
env.set("mbrs.5r4.b1", angle="-ad3.r4", k0="-kd3.r4", extra=dict(polarity=-1.0))
env.set("mbrb.5r4.b1", angle="ad4.r4", k0="kd4.r4", extra=dict(polarity=1.0))
env.set("mcbyv.5r4.b1", ksl=["acbyv5.r4b1"], extra=dict(polarity=1.0))
env.set("mqy.5r4.b1", k1="kq5.r4b1", extra=dict(polarity=-1.0))
env.set("mqy.6r4.b1", k1="kq6.r4b1", extra=dict(polarity=1.0))
env.set("mcbyh.6r4.b1", knl=["-(acbyh6.r4b1)"], extra=dict(polarity=1.0))
env.set("mqm.7r4.b1", k1="kq7.r4b1", extra=dict(polarity=-1.0))
env.set("mcbcv.7r4.b1", ksl=["acbcv7.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.8r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a8r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b8r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b8r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqml.8r4.b1", k1="kq8.r4b1", extra=dict(polarity=1.0))
env.set("mcbch.8r4.b1", knl=["-(acbch8.r4b1)"], extra=dict(polarity=1.0))
env.set("mcd.9r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a9r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b9r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b9r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqmc.9r4.b1", k1="kq9.r4b1", extra=dict(polarity=-1.0))
env.set("mqm.9r4.b1", k1="kq9.r4b1", extra=dict(polarity=-1.0))
env.set("mcbcv.9r4.b1", ksl=["acbcv9.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.10r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a10r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b10r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b10r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqml.10r4.b1", k1="kq10.r4b1", extra=dict(polarity=1.0))
env.set("mcbch.10r4.b1", knl=["-(acbch10.r4b1)"], extra=dict(polarity=1.0))
env.set("mcd.11r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a11r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b11r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b11r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mq.11r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("mqtli.11r4.b1", k1="kqtl11.r4b1", extra=dict(polarity=-1.0))
env.set("ms.11r4.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.11r4.b1", ksl=["acbv11.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a12r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a12r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b12r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b12r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b12r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c12r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.12r4.b1", k1="kqt12.r4b1", extra=dict(polarity=1.0))
env.set("mq.12r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.12r4.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.12r4.b1", knl=["-(acbh12.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a13r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a13r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.13r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b13r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c13r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c13r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.13r4.b1", k1="kqt13.r4b1", extra=dict(polarity=-1.0))
env.set("mq.13r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.13r4.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.13r4.b1", ksl=["acbv13.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a14r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a14r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b14r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b14r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b14r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c14r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.14r4.b1", k1="kqtf.a45b1", extra=dict(polarity=1.0))
env.set("mq.14r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.14r4.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.14r4.b1", knl=["-(acbh14.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a15r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a15r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.15r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b15r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c15r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c15r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.15r4.b1", k1="kqtd.a45b1", extra=dict(polarity=-1.0))
env.set("mq.15r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.15r4.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.15r4.b1", ksl=["acbv15.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a16r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a16r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b16r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b16r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b16r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c16r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.16r4.b1", k1="kqtf.a45b1", extra=dict(polarity=1.0))
env.set("mq.16r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.16r4.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.16r4.b1", knl=["-(acbh16.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a17r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a17r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.17r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b17r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c17r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c17r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.17r4.b1", k1="kqtd.a45b1", extra=dict(polarity=-1.0))
env.set("mq.17r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.17r4.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.17r4.b1", ksl=["acbv17.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a18r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a18r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b18r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b18r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b18r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c18r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.18r4.b1", k1="kqtf.a45b1", extra=dict(polarity=1.0))
env.set("mq.18r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.18r4.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.18r4.b1", knl=["-(acbh18.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a19r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a19r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.19r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b19r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c19r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c19r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.19r4.b1", k1="kqtd.a45b1", extra=dict(polarity=-1.0))
env.set("mq.19r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.19r4.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.19r4.b1", ksl=["acbv19.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a20r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a20r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b20r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b20r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b20r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c20r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.20r4.b1", k1="kqtf.a45b1", extra=dict(polarity=1.0))
env.set("mq.20r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.20r4.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.20r4.b1", knl=["-(acbh20.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a21r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a21r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.21r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b21r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c21r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c21r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.21r4.b1", k1="kqtd.a45b1", extra=dict(polarity=-1.0))
env.set("mq.21r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.21r4.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.21r4.b1", ksl=["acbv21.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a22r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a22r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b22r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b22r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b22r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c22r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.22r4.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.22r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.22r4.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.22r4.b1", knl=["-(acbh22.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a23r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a23r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.23r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b23r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c23r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c23r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqs.23r4.b1", k1s="kqs.a45b1", extra=dict(polarity=-1.0))
env.set("mq.23r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.23r4.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.23r4.b1", ksl=["acbv23.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a24r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a24r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b24r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b24r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b24r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c24r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.24r4.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.24r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.24r4.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.24r4.b1", knl=["-(acbh24.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a25r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a25r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.25r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b25r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c25r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c25r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.25r4.b1", k3="kod.a45b1", extra=dict(polarity=-1.0))
env.set("mq.25r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.25r4.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.25r4.b1", ksl=["acbv25.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a26r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a26r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b26r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b26r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b26r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c26r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.26r4.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.26r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.26r4.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.26r4.b1", knl=["-(acbh26.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a27r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a27r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.27r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b27r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c27r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c27r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqs.27r4.b1", k1s="kqs.a45b1", extra=dict(polarity=-1.0))
env.set("mq.27r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.27r4.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.27r4.b1", ksl=["acbv27.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a28r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a28r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b28r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b28r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b28r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c28r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.28r4.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.28r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.28r4.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.28r4.b1", knl=["-(acbh28.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a29r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a29r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.29r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b29r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c29r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c29r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.29r4.b1", k3="kod.a45b1", extra=dict(polarity=-1.0))
env.set("mq.29r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.29r4.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.29r4.b1", ksl=["acbv29.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a30r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a30r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b30r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b30r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b30r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c30r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.30r4.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.30r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("mss.30r4.b1", k2s="kss.a45b1", extra=dict(polarity=-1.0))
env.set("mcbh.30r4.b1", knl=["-(acbh30.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a31r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a31r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.31r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b31r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c31r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c31r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.31r4.b1", k3="kod.a45b1", extra=dict(polarity=-1.0))
env.set("mq.31r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.31r4.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.31r4.b1", ksl=["acbv31.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a32r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a32r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b32r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b32r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b32r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c32r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.32r4.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.32r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.32r4.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.32r4.b1", knl=["-(acbh32.r4b1)"], extra=dict(polarity=1.0))
env.set("mb.a33r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a33r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.33r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b33r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.c33r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c33r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.33r4.b1", k3="kod.a45b1", extra=dict(polarity=-1.0))
env.set("mq.33r4.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.33r4.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.33r4.b1", ksl=["acbv33.r4b1"], extra=dict(polarity=1.0))
env.set("mcd.a34r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a34r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b34r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b34r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.b34r4.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r4.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c34r4.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.34r4.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.34r4.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("mss.34l5.b1", k2s="kss.a45b1", extra=dict(polarity=-1.0))
env.set("mcbh.34l5.b1", knl=["-(acbh34.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c34l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c34l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.34l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b34l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a34l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a34l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.33l5.b1", k3="kod.a45b1", extra=dict(polarity=-1.0))
env.set("mq.33l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.33l5.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.33l5.b1", ksl=["acbv33.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b33l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c33l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b33l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b33l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a33l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a33l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.32l5.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.32l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("mss.32l5.b1", k2s="kss.a45b1", extra=dict(polarity=-1.0))
env.set("mcbh.32l5.b1", knl=["-(acbh32.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c32l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c32l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.32l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b32l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a32l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a32l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.31l5.b1", k3="kod.a45b1", extra=dict(polarity=-1.0))
env.set("mq.31l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.31l5.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.31l5.b1", ksl=["acbv31.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b31l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c31l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b31l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b31l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a31l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a31l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.30l5.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.30l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.30l5.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.30l5.b1", knl=["-(acbh30.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c30l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c30l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.30l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b30l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a30l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a30l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.29l5.b1", k3="kod.a45b1", extra=dict(polarity=-1.0))
env.set("mq.29l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.29l5.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.29l5.b1", ksl=["acbv29.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b29l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c29l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b29l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b29l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a29l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a29l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.28l5.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.28l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("mss.28l5.b1", k2s="kss.a45b1", extra=dict(polarity=-1.0))
env.set("mcbh.28l5.b1", knl=["-(acbh28.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c28l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c28l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.28l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b28l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a28l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a28l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqs.27l5.b1", k1s="kqs.a45b1", extra=dict(polarity=-1.0))
env.set("mq.27l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.27l5.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.27l5.b1", ksl=["acbv27.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b27l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c27l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b27l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b27l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a27l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a27l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.26l5.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.26l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.26l5.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.26l5.b1", knl=["-(acbh26.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c26l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c26l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.26l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b26l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a26l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a26l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.25l5.b1", k3="kod.a45b1", extra=dict(polarity=-1.0))
env.set("mq.25l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.25l5.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.25l5.b1", ksl=["acbv25.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b25l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c25l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b25l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b25l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a25l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a25l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.24l5.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.24l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.24l5.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.24l5.b1", knl=["-(acbh24.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c24l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c24l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.24l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b24l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a24l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a24l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqs.23l5.b1", k1s="kqs.a45b1", extra=dict(polarity=-1.0))
env.set("mq.23l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.23l5.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.23l5.b1", ksl=["acbv23.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b23l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c23l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b23l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b23l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a23l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a23l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mo.22l5.b1", k3="kof.a45b1", extra=dict(polarity=1.0))
env.set("mq.22l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.22l5.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.22l5.b1", knl=["-(acbh22.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c22l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c22l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.22l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b22l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a22l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a22l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.21l5.b1", k1="kqtd.a45b1", extra=dict(polarity=-1.0))
env.set("mq.21l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.21l5.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.21l5.b1", ksl=["acbv21.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b21l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c21l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b21l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b21l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a21l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a21l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.20l5.b1", k1="kqtf.a45b1", extra=dict(polarity=1.0))
env.set("mq.20l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.20l5.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.20l5.b1", knl=["-(acbh20.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c20l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c20l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.20l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b20l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a20l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a20l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.19l5.b1", k1="kqtd.a45b1", extra=dict(polarity=-1.0))
env.set("mq.19l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.19l5.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.19l5.b1", ksl=["acbv19.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b19l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c19l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b19l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b19l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a19l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a19l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.18l5.b1", k1="kqtf.a45b1", extra=dict(polarity=1.0))
env.set("mq.18l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.18l5.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.18l5.b1", knl=["-(acbh18.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c18l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c18l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.18l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b18l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a18l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a18l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.17l5.b1", k1="kqtd.a45b1", extra=dict(polarity=-1.0))
env.set("mq.17l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.17l5.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.17l5.b1", ksl=["acbv17.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b17l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c17l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b17l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b17l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a17l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a17l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.16l5.b1", k1="kqtf.a45b1", extra=dict(polarity=1.0))
env.set("mq.16l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.16l5.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.16l5.b1", knl=["-(acbh16.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c16l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c16l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.16l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b16l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a16l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a16l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.15l5.b1", k1="kqtd.a45b1", extra=dict(polarity=-1.0))
env.set("mq.15l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.15l5.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.15l5.b1", ksl=["acbv15.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b15l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c15l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b15l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b15l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a15l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a15l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.14l5.b1", k1="kqtf.a45b1", extra=dict(polarity=1.0))
env.set("mq.14l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.14l5.b1", k2="ksf1.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.14l5.b1", knl=["-(acbh14.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c14l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c14l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.14l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b14l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a14l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a14l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.13l5.b1", k1="kqt13.l5b1", extra=dict(polarity=-1.0))
env.set("mq.13l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.13l5.b1", k2="ksd1.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.13l5.b1", ksl=["acbv13.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.b13l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c13l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.b13l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b13l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.a13l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a13l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqt.12l5.b1", k1="kqt12.l5b1", extra=dict(polarity=1.0))
env.set("mq.12l5.b1", k1="kqf.a45", extra=dict(polarity=1.0))
env.set("ms.12l5.b1", k2="ksf2.a45b1", extra=dict(polarity=1.0))
env.set("mcbh.12l5.b1", knl=["-(acbh12.l5b1)"], extra=dict(polarity=1.0))
env.set("mb.c12l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c12l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mcd.12l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b12l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a12l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a12l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mq.11l5.b1", k1="kqd.a45", extra=dict(polarity=-1.0))
env.set("mqtli.11l5.b1", k1="kqtl11.l5b1", extra=dict(polarity=-1.0))
env.set("ms.11l5.b1", k2="ksd2.a45b1", extra=dict(polarity=-1.0))
env.set("mcbv.11l5.b1", ksl=["acbv11.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.11l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b11l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a11l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a11l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqml.10l5.b1", k1="kq10.l5b1", extra=dict(polarity=1.0))
env.set("mcbch.10l5.b1", knl=["-(acbch10.l5b1)"], extra=dict(polarity=1.0))
env.set("mcd.10l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b10l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a10l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a10l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqmc.9l5.b1", k1="kq9.l5b1", extra=dict(polarity=-1.0))
env.set("mqm.9l5.b1", k1="kq9.l5b1", extra=dict(polarity=-1.0))
env.set("mcbcv.9l5.b1", ksl=["acbcv9.l5b1"], extra=dict(polarity=1.0))
env.set("mcd.9l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b9l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a9l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a9l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqml.8l5.b1", k1="kq8.l5b1", extra=dict(polarity=1.0))
env.set("mcbch.8l5.b1", knl=["-(acbch8.l5b1)"], extra=dict(polarity=1.0))
env.set("mcd.8l5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a45b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b8l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mb.a8l5.b1", angle="ab.a45", k0="kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a8l5.b1", k2="kcs.a45b1", extra=dict(polarity=1.0))
env.set("mqm.b7l5.b1", k1="kq7.l5b1", extra=dict(polarity=-1.0))
env.set("mqm.a7l5.b1", k1="kq7.l5b1", extra=dict(polarity=-1.0))
env.set("mcbcv.7l5.b1", ksl=["acbcv7.l5b1"], extra=dict(polarity=1.0))
env.set("mqml.6l5.b1", k1="kq6.l5b1", extra=dict(polarity=1.0))
env.set("mcbch.6l5.b1", knl=["-(acbch6.l5b1)"], extra=dict(polarity=1.0))
env.set("mqml.5l5.b1", k1="kq5.l5b1", extra=dict(polarity=-1.0))
env.set("mcbcv.5l5.b1", ksl=["acbcv5.l5b1"], extra=dict(polarity=1.0))
env.set("mqy.4l5.b1", k1="kq4.l5b1", extra=dict(polarity=1.0))
env.set("mcbyh.b4l5.b1", knl=["-(acbyh4.l5b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.4l5.b1", ksl=["acbyvs4.l5b1"], extra=dict(polarity=1.0))
env.set("mcbyh.a4l5.b1", knl=["-(acbyhs4.l5b1)"], extra=dict(polarity=1.0))
env.set("mbrc.4l5.b1", angle="-ad2.l5", k0="-kd2.l5", extra=dict(polarity=-1.0))
env.set("mbxw.f4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.e4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.d4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.c4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.b4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.a4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mcosx.3l5", ksl=[0.0, 0.0, 0.0, "kcosx3.l5*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3l5", knl=[0.0, 0.0, 0.0, "kcox3.l5*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3l5", ksl=[0.0, 0.0, "kcssx3.l5*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mcbxh.3l5", knl=["-(acbxh3.l5)"], extra=dict(polarity=1.0))
env.set("mcbxv.3l5", ksl=["acbxv3.l5"], extra=dict(polarity=1.0))
env.set("mcsx.3l5", knl=[0.0, 0.0, "kcsx3.l5*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3l5", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.l5*l.mctx"], extra=dict(polarity=1.0))
env.set("mqxa.3l5", k1="kqx.l5", extra=dict(polarity=-1.0))
env.set("mqsx.3l5", k1s="kqsx3.l5", extra=dict(polarity=-1.0))
env.set("mqxb.b2l5", k1="-kqx.l5-ktqx2.l5", extra=dict(polarity=1.0))
env.set("mcbxh.2l5", knl=["-(acbxh2.l5)"], extra=dict(polarity=1.0))
env.set("mcbxv.2l5", ksl=["acbxv2.l5"], extra=dict(polarity=1.0))
env.set("mqxb.a2l5", k1="-kqx.l5-ktqx2.l5", extra=dict(polarity=1.0))
env.set("mcbxh.1l5", knl=["-(acbxh1.l5)"], extra=dict(polarity=1.0))
env.set("mcbxv.1l5", ksl=["acbxv1.l5"], extra=dict(polarity=1.0))
env.set("mqxa.1l5", k1="kqx.l5+ktqx1.l5", extra=dict(polarity=-1.0))
env.set("mbcs2.1l5", ks="abcs")
env.set("mbcs2.1r5", ks="abcs")
env.set("mqxa.1r5", k1="kqx.r5+ktqx1.r5", extra=dict(polarity=1.0))
env.set("mcbxh.1r5", knl=["-(acbxh1.r5)"], extra=dict(polarity=1.0))
env.set("mcbxv.1r5", ksl=["acbxv1.r5"], extra=dict(polarity=1.0))
env.set("mqxb.a2r5", k1="-kqx.r5-ktqx2.r5", extra=dict(polarity=-1.0))
env.set("mcbxh.2r5", knl=["-(acbxh2.r5)"], extra=dict(polarity=1.0))
env.set("mcbxv.2r5", ksl=["acbxv2.r5"], extra=dict(polarity=1.0))
env.set("mqxb.b2r5", k1="-kqx.r5-ktqx2.r5", extra=dict(polarity=-1.0))
env.set("mqsx.3r5", k1s="kqsx3.r5", extra=dict(polarity=-1.0))
env.set("mqxa.3r5", k1="kqx.r5", extra=dict(polarity=1.0))
env.set("mcbxh.3r5", knl=["-(acbxh3.r5)"], extra=dict(polarity=1.0))
env.set("mcbxv.3r5", ksl=["acbxv3.r5"], extra=dict(polarity=1.0))
env.set("mcsx.3r5", knl=[0.0, 0.0, "kcsx3.r5*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3r5", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.r5*l.mctx"], extra=dict(polarity=1.0))
env.set("mcosx.3r5", ksl=[0.0, 0.0, 0.0, "kcosx3.r5*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3r5", knl=[0.0, 0.0, 0.0, "kcox3.r5*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3r5", ksl=[0.0, 0.0, "kcssx3.r5*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mbxw.a4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.b4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.c4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.d4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.e4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.f4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbrc.4r5.b1", angle="ad2.r5", k0="kd2.r5", extra=dict(polarity=1.0))
env.set("mcbyv.a4r5.b1", ksl=["acbyvs4.r5b1"], extra=dict(polarity=1.0))
env.set("mcbyh.4r5.b1", knl=["-(acbyhs4.r5b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.b4r5.b1", ksl=["acbyv4.r5b1"], extra=dict(polarity=1.0))
env.set("mqy.4r5.b1", k1="kq4.r5b1", extra=dict(polarity=-1.0))
env.set("mqml.5r5.b1", k1="kq5.r5b1", extra=dict(polarity=1.0))
env.set("mcbch.5r5.b1", knl=["-(acbch5.r5b1)"], extra=dict(polarity=1.0))
env.set("mqml.6r5.b1", k1="kq6.r5b1", extra=dict(polarity=-1.0))
env.set("mcbcv.6r5.b1", ksl=["acbcv6.r5b1"], extra=dict(polarity=1.0))
env.set("mqm.a7r5.b1", k1="kq7.r5b1", extra=dict(polarity=1.0))
env.set("mqm.b7r5.b1", k1="kq7.r5b1", extra=dict(polarity=1.0))
env.set("mcbch.7r5.b1", knl=["-(acbch7.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.8r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a8r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b8r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b8r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqml.8r5.b1", k1="kq8.r5b1", extra=dict(polarity=-1.0))
env.set("mcbcv.8r5.b1", ksl=["acbcv8.r5b1"], extra=dict(polarity=1.0))
env.set("mco.9r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a9r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b9r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b9r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqmc.9r5.b1", k1="kq9.r5b1", extra=dict(polarity=1.0))
env.set("mqm.9r5.b1", k1="kq9.r5b1", extra=dict(polarity=1.0))
env.set("mcbch.9r5.b1", knl=["-(acbch9.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.10r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a10r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b10r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b10r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqml.10r5.b1", k1="kq10.r5b1", extra=dict(polarity=-1.0))
env.set("mcbcv.10r5.b1", ksl=["acbcv10.r5b1"], extra=dict(polarity=1.0))
env.set("mco.11r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a11r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b11r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b11r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mq.11r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("mqtli.11r5.b1", k1="kqtl11.r5b1", extra=dict(polarity=1.0))
env.set("ms.11r5.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.11r5.b1", knl=["-(acbh11.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a12r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a12r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b12r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b12r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b12r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c12r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.12r5.b1", k1="kqt12.r5b1", extra=dict(polarity=-1.0))
env.set("mq.12r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.12r5.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.12r5.b1", ksl=["acbv12.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a13r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a13r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.13r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b13r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c13r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c13r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.13r5.b1", k1="kqt13.r5b1", extra=dict(polarity=1.0))
env.set("mq.13r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.13r5.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.13r5.b1", knl=["-(acbh13.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a14r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a14r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b14r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b14r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b14r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c14r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.14r5.b1", k1="kqtd.a56b1", extra=dict(polarity=-1.0))
env.set("mq.14r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.14r5.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.14r5.b1", ksl=["acbv14.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a15r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a15r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.15r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b15r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c15r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c15r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.15r5.b1", k1="kqtf.a56b1", extra=dict(polarity=1.0))
env.set("mq.15r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.15r5.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.15r5.b1", knl=["-(acbh15.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a16r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a16r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b16r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b16r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b16r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c16r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.16r5.b1", k1="kqtd.a56b1", extra=dict(polarity=-1.0))
env.set("mq.16r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.16r5.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.16r5.b1", ksl=["acbv16.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a17r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a17r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.17r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b17r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c17r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c17r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.17r5.b1", k1="kqtf.a56b1", extra=dict(polarity=1.0))
env.set("mq.17r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.17r5.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.17r5.b1", knl=["-(acbh17.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a18r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a18r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b18r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b18r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b18r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c18r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.18r5.b1", k1="kqtd.a56b1", extra=dict(polarity=-1.0))
env.set("mq.18r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.18r5.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.18r5.b1", ksl=["acbv18.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a19r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a19r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.19r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b19r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c19r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c19r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.19r5.b1", k1="kqtf.a56b1", extra=dict(polarity=1.0))
env.set("mq.19r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.19r5.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.19r5.b1", knl=["-(acbh19.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a20r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a20r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b20r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b20r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b20r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c20r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.20r5.b1", k1="kqtd.a56b1", extra=dict(polarity=-1.0))
env.set("mq.20r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.20r5.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.20r5.b1", ksl=["acbv20.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a21r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a21r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.21r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b21r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c21r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c21r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.21r5.b1", k1="kqtf.a56b1", extra=dict(polarity=1.0))
env.set("mq.21r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.21r5.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.21r5.b1", knl=["-(acbh21.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a22r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a22r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b22r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b22r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b22r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c22r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mq.22r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.22r5.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.22r5.b1", ksl=["acbv22.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a23r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a23r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.23r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b23r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c23r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c23r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqs.23r5.b1", k1s="kqs.r5b1", extra=dict(polarity=-1.0))
env.set("mq.23r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.23r5.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.23r5.b1", knl=["-(acbh23.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a24r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a24r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b24r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b24r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b24r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c24r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mq.24r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.24r5.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.24r5.b1", ksl=["acbv24.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a25r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a25r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.25r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b25r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c25r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c25r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.25r5.b1", k3="kof.a56b1", extra=dict(polarity=1.0))
env.set("mq.25r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.25r5.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.25r5.b1", knl=["-(acbh25.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a26r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a26r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b26r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b26r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b26r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c26r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.26r5.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.26r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.26r5.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mb.a27r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a27r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.27r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b27r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c27r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c27r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqs.27r5.b1", k1s="kqs.r5b1", extra=dict(polarity=-1.0))
env.set("mq.27r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.27r5.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.27r5.b1", knl=["-(acbh27.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a28r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a28r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b28r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b28r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b28r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c28r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mq.28r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.28r5.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.28r5.b1", ksl=["acbv28.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a29r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a29r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.29r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b29r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c29r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c29r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.29r5.b1", k3="kof.a56b1", extra=dict(polarity=1.0))
env.set("mq.29r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("mss.29r5.b1", k2s="kss.a56b1", extra=dict(polarity=-1.0))
env.set("mcbh.29r5.b1", knl=["-(acbh29.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a30r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a30r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b30r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b30r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b30r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c30r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.30r5.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.30r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.30r5.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.30r5.b1", ksl=["acbv30.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a31r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a31r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.31r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b31r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c31r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c31r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.31r5.b1", k3="kof.a56b1", extra=dict(polarity=1.0))
env.set("mq.31r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.31r5.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.31r5.b1", knl=["-(acbh31.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a32r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a32r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b32r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b32r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b32r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c32r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.32r5.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.32r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.32r5.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.32r5.b1", ksl=["acbv32.r5b1"], extra=dict(polarity=1.0))
env.set("mb.a33r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a33r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.33r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b33r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.c33r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c33r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.33r5.b1", k3="kof.a56b1", extra=dict(polarity=1.0))
env.set("mq.33r5.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("mss.33r5.b1", k2s="kss.a56b1", extra=dict(polarity=-1.0))
env.set("mcbh.33r5.b1", knl=["-(acbh33.r5b1)"], extra=dict(polarity=1.0))
env.set("mco.a34r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a34r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b34r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b34r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.b34r5.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r5.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r5.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c34r5.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.34r5.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.34r5.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.34l6.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.34l6.b1", ksl=["acbv34.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c34l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c34l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.34l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b34l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a34l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a34l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.33l6.b1", k3="kof.a56b1", extra=dict(polarity=1.0))
env.set("mq.33l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("mss.33l6.b1", k2s="kss.a56b1", extra=dict(polarity=-1.0))
env.set("mcbh.33l6.b1", knl=["-(acbh33.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b33l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c33l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b33l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b33l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a33l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a33l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.32l6.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.32l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.32l6.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.32l6.b1", ksl=["acbv32.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c32l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c32l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.32l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b32l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a32l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a32l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.31l6.b1", k3="kof.a56b1", extra=dict(polarity=1.0))
env.set("mq.31l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.31l6.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.31l6.b1", knl=["-(acbh31.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b31l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c31l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b31l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b31l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a31l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a31l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.30l6.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.30l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.30l6.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.30l6.b1", ksl=["acbv30.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c30l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c30l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.30l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b30l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a30l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a30l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.29l6.b1", k3="kof.a56b1", extra=dict(polarity=1.0))
env.set("mq.29l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("mss.29l6.b1", k2s="kss.a56b1", extra=dict(polarity=-1.0))
env.set("mcbh.29l6.b1", knl=["-(acbh29.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b29l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c29l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b29l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b29l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a29l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a29l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.28l6.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.28l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.28l6.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.28l6.b1", ksl=["acbv28.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c28l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c28l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.28l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b28l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a28l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a28l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqs.27l6.b1", k1s="kqs.l6b1", extra=dict(polarity=-1.0))
env.set("mq.27l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.27l6.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.27l6.b1", knl=["-(acbh27.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b27l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c27l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b27l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b27l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a27l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a27l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.26l6.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.26l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.26l6.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.26l6.b1", ksl=["acbv26.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c26l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c26l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.26l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b26l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a26l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a26l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.25l6.b1", k3="kof.a56b1", extra=dict(polarity=1.0))
env.set("mq.25l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.25l6.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.25l6.b1", knl=["-(acbh25.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b25l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c25l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b25l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b25l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a25l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a25l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.24l6.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.24l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.24l6.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.24l6.b1", ksl=["acbv24.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c24l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c24l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.24l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b24l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a24l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a24l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqs.23l6.b1", k1s="kqs.l6b1", extra=dict(polarity=-1.0))
env.set("mq.23l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.23l6.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.23l6.b1", knl=["-(acbh23.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b23l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c23l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b23l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b23l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a23l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a23l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mo.22l6.b1", k3="kod.a56b1", extra=dict(polarity=-1.0))
env.set("mq.22l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.22l6.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.22l6.b1", ksl=["acbv22.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c22l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c22l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.22l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b22l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a22l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a22l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.21l6.b1", k1="kqtf.a56b1", extra=dict(polarity=1.0))
env.set("mq.21l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.21l6.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.21l6.b1", knl=["-(acbh21.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b21l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c21l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b21l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b21l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a21l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a21l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.20l6.b1", k1="kqtd.a56b1", extra=dict(polarity=-1.0))
env.set("mq.20l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.20l6.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.20l6.b1", ksl=["acbv20.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c20l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c20l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.20l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b20l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a20l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a20l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.19l6.b1", k1="kqtf.a56b1", extra=dict(polarity=1.0))
env.set("mq.19l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.19l6.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.19l6.b1", knl=["-(acbh19.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b19l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c19l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b19l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b19l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a19l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a19l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.18l6.b1", k1="kqtd.a56b1", extra=dict(polarity=-1.0))
env.set("mq.18l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.18l6.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.18l6.b1", ksl=["acbv18.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c18l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c18l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.18l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b18l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a18l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a18l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.17l6.b1", k1="kqtf.a56b1", extra=dict(polarity=1.0))
env.set("mq.17l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.17l6.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.17l6.b1", knl=["-(acbh17.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b17l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c17l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b17l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b17l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a17l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a17l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.16l6.b1", k1="kqtd.a56b1", extra=dict(polarity=-1.0))
env.set("mq.16l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.16l6.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.16l6.b1", ksl=["acbv16.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c16l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c16l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.16l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b16l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a16l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a16l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.15l6.b1", k1="kqtf.a56b1", extra=dict(polarity=1.0))
env.set("mq.15l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.15l6.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.15l6.b1", knl=["-(acbh15.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b15l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c15l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b15l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b15l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a15l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a15l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.14l6.b1", k1="kqtd.a56b1", extra=dict(polarity=-1.0))
env.set("mq.14l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.14l6.b1", k2="ksd2.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.14l6.b1", ksl=["acbv14.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c14l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c14l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.14l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b14l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a14l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a14l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.13l6.b1", k1="kqt13.l6b1", extra=dict(polarity=1.0))
env.set("mq.13l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("ms.13l6.b1", k2="ksf1.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.13l6.b1", knl=["-(acbh13.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.b13l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c13l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.b13l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b13l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.a13l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a13l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqt.12l6.b1", k1="kqt12.l6b1", extra=dict(polarity=-1.0))
env.set("mq.12l6.b1", k1="kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.12l6.b1", k2="ksd1.a56b1", extra=dict(polarity=-1.0))
env.set("mcbv.12l6.b1", ksl=["acbv12.l6b1"], extra=dict(polarity=1.0))
env.set("mb.c12l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c12l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mco.12l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b12l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a12l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a12l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mq.11l6.b1", k1="kqf.a56", extra=dict(polarity=1.0))
env.set("mqtli.11l6.b1", k1="kqtl11.l6b1", extra=dict(polarity=1.0))
env.set("ms.11l6.b1", k2="ksf2.a56b1", extra=dict(polarity=1.0))
env.set("mcbh.11l6.b1", knl=["-(acbh11.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.11l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b11l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a11l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a11l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqml.10l6.b1", k1="kq10.l6b1", extra=dict(polarity=-1.0))
env.set("mcbcv.10l6.b1", ksl=["acbcv10.l6b1"], extra=dict(polarity=1.0))
env.set("mco.10l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b10l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a10l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a10l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqmc.9l6.b1", k1="kq9.l6b1", extra=dict(polarity=1.0))
env.set("mqm.9l6.b1", k1="kq9.l6b1", extra=dict(polarity=1.0))
env.set("mcbch.9l6.b1", knl=["-(acbch9.l6b1)"], extra=dict(polarity=1.0))
env.set("mco.9l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b9l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a9l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a9l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqml.8l6.b1", k1="kq8.l6b1", extra=dict(polarity=-1.0))
env.set("mcbcv.8l6.b1", ksl=["acbcv8.l6b1"], extra=dict(polarity=1.0))
env.set("mco.8l6.b1", knl=[0.0, 0.0, 0.0, "kco.a56b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a56b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b8l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mb.a8l6.b1", angle="ab.a56", k0="kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a8l6.b1", k2="kcs.a56b1", extra=dict(polarity=1.0))
env.set("mqy.5l6.b1", k1="kq5.l6b1", extra=dict(polarity=1.0))
env.set("mcbyh.5l6.b1", knl=["-(acbyh5.l6b1)"], extra=dict(polarity=1.0))
env.set("mkd.o5l6.b1", knl=["-(akmkd)"])
env.set("mkd.n5l6.b1", knl=["-(akmkd)"])
env.set("mkd.m5l6.b1", knl=["-(akmkd)"])
env.set("mkd.l5l6.b1", knl=["-(akmkd)"])
env.set("mkd.k5l6.b1", knl=["-(akmkd)"])
env.set("mkd.j5l6.b1", knl=["-(akmkd)"])
env.set("mkd.i5l6.b1", knl=["-(akmkd)"])
env.set("mkd.h5l6.b1", knl=["-(akmkd)"])
env.set("mkd.g5l6.b1", knl=["-(akmkd)"])
env.set("mkd.f5l6.b1", knl=["-(akmkd)"])
env.set("mkd.e5l6.b1", knl=["-(akmkd)"])
env.set("mkd.d5l6.b1", knl=["-(akmkd)"])
env.set("mkd.c5l6.b1", knl=["-(akmkd)"])
env.set("mkd.b5l6.b1", knl=["-(akmkd)"])
env.set("mkd.a5l6.b1", knl=["-(akmkd)"])
env.set("mqy.4l6.b1", k1="kq4.l6b1", extra=dict(polarity=-1.0))
env.set("mcbyv.4l6.b1", ksl=["acbyv4.l6b1"], extra=dict(polarity=1.0))
env.set("msda.e4l6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msda.d4l6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msda.c4l6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msda.b4l6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msda.a4l6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdb.c4l6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdb.b4l6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdb2.4l6.b1", ksl=["-kmsd.lr6b1/2"], extra=dict(polarity=1.0))
env.set("msdb2.4r6.b1", ksl=["-kmsd.lr6b1/2"], extra=dict(polarity=1.0))
env.set("msdb.a4r6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdb.b4r6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdc.a4r6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdc.b4r6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdc.c4r6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdc.d4r6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("msdc.e4r6.b1", ksl=["-kmsd.lr6b1"], extra=dict(polarity=1.0))
env.set("mqy.4r6.b1", k1="kq4.r6b1", extra=dict(polarity=1.0))
env.set("mcbyh.4r6.b1", knl=["-(acbyh4.r6b1)"], extra=dict(polarity=1.0))
env.set("mqy.5r6.b1", k1="kq5.r6b1", extra=dict(polarity=-1.0))
env.set("mcbyv.5r6.b1", ksl=["acbyv5.r6b1"], extra=dict(polarity=1.0))
env.set("mco.8r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a8r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b8r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b8r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqml.8r6.b1", k1="kq8.r6b1", extra=dict(polarity=1.0))
env.set("mcbch.8r6.b1", knl=["-(acbch8.r6b1)"], extra=dict(polarity=1.0))
env.set("mco.9r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a9r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b9r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b9r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqmc.9r6.b1", k1="kq9.r6b1", extra=dict(polarity=-1.0))
env.set("mqm.9r6.b1", k1="kq9.r6b1", extra=dict(polarity=-1.0))
env.set("mcbcv.9r6.b1", ksl=["acbcv9.r6b1"], extra=dict(polarity=1.0))
env.set("mco.10r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a10r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b10r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b10r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqml.10r6.b1", k1="kq10.r6b1", extra=dict(polarity=1.0))
env.set("mcbch.10r6.b1", knl=["-(acbch10.r6b1)"], extra=dict(polarity=1.0))
env.set("mco.11r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a11r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b11r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b11r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mq.11r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("mqtli.11r6.b1", k1="kqtl11.r6b1", extra=dict(polarity=-1.0))
env.set("ms.11r6.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.11r6.b1", ksl=["acbv11.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a12r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a12r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b12r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b12r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b12r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c12r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.12r6.b1", k1="kqt12.r6b1", extra=dict(polarity=1.0))
env.set("mq.12r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.12r6.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.12r6.b1", knl=["-(acbh12.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a13r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a13r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.13r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b13r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c13r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c13r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.13r6.b1", k1="kqt13.r6b1", extra=dict(polarity=-1.0))
env.set("mq.13r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.13r6.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.13r6.b1", ksl=["acbv13.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a14r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a14r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b14r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b14r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b14r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c14r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.14r6.b1", k1="kqtf.a67b1", extra=dict(polarity=1.0))
env.set("mq.14r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.14r6.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.14r6.b1", knl=["-(acbh14.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a15r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a15r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.15r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b15r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c15r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c15r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.15r6.b1", k1="kqtd.a67b1", extra=dict(polarity=-1.0))
env.set("mq.15r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.15r6.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.15r6.b1", ksl=["acbv15.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a16r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a16r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b16r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b16r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b16r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c16r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.16r6.b1", k1="kqtf.a67b1", extra=dict(polarity=1.0))
env.set("mq.16r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.16r6.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.16r6.b1", knl=["-(acbh16.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a17r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a17r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.17r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b17r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c17r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c17r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.17r6.b1", k1="kqtd.a67b1", extra=dict(polarity=-1.0))
env.set("mq.17r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.17r6.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.17r6.b1", ksl=["acbv17.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a18r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a18r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b18r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b18r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b18r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c18r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.18r6.b1", k1="kqtf.a67b1", extra=dict(polarity=1.0))
env.set("mq.18r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.18r6.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.18r6.b1", knl=["-(acbh18.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a19r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a19r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.19r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b19r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c19r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c19r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.19r6.b1", k1="kqtd.a67b1", extra=dict(polarity=-1.0))
env.set("mq.19r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.19r6.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.19r6.b1", ksl=["acbv19.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a20r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a20r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b20r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b20r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b20r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c20r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.20r6.b1", k1="kqtf.a67b1", extra=dict(polarity=1.0))
env.set("mq.20r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.20r6.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.20r6.b1", knl=["-(acbh20.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a21r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a21r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.21r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b21r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c21r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c21r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.21r6.b1", k1="kqtd.a67b1", extra=dict(polarity=-1.0))
env.set("mq.21r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.21r6.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.21r6.b1", ksl=["acbv21.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a22r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a22r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b22r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b22r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b22r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c22r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.22r6.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.22r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.22r6.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.22r6.b1", knl=["-(acbh22.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a23r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a23r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.23r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b23r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c23r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c23r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqs.23r6.b1", k1s="kqs.a67b1", extra=dict(polarity=-1.0))
env.set("mq.23r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.23r6.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.23r6.b1", ksl=["acbv23.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a24r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a24r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b24r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b24r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b24r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c24r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.24r6.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.24r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.24r6.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.24r6.b1", knl=["-(acbh24.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a25r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a25r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.25r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b25r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c25r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c25r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.25r6.b1", k3="kod.a67b1", extra=dict(polarity=-1.0))
env.set("mq.25r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.25r6.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.25r6.b1", ksl=["acbv25.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a26r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a26r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b26r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b26r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b26r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c26r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.26r6.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.26r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.26r6.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.26r6.b1", knl=["-(acbh26.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a27r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a27r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.27r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b27r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c27r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c27r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqs.27r6.b1", k1s="kqs.a67b1", extra=dict(polarity=-1.0))
env.set("mq.27r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.27r6.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.27r6.b1", ksl=["acbv27.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a28r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a28r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b28r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b28r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b28r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c28r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.28r6.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.28r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.28r6.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.28r6.b1", knl=["-(acbh28.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a29r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a29r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.29r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b29r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c29r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c29r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.29r6.b1", k3="kod.a67b1", extra=dict(polarity=-1.0))
env.set("mq.29r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.29r6.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.29r6.b1", ksl=["acbv29.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a30r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a30r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b30r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b30r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b30r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c30r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.30r6.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.30r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("mss.30r6.b1", k2s="kss.a67b1", extra=dict(polarity=-1.0))
env.set("mcbh.30r6.b1", knl=["-(acbh30.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a31r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a31r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.31r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b31r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c31r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c31r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.31r6.b1", k3="kod.a67b1", extra=dict(polarity=-1.0))
env.set("mq.31r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.31r6.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.31r6.b1", ksl=["acbv31.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a32r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a32r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b32r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b32r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b32r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c32r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.32r6.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.32r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.32r6.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.32r6.b1", knl=["-(acbh32.r6b1)"], extra=dict(polarity=1.0))
env.set("mb.a33r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a33r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.33r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b33r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.c33r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c33r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.33r6.b1", k3="kod.a67b1", extra=dict(polarity=-1.0))
env.set("mq.33r6.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.33r6.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.33r6.b1", ksl=["acbv33.r6b1"], extra=dict(polarity=1.0))
env.set("mco.a34r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a34r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b34r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b34r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.b34r6.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r6.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r6.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c34r6.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.34r6.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.34r6.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("mss.34l7.b1", k2s="kss.a67b1", extra=dict(polarity=-1.0))
env.set("mcbh.34l7.b1", knl=["-(acbh34.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c34l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c34l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.34l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b34l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a34l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a34l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.33l7.b1", k3="kod.a67b1", extra=dict(polarity=-1.0))
env.set("mq.33l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.33l7.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.33l7.b1", ksl=["acbv33.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b33l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c33l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b33l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b33l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a33l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a33l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.32l7.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.32l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("mss.32l7.b1", k2s="kss.a67b1", extra=dict(polarity=-1.0))
env.set("mcbh.32l7.b1", knl=["-(acbh32.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c32l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c32l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.32l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b32l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a32l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a32l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.31l7.b1", k3="kod.a67b1", extra=dict(polarity=-1.0))
env.set("mq.31l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.31l7.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.31l7.b1", ksl=["acbv31.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b31l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c31l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b31l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b31l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a31l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a31l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.30l7.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.30l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.30l7.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.30l7.b1", knl=["-(acbh30.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c30l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c30l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.30l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b30l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a30l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a30l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.29l7.b1", k3="kod.a67b1", extra=dict(polarity=-1.0))
env.set("mq.29l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.29l7.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.29l7.b1", ksl=["acbv29.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b29l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c29l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b29l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b29l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a29l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a29l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.28l7.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.28l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("mss.28l7.b1", k2s="kss.a67b1", extra=dict(polarity=-1.0))
env.set("mcbh.28l7.b1", knl=["-(acbh28.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c28l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c28l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.28l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b28l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a28l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a28l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqs.27l7.b1", k1s="kqs.a67b1", extra=dict(polarity=-1.0))
env.set("mq.27l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.27l7.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.27l7.b1", ksl=["acbv27.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b27l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c27l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b27l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b27l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a27l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a27l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.26l7.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.26l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.26l7.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.26l7.b1", knl=["-(acbh26.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c26l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c26l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.26l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b26l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a26l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a26l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.25l7.b1", k3="kod.a67b1", extra=dict(polarity=-1.0))
env.set("mq.25l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.25l7.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.25l7.b1", ksl=["acbv25.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b25l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c25l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b25l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b25l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a25l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a25l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.24l7.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.24l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.24l7.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.24l7.b1", knl=["-(acbh24.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c24l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c24l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.24l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b24l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a24l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a24l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqs.23l7.b1", k1s="kqs.a67b1", extra=dict(polarity=-1.0))
env.set("mq.23l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.23l7.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.23l7.b1", ksl=["acbv23.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b23l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c23l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b23l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b23l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a23l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a23l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mo.22l7.b1", k3="kof.a67b1", extra=dict(polarity=1.0))
env.set("mq.22l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.22l7.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.22l7.b1", knl=["-(acbh22.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c22l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c22l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.22l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b22l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a22l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a22l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.21l7.b1", k1="kqtd.a67b1", extra=dict(polarity=-1.0))
env.set("mq.21l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.21l7.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.21l7.b1", ksl=["acbv21.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b21l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c21l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b21l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b21l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a21l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a21l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.20l7.b1", k1="kqtf.a67b1", extra=dict(polarity=1.0))
env.set("mq.20l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.20l7.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.20l7.b1", knl=["-(acbh20.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c20l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c20l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.20l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b20l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a20l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a20l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.19l7.b1", k1="kqtd.a67b1", extra=dict(polarity=-1.0))
env.set("mq.19l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.19l7.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.19l7.b1", ksl=["acbv19.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b19l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c19l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b19l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b19l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a19l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a19l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.18l7.b1", k1="kqtf.a67b1", extra=dict(polarity=1.0))
env.set("mq.18l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.18l7.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.18l7.b1", knl=["-(acbh18.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c18l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c18l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.18l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b18l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a18l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a18l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.17l7.b1", k1="kqtd.a67b1", extra=dict(polarity=-1.0))
env.set("mq.17l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.17l7.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.17l7.b1", ksl=["acbv17.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b17l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c17l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b17l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b17l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a17l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a17l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.16l7.b1", k1="kqtf.a67b1", extra=dict(polarity=1.0))
env.set("mq.16l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.16l7.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.16l7.b1", knl=["-(acbh16.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c16l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c16l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.16l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b16l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a16l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a16l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.15l7.b1", k1="kqtd.a67b1", extra=dict(polarity=-1.0))
env.set("mq.15l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.15l7.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.15l7.b1", ksl=["acbv15.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b15l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c15l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b15l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b15l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a15l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a15l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.14l7.b1", k1="kqtf.a67b1", extra=dict(polarity=1.0))
env.set("mq.14l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.14l7.b1", k2="ksf2.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.14l7.b1", knl=["-(acbh14.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c14l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c14l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.14l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b14l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a14l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a14l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.13l7.b1", k1="kqt13.l7b1", extra=dict(polarity=-1.0))
env.set("mq.13l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.13l7.b1", k2="ksd1.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.13l7.b1", ksl=["acbv13.l7b1"], extra=dict(polarity=1.0))
env.set("mco.b13l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c13l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.b13l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b13l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.a13l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a13l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mqt.12l7.b1", k1="kqt12.l7b1", extra=dict(polarity=1.0))
env.set("mq.12l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("ms.12l7.b1", k2="ksf1.a67b1", extra=dict(polarity=1.0))
env.set("mcbh.12l7.b1", knl=["-(acbh12.l7b1)"], extra=dict(polarity=1.0))
env.set("mb.c12l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c12l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mco.12l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b12l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a12l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a12l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mq.11l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("mqtli.11l7.b1", k1="kqtl11.l7b1", extra=dict(polarity=-1.0))
env.set("ms.11l7.b1", k2="ksd2.a67b1", extra=dict(polarity=-1.0))
env.set("mcbv.11l7.b1", ksl=["acbv11.l7b1"], extra=dict(polarity=1.0))
env.set("mco.11l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b11l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a11l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a11l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mq.10l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("mqtli.10l7.b1", k1="kqtl10.l7b1", extra=dict(polarity=1.0))
env.set("mcbch.10l7.b1", knl=["-(acbch10.l7b1)"], extra=dict(polarity=1.0))
env.set("mco.10l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b10l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a10l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a10l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mq.9l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("mqtli.b9l7.b1", k1="kqtl9.l7b1", extra=dict(polarity=-1.0))
env.set("mqtli.a9l7.b1", k1="kqtl9.l7b1", extra=dict(polarity=-1.0))
env.set("mcbcv.9l7.b1", ksl=["acbcv9.l7b1"], extra=dict(polarity=1.0))
env.set("mco.9l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b9l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a9l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a9l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mq.8l7.b1", k1="kqf.a67", extra=dict(polarity=1.0))
env.set("mqtli.8l7.b1", k1="kqtl8.l7b1", extra=dict(polarity=1.0))
env.set("mcbch.8l7.b1", knl=["-(acbch8.l7b1)"], extra=dict(polarity=1.0))
env.set("mco.8l7.b1", knl=[0.0, 0.0, 0.0, "kco.a67b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a67b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b8l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mb.a8l7.b1", angle="ab.a67", k0="kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a8l7.b1", k2="kcs.a67b1", extra=dict(polarity=1.0))
env.set("mq.7l7.b1", k1="kqd.a67", extra=dict(polarity=-1.0))
env.set("mqtli.7l7.b1", k1="kqtl7.l7b1", extra=dict(polarity=-1.0))
env.set("mcbcv.7l7.b1", ksl=["acbcv7.l7b1"], extra=dict(polarity=1.0))
env.set("mqtlh.f6l7.b1", k1="kq6.l7b1", extra=dict(polarity=1.0))
env.set("mqtlh.e6l7.b1", k1="kq6.l7b1", extra=dict(polarity=1.0))
env.set("mqtlh.d6l7.b1", k1="kq6.l7b1", extra=dict(polarity=1.0))
env.set("mqtlh.c6l7.b1", k1="kq6.l7b1", extra=dict(polarity=1.0))
env.set("mqtlh.b6l7.b1", k1="kq6.l7b1", extra=dict(polarity=1.0))
env.set("mqtlh.a6l7.b1", k1="kq6.l7b1", extra=dict(polarity=1.0))
env.set("mcbch.6l7.b1", knl=["-(acbch6.l7b1)"], extra=dict(polarity=1.0))
env.set("mbw.d6l7.b1", angle="-ad34.lr7", k0="-kd34.lr7", extra=dict(polarity=-1.0))
env.set("mbw.c6l7.b1", angle="-ad34.lr7", k0="-kd34.lr7", extra=dict(polarity=-1.0))
env.set("mbw.b6l7.b1", angle="ad34.lr7", k0="kd34.lr7", extra=dict(polarity=1.0))
env.set("mbw.a6l7.b1", angle="ad34.lr7", k0="kd34.lr7", extra=dict(polarity=1.0))
env.set("mqwa.d5l7.b1", k1="kq5.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.c5l7.b1", k1="kq5.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.f5l7.b1", k1="kq5.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.b5l7.b1", k1="kq5.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.a5l7.b1", k1="kq5.lr7", extra=dict(polarity=-1.0))
env.set("mcbwv.5l7.b1", ksl=["acbwv5.l7b1"], extra=dict(polarity=1.0))
env.set("mqwa.e4l7.b1", k1="kq4.lr7", extra=dict(polarity=1.0))
env.set("mqwa.d4l7.b1", k1="kq4.lr7", extra=dict(polarity=1.0))
env.set("mqwa.c4l7.b1", k1="kq4.lr7", extra=dict(polarity=1.0))
env.set("mqwb.4l7.b1", k1="kqt4.l7", extra=dict(polarity=1.0))
env.set("mqwa.b4l7.b1", k1="kq4.lr7", extra=dict(polarity=1.0))
env.set("mqwa.a4l7.b1", k1="kq4.lr7", extra=dict(polarity=1.0))
env.set("mcbwh.4l7.b1", knl=["-(acbwh4.l7b1)"], extra=dict(polarity=1.0))
env.set("mcbwv.4r7.b1", ksl=["acbwv4.r7b1"], extra=dict(polarity=1.0))
env.set("mqwa.a4r7.b1", k1="-kq4.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.b4r7.b1", k1="-kq4.lr7", extra=dict(polarity=-1.0))
env.set("mqwb.4r7.b1", k1="kqt4.r7", extra=dict(polarity=-1.0))
env.set("mqwa.c4r7.b1", k1="-kq4.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.d4r7.b1", k1="-kq4.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.e4r7.b1", k1="-kq4.lr7", extra=dict(polarity=-1.0))
env.set("mcbwh.5r7.b1", knl=["-(acbwh5.r7b1)"], extra=dict(polarity=1.0))
env.set("mqwa.a5r7.b1", k1="-kq5.lr7", extra=dict(polarity=1.0))
env.set("mqwa.b5r7.b1", k1="-kq5.lr7", extra=dict(polarity=1.0))
env.set("mqwa.f5r7.b1", k1="-kq5.lr7", extra=dict(polarity=1.0))
env.set("mqwa.c5r7.b1", k1="-kq5.lr7", extra=dict(polarity=1.0))
env.set("mqwa.d5r7.b1", k1="-kq5.lr7", extra=dict(polarity=1.0))
env.set("mbw.a6r7.b1", angle="ad34.lr7", k0="kd34.lr7", extra=dict(polarity=1.0))
env.set("mbw.b6r7.b1", angle="ad34.lr7", k0="kd34.lr7", extra=dict(polarity=1.0))
env.set("mbw.c6r7.b1", angle="-ad34.lr7", k0="-kd34.lr7", extra=dict(polarity=-1.0))
env.set("mbw.d6r7.b1", angle="-ad34.lr7", k0="-kd34.lr7", extra=dict(polarity=-1.0))
env.set("mqtlh.a6r7.b1", k1="kq6.r7b1", extra=dict(polarity=-1.0))
env.set("mqtlh.b6r7.b1", k1="kq6.r7b1", extra=dict(polarity=-1.0))
env.set("mqtlh.c6r7.b1", k1="kq6.r7b1", extra=dict(polarity=-1.0))
env.set("mqtlh.d6r7.b1", k1="kq6.r7b1", extra=dict(polarity=-1.0))
env.set("mqtlh.e6r7.b1", k1="kq6.r7b1", extra=dict(polarity=-1.0))
env.set("mqtlh.f6r7.b1", k1="kq6.r7b1", extra=dict(polarity=-1.0))
env.set("mcbcv.6r7.b1", ksl=["acbcv6.r7b1"], extra=dict(polarity=1.0))
env.set("mq.7r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("mqtli.7r7.b1", k1="kqtl7.r7b1", extra=dict(polarity=1.0))
env.set("mcbch.7r7.b1", knl=["-(acbch7.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.8r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a8r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b8r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b8r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mq.8r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("mqtli.8r7.b1", k1="kqtl8.r7b1", extra=dict(polarity=-1.0))
env.set("mcbcv.8r7.b1", ksl=["acbcv8.r7b1"], extra=dict(polarity=1.0))
env.set("mcd.9r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a9r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b9r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b9r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mq.9r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("mqtli.a9r7.b1", k1="kqtl9.r7b1", extra=dict(polarity=1.0))
env.set("mqtli.b9r7.b1", k1="kqtl9.r7b1", extra=dict(polarity=1.0))
env.set("mcbch.9r7.b1", knl=["-(acbch9.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.10r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a10r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b10r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b10r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mq.10r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("mqtli.10r7.b1", k1="kqtl10.r7b1", extra=dict(polarity=-1.0))
env.set("mcbcv.10r7.b1", ksl=["acbcv10.r7b1"], extra=dict(polarity=1.0))
env.set("mcd.11r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a11r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b11r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b11r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mq.11r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("mqtli.11r7.b1", k1="kqtl11.r7b1", extra=dict(polarity=1.0))
env.set("ms.11r7.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.11r7.b1", knl=["-(acbh11.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a12r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a12r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b12r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b12r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b12r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c12r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.12r7.b1", k1="kqt12.r7b1", extra=dict(polarity=-1.0))
env.set("mq.12r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.12r7.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.12r7.b1", ksl=["acbv12.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a13r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a13r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.13r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b13r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c13r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c13r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.13r7.b1", k1="kqt13.r7b1", extra=dict(polarity=1.0))
env.set("mq.13r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.13r7.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.13r7.b1", knl=["-(acbh13.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a14r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a14r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b14r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b14r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b14r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c14r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.14r7.b1", k1="kqtd.a78b1", extra=dict(polarity=-1.0))
env.set("mq.14r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.14r7.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.14r7.b1", ksl=["acbv14.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a15r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a15r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.15r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b15r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c15r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c15r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.15r7.b1", k1="kqtf.a78b1", extra=dict(polarity=1.0))
env.set("mq.15r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.15r7.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.15r7.b1", knl=["-(acbh15.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a16r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a16r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b16r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b16r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b16r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c16r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.16r7.b1", k1="kqtd.a78b1", extra=dict(polarity=-1.0))
env.set("mq.16r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.16r7.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.16r7.b1", ksl=["acbv16.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a17r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a17r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.17r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b17r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c17r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c17r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.17r7.b1", k1="kqtf.a78b1", extra=dict(polarity=1.0))
env.set("mq.17r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.17r7.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.17r7.b1", knl=["-(acbh17.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a18r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a18r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b18r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b18r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b18r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c18r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.18r7.b1", k1="kqtd.a78b1", extra=dict(polarity=-1.0))
env.set("mq.18r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.18r7.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.18r7.b1", ksl=["acbv18.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a19r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a19r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.19r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b19r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c19r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c19r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.19r7.b1", k1="kqtf.a78b1", extra=dict(polarity=1.0))
env.set("mq.19r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.19r7.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.19r7.b1", knl=["-(acbh19.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a20r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a20r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b20r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b20r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b20r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c20r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.20r7.b1", k1="kqtd.a78b1", extra=dict(polarity=-1.0))
env.set("mq.20r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.20r7.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.20r7.b1", ksl=["acbv20.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a21r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a21r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.21r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b21r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c21r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c21r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.21r7.b1", k1="kqtf.a78b1", extra=dict(polarity=1.0))
env.set("mq.21r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.21r7.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.21r7.b1", knl=["-(acbh21.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a22r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a22r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b22r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b22r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b22r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c22r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.22r7.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.22r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.22r7.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.22r7.b1", ksl=["acbv22.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a23r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a23r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.23r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b23r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c23r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c23r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqs.23r7.b1", k1s="kqs.r7b1", extra=dict(polarity=-1.0))
env.set("mq.23r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.23r7.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.23r7.b1", knl=["-(acbh23.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a24r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a24r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b24r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b24r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b24r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c24r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.24r7.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.24r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.24r7.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.24r7.b1", ksl=["acbv24.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a25r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a25r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.25r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b25r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c25r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c25r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.25r7.b1", k3="kof.a78b1", extra=dict(polarity=1.0))
env.set("mq.25r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.25r7.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.25r7.b1", knl=["-(acbh25.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a26r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a26r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b26r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b26r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b26r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c26r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.26r7.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.26r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.26r7.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.26r7.b1", ksl=["acbv26.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a27r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a27r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.27r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b27r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c27r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c27r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqs.27r7.b1", k1s="kqs.r7b1", extra=dict(polarity=-1.0))
env.set("mq.27r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.27r7.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.27r7.b1", knl=["-(acbh27.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a28r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a28r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b28r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b28r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b28r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c28r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.28r7.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.28r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.28r7.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.28r7.b1", ksl=["acbv28.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a29r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a29r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.29r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b29r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c29r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c29r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.29r7.b1", k3="kof.a78b1", extra=dict(polarity=1.0))
env.set("mq.29r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("mss.29r7.b1", k2s="kss.a78b1", extra=dict(polarity=-1.0))
env.set("mcbh.29r7.b1", knl=["-(acbh29.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a30r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a30r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b30r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b30r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b30r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c30r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.30r7.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.30r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.30r7.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.30r7.b1", ksl=["acbv30.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a31r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a31r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.31r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b31r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c31r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c31r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.31r7.b1", k3="kof.a78b1", extra=dict(polarity=1.0))
env.set("mq.31r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.31r7.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a32r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a32r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b32r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b32r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b32r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c32r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.32r7.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.32r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.32r7.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.32r7.b1", ksl=["acbv32.r7b1"], extra=dict(polarity=1.0))
env.set("mb.a33r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a33r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.33r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b33r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.c33r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c33r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.33r7.b1", k3="kof.a78b1", extra=dict(polarity=1.0))
env.set("mq.33r7.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("mss.33r7.b1", k2s="kss.a78b1", extra=dict(polarity=-1.0))
env.set("mcbh.33r7.b1", knl=["-(acbh33.r7b1)"], extra=dict(polarity=1.0))
env.set("mcd.a34r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a34r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b34r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b34r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.b34r7.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r7.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c34r7.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.34r7.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.34r7.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.34l8.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.34l8.b1", ksl=["acbv34.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c34l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c34l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.34l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b34l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a34l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a34l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.33l8.b1", k3="kof.a78b1", extra=dict(polarity=1.0))
env.set("mq.33l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("mss.33l8.b1", k2s="kss.a78b1", extra=dict(polarity=-1.0))
env.set("mcbh.33l8.b1", knl=["-(acbh33.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b33l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c33l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b33l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b33l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a33l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a33l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.32l8.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.32l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.32l8.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.32l8.b1", ksl=["acbv32.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c32l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c32l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.32l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b32l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a32l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a32l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.31l8.b1", k3="kof.a78b1", extra=dict(polarity=1.0))
env.set("mq.31l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.31l8.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.31l8.b1", knl=["-(acbh31.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b31l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c31l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b31l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b31l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a31l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a31l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.30l8.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.30l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.30l8.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.30l8.b1", ksl=["acbv30.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c30l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c30l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.30l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b30l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a30l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a30l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.29l8.b1", k3="kof.a78b1", extra=dict(polarity=1.0))
env.set("mq.29l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("mss.29l8.b1", k2s="kss.a78b1", extra=dict(polarity=-1.0))
env.set("mcbh.29l8.b1", knl=["-(acbh29.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b29l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c29l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b29l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b29l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a29l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a29l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.28l8.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.28l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.28l8.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.28l8.b1", ksl=["acbv28.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c28l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c28l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.28l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b28l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a28l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a28l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqs.27l8.b1", k1s="kqs.l8b1", extra=dict(polarity=-1.0))
env.set("mq.27l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.27l8.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.27l8.b1", knl=["-(acbh27.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b27l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c27l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b27l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b27l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a27l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a27l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.26l8.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.26l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.26l8.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.26l8.b1", ksl=["acbv26.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c26l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c26l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.26l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b26l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a26l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a26l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.25l8.b1", k3="kof.a78b1", extra=dict(polarity=1.0))
env.set("mq.25l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.25l8.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.25l8.b1", knl=["-(acbh25.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b25l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c25l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b25l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b25l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a25l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a25l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.24l8.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.24l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.24l8.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.24l8.b1", ksl=["acbv24.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c24l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c24l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.24l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b24l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a24l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a24l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqs.23l8.b1", k1s="kqs.l8b1", extra=dict(polarity=-1.0))
env.set("mq.23l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.23l8.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.23l8.b1", knl=["-(acbh23.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b23l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c23l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b23l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b23l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a23l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a23l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mo.22l8.b1", k3="kod.a78b1", extra=dict(polarity=-1.0))
env.set("mq.22l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.22l8.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.22l8.b1", ksl=["acbv22.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c22l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c22l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.22l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b22l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a22l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a22l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.21l8.b1", k1="kqtf.a78b1", extra=dict(polarity=1.0))
env.set("mq.21l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.21l8.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.21l8.b1", knl=["-(acbh21.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b21l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c21l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b21l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b21l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a21l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a21l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.20l8.b1", k1="kqtd.a78b1", extra=dict(polarity=-1.0))
env.set("mq.20l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.20l8.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.20l8.b1", ksl=["acbv20.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c20l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c20l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.20l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b20l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a20l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a20l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.19l8.b1", k1="kqtf.a78b1", extra=dict(polarity=1.0))
env.set("mq.19l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.19l8.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.19l8.b1", knl=["-(acbh19.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b19l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c19l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b19l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b19l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a19l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a19l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.18l8.b1", k1="kqtd.a78b1", extra=dict(polarity=-1.0))
env.set("mq.18l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.18l8.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.18l8.b1", ksl=["acbv18.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c18l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c18l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.18l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b18l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a18l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a18l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.17l8.b1", k1="kqtf.a78b1", extra=dict(polarity=1.0))
env.set("mq.17l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.17l8.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.17l8.b1", knl=["-(acbh17.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b17l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c17l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b17l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b17l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a17l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a17l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.16l8.b1", k1="kqtd.a78b1", extra=dict(polarity=-1.0))
env.set("mq.16l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.16l8.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.16l8.b1", ksl=["acbv16.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c16l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c16l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.16l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b16l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a16l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a16l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.15l8.b1", k1="kqtf.a78b1", extra=dict(polarity=1.0))
env.set("mq.15l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.15l8.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.15l8.b1", knl=["-(acbh15.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b15l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c15l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b15l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b15l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a15l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a15l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.14l8.b1", k1="kqtd.a78b1", extra=dict(polarity=-1.0))
env.set("mq.14l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.14l8.b1", k2="ksd2.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.14l8.b1", ksl=["acbv14.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c14l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c14l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.14l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b14l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a14l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a14l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.13l8.b1", k1="kqt13.l8b1", extra=dict(polarity=1.0))
env.set("mq.13l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("ms.13l8.b1", k2="ksf1.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.13l8.b1", knl=["-(acbh13.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.b13l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c13l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.b13l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b13l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.a13l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a13l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqt.12l8.b1", k1="kqt12.l8b1", extra=dict(polarity=-1.0))
env.set("mq.12l8.b1", k1="kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.12l8.b1", k2="ksd1.a78b1", extra=dict(polarity=-1.0))
env.set("mcbv.12l8.b1", ksl=["acbv12.l8b1"], extra=dict(polarity=1.0))
env.set("mb.c12l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c12l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mcd.12l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b12l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a12l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a12l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mq.11l8.b1", k1="kqf.a78", extra=dict(polarity=1.0))
env.set("mqtli.11l8.b1", k1="kqtl11.l8b1", extra=dict(polarity=1.0))
env.set("ms.11l8.b1", k2="ksf2.a78b1", extra=dict(polarity=1.0))
env.set("mcbh.11l8.b1", knl=["-(acbh11.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.11l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b11l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a11l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a11l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqml.10l8.b1", k1="kq10.l8b1", extra=dict(polarity=-1.0))
env.set("mcbcv.10l8.b1", ksl=["acbcv10.l8b1"], extra=dict(polarity=1.0))
env.set("mcd.10l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b10l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a10l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a10l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqmc.9l8.b1", k1="kq9.l8b1", extra=dict(polarity=1.0))
env.set("mqm.9l8.b1", k1="kq9.l8b1", extra=dict(polarity=1.0))
env.set("mcbch.9l8.b1", knl=["-(acbch9.l8b1)"], extra=dict(polarity=1.0))
env.set("mcd.9l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b9l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a9l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a9l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqml.8l8.b1", k1="kq8.l8b1", extra=dict(polarity=-1.0))
env.set("mcbcv.8l8.b1", ksl=["acbcv8.l8b1"], extra=dict(polarity=1.0))
env.set("mcd.8l8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a78b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b8l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mb.a8l8.b1", angle="ab.a78", k0="kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a8l8.b1", k2="kcs.a78b1", extra=dict(polarity=1.0))
env.set("mqm.b7l8.b1", k1="kq7.l8b1", extra=dict(polarity=1.0))
env.set("mqm.a7l8.b1", k1="kq7.l8b1", extra=dict(polarity=1.0))
env.set("mcbch.7l8.b1", knl=["-(acbch7.l8b1)"], extra=dict(polarity=1.0))
env.set("mcbcv.6l8.b1", ksl=["acbcv6.l8b1"], extra=dict(polarity=1.0))
env.set("mqml.6l8.b1", k1="kq6.l8b1", extra=dict(polarity=-1.0))
env.set("mqm.6l8.b1", k1="kq6.l8b1", extra=dict(polarity=-1.0))
env.set("mcbch.b5l8.b1", knl=["-(acbchs5.l8b1)"], extra=dict(polarity=1.0))
env.set("mcbcv.5l8.b1", ksl=["acbcvs5.l8b1"], extra=dict(polarity=1.0))
env.set("mcbch.a5l8.b1", knl=["-(acbch5.l8b1)"], extra=dict(polarity=1.0))
env.set("mqm.b5l8.b1", k1="kq5.l8b1", extra=dict(polarity=1.0))
env.set("mqm.a5l8.b1", k1="kq5.l8b1", extra=dict(polarity=1.0))
env.set("mqy.b4l8.b1", k1="kq4.l8b1", extra=dict(polarity=-1.0))
env.set("mqy.a4l8.b1", k1="kq4.l8b1", extra=dict(polarity=-1.0))
env.set("mcbyv.b4l8.b1", ksl=["acbyv4.l8b1"], extra=dict(polarity=1.0))
env.set("mcbyh.4l8.b1", knl=["-(acbyhs4.l8b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.a4l8.b1", ksl=["acbyvs4.l8b1"], extra=dict(polarity=1.0))
env.set("mbrc.4l8.b1", angle="ad2.l8", k0="kd2.l8", extra=dict(polarity=1.0))
env.set("mbx.4l8", angle="-ad1.l8", k0="-kd1.l8", extra=dict(polarity=-1.0))
env.set("mcosx.3l8", ksl=[0.0, 0.0, 0.0, "kcosx3.l8*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3l8", knl=[0.0, 0.0, 0.0, "kcox3.l8*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3l8", ksl=[0.0, 0.0, "kcssx3.l8*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mcbxh.3l8", knl=["-(acbxh3.l8)"], extra=dict(polarity=1.0))
env.set("mcbxv.3l8", ksl=["acbxv3.l8"], extra=dict(polarity=1.0))
env.set("mcsx.3l8", knl=[0.0, 0.0, "kcsx3.l8*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3l8", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.l8*l.mctx"], extra=dict(polarity=1.0))
env.set("mqxa.3l8", k1="kqx.l8", extra=dict(polarity=1.0))
env.set("mqsx.3l8", k1s="kqsx3.l8", extra=dict(polarity=-1.0))
env.set("mqxb.b2l8", k1="-kqx.l8-ktqx2.l8", extra=dict(polarity=-1.0))
env.set("mcbxh.2l8", knl=["-(acbxh2.l8)"], extra=dict(polarity=1.0))
env.set("mcbxv.2l8", ksl=["acbxv2.l8"], extra=dict(polarity=1.0))
env.set("mqxb.a2l8", k1="-kqx.l8-ktqx2.l8", extra=dict(polarity=-1.0))
env.set("mcbxh.1l8", knl=["-(acbxh1.l8)"], extra=dict(polarity=1.0))
env.set("mcbxv.1l8", ksl=["acbxv1.l8"], extra=dict(polarity=1.0))
env.set("mqxa.1l8", k1="kqx.l8+ktqx1.l8", extra=dict(polarity=1.0))
env.set("mbxws.1l8", rot_s_rad=0.013405855024372, ksl=["abxws.l8"], extra=dict(polarity=1.0))
env.set("mbxwh.1l8", rot_s_rad=0.013405855024372, knl=["-(abxwh.l8)"], extra=dict(polarity=1.0))
env.set("mblw.1r8", rot_s_rad=0.013405855024372, ksl=["ablw.r8"], extra=dict(polarity=1.0))
env.set("mbxws.1r8", rot_s_rad=0.013405855024372, ksl=["abxws.r8"], extra=dict(polarity=1.0))
env.set("mqxa.1r8", k1="kqx.r8+ktqx1.r8", extra=dict(polarity=-1.0))
env.set("mcbxh.1r8", knl=["-(acbxh1.r8)"], extra=dict(polarity=1.0))
env.set("mcbxv.1r8", ksl=["acbxv1.r8"], extra=dict(polarity=1.0))
env.set("mqxb.a2r8", k1="-kqx.r8-ktqx2.r8", extra=dict(polarity=1.0))
env.set("mcbxh.2r8", knl=["-(acbxh2.r8)"], extra=dict(polarity=1.0))
env.set("mcbxv.2r8", ksl=["acbxv2.r8"], extra=dict(polarity=1.0))
env.set("mqxb.b2r8", k1="-kqx.r8-ktqx2.r8", extra=dict(polarity=1.0))
env.set("mqsx.3r8", k1s="kqsx3.r8", extra=dict(polarity=-1.0))
env.set("mqxa.3r8", k1="kqx.r8", extra=dict(polarity=-1.0))
env.set("mcbxh.3r8", knl=["-(acbxh3.r8)"], extra=dict(polarity=1.0))
env.set("mcbxv.3r8", ksl=["acbxv3.r8"], extra=dict(polarity=1.0))
env.set("mcsx.3r8", knl=[0.0, 0.0, "kcsx3.r8*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3r8", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.r8*l.mctx"], extra=dict(polarity=1.0))
env.set("mcosx.3r8", ksl=[0.0, 0.0, 0.0, "kcosx3.r8*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3r8", knl=[0.0, 0.0, 0.0, "kcox3.r8*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3r8", ksl=[0.0, 0.0, "kcssx3.r8*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mbx.4r8", angle="ad1.r8", k0="kd1.r8", extra=dict(polarity=1.0))
env.set("mbrc.4r8.b1", angle="-ad2.r8", k0="-kd2.r8", extra=dict(polarity=-1.0))
env.set("mcbyh.a4r8.b1", knl=["-(acbyhs4.r8b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.4r8.b1", ksl=["acbyvs4.r8b1"], extra=dict(polarity=1.0))
env.set("mcbyh.b4r8.b1", knl=["-(acbyh4.r8b1)"], extra=dict(polarity=1.0))
env.set("mqy.a4r8.b1", k1="kq4.r8b1", extra=dict(polarity=1.0))
env.set("mqy.b4r8.b1", k1="kq4.r8b1", extra=dict(polarity=1.0))
env.set("mqy.a5r8.b1", k1="kq5.r8b1", extra=dict(polarity=-1.0))
env.set("mqy.b5r8.b1", k1="kq5.r8b1", extra=dict(polarity=-1.0))
env.set("mcbyv.a5r8.b1", ksl=["acbyv5.r8b1"], extra=dict(polarity=1.0))
env.set("mcbyh.5r8.b1", knl=["-(acbyhs5.r8b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.b5r8.b1", ksl=["acbyvs5.r8b1"], extra=dict(polarity=1.0))
env.set("msia.a6r8.b1", knl=["-(akmsia.r8b1)"], extra=dict(polarity=1.0))
env.set("msia.b6r8.b1", knl=["-(akmsia.r8b1)"], extra=dict(polarity=1.0))
env.set("msib.a6r8.b1", knl=["-(akmsib.r8b1)"], extra=dict(polarity=1.0))
env.set("msib.b6r8.b1", knl=["-(akmsib.r8b1)"], extra=dict(polarity=1.0))
env.set("msib.c6r8.b1", knl=["-(akmsib.r8b1)"], extra=dict(polarity=1.0))
env.set("mcbch.6r8.b1", knl=["-(acbch6.r8b1)"], extra=dict(polarity=1.0))
env.set("mqml.6r8.b1", k1="kq6.r8b1", extra=dict(polarity=1.0))
env.set("mqm.6r8.b1", k1="kq6.r8b1", extra=dict(polarity=1.0))
env.set("mqm.a7r8.b1", k1="kq7.r8b1", extra=dict(polarity=-1.0))
env.set("mqm.b7r8.b1", k1="kq7.r8b1", extra=dict(polarity=-1.0))
env.set("mcbcv.7r8.b1", ksl=["acbcv7.r8b1"], extra=dict(polarity=1.0))
env.set("mco.8r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a8r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b8r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b8r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqml.8r8.b1", k1="kq8.r8b1", extra=dict(polarity=1.0))
env.set("mcbch.8r8.b1", knl=["-(acbch8.r8b1)"], extra=dict(polarity=1.0))
env.set("mco.9r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a9r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b9r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b9r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqmc.9r8.b1", k1="kq9.r8b1", extra=dict(polarity=-1.0))
env.set("mqm.9r8.b1", k1="kq9.r8b1", extra=dict(polarity=-1.0))
env.set("mcbcv.9r8.b1", ksl=["acbcv9.r8b1"], extra=dict(polarity=1.0))
env.set("mco.10r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a10r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b10r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b10r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqml.10r8.b1", k1="kq10.r8b1", extra=dict(polarity=1.0))
env.set("mcbch.10r8.b1", knl=["-(acbch10.r8b1)"], extra=dict(polarity=1.0))
env.set("mco.11r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a11r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b11r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b11r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mq.11r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("mqtli.11r8.b1", k1="kqtl11.r8b1", extra=dict(polarity=-1.0))
env.set("ms.11r8.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.11r8.b1", ksl=["acbv11.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a12r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a12r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b12r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b12r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b12r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c12r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.12r8.b1", k1="kqt12.r8b1", extra=dict(polarity=1.0))
env.set("mq.12r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.12r8.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.12r8.b1", knl=["-(acbh12.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a13r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a13r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.13r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b13r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c13r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c13r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.13r8.b1", k1="kqt13.r8b1", extra=dict(polarity=-1.0))
env.set("mq.13r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.13r8.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.13r8.b1", ksl=["acbv13.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a14r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a14r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b14r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b14r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b14r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c14r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.14r8.b1", k1="kqtf.a81b1", extra=dict(polarity=1.0))
env.set("mq.14r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.14r8.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.14r8.b1", knl=["-(acbh14.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a15r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a15r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.15r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b15r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c15r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c15r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.15r8.b1", k1="kqtd.a81b1", extra=dict(polarity=-1.0))
env.set("mq.15r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.15r8.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.15r8.b1", ksl=["acbv15.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a16r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a16r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b16r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b16r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b16r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c16r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.16r8.b1", k1="kqtf.a81b1", extra=dict(polarity=1.0))
env.set("mq.16r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.16r8.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.16r8.b1", knl=["-(acbh16.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a17r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a17r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.17r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b17r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c17r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c17r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.17r8.b1", k1="kqtd.a81b1", extra=dict(polarity=-1.0))
env.set("mq.17r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.17r8.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.17r8.b1", ksl=["acbv17.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a18r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a18r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b18r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b18r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b18r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c18r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.18r8.b1", k1="kqtf.a81b1", extra=dict(polarity=1.0))
env.set("mq.18r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.18r8.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.18r8.b1", knl=["-(acbh18.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a19r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a19r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.19r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b19r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c19r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c19r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.19r8.b1", k1="kqtd.a81b1", extra=dict(polarity=-1.0))
env.set("mq.19r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.19r8.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.19r8.b1", ksl=["acbv19.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a20r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a20r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b20r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b20r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b20r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c20r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.20r8.b1", k1="kqtf.a81b1", extra=dict(polarity=1.0))
env.set("mq.20r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.20r8.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.20r8.b1", knl=["-(acbh20.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a21r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a21r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.21r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b21r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c21r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c21r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.21r8.b1", k1="kqtd.a81b1", extra=dict(polarity=-1.0))
env.set("mq.21r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.21r8.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.21r8.b1", ksl=["acbv21.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a22r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a22r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b22r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b22r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b22r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c22r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.22r8.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.22r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.22r8.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.22r8.b1", knl=["-(acbh22.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a23r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a23r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.23r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b23r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c23r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c23r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqs.23r8.b1", k1s="kqs.a81b1", extra=dict(polarity=-1.0))
env.set("mq.23r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.23r8.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.23r8.b1", ksl=["acbv23.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a24r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a24r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b24r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b24r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b24r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c24r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.24r8.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.24r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.24r8.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.24r8.b1", knl=["-(acbh24.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a25r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a25r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.25r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b25r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c25r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c25r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.25r8.b1", k3="kod.a81b1", extra=dict(polarity=-1.0))
env.set("mq.25r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.25r8.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.25r8.b1", ksl=["acbv25.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a26r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a26r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b26r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b26r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b26r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c26r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.26r8.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.26r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.26r8.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.26r8.b1", knl=["-(acbh26.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a27r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a27r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.27r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b27r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c27r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c27r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqs.27r8.b1", k1s="kqs.a81b1", extra=dict(polarity=-1.0))
env.set("mq.27r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.27r8.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.27r8.b1", ksl=["acbv27.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a28r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a28r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b28r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b28r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b28r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c28r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.28r8.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.28r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.28r8.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.28r8.b1", knl=["-(acbh28.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a29r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a29r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.29r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b29r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c29r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c29r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.29r8.b1", k3="kod.a81b1", extra=dict(polarity=-1.0))
env.set("mq.29r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.29r8.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.29r8.b1", ksl=["acbv29.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a30r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a30r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b30r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b30r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b30r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c30r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.30r8.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.30r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("mss.30r8.b1", k2s="kss.a81b1", extra=dict(polarity=-1.0))
env.set("mcbh.30r8.b1", knl=["-(acbh30.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a31r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a31r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.31r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b31r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c31r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c31r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.31r8.b1", k3="kod.a81b1", extra=dict(polarity=-1.0))
env.set("mq.31r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.31r8.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.31r8.b1", ksl=["acbv31.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a32r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a32r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b32r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b32r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b32r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c32r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.32r8.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.32r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.32r8.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.32r8.b1", knl=["-(acbh32.r8b1)"], extra=dict(polarity=1.0))
env.set("mb.a33r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a33r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.33r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b33r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.c33r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c33r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.33r8.b1", k3="kod.a81b1", extra=dict(polarity=-1.0))
env.set("mq.33r8.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.33r8.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.33r8.b1", ksl=["acbv33.r8b1"], extra=dict(polarity=1.0))
env.set("mco.a34r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a34r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b34r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b34r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.b34r8.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r8.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r8.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c34r8.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.34r8.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.34r8.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("mss.34l1.b1", k2s="kss.a81b1", extra=dict(polarity=-1.0))
env.set("mcbh.34l1.b1", knl=["-(acbh34.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c34l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c34l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.34l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b34l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a34l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a34l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.33l1.b1", k3="kod.a81b1", extra=dict(polarity=-1.0))
env.set("mq.33l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.33l1.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.33l1.b1", ksl=["acbv33.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b33l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c33l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b33l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b33l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a33l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a33l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.32l1.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.32l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("mss.32l1.b1", k2s="kss.a81b1", extra=dict(polarity=-1.0))
env.set("mcbh.32l1.b1", knl=["-(acbh32.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c32l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c32l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.32l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b32l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a32l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a32l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.31l1.b1", k3="kod.a81b1", extra=dict(polarity=-1.0))
env.set("mq.31l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.31l1.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.31l1.b1", ksl=["acbv31.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b31l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c31l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b31l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b31l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a31l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a31l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.30l1.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.30l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.30l1.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.30l1.b1", knl=["-(acbh30.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c30l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c30l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.30l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b30l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a30l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a30l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.29l1.b1", k3="kod.a81b1", extra=dict(polarity=-1.0))
env.set("mq.29l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.29l1.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.29l1.b1", ksl=["acbv29.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b29l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c29l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b29l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b29l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a29l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a29l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.28l1.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.28l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("mss.28l1.b1", k2s="kss.a81b1", extra=dict(polarity=-1.0))
env.set("mcbh.28l1.b1", knl=["-(acbh28.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c28l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c28l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.28l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b28l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a28l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a28l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqs.27l1.b1", k1s="kqs.a81b1", extra=dict(polarity=-1.0))
env.set("mq.27l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.27l1.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.27l1.b1", ksl=["acbv27.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b27l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c27l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b27l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b27l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a27l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a27l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.26l1.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.26l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.26l1.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.26l1.b1", knl=["-(acbh26.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c26l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c26l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.26l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b26l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a26l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a26l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.25l1.b1", k3="kod.a81b1", extra=dict(polarity=-1.0))
env.set("mq.25l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.25l1.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.25l1.b1", ksl=["acbv25.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b25l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c25l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b25l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b25l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a25l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a25l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.24l1.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.24l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.24l1.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.24l1.b1", knl=["-(acbh24.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c24l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c24l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.24l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b24l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a24l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a24l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqs.23l1.b1", k1s="kqs.a81b1", extra=dict(polarity=-1.0))
env.set("mq.23l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.23l1.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.23l1.b1", ksl=["acbv23.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b23l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c23l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b23l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b23l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a23l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a23l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mo.22l1.b1", k3="kof.a81b1", extra=dict(polarity=1.0))
env.set("mq.22l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.22l1.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.22l1.b1", knl=["-(acbh22.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c22l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c22l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.22l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b22l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a22l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a22l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.21l1.b1", k1="kqtd.a81b1", extra=dict(polarity=-1.0))
env.set("mq.21l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.21l1.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.21l1.b1", ksl=["acbv21.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b21l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c21l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b21l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b21l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a21l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a21l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mq.20l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.20l1.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.20l1.b1", knl=["-(acbh20.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c20l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c20l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.20l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b20l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a20l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a20l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.19l1.b1", k1="kqtd.a81b1", extra=dict(polarity=-1.0))
env.set("mq.19l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.19l1.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.19l1.b1", ksl=["acbv19.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b19l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c19l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b19l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b19l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a19l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a19l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mq.18l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.18l1.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.18l1.b1", knl=["-(acbh18.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c18l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c18l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.18l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b18l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a18l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a18l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.17l1.b1", k1="kqtd.a81b1", extra=dict(polarity=-1.0))
env.set("mq.17l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.17l1.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.17l1.b1", ksl=["acbv17.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b17l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c17l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b17l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b17l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a17l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a17l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mq.16l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.16l1.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.16l1.b1", knl=["-(acbh16.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c16l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c16l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.16l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b16l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a16l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a16l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.15l1.b1", k1="kqtd.a81b1", extra=dict(polarity=-1.0))
env.set("mq.15l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.15l1.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.15l1.b1", ksl=["acbv15.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b15l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c15l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b15l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b15l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a15l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a15l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mq.14l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.14l1.b1", k2="ksf1.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.14l1.b1", knl=["-(acbh14.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c14l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c14l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.14l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b14l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a14l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a14l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.13l1.b1", k1="kqt13.l1b1", extra=dict(polarity=-1.0))
env.set("mq.13l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.13l1.b1", k2="ksd1.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.13l1.b1", ksl=["acbv13.l1b1"], extra=dict(polarity=1.0))
env.set("mco.b13l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c13l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.b13l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b13l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.a13l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a13l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqt.12l1.b1", k1="kqt12.l1b1", extra=dict(polarity=1.0))
env.set("mq.12l1.b1", k1="kqf.a81", extra=dict(polarity=1.0))
env.set("ms.12l1.b1", k2="ksf2.a81b1", extra=dict(polarity=1.0))
env.set("mcbh.12l1.b1", knl=["-(acbh12.l1b1)"], extra=dict(polarity=1.0))
env.set("mb.c12l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c12l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mco.12l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b12l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a12l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a12l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mq.11l1.b1", k1="kqd.a81", extra=dict(polarity=-1.0))
env.set("mqtli.11l1.b1", k1="kqtl11.l1b1", extra=dict(polarity=-1.0))
env.set("ms.11l1.b1", k2="ksd2.a81b1", extra=dict(polarity=-1.0))
env.set("mcbv.11l1.b1", ksl=["acbv11.l1b1"], extra=dict(polarity=1.0))
env.set("mco.11l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b11l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a11l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a11l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqml.10l1.b1", k1="kq10.l1b1", extra=dict(polarity=1.0))
env.set("mcbch.10l1.b1", knl=["-(acbch10.l1b1)"], extra=dict(polarity=1.0))
env.set("mco.10l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b10l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a10l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a10l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqmc.9l1.b1", k1="kq9.l1b1", extra=dict(polarity=-1.0))
env.set("mqm.9l1.b1", k1="kq9.l1b1", extra=dict(polarity=-1.0))
env.set("mcbcv.9l1.b1", ksl=["acbcv9.l1b1"], extra=dict(polarity=1.0))
env.set("mco.9l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b9l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a9l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a9l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqml.8l1.b1", k1="kq8.l1b1", extra=dict(polarity=1.0))
env.set("mcbch.8l1.b1", knl=["-(acbch8.l1b1)"], extra=dict(polarity=1.0))
env.set("mco.8l1.b1", knl=[0.0, 0.0, 0.0, "kco.a81b1*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l1.b1", knl=[0.0, 0.0, 0.0, 0.0, "kcd.a81b1*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b8l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mb.a8l1.b1", angle="ab.a81", k0="kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a8l1.b1", k2="kcs.a81b1", extra=dict(polarity=1.0))
env.set("mqm.b7l1.b1", k1="kq7.l1b1", extra=dict(polarity=-1.0))
env.set("mqm.a7l1.b1", k1="kq7.l1b1", extra=dict(polarity=-1.0))
env.set("mcbcv.7l1.b1", ksl=["acbcv7.l1b1"], extra=dict(polarity=1.0))
env.set("mcbch.6l1.b1", knl=["-(acbch6.l1b1)"], extra=dict(polarity=1.0))
env.set("mqml.6l1.b1", k1="kq6.l1b1", extra=dict(polarity=1.0))
env.set("mcbcv.5l1.b1", ksl=["acbcv5.l1b1"], extra=dict(polarity=1.0))
env.set("mqml.5l1.b1", k1="kq5.l1b1", extra=dict(polarity=-1.0))
env.set("mqy.4l1.b1", k1="kq4.l1b1", extra=dict(polarity=1.0))
env.set("mcbyh.b4l1.b1", knl=["-(acbyh4.l1b1)"], extra=dict(polarity=1.0))
env.set("mcbyv.4l1.b1", ksl=["acbyvs4.l1b1"], extra=dict(polarity=1.0))
env.set("mcbyh.a4l1.b1", knl=["-(acbyhs4.l1b1)"], extra=dict(polarity=1.0))
env.set("mbrc.4l1.b1", angle="-ad2.l1", k0="-kd2.l1", extra=dict(polarity=-1.0))
env.set("mbxw.f4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.e4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.d4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.c4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.b4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.a4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mcox.3l1", knl=[0.0, 0.0, 0.0, "kcox3.l1*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3l1", ksl=[0.0, 0.0, "kcssx3.l1*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mcbxh.3l1", knl=["-(acbxh3.l1)"], extra=dict(polarity=1.0))
env.set("mcbxv.3l1", ksl=["acbxv3.l1"], extra=dict(polarity=1.0))
env.set("mcsx.3l1", knl=[0.0, 0.0, "kcsx3.l1*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3l1", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.l1*l.mctx"], extra=dict(polarity=1.0))
env.set("mqxa.3l1", k1="kqx.l1", extra=dict(polarity=-1.0))
env.set("mqsx.3l1", k1s="kqsx3.l1", extra=dict(polarity=-1.0))
env.set("mqxb.b2l1", k1="-kqx.l1-ktqx2.l1", extra=dict(polarity=1.0))
env.set("mcbxh.2l1", knl=["-(acbxh2.l1)"], extra=dict(polarity=1.0))
env.set("mcbxv.2l1", ksl=["acbxv2.l1"], extra=dict(polarity=1.0))
env.set("mqxb.a2l1", k1="-kqx.l1-ktqx2.l1", extra=dict(polarity=1.0))
env.set("mcbxh.1l1", knl=["-(acbxh1.l1)"], extra=dict(polarity=1.0))
env.set("mcbxv.1l1", ksl=["acbxv1.l1"], extra=dict(polarity=1.0))
env.set("mqxa.1l1", k1="kqx.l1+ktqx1.l1", extra=dict(polarity=-1.0))
env.set("mbas2.1l1", ks="abas")


# /************************************************************************************/
# /*                       MAGNET-CONSTANT LHC SEQUENCE %B2                           */
# /************************************************************************************/

env.set("mbas2.1r1", ks="abas")
env.set("mqxa.1r1", k1="kqx.r1+ktqx1.r1", extra=dict(polarity=1.0))
env.set("mcbxh.1r1", knl=["-(acbxh1.r1)"], extra=dict(polarity=1.0))
env.set("mcbxv.1r1", ksl=["acbxv1.r1"], extra=dict(polarity=1.0))
env.set("mqxb.a2r1", k1="-kqx.r1-ktqx2.r1", extra=dict(polarity=-1.0))
env.set("mcbxh.2r1", knl=["-(acbxh2.r1)"], extra=dict(polarity=1.0))
env.set("mcbxv.2r1", ksl=["acbxv2.r1"], extra=dict(polarity=1.0))
env.set("mqxb.b2r1", k1="-kqx.r1-ktqx2.r1", extra=dict(polarity=-1.0))
env.set("mqsx.3r1", k1s="kqsx3.r1", extra=dict(polarity=-1.0))
env.set("mqxa.3r1", k1="kqx.r1", extra=dict(polarity=1.0))
env.set("mcbxh.3r1", knl=["-(acbxh3.r1)"], extra=dict(polarity=1.0))
env.set("mcbxv.3r1", ksl=["acbxv3.r1"], extra=dict(polarity=1.0))
env.set("mcsx.3r1", knl=[0.0, 0.0, "kcsx3.r1*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3r1", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.r1*l.mctx"], extra=dict(polarity=1.0))
env.set("mcosx.3r1", ksl=[0.0, 0.0, 0.0, "kcosx3.r1*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3r1", knl=[0.0, 0.0, 0.0, "kcox3.r1*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3r1", ksl=[0.0, 0.0, "kcssx3.r1*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mbxw.a4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.b4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.c4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.d4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.e4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbxw.f4r1", angle="-ad1.lr1", k0="-kd1.lr1", extra=dict(polarity=-1.0))
env.set("mbrc.4r1.b2", angle="ad2.r1", k0="kd2.r1", extra=dict(polarity=-1.0))
env.set("mcbyh.a4r1.b2", knl=["-(-acbyhs4.r1b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.4r1.b2", ksl=["-acbyvs4.r1b2"], extra=dict(polarity=1.0))
env.set("mcbyh.b4r1.b2", knl=["-(-acbyh4.r1b2)"], extra=dict(polarity=1.0))
env.set("mqy.4r1.b2", k1="-kq4.r1b2", extra=dict(polarity=1.0))
env.set("mcbcv.5r1.b2", ksl=["-acbcv5.r1b2"], extra=dict(polarity=1.0))
env.set("mqml.5r1.b2", k1="-kq5.r1b2", extra=dict(polarity=-1.0))
env.set("mcbch.6r1.b2", knl=["-(-acbch6.r1b2)"], extra=dict(polarity=1.0))
env.set("mqml.6r1.b2", k1="-kq6.r1b2", extra=dict(polarity=1.0))
env.set("mqm.a7r1.b2", k1="-kq7.r1b2", extra=dict(polarity=-1.0))
env.set("mqm.b7r1.b2", k1="-kq7.r1b2", extra=dict(polarity=-1.0))
env.set("mcbcv.7r1.b2", ksl=["-acbcv7.r1b2"], extra=dict(polarity=1.0))
env.set("mco.8r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a8r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b8r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b8r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqml.8r1.b2", k1="-kq8.r1b2", extra=dict(polarity=1.0))
env.set("mcbch.8r1.b2", knl=["-(-acbch8.r1b2)"], extra=dict(polarity=1.0))
env.set("mco.9r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a9r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b9r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b9r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqmc.9r1.b2", k1="-kq9.r1b2", extra=dict(polarity=-1.0))
env.set("mqm.9r1.b2", k1="-kq9.r1b2", extra=dict(polarity=-1.0))
env.set("mcbcv.9r1.b2", ksl=["-acbcv9.r1b2"], extra=dict(polarity=1.0))
env.set("mco.10r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a10r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b10r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b10r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqml.10r1.b2", k1="-kq10.r1b2", extra=dict(polarity=1.0))
env.set("mcbch.10r1.b2", knl=["-(-acbch10.r1b2)"], extra=dict(polarity=1.0))
env.set("mco.11r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a11r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b11r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b11r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mq.11r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("mqtli.11r1.b2", k1="-kqtl11.r1b2", extra=dict(polarity=-1.0))
env.set("ms.11r1.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.11r1.b2", ksl=["-acbv11.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a12r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a12r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b12r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b12r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b12r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c12r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.12r1.b2", k1="-kqt12.r1b2", extra=dict(polarity=1.0))
env.set("mq.12r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.12r1.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.12r1.b2", knl=["-(-acbh12.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a13r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a13r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.13r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b13r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c13r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c13r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.13r1.b2", k1="-kqt13.r1b2", extra=dict(polarity=-1.0))
env.set("mq.13r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.13r1.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.13r1.b2", ksl=["-acbv13.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a14r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a14r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b14r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b14r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b14r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c14r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.14r1.b2", k1="-kqtf.a12b2", extra=dict(polarity=1.0))
env.set("mq.14r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.14r1.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.14r1.b2", knl=["-(-acbh14.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a15r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a15r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.15r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b15r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c15r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c15r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.15r1.b2", k1="-kqtd.a12b2", extra=dict(polarity=-1.0))
env.set("mq.15r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.15r1.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.15r1.b2", ksl=["-acbv15.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a16r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a16r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b16r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b16r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b16r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c16r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.16r1.b2", k1="-kqtf.a12b2", extra=dict(polarity=1.0))
env.set("mq.16r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.16r1.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.16r1.b2", knl=["-(-acbh16.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a17r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a17r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.17r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b17r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c17r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c17r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.17r1.b2", k1="-kqtd.a12b2", extra=dict(polarity=-1.0))
env.set("mq.17r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.17r1.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.17r1.b2", ksl=["-acbv17.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a18r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a18r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b18r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b18r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b18r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c18r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.18r1.b2", k1="-kqtf.a12b2", extra=dict(polarity=1.0))
env.set("mq.18r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.18r1.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.18r1.b2", knl=["-(-acbh18.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a19r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mco.19r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b19r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c19r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c19r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.19r1.b2", k1="-kqtd.a12b2", extra=dict(polarity=-1.0))
env.set("mq.19r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.19r1.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.19r1.b2", ksl=["-acbv19.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a20r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a20r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b20r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b20r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b20r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c20r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.20r1.b2", k1="-kqtf.a12b2", extra=dict(polarity=1.0))
env.set("mq.20r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.20r1.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.20r1.b2", knl=["-(-acbh20.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a21r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a21r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.21r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b21r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c21r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c21r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.21r1.b2", k1="-kqtd.a12b2", extra=dict(polarity=-1.0))
env.set("mq.21r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.21r1.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.21r1.b2", ksl=["-acbv21.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a22r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a22r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b22r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b22r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b22r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c22r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.22r1.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.22r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.22r1.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.22r1.b2", knl=["-(-acbh22.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a23r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a23r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.23r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b23r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c23r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c23r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqs.23r1.b2", k1s="-kqs.a12b2", extra=dict(polarity=-1.0))
env.set("mq.23r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.23r1.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.23r1.b2", ksl=["-acbv23.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a24r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a24r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b24r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b24r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b24r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c24r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.24r1.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.24r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.24r1.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.24r1.b2", knl=["-(-acbh24.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a25r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a25r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.25r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b25r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c25r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c25r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.25r1.b2", k3="-kod.a12b2", extra=dict(polarity=-1.0))
env.set("mq.25r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.25r1.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.25r1.b2", ksl=["-acbv25.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a26r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a26r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b26r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b26r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b26r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c26r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.26r1.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.26r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.26r1.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.26r1.b2", knl=["-(-acbh26.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a27r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a27r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.27r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b27r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c27r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c27r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqs.27r1.b2", k1s="-kqs.a12b2", extra=dict(polarity=-1.0))
env.set("mq.27r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.27r1.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.27r1.b2", ksl=["-acbv27.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a28r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a28r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b28r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b28r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b28r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c28r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.28r1.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.28r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.28r1.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.28r1.b2", knl=["-(-acbh28.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a29r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a29r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.29r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b29r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c29r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c29r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.29r1.b2", k3="-kod.a12b2", extra=dict(polarity=-1.0))
env.set("mq.29r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.29r1.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.29r1.b2", ksl=["-acbv29.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a30r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a30r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b30r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b30r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b30r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c30r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.30r1.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.30r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("mss.30r1.b2", k2s="-kss.a12b2", extra=dict(polarity=-1.0))
env.set("mcbh.30r1.b2", knl=["-(-acbh30.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a31r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a31r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.31r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b31r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c31r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c31r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.31r1.b2", k3="-kod.a12b2", extra=dict(polarity=-1.0))
env.set("mq.31r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.31r1.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.31r1.b2", ksl=["-acbv31.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a32r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a32r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b32r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b32r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b32r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c32r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.32r1.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.32r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.32r1.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.32r1.b2", knl=["-(-acbh32.r1b2)"], extra=dict(polarity=1.0))
env.set("mb.a33r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a33r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.33r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b33r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.c33r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c33r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.33r1.b2", k3="-kod.a12b2", extra=dict(polarity=-1.0))
env.set("mq.33r1.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.33r1.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.33r1.b2", ksl=["-acbv33.r1b2"], extra=dict(polarity=1.0))
env.set("mco.a34r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a34r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b34r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b34r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.b34r1.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r1.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c34r1.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.34r1.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.34r1.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("mss.34l2.b2", k2s="-kss.a12b2", extra=dict(polarity=-1.0))
env.set("mcbh.34l2.b2", knl=["-(-acbh34.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c34l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c34l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.34l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b34l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a34l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a34l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.33l2.b2", k3="-kod.a12b2", extra=dict(polarity=-1.0))
env.set("mq.33l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.33l2.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.33l2.b2", ksl=["-acbv33.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b33l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c33l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b33l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b33l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a33l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a33l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.32l2.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.32l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("mss.32l2.b2", k2s="-kss.a12b2", extra=dict(polarity=-1.0))
env.set("mcbh.32l2.b2", knl=["-(-acbh32.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c32l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c32l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.32l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b32l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a32l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a32l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.31l2.b2", k3="-kod.a12b2", extra=dict(polarity=-1.0))
env.set("mq.31l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.31l2.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.31l2.b2", ksl=["-acbv31.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b31l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c31l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b31l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b31l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a31l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a31l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.30l2.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.30l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.30l2.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.30l2.b2", knl=["-(-acbh30.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c30l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c30l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.30l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b30l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a30l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a30l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.29l2.b2", k3="-kod.a12b2", extra=dict(polarity=-1.0))
env.set("mq.29l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.29l2.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.29l2.b2", ksl=["-acbv29.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b29l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c29l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b29l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b29l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a29l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a29l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.28l2.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.28l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("mss.28l2.b2", k2s="-kss.a12b2", extra=dict(polarity=-1.0))
env.set("mcbh.28l2.b2", knl=["-(-acbh28.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c28l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c28l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.28l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b28l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a28l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a28l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqs.27l2.b2", k1s="-kqs.a12b2", extra=dict(polarity=-1.0))
env.set("mq.27l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.27l2.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.27l2.b2", ksl=["-acbv27.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b27l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c27l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b27l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b27l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a27l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a27l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.26l2.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.26l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.26l2.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.26l2.b2", knl=["-(-acbh26.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c26l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c26l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.26l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b26l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a26l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a26l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.25l2.b2", k3="-kod.a12b2", extra=dict(polarity=-1.0))
env.set("mq.25l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.25l2.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.25l2.b2", ksl=["-acbv25.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b25l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c25l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b25l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b25l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a25l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a25l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.24l2.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.24l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.24l2.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.24l2.b2", knl=["-(-acbh24.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c24l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c24l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.24l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b24l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a24l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a24l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqs.23l2.b2", k1s="-kqs.a12b2", extra=dict(polarity=-1.0))
env.set("mq.23l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.23l2.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.23l2.b2", ksl=["-acbv23.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b23l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c23l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b23l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b23l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a23l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a23l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mo.22l2.b2", k3="-kof.a12b2", extra=dict(polarity=1.0))
env.set("mq.22l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.22l2.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.22l2.b2", knl=["-(-acbh22.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c22l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c22l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.22l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b22l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a22l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a22l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.21l2.b2", k1="-kqtd.a12b2", extra=dict(polarity=-1.0))
env.set("mq.21l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.21l2.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.21l2.b2", ksl=["-acbv21.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b21l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c21l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b21l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b21l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a21l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a21l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.20l2.b2", k1="-kqtf.a12b2", extra=dict(polarity=1.0))
env.set("mq.20l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.20l2.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.20l2.b2", knl=["-(-acbh20.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c20l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c20l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.20l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b20l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a20l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a20l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.19l2.b2", k1="-kqtd.a12b2", extra=dict(polarity=-1.0))
env.set("mq.19l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.19l2.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.19l2.b2", ksl=["-acbv19.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b19l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c19l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b19l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b19l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a19l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a19l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.18l2.b2", k1="-kqtf.a12b2", extra=dict(polarity=1.0))
env.set("mq.18l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.18l2.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.18l2.b2", knl=["-(-acbh18.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c18l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c18l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.18l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b18l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a18l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a18l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.17l2.b2", k1="-kqtd.a12b2", extra=dict(polarity=-1.0))
env.set("mq.17l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.17l2.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.17l2.b2", ksl=["-acbv17.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b17l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c17l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b17l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b17l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a17l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a17l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.16l2.b2", k1="-kqtf.a12b2", extra=dict(polarity=1.0))
env.set("mq.16l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.16l2.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.16l2.b2", knl=["-(-acbh16.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c16l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c16l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.16l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b16l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a16l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a16l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.15l2.b2", k1="-kqtd.a12b2", extra=dict(polarity=-1.0))
env.set("mq.15l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.15l2.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.15l2.b2", ksl=["-acbv15.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b15l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c15l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b15l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b15l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a15l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a15l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.14l2.b2", k1="-kqtf.a12b2", extra=dict(polarity=1.0))
env.set("mq.14l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.14l2.b2", k2="-ksf2.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.14l2.b2", knl=["-(-acbh14.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c14l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c14l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.14l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b14l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a14l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a14l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.13l2.b2", k1="-kqt13.l2b2", extra=dict(polarity=-1.0))
env.set("mq.13l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("ms.13l2.b2", k2="-ksd1.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.13l2.b2", ksl=["-acbv13.l2b2"], extra=dict(polarity=1.0))
env.set("mco.b13l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c13l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.b13l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b13l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.a13l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a13l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqt.12l2.b2", k1="-kqt12.l2b2", extra=dict(polarity=1.0))
env.set("mq.12l2.b2", k1="-kqf.a12", extra=dict(polarity=1.0))
env.set("ms.12l2.b2", k2="-ksf1.a12b2", extra=dict(polarity=1.0))
env.set("mcbh.12l2.b2", knl=["-(-acbh12.l2b2)"], extra=dict(polarity=1.0))
env.set("mb.c12l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.c12l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mco.12l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b12l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a12l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a12l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mq.11l2.b2", k1="-kqd.a12", extra=dict(polarity=-1.0))
env.set("mqtli.11l2.b2", k1="-kqtl11.l2b2", extra=dict(polarity=-1.0))
env.set("ms.11l2.b2", k2="-ksd2.a12b2", extra=dict(polarity=-1.0))
env.set("mcbv.11l2.b2", ksl=["-acbv11.l2b2"], extra=dict(polarity=1.0))
env.set("mco.11l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b11l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a11l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a11l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqml.10l2.b2", k1="-kq10.l2b2", extra=dict(polarity=1.0))
env.set("mcbch.10l2.b2", knl=["-(-acbch10.l2b2)"], extra=dict(polarity=1.0))
env.set("mco.10l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b10l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a10l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a10l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqmc.9l2.b2", k1="-kq9.l2b2", extra=dict(polarity=-1.0))
env.set("mqm.9l2.b2", k1="-kq9.l2b2", extra=dict(polarity=-1.0))
env.set("mcbcv.9l2.b2", ksl=["-acbcv9.l2b2"], extra=dict(polarity=1.0))
env.set("mco.9l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b9l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a9l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a9l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqml.8l2.b2", k1="-kq8.l2b2", extra=dict(polarity=1.0))
env.set("mcbch.8l2.b2", knl=["-(-acbch8.l2b2)"], extra=dict(polarity=1.0))
env.set("mco.8l2.b2", knl=[0.0, 0.0, 0.0, "-kco.a12b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a12b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.b8l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mb.a8l2.b2", angle="-ab.a12", k0="-kb.a12", extra=dict(polarity=1.0))
env.set("mcs.a8l2.b2", k2="-kcs.a12b2", extra=dict(polarity=1.0))
env.set("mqm.b7l2.b2", k1="-kq7.l2b2", extra=dict(polarity=-1.0))
env.set("mqm.a7l2.b2", k1="-kq7.l2b2", extra=dict(polarity=-1.0))
env.set("mcbcv.7l2.b2", ksl=["-acbcv7.l2b2"], extra=dict(polarity=1.0))
env.set("mcbch.6l2.b2", knl=["-(-acbch6.l2b2)"], extra=dict(polarity=1.0))
env.set("mqml.6l2.b2", k1="-kq6.l2b2", extra=dict(polarity=1.0))
env.set("mqm.6l2.b2", k1="-kq6.l2b2", extra=dict(polarity=1.0))
env.set("msib.c6l2.b2", knl=["-(akmsib.l2b2)"], extra=dict(polarity=1.0))
env.set("msib.b6l2.b2", knl=["-(akmsib.l2b2)"], extra=dict(polarity=1.0))
env.set("msib.a6l2.b2", knl=["-(akmsib.l2b2)"], extra=dict(polarity=1.0))
env.set("msia.b6l2.b2", knl=["-(akmsia.l2b2)"], extra=dict(polarity=1.0))
env.set("msia.a6l2.b2", knl=["-(akmsia.l2b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.b5l2.b2", ksl=["-acbyvs5.l2b2"], extra=dict(polarity=1.0))
env.set("mcbyh.5l2.b2", knl=["-(-acbyhs5.l2b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.a5l2.b2", ksl=["-acbyv5.l2b2"], extra=dict(polarity=1.0))
env.set("mqy.b5l2.b2", k1="-kq5.l2b2", extra=dict(polarity=-1.0))
env.set("mqy.a5l2.b2", k1="-kq5.l2b2", extra=dict(polarity=-1.0))
env.set("mqy.b4l2.b2", k1="-kq4.l2b2", extra=dict(polarity=1.0))
env.set("mqy.a4l2.b2", k1="-kq4.l2b2", extra=dict(polarity=1.0))
env.set("mcbyh.b4l2.b2", knl=["-(-acbyh4.l2b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.4l2.b2", ksl=["-acbyvs4.l2b2"], extra=dict(polarity=1.0))
env.set("mcbyh.a4l2.b2", knl=["-(-acbyhs4.l2b2)"], extra=dict(polarity=1.0))
env.set("mbrc.4l2.b2", angle="ad2.l2", k0="kd2.l2", extra=dict(polarity=-1.0))
env.set("mbx.4l2", angle="-ad1.l2", k0="-kd1.l2", extra=dict(polarity=-1.0))
env.set("mcbxh.3l2", knl=["-(acbxh3.l2)"], extra=dict(polarity=1.0))
env.set("mcbxv.3l2", ksl=["acbxv3.l2"], extra=dict(polarity=1.0))
env.set("mcsx.3l2", knl=[0.0, 0.0, "kcsx3.l2*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3l2", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.l2*l.mctx"], extra=dict(polarity=1.0))
env.set("mqxa.3l2", k1="kqx.l2", extra=dict(polarity=1.0))
env.set("mqsx.3l2", k1s="kqsx3.l2", extra=dict(polarity=-1.0))
env.set("mqxb.b2l2", k1="-kqx.l2-ktqx2.l2", extra=dict(polarity=-1.0))
env.set("mcbxh.2l2", knl=["-(acbxh2.l2)"], extra=dict(polarity=1.0))
env.set("mcbxv.2l2", ksl=["acbxv2.l2"], extra=dict(polarity=1.0))
env.set("mqxb.a2l2", k1="-kqx.l2-ktqx2.l2", extra=dict(polarity=-1.0))
env.set("mcbxv.1l2", ksl=["acbxv1.l2"], extra=dict(polarity=1.0))
env.set("mqxa.1l2", k1="kqx.l2+ktqx1.l2", extra=dict(polarity=1.0))
env.set("mbxwt.1l2", rot_s_rad=-0.004170381943025, ksl=["abxwt.l2"], extra=dict(polarity=1.0))
env.set("mbwmd.1l2", rot_s_rad=-0.004170381943025, ksl=["abwmd.l2"], extra=dict(polarity=1.0))
env.set("mbls2.1l2", ks="abls")
env.set("mbls2.1r2", ks="abls")
env.set("mbaw.1r2", rot_s_rad=-0.004170381943025, ksl=["abaw.r2"], extra=dict(polarity=-1.0))
env.set("mbxwt.1r2", rot_s_rad=-0.004170381943025, ksl=["abxwt.r2"], extra=dict(polarity=1.0))
env.set("mqxa.1r2", k1="kqx.r2+ktqx1.r2", extra=dict(polarity=-1.0))
env.set("mcbxh.1r2", knl=["-(acbxh1.r2)"], extra=dict(polarity=1.0))
env.set("mcbxv.1r2", ksl=["acbxv1.r2"], extra=dict(polarity=1.0))
env.set("mqxb.a2r2", k1="-kqx.r2-ktqx2.r2", extra=dict(polarity=1.0))
env.set("mcbxh.2r2", knl=["-(acbxh2.r2)"], extra=dict(polarity=1.0))
env.set("mcbxv.2r2", ksl=["acbxv2.r2"], extra=dict(polarity=1.0))
env.set("mqxb.b2r2", k1="-kqx.r2-ktqx2.r2", extra=dict(polarity=1.0))
env.set("mqsx.3r2", k1s="kqsx3.r2", extra=dict(polarity=-1.0))
env.set("mqxa.3r2", k1="kqx.r2", extra=dict(polarity=-1.0))
env.set("mcbxh.3r2", knl=["-(acbxh3.r2)"], extra=dict(polarity=1.0))
env.set("mcbxv.3r2", ksl=["acbxv3.r2"], extra=dict(polarity=1.0))
env.set("mcsx.3r2", knl=[0.0, 0.0, "kcsx3.r2*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3r2", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.r2*l.mctx"], extra=dict(polarity=1.0))
env.set("mcosx.3r2", ksl=[0.0, 0.0, 0.0, "kcosx3.r2*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3r2", knl=[0.0, 0.0, 0.0, "kcox3.r2*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3r2", ksl=[0.0, 0.0, "kcssx3.r2*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mbx.4r2", angle="ad1.r2", k0="kd1.r2", extra=dict(polarity=1.0))
env.set("mbrc.4r2.b2", angle="-ad2.r2", k0="-kd2.r2", extra=dict(polarity=1.0))
env.set("mcbyv.a4r2.b2", ksl=["-acbyvs4.r2b2"], extra=dict(polarity=1.0))
env.set("mcbyh.4r2.b2", knl=["-(-acbyhs4.r2b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.b4r2.b2", ksl=["-acbyv4.r2b2"], extra=dict(polarity=1.0))
env.set("mqy.a4r2.b2", k1="-kq4.r2b2", extra=dict(polarity=-1.0))
env.set("mqy.b4r2.b2", k1="-kq4.r2b2", extra=dict(polarity=-1.0))
env.set("mcbch.a5r2.b2", knl=["-(-acbchs5.r2b2)"], extra=dict(polarity=1.0))
env.set("mcbcv.5r2.b2", ksl=["-acbcvs5.r2b2"], extra=dict(polarity=1.0))
env.set("mcbch.b5r2.b2", knl=["-(-acbch5.r2b2)"], extra=dict(polarity=1.0))
env.set("mqm.a5r2.b2", k1="-kq5.r2b2", extra=dict(polarity=1.0))
env.set("mqm.b5r2.b2", k1="-kq5.r2b2", extra=dict(polarity=1.0))
env.set("mcbcv.6r2.b2", ksl=["-acbcv6.r2b2"], extra=dict(polarity=1.0))
env.set("mqml.6r2.b2", k1="-kq6.r2b2", extra=dict(polarity=-1.0))
env.set("mqm.6r2.b2", k1="-kq6.r2b2", extra=dict(polarity=-1.0))
env.set("mqm.a7r2.b2", k1="-kq7.r2b2", extra=dict(polarity=1.0))
env.set("mqm.b7r2.b2", k1="-kq7.r2b2", extra=dict(polarity=1.0))
env.set("mcbch.7r2.b2", knl=["-(-acbch7.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.8r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a8r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b8r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b8r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqml.8r2.b2", k1="-kq8.r2b2", extra=dict(polarity=-1.0))
env.set("mcbcv.8r2.b2", ksl=["-acbcv8.r2b2"], extra=dict(polarity=1.0))
env.set("mco.9r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a9r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b9r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b9r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqmc.9r2.b2", k1="-kq9.r2b2", extra=dict(polarity=1.0))
env.set("mqm.9r2.b2", k1="-kq9.r2b2", extra=dict(polarity=1.0))
env.set("mcbch.9r2.b2", knl=["-(-acbch9.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.10r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a10r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b10r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b10r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqml.10r2.b2", k1="-kq10.r2b2", extra=dict(polarity=-1.0))
env.set("mcbcv.10r2.b2", ksl=["-acbcv10.r2b2"], extra=dict(polarity=1.0))
env.set("mco.11r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a11r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b11r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b11r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mq.11r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("mqtli.11r2.b2", k1="-kqtl11.r2b2", extra=dict(polarity=1.0))
env.set("ms.11r2.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.11r2.b2", knl=["-(-acbh11.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a12r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a12r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b12r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b12r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b12r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c12r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.12r2.b2", k1="-kqt12.r2b2", extra=dict(polarity=-1.0))
env.set("mq.12r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.12r2.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.12r2.b2", ksl=["-acbv12.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a13r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a13r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.13r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b13r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c13r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c13r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.13r2.b2", k1="-kqt13.r2b2", extra=dict(polarity=1.0))
env.set("mq.13r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.13r2.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.13r2.b2", knl=["-(-acbh13.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a14r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a14r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b14r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b14r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b14r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c14r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.14r2.b2", k1="-kqtd.a23b2", extra=dict(polarity=-1.0))
env.set("mq.14r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.14r2.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.14r2.b2", ksl=["-acbv14.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a15r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a15r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.15r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b15r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c15r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c15r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.15r2.b2", k1="-kqtf.a23b2", extra=dict(polarity=1.0))
env.set("mq.15r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.15r2.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.15r2.b2", knl=["-(-acbh15.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a16r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a16r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b16r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b16r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b16r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c16r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.16r2.b2", k1="-kqtd.a23b2", extra=dict(polarity=-1.0))
env.set("mq.16r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.16r2.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.16r2.b2", ksl=["-acbv16.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a17r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a17r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.17r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b17r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c17r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c17r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.17r2.b2", k1="-kqtf.a23b2", extra=dict(polarity=1.0))
env.set("mq.17r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.17r2.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.17r2.b2", knl=["-(-acbh17.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a18r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a18r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b18r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b18r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b18r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c18r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.18r2.b2", k1="-kqtd.a23b2", extra=dict(polarity=-1.0))
env.set("mq.18r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.18r2.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.18r2.b2", ksl=["-acbv18.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a19r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a19r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.19r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b19r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c19r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c19r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.19r2.b2", k1="-kqtf.a23b2", extra=dict(polarity=1.0))
env.set("mq.19r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.19r2.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.19r2.b2", knl=["-(-acbh19.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a20r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a20r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b20r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b20r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b20r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c20r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.20r2.b2", k1="-kqtd.a23b2", extra=dict(polarity=-1.0))
env.set("mq.20r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.20r2.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.20r2.b2", ksl=["-acbv20.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a21r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a21r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.21r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b21r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c21r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c21r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.21r2.b2", k1="-kqtf.a23b2", extra=dict(polarity=1.0))
env.set("mq.21r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.21r2.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.21r2.b2", knl=["-(-acbh21.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a22r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a22r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b22r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b22r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b22r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c22r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.22r2.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.22r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.22r2.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.22r2.b2", ksl=["-acbv22.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a23r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a23r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.23r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b23r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c23r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c23r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqs.23r2.b2", k1s="-kqs.r2b2", extra=dict(polarity=-1.0))
env.set("mq.23r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.23r2.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.23r2.b2", knl=["-(-acbh23.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a24r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a24r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b24r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b24r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b24r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c24r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.24r2.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.24r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.24r2.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.24r2.b2", ksl=["-acbv24.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a25r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a25r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.25r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b25r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c25r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c25r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.25r2.b2", k3="-kof.a23b2", extra=dict(polarity=1.0))
env.set("mq.25r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.25r2.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.25r2.b2", knl=["-(-acbh25.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a26r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a26r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b26r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b26r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b26r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c26r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.26r2.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.26r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.26r2.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.26r2.b2", ksl=["-acbv26.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a27r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a27r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.27r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b27r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c27r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c27r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqs.27r2.b2", k1s="-kqs.r2b2", extra=dict(polarity=-1.0))
env.set("mq.27r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.27r2.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.27r2.b2", knl=["-(-acbh27.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a28r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a28r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b28r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b28r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b28r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c28r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.28r2.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.28r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.28r2.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.28r2.b2", ksl=["-acbv28.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a29r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a29r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.29r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b29r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c29r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c29r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.29r2.b2", k3="-kof.a23b2", extra=dict(polarity=1.0))
env.set("mq.29r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("mss.29r2.b2", k2s="-kss.a23b2", extra=dict(polarity=-1.0))
env.set("mcbh.29r2.b2", knl=["-(-acbh29.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a30r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a30r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b30r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b30r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b30r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c30r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.30r2.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.30r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.30r2.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.30r2.b2", ksl=["-acbv30.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a31r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a31r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.31r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b31r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c31r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c31r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.31r2.b2", k3="-kof.a23b2", extra=dict(polarity=1.0))
env.set("mq.31r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.31r2.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.31r2.b2", knl=["-(-acbh31.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a32r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a32r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b32r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b32r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b32r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c32r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.32r2.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.32r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.32r2.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.32r2.b2", ksl=["-acbv32.r2b2"], extra=dict(polarity=1.0))
env.set("mb.a33r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a33r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.33r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b33r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.c33r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c33r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.33r2.b2", k3="-kof.a23b2", extra=dict(polarity=1.0))
env.set("mq.33r2.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("mss.33r2.b2", k2s="-kss.a23b2", extra=dict(polarity=-1.0))
env.set("mcbh.33r2.b2", knl=["-(-acbh33.r2b2)"], extra=dict(polarity=1.0))
env.set("mco.a34r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a34r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b34r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b34r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.b34r2.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r2.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r2.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c34r2.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.34r2.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.34r2.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.34l3.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.34l3.b2", ksl=["-acbv34.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c34l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c34l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.34l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b34l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a34l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a34l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.33l3.b2", k3="-kof.a23b2", extra=dict(polarity=1.0))
env.set("mq.33l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("mss.33l3.b2", k2s="-kss.a23b2", extra=dict(polarity=-1.0))
env.set("mcbh.33l3.b2", knl=["-(-acbh33.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b33l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c33l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b33l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b33l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a33l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a33l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.32l3.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.32l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.32l3.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.32l3.b2", ksl=["-acbv32.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c32l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c32l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.32l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b32l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a32l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a32l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.31l3.b2", k3="-kof.a23b2", extra=dict(polarity=1.0))
env.set("mq.31l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.31l3.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.31l3.b2", knl=["-(-acbh31.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b31l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c31l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b31l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b31l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a31l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a31l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.30l3.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.30l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.30l3.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.30l3.b2", ksl=["-acbv30.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c30l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c30l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.30l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b30l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a30l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a30l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.29l3.b2", k3="-kof.a23b2", extra=dict(polarity=1.0))
env.set("mq.29l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("mss.29l3.b2", k2s="-kss.a23b2", extra=dict(polarity=-1.0))
env.set("mcbh.29l3.b2", knl=["-(-acbh29.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b29l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c29l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b29l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b29l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a29l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a29l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.28l3.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.28l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.28l3.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.28l3.b2", ksl=["-acbv28.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c28l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c28l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.28l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b28l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a28l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a28l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqs.27l3.b2", k1s="-kqs.l3b2", extra=dict(polarity=-1.0))
env.set("mq.27l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.27l3.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.27l3.b2", knl=["-(-acbh27.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b27l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c27l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b27l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b27l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a27l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a27l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.26l3.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.26l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.26l3.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.26l3.b2", ksl=["-acbv26.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c26l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c26l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.26l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b26l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a26l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a26l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.25l3.b2", k3="-kof.a23b2", extra=dict(polarity=1.0))
env.set("mq.25l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.25l3.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.25l3.b2", knl=["-(-acbh25.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b25l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c25l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b25l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b25l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a25l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a25l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.24l3.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.24l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.24l3.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.24l3.b2", ksl=["-acbv24.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c24l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c24l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.24l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b24l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a24l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a24l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqs.23l3.b2", k1s="-kqs.l3b2", extra=dict(polarity=-1.0))
env.set("mq.23l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.23l3.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.23l3.b2", knl=["-(-acbh23.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b23l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c23l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b23l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b23l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a23l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a23l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mo.22l3.b2", k3="-kod.a23b2", extra=dict(polarity=-1.0))
env.set("mq.22l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.22l3.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.22l3.b2", ksl=["-acbv22.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c22l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c22l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.22l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b22l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a22l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a22l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.21l3.b2", k1="-kqtf.a23b2", extra=dict(polarity=1.0))
env.set("mq.21l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.21l3.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.21l3.b2", knl=["-(-acbh21.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b21l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c21l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b21l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b21l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a21l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a21l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.20l3.b2", k1="-kqtd.a23b2", extra=dict(polarity=-1.0))
env.set("mq.20l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.20l3.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.20l3.b2", ksl=["-acbv20.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c20l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c20l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.20l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b20l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a20l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a20l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.19l3.b2", k1="-kqtf.a23b2", extra=dict(polarity=1.0))
env.set("mq.19l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.19l3.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.19l3.b2", knl=["-(-acbh19.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b19l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c19l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b19l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b19l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a19l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a19l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.18l3.b2", k1="-kqtd.a23b2", extra=dict(polarity=-1.0))
env.set("mq.18l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.18l3.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.18l3.b2", ksl=["-acbv18.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c18l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c18l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.18l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b18l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a18l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a18l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.17l3.b2", k1="-kqtf.a23b2", extra=dict(polarity=1.0))
env.set("mq.17l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.17l3.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.17l3.b2", knl=["-(-acbh17.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b17l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c17l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b17l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b17l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a17l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a17l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.16l3.b2", k1="-kqtd.a23b2", extra=dict(polarity=-1.0))
env.set("mq.16l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.16l3.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.16l3.b2", ksl=["-acbv16.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c16l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c16l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.16l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b16l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a16l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a16l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.15l3.b2", k1="-kqtf.a23b2", extra=dict(polarity=1.0))
env.set("mq.15l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.15l3.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.15l3.b2", knl=["-(-acbh15.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b15l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c15l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b15l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b15l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a15l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a15l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.14l3.b2", k1="-kqtd.a23b2", extra=dict(polarity=-1.0))
env.set("mq.14l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.14l3.b2", k2="-ksd2.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.14l3.b2", ksl=["-acbv14.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c14l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c14l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.14l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b14l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a14l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a14l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.13l3.b2", k1="-kqt13.l3b2", extra=dict(polarity=1.0))
env.set("mq.13l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("ms.13l3.b2", k2="-ksf1.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.13l3.b2", knl=["-(-acbh13.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.b13l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c13l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.b13l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b13l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.a13l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a13l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mqt.12l3.b2", k1="-kqt12.l3b2", extra=dict(polarity=-1.0))
env.set("mq.12l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("ms.12l3.b2", k2="-ksd1.a23b2", extra=dict(polarity=-1.0))
env.set("mcbv.12l3.b2", ksl=["-acbv12.l3b2"], extra=dict(polarity=1.0))
env.set("mb.c12l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.c12l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mco.12l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b12l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a12l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a12l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mq.11l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("mqtli.11l3.b2", k1="-kqtl11.l3b2", extra=dict(polarity=1.0))
env.set("ms.11l3.b2", k2="-ksf2.a23b2", extra=dict(polarity=1.0))
env.set("mcbh.11l3.b2", knl=["-(-acbh11.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.11l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b11l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a11l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a11l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mq.10l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("mqtli.10l3.b2", k1="-kqtl10.l3b2", extra=dict(polarity=-1.0))
env.set("mcbcv.10l3.b2", ksl=["-acbcv10.l3b2"], extra=dict(polarity=1.0))
env.set("mco.10l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b10l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a10l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a10l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mq.9l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("mqtli.b9l3.b2", k1="-kqtl9.l3b2", extra=dict(polarity=1.0))
env.set("mqtli.a9l3.b2", k1="-kqtl9.l3b2", extra=dict(polarity=1.0))
env.set("mcbch.9l3.b2", knl=["-(-acbch9.l3b2)"], extra=dict(polarity=1.0))
env.set("mco.9l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b9l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a9l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a9l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mq.8l3.b2", k1="-kqd.a23", extra=dict(polarity=-1.0))
env.set("mqtli.8l3.b2", k1="-kqtl8.l3b2", extra=dict(polarity=-1.0))
env.set("mcbcv.8l3.b2", ksl=["-acbcv8.l3b2"], extra=dict(polarity=1.0))
env.set("mco.8l3.b2", knl=[0.0, 0.0, 0.0, "-kco.a23b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a23b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.b8l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mb.a8l3.b2", angle="-ab.a23", k0="-kb.a23", extra=dict(polarity=1.0))
env.set("mcs.a8l3.b2", k2="-kcs.a23b2", extra=dict(polarity=1.0))
env.set("mq.7l3.b2", k1="-kqf.a23", extra=dict(polarity=1.0))
env.set("mqtli.7l3.b2", k1="-kqtl7.l3b2", extra=dict(polarity=1.0))
env.set("mcbch.7l3.b2", knl=["-(-acbch7.l3b2)"], extra=dict(polarity=1.0))
env.set("mcbcv.6l3.b2", ksl=["-acbcv6.l3b2"], extra=dict(polarity=1.0))
env.set("mqtlh.f6l3.b2", k1="-kq6.l3b2", extra=dict(polarity=-1.0))
env.set("mqtlh.e6l3.b2", k1="-kq6.l3b2", extra=dict(polarity=-1.0))
env.set("mqtlh.d6l3.b2", k1="-kq6.l3b2", extra=dict(polarity=-1.0))
env.set("mqtlh.c6l3.b2", k1="-kq6.l3b2", extra=dict(polarity=-1.0))
env.set("mqtlh.b6l3.b2", k1="-kq6.l3b2", extra=dict(polarity=-1.0))
env.set("mqtlh.a6l3.b2", k1="-kq6.l3b2", extra=dict(polarity=-1.0))
env.set("mbw.f6l3.b2", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.e6l3.b2", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.d6l3.b2", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.c6l3.b2", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.b6l3.b2", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.a6l3.b2", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=1.0))
env.set("mqwa.e5l3.b2", k1="kq5.lr3", extra=dict(polarity=1.0))
env.set("mqwa.d5l3.b2", k1="kq5.lr3", extra=dict(polarity=1.0))
env.set("mqwa.c5l3.b2", k1="kq5.lr3", extra=dict(polarity=1.0))
env.set("mqwb.5l3.b2", k1="-kqt5.l3", extra=dict(polarity=-1.0))
env.set("mqwa.b5l3.b2", k1="kq5.lr3", extra=dict(polarity=1.0))
env.set("mqwa.a5l3.b2", k1="kq5.lr3", extra=dict(polarity=1.0))
env.set("mcbwh.5l3.b2", knl=["-(-acbwh5.l3b2)"], extra=dict(polarity=1.0))
env.set("mqwa.e4l3.b2", k1="kq4.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.d4l3.b2", k1="kq4.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.c4l3.b2", k1="kq4.lr3", extra=dict(polarity=-1.0))
env.set("mqwb.4l3.b2", k1="-kqt4.l3", extra=dict(polarity=1.0))
env.set("mqwa.b4l3.b2", k1="kq4.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.a4l3.b2", k1="kq4.lr3", extra=dict(polarity=-1.0))
env.set("mcbwv.4l3.b2", ksl=["-acbwv4.l3b2"], extra=dict(polarity=1.0))
env.set("mcbwh.4r3.b2", knl=["-(-acbwh4.r3b2)"], extra=dict(polarity=1.0))
env.set("mqwa.a4r3.b2", k1="-kq4.lr3", extra=dict(polarity=1.0))
env.set("mqwa.b4r3.b2", k1="-kq4.lr3", extra=dict(polarity=1.0))
env.set("mqwb.4r3.b2", k1="-kqt4.r3", extra=dict(polarity=-1.0))
env.set("mqwa.c4r3.b2", k1="-kq4.lr3", extra=dict(polarity=1.0))
env.set("mqwa.d4r3.b2", k1="-kq4.lr3", extra=dict(polarity=1.0))
env.set("mqwa.e4r3.b2", k1="-kq4.lr3", extra=dict(polarity=1.0))
env.set("mcbwv.5r3.b2", ksl=["-acbwv5.r3b2"], extra=dict(polarity=1.0))
env.set("mqwa.a5r3.b2", k1="-kq5.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.b5r3.b2", k1="-kq5.lr3", extra=dict(polarity=-1.0))
env.set("mqwb.5r3.b2", k1="-kqt5.r3", extra=dict(polarity=1.0))
env.set("mqwa.c5r3.b2", k1="-kq5.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.d5r3.b2", k1="-kq5.lr3", extra=dict(polarity=-1.0))
env.set("mqwa.e5r3.b2", k1="-kq5.lr3", extra=dict(polarity=-1.0))
env.set("mbw.a6r3.b2", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.b6r3.b2", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.c6r3.b2", angle="-ad34.lr3", k0="-kd34.lr3", extra=dict(polarity=1.0))
env.set("mbw.d6r3.b2", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.e6r3.b2", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=-1.0))
env.set("mbw.f6r3.b2", angle="ad34.lr3", k0="kd34.lr3", extra=dict(polarity=-1.0))
env.set("mcbch.6r3.b2", knl=["-(-acbch6.r3b2)"], extra=dict(polarity=1.0))
env.set("mqtlh.a6r3.b2", k1="-kq6.r3b2", extra=dict(polarity=1.0))
env.set("mqtlh.b6r3.b2", k1="-kq6.r3b2", extra=dict(polarity=1.0))
env.set("mqtlh.c6r3.b2", k1="-kq6.r3b2", extra=dict(polarity=1.0))
env.set("mqtlh.d6r3.b2", k1="-kq6.r3b2", extra=dict(polarity=1.0))
env.set("mqtlh.e6r3.b2", k1="-kq6.r3b2", extra=dict(polarity=1.0))
env.set("mqtlh.f6r3.b2", k1="-kq6.r3b2", extra=dict(polarity=1.0))
env.set("mq.7r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("mqtli.7r3.b2", k1="-kqtl7.r3b2", extra=dict(polarity=-1.0))
env.set("mcbcv.7r3.b2", ksl=["-acbcv7.r3b2"], extra=dict(polarity=1.0))
env.set("mco.8r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a8r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b8r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b8r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mq.8r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("mqtli.8r3.b2", k1="-kqtl8.r3b2", extra=dict(polarity=1.0))
env.set("mcbch.8r3.b2", knl=["-(-acbch8.r3b2)"], extra=dict(polarity=1.0))
env.set("mco.9r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a9r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b9r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b9r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mq.9r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("mqtli.a9r3.b2", k1="-kqtl9.r3b2", extra=dict(polarity=-1.0))
env.set("mqtli.b9r3.b2", k1="-kqtl9.r3b2", extra=dict(polarity=-1.0))
env.set("mcbcv.9r3.b2", ksl=["-acbcv9.r3b2"], extra=dict(polarity=1.0))
env.set("mco.10r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a10r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b10r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b10r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mq.10r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("mqtli.10r3.b2", k1="-kqtl10.r3b2", extra=dict(polarity=1.0))
env.set("mcbch.10r3.b2", knl=["-(-acbch10.r3b2)"], extra=dict(polarity=1.0))
env.set("mco.11r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a11r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b11r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b11r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mq.11r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("mqtli.11r3.b2", k1="-kqtl11.r3b2", extra=dict(polarity=-1.0))
env.set("ms.11r3.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.11r3.b2", ksl=["-acbv11.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a12r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a12r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b12r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b12r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b12r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c12r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.12r3.b2", k1="-kqt12.r3b2", extra=dict(polarity=1.0))
env.set("mq.12r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.12r3.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.12r3.b2", knl=["-(-acbh12.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a13r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a13r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.13r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b13r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c13r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c13r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.13r3.b2", k1="-kqt13.r3b2", extra=dict(polarity=-1.0))
env.set("mq.13r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.13r3.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.13r3.b2", ksl=["-acbv13.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a14r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a14r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b14r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b14r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b14r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c14r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.14r3.b2", k1="-kqtf.a34b2", extra=dict(polarity=1.0))
env.set("mq.14r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.14r3.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.14r3.b2", knl=["-(-acbh14.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a15r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a15r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.15r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b15r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c15r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c15r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.15r3.b2", k1="-kqtd.a34b2", extra=dict(polarity=-1.0))
env.set("mq.15r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.15r3.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.15r3.b2", ksl=["-acbv15.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a16r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a16r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b16r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b16r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b16r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c16r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.16r3.b2", k1="-kqtf.a34b2", extra=dict(polarity=1.0))
env.set("mq.16r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.16r3.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.16r3.b2", knl=["-(-acbh16.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a17r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a17r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.17r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b17r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c17r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c17r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.17r3.b2", k1="-kqtd.a34b2", extra=dict(polarity=-1.0))
env.set("mq.17r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.17r3.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.17r3.b2", ksl=["-acbv17.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a18r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a18r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b18r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b18r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b18r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c18r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.18r3.b2", k1="-kqtf.a34b2", extra=dict(polarity=1.0))
env.set("mq.18r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.18r3.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.18r3.b2", knl=["-(-acbh18.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a19r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a19r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.19r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b19r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c19r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c19r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.19r3.b2", k1="-kqtd.a34b2", extra=dict(polarity=-1.0))
env.set("mq.19r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.19r3.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.19r3.b2", ksl=["-acbv19.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a20r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a20r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b20r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b20r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b20r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c20r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.20r3.b2", k1="-kqtf.a34b2", extra=dict(polarity=1.0))
env.set("mq.20r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.20r3.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.20r3.b2", knl=["-(-acbh20.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a21r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a21r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.21r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b21r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c21r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c21r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.21r3.b2", k1="-kqtd.a34b2", extra=dict(polarity=-1.0))
env.set("mq.21r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.21r3.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.21r3.b2", ksl=["-acbv21.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a22r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a22r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b22r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b22r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b22r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c22r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.22r3.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.22r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.22r3.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.22r3.b2", knl=["-(-acbh22.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a23r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a23r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.23r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b23r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c23r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c23r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqs.23r3.b2", k1s="-kqs.a34b2", extra=dict(polarity=-1.0))
env.set("mq.23r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.23r3.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.23r3.b2", ksl=["-acbv23.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a24r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a24r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b24r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b24r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b24r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c24r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.24r3.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.24r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.24r3.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.24r3.b2", knl=["-(-acbh24.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a25r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a25r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.25r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b25r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c25r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c25r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.25r3.b2", k3="-kod.a34b2", extra=dict(polarity=-1.0))
env.set("mq.25r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.25r3.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.25r3.b2", ksl=["-acbv25.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a26r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a26r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b26r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b26r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b26r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c26r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.26r3.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.26r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.26r3.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.26r3.b2", knl=["-(-acbh26.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a27r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a27r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.27r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b27r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c27r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c27r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqs.27r3.b2", k1s="-kqs.a34b2", extra=dict(polarity=-1.0))
env.set("mq.27r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.27r3.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.27r3.b2", ksl=["-acbv27.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a28r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a28r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b28r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b28r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b28r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c28r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.28r3.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.28r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.28r3.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.28r3.b2", knl=["-(-acbh28.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a29r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a29r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.29r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b29r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c29r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c29r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.29r3.b2", k3="-kod.a34b2", extra=dict(polarity=-1.0))
env.set("mq.29r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.29r3.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.29r3.b2", ksl=["-acbv29.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a30r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a30r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b30r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b30r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mcd.b30r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c30r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.30r3.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.30r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("mss.30r3.b2", k2s="-kss.a34b2", extra=dict(polarity=-1.0))
env.set("mcbh.30r3.b2", knl=["-(-acbh30.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a31r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a31r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.31r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b31r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c31r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c31r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.31r3.b2", k3="-kod.a34b2", extra=dict(polarity=-1.0))
env.set("mq.31r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.31r3.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.31r3.b2", ksl=["-acbv31.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a32r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a32r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b32r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b32r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b32r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c32r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.32r3.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.32r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.32r3.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.32r3.b2", knl=["-(-acbh32.r3b2)"], extra=dict(polarity=1.0))
env.set("mb.a33r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a33r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.33r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b33r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.c33r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c33r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.33r3.b2", k3="-kod.a34b2", extra=dict(polarity=-1.0))
env.set("mq.33r3.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.33r3.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.33r3.b2", ksl=["-acbv33.r3b2"], extra=dict(polarity=1.0))
env.set("mco.a34r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a34r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b34r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b34r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.b34r3.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r3.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r3.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c34r3.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.34r3.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.34r3.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("mss.34l4.b2", k2s="-kss.a34b2", extra=dict(polarity=-1.0))
env.set("mcbh.34l4.b2", knl=["-(-acbh34.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c34l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c34l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.34l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b34l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a34l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a34l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.33l4.b2", k3="-kod.a34b2", extra=dict(polarity=-1.0))
env.set("mq.33l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.33l4.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.33l4.b2", ksl=["-acbv33.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b33l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c33l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b33l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b33l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a33l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a33l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.32l4.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.32l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("mss.32l4.b2", k2s="-kss.a34b2", extra=dict(polarity=-1.0))
env.set("mcbh.32l4.b2", knl=["-(-acbh32.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c32l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c32l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.32l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b32l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a32l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a32l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.31l4.b2", k3="-kod.a34b2", extra=dict(polarity=-1.0))
env.set("mq.31l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.31l4.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.31l4.b2", ksl=["-acbv31.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b31l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c31l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b31l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b31l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a31l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a31l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.30l4.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.30l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.30l4.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.30l4.b2", knl=["-(-acbh30.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c30l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c30l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.30l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b30l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a30l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a30l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.29l4.b2", k3="-kod.a34b2", extra=dict(polarity=-1.0))
env.set("mq.29l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.29l4.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.29l4.b2", ksl=["-acbv29.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b29l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c29l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b29l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b29l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a29l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a29l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.28l4.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.28l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("mss.28l4.b2", k2s="-kss.a34b2", extra=dict(polarity=-1.0))
env.set("mcbh.28l4.b2", knl=["-(-acbh28.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c28l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c28l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.28l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b28l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a28l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a28l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqs.27l4.b2", k1s="-kqs.a34b2", extra=dict(polarity=-1.0))
env.set("mq.27l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.27l4.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.27l4.b2", ksl=["-acbv27.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b27l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c27l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b27l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b27l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a27l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a27l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.26l4.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.26l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.26l4.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.26l4.b2", knl=["-(-acbh26.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c26l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c26l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.26l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b26l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a26l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a26l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.25l4.b2", k3="-kod.a34b2", extra=dict(polarity=-1.0))
env.set("mq.25l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.25l4.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.25l4.b2", ksl=["-acbv25.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b25l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c25l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b25l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b25l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a25l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a25l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.24l4.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.24l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.24l4.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.24l4.b2", knl=["-(-acbh24.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c24l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c24l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.24l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b24l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a24l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a24l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqs.23l4.b2", k1s="-kqs.a34b2", extra=dict(polarity=-1.0))
env.set("mq.23l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.23l4.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.23l4.b2", ksl=["-acbv23.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b23l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c23l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b23l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b23l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a23l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a23l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mo.22l4.b2", k3="-kof.a34b2", extra=dict(polarity=1.0))
env.set("mq.22l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.22l4.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.22l4.b2", knl=["-(-acbh22.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c22l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c22l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.22l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b22l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a22l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mqt.21l4.b2", k1="-kqtd.a34b2", extra=dict(polarity=-1.0))
env.set("mq.21l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.21l4.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.21l4.b2", ksl=["-acbv21.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b21l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c21l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b21l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b21l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a21l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a21l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.20l4.b2", k1="-kqtf.a34b2", extra=dict(polarity=1.0))
env.set("mq.20l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.20l4.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.20l4.b2", knl=["-(-acbh20.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c20l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c20l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.20l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b20l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a20l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a20l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.19l4.b2", k1="-kqtd.a34b2", extra=dict(polarity=-1.0))
env.set("mq.19l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.19l4.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.19l4.b2", ksl=["-acbv19.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b19l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c19l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b19l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b19l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a19l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a19l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.18l4.b2", k1="-kqtf.a34b2", extra=dict(polarity=1.0))
env.set("mq.18l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.18l4.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.18l4.b2", knl=["-(-acbh18.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c18l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c18l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.18l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mb.a18l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a18l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.17l4.b2", k1="-kqtd.a34b2", extra=dict(polarity=-1.0))
env.set("mq.17l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.17l4.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.17l4.b2", ksl=["-acbv17.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b17l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c17l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b17l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b17l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a17l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a17l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.16l4.b2", k1="-kqtf.a34b2", extra=dict(polarity=1.0))
env.set("mq.16l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.16l4.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.16l4.b2", knl=["-(-acbh16.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c16l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c16l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.16l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b16l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a16l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a16l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.15l4.b2", k1="-kqtd.a34b2", extra=dict(polarity=-1.0))
env.set("mq.15l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.15l4.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.15l4.b2", ksl=["-acbv15.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b15l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c15l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b15l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mco.a15l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a15l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.14l4.b2", k1="-kqtf.a34b2", extra=dict(polarity=1.0))
env.set("mq.14l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.14l4.b2", k2="-ksf2.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.14l4.b2", knl=["-(-acbh14.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c14l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c14l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.14l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b14l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a14l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a14l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.13l4.b2", k1="-kqt13.l4b2", extra=dict(polarity=-1.0))
env.set("mq.13l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("ms.13l4.b2", k2="-ksd1.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.13l4.b2", ksl=["-acbv13.l4b2"], extra=dict(polarity=1.0))
env.set("mco.b13l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c13l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.b13l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b13l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.a13l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a13l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqt.12l4.b2", k1="-kqt12.l4b2", extra=dict(polarity=1.0))
env.set("mq.12l4.b2", k1="-kqf.a34", extra=dict(polarity=1.0))
env.set("ms.12l4.b2", k2="-ksf1.a34b2", extra=dict(polarity=1.0))
env.set("mcbh.12l4.b2", knl=["-(-acbh12.l4b2)"], extra=dict(polarity=1.0))
env.set("mb.c12l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.c12l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mco.12l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b12l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a12l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a12l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mq.11l4.b2", k1="-kqd.a34", extra=dict(polarity=-1.0))
env.set("mqtli.11l4.b2", k1="-kqtl11.l4b2", extra=dict(polarity=-1.0))
env.set("ms.11l4.b2", k2="-ksd2.a34b2", extra=dict(polarity=-1.0))
env.set("mcbv.11l4.b2", ksl=["-acbv11.l4b2"], extra=dict(polarity=1.0))
env.set("mco.11l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b11l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a11l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a11l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqml.10l4.b2", k1="-kq10.l4b2", extra=dict(polarity=1.0))
env.set("mcbch.10l4.b2", knl=["-(-acbch10.l4b2)"], extra=dict(polarity=1.0))
env.set("mco.10l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b10l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a10l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a10l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqmc.9l4.b2", k1="-kq9.l4b2", extra=dict(polarity=-1.0))
env.set("mqm.9l4.b2", k1="-kq9.l4b2", extra=dict(polarity=-1.0))
env.set("mcbcv.9l4.b2", ksl=["-acbcv9.l4b2"], extra=dict(polarity=1.0))
env.set("mco.9l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b9l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a9l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a9l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqml.8l4.b2", k1="-kq8.l4b2", extra=dict(polarity=1.0))
env.set("mcbch.8l4.b2", knl=["-(-acbch8.l4b2)"], extra=dict(polarity=1.0))
env.set("mco.8l4.b2", knl=[0.0, 0.0, 0.0, "-kco.a34b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a34b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.b8l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mb.a8l4.b2", angle="-ab.a34", k0="-kb.a34", extra=dict(polarity=1.0))
env.set("mcs.a8l4.b2", k2="-kcs.a34b2", extra=dict(polarity=1.0))
env.set("mqm.7l4.b2", k1="-kq7.l4b2", extra=dict(polarity=-1.0))
env.set("mcbcv.7l4.b2", ksl=["-acbcv7.l4b2"], extra=dict(polarity=1.0))
env.set("mqy.6l4.b2", k1="-kq6.l4b2", extra=dict(polarity=1.0))
env.set("mcbyh.6l4.b2", knl=["-(-acbyh6.l4b2)"], extra=dict(polarity=1.0))
env.set("mkqa.6l4.b2", knl=["-(khmkqa.l4b2)"], ksl=["kvmkqa.l4b2"])
env.set("mqy.5l4.b2", k1="-kq5.l4b2", extra=dict(polarity=-1.0))
env.set("mcbyv.5l4.b2", ksl=["-acbyv5.l4b2"], extra=dict(polarity=1.0))
env.set("mbrb.5l4.b2", angle="ad4.l4", k0="kd4.l4", extra=dict(polarity=-1.0))
env.set("mbrs.5l4.b2", angle="-ad3.l4", k0="-kd3.l4", extra=dict(polarity=1.0))
env.set("mu.d5l4.b2", knl=["-(kmu.l4b2)"], extra=dict(polarity=-1.0))
env.set("mu.c5l4.b2", knl=["-(kmu.l4b2)"], extra=dict(polarity=-1.0))
env.set("mu.b5l4.b2", knl=["-(kmu.l4b2)"], extra=dict(polarity=-1.0))
env.set("mu.a5l4.b2", knl=["-(kmu.l4b2)"], extra=dict(polarity=-1.0))
env.set("adtkv.d5l4.b2", ksl=["akadtkv.l4b2"])
env.set("adtkv.c5l4.b2", ksl=["akadtkv.l4b2"])
env.set("adtkv.b5l4.b2", ksl=["akadtkv.l4b2"])
env.set("adtkv.a5l4.b2", ksl=["akadtkv.l4b2"])
env.set("adtkh.a5r4.b2", knl=["-(akadtkh.r4b2)"])
env.set("adtkh.b5r4.b2", knl=["-(akadtkh.r4b2)"])
env.set("adtkh.c5r4.b2", knl=["-(akadtkh.r4b2)"])
env.set("adtkh.d5r4.b2", knl=["-(akadtkh.r4b2)"])
env.set("mbrs.5r4.b2", angle="-ad3.r4", k0="-kd3.r4", extra=dict(polarity=1.0))
env.set("mgmwv.a5r4.b2", ksl=["-kgmwv.r4b2"], extra=dict(polarity=-1.0))
env.set("mgmwv.c5r4.b2", ksl=["kgmwv.r4b2"], extra=dict(polarity=1.0))
env.set("mgmwh.c5r4.b2", knl=["-(-kgmwh.r4b2)"], extra=dict(polarity=1.0))
env.set("mgmwh.a5r4.b2", knl=["-(kgmwh.r4b2)"], extra=dict(polarity=-1.0))
env.set("mbrb.5r4.b2", angle="ad4.r4", k0="kd4.r4", extra=dict(polarity=-1.0))
env.set("mcbyh.5r4.b2", knl=["-(-acbyh5.r4b2)"], extra=dict(polarity=1.0))
env.set("mqy.5r4.b2", k1="-kq5.r4b2", extra=dict(polarity=1.0))
env.set("bqkh.a6r4.b2", knl=["-(akbqkh.r4b2)"])
env.set("bqkv.6r4.b2", ksl=["akbqkv.r4b2"])
env.set("mqy.6r4.b2", k1="-kq6.r4b2", extra=dict(polarity=-1.0))
env.set("mcbyv.6r4.b2", ksl=["-acbyv6.r4b2"], extra=dict(polarity=1.0))
env.set("mqm.7r4.b2", k1="-kq7.r4b2", extra=dict(polarity=1.0))
env.set("mcbch.7r4.b2", knl=["-(-acbch7.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.8r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a8r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b8r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b8r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqml.8r4.b2", k1="-kq8.r4b2", extra=dict(polarity=-1.0))
env.set("mcbcv.8r4.b2", ksl=["-acbcv8.r4b2"], extra=dict(polarity=1.0))
env.set("mco.9r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a9r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b9r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b9r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqmc.9r4.b2", k1="-kq9.r4b2", extra=dict(polarity=1.0))
env.set("mqm.9r4.b2", k1="-kq9.r4b2", extra=dict(polarity=1.0))
env.set("mcbch.9r4.b2", knl=["-(-acbch9.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.10r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a10r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b10r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b10r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqml.10r4.b2", k1="-kq10.r4b2", extra=dict(polarity=-1.0))
env.set("mcbcv.10r4.b2", ksl=["-acbcv10.r4b2"], extra=dict(polarity=1.0))
env.set("mco.11r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a11r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b11r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b11r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mq.11r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("mqtli.11r4.b2", k1="-kqtl11.r4b2", extra=dict(polarity=1.0))
env.set("ms.11r4.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.11r4.b2", knl=["-(-acbh11.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a12r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a12r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b12r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b12r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b12r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c12r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.12r4.b2", k1="-kqt12.r4b2", extra=dict(polarity=-1.0))
env.set("mq.12r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.12r4.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.12r4.b2", ksl=["-acbv12.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a13r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a13r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.13r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b13r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c13r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c13r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.13r4.b2", k1="-kqt13.r4b2", extra=dict(polarity=1.0))
env.set("mq.13r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.13r4.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.13r4.b2", knl=["-(-acbh13.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a14r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a14r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b14r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b14r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b14r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c14r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.14r4.b2", k1="-kqtd.a45b2", extra=dict(polarity=-1.0))
env.set("mq.14r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.14r4.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.14r4.b2", ksl=["-acbv14.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a15r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a15r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.15r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b15r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c15r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c15r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.15r4.b2", k1="-kqtf.a45b2", extra=dict(polarity=1.0))
env.set("mq.15r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.15r4.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.15r4.b2", knl=["-(-acbh15.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a16r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a16r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b16r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b16r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b16r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c16r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.16r4.b2", k1="-kqtd.a45b2", extra=dict(polarity=-1.0))
env.set("mq.16r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.16r4.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.16r4.b2", ksl=["-acbv16.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a17r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a17r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.17r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b17r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c17r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c17r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.17r4.b2", k1="-kqtf.a45b2", extra=dict(polarity=1.0))
env.set("mq.17r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.17r4.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.17r4.b2", knl=["-(-acbh17.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a18r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a18r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b18r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b18r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b18r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c18r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.18r4.b2", k1="-kqtd.a45b2", extra=dict(polarity=-1.0))
env.set("mq.18r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.18r4.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.18r4.b2", ksl=["-acbv18.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a19r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a19r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.19r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b19r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c19r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c19r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.19r4.b2", k1="-kqtf.a45b2", extra=dict(polarity=1.0))
env.set("mq.19r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.19r4.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.19r4.b2", knl=["-(-acbh19.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a20r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a20r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b20r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b20r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b20r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c20r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.20r4.b2", k1="-kqtd.a45b2", extra=dict(polarity=-1.0))
env.set("mq.20r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.20r4.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.20r4.b2", ksl=["-acbv20.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a21r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a21r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.21r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b21r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c21r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c21r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.21r4.b2", k1="-kqtf.a45b2", extra=dict(polarity=1.0))
env.set("mq.21r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.21r4.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.21r4.b2", knl=["-(-acbh21.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a22r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a22r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b22r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b22r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b22r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c22r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.22r4.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.22r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.22r4.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.22r4.b2", ksl=["-acbv22.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a23r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a23r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.23r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b23r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c23r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c23r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqs.23r4.b2", k1s="-kqs.r4b2", extra=dict(polarity=-1.0))
env.set("mq.23r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.23r4.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.23r4.b2", knl=["-(-acbh23.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a24r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a24r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b24r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b24r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b24r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c24r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.24r4.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.24r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.24r4.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.24r4.b2", ksl=["-acbv24.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a25r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a25r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.25r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b25r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c25r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c25r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.25r4.b2", k3="-kof.a45b2", extra=dict(polarity=1.0))
env.set("mq.25r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.25r4.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.25r4.b2", knl=["-(-acbh25.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a26r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a26r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b26r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b26r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b26r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c26r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.26r4.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.26r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.26r4.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.26r4.b2", ksl=["-acbv26.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a27r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a27r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.27r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b27r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c27r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c27r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqs.27r4.b2", k1s="-kqs.r4b2", extra=dict(polarity=-1.0))
env.set("mq.27r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.27r4.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.27r4.b2", knl=["-(-acbh27.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a28r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a28r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b28r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b28r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b28r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c28r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.28r4.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.28r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.28r4.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.28r4.b2", ksl=["-acbv28.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a29r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a29r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.29r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b29r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c29r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c29r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.29r4.b2", k3="-kof.a45b2", extra=dict(polarity=1.0))
env.set("mq.29r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("mss.29r4.b2", k2s="-kss.a45b2", extra=dict(polarity=-1.0))
env.set("mcbh.29r4.b2", knl=["-(-acbh29.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a30r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a30r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b30r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b30r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b30r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c30r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.30r4.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.30r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.30r4.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.30r4.b2", ksl=["-acbv30.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a31r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a31r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.31r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b31r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c31r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c31r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.31r4.b2", k3="-kof.a45b2", extra=dict(polarity=1.0))
env.set("mq.31r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.31r4.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.31r4.b2", knl=["-(-acbh31.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a32r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a32r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b32r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b32r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b32r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c32r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.32r4.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.32r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.32r4.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.32r4.b2", ksl=["-acbv32.r4b2"], extra=dict(polarity=1.0))
env.set("mb.a33r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a33r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.33r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b33r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.c33r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c33r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.33r4.b2", k3="-kof.a45b2", extra=dict(polarity=1.0))
env.set("mq.33r4.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("mss.33r4.b2", k2s="-kss.a45b2", extra=dict(polarity=-1.0))
env.set("mcbh.33r4.b2", knl=["-(-acbh33.r4b2)"], extra=dict(polarity=1.0))
env.set("mco.a34r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a34r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b34r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b34r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.b34r4.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r4.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r4.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c34r4.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.34r4.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.34r4.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.34l5.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.34l5.b2", ksl=["-acbv34.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c34l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c34l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.34l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b34l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a34l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a34l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.33l5.b2", k3="-kof.a45b2", extra=dict(polarity=1.0))
env.set("mq.33l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("mss.33l5.b2", k2s="-kss.a45b2", extra=dict(polarity=-1.0))
env.set("mcbh.33l5.b2", knl=["-(-acbh33.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b33l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c33l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b33l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b33l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a33l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a33l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.32l5.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.32l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.32l5.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.32l5.b2", ksl=["-acbv32.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c32l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c32l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.32l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b32l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a32l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a32l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.31l5.b2", k3="-kof.a45b2", extra=dict(polarity=1.0))
env.set("mq.31l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.31l5.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.31l5.b2", knl=["-(-acbh31.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b31l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c31l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b31l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b31l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a31l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a31l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.30l5.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.30l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.30l5.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.30l5.b2", ksl=["-acbv30.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c30l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c30l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.30l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b30l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a30l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a30l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.29l5.b2", k3="-kof.a45b2", extra=dict(polarity=1.0))
env.set("mq.29l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("mss.29l5.b2", k2s="-kss.a45b2", extra=dict(polarity=-1.0))
env.set("mcbh.29l5.b2", knl=["-(-acbh29.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b29l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c29l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b29l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b29l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a29l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a29l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.28l5.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.28l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.28l5.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.28l5.b2", ksl=["-acbv28.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c28l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c28l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.28l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b28l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a28l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a28l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqs.27l5.b2", k1s="-kqs.l5b2", extra=dict(polarity=-1.0))
env.set("mq.27l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.27l5.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.27l5.b2", knl=["-(-acbh27.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b27l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c27l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b27l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b27l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a27l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a27l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.26l5.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.26l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.26l5.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.26l5.b2", ksl=["-acbv26.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c26l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c26l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.26l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b26l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a26l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a26l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.25l5.b2", k3="-kof.a45b2", extra=dict(polarity=1.0))
env.set("mq.25l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.25l5.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.25l5.b2", knl=["-(-acbh25.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b25l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c25l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b25l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b25l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a25l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a25l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.24l5.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.24l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.24l5.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.24l5.b2", ksl=["-acbv24.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c24l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c24l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.24l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b24l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a24l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a24l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqs.23l5.b2", k1s="-kqs.l5b2", extra=dict(polarity=-1.0))
env.set("mq.23l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.23l5.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.23l5.b2", knl=["-(-acbh23.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b23l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c23l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b23l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b23l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a23l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a23l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mo.22l5.b2", k3="-kod.a45b2", extra=dict(polarity=-1.0))
env.set("mq.22l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.22l5.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.22l5.b2", ksl=["-acbv22.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c22l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c22l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.22l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b22l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a22l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a22l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.21l5.b2", k1="-kqtf.a45b2", extra=dict(polarity=1.0))
env.set("mq.21l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.21l5.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.21l5.b2", knl=["-(-acbh21.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b21l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c21l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b21l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b21l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a21l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a21l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.20l5.b2", k1="-kqtd.a45b2", extra=dict(polarity=-1.0))
env.set("mq.20l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.20l5.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.20l5.b2", ksl=["-acbv20.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c20l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c20l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.20l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b20l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a20l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a20l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.19l5.b2", k1="-kqtf.a45b2", extra=dict(polarity=1.0))
env.set("mq.19l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.19l5.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.19l5.b2", knl=["-(-acbh19.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b19l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c19l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b19l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b19l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a19l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a19l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.18l5.b2", k1="-kqtd.a45b2", extra=dict(polarity=-1.0))
env.set("mq.18l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.18l5.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.18l5.b2", ksl=["-acbv18.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c18l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c18l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.18l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b18l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a18l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a18l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.17l5.b2", k1="-kqtf.a45b2", extra=dict(polarity=1.0))
env.set("mq.17l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.17l5.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.17l5.b2", knl=["-(-acbh17.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b17l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c17l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b17l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b17l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a17l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a17l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.16l5.b2", k1="-kqtd.a45b2", extra=dict(polarity=-1.0))
env.set("mq.16l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.16l5.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.16l5.b2", ksl=["-acbv16.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c16l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c16l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.16l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b16l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a16l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a16l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.15l5.b2", k1="-kqtf.a45b2", extra=dict(polarity=1.0))
env.set("mq.15l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.15l5.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.15l5.b2", knl=["-(-acbh15.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b15l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c15l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b15l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b15l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a15l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a15l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.14l5.b2", k1="-kqtd.a45b2", extra=dict(polarity=-1.0))
env.set("mq.14l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.14l5.b2", k2="-ksd1.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.14l5.b2", ksl=["-acbv14.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c14l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c14l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.14l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b14l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a14l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a14l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.13l5.b2", k1="-kqt13.l5b2", extra=dict(polarity=1.0))
env.set("mq.13l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("ms.13l5.b2", k2="-ksf1.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.13l5.b2", knl=["-(-acbh13.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.b13l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c13l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.b13l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b13l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.a13l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a13l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqt.12l5.b2", k1="-kqt12.l5b2", extra=dict(polarity=-1.0))
env.set("mq.12l5.b2", k1="-kqd.a45", extra=dict(polarity=-1.0))
env.set("ms.12l5.b2", k2="-ksd2.a45b2", extra=dict(polarity=-1.0))
env.set("mcbv.12l5.b2", ksl=["-acbv12.l5b2"], extra=dict(polarity=1.0))
env.set("mb.c12l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.c12l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mco.12l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b12l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a12l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a12l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mq.11l5.b2", k1="-kqf.a45", extra=dict(polarity=1.0))
env.set("mqtli.11l5.b2", k1="-kqtl11.l5b2", extra=dict(polarity=1.0))
env.set("ms.11l5.b2", k2="-ksf2.a45b2", extra=dict(polarity=1.0))
env.set("mcbh.11l5.b2", knl=["-(-acbh11.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.11l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b11l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a11l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a11l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqml.10l5.b2", k1="-kq10.l5b2", extra=dict(polarity=-1.0))
env.set("mcbcv.10l5.b2", ksl=["-acbcv10.l5b2"], extra=dict(polarity=1.0))
env.set("mco.10l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b10l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a10l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a10l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqmc.9l5.b2", k1="-kq9.l5b2", extra=dict(polarity=1.0))
env.set("mqm.9l5.b2", k1="-kq9.l5b2", extra=dict(polarity=1.0))
env.set("mcbch.9l5.b2", knl=["-(-acbch9.l5b2)"], extra=dict(polarity=1.0))
env.set("mco.9l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b9l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a9l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a9l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqml.8l5.b2", k1="-kq8.l5b2", extra=dict(polarity=-1.0))
env.set("mcbcv.8l5.b2", ksl=["-acbcv8.l5b2"], extra=dict(polarity=1.0))
env.set("mco.8l5.b2", knl=[0.0, 0.0, 0.0, "-kco.a45b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a45b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.b8l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mb.a8l5.b2", angle="-ab.a45", k0="-kb.a45", extra=dict(polarity=1.0))
env.set("mcs.a8l5.b2", k2="-kcs.a45b2", extra=dict(polarity=1.0))
env.set("mqm.b7l5.b2", k1="-kq7.l5b2", extra=dict(polarity=1.0))
env.set("mqm.a7l5.b2", k1="-kq7.l5b2", extra=dict(polarity=1.0))
env.set("mcbch.7l5.b2", knl=["-(-acbch7.l5b2)"], extra=dict(polarity=1.0))
env.set("mqml.6l5.b2", k1="-kq6.l5b2", extra=dict(polarity=-1.0))
env.set("mcbcv.6l5.b2", ksl=["-acbcv6.l5b2"], extra=dict(polarity=1.0))
env.set("mqml.5l5.b2", k1="-kq5.l5b2", extra=dict(polarity=1.0))
env.set("mcbch.5l5.b2", knl=["-(-acbch5.l5b2)"], extra=dict(polarity=1.0))
env.set("mqy.4l5.b2", k1="-kq4.l5b2", extra=dict(polarity=-1.0))
env.set("mcbyv.b4l5.b2", ksl=["-acbyv4.l5b2"], extra=dict(polarity=1.0))
env.set("mcbyh.4l5.b2", knl=["-(-acbyhs4.l5b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.a4l5.b2", ksl=["-acbyvs4.l5b2"], extra=dict(polarity=1.0))
env.set("mbrc.4l5.b2", angle="-ad2.l5", k0="-kd2.l5", extra=dict(polarity=1.0))
env.set("mbxw.f4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.e4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.d4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.c4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.b4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mbxw.a4l5", angle="ad1.lr5", k0="kd1.lr5", extra=dict(polarity=1.0))
env.set("mcosx.3l5", ksl=[0.0, 0.0, 0.0, "kcosx3.l5*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3l5", knl=[0.0, 0.0, 0.0, "kcox3.l5*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3l5", ksl=[0.0, 0.0, "kcssx3.l5*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mcbxh.3l5", knl=["-(acbxh3.l5)"], extra=dict(polarity=1.0))
env.set("mcbxv.3l5", ksl=["acbxv3.l5"], extra=dict(polarity=1.0))
env.set("mcsx.3l5", knl=[0.0, 0.0, "kcsx3.l5*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3l5", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.l5*l.mctx"], extra=dict(polarity=1.0))
env.set("mqxa.3l5", k1="kqx.l5", extra=dict(polarity=-1.0))
env.set("mqsx.3l5", k1s="kqsx3.l5", extra=dict(polarity=-1.0))
env.set("mqxb.b2l5", k1="-kqx.l5-ktqx2.l5", extra=dict(polarity=1.0))
env.set("mcbxh.2l5", knl=["-(acbxh2.l5)"], extra=dict(polarity=1.0))
env.set("mcbxv.2l5", ksl=["acbxv2.l5"], extra=dict(polarity=1.0))
env.set("mqxb.a2l5", k1="-kqx.l5-ktqx2.l5", extra=dict(polarity=1.0))
env.set("mcbxh.1l5", knl=["-(acbxh1.l5)"], extra=dict(polarity=1.0))
env.set("mcbxv.1l5", ksl=["acbxv1.l5"], extra=dict(polarity=1.0))
env.set("mqxa.1l5", k1="kqx.l5+ktqx1.l5", extra=dict(polarity=-1.0))
env.set("mbcs2.1l5", ks="abcs")
env.set("mbcs2.1r5", ks="abcs")
env.set("mqxa.1r5", k1="kqx.r5+ktqx1.r5", extra=dict(polarity=1.0))
env.set("mcbxh.1r5", knl=["-(acbxh1.r5)"], extra=dict(polarity=1.0))
env.set("mcbxv.1r5", ksl=["acbxv1.r5"], extra=dict(polarity=1.0))
env.set("mqxb.a2r5", k1="-kqx.r5-ktqx2.r5", extra=dict(polarity=-1.0))
env.set("mcbxh.2r5", knl=["-(acbxh2.r5)"], extra=dict(polarity=1.0))
env.set("mcbxv.2r5", ksl=["acbxv2.r5"], extra=dict(polarity=1.0))
env.set("mqxb.b2r5", k1="-kqx.r5-ktqx2.r5", extra=dict(polarity=-1.0))
env.set("mqsx.3r5", k1s="kqsx3.r5", extra=dict(polarity=-1.0))
env.set("mqxa.3r5", k1="kqx.r5", extra=dict(polarity=1.0))
env.set("mcbxh.3r5", knl=["-(acbxh3.r5)"], extra=dict(polarity=1.0))
env.set("mcbxv.3r5", ksl=["acbxv3.r5"], extra=dict(polarity=1.0))
env.set("mcsx.3r5", knl=[0.0, 0.0, "kcsx3.r5*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3r5", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.r5*l.mctx"], extra=dict(polarity=1.0))
env.set("mcosx.3r5", ksl=[0.0, 0.0, 0.0, "kcosx3.r5*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3r5", knl=[0.0, 0.0, 0.0, "kcox3.r5*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3r5", ksl=[0.0, 0.0, "kcssx3.r5*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mbxw.a4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.b4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.c4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.d4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.e4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbxw.f4r5", angle="-ad1.lr5", k0="-kd1.lr5", extra=dict(polarity=-1.0))
env.set("mbrc.4r5.b2", angle="ad2.r5", k0="kd2.r5", extra=dict(polarity=-1.0))
env.set("mcbyh.a4r5.b2", knl=["-(-acbyhs4.r5b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.4r5.b2", ksl=["-acbyvs4.r5b2"], extra=dict(polarity=1.0))
env.set("mcbyh.b4r5.b2", knl=["-(-acbyh4.r5b2)"], extra=dict(polarity=1.0))
env.set("mqy.4r5.b2", k1="-kq4.r5b2", extra=dict(polarity=1.0))
env.set("mqml.5r5.b2", k1="-kq5.r5b2", extra=dict(polarity=-1.0))
env.set("mcbcv.5r5.b2", ksl=["-acbcv5.r5b2"], extra=dict(polarity=1.0))
env.set("mqml.6r5.b2", k1="-kq6.r5b2", extra=dict(polarity=1.0))
env.set("mcbch.6r5.b2", knl=["-(-acbch6.r5b2)"], extra=dict(polarity=1.0))
env.set("mqm.a7r5.b2", k1="-kq7.r5b2", extra=dict(polarity=-1.0))
env.set("mqm.b7r5.b2", k1="-kq7.r5b2", extra=dict(polarity=-1.0))
env.set("mcbcv.7r5.b2", ksl=["-acbcv7.r5b2"], extra=dict(polarity=1.0))
env.set("mco.8r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a8r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b8r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b8r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqml.8r5.b2", k1="-kq8.r5b2", extra=dict(polarity=1.0))
env.set("mcbch.8r5.b2", knl=["-(-acbch8.r5b2)"], extra=dict(polarity=1.0))
env.set("mco.9r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a9r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b9r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b9r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqmc.9r5.b2", k1="-kq9.r5b2", extra=dict(polarity=-1.0))
env.set("mqm.9r5.b2", k1="-kq9.r5b2", extra=dict(polarity=-1.0))
env.set("mcbcv.9r5.b2", ksl=["-acbcv9.r5b2"], extra=dict(polarity=1.0))
env.set("mco.10r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a10r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b10r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b10r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqml.10r5.b2", k1="-kq10.r5b2", extra=dict(polarity=1.0))
env.set("mcbch.10r5.b2", knl=["-(-acbch10.r5b2)"], extra=dict(polarity=1.0))
env.set("mco.11r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a11r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b11r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b11r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mq.11r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("mqtli.11r5.b2", k1="-kqtl11.r5b2", extra=dict(polarity=-1.0))
env.set("ms.11r5.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.11r5.b2", ksl=["-acbv11.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a12r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a12r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b12r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b12r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b12r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c12r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.12r5.b2", k1="-kqt12.r5b2", extra=dict(polarity=1.0))
env.set("mq.12r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.12r5.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.12r5.b2", knl=["-(-acbh12.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a13r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a13r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.13r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b13r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c13r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c13r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.13r5.b2", k1="-kqt13.r5b2", extra=dict(polarity=-1.0))
env.set("mq.13r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.13r5.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.13r5.b2", ksl=["-acbv13.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a14r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a14r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b14r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b14r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b14r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c14r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.14r5.b2", k1="-kqtf.a56b2", extra=dict(polarity=1.0))
env.set("mq.14r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.14r5.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.14r5.b2", knl=["-(-acbh14.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a15r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a15r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.15r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b15r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c15r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c15r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.15r5.b2", k1="-kqtd.a56b2", extra=dict(polarity=-1.0))
env.set("mq.15r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.15r5.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.15r5.b2", ksl=["-acbv15.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a16r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a16r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b16r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b16r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b16r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c16r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.16r5.b2", k1="-kqtf.a56b2", extra=dict(polarity=1.0))
env.set("mq.16r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.16r5.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.16r5.b2", knl=["-(-acbh16.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a17r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a17r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.17r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b17r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c17r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c17r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.17r5.b2", k1="-kqtd.a56b2", extra=dict(polarity=-1.0))
env.set("mq.17r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.17r5.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.17r5.b2", ksl=["-acbv17.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a18r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a18r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b18r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b18r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b18r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c18r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.18r5.b2", k1="-kqtf.a56b2", extra=dict(polarity=1.0))
env.set("mq.18r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.18r5.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.18r5.b2", knl=["-(-acbh18.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a19r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a19r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.19r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b19r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c19r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c19r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.19r5.b2", k1="-kqtd.a56b2", extra=dict(polarity=-1.0))
env.set("mq.19r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.19r5.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.19r5.b2", ksl=["-acbv19.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a20r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a20r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b20r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b20r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b20r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c20r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.20r5.b2", k1="-kqtf.a56b2", extra=dict(polarity=1.0))
env.set("mq.20r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.20r5.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.20r5.b2", knl=["-(-acbh20.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a21r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a21r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.21r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b21r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c21r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c21r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.21r5.b2", k1="-kqtd.a56b2", extra=dict(polarity=-1.0))
env.set("mq.21r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.21r5.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.21r5.b2", ksl=["-acbv21.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a22r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a22r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b22r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b22r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b22r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c22r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.22r5.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.22r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.22r5.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.22r5.b2", knl=["-(-acbh22.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a23r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a23r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.23r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b23r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c23r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c23r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqs.23r5.b2", k1s="-kqs.a56b2", extra=dict(polarity=-1.0))
env.set("mq.23r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.23r5.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.23r5.b2", ksl=["-acbv23.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a24r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a24r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b24r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b24r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b24r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c24r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.24r5.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.24r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.24r5.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.24r5.b2", knl=["-(-acbh24.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a25r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a25r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.25r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b25r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c25r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c25r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.25r5.b2", k3="-kod.a56b2", extra=dict(polarity=-1.0))
env.set("mq.25r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.25r5.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.25r5.b2", ksl=["-acbv25.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a26r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a26r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b26r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b26r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b26r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c26r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.26r5.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.26r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.26r5.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.26r5.b2", knl=["-(-acbh26.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a27r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a27r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.27r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b27r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c27r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c27r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqs.27r5.b2", k1s="-kqs.a56b2", extra=dict(polarity=-1.0))
env.set("mq.27r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.27r5.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.27r5.b2", ksl=["-acbv27.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a28r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a28r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b28r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b28r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b28r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c28r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.28r5.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.28r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.28r5.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.28r5.b2", knl=["-(-acbh28.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a29r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a29r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.29r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b29r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c29r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c29r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.29r5.b2", k3="-kod.a56b2", extra=dict(polarity=-1.0))
env.set("mq.29r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.29r5.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.29r5.b2", ksl=["-acbv29.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a30r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a30r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b30r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b30r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b30r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c30r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.30r5.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.30r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("mss.30r5.b2", k2s="-kss.a56b2", extra=dict(polarity=-1.0))
env.set("mcbh.30r5.b2", knl=["-(-acbh30.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a31r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a31r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.31r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b31r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c31r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c31r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.31r5.b2", k3="-kod.a56b2", extra=dict(polarity=-1.0))
env.set("mq.31r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.31r5.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.31r5.b2", ksl=["-acbv31.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a32r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a32r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b32r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b32r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b32r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c32r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.32r5.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.32r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.32r5.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.32r5.b2", knl=["-(-acbh32.r5b2)"], extra=dict(polarity=1.0))
env.set("mb.a33r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a33r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.33r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b33r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.c33r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c33r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.33r5.b2", k3="-kod.a56b2", extra=dict(polarity=-1.0))
env.set("mq.33r5.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.33r5.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.33r5.b2", ksl=["-acbv33.r5b2"], extra=dict(polarity=1.0))
env.set("mco.a34r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a34r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b34r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b34r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.b34r5.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r5.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r5.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c34r5.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.34r5.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.34r5.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("mss.34l6.b2", k2s="-kss.a56b2", extra=dict(polarity=-1.0))
env.set("mcbh.34l6.b2", knl=["-(-acbh34.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c34l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c34l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.34l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b34l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a34l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a34l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.33l6.b2", k3="-kod.a56b2", extra=dict(polarity=-1.0))
env.set("mq.33l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.33l6.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.33l6.b2", ksl=["-acbv33.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b33l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c33l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b33l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b33l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a33l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a33l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.32l6.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.32l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("mss.32l6.b2", k2s="-kss.a56b2", extra=dict(polarity=-1.0))
env.set("mcbh.32l6.b2", knl=["-(-acbh32.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c32l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c32l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.32l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b32l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a32l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a32l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.31l6.b2", k3="-kod.a56b2", extra=dict(polarity=-1.0))
env.set("mq.31l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.31l6.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.31l6.b2", ksl=["-acbv31.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b31l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c31l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b31l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b31l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a31l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a31l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.30l6.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.30l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.30l6.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.30l6.b2", knl=["-(-acbh30.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c30l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c30l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.30l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b30l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a30l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a30l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.29l6.b2", k3="-kod.a56b2", extra=dict(polarity=-1.0))
env.set("mq.29l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.29l6.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.29l6.b2", ksl=["-acbv29.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b29l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c29l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b29l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b29l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a29l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a29l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.28l6.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.28l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("mss.28l6.b2", k2s="-kss.a56b2", extra=dict(polarity=-1.0))
env.set("mcbh.28l6.b2", knl=["-(-acbh28.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c28l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c28l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.28l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b28l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a28l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a28l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqs.27l6.b2", k1s="-kqs.a56b2", extra=dict(polarity=-1.0))
env.set("mq.27l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.27l6.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.27l6.b2", ksl=["-acbv27.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b27l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c27l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b27l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b27l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a27l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a27l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.26l6.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.26l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.26l6.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.26l6.b2", knl=["-(-acbh26.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c26l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c26l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.26l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b26l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a26l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a26l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.25l6.b2", k3="-kod.a56b2", extra=dict(polarity=-1.0))
env.set("mq.25l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.25l6.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.25l6.b2", ksl=["-acbv25.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b25l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c25l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b25l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b25l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a25l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a25l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.24l6.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.24l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.24l6.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.24l6.b2", knl=["-(-acbh24.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c24l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c24l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.24l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b24l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a24l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a24l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqs.23l6.b2", k1s="-kqs.a56b2", extra=dict(polarity=-1.0))
env.set("mq.23l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.23l6.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.23l6.b2", ksl=["-acbv23.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b23l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c23l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b23l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b23l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a23l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a23l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mo.22l6.b2", k3="-kof.a56b2", extra=dict(polarity=1.0))
env.set("mq.22l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.22l6.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.22l6.b2", knl=["-(-acbh22.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c22l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c22l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.22l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b22l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a22l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a22l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.21l6.b2", k1="-kqtd.a56b2", extra=dict(polarity=-1.0))
env.set("mq.21l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.21l6.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.21l6.b2", ksl=["-acbv21.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b21l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c21l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b21l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b21l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a21l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a21l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.20l6.b2", k1="-kqtf.a56b2", extra=dict(polarity=1.0))
env.set("mq.20l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.20l6.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.20l6.b2", knl=["-(-acbh20.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c20l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c20l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.20l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b20l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a20l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a20l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.19l6.b2", k1="-kqtd.a56b2", extra=dict(polarity=-1.0))
env.set("mq.19l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.19l6.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.19l6.b2", ksl=["-acbv19.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b19l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c19l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b19l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b19l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a19l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a19l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.18l6.b2", k1="-kqtf.a56b2", extra=dict(polarity=1.0))
env.set("mq.18l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.18l6.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.18l6.b2", knl=["-(-acbh18.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c18l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c18l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.18l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b18l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a18l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a18l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.17l6.b2", k1="-kqtd.a56b2", extra=dict(polarity=-1.0))
env.set("mq.17l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.17l6.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.17l6.b2", ksl=["-acbv17.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b17l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c17l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b17l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b17l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a17l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a17l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.16l6.b2", k1="-kqtf.a56b2", extra=dict(polarity=1.0))
env.set("mq.16l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.16l6.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.16l6.b2", knl=["-(-acbh16.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c16l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c16l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.16l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b16l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a16l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a16l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.15l6.b2", k1="-kqtd.a56b2", extra=dict(polarity=-1.0))
env.set("mq.15l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.15l6.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.15l6.b2", ksl=["-acbv15.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b15l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c15l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b15l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b15l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a15l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a15l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.14l6.b2", k1="-kqtf.a56b2", extra=dict(polarity=1.0))
env.set("mq.14l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.14l6.b2", k2="-ksf2.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.14l6.b2", knl=["-(-acbh14.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c14l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c14l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.14l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b14l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a14l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a14l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.13l6.b2", k1="-kqt13.l6b2", extra=dict(polarity=-1.0))
env.set("mq.13l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("ms.13l6.b2", k2="-ksd1.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.13l6.b2", ksl=["-acbv13.l6b2"], extra=dict(polarity=1.0))
env.set("mco.b13l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c13l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.b13l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b13l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.a13l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a13l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqt.12l6.b2", k1="-kqt12.l6b2", extra=dict(polarity=1.0))
env.set("mq.12l6.b2", k1="-kqf.a56", extra=dict(polarity=1.0))
env.set("ms.12l6.b2", k2="-ksf1.a56b2", extra=dict(polarity=1.0))
env.set("mcbh.12l6.b2", knl=["-(-acbh12.l6b2)"], extra=dict(polarity=1.0))
env.set("mb.c12l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.c12l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mco.12l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b12l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a12l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a12l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mq.11l6.b2", k1="-kqd.a56", extra=dict(polarity=-1.0))
env.set("mqtli.11l6.b2", k1="-kqtl11.l6b2", extra=dict(polarity=-1.0))
env.set("ms.11l6.b2", k2="-ksd2.a56b2", extra=dict(polarity=-1.0))
env.set("mcbv.11l6.b2", ksl=["-acbv11.l6b2"], extra=dict(polarity=1.0))
env.set("mco.11l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b11l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a11l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a11l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqml.10l6.b2", k1="-kq10.l6b2", extra=dict(polarity=1.0))
env.set("mcbch.10l6.b2", knl=["-(-acbch10.l6b2)"], extra=dict(polarity=1.0))
env.set("mco.10l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b10l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a10l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a10l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqmc.9l6.b2", k1="-kq9.l6b2", extra=dict(polarity=-1.0))
env.set("mqm.9l6.b2", k1="-kq9.l6b2", extra=dict(polarity=-1.0))
env.set("mcbcv.9l6.b2", ksl=["-acbcv9.l6b2"], extra=dict(polarity=1.0))
env.set("mco.9l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b9l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a9l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a9l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqml.8l6.b2", k1="-kq8.l6b2", extra=dict(polarity=1.0))
env.set("mcbch.8l6.b2", knl=["-(-acbch8.l6b2)"], extra=dict(polarity=1.0))
env.set("mco.8l6.b2", knl=[0.0, 0.0, 0.0, "-kco.a56b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a56b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.b8l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mb.a8l6.b2", angle="-ab.a56", k0="-kb.a56", extra=dict(polarity=1.0))
env.set("mcs.a8l6.b2", k2="-kcs.a56b2", extra=dict(polarity=1.0))
env.set("mqy.5l6.b2", k1="-kq5.l6b2", extra=dict(polarity=-1.0))
env.set("mcbyv.5l6.b2", ksl=["-acbyv5.l6b2"], extra=dict(polarity=1.0))
env.set("mqy.4l6.b2", k1="-kq4.l6b2", extra=dict(polarity=1.0))
env.set("mcbyh.4l6.b2", knl=["-(-acbyh4.l6b2)"], extra=dict(polarity=1.0))
env.set("msdc.e4l6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msdc.d4l6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msdc.c4l6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msdc.b4l6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msdc.a4l6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msdb.c4l6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msdb.b4l6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msdb2.4l6.b2", ksl=["kmsd.lr6b2/2"], extra=dict(polarity=1.0))
env.set("msdb2.4r6.b2", ksl=["kmsd.lr6b2/2"], extra=dict(polarity=1.0))
env.set("msdb.a4r6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msdb.b4r6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msda.a4r6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msda.b4r6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msda.c4r6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msda.d4r6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("msda.e4r6.b2", ksl=["kmsd.lr6b2"], extra=dict(polarity=1.0))
env.set("mqy.4r6.b2", k1="-kq4.r6b2", extra=dict(polarity=-1.0))
env.set("mcbyv.4r6.b2", ksl=["-acbyv4.r6b2"], extra=dict(polarity=1.0))
env.set("mkd.a5r6.b2", knl=["-(akmkd)"])
env.set("mkd.b5r6.b2", knl=["-(akmkd)"])
env.set("mkd.c5r6.b2", knl=["-(akmkd)"])
env.set("mkd.d5r6.b2", knl=["-(akmkd)"])
env.set("mkd.e5r6.b2", knl=["-(akmkd)"])
env.set("mkd.f5r6.b2", knl=["-(akmkd)"])
env.set("mkd.g5r6.b2", knl=["-(akmkd)"])
env.set("mkd.h5r6.b2", knl=["-(akmkd)"])
env.set("mkd.i5r6.b2", knl=["-(akmkd)"])
env.set("mkd.j5r6.b2", knl=["-(akmkd)"])
env.set("mkd.k5r6.b2", knl=["-(akmkd)"])
env.set("mkd.l5r6.b2", knl=["-(akmkd)"])
env.set("mkd.m5r6.b2", knl=["-(akmkd)"])
env.set("mkd.n5r6.b2", knl=["-(akmkd)"])
env.set("mkd.o5r6.b2", knl=["-(akmkd)"])
env.set("mqy.5r6.b2", k1="-kq5.r6b2", extra=dict(polarity=1.0))
env.set("mcbyh.5r6.b2", knl=["-(-acbyh5.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.8r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a8r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b8r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b8r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqml.8r6.b2", k1="-kq8.r6b2", extra=dict(polarity=-1.0))
env.set("mcbcv.8r6.b2", ksl=["-acbcv8.r6b2"], extra=dict(polarity=1.0))
env.set("mco.9r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a9r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b9r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b9r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqmc.9r6.b2", k1="-kq9.r6b2", extra=dict(polarity=1.0))
env.set("mqm.9r6.b2", k1="-kq9.r6b2", extra=dict(polarity=1.0))
env.set("mcbch.9r6.b2", knl=["-(-acbch9.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.10r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a10r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b10r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b10r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqml.10r6.b2", k1="-kq10.r6b2", extra=dict(polarity=-1.0))
env.set("mcbcv.10r6.b2", ksl=["-acbcv10.r6b2"], extra=dict(polarity=1.0))
env.set("mco.11r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a11r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b11r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b11r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mq.11r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("mqtli.11r6.b2", k1="-kqtl11.r6b2", extra=dict(polarity=1.0))
env.set("ms.11r6.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.11r6.b2", knl=["-(-acbh11.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a12r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a12r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b12r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b12r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b12r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c12r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.12r6.b2", k1="-kqt12.r6b2", extra=dict(polarity=-1.0))
env.set("mq.12r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.12r6.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.12r6.b2", ksl=["-acbv12.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a13r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a13r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.13r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b13r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c13r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c13r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.13r6.b2", k1="-kqt13.r6b2", extra=dict(polarity=1.0))
env.set("mq.13r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.13r6.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.13r6.b2", knl=["-(-acbh13.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a14r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a14r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b14r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b14r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b14r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c14r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.14r6.b2", k1="-kqtd.a67b2", extra=dict(polarity=-1.0))
env.set("mq.14r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.14r6.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.14r6.b2", ksl=["-acbv14.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a15r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a15r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.15r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b15r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c15r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c15r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.15r6.b2", k1="-kqtf.a67b2", extra=dict(polarity=1.0))
env.set("mq.15r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.15r6.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.15r6.b2", knl=["-(-acbh15.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a16r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a16r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b16r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b16r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b16r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c16r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.16r6.b2", k1="-kqtd.a67b2", extra=dict(polarity=-1.0))
env.set("mq.16r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.16r6.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.16r6.b2", ksl=["-acbv16.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a17r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a17r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.17r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b17r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c17r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c17r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.17r6.b2", k1="-kqtf.a67b2", extra=dict(polarity=1.0))
env.set("mq.17r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.17r6.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.17r6.b2", knl=["-(-acbh17.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a18r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a18r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b18r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b18r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b18r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c18r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.18r6.b2", k1="-kqtd.a67b2", extra=dict(polarity=-1.0))
env.set("mq.18r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.18r6.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.18r6.b2", ksl=["-acbv18.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a19r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a19r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.19r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b19r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c19r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c19r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.19r6.b2", k1="-kqtf.a67b2", extra=dict(polarity=1.0))
env.set("mq.19r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.19r6.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.19r6.b2", knl=["-(-acbh19.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a20r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a20r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b20r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b20r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b20r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c20r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.20r6.b2", k1="-kqtd.a67b2", extra=dict(polarity=-1.0))
env.set("mq.20r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.20r6.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.20r6.b2", ksl=["-acbv20.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a21r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a21r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.21r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b21r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c21r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c21r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.21r6.b2", k1="-kqtf.a67b2", extra=dict(polarity=1.0))
env.set("mq.21r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.21r6.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.21r6.b2", knl=["-(-acbh21.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a22r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a22r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b22r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b22r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b22r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c22r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.22r6.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.22r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.22r6.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.22r6.b2", ksl=["-acbv22.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a23r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a23r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.23r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b23r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c23r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c23r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqs.23r6.b2", k1s="-kqs.r6b2", extra=dict(polarity=-1.0))
env.set("mq.23r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.23r6.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.23r6.b2", knl=["-(-acbh23.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a24r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a24r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b24r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b24r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b24r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c24r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.24r6.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.24r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.24r6.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.24r6.b2", ksl=["-acbv24.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a25r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a25r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.25r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b25r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c25r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c25r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.25r6.b2", k3="-kof.a67b2", extra=dict(polarity=1.0))
env.set("mq.25r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.25r6.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.25r6.b2", knl=["-(-acbh25.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a26r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a26r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b26r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b26r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b26r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c26r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.26r6.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.26r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.26r6.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.26r6.b2", ksl=["-acbv26.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a27r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a27r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.27r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b27r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c27r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c27r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqs.27r6.b2", k1s="-kqs.r6b2", extra=dict(polarity=-1.0))
env.set("mq.27r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.27r6.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.27r6.b2", knl=["-(-acbh27.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a28r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a28r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b28r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b28r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b28r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c28r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.28r6.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.28r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.28r6.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.28r6.b2", ksl=["-acbv28.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a29r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a29r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.29r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b29r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c29r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c29r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.29r6.b2", k3="-kof.a67b2", extra=dict(polarity=1.0))
env.set("mq.29r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("mss.29r6.b2", k2s="-kss.a67b2", extra=dict(polarity=-1.0))
env.set("mcbh.29r6.b2", knl=["-(-acbh29.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a30r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a30r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b30r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b30r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b30r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c30r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.30r6.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.30r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.30r6.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.30r6.b2", ksl=["-acbv30.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a31r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a31r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.31r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b31r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c31r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c31r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.31r6.b2", k3="-kof.a67b2", extra=dict(polarity=1.0))
env.set("mq.31r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.31r6.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.31r6.b2", knl=["-(-acbh31.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a32r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a32r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b32r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b32r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b32r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c32r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.32r6.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.32r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.32r6.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.32r6.b2", ksl=["-acbv32.r6b2"], extra=dict(polarity=1.0))
env.set("mb.a33r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a33r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.33r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b33r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.c33r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c33r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.33r6.b2", k3="-kof.a67b2", extra=dict(polarity=1.0))
env.set("mq.33r6.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("mss.33r6.b2", k2s="-kss.a67b2", extra=dict(polarity=-1.0))
env.set("mcbh.33r6.b2", knl=["-(-acbh33.r6b2)"], extra=dict(polarity=1.0))
env.set("mco.a34r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a34r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b34r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b34r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.b34r6.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r6.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r6.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c34r6.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.34r6.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.34r6.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.34l7.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.34l7.b2", ksl=["-acbv34.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c34l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c34l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.34l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b34l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a34l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a34l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.33l7.b2", k3="-kof.a67b2", extra=dict(polarity=1.0))
env.set("mq.33l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("mss.33l7.b2", k2s="-kss.a67b2", extra=dict(polarity=-1.0))
env.set("mcbh.33l7.b2", knl=["-(-acbh33.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b33l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c33l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b33l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b33l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a33l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a33l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.32l7.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.32l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.32l7.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.32l7.b2", ksl=["-acbv32.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c32l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c32l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.32l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b32l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a32l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a32l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.31l7.b2", k3="-kof.a67b2", extra=dict(polarity=1.0))
env.set("mq.31l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.31l7.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.31l7.b2", knl=["-(-acbh31.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b31l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c31l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b31l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b31l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a31l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a31l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.30l7.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.30l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.30l7.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.30l7.b2", ksl=["-acbv30.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c30l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c30l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.30l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b30l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a30l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a30l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.29l7.b2", k3="-kof.a67b2", extra=dict(polarity=1.0))
env.set("mq.29l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("mss.29l7.b2", k2s="-kss.a67b2", extra=dict(polarity=-1.0))
env.set("mcbh.29l7.b2", knl=["-(-acbh29.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b29l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c29l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b29l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b29l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a29l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a29l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.28l7.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.28l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.28l7.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.28l7.b2", ksl=["-acbv28.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c28l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c28l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.28l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b28l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a28l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a28l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqs.27l7.b2", k1s="-kqs.l7b2", extra=dict(polarity=-1.0))
env.set("mq.27l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.27l7.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.27l7.b2", knl=["-(-acbh27.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b27l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c27l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b27l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b27l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a27l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a27l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.26l7.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.26l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.26l7.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.26l7.b2", ksl=["-acbv26.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c26l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c26l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.26l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b26l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a26l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a26l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.25l7.b2", k3="-kof.a67b2", extra=dict(polarity=1.0))
env.set("mq.25l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.25l7.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.25l7.b2", knl=["-(-acbh25.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b25l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c25l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b25l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b25l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a25l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a25l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.24l7.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.24l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.24l7.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.24l7.b2", ksl=["-acbv24.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c24l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c24l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.24l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b24l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a24l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a24l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqs.23l7.b2", k1s="-kqs.l7b2", extra=dict(polarity=-1.0))
env.set("mq.23l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.23l7.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.23l7.b2", knl=["-(-acbh23.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b23l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c23l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b23l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b23l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a23l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a23l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mo.22l7.b2", k3="-kod.a67b2", extra=dict(polarity=-1.0))
env.set("mq.22l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.22l7.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.22l7.b2", ksl=["-acbv22.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c22l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c22l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.22l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b22l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a22l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a22l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.21l7.b2", k1="-kqtf.a67b2", extra=dict(polarity=1.0))
env.set("mq.21l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.21l7.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.21l7.b2", knl=["-(-acbh21.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b21l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c21l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b21l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b21l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a21l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a21l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.20l7.b2", k1="-kqtd.a67b2", extra=dict(polarity=-1.0))
env.set("mq.20l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.20l7.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.20l7.b2", ksl=["-acbv20.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c20l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c20l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.20l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b20l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a20l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a20l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.19l7.b2", k1="-kqtf.a67b2", extra=dict(polarity=1.0))
env.set("mq.19l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.19l7.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.19l7.b2", knl=["-(-acbh19.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b19l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c19l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b19l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b19l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a19l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a19l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.18l7.b2", k1="-kqtd.a67b2", extra=dict(polarity=-1.0))
env.set("mq.18l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.18l7.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.18l7.b2", ksl=["-acbv18.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c18l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c18l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.18l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b18l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a18l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a18l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.17l7.b2", k1="-kqtf.a67b2", extra=dict(polarity=1.0))
env.set("mq.17l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.17l7.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.17l7.b2", knl=["-(-acbh17.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b17l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c17l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b17l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b17l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a17l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a17l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.16l7.b2", k1="-kqtd.a67b2", extra=dict(polarity=-1.0))
env.set("mq.16l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.16l7.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.16l7.b2", ksl=["-acbv16.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c16l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c16l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.16l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b16l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a16l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a16l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.15l7.b2", k1="-kqtf.a67b2", extra=dict(polarity=1.0))
env.set("mq.15l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.15l7.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.15l7.b2", knl=["-(-acbh15.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b15l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c15l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b15l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b15l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a15l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a15l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.14l7.b2", k1="-kqtd.a67b2", extra=dict(polarity=-1.0))
env.set("mq.14l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.14l7.b2", k2="-ksd2.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.14l7.b2", ksl=["-acbv14.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c14l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c14l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.14l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b14l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a14l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a14l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.13l7.b2", k1="-kqt13.l7b2", extra=dict(polarity=1.0))
env.set("mq.13l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("ms.13l7.b2", k2="-ksf1.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.13l7.b2", knl=["-(-acbh13.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.b13l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c13l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.b13l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b13l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.a13l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a13l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mqt.12l7.b2", k1="-kqt12.l7b2", extra=dict(polarity=-1.0))
env.set("mq.12l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("ms.12l7.b2", k2="-ksd1.a67b2", extra=dict(polarity=-1.0))
env.set("mcbv.12l7.b2", ksl=["-acbv12.l7b2"], extra=dict(polarity=1.0))
env.set("mb.c12l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.c12l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mco.12l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.12l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b12l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a12l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a12l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mq.11l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("mqtli.11l7.b2", k1="-kqtl11.l7b2", extra=dict(polarity=1.0))
env.set("ms.11l7.b2", k2="-ksf2.a67b2", extra=dict(polarity=1.0))
env.set("mcbh.11l7.b2", knl=["-(-acbh11.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.11l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b11l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a11l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a11l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mq.10l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("mqtli.10l7.b2", k1="-kqtl10.l7b2", extra=dict(polarity=-1.0))
env.set("mcbcv.10l7.b2", ksl=["-acbcv10.l7b2"], extra=dict(polarity=1.0))
env.set("mco.10l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b10l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a10l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a10l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mq.9l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("mqtli.b9l7.b2", k1="-kqtl9.l7b2", extra=dict(polarity=1.0))
env.set("mqtli.a9l7.b2", k1="-kqtl9.l7b2", extra=dict(polarity=1.0))
env.set("mcbch.9l7.b2", knl=["-(-acbch9.l7b2)"], extra=dict(polarity=1.0))
env.set("mco.9l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b9l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a9l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a9l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mq.8l7.b2", k1="-kqd.a67", extra=dict(polarity=-1.0))
env.set("mqtli.8l7.b2", k1="-kqtl8.l7b2", extra=dict(polarity=-1.0))
env.set("mcbcv.8l7.b2", ksl=["-acbcv8.l7b2"], extra=dict(polarity=1.0))
env.set("mco.8l7.b2", knl=[0.0, 0.0, 0.0, "-kco.a67b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a67b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.b8l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mb.a8l7.b2", angle="-ab.a67", k0="-kb.a67", extra=dict(polarity=1.0))
env.set("mcs.a8l7.b2", k2="-kcs.a67b2", extra=dict(polarity=1.0))
env.set("mq.7l7.b2", k1="-kqf.a67", extra=dict(polarity=1.0))
env.set("mqtli.7l7.b2", k1="-kqtl7.l7b2", extra=dict(polarity=1.0))
env.set("mcbch.7l7.b2", knl=["-(-acbch7.l7b2)"], extra=dict(polarity=1.0))
env.set("mqtlh.f6l7.b2", k1="-kq6.l7b2", extra=dict(polarity=-1.0))
env.set("mqtlh.e6l7.b2", k1="-kq6.l7b2", extra=dict(polarity=-1.0))
env.set("mqtlh.d6l7.b2", k1="-kq6.l7b2", extra=dict(polarity=-1.0))
env.set("mqtlh.c6l7.b2", k1="-kq6.l7b2", extra=dict(polarity=-1.0))
env.set("mqtlh.b6l7.b2", k1="-kq6.l7b2", extra=dict(polarity=-1.0))
env.set("mqtlh.a6l7.b2", k1="-kq6.l7b2", extra=dict(polarity=-1.0))
env.set("mcbcv.6l7.b2", ksl=["-acbcv6.l7b2"], extra=dict(polarity=1.0))
env.set("mbw.d6l7.b2", angle="-ad34.lr7", k0="-kd34.lr7", extra=dict(polarity=1.0))
env.set("mbw.c6l7.b2", angle="-ad34.lr7", k0="-kd34.lr7", extra=dict(polarity=1.0))
env.set("mbw.b6l7.b2", angle="ad34.lr7", k0="kd34.lr7", extra=dict(polarity=-1.0))
env.set("mbw.a6l7.b2", angle="ad34.lr7", k0="kd34.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.d5l7.b2", k1="kq5.lr7", extra=dict(polarity=1.0))
env.set("mqwa.c5l7.b2", k1="kq5.lr7", extra=dict(polarity=1.0))
env.set("mqwa.f5l7.b2", k1="kq5.lr7", extra=dict(polarity=1.0))
env.set("mqwa.b5l7.b2", k1="kq5.lr7", extra=dict(polarity=1.0))
env.set("mqwa.a5l7.b2", k1="kq5.lr7", extra=dict(polarity=1.0))
env.set("mcbwh.5l7.b2", knl=["-(-acbwh5.l7b2)"], extra=dict(polarity=1.0))
env.set("mqwa.e4l7.b2", k1="kq4.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.d4l7.b2", k1="kq4.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.c4l7.b2", k1="kq4.lr7", extra=dict(polarity=-1.0))
env.set("mqwb.4l7.b2", k1="-kqt4.l7", extra=dict(polarity=1.0))
env.set("mqwa.b4l7.b2", k1="kq4.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.a4l7.b2", k1="kq4.lr7", extra=dict(polarity=-1.0))
env.set("mcbwv.4l7.b2", ksl=["-acbwv4.l7b2"], extra=dict(polarity=1.0))
env.set("mcbwh.4r7.b2", knl=["-(-acbwh4.r7b2)"], extra=dict(polarity=1.0))
env.set("mqwa.a4r7.b2", k1="-kq4.lr7", extra=dict(polarity=1.0))
env.set("mqwa.b4r7.b2", k1="-kq4.lr7", extra=dict(polarity=1.0))
env.set("mqwb.4r7.b2", k1="-kqt4.r7", extra=dict(polarity=-1.0))
env.set("mqwa.c4r7.b2", k1="-kq4.lr7", extra=dict(polarity=1.0))
env.set("mqwa.d4r7.b2", k1="-kq4.lr7", extra=dict(polarity=1.0))
env.set("mqwa.e4r7.b2", k1="-kq4.lr7", extra=dict(polarity=1.0))
env.set("mcbwv.5r7.b2", ksl=["-acbwv5.r7b2"], extra=dict(polarity=1.0))
env.set("mqwa.a5r7.b2", k1="-kq5.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.b5r7.b2", k1="-kq5.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.f5r7.b2", k1="-kq5.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.c5r7.b2", k1="-kq5.lr7", extra=dict(polarity=-1.0))
env.set("mqwa.d5r7.b2", k1="-kq5.lr7", extra=dict(polarity=-1.0))
env.set("mbw.a6r7.b2", angle="ad34.lr7", k0="kd34.lr7", extra=dict(polarity=-1.0))
env.set("mbw.b6r7.b2", angle="ad34.lr7", k0="kd34.lr7", extra=dict(polarity=-1.0))
env.set("mbw.c6r7.b2", angle="-ad34.lr7", k0="-kd34.lr7", extra=dict(polarity=1.0))
env.set("mbw.d6r7.b2", angle="-ad34.lr7", k0="-kd34.lr7", extra=dict(polarity=1.0))
env.set("mqtlh.a6r7.b2", k1="-kq6.r7b2", extra=dict(polarity=1.0))
env.set("mqtlh.b6r7.b2", k1="-kq6.r7b2", extra=dict(polarity=1.0))
env.set("mqtlh.c6r7.b2", k1="-kq6.r7b2", extra=dict(polarity=1.0))
env.set("mqtlh.d6r7.b2", k1="-kq6.r7b2", extra=dict(polarity=1.0))
env.set("mqtlh.e6r7.b2", k1="-kq6.r7b2", extra=dict(polarity=1.0))
env.set("mqtlh.f6r7.b2", k1="-kq6.r7b2", extra=dict(polarity=1.0))
env.set("mcbch.6r7.b2", knl=["-(-acbch6.r7b2)"], extra=dict(polarity=1.0))
env.set("mq.7r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("mqtli.7r7.b2", k1="-kqtl7.r7b2", extra=dict(polarity=-1.0))
env.set("mcbcv.7r7.b2", ksl=["-acbcv7.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.8r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a8r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b8r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b8r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mq.8r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("mqtli.8r7.b2", k1="-kqtl8.r7b2", extra=dict(polarity=1.0))
env.set("mcbch.8r7.b2", knl=["-(-acbch8.r7b2)"], extra=dict(polarity=1.0))
env.set("mcd.9r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mb.b9r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b9r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mq.9r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("mqtli.a9r7.b2", k1="-kqtl9.r7b2", extra=dict(polarity=-1.0))
env.set("mqtli.b9r7.b2", k1="-kqtl9.r7b2", extra=dict(polarity=-1.0))
env.set("mcbcv.9r7.b2", ksl=["-acbcv9.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.10r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a10r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b10r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b10r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mq.10r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("mqtli.10r7.b2", k1="-kqtl10.r7b2", extra=dict(polarity=1.0))
env.set("mcbch.10r7.b2", knl=["-(-acbch10.r7b2)"], extra=dict(polarity=1.0))
env.set("mcd.11r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a11r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b11r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b11r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mq.11r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("mqtli.11r7.b2", k1="-kqtl11.r7b2", extra=dict(polarity=-1.0))
env.set("ms.11r7.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.11r7.b2", ksl=["-acbv11.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a12r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a12r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b12r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b12r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b12r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c12r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.12r7.b2", k1="-kqt12.r7b2", extra=dict(polarity=1.0))
env.set("mq.12r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.12r7.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.12r7.b2", knl=["-(-acbh12.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a13r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a13r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.13r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b13r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c13r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c13r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.13r7.b2", k1="-kqt13.r7b2", extra=dict(polarity=-1.0))
env.set("mq.13r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.13r7.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.13r7.b2", ksl=["-acbv13.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a14r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a14r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b14r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b14r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b14r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c14r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.14r7.b2", k1="-kqtf.a78b2", extra=dict(polarity=1.0))
env.set("mq.14r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.14r7.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.14r7.b2", knl=["-(-acbh14.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a15r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a15r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.15r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b15r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c15r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c15r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.15r7.b2", k1="-kqtd.a78b2", extra=dict(polarity=-1.0))
env.set("mq.15r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.15r7.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.15r7.b2", ksl=["-acbv15.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a16r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a16r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b16r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b16r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b16r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c16r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.16r7.b2", k1="-kqtf.a78b2", extra=dict(polarity=1.0))
env.set("mq.16r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.16r7.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.16r7.b2", knl=["-(-acbh16.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a17r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a17r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.17r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b17r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c17r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c17r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.17r7.b2", k1="-kqtd.a78b2", extra=dict(polarity=-1.0))
env.set("mq.17r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.17r7.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.17r7.b2", ksl=["-acbv17.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a18r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a18r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b18r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b18r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b18r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c18r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.18r7.b2", k1="-kqtf.a78b2", extra=dict(polarity=1.0))
env.set("mq.18r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.18r7.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.18r7.b2", knl=["-(-acbh18.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a19r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a19r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.19r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b19r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c19r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c19r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.19r7.b2", k1="-kqtd.a78b2", extra=dict(polarity=-1.0))
env.set("mq.19r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.19r7.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.19r7.b2", ksl=["-acbv19.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a20r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a20r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b20r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b20r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b20r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c20r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.20r7.b2", k1="-kqtf.a78b2", extra=dict(polarity=1.0))
env.set("mq.20r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.20r7.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.20r7.b2", knl=["-(-acbh20.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a21r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a21r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.21r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b21r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c21r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c21r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.21r7.b2", k1="-kqtd.a78b2", extra=dict(polarity=-1.0))
env.set("mq.21r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.21r7.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.21r7.b2", ksl=["-acbv21.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a22r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a22r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b22r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b22r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b22r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c22r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.22r7.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.22r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.22r7.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.22r7.b2", knl=["-(-acbh22.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a23r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a23r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.23r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b23r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c23r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c23r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqs.23r7.b2", k1s="-kqs.a78b2", extra=dict(polarity=-1.0))
env.set("mq.23r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.23r7.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.23r7.b2", ksl=["-acbv23.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a24r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a24r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b24r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b24r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b24r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c24r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.24r7.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.24r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.24r7.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.24r7.b2", knl=["-(-acbh24.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a25r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a25r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.25r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b25r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c25r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c25r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.25r7.b2", k3="-kod.a78b2", extra=dict(polarity=-1.0))
env.set("mq.25r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.25r7.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.25r7.b2", ksl=["-acbv25.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a26r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a26r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b26r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b26r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b26r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c26r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.26r7.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.26r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.26r7.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.26r7.b2", knl=["-(-acbh26.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a27r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a27r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.27r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b27r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c27r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mqs.27r7.b2", k1s="-kqs.a78b2", extra=dict(polarity=-1.0))
env.set("mq.27r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.27r7.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.27r7.b2", ksl=["-acbv27.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a28r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a28r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b28r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcd.b28r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c28r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.28r7.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.28r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.28r7.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.28r7.b2", knl=["-(-acbh28.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a29r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcd.29r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b29r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c29r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mo.29r7.b2", k3="-kod.a78b2", extra=dict(polarity=-1.0))
env.set("mq.29r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.29r7.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.29r7.b2", ksl=["-acbv29.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a30r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a30r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b30r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b30r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b30r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c30r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.30r7.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.30r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("mss.30r7.b2", k2s="-kss.a78b2", extra=dict(polarity=-1.0))
env.set("mcbh.30r7.b2", knl=["-(-acbh30.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a31r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a31r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.31r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b31r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c31r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c31r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.31r7.b2", k3="-kod.a78b2", extra=dict(polarity=-1.0))
env.set("mq.31r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.31r7.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.31r7.b2", ksl=["-acbv31.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a32r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a32r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b32r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b32r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b32r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c32r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.32r7.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.32r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.32r7.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.32r7.b2", knl=["-(-acbh32.r7b2)"], extra=dict(polarity=1.0))
env.set("mb.a33r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a33r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.33r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b33r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.c33r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c33r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.33r7.b2", k3="-kod.a78b2", extra=dict(polarity=-1.0))
env.set("mq.33r7.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.33r7.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.33r7.b2", ksl=["-acbv33.r7b2"], extra=dict(polarity=1.0))
env.set("mcd.a34r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a34r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b34r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b34r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.b34r7.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r7.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c34r7.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.34r7.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.34r7.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("mss.34l8.b2", k2s="-kss.a78b2", extra=dict(polarity=-1.0))
env.set("mcbh.34l8.b2", knl=["-(-acbh34.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c34l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c34l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.34l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b34l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a34l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a34l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.33l8.b2", k3="-kod.a78b2", extra=dict(polarity=-1.0))
env.set("mq.33l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.33l8.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.33l8.b2", ksl=["-acbv33.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b33l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c33l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b33l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b33l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a33l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a33l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.32l8.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.32l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("mss.32l8.b2", k2s="-kss.a78b2", extra=dict(polarity=-1.0))
env.set("mcbh.32l8.b2", knl=["-(-acbh32.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c32l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c32l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.32l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b32l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a32l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a32l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.31l8.b2", k3="-kod.a78b2", extra=dict(polarity=-1.0))
env.set("mq.31l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.31l8.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.31l8.b2", ksl=["-acbv31.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b31l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c31l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b31l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b31l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a31l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a31l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.30l8.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.30l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.30l8.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.30l8.b2", knl=["-(-acbh30.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c30l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c30l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.30l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b30l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a30l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a30l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.29l8.b2", k3="-kod.a78b2", extra=dict(polarity=-1.0))
env.set("mq.29l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.29l8.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.29l8.b2", ksl=["-acbv29.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b29l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c29l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b29l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b29l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a29l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a29l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.28l8.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.28l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("mss.28l8.b2", k2s="-kss.a78b2", extra=dict(polarity=-1.0))
env.set("mcbh.28l8.b2", knl=["-(-acbh28.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c28l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c28l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.28l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b28l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a28l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a28l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqs.27l8.b2", k1s="-kqs.a78b2", extra=dict(polarity=-1.0))
env.set("mq.27l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.27l8.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.27l8.b2", ksl=["-acbv27.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b27l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c27l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b27l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b27l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a27l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a27l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.26l8.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.26l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.26l8.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.26l8.b2", knl=["-(-acbh26.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c26l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c26l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.26l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b26l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a26l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a26l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.25l8.b2", k3="-kod.a78b2", extra=dict(polarity=-1.0))
env.set("mq.25l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.25l8.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.25l8.b2", ksl=["-acbv25.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b25l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c25l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b25l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b25l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a25l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a25l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.24l8.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.24l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.24l8.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.24l8.b2", knl=["-(-acbh24.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c24l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c24l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.24l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b24l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a24l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a24l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqs.23l8.b2", k1s="-kqs.a78b2", extra=dict(polarity=-1.0))
env.set("mq.23l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.23l8.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.23l8.b2", ksl=["-acbv23.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b23l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c23l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b23l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b23l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a23l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a23l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mo.22l8.b2", k3="-kof.a78b2", extra=dict(polarity=1.0))
env.set("mq.22l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.22l8.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.22l8.b2", knl=["-(-acbh22.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c22l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c22l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.22l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b22l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a22l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a22l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.21l8.b2", k1="-kqtd.a78b2", extra=dict(polarity=-1.0))
env.set("mq.21l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.21l8.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.21l8.b2", ksl=["-acbv21.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b21l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c21l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b21l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b21l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a21l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a21l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.20l8.b2", k1="-kqtf.a78b2", extra=dict(polarity=1.0))
env.set("mq.20l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.20l8.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.20l8.b2", knl=["-(-acbh20.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c20l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c20l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.20l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b20l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a20l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a20l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.19l8.b2", k1="-kqtd.a78b2", extra=dict(polarity=-1.0))
env.set("mq.19l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.19l8.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.19l8.b2", ksl=["-acbv19.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b19l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c19l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b19l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b19l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a19l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a19l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.18l8.b2", k1="-kqtf.a78b2", extra=dict(polarity=1.0))
env.set("mq.18l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.18l8.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.18l8.b2", knl=["-(-acbh18.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c18l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c18l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.18l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b18l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a18l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a18l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.17l8.b2", k1="-kqtd.a78b2", extra=dict(polarity=-1.0))
env.set("mq.17l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.17l8.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.17l8.b2", ksl=["-acbv17.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b17l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c17l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b17l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b17l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a17l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a17l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.16l8.b2", k1="-kqtf.a78b2", extra=dict(polarity=1.0))
env.set("mq.16l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.16l8.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.16l8.b2", knl=["-(-acbh16.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c16l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c16l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.16l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b16l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a16l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a16l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.15l8.b2", k1="-kqtd.a78b2", extra=dict(polarity=-1.0))
env.set("mq.15l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.15l8.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.15l8.b2", ksl=["-acbv15.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b15l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c15l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b15l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b15l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a15l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a15l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.14l8.b2", k1="-kqtf.a78b2", extra=dict(polarity=1.0))
env.set("mq.14l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.14l8.b2", k2="-ksf2.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.14l8.b2", knl=["-(-acbh14.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c14l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c14l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.14l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b14l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a14l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a14l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.13l8.b2", k1="-kqt13.l8b2", extra=dict(polarity=-1.0))
env.set("mq.13l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("ms.13l8.b2", k2="-ksd1.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.13l8.b2", ksl=["-acbv13.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.b13l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c13l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.b13l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b13l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.a13l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a13l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqt.12l8.b2", k1="-kqt12.l8b2", extra=dict(polarity=1.0))
env.set("mq.12l8.b2", k1="-kqf.a78", extra=dict(polarity=1.0))
env.set("ms.12l8.b2", k2="-ksf1.a78b2", extra=dict(polarity=1.0))
env.set("mcbh.12l8.b2", knl=["-(-acbh12.l8b2)"], extra=dict(polarity=1.0))
env.set("mb.c12l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.c12l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mcd.12l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b12l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a12l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a12l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mq.11l8.b2", k1="-kqd.a78", extra=dict(polarity=-1.0))
env.set("mqtli.11l8.b2", k1="-kqtl11.l8b2", extra=dict(polarity=-1.0))
env.set("ms.11l8.b2", k2="-ksd2.a78b2", extra=dict(polarity=-1.0))
env.set("mcbv.11l8.b2", ksl=["-acbv11.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.11l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b11l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a11l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a11l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqml.10l8.b2", k1="-kq10.l8b2", extra=dict(polarity=1.0))
env.set("mcbch.10l8.b2", knl=["-(-acbch10.l8b2)"], extra=dict(polarity=1.0))
env.set("mcd.10l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b10l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a10l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a10l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqmc.9l8.b2", k1="-kq9.l8b2", extra=dict(polarity=-1.0))
env.set("mqm.9l8.b2", k1="-kq9.l8b2", extra=dict(polarity=-1.0))
env.set("mcbcv.9l8.b2", ksl=["-acbcv9.l8b2"], extra=dict(polarity=1.0))
env.set("mcd.9l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b9l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a9l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a9l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqml.8l8.b2", k1="-kq8.l8b2", extra=dict(polarity=1.0))
env.set("mcbch.8l8.b2", knl=["-(-acbch8.l8b2)"], extra=dict(polarity=1.0))
env.set("mcd.8l8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a78b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.b8l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mb.a8l8.b2", angle="-ab.a78", k0="-kb.a78", extra=dict(polarity=1.0))
env.set("mcs.a8l8.b2", k2="-kcs.a78b2", extra=dict(polarity=1.0))
env.set("mqm.b7l8.b2", k1="-kq7.l8b2", extra=dict(polarity=-1.0))
env.set("mqm.a7l8.b2", k1="-kq7.l8b2", extra=dict(polarity=-1.0))
env.set("mcbcv.7l8.b2", ksl=["-acbcv7.l8b2"], extra=dict(polarity=1.0))
env.set("mcbch.6l8.b2", knl=["-(-acbch6.l8b2)"], extra=dict(polarity=1.0))
env.set("mqml.6l8.b2", k1="-kq6.l8b2", extra=dict(polarity=1.0))
env.set("mqm.6l8.b2", k1="-kq6.l8b2", extra=dict(polarity=1.0))
env.set("mcbcv.b5l8.b2", ksl=["-acbcvs5.l8b2"], extra=dict(polarity=1.0))
env.set("mcbch.5l8.b2", knl=["-(-acbchs5.l8b2)"], extra=dict(polarity=1.0))
env.set("mcbcv.a5l8.b2", ksl=["-acbcv5.l8b2"], extra=dict(polarity=1.0))
env.set("mqm.b5l8.b2", k1="-kq5.l8b2", extra=dict(polarity=-1.0))
env.set("mqm.a5l8.b2", k1="-kq5.l8b2", extra=dict(polarity=-1.0))
env.set("mqy.b4l8.b2", k1="-kq4.l8b2", extra=dict(polarity=1.0))
env.set("mqy.a4l8.b2", k1="-kq4.l8b2", extra=dict(polarity=1.0))
env.set("mcbyh.b4l8.b2", knl=["-(-acbyh4.l8b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.4l8.b2", ksl=["-acbyvs4.l8b2"], extra=dict(polarity=1.0))
env.set("mcbyh.a4l8.b2", knl=["-(-acbyhs4.l8b2)"], extra=dict(polarity=1.0))
env.set("mbrc.4l8.b2", angle="ad2.l8", k0="kd2.l8", extra=dict(polarity=-1.0))
env.set("mbx.4l8", angle="-ad1.l8", k0="-kd1.l8", extra=dict(polarity=-1.0))
env.set("mcosx.3l8", ksl=[0.0, 0.0, 0.0, "kcosx3.l8*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3l8", knl=[0.0, 0.0, 0.0, "kcox3.l8*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3l8", ksl=[0.0, 0.0, "kcssx3.l8*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mcbxh.3l8", knl=["-(acbxh3.l8)"], extra=dict(polarity=1.0))
env.set("mcbxv.3l8", ksl=["acbxv3.l8"], extra=dict(polarity=1.0))
env.set("mcsx.3l8", knl=[0.0, 0.0, "kcsx3.l8*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3l8", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.l8*l.mctx"], extra=dict(polarity=1.0))
env.set("mqxa.3l8", k1="kqx.l8", extra=dict(polarity=1.0))
env.set("mqsx.3l8", k1s="kqsx3.l8", extra=dict(polarity=-1.0))
env.set("mqxb.b2l8", k1="-kqx.l8-ktqx2.l8", extra=dict(polarity=-1.0))
env.set("mcbxh.2l8", knl=["-(acbxh2.l8)"], extra=dict(polarity=1.0))
env.set("mcbxv.2l8", ksl=["acbxv2.l8"], extra=dict(polarity=1.0))
env.set("mqxb.a2l8", k1="-kqx.l8-ktqx2.l8", extra=dict(polarity=-1.0))
env.set("mcbxh.1l8", knl=["-(acbxh1.l8)"], extra=dict(polarity=1.0))
env.set("mcbxv.1l8", ksl=["acbxv1.l8"], extra=dict(polarity=1.0))
env.set("mqxa.1l8", k1="kqx.l8+ktqx1.l8", extra=dict(polarity=1.0))
env.set("mbxws.1l8", rot_s_rad=0.013405855024372, ksl=["abxws.l8"], extra=dict(polarity=1.0))
env.set("mbxwh.1l8", rot_s_rad=0.013405855024372, knl=["-(abxwh.l8)"], extra=dict(polarity=1.0))
env.set("mblw.1r8", rot_s_rad=0.013405855024372, ksl=["ablw.r8"], extra=dict(polarity=1.0))
env.set("mbxws.1r8", rot_s_rad=0.013405855024372, ksl=["abxws.r8"], extra=dict(polarity=1.0))
env.set("mqxa.1r8", k1="kqx.r8+ktqx1.r8", extra=dict(polarity=-1.0))
env.set("mcbxh.1r8", knl=["-(acbxh1.r8)"], extra=dict(polarity=1.0))
env.set("mcbxv.1r8", ksl=["acbxv1.r8"], extra=dict(polarity=1.0))
env.set("mqxb.a2r8", k1="-kqx.r8-ktqx2.r8", extra=dict(polarity=1.0))
env.set("mcbxh.2r8", knl=["-(acbxh2.r8)"], extra=dict(polarity=1.0))
env.set("mcbxv.2r8", ksl=["acbxv2.r8"], extra=dict(polarity=1.0))
env.set("mqxb.b2r8", k1="-kqx.r8-ktqx2.r8", extra=dict(polarity=1.0))
env.set("mqsx.3r8", k1s="kqsx3.r8", extra=dict(polarity=-1.0))
env.set("mqxa.3r8", k1="kqx.r8", extra=dict(polarity=-1.0))
env.set("mcbxh.3r8", knl=["-(acbxh3.r8)"], extra=dict(polarity=1.0))
env.set("mcbxv.3r8", ksl=["acbxv3.r8"], extra=dict(polarity=1.0))
env.set("mcsx.3r8", knl=[0.0, 0.0, "kcsx3.r8*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3r8", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.r8*l.mctx"], extra=dict(polarity=1.0))
env.set("mcosx.3r8", ksl=[0.0, 0.0, 0.0, "kcosx3.r8*l.mcosx"], extra=dict(polarity=-1.0))
env.set("mcox.3r8", knl=[0.0, 0.0, 0.0, "kcox3.r8*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3r8", ksl=[0.0, 0.0, "kcssx3.r8*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mbx.4r8", angle="ad1.r8", k0="kd1.r8", extra=dict(polarity=1.0))
env.set("mbrc.4r8.b2", angle="-ad2.r8", k0="-kd2.r8", extra=dict(polarity=1.0))
env.set("mcbyv.a4r8.b2", ksl=["-acbyvs4.r8b2"], extra=dict(polarity=1.0))
env.set("mcbyh.4r8.b2", knl=["-(-acbyhs4.r8b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.b4r8.b2", ksl=["-acbyv4.r8b2"], extra=dict(polarity=1.0))
env.set("mqy.a4r8.b2", k1="-kq4.r8b2", extra=dict(polarity=-1.0))
env.set("mqy.b4r8.b2", k1="-kq4.r8b2", extra=dict(polarity=-1.0))
env.set("mki.a5r8.b2", ksl=["akmki"], extra=dict(polarity=1.0))
env.set("mki.b5r8.b2", ksl=["akmki"], extra=dict(polarity=1.0))
env.set("mki.c5r8.b2", ksl=["akmki"], extra=dict(polarity=1.0))
env.set("mki.d5r8.b2", ksl=["akmki"], extra=dict(polarity=1.0))
env.set("mqy.a5r8.b2", k1="-kq5.r8b2", extra=dict(polarity=1.0))
env.set("mqy.b5r8.b2", k1="-kq5.r8b2", extra=dict(polarity=1.0))
env.set("mcbyh.a5r8.b2", knl=["-(-acbyh5.r8b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.5r8.b2", ksl=["-acbyvs5.r8b2"], extra=dict(polarity=1.0))
env.set("mcbyh.b5r8.b2", knl=["-(-acbyhs5.r8b2)"], extra=dict(polarity=1.0))
env.set("msia.a6r8.b2", knl=["-(akmsia.r8b2)"], extra=dict(polarity=-1.0))
env.set("msia.b6r8.b2", knl=["-(akmsia.r8b2)"], extra=dict(polarity=-1.0))
env.set("msib.a6r8.b2", knl=["-(akmsib.r8b2)"], extra=dict(polarity=-1.0))
env.set("msib.b6r8.b2", knl=["-(akmsib.r8b2)"], extra=dict(polarity=-1.0))
env.set("msib.c6r8.b2", knl=["-(akmsib.r8b2)"], extra=dict(polarity=-1.0))
env.set("mcbcv.6r8.b2", ksl=["-acbcv6.r8b2"], extra=dict(polarity=1.0))
env.set("mqml.6r8.b2", k1="-kq6.r8b2", extra=dict(polarity=-1.0))
env.set("mqm.6r8.b2", k1="-kq6.r8b2", extra=dict(polarity=-1.0))
env.set("mqm.a7r8.b2", k1="-kq7.r8b2", extra=dict(polarity=1.0))
env.set("mqm.b7r8.b2", k1="-kq7.r8b2", extra=dict(polarity=1.0))
env.set("mcbch.7r8.b2", knl=["-(-acbch7.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.8r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a8r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a8r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b8r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b8r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqml.8r8.b2", k1="-kq8.r8b2", extra=dict(polarity=-1.0))
env.set("mcbcv.8r8.b2", ksl=["-acbcv8.r8b2"], extra=dict(polarity=1.0))
env.set("mco.9r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a9r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a9r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b9r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b9r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqmc.9r8.b2", k1="-kq9.r8b2", extra=dict(polarity=1.0))
env.set("mqm.9r8.b2", k1="-kq9.r8b2", extra=dict(polarity=1.0))
env.set("mcbch.9r8.b2", knl=["-(-acbch9.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.10r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a10r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a10r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b10r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b10r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqml.10r8.b2", k1="-kq10.r8b2", extra=dict(polarity=-1.0))
env.set("mcbcv.10r8.b2", ksl=["-acbcv10.r8b2"], extra=dict(polarity=1.0))
env.set("mco.11r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.11r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a11r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a11r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b11r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b11r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mq.11r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("mqtli.11r8.b2", k1="-kqtl11.r8b2", extra=dict(polarity=1.0))
env.set("ms.11r8.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.11r8.b2", knl=["-(-acbh11.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a12r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a12r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a12r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a12r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b12r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b12r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b12r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b12r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c12r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c12r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.12r8.b2", k1="-kqt12.r8b2", extra=dict(polarity=-1.0))
env.set("mq.12r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.12r8.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.12r8.b2", ksl=["-acbv12.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a13r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a13r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.13r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.13r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b13r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b13r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c13r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c13r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.13r8.b2", k1="-kqt13.r8b2", extra=dict(polarity=1.0))
env.set("mq.13r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.13r8.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.13r8.b2", knl=["-(-acbh13.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a14r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a14r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a14r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a14r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b14r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b14r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b14r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b14r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c14r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c14r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.14r8.b2", k1="-kqtd.a81b2", extra=dict(polarity=-1.0))
env.set("mq.14r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.14r8.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.14r8.b2", ksl=["-acbv14.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a15r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a15r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.15r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.15r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b15r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b15r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c15r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c15r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.15r8.b2", k1="-kqtf.a81b2", extra=dict(polarity=1.0))
env.set("mq.15r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.15r8.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.15r8.b2", knl=["-(-acbh15.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a16r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a16r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a16r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a16r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b16r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b16r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b16r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b16r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c16r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c16r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.16r8.b2", k1="-kqtd.a81b2", extra=dict(polarity=-1.0))
env.set("mq.16r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.16r8.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.16r8.b2", ksl=["-acbv16.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a17r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a17r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.17r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.17r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b17r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b17r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c17r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c17r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.17r8.b2", k1="-kqtf.a81b2", extra=dict(polarity=1.0))
env.set("mq.17r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.17r8.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.17r8.b2", knl=["-(-acbh17.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a18r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a18r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a18r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a18r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b18r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b18r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b18r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b18r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c18r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c18r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.18r8.b2", k1="-kqtd.a81b2", extra=dict(polarity=-1.0))
env.set("mq.18r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.18r8.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.18r8.b2", ksl=["-acbv18.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a19r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a19r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.19r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.19r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b19r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b19r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c19r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c19r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.19r8.b2", k1="-kqtf.a81b2", extra=dict(polarity=1.0))
env.set("mq.19r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.19r8.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.19r8.b2", knl=["-(-acbh19.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a20r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a20r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a20r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a20r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b20r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b20r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b20r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b20r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c20r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c20r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.20r8.b2", k1="-kqtd.a81b2", extra=dict(polarity=-1.0))
env.set("mq.20r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.20r8.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.20r8.b2", ksl=["-acbv20.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a21r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a21r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.21r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.21r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b21r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b21r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c21r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c21r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.21r8.b2", k1="-kqtf.a81b2", extra=dict(polarity=1.0))
env.set("mq.21r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.21r8.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.21r8.b2", knl=["-(-acbh21.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a22r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a22r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a22r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a22r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b22r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b22r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b22r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b22r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c22r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c22r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.22r8.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.22r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.22r8.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.22r8.b2", ksl=["-acbv22.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a23r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a23r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.23r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.23r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b23r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b23r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c23r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c23r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqs.23r8.b2", k1s="-kqs.r8b2", extra=dict(polarity=-1.0))
env.set("mq.23r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.23r8.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.23r8.b2", knl=["-(-acbh23.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a24r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a24r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a24r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a24r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b24r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b24r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b24r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b24r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c24r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c24r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.24r8.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.24r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.24r8.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.24r8.b2", ksl=["-acbv24.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a25r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a25r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.25r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.25r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b25r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b25r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c25r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c25r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.25r8.b2", k3="-kof.a81b2", extra=dict(polarity=1.0))
env.set("mq.25r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.25r8.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.25r8.b2", knl=["-(-acbh25.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a26r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a26r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a26r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a26r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b26r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b26r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b26r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b26r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c26r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c26r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.26r8.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.26r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.26r8.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.26r8.b2", ksl=["-acbv26.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a27r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a27r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.27r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.27r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b27r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b27r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c27r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c27r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqs.27r8.b2", k1s="-kqs.r8b2", extra=dict(polarity=-1.0))
env.set("mq.27r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.27r8.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.27r8.b2", knl=["-(-acbh27.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a28r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a28r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a28r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a28r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b28r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b28r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b28r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b28r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c28r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c28r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.28r8.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.28r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.28r8.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.28r8.b2", ksl=["-acbv28.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a29r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a29r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.29r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.29r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b29r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b29r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c29r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c29r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.29r8.b2", k3="-kof.a81b2", extra=dict(polarity=1.0))
env.set("mq.29r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("mss.29r8.b2", k2s="-kss.a81b2", extra=dict(polarity=-1.0))
env.set("mcbh.29r8.b2", knl=["-(-acbh29.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a30r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a30r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a30r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a30r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b30r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b30r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b30r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b30r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c30r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c30r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.30r8.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.30r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.30r8.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.30r8.b2", ksl=["-acbv30.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a31r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a31r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.31r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.31r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b31r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b31r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c31r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c31r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.31r8.b2", k3="-kof.a81b2", extra=dict(polarity=1.0))
env.set("mq.31r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.31r8.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.31r8.b2", knl=["-(-acbh31.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a32r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a32r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a32r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a32r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b32r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b32r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b32r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b32r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c32r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c32r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.32r8.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.32r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.32r8.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.32r8.b2", ksl=["-acbv32.r8b2"], extra=dict(polarity=1.0))
env.set("mb.a33r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a33r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.33r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.33r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b33r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b33r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.c33r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c33r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.33r8.b2", k3="-kof.a81b2", extra=dict(polarity=1.0))
env.set("mq.33r8.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("mss.33r8.b2", k2s="-kss.a81b2", extra=dict(polarity=-1.0))
env.set("mcbh.33r8.b2", knl=["-(-acbh33.r8b2)"], extra=dict(polarity=1.0))
env.set("mco.a34r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a34r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a34r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a34r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b34r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b34r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.b34r8.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b34r8.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c34r8.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c34r8.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.34r8.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.34r8.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.34l1.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.34l1.b2", ksl=["-acbv34.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c34l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c34l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.34l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.34l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b34l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b34l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a34l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a34l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.33l1.b2", k3="-kof.a81b2", extra=dict(polarity=1.0))
env.set("mq.33l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("mss.33l1.b2", k2s="-kss.a81b2", extra=dict(polarity=-1.0))
env.set("mcbh.33l1.b2", knl=["-(-acbh33.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b33l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b33l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c33l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c33l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b33l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b33l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a33l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a33l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a33l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a33l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.32l1.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.32l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.32l1.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.32l1.b2", ksl=["-acbv32.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c32l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c32l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.32l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.32l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b32l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b32l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a32l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a32l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.31l1.b2", k3="-kof.a81b2", extra=dict(polarity=1.0))
env.set("mq.31l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.31l1.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.31l1.b2", knl=["-(-acbh31.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b31l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b31l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c31l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c31l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b31l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b31l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a31l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a31l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a31l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a31l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.30l1.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.30l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.30l1.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.30l1.b2", ksl=["-acbv30.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c30l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c30l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.30l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.30l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b30l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b30l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a30l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a30l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.29l1.b2", k3="-kof.a81b2", extra=dict(polarity=1.0))
env.set("mq.29l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("mss.29l1.b2", k2s="-kss.a81b2", extra=dict(polarity=-1.0))
env.set("mcbh.29l1.b2", knl=["-(-acbh29.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b29l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b29l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c29l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c29l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b29l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b29l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a29l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a29l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a29l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a29l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.28l1.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.28l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.28l1.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.28l1.b2", ksl=["-acbv28.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c28l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c28l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.28l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.28l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b28l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b28l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a28l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a28l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqs.27l1.b2", k1s="-kqs.l1b2", extra=dict(polarity=-1.0))
env.set("mq.27l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.27l1.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.27l1.b2", knl=["-(-acbh27.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b27l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b27l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c27l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c27l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b27l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b27l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a27l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a27l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a27l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a27l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.26l1.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.26l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.26l1.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.26l1.b2", ksl=["-acbv26.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c26l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c26l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.26l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.26l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b26l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b26l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a26l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a26l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.25l1.b2", k3="-kof.a81b2", extra=dict(polarity=1.0))
env.set("mq.25l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.25l1.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.25l1.b2", knl=["-(-acbh25.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b25l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b25l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c25l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c25l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b25l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b25l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a25l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a25l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a25l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a25l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.24l1.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.24l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.24l1.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.24l1.b2", ksl=["-acbv24.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c24l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c24l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.24l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.24l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b24l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b24l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a24l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a24l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqs.23l1.b2", k1s="-kqs.l1b2", extra=dict(polarity=-1.0))
env.set("mq.23l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.23l1.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.23l1.b2", knl=["-(-acbh23.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b23l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b23l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c23l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c23l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b23l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b23l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a23l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a23l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a23l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a23l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mo.22l1.b2", k3="-kod.a81b2", extra=dict(polarity=-1.0))
env.set("mq.22l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.22l1.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.22l1.b2", ksl=["-acbv22.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c22l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c22l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.22l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.22l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b22l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b22l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a22l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a22l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.21l1.b2", k1="-kqtf.a81b2", extra=dict(polarity=1.0))
env.set("mq.21l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.21l1.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.21l1.b2", knl=["-(-acbh21.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b21l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b21l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c21l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c21l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b21l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b21l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a21l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a21l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a21l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a21l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.20l1.b2", k1="-kqtd.a81b2", extra=dict(polarity=-1.0))
env.set("mq.20l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.20l1.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.20l1.b2", ksl=["-acbv20.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c20l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c20l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.20l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.20l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b20l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b20l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a20l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a20l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.19l1.b2", k1="-kqtf.a81b2", extra=dict(polarity=1.0))
env.set("mq.19l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.19l1.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.19l1.b2", knl=["-(-acbh19.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b19l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b19l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c19l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c19l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b19l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b19l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a19l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a19l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a19l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a19l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.18l1.b2", k1="-kqtd.a81b2", extra=dict(polarity=-1.0))
env.set("mq.18l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.18l1.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.18l1.b2", ksl=["-acbv18.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c18l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c18l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.18l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.18l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b18l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b18l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a18l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a18l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.17l1.b2", k1="-kqtf.a81b2", extra=dict(polarity=1.0))
env.set("mq.17l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.17l1.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.17l1.b2", knl=["-(-acbh17.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b17l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b17l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c17l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c17l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b17l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b17l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a17l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a17l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a17l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a17l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.16l1.b2", k1="-kqtd.a81b2", extra=dict(polarity=-1.0))
env.set("mq.16l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.16l1.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.16l1.b2", ksl=["-acbv16.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c16l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c16l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.16l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.16l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b16l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b16l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a16l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a16l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.15l1.b2", k1="-kqtf.a81b2", extra=dict(polarity=1.0))
env.set("mq.15l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.15l1.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.15l1.b2", knl=["-(-acbh15.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b15l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b15l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c15l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c15l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b15l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b15l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a15l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a15l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a15l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a15l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.14l1.b2", k1="-kqtd.a81b2", extra=dict(polarity=-1.0))
env.set("mq.14l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.14l1.b2", k2="-ksd1.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.14l1.b2", ksl=["-acbv14.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c14l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c14l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.14l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.14l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b14l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b14l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a14l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a14l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.13l1.b2", k1="-kqt13.l1b2", extra=dict(polarity=1.0))
env.set("mq.13l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("ms.13l1.b2", k2="-ksf1.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.13l1.b2", knl=["-(-acbh13.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.b13l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.b13l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.c13l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c13l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.b13l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b13l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mco.a13l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.a13l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.a13l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a13l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqt.12l1.b2", k1="-kqt12.l1b2", extra=dict(polarity=-1.0))
env.set("mq.12l1.b2", k1="-kqd.a81", extra=dict(polarity=-1.0))
env.set("ms.12l1.b2", k2="-ksd2.a81b2", extra=dict(polarity=-1.0))
env.set("mcbv.12l1.b2", ksl=["-acbv12.l1b2"], extra=dict(polarity=1.0))
env.set("mb.c12l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.c12l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mcd.12l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b12l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b12l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a12l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a12l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mq.11l1.b2", k1="-kqf.a81", extra=dict(polarity=1.0))
env.set("mqtli.11l1.b2", k1="-kqtl11.l1b2", extra=dict(polarity=1.0))
env.set("ms.11l1.b2", k2="-ksf2.a81b2", extra=dict(polarity=1.0))
env.set("mcbh.11l1.b2", knl=["-(-acbh11.l1b2)"], extra=dict(polarity=1.0))
env.set("mcd.11l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b11l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b11l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a11l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a11l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqml.10l1.b2", k1="-kq10.l1b2", extra=dict(polarity=-1.0))
env.set("mcbcv.10l1.b2", ksl=["-acbcv10.l1b2"], extra=dict(polarity=1.0))
env.set("mco.10l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.10l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b10l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b10l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a10l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a10l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqmc.9l1.b2", k1="-kq9.l1b2", extra=dict(polarity=1.0))
env.set("mqm.9l1.b2", k1="-kq9.l1b2", extra=dict(polarity=1.0))
env.set("mcbch.9l1.b2", knl=["-(-acbch9.l1b2)"], extra=dict(polarity=1.0))
env.set("mco.9l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.9l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b9l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b9l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a9l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a9l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqml.8l1.b2", k1="-kq8.l1b2", extra=dict(polarity=-1.0))
env.set("mcbcv.8l1.b2", ksl=["-acbcv8.l1b2"], extra=dict(polarity=1.0))
env.set("mco.8l1.b2", knl=[0.0, 0.0, 0.0, "-kco.a81b2*l.mco", 0.0], extra=dict(polarity=1.0))
env.set("mcd.8l1.b2", knl=[0.0, 0.0, 0.0, 0.0, "-kcd.a81b2*l.mcd"], extra=dict(polarity=1.0))
env.set("mb.b8l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.b8l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mb.a8l1.b2", angle="-ab.a81", k0="-kb.a81", extra=dict(polarity=1.0))
env.set("mcs.a8l1.b2", k2="-kcs.a81b2", extra=dict(polarity=1.0))
env.set("mqm.b7l1.b2", k1="-kq7.l1b2", extra=dict(polarity=1.0))
env.set("mqm.a7l1.b2", k1="-kq7.l1b2", extra=dict(polarity=1.0))
env.set("mcbch.7l1.b2", knl=["-(-acbch7.l1b2)"], extra=dict(polarity=1.0))
env.set("mcbcv.6l1.b2", ksl=["-acbcv6.l1b2"], extra=dict(polarity=1.0))
env.set("mqml.6l1.b2", k1="-kq6.l1b2", extra=dict(polarity=-1.0))
env.set("mcbch.5l1.b2", knl=["-(-acbch5.l1b2)"], extra=dict(polarity=1.0))
env.set("mqml.5l1.b2", k1="-kq5.l1b2", extra=dict(polarity=1.0))
env.set("mqy.4l1.b2", k1="-kq4.l1b2", extra=dict(polarity=-1.0))
env.set("mcbyv.b4l1.b2", ksl=["-acbyv4.l1b2"], extra=dict(polarity=1.0))
env.set("mcbyh.4l1.b2", knl=["-(-acbyhs4.l1b2)"], extra=dict(polarity=1.0))
env.set("mcbyv.a4l1.b2", ksl=["-acbyvs4.l1b2"], extra=dict(polarity=1.0))
env.set("mbrc.4l1.b2", angle="-ad2.l1", k0="-kd2.l1", extra=dict(polarity=1.0))
env.set("mbxw.f4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.e4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.d4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.c4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.b4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mbxw.a4l1", angle="ad1.lr1", k0="kd1.lr1", extra=dict(polarity=1.0))
env.set("mcox.3l1", knl=[0.0, 0.0, 0.0, "kcox3.l1*l.mcox"], extra=dict(polarity=1.0))
env.set("mcssx.3l1", ksl=[0.0, 0.0, "kcssx3.l1*l.mcssx", 0.0], extra=dict(polarity=-1.0))
env.set("mcbxh.3l1", knl=["-(acbxh3.l1)"], extra=dict(polarity=1.0))
env.set("mcbxv.3l1", ksl=["acbxv3.l1"], extra=dict(polarity=1.0))
env.set("mcsx.3l1", knl=[0.0, 0.0, "kcsx3.l1*l.mcsx", 0.0, 0.0, 0.0], extra=dict(polarity=1.0))
env.set("mctx.3l1", knl=[0.0, 0.0, 0.0, 0.0, 0.0, "kctx3.l1*l.mctx"], extra=dict(polarity=1.0))
env.set("mqxa.3l1", k1="kqx.l1", extra=dict(polarity=-1.0))
env.set("mqsx.3l1", k1s="kqsx3.l1", extra=dict(polarity=-1.0))
env.set("mqxb.b2l1", k1="-kqx.l1-ktqx2.l1", extra=dict(polarity=1.0))
env.set("mcbxh.2l1", knl=["-(acbxh2.l1)"], extra=dict(polarity=1.0))
env.set("mcbxv.2l1", ksl=["acbxv2.l1"], extra=dict(polarity=1.0))
env.set("mqxb.a2l1", k1="-kqx.l1-ktqx2.l1", extra=dict(polarity=1.0))
env.set("mcbxh.1l1", knl=["-(acbxh1.l1)"], extra=dict(polarity=1.0))
env.set("mcbxv.1l1", ksl=["acbxv1.l1"], extra=dict(polarity=1.0))
env.set("mqxa.1l1", k1="kqx.l1+ktqx1.l1", extra=dict(polarity=-1.0))
env.set("mbas2.1l1", ks="abas")

# /************************************************************************************/
# /*                       Kmax at 4.5K                                               */
# /************************************************************************************/

env.set("mbrc.4r1.b1", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mcbyv.a4r1.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.4r1.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.b4r1.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.4r1.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbch.5r1.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.5r1.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbcv.6r1.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.6r1.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbcv.6l2.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.6l2.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqm.6l2.b1", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbyh.b5l2.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.5l2.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.a5l2.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.b5l2.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.a5l2.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.b4l2.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.a4l2.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.b4l2.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.4l2.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.a4l2.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mbrc.4l2.b1", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mbrc.4r2.b1", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mcbyh.a4r2.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.4r2.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.b4r2.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.a4r2.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.b4r2.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbcv.a5r2.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mcbch.5r2.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mcbcv.b5r2.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqm.a5r2.b1", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mqm.b5r2.b1", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbch.6r2.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.6r2.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqm.6r2.b1", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbch.6l3.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqtlh.f6l3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.e6l3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.d6l3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.c6l3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.b6l3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.a6l3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mcbcv.6r3.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqtlh.a6r3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.b6r3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.c6r3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.d6r3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.e6r3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.f6r3.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqy.6l4.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.6l4.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.5l4.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.5l4.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mbrb.5l4.b1", extra=dict(kmax="kmax_mbrb_4.5k", kmin="kmin_mbrb_4.5k", calib="kmax_mbrb_4.5k/imax_mbrb_4.5k"))
env.set("mbrs.5l4.b1", extra=dict(kmax="kmax_mbrs_4.5k", kmin="kmin_mbrs_4.5k", calib="kmax_mbrs_4.5k/imax_mbrs_4.5k"))
env.set("mbrs.5r4.b1", extra=dict(kmax="kmax_mbrs_4.5k", kmin="kmin_mbrs_4.5k", calib="kmax_mbrs_4.5k/imax_mbrs_4.5k"))
env.set("mbrb.5r4.b1", extra=dict(kmax="kmax_mbrb_4.5k", kmin="kmin_mbrb_4.5k", calib="kmax_mbrb_4.5k/imax_mbrb_4.5k"))
env.set("mcbyv.5r4.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.5r4.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.6r4.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.6r4.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqml.6l5.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbch.6l5.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.5l5.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbcv.5l5.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqy.4l5.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.b4l5.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.4l5.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.a4l5.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mbrc.4l5.b1", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mbrc.4r5.b1", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mcbyv.a4r5.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.4r5.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.b4r5.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.4r5.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqml.5r5.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbch.5r5.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.6r5.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbcv.6r5.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqy.5l6.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.5l6.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.4l6.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.4l6.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.4r6.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.4r6.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.5r6.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.5r6.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqtlh.f6l7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.e6l7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.d6l7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.c6l7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.b6l7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.a6l7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mcbch.6l7.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqtlh.a6r7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.b6r7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.c6r7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.d6r7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.e6r7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.f6r7.b1", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mcbcv.6r7.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mcbcv.6l8.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.6l8.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqm.6l8.b1", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbch.b5l8.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mcbcv.5l8.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mcbch.a5l8.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqm.b5l8.b1", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mqm.a5l8.b1", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mqy.b4l8.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.a4l8.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.b4l8.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.4l8.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.a4l8.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mbrc.4l8.b1", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mbrc.4r8.b1", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mcbyh.a4r8.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.4r8.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.b4r8.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.a4r8.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.b4r8.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.a5r8.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.b5r8.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.a5r8.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.5r8.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.b5r8.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbch.6r8.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.6r8.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqm.6r8.b1", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbch.6l1.b1", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.6l1.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbcv.5l1.b1", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.5l1.b1", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqy.4l1.b1", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.b4l1.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.4l1.b1", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.a4l1.b1", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mbrc.4l1.b1", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mbrc.4r1.b2", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mcbyh.a4r1.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.4r1.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.b4r1.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.4r1.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbcv.5r1.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.5r1.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbch.6r1.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.6r1.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbch.6l2.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.6l2.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqm.6l2.b2", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbyv.b5l2.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.5l2.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.a5l2.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.b5l2.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.a5l2.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.b4l2.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.a4l2.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.b4l2.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.4l2.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.a4l2.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mbrc.4l2.b2", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mbrc.4r2.b2", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mcbyv.a4r2.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.4r2.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.b4r2.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.a4r2.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.b4r2.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbch.a5r2.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mcbcv.5r2.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mcbch.b5r2.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqm.a5r2.b2", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mqm.b5r2.b2", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbcv.6r2.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.6r2.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqm.6r2.b2", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbcv.6l3.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqtlh.f6l3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.e6l3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.d6l3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.c6l3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.b6l3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.a6l3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mcbch.6r3.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqtlh.a6r3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.b6r3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.c6r3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.d6r3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.e6r3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.f6r3.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqy.6l4.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.6l4.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.5l4.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.5l4.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mbrb.5l4.b2", extra=dict(kmax="kmax_mbrb_4.5k", kmin="kmin_mbrb_4.5k", calib="kmax_mbrb_4.5k/imax_mbrb_4.5k"))
env.set("mbrs.5l4.b2", extra=dict(kmax="kmax_mbrs_4.5k", kmin="kmin_mbrs_4.5k", calib="kmax_mbrs_4.5k/imax_mbrs_4.5k"))
env.set("mbrs.5r4.b2", extra=dict(kmax="kmax_mbrs_4.5k", kmin="kmin_mbrs_4.5k", calib="kmax_mbrs_4.5k/imax_mbrs_4.5k"))
env.set("mbrb.5r4.b2", extra=dict(kmax="kmax_mbrb_4.5k", kmin="kmin_mbrb_4.5k", calib="kmax_mbrb_4.5k/imax_mbrb_4.5k"))
env.set("mcbyh.5r4.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.5r4.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.6r4.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.6r4.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqml.6l5.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbcv.6l5.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.5l5.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbch.5l5.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqy.4l5.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.b4l5.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.4l5.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.a4l5.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mbrc.4l5.b2", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mbrc.4r5.b2", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mcbyh.a4r5.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.4r5.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.b4r5.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.4r5.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqml.5r5.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbcv.5r5.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.6r5.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbch.6r5.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqy.5l6.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.5l6.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.4l6.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.4l6.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqy.4r6.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.4r6.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.5r6.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.5r6.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mqtlh.f6l7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.e6l7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.d6l7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.c6l7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.b6l7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.a6l7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mcbcv.6l7.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqtlh.a6r7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.b6r7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.c6r7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.d6r7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.e6r7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mqtlh.f6r7.b2", extra=dict(kmax="kmax_mqtlh_4.5k", kmin="kmin_mqtlh_4.5k", calib="kmax_mqtlh_4.5k/imax_mqtlh_4.5k"))
env.set("mcbch.6r7.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mcbch.6l8.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.6l8.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqm.6l8.b2", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbcv.b5l8.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mcbch.5l8.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mcbcv.a5l8.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqm.b5l8.b2", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mqm.a5l8.b2", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mqy.b4l8.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.a4l8.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.b4l8.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.4l8.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.a4l8.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mbrc.4l8.b2", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mbrc.4r8.b2", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))
env.set("mcbyv.a4r8.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.4r8.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.b4r8.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mqy.a4r8.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.b4r8.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.a5r8.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mqy.b5r8.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyh.a5r8.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.5r8.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.b5r8.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbcv.6r8.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.6r8.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqm.6r8.b2", extra=dict(kmax="kmax_mqm_4.5k", kmin="kmin_mqm_4.5k", calib="kmax_mqm_4.5k/imax_mqm_4.5k"))
env.set("mcbcv.6l1.b2", extra=dict(kmax="kmax_mcbcv_4.5k", kmin="kmin_mcbcv_4.5k", calib="kmax_mcbcv_4.5k/imax_mcbcv_4.5k"))
env.set("mqml.6l1.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mcbch.5l1.b2", extra=dict(kmax="kmax_mcbch_4.5k", kmin="kmin_mcbch_4.5k", calib="kmax_mcbch_4.5k/imax_mcbch_4.5k"))
env.set("mqml.5l1.b2", extra=dict(kmax="kmax_mqml_4.5k", kmin="kmin_mqml_4.5k", calib="kmax_mqml_4.5k/imax_mqml_4.5k"))
env.set("mqy.4l1.b2", extra=dict(kmax="kmax_mqy_4.5k", kmin="kmin_mqy_4.5k", calib="kmax_mqy_4.5k/imax_mqy_4.5k"))
env.set("mcbyv.b4l1.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mcbyh.4l1.b2", extra=dict(kmax="kmax_mcbyh_4.5k", kmin="kmin_mcbyh_4.5k", calib="kmax_mcbyh_4.5k/imax_mcbyh_4.5k"))
env.set("mcbyv.a4l1.b2", extra=dict(kmax="kmax_mcbyv_4.5k", kmin="kmin_mcbyv_4.5k", calib="kmax_mcbyv_4.5k/imax_mcbyv_4.5k"))
env.set("mbrc.4l1.b2", extra=dict(kmax="kmax_mbrc_4.5k", kmin="kmin_mbrc_4.5k", calib="kmax_mbrc_4.5k/imax_mbrc_4.5k"))


# /************************************************************************************/
